/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var h1=["require","exports","vs/base/common/errors","vs/base/common/platform","vs/base/common/charCode","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/event","vs/base/common/strings","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/types","vs/base/common/objects","vs/base/common/uint","vs/base/common/uri","vs/base/common/network","vs/base/common/worker/simpleWorker"],g1=function(t1){for(var t=[],h=0,e=t1.length;h<e;h++)t[h]=h1[t1[h]];return t};define(h1[10],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ob=void 0,t.$hb=h,t.$ib=e,t.$jb=p,t.$kb=I,t.$lb=Q,t.$mb=K,t.$nb=N,t.$pb=W,t.$qb=Y,t.$rb=k,t.$sb=z,t.$tb=M;function h(U,R){const j=e(U,R);if(j!==-1)return U[j]}function e(U,R,j=U.length-1){for(let E=j;E>=0;E--){const O=U[E];if(R(O))return E}return-1}function p(U,R){const j=I(U,R);return j===-1?void 0:U[j]}function I(U,R,j=0,E=U.length){let O=j,B=E;for(;O<B;){const v=Math.floor((O+B)/2);R(U[v])?O=v+1:B=v}return O-1}function Q(U,R){const j=K(U,R);return j===U.length?void 0:U[j]}function K(U,R,j=0,E=U.length){let O=j,B=E;for(;O<B;){const v=Math.floor((O+B)/2);R(U[v])?B=v:O=v+1}return O}function N(U,R,j=0,E=U.length){const O=K(U,R,j,E);return O===U.length?-1:O}class D{static{this.assertInvariants=!1}constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(D.assertInvariants){if(this.d){for(const E of this.e)if(this.d(E)&&!R(E))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const j=I(this.e,R,this.c);return this.c=j+1,j===-1?void 0:this.e[j]}}t.$ob=D;function W(U,R){if(U.length===0)return;let j=U[0];for(let E=1;E<U.length;E++){const O=U[E];R(O,j)>0&&(j=O)}return j}function Y(U,R){if(U.length===0)return;let j=U[0];for(let E=1;E<U.length;E++){const O=U[E];R(O,j)>=0&&(j=O)}return j}function k(U,R){return W(U,(j,E)=>-R(j,E))}function z(U,R){if(U.length===0)return-1;let j=0;for(let E=1;E<U.length;E++){const O=U[E];R(O,U[j])>0&&(j=E)}return j}function M(U,R){for(const j of U){const E=R(j);if(E!==void 0)return E}}}),define(h1[4],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var h;(function(e){e[e.Null=0]="Null",e[e.Backspace=8]="Backspace",e[e.Tab=9]="Tab",e[e.LineFeed=10]="LineFeed",e[e.CarriageReturn=13]="CarriageReturn",e[e.Space=32]="Space",e[e.ExclamationMark=33]="ExclamationMark",e[e.DoubleQuote=34]="DoubleQuote",e[e.Hash=35]="Hash",e[e.DollarSign=36]="DollarSign",e[e.PercentSign=37]="PercentSign",e[e.Ampersand=38]="Ampersand",e[e.SingleQuote=39]="SingleQuote",e[e.OpenParen=40]="OpenParen",e[e.CloseParen=41]="CloseParen",e[e.Asterisk=42]="Asterisk",e[e.Plus=43]="Plus",e[e.Comma=44]="Comma",e[e.Dash=45]="Dash",e[e.Period=46]="Period",e[e.Slash=47]="Slash",e[e.Digit0=48]="Digit0",e[e.Digit1=49]="Digit1",e[e.Digit2=50]="Digit2",e[e.Digit3=51]="Digit3",e[e.Digit4=52]="Digit4",e[e.Digit5=53]="Digit5",e[e.Digit6=54]="Digit6",e[e.Digit7=55]="Digit7",e[e.Digit8=56]="Digit8",e[e.Digit9=57]="Digit9",e[e.Colon=58]="Colon",e[e.Semicolon=59]="Semicolon",e[e.LessThan=60]="LessThan",e[e.Equals=61]="Equals",e[e.GreaterThan=62]="GreaterThan",e[e.QuestionMark=63]="QuestionMark",e[e.AtSign=64]="AtSign",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.OpenSquareBracket=91]="OpenSquareBracket",e[e.Backslash=92]="Backslash",e[e.CloseSquareBracket=93]="CloseSquareBracket",e[e.Caret=94]="Caret",e[e.Underline=95]="Underline",e[e.BackTick=96]="BackTick",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.OpenCurlyBrace=123]="OpenCurlyBrace",e[e.Pipe=124]="Pipe",e[e.CloseCurlyBrace=125]="CloseCurlyBrace",e[e.Tilde=126]="Tilde",e[e.NoBreakSpace=160]="NoBreakSpace",e[e.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",e[e.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",e[e.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",e[e.U_Combining_Tilde=771]="U_Combining_Tilde",e[e.U_Combining_Macron=772]="U_Combining_Macron",e[e.U_Combining_Overline=773]="U_Combining_Overline",e[e.U_Combining_Breve=774]="U_Combining_Breve",e[e.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",e[e.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",e[e.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",e[e.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",e[e.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",e[e.U_Combining_Caron=780]="U_Combining_Caron",e[e.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",e[e.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",e[e.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",e[e.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",e[e.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",e[e.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",e[e.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",e[e.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",e[e.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",e[e.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",e[e.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",e[e.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",e[e.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",e[e.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",e[e.U_Combining_Horn=795]="U_Combining_Horn",e[e.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",e[e.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",e[e.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",e[e.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",e[e.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",e[e.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",e[e.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",e[e.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",e[e.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",e[e.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",e[e.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",e[e.U_Combining_Cedilla=807]="U_Combining_Cedilla",e[e.U_Combining_Ogonek=808]="U_Combining_Ogonek",e[e.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",e[e.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",e[e.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",e[e.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",e[e.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",e[e.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",e[e.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",e[e.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",e[e.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",e[e.U_Combining_Low_Line=818]="U_Combining_Low_Line",e[e.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",e[e.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",e[e.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",e[e.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",e[e.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",e[e.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",e[e.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",e[e.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",e[e.U_Combining_Square_Below=827]="U_Combining_Square_Below",e[e.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",e[e.U_Combining_X_Above=829]="U_Combining_X_Above",e[e.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",e[e.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",e[e.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",e[e.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",e[e.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",e[e.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",e[e.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",e[e.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",e[e.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",e[e.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",e[e.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",e[e.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",e[e.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",e[e.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",e[e.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",e[e.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",e[e.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",e[e.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",e[e.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",e[e.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",e[e.U_Combining_Fermata=850]="U_Combining_Fermata",e[e.U_Combining_X_Below=851]="U_Combining_X_Below",e[e.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",e[e.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",e[e.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",e[e.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",e[e.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",e[e.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",e[e.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",e[e.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",e[e.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",e[e.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",e[e.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",e[e.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",e[e.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",e[e.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",e[e.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",e[e.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",e[e.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",e[e.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",e[e.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",e[e.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",e[e.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",e[e.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",e[e.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",e[e.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",e[e.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",e[e.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",e[e.LINE_SEPARATOR=8232]="LINE_SEPARATOR",e[e.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",e[e.NEXT_LINE=133]="NEXT_LINE",e[e.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",e[e.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",e[e.U_DIAERESIS=168]="U_DIAERESIS",e[e.U_MACRON=175]="U_MACRON",e[e.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",e[e.U_CEDILLA=184]="U_CEDILLA",e[e.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",e[e.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",e[e.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",e[e.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",e[e.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",e[e.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",e[e.U_BREVE=728]="U_BREVE",e[e.U_DOT_ABOVE=729]="U_DOT_ABOVE",e[e.U_RING_ABOVE=730]="U_RING_ABOVE",e[e.U_OGONEK=731]="U_OGONEK",e[e.U_SMALL_TILDE=732]="U_SMALL_TILDE",e[e.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",e[e.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",e[e.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",e[e.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",e[e.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",e[e.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",e[e.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",e[e.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",e[e.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",e[e.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",e[e.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",e[e.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",e[e.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",e[e.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",e[e.U_GREEK_TONOS=900]="U_GREEK_TONOS",e[e.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",e[e.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",e[e.U_GREEK_PSILI=8127]="U_GREEK_PSILI",e[e.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",e[e.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",e[e.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",e[e.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",e[e.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",e[e.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",e[e.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",e[e.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",e[e.U_GREEK_VARIA=8175]="U_GREEK_VARIA",e[e.U_GREEK_OXIA=8189]="U_GREEK_OXIA",e[e.U_GREEK_DASIA=8190]="U_GREEK_DASIA",e[e.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",e[e.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",e[e.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",e[e.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",e[e.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",e[e.U_OVERLINE=8254]="U_OVERLINE",e[e.UTF8_BOM=65279]="UTF8_BOM",e[e.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",e[e.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(h||(t.CharCode=h={}))}),define(h1[11],g1([0,1]),function(t1,t){"use strict";var h;Object.defineProperty(t,"__esModule",{value:!0}),t.$g=void 0,t.$c=e,t.$d=p,t.$e=I,t.$f=Q;function e(N,D){const W=Object.create(null);for(const Y of N){const k=D(Y);let z=W[k];z||(z=W[k]=[]),z.push(Y)}return W}function p(N,D){const W=[],Y=[];for(const k of N)D.has(k)||W.push(k);for(const k of D)N.has(k)||Y.push(k);return{removed:W,added:Y}}function I(N,D){const W=[],Y=[];for(const[k,z]of N)D.has(k)||W.push(z);for(const[k,z]of D)N.has(k)||Y.push(z);return{removed:W,added:Y}}function Q(N,D){const W=new Set;for(const Y of D)N.has(Y)&&W.add(Y);return W}class K{static{h=Symbol.toStringTag}constructor(D,W){this.b=W,this.a=new Map,this[h]="SetWithKey";for(const Y of D)this.add(Y)}get size(){return this.a.size}add(D){const W=this.b(D);return this.a.set(W,D),this}delete(D){return this.a.delete(this.b(D))}has(D){return this.a.has(this.b(D))}*entries(){for(const D of this.a.values())yield[D,D]}keys(){return this.values()}*values(){for(const D of this.a.values())yield D}clear(){this.a.clear()}forEach(D,W){this.a.forEach(Y=>D.call(W,Y,Y,this))}[Symbol.iterator](){return this.values()}}t.$g=K}),define(h1[2],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eb=t.$db=t.$cb=t.$bb=t.$ab=t.$$=t.$7=t.$Y=t.$X=void 0,t.setUnexpectedErrorHandler=e,t.$1=p,t.$2=I,t.$3=Q,t.$4=K,t.$5=N,t.$6=W,t.$8=k,t.$9=z,t.$0=M,t.$_=R;class h{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?B.isErrorNoTelemetry(n)?new B(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$X=h,t.$Y=new h;function e(i){t.$Y.setUnexpectedErrorHandler(i)}function p(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function I(i){W(i)||t.$Y.onUnexpectedError(i)}function Q(i){W(i)||t.$Y.onUnexpectedExternalError(i)}function K(i){if(i instanceof Error){const{name:n,message:s}=i,f=i.stacktrace||i.stack;return{$isError:!0,name:n,message:s,stack:f,noTelemetry:B.isErrorNoTelemetry(i)}}return i}function N(i){let n;return i.noTelemetry?n=new B:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const D="Canceled";function W(i){return i instanceof Y?!0:i instanceof Error&&i.name===D&&i.message===D}class Y extends Error{constructor(){super(D),this.name=this.message}}t.$7=Y;function k(){const i=new Error(D);return i.name=i.message,i}function z(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function M(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class U extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$$=U;function R(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class j extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$ab=j;class E extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$bb=E;class O extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$cb=O;class B extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof B)return n;const s=new B;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$db=B;class v extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype)}}t.$eb=v}),define(h1[12],g1([0,1,2,10]),function(t1,t,h,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cc=t.$bc=t.$ac=t.$$b=t.$0b=t.CompareResult=void 0,t.$ub=p,t.$vb=I,t.$wb=Q,t.$xb=K,t.$yb=N,t.$zb=D,t.$Ab=W,t.$Bb=Y,t.$Cb=k,t.$Db=z,t.$Eb=M,t.$Fb=U,t.$Gb=R,t.top=j,t.$Ib=E,t.$Jb=B,t.$Kb=v,t.$Lb=i,t.$Mb=n,t.$Nb=s,t.$Ob=f,t.$Pb=d,t.$Qb=r,t.$Rb=o,t.$Sb=a,t.$Tb=u,t.$Ub=y,t.$Vb=$,t.$Wb=l,t.$Xb=T,t.$Yb=F,t.$Zb=L,t.$1b=A,t.$2b=H,t.$3b=i1,t.$4b=e1,t.$5b=s1,t.$6b=u1,t.$7b=C,t.$8b=L1,t.$9b=U1,t.$_b=G1,t.$dc=p1;function p(g,m=0){return g[g.length-(1+m)]}function I(g){if(g.length===0)throw new Error("Invalid tail call");return[g.slice(0,g.length-1),g[g.length-1]]}function Q(g,m,b=(S,q)=>S===q){if(g===m)return!0;if(!g||!m||g.length!==m.length)return!1;for(let S=0,q=g.length;S<q;S++)if(!b(g[S],m[S]))return!1;return!0}function K(g,m){const b=g.length-1;m<b&&(g[m]=g[b]),g.pop()}function N(g,m,b){return D(g.length,S=>b(g[S],m))}function D(g,m){let b=0,S=g-1;for(;b<=S;){const q=(b+S)/2|0,n1=m(q);if(n1<0)b=q+1;else if(n1>0)S=q-1;else return q}return-(b+1)}function W(g,m,b){if(g=g|0,g>=m.length)throw new TypeError("invalid index");const S=m[Math.floor(m.length*Math.random())],q=[],n1=[],f1=[];for(const $1 of m){const b1=b($1,S);b1<0?q.push($1):b1>0?n1.push($1):f1.push($1)}return g<q.length?W(g,q,b):g<q.length+f1.length?f1[0]:W(g-(q.length+f1.length),n1,b)}function Y(g,m){const b=[];let S;for(const q of g.slice(0).sort(m))!S||m(S[0],q)!==0?(S=[q],b.push(S)):S.push(q);return b}function*k(g,m){let b,S;for(const q of g)S!==void 0&&m(S,q)?b.push(q):(b&&(yield b),b=[q]),S=q;b&&(yield b)}function z(g,m){for(let b=0;b<=g.length;b++)m(b===0?void 0:g[b-1],b===g.length?void 0:g[b])}function M(g,m){for(let b=0;b<g.length;b++)m(b===0?void 0:g[b-1],g[b],b+1===g.length?void 0:g[b+1])}function U(g,m,b){const S=[];function q($1,b1,A1){if(b1===0&&A1.length===0)return;const v1=S[S.length-1];v1&&v1.start+v1.deleteCount===$1?(v1.deleteCount+=b1,v1.toInsert.push(...A1)):S.push({start:$1,deleteCount:b1,toInsert:A1})}let n1=0,f1=0;for(;;){if(n1===g.length){q(n1,0,m.slice(f1));break}if(f1===m.length){q(n1,g.length-n1,[]);break}const $1=g[n1],b1=m[f1],A1=b($1,b1);A1===0?(n1+=1,f1+=1):A1<0?(q(n1,1,[]),n1+=1):A1>0&&(q(n1,0,[b1]),f1+=1)}return S}function R(g,m,b){const S=U(g,m,b),q=[],n1=[];for(const f1 of S)q.push(...g.slice(f1.start,f1.start+f1.deleteCount)),n1.push(...f1.toInsert);return{removed:q,added:n1}}function j(g,m,b){if(b===0)return[];const S=g.slice(0,b).sort(m);return O(g,m,S,b,g.length),S}function E(g,m,b,S,q){return b===0?Promise.resolve([]):new Promise((n1,f1)=>{(async()=>{const $1=g.length,b1=g.slice(0,b).sort(m);for(let A1=b,v1=Math.min(b+S,$1);A1<$1;A1=v1,v1=Math.min(v1+S,$1)){if(A1>b&&await new Promise(X=>setTimeout(X)),q&&q.isCancellationRequested)throw new h.$7;O(g,m,b1,A1,v1)}return b1})().then(n1,f1)})}function O(g,m,b,S,q){for(const n1=b.length;S<q;S++){const f1=g[S];if(m(f1,b[n1-1])<0){b.pop();const $1=(0,e.$mb)(b,b1=>m(f1,b1)<0);b.splice($1,0,f1)}}}function B(g){return g.filter(m=>!!m)}function v(g){let m=0;for(let b=0;b<g.length;b++)g[b]&&(g[m]=g[b],m+=1);g.length=m}function i(g,m,b){g.splice(b,0,g.splice(m,1)[0])}function n(g){return!Array.isArray(g)||g.length===0}function s(g){return Array.isArray(g)&&g.length>0}function f(g,m=b=>b){const b=new Set;return g.filter(S=>{const q=m(S);return b.has(q)?!1:(b.add(q),!0)})}function d(g){const m=new Set;return b=>{const S=g(b);return m.has(S)?!1:(m.add(S),!0)}}function r(g,m){return g.length>0?g[0]:m}function o(g,m){return g.length>0?g[g.length-1]:m}function a(g,m,b=(S,q)=>S===q){let S=0;for(let q=0,n1=Math.min(g.length,m.length);q<n1&&b(g[q],m[q]);q++)S++;return S}function u(g,m){let b=typeof m=="number"?g:0;typeof m=="number"?b=g:(b=0,m=g);const S=[];if(b<=m)for(let q=b;q<m;q++)S.push(q);else for(let q=b;q>m;q--)S.push(q);return S}function y(g,m,b){return g.reduce((S,q)=>(S[m(q)]=b?b(q):q,S),Object.create(null))}function $(g,m){return g.push(m),()=>l(g,m)}function l(g,m){const b=g.indexOf(m);if(b>-1)return g.splice(b,1),m}function T(g,m,b){const S=g.slice(0,m),q=g.slice(m);return S.concat(b,q)}function F(g,m){let b;if(typeof m=="number"){let S=m;b=()=>{const q=Math.sin(S++)*179426549;return q-Math.floor(q)}}else b=Math.random;for(let S=g.length-1;S>0;S-=1){const q=Math.floor(b()*(S+1)),n1=g[S];g[S]=g[q],g[q]=n1}}function L(g,m){const b=g.indexOf(m);b>-1&&(g.splice(b,1),g.unshift(m))}function A(g,m){const b=g.indexOf(m);b>-1&&(g.splice(b,1),g.push(m))}function H(g,m){for(const b of m)g.push(b)}function i1(g,m){return Array.isArray(g)?g.map(m):m(g)}function e1(g){return Array.isArray(g)?g:[g]}function s1(g){return g[Math.floor(Math.random()*g.length)]}function u1(g,m,b){const S=c1(g,m),q=g.length,n1=b.length;g.length=q+n1;for(let f1=q-1;f1>=S;f1--)g[f1+n1]=g[f1];for(let f1=0;f1<n1;f1++)g[f1+S]=b[f1]}function C(g,m,b,S){const q=c1(g,m);let n1=g.splice(q,b);return n1===void 0&&(n1=[]),u1(g,q,S),n1}function c1(g,m){return m<0?Math.max(m+g.length,0):Math.min(m,g.length)}var _1;(function(g){function m(n1){return n1<0}g.isLessThan=m;function b(n1){return n1<=0}g.isLessThanOrEqual=b;function S(n1){return n1>0}g.isGreaterThan=S;function q(n1){return n1===0}g.isNeitherLessOrGreaterThan=q,g.greaterThan=1,g.lessThan=-1,g.neitherLessOrGreaterThan=0})(_1||(t.CompareResult=_1={}));function L1(g,m){return(b,S)=>m(g(b),g(S))}function U1(...g){return(m,b)=>{for(const S of g){const q=S(m,b);if(!_1.isNeitherLessOrGreaterThan(q))return q}return _1.neitherLessOrGreaterThan}}const O1=(g,m)=>g-m;t.$0b=O1;const S1=(g,m)=>(0,t.$0b)(g?1:0,m?1:0);t.$$b=S1;function G1(g){return(m,b)=>-g(m,b)}class H1{constructor(m){this.g=m,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(m){let b=this.c;for(;b<this.g.length&&m(this.g[b]);)b++;const S=b===this.c?null:this.g.slice(this.c,b);return this.c=b,S}takeFromEndWhile(m){let b=this.d;for(;b>=0&&m(this.g[b]);)b--;const S=b===this.d?null:this.g.slice(b+1,this.d+1);return this.d=b,S}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const m=this.g[this.c];return this.c++,m}removeLast(){const m=this.g[this.d];return this.d--,m}takeCount(m){const b=this.g.slice(this.c,this.c+m);return this.c+=m,b}}t.$ac=H1;class I1{static{this.empty=new I1(m=>{})}constructor(m){this.iterate=m}forEach(m){this.iterate(b=>(m(b),!0))}toArray(){const m=[];return this.iterate(b=>(m.push(b),!0)),m}filter(m){return new I1(b=>this.iterate(S=>m(S)?b(S):!0))}map(m){return new I1(b=>this.iterate(S=>b(m(S))))}some(m){let b=!1;return this.iterate(S=>(b=m(S),!b)),b}findFirst(m){let b;return this.iterate(S=>m(S)?(b=S,!1):!0),b}findLast(m){let b;return this.iterate(S=>(m(S)&&(b=S),!0)),b}findLastMaxBy(m){let b,S=!0;return this.iterate(q=>((S||_1.isGreaterThan(m(q,b)))&&(S=!1,b=q),!0)),b}}t.$bc=I1;class P1{constructor(m){this.c=m}static createSortPermutation(m,b){const S=Array.from(m.keys()).sort((q,n1)=>b(m[q],m[n1]));return new P1(S)}apply(m){return m.map((b,S)=>m[this.c[S]])}inverse(){const m=this.c.slice();for(let b=0;b<this.c.length;b++)m[this.c[b]]=b;return new P1(m)}}t.$cc=P1;async function p1(g,m){return(await Promise.all(g.map(async(S,q)=>({element:S,ok:await m(S,q)})))).find(S=>S.ok)?.element}}),define(h1[5],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fb=h;function h(e,p){const I=this;let Q=!1,K;return function(){if(Q)return K;if(Q=!0,p)try{K=e.apply(I,arguments)}finally{p()}else K=e.apply(I,arguments);return K}}}),define(h1[13],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var h;(function(e){function p(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}e.is=p;const I=Object.freeze([]);function Q(){return I}e.empty=Q;function*K(n){yield n}e.single=K;function N(n){return p(n)?n:K(n)}e.wrap=N;function D(n){return n||I}e.from=D;function*W(n){for(let s=n.length-1;s>=0;s--)yield n[s]}e.reverse=W;function Y(n){return!n||n[Symbol.iterator]().next().done===!0}e.isEmpty=Y;function k(n){return n[Symbol.iterator]().next().value}e.first=k;function z(n,s){let f=0;for(const d of n)if(s(d,f++))return!0;return!1}e.some=z;function M(n,s){for(const f of n)if(s(f))return f}e.find=M;function*U(n,s){for(const f of n)s(f)&&(yield f)}e.filter=U;function*R(n,s){let f=0;for(const d of n)yield s(d,f++)}e.map=R;function*j(n,s){let f=0;for(const d of n)yield*s(d,f++)}e.flatMap=j;function*E(...n){for(const s of n)yield*s}e.concat=E;function O(n,s,f){let d=f;for(const r of n)d=s(d,r);return d}e.reduce=O;function*B(n,s,f=n.length){for(s<0&&(s+=n.length),f<0?f+=n.length:f>n.length&&(f=n.length);s<f;s++)yield n[s]}e.slice=B;function v(n,s=Number.POSITIVE_INFINITY){const f=[];if(s===0)return[f,n];const d=n[Symbol.iterator]();for(let r=0;r<s;r++){const o=d.next();if(o.done)return[f,e.empty()];f.push(o.value)}return[f,{[Symbol.iterator](){return d}}]}e.consume=v;async function i(n){const s=[];for await(const f of n)s.push(f);return Promise.resolve(s)}e.asyncToArray=i})(h||(t.Iterable=h={}))}),define(h1[14],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W=void 0;class h{constructor(p){this.d=p,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(p){this.c=p}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$W=h}),define(h1[15],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8c=void 0;class h{static{this.Undefined=new h(void 0)}constructor(I){this.element=I,this.next=h.Undefined,this.prev=h.Undefined}}class e{constructor(){this.a=h.Undefined,this.b=h.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===h.Undefined}clear(){let I=this.a;for(;I!==h.Undefined;){const Q=I.next;I.prev=h.Undefined,I.next=h.Undefined,I=Q}this.a=h.Undefined,this.b=h.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,Q){const K=new h(I);if(this.a===h.Undefined)this.a=K,this.b=K;else if(Q){const D=this.b;this.b=K,K.prev=D,D.next=K}else{const D=this.a;this.a=K,K.next=D,D.prev=K}this.c+=1;let N=!1;return()=>{N||(N=!0,this.e(K))}}shift(){if(this.a!==h.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==h.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==h.Undefined&&I.next!==h.Undefined){const Q=I.prev;Q.next=I.next,I.next.prev=Q}else I.prev===h.Undefined&&I.next===h.Undefined?(this.a=h.Undefined,this.b=h.Undefined):I.next===h.Undefined?(this.b=this.b.prev,this.b.next=h.Undefined):I.prev===h.Undefined&&(this.a=this.a.next,this.a.prev=h.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==h.Undefined;)yield I.element,I=I.next}}t.$8c=e}),define(h1[16],g1([0,1]),function(t1,t){"use strict";var h,e,p;Object.defineProperty(t,"__esModule",{value:!0}),t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.Touch=t.$Ec=t.$Dc=void 0,t.$Ac=I,t.$Bc=Q,t.$Cc=K,t.$Lc=B;function I(v,i,n){let s=v.get(i);return s===void 0&&(s=n,v.set(i,s)),s}function Q(v){const i=[];return v.forEach((n,s)=>{i.push(`${s} => ${n}`)}),`Map(${v.size}) {${i.join(", ")}}`}function K(v){const i=[];return v.forEach(n=>{i.push(n)}),`Set(${v.size}) {${i.join(", ")}}`}class N{constructor(i,n){this.uri=i,this.value=n}}function D(v){return Array.isArray(v)}class W{static{this.c=i=>i.toString()}constructor(i,n){if(this[h]="ResourceMap",i instanceof W)this.d=new Map(i.d),this.e=n??W.c;else if(D(i)){this.d=new Map,this.e=n??W.c;for(const[s,f]of i)this.set(s,f)}else this.d=new Map,this.e=i??W.c}set(i,n){return this.d.set(this.e(i),new N(i,n)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[s,f]of this.d)i(f.value,f.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(h=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}t.$Dc=W;class Y{constructor(i,n){this[e]="ResourceSet",!i||typeof i=="function"?this.c=new W(i):(this.c=new W(n),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,n){this.c.forEach((s,f)=>i.call(n,f,f,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(e=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ec=Y;var k;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(k||(t.Touch=k={}));class z{constructor(){this[p]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,n=k.None){const s=this.c.get(i);if(s)return n!==k.None&&this.m(s,n),s.value}set(i,n,s=k.None){let f=this.c.get(i);if(f)f.value=n,s!==k.None&&this.m(f,s);else{switch(f={key:i,value:n,next:void 0,previous:void 0},s){case k.None:this.k(f);break;case k.AsOld:this.j(f);break;case k.AsNew:this.k(f);break;default:this.k(f);break}this.c.set(i,f),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this.c.get(i);if(n)return this.c.delete(i),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,n){const s=this.g;let f=this.d;for(;f;){if(n?i.bind(n)(f.value,f.key,this):i(f.value,f.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const i=this,n=this.g;let s=this.d;const f={[Symbol.iterator](){return f},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const d={value:s.key,done:!1};return s=s.next,d}else return{value:void 0,done:!0}}};return f}values(){const i=this,n=this.g;let s=this.d;const f={[Symbol.iterator](){return f},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const d={value:s.value,done:!1};return s=s.next,d}else return{value:void 0,done:!0}}};return f}entries(){const i=this,n=this.g;let s=this.d;const f={[Symbol.iterator](){return f},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const d={value:[s.key,s.value],done:!1};return s=s.next,d}else return{value:void 0,done:!0}}};return f}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.d,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.next,s--;this.d=n,this.f=s,n&&(n.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.e,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.previous,s--;this.e=n,this.f=s,n&&(n.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const n=i.next,s=i.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}i.next=void 0,i.previous=void 0,this.g++}m(i,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==k.AsOld&&n!==k.AsNew)){if(n===k.AsOld){if(i===this.d)return;const s=i.next,f=i.previous;i===this.e?(f.next=void 0,this.e=f):(s.previous=f,f.next=s),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(n===k.AsNew){if(i===this.e)return;const s=i.next,f=i.previous;i===this.d?(s.previous=void 0,this.d=s):(s.previous=f,f.next=s),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((n,s)=>{i.push([s,n])}),i}fromJSON(i){this.clear();for(const[n,s]of i)this.set(n,s)}}t.$Fc=z;class M extends z{constructor(i,n=1){super(),this.n=i,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,n=k.AsNew){return super.get(i,n)}peek(i){return super.get(i,k.None)}set(i,n){return super.set(i,n,k.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class U extends M{constructor(i,n=1){super(i,n)}q(i){this.h(i)}set(i,n){return super.set(i,n),this.p(),this}}t.$Gc=U;class R extends M{constructor(i,n=1){super(i,n)}q(i){this.i(i)}set(i,n){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,n),this}}t.$Hc=R;class j{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let n=this.c.get(i)||0;return n===0?!1:(n--,n===0?this.c.delete(i):this.c.set(i,n),!0)}has(i){return this.c.has(i)}}t.$Ic=j;class E{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[n,s]of i)this.set(n,s)}clear(){this.c.clear(),this.d.clear()}set(i,n){this.c.set(i,n),this.d.set(n,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const n=this.c.get(i);return n===void 0?!1:(this.c.delete(i),this.d.delete(n),!0)}forEach(i,n){this.c.forEach((s,f)=>{i.call(n,s,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Jc=E;class O{constructor(){this.c=new Map}add(i,n){let s=this.c.get(i);s||(s=new Set,this.c.set(i,s)),s.add(n)}delete(i,n){const s=this.c.get(i);s&&(s.delete(n),s.size===0&&this.c.delete(i))}forEach(i,n){const s=this.c.get(i);s&&s.forEach(n)}get(i){const n=this.c.get(i);return n||new Set}}t.$Kc=O;function B(v,i){if(v===i)return!0;if(v.size!==i.size)return!1;for(const[n,s]of v)if(!i.has(n)||i.get(n)!==s)return!1;for(const[n]of i)if(!v.has(n))return!1;return!0}}),define(h1[6],g1([0,1,12,11,16,5,13]),function(t1,t,h,e,p,I,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=t.$5c=t.$4c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Mc=void 0,t.$Nc=W,t.$Oc=Y,t.$Pc=k,t.$Qc=U,t.$Rc=R,t.$Sc=j,t.$Tc=E,t.$Uc=O,t.$Vc=B,t.$6c=u;const K=!1;let N=null;class D{constructor(){this.b=new Map}static{this.a=0}c(l){let T=this.b.get(l);return T||(T={parent:null,source:null,isSingleton:!1,value:l,idx:D.a++},this.b.set(l,T)),T}trackDisposable(l){const T=this.c(l);T.source||(T.source=new Error().stack)}setParent(l,T){const F=this.c(l);F.parent=T}markAsDisposed(l){this.b.delete(l)}markAsSingleton(l){this.c(l).isSingleton=!0}f(l,T){const F=T.get(l);if(F)return F;const L=l.parent?this.f(this.c(l.parent),T):l;return T.set(l,L),L}getTrackedDisposables(){const l=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,l).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(l=10,T){let F;if(T)F=T;else{const e1=new Map,s1=[...this.b.values()].filter(C=>C.source!==null&&!this.f(C,e1).isSingleton);if(s1.length===0)return;const u1=new Set(s1.map(C=>C.value));if(F=s1.filter(C=>!(C.parent&&u1.has(C.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function L(e1){function s1(C,c1){for(;C.length>0&&c1.some(_1=>typeof _1=="string"?_1===C[0]:C[0].match(_1));)C.shift()}const u1=e1.source.split(`
`).map(C=>C.trim().replace("at ","")).filter(C=>C!=="");return s1(u1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),u1.reverse()}const A=new p.$Kc;for(const e1 of F){const s1=L(e1);for(let u1=0;u1<=s1.length;u1++)A.add(s1.slice(0,u1).join(`
`),e1)}F.sort((0,h.$8b)(e1=>e1.idx,h.$0b));let H="",i1=0;for(const e1 of F.slice(0,l)){i1++;const s1=L(e1),u1=[];for(let C=0;C<s1.length;C++){let c1=s1[C];c1=`(shared with ${A.get(s1.slice(0,C+1).join(`
`)).size}/${F.length} leaks) at ${c1}`;const L1=A.get(s1.slice(0,C).join(`
`)),U1=(0,e.$c)([...L1].map(O1=>L(O1)[C]),O1=>O1);delete U1[s1[C]];for(const[O1,S1]of Object.entries(U1))u1.unshift(`    - stacktraces of ${S1.length} other leaks continue with ${O1}`);u1.unshift(c1)}H+=`


==================== Leaking disposable ${i1}/${F.length}: ${e1.value.constructor.name} ====================
${u1.join(`
`)}
============================================================

`}return F.length>l&&(H+=`


... and ${F.length-l} more leaking disposables

`),{leaks:F,details:H}}}t.$Mc=D;function W($){N=$}if(K){const $="__is_disposable_tracked__";W(new class{trackDisposable(l){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[$]||console.log(T)},3e3)}setParent(l,T){if(l&&l!==i.None)try{l[$]=!0}catch{}}markAsDisposed(l){if(l&&l!==i.None)try{l[$]=!0}catch{}}markAsSingleton(l){}})}function Y($){return N?.trackDisposable($),$}function k($){N?.markAsDisposed($)}function z($,l){N?.setParent($,l)}function M($,l){if(N)for(const T of $)N.setParent(T,l)}function U($){return N?.markAsSingleton($),$}function R($){return typeof $=="object"&&$!==null&&typeof $.dispose=="function"&&$.dispose.length===0}function j($){if(Q.Iterable.is($)){const l=[];for(const T of $)if(T)try{T.dispose()}catch(F){l.push(F)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray($)?[]:$}else if($)return $.dispose(),$}function E($){for(const l of $)R(l)&&l.dispose();return[]}function O(...$){const l=B(()=>j($));return M($,l),l}function B($){const l=Y({dispose:(0,I.$fb)(()=>{k(l),$()})});return l}class v{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,Y(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{j(this.f)}finally{this.f.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return z(l,this),this.g?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(l),l}delete(l){if(l){if(l===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(l),l.dispose()}}deleteAndLeak(l){l&&this.f.has(l)&&(this.f.delete(l),z(l,null))}}t.$Wc=v;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new v,Y(this),z(this.q,this)}dispose(){k(this),this.q.dispose()}B(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(l)}}t.$Xc=i;class n{constructor(){this.b=!1,Y(this)}get value(){return this.b?void 0:this.a}set value(l){this.b||l===this.a||(this.a?.dispose(),l&&z(l,this),this.a=l)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const l=this.a;return this.a=void 0,l&&z(l,null),l}}t.$Yc=n;class s{constructor(l){this.a=new n,this.b=!1,this.a.value=l}get value(){return this.a.value}set value(l){this.b||l===this.a.value||(this.a.value=l)}dispose(){this.b=!0,this.a.dispose()}}t.$Zc=s;class f{constructor(l){this.b=l,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$1c=f;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,Y(this)}set(l){let T=l;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,k(this))},this}}t.$2c=d;class r{constructor(){this.a=new Map}acquire(l,...T){let F=this.a.get(l);F||(F={counter:0,object:this.b(l,...T)},this.a.set(l,F));const{object:L}=F,A=(0,I.$fb)(()=>{--F.counter===0&&(this.c(l,F.object),this.a.delete(l))});return F.counter++,{object:L,dispose:A}}}t.$3c=r;class o{constructor(l){this.a=l}async acquire(l,...T){const F=this.a.acquire(l,...T);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(L){throw F.dispose(),L}}}t.$4c=o;class a{constructor(l){this.object=l}dispose(){}}t.$5c=a;function u($){const l=new v;try{$(l)}finally{l.dispose()}}class y{constructor(){this.a=new Map,this.b=!1,Y(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{j(this.a.values())}finally{this.a.clear()}}has(l){return this.a.has(l)}get size(){return this.a.size}get(l){return this.a.get(l)}set(l,T,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(l)?.dispose(),this.a.set(l,T)}deleteAndDispose(l){this.a.get(l)?.dispose(),this.a.delete(l)}deleteAndLeak(l){const T=this.a.get(l);return this.a.delete(l),T}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$7c=y}),define(h1[17],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var h;(function(e){e[e.Uri=1]="Uri",e[e.Regexp=2]="Regexp",e[e.ScmResource=3]="ScmResource",e[e.ScmResourceGroup=4]="ScmResourceGroup",e[e.ScmProvider=5]="ScmProvider",e[e.CommentController=6]="CommentController",e[e.CommentThread=7]="CommentThread",e[e.CommentThreadInstance=8]="CommentThreadInstance",e[e.CommentThreadReply=9]="CommentThreadReply",e[e.CommentNode=10]="CommentNode",e[e.CommentThreadNode=11]="CommentThreadNode",e[e.TimelineActionContext=12]="TimelineActionContext",e[e.NotebookCellActionContext=13]="NotebookCellActionContext",e[e.NotebookActionContext=14]="NotebookActionContext",e[e.TerminalContext=15]="TerminalContext",e[e.TestItemContext=16]="TestItemContext",e[e.Date=17]="Date",e[e.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(h||(t.MarshalledId=h={}))}),define(h1[3],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.OS=t.OperatingSystem=t.$C=t.$B=t.$A=t.$z=t.$y=t.Language=t.$x=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.Platform=t.$h=void 0,t.$i=i,t.$E=o,t.$K=a,t.$h="en";let h=!1,e=!1,p=!1,I=!1,Q=!1,K=!1,N=!1,D=!1,W=!1,Y=!1,k,z=t.$h,M=t.$h,U,R;const j=globalThis;let E;typeof j.vscode<"u"&&typeof j.vscode.process<"u"?E=j.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(E=process);const O=typeof E?.versions?.electron=="string",B=O&&E?.type==="renderer";if(typeof E=="object"){h=E.platform==="win32",e=E.platform==="darwin",p=E.platform==="linux",I=p&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,N=O,W=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=t.$h,z=t.$h;const u=E.env.VSCODE_NLS_CONFIG;if(u)try{const y=JSON.parse(u);k=y.userLocale,M=y.osLocale,z=y.resolvedLanguage||t.$h,U=y.languagePack?.translationsConfigFile}catch{}Q=!0}else typeof navigator=="object"&&!B?(R=navigator.userAgent,h=R.indexOf("Windows")>=0,e=R.indexOf("Macintosh")>=0,D=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=R.indexOf("Linux")>=0,Y=R?.indexOf("Mobi")>=0,K=!0,z=globalThis._VSCODE_NLS_LANGUAGE||t.$h,k=navigator.language.toLowerCase(),M=k):console.error("Unable to resolve platform.");var v;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(v||(t.Platform=v={}));function i(u){switch(u){case v.Web:return"Web";case v.Mac:return"Mac";case v.Linux:return"Linux";case v.Windows:return"Windows"}}let n=v.Web;e?n=v.Mac:h?n=v.Windows:p&&(n=v.Linux),t.$j=h,t.$k=e,t.$l=p,t.$m=I,t.$n=Q,t.$o=N,t.$p=K,t.$q=K&&typeof j.importScripts=="function",t.$r=t.$q?j.origin:void 0,t.$s=D,t.$t=Y,t.$u=W,t.$v=n,t.$w=R,t.$x=z;var s;(function(u){function y(){return t.$x}u.value=y;function $(){return t.$x.length===2?t.$x==="en":t.$x.length>=3?t.$x[0]==="e"&&t.$x[1]==="n"&&t.$x[2]==="-":!1}u.isDefaultVariant=$;function l(){return t.$x==="en"}u.isDefault=l})(s||(t.Language=s={})),t.$y=k,t.$z=M,t.$A=U,t.$B=typeof j.postMessage=="function"&&!j.importScripts,t.$C=(()=>{if(t.$B){const u=[];j.addEventListener("message",$=>{if($.data&&$.data.vscodeScheduleAsyncWork)for(let l=0,T=u.length;l<T;l++){const F=u[l];if(F.id===$.data.vscodeScheduleAsyncWork){u.splice(l,1),F.callback();return}}});let y=0;return $=>{const l=++y;u.push({id:l,callback:$}),j.postMessage({vscodeScheduleAsyncWork:l},"*")}}return u=>setTimeout(u)})();var f;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(f||(t.OperatingSystem=f={})),t.OS=e||D?f.Macintosh:h?f.Windows:f.Linux;let d=!0,r=!1;function o(){if(!r){r=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,d=new Uint16Array(u.buffer)[0]===513}return d}t.$F=!!(t.$w&&t.$w.indexOf("Chrome")>=0),t.$G=!!(t.$w&&t.$w.indexOf("Firefox")>=0),t.$H=!!(!t.$F&&t.$w&&t.$w.indexOf("Safari")>=0),t.$I=!!(t.$w&&t.$w.indexOf("Edg/")>=0),t.$J=!!(t.$w&&t.$w.indexOf("Android")>=0);function a(u){return parseFloat(u)>=20}}),define(h1[18],g1([0,1,3]),function(t1,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hc=t.$gc=t.env=t.cwd=void 0;let e;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const I=p.process;e={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return h.$j?"win32":h.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=e.cwd,t.env=e.env,t.$gc=e.platform,t.$hc=e.arch});var Y1=this&&this.__createBinding||(Object.create?function(t1,t,h,e){e===void 0&&(e=h);var p=Object.getOwnPropertyDescriptor(t,h);(!p||("get"in p?!t.__esModule:p.writable||p.configurable))&&(p={enumerable:!0,get:function(){return t[h]}}),Object.defineProperty(t1,e,p)}:function(t1,t,h,e){e===void 0&&(e=h),t1[e]=t[h]}),Z1=this&&this.__setModuleDefault||(Object.create?function(t1,t){Object.defineProperty(t1,"default",{enumerable:!0,value:t})}:function(t1,t){t1.default=t}),k1=this&&this.__importStar||function(t1){if(t1&&t1.__esModule)return t1;var t={};if(t1!=null)for(var h in t1)h!=="default"&&Object.prototype.hasOwnProperty.call(t1,h)&&Y1(t,t1,h);return Z1(t,t1),t};define(h1[7],g1([0,1,18]),function(t1,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.sep=t.$uc=t.$tc=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=void 0,h=k1(h);const e=65,p=97,I=90,Q=122,K=46,N=47,D=92,W=58,Y=63;class k extends Error{constructor(s,f,d){let r;typeof f=="string"&&f.indexOf("not ")===0?(r="must not be",f=f.replace(/^not /,"")):r="must be";const o=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${o} ${r} of type ${f}`;a+=`. Received type ${typeof d}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function z(n,s){if(n===null||typeof n!="object")throw new k(s,"Object",n)}function M(n,s){if(typeof n!="string")throw new k(s,"string",n)}const U=h.$gc==="win32";function R(n){return n===N||n===D}function j(n){return n===N}function E(n){return n>=e&&n<=I||n>=p&&n<=Q}function O(n,s,f,d){let r="",o=0,a=-1,u=0,y=0;for(let $=0;$<=n.length;++$){if($<n.length)y=n.charCodeAt($);else{if(d(y))break;y=N}if(d(y)){if(!(a===$-1||u===1))if(u===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==K||r.charCodeAt(r.length-2)!==K){if(r.length>2){const l=r.lastIndexOf(f);l===-1?(r="",o=0):(r=r.slice(0,l),o=r.length-1-r.lastIndexOf(f)),a=$,u=0;continue}else if(r.length!==0){r="",o=0,a=$,u=0;continue}}s&&(r+=r.length>0?`${f}..`:"..",o=2)}else r.length>0?r+=`${f}${n.slice(a+1,$)}`:r=n.slice(a+1,$),o=$-a-1;a=$,u=0}else y===K&&u!==-1?++u:u=-1}return r}function B(n){return n?`${n[0]==="."?"":"."}${n}`:""}function v(n,s){z(s,"pathObject");const f=s.dir||s.root,d=s.base||`${s.name||""}${B(s.ext)}`;return f?f===s.root?`${f}${d}`:`${f}${n}${d}`:d}t.$ic={resolve(...n){let s="",f="",d=!1;for(let r=n.length-1;r>=-1;r--){let o;if(r>=0){if(o=n[r],M(o,`paths[${r}]`),o.length===0)continue}else s.length===0?o=h.cwd():(o=h.env[`=${s}`]||h.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==s.toLowerCase()&&o.charCodeAt(2)===D)&&(o=`${s}\\`));const a=o.length;let u=0,y="",$=!1;const l=o.charCodeAt(0);if(a===1)R(l)&&(u=1,$=!0);else if(R(l))if($=!0,R(o.charCodeAt(1))){let T=2,F=T;for(;T<a&&!R(o.charCodeAt(T));)T++;if(T<a&&T!==F){const L=o.slice(F,T);for(F=T;T<a&&R(o.charCodeAt(T));)T++;if(T<a&&T!==F){for(F=T;T<a&&!R(o.charCodeAt(T));)T++;(T===a||T!==F)&&(y=`\\\\${L}\\${o.slice(F,T)}`,u=T)}}}else u=1;else E(l)&&o.charCodeAt(1)===W&&(y=o.slice(0,2),u=2,a>2&&R(o.charCodeAt(2))&&($=!0,u=3));if(y.length>0)if(s.length>0){if(y.toLowerCase()!==s.toLowerCase())continue}else s=y;if(d){if(s.length>0)break}else if(f=`${o.slice(u)}\\${f}`,d=$,$&&s.length>0)break}return f=O(f,!d,"\\",R),d?`${s}\\${f}`:`${s}${f}`||"."},normalize(n){M(n,"path");const s=n.length;if(s===0)return".";let f=0,d,r=!1;const o=n.charCodeAt(0);if(s===1)return j(o)?"\\":n;if(R(o))if(r=!0,R(n.charCodeAt(1))){let u=2,y=u;for(;u<s&&!R(n.charCodeAt(u));)u++;if(u<s&&u!==y){const $=n.slice(y,u);for(y=u;u<s&&R(n.charCodeAt(u));)u++;if(u<s&&u!==y){for(y=u;u<s&&!R(n.charCodeAt(u));)u++;if(u===s)return`\\\\${$}\\${n.slice(y)}\\`;u!==y&&(d=`\\\\${$}\\${n.slice(y,u)}`,f=u)}}}else f=1;else E(o)&&n.charCodeAt(1)===W&&(d=n.slice(0,2),f=2,s>2&&R(n.charCodeAt(2))&&(r=!0,f=3));let a=f<s?O(n.slice(f),!r,"\\",R):"";return a.length===0&&!r&&(a="."),a.length>0&&R(n.charCodeAt(s-1))&&(a+="\\"),d===void 0?r?`\\${a}`:a:r?`${d}\\${a}`:`${d}${a}`},isAbsolute(n){M(n,"path");const s=n.length;if(s===0)return!1;const f=n.charCodeAt(0);return R(f)||s>2&&E(f)&&n.charCodeAt(1)===W&&R(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,f;for(let o=0;o<n.length;++o){const a=n[o];M(a,"path"),a.length>0&&(s===void 0?s=f=a:s+=`\\${a}`)}if(s===void 0)return".";let d=!0,r=0;if(typeof f=="string"&&R(f.charCodeAt(0))){++r;const o=f.length;o>1&&R(f.charCodeAt(1))&&(++r,o>2&&(R(f.charCodeAt(2))?++r:d=!1))}if(d){for(;r<s.length&&R(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return t.$ic.normalize(s)},relative(n,s){if(M(n,"from"),M(s,"to"),n===s)return"";const f=t.$ic.resolve(n),d=t.$ic.resolve(s);if(f===d||(n=f.toLowerCase(),s=d.toLowerCase(),n===s))return"";let r=0;for(;r<n.length&&n.charCodeAt(r)===D;)r++;let o=n.length;for(;o-1>r&&n.charCodeAt(o-1)===D;)o--;const a=o-r;let u=0;for(;u<s.length&&s.charCodeAt(u)===D;)u++;let y=s.length;for(;y-1>u&&s.charCodeAt(y-1)===D;)y--;const $=y-u,l=a<$?a:$;let T=-1,F=0;for(;F<l;F++){const A=n.charCodeAt(r+F);if(A!==s.charCodeAt(u+F))break;A===D&&(T=F)}if(F!==l){if(T===-1)return d}else{if($>l){if(s.charCodeAt(u+F)===D)return d.slice(u+F+1);if(F===2)return d.slice(u+F)}a>l&&(n.charCodeAt(r+F)===D?T=F:F===2&&(T=3)),T===-1&&(T=0)}let L="";for(F=r+T+1;F<=o;++F)(F===o||n.charCodeAt(F)===D)&&(L+=L.length===0?"..":"\\..");return u+=T,L.length>0?`${L}${d.slice(u,y)}`:(d.charCodeAt(u)===D&&++u,d.slice(u,y))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$ic.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===D){if(s.charCodeAt(1)===D){const f=s.charCodeAt(2);if(f!==Y&&f!==K)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(E(s.charCodeAt(0))&&s.charCodeAt(1)===W&&s.charCodeAt(2)===D)return`\\\\?\\${s}`;return n},dirname(n){M(n,"path");const s=n.length;if(s===0)return".";let f=-1,d=0;const r=n.charCodeAt(0);if(s===1)return R(r)?n:".";if(R(r)){if(f=d=1,R(n.charCodeAt(1))){let u=2,y=u;for(;u<s&&!R(n.charCodeAt(u));)u++;if(u<s&&u!==y){for(y=u;u<s&&R(n.charCodeAt(u));)u++;if(u<s&&u!==y){for(y=u;u<s&&!R(n.charCodeAt(u));)u++;if(u===s)return n;u!==y&&(f=d=u+1)}}}}else E(r)&&n.charCodeAt(1)===W&&(f=s>2&&R(n.charCodeAt(2))?3:2,d=f);let o=-1,a=!0;for(let u=s-1;u>=d;--u)if(R(n.charCodeAt(u))){if(!a){o=u;break}}else a=!1;if(o===-1){if(f===-1)return".";o=f}return n.slice(0,o)},basename(n,s){s!==void 0&&M(s,"suffix"),M(n,"path");let f=0,d=-1,r=!0,o;if(n.length>=2&&E(n.charCodeAt(0))&&n.charCodeAt(1)===W&&(f=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let a=s.length-1,u=-1;for(o=n.length-1;o>=f;--o){const y=n.charCodeAt(o);if(R(y)){if(!r){f=o+1;break}}else u===-1&&(r=!1,u=o+1),a>=0&&(y===s.charCodeAt(a)?--a===-1&&(d=o):(a=-1,d=u))}return f===d?d=u:d===-1&&(d=n.length),n.slice(f,d)}for(o=n.length-1;o>=f;--o)if(R(n.charCodeAt(o))){if(!r){f=o+1;break}}else d===-1&&(r=!1,d=o+1);return d===-1?"":n.slice(f,d)},extname(n){M(n,"path");let s=0,f=-1,d=0,r=-1,o=!0,a=0;n.length>=2&&n.charCodeAt(1)===W&&E(n.charCodeAt(0))&&(s=d=2);for(let u=n.length-1;u>=s;--u){const y=n.charCodeAt(u);if(R(y)){if(!o){d=u+1;break}continue}r===-1&&(o=!1,r=u+1),y===K?f===-1?f=u:a!==1&&(a=1):f!==-1&&(a=-1)}return f===-1||r===-1||a===0||a===1&&f===r-1&&f===d+1?"":n.slice(f,r)},format:v.bind(null,"\\"),parse(n){M(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const f=n.length;let d=0,r=n.charCodeAt(0);if(f===1)return R(r)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(R(r)){if(d=1,R(n.charCodeAt(1))){let T=2,F=T;for(;T<f&&!R(n.charCodeAt(T));)T++;if(T<f&&T!==F){for(F=T;T<f&&R(n.charCodeAt(T));)T++;if(T<f&&T!==F){for(F=T;T<f&&!R(n.charCodeAt(T));)T++;T===f?d=T:T!==F&&(d=T+1)}}}}else if(E(r)&&n.charCodeAt(1)===W){if(f<=2)return s.root=s.dir=n,s;if(d=2,R(n.charCodeAt(2))){if(f===3)return s.root=s.dir=n,s;d=3}}d>0&&(s.root=n.slice(0,d));let o=-1,a=d,u=-1,y=!0,$=n.length-1,l=0;for(;$>=d;--$){if(r=n.charCodeAt($),R(r)){if(!y){a=$+1;break}continue}u===-1&&(y=!1,u=$+1),r===K?o===-1?o=$:l!==1&&(l=1):o!==-1&&(l=-1)}return u!==-1&&(o===-1||l===0||l===1&&o===u-1&&o===a+1?s.base=s.name=n.slice(a,u):(s.name=n.slice(a,o),s.base=n.slice(a,u),s.ext=n.slice(o,u))),a>0&&a!==d?s.dir=n.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(U){const n=/\\/g;return()=>{const s=h.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>h.cwd()})();t.$jc={resolve(...n){let s="",f=!1;for(let d=n.length-1;d>=-1&&!f;d--){const r=d>=0?n[d]:i();M(r,`paths[${d}]`),r.length!==0&&(s=`${r}/${s}`,f=r.charCodeAt(0)===N)}return s=O(s,!f,"/",j),f?`/${s}`:s.length>0?s:"."},normalize(n){if(M(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===N,f=n.charCodeAt(n.length-1)===N;return n=O(n,!s,"/",j),n.length===0?s?"/":f?"./":".":(f&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return M(n,"path"),n.length>0&&n.charCodeAt(0)===N},join(...n){if(n.length===0)return".";let s;for(let f=0;f<n.length;++f){const d=n[f];M(d,"path"),d.length>0&&(s===void 0?s=d:s+=`/${d}`)}return s===void 0?".":t.$jc.normalize(s)},relative(n,s){if(M(n,"from"),M(s,"to"),n===s||(n=t.$jc.resolve(n),s=t.$jc.resolve(s),n===s))return"";const f=1,d=n.length,r=d-f,o=1,a=s.length-o,u=r<a?r:a;let y=-1,$=0;for(;$<u;$++){const T=n.charCodeAt(f+$);if(T!==s.charCodeAt(o+$))break;T===N&&(y=$)}if($===u)if(a>u){if(s.charCodeAt(o+$)===N)return s.slice(o+$+1);if($===0)return s.slice(o+$)}else r>u&&(n.charCodeAt(f+$)===N?y=$:$===0&&(y=0));let l="";for($=f+y+1;$<=d;++$)($===d||n.charCodeAt($)===N)&&(l+=l.length===0?"..":"/..");return`${l}${s.slice(o+y)}`},toNamespacedPath(n){return n},dirname(n){if(M(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===N;let f=-1,d=!0;for(let r=n.length-1;r>=1;--r)if(n.charCodeAt(r)===N){if(!d){f=r;break}}else d=!1;return f===-1?s?"/":".":s&&f===1?"//":n.slice(0,f)},basename(n,s){s!==void 0&&M(s,"ext"),M(n,"path");let f=0,d=-1,r=!0,o;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let a=s.length-1,u=-1;for(o=n.length-1;o>=0;--o){const y=n.charCodeAt(o);if(y===N){if(!r){f=o+1;break}}else u===-1&&(r=!1,u=o+1),a>=0&&(y===s.charCodeAt(a)?--a===-1&&(d=o):(a=-1,d=u))}return f===d?d=u:d===-1&&(d=n.length),n.slice(f,d)}for(o=n.length-1;o>=0;--o)if(n.charCodeAt(o)===N){if(!r){f=o+1;break}}else d===-1&&(r=!1,d=o+1);return d===-1?"":n.slice(f,d)},extname(n){M(n,"path");let s=-1,f=0,d=-1,r=!0,o=0;for(let a=n.length-1;a>=0;--a){const u=n.charCodeAt(a);if(u===N){if(!r){f=a+1;break}continue}d===-1&&(r=!1,d=a+1),u===K?s===-1?s=a:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||d===-1||o===0||o===1&&s===d-1&&s===f+1?"":n.slice(s,d)},format:v.bind(null,"/"),parse(n){M(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const f=n.charCodeAt(0)===N;let d;f?(s.root="/",d=1):d=0;let r=-1,o=0,a=-1,u=!0,y=n.length-1,$=0;for(;y>=d;--y){const l=n.charCodeAt(y);if(l===N){if(!u){o=y+1;break}continue}a===-1&&(u=!1,a=y+1),l===K?r===-1?r=y:$!==1&&($=1):r!==-1&&($=-1)}if(a!==-1){const l=o===0&&f?1:o;r===-1||$===0||$===1&&r===a-1&&r===o+1?s.base=s.name=n.slice(l,a):(s.name=n.slice(l,r),s.base=n.slice(l,a),s.ext=n.slice(r,a))}return o>0?s.dir=n.slice(0,o-1):f&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$jc.win32=t.$ic.win32=t.$ic,t.$jc.posix=t.$ic.posix=t.$jc,t.$kc=U?t.$ic.normalize:t.$jc.normalize,t.$lc=U?t.$ic.isAbsolute:t.$jc.isAbsolute,t.$mc=U?t.$ic.join:t.$jc.join,t.$nc=U?t.$ic.resolve:t.$jc.resolve,t.$oc=U?t.$ic.relative:t.$jc.relative,t.$pc=U?t.$ic.dirname:t.$jc.dirname,t.$qc=U?t.$ic.basename:t.$jc.basename,t.$rc=U?t.$ic.extname:t.$jc.extname,t.$sc=U?t.$ic.format:t.$jc.format,t.$tc=U?t.$ic.parse:t.$jc.parse,t.$uc=U?t.$ic.toNamespacedPath:t.$jc.toNamespacedPath,t.sep=U?t.$ic.sep:t.$jc.sep,t.$wc=U?t.$ic.delimiter:t.$jc.delimiter}),define(h1[19],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=void 0;const h=globalThis.performance&&typeof globalThis.performance.now=="function";class e{static create(I){return new e(I)}constructor(I){this.c=h&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ie=e}),define(h1[8],g1([0,1,2,5,6,15,19]),function(t1,t,h,e,p,I,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$ke=t.Event=void 0,t.$le=z;const K=!1,N=!1,D=!1;var W;(function(L){L.None=()=>p.$Xc.None;function A(X){if(D){const{onDidAddListener:G}=X,Z=U.create();let V=0;X.onDidAddListener=()=>{++V===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),G?.()}}}function H(X,G){return S1(X,()=>{},0,void 0,!0,void 0,G)}L.defer=H;function i1(X){return(G,Z=null,V)=>{let x=!1,o1;return o1=X(a1=>{if(!x)return o1?o1.dispose():x=!0,G.call(Z,a1)},null,V),x&&o1.dispose(),o1}}L.once=i1;function e1(X,G){return L.once(L.filter(X,G))}L.onceIf=e1;function s1(X,G,Z){return U1((V,x=null,o1)=>X(a1=>V.call(x,G(a1)),null,o1),Z)}L.map=s1;function u1(X,G,Z){return U1((V,x=null,o1)=>X(a1=>{G(a1),V.call(x,a1)},null,o1),Z)}L.forEach=u1;function C(X,G,Z){return U1((V,x=null,o1)=>X(a1=>G(a1)&&V.call(x,a1),null,o1),Z)}L.filter=C;function c1(X){return X}L.signal=c1;function _1(...X){return(G,Z=null,V)=>{const x=(0,p.$Uc)(...X.map(o1=>o1(a1=>G.call(Z,a1))));return O1(x,V)}}L.any=_1;function L1(X,G,Z,V){let x=Z;return s1(X,o1=>(x=G(x,o1),x),V)}L.reduce=L1;function U1(X,G){let Z;const V={onWillAddFirstListener(){Z=X(x.fire,x)},onDidRemoveLastListener(){Z?.dispose()}};G||A(V);const x=new n(V);return G?.add(x),x.event}function O1(X,G){return G instanceof Array?G.push(X):G&&G.add(X),X}function S1(X,G,Z=100,V=!1,x=!1,o1,a1){let d1,m1,r1,R1=0,F1;const K1={leakWarningThreshold:o1,onWillAddFirstListener(){d1=X(V1=>{R1++,m1=G(m1,V1),V&&!r1&&(j1.fire(m1),m1=void 0),F1=()=>{const B1=m1;m1=void 0,r1=void 0,(!V||R1>1)&&j1.fire(B1),R1=0},typeof Z=="number"?(clearTimeout(r1),r1=setTimeout(F1,Z)):r1===void 0&&(r1=0,queueMicrotask(F1))})},onWillRemoveListener(){x&&R1>0&&F1?.()},onDidRemoveLastListener(){F1=void 0,d1.dispose()}};a1||A(K1);const j1=new n(K1);return a1?.add(j1),j1.event}L.debounce=S1;function G1(X,G=0,Z){return L.debounce(X,(V,x)=>V?(V.push(x),V):[x],G,void 0,!0,void 0,Z)}L.accumulate=G1;function H1(X,G=(V,x)=>V===x,Z){let V=!0,x;return C(X,o1=>{const a1=V||!G(o1,x);return V=!1,x=o1,a1},Z)}L.latch=H1;function I1(X,G,Z){return[L.filter(X,G,Z),L.filter(X,V=>!G(V),Z)]}L.split=I1;function P1(X,G=!1,Z=[],V){let x=Z.slice(),o1=X(m1=>{x?x.push(m1):d1.fire(m1)});V&&V.add(o1);const a1=()=>{x?.forEach(m1=>d1.fire(m1)),x=null},d1=new n({onWillAddFirstListener(){o1||(o1=X(m1=>d1.fire(m1)),V&&V.add(o1))},onDidAddFirstListener(){x&&(G?setTimeout(a1):a1())},onDidRemoveLastListener(){o1&&o1.dispose(),o1=null}});return V&&V.add(d1),d1.event}L.buffer=P1;function p1(X,G){return(V,x,o1)=>{const a1=G(new m);return X(function(d1){const m1=a1.evaluate(d1);m1!==g&&V.call(x,m1)},void 0,o1)}}L.chain=p1;const g=Symbol("HaltChainable");class m{constructor(){this.f=[]}map(G){return this.f.push(G),this}forEach(G){return this.f.push(Z=>(G(Z),Z)),this}filter(G){return this.f.push(Z=>G(Z)?Z:g),this}reduce(G,Z){let V=Z;return this.f.push(x=>(V=G(V,x),V)),this}latch(G=(Z,V)=>Z===V){let Z=!0,V;return this.f.push(x=>{const o1=Z||!G(x,V);return Z=!1,V=x,o1?x:g}),this}evaluate(G){for(const Z of this.f)if(G=Z(G),G===g)break;return G}}function b(X,G,Z=V=>V){const V=(...d1)=>a1.fire(Z(...d1)),x=()=>X.on(G,V),o1=()=>X.removeListener(G,V),a1=new n({onWillAddFirstListener:x,onDidRemoveLastListener:o1});return a1.event}L.fromNodeEventEmitter=b;function S(X,G,Z=V=>V){const V=(...d1)=>a1.fire(Z(...d1)),x=()=>X.addEventListener(G,V),o1=()=>X.removeEventListener(G,V),a1=new n({onWillAddFirstListener:x,onDidRemoveLastListener:o1});return a1.event}L.fromDOMEventEmitter=S;function q(X){return new Promise(G=>i1(X)(G))}L.toPromise=q;function n1(X){const G=new n;return X.then(Z=>{G.fire(Z)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}L.fromPromise=n1;function f1(X,G){return X(Z=>G.fire(Z))}L.forward=f1;function $1(X,G,Z){return G(Z),X(V=>G(V))}L.runAndSubscribe=$1;class b1{constructor(G,Z){this._observable=G,this.f=0,this.g=!1;const V={onWillAddFirstListener:()=>{G.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Z||A(V),this.emitter=new n(V),Z&&Z.add(this.emitter)}beginUpdate(G){this.f++}handlePossibleChange(G){}handleChange(G,Z){this.g=!0}endUpdate(G){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function A1(X,G){return new b1(X,G).emitter.event}L.fromObservable=A1;function v1(X){return(G,Z,V)=>{let x=0,o1=!1;const a1={beginUpdate(){x++},endUpdate(){x--,x===0&&(X.reportChanges(),o1&&(o1=!1,G.call(Z)))},handlePossibleChange(){},handleChange(){o1=!0}};X.addObserver(a1),X.reportChanges();const d1={dispose(){X.removeObserver(a1)}};return V instanceof p.$Wc?V.add(d1):Array.isArray(V)&&V.push(d1),d1}}L.fromObservableLight=v1})(W||(t.Event=W={}));class Y{static{this.all=new Set}static{this.f=0}constructor(A){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${A}_${Y.f++}`,Y.all.add(this)}start(A){this.g=new Q.$ie,this.listenerCount=A}stop(){if(this.g){const A=this.g.elapsed();this.durations.push(A),this.elapsedOverall+=A,this.invocationCount+=1,this.g=void 0}}}t.$ke=Y;let k=-1;function z(L){const A=k;return k=L,{dispose(){k=A}}}class M{static{this.f=1}constructor(A,H,i1=(M.f++).toString(16).padStart(3,"0")){this.j=A,this.threshold=H,this.name=i1,this.h=0}dispose(){this.g?.clear()}check(A,H){const i1=this.threshold;if(i1<=0||H<i1)return;this.g||(this.g=new Map);const e1=this.g.get(A.value)||0;if(this.g.set(A.value,e1+1),this.h-=1,this.h<=0){this.h=i1*.5;const[s1,u1]=this.getMostFrequentStack(),C=`[${this.name}] potential listener LEAK detected, having ${H} listeners already. MOST frequent listener (${u1}):`;console.warn(C),console.warn(s1);const c1=new R(C,s1);this.j(c1)}return()=>{const s1=this.g.get(A.value)||0;this.g.set(A.value,s1-1)}}getMostFrequentStack(){if(!this.g)return;let A,H=0;for(const[i1,e1]of this.g)(!A||H<e1)&&(A=[i1,e1],H=e1);return A}}class U{static create(){const A=new Error;return new U(A.stack??"")}constructor(A){this.value=A}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class R extends Error{constructor(A,H){super(A),this.name="ListenerLeakError",this.stack=H}}t.$me=R;class j extends Error{constructor(A,H){super(A),this.name="ListenerRefusalError",this.stack=H}}t.$ne=j;let E=0;class O{constructor(A){this.value=A,this.id=E++}}const B=2,v=(L,A)=>{if(L instanceof O)A(L);else for(let H=0;H<L.length;H++){const i1=L[H];i1&&A(i1)}};let i;if(K){const L=[];setInterval(()=>{L.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(L.join(`
`)),L.length=0)},3e3),i=new FinalizationRegistry(A=>{typeof A=="string"&&L.push(A)})}class n{constructor(A){this.z=0,this.f=A,this.g=k>0||this.f?.leakWarningThreshold?new M(A?.onListenerError??h.$2,this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new Y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(N){const A=this.u;queueMicrotask(()=>{v(A,H=>H.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(A,H,i1)=>{if(this.g&&this.z>this.g.threshold**2){const c1=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(c1);const _1=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],L1=new j(`${c1}. HINT: Stack shows most frequent listener (${_1[1]}-times)`,_1[0]);return(this.f?.onListenerError||h.$2)(L1),p.$Xc.None}if(this.m)return p.$Xc.None;H&&(A=A.bind(H));const e1=new O(A);let s1,u1;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(e1.stack=U.create(),s1=this.g.check(e1.stack,this.z+1)),N&&(e1.stack=u1??U.create()),this.u?this.u instanceof O?(this.w??=new f,this.u=[this.u,e1]):this.u.push(e1):(this.f?.onWillAddFirstListener?.(this),this.u=e1,this.f?.onDidAddFirstListener?.(this)),this.z++;const C=(0,p.$Vc)(()=>{i?.unregister(C),s1?.(),this.A(e1)});if(i1 instanceof p.$Wc?i1.add(C):Array.isArray(i1)&&i1.push(C),i){const c1=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_1=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(c1);i.register(C,_1?.[2]??c1,C)}return C},this.q}A(A){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const H=this.u,i1=H.indexOf(A);if(i1===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,H[i1]=void 0;const e1=this.w.current===this;if(this.z*B<=H.length){let s1=0;for(let u1=0;u1<H.length;u1++)H[u1]?H[s1++]=H[u1]:e1&&(this.w.end--,s1<this.w.i&&this.w.i--);H.length=s1}}B(A,H){if(!A)return;const i1=this.f?.onListenerError||h.$2;if(!i1){A.value(H);return}try{A.value(H)}catch(e1){i1(e1)}}C(A){const H=A.current.u;for(;A.i<A.end;)this.B(H[A.i++],A.value);A.reset()}fire(A){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof O)this.B(this.u,A);else{const H=this.w;H.enqueue(this,A,this.u.length),this.C(H)}this.j?.stop()}hasListeners(){return this.z>0}}t.$oe=n;const s=()=>new f;t.$pe=s;class f{constructor(){this.i=-1,this.end=0}enqueue(A,H,i1){this.i=0,this.end=i1,this.current=A,this.value=H}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends n{async fireAsync(A,H,i1){if(this.u)for(this.h||(this.h=new I.$8c),v(this.u,e1=>this.h.push([e1.value,A]));this.h.size>0&&!H.isCancellationRequested;){const[e1,s1]=this.h.shift(),u1=[],C={...s1,token:H,waitUntil:c1=>{if(Object.isFrozen(u1))throw new Error("waitUntil can NOT be called asynchronous");i1&&(c1=i1(c1,e1)),u1.push(c1)}};try{e1(C)}catch(c1){(0,h.$2)(c1);continue}Object.freeze(u1),await Promise.allSettled(u1).then(c1=>{for(const _1 of c1)_1.status==="rejected"&&(0,h.$2)(_1.reason)})}}}t.$qe=d;class r extends n{get isPaused(){return this.h!==0}constructor(A){super(A),this.h=0,this.s=new I.$8c,this.t=A?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const A=Array.from(this.s);this.s.clear(),super.fire(this.t(A))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(A){this.z&&(this.h!==0?this.s.push(A):super.fire(A))}}t.$re=r;class o extends r{constructor(A){super(A),this.k=A.delay??100}fire(A){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(A)}}t.$se=o;class a extends n{constructor(A){super(A),this.h=[],this.k=A?.merge}fire(A){this.hasListeners()&&(this.h.push(A),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(H=>super.fire(H)),this.h=[]}))}}t.$te=a;class u{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(A){const H={event:A,listener:null};this.h.push(H),this.g&&this.m(H);const i1=()=>{this.g&&this.o(H);const e1=this.h.indexOf(H);this.h.splice(e1,1)};return(0,p.$Vc)((0,e.$fb)(i1))}j(){this.g=!0,this.h.forEach(A=>this.m(A))}k(){this.g=!1,this.h.forEach(A=>this.o(A))}m(A){A.listener=A.event(H=>this.f.fire(H))}o(A){A.listener?.dispose(),A.listener=null}dispose(){this.f.dispose();for(const A of this.h)A.listener?.dispose();this.h=[]}}t.$ue=u;class y{constructor(A,H,i1,e1){this.f=new p.$Wc;const s1=this.f.add(new u),u1=this.f.add(new p.$7c);function C(c1){u1.set(c1,s1.add(e1(c1)))}for(const c1 of A)C(c1);this.f.add(H(c1=>{C(c1)})),this.f.add(i1(c1=>{u1.deleteAndDispose(c1)})),this.event=s1.event}dispose(){this.f.dispose()}}t.$ve=y;class ${constructor(){this.f=[]}wrapEvent(A,H,i1){return(e1,s1,u1)=>A(C=>{const c1=this.f[this.f.length-1];if(!H){c1?c1.buffers.push(()=>e1.call(s1,C)):e1.call(s1,C);return}const _1=c1;if(!_1){e1.call(s1,H(i1,C));return}_1.items??=[],_1.items.push(C),_1.buffers.length===0&&c1.buffers.push(()=>{_1.reducedResult??=i1?_1.items.reduce(H,i1):_1.items.reduce(H),e1.call(s1,_1.reducedResult)})},void 0,u1)}bufferEvents(A){const H={buffers:new Array};this.f.push(H);const i1=A();return this.f.pop(),H.buffers.forEach(e1=>e1()),i1}}t.$we=$;class l{constructor(){this.f=!1,this.g=W.None,this.h=p.$Xc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(A){this.g=A,this.f&&(this.h.dispose(),this.h=A(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$xe=l;class T{static const(A){return new F(A)}constructor(A){this.g=A,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(A){A!==this.g&&(this.g=A,this.f.fire(void 0))}}t.$ye=T;class F{constructor(A){this.value=A,this.onDidChange=W.None}}}),define(h1[20],g1([0,1,8]),function(t1,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.CancellationToken=void 0,t.$Ae=K;const e=Object.freeze(function(N,D){const W=setTimeout(N.bind(D),0);return{dispose(){clearTimeout(W)}}});var p;(function(N){function D(W){return W===N.None||W===N.Cancelled||W instanceof I?!0:!W||typeof W!="object"?!1:typeof W.isCancellationRequested=="boolean"&&typeof W.onCancellationRequested=="function"}N.isCancellationToken=D,N.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),N.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(p||(t.CancellationToken=p={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?e:(this.b||(this.b=new h.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class Q{constructor(D){this.f=void 0,this.g=void 0,this.g=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=p.Cancelled}dispose(D=!1){D&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=p.None}}t.$ze=Q;function K(N){const D=new Q;return N.add({dispose(){D.cancel()}}),D.token}}),define(h1[21],g1([0,1,20]),function(t1,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cf=t.$bf=t.$_e=void 0,t.$af=p;class e{constructor(N){this.b=N,this.a=null}get(){if(this.a)return this.a;const N=new h.$ze,D=this.b(N.token);return this.a={promise:D,dispose:()=>{this.a=null,N.cancel(),N.dispose()}},this.a}}t.$_e=e;function p(K){return K}class I{constructor(N,D){this.a=void 0,this.b=void 0,typeof N=="function"?(this.c=N,this.d=p):(this.c=D,this.d=N.getCacheKey)}get(N){const D=this.d(N);return this.b!==D&&(this.b=D,this.a=this.c(N)),this.a}}t.$bf=I;class Q{get cachedValues(){return this.a}constructor(N,D){this.a=new Map,this.b=new Map,typeof N=="function"?(this.c=N,this.d=p):(this.c=D,this.d=N.getCacheKey)}get(N){const D=this.d(N);if(this.b.has(D))return this.b.get(D);const W=this.c(N);return this.a.set(N,W),this.b.set(D,W),W}}t.$cf=Q}),define(h1[22],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hg=h,t.$ig=e,t.$jg=p,t.$kg=I,t.$lg=Q,t.$mg=K,t.$ng=N,t.$og=D,t.$pg=W,t.$qg=Y,t.$rg=k,t.$sg=z,t.$tg=M,t.$ug=R,t.$vg=j,t.$wg=E,t.$xg=O,t.$yg=B,t.$zg=v;function h(i){return typeof i=="string"}function e(i){return Array.isArray(i)&&i.every(n=>h(n))}function p(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function I(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function Q(i){return typeof i=="number"&&!isNaN(i)}function K(i){return!!i&&typeof i[Symbol.iterator]=="function"}function N(i){return i===!0||i===!1}function D(i){return typeof i>"u"}function W(i){return!Y(i)}function Y(i){return D(i)||i===null}function k(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function z(i){if(Y(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function M(...i){const n=[];for(let s=0;s<i.length;s++){const f=i[s];if(Y(f))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(f)}return n}const U=Object.prototype.hasOwnProperty;function R(i){if(!p(i))return!1;for(const n in i)if(U.call(i,n))return!1;return!0}function j(i){return typeof i=="function"}function E(...i){return i.length>0&&i.every(j)}function O(i,n){const s=Math.min(i.length,n.length);for(let f=0;f<s;f++)B(i[f],n[f])}function B(i,n){if(h(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(j(n)){try{if(i instanceof n)return}catch{}if(!Y(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function v(i){return i}}),define(h1[23],g1([0,1,22]),function(t1,t,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ho=e,t.$io=p,t.$jo=Q,t.$ko=N,t.$lo=D,t.$mo=W,t.$no=Y,t.$oo=k,t.$po=z,t.$qo=M,t.$ro=U,t.$so=R,t.$to=j;function e(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const O=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([B,v])=>{O[B]=v&&typeof v=="object"?e(v):v}),O}function p(E){if(!E||typeof E!="object")return E;const O=[E];for(;O.length>0;){const B=O.shift();Object.freeze(B);for(const v in B)if(I.call(B,v)){const i=B[v];typeof i=="object"&&!Object.isFrozen(i)&&!(0,h.$kg)(i)&&O.push(i)}}return E}const I=Object.prototype.hasOwnProperty;function Q(E,O){return K(E,O,new Set)}function K(E,O,B){if((0,h.$qg)(E))return E;const v=O(E);if(typeof v<"u")return v;if(Array.isArray(E)){const i=[];for(const n of E)i.push(K(n,O,B));return i}if((0,h.$jg)(E)){if(B.has(E))throw new Error("Cannot clone recursive data-structure");B.add(E);const i={};for(const n in E)I.call(E,n)&&(i[n]=K(E[n],O,B));return B.delete(E),i}return E}function N(E,O,B=!0){return(0,h.$jg)(E)?((0,h.$jg)(O)&&Object.keys(O).forEach(v=>{v in E?B&&((0,h.$jg)(E[v])&&(0,h.$jg)(O[v])?N(E[v],O[v],B):E[v]=O[v]):E[v]=O[v]}),E):O}function D(E,O){if(E===O)return!0;if(E==null||O===null||O===void 0||typeof E!=typeof O||typeof E!="object"||Array.isArray(E)!==Array.isArray(O))return!1;let B,v;if(Array.isArray(E)){if(E.length!==O.length)return!1;for(B=0;B<E.length;B++)if(!D(E[B],O[B]))return!1}else{const i=[];for(v in E)i.push(v);i.sort();const n=[];for(v in O)n.push(v);if(n.sort(),!D(i,n))return!1;for(B=0;B<i.length;B++)if(!D(E[i[B]],O[i[B]]))return!1}return!0}function W(E){const O=new Set;return JSON.stringify(E,(B,v)=>{if((0,h.$jg)(v)||Array.isArray(v)){if(O.has(v))return"[Circular]";O.add(v)}return typeof v=="bigint"?`[BigInt ${v.toString()}]`:v})}function Y(E,O){const B=Object.create(null);return!E||!O||Object.keys(O).forEach(i=>{const n=E[i],s=O[i];D(n,s)||(B[i]=s)}),B}function k(E,O){const B=O.toLowerCase(),v=Object.keys(E).find(i=>i.toLowerCase()===B);return v?E[v]:E[O]}function z(E,O){const B=Object.create(null);for(const[v,i]of Object.entries(E))O(v,i)&&(B[v]=i);return B}function M(E){let O=[];for(;Object.prototype!==E;)O=O.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return O}function U(E){const O=[];for(const B of M(E))typeof E[B]=="function"&&O.push(B);return O}function R(E,O){const B=i=>function(){const n=Array.prototype.slice.call(arguments,0);return O(i,n)},v={};for(const i of E)v[i]=B(i);return v}function j(E,O){const B={};for(const[v,i]of Object.entries(E))B[v]=O(i,v);return B}}),define(h1[24],g1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$df=e,t.$ef=p;var h;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h||(t.Constants=h={}));function e(I){return I<0?0:I>h.MAX_UINT_8?h.MAX_UINT_8:I|0}function p(I){return I<0?0:I>h.MAX_UINT_32?h.MAX_UINT_32:I|0}}),define(h1[9],g1([0,1,21,4,14,24]),function(t1,t,h,e,p,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gg=t.$fg=t.$eg=t.GraphemeBreakType=t.$7f=t.$Yf=t.$Rf=t.$Qf=void 0,t.$ff=Q,t.$gf=N,t.$hf=W,t.$if=Y,t.$jf=k,t.$kf=z,t.$lf=M,t.$mf=U,t.$nf=R,t.$of=j,t.$pf=E,t.$qf=O,t.$rf=B,t.$sf=v,t.$tf=i,t.$uf=n,t.$vf=s,t.$wf=f,t.$xf=d,t.$yf=r,t.$zf=o,t.$Af=a,t.$Bf=u,t.$Cf=y,t.$Df=$,t.$Ef=l,t.$Ff=T,t.$Gf=F,t.$Hf=L,t.$If=A,t.$Jf=H,t.$Kf=i1,t.$Lf=e1,t.$Mf=s1,t.$Nf=u1,t.$Of=C,t.$Pf=c1,t.$Sf=O1,t.$Tf=S1,t.$Uf=G1,t.$Vf=H1,t.$Wf=p1,t.$Xf=m,t.$Zf=b,t.$1f=S,t.$2f=q,t.$3f=n1,t.$4f=$1,t.$5f=b1,t.$6f=v1,t.$8f=X,t.$9f=G,t.$0f=Z,t.$$f=V,t.$_f=x,t.$ag=o1,t.$bg=a1,t.$cg=d1,t.$dg=K1;function Q(c){return!c||typeof c!="string"?!0:c.trim().length===0}const K=/{(\d+)}/g;function N(c,..._){return _.length===0?c:c.replace(K,function(w,P){const J=parseInt(P,10);return isNaN(J)||J<0||J>=_.length?w:_[J]})}const D=/{([^}]+)}/g;function W(c,_){return Object.keys(_).length===0?c:c.replace(D,(w,P)=>_[P]??w)}function Y(c){return c.replace(/[<>"'&]/g,_=>{switch(_){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return _})}function k(c){return c.replace(/[<>&]/g,function(_){switch(_){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _}})}function z(c){return c.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function M(c,_){let w=0,P=c.indexOf(_);for(;P!==-1;)w++,P=c.indexOf(_,P+_.length);return w}function U(c,_,w="\u2026"){return c.length<=_?c:`${c.substr(0,_)}${w}`}function R(c,_,w="\u2026"){if(c.length<=_)return c;const P=Math.ceil(_/2)-w.length/2,J=Math.floor(_/2)-w.length/2;return`${c.substr(0,P)}${w}${c.substr(c.length-J)}`}function j(c,_=" "){const w=E(c,_);return O(w,_)}function E(c,_){if(!c||!_)return c;const w=_.length;if(w===0||c.length===0)return c;let P=0;for(;c.indexOf(_,P)===P;)P=P+w;return c.substring(P)}function O(c,_){if(!c||!_)return c;const w=_.length,P=c.length;if(w===0||P===0)return c;let J=P,l1=-1;for(;l1=c.lastIndexOf(_,J-1),!(l1===-1||l1+w!==J);){if(l1===0)return"";J=l1}return c.substring(0,J)}function B(c){return c.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(c){return c.replace(/\*/g,"")}function i(c,_,w={}){if(!c)throw new Error("Cannot create regex from empty string");_||(c=z(c)),w.wholeWord&&(/\B/.test(c.charAt(0))||(c="\\b"+c),/\B/.test(c.charAt(c.length-1))||(c=c+"\\b"));let P="";return w.global&&(P+="g"),w.matchCase||(P+="i"),w.multiline&&(P+="m"),w.unicode&&(P+="u"),new RegExp(c,P)}function n(c){return c.source==="^"||c.source==="^$"||c.source==="$"||c.source==="^\\s*$"?!1:!!(c.exec("")&&c.lastIndex===0)}function s(c){return c.split(/\r\n|\r|\n/)}function f(c){const _=[],w=c.split(/(\r\n|\r|\n)/);for(let P=0;P<Math.ceil(w.length/2);P++)_.push(w[2*P]+(w[2*P+1]??""));return _}function d(c){for(let _=0,w=c.length;_<w;_++){const P=c.charCodeAt(_);if(P!==e.CharCode.Space&&P!==e.CharCode.Tab)return _}return-1}function r(c,_=0,w=c.length){for(let P=_;P<w;P++){const J=c.charCodeAt(P);if(J!==e.CharCode.Space&&J!==e.CharCode.Tab)return c.substring(_,P)}return c.substring(_,w)}function o(c,_=c.length-1){for(let w=_;w>=0;w--){const P=c.charCodeAt(w);if(P!==e.CharCode.Space&&P!==e.CharCode.Tab)return w}return-1}function a(c,_,w){const P=[];let J=0;for(const l1 of c.matchAll(_)){if(P.push(c.slice(J,l1.index)),l1.index===void 0)throw new Error("match.index should be defined");J=l1.index+l1[0].length,P.push(w(l1[0],...l1.slice(1),l1.index,c,l1.groups))}return P.push(c.slice(J)),Promise.all(P).then(l1=>l1.join(""))}function u(c,_){return c<_?-1:c>_?1:0}function y(c,_,w=0,P=c.length,J=0,l1=_.length){for(;w<P&&J<l1;w++,J++){const T1=c.charCodeAt(w),D1=_.charCodeAt(J);if(T1<D1)return-1;if(T1>D1)return 1}const E1=P-w,N1=l1-J;return E1<N1?-1:E1>N1?1:0}function $(c,_){return l(c,_,0,c.length,0,_.length)}function l(c,_,w=0,P=c.length,J=0,l1=_.length){for(;w<P&&J<l1;w++,J++){let T1=c.charCodeAt(w),D1=_.charCodeAt(J);if(T1===D1)continue;if(T1>=128||D1>=128)return y(c.toLowerCase(),_.toLowerCase(),w,P,J,l1);F(T1)&&(T1-=32),F(D1)&&(D1-=32);const w1=T1-D1;if(w1!==0)return w1}const E1=P-w,N1=l1-J;return E1<N1?-1:E1>N1?1:0}function T(c){return c>=e.CharCode.Digit0&&c<=e.CharCode.Digit9}function F(c){return c>=e.CharCode.a&&c<=e.CharCode.z}function L(c){return c>=e.CharCode.A&&c<=e.CharCode.Z}function A(c,_){return c.length===_.length&&l(c,_)===0}function H(c,_){const w=_.length;return _.length>c.length?!1:l(c,_,0,w)===0}function i1(c,_){const w=Math.min(c.length,_.length);let P;for(P=0;P<w;P++)if(c.charCodeAt(P)!==_.charCodeAt(P))return P;return w}function e1(c,_){const w=Math.min(c.length,_.length);let P;const J=c.length-1,l1=_.length-1;for(P=0;P<w;P++)if(c.charCodeAt(J-P)!==_.charCodeAt(l1-P))return P;return w}function s1(c){return 55296<=c&&c<=56319}function u1(c){return 56320<=c&&c<=57343}function C(c,_){return(c-55296<<10)+(_-56320)+65536}function c1(c,_,w){const P=c.charCodeAt(w);if(s1(P)&&w+1<_){const J=c.charCodeAt(w+1);if(u1(J))return C(P,J)}return P}function _1(c,_){const w=c.charCodeAt(_-1);if(u1(w)&&_>1){const P=c.charCodeAt(_-2);if(s1(P))return C(P,w)}return w}class L1{get offset(){return this.e}constructor(_,w=0){this.c=_,this.d=_.length,this.e=w}setOffset(_){this.e=_}prevCodePoint(){const _=_1(this.c,this.e);return this.e-=_>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,_}nextCodePoint(){const _=c1(this.c,this.d,this.e);return this.e+=_>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,_}eol(){return this.e>=this.d}}t.$Qf=L1;class U1{get offset(){return this.c.offset}constructor(_,w=0){this.c=new L1(_,w)}nextGraphemeLength(){const _=R1.getInstance(),w=this.c,P=w.offset;let J=_.getGraphemeBreakType(w.nextCodePoint());for(;!w.eol();){const l1=w.offset,E1=_.getGraphemeBreakType(w.nextCodePoint());if(m1(J,E1)){w.setOffset(l1);break}J=E1}return w.offset-P}prevGraphemeLength(){const _=R1.getInstance(),w=this.c,P=w.offset;let J=_.getGraphemeBreakType(w.prevCodePoint());for(;w.offset>0;){const l1=w.offset,E1=_.getGraphemeBreakType(w.prevCodePoint());if(m1(E1,J)){w.setOffset(l1);break}J=E1}return P-w.offset}eol(){return this.c.eol()}}t.$Rf=U1;function O1(c,_){return new U1(c,_).nextGraphemeLength()}function S1(c,_){return new U1(c,_).prevGraphemeLength()}function G1(c,_){_>0&&u1(c.charCodeAt(_))&&_--;const w=_+O1(c,_);return[w-S1(c,w),w]}function H1(c){const _=new U1(c);let w=0;for(;!_.eol();)w++,_.nextGraphemeLength();return w}let I1;function P1(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function p1(c){return I1||(I1=P1()),I1.test(c)}const g=/^[\t\n\r\x20-\x7E]*$/;function m(c){return g.test(c)}t.$Yf=/[\u2028\u2029]/;function b(c){return t.$Yf.test(c)}function S(c){return c>=11904&&c<=55215||c>=63744&&c<=64255||c>=65281&&c<=65374}function q(c){return c>=127462&&c<=127487||c===8986||c===8987||c===9200||c===9203||c>=9728&&c<=10175||c===11088||c===11093||c>=127744&&c<=128591||c>=128640&&c<=128764||c>=128992&&c<=129008||c>=129280&&c<=129535||c>=129648&&c<=129782}function n1(c,_,w=""){const P=c.trimStart();if(P.length<_)return P;const J=/\b/g;let l1=0;for(;J.test(P)&&!(P.length-J.lastIndex<_);)l1=J.lastIndex,J.lastIndex+=1;return l1===0?P:w+P.substring(l1).trimStart()}const f1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$1(c){let _=0;for(const w of c.matchAll(f1))_!==w.index&&(yield{isCode:!1,str:c.substring(_,w.index)}),yield{isCode:!0,str:w[0]},_=w.index+w[0].length;_!==c.length&&(yield{isCode:!1,str:c.substring(_)})}function b1(c){return c&&(c=c.replace(f1,"")),c}const A1=/\\\[.*?\\\]/g;function v1(c){return b1(c).replace(A1,"")}t.$7f=String.fromCharCode(e.CharCode.UTF8_BOM);function X(c){return!!(c&&c.length>0&&c.charCodeAt(0)===e.CharCode.UTF8_BOM)}function G(c){return X(c)?c.substr(1):c}function Z(c,_){if(!c||!_||c.length<_.length)return!1;const w=_.length,P=c.toLowerCase();let J=0,l1=-1;for(;J<w;){const E1=P.indexOf(_[J],l1+1);if(E1<0)return!1;l1=E1,J++}return!0}function V(c,_=!1){return c?(_&&(c=c.replace(/\\./g,"")),c.toLowerCase()!==c):!1}function x(c){return c.charAt(0).toUpperCase()+c.slice(1)}function o1(c,_=1){if(_===0)return"";let w=-1;do w=c.indexOf(`
`,w+1),_--;while(_>0&&w>=0);return w===-1?c:(c[w-1]==="\r"&&w--,c.substr(0,w))}function a1(c){const _=e.CharCode.Z-e.CharCode.A+1;return c=c%(2*_),c<_?String.fromCharCode(e.CharCode.a+c):String.fromCharCode(e.CharCode.A+c-_)}function d1(c){return R1.getInstance().getGraphemeBreakType(c)}function m1(c,_){return c===r1.Other?_!==r1.Extend&&_!==r1.SpacingMark:c===r1.CR&&_===r1.LF?!1:c===r1.Control||c===r1.CR||c===r1.LF||_===r1.Control||_===r1.CR||_===r1.LF?!0:!(c===r1.L&&(_===r1.L||_===r1.V||_===r1.LV||_===r1.LVT)||(c===r1.LV||c===r1.V)&&(_===r1.V||_===r1.T)||(c===r1.LVT||c===r1.T)&&_===r1.T||_===r1.Extend||_===r1.ZWJ||_===r1.SpacingMark||c===r1.Prepend||c===r1.ZWJ&&_===r1.Extended_Pictographic||c===r1.Regional_Indicator&&_===r1.Regional_Indicator)}var r1;(function(c){c[c.Other=0]="Other",c[c.Prepend=1]="Prepend",c[c.CR=2]="CR",c[c.LF=3]="LF",c[c.Control=4]="Control",c[c.Extend=5]="Extend",c[c.Regional_Indicator=6]="Regional_Indicator",c[c.SpacingMark=7]="SpacingMark",c[c.L=8]="L",c[c.V=9]="V",c[c.T=10]="T",c[c.LV=11]="LV",c[c.LVT=12]="LVT",c[c.ZWJ=13]="ZWJ",c[c.Extended_Pictographic=14]="Extended_Pictographic"})(r1||(t.GraphemeBreakType=r1={}));class R1{static{this.c=null}static getInstance(){return R1.c||(R1.c=new R1),R1.c}constructor(){this.d=F1()}getGraphemeBreakType(_){if(_<32)return _===e.CharCode.LineFeed?r1.LF:_===e.CharCode.CarriageReturn?r1.CR:r1.Control;if(_<127)return r1.Other;const w=this.d,P=w.length/3;let J=1;for(;J<=P;)if(_<w[3*J])J=2*J;else if(_>w[3*J+1])J=2*J+1;else return w[3*J+2];return r1.Other}}function F1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function K1(c,_){if(c===0)return 0;const w=j1(c,_);if(w!==void 0)return w;const P=new L1(_,c);return P.prevCodePoint(),P.offset}function j1(c,_){const w=new L1(_,c);let P=w.prevCodePoint();for(;V1(P)||P===B1.emojiVariantSelector||P===B1.enclosingKeyCap;){if(w.offset===0)return;P=w.prevCodePoint()}if(!q(P))return;let J=w.offset;return J>0&&w.prevCodePoint()===B1.zwj&&(J=w.offset),J}function V1(c){return 127995<=c&&c<=127999}var B1;(function(c){c[c.zwj=8205]="zwj",c[c.emojiVariantSelector=65039]="emojiVariantSelector",c[c.enclosingKeyCap=8419]="enclosingKeyCap"})(B1||(B1={})),t.$eg="\xA0";class q1{static{this.c=new p.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new h.$bf({getCacheKey:JSON.stringify},_=>{function w(w1){const M1=new Map;for(let y1=0;y1<w1.length;y1+=2)M1.set(w1[y1],w1[y1+1]);return M1}function P(w1,M1){const y1=new Map(w1);for(const[z1,X1]of M1)y1.set(z1,X1);return y1}function J(w1,M1){if(!w1)return M1;const y1=new Map;for(const[z1,X1]of w1)M1.has(z1)&&y1.set(z1,X1);return y1}const l1=this.c.value;let E1=_.filter(w1=>!w1.startsWith("_")&&w1 in l1);E1.length===0&&(E1=["_default"]);let N1;for(const w1 of E1){const M1=w(l1[w1]);N1=J(N1,M1)}const T1=w(l1._common),D1=P(T1,N1);return new q1(D1)})}static getInstance(_){return q1.d.get(Array.from(_))}static{this.e=new p.$W(()=>Object.keys(q1.c.value).filter(_=>!_.startsWith("_")))}static getLocales(){return q1.e.value}constructor(_){this.f=_}isAmbiguous(_){return this.f.has(_)}containsAmbiguousCharacter(_){for(let w=0;w<_.length;w++){const P=_.codePointAt(w);if(typeof P=="number"&&this.isAmbiguous(P))return!0}return!1}getPrimaryConfusable(_){return this.f.get(_)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$fg=q1;class W1{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(W1.c())),this.d}static isInvisibleCharacter(_){return W1.e().has(_)}static containsInvisibleCharacter(_){for(let w=0;w<_.length;w++){const P=_.codePointAt(w);if(typeof P=="number"&&W1.isInvisibleCharacter(P))return!0}return!1}static get codePoints(){return W1.e()}}t.$gg=W1}),define(h1[25],g1([0,1,4,17,7,3]),function(t1,t,h,e,p,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$yc=R,t.$zc=i,p=k1(p);const Q=/^\w[\w\d+.-]*$/,K=/^\//,N=/^\/\//;function D(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!Q.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!K.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function W(r,o){return!r&&!o?"file":r}function Y(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==z&&(o=z+o):o=z;break}return o}const k="",z="/",M=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class U{static isUri(o){return o instanceof U?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,a,u,y,$,l=!1){typeof o=="object"?(this.scheme=o.scheme||k,this.authority=o.authority||k,this.path=o.path||k,this.query=o.query||k,this.fragment=o.fragment||k):(this.scheme=W(o,l),this.authority=a||k,this.path=Y(this.scheme,u||k),this.query=y||k,this.fragment=$||k,D(this,l))}get fsPath(){return i(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:u,path:y,query:$,fragment:l}=o;return a===void 0?a=this.scheme:a===null&&(a=k),u===void 0?u=this.authority:u===null&&(u=k),y===void 0?y=this.path:y===null&&(y=k),$===void 0?$=this.query:$===null&&($=k),l===void 0?l=this.fragment:l===null&&(l=k),a===this.scheme&&u===this.authority&&y===this.path&&$===this.query&&l===this.fragment?this:new E(a,u,y,$,l)}static parse(o,a=!1){const u=M.exec(o);return u?new E(u[2]||k,d(u[4]||k),d(u[5]||k),d(u[7]||k),d(u[9]||k),a):new E(k,k,k,k,k)}static file(o){let a=k;if(I.$j&&(o=o.replace(/\\/g,z)),o[0]===z&&o[1]===z){const u=o.indexOf(z,2);u===-1?(a=o.substring(2),o=z):(a=o.substring(2,u),o=o.substring(u)||z)}return new E("file",a,o,k,k)}static from(o,a){return new E(o.scheme,o.authority,o.path,o.query,o.fragment,a)}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return I.$j&&o.scheme==="file"?u=U.file(p.$ic.join(i(o,!0),...a)).path:u=p.$jc.join(o.path,...a),o.with({path:u})}toString(o=!1){return n(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof U)return o;{const a=new E(o);return a._formatted=o.external??null,a._fsPath=o._sep===j?o.fsPath??null:null,a}}else return o}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=U;function R(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const j=I.$j?1:void 0;class E extends U{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(o=!1){return o?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const o={$mid:e.MarshalledId.Uri};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=j),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const O={[h.CharCode.Colon]:"%3A",[h.CharCode.Slash]:"%2F",[h.CharCode.QuestionMark]:"%3F",[h.CharCode.Hash]:"%23",[h.CharCode.OpenSquareBracket]:"%5B",[h.CharCode.CloseSquareBracket]:"%5D",[h.CharCode.AtSign]:"%40",[h.CharCode.ExclamationMark]:"%21",[h.CharCode.DollarSign]:"%24",[h.CharCode.Ampersand]:"%26",[h.CharCode.SingleQuote]:"%27",[h.CharCode.OpenParen]:"%28",[h.CharCode.CloseParen]:"%29",[h.CharCode.Asterisk]:"%2A",[h.CharCode.Plus]:"%2B",[h.CharCode.Comma]:"%2C",[h.CharCode.Semicolon]:"%3B",[h.CharCode.Equals]:"%3D",[h.CharCode.Space]:"%20"};function B(r,o,a){let u,y=-1;for(let $=0;$<r.length;$++){const l=r.charCodeAt($);if(l>=h.CharCode.a&&l<=h.CharCode.z||l>=h.CharCode.A&&l<=h.CharCode.Z||l>=h.CharCode.Digit0&&l<=h.CharCode.Digit9||l===h.CharCode.Dash||l===h.CharCode.Period||l===h.CharCode.Underline||l===h.CharCode.Tilde||o&&l===h.CharCode.Slash||a&&l===h.CharCode.OpenSquareBracket||a&&l===h.CharCode.CloseSquareBracket||a&&l===h.CharCode.Colon)y!==-1&&(u+=encodeURIComponent(r.substring(y,$)),y=-1),u!==void 0&&(u+=r.charAt($));else{u===void 0&&(u=r.substr(0,$));const T=O[l];T!==void 0?(y!==-1&&(u+=encodeURIComponent(r.substring(y,$)),y=-1),u+=T):y===-1&&(y=$)}}return y!==-1&&(u+=encodeURIComponent(r.substring(y))),u!==void 0?u:r}function v(r){let o;for(let a=0;a<r.length;a++){const u=r.charCodeAt(a);u===h.CharCode.Hash||u===h.CharCode.QuestionMark?(o===void 0&&(o=r.substr(0,a)),o+=O[u]):o!==void 0&&(o+=r[a])}return o!==void 0?o:r}function i(r,o){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===h.CharCode.Slash&&(r.path.charCodeAt(1)>=h.CharCode.A&&r.path.charCodeAt(1)<=h.CharCode.Z||r.path.charCodeAt(1)>=h.CharCode.a&&r.path.charCodeAt(1)<=h.CharCode.z)&&r.path.charCodeAt(2)===h.CharCode.Colon?o?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,I.$j&&(a=a.replace(/\//g,"\\")),a}function n(r,o){const a=o?v:B;let u="",{scheme:y,authority:$,path:l,query:T,fragment:F}=r;if(y&&(u+=y,u+=":"),($||y==="file")&&(u+=z,u+=z),$){let L=$.indexOf("@");if(L!==-1){const A=$.substr(0,L);$=$.substr(L+1),L=A.lastIndexOf(":"),L===-1?u+=a(A,!1,!1):(u+=a(A.substr(0,L),!1,!1),u+=":",u+=a(A.substr(L+1),!1,!0)),u+="@"}$=$.toLowerCase(),L=$.lastIndexOf(":"),L===-1?u+=a($,!1,!0):(u+=a($.substr(0,L),!1,!0),u+=$.substr(L))}if(l){if(l.length>=3&&l.charCodeAt(0)===h.CharCode.Slash&&l.charCodeAt(2)===h.CharCode.Colon){const L=l.charCodeAt(1);L>=h.CharCode.A&&L<=h.CharCode.Z&&(l=`/${String.fromCharCode(L+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===h.CharCode.Colon){const L=l.charCodeAt(0);L>=h.CharCode.A&&L<=h.CharCode.Z&&(l=`${String.fromCharCode(L+32)}:${l.substr(2)}`)}u+=a(l,!0,!1)}return T&&(u+="?",u+=a(T,!1,!1)),F&&(u+="#",u+=o?F:B(F,!1,!1)),u}function s(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+s(r.substr(3)):r}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(r){return r.match(f)?r.replace(f,o=>s(o)):r}}),define(h1[26],g1([0,1,2,3,9,25,7]),function(t1,t,h,e,p,I,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Vg=t.$Ug=t.$Tg=t.Schemas=void 0,t.$Rg=N,t.$Sg=D,t.$Wg=Y,h=k1(h),e=k1(e),Q=k1(Q);var K;(function(M){M.inMemory="inmemory",M.vscode="vscode",M.internal="private",M.walkThrough="walkThrough",M.walkThroughSnippet="walkThroughSnippet",M.http="http",M.https="https",M.file="file",M.mailto="mailto",M.untitled="untitled",M.data="data",M.command="command",M.vscodeRemote="vscode-remote",M.vscodeRemoteResource="vscode-remote-resource",M.vscodeManagedRemoteResource="vscode-managed-remote-resource",M.vscodeUserData="vscode-userdata",M.vscodeCustomEditor="vscode-custom-editor",M.vscodeNotebookCell="vscode-notebook-cell",M.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",M.vscodeNotebookCellOutput="vscode-notebook-cell-output",M.vscodeInteractiveInput="vscode-interactive-input",M.vscodeSettings="vscode-settings",M.vscodeWorkspaceTrust="vscode-workspace-trust",M.vscodeTerminal="vscode-terminal",M.vscodeChatCodeBlock="vscode-chat-code-block",M.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",M.vscodeChatSesssion="vscode-chat-editor",M.webviewPanel="webview-panel",M.vscodeWebview="vscode-webview",M.extension="extension",M.vscodeFileResource="vscode-file",M.tmp="tmp",M.vsls="vsls",M.vscodeSourceControl="vscode-scm",M.commentsInput="comment",M.codeSetting="code-setting",M.outputChannel="output"})(K||(t.Schemas=K={}));function N(M,U){return I.URI.isUri(M)?(0,p.$If)(M.scheme,U):(0,p.$Jf)(M,U+":")}function D(M,...U){return U.some(R=>N(M,R))}t.$Tg="vscode-tkn",t.$Ug="tkn";class W{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(U){this.d=U}setDelegate(U){this.e=U}setServerRootPath(U,R){this.f=Y(U,R)}getServerRootPath(){return this.f}get g(){return Q.$jc.join(this.f,K.vscodeRemoteResource)}set(U,R,j){this.a[U]=R,this.b[U]=j}setConnectionToken(U,R){this.c[U]=R}getPreferredWebSchema(){return this.d}rewrite(U){if(this.e)try{return this.e(U)}catch(v){return h.$2(v),U}const R=U.authority;let j=this.a[R];j&&j.indexOf(":")!==-1&&j.indexOf("[")===-1&&(j=`[${j}]`);const E=this.b[R],O=this.c[R];let B=`path=${encodeURIComponent(U.path)}`;return typeof O=="string"&&(B+=`&${t.$Ug}=${encodeURIComponent(O)}`),I.URI.from({scheme:e.$p?this.d:K.vscodeRemoteResource,authority:`${j}:${E}`,path:this.g,query:B})}}t.$Vg=new W;function Y(M,U){return Q.$jc.join(U??"/",`${M.quality??"oss"}-${M.commit??"dev"}`)}t.$Xg="vs/../../extensions",t.$Yg="vs/../../node_modules",t.$Zg="vs/../../node_modules.asar",t.$1g="vs/../../node_modules.asar.unpacked",t.$2g="vscode-app";class k{static{this.a=t.$2g}asBrowserUri(U){const R=this.b(U,t1);return this.uriToBrowserUri(R)}uriToBrowserUri(U){return U.scheme===K.vscodeRemote?t.$Vg.rewrite(U):U.scheme===K.file&&(e.$n||e.$r===`${K.vscodeFileResource}://${k.a}`)?U.with({scheme:K.vscodeFileResource,authority:U.authority||k.a,query:null,fragment:null}):U}asFileUri(U){const R=this.b(U,t1);return this.uriToFileUri(R)}uriToFileUri(U){return U.scheme===K.vscodeFileResource?U.with({scheme:K.file,authority:U.authority!==k.a?U.authority:null,query:null,fragment:null}):U}b(U,R){if(I.URI.isUri(U))return U;if(globalThis._VSCODE_FILE_ROOT){const j=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(j))return I.URI.joinPath(I.URI.parse(j,!0),U);const E=Q.$mc(j,U);return I.URI.file(E)}return I.URI.parse(R.toUrl(U))}}t.$3g=new k;var z;(function(M){const U=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);M.CoopAndCoep=Object.freeze(U.get("3"));const R="vscode-coi";function j(O){let B;typeof O=="string"?B=new URL(O).searchParams:O instanceof URL?B=O.searchParams:I.URI.isUri(O)&&(B=new URL(O.toString(!0)).searchParams);const v=B?.get(R);if(v)return U.get(v)}M.getHeadersFromQuery=j;function E(O,B,v){if(!globalThis.crossOriginIsolated)return;const i=B&&v?"3":v?"2":"1";O instanceof URLSearchParams?O.set(R,i):O[R]=i}M.addSearchParam=E})(z||(t.COI=z={}))}),define(h1[27],g1([0,1,2,8,6,26,23,3,9]),function(t1,t,h,e,p,I,Q,K,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=k,t.create=f,N=k1(N);const D=!1,W="$initialize";let Y=!1;function k(d){K.$p&&(Y||(Y=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(d.message))}var z;(function(d){d[d.Request=0]="Request",d[d.Reply=1]="Reply",d[d.SubscribeEvent=2]="SubscribeEvent",d[d.Event=3]="Event",d[d.UnsubscribeEvent=4]="UnsubscribeEvent"})(z||(z={}));class M{constructor(r,o,a,u){this.vsWorker=r,this.req=o,this.method=a,this.args=u,this.type=z.Request}}class U{constructor(r,o,a,u){this.vsWorker=r,this.seq=o,this.res=a,this.err=u,this.type=z.Reply}}class R{constructor(r,o,a,u){this.vsWorker=r,this.req=o,this.eventName=a,this.arg=u,this.type=z.SubscribeEvent}}class j{constructor(r,o,a){this.vsWorker=r,this.req=o,this.event=a,this.type=z.Event}}class E{constructor(r,o){this.vsWorker=r,this.req=o,this.type=z.UnsubscribeEvent}}class O{constructor(r){this.a=-1,this.g=r,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(r){this.a=r}sendMessage(r,o){const a=String(++this.b);return new Promise((u,y)=>{this.c[a]={resolve:u,reject:y},this.o(new M(this.a,a,r,o))})}listen(r,o){let a=null;const u=new e.$oe({onWillAddFirstListener:()=>{a=String(++this.b),this.d.set(a,u),this.o(new R(this.a,a,r,o))},onDidRemoveLastListener:()=>{this.d.delete(a),this.o(new E(this.a,a)),a=null}});return u.event}handleMessage(r){!r||!r.vsWorker||this.a!==-1&&r.vsWorker!==this.a||this.h(r)}h(r){switch(r.type){case z.Reply:return this.j(r);case z.Request:return this.k(r);case z.SubscribeEvent:return this.l(r);case z.Event:return this.m(r);case z.UnsubscribeEvent:return this.n(r)}}j(r){if(!this.c[r.seq]){console.warn("Got reply to unknown seq");return}const o=this.c[r.seq];if(delete this.c[r.seq],r.err){let a=r.err;r.err.$isError&&(a=new Error,a.name=r.err.name,a.message=r.err.message,a.stack=r.err.stack),o.reject(a);return}o.resolve(r.res)}k(r){const o=r.req;this.g.handleMessage(r.method,r.args).then(u=>{this.o(new U(this.a,o,u,void 0))},u=>{u.detail instanceof Error&&(u.detail=(0,h.$4)(u.detail)),this.o(new U(this.a,o,void 0,(0,h.$4)(u)))})}l(r){const o=r.req,a=this.g.handleEvent(r.eventName,r.arg)(u=>{this.o(new j(this.a,o,u))});this.f.set(o,a)}m(r){if(!this.d.has(r.req)){console.warn("Got event for unknown req");return}this.d.get(r.req).fire(r.event)}n(r){if(!this.f.has(r.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(r.req).dispose(),this.f.delete(r.req)}o(r){const o=[];if(r.type===z.Request)for(let a=0;a<r.args.length;a++)r.args[a]instanceof ArrayBuffer&&o.push(r.args[a]);else r.type===z.Reply&&r.res instanceof ArrayBuffer&&o.push(r.res);this.g.sendMessage(r,o)}}class B extends p.$Xc{constructor(r,o,a){super();let u=null;this.a=this.B(r.create({moduleId:"vs/base/common/worker/simpleWorker",esmModuleId:o},L=>{this.c.handleMessage(L)},L=>{u?.(L)})),this.c=new O({sendMessage:(L,A)=>{this.a.postMessage(L,A)},handleMessage:(L,A)=>{if(typeof a[L]!="function")return Promise.reject(new Error("Missing method "+L+" on main thread host."));try{return Promise.resolve(a[L].apply(a,A))}catch(H){return Promise.reject(H)}},handleEvent:(L,A)=>{if(i(L)){const H=a[L].call(a,A);if(typeof H!="function")throw new Error(`Missing dynamic event ${L} on main thread host.`);return H}if(v(L)){const H=a[L];if(typeof H!="function")throw new Error(`Missing event ${L} on main thread host.`);return H}throw new Error(`Malformed event name ${L}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const $=globalThis.require;typeof $<"u"&&typeof $.getConfig=="function"?y=$.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const l=(0,Q.$ro)(a);this.b=this.c.sendMessage(W,[this.a.getId(),JSON.parse(JSON.stringify(y)),o,l]);const T=(L,A)=>this.g(L,A),F=(L,A)=>this.c.listen(L,A);this.f=new Promise((L,A)=>{u=A,this.b.then(H=>{L(n(H,T,F))},H=>{A(H),this.h("Worker failed to load "+o,H)})})}getProxyObject(){return this.f}g(r,o){return new Promise((a,u)=>{this.b.then(()=>{this.c.sendMessage(r,o).then(a,u)},u)})}h(r,o){console.error(r),console.info(o)}}t.SimpleWorkerClient=B;function v(d){return d[0]==="o"&&d[1]==="n"&&N.$Hf(d.charCodeAt(2))}function i(d){return/^onDynamic/.test(d)&&N.$Hf(d.charCodeAt(9))}function n(d,r,o){const a=$=>function(){const l=Array.prototype.slice.call(arguments,0);return r($,l)},u=$=>function(l){return o($,l)},y={};for(const $ of d){if(i($)){y[$]=u($);continue}if(v($)){y[$]=o($,void 0);continue}y[$]=a($)}return y}class s{constructor(r,o){this.a=o,this.b=null,this.c=new O({sendMessage:(a,u)=>{r(a,u)},handleMessage:(a,u)=>this.d(a,u),handleEvent:(a,u)=>this.f(a,u)})}onmessage(r){this.c.handleMessage(r)}d(r,o){if(r===W)return this.g(o[0],o[1],o[2],o[3]);if(!this.b||typeof this.b[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.b[r].apply(this.b,o))}catch(a){return Promise.reject(a)}}f(r,o){if(!this.b)throw new Error("Missing requestHandler");if(i(r)){const a=this.b[r].call(this.b,o);if(typeof a!="function")throw new Error(`Missing dynamic event ${r} on request handler.`);return a}if(v(r)){const a=this.b[r];if(typeof a!="function")throw new Error(`Missing event ${r} on request handler.`);return a}throw new Error(`Malformed event name ${r}`)}g(r,o,a,u){this.c.setWorkerId(r);const l=n(u,(T,F)=>this.c.sendMessage(T,F),(T,F)=>this.c.listen(T,F));if(this.a)return this.b=this.a(l),Promise.resolve((0,Q.$ro)(this.b));if(o&&(typeof o.baseUrl<"u"&&delete o.baseUrl,typeof o.paths<"u"&&typeof o.paths.vs<"u"&&delete o.paths.vs,typeof o.trustedTypesPolicy<"u"&&delete o.trustedTypesPolicy,o.catchError=!0,globalThis.require.config(o)),D){const T=I.$3g.asBrowserUri(`${a}.js`).toString(!0);return new Promise((F,L)=>{t1([`${T}`],F,L)}).then(k1).then(F=>{if(this.b=F.create(l),!this.b)throw new Error("No RequestHandler!");return(0,Q.$ro)(this.b)})}return new Promise((T,F)=>{(globalThis.require||t1)([a],A=>{if(this.b=A.create(l),!this.b){F(new Error("No RequestHandler!"));return}T((0,Q.$ro)(this.b))},F)})}}t.SimpleWorkerServer=s;function f(d){return new s(d,null)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e2b54301a5745870f6b95d81c91fb3e9557d4f08/core/vs/base/common/worker/simpleWorker.js.map
