/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/charCode","vs/editor/common/core/offsetRange","vs/base/common/strings","vs/base/common/arrays","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/uint","vs/base/common/uri","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/path","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/base/common/network","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(x){for(var i=[],t=0,n=x.length;t<n;t++)i[t]=ie[x[t]];return i};const Qe=this,Je=typeof global=="object"?global:{};var Le;(function(x){x.global=Qe;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof x.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}x.Environment=i})(Le||(Le={}));var Le;(function(x){class i{constructor(f,E,g){this.type=f,this.detail=E,this.timestamp=g}}x.LoaderEvent=i;class t{constructor(f){this._events=[new i(1,"",f)]}record(f,E){this._events.push(new i(f,E,x.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}x.LoaderEventRecorder=t;class n{record(f,E){}getEvents(){return[]}}n.INSTANCE=new n,x.NullLoaderEventRecorder=n})(Le||(Le={}));var Le;(function(x){class i{static fileUriToFilePath(n,T){if(T=decodeURI(T).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(T))return T.substr(8);if(/^file:\/\//.test(T))return T.substr(5)}else if(/^file:\/\//.test(T))return T.substr(7);return T}static startsWith(n,T){return n.length>=T.length&&n.substr(0,T.length)===T}static endsWith(n,T){return n.length>=T.length&&n.substr(n.length-T.length)===T}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,T){if(n){let f;for(f in n)n.hasOwnProperty(f)&&T(f,n[f])}}static isEmpty(n){let T=!0;return i.forEachProperty(n,()=>{T=!1}),T}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let T=Array.isArray(n)?[]:{};return i.forEachProperty(n,(f,E)=>{E&&typeof E=="object"?T[f]=i.recursiveClone(E):T[f]=E}),T}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=x.global.performance&&typeof x.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?x.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,x.Utilities=i})(Le||(Le={}));var Le;(function(x){function i(T){if(T instanceof Error)return T;const f=new Error(T.message||String(T)||"Unknown Error");return T.stack&&(f.stack=T.stack),f}x.ensureError=i;class t{static validateConfigurationOptions(f){function E(g){if(g.phase==="loading"){console.error('Loading "'+g.moduleId+'" failed'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}if(g.phase==="factory"){console.error('The factory function of "'+g.moduleId+'" has thrown an exception'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=E),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(x.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const g=i(new Error("INVALID cached data configuration, 'path' MUST be set"));g.phase="configuration",f.onError(g),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,E=null){let g=x.Utilities.recursiveClone(E||{});return x.Utilities.forEachProperty(f,(a,u)=>{a==="ignoreDuplicateModules"&&typeof g.ignoreDuplicateModules<"u"?g.ignoreDuplicateModules=g.ignoreDuplicateModules.concat(u):a==="paths"&&typeof g.paths<"u"?x.Utilities.forEachProperty(u,(o,w)=>g.paths[o]=w):a==="config"&&typeof g.config<"u"?x.Utilities.forEachProperty(u,(o,w)=>g.config[o]=w):g[a]=x.Utilities.recursiveClone(u)}),t.validateConfigurationOptions(g)}}x.ConfigurationOptionsUtil=t;class n{constructor(f,E){if(this._env=f,this.options=t.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let g=this.options.nodeRequire.main.filename,a=Math.max(g.lastIndexOf("/"),g.lastIndexOf("\\"));this.options.baseUrl=g.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],x.Utilities.forEachProperty(this.options.paths,(f,E)=>{Array.isArray(E)?this.sortedPathsRules.push({from:f,to:E}):this.sortedPathsRules.push({from:f,to:[E]})}),this.sortedPathsRules.sort((f,E)=>E.from.length-f.from.length)}cloneAndMerge(f){return new n(this._env,t.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let E;for(let g=0,a=this.sortedPathsRules.length;g<a;g++)if(E=this.sortedPathsRules[g],x.Utilities.startsWith(f,E.from)){let u=[];for(let o=0,w=E.to.length;o<w;o++)u.push(E.to[o]+f.substr(E.from.length));return u}return[f]}_addUrlArgsToUrl(f){return x.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let E=0,g=f.length;E<g;E++)f[E]=this._addUrlArgsToUrl(f[E]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let E=f,g;if(!x.Utilities.endsWith(E,".js")&&!x.Utilities.isAbsolutePath(E)){g=this._applyPaths(E);for(let a=0,u=g.length;a<u;a++)this.isBuild()&&g[a]==="empty:"||(x.Utilities.isAbsolutePath(g[a])||(g[a]=this.options.baseUrl+g[a]),!x.Utilities.endsWith(g[a],".js")&&!x.Utilities.containsQueryString(g[a])&&(g[a]=g[a]+".js"))}else!x.Utilities.endsWith(E,".js")&&!x.Utilities.containsQueryString(E)&&(E=E+".js"),g=[E];return this._addUrlArgsIfNecessaryToUrls(g)}requireToUrl(f){let E=f;return x.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],x.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||x.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}x.Configuration=n})(Le||(Le={}));var Le;(function(x){class i{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,o,w,h){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new T;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new t;let m={callback:w,errorback:h};if(this._callbackMap.hasOwnProperty(o)){this._callbackMap[o].push(m);return}this._callbackMap[o]=[m],this._scriptLoader.load(u,o,()=>this.triggerCallback(o),e=>this.triggerErrorback(o,e))}triggerCallback(u){let o=this._callbackMap[u];delete this._callbackMap[u];for(let w=0;w<o.length;w++)o[w].callback()}triggerErrorback(u,o){let w=this._callbackMap[u];delete this._callbackMap[u];for(let h=0;h<w.length;h++)w[h].errorback(o)}}class t{attachListeners(u,o,w){let h=()=>{u.removeEventListener("load",m),u.removeEventListener("error",e)},m=b=>{h(),o()},e=b=>{h(),w(b)};u.addEventListener("load",m),u.addEventListener("error",e)}load(u,o,w,h){if(/^node\|/.test(o)){let m=u.getConfig().getOptionsLiteral(),e=E(u.getRecorder(),m.nodeRequire||x.global.nodeRequire),b=o.split("|"),L=null;try{L=e(b[1])}catch(R){h(R);return}u.enqueueDefineAnonymousModule([],()=>L),w()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,w,h);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(o=e.createScriptURL(o)),m.setAttribute("src",o);const{cspNonce:b}=u.getConfig().getOptionsLiteral();b&&m.setAttribute("nonce",b),document.getElementsByTagName("head")[0].appendChild(m)}}}function n(a){const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class T{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(u)),this._cachedCanUseEval}load(u,o,w,h){if(/^node\|/.test(o)){const m=u.getConfig().getOptionsLiteral(),e=E(u.getRecorder(),m.nodeRequire||x.global.nodeRequire),b=o.split("|");let L=null;try{L=e(b[1])}catch(R){h(R);return}u.enqueueDefineAnonymousModule([],function(){return L}),w()}else{const{trustedTypesPolicy:m}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(o).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${o}`,(m?self.eval(m.createScript("",b)):new Function(b)).call(self),w()}).then(void 0,h);return}try{m&&(o=m.createScriptURL(o)),importScripts(o),w()}catch(b){h(b)}}}}class f{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,o){const{nodeCachedData:w}=o.getConfig().getOptionsLiteral();if(!w||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const h=this,m=u("module");function e(b){const L=b.constructor;let R=function(v){try{return b.require(v)}finally{}};return R.resolve=function(v,_){return L._resolveFilename(v,b,!1,_)},R.resolve.paths=function(v){return L._resolveLookupPaths(v,b)},R.main=process.mainModule,R.extensions=L._extensions,R.cache=L._cache,R}m.prototype._compile=function(b,L){const R=m.wrap(b.replace(/^#!.*/,"")),A=o.getRecorder(),v=h._getCachedDataPath(w,L),_={filename:L};let $;try{const p=h._fs.readFileSync(v);$=p.slice(0,16),_.cachedData=p.slice(16),A.record(60,v)}catch{A.record(61,v)}const l=new h._vm.Script(R,_),s=l.runInThisContext(_),c=h._path.dirname(L),d=e(this),j=[this.exports,d,this,L,c,process,Je,Buffer],N=s.apply(this.exports,j);return h._handleCachedData(l,R,v,!_.cachedData,o),h._verifyCachedData(l,R,v,$,o),N}}load(u,o,w,h){const m=u.getConfig().getOptionsLiteral(),e=E(u.getRecorder(),m.nodeRequire||x.global.nodeRequire),b=m.nodeInstrumenter||function(R){return R};this._init(e),this._initNodeRequire(e,u);let L=u.getRecorder();if(/^node\|/.test(o)){let R=o.split("|"),A=null;try{A=e(R[1])}catch(v){h(v);return}u.enqueueDefineAnonymousModule([],()=>A),w()}else{o=x.Utilities.fileUriToFilePath(this._env.isWindows,o);const R=this._path.normalize(o),A=this._getElectronRendererScriptPathOrUri(R),v=!!m.nodeCachedData,_=v?this._getCachedDataPath(m.nodeCachedData,o):void 0;this._readSourceAndCachedData(R,_,L,($,l,s,c)=>{if($){h($);return}let d;l.charCodeAt(0)===f._BOM?d=f._PREFIX+l.substring(1)+f._SUFFIX:d=f._PREFIX+l+f._SUFFIX,d=b(d,R);const j={filename:A,cachedData:s},N=this._createAndEvalScript(u,d,j,w,h);this._handleCachedData(N,d,_,v&&!s,u),this._verifyCachedData(N,d,_,c,u)})}}_createAndEvalScript(u,o,w,h,m){const e=u.getRecorder();e.record(31,w.filename);const b=new this._vm.Script(o,w),L=b.runInThisContext(w),R=u.getGlobalAMDDefineFunc();let A=!1;const v=function(){return A=!0,R.apply(null,arguments)};return v.amd=R.amd,L.call(x.global,u.getGlobalAMDRequireFunc(),v,w.filename,this._path.dirname(w.filename)),e.record(32,w.filename),A?h():m(new Error(`Didn't receive define call in ${w.filename}!`)),b}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let o=u.match(/^([a-z])\:(.*)/i);return o?`file:///${(o[1].toUpperCase()+":"+o[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,o){const w=this._crypto.createHash("md5").update(o,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),h=this._path.basename(o).replace(/\.js$/,"");return this._path.join(u.path,`${h}-${w}.code`)}_handleCachedData(u,o,w,h,m){u.cachedDataRejected?this._fs.unlink(w,e=>{m.getRecorder().record(62,w),this._createAndWriteCachedData(u,o,w,m),e&&m.getConfig().onError(e)}):h&&this._createAndWriteCachedData(u,o,w,m)}_createAndWriteCachedData(u,o,w,h){let m=Math.ceil(h.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,b=0,L;const R=()=>{setTimeout(()=>{L||(L=this._crypto.createHash("md5").update(o,"utf8").digest());const A=u.createCachedData();if(!(A.length===0||A.length===e||b>=5)){if(A.length<e){R();return}e=A.length,this._fs.writeFile(w,Buffer.concat([L,A]),v=>{v&&h.getConfig().onError(v),h.getRecorder().record(63,w),R()})}},m*Math.pow(4,b++))};R()}_readSourceAndCachedData(u,o,w,h){if(!o)this._fs.readFile(u,{encoding:"utf8"},h);else{let m,e,b,L=2;const R=A=>{A?h(A):--L===0&&h(void 0,m,e,b)};this._fs.readFile(u,{encoding:"utf8"},(A,v)=>{m=v,R(A)}),this._fs.readFile(o,(A,v)=>{!A&&v&&v.length>0?(b=v.slice(0,16),e=v.slice(16),w.record(60,o)):w.record(61,o),R()})}}_verifyCachedData(u,o,w,h,m){h&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(o,"utf8").digest();h.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${w}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(w,b=>{b&&m.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function E(a,u){if(u.__$__isRecorded)return u;const o=function(h){a.record(33,h);try{return u(h)}finally{a.record(34,h)}};return o.__$__isRecorded=!0,o}x.ensureRecordedNodeRequire=E;function g(a){return new i(a)}x.createScriptLoader=g})(Le||(Le={}));var Le;(function(x){class i{constructor(a){let u=a.lastIndexOf("/");u!==-1?this.fromModulePath=a.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(a){let u=a,o;for(o=/\/\.\//;o.test(u);)u=u.replace(o,"/");for(u=u.replace(/^\.\//g,""),o=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;o.test(u);)u=u.replace(o,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(a){let u=a;return x.Utilities.isAbsolutePath(u)||(x.Utilities.startsWith(u,"./")||x.Utilities.startsWith(u,"../"))&&(u=i._normalizeModuleId(this.fromModulePath+u)),u}}i.ROOT=new i(""),x.ModuleIdResolver=i;class t{constructor(a,u,o,w,h,m){this.id=a,this.strId=u,this.dependencies=o,this._callback=w,this._errorback=h,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,u){try{return{returnedValue:a.apply(x.global,u),producedError:null}}catch(o){return{returnedValue:null,producedError:o}}}static _invokeFactory(a,u,o,w){return a.shouldInvokeFactory(u)?a.shouldCatchError()?this._safeInvokeFunction(o,w):{returnedValue:o.apply(x.global,w),producedError:null}:{returnedValue:null,producedError:null}}complete(a,u,o,w){this._isComplete=!0;let h=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let m=t._invokeFactory(u,this.strId,this._callback,o);h=m.producedError,a.record(22,this.strId),!h&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||x.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(h){let m=x.ensureError(h);m.phase="factory",m.moduleId=this.strId,m.neededBy=w(this.id),this.error=m,u.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}x.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let u=this._strModuleIdToIntModuleId.get(a);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(a,u),this._intModuleIdToStrModuleId[u]=a),u}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class T{constructor(a){this.id=a}}T.EXPORTS=new T(0),T.MODULE=new T(1),T.REQUIRE=new T(2),x.RegularDependency=T;class f{constructor(a,u,o){this.id=a,this.pluginId=u,this.pluginParam=o}}x.PluginDependency=f;class E{constructor(a,u,o,w,h=0){this._env=a,this._scriptLoader=u,this._loaderAvailableTimestamp=h,this._defineFunc=o,this._requireFunc=w,this._moduleIdProvider=new n,this._config=new x.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new E(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,u){let o=m=>m.replace(/\\/g,"/"),w=o(a),h=u.split(/\n/);for(let m=0;m<h.length;m++){let e=h[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let b=e[1],L=e[2],R=e[3],A=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(A),b=o(b),b===w){let v={line:parseInt(L,10),col:parseInt(R,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],u=0;for(let o=0,w=this._modules2.length;o<w;o++){let h=this._modules2[o];if(!h)continue;let m=this._buildInfoPath[h.id]||null,e=this._buildInfoDefineStack[h.id]||null,b=this._buildInfoDependencies[h.id];a[u++]={id:h.strId,path:m,defineLocation:m&&e?E._findRelevantLocationInStack(m,e):null,dependencies:b,shim:null,exports:h.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new x.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=x.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let o=null;this._config.isBuild()&&(o=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:o,dependencies:a,callback:u}}defineModule(a,u,o,w,h,m=new i(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let b=new t(e,a,this._normalizeDependencies(u,m),o,w,m);this._modules2[e]=b,this._config.isBuild()&&(this._buildInfoDefineStack[e]=h,this._buildInfoDependencies[e]=(b.dependencies||[]).map(L=>this._moduleIdProvider.getStrModuleId(L.id))),this._resolve(b)}_normalizeDependency(a,u){if(a==="exports")return T.EXPORTS;if(a==="module")return T.MODULE;if(a==="require")return T.REQUIRE;let o=a.indexOf("!");if(o>=0){let w=u.resolveModule(a.substr(0,o)),h=u.resolveModule(a.substr(o+1)),m=this._moduleIdProvider.getModuleId(w+"!"+h),e=this._moduleIdProvider.getModuleId(w);return new f(m,e,h)}return new T(this._moduleIdProvider.getModuleId(u.resolveModule(a)))}_normalizeDependencies(a,u){let o=[],w=0;for(let h=0,m=a.length;h<m;h++)o[w++]=this._normalizeDependency(a[h],u);return o}_relativeRequire(a,u,o,w){if(typeof u=="string")return this.synchronousRequire(u,a);this.defineModule(x.Utilities.generateAnonymousModule(),u,o,w,null,a)}synchronousRequire(a,u=new i(a)){let o=this._normalizeDependency(a,u),w=this._modules2[o.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports}configure(a,u){let o=this._config.shouldRecordStats();u?this._config=new x.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!o&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),u.dependencies,u.callback,null,u.stack)}}_createLoadError(a,u){let o=this._moduleIdProvider.getStrModuleId(a),w=(this._inverseDependencies2[a]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const h=x.ensureError(u);return h.phase="loading",h.moduleId=o,h.neededBy=w,h}_onLoadError(a,u){const o=this._createLoadError(a,u);this._modules2[a]||(this._modules2[a]=new t(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let w=[];for(let e=0,b=this._moduleIdProvider.getMaxModuleId();e<b;e++)w[e]=!1;let h=!1,m=[];for(m.push(a),w[a]=!0;m.length>0;){let e=m.shift(),b=this._modules2[e];b&&(h=b.onDependencyError(o)||h);let L=this._inverseDependencies2[e];if(L)for(let R=0,A=L.length;R<A;R++){let v=L[R];w[v]||(m.push(v),w[v]=!0)}}h||this._config.onError(o)}_hasDependencyPath(a,u){let o=this._modules2[a];if(!o)return!1;let w=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)w[m]=!1;let h=[];for(h.push(o),w[a]=!0;h.length>0;){let e=h.shift().dependencies;if(e)for(let b=0,L=e.length;b<L;b++){let R=e[b];if(R.id===u)return!0;let A=this._modules2[R.id];A&&!w[R.id]&&(w[R.id]=!0,h.push(A))}}return!1}_findCyclePath(a,u,o){if(a===u||o===50)return[a];let w=this._modules2[a];if(!w)return null;let h=w.dependencies;if(h)for(let m=0,e=h.length;m<e;m++){let b=this._findCyclePath(h[m].id,u,o+1);if(b!==null)return b.push(a),b}return null}_createRequire(a){let u=(o,w,h)=>this._relativeRequire(a,o,w,h);return u.toUrl=o=>this._config.requireToUrl(a.resolveModule(o)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(o,w=!1)=>{this.configure(o,w)},u.__$__nodeRequire=x.global.nodeRequire,u}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let u=this._moduleIdProvider.getStrModuleId(a),o=this._config.moduleIdToPaths(u),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||w.test(u))&&o.push("node|"+u);let h=-1,m=e=>{if(h++,h>=o.length)this._onLoadError(a,e);else{let b=o[h],L=this.getRecorder();if(this._config.isBuild()&&b==="empty:"){this._buildInfoPath[a]=b,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}L.record(10,b),this._scriptLoader.load(this,b,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=b),L.record(11,b),this._onLoad(a)},R=>{L.record(12,b),m(R)})}};m(null)}_loadPluginDependency(a,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let o=w=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],w,null,null)};o.error=w=>{this._config.onError(this._createLoadError(u.id,w))},a.load(u.pluginParam,this._createRequire(i.ROOT),o,this._config.getOptionsLiteral())}_resolve(a){let u=a.dependencies;if(u)for(let o=0,w=u.length;o<w;o++){let h=u[o];if(h===T.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(h===T.MODULE){a.unresolvedDependenciesCount--;continue}if(h===T.REQUIRE){a.unresolvedDependenciesCount--;continue}let m=this._modules2[h.id];if(m&&m.isComplete()){if(m.error){a.onDependencyError(m.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(h.id,a.id,0)||[];e.reverse(),e.push(h.id),console.warn(e.map(b=>this._moduleIdProvider.getStrModuleId(b)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(a.id),h instanceof f){let e=this._modules2[h.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,h);continue}let b=this._inversePluginDependencies2.get(h.pluginId);b||(b=[],this._inversePluginDependencies2.set(h.pluginId,b)),b.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let u=this.getRecorder();if(a.isComplete())return;let o=a.dependencies,w=[];if(o)for(let b=0,L=o.length;b<L;b++){let R=o[b];if(R===T.EXPORTS){w[b]=a.exports;continue}if(R===T.MODULE){w[b]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(R===T.REQUIRE){w[b]=this._createRequire(a.moduleIdResolver);continue}let A=this._modules2[R.id];if(A){w[b]=A.exports;continue}w[b]=null}const h=b=>(this._inverseDependencies2[b]||[]).map(L=>this._moduleIdProvider.getStrModuleId(L));a.complete(u,this._config,w,h);let m=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,m)for(let b=0,L=m.length;b<L;b++){let R=m[b],A=this._modules2[R];A.unresolvedDependenciesCount--,A.unresolvedDependenciesCount===0&&this._onModuleComplete(A)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let b=0,L=e.length;b<L;b++)this._loadPluginDependency(a.exports,e[b])}}}x.ModuleManager=E})(Le||(Le={}));var ne,Le;(function(x){const i=new x.Environment;let t=null;const n=function(g,a,u){typeof g!="string"&&(u=a,a=g,g=null),(typeof a!="object"||!Array.isArray(a))&&(u=a,a=null),a||(a=["require","exports","module"]),g?t.defineModule(g,a,u,null,null):t.enqueueDefineAnonymousModule(a,u)};n.amd={jQuery:!0};const T=function(g,a=!1){t.configure(g,a)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){T(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(x.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=T,f.getConfig=function(){return t.getConfig().getOptionsLiteral()},f.reset=function(){t=t.reset()},f.getBuildInfo=function(){return t.getBuildInfo()},f.getStats=function(){return t.getLoaderEvents()},f.define=n;function E(){if(typeof x.global.require<"u"||typeof require<"u"){const g=x.global.require||require;if(typeof g=="function"&&typeof g.resolve=="function"){const a=x.ensureRecordedNodeRequire(t.getRecorder(),g);x.global.nodeRequire=a,f.nodeRequire=a,f.__$__nodeRequire=a}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=f:(i.isElectronRenderer||(x.global.define=n),x.global.require=f)}x.init=E,(typeof x.global.define!="function"||!x.global.define.amd)&&(t=new x.ModuleManager(i,x.createScriptLoader(i),n,f,x.Utilities.getHighPerformanceTimestamp()),typeof x.global.require<"u"&&typeof x.global.require!="function"&&f.config(x.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&E())})(Le||(Le={})),ne(ie[76],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(g,a,u,o){if(o=o||{},(o["vs/css"]||{}).disabled){u({});return}const h=a.toUrl(g+".css");n(g,h,()=>{u({})},m=>{typeof u.error=="function"&&u.error("Could not find "+h+".")})}function n(g,a,u,o){if(T(g,a)){u();return}f(g,a,u,o)}function T(g,a){const u=window.document.getElementsByTagName("link");for(let o=0,w=u.length;o<w;o++){const h=u[o].getAttribute("data-name"),m=u[o].getAttribute("href");if(h===g||m===a)return!0}return!1}function f(g,a,u,o){const w=document.createElement("link");w.setAttribute("rel","stylesheet"),w.setAttribute("type","text/css"),w.setAttribute("data-name",g),E(g,w,u,o),w.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(w)}function E(g,a,u,o){const w=()=>{a.removeEventListener("load",h),a.removeEventListener("error",m)},h=e=>{w(),u()},m=e=>{w(),o(e)};a.addEventListener("load",h),a.addEventListener("error",m)}}),function(){const x=globalThis.MonacoEnvironment,i=x&&x.baseUrl?x.baseUrl:"../../../";function t(w,h){if(x?.createTrustedTypesPolicy)try{return x.createTrustedTypesPolicy(w,h)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(w,h)}catch(m){console.warn(m);return}}const n=t("amdLoader",{createScriptURL:w=>w,createScript:(w,...h)=>{const m=h.slice(0,-1).join(","),e=h.pop().toString();return`(function anonymous(${m}) { ${e}
})`}});function T(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((w,h)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return w();const m=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&T()){fetch(m).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${m}`,(n?globalThis.eval(n.createScript("",b)):new Function(b)).call(globalThis),w()}).then(void 0,h);return}n?importScripts(n.createScriptURL(m)):importScripts(m),w()})}function E(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function g(w){return f().then(()=>(E(),new Promise((h,m)=>{require([w],h,m)})))}function a(w){setTimeout(function(){const h=w.create((m,e)=>{globalThis.postMessage(m,e)});for(self.onmessage=m=>h.onmessage(m.data,m.ports);o.length>0;)self.onmessage(o.shift())},0)}typeof globalThis.define=="function"&&globalThis.define.amd&&E();let u=!0;const o=[];globalThis.onmessage=w=>{if(!u){o.push(w);return}u=!1,g(w.data).then(h=>{a(h)},h=>{console.error(h)})}}(),ne(ie[9],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ob=void 0,i.$hb=t,i.$ib=n,i.$jb=T,i.$kb=f,i.$lb=E,i.$mb=g,i.$nb=a,i.$pb=o,i.$qb=w,i.$rb=h,i.$sb=m,i.$tb=e;function t(b,L){const R=n(b,L);if(R!==-1)return b[R]}function n(b,L,R=b.length-1){for(let A=R;A>=0;A--){const v=b[A];if(L(v))return A}return-1}function T(b,L){const R=f(b,L);return R===-1?void 0:b[R]}function f(b,L,R=0,A=b.length){let v=R,_=A;for(;v<_;){const $=Math.floor((v+_)/2);L(b[$])?v=$+1:_=$}return v-1}function E(b,L){const R=g(b,L);return R===b.length?void 0:b[R]}function g(b,L,R=0,A=b.length){let v=R,_=A;for(;v<_;){const $=Math.floor((v+_)/2);L(b[$])?_=$:v=$+1}return v}function a(b,L,R=0,A=b.length){const v=g(b,L,R,A);return v===b.length?-1:v}class u{static{this.assertInvariants=!1}constructor(L){this.e=L,this.c=0}findLastMonotonous(L){if(u.assertInvariants){if(this.d){for(const A of this.e)if(this.d(A)&&!L(A))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=L}const R=f(this.e,L,this.c);return this.c=R+1,R===-1?void 0:this.e[R]}}i.$ob=u;function o(b,L){if(b.length===0)return;let R=b[0];for(let A=1;A<b.length;A++){const v=b[A];L(v,R)>0&&(R=v)}return R}function w(b,L){if(b.length===0)return;let R=b[0];for(let A=1;A<b.length;A++){const v=b[A];L(v,R)>=0&&(R=v)}return R}function h(b,L){return o(b,(R,A)=>-L(R,A))}function m(b,L){if(b.length===0)return-1;let R=0;for(let A=1;A<b.length;A++){const v=b[A];L(v,b[R])>0&&(R=A)}return R}function e(b,L){for(const R of b){const A=L(R);if(A!==void 0)return A}}}),ne(ie[5],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[39],re([0,1]),function(x,i){"use strict";var t;Object.defineProperty(i,"__esModule",{value:!0}),i.$g=void 0,i.$c=n,i.$d=T,i.$e=f,i.$f=E;function n(a,u){const o=Object.create(null);for(const w of a){const h=u(w);let m=o[h];m||(m=o[h]=[]),m.push(w)}return o}function T(a,u){const o=[],w=[];for(const h of a)u.has(h)||o.push(h);for(const h of u)a.has(h)||w.push(h);return{removed:o,added:w}}function f(a,u){const o=[],w=[];for(const[h,m]of a)u.has(h)||o.push(m);for(const[h,m]of u)a.has(h)||w.push(m);return{removed:o,added:w}}function E(a,u){const o=new Set;for(const w of u)a.has(w)&&o.add(w);return o}class g{static{t=Symbol.toStringTag}constructor(u,o){this.b=o,this.a=new Map,this[t]="SetWithKey";for(const w of u)this.add(w)}get size(){return this.a.size}add(u){const o=this.b(u);return this.a.set(o,u),this}delete(u){return this.a.delete(this.b(u))}has(u){return this.a.has(this.b(u))}*entries(){for(const u of this.a.values())yield[u,u]}keys(){return this.values()}*values(){for(const u of this.a.values())yield u}clear(){this.a.clear()}forEach(u,o){this.a.forEach(w=>u.call(o,w,w,this))}[Symbol.iterator](){return this.values()}}i.$g=g}),ne(ie[40],re([0,1,5]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$tu=i.$su=i.$ru=i.$qu=void 0;function n(a,u){const o=Math.pow(10,u);return Math.round(a*o)/o}class T{constructor(u,o,w,h=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,o))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=n(Math.max(Math.min(1,h),0),3)}static equals(u,o){return u.r===o.r&&u.g===o.g&&u.b===o.b&&u.a===o.a}}i.$qu=T;class f{constructor(u,o,w,h){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,o),0),3),this.l=n(Math.max(Math.min(1,w),0),3),this.a=n(Math.max(Math.min(1,h),0),3)}static equals(u,o){return u.h===o.h&&u.s===o.s&&u.l===o.l&&u.a===o.a}static fromRGBA(u){const o=u.r/255,w=u.g/255,h=u.b/255,m=u.a,e=Math.max(o,w,h),b=Math.min(o,w,h);let L=0,R=0;const A=(b+e)/2,v=e-b;if(v>0){switch(R=Math.min(A<=.5?v/(2*A):v/(2-2*A),1),e){case o:L=(w-h)/v+(w<h?6:0);break;case w:L=(h-o)/v+2;break;case h:L=(o-w)/v+4;break}L*=60,L=Math.round(L)}return new f(L,R,A,m)}static i(u,o,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?u+(o-u)*6*w:w<1/2?o:w<2/3?u+(o-u)*(2/3-w)*6:u}static toRGBA(u){const o=u.h/360,{s:w,l:h,a:m}=u;let e,b,L;if(w===0)e=b=L=h;else{const R=h<.5?h*(1+w):h+w-h*w,A=2*h-R;e=f.i(A,R,o+1/3),b=f.i(A,R,o),L=f.i(A,R,o-1/3)}return new T(Math.round(e*255),Math.round(b*255),Math.round(L*255),m)}}i.$ru=f;class E{constructor(u,o,w,h){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,o),0),3),this.v=n(Math.max(Math.min(1,w),0),3),this.a=n(Math.max(Math.min(1,h),0),3)}static equals(u,o){return u.h===o.h&&u.s===o.s&&u.v===o.v&&u.a===o.a}static fromRGBA(u){const o=u.r/255,w=u.g/255,h=u.b/255,m=Math.max(o,w,h),e=Math.min(o,w,h),b=m-e,L=m===0?0:b/m;let R;return b===0?R=0:m===o?R=((w-h)/b%6+6)%6:m===w?R=(h-o)/b+2:R=(o-w)/b+4,new E(Math.round(R*60),L,m,u.a)}static toRGBA(u){const{h:o,s:w,v:h,a:m}=u,e=h*w,b=e*(1-Math.abs(o/60%2-1)),L=h-e;let[R,A,v]=[0,0,0];return o<60?(R=e,A=b):o<120?(R=b,A=e):o<180?(A=e,v=b):o<240?(A=b,v=e):o<300?(R=b,v=e):o<=360&&(R=e,v=b),R=Math.round((R+L)*255),A=Math.round((A+L)*255),v=Math.round((v+L)*255),new T(R,A,v,m)}}i.$su=E;class g{static fromHex(u){return g.Format.CSS.parseHex(u)||g.red}static equals(u,o){return!u&&!o?!0:!u||!o?!1:u.equals(o)}get hsla(){return this.i?this.i:f.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:E.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof T)this.rgba=u;else if(u instanceof f)this.i=u,this.rgba=f.toRGBA(u);else if(u instanceof E)this.j=u,this.rgba=E.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&T.equals(this.rgba,u.rgba)&&f.equals(this.hsla,u.hsla)&&E.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=g.k(this.rgba.r),o=g.k(this.rgba.g),w=g.k(this.rgba.b),h=.2126*u+.7152*o+.0722*w;return n(h,4)}static k(u){const o=u/255;return o<=.03928?o/12.92:Math.pow((o+.055)/1.055,2.4)}getContrastRatio(u){const o=this.getRelativeLuminance(),w=u.getRelativeLuminance();return o>w?(o+.05)/(w+.05):(w+.05)/(o+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const o=this.getRelativeLuminance(),w=u.getRelativeLuminance();return o>w}isDarkerThan(u){const o=this.getRelativeLuminance(),w=u.getRelativeLuminance();return o<w}lighten(u){return new g(new f(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new g(new f(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:o,g:w,b:h,a:m}=this.rgba;return new g(new T(o,w,h,m*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new g(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const o=u.rgba,w=this.rgba.a,h=o.a,m=w+h*(1-w);if(m<1e-6)return g.transparent;const e=this.rgba.r*w/m+o.r*h*(1-w)/m,b=this.rgba.g*w/m+o.g*h*(1-w)/m,L=this.rgba.b*w/m+o.b*h*(1-w)/m;return new g(new T(e,b,L,m))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:o,g:w,b:h,a:m}=this.rgba;return new g(new T(u.rgba.r-m*(u.rgba.r-o),u.rgba.g-m*(u.rgba.g-w),u.rgba.b-m*(u.rgba.b-h),1))}flatten(...u){const o=u.reduceRight((w,h)=>g.o(h,w));return g.o(this,o)}static o(u,o){const w=1-u.rgba.a;return new g(new T(w*o.rgba.r+u.rgba.a*u.rgba.r,w*o.rgba.g+u.rgba.a*u.rgba.g,w*o.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=g.Format.CSS.format(this)),this.u}static getLighterColor(u,o,w){if(u.isLighterThan(o))return u;w=w||.5;const h=u.getRelativeLuminance(),m=o.getRelativeLuminance();return w=w*(m-h)/m,u.lighten(w)}static getDarkerColor(u,o,w){if(u.isDarkerThan(o))return u;w=w||.5;const h=u.getRelativeLuminance(),m=o.getRelativeLuminance();return w=w*(h-m)/h,u.darken(w)}static{this.white=new g(new T(255,255,255,1))}static{this.black=new g(new T(0,0,0,1))}static{this.red=new g(new T(255,0,0,1))}static{this.blue=new g(new T(0,0,255,1))}static{this.green=new g(new T(0,255,0,1))}static{this.cyan=new g(new T(0,255,255,1))}static{this.lightgrey=new g(new T(211,211,211,1))}static{this.transparent=new g(new T(0,0,0,0))}}i.$tu=g,function(a){let u;(function(o){let w;(function(h){function m(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:a.Format.CSS.formatRGBA(s)}h.formatRGB=m;function e(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}h.formatRGBA=e;function b(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:a.Format.CSS.formatHSLA(s)}h.formatHSL=b;function L(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}h.formatHSLA=L;function R(s){const c=s.toString(16);return c.length!==2?"0"+c:c}function A(s){return`#${R(s.rgba.r)}${R(s.rgba.g)}${R(s.rgba.b)}`}h.formatHex=A;function v(s,c=!1){return c&&s.rgba.a===1?a.Format.CSS.formatHex(s):`#${R(s.rgba.r)}${R(s.rgba.g)}${R(s.rgba.b)}${R(Math.round(s.rgba.a*255))}`}h.formatHexA=v;function _(s){return s.isOpaque()?a.Format.CSS.formatHex(s):a.Format.CSS.formatRGBA(s)}h.format=_;function $(s){const c=s.length;if(c===0||s.charCodeAt(0)!==t.CharCode.Hash)return null;if(c===7){const d=16*l(s.charCodeAt(1))+l(s.charCodeAt(2)),j=16*l(s.charCodeAt(3))+l(s.charCodeAt(4)),N=16*l(s.charCodeAt(5))+l(s.charCodeAt(6));return new a(new T(d,j,N,1))}if(c===9){const d=16*l(s.charCodeAt(1))+l(s.charCodeAt(2)),j=16*l(s.charCodeAt(3))+l(s.charCodeAt(4)),N=16*l(s.charCodeAt(5))+l(s.charCodeAt(6)),p=16*l(s.charCodeAt(7))+l(s.charCodeAt(8));return new a(new T(d,j,N,p/255))}if(c===4){const d=l(s.charCodeAt(1)),j=l(s.charCodeAt(2)),N=l(s.charCodeAt(3));return new a(new T(16*d+d,16*j+j,16*N+N))}if(c===5){const d=l(s.charCodeAt(1)),j=l(s.charCodeAt(2)),N=l(s.charCodeAt(3)),p=l(s.charCodeAt(4));return new a(new T(16*d+d,16*j+j,16*N+N,(16*p+p)/255))}return null}h.parseHex=$;function l(s){switch(s){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})(w=o.CSS||(o.CSS={}))})(u=a.Format||(a.Format={}))}(g||(i.$tu=g={}))}),ne(ie[41],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Wt=void 0;class t{constructor(T,f,E,g){this.originalStart=T,this.originalLength=f,this.modifiedStart=E,this.modifiedLength=g}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.$Wt=t}),ne(ie[3],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$eb=i.$db=i.$cb=i.$bb=i.$ab=i.$$=i.$7=i.$Y=i.$X=void 0,i.setUnexpectedErrorHandler=n,i.$1=T,i.$2=f,i.$3=E,i.$4=g,i.$5=a,i.$6=o,i.$8=h,i.$9=m,i.$0=e,i.$_=L;class t{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?_.isErrorNoTelemetry(s)?new _(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(c=>{c(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}i.$X=t,i.$Y=new t;function n(l){i.$Y.setUnexpectedErrorHandler(l)}function T(l){if(!l||typeof l!="object")return!1;const s=l;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}function f(l){o(l)||i.$Y.onUnexpectedError(l)}function E(l){o(l)||i.$Y.onUnexpectedExternalError(l)}function g(l){if(l instanceof Error){const{name:s,message:c}=l,d=l.stacktrace||l.stack;return{$isError:!0,name:s,message:c,stack:d,noTelemetry:_.isErrorNoTelemetry(l)}}return l}function a(l){let s;return l.noTelemetry?s=new _:(s=new Error,s.name=l.name),s.message=l.message,s.stack=l.stack,s}const u="Canceled";function o(l){return l instanceof w?!0:l instanceof Error&&l.name===u&&l.message===u}class w extends Error{constructor(){super(u),this.name=this.message}}i.$7=w;function h(){const l=new Error(u);return l.name=l.message,l}function m(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function e(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class b extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}i.$$=b;function L(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class R extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}i.$ab=R;class A extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}i.$bb=A;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.$cb=v;class _ extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof _)return s;const c=new _;return c.message=s.message,c.stack=s.stack,c}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}i.$db=_;class $ extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}i.$eb=$}),ne(ie[8],re([0,1,3,9]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cc=i.$bc=i.$ac=i.$$b=i.$0b=i.CompareResult=void 0,i.$ub=T,i.$vb=f,i.$wb=E,i.$xb=g,i.$yb=a,i.$zb=u,i.$Ab=o,i.$Bb=w,i.$Cb=h,i.$Db=m,i.$Eb=e,i.$Fb=b,i.$Gb=L,i.top=R,i.$Ib=A,i.$Jb=_,i.$Kb=$,i.$Lb=l,i.$Mb=s,i.$Nb=c,i.$Ob=d,i.$Pb=j,i.$Qb=N,i.$Rb=p,i.$Sb=D,i.$Tb=M,i.$Ub=S,i.$Vb=I,i.$Wb=F,i.$Xb=B,i.$Yb=W,i.$Zb=O,i.$1b=y,i.$2b=X,i.$3b=Z,i.$4b=Y,i.$5b=Q,i.$6b=C,i.$7b=k,i.$8b=ce,i.$9b=we,i.$_b=Pe,i.$dc=Ge;function T(U,H=0){return U[U.length-(1+H)]}function f(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function E(U,H,V=(J,ee)=>J===ee){if(U===H)return!0;if(!U||!H||U.length!==H.length)return!1;for(let J=0,ee=U.length;J<ee;J++)if(!V(U[J],H[J]))return!1;return!0}function g(U,H){const V=U.length-1;H<V&&(U[H]=U[V]),U.pop()}function a(U,H,V){return u(U.length,J=>V(U[J],H))}function u(U,H){let V=0,J=U-1;for(;V<=J;){const ee=(V+J)/2|0,he=H(ee);if(he<0)V=ee+1;else if(he>0)J=ee-1;else return ee}return-(V+1)}function o(U,H,V){if(U=U|0,U>=H.length)throw new TypeError("invalid index");const J=H[Math.floor(H.length*Math.random())],ee=[],he=[],de=[];for(const Ne of H){const ve=V(Ne,J);ve<0?ee.push(Ne):ve>0?he.push(Ne):de.push(Ne)}return U<ee.length?o(U,ee,V):U<ee.length+de.length?de[0]:o(U-(ee.length+de.length),he,V)}function w(U,H){const V=[];let J;for(const ee of U.slice(0).sort(H))!J||H(J[0],ee)!==0?(J=[ee],V.push(J)):J.push(ee);return V}function*h(U,H){let V,J;for(const ee of U)J!==void 0&&H(J,ee)?V.push(ee):(V&&(yield V),V=[ee]),J=ee;V&&(yield V)}function m(U,H){for(let V=0;V<=U.length;V++)H(V===0?void 0:U[V-1],V===U.length?void 0:U[V])}function e(U,H){for(let V=0;V<U.length;V++)H(V===0?void 0:U[V-1],U[V],V+1===U.length?void 0:U[V+1])}function b(U,H,V){const J=[];function ee(Ne,ve,_e){if(ve===0&&_e.length===0)return;const je=J[J.length-1];je&&je.start+je.deleteCount===Ne?(je.deleteCount+=ve,je.toInsert.push(..._e)):J.push({start:Ne,deleteCount:ve,toInsert:_e})}let he=0,de=0;for(;;){if(he===U.length){ee(he,0,H.slice(de));break}if(de===H.length){ee(he,U.length-he,[]);break}const Ne=U[he],ve=H[de],_e=V(Ne,ve);_e===0?(he+=1,de+=1):_e<0?(ee(he,1,[]),he+=1):_e>0&&(ee(he,0,[ve]),de+=1)}return J}function L(U,H,V){const J=b(U,H,V),ee=[],he=[];for(const de of J)ee.push(...U.slice(de.start,de.start+de.deleteCount)),he.push(...de.toInsert);return{removed:ee,added:he}}function R(U,H,V){if(V===0)return[];const J=U.slice(0,V).sort(H);return v(U,H,J,V,U.length),J}function A(U,H,V,J,ee){return V===0?Promise.resolve([]):new Promise((he,de)=>{(async()=>{const Ne=U.length,ve=U.slice(0,V).sort(H);for(let _e=V,je=Math.min(V+J,Ne);_e<Ne;_e=je,je=Math.min(je+J,Ne)){if(_e>V&&await new Promise(ue=>setTimeout(ue)),ee&&ee.isCancellationRequested)throw new t.$7;v(U,H,ve,_e,je)}return ve})().then(he,de)})}function v(U,H,V,J,ee){for(const he=V.length;J<ee;J++){const de=U[J];if(H(de,V[he-1])<0){V.pop();const Ne=(0,n.$mb)(V,ve=>H(de,ve)<0);V.splice(Ne,0,de)}}}function _(U){return U.filter(H=>!!H)}function $(U){let H=0;for(let V=0;V<U.length;V++)U[V]&&(U[H]=U[V],H+=1);U.length=H}function l(U,H,V){U.splice(V,0,U.splice(H,1)[0])}function s(U){return!Array.isArray(U)||U.length===0}function c(U){return Array.isArray(U)&&U.length>0}function d(U,H=V=>V){const V=new Set;return U.filter(J=>{const ee=H(J);return V.has(ee)?!1:(V.add(ee),!0)})}function j(U){const H=new Set;return V=>{const J=U(V);return H.has(J)?!1:(H.add(J),!0)}}function N(U,H){return U.length>0?U[0]:H}function p(U,H){return U.length>0?U[U.length-1]:H}function D(U,H,V=(J,ee)=>J===ee){let J=0;for(let ee=0,he=Math.min(U.length,H.length);ee<he&&V(U[ee],H[ee]);ee++)J++;return J}function M(U,H){let V=typeof H=="number"?U:0;typeof H=="number"?V=U:(V=0,H=U);const J=[];if(V<=H)for(let ee=V;ee<H;ee++)J.push(ee);else for(let ee=V;ee>H;ee--)J.push(ee);return J}function S(U,H,V){return U.reduce((J,ee)=>(J[H(ee)]=V?V(ee):ee,J),Object.create(null))}function I(U,H){return U.push(H),()=>F(U,H)}function F(U,H){const V=U.indexOf(H);if(V>-1)return U.splice(V,1),H}function B(U,H,V){const J=U.slice(0,H),ee=U.slice(H);return J.concat(V,ee)}function W(U,H){let V;if(typeof H=="number"){let J=H;V=()=>{const ee=Math.sin(J++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let J=U.length-1;J>0;J-=1){const ee=Math.floor(V()*(J+1)),he=U[J];U[J]=U[ee],U[ee]=he}}function O(U,H){const V=U.indexOf(H);V>-1&&(U.splice(V,1),U.unshift(H))}function y(U,H){const V=U.indexOf(H);V>-1&&(U.splice(V,1),U.push(H))}function X(U,H){for(const V of H)U.push(V)}function Z(U,H){return Array.isArray(U)?U.map(H):H(U)}function Y(U){return Array.isArray(U)?U:[U]}function Q(U){return U[Math.floor(Math.random()*U.length)]}function C(U,H,V){const J=G(U,H),ee=U.length,he=V.length;U.length=ee+he;for(let de=ee-1;de>=J;de--)U[de+he]=U[de];for(let de=0;de<he;de++)U[de+J]=V[de]}function k(U,H,V,J){const ee=G(U,H);let he=U.splice(ee,V);return he===void 0&&(he=[]),C(U,ee,J),he}function G(U,H){return H<0?Math.max(H+U.length,0):Math.min(H,U.length)}var oe;(function(U){function H(he){return he<0}U.isLessThan=H;function V(he){return he<=0}U.isLessThanOrEqual=V;function J(he){return he>0}U.isGreaterThan=J;function ee(he){return he===0}U.isNeitherLessOrGreaterThan=ee,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(oe||(i.CompareResult=oe={}));function ce(U,H){return(V,J)=>H(U(V),U(J))}function we(...U){return(H,V)=>{for(const J of U){const ee=J(H,V);if(!oe.isNeitherLessOrGreaterThan(ee))return ee}return oe.neitherLessOrGreaterThan}}const r=(U,H)=>U-H;i.$0b=r;const Te=(U,H)=>(0,i.$0b)(U?1:0,H?1:0);i.$$b=Te;function Pe(U){return(H,V)=>-U(H,V)}class He{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let V=this.c;for(;V<this.g.length&&H(this.g[V]);)V++;const J=V===this.c?null:this.g.slice(this.c,V);return this.c=V,J}takeFromEndWhile(H){let V=this.d;for(;V>=0&&H(this.g[V]);)V--;const J=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const V=this.g.slice(this.c,this.c+H);return this.c+=H,V}}i.$ac=He;class Fe{static{this.empty=new Fe(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(V=>(H(V),!0))}toArray(){const H=[];return this.iterate(V=>(H.push(V),!0)),H}filter(H){return new Fe(V=>this.iterate(J=>H(J)?V(J):!0))}map(H){return new Fe(V=>this.iterate(J=>V(H(J))))}some(H){let V=!1;return this.iterate(J=>(V=H(J),!V)),V}findFirst(H){let V;return this.iterate(J=>H(J)?(V=J,!1):!0),V}findLast(H){let V;return this.iterate(J=>(H(J)&&(V=J),!0)),V}findLastMaxBy(H){let V,J=!0;return this.iterate(ee=>((J||oe.isGreaterThan(H(ee,V)))&&(J=!1,V=ee),!0)),V}}i.$bc=Fe;class Be{constructor(H){this.c=H}static createSortPermutation(H,V){const J=Array.from(H.keys()).sort((ee,he)=>V(H[ee],H[he]));return new Be(J)}apply(H){return H.map((V,J)=>H[this.c[J]])}inverse(){const H=this.c.slice();for(let V=0;V<this.c.length;V++)H[this.c[V]]=V;return new Be(H)}}i.$cc=Be;async function Ge(U,H){return(await Promise.all(U.map(async(J,ee)=>({element:J,ok:await H(J,ee)})))).find(J=>J.ok)?.element}}),ne(ie[11],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.$hd=T,i.$id=f,i.$jd=E,i.$kd=g,i.$ld=a;function n(u,o){if(!u)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}function T(u,o="Unreachable"){throw new Error(o)}function f(u,o="unexpected state"){if(!u)throw new t.$eb(`Assertion Failed: ${o}`)}function E(u){u||(0,t.$2)(new t.$eb("Soft Assertion Failed"))}function g(u){if(!u()){debugger;u(),(0,t.$2)(new t.$eb("Assertion Failed"))}}function a(u,o){let w=0;for(;w<u.length-1;){const h=u[w],m=u[w+1];if(!o(h,m))return!1;w++}return!0}}),ne(ie[22],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fb=t;function t(n,T){const f=this;let E=!1,g;return function(){if(E)return g;if(E=!0,T)try{g=n.apply(f,arguments)}finally{T()}else g=n.apply(f,arguments);return g}}}),ne(ie[23],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function T(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}n.is=T;const f=Object.freeze([]);function E(){return f}n.empty=E;function*g(s){yield s}n.single=g;function a(s){return T(s)?s:g(s)}n.wrap=a;function u(s){return s||f}n.from=u;function*o(s){for(let c=s.length-1;c>=0;c--)yield s[c]}n.reverse=o;function w(s){return!s||s[Symbol.iterator]().next().done===!0}n.isEmpty=w;function h(s){return s[Symbol.iterator]().next().value}n.first=h;function m(s,c){let d=0;for(const j of s)if(c(j,d++))return!0;return!1}n.some=m;function e(s,c){for(const d of s)if(c(d))return d}n.find=e;function*b(s,c){for(const d of s)c(d)&&(yield d)}n.filter=b;function*L(s,c){let d=0;for(const j of s)yield c(j,d++)}n.map=L;function*R(s,c){let d=0;for(const j of s)yield*c(j,d++)}n.flatMap=R;function*A(...s){for(const c of s)yield*c}n.concat=A;function v(s,c,d){let j=d;for(const N of s)j=c(j,N);return j}n.reduce=v;function*_(s,c,d=s.length){for(c<0&&(c+=s.length),d<0?d+=s.length:d>s.length&&(d=s.length);c<d;c++)yield s[c]}n.slice=_;function $(s,c=Number.POSITIVE_INFINITY){const d=[];if(c===0)return[d,s];const j=s[Symbol.iterator]();for(let N=0;N<c;N++){const p=j.next();if(p.done)return[d,n.empty()];d.push(p.value)}return[d,{[Symbol.iterator](){return j}}]}n.consume=$;async function l(s){const c=[];for await(const d of s)c.push(d);return Promise.resolve(c)}n.asyncToArray=l})(t||(i.Iterable=t={}))}),ne(ie[42],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.$3r=i.$2r=i.$1r=i.$Zr=i.$Yr=i.ScanCode=i.KeyCode=void 0,i.$4r=m;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class T{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(b,L){this._keyCodeToStr[b]=L,this._strToKeyCode[L.toLowerCase()]=b}keyCodeToStr(b){return this._keyCodeToStr[b]}strToKeyCode(b){return this._strToKeyCode[b.toLowerCase()]||t.Unknown}}const f=new T,E=new T,g=new T;i.$Yr=new Array(230),i.$Zr={};const a=[],u=Object.create(null),o=Object.create(null);i.$1r={lowerCaseToEnum:e=>o[e]||n.None,toEnum:e=>u[e]||n.None,toString:e=>a[e]||"None"},i.$2r=[],i.$3r=[];for(let e=0;e<=n.MAX_VALUE;e++)i.$2r[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.$3r[e]=n.DependsOnKbLayout;(function(){const e="",b=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],L=[],R=[];for(const A of b){const[v,_,$,l,s,c,d,j,N]=A;if(R[_]||(R[_]=!0,a[_]=$,u[$]=_,o[$.toLowerCase()]=_,v&&(i.$2r[_]=l,l!==t.Unknown&&l!==t.Enter&&l!==t.Ctrl&&l!==t.Shift&&l!==t.Alt&&l!==t.Meta&&(i.$3r[l]=_))),!L[l]){if(L[l]=!0,!s)throw new Error(`String representation missing for key code ${l} around scan code ${$}`);f.define(l,s),E.define(l,j||s),g.define(l,N||j||s)}c&&(i.$Yr[c]=l),d&&(i.$Zr[d]=l)}i.$3r[t.Enter]=n.Enter})();var w;(function(e){function b($){return f.keyCodeToStr($)}e.toString=b;function L($){return f.strToKeyCode($)}e.fromString=L;function R($){return E.keyCodeToStr($)}e.toUserSettingsUS=R;function A($){return g.keyCodeToStr($)}e.toUserSettingsGeneral=A;function v($){return E.strToKeyCode($)||g.strToKeyCode($)}e.fromUserSettings=v;function _($){if($>=t.Numpad0&&$<=t.NumpadDivide)return null;switch($){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return f.keyCodeToStr($)}e.toElectronAccelerator=_})(w||(i.KeyCodeUtils=w={}));var h;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(h||(i.KeyMod=h={}));function m(e,b){const L=(b&65535)<<16>>>0;return(e|L)>>>0}}),ne(ie[43],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$W=void 0;class t{constructor(T){this.d=T,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.$W=t}),ne(ie[24],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8c=void 0;class t{static{this.Undefined=new t(void 0)}constructor(f){this.element=f,this.next=t.Undefined,this.prev=t.Undefined}}class n{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let f=this.a;for(;f!==t.Undefined;){const E=f.next;f.prev=t.Undefined,f.next=t.Undefined,f=E}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,E){const g=new t(f);if(this.a===t.Undefined)this.a=g,this.b=g;else if(E){const u=this.b;this.b=g,g.prev=u,u.next=g}else{const u=this.a;this.a=g,g.next=u,u.prev=g}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(g))}}shift(){if(this.a!==t.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==t.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==t.Undefined&&f.next!==t.Undefined){const E=f.prev;E.next=f.next,f.next.prev=E}else f.prev===t.Undefined&&f.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):f.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):f.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==t.Undefined;)yield f.element,f=f.next}}i.$8c=n}),ne(ie[18],re([0,1]),function(x,i){"use strict";var t,n,T;Object.defineProperty(i,"__esModule",{value:!0}),i.$Kc=i.$Jc=i.$Ic=i.$Hc=i.$Gc=i.$Fc=i.Touch=i.$Ec=i.$Dc=void 0,i.$Ac=f,i.$Bc=E,i.$Cc=g,i.$Lc=_;function f($,l,s){let c=$.get(l);return c===void 0&&(c=s,$.set(l,c)),c}function E($){const l=[];return $.forEach((s,c)=>{l.push(`${c} => ${s}`)}),`Map(${$.size}) {${l.join(", ")}}`}function g($){const l=[];return $.forEach(s=>{l.push(s)}),`Set(${$.size}) {${l.join(", ")}}`}class a{constructor(l,s){this.uri=l,this.value=s}}function u($){return Array.isArray($)}class o{static{this.c=l=>l.toString()}constructor(l,s){if(this[t]="ResourceMap",l instanceof o)this.d=new Map(l.d),this.e=s??o.c;else if(u(l)){this.d=new Map,this.e=s??o.c;for(const[c,d]of l)this.set(c,d)}else this.d=new Map,this.e=l??o.c}set(l,s){return this.d.set(this.e(l),new a(l,s)),this}get(l){return this.d.get(this.e(l))?.value}has(l){return this.d.has(this.e(l))}get size(){return this.d.size}clear(){this.d.clear()}delete(l){return this.d.delete(this.e(l))}forEach(l,s){typeof s<"u"&&(l=l.bind(s));for(const[c,d]of this.d)l(d.value,d.uri,this)}*values(){for(const l of this.d.values())yield l.value}*keys(){for(const l of this.d.values())yield l.uri}*entries(){for(const l of this.d.values())yield[l.uri,l.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.d)yield[l.uri,l.value]}}i.$Dc=o;class w{constructor(l,s){this[n]="ResourceSet",!l||typeof l=="function"?this.c=new o(l):(this.c=new o(s),l.forEach(this.add,this))}get size(){return this.c.size}add(l){return this.c.set(l,l),this}clear(){this.c.clear()}delete(l){return this.c.delete(l)}forEach(l,s){this.c.forEach((c,d)=>l.call(s,d,d,this))}has(l){return this.c.has(l)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.$Ec=w;var h;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(h||(i.Touch=h={}));class m{constructor(){this[T]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(l){return this.c.has(l)}get(l,s=h.None){const c=this.c.get(l);if(c)return s!==h.None&&this.m(c,s),c.value}set(l,s,c=h.None){let d=this.c.get(l);if(d)d.value=s,c!==h.None&&this.m(d,c);else{switch(d={key:l,value:s,next:void 0,previous:void 0},c){case h.None:this.k(d);break;case h.AsOld:this.j(d);break;case h.AsNew:this.k(d);break;default:this.k(d);break}this.c.set(l,d),this.f++}return this}delete(l){return!!this.remove(l)}remove(l){const s=this.c.get(l);if(s)return this.c.delete(l),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const l=this.d;return this.c.delete(l.key),this.l(l),this.f--,l.value}forEach(l,s){const c=this.g;let d=this.d;for(;d;){if(s?l.bind(s)(d.value,d.key,this):l(d.value,d.key,this),this.g!==c)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const l=this,s=this.g;let c=this.d;const d={[Symbol.iterator](){return d},next(){if(l.g!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const j={value:c.key,done:!1};return c=c.next,j}else return{value:void 0,done:!0}}};return d}values(){const l=this,s=this.g;let c=this.d;const d={[Symbol.iterator](){return d},next(){if(l.g!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const j={value:c.value,done:!1};return c=c.next,j}else return{value:void 0,done:!0}}};return d}entries(){const l=this,s=this.g;let c=this.d;const d={[Symbol.iterator](){return d},next(){if(l.g!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const j={value:[c.key,c.value],done:!1};return c=c.next,j}else return{value:void 0,done:!0}}};return d}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(l){if(l>=this.size)return;if(l===0){this.clear();return}let s=this.d,c=this.size;for(;s&&c>l;)this.c.delete(s.key),s=s.next,c--;this.d=s,this.f=c,s&&(s.previous=void 0),this.g++}i(l){if(l>=this.size)return;if(l===0){this.clear();return}let s=this.e,c=this.size;for(;s&&c>l;)this.c.delete(s.key),s=s.previous,c--;this.e=s,this.f=c,s&&(s.next=void 0),this.g++}j(l){if(!this.d&&!this.e)this.e=l;else if(this.d)l.next=this.d,this.d.previous=l;else throw new Error("Invalid list");this.d=l,this.g++}k(l){if(!this.d&&!this.e)this.d=l;else if(this.e)l.previous=this.e,this.e.next=l;else throw new Error("Invalid list");this.e=l,this.g++}l(l){if(l===this.d&&l===this.e)this.d=void 0,this.e=void 0;else if(l===this.d){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.d=l.next}else if(l===this.e){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.e=l.previous}else{const s=l.next,c=l.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}l.next=void 0,l.previous=void 0,this.g++}m(l,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==h.AsOld&&s!==h.AsNew)){if(s===h.AsOld){if(l===this.d)return;const c=l.next,d=l.previous;l===this.e?(d.next=void 0,this.e=d):(c.previous=d,d.next=c),l.previous=void 0,l.next=this.d,this.d.previous=l,this.d=l,this.g++}else if(s===h.AsNew){if(l===this.e)return;const c=l.next,d=l.previous;l===this.d?(c.previous=void 0,this.d=c):(c.previous=d,d.next=c),l.next=void 0,l.previous=this.e,this.e.next=l,this.e=l,this.g++}}}toJSON(){const l=[];return this.forEach((s,c)=>{l.push([c,s])}),l}fromJSON(l){this.clear();for(const[s,c]of l)this.set(s,c)}}i.$Fc=m;class e extends m{constructor(l,s=1){super(),this.n=l,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(l){this.n=l,this.p()}get ratio(){return this.o}set ratio(l){this.o=Math.min(Math.max(0,l),1),this.p()}get(l,s=h.AsNew){return super.get(l,s)}peek(l){return super.get(l,h.None)}set(l,s){return super.set(l,s,h.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class b extends e{constructor(l,s=1){super(l,s)}q(l){this.h(l)}set(l,s){return super.set(l,s),this.p(),this}}i.$Gc=b;class L extends e{constructor(l,s=1){super(l,s)}q(l){this.i(l)}set(l,s){return this.n<=this.size&&!this.has(l)&&this.q(Math.round(this.n*this.o)-1),super.set(l,s),this}}i.$Hc=L;class R{constructor(){this.c=new Map}add(l){return this.c.set(l,(this.c.get(l)||0)+1),this}delete(l){let s=this.c.get(l)||0;return s===0?!1:(s--,s===0?this.c.delete(l):this.c.set(l,s),!0)}has(l){return this.c.has(l)}}i.$Ic=R;class A{constructor(l){if(this.c=new Map,this.d=new Map,l)for(const[s,c]of l)this.set(s,c)}clear(){this.c.clear(),this.d.clear()}set(l,s){this.c.set(l,s),this.d.set(s,l)}get(l){return this.c.get(l)}getKey(l){return this.d.get(l)}delete(l){const s=this.c.get(l);return s===void 0?!1:(this.c.delete(l),this.d.delete(s),!0)}forEach(l,s){this.c.forEach((c,d)=>{l.call(s,c,d,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}i.$Jc=A;class v{constructor(){this.c=new Map}add(l,s){let c=this.c.get(l);c||(c=new Set,this.c.set(l,c)),c.add(s)}delete(l,s){const c=this.c.get(l);c&&(c.delete(s),c.size===0&&this.c.delete(l))}forEach(l,s){const c=this.c.get(l);c&&c.forEach(s)}get(l){const s=this.c.get(l);return s||new Set}}i.$Kc=v;function _($,l){if($===l)return!0;if($.size!==l.size)return!1;for(const[s,c]of $)if(!l.has(s)||l.get(s)!==c)return!1;for(const[s]of l)if(!$.has(s))return!1;return!0}}),ne(ie[12],re([0,1,8,39,18,22,23]),function(x,i,t,n,T,f,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$7c=i.$5c=i.$4c=i.$3c=i.$2c=i.$1c=i.$Zc=i.$Yc=i.$Xc=i.$Wc=i.$Mc=void 0,i.$Nc=o,i.$Oc=w,i.$Pc=h,i.$Qc=b,i.$Rc=L,i.$Sc=R,i.$Tc=A,i.$Uc=v,i.$Vc=_,i.$6c=M;const g=!1;let a=null;class u{constructor(){this.b=new Map}static{this.a=0}c(F){let B=this.b.get(F);return B||(B={parent:null,source:null,isSingleton:!1,value:F,idx:u.a++},this.b.set(F,B)),B}trackDisposable(F){const B=this.c(F);B.source||(B.source=new Error().stack)}setParent(F,B){const W=this.c(F);W.parent=B}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,B){const W=B.get(F);if(W)return W;const O=F.parent?this.f(this.c(F.parent),B):F;return B.set(F,O),O}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,F).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(F=10,B){let W;if(B)W=B;else{const Y=new Map,Q=[...this.b.values()].filter(k=>k.source!==null&&!this.f(k,Y).isSingleton);if(Q.length===0)return;const C=new Set(Q.map(k=>k.value));if(W=Q.filter(k=>!(k.parent&&C.has(k.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function O(Y){function Q(k,G){for(;k.length>0&&G.some(oe=>typeof oe=="string"?oe===k[0]:k[0].match(oe));)k.shift()}const C=Y.source.split(`
`).map(k=>k.trim().replace("at ","")).filter(k=>k!=="");return Q(C,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),C.reverse()}const y=new T.$Kc;for(const Y of W){const Q=O(Y);for(let C=0;C<=Q.length;C++)y.add(Q.slice(0,C).join(`
`),Y)}W.sort((0,t.$8b)(Y=>Y.idx,t.$0b));let X="",Z=0;for(const Y of W.slice(0,F)){Z++;const Q=O(Y),C=[];for(let k=0;k<Q.length;k++){let G=Q[k];G=`(shared with ${y.get(Q.slice(0,k+1).join(`
`)).size}/${W.length} leaks) at ${G}`;const ce=y.get(Q.slice(0,k).join(`
`)),we=(0,n.$c)([...ce].map(r=>O(r)[k]),r=>r);delete we[Q[k]];for(const[r,Te]of Object.entries(we))C.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${r}`);C.unshift(G)}X+=`


==================== Leaking disposable ${Z}/${W.length}: ${Y.value.constructor.name} ====================
${C.join(`
`)}
============================================================

`}return W.length>F&&(X+=`


... and ${W.length-F} more leaking disposables

`),{leaks:W,details:X}}}i.$Mc=u;function o(I){a=I}if(g){const I="__is_disposable_tracked__";o(new class{trackDisposable(F){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[I]||console.log(B)},3e3)}setParent(F,B){if(F&&F!==l.None)try{F[I]=!0}catch{}}markAsDisposed(F){if(F&&F!==l.None)try{F[I]=!0}catch{}}markAsSingleton(F){}})}function w(I){return a?.trackDisposable(I),I}function h(I){a?.markAsDisposed(I)}function m(I,F){a?.setParent(I,F)}function e(I,F){if(a)for(const B of I)a.setParent(B,F)}function b(I){return a?.markAsSingleton(I),I}function L(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function R(I){if(E.Iterable.is(I)){const F=[];for(const B of I)if(B)try{B.dispose()}catch(W){F.push(W)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function A(I){for(const F of I)L(F)&&F.dispose();return[]}function v(...I){const F=_(()=>R(I));return e(I,F),F}function _(I){const F=w({dispose:(0,f.$fb)(()=>{h(F),I()})});return F}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{R(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return m(F,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),m(F,null))}}i.$Wc=$;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,w(this),m(this.q,this)}dispose(){h(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}i.$Xc=l;class s{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&m(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&m(F,null),F}}i.$Yc=s;class c{constructor(F){this.a=new s,this.b=!1,this.a.value=F}get value(){return this.a.value}set value(F){this.b||F===this.a.value||(this.a.value=F)}dispose(){this.b=!0,this.a.dispose()}}i.$Zc=c;class d{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.$1c=d;class j{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(F){let B=F;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,h(this))},this}}i.$2c=j;class N{constructor(){this.a=new Map}acquire(F,...B){let W=this.a.get(F);W||(W={counter:0,object:this.b(F,...B)},this.a.set(F,W));const{object:O}=W,y=(0,f.$fb)(()=>{--W.counter===0&&(this.c(F,W.object),this.a.delete(F))});return W.counter++,{object:O,dispose:y}}}i.$3c=N;class p{constructor(F){this.a=F}async acquire(F,...B){const W=this.a.acquire(F,...B);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(O){throw W.dispose(),O}}}i.$4c=p;class D{constructor(F){this.object=F}dispose(){}}i.$5c=D;function M(I){const F=new $;try{I(F)}finally{F.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{R(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,B,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(F)?.dispose(),this.a.set(F,B)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}deleteAndLeak(F){const B=this.a.get(F);return this.a.delete(F),B}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.$7c=S}),ne(ie[44],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[13],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$J=i.$I=i.$H=i.$G=i.$F=i.OS=i.OperatingSystem=i.$C=i.$B=i.$A=i.$z=i.$y=i.Language=i.$x=i.$w=i.$v=i.$u=i.$t=i.$s=i.$r=i.$q=i.$p=i.$o=i.$n=i.$m=i.$l=i.$k=i.$j=i.Platform=i.$h=void 0,i.$i=l,i.$E=p,i.$K=D,i.$h="en";let t=!1,n=!1,T=!1,f=!1,E=!1,g=!1,a=!1,u=!1,o=!1,w=!1,h,m=i.$h,e=i.$h,b,L;const R=globalThis;let A;typeof R.vscode<"u"&&typeof R.vscode.process<"u"?A=R.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(A=process);const v=typeof A?.versions?.electron=="string",_=v&&A?.type==="renderer";if(typeof A=="object"){t=A.platform==="win32",n=A.platform==="darwin",T=A.platform==="linux",f=T&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,a=v,o=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=i.$h,m=i.$h;const M=A.env.VSCODE_NLS_CONFIG;if(M)try{const S=JSON.parse(M);h=S.userLocale,e=S.osLocale,m=S.resolvedLanguage||i.$h,b=S.languagePack?.translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!_?(L=navigator.userAgent,t=L.indexOf("Windows")>=0,n=L.indexOf("Macintosh")>=0,u=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=L.indexOf("Linux")>=0,w=L?.indexOf("Mobi")>=0,g=!0,m=globalThis._VSCODE_NLS_LANGUAGE||i.$h,h=navigator.language.toLowerCase(),e=h):console.error("Unable to resolve platform.");var $;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})($||(i.Platform=$={}));function l(M){switch(M){case $.Web:return"Web";case $.Mac:return"Mac";case $.Linux:return"Linux";case $.Windows:return"Windows"}}let s=$.Web;n?s=$.Mac:t?s=$.Windows:T&&(s=$.Linux),i.$j=t,i.$k=n,i.$l=T,i.$m=f,i.$n=E,i.$o=a,i.$p=g,i.$q=g&&typeof R.importScripts=="function",i.$r=i.$q?R.origin:void 0,i.$s=u,i.$t=w,i.$u=o,i.$v=s,i.$w=L,i.$x=m;var c;(function(M){function S(){return i.$x}M.value=S;function I(){return i.$x.length===2?i.$x==="en":i.$x.length>=3?i.$x[0]==="e"&&i.$x[1]==="n"&&i.$x[2]==="-":!1}M.isDefaultVariant=I;function F(){return i.$x==="en"}M.isDefault=F})(c||(i.Language=c={})),i.$y=h,i.$z=e,i.$A=b,i.$B=typeof R.postMessage=="function"&&!R.importScripts,i.$C=(()=>{if(i.$B){const M=[];R.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let F=0,B=M.length;F<B;F++){const W=M[F];if(W.id===I.data.vscodeScheduleAsyncWork){M.splice(F,1),W.callback();return}}});let S=0;return I=>{const F=++S;M.push({id:F,callback:I}),R.postMessage({vscodeScheduleAsyncWork:F},"*")}}return M=>setTimeout(M)})();var d;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(d||(i.OperatingSystem=d={})),i.OS=n||u?d.Macintosh:t?d.Windows:d.Linux;let j=!0,N=!1;function p(){if(!N){N=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,j=new Uint16Array(M.buffer)[0]===513}return j}i.$F=!!(i.$w&&i.$w.indexOf("Chrome")>=0),i.$G=!!(i.$w&&i.$w.indexOf("Firefox")>=0),i.$H=!!(!i.$F&&i.$w&&i.$w.indexOf("Safari")>=0),i.$I=!!(i.$w&&i.$w.indexOf("Edg/")>=0),i.$J=!!(i.$w&&i.$w.indexOf("Android")>=0);function D(M){return parseFloat(M)>=20}}),ne(ie[45],re([0,1,13]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$hc=i.$gc=i.env=i.cwd=void 0;let n;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const f=T.process;n={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.$j?"win32":t.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.$gc=n.platform,i.$hc=n.arch});var Ke=this&&this.__createBinding||(Object.create?function(x,i,t,n){n===void 0&&(n=t);var T=Object.getOwnPropertyDescriptor(i,t);(!T||("get"in T?!i.__esModule:T.writable||T.configurable))&&(T={enumerable:!0,get:function(){return i[t]}}),Object.defineProperty(x,n,T)}:function(x,i,t,n){n===void 0&&(n=t),x[n]=i[t]}),Ce=this&&this.__setModuleDefault||(Object.create?function(x,i){Object.defineProperty(x,"default",{enumerable:!0,value:i})}:function(x,i){x.default=i}),Me=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var i={};if(x!=null)for(var t in x)t!=="default"&&Object.prototype.hasOwnProperty.call(x,t)&&Ke(i,x,t);return Ce(i,x),i};ne(ie[25],re([0,1,45]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$wc=i.sep=i.$uc=i.$tc=i.$sc=i.$rc=i.$qc=i.$pc=i.$oc=i.$nc=i.$mc=i.$lc=i.$kc=i.$jc=i.$ic=void 0,t=Me(t);const n=65,T=97,f=90,E=122,g=46,a=47,u=92,o=58,w=63;class h extends Error{constructor(c,d,j){let N;typeof d=="string"&&d.indexOf("not ")===0?(N="must not be",d=d.replace(/^not /,"")):N="must be";const p=c.indexOf(".")!==-1?"property":"argument";let D=`The "${c}" ${p} ${N} of type ${d}`;D+=`. Received type ${typeof j}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function m(s,c){if(s===null||typeof s!="object")throw new h(c,"Object",s)}function e(s,c){if(typeof s!="string")throw new h(c,"string",s)}const b=t.$gc==="win32";function L(s){return s===a||s===u}function R(s){return s===a}function A(s){return s>=n&&s<=f||s>=T&&s<=E}function v(s,c,d,j){let N="",p=0,D=-1,M=0,S=0;for(let I=0;I<=s.length;++I){if(I<s.length)S=s.charCodeAt(I);else{if(j(S))break;S=a}if(j(S)){if(!(D===I-1||M===1))if(M===2){if(N.length<2||p!==2||N.charCodeAt(N.length-1)!==g||N.charCodeAt(N.length-2)!==g){if(N.length>2){const F=N.lastIndexOf(d);F===-1?(N="",p=0):(N=N.slice(0,F),p=N.length-1-N.lastIndexOf(d)),D=I,M=0;continue}else if(N.length!==0){N="",p=0,D=I,M=0;continue}}c&&(N+=N.length>0?`${d}..`:"..",p=2)}else N.length>0?N+=`${d}${s.slice(D+1,I)}`:N=s.slice(D+1,I),p=I-D-1;D=I,M=0}else S===g&&M!==-1?++M:M=-1}return N}function _(s){return s?`${s[0]==="."?"":"."}${s}`:""}function $(s,c){m(c,"pathObject");const d=c.dir||c.root,j=c.base||`${c.name||""}${_(c.ext)}`;return d?d===c.root?`${d}${j}`:`${d}${s}${j}`:j}i.$ic={resolve(...s){let c="",d="",j=!1;for(let N=s.length-1;N>=-1;N--){let p;if(N>=0){if(p=s[N],e(p,`paths[${N}]`),p.length===0)continue}else c.length===0?p=t.cwd():(p=t.env[`=${c}`]||t.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==c.toLowerCase()&&p.charCodeAt(2)===u)&&(p=`${c}\\`));const D=p.length;let M=0,S="",I=!1;const F=p.charCodeAt(0);if(D===1)L(F)&&(M=1,I=!0);else if(L(F))if(I=!0,L(p.charCodeAt(1))){let B=2,W=B;for(;B<D&&!L(p.charCodeAt(B));)B++;if(B<D&&B!==W){const O=p.slice(W,B);for(W=B;B<D&&L(p.charCodeAt(B));)B++;if(B<D&&B!==W){for(W=B;B<D&&!L(p.charCodeAt(B));)B++;(B===D||B!==W)&&(S=`\\\\${O}\\${p.slice(W,B)}`,M=B)}}}else M=1;else A(F)&&p.charCodeAt(1)===o&&(S=p.slice(0,2),M=2,D>2&&L(p.charCodeAt(2))&&(I=!0,M=3));if(S.length>0)if(c.length>0){if(S.toLowerCase()!==c.toLowerCase())continue}else c=S;if(j){if(c.length>0)break}else if(d=`${p.slice(M)}\\${d}`,j=I,I&&c.length>0)break}return d=v(d,!j,"\\",L),j?`${c}\\${d}`:`${c}${d}`||"."},normalize(s){e(s,"path");const c=s.length;if(c===0)return".";let d=0,j,N=!1;const p=s.charCodeAt(0);if(c===1)return R(p)?"\\":s;if(L(p))if(N=!0,L(s.charCodeAt(1))){let M=2,S=M;for(;M<c&&!L(s.charCodeAt(M));)M++;if(M<c&&M!==S){const I=s.slice(S,M);for(S=M;M<c&&L(s.charCodeAt(M));)M++;if(M<c&&M!==S){for(S=M;M<c&&!L(s.charCodeAt(M));)M++;if(M===c)return`\\\\${I}\\${s.slice(S)}\\`;M!==S&&(j=`\\\\${I}\\${s.slice(S,M)}`,d=M)}}}else d=1;else A(p)&&s.charCodeAt(1)===o&&(j=s.slice(0,2),d=2,c>2&&L(s.charCodeAt(2))&&(N=!0,d=3));let D=d<c?v(s.slice(d),!N,"\\",L):"";return D.length===0&&!N&&(D="."),D.length>0&&L(s.charCodeAt(c-1))&&(D+="\\"),j===void 0?N?`\\${D}`:D:N?`${j}\\${D}`:`${j}${D}`},isAbsolute(s){e(s,"path");const c=s.length;if(c===0)return!1;const d=s.charCodeAt(0);return L(d)||c>2&&A(d)&&s.charCodeAt(1)===o&&L(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let c,d;for(let p=0;p<s.length;++p){const D=s[p];e(D,"path"),D.length>0&&(c===void 0?c=d=D:c+=`\\${D}`)}if(c===void 0)return".";let j=!0,N=0;if(typeof d=="string"&&L(d.charCodeAt(0))){++N;const p=d.length;p>1&&L(d.charCodeAt(1))&&(++N,p>2&&(L(d.charCodeAt(2))?++N:j=!1))}if(j){for(;N<c.length&&L(c.charCodeAt(N));)N++;N>=2&&(c=`\\${c.slice(N)}`)}return i.$ic.normalize(c)},relative(s,c){if(e(s,"from"),e(c,"to"),s===c)return"";const d=i.$ic.resolve(s),j=i.$ic.resolve(c);if(d===j||(s=d.toLowerCase(),c=j.toLowerCase(),s===c))return"";let N=0;for(;N<s.length&&s.charCodeAt(N)===u;)N++;let p=s.length;for(;p-1>N&&s.charCodeAt(p-1)===u;)p--;const D=p-N;let M=0;for(;M<c.length&&c.charCodeAt(M)===u;)M++;let S=c.length;for(;S-1>M&&c.charCodeAt(S-1)===u;)S--;const I=S-M,F=D<I?D:I;let B=-1,W=0;for(;W<F;W++){const y=s.charCodeAt(N+W);if(y!==c.charCodeAt(M+W))break;y===u&&(B=W)}if(W!==F){if(B===-1)return j}else{if(I>F){if(c.charCodeAt(M+W)===u)return j.slice(M+W+1);if(W===2)return j.slice(M+W)}D>F&&(s.charCodeAt(N+W)===u?B=W:W===2&&(B=3)),B===-1&&(B=0)}let O="";for(W=N+B+1;W<=p;++W)(W===p||s.charCodeAt(W)===u)&&(O+=O.length===0?"..":"\\..");return M+=B,O.length>0?`${O}${j.slice(M,S)}`:(j.charCodeAt(M)===u&&++M,j.slice(M,S))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const c=i.$ic.resolve(s);if(c.length<=2)return s;if(c.charCodeAt(0)===u){if(c.charCodeAt(1)===u){const d=c.charCodeAt(2);if(d!==w&&d!==g)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(A(c.charCodeAt(0))&&c.charCodeAt(1)===o&&c.charCodeAt(2)===u)return`\\\\?\\${c}`;return s},dirname(s){e(s,"path");const c=s.length;if(c===0)return".";let d=-1,j=0;const N=s.charCodeAt(0);if(c===1)return L(N)?s:".";if(L(N)){if(d=j=1,L(s.charCodeAt(1))){let M=2,S=M;for(;M<c&&!L(s.charCodeAt(M));)M++;if(M<c&&M!==S){for(S=M;M<c&&L(s.charCodeAt(M));)M++;if(M<c&&M!==S){for(S=M;M<c&&!L(s.charCodeAt(M));)M++;if(M===c)return s;M!==S&&(d=j=M+1)}}}}else A(N)&&s.charCodeAt(1)===o&&(d=c>2&&L(s.charCodeAt(2))?3:2,j=d);let p=-1,D=!0;for(let M=c-1;M>=j;--M)if(L(s.charCodeAt(M))){if(!D){p=M;break}}else D=!1;if(p===-1){if(d===-1)return".";p=d}return s.slice(0,p)},basename(s,c){c!==void 0&&e(c,"suffix"),e(s,"path");let d=0,j=-1,N=!0,p;if(s.length>=2&&A(s.charCodeAt(0))&&s.charCodeAt(1)===o&&(d=2),c!==void 0&&c.length>0&&c.length<=s.length){if(c===s)return"";let D=c.length-1,M=-1;for(p=s.length-1;p>=d;--p){const S=s.charCodeAt(p);if(L(S)){if(!N){d=p+1;break}}else M===-1&&(N=!1,M=p+1),D>=0&&(S===c.charCodeAt(D)?--D===-1&&(j=p):(D=-1,j=M))}return d===j?j=M:j===-1&&(j=s.length),s.slice(d,j)}for(p=s.length-1;p>=d;--p)if(L(s.charCodeAt(p))){if(!N){d=p+1;break}}else j===-1&&(N=!1,j=p+1);return j===-1?"":s.slice(d,j)},extname(s){e(s,"path");let c=0,d=-1,j=0,N=-1,p=!0,D=0;s.length>=2&&s.charCodeAt(1)===o&&A(s.charCodeAt(0))&&(c=j=2);for(let M=s.length-1;M>=c;--M){const S=s.charCodeAt(M);if(L(S)){if(!p){j=M+1;break}continue}N===-1&&(p=!1,N=M+1),S===g?d===-1?d=M:D!==1&&(D=1):d!==-1&&(D=-1)}return d===-1||N===-1||D===0||D===1&&d===N-1&&d===j+1?"":s.slice(d,N)},format:$.bind(null,"\\"),parse(s){e(s,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return c;const d=s.length;let j=0,N=s.charCodeAt(0);if(d===1)return L(N)?(c.root=c.dir=s,c):(c.base=c.name=s,c);if(L(N)){if(j=1,L(s.charCodeAt(1))){let B=2,W=B;for(;B<d&&!L(s.charCodeAt(B));)B++;if(B<d&&B!==W){for(W=B;B<d&&L(s.charCodeAt(B));)B++;if(B<d&&B!==W){for(W=B;B<d&&!L(s.charCodeAt(B));)B++;B===d?j=B:B!==W&&(j=B+1)}}}}else if(A(N)&&s.charCodeAt(1)===o){if(d<=2)return c.root=c.dir=s,c;if(j=2,L(s.charCodeAt(2))){if(d===3)return c.root=c.dir=s,c;j=3}}j>0&&(c.root=s.slice(0,j));let p=-1,D=j,M=-1,S=!0,I=s.length-1,F=0;for(;I>=j;--I){if(N=s.charCodeAt(I),L(N)){if(!S){D=I+1;break}continue}M===-1&&(S=!1,M=I+1),N===g?p===-1?p=I:F!==1&&(F=1):p!==-1&&(F=-1)}return M!==-1&&(p===-1||F===0||F===1&&p===M-1&&p===D+1?c.base=c.name=s.slice(D,M):(c.name=s.slice(D,p),c.base=s.slice(D,M),c.ext=s.slice(p,M))),D>0&&D!==j?c.dir=s.slice(0,D-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(b){const s=/\\/g;return()=>{const c=t.cwd().replace(s,"/");return c.slice(c.indexOf("/"))}}return()=>t.cwd()})();i.$jc={resolve(...s){let c="",d=!1;for(let j=s.length-1;j>=-1&&!d;j--){const N=j>=0?s[j]:l();e(N,`paths[${j}]`),N.length!==0&&(c=`${N}/${c}`,d=N.charCodeAt(0)===a)}return c=v(c,!d,"/",R),d?`/${c}`:c.length>0?c:"."},normalize(s){if(e(s,"path"),s.length===0)return".";const c=s.charCodeAt(0)===a,d=s.charCodeAt(s.length-1)===a;return s=v(s,!c,"/",R),s.length===0?c?"/":d?"./":".":(d&&(s+="/"),c?`/${s}`:s)},isAbsolute(s){return e(s,"path"),s.length>0&&s.charCodeAt(0)===a},join(...s){if(s.length===0)return".";let c;for(let d=0;d<s.length;++d){const j=s[d];e(j,"path"),j.length>0&&(c===void 0?c=j:c+=`/${j}`)}return c===void 0?".":i.$jc.normalize(c)},relative(s,c){if(e(s,"from"),e(c,"to"),s===c||(s=i.$jc.resolve(s),c=i.$jc.resolve(c),s===c))return"";const d=1,j=s.length,N=j-d,p=1,D=c.length-p,M=N<D?N:D;let S=-1,I=0;for(;I<M;I++){const B=s.charCodeAt(d+I);if(B!==c.charCodeAt(p+I))break;B===a&&(S=I)}if(I===M)if(D>M){if(c.charCodeAt(p+I)===a)return c.slice(p+I+1);if(I===0)return c.slice(p+I)}else N>M&&(s.charCodeAt(d+I)===a?S=I:I===0&&(S=0));let F="";for(I=d+S+1;I<=j;++I)(I===j||s.charCodeAt(I)===a)&&(F+=F.length===0?"..":"/..");return`${F}${c.slice(p+S)}`},toNamespacedPath(s){return s},dirname(s){if(e(s,"path"),s.length===0)return".";const c=s.charCodeAt(0)===a;let d=-1,j=!0;for(let N=s.length-1;N>=1;--N)if(s.charCodeAt(N)===a){if(!j){d=N;break}}else j=!1;return d===-1?c?"/":".":c&&d===1?"//":s.slice(0,d)},basename(s,c){c!==void 0&&e(c,"ext"),e(s,"path");let d=0,j=-1,N=!0,p;if(c!==void 0&&c.length>0&&c.length<=s.length){if(c===s)return"";let D=c.length-1,M=-1;for(p=s.length-1;p>=0;--p){const S=s.charCodeAt(p);if(S===a){if(!N){d=p+1;break}}else M===-1&&(N=!1,M=p+1),D>=0&&(S===c.charCodeAt(D)?--D===-1&&(j=p):(D=-1,j=M))}return d===j?j=M:j===-1&&(j=s.length),s.slice(d,j)}for(p=s.length-1;p>=0;--p)if(s.charCodeAt(p)===a){if(!N){d=p+1;break}}else j===-1&&(N=!1,j=p+1);return j===-1?"":s.slice(d,j)},extname(s){e(s,"path");let c=-1,d=0,j=-1,N=!0,p=0;for(let D=s.length-1;D>=0;--D){const M=s.charCodeAt(D);if(M===a){if(!N){d=D+1;break}continue}j===-1&&(N=!1,j=D+1),M===g?c===-1?c=D:p!==1&&(p=1):c!==-1&&(p=-1)}return c===-1||j===-1||p===0||p===1&&c===j-1&&c===d+1?"":s.slice(c,j)},format:$.bind(null,"/"),parse(s){e(s,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return c;const d=s.charCodeAt(0)===a;let j;d?(c.root="/",j=1):j=0;let N=-1,p=0,D=-1,M=!0,S=s.length-1,I=0;for(;S>=j;--S){const F=s.charCodeAt(S);if(F===a){if(!M){p=S+1;break}continue}D===-1&&(M=!1,D=S+1),F===g?N===-1?N=S:I!==1&&(I=1):N!==-1&&(I=-1)}if(D!==-1){const F=p===0&&d?1:p;N===-1||I===0||I===1&&N===D-1&&N===p+1?c.base=c.name=s.slice(F,D):(c.name=s.slice(F,N),c.base=s.slice(F,D),c.ext=s.slice(N,D))}return p>0?c.dir=s.slice(0,p-1):d&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},i.$jc.win32=i.$ic.win32=i.$ic,i.$jc.posix=i.$ic.posix=i.$jc,i.$kc=b?i.$ic.normalize:i.$jc.normalize,i.$lc=b?i.$ic.isAbsolute:i.$jc.isAbsolute,i.$mc=b?i.$ic.join:i.$jc.join,i.$nc=b?i.$ic.resolve:i.$jc.resolve,i.$oc=b?i.$ic.relative:i.$jc.relative,i.$pc=b?i.$ic.dirname:i.$jc.dirname,i.$qc=b?i.$ic.basename:i.$jc.basename,i.$rc=b?i.$ic.extname:i.$jc.extname,i.$sc=b?i.$ic.format:i.$jc.format,i.$tc=b?i.$ic.parse:i.$jc.parse,i.$uc=b?i.$ic.toNamespacedPath:i.$jc.toNamespacedPath,i.sep=b?i.$ic.sep:i.$jc.sep,i.$wc=b?i.$ic.delimiter:i.$jc.delimiter}),ne(ie[26],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ie=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(f){return new n(f)}constructor(f){this.c=t&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}i.$ie=n}),ne(ie[14],re([0,1,3,22,12,24,26]),function(x,i,t,n,T,f,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ye=i.$xe=i.$we=i.$ve=i.$ue=i.$te=i.$se=i.$re=i.$qe=i.$pe=i.$oe=i.$ne=i.$me=i.$ke=i.Event=void 0,i.$le=m;const g=!1,a=!1,u=!1;var o;(function(O){O.None=()=>T.$Xc.None;function y(ue){if(u){const{onDidAddListener:te}=ue,le=b.create();let se=0;ue.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),te?.()}}}function X(ue,te){return Te(ue,()=>{},0,void 0,!0,void 0,te)}O.defer=X;function Z(ue){return(te,le=null,se)=>{let fe=!1,me;return me=ue($e=>{if(!fe)return me?me.dispose():fe=!0,te.call(le,$e)},null,se),fe&&me.dispose(),me}}O.once=Z;function Y(ue,te){return O.once(O.filter(ue,te))}O.onceIf=Y;function Q(ue,te,le){return we((se,fe=null,me)=>ue($e=>se.call(fe,te($e)),null,me),le)}O.map=Q;function C(ue,te,le){return we((se,fe=null,me)=>ue($e=>{te($e),se.call(fe,$e)},null,me),le)}O.forEach=C;function k(ue,te,le){return we((se,fe=null,me)=>ue($e=>te($e)&&se.call(fe,$e),null,me),le)}O.filter=k;function G(ue){return ue}O.signal=G;function oe(...ue){return(te,le=null,se)=>{const fe=(0,T.$Uc)(...ue.map(me=>me($e=>te.call(le,$e))));return r(fe,se)}}O.any=oe;function ce(ue,te,le,se){let fe=le;return Q(ue,me=>(fe=te(fe,me),fe),se)}O.reduce=ce;function we(ue,te){let le;const se={onWillAddFirstListener(){le=ue(fe.fire,fe)},onDidRemoveLastListener(){le?.dispose()}};te||y(se);const fe=new s(se);return te?.add(fe),fe.event}function r(ue,te){return te instanceof Array?te.push(ue):te&&te.add(ue),ue}function Te(ue,te,le=100,se=!1,fe=!1,me,$e){let Ee,Ae,ge,De=0,qe;const ze={leakWarningThreshold:me,onWillAddFirstListener(){Ee=ue(Ye=>{De++,Ae=te(Ae,Ye),se&&!ge&&(Ue.fire(Ae),Ae=void 0),qe=()=>{const xe=Ae;Ae=void 0,ge=void 0,(!se||De>1)&&Ue.fire(xe),De=0},typeof le=="number"?(clearTimeout(ge),ge=setTimeout(qe,le)):ge===void 0&&(ge=0,queueMicrotask(qe))})},onWillRemoveListener(){fe&&De>0&&qe?.()},onDidRemoveLastListener(){qe=void 0,Ee.dispose()}};$e||y(ze);const Ue=new s(ze);return $e?.add(Ue),Ue.event}O.debounce=Te;function Pe(ue,te=0,le){return O.debounce(ue,(se,fe)=>se?(se.push(fe),se):[fe],te,void 0,!0,void 0,le)}O.accumulate=Pe;function He(ue,te=(se,fe)=>se===fe,le){let se=!0,fe;return k(ue,me=>{const $e=se||!te(me,fe);return se=!1,fe=me,$e},le)}O.latch=He;function Fe(ue,te,le){return[O.filter(ue,te,le),O.filter(ue,se=>!te(se),le)]}O.split=Fe;function Be(ue,te=!1,le=[],se){let fe=le.slice(),me=ue(Ae=>{fe?fe.push(Ae):Ee.fire(Ae)});se&&se.add(me);const $e=()=>{fe?.forEach(Ae=>Ee.fire(Ae)),fe=null},Ee=new s({onWillAddFirstListener(){me||(me=ue(Ae=>Ee.fire(Ae)),se&&se.add(me))},onDidAddFirstListener(){fe&&(te?setTimeout($e):$e())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return se&&se.add(Ee),Ee.event}O.buffer=Be;function Ge(ue,te){return(se,fe,me)=>{const $e=te(new H);return ue(function(Ee){const Ae=$e.evaluate(Ee);Ae!==U&&se.call(fe,Ae)},void 0,me)}}O.chain=Ge;const U=Symbol("HaltChainable");class H{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(le=>(te(le),le)),this}filter(te){return this.f.push(le=>te(le)?le:U),this}reduce(te,le){let se=le;return this.f.push(fe=>(se=te(se,fe),se)),this}latch(te=(le,se)=>le===se){let le=!0,se;return this.f.push(fe=>{const me=le||!te(fe,se);return le=!1,se=fe,me?fe:U}),this}evaluate(te){for(const le of this.f)if(te=le(te),te===U)break;return te}}function V(ue,te,le=se=>se){const se=(...Ee)=>$e.fire(le(...Ee)),fe=()=>ue.on(te,se),me=()=>ue.removeListener(te,se),$e=new s({onWillAddFirstListener:fe,onDidRemoveLastListener:me});return $e.event}O.fromNodeEventEmitter=V;function J(ue,te,le=se=>se){const se=(...Ee)=>$e.fire(le(...Ee)),fe=()=>ue.addEventListener(te,se),me=()=>ue.removeEventListener(te,se),$e=new s({onWillAddFirstListener:fe,onDidRemoveLastListener:me});return $e.event}O.fromDOMEventEmitter=J;function ee(ue){return new Promise(te=>Z(ue)(te))}O.toPromise=ee;function he(ue){const te=new s;return ue.then(le=>{te.fire(le)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}O.fromPromise=he;function de(ue,te){return ue(le=>te.fire(le))}O.forward=de;function Ne(ue,te,le){return te(le),ue(se=>te(se))}O.runAndSubscribe=Ne;class ve{constructor(te,le){this._observable=te,this.f=0,this.g=!1;const se={onWillAddFirstListener:()=>{te.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{te.removeObserver(this)}};le||y(se),this.emitter=new s(se),le&&le.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,le){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _e(ue,te){return new ve(ue,te).emitter.event}O.fromObservable=_e;function je(ue){return(te,le,se)=>{let fe=0,me=!1;const $e={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(ue.reportChanges(),me&&(me=!1,te.call(le)))},handlePossibleChange(){},handleChange(){me=!0}};ue.addObserver($e),ue.reportChanges();const Ee={dispose(){ue.removeObserver($e)}};return se instanceof T.$Wc?se.add(Ee):Array.isArray(se)&&se.push(Ee),Ee}}O.fromObservableLight=je})(o||(i.Event=o={}));class w{static{this.all=new Set}static{this.f=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${w.f++}`,w.all.add(this)}start(y){this.g=new E.$ie,this.listenerCount=y}stop(){if(this.g){const y=this.g.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this.g=void 0}}}i.$ke=w;let h=-1;function m(O){const y=h;return h=O,{dispose(){h=y}}}class e{static{this.f=1}constructor(y,X,Z=(e.f++).toString(16).padStart(3,"0")){this.j=y,this.threshold=X,this.name=Z,this.h=0}dispose(){this.g?.clear()}check(y,X){const Z=this.threshold;if(Z<=0||X<Z)return;this.g||(this.g=new Map);const Y=this.g.get(y.value)||0;if(this.g.set(y.value,Y+1),this.h-=1,this.h<=0){this.h=Z*.5;const[Q,C]=this.getMostFrequentStack(),k=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${C}):`;console.warn(k),console.warn(Q);const G=new L(k,Q);this.j(G)}return()=>{const Q=this.g.get(y.value)||0;this.g.set(y.value,Q-1)}}getMostFrequentStack(){if(!this.g)return;let y,X=0;for(const[Z,Y]of this.g)(!y||X<Y)&&(y=[Z,Y],X=Y);return y}}class b{static create(){const y=new Error;return new b(y.stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class L extends Error{constructor(y,X){super(y),this.name="ListenerLeakError",this.stack=X}}i.$me=L;class R extends Error{constructor(y,X){super(y),this.name="ListenerRefusalError",this.stack=X}}i.$ne=R;let A=0;class v{constructor(y){this.value=y,this.id=A++}}const _=2,$=(O,y)=>{if(O instanceof v)y(O);else for(let X=0;X<O.length;X++){const Z=O[X];Z&&y(Z)}};let l;if(g){const O=[];setInterval(()=>{O.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(O.join(`
`)),O.length=0)},3e3),l=new FinalizationRegistry(y=>{typeof y=="string"&&O.push(y)})}class s{constructor(y){this.z=0,this.f=y,this.g=h>0||this.f?.leakWarningThreshold?new e(y?.onListenerError??t.$2,this.f?.leakWarningThreshold??h):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(a){const y=this.u;queueMicrotask(()=>{$(y,X=>X.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(y,X,Z)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const oe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ce=new R(`${G}. HINT: Stack shows most frequent listener (${oe[1]}-times)`,oe[0]);return(this.f?.onListenerError||t.$2)(ce),T.$Xc.None}if(this.m)return T.$Xc.None;X&&(y=y.bind(X));const Y=new v(y);let Q,C;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Y.stack=b.create(),Q=this.g.check(Y.stack,this.z+1)),a&&(Y.stack=C??b.create()),this.u?this.u instanceof v?(this.w??=new d,this.u=[this.u,Y]):this.u.push(Y):(this.f?.onWillAddFirstListener?.(this),this.u=Y,this.f?.onDidAddFirstListener?.(this)),this.z++;const k=(0,T.$Vc)(()=>{l?.unregister(k),Q?.(),this.A(Y)});if(Z instanceof T.$Wc?Z.add(k):Array.isArray(Z)&&Z.push(k),l){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),oe=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);l.register(k,oe?.[2]??G,k)}return k},this.q}A(y){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const X=this.u,Z=X.indexOf(y);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,X[Z]=void 0;const Y=this.w.current===this;if(this.z*_<=X.length){let Q=0;for(let C=0;C<X.length;C++)X[C]?X[Q++]=X[C]:Y&&(this.w.end--,Q<this.w.i&&this.w.i--);X.length=Q}}B(y,X){if(!y)return;const Z=this.f?.onListenerError||t.$2;if(!Z){y.value(X);return}try{y.value(X)}catch(Y){Z(Y)}}C(y){const X=y.current.u;for(;y.i<y.end;)this.B(X[y.i++],y.value);y.reset()}fire(y){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof v)this.B(this.u,y);else{const X=this.w;X.enqueue(this,y,this.u.length),this.C(X)}this.j?.stop()}hasListeners(){return this.z>0}}i.$oe=s;const c=()=>new d;i.$pe=c;class d{constructor(){this.i=-1,this.end=0}enqueue(y,X,Z){this.i=0,this.end=Z,this.current=y,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class j extends s{async fireAsync(y,X,Z){if(this.u)for(this.h||(this.h=new f.$8c),$(this.u,Y=>this.h.push([Y.value,y]));this.h.size>0&&!X.isCancellationRequested;){const[Y,Q]=this.h.shift(),C=[],k={...Q,token:X,waitUntil:G=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");Z&&(G=Z(G,Y)),C.push(G)}};try{Y(k)}catch(G){(0,t.$2)(G);continue}Object.freeze(C),await Promise.allSettled(C).then(G=>{for(const oe of G)oe.status==="rejected"&&(0,t.$2)(oe.reason)})}}}i.$qe=j;class N extends s{get isPaused(){return this.h!==0}constructor(y){super(y),this.h=0,this.s=new f.$8c,this.t=y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const y=Array.from(this.s);this.s.clear(),super.fire(this.t(y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(y){this.z&&(this.h!==0?this.s.push(y):super.fire(y))}}i.$re=N;class p extends N{constructor(y){super(y),this.k=y.delay??100}fire(y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(y)}}i.$se=p;class D extends s{constructor(y){super(y),this.h=[],this.k=y?.merge}fire(y){this.hasListeners()&&(this.h.push(y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(X=>super.fire(X)),this.h=[]}))}}i.$te=D;class M{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(y){const X={event:y,listener:null};this.h.push(X),this.g&&this.m(X);const Z=()=>{this.g&&this.o(X);const Y=this.h.indexOf(X);this.h.splice(Y,1)};return(0,T.$Vc)((0,n.$fb)(Z))}j(){this.g=!0,this.h.forEach(y=>this.m(y))}k(){this.g=!1,this.h.forEach(y=>this.o(y))}m(y){y.listener=y.event(X=>this.f.fire(X))}o(y){y.listener?.dispose(),y.listener=null}dispose(){this.f.dispose();for(const y of this.h)y.listener?.dispose();this.h=[]}}i.$ue=M;class S{constructor(y,X,Z,Y){this.f=new T.$Wc;const Q=this.f.add(new M),C=this.f.add(new T.$7c);function k(G){C.set(G,Q.add(Y(G)))}for(const G of y)k(G);this.f.add(X(G=>{k(G)})),this.f.add(Z(G=>{C.deleteAndDispose(G)})),this.event=Q.event}dispose(){this.f.dispose()}}i.$ve=S;class I{constructor(){this.f=[]}wrapEvent(y,X,Z){return(Y,Q,C)=>y(k=>{const G=this.f[this.f.length-1];if(!X){G?G.buffers.push(()=>Y.call(Q,k)):Y.call(Q,k);return}const oe=G;if(!oe){Y.call(Q,X(Z,k));return}oe.items??=[],oe.items.push(k),oe.buffers.length===0&&G.buffers.push(()=>{oe.reducedResult??=Z?oe.items.reduce(X,Z):oe.items.reduce(X),Y.call(Q,oe.reducedResult)})},void 0,C)}bufferEvents(y){const X={buffers:new Array};this.f.push(X);const Z=y();return this.f.pop(),X.buffers.forEach(Y=>Y()),Z}}i.$we=I;class F{constructor(){this.f=!1,this.g=o.None,this.h=T.$Xc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(y){this.g=y,this.f&&(this.h.dispose(),this.h=y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}i.$xe=F;class B{static const(y){return new W(y)}constructor(y){this.g=y,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(y){y!==this.g&&(this.g=y,this.f.fire(void 0))}}i.$ye=B;class W{constructor(y){this.value=y,this.onDidChange=o.None}}}),ne(ie[27],re([0,1,14]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ze=i.CancellationToken=void 0,i.$Ae=g;const n=Object.freeze(function(a,u){const o=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(o)}}});var T;(function(a){function u(o){return o===a.None||o===a.Cancelled||o instanceof f?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(T||(i.CancellationToken=T={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new t.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=T.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=T.None}}i.$ze=E;function g(a){const u=new E;return a.add({dispose(){u.cancel()}}),u.token}}),ne(ie[46],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cf=i.$bf=i.$_e=void 0,i.$af=T;class n{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new t.$ze,u=this.b(a.token);return this.a={promise:u,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}i.$_e=n;function T(g){return g}class f{constructor(a,u){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=T):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);return this.b!==u&&(this.b=u,this.a=this.c(a)),this.a}}i.$bf=f;class E{get cachedValues(){return this.a}constructor(a,u){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=T):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);if(this.b.has(u))return this.b.get(u);const o=this.c(a);return this.a.set(a,o),this.b.set(u,o),o}}i.$cf=E}),ne(ie[28],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$hg=t,i.$ig=n,i.$jg=T,i.$kg=f,i.$lg=E,i.$mg=g,i.$ng=a,i.$og=u,i.$pg=o,i.$qg=w,i.$rg=h,i.$sg=m,i.$tg=e,i.$ug=L,i.$vg=R,i.$wg=A,i.$xg=v,i.$yg=_,i.$zg=$;function t(l){return typeof l=="string"}function n(l){return Array.isArray(l)&&l.every(s=>t(s))}function T(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function f(l){const s=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof s}function E(l){return typeof l=="number"&&!isNaN(l)}function g(l){return!!l&&typeof l[Symbol.iterator]=="function"}function a(l){return l===!0||l===!1}function u(l){return typeof l>"u"}function o(l){return!w(l)}function w(l){return u(l)||l===null}function h(l,s){if(!l)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}function m(l){if(w(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const s=[];for(let c=0;c<l.length;c++){const d=l[c];if(w(d))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);s.push(d)}return s}const b=Object.prototype.hasOwnProperty;function L(l){if(!T(l))return!1;for(const s in l)if(b.call(l,s))return!1;return!0}function R(l){return typeof l=="function"}function A(...l){return l.length>0&&l.every(R)}function v(l,s){const c=Math.min(l.length,s.length);for(let d=0;d<c;d++)_(l[d],s[d])}function _(l,s){if(t(s)){if(typeof l!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(R(s)){try{if(l instanceof s)return}catch{}if(!w(l)&&l.constructor===s||s.length===1&&s.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function $(l){return l}}),ne(ie[29],re([0,1,28]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$3j=T,i.$4j=f;const n=Object.create(null);function T(E,g){if((0,t.$hg)(g)){const a=n[g];if(a===void 0)throw new Error(`${E} references an unknown codicon: ${g}`);g=a}return n[E]=g,{id:E}}function f(){return n}}),ne(ie[47],re([0,1,29]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$5j=void 0,i.$5j={add:(0,t.$3j)("add",6e4),plus:(0,t.$3j)("plus",6e4),gistNew:(0,t.$3j)("gist-new",6e4),repoCreate:(0,t.$3j)("repo-create",6e4),lightbulb:(0,t.$3j)("lightbulb",60001),lightBulb:(0,t.$3j)("light-bulb",60001),repo:(0,t.$3j)("repo",60002),repoDelete:(0,t.$3j)("repo-delete",60002),gistFork:(0,t.$3j)("gist-fork",60003),repoForked:(0,t.$3j)("repo-forked",60003),gitPullRequest:(0,t.$3j)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$3j)("git-pull-request-abandoned",60004),recordKeys:(0,t.$3j)("record-keys",60005),keyboard:(0,t.$3j)("keyboard",60005),tag:(0,t.$3j)("tag",60006),gitPullRequestLabel:(0,t.$3j)("git-pull-request-label",60006),tagAdd:(0,t.$3j)("tag-add",60006),tagRemove:(0,t.$3j)("tag-remove",60006),person:(0,t.$3j)("person",60007),personFollow:(0,t.$3j)("person-follow",60007),personOutline:(0,t.$3j)("person-outline",60007),personFilled:(0,t.$3j)("person-filled",60007),gitBranch:(0,t.$3j)("git-branch",60008),gitBranchCreate:(0,t.$3j)("git-branch-create",60008),gitBranchDelete:(0,t.$3j)("git-branch-delete",60008),sourceControl:(0,t.$3j)("source-control",60008),mirror:(0,t.$3j)("mirror",60009),mirrorPublic:(0,t.$3j)("mirror-public",60009),star:(0,t.$3j)("star",60010),starAdd:(0,t.$3j)("star-add",60010),starDelete:(0,t.$3j)("star-delete",60010),starEmpty:(0,t.$3j)("star-empty",60010),comment:(0,t.$3j)("comment",60011),commentAdd:(0,t.$3j)("comment-add",60011),alert:(0,t.$3j)("alert",60012),warning:(0,t.$3j)("warning",60012),search:(0,t.$3j)("search",60013),searchSave:(0,t.$3j)("search-save",60013),logOut:(0,t.$3j)("log-out",60014),signOut:(0,t.$3j)("sign-out",60014),logIn:(0,t.$3j)("log-in",60015),signIn:(0,t.$3j)("sign-in",60015),eye:(0,t.$3j)("eye",60016),eyeUnwatch:(0,t.$3j)("eye-unwatch",60016),eyeWatch:(0,t.$3j)("eye-watch",60016),circleFilled:(0,t.$3j)("circle-filled",60017),primitiveDot:(0,t.$3j)("primitive-dot",60017),closeDirty:(0,t.$3j)("close-dirty",60017),debugBreakpoint:(0,t.$3j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$3j)("debug-breakpoint-disabled",60017),debugHint:(0,t.$3j)("debug-hint",60017),terminalDecorationSuccess:(0,t.$3j)("terminal-decoration-success",60017),primitiveSquare:(0,t.$3j)("primitive-square",60018),edit:(0,t.$3j)("edit",60019),pencil:(0,t.$3j)("pencil",60019),info:(0,t.$3j)("info",60020),issueOpened:(0,t.$3j)("issue-opened",60020),gistPrivate:(0,t.$3j)("gist-private",60021),gitForkPrivate:(0,t.$3j)("git-fork-private",60021),lock:(0,t.$3j)("lock",60021),mirrorPrivate:(0,t.$3j)("mirror-private",60021),close:(0,t.$3j)("close",60022),removeClose:(0,t.$3j)("remove-close",60022),x:(0,t.$3j)("x",60022),repoSync:(0,t.$3j)("repo-sync",60023),sync:(0,t.$3j)("sync",60023),clone:(0,t.$3j)("clone",60024),desktopDownload:(0,t.$3j)("desktop-download",60024),beaker:(0,t.$3j)("beaker",60025),microscope:(0,t.$3j)("microscope",60025),vm:(0,t.$3j)("vm",60026),deviceDesktop:(0,t.$3j)("device-desktop",60026),file:(0,t.$3j)("file",60027),fileText:(0,t.$3j)("file-text",60027),more:(0,t.$3j)("more",60028),ellipsis:(0,t.$3j)("ellipsis",60028),kebabHorizontal:(0,t.$3j)("kebab-horizontal",60028),mailReply:(0,t.$3j)("mail-reply",60029),reply:(0,t.$3j)("reply",60029),organization:(0,t.$3j)("organization",60030),organizationFilled:(0,t.$3j)("organization-filled",60030),organizationOutline:(0,t.$3j)("organization-outline",60030),newFile:(0,t.$3j)("new-file",60031),fileAdd:(0,t.$3j)("file-add",60031),newFolder:(0,t.$3j)("new-folder",60032),fileDirectoryCreate:(0,t.$3j)("file-directory-create",60032),trash:(0,t.$3j)("trash",60033),trashcan:(0,t.$3j)("trashcan",60033),history:(0,t.$3j)("history",60034),clock:(0,t.$3j)("clock",60034),folder:(0,t.$3j)("folder",60035),fileDirectory:(0,t.$3j)("file-directory",60035),symbolFolder:(0,t.$3j)("symbol-folder",60035),logoGithub:(0,t.$3j)("logo-github",60036),markGithub:(0,t.$3j)("mark-github",60036),github:(0,t.$3j)("github",60036),terminal:(0,t.$3j)("terminal",60037),console:(0,t.$3j)("console",60037),repl:(0,t.$3j)("repl",60037),zap:(0,t.$3j)("zap",60038),symbolEvent:(0,t.$3j)("symbol-event",60038),error:(0,t.$3j)("error",60039),stop:(0,t.$3j)("stop",60039),variable:(0,t.$3j)("variable",60040),symbolVariable:(0,t.$3j)("symbol-variable",60040),array:(0,t.$3j)("array",60042),symbolArray:(0,t.$3j)("symbol-array",60042),symbolModule:(0,t.$3j)("symbol-module",60043),symbolPackage:(0,t.$3j)("symbol-package",60043),symbolNamespace:(0,t.$3j)("symbol-namespace",60043),symbolObject:(0,t.$3j)("symbol-object",60043),symbolMethod:(0,t.$3j)("symbol-method",60044),symbolFunction:(0,t.$3j)("symbol-function",60044),symbolConstructor:(0,t.$3j)("symbol-constructor",60044),symbolBoolean:(0,t.$3j)("symbol-boolean",60047),symbolNull:(0,t.$3j)("symbol-null",60047),symbolNumeric:(0,t.$3j)("symbol-numeric",60048),symbolNumber:(0,t.$3j)("symbol-number",60048),symbolStructure:(0,t.$3j)("symbol-structure",60049),symbolStruct:(0,t.$3j)("symbol-struct",60049),symbolParameter:(0,t.$3j)("symbol-parameter",60050),symbolTypeParameter:(0,t.$3j)("symbol-type-parameter",60050),symbolKey:(0,t.$3j)("symbol-key",60051),symbolText:(0,t.$3j)("symbol-text",60051),symbolReference:(0,t.$3j)("symbol-reference",60052),goToFile:(0,t.$3j)("go-to-file",60052),symbolEnum:(0,t.$3j)("symbol-enum",60053),symbolValue:(0,t.$3j)("symbol-value",60053),symbolRuler:(0,t.$3j)("symbol-ruler",60054),symbolUnit:(0,t.$3j)("symbol-unit",60054),activateBreakpoints:(0,t.$3j)("activate-breakpoints",60055),archive:(0,t.$3j)("archive",60056),arrowBoth:(0,t.$3j)("arrow-both",60057),arrowDown:(0,t.$3j)("arrow-down",60058),arrowLeft:(0,t.$3j)("arrow-left",60059),arrowRight:(0,t.$3j)("arrow-right",60060),arrowSmallDown:(0,t.$3j)("arrow-small-down",60061),arrowSmallLeft:(0,t.$3j)("arrow-small-left",60062),arrowSmallRight:(0,t.$3j)("arrow-small-right",60063),arrowSmallUp:(0,t.$3j)("arrow-small-up",60064),arrowUp:(0,t.$3j)("arrow-up",60065),bell:(0,t.$3j)("bell",60066),bold:(0,t.$3j)("bold",60067),book:(0,t.$3j)("book",60068),bookmark:(0,t.$3j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$3j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$3j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$3j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$3j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$3j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$3j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$3j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$3j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$3j)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$3j)("briefcase",60076),broadcast:(0,t.$3j)("broadcast",60077),browser:(0,t.$3j)("browser",60078),bug:(0,t.$3j)("bug",60079),calendar:(0,t.$3j)("calendar",60080),caseSensitive:(0,t.$3j)("case-sensitive",60081),check:(0,t.$3j)("check",60082),checklist:(0,t.$3j)("checklist",60083),chevronDown:(0,t.$3j)("chevron-down",60084),chevronLeft:(0,t.$3j)("chevron-left",60085),chevronRight:(0,t.$3j)("chevron-right",60086),chevronUp:(0,t.$3j)("chevron-up",60087),chromeClose:(0,t.$3j)("chrome-close",60088),chromeMaximize:(0,t.$3j)("chrome-maximize",60089),chromeMinimize:(0,t.$3j)("chrome-minimize",60090),chromeRestore:(0,t.$3j)("chrome-restore",60091),circleOutline:(0,t.$3j)("circle-outline",60092),circle:(0,t.$3j)("circle",60092),debugBreakpointUnverified:(0,t.$3j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$3j)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$3j)("circle-slash",60093),circuitBoard:(0,t.$3j)("circuit-board",60094),clearAll:(0,t.$3j)("clear-all",60095),clippy:(0,t.$3j)("clippy",60096),closeAll:(0,t.$3j)("close-all",60097),cloudDownload:(0,t.$3j)("cloud-download",60098),cloudUpload:(0,t.$3j)("cloud-upload",60099),code:(0,t.$3j)("code",60100),collapseAll:(0,t.$3j)("collapse-all",60101),colorMode:(0,t.$3j)("color-mode",60102),commentDiscussion:(0,t.$3j)("comment-discussion",60103),creditCard:(0,t.$3j)("credit-card",60105),dash:(0,t.$3j)("dash",60108),dashboard:(0,t.$3j)("dashboard",60109),database:(0,t.$3j)("database",60110),debugContinue:(0,t.$3j)("debug-continue",60111),debugDisconnect:(0,t.$3j)("debug-disconnect",60112),debugPause:(0,t.$3j)("debug-pause",60113),debugRestart:(0,t.$3j)("debug-restart",60114),debugStart:(0,t.$3j)("debug-start",60115),debugStepInto:(0,t.$3j)("debug-step-into",60116),debugStepOut:(0,t.$3j)("debug-step-out",60117),debugStepOver:(0,t.$3j)("debug-step-over",60118),debugStop:(0,t.$3j)("debug-stop",60119),debug:(0,t.$3j)("debug",60120),deviceCameraVideo:(0,t.$3j)("device-camera-video",60121),deviceCamera:(0,t.$3j)("device-camera",60122),deviceMobile:(0,t.$3j)("device-mobile",60123),diffAdded:(0,t.$3j)("diff-added",60124),diffIgnored:(0,t.$3j)("diff-ignored",60125),diffModified:(0,t.$3j)("diff-modified",60126),diffRemoved:(0,t.$3j)("diff-removed",60127),diffRenamed:(0,t.$3j)("diff-renamed",60128),diff:(0,t.$3j)("diff",60129),diffSidebyside:(0,t.$3j)("diff-sidebyside",60129),discard:(0,t.$3j)("discard",60130),editorLayout:(0,t.$3j)("editor-layout",60131),emptyWindow:(0,t.$3j)("empty-window",60132),exclude:(0,t.$3j)("exclude",60133),extensions:(0,t.$3j)("extensions",60134),eyeClosed:(0,t.$3j)("eye-closed",60135),fileBinary:(0,t.$3j)("file-binary",60136),fileCode:(0,t.$3j)("file-code",60137),fileMedia:(0,t.$3j)("file-media",60138),filePdf:(0,t.$3j)("file-pdf",60139),fileSubmodule:(0,t.$3j)("file-submodule",60140),fileSymlinkDirectory:(0,t.$3j)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$3j)("file-symlink-file",60142),fileZip:(0,t.$3j)("file-zip",60143),files:(0,t.$3j)("files",60144),filter:(0,t.$3j)("filter",60145),flame:(0,t.$3j)("flame",60146),foldDown:(0,t.$3j)("fold-down",60147),foldUp:(0,t.$3j)("fold-up",60148),fold:(0,t.$3j)("fold",60149),folderActive:(0,t.$3j)("folder-active",60150),folderOpened:(0,t.$3j)("folder-opened",60151),gear:(0,t.$3j)("gear",60152),gift:(0,t.$3j)("gift",60153),gistSecret:(0,t.$3j)("gist-secret",60154),gist:(0,t.$3j)("gist",60155),gitCommit:(0,t.$3j)("git-commit",60156),gitCompare:(0,t.$3j)("git-compare",60157),compareChanges:(0,t.$3j)("compare-changes",60157),gitMerge:(0,t.$3j)("git-merge",60158),githubAction:(0,t.$3j)("github-action",60159),githubAlt:(0,t.$3j)("github-alt",60160),globe:(0,t.$3j)("globe",60161),grabber:(0,t.$3j)("grabber",60162),graph:(0,t.$3j)("graph",60163),gripper:(0,t.$3j)("gripper",60164),heart:(0,t.$3j)("heart",60165),home:(0,t.$3j)("home",60166),horizontalRule:(0,t.$3j)("horizontal-rule",60167),hubot:(0,t.$3j)("hubot",60168),inbox:(0,t.$3j)("inbox",60169),issueReopened:(0,t.$3j)("issue-reopened",60171),issues:(0,t.$3j)("issues",60172),italic:(0,t.$3j)("italic",60173),jersey:(0,t.$3j)("jersey",60174),json:(0,t.$3j)("json",60175),kebabVertical:(0,t.$3j)("kebab-vertical",60176),key:(0,t.$3j)("key",60177),law:(0,t.$3j)("law",60178),lightbulbAutofix:(0,t.$3j)("lightbulb-autofix",60179),linkExternal:(0,t.$3j)("link-external",60180),link:(0,t.$3j)("link",60181),listOrdered:(0,t.$3j)("list-ordered",60182),listUnordered:(0,t.$3j)("list-unordered",60183),liveShare:(0,t.$3j)("live-share",60184),loading:(0,t.$3j)("loading",60185),location:(0,t.$3j)("location",60186),mailRead:(0,t.$3j)("mail-read",60187),mail:(0,t.$3j)("mail",60188),markdown:(0,t.$3j)("markdown",60189),megaphone:(0,t.$3j)("megaphone",60190),mention:(0,t.$3j)("mention",60191),milestone:(0,t.$3j)("milestone",60192),gitPullRequestMilestone:(0,t.$3j)("git-pull-request-milestone",60192),mortarBoard:(0,t.$3j)("mortar-board",60193),move:(0,t.$3j)("move",60194),multipleWindows:(0,t.$3j)("multiple-windows",60195),mute:(0,t.$3j)("mute",60196),noNewline:(0,t.$3j)("no-newline",60197),note:(0,t.$3j)("note",60198),octoface:(0,t.$3j)("octoface",60199),openPreview:(0,t.$3j)("open-preview",60200),package:(0,t.$3j)("package",60201),paintcan:(0,t.$3j)("paintcan",60202),pin:(0,t.$3j)("pin",60203),play:(0,t.$3j)("play",60204),run:(0,t.$3j)("run",60204),plug:(0,t.$3j)("plug",60205),preserveCase:(0,t.$3j)("preserve-case",60206),preview:(0,t.$3j)("preview",60207),project:(0,t.$3j)("project",60208),pulse:(0,t.$3j)("pulse",60209),question:(0,t.$3j)("question",60210),quote:(0,t.$3j)("quote",60211),radioTower:(0,t.$3j)("radio-tower",60212),reactions:(0,t.$3j)("reactions",60213),references:(0,t.$3j)("references",60214),refresh:(0,t.$3j)("refresh",60215),regex:(0,t.$3j)("regex",60216),remoteExplorer:(0,t.$3j)("remote-explorer",60217),remote:(0,t.$3j)("remote",60218),remove:(0,t.$3j)("remove",60219),replaceAll:(0,t.$3j)("replace-all",60220),replace:(0,t.$3j)("replace",60221),repoClone:(0,t.$3j)("repo-clone",60222),repoForcePush:(0,t.$3j)("repo-force-push",60223),repoPull:(0,t.$3j)("repo-pull",60224),repoPush:(0,t.$3j)("repo-push",60225),report:(0,t.$3j)("report",60226),requestChanges:(0,t.$3j)("request-changes",60227),rocket:(0,t.$3j)("rocket",60228),rootFolderOpened:(0,t.$3j)("root-folder-opened",60229),rootFolder:(0,t.$3j)("root-folder",60230),rss:(0,t.$3j)("rss",60231),ruby:(0,t.$3j)("ruby",60232),saveAll:(0,t.$3j)("save-all",60233),saveAs:(0,t.$3j)("save-as",60234),save:(0,t.$3j)("save",60235),screenFull:(0,t.$3j)("screen-full",60236),screenNormal:(0,t.$3j)("screen-normal",60237),searchStop:(0,t.$3j)("search-stop",60238),server:(0,t.$3j)("server",60240),settingsGear:(0,t.$3j)("settings-gear",60241),settings:(0,t.$3j)("settings",60242),shield:(0,t.$3j)("shield",60243),smiley:(0,t.$3j)("smiley",60244),sortPrecedence:(0,t.$3j)("sort-precedence",60245),splitHorizontal:(0,t.$3j)("split-horizontal",60246),splitVertical:(0,t.$3j)("split-vertical",60247),squirrel:(0,t.$3j)("squirrel",60248),starFull:(0,t.$3j)("star-full",60249),starHalf:(0,t.$3j)("star-half",60250),symbolClass:(0,t.$3j)("symbol-class",60251),symbolColor:(0,t.$3j)("symbol-color",60252),symbolConstant:(0,t.$3j)("symbol-constant",60253),symbolEnumMember:(0,t.$3j)("symbol-enum-member",60254),symbolField:(0,t.$3j)("symbol-field",60255),symbolFile:(0,t.$3j)("symbol-file",60256),symbolInterface:(0,t.$3j)("symbol-interface",60257),symbolKeyword:(0,t.$3j)("symbol-keyword",60258),symbolMisc:(0,t.$3j)("symbol-misc",60259),symbolOperator:(0,t.$3j)("symbol-operator",60260),symbolProperty:(0,t.$3j)("symbol-property",60261),wrench:(0,t.$3j)("wrench",60261),wrenchSubaction:(0,t.$3j)("wrench-subaction",60261),symbolSnippet:(0,t.$3j)("symbol-snippet",60262),tasklist:(0,t.$3j)("tasklist",60263),telescope:(0,t.$3j)("telescope",60264),textSize:(0,t.$3j)("text-size",60265),threeBars:(0,t.$3j)("three-bars",60266),thumbsdown:(0,t.$3j)("thumbsdown",60267),thumbsup:(0,t.$3j)("thumbsup",60268),tools:(0,t.$3j)("tools",60269),triangleDown:(0,t.$3j)("triangle-down",60270),triangleLeft:(0,t.$3j)("triangle-left",60271),triangleRight:(0,t.$3j)("triangle-right",60272),triangleUp:(0,t.$3j)("triangle-up",60273),twitter:(0,t.$3j)("twitter",60274),unfold:(0,t.$3j)("unfold",60275),unlock:(0,t.$3j)("unlock",60276),unmute:(0,t.$3j)("unmute",60277),unverified:(0,t.$3j)("unverified",60278),verified:(0,t.$3j)("verified",60279),versions:(0,t.$3j)("versions",60280),vmActive:(0,t.$3j)("vm-active",60281),vmOutline:(0,t.$3j)("vm-outline",60282),vmRunning:(0,t.$3j)("vm-running",60283),watch:(0,t.$3j)("watch",60284),whitespace:(0,t.$3j)("whitespace",60285),wholeWord:(0,t.$3j)("whole-word",60286),window:(0,t.$3j)("window",60287),wordWrap:(0,t.$3j)("word-wrap",60288),zoomIn:(0,t.$3j)("zoom-in",60289),zoomOut:(0,t.$3j)("zoom-out",60290),listFilter:(0,t.$3j)("list-filter",60291),listFlat:(0,t.$3j)("list-flat",60292),listSelection:(0,t.$3j)("list-selection",60293),selection:(0,t.$3j)("selection",60293),listTree:(0,t.$3j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$3j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$3j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$3j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$3j)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$3j)("circle-small-filled",60298),debugStackframeDot:(0,t.$3j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$3j)("terminal-decoration-mark",60298),debugStackframe:(0,t.$3j)("debug-stackframe",60299),debugStackframeFocused:(0,t.$3j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$3j)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$3j)("symbol-string",60301),debugReverseContinue:(0,t.$3j)("debug-reverse-continue",60302),debugStepBack:(0,t.$3j)("debug-step-back",60303),debugRestartFrame:(0,t.$3j)("debug-restart-frame",60304),debugAlt:(0,t.$3j)("debug-alt",60305),callIncoming:(0,t.$3j)("call-incoming",60306),callOutgoing:(0,t.$3j)("call-outgoing",60307),menu:(0,t.$3j)("menu",60308),expandAll:(0,t.$3j)("expand-all",60309),feedback:(0,t.$3j)("feedback",60310),gitPullRequestReviewer:(0,t.$3j)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$3j)("group-by-ref-type",60311),ungroupByRefType:(0,t.$3j)("ungroup-by-ref-type",60312),account:(0,t.$3j)("account",60313),gitPullRequestAssignee:(0,t.$3j)("git-pull-request-assignee",60313),bellDot:(0,t.$3j)("bell-dot",60314),debugConsole:(0,t.$3j)("debug-console",60315),library:(0,t.$3j)("library",60316),output:(0,t.$3j)("output",60317),runAll:(0,t.$3j)("run-all",60318),syncIgnored:(0,t.$3j)("sync-ignored",60319),pinned:(0,t.$3j)("pinned",60320),githubInverted:(0,t.$3j)("github-inverted",60321),serverProcess:(0,t.$3j)("server-process",60322),serverEnvironment:(0,t.$3j)("server-environment",60323),pass:(0,t.$3j)("pass",60324),issueClosed:(0,t.$3j)("issue-closed",60324),stopCircle:(0,t.$3j)("stop-circle",60325),playCircle:(0,t.$3j)("play-circle",60326),record:(0,t.$3j)("record",60327),debugAltSmall:(0,t.$3j)("debug-alt-small",60328),vmConnect:(0,t.$3j)("vm-connect",60329),cloud:(0,t.$3j)("cloud",60330),merge:(0,t.$3j)("merge",60331),export:(0,t.$3j)("export",60332),graphLeft:(0,t.$3j)("graph-left",60333),magnet:(0,t.$3j)("magnet",60334),notebook:(0,t.$3j)("notebook",60335),redo:(0,t.$3j)("redo",60336),checkAll:(0,t.$3j)("check-all",60337),pinnedDirty:(0,t.$3j)("pinned-dirty",60338),passFilled:(0,t.$3j)("pass-filled",60339),circleLargeFilled:(0,t.$3j)("circle-large-filled",60340),circleLarge:(0,t.$3j)("circle-large",60341),circleLargeOutline:(0,t.$3j)("circle-large-outline",60341),combine:(0,t.$3j)("combine",60342),gather:(0,t.$3j)("gather",60342),table:(0,t.$3j)("table",60343),variableGroup:(0,t.$3j)("variable-group",60344),typeHierarchy:(0,t.$3j)("type-hierarchy",60345),typeHierarchySub:(0,t.$3j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$3j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$3j)("git-pull-request-create",60348),runAbove:(0,t.$3j)("run-above",60349),runBelow:(0,t.$3j)("run-below",60350),notebookTemplate:(0,t.$3j)("notebook-template",60351),debugRerun:(0,t.$3j)("debug-rerun",60352),workspaceTrusted:(0,t.$3j)("workspace-trusted",60353),workspaceUntrusted:(0,t.$3j)("workspace-untrusted",60354),workspaceUnknown:(0,t.$3j)("workspace-unknown",60355),terminalCmd:(0,t.$3j)("terminal-cmd",60356),terminalDebian:(0,t.$3j)("terminal-debian",60357),terminalLinux:(0,t.$3j)("terminal-linux",60358),terminalPowershell:(0,t.$3j)("terminal-powershell",60359),terminalTmux:(0,t.$3j)("terminal-tmux",60360),terminalUbuntu:(0,t.$3j)("terminal-ubuntu",60361),terminalBash:(0,t.$3j)("terminal-bash",60362),arrowSwap:(0,t.$3j)("arrow-swap",60363),copy:(0,t.$3j)("copy",60364),personAdd:(0,t.$3j)("person-add",60365),filterFilled:(0,t.$3j)("filter-filled",60366),wand:(0,t.$3j)("wand",60367),debugLineByLine:(0,t.$3j)("debug-line-by-line",60368),inspect:(0,t.$3j)("inspect",60369),layers:(0,t.$3j)("layers",60370),layersDot:(0,t.$3j)("layers-dot",60371),layersActive:(0,t.$3j)("layers-active",60372),compass:(0,t.$3j)("compass",60373),compassDot:(0,t.$3j)("compass-dot",60374),compassActive:(0,t.$3j)("compass-active",60375),azure:(0,t.$3j)("azure",60376),issueDraft:(0,t.$3j)("issue-draft",60377),gitPullRequestClosed:(0,t.$3j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$3j)("git-pull-request-draft",60379),debugAll:(0,t.$3j)("debug-all",60380),debugCoverage:(0,t.$3j)("debug-coverage",60381),runErrors:(0,t.$3j)("run-errors",60382),folderLibrary:(0,t.$3j)("folder-library",60383),debugContinueSmall:(0,t.$3j)("debug-continue-small",60384),beakerStop:(0,t.$3j)("beaker-stop",60385),graphLine:(0,t.$3j)("graph-line",60386),graphScatter:(0,t.$3j)("graph-scatter",60387),pieChart:(0,t.$3j)("pie-chart",60388),bracket:(0,t.$3j)("bracket",60175),bracketDot:(0,t.$3j)("bracket-dot",60389),bracketError:(0,t.$3j)("bracket-error",60390),lockSmall:(0,t.$3j)("lock-small",60391),azureDevops:(0,t.$3j)("azure-devops",60392),verifiedFilled:(0,t.$3j)("verified-filled",60393),newline:(0,t.$3j)("newline",60394),layout:(0,t.$3j)("layout",60395),layoutActivitybarLeft:(0,t.$3j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$3j)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$3j)("layout-panel-left",60398),layoutPanelCenter:(0,t.$3j)("layout-panel-center",60399),layoutPanelJustify:(0,t.$3j)("layout-panel-justify",60400),layoutPanelRight:(0,t.$3j)("layout-panel-right",60401),layoutPanel:(0,t.$3j)("layout-panel",60402),layoutSidebarLeft:(0,t.$3j)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$3j)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$3j)("layout-statusbar",60405),layoutMenubar:(0,t.$3j)("layout-menubar",60406),layoutCentered:(0,t.$3j)("layout-centered",60407),target:(0,t.$3j)("target",60408),indent:(0,t.$3j)("indent",60409),recordSmall:(0,t.$3j)("record-small",60410),errorSmall:(0,t.$3j)("error-small",60411),terminalDecorationError:(0,t.$3j)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$3j)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$3j)("arrow-circle-left",60413),arrowCircleRight:(0,t.$3j)("arrow-circle-right",60414),arrowCircleUp:(0,t.$3j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$3j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$3j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$3j)("layout-sidebar-left-off",60418),blank:(0,t.$3j)("blank",60419),heartFilled:(0,t.$3j)("heart-filled",60420),map:(0,t.$3j)("map",60421),mapHorizontal:(0,t.$3j)("map-horizontal",60421),foldHorizontal:(0,t.$3j)("fold-horizontal",60421),mapFilled:(0,t.$3j)("map-filled",60422),mapHorizontalFilled:(0,t.$3j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$3j)("fold-horizontal-filled",60422),circleSmall:(0,t.$3j)("circle-small",60423),bellSlash:(0,t.$3j)("bell-slash",60424),bellSlashDot:(0,t.$3j)("bell-slash-dot",60425),commentUnresolved:(0,t.$3j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$3j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$3j)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$3j)("search-fuzzy",60429),commentDraft:(0,t.$3j)("comment-draft",60430),send:(0,t.$3j)("send",60431),sparkle:(0,t.$3j)("sparkle",60432),insert:(0,t.$3j)("insert",60433),mic:(0,t.$3j)("mic",60434),thumbsdownFilled:(0,t.$3j)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$3j)("thumbsup-filled",60436),coffee:(0,t.$3j)("coffee",60437),snake:(0,t.$3j)("snake",60438),game:(0,t.$3j)("game",60439),vr:(0,t.$3j)("vr",60440),chip:(0,t.$3j)("chip",60441),piano:(0,t.$3j)("piano",60442),music:(0,t.$3j)("music",60443),micFilled:(0,t.$3j)("mic-filled",60444),repoFetch:(0,t.$3j)("repo-fetch",60445),copilot:(0,t.$3j)("copilot",60446),lightbulbSparkle:(0,t.$3j)("lightbulb-sparkle",60447),robot:(0,t.$3j)("robot",60448),sparkleFilled:(0,t.$3j)("sparkle-filled",60449),diffSingle:(0,t.$3j)("diff-single",60450),diffMultiple:(0,t.$3j)("diff-multiple",60451),surroundWith:(0,t.$3j)("surround-with",60452),share:(0,t.$3j)("share",60453),gitStash:(0,t.$3j)("git-stash",60454),gitStashApply:(0,t.$3j)("git-stash-apply",60455),gitStashPop:(0,t.$3j)("git-stash-pop",60456),vscode:(0,t.$3j)("vscode",60457),vscodeInsiders:(0,t.$3j)("vscode-insiders",60458),codeOss:(0,t.$3j)("code-oss",60459),runCoverage:(0,t.$3j)("run-coverage",60460),runAllCoverage:(0,t.$3j)("run-all-coverage",60461),coverage:(0,t.$3j)("coverage",60462),githubProject:(0,t.$3j)("github-project",60463),mapVertical:(0,t.$3j)("map-vertical",60464),foldVertical:(0,t.$3j)("fold-vertical",60464),mapVerticalFilled:(0,t.$3j)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$3j)("fold-vertical-filled",60465),goToSearch:(0,t.$3j)("go-to-search",60466),percentage:(0,t.$3j)("percentage",60467),sortPercentage:(0,t.$3j)("sort-percentage",60467),attach:(0,t.$3j)("attach",60468)}}),ne(ie[48],re([0,1,29,47]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8j=i.$7j=void 0,i.$6j=T;function T(){return Object.values(i.$8j)}i.$7j={dialogError:(0,t.$3j)("dialog-error","error"),dialogWarning:(0,t.$3j)("dialog-warning","warning"),dialogInfo:(0,t.$3j)("dialog-info","info"),dialogClose:(0,t.$3j)("dialog-close","close"),treeItemExpanded:(0,t.$3j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$3j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$3j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$3j)("tree-filter-clear","close"),treeItemLoading:(0,t.$3j)("tree-item-loading","loading"),menuSelection:(0,t.$3j)("menu-selection","check"),menuSubmenu:(0,t.$3j)("menu-submenu","chevron-right"),menuBarMore:(0,t.$3j)("menubar-more","more"),scrollbarButtonLeft:(0,t.$3j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$3j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$3j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$3j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$3j)("toolbar-more","more"),quickInputBack:(0,t.$3j)("quick-input-back","arrow-left"),dropDownButton:(0,t.$3j)("drop-down-button",60084),symbolCustomColor:(0,t.$3j)("symbol-customcolor",60252),exportIcon:(0,t.$3j)("export",60332),workspaceUnspecified:(0,t.$3j)("workspace-unspecified",60355),newLine:(0,t.$3j)("newline",60394),thumbsDownFilled:(0,t.$3j)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$3j)("thumbsup-filled",60436),gitFetch:(0,t.$3j)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$3j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$3j)("debug-breakpoint-pending",60377)},i.$8j={...n.$5j,...i.$7j}}),ne(ie[19],re([0,1,28]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ho=n,i.$io=T,i.$jo=E,i.$ko=a,i.$lo=u,i.$mo=o,i.$no=w,i.$oo=h,i.$po=m,i.$qo=e,i.$ro=b,i.$so=L,i.$to=R;function n(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const v=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([_,$])=>{v[_]=$&&typeof $=="object"?n($):$}),v}function T(A){if(!A||typeof A!="object")return A;const v=[A];for(;v.length>0;){const _=v.shift();Object.freeze(_);for(const $ in _)if(f.call(_,$)){const l=_[$];typeof l=="object"&&!Object.isFrozen(l)&&!(0,t.$kg)(l)&&v.push(l)}}return A}const f=Object.prototype.hasOwnProperty;function E(A,v){return g(A,v,new Set)}function g(A,v,_){if((0,t.$qg)(A))return A;const $=v(A);if(typeof $<"u")return $;if(Array.isArray(A)){const l=[];for(const s of A)l.push(g(s,v,_));return l}if((0,t.$jg)(A)){if(_.has(A))throw new Error("Cannot clone recursive data-structure");_.add(A);const l={};for(const s in A)f.call(A,s)&&(l[s]=g(A[s],v,_));return _.delete(A),l}return A}function a(A,v,_=!0){return(0,t.$jg)(A)?((0,t.$jg)(v)&&Object.keys(v).forEach($=>{$ in A?_&&((0,t.$jg)(A[$])&&(0,t.$jg)(v[$])?a(A[$],v[$],_):A[$]=v[$]):A[$]=v[$]}),A):v}function u(A,v){if(A===v)return!0;if(A==null||v===null||v===void 0||typeof A!=typeof v||typeof A!="object"||Array.isArray(A)!==Array.isArray(v))return!1;let _,$;if(Array.isArray(A)){if(A.length!==v.length)return!1;for(_=0;_<A.length;_++)if(!u(A[_],v[_]))return!1}else{const l=[];for($ in A)l.push($);l.sort();const s=[];for($ in v)s.push($);if(s.sort(),!u(l,s))return!1;for(_=0;_<l.length;_++)if(!u(A[l[_]],v[l[_]]))return!1}return!0}function o(A){const v=new Set;return JSON.stringify(A,(_,$)=>{if((0,t.$jg)($)||Array.isArray($)){if(v.has($))return"[Circular]";v.add($)}return typeof $=="bigint"?`[BigInt ${$.toString()}]`:$})}function w(A,v){const _=Object.create(null);return!A||!v||Object.keys(v).forEach(l=>{const s=A[l],c=v[l];u(s,c)||(_[l]=c)}),_}function h(A,v){const _=v.toLowerCase(),$=Object.keys(A).find(l=>l.toLowerCase()===_);return $?A[$]:A[v]}function m(A,v){const _=Object.create(null);for(const[$,l]of Object.entries(A))v($,l)&&(_[$]=l);return _}function e(A){let v=[];for(;Object.prototype!==A;)v=v.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return v}function b(A){const v=[];for(const _ of e(A))typeof A[_]=="function"&&v.push(_);return v}function L(A,v){const _=l=>function(){const s=Array.prototype.slice.call(arguments,0);return v(l,s)},$={};for(const l of A)$[l]=_(l);return $}function R(A,v){const _={};for(const[$,l]of Object.entries(A))_[$]=v(l,$);return _}}),ne(ie[15],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.$df=n,i.$ef=T;var t;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(f){return f<0?0:f>t.MAX_UINT_8?t.MAX_UINT_8:f|0}function T(f){return f<0?0:f>t.MAX_UINT_32?t.MAX_UINT_32:f|0}}),ne(ie[7],re([0,1,46,5,43,15]),function(x,i,t,n,T,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gg=i.$fg=i.$eg=i.GraphemeBreakType=i.$7f=i.$Yf=i.$Rf=i.$Qf=void 0,i.$ff=E,i.$gf=a,i.$hf=o,i.$if=w,i.$jf=h,i.$kf=m,i.$lf=e,i.$mf=b,i.$nf=L,i.$of=R,i.$pf=A,i.$qf=v,i.$rf=_,i.$sf=$,i.$tf=l,i.$uf=s,i.$vf=c,i.$wf=d,i.$xf=j,i.$yf=N,i.$zf=p,i.$Af=D,i.$Bf=M,i.$Cf=S,i.$Df=I,i.$Ef=F,i.$Ff=B,i.$Gf=W,i.$Hf=O,i.$If=y,i.$Jf=X,i.$Kf=Z,i.$Lf=Y,i.$Mf=Q,i.$Nf=C,i.$Of=k,i.$Pf=G,i.$Sf=r,i.$Tf=Te,i.$Uf=Pe,i.$Vf=He,i.$Wf=Ge,i.$Xf=H,i.$Zf=V,i.$1f=J,i.$2f=ee,i.$3f=he,i.$4f=Ne,i.$5f=ve,i.$6f=je,i.$8f=ue,i.$9f=te,i.$0f=le,i.$$f=se,i.$_f=fe,i.$ag=me,i.$bg=$e,i.$cg=Ee,i.$dg=ze;function E(P){return!P||typeof P!="string"?!0:P.trim().length===0}const g=/{(\d+)}/g;function a(P,...q){return q.length===0?P:P.replace(g,function(z,K){const ae=parseInt(K,10);return isNaN(ae)||ae<0||ae>=q.length?z:q[ae]})}const u=/{([^}]+)}/g;function o(P,q){return Object.keys(q).length===0?P:P.replace(u,(z,K)=>q[K]??z)}function w(P){return P.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function h(P){return P.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function m(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(P,q){let z=0,K=P.indexOf(q);for(;K!==-1;)z++,K=P.indexOf(q,K+q.length);return z}function b(P,q,z="\u2026"){return P.length<=q?P:`${P.substr(0,q)}${z}`}function L(P,q,z="\u2026"){if(P.length<=q)return P;const K=Math.ceil(q/2)-z.length/2,ae=Math.floor(q/2)-z.length/2;return`${P.substr(0,K)}${z}${P.substr(P.length-ae)}`}function R(P,q=" "){const z=A(P,q);return v(z,q)}function A(P,q){if(!P||!q)return P;const z=q.length;if(z===0||P.length===0)return P;let K=0;for(;P.indexOf(q,K)===K;)K=K+z;return P.substring(K)}function v(P,q){if(!P||!q)return P;const z=q.length,K=P.length;if(z===0||K===0)return P;let ae=K,be=-1;for(;be=P.lastIndexOf(q,ae-1),!(be===-1||be+z!==ae);){if(be===0)return"";ae=be}return P.substring(0,ae)}function _(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function $(P){return P.replace(/\*/g,"")}function l(P,q,z={}){if(!P)throw new Error("Cannot create regex from empty string");q||(P=m(P)),z.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let K="";return z.global&&(K+="g"),z.matchCase||(K+="i"),z.multiline&&(K+="m"),z.unicode&&(K+="u"),new RegExp(P,K)}function s(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}function c(P){return P.split(/\r\n|\r|\n/)}function d(P){const q=[],z=P.split(/(\r\n|\r|\n)/);for(let K=0;K<Math.ceil(z.length/2);K++)q.push(z[2*K]+(z[2*K+1]??""));return q}function j(P){for(let q=0,z=P.length;q<z;q++){const K=P.charCodeAt(q);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return q}return-1}function N(P,q=0,z=P.length){for(let K=q;K<z;K++){const ae=P.charCodeAt(K);if(ae!==n.CharCode.Space&&ae!==n.CharCode.Tab)return P.substring(q,K)}return P.substring(q,z)}function p(P,q=P.length-1){for(let z=q;z>=0;z--){const K=P.charCodeAt(z);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return z}return-1}function D(P,q,z){const K=[];let ae=0;for(const be of P.matchAll(q)){if(K.push(P.slice(ae,be.index)),be.index===void 0)throw new Error("match.index should be defined");ae=be.index+be[0].length,K.push(z(be[0],...be.slice(1),be.index,P,be.groups))}return K.push(P.slice(ae)),Promise.all(K).then(be=>be.join(""))}function M(P,q){return P<q?-1:P>q?1:0}function S(P,q,z=0,K=P.length,ae=0,be=q.length){for(;z<K&&ae<be;z++,ae++){const ke=P.charCodeAt(z),Ie=q.charCodeAt(ae);if(ke<Ie)return-1;if(ke>Ie)return 1}const Re=K-z,ye=be-ae;return Re<ye?-1:Re>ye?1:0}function I(P,q){return F(P,q,0,P.length,0,q.length)}function F(P,q,z=0,K=P.length,ae=0,be=q.length){for(;z<K&&ae<be;z++,ae++){let ke=P.charCodeAt(z),Ie=q.charCodeAt(ae);if(ke===Ie)continue;if(ke>=128||Ie>=128)return S(P.toLowerCase(),q.toLowerCase(),z,K,ae,be);W(ke)&&(ke-=32),W(Ie)&&(Ie-=32);const pe=ke-Ie;if(pe!==0)return pe}const Re=K-z,ye=be-ae;return Re<ye?-1:Re>ye?1:0}function B(P){return P>=n.CharCode.Digit0&&P<=n.CharCode.Digit9}function W(P){return P>=n.CharCode.a&&P<=n.CharCode.z}function O(P){return P>=n.CharCode.A&&P<=n.CharCode.Z}function y(P,q){return P.length===q.length&&F(P,q)===0}function X(P,q){const z=q.length;return q.length>P.length?!1:F(P,q,0,z)===0}function Z(P,q){const z=Math.min(P.length,q.length);let K;for(K=0;K<z;K++)if(P.charCodeAt(K)!==q.charCodeAt(K))return K;return z}function Y(P,q){const z=Math.min(P.length,q.length);let K;const ae=P.length-1,be=q.length-1;for(K=0;K<z;K++)if(P.charCodeAt(ae-K)!==q.charCodeAt(be-K))return K;return z}function Q(P){return 55296<=P&&P<=56319}function C(P){return 56320<=P&&P<=57343}function k(P,q){return(P-55296<<10)+(q-56320)+65536}function G(P,q,z){const K=P.charCodeAt(z);if(Q(K)&&z+1<q){const ae=P.charCodeAt(z+1);if(C(ae))return k(K,ae)}return K}function oe(P,q){const z=P.charCodeAt(q-1);if(C(z)&&q>1){const K=P.charCodeAt(q-2);if(Q(K))return k(K,z)}return z}class ce{get offset(){return this.e}constructor(q,z=0){this.c=q,this.d=q.length,this.e=z}setOffset(q){this.e=q}prevCodePoint(){const q=oe(this.c,this.e);return this.e-=q>=f.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,q}nextCodePoint(){const q=G(this.c,this.d,this.e);return this.e+=q>=f.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,q}eol(){return this.e>=this.d}}i.$Qf=ce;class we{get offset(){return this.c.offset}constructor(q,z=0){this.c=new ce(q,z)}nextGraphemeLength(){const q=De.getInstance(),z=this.c,K=z.offset;let ae=q.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const be=z.offset,Re=q.getGraphemeBreakType(z.nextCodePoint());if(Ae(ae,Re)){z.setOffset(be);break}ae=Re}return z.offset-K}prevGraphemeLength(){const q=De.getInstance(),z=this.c,K=z.offset;let ae=q.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const be=z.offset,Re=q.getGraphemeBreakType(z.prevCodePoint());if(Ae(Re,ae)){z.setOffset(be);break}ae=Re}return K-z.offset}eol(){return this.c.eol()}}i.$Rf=we;function r(P,q){return new we(P,q).nextGraphemeLength()}function Te(P,q){return new we(P,q).prevGraphemeLength()}function Pe(P,q){q>0&&C(P.charCodeAt(q))&&q--;const z=q+r(P,q);return[z-Te(P,z),z]}function He(P){const q=new we(P);let z=0;for(;!q.eol();)z++,q.nextGraphemeLength();return z}let Fe;function Be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ge(P){return Fe||(Fe=Be()),Fe.test(P)}const U=/^[\t\n\r\x20-\x7E]*$/;function H(P){return U.test(P)}i.$Yf=/[\u2028\u2029]/;function V(P){return i.$Yf.test(P)}function J(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}function ee(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}function he(P,q,z=""){const K=P.trimStart();if(K.length<q)return K;const ae=/\b/g;let be=0;for(;ae.test(K)&&!(K.length-ae.lastIndex<q);)be=ae.lastIndex,ae.lastIndex+=1;return be===0?K:z+K.substring(be).trimStart()}const de=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ne(P){let q=0;for(const z of P.matchAll(de))q!==z.index&&(yield{isCode:!1,str:P.substring(q,z.index)}),yield{isCode:!0,str:z[0]},q=z.index+z[0].length;q!==P.length&&(yield{isCode:!1,str:P.substring(q)})}function ve(P){return P&&(P=P.replace(de,"")),P}const _e=/\\\[.*?\\\]/g;function je(P){return ve(P).replace(_e,"")}i.$7f=String.fromCharCode(n.CharCode.UTF8_BOM);function ue(P){return!!(P&&P.length>0&&P.charCodeAt(0)===n.CharCode.UTF8_BOM)}function te(P){return ue(P)?P.substr(1):P}function le(P,q){if(!P||!q||P.length<q.length)return!1;const z=q.length,K=P.toLowerCase();let ae=0,be=-1;for(;ae<z;){const Re=K.indexOf(q[ae],be+1);if(Re<0)return!1;be=Re,ae++}return!0}function se(P,q=!1){return P?(q&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}function fe(P){return P.charAt(0).toUpperCase()+P.slice(1)}function me(P,q=1){if(q===0)return"";let z=-1;do z=P.indexOf(`
`,z+1),q--;while(q>0&&z>=0);return z===-1?P:(P[z-1]==="\r"&&z--,P.substr(0,z))}function $e(P){const q=n.CharCode.Z-n.CharCode.A+1;return P=P%(2*q),P<q?String.fromCharCode(n.CharCode.a+P):String.fromCharCode(n.CharCode.A+P-q)}function Ee(P){return De.getInstance().getGraphemeBreakType(P)}function Ae(P,q){return P===ge.Other?q!==ge.Extend&&q!==ge.SpacingMark:P===ge.CR&&q===ge.LF?!1:P===ge.Control||P===ge.CR||P===ge.LF||q===ge.Control||q===ge.CR||q===ge.LF?!0:!(P===ge.L&&(q===ge.L||q===ge.V||q===ge.LV||q===ge.LVT)||(P===ge.LV||P===ge.V)&&(q===ge.V||q===ge.T)||(P===ge.LVT||P===ge.T)&&q===ge.T||q===ge.Extend||q===ge.ZWJ||q===ge.SpacingMark||P===ge.Prepend||P===ge.ZWJ&&q===ge.Extended_Pictographic||P===ge.Regional_Indicator&&q===ge.Regional_Indicator)}var ge;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(i.GraphemeBreakType=ge={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=qe()}getGraphemeBreakType(q){if(q<32)return q===n.CharCode.LineFeed?ge.LF:q===n.CharCode.CarriageReturn?ge.CR:ge.Control;if(q<127)return ge.Other;const z=this.d,K=z.length/3;let ae=1;for(;ae<=K;)if(q<z[3*ae])ae=2*ae;else if(q>z[3*ae+1])ae=2*ae+1;else return z[3*ae+2];return ge.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(P,q){if(P===0)return 0;const z=Ue(P,q);if(z!==void 0)return z;const K=new ce(q,P);return K.prevCodePoint(),K.offset}function Ue(P,q){const z=new ce(q,P);let K=z.prevCodePoint();for(;Ye(K)||K===xe.emojiVariantSelector||K===xe.enclosingKeyCap;){if(z.offset===0)return;K=z.prevCodePoint()}if(!ee(K))return;let ae=z.offset;return ae>0&&z.prevCodePoint()===xe.zwj&&(ae=z.offset),ae}function Ye(P){return 127995<=P&&P<=127999}var xe;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),i.$eg="\xA0";class We{static{this.c=new T.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new t.$bf({getCacheKey:JSON.stringify},q=>{function z(pe){const Oe=new Map;for(let Se=0;Se<pe.length;Se+=2)Oe.set(pe[Se],pe[Se+1]);return Oe}function K(pe,Oe){const Se=new Map(pe);for(const[Xe,Ze]of Oe)Se.set(Xe,Ze);return Se}function ae(pe,Oe){if(!pe)return Oe;const Se=new Map;for(const[Xe,Ze]of pe)Oe.has(Xe)&&Se.set(Xe,Ze);return Se}const be=this.c.value;let Re=q.filter(pe=>!pe.startsWith("_")&&pe in be);Re.length===0&&(Re=["_default"]);let ye;for(const pe of Re){const Oe=z(be[pe]);ye=ae(ye,Oe)}const ke=z(be._common),Ie=K(ke,ye);return new We(Ie)})}static getInstance(q){return We.d.get(Array.from(q))}static{this.e=new T.$W(()=>Object.keys(We.c.value).filter(q=>!q.startsWith("_")))}static getLocales(){return We.e.value}constructor(q){this.f=q}isAmbiguous(q){return this.f.has(q)}containsAmbiguousCharacter(q){for(let z=0;z<q.length;z++){const K=q.codePointAt(z);if(typeof K=="number"&&this.isAmbiguous(K))return!0}return!1}getPrimaryConfusable(q){return this.f.get(q)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.$fg=We;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(q){return Ve.e().has(q)}static containsInvisibleCharacter(q){for(let z=0;z<q.length;z++){const K=q.codePointAt(z);if(typeof K=="number"&&Ve.isInvisibleCharacter(K))return!0}return!1}static get codePoints(){return Ve.e()}}i.$gg=Ve}),ne(ie[49],re([0,1,7]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Cj=i.$Aj=void 0,i.$wj=n,i.$xj=T,i.$yj=f,i.$zj=g,i.$Bj=b,t=Me(t);function n(R){return T(R,0)}function T(R,A){switch(typeof R){case"object":return R===null?f(349,A):Array.isArray(R)?a(R,A):u(R,A);case"string":return g(R,A);case"boolean":return E(R,A);case"number":return f(R,A);case"undefined":return f(937,A);default:return f(617,A)}}function f(R,A){return(A<<5)-A+R|0}function E(R,A){return f(R?433:863,A)}function g(R,A){A=f(149417,A);for(let v=0,_=R.length;v<_;v++)A=f(R.charCodeAt(v),A);return A}function a(R,A){return A=f(104579,A),R.reduce((v,_)=>T(_,v),A)}function u(R,A){return A=f(181387,A),Object.keys(R).sort().reduce((v,_)=>(v=g(_,v),T(R[_],v)),A)}class o{constructor(){this.g=0}get value(){return this.g}hash(A){return this.g=T(A,this.g),this.g}}i.$Aj=o;var w;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function h(R,A,v=32){const _=v-A,$=~((1<<_)-1);return(R<<A|($&R)>>>_)>>>0}function m(R,A=0,v=R.byteLength,_=0){for(let $=0;$<v;$++)R[A+$]=_}function e(R,A,v="0"){for(;R.length<A;)R=v+R;return R}function b(R,A=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((R>>>0).toString(16),A/4)}class L{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(w.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(A){const v=A.length;if(v===0)return;const _=this.p;let $=this.r,l=this.u,s,c;for(l!==0?(s=l,c=-1,l=0):(s=A.charCodeAt(0),c=0);;){let d=s;if(t.$Mf(s))if(c+1<v){const j=A.charCodeAt(c+1);t.$Nf(j)?(c++,d=t.$Of(s,j)):d=w.UNICODE_REPLACEMENT}else{l=s;break}else t.$Nf(s)&&(d=w.UNICODE_REPLACEMENT);if($=this.w(_,$,d),c++,c<v)s=A.charCodeAt(c);else break}this.r=$,this.u=l}w(A,v,_){return _<128?A[v++]=_:_<2048?(A[v++]=192|(_&1984)>>>6,A[v++]=128|(_&63)>>>0):_<65536?(A[v++]=224|(_&61440)>>>12,A[v++]=128|(_&4032)>>>6,A[v++]=128|(_&63)>>>0):(A[v++]=240|(_&1835008)>>>18,A[v++]=128|(_&258048)>>>12,A[v++]=128|(_&4032)>>>6,A[v++]=128|(_&63)>>>0),v>=w.BLOCK_SIZE&&(this.y(),v-=w.BLOCK_SIZE,this.t+=w.BLOCK_SIZE,A[0]=A[w.BLOCK_SIZE+0],A[1]=A[w.BLOCK_SIZE+1],A[2]=A[w.BLOCK_SIZE+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,w.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const A=8*this.t;this.q.setUint32(56,Math.floor(A/4294967296),!1),this.q.setUint32(60,A%4294967296,!1),this.y()}y(){const A=L.g,v=this.q;for(let p=0;p<64;p+=4)A.setUint32(p,v.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)A.setUint32(p,h(A.getUint32(p-12,!1)^A.getUint32(p-32,!1)^A.getUint32(p-56,!1)^A.getUint32(p-64,!1),1),!1);let _=this.h,$=this.l,l=this.m,s=this.n,c=this.o,d,j,N;for(let p=0;p<80;p++)p<20?(d=$&l|~$&s,j=1518500249):p<40?(d=$^l^s,j=1859775393):p<60?(d=$&l|$&s|l&s,j=2400959708):(d=$^l^s,j=3395469782),N=h(_,5)+d+c+j+A.getUint32(p*4,!1)&4294967295,c=s,s=l,l=h($,30),$=_,_=N;this.h=this.h+_&4294967295,this.l=this.l+$&4294967295,this.m=this.m+l&4294967295,this.n=this.n+s&4294967295,this.o=this.o+c&4294967295}}i.$Cj=L}),ne(ie[30],re([0,1,41,49,15]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Zt=i.$Xt=void 0,i.$Yt=E;class f{constructor(m){this.a=m}getElements(){const m=this.a,e=new Int32Array(m.length);for(let b=0,L=m.length;b<L;b++)e[b]=m.charCodeAt(b);return e}}i.$Xt=f;function E(h,m,e){return new w(new f(h),new f(m)).ComputeDiff(e).changes}class g{static Assert(m,e){if(!m)throw new Error(e)}}class a{static Copy(m,e,b,L,R){for(let A=0;A<R;A++)b[L+A]=m[e+A]}static Copy2(m,e,b,L,R){for(let A=0;A<R;A++)b[L+A]=m[e+A]}}var u;(function(h){h[h.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class o{constructor(){this.a=[],this.b=T.Constants.MAX_SAFE_SMALL_INTEGER,this.c=T.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new t.$Wt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=T.Constants.MAX_SAFE_SMALL_INTEGER,this.c=T.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class w{constructor(m,e,b=null){this.a=b,this.b=m,this.c=e;const[L,R,A]=w.o(m),[v,_,$]=w.o(e);this.d=A&&$,this.e=L,this.f=R,this.g=v,this.h=_,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const e=m.getElements();if(w.n(e)){const b=new Int32Array(e.length);for(let L=0,R=e.length;L<R;L++)b[L]=(0,n.$zj)(e[L],0);return[e,b,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(m,e){return this.f[m]!==this.h[e]?!1:this.d?this.e[m]===this.g[e]:!0}q(m,e){if(!this.p(m,e))return!1;const b=w.r(this.b,m),L=w.r(this.c,e);return b===L}static r(m,e){return typeof m.getStrictElement=="function"?m.getStrictElement(e):null}s(m,e){return this.f[m]!==this.f[e]?!1:this.d?this.e[m]===this.e[e]:!0}u(m,e){return this.h[m]!==this.h[e]?!1:this.d?this.g[m]===this.g[e]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,e,b,L,R){const A=[!1];let v=this.w(m,e,b,L,A);return R&&(v=this.z(v)),{quitEarly:A[0],changes:v}}w(m,e,b,L,R){for(R[0]=!1;m<=e&&b<=L&&this.p(m,b);)m++,b++;for(;e>=m&&L>=b&&this.p(e,L);)e--,L--;if(m>e||b>L){let s;return b<=L?(g.Assert(m===e+1,"originalStart should only be one more than originalEnd"),s=[new t.$Wt(m,0,b,L-b+1)]):m<=e?(g.Assert(b===L+1,"modifiedStart should only be one more than modifiedEnd"),s=[new t.$Wt(m,e-m+1,b,0)]):(g.Assert(m===e+1,"originalStart should only be one more than originalEnd"),g.Assert(b===L+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const A=[0],v=[0],_=this.y(m,e,b,L,A,v,R),$=A[0],l=v[0];if(_!==null)return _;if(!R[0]){const s=this.w(m,$,b,l,R);let c=[];return R[0]?c=[new t.$Wt($+1,e-($+1)+1,l+1,L-(l+1)+1)]:c=this.w($+1,e,l+1,L,R),this.H(s,c)}return[new t.$Wt(m,e-m+1,b,L-b+1)]}x(m,e,b,L,R,A,v,_,$,l,s,c,d,j,N,p,D,M){let S=null,I=null,F=new o,B=e,W=b,O=d[0]-p[0]-L,y=T.Constants.MIN_SAFE_SMALL_INTEGER,X=this.k.length-1;do{const Z=O+m;Z===B||Z<W&&$[Z-1]<$[Z+1]?(s=$[Z+1],j=s-O-L,s<y&&F.MarkNextChange(),y=s,F.AddModifiedElement(s+1,j),O=Z+1-m):(s=$[Z-1]+1,j=s-O-L,s<y&&F.MarkNextChange(),y=s-1,F.AddOriginalElement(s,j+1),O=Z-1-m),X>=0&&($=this.k[X],m=$[0],B=1,W=$.length-1)}while(--X>=-1);if(S=F.getReverseChanges(),M[0]){let Z=d[0]+1,Y=p[0]+1;if(S!==null&&S.length>0){const Q=S[S.length-1];Z=Math.max(Z,Q.getOriginalEnd()),Y=Math.max(Y,Q.getModifiedEnd())}I=[new t.$Wt(Z,c-Z+1,Y,N-Y+1)]}else{F=new o,B=A,W=v,O=d[0]-p[0]-_,y=T.Constants.MAX_SAFE_SMALL_INTEGER,X=D?this.m.length-1:this.m.length-2;do{const Z=O+R;Z===B||Z<W&&l[Z-1]>=l[Z+1]?(s=l[Z+1]-1,j=s-O-_,s>y&&F.MarkNextChange(),y=s+1,F.AddOriginalElement(s+1,j+1),O=Z+1-R):(s=l[Z-1],j=s-O-_,s>y&&F.MarkNextChange(),y=s,F.AddModifiedElement(s+1,j+1),O=Z-1-R),X>=0&&(l=this.m[X],R=l[0],B=1,W=l.length-1)}while(--X>=-1);I=F.getChanges()}return this.H(S,I)}y(m,e,b,L,R,A,v){let _=0,$=0,l=0,s=0,c=0,d=0;m--,b--,R[0]=0,A[0]=0,this.k=[],this.m=[];const j=e-m+(L-b),N=j+1,p=new Int32Array(N),D=new Int32Array(N),M=L-b,S=e-m,I=m-b,F=e-L,W=(S-M)%2===0;p[M]=m,D[S]=e,v[0]=!1;for(let O=1;O<=j/2+1;O++){let y=0,X=0;l=this.J(M-O,O,M,N),s=this.J(M+O,O,M,N);for(let Y=l;Y<=s;Y+=2){Y===l||Y<s&&p[Y-1]<p[Y+1]?_=p[Y+1]:_=p[Y-1]+1,$=_-(Y-M)-I;const Q=_;for(;_<e&&$<L&&this.p(_+1,$+1);)_++,$++;if(p[Y]=_,_+$>y+X&&(y=_,X=$),!W&&Math.abs(Y-S)<=O-1&&_>=D[Y])return R[0]=_,A[0]=$,Q<=D[Y]&&u.MaxDifferencesHistory>0&&O<=u.MaxDifferencesHistory+1?this.x(M,l,s,I,S,c,d,F,p,D,_,e,R,$,L,A,W,v):null}const Z=(y-m+(X-b)-O)/2;if(this.a!==null&&!this.a(y,Z))return v[0]=!0,R[0]=y,A[0]=X,Z>0&&u.MaxDifferencesHistory>0&&O<=u.MaxDifferencesHistory+1?this.x(M,l,s,I,S,c,d,F,p,D,_,e,R,$,L,A,W,v):(m++,b++,[new t.$Wt(m,e-m+1,b,L-b+1)]);c=this.J(S-O,O,S,N),d=this.J(S+O,O,S,N);for(let Y=c;Y<=d;Y+=2){Y===c||Y<d&&D[Y-1]>=D[Y+1]?_=D[Y+1]-1:_=D[Y-1],$=_-(Y-S)-F;const Q=_;for(;_>m&&$>b&&this.p(_,$);)_--,$--;if(D[Y]=_,W&&Math.abs(Y-M)<=O&&_<=p[Y])return R[0]=_,A[0]=$,Q>=p[Y]&&u.MaxDifferencesHistory>0&&O<=u.MaxDifferencesHistory+1?this.x(M,l,s,I,S,c,d,F,p,D,_,e,R,$,L,A,W,v):null}if(O<=u.MaxDifferencesHistory){let Y=new Int32Array(s-l+2);Y[0]=M-l+1,a.Copy2(p,l,Y,1,s-l+1),this.k.push(Y),Y=new Int32Array(d-c+2),Y[0]=S-c+1,a.Copy2(D,c,Y,1,d-c+1),this.m.push(Y)}}return this.x(M,l,s,I,S,c,d,F,p,D,_,e,R,$,L,A,W,v)}z(m){for(let e=0;e<m.length;e++){const b=m[e],L=e<m.length-1?m[e+1].originalStart:this.f.length,R=e<m.length-1?m[e+1].modifiedStart:this.h.length,A=b.originalLength>0,v=b.modifiedLength>0;for(;b.originalStart+b.originalLength<L&&b.modifiedStart+b.modifiedLength<R&&(!A||this.s(b.originalStart,b.originalStart+b.originalLength))&&(!v||this.u(b.modifiedStart,b.modifiedStart+b.modifiedLength));){const $=this.q(b.originalStart,b.modifiedStart);if(this.q(b.originalStart+b.originalLength,b.modifiedStart+b.modifiedLength)&&!$)break;b.originalStart++,b.modifiedStart++}const _=[null];if(e<m.length-1&&this.I(m[e],m[e+1],_)){m[e]=_[0],m.splice(e+1,1),e--;continue}}for(let e=m.length-1;e>=0;e--){const b=m[e];let L=0,R=0;if(e>0){const s=m[e-1];L=s.originalStart+s.originalLength,R=s.modifiedStart+s.modifiedLength}const A=b.originalLength>0,v=b.modifiedLength>0;let _=0,$=this.G(b.originalStart,b.originalLength,b.modifiedStart,b.modifiedLength);for(let s=1;;s++){const c=b.originalStart-s,d=b.modifiedStart-s;if(c<L||d<R||A&&!this.s(c,c+b.originalLength)||v&&!this.u(d,d+b.modifiedLength))break;const N=(c===L&&d===R?5:0)+this.G(c,b.originalLength,d,b.modifiedLength);N>$&&($=N,_=s)}b.originalStart-=_,b.modifiedStart-=_;const l=[null];if(e>0&&this.I(m[e-1],m[e],l)){m[e-1]=l[0],m.splice(e,1),e++;continue}}if(this.d)for(let e=1,b=m.length;e<b;e++){const L=m[e-1],R=m[e],A=R.originalStart-L.originalStart-L.originalLength,v=L.originalStart,_=R.originalStart+R.originalLength,$=_-v,l=L.modifiedStart,s=R.modifiedStart+R.modifiedLength,c=s-l;if(A<5&&$<20&&c<20){const d=this.A(v,$,l,c,A);if(d){const[j,N]=d;(j!==L.originalStart+L.originalLength||N!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=j-L.originalStart,L.modifiedLength=N-L.modifiedStart,R.originalStart=j+A,R.modifiedStart=N+A,R.originalLength=_-R.originalStart,R.modifiedLength=s-R.modifiedStart)}}}return m}A(m,e,b,L,R){if(e<R||L<R)return null;const A=m+e-R+1,v=b+L-R+1;let _=0,$=0,l=0;for(let s=m;s<A;s++)for(let c=b;c<v;c++){const d=this.B(s,c,R);d>0&&d>_&&(_=d,$=s,l=c)}return _>0?[$,l]:null}B(m,e,b){let L=0;for(let R=0;R<b;R++){if(!this.p(m+R,e+R))return 0;L+=this.e[m+R].length}return L}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,e){if(this.C(m)||this.C(m-1))return!0;if(e>0){const b=m+e;if(this.C(b-1)||this.C(b))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,e){if(this.E(m)||this.E(m-1))return!0;if(e>0){const b=m+e;if(this.E(b-1)||this.E(b))return!0}return!1}G(m,e,b,L){const R=this.D(m,e)?1:0,A=this.F(b,L)?1:0;return R+A}H(m,e){const b=[];if(m.length===0||e.length===0)return e.length>0?e:m;if(this.I(m[m.length-1],e[0],b)){const L=new Array(m.length+e.length-1);return a.Copy(m,0,L,0,m.length-1),L[m.length-1]=b[0],a.Copy(e,1,L,m.length,e.length-1),L}else{const L=new Array(m.length+e.length);return a.Copy(m,0,L,0,m.length),a.Copy(e,0,L,m.length,e.length),L}}I(m,e,b){if(g.Assert(m.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),g.Assert(m.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=e.originalStart||m.modifiedStart+m.modifiedLength>=e.modifiedStart){const L=m.originalStart;let R=m.originalLength;const A=m.modifiedStart;let v=m.modifiedLength;return m.originalStart+m.originalLength>=e.originalStart&&(R=e.originalStart+e.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=e.modifiedStart&&(v=e.modifiedStart+e.modifiedLength-m.modifiedStart),b[0]=new t.$Wt(L,R,A,v),!0}else return b[0]=null,!1}J(m,e,b,L){if(m>=0&&m<L)return m;const R=b,A=L-b-1,v=e%2===0;if(m<0){const _=R%2===0;return v===_?0:1}else{const _=A%2===0;return v===_?L-1:L-2}}}i.$Zt=w}),ne(ie[16],re([0,1,5,44,25,13]),function(x,i,t,n,T,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.$yc=L,i.$zc=l,T=Me(T);const E=/^\w[\w\d+.-]*$/,g=/^\//,a=/^\/\//;function u(N,p){if(!N.scheme&&p)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${N.authority}", path: "${N.path}", query: "${N.query}", fragment: "${N.fragment}"}`);if(N.scheme&&!E.test(N.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(N.path){if(N.authority){if(!g.test(N.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(N.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(N,p){return!N&&!p?"file":N}function w(N,p){switch(N){case"https":case"http":case"file":p?p[0]!==m&&(p=m+p):p=m;break}return p}const h="",m="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(p){return p instanceof b?!0:p?typeof p.authority=="string"&&typeof p.fragment=="string"&&typeof p.path=="string"&&typeof p.query=="string"&&typeof p.scheme=="string"&&typeof p.fsPath=="string"&&typeof p.with=="function"&&typeof p.toString=="function":!1}constructor(p,D,M,S,I,F=!1){typeof p=="object"?(this.scheme=p.scheme||h,this.authority=p.authority||h,this.path=p.path||h,this.query=p.query||h,this.fragment=p.fragment||h):(this.scheme=o(p,F),this.authority=D||h,this.path=w(this.scheme,M||h),this.query=S||h,this.fragment=I||h,u(this,F))}get fsPath(){return l(this,!1)}with(p){if(!p)return this;let{scheme:D,authority:M,path:S,query:I,fragment:F}=p;return D===void 0?D=this.scheme:D===null&&(D=h),M===void 0?M=this.authority:M===null&&(M=h),S===void 0?S=this.path:S===null&&(S=h),I===void 0?I=this.query:I===null&&(I=h),F===void 0?F=this.fragment:F===null&&(F=h),D===this.scheme&&M===this.authority&&S===this.path&&I===this.query&&F===this.fragment?this:new A(D,M,S,I,F)}static parse(p,D=!1){const M=e.exec(p);return M?new A(M[2]||h,j(M[4]||h),j(M[5]||h),j(M[7]||h),j(M[9]||h),D):new A(h,h,h,h,h)}static file(p){let D=h;if(f.$j&&(p=p.replace(/\\/g,m)),p[0]===m&&p[1]===m){const M=p.indexOf(m,2);M===-1?(D=p.substring(2),p=m):(D=p.substring(2,M),p=p.substring(M)||m)}return new A("file",D,p,h,h)}static from(p,D){return new A(p.scheme,p.authority,p.path,p.query,p.fragment,D)}static joinPath(p,...D){if(!p.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return f.$j&&p.scheme==="file"?M=b.file(T.$ic.join(l(p,!0),...D)).path:M=T.$jc.join(p.path,...D),p.with({path:M})}toString(p=!1){return s(this,p)}toJSON(){return this}static revive(p){if(p){if(p instanceof b)return p;{const D=new A(p);return D._formatted=p.external??null,D._fsPath=p._sep===R?p.fsPath??null:null,D}}else return p}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}i.URI=b;function L(N){return!N||typeof N!="object"?!1:typeof N.scheme=="string"&&(typeof N.authority=="string"||typeof N.authority>"u")&&(typeof N.path=="string"||typeof N.path>"u")&&(typeof N.query=="string"||typeof N.query>"u")&&(typeof N.fragment=="string"||typeof N.fragment>"u")}const R=f.$j?1:void 0;class A extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(p=!1){return p?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const p={$mid:n.MarshalledId.Uri};return this._fsPath&&(p.fsPath=this._fsPath,p._sep=R),this._formatted&&(p.external=this._formatted),this.path&&(p.path=this.path),this.scheme&&(p.scheme=this.scheme),this.authority&&(p.authority=this.authority),this.query&&(p.query=this.query),this.fragment&&(p.fragment=this.fragment),p}}const v={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function _(N,p,D){let M,S=-1;for(let I=0;I<N.length;I++){const F=N.charCodeAt(I);if(F>=t.CharCode.a&&F<=t.CharCode.z||F>=t.CharCode.A&&F<=t.CharCode.Z||F>=t.CharCode.Digit0&&F<=t.CharCode.Digit9||F===t.CharCode.Dash||F===t.CharCode.Period||F===t.CharCode.Underline||F===t.CharCode.Tilde||p&&F===t.CharCode.Slash||D&&F===t.CharCode.OpenSquareBracket||D&&F===t.CharCode.CloseSquareBracket||D&&F===t.CharCode.Colon)S!==-1&&(M+=encodeURIComponent(N.substring(S,I)),S=-1),M!==void 0&&(M+=N.charAt(I));else{M===void 0&&(M=N.substr(0,I));const B=v[F];B!==void 0?(S!==-1&&(M+=encodeURIComponent(N.substring(S,I)),S=-1),M+=B):S===-1&&(S=I)}}return S!==-1&&(M+=encodeURIComponent(N.substring(S))),M!==void 0?M:N}function $(N){let p;for(let D=0;D<N.length;D++){const M=N.charCodeAt(D);M===t.CharCode.Hash||M===t.CharCode.QuestionMark?(p===void 0&&(p=N.substr(0,D)),p+=v[M]):p!==void 0&&(p+=N[D])}return p!==void 0?p:N}function l(N,p){let D;return N.authority&&N.path.length>1&&N.scheme==="file"?D=`//${N.authority}${N.path}`:N.path.charCodeAt(0)===t.CharCode.Slash&&(N.path.charCodeAt(1)>=t.CharCode.A&&N.path.charCodeAt(1)<=t.CharCode.Z||N.path.charCodeAt(1)>=t.CharCode.a&&N.path.charCodeAt(1)<=t.CharCode.z)&&N.path.charCodeAt(2)===t.CharCode.Colon?p?D=N.path.substr(1):D=N.path[1].toLowerCase()+N.path.substr(2):D=N.path,f.$j&&(D=D.replace(/\//g,"\\")),D}function s(N,p){const D=p?$:_;let M="",{scheme:S,authority:I,path:F,query:B,fragment:W}=N;if(S&&(M+=S,M+=":"),(I||S==="file")&&(M+=m,M+=m),I){let O=I.indexOf("@");if(O!==-1){const y=I.substr(0,O);I=I.substr(O+1),O=y.lastIndexOf(":"),O===-1?M+=D(y,!1,!1):(M+=D(y.substr(0,O),!1,!1),M+=":",M+=D(y.substr(O+1),!1,!0)),M+="@"}I=I.toLowerCase(),O=I.lastIndexOf(":"),O===-1?M+=D(I,!1,!0):(M+=D(I.substr(0,O),!1,!0),M+=I.substr(O))}if(F){if(F.length>=3&&F.charCodeAt(0)===t.CharCode.Slash&&F.charCodeAt(2)===t.CharCode.Colon){const O=F.charCodeAt(1);O>=t.CharCode.A&&O<=t.CharCode.Z&&(F=`/${String.fromCharCode(O+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===t.CharCode.Colon){const O=F.charCodeAt(0);O>=t.CharCode.A&&O<=t.CharCode.Z&&(F=`${String.fromCharCode(O+32)}:${F.substr(2)}`)}M+=D(F,!0,!1)}return B&&(M+="?",M+=D(B,!1,!1)),W&&(M+="#",M+=p?W:_(W,!1,!1)),M}function c(N){try{return decodeURIComponent(N)}catch{return N.length>3?N.substr(0,3)+c(N.substr(3)):N}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function j(N){return N.match(d)?N.replace(d,p=>c(p)):N}}),ne(ie[31],re([0,1,3,13,7,16,25]),function(x,i,t,n,T,f,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.COI=i.$3g=i.$2g=i.$1g=i.$Zg=i.$Yg=i.$Xg=i.$Vg=i.$Ug=i.$Tg=i.Schemas=void 0,i.$Rg=a,i.$Sg=u,i.$Wg=w,t=Me(t),n=Me(n),E=Me(E);var g;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting",e.outputChannel="output"})(g||(i.Schemas=g={}));function a(e,b){return f.URI.isUri(e)?(0,T.$If)(e.scheme,b):(0,T.$Jf)(e,b+":")}function u(e,...b){return b.some(L=>a(e,L))}i.$Tg="vscode-tkn",i.$Ug="tkn";class o{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,L){this.f=w(b,L)}getServerRootPath(){return this.f}get g(){return E.$jc.join(this.f,g.vscodeRemoteResource)}set(b,L,R){this.a[b]=L,this.b[b]=R}setConnectionToken(b,L){this.c[b]=L}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch($){return t.$2($),b}const L=b.authority;let R=this.a[L];R&&R.indexOf(":")!==-1&&R.indexOf("[")===-1&&(R=`[${R}]`);const A=this.b[L],v=this.c[L];let _=`path=${encodeURIComponent(b.path)}`;return typeof v=="string"&&(_+=`&${i.$Ug}=${encodeURIComponent(v)}`),f.URI.from({scheme:n.$p?this.d:g.vscodeRemoteResource,authority:`${R}:${A}`,path:this.g,query:_})}}i.$Vg=new o;function w(e,b){return E.$jc.join(b??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}i.$Xg="vs/../../extensions",i.$Yg="vs/../../node_modules",i.$Zg="vs/../../node_modules.asar",i.$1g="vs/../../node_modules.asar.unpacked",i.$2g="vscode-app";class h{static{this.a=i.$2g}asBrowserUri(b){const L=this.b(b,x);return this.uriToBrowserUri(L)}uriToBrowserUri(b){return b.scheme===g.vscodeRemote?i.$Vg.rewrite(b):b.scheme===g.file&&(n.$n||n.$r===`${g.vscodeFileResource}://${h.a}`)?b.with({scheme:g.vscodeFileResource,authority:b.authority||h.a,query:null,fragment:null}):b}asFileUri(b){const L=this.b(b,x);return this.uriToFileUri(L)}uriToFileUri(b){return b.scheme===g.vscodeFileResource?b.with({scheme:g.file,authority:b.authority!==h.a?b.authority:null,query:null,fragment:null}):b}b(b,L){if(f.URI.isUri(b))return b;if(globalThis._VSCODE_FILE_ROOT){const R=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(R))return f.URI.joinPath(f.URI.parse(R,!0),b);const A=E.$mc(R,b);return f.URI.file(A)}return f.URI.parse(L.toUrl(b))}}i.$3g=new h;var m;(function(e){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(b.get("3"));const L="vscode-coi";function R(v){let _;typeof v=="string"?_=new URL(v).searchParams:v instanceof URL?_=v.searchParams:f.URI.isUri(v)&&(_=new URL(v.toString(!0)).searchParams);const $=_?.get(L);if($)return b.get($)}e.getHeadersFromQuery=R;function A(v,_,$){if(!globalThis.crossOriginIsolated)return;const l=_&&$?"3":$?"2":"1";v instanceof URLSearchParams?v.set(L,l):v[L]=l}e.addSearchParam=A})(m||(i.COI=m={}))}),ne(ie[77],re([0,1,3,14,12,31,19,13,7]),function(x,i,t,n,T,f,E,g,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=h,i.create=d,a=Me(a);const u=!1,o="$initialize";let w=!1;function h(j){g.$p&&(w||(w=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(j.message))}var m;(function(j){j[j.Request=0]="Request",j[j.Reply=1]="Reply",j[j.SubscribeEvent=2]="SubscribeEvent",j[j.Event=3]="Event",j[j.UnsubscribeEvent=4]="UnsubscribeEvent"})(m||(m={}));class e{constructor(N,p,D,M){this.vsWorker=N,this.req=p,this.method=D,this.args=M,this.type=m.Request}}class b{constructor(N,p,D,M){this.vsWorker=N,this.seq=p,this.res=D,this.err=M,this.type=m.Reply}}class L{constructor(N,p,D,M){this.vsWorker=N,this.req=p,this.eventName=D,this.arg=M,this.type=m.SubscribeEvent}}class R{constructor(N,p,D){this.vsWorker=N,this.req=p,this.event=D,this.type=m.Event}}class A{constructor(N,p){this.vsWorker=N,this.req=p,this.type=m.UnsubscribeEvent}}class v{constructor(N){this.a=-1,this.g=N,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(N){this.a=N}sendMessage(N,p){const D=String(++this.b);return new Promise((M,S)=>{this.c[D]={resolve:M,reject:S},this.o(new e(this.a,D,N,p))})}listen(N,p){let D=null;const M=new n.$oe({onWillAddFirstListener:()=>{D=String(++this.b),this.d.set(D,M),this.o(new L(this.a,D,N,p))},onDidRemoveLastListener:()=>{this.d.delete(D),this.o(new A(this.a,D)),D=null}});return M.event}handleMessage(N){!N||!N.vsWorker||this.a!==-1&&N.vsWorker!==this.a||this.h(N)}h(N){switch(N.type){case m.Reply:return this.j(N);case m.Request:return this.k(N);case m.SubscribeEvent:return this.l(N);case m.Event:return this.m(N);case m.UnsubscribeEvent:return this.n(N)}}j(N){if(!this.c[N.seq]){console.warn("Got reply to unknown seq");return}const p=this.c[N.seq];if(delete this.c[N.seq],N.err){let D=N.err;N.err.$isError&&(D=new Error,D.name=N.err.name,D.message=N.err.message,D.stack=N.err.stack),p.reject(D);return}p.resolve(N.res)}k(N){const p=N.req;this.g.handleMessage(N.method,N.args).then(M=>{this.o(new b(this.a,p,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,t.$4)(M.detail)),this.o(new b(this.a,p,void 0,(0,t.$4)(M)))})}l(N){const p=N.req,D=this.g.handleEvent(N.eventName,N.arg)(M=>{this.o(new R(this.a,p,M))});this.f.set(p,D)}m(N){if(!this.d.has(N.req)){console.warn("Got event for unknown req");return}this.d.get(N.req).fire(N.event)}n(N){if(!this.f.has(N.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(N.req).dispose(),this.f.delete(N.req)}o(N){const p=[];if(N.type===m.Request)for(let D=0;D<N.args.length;D++)N.args[D]instanceof ArrayBuffer&&p.push(N.args[D]);else N.type===m.Reply&&N.res instanceof ArrayBuffer&&p.push(N.res);this.g.sendMessage(N,p)}}class _ extends T.$Xc{constructor(N,p,D){super();let M=null;this.a=this.B(N.create({moduleId:"vs/base/common/worker/simpleWorker",esmModuleId:p},O=>{this.c.handleMessage(O)},O=>{M?.(O)})),this.c=new v({sendMessage:(O,y)=>{this.a.postMessage(O,y)},handleMessage:(O,y)=>{if(typeof D[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(D[O].apply(D,y))}catch(X){return Promise.reject(X)}},handleEvent:(O,y)=>{if(l(O)){const X=D[O].call(D,y);if(typeof X!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return X}if($(O)){const X=D[O];if(typeof X!="function")throw new Error(`Missing event ${O} on main thread host.`);return X}throw new Error(`Malformed event name ${O}`)}}),this.c.setWorkerId(this.a.getId());let S=null;const I=globalThis.require;typeof I<"u"&&typeof I.getConfig=="function"?S=I.getConfig():typeof globalThis.requirejs<"u"&&(S=globalThis.requirejs.s.contexts._.config);const F=(0,E.$ro)(D);this.b=this.c.sendMessage(o,[this.a.getId(),JSON.parse(JSON.stringify(S)),p,F]);const B=(O,y)=>this.g(O,y),W=(O,y)=>this.c.listen(O,y);this.f=new Promise((O,y)=>{M=y,this.b.then(X=>{O(s(X,B,W))},X=>{y(X),this.h("Worker failed to load "+p,X)})})}getProxyObject(){return this.f}g(N,p){return new Promise((D,M)=>{this.b.then(()=>{this.c.sendMessage(N,p).then(D,M)},M)})}h(N,p){console.error(N),console.info(p)}}i.SimpleWorkerClient=_;function $(j){return j[0]==="o"&&j[1]==="n"&&a.$Hf(j.charCodeAt(2))}function l(j){return/^onDynamic/.test(j)&&a.$Hf(j.charCodeAt(9))}function s(j,N,p){const D=I=>function(){const F=Array.prototype.slice.call(arguments,0);return N(I,F)},M=I=>function(F){return p(I,F)},S={};for(const I of j){if(l(I)){S[I]=M(I);continue}if($(I)){S[I]=p(I,void 0);continue}S[I]=D(I)}return S}class c{constructor(N,p){this.a=p,this.b=null,this.c=new v({sendMessage:(D,M)=>{N(D,M)},handleMessage:(D,M)=>this.d(D,M),handleEvent:(D,M)=>this.f(D,M)})}onmessage(N){this.c.handleMessage(N)}d(N,p){if(N===o)return this.g(p[0],p[1],p[2],p[3]);if(!this.b||typeof this.b[N]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+N));try{return Promise.resolve(this.b[N].apply(this.b,p))}catch(D){return Promise.reject(D)}}f(N,p){if(!this.b)throw new Error("Missing requestHandler");if(l(N)){const D=this.b[N].call(this.b,p);if(typeof D!="function")throw new Error(`Missing dynamic event ${N} on request handler.`);return D}if($(N)){const D=this.b[N];if(typeof D!="function")throw new Error(`Missing event ${N} on request handler.`);return D}throw new Error(`Malformed event name ${N}`)}g(N,p,D,M){this.c.setWorkerId(N);const F=s(M,(B,W)=>this.c.sendMessage(B,W),(B,W)=>this.c.listen(B,W));if(this.a)return this.b=this.a(F),Promise.resolve((0,E.$ro)(this.b));if(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy<"u"&&delete p.trustedTypesPolicy,p.catchError=!0,globalThis.require.config(p)),u){const B=f.$3g.asBrowserUri(`${D}.js`).toString(!0);return new Promise((W,O)=>{x([`${B}`],W,O)}).then(Me).then(W=>{if(this.b=W.create(F),!this.b)throw new Error("No RequestHandler!");return(0,E.$ro)(this.b)})}return new Promise((B,W)=>{(globalThis.require||x)([D],y=>{if(this.b=y.create(F),!this.b){W(new Error("No RequestHandler!"));return}B((0,E.$ro)(this.b))},W)})}}i.SimpleWorkerServer=c;function d(j){return new c(j,null)}}),ne(ie[32],re([0,1,15]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$nu=i.$mu=void 0;class n{constructor(g){const a=(0,t.$df)(g);this.c=a,this.a=n.d(a),this.b=new Map}static d(g){const a=new Uint8Array(256);return a.fill(g),a}set(g,a){const u=(0,t.$df)(a);g>=0&&g<256?this.a[g]=u:this.b.set(g,u)}get(g){return g>=0&&g<256?this.a[g]:this.b.get(g)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.$mu=n;var T;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(T||(T={}));class f{constructor(){this.a=new n(T.False)}add(g){this.a.set(g,T.True)}has(g){return this.a.get(g)===T.True}clear(){return this.a.clear()}}i.$nu=f}),ne(ie[6],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$2t=i.$1t=void 0;class n{static addRange(E,g){let a=0;for(;a<g.length&&g[a].endExclusive<E.start;)a++;let u=a;for(;u<g.length&&g[u].start<=E.endExclusive;)u++;if(a===u)g.splice(a,0,E);else{const o=Math.min(E.start,g[a].start),w=Math.max(E.endExclusive,g[u-1].endExclusive);g.splice(a,u-a,new n(o,w))}}static tryCreate(E,g){if(!(E>g))return new n(E,g)}static ofLength(E){return new n(0,E)}static ofStartAndLength(E,g){return new n(E,E+g)}constructor(E,g){if(this.start=E,this.endExclusive=g,E>g)throw new t.$eb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(E){return new n(this.start+E,this.endExclusive+E)}deltaStart(E){return new n(this.start+E,this.endExclusive)}deltaEnd(E){return new n(this.start,this.endExclusive+E)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(E){return this.start===E.start&&this.endExclusive===E.endExclusive}containsRange(E){return this.start<=E.start&&E.endExclusive<=this.endExclusive}contains(E){return this.start<=E&&E<this.endExclusive}join(E){return new n(Math.min(this.start,E.start),Math.max(this.endExclusive,E.endExclusive))}intersect(E){const g=Math.max(this.start,E.start),a=Math.min(this.endExclusive,E.endExclusive);if(g<=a)return new n(g,a)}intersects(E){const g=Math.max(this.start,E.start),a=Math.min(this.endExclusive,E.endExclusive);return g<a}intersectsOrTouches(E){const g=Math.max(this.start,E.start),a=Math.min(this.endExclusive,E.endExclusive);return g<=a}isBefore(E){return this.endExclusive<=E.start}isAfter(E){return this.start>=E.endExclusive}slice(E){return E.slice(this.start,this.endExclusive)}substring(E){return E.substring(this.start,this.endExclusive)}clip(E){if(this.isEmpty)throw new t.$eb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,E))}clipCyclic(E){if(this.isEmpty)throw new t.$eb(`Invalid clipping range: ${this.toString()}`);return E<this.start?this.endExclusive-(this.start-E)%this.length:E>=this.endExclusive?this.start+(E-this.start)%this.length:E}map(E){const g=[];for(let a=this.start;a<this.endExclusive;a++)g.push(E(a));return g}forEach(E){for(let g=this.start;g<this.endExclusive;g++)E(g)}}i.$1t=n;class T{constructor(){this.a=[]}addRange(E){let g=0;for(;g<this.a.length&&this.a[g].endExclusive<E.start;)g++;let a=g;for(;a<this.a.length&&this.a[a].start<=E.endExclusive;)a++;if(g===a)this.a.splice(g,0,E);else{const u=Math.min(E.start,this.a[g].start),o=Math.max(E.endExclusive,this.a[a-1].endExclusive);this.a.splice(g,a-g,new n(u,o))}}toString(){return this.a.map(E=>E.toString()).join(", ")}intersectsStrict(E){let g=0;for(;g<this.a.length&&this.a[g].endExclusive<=E.start;)g++;return g<this.a.length&&this.a[g].start<E.endExclusive}intersectWithRange(E){const g=new T;for(const a of this.a){const u=a.intersect(E);u&&g.addRange(u)}return g}intersectWithRangeLength(E){return this.intersectWithRange(E).length}get length(){return this.a.reduce((E,g)=>E+g.length,0)}}i.$2t=T}),ne(ie[4],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$St=void 0;class t{constructor(T,f){this.lineNumber=T,this.column=f}with(T=this.lineNumber,f=this.column){return T===this.lineNumber&&f===this.column?this:new t(T,f)}delta(T=0,f=0){return this.with(this.lineNumber+T,this.column+f)}equals(T){return t.equals(this,T)}static equals(T,f){return!T&&!f?!0:!!T&&!!f&&T.lineNumber===f.lineNumber&&T.column===f.column}isBefore(T){return t.isBefore(this,T)}static isBefore(T,f){return T.lineNumber<f.lineNumber?!0:f.lineNumber<T.lineNumber?!1:T.column<f.column}isBeforeOrEqual(T){return t.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,f){return T.lineNumber<f.lineNumber?!0:f.lineNumber<T.lineNumber?!1:T.column<=f.column}static compare(T,f){const E=T.lineNumber|0,g=f.lineNumber|0;if(E===g){const a=T.column|0,u=f.column|0;return a-u}return E-g}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new t(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.$St=t}),ne(ie[2],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Tt=void 0;class n{constructor(f,E,g,a){f>g||f===g&&E>a?(this.startLineNumber=g,this.startColumn=a,this.endLineNumber=f,this.endColumn=E):(this.startLineNumber=f,this.startColumn=E,this.endLineNumber=g,this.endColumn=a)}isEmpty(){return n.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return n.containsPosition(this,f)}static containsPosition(f,E){return!(E.lineNumber<f.startLineNumber||E.lineNumber>f.endLineNumber||E.lineNumber===f.startLineNumber&&E.column<f.startColumn||E.lineNumber===f.endLineNumber&&E.column>f.endColumn)}static strictContainsPosition(f,E){return!(E.lineNumber<f.startLineNumber||E.lineNumber>f.endLineNumber||E.lineNumber===f.startLineNumber&&E.column<=f.startColumn||E.lineNumber===f.endLineNumber&&E.column>=f.endColumn)}containsRange(f){return n.containsRange(this,f)}static containsRange(f,E){return!(E.startLineNumber<f.startLineNumber||E.endLineNumber<f.startLineNumber||E.startLineNumber>f.endLineNumber||E.endLineNumber>f.endLineNumber||E.startLineNumber===f.startLineNumber&&E.startColumn<f.startColumn||E.endLineNumber===f.endLineNumber&&E.endColumn>f.endColumn)}strictContainsRange(f){return n.strictContainsRange(this,f)}static strictContainsRange(f,E){return!(E.startLineNumber<f.startLineNumber||E.endLineNumber<f.startLineNumber||E.startLineNumber>f.endLineNumber||E.endLineNumber>f.endLineNumber||E.startLineNumber===f.startLineNumber&&E.startColumn<=f.startColumn||E.endLineNumber===f.endLineNumber&&E.endColumn>=f.endColumn)}plusRange(f){return n.plusRange(this,f)}static plusRange(f,E){let g,a,u,o;return E.startLineNumber<f.startLineNumber?(g=E.startLineNumber,a=E.startColumn):E.startLineNumber===f.startLineNumber?(g=E.startLineNumber,a=Math.min(E.startColumn,f.startColumn)):(g=f.startLineNumber,a=f.startColumn),E.endLineNumber>f.endLineNumber?(u=E.endLineNumber,o=E.endColumn):E.endLineNumber===f.endLineNumber?(u=E.endLineNumber,o=Math.max(E.endColumn,f.endColumn)):(u=f.endLineNumber,o=f.endColumn),new n(g,a,u,o)}intersectRanges(f){return n.intersectRanges(this,f)}static intersectRanges(f,E){let g=f.startLineNumber,a=f.startColumn,u=f.endLineNumber,o=f.endColumn;const w=E.startLineNumber,h=E.startColumn,m=E.endLineNumber,e=E.endColumn;return g<w?(g=w,a=h):g===w&&(a=Math.max(a,h)),u>m?(u=m,o=e):u===m&&(o=Math.min(o,e)),g>u||g===u&&a>o?null:new n(g,a,u,o)}equalsRange(f){return n.equalsRange(this,f)}static equalsRange(f,E){return!f&&!E?!0:!!f&&!!E&&f.startLineNumber===E.startLineNumber&&f.startColumn===E.startColumn&&f.endLineNumber===E.endLineNumber&&f.endColumn===E.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(f){return new t.$St(f.endLineNumber,f.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(f){return new t.$St(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,E){return new n(this.startLineNumber,this.startColumn,f,E)}setStartPosition(f,E){return new n(f,E,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(f){return new n(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(f){return new n(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new n(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,E=f){return new n(f.lineNumber,f.column,E.lineNumber,E.column)}static lift(f){return f?new n(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,E){return!(f.endLineNumber<E.startLineNumber||f.endLineNumber===E.startLineNumber&&f.endColumn<E.startColumn||E.endLineNumber<f.startLineNumber||E.endLineNumber===f.startLineNumber&&E.endColumn<f.startColumn)}static areIntersecting(f,E){return!(f.endLineNumber<E.startLineNumber||f.endLineNumber===E.startLineNumber&&f.endColumn<=E.startColumn||E.endLineNumber<f.startLineNumber||E.endLineNumber===f.startLineNumber&&E.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,E){if(f&&E){const u=f.startLineNumber|0,o=E.startLineNumber|0;if(u===o){const w=f.startColumn|0,h=E.startColumn|0;if(w===h){const m=f.endLineNumber|0,e=E.endLineNumber|0;if(m===e){const b=f.endColumn|0,L=E.endColumn|0;return b-L}return m-e}return w-h}return u-o}return(f?1:0)-(E?1:0)}static compareRangesUsingEnds(f,E){return f.endLineNumber===E.endLineNumber?f.endColumn===E.endColumn?f.startLineNumber===E.startLineNumber?f.startColumn-E.startColumn:f.startLineNumber-E.startLineNumber:f.endColumn-E.endColumn:f.endLineNumber-E.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}i.$Tt=n}),ne(ie[50],re([0,1,2]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Ut=void 0;class n{static insert(f,E){return{range:new t.$Tt(f.lineNumber,f.column,f.lineNumber,f.column),text:E,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,E){return{range:f,text:E}}static replaceMove(f,E){return{range:f,text:E,forceMoveMarkers:!0}}}i.$Ut=n}),ne(ie[17],re([0,1,3,6,2,9]),function(x,i,t,n,T,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$4t=i.$3t=void 0;class E{static fromRange(u){return new E(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new E(u.startLineNumber,u.endLineNumber+1)}static subtract(u,o){return o?u.startLineNumber<o.startLineNumber&&o.endLineNumberExclusive<u.endLineNumberExclusive?[new E(u.startLineNumber,o.startLineNumber),new E(o.endLineNumberExclusive,u.endLineNumberExclusive)]:o.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=o.endLineNumberExclusive?[]:o.endLineNumberExclusive<u.endLineNumberExclusive?[new E(Math.max(o.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new E(u.startLineNumber,Math.min(o.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let o=new g(u[0].slice());for(let w=1;w<u.length;w++)o=o.getUnion(new g(u[w].slice()));return o.ranges}static join(u){if(u.length===0)throw new t.$eb("lineRanges cannot be empty");let o=u[0].startLineNumber,w=u[0].endLineNumberExclusive;for(let h=1;h<u.length;h++)o=Math.min(o,u[h].startLineNumber),w=Math.max(w,u[h].endLineNumberExclusive);return new E(o,w)}static ofLength(u,o){return new E(u,u+o)}static deserialize(u){return new E(u[0],u[1])}constructor(u,o){if(u>o)throw new t.$eb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${o}`);this.startLineNumber=u,this.endLineNumberExclusive=o}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new E(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new E(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new E(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const o=Math.max(this.startLineNumber,u.startLineNumber),w=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(o<=w)return new E(o,w)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new T.$Tt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new T.$Tt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const o=[];for(let w=this.startLineNumber;w<this.endLineNumberExclusive;w++)o.push(u(w));return o}forEach(u){for(let o=this.startLineNumber;o<this.endLineNumberExclusive;o++)u(o)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new n.$1t(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.$3t=E;class g{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const o=(0,f.$mb)(this.c,h=>h.endLineNumberExclusive>=u.startLineNumber),w=(0,f.$kb)(this.c,h=>h.startLineNumber<=u.endLineNumberExclusive)+1;if(o===w)this.c.splice(o,0,u);else if(o===w-1){const h=this.c[o];this.c[o]=h.join(u)}else{const h=this.c[o].join(this.c[w-1]).join(u);this.c.splice(o,w-o,h)}}contains(u){const o=(0,f.$jb)(this.c,w=>w.startLineNumber<=u);return!!o&&o.endLineNumberExclusive>u}intersects(u){const o=(0,f.$jb)(this.c,w=>w.startLineNumber<u.endLineNumberExclusive);return!!o&&o.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const o=[];let w=0,h=0,m=null;for(;w<this.c.length||h<u.c.length;){let e=null;if(w<this.c.length&&h<u.c.length){const b=this.c[w],L=u.c[h];b.startLineNumber<L.startLineNumber?(e=b,w++):(e=L,h++)}else w<this.c.length?(e=this.c[w],w++):(e=u.c[h],h++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new E(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(o.push(m),m=e)}return m!==null&&o.push(m),new g(o)}subtractFrom(u){const o=(0,f.$mb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),w=(0,f.$kb)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(o===w)return new g([u]);const h=[];let m=u.startLineNumber;for(let e=o;e<w;e++){const b=this.c[e];b.startLineNumber>m&&h.push(new E(m,b.startLineNumber)),m=b.endLineNumberExclusive}return m<u.endLineNumberExclusive&&h.push(new E(m,u.endLineNumberExclusive)),new g(h)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const o=[];let w=0,h=0;for(;w<this.c.length&&h<u.c.length;){const m=this.c[w],e=u.c[h],b=m.intersect(e);b&&!b.isEmpty&&o.push(b),m.endLineNumberExclusive<e.endLineNumberExclusive?w++:h++}return new g(o)}getWithDelta(u){return new g(this.c.map(o=>o.delta(u)))}}i.$4t=g}),ne(ie[51],re([0,1,4,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Vt=i.SelectionDirection=void 0;var T;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(T||(i.SelectionDirection=T={}));class f extends n.$Tt{constructor(g,a,u,o){super(g,a,u,o),this.selectionStartLineNumber=g,this.selectionStartColumn=a,this.positionLineNumber=u,this.positionColumn=o}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return f.selectionsEqual(this,g)}static selectionsEqual(g,a){return g.selectionStartLineNumber===a.selectionStartLineNumber&&g.selectionStartColumn===a.selectionStartColumn&&g.positionLineNumber===a.positionLineNumber&&g.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?T.LTR:T.RTL}setEndPosition(g,a){return this.getDirection()===T.LTR?new f(this.startLineNumber,this.startColumn,g,a):new f(g,a,this.startLineNumber,this.startColumn)}getPosition(){return new t.$St(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.$St(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,a){return this.getDirection()===T.LTR?new f(g,a,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,g,a)}static fromPositions(g,a=g){return new f(g.lineNumber,g.column,a.lineNumber,a.column)}static fromRange(g,a){return a===T.LTR?new f(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new f(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new f(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,a){if(g&&!a||!g&&a)return!1;if(!g&&!a)return!0;if(g.length!==a.length)return!1;for(let u=0,o=g.length;u<o;u++)if(!this.selectionsEqual(g[u],a[u]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,a,u,o,w){return w===T.LTR?new f(g,a,u,o):new f(u,o,g,a)}}i.$Vt=f}),ne(ie[33],re([0,1,4,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$5t=void 0;class T{static{this.zero=new T(0,0)}static lengthDiffNonNegative(E,g){return g.isLessThan(E)?T.zero:E.lineCount===g.lineCount?new T(0,g.columnCount-E.columnCount):new T(g.lineCount-E.lineCount,g.columnCount)}static betweenPositions(E,g){return E.lineNumber===g.lineNumber?new T(0,g.column-E.column):new T(g.lineNumber-E.lineNumber,g.column-1)}static ofRange(E){return T.betweenPositions(E.getStartPosition(),E.getEndPosition())}static ofText(E){let g=0,a=0;for(const u of E)u===`
`?(g++,a=0):a++;return new T(g,a)}constructor(E,g){this.lineCount=E,this.columnCount=g}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(E){return this.lineCount!==E.lineCount?this.lineCount<E.lineCount:this.columnCount<E.columnCount}isGreaterThan(E){return this.lineCount!==E.lineCount?this.lineCount>E.lineCount:this.columnCount>E.columnCount}isGreaterThanOrEqualTo(E){return this.lineCount!==E.lineCount?this.lineCount>E.lineCount:this.columnCount>=E.columnCount}equals(E){return this.lineCount===E.lineCount&&this.columnCount===E.columnCount}compare(E){return this.lineCount!==E.lineCount?this.lineCount-E.lineCount:this.columnCount-E.columnCount}add(E){return E.lineCount===0?new T(this.lineCount,this.columnCount+E.columnCount):new T(this.lineCount+E.lineCount,E.columnCount)}createRange(E){return this.lineCount===0?new n.$Tt(E.lineNumber,E.column,E.lineNumber,E.column+this.columnCount):new n.$Tt(E.lineNumber,E.column,E.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.$Tt(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(E){return this.lineCount===0?new t.$St(E.lineNumber,E.column+this.columnCount):new t.$St(E.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.$5t=T}),ne(ie[52],re([0,1,9,6,4,2,33]),function(x,i,t,n,T,f,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$6t=void 0;class g{constructor(u){this.text=u,this.a=[],this.a.push(0);for(let o=0;o<u.length;o++)u.charAt(o)===`
`&&this.a.push(o+1)}getOffset(u){return this.a[u.lineNumber-1]+u.column-1}getOffsetRange(u){return new n.$1t(this.getOffset(u.getStartPosition()),this.getOffset(u.getEndPosition()))}getPosition(u){const o=(0,t.$kb)(this.a,m=>m<=u),w=o+1,h=u-this.a[o]+1;return new T.$St(w,h)}getRange(u){return f.$Tt.fromPositions(this.getPosition(u.start),this.getPosition(u.endExclusive))}getTextLength(u){return E.$5t.ofRange(this.getRange(u))}get textLength(){const u=this.a.length-1;return new E.$5t(u,this.text.length-this.a[u])}}i.$6t=g}),ne(ie[53],re([0,1,11,3,4,52,2,33]),function(x,i,t,n,T,f,E,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_t=i.$$t=i.$0t=i.$9t=i.$8t=i.$7t=void 0;class a{static single(L,R){return new a([new u(L,R)])}constructor(L){this.edits=L,(0,t.$kd)(()=>(0,t.$ld)(L,(R,A)=>R.range.getEndPosition().isBeforeOrEqual(A.range.getStartPosition())))}normalize(){const L=[];for(const R of this.edits)if(L.length>0&&L[L.length-1].range.getEndPosition().equals(R.range.getStartPosition())){const A=L[L.length-1];L[L.length-1]=new u(A.range.plusRange(R.range),A.text+R.text)}else R.isEmpty||L.push(R);return new a(L)}mapPosition(L){let R=0,A=0,v=0;for(const _ of this.edits){const $=_.range.getStartPosition(),l=_.range.getEndPosition();if(L.isBeforeOrEqual($))break;const s=g.$5t.ofText(_.text);if(L.isBefore(l)){const c=new T.$St($.lineNumber+R,$.column+($.lineNumber+R===A?v:0)),d=s.addToPosition(c);return o(c,d)}R+=s.lineCount-(_.range.endLineNumber-_.range.startLineNumber),s.lineCount===0?l.lineNumber!==$.lineNumber?v+=s.columnCount-(l.column-1):v+=s.columnCount-(l.column-$.column):v=s.columnCount,A=l.lineNumber+R}return new T.$St(L.lineNumber+R,L.column+(L.lineNumber+R===A?v:0))}mapRange(L){function R($){return $ instanceof T.$St?$:$.getStartPosition()}function A($){return $ instanceof T.$St?$:$.getEndPosition()}const v=R(this.mapPosition(L.getStartPosition())),_=A(this.mapPosition(L.getEndPosition()));return o(v,_)}inverseMapPosition(L,R){return this.inverse(R).mapPosition(L)}inverseMapRange(L,R){return this.inverse(R).mapRange(L)}apply(L){let R="",A=new T.$St(1,1);for(const _ of this.edits){const $=_.range,l=$.getStartPosition(),s=$.getEndPosition(),c=o(A,l);c.isEmpty()||(R+=L.getValueOfRange(c)),R+=_.text,A=s}const v=o(A,L.endPositionExclusive);return v.isEmpty()||(R+=L.getValueOfRange(v)),R}applyToString(L){const R=new e(L);return this.apply(R)}inverse(L){const R=this.getNewRanges();return new a(this.edits.map((A,v)=>new u(R[v],L.getValueOfRange(A.range))))}getNewRanges(){const L=[];let R=0,A=0,v=0;for(const _ of this.edits){const $=g.$5t.ofText(_.text),l=T.$St.lift({lineNumber:_.range.startLineNumber+A,column:_.range.startColumn+(_.range.startLineNumber===R?v:0)}),s=$.createRange(l);L.push(s),A=s.endLineNumber-_.range.endLineNumber,v=s.endColumn-_.range.endColumn,R=_.range.endLineNumber}return L}}i.$7t=a;class u{constructor(L,R){this.range=L,this.text=R}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(L,R){return L.range.equalsRange(R.range)&&L.text===R.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.$8t=u;function o(b,L){if(b.lineNumber===L.lineNumber&&b.column===Number.MAX_SAFE_INTEGER)return E.$Tt.fromPositions(L,L);if(!b.isBeforeOrEqual(L))throw new n.$eb("start must be before end");return new E.$Tt(b.lineNumber,b.column,L.lineNumber,L.column)}class w{get endPositionExclusive(){return this.length.addToPosition(new T.$St(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.$9t=w;class h extends w{constructor(L,R){(0,t.$id)(R>=1),super(),this.c=L,this.d=R}getValueOfRange(L){if(L.startLineNumber===L.endLineNumber)return this.c(L.startLineNumber).substring(L.startColumn-1,L.endColumn-1);let R=this.c(L.startLineNumber).substring(L.startColumn-1);for(let A=L.startLineNumber+1;A<L.endLineNumber;A++)R+=`
`+this.c(A);return R+=`
`+this.c(L.endLineNumber).substring(0,L.endColumn-1),R}get length(){const L=this.c(this.d);return new g.$5t(this.d-1,L.length)}}i.$0t=h;class m extends h{constructor(L){super(R=>L[R-1],L.length)}}i.$$t=m;class e extends w{constructor(L){super(),this.value=L,this.c=new f.$6t(this.value)}getValueOfRange(L){return this.c.getOffsetRange(L).substring(this.value)}get length(){return this.c.textLength}}i.$_t=e}),ne(ie[54],re([0,1,5,18,32]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ou=i.WordCharacterClass=void 0,i.$pu=a;var f;(function(u){u[u.Regular=0]="Regular",u[u.Whitespace=1]="Whitespace",u[u.WordSeparator=2]="WordSeparator"})(f||(i.WordCharacterClass=f={}));class E extends T.$mu{constructor(o,w){super(f.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=w,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let h=0,m=o.length;h<m;h++)this.set(o.charCodeAt(h),f.WordSeparator);this.set(t.CharCode.Space,f.Whitespace),this.set(t.CharCode.Tab,f.Whitespace)}findPrevIntlWordBeforeOrAtOffset(o,w){let h=null;for(const m of this.h(o)){if(m.index>w)break;h=m}return h}findNextIntlWordAtOrAfterOffset(o,w){for(const h of this.h(o))if(!(h.index<w))return h;return null}h(o){return this.e?this.f===o?this.g:(this.f=o,this.g=this.j(this.e.segment(o)),this.g):[]}j(o){const w=[];for(const h of o)this.k(h)&&w.push(h);return w}k(o){return!!o.isWordLike}}i.$ou=E;const g=new n.$Gc(10);function a(u,o){const w=`${u}/${o.join(",")}`;let h=g.get(w);return h||(h=new E(u,o),g.set(w,h)),h}}),ne(ie[34],re([0,1,23,12,24]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$st=i.$rt=void 0,i.$tt=E,i.$ut=a,i.$vt=u,i.$rt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(w=""){let h="(-?\\d*\\.\\d\\w*)|([^";for(const m of i.$rt)w.indexOf(m)>=0||(h+="\\"+m);return h+="\\s]+)",new RegExp(h,"g")}i.$st=f();function E(w){let h=i.$st;if(w&&w instanceof RegExp)if(w.global)h=w;else{let m="g";w.ignoreCase&&(m+="i"),w.multiline&&(m+="m"),w.unicode&&(m+="u"),h=new RegExp(w.source,m)}return h.lastIndex=0,h}const g=new T.$8c;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(w){const h=g.unshift(w);return(0,n.$Vc)(h)}function u(w,h,m,e,b){if(h=E(h),b||(b=t.Iterable.first(g)),m.length>b.maxLen){let _=w-b.maxLen/2;return _<0?_=0:e+=_,m=m.substring(_,w+b.maxLen/2),u(w,h,m,e,b)}const L=Date.now(),R=w-1-e;let A=-1,v=null;for(let _=1;!(Date.now()-L>=b.timeBudget);_++){const $=R-b.windowSize*_;h.lastIndex=Math.max(0,$);const l=o(h,m,R,A);if(!l&&v||(v=l,$<=0))break;A=$}if(v){const _={word:v[0],startColumn:e+1+v.index,endColumn:e+1+v.index+v[0].length};return h.lastIndex=0,_}return null}function o(w,h,m,e){let b;for(;b=w.exec(h);){const L=b.index||0;if(L<=m&&w.lastIndex>=m)return b;if(e>0&&L>e)return null}return null}}),ne(ie[10],re([0,1,8,3,6]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_4=i.$$4=i.$04=i.$94=i.$84=void 0;class f{static trivial(w,h){return new f([new E(T.$1t.ofLength(w.length),T.$1t.ofLength(h.length))],!1)}static trivialTimedOut(w,h){return new f([new E(T.$1t.ofLength(w.length),T.$1t.ofLength(h.length))],!0)}constructor(w,h){this.diffs=w,this.hitTimeout=h}}i.$84=f;class E{static invert(w,h){const m=[];return(0,t.$Db)(w,(e,b)=>{m.push(E.fromOffsetPairs(e?e.getEndExclusives():g.zero,b?b.getStarts():new g(h,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+h)))}),m}static fromOffsetPairs(w,h){return new E(new T.$1t(w.offset1,h.offset1),new T.$1t(w.offset2,h.offset2))}static assertSorted(w){let h;for(const m of w){if(h&&!(h.seq1Range.endExclusive<=m.seq1Range.start&&h.seq2Range.endExclusive<=m.seq2Range.start))throw new n.$eb("Sequence diffs must be sorted");h=m}}constructor(w,h){this.seq1Range=w,this.seq2Range=h}swap(){return new E(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(w){return new E(this.seq1Range.join(w.seq1Range),this.seq2Range.join(w.seq2Range))}delta(w){return w===0?this:new E(this.seq1Range.delta(w),this.seq2Range.delta(w))}deltaStart(w){return w===0?this:new E(this.seq1Range.deltaStart(w),this.seq2Range.deltaStart(w))}deltaEnd(w){return w===0?this:new E(this.seq1Range.deltaEnd(w),this.seq2Range.deltaEnd(w))}intersectsOrTouches(w){return this.seq1Range.intersectsOrTouches(w.seq1Range)||this.seq2Range.intersectsOrTouches(w.seq2Range)}intersect(w){const h=this.seq1Range.intersect(w.seq1Range),m=this.seq2Range.intersect(w.seq2Range);if(!(!h||!m))return new E(h,m)}getStarts(){return new g(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new g(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.$94=E;class g{static{this.zero=new g(0,0)}static{this.max=new g(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(w,h){this.offset1=w,this.offset2=h}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(w){return w===0?this:new g(this.offset1+w,this.offset2+w)}equals(w){return this.offset1===w.offset1&&this.offset2===w.offset2}}i.$04=g;class a{static{this.instance=new a}isValid(){return!0}}i.$$4=a;class u{constructor(w){if(this.e=w,this.c=Date.now(),this.d=!0,w<=0)throw new n.$eb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}i.$_4=u}),ne(ie[35],re([0,1,6,10]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$e5=void 0;class T{compute(u,o,w=n.$$4.instance){if(u.length===0||o.length===0)return n.$84.trivial(u,o);const h=u,m=o;function e(s,c){for(;s<h.length&&c<m.length&&h.getElement(s)===m.getElement(c);)s++,c++;return s}let b=0;const L=new E;L.set(0,e(0,0));const R=new g;R.set(0,L.get(0)===0?null:new f(null,0,0,L.get(0)));let A=0;e:for(;;){if(b++,!w.isValid())return n.$84.trivialTimedOut(h,m);const s=-Math.min(b,m.length+b%2),c=Math.min(b,h.length+b%2);for(A=s;A<=c;A+=2){let d=0;const j=A===c?-1:L.get(A+1),N=A===s?-1:L.get(A-1)+1;d++;const p=Math.min(Math.max(j,N),h.length),D=p-A;if(d++,p>h.length||D>m.length)continue;const M=e(p,D);L.set(A,M);const S=p===j?R.get(A+1):R.get(A-1);if(R.set(A,M!==p?new f(S,p,D,M-p):S),L.get(A)===h.length&&L.get(A)-A===m.length)break e}}let v=R.get(A);const _=[];let $=h.length,l=m.length;for(;;){const s=v?v.x+v.length:0,c=v?v.y+v.length:0;if((s!==$||c!==l)&&_.push(new n.$94(new t.$1t(s,$),new t.$1t(c,l))),!v)break;$=v.x,l=v.y,v=v.prev}return _.reverse(),new n.$84(_,!1)}}i.$e5=T;class f{constructor(u,o,w,h){this.prev=u,this.x=o,this.y=w,this.length=h}}class E{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){if(u<0){if(u=-u-1,u>=this.b.length){const w=this.b;this.b=new Int32Array(w.length*2),this.b.set(w)}this.b[u]=o}else{if(u>=this.a.length){const w=this.a;this.a=new Int32Array(w.length*2),this.a.set(w)}this.a[u]=o}}}class g{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){u<0?(u=-u-1,this.b[u]=o):this.a[u]=o}}}),ne(ie[55],re([0,1,8,6,10]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$i5=f,i.$j5=u,i.$k5=o,i.$l5=h,i.$m5=m;function f(e,b,L){let R=L;return R=E(e,b,R),R=E(e,b,R),R=g(e,b,R),R}function E(e,b,L){if(L.length===0)return L;const R=[];R.push(L[0]);for(let v=1;v<L.length;v++){const _=R[R.length-1];let $=L[v];if($.seq1Range.isEmpty||$.seq2Range.isEmpty){const l=$.seq1Range.start-_.seq1Range.endExclusive;let s;for(s=1;s<=l&&!(e.getElement($.seq1Range.start-s)!==e.getElement($.seq1Range.endExclusive-s)||b.getElement($.seq2Range.start-s)!==b.getElement($.seq2Range.endExclusive-s));s++);if(s--,s===l){R[R.length-1]=new T.$94(new n.$1t(_.seq1Range.start,$.seq1Range.endExclusive-l),new n.$1t(_.seq2Range.start,$.seq2Range.endExclusive-l));continue}$=$.delta(-s)}R.push($)}const A=[];for(let v=0;v<R.length-1;v++){const _=R[v+1];let $=R[v];if($.seq1Range.isEmpty||$.seq2Range.isEmpty){const l=_.seq1Range.start-$.seq1Range.endExclusive;let s;for(s=0;s<l&&!(!e.isStronglyEqual($.seq1Range.start+s,$.seq1Range.endExclusive+s)||!b.isStronglyEqual($.seq2Range.start+s,$.seq2Range.endExclusive+s));s++);if(s===l){R[v+1]=new T.$94(new n.$1t($.seq1Range.start+l,_.seq1Range.endExclusive),new n.$1t($.seq2Range.start+l,_.seq2Range.endExclusive));continue}s>0&&($=$.delta(s))}A.push($)}return R.length>0&&A.push(R[R.length-1]),A}function g(e,b,L){if(!e.getBoundaryScore||!b.getBoundaryScore)return L;for(let R=0;R<L.length;R++){const A=R>0?L[R-1]:void 0,v=L[R],_=R+1<L.length?L[R+1]:void 0,$=new n.$1t(A?A.seq1Range.endExclusive+1:0,_?_.seq1Range.start-1:e.length),l=new n.$1t(A?A.seq2Range.endExclusive+1:0,_?_.seq2Range.start-1:b.length);v.seq1Range.isEmpty?L[R]=a(v,e,b,$,l):v.seq2Range.isEmpty&&(L[R]=a(v.swap(),b,e,l,$).swap())}return L}function a(e,b,L,R,A){let _=1;for(;e.seq1Range.start-_>=R.start&&e.seq2Range.start-_>=A.start&&L.isStronglyEqual(e.seq2Range.start-_,e.seq2Range.endExclusive-_)&&_<100;)_++;_--;let $=0;for(;e.seq1Range.start+$<R.endExclusive&&e.seq2Range.endExclusive+$<A.endExclusive&&L.isStronglyEqual(e.seq2Range.start+$,e.seq2Range.endExclusive+$)&&$<100;)$++;if(_===0&&$===0)return e;let l=0,s=-1;for(let c=-_;c<=$;c++){const d=e.seq2Range.start+c,j=e.seq2Range.endExclusive+c,N=e.seq1Range.start+c,p=b.getBoundaryScore(N)+L.getBoundaryScore(d)+L.getBoundaryScore(j);p>s&&(s=p,l=c)}return e.delta(l)}function u(e,b,L){const R=[];for(const A of L){const v=R[R.length-1];if(!v){R.push(A);continue}A.seq1Range.start-v.seq1Range.endExclusive<=2||A.seq2Range.start-v.seq2Range.endExclusive<=2?R[R.length-1]=new T.$94(v.seq1Range.join(A.seq1Range),v.seq2Range.join(A.seq2Range)):R.push(A)}return R}function o(e,b,L){const R=T.$94.invert(L,e.length),A=[];let v=new T.$04(0,0);function _(l,s){if(l.offset1<v.offset1||l.offset2<v.offset2)return;const c=e.findWordContaining(l.offset1),d=b.findWordContaining(l.offset2);if(!c||!d)return;let j=new T.$94(c,d);const N=j.intersect(s);let p=N.seq1Range.length,D=N.seq2Range.length;for(;R.length>0;){const M=R[0];if(!(M.seq1Range.intersects(j.seq1Range)||M.seq2Range.intersects(j.seq2Range)))break;const I=e.findWordContaining(M.seq1Range.start),F=b.findWordContaining(M.seq2Range.start),B=new T.$94(I,F),W=B.intersect(M);if(p+=W.seq1Range.length,D+=W.seq2Range.length,j=j.join(B),j.seq1Range.endExclusive>=M.seq1Range.endExclusive)R.shift();else break}p+D<(j.seq1Range.length+j.seq2Range.length)*2/3&&A.push(j),v=j.getEndExclusives()}for(;R.length>0;){const l=R.shift();l.seq1Range.isEmpty||(_(l.getStarts(),l),_(l.getEndExclusives().delta(-1),l))}return w(L,A)}function w(e,b){const L=[];for(;e.length>0||b.length>0;){const R=e[0],A=b[0];let v;R&&(!A||R.seq1Range.start<A.seq1Range.start)?v=e.shift():v=b.shift(),L.length>0&&L[L.length-1].seq1Range.endExclusive>=v.seq1Range.start?L[L.length-1]=L[L.length-1].join(v):L.push(v)}return L}function h(e,b,L){let R=L;if(R.length===0)return R;let A=0,v;do{v=!1;const _=[R[0]];for(let $=1;$<R.length;$++){let c=function(j,N){const p=new n.$1t(s.seq1Range.endExclusive,l.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(j.seq1Range.length+j.seq2Range.length>5||N.seq1Range.length+N.seq2Range.length>5)};const l=R[$],s=_[_.length-1];c(s,l)?(v=!0,_[_.length-1]=_[_.length-1].join(l)):_.push(l)}R=_}while(A++<10&&v);return R}function m(e,b,L){let R=L;if(R.length===0)return R;let A=0,v;do{v=!1;const $=[R[0]];for(let l=1;l<R.length;l++){let d=function(N,p){const D=new n.$1t(c.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(D)>5||D.length>500)return!1;const S=e.getText(D).trim();if(S.length>20||S.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(N.seq1Range),F=N.seq1Range.length,B=b.countLinesIn(N.seq2Range),W=N.seq2Range.length,O=e.countLinesIn(p.seq1Range),y=p.seq1Range.length,X=b.countLinesIn(p.seq2Range),Z=p.seq2Range.length,Y=2*40+50;function Q(C){return Math.min(C,Y)}return Math.pow(Math.pow(Q(I*40+F),1.5)+Math.pow(Q(B*40+W),1.5),1.5)+Math.pow(Math.pow(Q(O*40+y),1.5)+Math.pow(Q(X*40+Z),1.5),1.5)>(Y**1.5)**1.5*1.3};const s=R[l],c=$[$.length-1];d(c,s)?(v=!0,$[$.length-1]=$[$.length-1].join(s)):$.push(s)}R=$}while(A++<10&&v);const _=[];return(0,t.$Eb)(R,($,l,s)=>{let c=l;function d(S){return S.length>0&&S.trim().length<=3&&l.seq1Range.length+l.seq2Range.length>100}const j=e.extendToFullLines(l.seq1Range),N=e.getText(new n.$1t(j.start,l.seq1Range.start));d(N)&&(c=c.deltaStart(-N.length));const p=e.getText(new n.$1t(l.seq1Range.endExclusive,j.endExclusive));d(p)&&(c=c.deltaEnd(p.length));const D=T.$94.fromOffsetPairs($?$.getEndExclusives():T.$04.zero,s?s.getStarts():T.$04.max),M=c.intersect(D);_.length>0&&M.getStarts().equals(_[_.length-1].getEndExclusives())?_[_.length-1]=_[_.length-1].join(M):_.push(M)}),_}}),ne(ie[56],re([0,1,5]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$h5=void 0;class n{constructor(E,g){this.a=E,this.b=g}getElement(E){return this.a[E]}get length(){return this.a.length}getBoundaryScore(E){const g=E===0?0:T(this.b[E-1]),a=E===this.b.length?0:T(this.b[E]);return 1e3-(g+a)}getText(E){return this.b.slice(E.start,E.endExclusive).join(`
`)}isStronglyEqual(E,g){return this.b[E]===this.b[g]}}i.$h5=n;function T(f){let E=0;for(;E<f.length&&(f.charCodeAt(E)===t.CharCode.Space||f.charCodeAt(E)===t.CharCode.Tab);)E++;return E}}),ne(ie[20],re([0,1,5]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$c5=i.$a5=void 0,i.$b5=T;class n{constructor(g,a){this.width=g,this.height=a,this.a=[],this.a=new Array(g*a)}get(g,a){return this.a[g+a*this.width]}set(g,a,u){this.a[g+a*this.width]=u}}i.$a5=n;function T(E){return E===t.CharCode.Space||E===t.CharCode.Tab}class f{static{this.a=new Map}static b(g){let a=this.a.get(g);return a===void 0&&(a=this.a.size,this.a.set(g,a)),a}constructor(g,a,u){this.range=g,this.lines=a,this.source=u,this.d=[];let o=0;for(let w=g.startLineNumber-1;w<g.endLineNumberExclusive-1;w++){const h=a[w];for(let e=0;e<h.length;e++){o++;const b=h[e],L=f.b(b);this.d[L]=(this.d[L]||0)+1}o++;const m=f.b(`
`);this.d[m]=(this.d[m]||0)+1}this.c=o}computeSimilarity(g){let a=0;const u=Math.max(this.d.length,g.d.length);for(let o=0;o<u;o++)a+=Math.abs((this.d[o]??0)-(g.d[o]??0));return 1-a/(this.c+g.c)}}i.$c5=f}),ne(ie[57],re([0,1,6,10,20]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$d5=void 0;class f{compute(g,a,u=n.$$4.instance,o){if(g.length===0||a.length===0)return n.$84.trivial(g,a);const w=new T.$a5(g.length,a.length),h=new T.$a5(g.length,a.length),m=new T.$a5(g.length,a.length);for(let _=0;_<g.length;_++)for(let $=0;$<a.length;$++){if(!u.isValid())return n.$84.trivialTimedOut(g,a);const l=_===0?0:w.get(_-1,$),s=$===0?0:w.get(_,$-1);let c;g.getElement(_)===a.getElement($)?(_===0||$===0?c=0:c=w.get(_-1,$-1),_>0&&$>0&&h.get(_-1,$-1)===3&&(c+=m.get(_-1,$-1)),c+=o?o(_,$):1):c=-1;const d=Math.max(l,s,c);if(d===c){const j=_>0&&$>0?m.get(_-1,$-1):0;m.set(_,$,j+1),h.set(_,$,3)}else d===l?(m.set(_,$,0),h.set(_,$,1)):d===s&&(m.set(_,$,0),h.set(_,$,2));w.set(_,$,d)}const e=[];let b=g.length,L=a.length;function R(_,$){(_+1!==b||$+1!==L)&&e.push(new n.$94(new t.$1t(_+1,b),new t.$1t($+1,L))),b=_,L=$}let A=g.length-1,v=a.length-1;for(;A>=0&&v>=0;)h.get(A,v)===3?(R(A,v),A--,v--):h.get(A,v)===1?A--:v--;return R(-1,-1),e.reverse(),new n.$84(e,!1)}}i.$d5=f}),ne(ie[36],re([0,1,9,5,6,4,2,20]),function(x,i,t,n,T,f,E,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$f5=void 0;class a{constructor(b,L,R){this.lines=b,this.g=L,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[],this.f=[],this.c.push(0);for(let A=this.g.startLineNumber;A<=this.g.endLineNumber;A++){let v=b[A-1],_=0;A===this.g.startLineNumber&&this.g.startColumn>1&&(_=this.g.startColumn-1,v=v.substring(_)),this.d.push(_);let $=0;if(!R){const s=v.trimStart();$=v.length-s.length,v=s.trimEnd()}this.f.push($);const l=A===this.g.endLineNumber?Math.min(this.g.endColumn-1-_-$,v.length):v.length;for(let s=0;s<l;s++)this.b.push(v.charCodeAt(s));A<this.g.endLineNumber&&(this.b.push(10),this.c.push(this.b.length))}}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new T.$1t(0,this.length))}getText(b){return this.b.slice(b.start,b.endExclusive).map(L=>String.fromCharCode(L)).join("")}getElement(b){return this.b[b]}get length(){return this.b.length}getBoundaryScore(b){const L=m(b>0?this.b[b-1]:-1),R=m(b<this.b.length?this.b[b]:-1);if(L===o.LineBreakCR&&R===o.LineBreakLF)return 0;if(L===o.LineBreakLF)return 150;let A=0;return L!==R&&(A+=10,L===o.WordLower&&R===o.WordUpper&&(A+=1)),A+=h(L),A+=h(R),A}translateOffset(b,L="right"){const R=(0,t.$kb)(this.c,v=>v<=b),A=b-this.c[R];return new f.$St(this.g.startLineNumber+R,1+this.d[R]+A+(A===0&&L==="left"?0:this.f[R]))}translateRange(b){const L=this.translateOffset(b.start,"right"),R=this.translateOffset(b.endExclusive,"left");return R.isBefore(L)?E.$Tt.fromPositions(R,R):E.$Tt.fromPositions(L,R)}findWordContaining(b){if(b<0||b>=this.b.length||!u(this.b[b]))return;let L=b;for(;L>0&&u(this.b[L-1]);)L--;let R=b;for(;R<this.b.length&&u(this.b[R]);)R++;return new T.$1t(L,R)}countLinesIn(b){return this.translateOffset(b.endExclusive).lineNumber-this.translateOffset(b.start).lineNumber}isStronglyEqual(b,L){return this.b[b]===this.b[L]}extendToFullLines(b){const L=(0,t.$jb)(this.c,A=>A<=b.start)??0,R=(0,t.$lb)(this.c,A=>b.endExclusive<=A)??this.b.length;return new T.$1t(L,R)}}i.$f5=a;function u(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var o;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(o||(o={}));const w={[o.WordLower]:0,[o.WordUpper]:0,[o.WordNumber]:0,[o.End]:10,[o.Other]:2,[o.Separator]:30,[o.Space]:3,[o.LineBreakCR]:10,[o.LineBreakLF]:10};function h(e){return w[e]}function m(e){return e===n.CharCode.LineFeed?o.LineBreakLF:e===n.CharCode.CarriageReturn?o.LineBreakCR:(0,g.$b5)(e)?o.Space:e>=n.CharCode.a&&e<=n.CharCode.z?o.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?o.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?o.WordNumber:e===-1?o.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?o.Separator:o.Other}}),ne(ie[37],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$eu=i.$du=void 0;class t{constructor(f,E,g){this.changes=f,this.moves=E,this.hitTimeout=g}}i.$du=t;class n{constructor(f,E){this.lineRangeMapping=f,this.changes=E}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}i.$eu=n}),ne(ie[21],re([0,1,3,17,4,2,53]),function(x,i,t,n,T,f,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cu=i.$bu=i.$au=void 0;class g{static inverse(m,e,b){const L=[];let R=1,A=1;for(const _ of m){const $=new g(new n.$3t(R,_.original.startLineNumber),new n.$3t(A,_.modified.startLineNumber));$.modified.isEmpty||L.push($),R=_.original.endLineNumberExclusive,A=_.modified.endLineNumberExclusive}const v=new g(new n.$3t(R,e+1),new n.$3t(A,b+1));return v.modified.isEmpty||L.push(v),L}static clip(m,e,b){const L=[];for(const R of m){const A=R.original.intersect(e),v=R.modified.intersect(b);A&&!A.isEmpty&&v&&!v.isEmpty&&L.push(new g(A,v))}return L}constructor(m,e){this.original=m,this.modified=e}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new g(this.modified,this.original)}join(m){return new g(this.original.join(m.original),this.modified.join(m.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const m=this.original.toInclusiveRange(),e=this.modified.toInclusiveRange();if(m&&e)return new w(m,e);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.$eb("not a valid diff");return new w(new f.$Tt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new f.$Tt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new w(new f.$Tt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new f.$Tt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}toRangeMapping2(m,e){if(u(this.original.endLineNumberExclusive,m)&&u(this.modified.endLineNumberExclusive,e))return new w(new f.$Tt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new f.$Tt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1));if(!this.original.isEmpty&&!this.modified.isEmpty)return new w(f.$Tt.fromPositions(new T.$St(this.original.startLineNumber,1),a(new T.$St(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),m)),f.$Tt.fromPositions(new T.$St(this.modified.startLineNumber,1),a(new T.$St(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));if(this.original.startLineNumber>1&&this.modified.startLineNumber>1)return new w(f.$Tt.fromPositions(a(new T.$St(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER),m),a(new T.$St(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),m)),f.$Tt.fromPositions(a(new T.$St(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER),e),a(new T.$St(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));throw new t.$eb}}i.$au=g;function a(h,m){if(h.lineNumber<1)return new T.$St(1,1);if(h.lineNumber>m.length)return new T.$St(m.length,m[m.length-1].length+1);const e=m[h.lineNumber-1];return h.column>e.length+1?new T.$St(h.lineNumber,e.length+1):h}function u(h,m){return h>=1&&h<=m.length}class o extends g{static fromRangeMappings(m){const e=n.$3t.join(m.map(L=>n.$3t.fromRangeInclusive(L.originalRange))),b=n.$3t.join(m.map(L=>n.$3t.fromRangeInclusive(L.modifiedRange)));return new o(e,b,m)}constructor(m,e,b){super(m,e),this.innerChanges=b}flip(){return new o(this.modified,this.original,this.innerChanges?.map(m=>m.flip()))}withInnerChangesFromLineRanges(){return new o(this.original,this.modified,[this.toRangeMapping()])}}i.$bu=o;class w{static assertSorted(m){for(let e=1;e<m.length;e++){const b=m[e-1],L=m[e];if(!(b.originalRange.getEndPosition().isBeforeOrEqual(L.originalRange.getStartPosition())&&b.modifiedRange.getEndPosition().isBeforeOrEqual(L.modifiedRange.getStartPosition())))throw new t.$eb("Range mappings must be sorted")}}constructor(m,e){this.originalRange=m,this.modifiedRange=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new w(this.modifiedRange,this.originalRange)}toTextEdit(m){const e=m.getValueOfRange(this.modifiedRange);return new E.$8t(this.originalRange,e)}}i.$cu=w}),ne(ie[58],re([0,1,10,21,8,9,18,17,36,20,35,2]),function(x,i,t,n,T,f,E,g,a,u,o,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$g5=h;function h(v,_,$,l,s,c){let{moves:d,excludedChanges:j}=e(v,_,$,c);if(!c.isValid())return[];const N=v.filter(D=>!j.has(D)),p=b(N,l,s,_,$,c);return(0,T.$2b)(d,p),d=R(d),d=d.filter(D=>{const M=D.original.toOffsetRange().slice(_).map(I=>I.trim());return M.join(`
`).length>=15&&m(M,I=>I.length>=2)>=2}),d=A(v,d),d}function m(v,_){let $=0;for(const l of v)_(l)&&$++;return $}function e(v,_,$,l){const s=[],c=v.filter(N=>N.modified.isEmpty&&N.original.length>=3).map(N=>new u.$c5(N.original,_,N)),d=new Set(v.filter(N=>N.original.isEmpty&&N.modified.length>=3).map(N=>new u.$c5(N.modified,$,N))),j=new Set;for(const N of c){let p=-1,D;for(const M of d){const S=N.computeSimilarity(M);S>p&&(p=S,D=M)}if(p>.9&&D&&(d.delete(D),s.push(new n.$au(N.range,D.range)),j.add(N.source),j.add(D.source)),!l.isValid())return{moves:s,excludedChanges:j}}return{moves:s,excludedChanges:j}}function b(v,_,$,l,s,c){const d=[],j=new E.$Kc;for(const S of v)for(let I=S.original.startLineNumber;I<S.original.endLineNumberExclusive-2;I++){const F=`${_[I-1]}:${_[I+1-1]}:${_[I+2-1]}`;j.add(F,{range:new g.$3t(I,I+3)})}const N=[];v.sort((0,T.$8b)(S=>S.modified.startLineNumber,T.$0b));for(const S of v){let I=[];for(let F=S.modified.startLineNumber;F<S.modified.endLineNumberExclusive-2;F++){const B=`${$[F-1]}:${$[F+1-1]}:${$[F+2-1]}`,W=new g.$3t(F,F+3),O=[];j.forEach(B,({range:y})=>{for(const Z of I)if(Z.originalLineRange.endLineNumberExclusive+1===y.endLineNumberExclusive&&Z.modifiedLineRange.endLineNumberExclusive+1===W.endLineNumberExclusive){Z.originalLineRange=new g.$3t(Z.originalLineRange.startLineNumber,y.endLineNumberExclusive),Z.modifiedLineRange=new g.$3t(Z.modifiedLineRange.startLineNumber,W.endLineNumberExclusive),O.push(Z);return}const X={modifiedLineRange:W,originalLineRange:y};N.push(X),O.push(X)}),I=O}if(!c.isValid())return[]}N.sort((0,T.$_b)((0,T.$8b)(S=>S.modifiedLineRange.length,T.$0b)));const p=new g.$4t,D=new g.$4t;for(const S of N){const I=S.modifiedLineRange.startLineNumber-S.originalLineRange.startLineNumber,F=p.subtractFrom(S.modifiedLineRange),B=D.subtractFrom(S.originalLineRange).getWithDelta(I),W=F.getIntersection(B);for(const O of W.ranges){if(O.length<3)continue;const y=O,X=O.delta(-I);d.push(new n.$au(X,y)),p.addRange(y),D.addRange(X)}}d.sort((0,T.$8b)(S=>S.original.startLineNumber,T.$0b));const M=new f.$ob(v);for(let S=0;S<d.length;S++){const I=d[S],F=M.findLastMonotonous(Q=>Q.original.startLineNumber<=I.original.startLineNumber),B=(0,f.$jb)(v,Q=>Q.modified.startLineNumber<=I.modified.startLineNumber),W=Math.max(I.original.startLineNumber-F.original.startLineNumber,I.modified.startLineNumber-B.modified.startLineNumber),O=M.findLastMonotonous(Q=>Q.original.startLineNumber<I.original.endLineNumberExclusive),y=(0,f.$jb)(v,Q=>Q.modified.startLineNumber<I.modified.endLineNumberExclusive),X=Math.max(O.original.endLineNumberExclusive-I.original.endLineNumberExclusive,y.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let Z;for(Z=0;Z<W;Z++){const Q=I.original.startLineNumber-Z-1,C=I.modified.startLineNumber-Z-1;if(Q>l.length||C>s.length||p.contains(C)||D.contains(Q)||!L(l[Q-1],s[C-1],c))break}Z>0&&(D.addRange(new g.$3t(I.original.startLineNumber-Z,I.original.startLineNumber)),p.addRange(new g.$3t(I.modified.startLineNumber-Z,I.modified.startLineNumber)));let Y;for(Y=0;Y<X;Y++){const Q=I.original.endLineNumberExclusive+Y,C=I.modified.endLineNumberExclusive+Y;if(Q>l.length||C>s.length||p.contains(C)||D.contains(Q)||!L(l[Q-1],s[C-1],c))break}Y>0&&(D.addRange(new g.$3t(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+Y)),p.addRange(new g.$3t(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+Y))),(Z>0||Y>0)&&(d[S]=new n.$au(new g.$3t(I.original.startLineNumber-Z,I.original.endLineNumberExclusive+Y),new g.$3t(I.modified.startLineNumber-Z,I.modified.endLineNumberExclusive+Y)))}return d}function L(v,_,$){if(v.trim()===_.trim())return!0;if(v.length>300&&_.length>300)return!1;const s=new o.$e5().compute(new a.$f5([v],new w.$Tt(1,1,1,v.length),!1),new a.$f5([_],new w.$Tt(1,1,1,_.length),!1),$);let c=0;const d=t.$94.invert(s.diffs,v.length);for(const D of d)D.seq1Range.forEach(M=>{(0,u.$b5)(v.charCodeAt(M))||c++});function j(D){let M=0;for(let S=0;S<v.length;S++)(0,u.$b5)(D.charCodeAt(S))||M++;return M}const N=j(v.length>_.length?v:_);return c/N>.6&&N>10}function R(v){if(v.length===0)return v;v.sort((0,T.$8b)($=>$.original.startLineNumber,T.$0b));const _=[v[0]];for(let $=1;$<v.length;$++){const l=_[_.length-1],s=v[$],c=s.original.startLineNumber-l.original.endLineNumberExclusive,d=s.modified.startLineNumber-l.modified.endLineNumberExclusive;if(c>=0&&d>=0&&c+d<=2){_[_.length-1]=l.join(s);continue}_.push(s)}return _}function A(v,_){const $=new f.$ob(v);return _=_.filter(l=>{const s=$.findLastMonotonous(j=>j.original.startLineNumber<l.original.endLineNumberExclusive)||new n.$au(new g.$3t(1,1),new g.$3t(1,1)),c=(0,f.$jb)(v,j=>j.modified.startLineNumber<l.modified.endLineNumberExclusive);return s!==c}),_}}),ne(ie[59],re([0,1,8,11,17,6,2,10,57,35,58,55,56,36,37,21]),function(x,i,t,n,T,f,E,g,a,u,o,w,h,m,e,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$n5=void 0,i.$o5=R,i.$p5=A;class L{constructor(){this.e=new a.$d5,this.f=new u.$e5}computeDiff($,l,s){if($.length<=1&&(0,t.$wb)($,l,(Q,C)=>Q===C))return new e.$du([],[],!1);if($.length===1&&$[0].length===0||l.length===1&&l[0].length===0)return new e.$du([new b.$bu(new T.$3t(1,$.length+1),new T.$3t(1,l.length+1),[new b.$cu(new E.$Tt(1,1,$.length,$[$.length-1].length+1),new E.$Tt(1,1,l.length,l[l.length-1].length+1))])],[],!1);const c=s.maxComputationTimeMs===0?g.$$4.instance:new g.$_4(s.maxComputationTimeMs),d=!s.ignoreTrimWhitespace,j=new Map;function N(Q){let C=j.get(Q);return C===void 0&&(C=j.size,j.set(Q,C)),C}const p=$.map(Q=>N(Q.trim())),D=l.map(Q=>N(Q.trim())),M=new h.$h5(p,$),S=new h.$h5(D,l),I=M.length+S.length<1700?this.e.compute(M,S,c,(Q,C)=>$[Q]===l[C]?l[C].length===0?.1:1+Math.log(1+l[C].length):.99):this.f.compute(M,S,c);let F=I.diffs,B=I.hitTimeout;F=(0,w.$i5)(M,S,F),F=(0,w.$l5)(M,S,F);const W=[],O=Q=>{if(d)for(let C=0;C<Q;C++){const k=y+C,G=X+C;if($[k]!==l[G]){const oe=this.j($,l,new g.$94(new f.$1t(k,k+1),new f.$1t(G,G+1)),c,d);for(const ce of oe.mappings)W.push(ce);oe.hitTimeout&&(B=!0)}}};let y=0,X=0;for(const Q of F){(0,n.$kd)(()=>Q.seq1Range.start-y===Q.seq2Range.start-X);const C=Q.seq1Range.start-y;O(C),y=Q.seq1Range.endExclusive,X=Q.seq2Range.endExclusive;const k=this.j($,l,Q,c,d);k.hitTimeout&&(B=!0);for(const G of k.mappings)W.push(G)}O($.length-y);const Z=R(W,$,l);let Y=[];return s.computeMoves&&(Y=this.h(Z,$,l,p,D,c,d)),(0,n.$kd)(()=>{function Q(k,G){if(k.lineNumber<1||k.lineNumber>G.length)return!1;const oe=G[k.lineNumber-1];return!(k.column<1||k.column>oe.length+1)}function C(k,G){return!(k.startLineNumber<1||k.startLineNumber>G.length+1||k.endLineNumberExclusive<1||k.endLineNumberExclusive>G.length+1)}for(const k of Z){if(!k.innerChanges)return!1;for(const G of k.innerChanges)if(!(Q(G.modifiedRange.getStartPosition(),l)&&Q(G.modifiedRange.getEndPosition(),l)&&Q(G.originalRange.getStartPosition(),$)&&Q(G.originalRange.getEndPosition(),$)))return!1;if(!C(k.modified,l)||!C(k.original,$))return!1}return!0}),new e.$du(Z,Y,B)}h($,l,s,c,d,j,N){return(0,o.$g5)($,l,s,c,d,j).map(M=>{const S=this.j(l,s,new g.$94(M.original.toOffsetRange(),M.modified.toOffsetRange()),j,N),I=R(S.mappings,l,s,!0);return new e.$eu(M,I)})}j($,l,s,c,d){const N=v(s).toRangeMapping2($,l),p=new m.$f5($,N.originalRange,d),D=new m.$f5(l,N.modifiedRange,d),M=p.length+D.length<500?this.e.compute(p,D,c):this.f.compute(p,D,c),S=!1;let I=M.diffs;S&&g.$94.assertSorted(I),I=(0,w.$i5)(p,D,I),S&&g.$94.assertSorted(I),I=(0,w.$k5)(p,D,I),S&&g.$94.assertSorted(I),I=(0,w.$j5)(p,D,I),S&&g.$94.assertSorted(I),I=(0,w.$m5)(p,D,I),S&&g.$94.assertSorted(I);const F=I.map(B=>new b.$cu(p.translateRange(B.seq1Range),D.translateRange(B.seq2Range)));return S&&b.$cu.assertSorted(F),{mappings:F,hitTimeout:M.hitTimeout}}}i.$n5=L;function R(_,$,l,s=!1){const c=[];for(const d of(0,t.$Cb)(_.map(j=>A(j,$,l)),(j,N)=>j.original.overlapOrTouch(N.original)||j.modified.overlapOrTouch(N.modified))){const j=d[0],N=d[d.length-1];c.push(new b.$bu(j.original.join(N.original),j.modified.join(N.modified),d.map(p=>p.innerChanges[0])))}return(0,n.$kd)(()=>!s&&c.length>0&&(c[0].modified.startLineNumber!==c[0].original.startLineNumber||l.length-c[c.length-1].modified.endLineNumberExclusive!==$.length-c[c.length-1].original.endLineNumberExclusive)?!1:(0,n.$ld)(c,(d,j)=>j.original.startLineNumber-d.original.endLineNumberExclusive===j.modified.startLineNumber-d.modified.endLineNumberExclusive&&d.original.endLineNumberExclusive<j.original.startLineNumber&&d.modified.endLineNumberExclusive<j.modified.startLineNumber)),c}function A(_,$,l){let s=0,c=0;_.modifiedRange.endColumn===1&&_.originalRange.endColumn===1&&_.originalRange.startLineNumber+s<=_.originalRange.endLineNumber&&_.modifiedRange.startLineNumber+s<=_.modifiedRange.endLineNumber&&(c=-1),_.modifiedRange.startColumn-1>=l[_.modifiedRange.startLineNumber-1].length&&_.originalRange.startColumn-1>=$[_.originalRange.startLineNumber-1].length&&_.originalRange.startLineNumber<=_.originalRange.endLineNumber+c&&_.modifiedRange.startLineNumber<=_.modifiedRange.endLineNumber+c&&(s=1);const d=new T.$3t(_.originalRange.startLineNumber+s,_.originalRange.endLineNumber+1+c),j=new T.$3t(_.modifiedRange.startLineNumber+s,_.modifiedRange.endLineNumber+1+c);return new b.$bu(d,j,[_])}function v(_){return new b.$au(new T.$3t(_.seq1Range.start+1,_.seq1Range.endExclusive+1),new T.$3t(_.seq2Range.start+1,_.seq2Range.endExclusive+1))}}),ne(ie[38],re([0,1,5,30,37,21,7,2,11,17]),function(x,i,t,n,T,f,E,g,a,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gu=i.$fu=void 0,E=Me(E);const o=3;class w{computeDiff(s,c,d){const N=new A(s,c,{maxComputationTime:d.maxComputationTimeMs,shouldIgnoreTrimWhitespace:d.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),p=[];let D=null;for(const M of N.changes){let S;M.originalEndLineNumber===0?S=new u.$3t(M.originalStartLineNumber+1,M.originalStartLineNumber+1):S=new u.$3t(M.originalStartLineNumber,M.originalEndLineNumber+1);let I;M.modifiedEndLineNumber===0?I=new u.$3t(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):I=new u.$3t(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let F=new f.$bu(S,I,M.charChanges?.map(B=>new f.$cu(new g.$Tt(B.originalStartLineNumber,B.originalStartColumn,B.originalEndLineNumber,B.originalEndColumn),new g.$Tt(B.modifiedStartLineNumber,B.modifiedStartColumn,B.modifiedEndLineNumber,B.modifiedEndColumn))));D&&(D.modified.endLineNumberExclusive===F.modified.startLineNumber||D.original.endLineNumberExclusive===F.original.startLineNumber)&&(F=new f.$bu(D.original.join(F.original),D.modified.join(F.modified),D.innerChanges&&F.innerChanges?D.innerChanges.concat(F.innerChanges):void 0),p.pop()),p.push(F),D=F}return(0,a.$kd)(()=>(0,a.$ld)(p,(M,S)=>S.original.startLineNumber-M.original.endLineNumberExclusive===S.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<S.original.startLineNumber&&M.modified.endLineNumberExclusive<S.modified.startLineNumber)),new T.$du(p,[],N.quitEarly)}}i.$fu=w;function h(l,s,c,d){return new n.$Zt(l,s,c).ComputeDiff(d)}class m{constructor(s){const c=[],d=[];for(let j=0,N=s.length;j<N;j++)c[j]=v(s[j],1),d[j]=_(s[j],1);this.lines=s,this.a=c,this.b=d}getElements(){const s=[];for(let c=0,d=this.lines.length;c<d;c++)s[c]=this.lines[c].substring(this.a[c]-1,this.b[c]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,c,d){const j=[],N=[],p=[];let D=0;for(let M=c;M<=d;M++){const S=this.lines[M],I=s?this.a[M]:1,F=s?this.b[M]:S.length+1;for(let B=I;B<F;B++)j[D]=S.charCodeAt(B-1),N[D]=M+1,p[D]=B,D++;!s&&M<d&&(j[D]=t.CharCode.LineFeed,N[D]=M+1,p[D]=S.length+1,D++)}return new e(j,N,p)}}class e{constructor(s,c,d){this.a=s,this.b=c,this.d=d}toString(){return"["+this.a.map((s,c)=>(s===t.CharCode.LineFeed?"\\n":String.fromCharCode(s))+`-(${this.b[c]},${this.d[c]})`).join(", ")+"]"}e(s,c){if(s<0||s>=c.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(s){return s>0&&s===this.b.length?this.getEndLineNumber(s-1):(this.e(s,this.b),this.b[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this.e(s,this.b),this.a[s]===t.CharCode.LineFeed?this.b[s]+1:this.b[s])}getStartColumn(s){return s>0&&s===this.d.length?this.getEndColumn(s-1):(this.e(s,this.d),this.d[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this.e(s,this.d),this.a[s]===t.CharCode.LineFeed?1:this.d[s]+1)}}class b{constructor(s,c,d,j,N,p,D,M){this.originalStartLineNumber=s,this.originalStartColumn=c,this.originalEndLineNumber=d,this.originalEndColumn=j,this.modifiedStartLineNumber=N,this.modifiedStartColumn=p,this.modifiedEndLineNumber=D,this.modifiedEndColumn=M}static createFromDiffChange(s,c,d){const j=c.getStartLineNumber(s.originalStart),N=c.getStartColumn(s.originalStart),p=c.getEndLineNumber(s.originalStart+s.originalLength-1),D=c.getEndColumn(s.originalStart+s.originalLength-1),M=d.getStartLineNumber(s.modifiedStart),S=d.getStartColumn(s.modifiedStart),I=d.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),F=d.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new b(j,N,p,D,M,S,I,F)}}function L(l){if(l.length<=1)return l;const s=[l[0]];let c=s[0];for(let d=1,j=l.length;d<j;d++){const N=l[d],p=N.originalStart-(c.originalStart+c.originalLength),D=N.modifiedStart-(c.modifiedStart+c.modifiedLength);Math.min(p,D)<o?(c.originalLength=N.originalStart+N.originalLength-c.originalStart,c.modifiedLength=N.modifiedStart+N.modifiedLength-c.modifiedStart):(s.push(N),c=N)}return s}class R{constructor(s,c,d,j,N){this.originalStartLineNumber=s,this.originalEndLineNumber=c,this.modifiedStartLineNumber=d,this.modifiedEndLineNumber=j,this.charChanges=N}static createFromDiffResult(s,c,d,j,N,p,D){let M,S,I,F,B;if(c.originalLength===0?(M=d.getStartLineNumber(c.originalStart)-1,S=0):(M=d.getStartLineNumber(c.originalStart),S=d.getEndLineNumber(c.originalStart+c.originalLength-1)),c.modifiedLength===0?(I=j.getStartLineNumber(c.modifiedStart)-1,F=0):(I=j.getStartLineNumber(c.modifiedStart),F=j.getEndLineNumber(c.modifiedStart+c.modifiedLength-1)),p&&c.originalLength>0&&c.originalLength<20&&c.modifiedLength>0&&c.modifiedLength<20&&N()){const W=d.createCharSequence(s,c.originalStart,c.originalStart+c.originalLength-1),O=j.createCharSequence(s,c.modifiedStart,c.modifiedStart+c.modifiedLength-1);if(W.getElements().length>0&&O.getElements().length>0){let y=h(W,O,N,!0).changes;D&&(y=L(y)),B=[];for(let X=0,Z=y.length;X<Z;X++)B.push(b.createFromDiffChange(y[X],W,O))}}return new R(M,S,I,F,B)}}class A{constructor(s,c,d){this.a=d.shouldComputeCharChanges,this.b=d.shouldPostProcessCharChanges,this.d=d.shouldIgnoreTrimWhitespace,this.e=d.shouldMakePrettyDiff,this.f=s,this.g=c,this.h=new m(s),this.j=new m(c),this.k=$(d.maxComputationTime),this.l=$(d.maxComputationTime===0?0:Math.min(d.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=h(this.h,this.j,this.k,this.e),c=s.changes,d=s.quitEarly;if(this.d){const D=[];for(let M=0,S=c.length;M<S;M++)D.push(R.createFromDiffResult(this.d,c[M],this.h,this.j,this.l,this.a,this.b));return{quitEarly:d,changes:D}}const j=[];let N=0,p=0;for(let D=-1,M=c.length;D<M;D++){const S=D+1<M?c[D+1]:null,I=S?S.originalStart:this.f.length,F=S?S.modifiedStart:this.g.length;for(;N<I&&p<F;){const B=this.f[N],W=this.g[p];if(B!==W){{let O=v(B,1),y=v(W,1);for(;O>1&&y>1;){const X=B.charCodeAt(O-2),Z=W.charCodeAt(y-2);if(X!==Z)break;O--,y--}(O>1||y>1)&&this.m(j,N+1,1,O,p+1,1,y)}{let O=_(B,1),y=_(W,1);const X=B.length+1,Z=W.length+1;for(;O<X&&y<Z;){const Y=B.charCodeAt(O-1),Q=B.charCodeAt(y-1);if(Y!==Q)break;O++,y++}(O<X||y<Z)&&this.m(j,N+1,O,X,p+1,y,Z)}}N++,p++}S&&(j.push(R.createFromDiffResult(this.d,S,this.h,this.j,this.l,this.a,this.b)),N+=S.originalLength,p+=S.modifiedLength)}return{quitEarly:d,changes:j}}m(s,c,d,j,N,p,D){if(this.n(s,c,d,j,N,p,D))return;let M;this.a&&(M=[new b(c,d,c,j,N,p,N,D)]),s.push(new R(c,c,N,N,M))}n(s,c,d,j,N,p,D){const M=s.length;if(M===0)return!1;const S=s[M-1];return S.originalEndLineNumber===0||S.modifiedEndLineNumber===0?!1:S.originalEndLineNumber===c&&S.modifiedEndLineNumber===N?(this.a&&S.charChanges&&S.charChanges.push(new b(c,d,c,j,N,p,N,D)),!0):S.originalEndLineNumber+1===c&&S.modifiedEndLineNumber+1===N?(S.originalEndLineNumber=c,S.modifiedEndLineNumber=N,this.a&&S.charChanges&&S.charChanges.push(new b(c,d,c,j,N,p,N,D)),!0):!1}}i.$gu=A;function v(l,s){const c=E.$xf(l);return c===-1?s:c+1}function _(l,s){const c=E.$zf(l);return c===-1?s:c+2}function $(l){if(l===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<l}}),ne(ie[60],re([0,1,38,59]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$q5=void 0,i.$q5={getLegacy:()=>new t.$fu,getDefault:()=>new n.$n5}}),ne(ie[61],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Au=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var T;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(T||(i.ColorId=T={}));var f;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(f||(i.StandardTokenType=f={}));var E;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",a[a.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(E||(i.MetadataConsts=E={}));class g{static getLanguageId(u){return(u&E.LANGUAGEID_MASK)>>>E.LANGUAGEID_OFFSET}static getTokenType(u){return(u&E.TOKEN_TYPE_MASK)>>>E.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(u){return(u&E.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(u){return(u&E.FONT_STYLE_MASK)>>>E.FONT_STYLE_OFFSET}static getForeground(u){return(u&E.FOREGROUND_MASK)>>>E.FOREGROUND_OFFSET}static getBackground(u){return(u&E.BACKGROUND_MASK)>>>E.BACKGROUND_OFFSET}static getClassNameFromMetadata(u){let w="mtk"+this.getForeground(u);const h=this.getFontStyle(u);return h&n.Italic&&(w+=" mtki"),h&n.Bold&&(w+=" mtkb"),h&n.Underline&&(w+=" mtku"),h&n.Strikethrough&&(w+=" mtks"),w}static getInlineStyleFromMetadata(u,o){const w=this.getForeground(u),h=this.getFontStyle(u);let m=`color: ${o[w]};`;h&n.Italic&&(m+="font-style: italic;"),h&n.Bold&&(m+="font-weight: bold;");let e="";return h&n.Underline&&(e+=" underline"),h&n.Strikethrough&&(e+=" line-through"),e&&(m+=`text-decoration:${e};`),m}static getPresentationFromMetadata(u){const o=this.getForeground(u),w=this.getFontStyle(u);return{foreground:o,italic:!!(w&n.Italic),bold:!!(w&n.Bold),underline:!!(w&n.Underline),strikethrough:!!(w&n.Strikethrough)}}}i.$Au=g}),ne(ie[62],re([0,1,40]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$r5=w;function n(h){const m=[];for(const e of h){const b=Number(e);(b||b===0&&e.replace(/\s/g,"")!=="")&&m.push(b)}return m}function T(h,m,e,b){return{red:h/255,blue:e/255,green:m/255,alpha:b}}function f(h,m){const e=m.index,b=m[0].length;if(!e)return;const L=h.positionAt(e);return{startLineNumber:L.lineNumber,startColumn:L.column,endLineNumber:L.lineNumber,endColumn:L.column+b}}function E(h,m){if(!h)return;const e=t.$tu.Format.CSS.parseHex(m);if(e)return{range:h,color:T(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function g(h,m,e){if(!h||m.length!==1)return;const L=m[0].values(),R=n(L);return{range:h,color:T(R[0],R[1],R[2],e?R[3]:1)}}function a(h,m,e){if(!h||m.length!==1)return;const L=m[0].values(),R=n(L),A=new t.$tu(new t.$ru(R[0],R[1]/100,R[2]/100,e?R[3]:1));return{range:h,color:T(A.rgba.r,A.rgba.g,A.rgba.b,A.rgba.a)}}function u(h,m){return typeof h=="string"?[...h.matchAll(m)]:h.findMatches(m)}function o(h){const m=[],b=u(h,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(b.length>0)for(const L of b){const R=L.filter($=>$!==void 0),A=R[1],v=R[2];if(!v)continue;let _;if(A==="rgb"){const $=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;_=g(f(h,L),u(v,$),!1)}else if(A==="rgba"){const $=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;_=g(f(h,L),u(v,$),!0)}else if(A==="hsl"){const $=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;_=a(f(h,L),u(v,$),!1)}else if(A==="hsla"){const $=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;_=a(f(h,L),u(v,$),!0)}else A==="#"&&(_=E(f(h,L),A+v));_&&m.push(_)}return m}function w(h){return!h||typeof h.getValue!="function"||typeof h.positionAt!="function"?[]:o(h)}}),ne(ie[63],re([0,1,5,32]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$34=i.$24=i.State=void 0,i.$44=m;var T;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(T||(i.State=T={}));class f{constructor(b,L,R){const A=new Uint8Array(b*L);for(let v=0,_=b*L;v<_;v++)A[v]=R;this.a=A,this.rows=b,this.cols=L}get(b,L){return this.a[b*this.cols+L]}set(b,L,R){this.a[b*this.cols+L]=R}}class E{constructor(b){let L=0,R=T.Invalid;for(let v=0,_=b.length;v<_;v++){const[$,l,s]=b[v];l>L&&(L=l),$>R&&(R=$),s>R&&(R=s)}L++,R++;const A=new f(R,L,T.Invalid);for(let v=0,_=b.length;v<_;v++){const[$,l,s]=b[v];A.set($,l,s)}this.a=A,this.b=L}nextState(b,L){return L<0||L>=this.b?T.Invalid:this.a.get(b,L)}}i.$24=E;let g=null;function a(){return g===null&&(g=new E([[T.Start,t.CharCode.h,T.H],[T.Start,t.CharCode.H,T.H],[T.Start,t.CharCode.f,T.F],[T.Start,t.CharCode.F,T.F],[T.H,t.CharCode.t,T.HT],[T.H,t.CharCode.T,T.HT],[T.HT,t.CharCode.t,T.HTT],[T.HT,t.CharCode.T,T.HTT],[T.HTT,t.CharCode.p,T.HTTP],[T.HTT,t.CharCode.P,T.HTTP],[T.HTTP,t.CharCode.s,T.BeforeColon],[T.HTTP,t.CharCode.S,T.BeforeColon],[T.HTTP,t.CharCode.Colon,T.AfterColon],[T.F,t.CharCode.i,T.FI],[T.F,t.CharCode.I,T.FI],[T.FI,t.CharCode.l,T.FIL],[T.FI,t.CharCode.L,T.FIL],[T.FIL,t.CharCode.e,T.BeforeColon],[T.FIL,t.CharCode.E,T.BeforeColon],[T.BeforeColon,t.CharCode.Colon,T.AfterColon],[T.AfterColon,t.CharCode.Slash,T.AlmostThere],[T.AlmostThere,t.CharCode.Slash,T.End]])),g}var u;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let o=null;function w(){if(o===null){o=new n.$mu(u.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<e.length;L++)o.set(e.charCodeAt(L),u.ForceTermination);const b=".,;:";for(let L=0;L<b.length;L++)o.set(b.charCodeAt(L),u.CannotEndIn)}return o}class h{static a(b,L,R,A,v){let _=v-1;do{const $=L.charCodeAt(_);if(b.get($)!==u.CannotEndIn)break;_--}while(_>A);if(A>0){const $=L.charCodeAt(A-1),l=L.charCodeAt(_);($===t.CharCode.OpenParen&&l===t.CharCode.CloseParen||$===t.CharCode.OpenSquareBracket&&l===t.CharCode.CloseSquareBracket||$===t.CharCode.OpenCurlyBrace&&l===t.CharCode.CloseCurlyBrace)&&_--}return{range:{startLineNumber:R,startColumn:A+1,endLineNumber:R,endColumn:_+2},url:L.substring(A,_+1)}}static computeLinks(b,L=a()){const R=w(),A=[];for(let v=1,_=b.getLineCount();v<=_;v++){const $=b.getLineContent(v),l=$.length;let s=0,c=0,d=0,j=T.Start,N=!1,p=!1,D=!1,M=!1;for(;s<l;){let S=!1;const I=$.charCodeAt(s);if(j===T.Accept){let F;switch(I){case t.CharCode.OpenParen:N=!0,F=u.None;break;case t.CharCode.CloseParen:F=N?u.None:u.ForceTermination;break;case t.CharCode.OpenSquareBracket:D=!0,p=!0,F=u.None;break;case t.CharCode.CloseSquareBracket:D=!1,F=p?u.None:u.ForceTermination;break;case t.CharCode.OpenCurlyBrace:M=!0,F=u.None;break;case t.CharCode.CloseCurlyBrace:F=M?u.None:u.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:d===I?F=u.ForceTermination:d===t.CharCode.SingleQuote||d===t.CharCode.DoubleQuote||d===t.CharCode.BackTick?F=u.None:F=u.ForceTermination;break;case t.CharCode.Asterisk:F=d===t.CharCode.Asterisk?u.ForceTermination:u.None;break;case t.CharCode.Pipe:F=d===t.CharCode.Pipe?u.ForceTermination:u.None;break;case t.CharCode.Space:F=D?u.None:u.ForceTermination;break;default:F=R.get(I)}F===u.ForceTermination&&(A.push(h.a(R,$,v,c,s)),S=!0)}else if(j===T.End){let F;I===t.CharCode.OpenSquareBracket?(p=!0,F=u.None):F=R.get(I),F===u.ForceTermination?S=!0:j=T.Accept}else j=L.nextState(j,I),j===T.Invalid&&(S=!0);S&&(j=T.Start,N=!1,p=!1,M=!1,c=s+1,d=I),s++}j===T.Accept&&A.push(h.a(R,$,v,c,l))}return A}}i.$34=h;function m(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:h.computeLinks(e)}}),ne(ie[64],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$54=void 0;class t{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new t}navigateValueSet(T,f,E,g,a){if(T&&f){const u=this.a(f,a);if(u)return{range:T,value:u}}if(E&&g){const u=this.a(g,a);if(u)return{range:E,value:u}}return null}a(T,f){const E=this.b(T,f);return E!==null?E:this.d(T,f)}b(T,f){const E=Math.pow(10,T.length-(T.lastIndexOf(".")+1));let g=Number(T);const a=parseFloat(T);return!isNaN(g)&&!isNaN(a)&&g===a?g===0&&!f?null:(g=Math.floor(g*E),g+=f?E:-E,String(g/E)):null}d(T,f){return this.e(this.c,T,f)}e(T,f,E){let g=null;for(let a=0,u=T.length;g===null&&a<u;a++)g=this.f(T[a],f,E);return g}f(T,f,E){let g=T.indexOf(f);return g>=0?(g+=E?1:-1,g<0?g=T.length-1:g%=T.length,T[g]):null}}i.$54=t}),ne(ie[65],re([0,1,19]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ow=i.$nw=i.$mw=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.$kw=i.$jw=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.$lw=e,i.$pw=_;var n;(function($){$[$.Left=1]="Left",$[$.Center=2]="Center",$[$.Right=4]="Right",$[$.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var T;(function($){$[$.Left=1]="Left",$[$.Center=2]="Center",$[$.Right=3]="Right"})(T||(i.GlyphMarginLane=T={}));var f;(function($){$[$.Inline=1]="Inline",$[$.Gutter=2]="Gutter"})(f||(i.MinimapPosition=f={}));var E;(function($){$[$.Normal=1]="Normal",$[$.Underlined=2]="Underlined"})(E||(i.MinimapSectionHeaderStyle=E={}));var g;(function($){$[$.Both=0]="Both",$[$.Right=1]="Right",$[$.Left=2]="Left",$[$.None=3]="None"})(g||(i.InjectedTextCursorStops=g={}));var a;(function($){$[$.TextDefined=0]="TextDefined",$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(a||(i.EndOfLinePreference=a={}));var u;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(u||(i.DefaultEndOfLine=u={}));var o;(function($){$[$.LF=0]="LF",$[$.CRLF=1]="CRLF"})(o||(i.EndOfLineSequence=o={}));class w{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,t.$lo)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}i.$jw=w;class h{constructor(l,s){this._findMatchBrand=void 0,this.range=l,this.matches=s}}i.$kw=h;var m;(function($){$[$.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",$[$.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",$[$.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",$[$.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(i.TrackedRangeStickiness=m={}));function e($){return $&&typeof $.read=="function"}var b;(function($){$[$.Left=0]="Left",$[$.Right=1]="Right",$[$.None=2]="None",$[$.LeftOfInjectedText=3]="LeftOfInjectedText",$[$.RightOfInjectedText=4]="RightOfInjectedText"})(b||(i.PositionAffinity=b={}));var L;(function($){$[$.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(L||(i.ModelConstants=L={}));class R{constructor(l,s,c,d,j,N){this.identifier=l,this.range=s,this.text=c,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=j,this._isTracked=N}}i.$mw=R;class A{constructor(l,s,c){this.regex=l,this.wordSeparators=s,this.simpleSearch=c}}i.$nw=A;class v{constructor(l,s,c){this.reverseEdits=l,this.changes=s,this.trimAutoWhitespaceLineNumbers=c}}i.$ow=v;function _($){return!$.isTooLargeForSyncing()&&!$.isForSimpleWidget}}),ne(ie[66],re([0,1,8,15]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$uw=i.$tw=i.$sw=void 0;class T{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,u){a=(0,n.$ef)(a);const o=this.a,w=this.b,h=u.length;return h===0?!1:(this.a=new Uint32Array(o.length+h),this.a.set(o.subarray(0,a),0),this.a.set(o.subarray(a),a+h),this.a.set(u,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(w.subarray(0,this.c[0]+1)),!0)}setValue(a,u){return a=(0,n.$ef)(a),u=(0,n.$ef)(u),this.a[a]===u?!1:(this.a[a]=u,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,u){a=(0,n.$ef)(a),u=(0,n.$ef)(u);const o=this.a,w=this.b;if(a>=o.length)return!1;const h=o.length-a;return u>=h&&(u=h),u===0?!1:(this.a=new Uint32Array(o.length-u),this.a.set(o.subarray(0,a),0),this.a.set(o.subarray(a+u),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(w.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,n.$ef)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),a>=this.a.length&&(a=this.a.length-1);for(let o=u;o<=a;o++)this.b[o]=this.b[o-1]+this.a[o];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let u=0,o=this.a.length-1,w=0,h=0,m=0;for(;u<=o;)if(w=u+(o-u)/2|0,h=this.b[w],m=h-this.a[w],a<m)o=w-1;else if(a>=h)u=w+1;else break;return new E(w,a-m)}}i.$sw=T;class f{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const u=this.e[a],o=u>0?this.d[u-1]:0;return new E(u,a-o)}removeValues(a,u){this.a.splice(a,u),this.f(a)}insertValues(a,u){this.a=(0,t.$Xb)(this.a,a,u),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,u=this.a.length;a<u;a++){const o=this.a[a],w=a>0?this.d[a-1]:0;this.d[a]=w+o;for(let h=0;h<o;h++)this.e[w+h]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,u){this.a[a]!==u&&(this.a[a]=u,this.f(a))}}i.$tw=f;class E{constructor(a,u){this.index=a,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=u}}i.$uw=E}),ne(ie[67],re([0,1,7,4,66]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$vw=void 0;class f{constructor(g,a,u,o){this.d=g,this.f=a,this.g=u,this.h=o,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(g){g.eol&&g.eol!==this.g&&(this.g=g.eol,this.j=null);const a=g.changes;for(const u of a)this.o(u.range),this.p(new n.$St(u.range.startLineNumber,u.range.startColumn),u.text);this.h=g.versionId,this.k=null}l(){if(!this.j){const g=this.g.length,a=this.f.length,u=new Uint32Array(a);for(let o=0;o<a;o++)u[o]=this.f[o].length+g;this.j=new T.$sw(u)}}n(g,a){this.f[g]=a,this.j&&this.j.setValue(g,this.f[g].length+this.g.length)}o(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.startLineNumber-1].substring(g.endColumn-1));return}this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.endLineNumber-1].substring(g.endColumn-1)),this.f.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this.j&&this.j.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}p(g,a){if(a.length===0)return;const u=(0,t.$vf)(a);if(u.length===1){this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+u[0]+this.f[g.lineNumber-1].substring(g.column-1));return}u[u.length-1]+=this.f[g.lineNumber-1].substring(g.column-1),this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+u[0]);const o=new Uint32Array(u.length-1);for(let w=1;w<u.length;w++)this.f.splice(g.lineNumber+w-1,0,u[w]),o[w-1]=u[w].length+this.g.length;this.j&&this.j.insertValues(g.lineNumber,o)}}i.$vw=f}),ne(ie[68],re([0,1,5,7,54,4,2,65]),function(x,i,t,n,T,f,E,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$zD=i.$xD=i.$uD=void 0,i.$vD=o,i.$wD=w,i.$yD=L,n=Me(n);const a=999;class u{constructor(v,_,$,l){this.searchString=v,this.isRegex=_,this.matchCase=$,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=o(this.searchString):v=this.searchString.indexOf(`
`)>=0;let _=null;try{_=n.$tf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!_)return null;let $=!this.isRegex&&!v;return $&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&($=this.matchCase),new g.$nw(_,this.wordSeparators?(0,T.$pu)(this.wordSeparators,[]):null,$?this.searchString:null)}}i.$uD=u;function o(A){if(!A||A.length===0)return!1;for(let v=0,_=A.length;v<_;v++){const $=A.charCodeAt(v);if($===t.CharCode.LineFeed)return!0;if($===t.CharCode.Backslash){if(v++,v>=_)break;const l=A.charCodeAt(v);if(l===t.CharCode.n||l===t.CharCode.r||l===t.CharCode.W)return!0}}return!1}function w(A,v,_){if(!_)return new g.$kw(A,null);const $=[];for(let l=0,s=v.length;l<s;l++)$[l]=v[l];return new g.$kw(A,$)}class h{constructor(v){const _=[];let $=0;for(let l=0,s=v.length;l<s;l++)v.charCodeAt(l)===t.CharCode.LineFeed&&(_[$++]=l);this.a=_}findLineFeedCountBeforeOffset(v){const _=this.a;let $=0,l=_.length-1;if(l===-1||v<=_[0])return 0;for(;$<l;){const s=$+((l-$)/2>>0);_[s]>=v?l=s-1:_[s+1]>=v?($=s,l=s):$=s+1}return $+1}}class m{static findMatches(v,_,$,l,s){const c=_.parseSearchRequest();return c?c.regex.multiline?this.b(v,$,new R(c.wordSeparators,c.regex),l,s):this.c(v,$,c,l,s):[]}static a(v,_,$,l,s,c){let d,j=0;l?(j=l.findLineFeedCountBeforeOffset(s),d=_+s+j):d=_+s;let N;if(l){const S=l.findLineFeedCountBeforeOffset(s+c.length)-j;N=d+c.length+S}else N=d+c.length;const p=v.getPositionAt(d),D=v.getPositionAt(N);return new E.$Tt(p.lineNumber,p.column,D.lineNumber,D.column)}static b(v,_,$,l,s){const c=v.getOffsetAt(_.getStartPosition()),d=v.getValueInRange(_,g.EndOfLinePreference.LF),j=v.getEOL()===`\r
`?new h(d):null,N=[];let p=0,D;for($.reset(0);D=$.next(d);)if(N[p++]=w(this.a(v,c,d,j,D.index,D[0]),D,l),p>=s)return N;return N}static c(v,_,$,l,s){const c=[];let d=0;if(_.startLineNumber===_.endLineNumber){const N=v.getLineContent(_.startLineNumber).substring(_.startColumn-1,_.endColumn-1);return d=this.d($,N,_.startLineNumber,_.startColumn-1,d,c,l,s),c}const j=v.getLineContent(_.startLineNumber).substring(_.startColumn-1);d=this.d($,j,_.startLineNumber,_.startColumn-1,d,c,l,s);for(let N=_.startLineNumber+1;N<_.endLineNumber&&d<s;N++)d=this.d($,v.getLineContent(N),N,0,d,c,l,s);if(d<s){const N=v.getLineContent(_.endLineNumber).substring(0,_.endColumn-1);d=this.d($,N,_.endLineNumber,0,d,c,l,s)}return c}static d(v,_,$,l,s,c,d,j){const N=v.wordSeparators;if(!d&&v.simpleSearch){const M=v.simpleSearch,S=M.length,I=_.length;let F=-S;for(;(F=_.indexOf(M,F+S))!==-1;)if((!N||L(N,_,I,F,S))&&(c[s++]=new g.$kw(new E.$Tt($,F+1+l,$,F+1+S+l),null),s>=j))return s;return s}const p=new R(v.wordSeparators,v.regex);let D;p.reset(0);do if(D=p.next(_),D&&(c[s++]=w(new E.$Tt($,D.index+1+l,$,D.index+1+D[0].length+l),D,d),s>=j))return s;while(D);return s}static findNextMatch(v,_,$,l){const s=_.parseSearchRequest();if(!s)return null;const c=new R(s.wordSeparators,s.regex);return s.regex.multiline?this.e(v,$,c,l):this.f(v,$,c,l)}static e(v,_,$,l){const s=new f.$St(_.lineNumber,1),c=v.getOffsetAt(s),d=v.getLineCount(),j=v.getValueInRange(new E.$Tt(s.lineNumber,s.column,d,v.getLineMaxColumn(d)),g.EndOfLinePreference.LF),N=v.getEOL()===`\r
`?new h(j):null;$.reset(_.column-1);const p=$.next(j);return p?w(this.a(v,c,j,N,p.index,p[0]),p,l):_.lineNumber!==1||_.column!==1?this.e(v,new f.$St(1,1),$,l):null}static f(v,_,$,l){const s=v.getLineCount(),c=_.lineNumber,d=v.getLineContent(c),j=this.g($,d,c,_.column,l);if(j)return j;for(let N=1;N<=s;N++){const p=(c+N-1)%s,D=v.getLineContent(p+1),M=this.g($,D,p+1,1,l);if(M)return M}return null}static g(v,_,$,l,s){v.reset(l-1);const c=v.next(_);return c?w(new E.$Tt($,c.index+1,$,c.index+1+c[0].length),c,s):null}static findPreviousMatch(v,_,$,l){const s=_.parseSearchRequest();if(!s)return null;const c=new R(s.wordSeparators,s.regex);return s.regex.multiline?this.h(v,$,c,l):this.j(v,$,c,l)}static h(v,_,$,l){const s=this.b(v,new E.$Tt(1,1,_.lineNumber,_.column),$,l,10*a);if(s.length>0)return s[s.length-1];const c=v.getLineCount();return _.lineNumber!==c||_.column!==v.getLineMaxColumn(c)?this.h(v,new f.$St(c,v.getLineMaxColumn(c)),$,l):null}static j(v,_,$,l){const s=v.getLineCount(),c=_.lineNumber,d=v.getLineContent(c).substring(0,_.column-1),j=this.k($,d,c,l);if(j)return j;for(let N=1;N<=s;N++){const p=(s+c-N-1)%s,D=v.getLineContent(p+1),M=this.k($,D,p+1,l);if(M)return M}return null}static k(v,_,$,l){let s=null,c;for(v.reset(0);c=v.next(_);)s=w(new E.$Tt($,c.index+1,$,c.index+1+c[0].length),c,l);return s}}i.$xD=m;function e(A,v,_,$,l){if($===0)return!0;const s=v.charCodeAt($-1);if(A.get(s)!==T.WordCharacterClass.Regular||s===t.CharCode.CarriageReturn||s===t.CharCode.LineFeed)return!0;if(l>0){const c=v.charCodeAt($);if(A.get(c)!==T.WordCharacterClass.Regular)return!0}return!1}function b(A,v,_,$,l){if($+l===_)return!0;const s=v.charCodeAt($+l);if(A.get(s)!==T.WordCharacterClass.Regular||s===t.CharCode.CarriageReturn||s===t.CharCode.LineFeed)return!0;if(l>0){const c=v.charCodeAt($+l-1);if(A.get(c)!==T.WordCharacterClass.Regular)return!0}return!1}function L(A,v,_,$,l){return e(A,v,_,$,l)&&b(A,v,_,$,l)}class R{constructor(v,_){this._wordSeparators=v,this.a=_,this.b=-1,this.c=0}reset(v){this.a.lastIndex=v,this.b=-1,this.c=0}next(v){const _=v.length;let $;do{if(this.b+this.c===_||($=this.a.exec(v),!$))return null;const l=$.index,s=$[0].length;if(l===this.b&&s===this.c){if(s===0){n.$Pf(v,_,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=s,!this._wordSeparators||L(this._wordSeparators,v,_,l,s))return $}while($);return null}}i.$zD=R}),ne(ie[69],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$s5=T;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function T(u,o){let w=[];if(o.findRegionSectionHeaders&&o.foldingRules?.markers){const h=f(u,o);w=w.concat(h)}if(o.findMarkSectionHeaders){const h=E(u);w=w.concat(h)}return w}function f(u,o){const w=[],h=u.getLineCount();for(let m=1;m<=h;m++){const e=u.getLineContent(m),b=e.match(o.foldingRules.markers.start);if(b){const L={startLineNumber:m,startColumn:b[0].length+1,endLineNumber:m,endColumn:e.length+1};if(L.endColumn>L.startColumn){const R={range:L,...a(e.substring(b[0].length)),shouldBeInComments:!1};(R.text||R.hasSeparatorLine)&&w.push(R)}}}return w}function E(u){const o=[],w=u.getLineCount();for(let h=1;h<=w;h++){const m=u.getLineContent(h);g(m,h,o)}return o}function g(u,o,w){t.lastIndex=0;const h=t.exec(u);if(h){const m=h.indices[1][0]+1,e=h.indices[1][1]+1,b={startLineNumber:o,startColumn:m,endLineNumber:o,endColumn:e};if(b.endColumn>b.startColumn){const L={range:b,...a(h[1]),shouldBeInComments:!0};(L.text||L.hasSeparatorLine)&&w.push(L)}}}function a(u){u=u.trim();const o=u.startsWith("-");return u=u.replace(n,""),{text:u,hasSeparatorLine:o}}}),ne(ie[70],re([0,1,2,68,7,11,34]),function(x,i,t,n,T,f,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.$14=void 0,T=Me(T);class g{static computeUnicodeHighlights(e,b,L){const R=L?L.startLineNumber:1,A=L?L.endLineNumber:e.getLineCount(),v=new o(b),_=v.getCandidateCodePoints();let $;_==="allNonBasicAscii"?$=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):$=new RegExp(`${a(Array.from(_))}`,"g");const l=new n.$zD(null,$),s=[];let c=!1,d,j=0,N=0,p=0;e:for(let D=R,M=A;D<=M;D++){const S=e.getLineContent(D),I=S.length;l.reset(0);do if(d=l.next(S),d){let F=d.index,B=d.index+d[0].length;if(F>0){const X=S.charCodeAt(F-1);T.$Mf(X)&&F--}if(B+1<I){const X=S.charCodeAt(B-1);T.$Mf(X)&&B++}const W=S.substring(F,B);let O=(0,E.$vt)(F+1,E.$st,S,0);O&&O.endColumn<=F+1&&(O=null);const y=v.shouldHighlightNonBasicASCII(W,O?O.word:null);if(y!==h.None){if(y===h.Ambiguous?j++:y===h.Invisible?N++:y===h.NonBasicASCII?p++:(0,f.$hd)(y),s.length>=1e3){c=!0;break e}s.push(new t.$Tt(D,F+1,D,B+1))}}while(d)}return{ranges:s,hasMore:c,ambiguousCharacterCount:j,invisibleCharacterCount:N,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,b){const L=new o(b);switch(L.shouldHighlightNonBasicASCII(e,null)){case h.None:return null;case h.Invisible:return{kind:u.Invisible};case h.Ambiguous:{const A=e.codePointAt(0),v=L.ambiguousCharacters.getPrimaryConfusable(A),_=T.$fg.getLocales().filter($=>!T.$fg.getInstance(new Set([...b.allowedLocales,$])).isAmbiguous(A));return{kind:u.Ambiguous,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:_}}case h.NonBasicASCII:return{kind:u.NonBasicAscii}}}}i.$14=g;function a(m,e){return`[${T.$kf(m.map(L=>String.fromCodePoint(L)).join(""))}]`}var u;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(u||(i.UnicodeHighlighterReasonKind=u={}));class o{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=T.$fg.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const b of T.$gg.codePoints)w(String.fromCodePoint(b))||e.add(b);if(this.b.ambiguousCharacters)for(const b of this.ambiguousCharacters.getConfusableCodePoints())e.add(b);for(const b of this.a)e.delete(b);return e}shouldHighlightNonBasicASCII(e,b){const L=e.codePointAt(0);if(this.a.has(L))return h.None;if(this.b.nonBasicASCII)return h.NonBasicASCII;let R=!1,A=!1;if(b)for(const v of b){const _=v.codePointAt(0),$=T.$Xf(v);R=R||$,!$&&!this.ambiguousCharacters.isAmbiguous(_)&&!T.$gg.isInvisibleCharacter(_)&&(A=!0)}return!R&&A?h.None:this.b.invisibleCharacters&&!w(e)&&T.$gg.isInvisibleCharacter(L)?h.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(L)?h.Ambiguous:h.None}}function w(m){return m===" "||m===`
`||m==="	"}var h;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(h||(h={}))}),ne(ie[71],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var T;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(T||(i.CompletionItemInsertTextRule=T={}));var f;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(f||(i.CompletionItemKind=f={}));var E;(function(r){r[r.Deprecated=1]="Deprecated"})(E||(i.CompletionItemTag=E={}));var g;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(i.CompletionTriggerKind=g={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a||(i.ContentWidgetPositionPreference=a={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(i.CursorChangeReason=u={}));var o;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(o||(i.DefaultEndOfLine=o={}));var w;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(w||(i.DocumentHighlightKind=w={}));var h;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(h||(i.EditorAutoIndentStrategy=h={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.placeholder=88]="placeholder",r[r.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",r[r.quickSuggestions=90]="quickSuggestions",r[r.quickSuggestionsDelay=91]="quickSuggestionsDelay",r[r.readOnly=92]="readOnly",r[r.readOnlyMessage=93]="readOnlyMessage",r[r.renameOnType=94]="renameOnType",r[r.renderControlCharacters=95]="renderControlCharacters",r[r.renderFinalNewline=96]="renderFinalNewline",r[r.renderLineHighlight=97]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=99]="renderValidationDecorations",r[r.renderWhitespace=100]="renderWhitespace",r[r.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",r[r.roundedSelection=102]="roundedSelection",r[r.rulers=103]="rulers",r[r.scrollbar=104]="scrollbar",r[r.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=106]="scrollBeyondLastLine",r[r.scrollPredominantAxis=107]="scrollPredominantAxis",r[r.selectionClipboard=108]="selectionClipboard",r[r.selectionHighlight=109]="selectionHighlight",r[r.selectOnLineNumbers=110]="selectOnLineNumbers",r[r.showFoldingControls=111]="showFoldingControls",r[r.showUnused=112]="showUnused",r[r.snippetSuggestions=113]="snippetSuggestions",r[r.smartSelect=114]="smartSelect",r[r.smoothScrolling=115]="smoothScrolling",r[r.stickyScroll=116]="stickyScroll",r[r.stickyTabStops=117]="stickyTabStops",r[r.stopRenderingLineAfter=118]="stopRenderingLineAfter",r[r.suggest=119]="suggest",r[r.suggestFontSize=120]="suggestFontSize",r[r.suggestLineHeight=121]="suggestLineHeight",r[r.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",r[r.suggestSelection=123]="suggestSelection",r[r.tabCompletion=124]="tabCompletion",r[r.tabIndex=125]="tabIndex",r[r.unicodeHighlighting=126]="unicodeHighlighting",r[r.unusualLineTerminators=127]="unusualLineTerminators",r[r.useShadowDOM=128]="useShadowDOM",r[r.useTabStops=129]="useTabStops",r[r.wordBreak=130]="wordBreak",r[r.wordSegmenterLocales=131]="wordSegmenterLocales",r[r.wordSeparators=132]="wordSeparators",r[r.wordWrap=133]="wordWrap",r[r.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=136]="wordWrapColumn",r[r.wordWrapOverride1=137]="wordWrapOverride1",r[r.wordWrapOverride2=138]="wordWrapOverride2",r[r.wrappingIndent=139]="wrappingIndent",r[r.wrappingStrategy=140]="wrappingStrategy",r[r.showDeprecated=141]="showDeprecated",r[r.inlayHints=142]="inlayHints",r[r.editorClassName=143]="editorClassName",r[r.pixelRatio=144]="pixelRatio",r[r.tabFocusMode=145]="tabFocusMode",r[r.layoutInfo=146]="layoutInfo",r[r.wrappingInfo=147]="wrappingInfo",r[r.defaultColorDecorators=148]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(m||(i.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var b;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(b||(i.EndOfLineSequence=b={}));var L;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(L||(i.GlyphMarginLane=L={}));var R;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(R||(i.HoverVerbosityAction=R={}));var A;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(A||(i.IndentAction=A={}));var v;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(v||(i.InjectedTextCursorStops=v={}));var _;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(_||(i.InlayHintKind=_={}));var $;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})($||(i.InlineCompletionTriggerKind=$={}));var l;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(l||(i.InlineEditTriggerKind=l={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(i.KeyCode=s={}));var c;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(c||(i.MarkerSeverity=c={}));var d;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(d||(i.MarkerTag=d={}));var j;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(j||(i.MinimapPosition=j={}));var N;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(N||(i.MinimapSectionHeaderStyle=N={}));var p;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(p||(i.MouseTargetType=p={}));var D;(function(r){r[r.AIGenerated=1]="AIGenerated"})(D||(i.NewSymbolNameTag=D={}));var M;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(M||(i.NewSymbolNameTriggerKind=M={}));var S;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(S||(i.OverlayWidgetPositionPreference=S={}));var I;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(I||(i.OverviewRulerLane=I={}));var F;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(F||(i.PartialAcceptTriggerKind=F={}));var B;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(B||(i.PositionAffinity=B={}));var W;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(W||(i.RenderLineNumbersType=W={}));var O;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(O||(i.RenderMinimap=O={}));var y;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(y||(i.ScrollType=y={}));var X;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(X||(i.ScrollbarVisibility=X={}));var Z;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(Z||(i.SelectionDirection=Z={}));var Y;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(Y||(i.ShowLightbulbIconMode=Y={}));var Q;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(Q||(i.SignatureHelpTriggerKind=Q={}));var C;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(C||(i.SymbolKind=C={}));var k;(function(r){r[r.Deprecated=1]="Deprecated"})(k||(i.SymbolTag=k={}));var G;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(G||(i.TextEditorCursorBlinkingStyle=G={}));var oe;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(oe||(i.TextEditorCursorStyle=oe={}));var ce;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ce||(i.TrackedRangeStickiness=ce={}));var we;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(we||(i.WrappingIndent=we={}))}),ne(ie[72],re([0,1,14,12,61]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Du=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$oe,this.onDidChange=this.c.event,this.d=null}handleChange(a){this.c.fire({changedLanguages:a,changedColorMap:!1})}register(a,u){return this.a.set(a,u),this.handleChange([a]),(0,n.$Vc)(()=>{this.a.get(a)===u&&(this.a.delete(a),this.handleChange([a]))})}get(a){return this.a.get(a)||null}registerFactory(a,u){this.b.get(a)?.dispose();const o=new E(this,a,u);return this.b.set(a,o),(0,n.$Vc)(()=>{const w=this.b.get(a);!w||w!==o||(this.b.delete(a),w.dispose())})}async getOrCreate(a){const u=this.get(a);if(u)return u;const o=this.b.get(a);return!o||o.isResolved?null:(await o.resolve(),this.get(a))}isResolved(a){if(this.get(a))return!0;const o=this.b.get(a);return!!(!o||o.isResolved)}setColorMap(a){this.d=a,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>T.ColorId.DefaultBackground?this.d[T.ColorId.DefaultBackground]:null}}i.$Du=f;class E extends n.$Xc{get isResolved(){return this.c}constructor(a,u,o){super(),this.f=a,this.g=u,this.h=o,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const a=await this.h.tokenizationSupport;this.c=!0,a&&!this.a&&this.B(this.f.register(this.g,a))}}}),ne(ie[73],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=T,i.localize2=E;const t=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function n(g,a){let u;return a.length===0?u=g:u=g.replace(/\{(\d+)\}/g,(o,w)=>{const h=w[0],m=a[h];let e=o;return typeof m=="string"?e=m:(typeof m=="number"||typeof m=="boolean"||m===void 0||m===null)&&(e=String(m)),e}),t&&(u="\uFF3B"+u.replace(/[aouei]/g,"$&$&")+"\uFF3D"),u}function T(g,a,...u){return n(typeof g=="number"?f(g,a):a,u)}function f(g,a){const u=globalThis._VSCODE_NLS_MESSAGES?.[g];if(typeof u!="string"){if(typeof a=="string")return a;throw new Error(`!!! NLS MISSING: ${g} !!!`)}return u}function E(g,a,...u){let o;typeof g=="number"?o=f(g,a):o=a;const w=n(o,u);return{value:w,original:a===o?w:n(a,u)}}}),ne(ie[74],re([0,1,48,16,50,2,72,73]),function(x,i,t,n,T,f,E,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.$Xu=i.$Wu=i.$Vu=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.$Uu=i.$Tu=i.SymbolKinds=i.SymbolTag=i.$Ru=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.$Pu=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.$Ou=i.$Nu=i.$Mu=void 0,i.$Qu=c,i.$Su=j;class a{constructor(G,oe,ce){this.offset=G,this.type=oe,this.language=ce,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.$Mu=a;class u{constructor(G,oe){this.tokens=G,this.endState=oe,this._tokenizationResultBrand=void 0}}i.$Nu=u;class o{constructor(G,oe){this.tokens=G,this.endState=oe,this._encodedTokenizationResultBrand=void 0}}i.$Ou=o;var w;(function(k){k[k.Increase=0]="Increase",k[k.Decrease=1]="Decrease"})(w||(i.HoverVerbosityAction=w={}));var h;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(h||(i.CompletionItemKind=h={}));var m;(function(k){const G=new Map;G.set(h.Method,t.$8j.symbolMethod),G.set(h.Function,t.$8j.symbolFunction),G.set(h.Constructor,t.$8j.symbolConstructor),G.set(h.Field,t.$8j.symbolField),G.set(h.Variable,t.$8j.symbolVariable),G.set(h.Class,t.$8j.symbolClass),G.set(h.Struct,t.$8j.symbolStruct),G.set(h.Interface,t.$8j.symbolInterface),G.set(h.Module,t.$8j.symbolModule),G.set(h.Property,t.$8j.symbolProperty),G.set(h.Event,t.$8j.symbolEvent),G.set(h.Operator,t.$8j.symbolOperator),G.set(h.Unit,t.$8j.symbolUnit),G.set(h.Value,t.$8j.symbolValue),G.set(h.Enum,t.$8j.symbolEnum),G.set(h.Constant,t.$8j.symbolConstant),G.set(h.Enum,t.$8j.symbolEnum),G.set(h.EnumMember,t.$8j.symbolEnumMember),G.set(h.Keyword,t.$8j.symbolKeyword),G.set(h.Snippet,t.$8j.symbolSnippet),G.set(h.Text,t.$8j.symbolText),G.set(h.Color,t.$8j.symbolColor),G.set(h.File,t.$8j.symbolFile),G.set(h.Reference,t.$8j.symbolReference),G.set(h.Customcolor,t.$8j.symbolCustomColor),G.set(h.Folder,t.$8j.symbolFolder),G.set(h.TypeParameter,t.$8j.symbolTypeParameter),G.set(h.User,t.$8j.account),G.set(h.Issue,t.$8j.issues);function oe(r){let Te=G.get(r);return Te||(console.info("No codicon found for CompletionItemKind "+r),Te=t.$8j.symbolProperty),Te}k.toIcon=oe;const ce=new Map;ce.set("method",h.Method),ce.set("function",h.Function),ce.set("constructor",h.Constructor),ce.set("field",h.Field),ce.set("variable",h.Variable),ce.set("class",h.Class),ce.set("struct",h.Struct),ce.set("interface",h.Interface),ce.set("module",h.Module),ce.set("property",h.Property),ce.set("event",h.Event),ce.set("operator",h.Operator),ce.set("unit",h.Unit),ce.set("value",h.Value),ce.set("constant",h.Constant),ce.set("enum",h.Enum),ce.set("enum-member",h.EnumMember),ce.set("enumMember",h.EnumMember),ce.set("keyword",h.Keyword),ce.set("snippet",h.Snippet),ce.set("text",h.Text),ce.set("color",h.Color),ce.set("file",h.File),ce.set("reference",h.Reference),ce.set("customcolor",h.Customcolor),ce.set("folder",h.Folder),ce.set("type-parameter",h.TypeParameter),ce.set("typeParameter",h.TypeParameter),ce.set("account",h.User),ce.set("issue",h.Issue);function we(r,Te){let Pe=ce.get(r);return typeof Pe>"u"&&!Te&&(Pe=h.Property),Pe}k.fromString=we})(m||(i.CompletionItemKinds=m={}));var e;(function(k){k[k.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var b;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(b||(i.CompletionItemInsertTextRule=b={}));var L;(function(k){k[k.Word=0]="Word",k[k.Line=1]="Line",k[k.Suggest=2]="Suggest"})(L||(i.PartialAcceptTriggerKind=L={}));var R;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(R||(i.CompletionTriggerKind=R={}));var A;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})(A||(i.InlineCompletionTriggerKind=A={}));class v{constructor(G,oe,ce,we){this.range=G,this.text=oe,this.completionKind=ce,this.isSnippetText=we}equals(G){return f.$Tt.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}i.$Pu=v;var _;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})(_||(i.CodeActionTriggerType=_={}));var $;(function(k){k[k.Automatic=0]="Automatic",k[k.PasteAs=1]="PasteAs"})($||(i.DocumentPasteTriggerKind=$={}));var l;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(l||(i.SignatureHelpTriggerKind=l={}));var s;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(s||(i.DocumentHighlightKind=s={}));function c(k){return k&&n.URI.isUri(k.uri)&&f.$Tt.isIRange(k.range)&&(f.$Tt.isIRange(k.originSelectionRange)||f.$Tt.isIRange(k.targetSelectionRange))}var d;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(d||(i.SymbolKind=d={})),i.$Ru={[d.Array]:(0,g.localize)(786,null),[d.Boolean]:(0,g.localize)(787,null),[d.Class]:(0,g.localize)(788,null),[d.Constant]:(0,g.localize)(789,null),[d.Constructor]:(0,g.localize)(790,null),[d.Enum]:(0,g.localize)(791,null),[d.EnumMember]:(0,g.localize)(792,null),[d.Event]:(0,g.localize)(793,null),[d.Field]:(0,g.localize)(794,null),[d.File]:(0,g.localize)(795,null),[d.Function]:(0,g.localize)(796,null),[d.Interface]:(0,g.localize)(797,null),[d.Key]:(0,g.localize)(798,null),[d.Method]:(0,g.localize)(799,null),[d.Module]:(0,g.localize)(800,null),[d.Namespace]:(0,g.localize)(801,null),[d.Null]:(0,g.localize)(802,null),[d.Number]:(0,g.localize)(803,null),[d.Object]:(0,g.localize)(804,null),[d.Operator]:(0,g.localize)(805,null),[d.Package]:(0,g.localize)(806,null),[d.Property]:(0,g.localize)(807,null),[d.String]:(0,g.localize)(808,null),[d.Struct]:(0,g.localize)(809,null),[d.TypeParameter]:(0,g.localize)(810,null),[d.Variable]:(0,g.localize)(811,null)};function j(k,G){return(0,g.localize)(812,null,k,i.$Ru[G])}var N;(function(k){k[k.Deprecated=1]="Deprecated"})(N||(i.SymbolTag=N={}));var p;(function(k){const G=new Map;G.set(d.File,t.$8j.symbolFile),G.set(d.Module,t.$8j.symbolModule),G.set(d.Namespace,t.$8j.symbolNamespace),G.set(d.Package,t.$8j.symbolPackage),G.set(d.Class,t.$8j.symbolClass),G.set(d.Method,t.$8j.symbolMethod),G.set(d.Property,t.$8j.symbolProperty),G.set(d.Field,t.$8j.symbolField),G.set(d.Constructor,t.$8j.symbolConstructor),G.set(d.Enum,t.$8j.symbolEnum),G.set(d.Interface,t.$8j.symbolInterface),G.set(d.Function,t.$8j.symbolFunction),G.set(d.Variable,t.$8j.symbolVariable),G.set(d.Constant,t.$8j.symbolConstant),G.set(d.String,t.$8j.symbolString),G.set(d.Number,t.$8j.symbolNumber),G.set(d.Boolean,t.$8j.symbolBoolean),G.set(d.Array,t.$8j.symbolArray),G.set(d.Object,t.$8j.symbolObject),G.set(d.Key,t.$8j.symbolKey),G.set(d.Null,t.$8j.symbolNull),G.set(d.EnumMember,t.$8j.symbolEnumMember),G.set(d.Struct,t.$8j.symbolStruct),G.set(d.Event,t.$8j.symbolEvent),G.set(d.Operator,t.$8j.symbolOperator),G.set(d.TypeParameter,t.$8j.symbolTypeParameter);function oe(ce){let we=G.get(ce);return we||(console.info("No codicon found for SymbolKind "+ce),we=t.$8j.symbolProperty),we}k.toIcon=oe})(p||(i.SymbolKinds=p={}));class D{static asEditOperation(G){return T.$Ut.replace(f.$Tt.lift(G.range),G.text)}}i.$Tu=D;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(G){switch(G){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(G)}constructor(G){this.value=G}}i.$Uu=M;var S;(function(k){k[k.AIGenerated=1]="AIGenerated"})(S||(i.NewSymbolNameTag=S={}));var I;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(I||(i.NewSymbolNameTriggerKind=I={}));var F;(function(k){function G(oe){return!oe||typeof oe!="object"?!1:typeof oe.id=="string"&&typeof oe.title=="string"}k.is=G})(F||(i.Command=F={}));var B;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(B||(i.CommentThreadCollapsibleState=B={}));var W;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(W||(i.CommentThreadState=W={}));var O;(function(k){k[k.Current=0]="Current",k[k.Outdated=1]="Outdated"})(O||(i.CommentThreadApplicability=O={}));var y;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(y||(i.CommentMode=y={}));var X;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(X||(i.CommentState=X={}));var Z;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(Z||(i.InlayHintKind=Z={}));class Y{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}i.$Vu=Y,i.$Wu=new E.$Du,i.$Xu=new E.$Du;var Q;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(Q||(i.ExternalUriOpenerPriority=Q={}));var C;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(C||(i.InlineEditTriggerKind=C={}))}),ne(ie[75],re([0,1,27,14,42,16,4,2,51,74,71]),function(x,i,t,n,T,f,E,g,a,u,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$64=void 0,i.$74=h,o=Me(o);class w{static{this.CtrlCmd=T.KeyMod.CtrlCmd}static{this.Shift=T.KeyMod.Shift}static{this.Alt=T.KeyMod.Alt}static{this.WinCtrl=T.KeyMod.WinCtrl}static chord(e,b){return(0,T.$4r)(e,b)}}i.$64=w;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.$ze,Emitter:n.$oe,KeyCode:o.KeyCode,KeyMod:w,Position:E.$St,Range:g.$Tt,Selection:a.$Vt,SelectionDirection:o.SelectionDirection,MarkerSeverity:o.MarkerSeverity,MarkerTag:o.MarkerTag,Uri:f.URI,Token:u.$Mu}}}),ne(ie[78],re([0,1,30,16,4,2,67,34,63,64,75,26,70,38,60,19,31,3,62,69]),function(x,i,t,n,T,f,E,g,a,u,o,w,h,m,e,b,L,R,A,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=s;const _=!1;class $ extends E.$vw{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(d){const j=[];for(let N=0;N<this.f.length;N++){const p=this.f[N],D=this.offsetAt(new T.$St(N+1,1)),M=p.matchAll(d);for(const S of M)(S.index||S.index===0)&&(S.index=S.index+D),j.push(S)}return j}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(d){return this.f[d-1]}getWordAtPosition(d,j){const N=(0,g.$vt)(d.column,(0,g.$tt)(j),this.f[d.lineNumber-1],0);return N?new f.$Tt(d.lineNumber,N.startColumn,d.lineNumber,N.endColumn):null}getWordUntilPosition(d,j){const N=this.getWordAtPosition(d,j);return N?{word:this.f[d.lineNumber-1].substring(N.startColumn-1,d.column-1),startColumn:N.startColumn,endColumn:d.column}:{word:"",startColumn:d.column,endColumn:d.column}}words(d){const j=this.f,N=this.q.bind(this);let p=0,D="",M=0,S=[];return{*[Symbol.iterator](){for(;;)if(M<S.length){const I=D.substring(S[M].start,S[M].end);M+=1,yield I}else if(p<j.length)D=j[p],S=N(D,d),M=0,p+=1;else break}}}getLineWords(d,j){const N=this.f[d-1],p=this.q(N,j),D=[];for(const M of p)D.push({word:N.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return D}q(d,j){const N=[];let p;for(j.lastIndex=0;(p=j.exec(d))&&p[0].length!==0;)N.push({start:p.index,end:p.index+p[0].length});return N}getValueInRange(d){if(d=this.r(d),d.startLineNumber===d.endLineNumber)return this.f[d.startLineNumber-1].substring(d.startColumn-1,d.endColumn-1);const j=this.g,N=d.startLineNumber-1,p=d.endLineNumber-1,D=[];D.push(this.f[N].substring(d.startColumn-1));for(let M=N+1;M<p;M++)D.push(this.f[M]);return D.push(this.f[p].substring(0,d.endColumn-1)),D.join(j)}offsetAt(d){return d=this.s(d),this.l(),this.j.getPrefixSum(d.lineNumber-2)+(d.column-1)}positionAt(d){d=Math.floor(d),d=Math.max(0,d),this.l();const j=this.j.getIndexOf(d),N=this.f[j.index].length;return{lineNumber:1+j.index,column:1+Math.min(j.remainder,N)}}r(d){const j=this.s({lineNumber:d.startLineNumber,column:d.startColumn}),N=this.s({lineNumber:d.endLineNumber,column:d.endColumn});return j.lineNumber!==d.startLineNumber||j.column!==d.startColumn||N.lineNumber!==d.endLineNumber||N.column!==d.endColumn?{startLineNumber:j.lineNumber,startColumn:j.column,endLineNumber:N.lineNumber,endColumn:N.column}:d}s(d){if(!T.$St.isIPosition(d))throw new Error("bad position");let{lineNumber:j,column:N}=d,p=!1;if(j<1)j=1,N=1,p=!0;else if(j>this.f.length)j=this.f.length,N=this.f[j-1].length+1,p=!0;else{const D=this.f[j-1].length+1;N<1?(N=1,p=!0):N>D&&(N=D,p=!0)}return p?{lineNumber:j,column:N}:d}}class l{constructor(d,j){this.d=d,this.f=Object.create(null),this.g=j,this.h=null}dispose(){this.f=Object.create(null)}j(d){return this.f[d]}k(){const d=[];return Object.keys(this.f).forEach(j=>d.push(this.f[j])),d}acceptNewModel(d){this.f[d.url]=new $(n.URI.parse(d.url),d.lines,d.EOL,d.versionId)}acceptModelChanged(d,j){if(!this.f[d])return;this.f[d].onEvents(j)}acceptRemovedModel(d){this.f[d]&&delete this.f[d]}async computeUnicodeHighlights(d,j,N){const p=this.j(d);return p?h.$14.computeUnicodeHighlights(p,j,N):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(d,j){const N=this.j(d);return N?(0,v.$s5)(N,j):[]}async computeDiff(d,j,N,p){const D=this.j(d),M=this.j(j);return!D||!M?null:l.l(D,M,N,p)}static l(d,j,N,p){const D=p==="advanced"?e.$q5.getDefault():e.$q5.getLegacy(),M=d.getLinesContent(),S=j.getLinesContent(),I=D.computeDiff(M,S,N),F=I.changes.length>0?!1:this.n(d,j);function B(W){return W.map(O=>[O.original.startLineNumber,O.original.endLineNumberExclusive,O.modified.startLineNumber,O.modified.endLineNumberExclusive,O.innerChanges?.map(y=>[y.originalRange.startLineNumber,y.originalRange.startColumn,y.originalRange.endLineNumber,y.originalRange.endColumn,y.modifiedRange.startLineNumber,y.modifiedRange.startColumn,y.modifiedRange.endLineNumber,y.modifiedRange.endColumn])])}return{identical:F,quitEarly:I.hitTimeout,changes:B(I.changes),moves:I.moves.map(W=>[W.lineRangeMapping.original.startLineNumber,W.lineRangeMapping.original.endLineNumberExclusive,W.lineRangeMapping.modified.startLineNumber,W.lineRangeMapping.modified.endLineNumberExclusive,B(W.changes)])}}static n(d,j){const N=d.getLineCount(),p=j.getLineCount();if(N!==p)return!1;for(let D=1;D<=N;D++){const M=d.getLineContent(D),S=j.getLineContent(D);if(M!==S)return!1}return!0}async computeDirtyDiff(d,j,N){const p=this.j(d),D=this.j(j);if(!p||!D)return null;const M=p.getLinesContent(),S=D.getLinesContent();return new m.$gu(M,S,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:N,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(d,j,N){const p=this.j(d);if(!p)return j;const D=[];let M;j=j.slice(0).sort((I,F)=>{if(I.range&&F.range)return f.$Tt.compareRangesUsingStarts(I.range,F.range);const B=I.range?0:1,W=F.range?0:1;return B-W});let S=0;for(let I=1;I<j.length;I++)f.$Tt.getEndPosition(j[S].range).equals(f.$Tt.getStartPosition(j[I].range))?(j[S].range=f.$Tt.fromPositions(f.$Tt.getStartPosition(j[S].range),f.$Tt.getEndPosition(j[I].range)),j[S].text+=j[I].text):(S++,j[S]=j[I]);j.length=S+1;for(let{range:I,text:F,eol:B}of j){if(typeof B=="number"&&(M=B),f.$Tt.isEmpty(I)&&!F)continue;const W=p.getValueInRange(I);if(F=F.replace(/\r\n|\n|\r/g,p.eol),W===F)continue;if(Math.max(F.length,W.length)>l.o){D.push({range:I,text:F});continue}const O=(0,t.$Yt)(W,F,N),y=p.offsetAt(f.$Tt.lift(I).getStartPosition());for(const X of O){const Z=p.positionAt(y+X.originalStart),Y=p.positionAt(y+X.originalStart+X.originalLength),Q={text:F.substr(X.modifiedStart,X.modifiedLength),range:{startLineNumber:Z.lineNumber,startColumn:Z.column,endLineNumber:Y.lineNumber,endColumn:Y.column}};p.getValueInRange(Q.range)!==Q.text&&D.push(Q)}}return typeof M=="number"&&D.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),D}computeHumanReadableDiff(d,j,N){const p=this.j(d);if(!p)return j;const D=[];let M;j=j.slice(0).sort((S,I)=>{if(S.range&&I.range)return f.$Tt.compareRangesUsingStarts(S.range,I.range);const F=S.range?0:1,B=I.range?0:1;return F-B});for(let{range:S,text:I,eol:F}of j){let Z=function(Q,C){return new T.$St(Q.lineNumber+C.lineNumber-1,C.lineNumber===1?Q.column+C.column-1:C.column)},Y=function(Q,C){const k=[];for(let G=C.startLineNumber;G<=C.endLineNumber;G++){const oe=Q[G-1];G===C.startLineNumber&&G===C.endLineNumber?k.push(oe.substring(C.startColumn-1,C.endColumn-1)):G===C.startLineNumber?k.push(oe.substring(C.startColumn-1)):G===C.endLineNumber?k.push(oe.substring(0,C.endColumn-1)):k.push(oe)}return k};if(typeof F=="number"&&(M=F),f.$Tt.isEmpty(S)&&!I)continue;const B=p.getValueInRange(S);if(I=I.replace(/\r\n|\n|\r/g,p.eol),B===I)continue;if(Math.max(I.length,B.length)>l.o){D.push({range:S,text:I});continue}const W=B.split(/\r\n|\n|\r/),O=I.split(/\r\n|\n|\r/),y=e.$q5.getDefault().computeDiff(W,O,N),X=f.$Tt.lift(S).getStartPosition();for(const Q of y.changes)if(Q.innerChanges)for(const C of Q.innerChanges)D.push({range:f.$Tt.fromPositions(Z(X,C.originalRange.getStartPosition()),Z(X,C.originalRange.getEndPosition())),text:Y(O,C.modifiedRange).join(p.eol)});else throw new R.$eb("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&D.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),D}async computeLinks(d){const j=this.j(d);return j?(0,a.$44)(j):null}async computeDefaultDocumentColors(d){const j=this.j(d);return j?(0,A.$r5)(j):null}static{this.p=1e4}async textualSuggest(d,j,N,p){const D=new w.$ie,M=new RegExp(N,p),S=new Set;e:for(const I of d){const F=this.j(I);if(F){for(const B of F.words(M))if(!(B===j||!isNaN(Number(B)))&&(S.add(B),S.size>l.p))break e}}return{words:Array.from(S),duration:D.elapsed()}}async computeWordRanges(d,j,N,p){const D=this.j(d);if(!D)return Object.create(null);const M=new RegExp(N,p),S=Object.create(null);for(let I=j.startLineNumber;I<j.endLineNumber;I++){const F=D.getLineWords(I,M);for(const B of F){if(!isNaN(Number(B.word)))continue;let W=S[B.word];W||(W=[],S[B.word]=W),W.push({startLineNumber:I,startColumn:B.startColumn,endLineNumber:I,endColumn:B.endColumn})}}return S}async navigateValueSet(d,j,N,p,D){const M=this.j(d);if(!M)return null;const S=new RegExp(p,D);j.startColumn===j.endColumn&&(j={startLineNumber:j.startLineNumber,startColumn:j.startColumn,endLineNumber:j.endLineNumber,endColumn:j.endColumn+1});const I=M.getValueInRange(j),F=M.getWordAtPosition({lineNumber:j.startLineNumber,column:j.startColumn},S);if(!F)return null;const B=M.getValueInRange(F);return u.$54.INSTANCE.navigateValueSet(j,I,F,B,N)}loadForeignModule(d,j,N){const p=(S,I)=>this.d.fhr(S,I),M={host:(0,b.$so)(N,p),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,j),Promise.resolve((0,b.$ro)(this.h))):new Promise((S,I)=>{const F=B=>{this.h=B.create(M,j),S((0,b.$ro)(this.h))};if(!_)x([`${d}`],F,I);else{const B=L.$3g.asBrowserUri(`${d}.js`).toString(!0);new Promise((W,O)=>{x([`${B}`],W,O)}).then(Me).then(F).catch(I)}})}fmr(d,j){if(!this.h||typeof this.h[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.h[d].apply(this.h,j))}catch(N){return Promise.reject(N)}}}i.EditorSimpleWorker=l;function s(c){return new l(c,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,o.$74)())})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e2b54301a5745870f6b95d81c91fb3e9557d4f08/core/vs/base/worker/workerMain.js.map
