/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/process","vs/base/common/objects","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/cssDev/node/cssDevService","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","path","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ue=function(K){for(var e=[],i=0,r=K.length;i<r;i++)e[i]=le[K[i]];return e};define(le[67],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=e.$T=void 0,e.$T=!1,e.$U=!0;var i;(function(E){E[E.LoaderAvailable=1]="LoaderAvailable",E[E.BeginLoadingScript=10]="BeginLoadingScript",E[E.EndLoadingScriptOK=11]="EndLoadingScriptOK",E[E.EndLoadingScriptError=12]="EndLoadingScriptError",E[E.BeginInvokeFactory=21]="BeginInvokeFactory",E[E.EndInvokeFactory=22]="EndInvokeFactory",E[E.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",E[E.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",E[E.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",E[E.NodeEndNativeRequire=34]="NodeEndNativeRequire",E[E.CachedDataFound=60]="CachedDataFound",E[E.CachedDataMissed=61]="CachedDataMissed",E[E.CachedDataRejected=62]="CachedDataRejected",E[E.CachedDataCreated=63]="CachedDataCreated"})(i||(e.LoaderEventType=i={}));class r{static get(){const D=new Map,O=new Map,I=new Map,b=new Map;function l(f,d){f.has(d.detail)||f.set(d.detail,-d.timestamp)}function g(f,d){const v=f.get(d.detail);v&&(v>=0||f.set(d.detail,v+d.timestamp))}let u=[];typeof K=="function"&&typeof K.getStats=="function"&&(u=K.getStats().slice(0).sort((f,d)=>f.timestamp-d.timestamp));for(const f of u)switch(f.type){case i.BeginLoadingScript:l(D,f);break;case i.EndLoadingScriptOK:case i.EndLoadingScriptError:g(D,f);break;case i.BeginInvokeFactory:l(O,f);break;case i.EndInvokeFactory:g(O,f);break;case i.NodeBeginNativeRequire:l(I,f);break;case i.NodeEndNativeRequire:g(I,f);break;case i.NodeBeginEvaluatingScript:l(b,f);break;case i.NodeEndEvaluatingScript:g(b,f);break}let m=0;I.forEach(f=>m+=f);function p(f){const d=[];return f.forEach((v,y)=>d.push([y,v])),d}return{amdLoad:p(D),amdInvoke:p(O),nodeRequire:p(I),nodeEval:p(b),nodeRequireTotal:m}}static toMarkdownTable(D,O){let I="";const b=[];return D.forEach((l,g)=>{b[g]=l.length}),O.forEach(l=>{l.forEach((g,u)=>{typeof g>"u"&&(g=l[u]="-");const m=g.toString().length;b[u]=Math.max(m,b[u])})}),D.forEach((l,g)=>{I+=`| ${l+" ".repeat(b[g]-l.toString().length)} `}),I+=`|
`,D.forEach((l,g)=>{I+=`| ${"-".repeat(b[g])} `}),I+=`|
`,O.forEach(l=>{l.forEach((g,u)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(b[u]-g.toString().length)} `)}),I+=`|
`}),I}}e.$V=r}),define(le[140],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=i,e.$ib=r,e.$jb=E,e.$kb=D,e.$lb=O,e.$mb=I,e.$nb=b,e.$pb=g,e.$qb=u,e.$rb=m,e.$sb=p,e.$tb=f;function i(d,v){const y=r(d,v);if(y!==-1)return d[y]}function r(d,v,y=d.length-1){for(let $=y;$>=0;$--){const S=d[$];if(v(S))return $}return-1}function E(d,v){const y=D(d,v);return y===-1?void 0:d[y]}function D(d,v,y=0,$=d.length){let S=y,k=$;for(;S<k;){const s=Math.floor((S+k)/2);v(d[s])?S=s+1:k=s}return S-1}function O(d,v){const y=I(d,v);return y===d.length?void 0:d[y]}function I(d,v,y=0,$=d.length){let S=y,k=$;for(;S<k;){const s=Math.floor((S+k)/2);v(d[s])?k=s:S=s+1}return S}function b(d,v,y=0,$=d.length){const S=I(d,v,y,$);return S===d.length?-1:S}class l{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(l.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!v($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const y=D(this.e,v,this.c);return this.c=y+1,y===-1?void 0:this.e[y]}}e.$ob=l;function g(d,v){if(d.length===0)return;let y=d[0];for(let $=1;$<d.length;$++){const S=d[$];v(S,y)>0&&(y=S)}return y}function u(d,v){if(d.length===0)return;let y=d[0];for(let $=1;$<d.length;$++){const S=d[$];v(S,y)>=0&&(y=S)}return y}function m(d,v){return g(d,(y,$)=>-v(y,$))}function p(d,v){if(d.length===0)return-1;let y=0;for(let $=1;$<d.length;$++){const S=d[$];v(S,d[y])>0&&(y=$)}return y}function f(d,v){for(const y of d){const $=v(y);if($!==void 0)return $}}}),define(le[39],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(le[141],ue([0,1]),function(K,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=E,e.$e=D,e.$f=O;function r(b,l){const g=Object.create(null);for(const u of b){const m=l(u);let p=g[m];p||(p=g[m]=[]),p.push(u)}return g}function E(b,l){const g=[],u=[];for(const m of b)l.has(m)||g.push(m);for(const m of l)b.has(m)||u.push(m);return{removed:g,added:u}}function D(b,l){const g=[],u=[];for(const[m,p]of b)l.has(m)||g.push(p);for(const[m,p]of l)b.has(m)||u.push(p);return{removed:g,added:u}}function O(b,l){const g=new Set;for(const u of l)b.has(u)&&g.add(u);return g}class I{static{i=Symbol.toStringTag}constructor(l,g){this.b=g,this.a=new Map,this[i]="SetWithKey";for(const u of l)this.add(u)}get size(){return this.a.size}add(l){const g=this.b(l);return this.a.set(g,l),this}delete(l){return this.a.delete(this.b(l))}has(l){return this.a.has(this.b(l))}*entries(){for(const l of this.a.values())yield[l,l]}keys(){return this.values()}*values(){for(const l of this.a.values())yield l}clear(){this.a.clear()}forEach(l,g){this.a.forEach(u=>l.call(g,u,u,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(le[142],ue([0,1,39]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=e.$su=e.$ru=e.$qu=void 0;function r(b,l){const g=Math.pow(10,l);return Math.round(b*g)/g}class E{constructor(l,g,u,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,u))|0,this.a=r(Math.max(Math.min(1,m),0),3)}static equals(l,g){return l.r===g.r&&l.g===g.g&&l.b===g.b&&l.a===g.a}}e.$qu=E;class D{constructor(l,g,u,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,g),0),3),this.l=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,m),0),3)}static equals(l,g){return l.h===g.h&&l.s===g.s&&l.l===g.l&&l.a===g.a}static fromRGBA(l){const g=l.r/255,u=l.g/255,m=l.b/255,p=l.a,f=Math.max(g,u,m),d=Math.min(g,u,m);let v=0,y=0;const $=(d+f)/2,S=f-d;if(S>0){switch(y=Math.min($<=.5?S/(2*$):S/(2-2*$),1),f){case g:v=(u-m)/S+(u<m?6:0);break;case u:v=(m-g)/S+2;break;case m:v=(g-u)/S+4;break}v*=60,v=Math.round(v)}return new D(v,y,$,p)}static i(l,g,u){return u<0&&(u+=1),u>1&&(u-=1),u<1/6?l+(g-l)*6*u:u<1/2?g:u<2/3?l+(g-l)*(2/3-u)*6:l}static toRGBA(l){const g=l.h/360,{s:u,l:m,a:p}=l;let f,d,v;if(u===0)f=d=v=m;else{const y=m<.5?m*(1+u):m+u-m*u,$=2*m-y;f=D.i($,y,g+1/3),d=D.i($,y,g),v=D.i($,y,g-1/3)}return new E(Math.round(f*255),Math.round(d*255),Math.round(v*255),p)}}e.$ru=D;class O{constructor(l,g,u,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,g),0),3),this.v=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,m),0),3)}static equals(l,g){return l.h===g.h&&l.s===g.s&&l.v===g.v&&l.a===g.a}static fromRGBA(l){const g=l.r/255,u=l.g/255,m=l.b/255,p=Math.max(g,u,m),f=Math.min(g,u,m),d=p-f,v=p===0?0:d/p;let y;return d===0?y=0:p===g?y=((u-m)/d%6+6)%6:p===u?y=(m-g)/d+2:y=(g-u)/d+4,new O(Math.round(y*60),v,p,l.a)}static toRGBA(l){const{h:g,s:u,v:m,a:p}=l,f=m*u,d=f*(1-Math.abs(g/60%2-1)),v=m-f;let[y,$,S]=[0,0,0];return g<60?(y=f,$=d):g<120?(y=d,$=f):g<180?($=f,S=d):g<240?($=d,S=f):g<300?(y=d,S=f):g<=360&&(y=f,S=d),y=Math.round((y+v)*255),$=Math.round(($+v)*255),S=Math.round((S+v)*255),new E(y,$,S,p)}}e.$su=O;class I{static fromHex(l){return I.Format.CSS.parseHex(l)||I.red}static equals(l,g){return!l&&!g?!0:!l||!g?!1:l.equals(g)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof E)this.rgba=l;else if(l instanceof D)this.i=l,this.rgba=D.toRGBA(l);else if(l instanceof O)this.j=l,this.rgba=O.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&E.equals(this.rgba,l.rgba)&&D.equals(this.hsla,l.hsla)&&O.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=I.k(this.rgba.r),g=I.k(this.rgba.g),u=I.k(this.rgba.b),m=.2126*l+.7152*g+.0722*u;return r(m,4)}static k(l){const g=l/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(l){const g=this.getRelativeLuminance(),u=l.getRelativeLuminance();return g>u?(g+.05)/(u+.05):(u+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const g=this.getRelativeLuminance(),u=l.getRelativeLuminance();return g>u}isDarkerThan(l){const g=this.getRelativeLuminance(),u=l.getRelativeLuminance();return g<u}lighten(l){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:g,g:u,b:m,a:p}=this.rgba;return new I(new E(g,u,m,p*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new E(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const g=l.rgba,u=this.rgba.a,m=g.a,p=u+m*(1-u);if(p<1e-6)return I.transparent;const f=this.rgba.r*u/p+g.r*m*(1-u)/p,d=this.rgba.g*u/p+g.g*m*(1-u)/p,v=this.rgba.b*u/p+g.b*m*(1-u)/p;return new I(new E(f,d,v,p))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:g,g:u,b:m,a:p}=this.rgba;return new I(new E(l.rgba.r-p*(l.rgba.r-g),l.rgba.g-p*(l.rgba.g-u),l.rgba.b-p*(l.rgba.b-m),1))}flatten(...l){const g=l.reduceRight((u,m)=>I.o(m,u));return I.o(this,g)}static o(l,g){const u=1-l.rgba.a;return new I(new E(u*g.rgba.r+l.rgba.a*l.rgba.r,u*g.rgba.g+l.rgba.a*l.rgba.g,u*g.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(l,g,u){if(l.isLighterThan(g))return l;u=u||.5;const m=l.getRelativeLuminance(),p=g.getRelativeLuminance();return u=u*(p-m)/p,l.lighten(u)}static getDarkerColor(l,g,u){if(l.isDarkerThan(g))return l;u=u||.5;const m=l.getRelativeLuminance(),p=g.getRelativeLuminance();return u=u*(m-p)/m,l.darken(u)}static{this.white=new I(new E(255,255,255,1))}static{this.black=new I(new E(0,0,0,1))}static{this.red=new I(new E(255,0,0,1))}static{this.blue=new I(new E(0,0,255,1))}static{this.green=new I(new E(0,255,0,1))}static{this.cyan=new I(new E(0,255,255,1))}static{this.lightgrey=new I(new E(211,211,211,1))}static{this.transparent=new I(new E(0,0,0,0))}}e.$tu=I,function(b){let l;(function(g){let u;(function(m){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:b.Format.CSS.formatRGBA(t)}m.formatRGB=p;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}m.formatRGBA=f;function d(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(t)}m.formatHSL=d;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}m.formatHSLA=v;function y(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function $(t){return`#${y(t.rgba.r)}${y(t.rgba.g)}${y(t.rgba.b)}`}m.formatHex=$;function S(t,o=!1){return o&&t.rgba.a===1?b.Format.CSS.formatHex(t):`#${y(t.rgba.r)}${y(t.rgba.g)}${y(t.rgba.b)}${y(Math.round(t.rgba.a*255))}`}m.formatHexA=S;function k(t){return t.isOpaque()?b.Format.CSS.formatHex(t):b.Format.CSS.formatRGBA(t)}m.format=k;function s(t){const o=t.length;if(o===0||t.charCodeAt(0)!==i.CharCode.Hash)return null;if(o===7){const n=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),c=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),h=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new b(new E(n,c,h,1))}if(o===9){const n=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),c=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),h=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),P=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new b(new E(n,c,h,P/255))}if(o===4){const n=a(t.charCodeAt(1)),c=a(t.charCodeAt(2)),h=a(t.charCodeAt(3));return new b(new E(16*n+n,16*c+c,16*h+h))}if(o===5){const n=a(t.charCodeAt(1)),c=a(t.charCodeAt(2)),h=a(t.charCodeAt(3)),P=a(t.charCodeAt(4));return new b(new E(16*n+n,16*c+c,16*h+h,(16*P+P)/255))}return null}m.parseHex=s;function a(t){switch(t){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(u=g.CSS||(g.CSS={}))})(l=b.Format||(b.Format={}))}(I||(e.$tu=I={}))}),define(le[54],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=r,e.$bi=E,e.$ci=D;function i(O){return(I,b,l)=>{let g=null,u=null;if(typeof l.value=="function"?(g="value",u=l.value):typeof l.get=="function"&&(g="get",u=l.get),!u)throw new Error("not supported");l[g]=O(u,b)}}function r(O,I,b){let l=null,g=null;if(typeof b.value=="function"?(l="value",g=b.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(l="get",g=b.get),!g)throw new Error("not supported");const u=`$memoize$${I}`;b[l]=function(...m){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,m)}),this[u]}}function E(O,I,b){return i((l,g)=>{const u=`$debounce$${g}`,m=`$debounce$result$${g}`;return function(...p){this[m]||(this[m]=b?b():void 0),clearTimeout(this[u]),I&&(this[m]=I(this[m],...p),p=[this[m]]),this[u]=setTimeout(()=>{l.apply(this,p),this[m]=b?b():void 0},O)}})}function D(O,I,b){return i((l,g)=>{const u=`$throttle$timer$${g}`,m=`$throttle$result$${g}`,p=`$throttle$lastRun$${g}`,f=`$throttle$pending$${g}`;return function(...d){if(this[m]||(this[m]=b?b():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...d)),this[f])return;const v=this[p]+O;v<=Date.now()?(this[p]=Date.now(),l.apply(this,[this[m]]),this[m]=b?b():void 0):(this[f]=!0,this[u]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),l.apply(this,[this[m]]),this[m]=b?b():void 0},v-Date.now()))}})}}),define(le[15],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=r,e.$1=E,e.$2=D,e.$3=O,e.$4=I,e.$5=b,e.$6=g,e.$8=m,e.$9=p,e.$0=f,e.$_=v;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?k.isErrorNoTelemetry(t)?new k(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$X=i,e.$Y=new i;function r(a){e.$Y.setUnexpectedErrorHandler(a)}function E(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(a){g(a)||e.$Y.onUnexpectedError(a)}function O(a){g(a)||e.$Y.onUnexpectedExternalError(a)}function I(a){if(a instanceof Error){const{name:t,message:o}=a,n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:n,noTelemetry:k.isErrorNoTelemetry(a)}}return a}function b(a){let t;return a.noTelemetry?t=new k:(t=new Error,t.name=a.name),t.message=a.message,t.stack=a.stack,t}const l="Canceled";function g(a){return a instanceof u?!0:a instanceof Error&&a.name===l&&a.message===l}class u extends Error{constructor(){super(l),this.name=this.message}}e.$7=u;function m(){const a=new Error(l);return a.name=a.message,a}function p(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function f(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=d;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class y extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$ab=y;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$bb=$;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=S;class k extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof k)return t;const o=new k;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$db=k;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$eb=s}),define(le[21],ue([0,1,15,140]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=E,e.$vb=D,e.$wb=O,e.$xb=I,e.$yb=b,e.$zb=l,e.$Ab=g,e.$Bb=u,e.$Cb=m,e.$Db=p,e.$Eb=f,e.$Fb=d,e.$Gb=v,e.top=y,e.$Ib=$,e.$Jb=k,e.$Kb=s,e.$Lb=a,e.$Mb=t,e.$Nb=o,e.$Ob=n,e.$Pb=c,e.$Qb=h,e.$Rb=P,e.$Sb=w,e.$Tb=R,e.$Ub=L,e.$Vb=A,e.$Wb=T,e.$Xb=j,e.$Yb=G,e.$Zb=q,e.$1b=Q,e.$2b=de,e.$3b=x,e.$4b=J,e.$5b=B,e.$6b=_,e.$7b=C,e.$8b=H,e.$9b=ne,e.$_b=oe,e.$dc=U;function E(N,ie=0){return N[N.length-(1+ie)]}function D(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function O(N,ie,X=(z,te)=>z===te){if(N===ie)return!0;if(!N||!ie||N.length!==ie.length)return!1;for(let z=0,te=N.length;z<te;z++)if(!X(N[z],ie[z]))return!1;return!0}function I(N,ie){const X=N.length-1;ie<X&&(N[ie]=N[X]),N.pop()}function b(N,ie,X){return l(N.length,z=>X(N[z],ie))}function l(N,ie){let X=0,z=N-1;for(;X<=z;){const te=(X+z)/2|0,ae=ie(te);if(ae<0)X=te+1;else if(ae>0)z=te-1;else return te}return-(X+1)}function g(N,ie,X){if(N=N|0,N>=ie.length)throw new TypeError("invalid index");const z=ie[Math.floor(ie.length*Math.random())],te=[],ae=[],me=[];for(const be of ie){const ye=X(be,z);ye<0?te.push(be):ye>0?ae.push(be):me.push(be)}return N<te.length?g(N,te,X):N<te.length+me.length?me[0]:g(N-(te.length+me.length),ae,X)}function u(N,ie){const X=[];let z;for(const te of N.slice(0).sort(ie))!z||ie(z[0],te)!==0?(z=[te],X.push(z)):z.push(te);return X}function*m(N,ie){let X,z;for(const te of N)z!==void 0&&ie(z,te)?X.push(te):(X&&(yield X),X=[te]),z=te;X&&(yield X)}function p(N,ie){for(let X=0;X<=N.length;X++)ie(X===0?void 0:N[X-1],X===N.length?void 0:N[X])}function f(N,ie){for(let X=0;X<N.length;X++)ie(X===0?void 0:N[X-1],N[X],X+1===N.length?void 0:N[X+1])}function d(N,ie,X){const z=[];function te(be,ye,Fe){if(ye===0&&Fe.length===0)return;const xe=z[z.length-1];xe&&xe.start+xe.deleteCount===be?(xe.deleteCount+=ye,xe.toInsert.push(...Fe)):z.push({start:be,deleteCount:ye,toInsert:Fe})}let ae=0,me=0;for(;;){if(ae===N.length){te(ae,0,ie.slice(me));break}if(me===ie.length){te(ae,N.length-ae,[]);break}const be=N[ae],ye=ie[me],Fe=X(be,ye);Fe===0?(ae+=1,me+=1):Fe<0?(te(ae,1,[]),ae+=1):Fe>0&&(te(ae,0,[ye]),me+=1)}return z}function v(N,ie,X){const z=d(N,ie,X),te=[],ae=[];for(const me of z)te.push(...N.slice(me.start,me.start+me.deleteCount)),ae.push(...me.toInsert);return{removed:te,added:ae}}function y(N,ie,X){if(X===0)return[];const z=N.slice(0,X).sort(ie);return S(N,ie,z,X,N.length),z}function $(N,ie,X,z,te){return X===0?Promise.resolve([]):new Promise((ae,me)=>{(async()=>{const be=N.length,ye=N.slice(0,X).sort(ie);for(let Fe=X,xe=Math.min(X+z,be);Fe<be;Fe=xe,xe=Math.min(xe+z,be)){if(Fe>X&&await new Promise(Ae=>setTimeout(Ae)),te&&te.isCancellationRequested)throw new i.$7;S(N,ie,ye,Fe,xe)}return ye})().then(ae,me)})}function S(N,ie,X,z,te){for(const ae=X.length;z<te;z++){const me=N[z];if(ie(me,X[ae-1])<0){X.pop();const be=(0,r.$mb)(X,ye=>ie(me,ye)<0);X.splice(be,0,me)}}}function k(N){return N.filter(ie=>!!ie)}function s(N){let ie=0;for(let X=0;X<N.length;X++)N[X]&&(N[ie]=N[X],ie+=1);N.length=ie}function a(N,ie,X){N.splice(X,0,N.splice(ie,1)[0])}function t(N){return!Array.isArray(N)||N.length===0}function o(N){return Array.isArray(N)&&N.length>0}function n(N,ie=X=>X){const X=new Set;return N.filter(z=>{const te=ie(z);return X.has(te)?!1:(X.add(te),!0)})}function c(N){const ie=new Set;return X=>{const z=N(X);return ie.has(z)?!1:(ie.add(z),!0)}}function h(N,ie){return N.length>0?N[0]:ie}function P(N,ie){return N.length>0?N[N.length-1]:ie}function w(N,ie,X=(z,te)=>z===te){let z=0;for(let te=0,ae=Math.min(N.length,ie.length);te<ae&&X(N[te],ie[te]);te++)z++;return z}function R(N,ie){let X=typeof ie=="number"?N:0;typeof ie=="number"?X=N:(X=0,ie=N);const z=[];if(X<=ie)for(let te=X;te<ie;te++)z.push(te);else for(let te=X;te>ie;te--)z.push(te);return z}function L(N,ie,X){return N.reduce((z,te)=>(z[ie(te)]=X?X(te):te,z),Object.create(null))}function A(N,ie){return N.push(ie),()=>T(N,ie)}function T(N,ie){const X=N.indexOf(ie);if(X>-1)return N.splice(X,1),ie}function j(N,ie,X){const z=N.slice(0,ie),te=N.slice(ie);return z.concat(X,te)}function G(N,ie){let X;if(typeof ie=="number"){let z=ie;X=()=>{const te=Math.sin(z++)*179426549;return te-Math.floor(te)}}else X=Math.random;for(let z=N.length-1;z>0;z-=1){const te=Math.floor(X()*(z+1)),ae=N[z];N[z]=N[te],N[te]=ae}}function q(N,ie){const X=N.indexOf(ie);X>-1&&(N.splice(X,1),N.unshift(ie))}function Q(N,ie){const X=N.indexOf(ie);X>-1&&(N.splice(X,1),N.push(ie))}function de(N,ie){for(const X of ie)N.push(X)}function x(N,ie){return Array.isArray(N)?N.map(ie):ie(N)}function J(N){return Array.isArray(N)?N:[N]}function B(N){return N[Math.floor(Math.random()*N.length)]}function _(N,ie,X){const z=W(N,ie),te=N.length,ae=X.length;N.length=te+ae;for(let me=te-1;me>=z;me--)N[me+ae]=N[me];for(let me=0;me<ae;me++)N[me+z]=X[me]}function C(N,ie,X,z){const te=W(N,ie);let ae=N.splice(te,X);return ae===void 0&&(ae=[]),_(N,te,z),ae}function W(N,ie){return ie<0?Math.max(ie+N.length,0):Math.min(ie,N.length)}var F;(function(N){function ie(ae){return ae<0}N.isLessThan=ie;function X(ae){return ae<=0}N.isLessThanOrEqual=X;function z(ae){return ae>0}N.isGreaterThan=z;function te(ae){return ae===0}N.isNeitherLessOrGreaterThan=te,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(F||(e.CompareResult=F={}));function H(N,ie){return(X,z)=>ie(N(X),N(z))}function ne(...N){return(ie,X)=>{for(const z of N){const te=z(ie,X);if(!F.isNeitherLessOrGreaterThan(te))return te}return F.neitherLessOrGreaterThan}}const V=(N,ie)=>N-ie;e.$0b=V;const ce=(N,ie)=>(0,e.$0b)(N?1:0,ie?1:0);e.$$b=ce;function oe(N){return(ie,X)=>-N(ie,X)}class Y{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let X=this.c;for(;X<this.g.length&&ie(this.g[X]);)X++;const z=X===this.c?null:this.g.slice(this.c,X);return this.c=X,z}takeFromEndWhile(ie){let X=this.d;for(;X>=0&&ie(this.g[X]);)X--;const z=X===this.d?null:this.g.slice(X+1,this.d+1);return this.d=X,z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const X=this.g.slice(this.c,this.c+ie);return this.c+=ie,X}}e.$ac=Y;class M{static{this.empty=new M(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(X=>(ie(X),!0))}toArray(){const ie=[];return this.iterate(X=>(ie.push(X),!0)),ie}filter(ie){return new M(X=>this.iterate(z=>ie(z)?X(z):!0))}map(ie){return new M(X=>this.iterate(z=>X(ie(z))))}some(ie){let X=!1;return this.iterate(z=>(X=ie(z),!X)),X}findFirst(ie){let X;return this.iterate(z=>ie(z)?(X=z,!1):!0),X}findLast(ie){let X;return this.iterate(z=>(ie(z)&&(X=z),!0)),X}findLastMaxBy(ie){let X,z=!0;return this.iterate(te=>((z||F.isGreaterThan(ie(te,X)))&&(z=!1,X=te),!0)),X}}e.$bc=M;class Z{constructor(ie){this.c=ie}static createSortPermutation(ie,X){const z=Array.from(ie.keys()).sort((te,ae)=>X(ie[te],ie[ae]));return new Z(z)}apply(ie){return ie.map((X,z)=>ie[this.c[z]])}inverse(){const ie=this.c.slice();for(let X=0;X<this.c.length;X++)ie[this.c[X]]=X;return new Z(ie)}}e.$cc=Z;async function U(N,ie){return(await Promise.all(N.map(async(z,te)=>({element:z,ok:await ie(z,te)})))).find(z=>z.ok)?.element}}),define(le[143],ue([0,1,15]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$hd=E,e.$id=D,e.$jd=O,e.$kd=I,e.$ld=b;function r(l,g){if(!l)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function E(l,g="Unreachable"){throw new Error(g)}function D(l,g="unexpected state"){if(!l)throw new i.$eb(`Assertion Failed: ${g}`)}function O(l){l||(0,i.$2)(new i.$eb("Soft Assertion Failed"))}function I(l){if(!l()){debugger;l(),(0,i.$2)(new i.$eb("Assertion Failed"))}}function b(l,g){let u=0;for(;u<l.length-1;){const m=l[u],p=l[u+1];if(!g(m,p))return!1;u++}return!0}}),define(le[91],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=i;function i(r,E){const D=this;let O=!1,I;return function(){if(O)return I;if(O=!0,E)try{I=r.apply(D,arguments)}finally{E()}else I=r.apply(D,arguments);return I}}}),define(le[78],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(r){function E(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}r.is=E;const D=Object.freeze([]);function O(){return D}r.empty=O;function*I(t){yield t}r.single=I;function b(t){return E(t)?t:I(t)}r.wrap=b;function l(t){return t||D}r.from=l;function*g(t){for(let o=t.length-1;o>=0;o--)yield t[o]}r.reverse=g;function u(t){return!t||t[Symbol.iterator]().next().done===!0}r.isEmpty=u;function m(t){return t[Symbol.iterator]().next().value}r.first=m;function p(t,o){let n=0;for(const c of t)if(o(c,n++))return!0;return!1}r.some=p;function f(t,o){for(const n of t)if(o(n))return n}r.find=f;function*d(t,o){for(const n of t)o(n)&&(yield n)}r.filter=d;function*v(t,o){let n=0;for(const c of t)yield o(c,n++)}r.map=v;function*y(t,o){let n=0;for(const c of t)yield*o(c,n++)}r.flatMap=y;function*$(...t){for(const o of t)yield*o}r.concat=$;function S(t,o,n){let c=n;for(const h of t)c=o(c,h);return c}r.reduce=S;function*k(t,o,n=t.length){for(o<0&&(o+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);o<n;o++)yield t[o]}r.slice=k;function s(t,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,t];const c=t[Symbol.iterator]();for(let h=0;h<o;h++){const P=c.next();if(P.done)return[n,r.empty()];n.push(P.value)}return[n,{[Symbol.iterator](){return c}}]}r.consume=s;async function a(t){const o=[];for await(const n of t)o.push(n);return Promise.resolve(o)}r.asyncToArray=a})(i||(e.Iterable=i={}))}),define(le[43],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Zn=O,e.$1n=u,e.$2n=m,e.$3n=p,e.$4n=f,e.$5n=d,e.$6n=v,e.$7n=y,e.$8n=$,e.$9n=S,e.$0n=k;var i;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var r;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var E;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var D;(function(s){s.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function O(s,a=!1){let t=0;const o=s.length;let n="",c=0,h=r.Unknown,P=i.None;function w(q){let Q=0,de=0;for(;Q<q;){const x=s.charCodeAt(t);if(x>=g._0&&x<=g._9)de=de*16+x-g._0;else if(x>=g.A&&x<=g.F)de=de*16+x-g.A+10;else if(x>=g.a&&x<=g.f)de=de*16+x-g.a+10;else break;t++,Q++}return Q<q&&(de=-1),de}function R(q){t=q,n="",c=0,h=r.Unknown,P=i.None}function L(){const q=t;if(s.charCodeAt(t)===g._0)t++;else for(t++;t<s.length&&l(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===g.dot)if(t++,t<s.length&&l(s.charCodeAt(t)))for(t++;t<s.length&&l(s.charCodeAt(t));)t++;else return P=i.UnexpectedEndOfNumber,s.substring(q,t);let Q=t;if(t<s.length&&(s.charCodeAt(t)===g.E||s.charCodeAt(t)===g.e))if(t++,(t<s.length&&s.charCodeAt(t)===g.plus||s.charCodeAt(t)===g.minus)&&t++,t<s.length&&l(s.charCodeAt(t))){for(t++;t<s.length&&l(s.charCodeAt(t));)t++;Q=t}else P=i.UnexpectedEndOfNumber;return s.substring(q,Q)}function A(){let q="",Q=t;for(;;){if(t>=o){q+=s.substring(Q,t),P=i.UnexpectedEndOfString;break}const de=s.charCodeAt(t);if(de===g.doubleQuote){q+=s.substring(Q,t),t++;break}if(de===g.backslash){if(q+=s.substring(Q,t),t++,t>=o){P=i.UnexpectedEndOfString;break}switch(s.charCodeAt(t++)){case g.doubleQuote:q+='"';break;case g.backslash:q+="\\";break;case g.slash:q+="/";break;case g.b:q+="\b";break;case g.f:q+="\f";break;case g.n:q+=`
`;break;case g.r:q+="\r";break;case g.t:q+="	";break;case g.u:{const J=w(4);J>=0?q+=String.fromCharCode(J):P=i.InvalidUnicode;break}default:P=i.InvalidEscapeCharacter}Q=t;continue}if(de>=0&&de<=31)if(b(de)){q+=s.substring(Q,t),P=i.UnexpectedEndOfString;break}else P=i.InvalidCharacter;t++}return q}function T(){if(n="",P=i.None,c=t,t>=o)return c=o,h=r.EOF;let q=s.charCodeAt(t);if(I(q)){do t++,n+=String.fromCharCode(q),q=s.charCodeAt(t);while(I(q));return h=r.Trivia}if(b(q))return t++,n+=String.fromCharCode(q),q===g.carriageReturn&&s.charCodeAt(t)===g.lineFeed&&(t++,n+=`
`),h=r.LineBreakTrivia;switch(q){case g.openBrace:return t++,h=r.OpenBraceToken;case g.closeBrace:return t++,h=r.CloseBraceToken;case g.openBracket:return t++,h=r.OpenBracketToken;case g.closeBracket:return t++,h=r.CloseBracketToken;case g.colon:return t++,h=r.ColonToken;case g.comma:return t++,h=r.CommaToken;case g.doubleQuote:return t++,n=A(),h=r.StringLiteral;case g.slash:{const Q=t-1;if(s.charCodeAt(t+1)===g.slash){for(t+=2;t<o&&!b(s.charCodeAt(t));)t++;return n=s.substring(Q,t),h=r.LineCommentTrivia}if(s.charCodeAt(t+1)===g.asterisk){t+=2;const de=o-1;let x=!1;for(;t<de;){if(s.charCodeAt(t)===g.asterisk&&s.charCodeAt(t+1)===g.slash){t+=2,x=!0;break}t++}return x||(t++,P=i.UnexpectedEndOfComment),n=s.substring(Q,t),h=r.BlockCommentTrivia}return n+=String.fromCharCode(q),t++,h=r.Unknown}case g.minus:if(n+=String.fromCharCode(q),t++,t===o||!l(s.charCodeAt(t)))return h=r.Unknown;case g._0:case g._1:case g._2:case g._3:case g._4:case g._5:case g._6:case g._7:case g._8:case g._9:return n+=L(),h=r.NumericLiteral;default:for(;t<o&&j(q);)t++,q=s.charCodeAt(t);if(c!==t){switch(n=s.substring(c,t),n){case"true":return h=r.TrueKeyword;case"false":return h=r.FalseKeyword;case"null":return h=r.NullKeyword}return h=r.Unknown}return n+=String.fromCharCode(q),t++,h=r.Unknown}}function j(q){if(I(q)||b(q))return!1;switch(q){case g.closeBrace:case g.closeBracket:case g.openBrace:case g.openBracket:case g.doubleQuote:case g.colon:case g.comma:case g.slash:return!1}return!0}function G(){let q;do q=T();while(q>=r.LineCommentTrivia&&q<=r.Trivia);return q}return{setPosition:R,getPosition:()=>t,scan:a?G:T,getToken:()=>h,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>P}}function I(s){return s===g.space||s===g.tab||s===g.verticalTab||s===g.formFeed||s===g.nonBreakingSpace||s===g.ogham||s>=g.enQuad&&s<=g.zeroWidthSpace||s===g.narrowNoBreakSpace||s===g.mathematicalSpace||s===g.ideographicSpace||s===g.byteOrderMark}function b(s){return s===g.lineFeed||s===g.carriageReturn||s===g.lineSeparator||s===g.paragraphSeparator}function l(s){return s>=g._0&&s<=g._9}var g;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(g||(g={}));function u(s,a){const t=[],o=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function P(w,R,L,A){c.value=w,c.offset=R,c.length=L,c.type=A,c.colonOffset=void 0,n=c}try{S(s,{onObjectBegin:(w,R)=>{if(a<=w)throw o;n=void 0,h=a>w,t.push("")},onObjectProperty:(w,R,L)=>{if(a<R||(P(w,R,L,"property"),t[t.length-1]=w,a<=R+L))throw o},onObjectEnd:(w,R)=>{if(a<=w)throw o;n=void 0,t.pop()},onArrayBegin:(w,R)=>{if(a<=w)throw o;n=void 0,t.push(0)},onArrayEnd:(w,R)=>{if(a<=w)throw o;n=void 0,t.pop()},onLiteralValue:(w,R,L)=>{if(a<R||(P(w,R,L,k(w)),a<=R+L))throw o},onSeparator:(w,R,L)=>{if(a<=R)throw o;if(w===":"&&n&&n.type==="property")n.colonOffset=R,h=!1,n=void 0;else if(w===","){const A=t[t.length-1];typeof A=="number"?t[t.length-1]=A+1:(h=!0,t[t.length-1]=""),n=void 0}}})}catch(w){if(w!==o)throw w}return{path:t,previousNode:n,isAtPropertyKey:h,matches:w=>{let R=0;for(let L=0;R<w.length&&L<t.length;L++)if(w[R]===t[L]||w[R]==="*")R++;else if(w[R]!=="**")return!1;return R===w.length}}}function m(s,a=[],t=D.DEFAULT){let o=null,n=[];const c=[];function h(w){Array.isArray(n)?n.push(w):o!==null&&(n[o]=w)}return S(s,{onObjectBegin:()=>{const w={};h(w),c.push(n),n=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const w=[];h(w),c.push(n),n=w,o=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:h,onError:(w,R,L)=>{a.push({error:w,offset:R,length:L})}},t),n[0]}function p(s,a=[],t=D.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function c(w){return o.children.push(w),w}S(s,{onObjectBegin:w=>{o=c({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,R,L)=>{o=c({type:"property",offset:R,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:R,length:L,parent:o})},onObjectEnd:(w,R)=>{o.length=w+R-o.offset,o=o.parent,n(w+R)},onArrayBegin:(w,R)=>{o=c({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,R)=>{o.length=w+R-o.offset,o=o.parent,n(w+R)},onLiteralValue:(w,R,L)=>{c({type:k(w),offset:R,length:L,parent:o,value:w}),n(R+L)},onSeparator:(w,R,L)=>{o.type==="property"&&(w===":"?o.colonOffset=R:w===","&&n(R))},onError:(w,R,L)=>{a.push({error:w,offset:R,length:L})}},t);const P=o.children[0];return P&&delete P.parent,P}function f(s,a){if(!s)return;let t=s;for(const o of a)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===o){t=c.children[1],n=!0;break}if(!n)return}else{const n=o;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}function d(s){if(!s.parent||!s.parent.children)return[];const a=d(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;a.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&a.push(t)}return a}function v(s){switch(s.type){case"array":return s.children.map(v);case"object":{const a=Object.create(null);for(const t of s.children){const o=t.children[1];o&&(a[t.children[0].value]=v(o))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}function y(s,a,t=!1){return a>=s.offset&&a<s.offset+s.length||t&&a===s.offset+s.length}function $(s,a,t=!1){if(y(s,a,t)){const o=s.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=a;n++){const c=$(o[n],a,t);if(c)return c}return s}}function S(s,a,t=D.DEFAULT){const o=O(s,!1);function n(H){return H?()=>H(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(H){return H?ne=>H(ne,o.getTokenOffset(),o.getTokenLength()):()=>!0}const h=n(a.onObjectBegin),P=c(a.onObjectProperty),w=n(a.onObjectEnd),R=n(a.onArrayBegin),L=n(a.onArrayEnd),A=c(a.onLiteralValue),T=c(a.onSeparator),j=n(a.onComment),G=c(a.onError),q=t&&t.disallowComments,Q=t&&t.allowTrailingComma;function de(){for(;;){const H=o.scan();switch(o.getTokenError()){case i.InvalidUnicode:x(E.InvalidUnicode);break;case i.InvalidEscapeCharacter:x(E.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:x(E.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:q||x(E.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:x(E.UnexpectedEndOfString);break;case i.InvalidCharacter:x(E.InvalidCharacter);break}switch(H){case r.LineCommentTrivia:case r.BlockCommentTrivia:q?x(E.InvalidCommentToken):j();break;case r.Unknown:x(E.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return H}}}function x(H,ne=[],V=[]){if(G(H),ne.length+V.length>0){let ce=o.getToken();for(;ce!==r.EOF;){if(ne.indexOf(ce)!==-1){de();break}else if(V.indexOf(ce)!==-1)break;ce=de()}}}function J(H){const ne=o.getTokenValue();return H?A(ne):P(ne),de(),!0}function B(){switch(o.getToken()){case r.NumericLiteral:{let H=0;try{H=JSON.parse(o.getTokenValue()),typeof H!="number"&&(x(E.InvalidNumberFormat),H=0)}catch{x(E.InvalidNumberFormat)}A(H);break}case r.NullKeyword:A(null);break;case r.TrueKeyword:A(!0);break;case r.FalseKeyword:A(!1);break;default:return!1}return de(),!0}function _(){return o.getToken()!==r.StringLiteral?(x(E.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(J(!1),o.getToken()===r.ColonToken?(T(":"),de(),F()||x(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):x(E.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function C(){h(),de();let H=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(H||x(E.ValueExpected,[],[]),T(","),de(),o.getToken()===r.CloseBraceToken&&Q)break}else H&&x(E.CommaExpected,[],[]);_()||x(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),H=!0}return w(),o.getToken()!==r.CloseBraceToken?x(E.CloseBraceExpected,[r.CloseBraceToken],[]):de(),!0}function W(){R(),de();let H=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(H||x(E.ValueExpected,[],[]),T(","),de(),o.getToken()===r.CloseBracketToken&&Q)break}else H&&x(E.CommaExpected,[],[]);F()||x(E.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),H=!0}return L(),o.getToken()!==r.CloseBracketToken?x(E.CloseBracketExpected,[r.CloseBracketToken],[]):de(),!0}function F(){switch(o.getToken()){case r.OpenBracketToken:return W();case r.OpenBraceToken:return C();case r.StringLiteral:return J(!0);default:return B()}}return de(),o.getToken()===r.EOF?t.allowEmptyContent?!0:(x(E.ValueExpected,[],[]),!1):F()?(o.getToken()!==r.EOF&&x(E.EndOfFileExpected,[],[]),!0):(x(E.ValueExpected,[],[]),!1)}function k(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[144],ue([0,1,43]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=r,e.$_n=E,e.$ao=I,e.$bo=b;function r(l,g,u){let m,p,f,d,v;if(g){for(d=g.offset,v=d+g.length,f=d;f>0&&!b(l,f-1);)f--;let P=v;for(;P<l.length&&!b(l,P);)P++;p=l.substring(f,P),m=O(p,u)}else p=l,m=0,f=0,d=0,v=l.length;const y=I(u,l);let $=!1,S=0,k;u.insertSpaces?k=D(" ",u.tabSize||4):k="	";const s=(0,i.$Zn)(p,!1);let a=!1;function t(){return y+D(k,m+S)}function o(){let P=s.scan();for($=!1;P===i.SyntaxKind.Trivia||P===i.SyntaxKind.LineBreakTrivia;)$=$||P===i.SyntaxKind.LineBreakTrivia,P=s.scan();return a=P===i.SyntaxKind.Unknown||s.getTokenError()!==i.ScanError.None,P}const n=[];function c(P,w,R){!a&&w<v&&R>d&&l.substring(w,R)!==P&&n.push({offset:w,length:R-w,content:P})}let h=o();if(h!==i.SyntaxKind.EOF){const P=s.getTokenOffset()+f,w=D(k,m);c(w,f,P)}for(;h!==i.SyntaxKind.EOF;){let P=s.getTokenOffset()+s.getTokenLength()+f,w=o(),R="";for(;!$&&(w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia);){const A=s.getTokenOffset()+f;c(" ",P,A),P=s.getTokenOffset()+s.getTokenLength()+f,R=w===i.SyntaxKind.LineCommentTrivia?t():"",w=o()}if(w===i.SyntaxKind.CloseBraceToken)h!==i.SyntaxKind.OpenBraceToken&&(S--,R=t());else if(w===i.SyntaxKind.CloseBracketToken)h!==i.SyntaxKind.OpenBracketToken&&(S--,R=t());else{switch(h){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:S++,R=t();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:R=t();break;case i.SyntaxKind.BlockCommentTrivia:$?R=t():R=" ";break;case i.SyntaxKind.ColonToken:R=" ";break;case i.SyntaxKind.StringLiteral:if(w===i.SyntaxKind.ColonToken){R="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia?R=" ":w!==i.SyntaxKind.CommaToken&&w!==i.SyntaxKind.EOF&&(a=!0);break;case i.SyntaxKind.Unknown:a=!0;break}$&&(w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia)&&(R=t())}const L=s.getTokenOffset()+f;c(R,P,L),h=w}return n}function E(l,g){const u=JSON.stringify(l,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?u.replace(/\r\n|\r|\n/g,g.eol):u}function D(l,g){let u="";for(let m=0;m<g;m++)u+=l;return u}function O(l,g){let u=0,m=0;const p=g.tabSize||4;for(;u<l.length;){const f=l.charAt(u);if(f===" ")m++;else if(f==="	")m+=p;else break;u++}return Math.floor(m/p)}function I(l,g){for(let u=0;u<g.length;u++){const m=g.charAt(u);if(m==="\r")return u+1<g.length&&g.charAt(u+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return l&&l.eol||`
`}function b(l,g){return`\r
`.indexOf(l.charAt(g))!==-1}}),define(le[110],ue([0,1,43,144]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=E,e.$do=D,e.$eo=O,e.$fo=I,e.$go=b;function E(l,g,u){return D(l,g,void 0,u)}function D(l,g,u,m,p){const f=g.slice(),d=[],v=(0,i.$3n)(l,d);let y,$;for(;f.length>0&&($=f.pop(),y=(0,i.$4n)(v,f),y===void 0&&u!==void 0);)typeof $=="string"?u={[$]:u}:u=[u];if(y)if(y.type==="object"&&typeof $=="string"&&Array.isArray(y.children)){const S=(0,i.$4n)(y,[$]);if(S!==void 0)if(u===void 0){if(!S.parent)throw new Error("Malformed AST");const k=y.children.indexOf(S.parent);let s,a=S.parent.offset+S.parent.length;if(k>0){const t=y.children[k-1];s=t.offset+t.length}else s=y.offset+1,y.children.length>1&&(a=y.children[1].offset);return O(l,{offset:s,length:a-s,content:""},m)}else return O(l,{offset:S.offset,length:S.length,content:JSON.stringify(u)},m);else{if(u===void 0)return[];const k=`${JSON.stringify($)}: ${JSON.stringify(u)}`,s=p?p(y.children.map(t=>t.children[0].value)):y.children.length;let a;if(s>0){const t=y.children[s-1];a={offset:t.offset+t.length,length:0,content:","+k}}else y.children.length===0?a={offset:y.offset+1,length:0,content:k}:a={offset:y.offset+1,length:0,content:k+","};return O(l,a,m)}}else if(y.type==="array"&&typeof $=="number"&&Array.isArray(y.children))if(u!==void 0){const S=`${JSON.stringify(u)}`;let k;if(y.children.length===0||$===0)k={offset:y.offset+1,length:0,content:y.children.length===0?S:S+","};else{const s=$===-1||$>y.children.length?y.children.length:$,a=y.children[s-1];k={offset:a.offset+a.length,length:0,content:","+S}}return O(l,k,m)}else{const S=$,k=y.children[S];let s;if(y.children.length===1)s={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===S){const a=y.children[S-1],t=a.offset+a.length,o=y.offset+y.length;s={offset:t,length:o-2-t,content:""}}else s={offset:k.offset,length:y.children[S+1].offset-k.offset,content:""};return O(l,s,m)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${y.type}`);else return u===void 0?[]:O(l,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(u)},m)}function O(l,g,u){let m=I(l,g),p=g.offset,f=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;p>0&&!(0,r.$bo)(m,p-1);)p--;for(;f<m.length&&!(0,r.$bo)(m,f);)f++}const d=(0,r.$$n)(m,{offset:p,length:f-p},u);for(let y=d.length-1;y>=0;y--){const $=d[y];m=I(m,$),p=Math.min(p,$.offset),f=Math.max(f,$.offset+$.length),f+=$.content.length-$.length}const v=l.length-(m.length-f)-p;return[{offset:p,length:v,content:m.substring(p,f)}]}function I(l,g){return l.substring(0,g.offset)+g.content+l.substring(g.offset+g.length)}function b(l,g){const u=g.slice(0).sort((p,f)=>{const d=p.offset-f.offset;return d===0?p.length-f.length:d});let m=l.length;for(let p=u.length-1;p>=0;p--){const f=u[p];if(f.offset+f.length<=m)l=I(l,f);else throw new Error("Overlapping edit");m=f.offset}return l}}),define(le[145],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=i;function i(D){let O=!1;const I=new Map,b=new Map;if(E(D,d=>{if(D===d)return!0;const v=JSON.stringify(d);if(v.length<30)return!0;const y=I.get(v);if(!y){const $={schemas:[d]};return I.set(v,$),b.set(d,$),!0}return y.schemas.push(d),b.set(d,y),O=!0,!1}),I.clear(),!O)return JSON.stringify(D);let g="$defs";for(;D.hasOwnProperty(g);)g+="_";const u=[];function m(d){return JSON.stringify(d,(v,y)=>{if(y!==d){const $=b.get(y);if($&&$.schemas.length>1)return $.id||($.id=`_${u.length}`,u.push($.schemas[0])),{$ref:`#/${g}/${$.id}`}}return y})}const p=m(D),f=[];for(let d=0;d<u.length;d++)f.push(`"_${d}":${m(u[d])}`);return f.length?`${p.substring(0,p.length-1)},"${g}":{${f.join(",")}}}`:p}function r(D){return typeof D=="object"&&D!==null}function E(D,O){if(!D||typeof D!="object")return;const I=(...p)=>{for(const f of p)r(f)&&u.push(f)},b=(...p)=>{for(const f of p)if(r(f))for(const d in f){const v=f[d];r(v)&&u.push(v)}},l=(...p)=>{for(const f of p)if(Array.isArray(f))for(const d of f)r(d)&&u.push(d)},g=p=>{if(Array.isArray(p))for(const f of p)r(f)&&u.push(f);else r(p)&&u.push(p)},u=[D];let m=u.pop();for(;m;)O(m)&&(I(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),b(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),l(m.anyOf,m.allOf,m.oneOf,m.prefixItems),g(m.items)),m=u.pop()}}),function(){function K(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function i(E){return E.replace(e,function(D,O,I,b,l,g){if(b)return"";if(l){const u=l.length;return l[u-1]===`
`?l[u-2]==="\r"?`\r
`:`
`:""}else return g?D.substring(1):D})}function r(E){const D=i(E);try{return JSON.parse(D)}catch{const I=D.replace(/,\s*([}\]])/g,"$1");return JSON.parse(I)}}return{stripComments:i,parse:r}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[68],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class i{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=i}),define(le[111],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(D){this.element=D,this.next=i.Undefined,this.prev=i.Undefined}}class r{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let D=this.a;for(;D!==i.Undefined;){const O=D.next;D.prev=i.Undefined,D.next=i.Undefined,D=O}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,O){const I=new i(D);if(this.a===i.Undefined)this.a=I,this.b=I;else if(O){const l=this.b;this.b=I,I.prev=l,l.next=I}else{const l=this.a;this.a=I,I.next=l,l.prev=I}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(I))}}shift(){if(this.a!==i.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==i.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==i.Undefined&&D.next!==i.Undefined){const O=D.prev;O.next=D.next,D.next.prev=O}else D.prev===i.Undefined&&D.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):D.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):D.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==i.Undefined;)yield D.element,D=D.next}}e.$8c=r}),define(le[31],ue([0,1]),function(K,e){"use strict";var i,r,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=D,e.$Bc=O,e.$Cc=I,e.$Lc=k;function D(s,a,t){let o=s.get(a);return o===void 0&&(o=t,s.set(a,o)),o}function O(s){const a=[];return s.forEach((t,o)=>{a.push(`${o} => ${t}`)}),`Map(${s.size}) {${a.join(", ")}}`}function I(s){const a=[];return s.forEach(t=>{a.push(t)}),`Set(${s.size}) {${a.join(", ")}}`}class b{constructor(a,t){this.uri=a,this.value=t}}function l(s){return Array.isArray(s)}class g{static{this.c=a=>a.toString()}constructor(a,t){if(this[i]="ResourceMap",a instanceof g)this.d=new Map(a.d),this.e=t??g.c;else if(l(a)){this.d=new Map,this.e=t??g.c;for(const[o,n]of a)this.set(o,n)}else this.d=new Map,this.e=a??g.c}set(a,t){return this.d.set(this.e(a),new b(a,t)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,t){typeof t<"u"&&(a=a.bind(t));for(const[o,n]of this.d)a(n.value,n.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}e.$Dc=g;class u{constructor(a,t){this[r]="ResourceSet",!a||typeof a=="function"?this.c=new g(a):(this.c=new g(t),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,t){this.c.forEach((o,n)=>a.call(t,n,n,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=u;var m;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class p{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,t=m.None){const o=this.c.get(a);if(o)return t!==m.None&&this.m(o,t),o.value}set(a,t,o=m.None){let n=this.c.get(a);if(n)n.value=t,o!==m.None&&this.m(n,o);else{switch(n={key:a,value:t,next:void 0,previous:void 0},o){case m.None:this.k(n);break;case m.AsOld:this.j(n);break;case m.AsNew:this.k(n);break;default:this.k(n);break}this.c.set(a,n),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this.c.get(a);if(t)return this.c.delete(a),this.l(t),this.f--,t.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.l(a),this.f--,a.value}forEach(a,t){const o=this.g;let n=this.d;for(;n;){if(t?a.bind(t)(n.value,n.key,this):a(n.value,n.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}values(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}entries(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let t=this.d,o=this.size;for(;t&&o>a;)this.c.delete(t.key),t=t.next,o--;this.d=t,this.f=o,t&&(t.previous=void 0),this.g++}i(a){if(a>=this.size)return;if(a===0){this.clear();return}let t=this.e,o=this.size;for(;t&&o>a;)this.c.delete(t.key),t=t.previous,o--;this.e=t,this.f=o,t&&(t.next=void 0),this.g++}j(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}k(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}l(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const t=a.next,o=a.previous;if(!t||!o)throw new Error("Invalid list");t.previous=o,o.next=t}a.next=void 0,a.previous=void 0,this.g++}m(a,t){if(!this.d||!this.e)throw new Error("Invalid list");if(!(t!==m.AsOld&&t!==m.AsNew)){if(t===m.AsOld){if(a===this.d)return;const o=a.next,n=a.previous;a===this.e?(n.next=void 0,this.e=n):(o.previous=n,n.next=o),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(t===m.AsNew){if(a===this.e)return;const o=a.next,n=a.previous;a===this.d?(o.previous=void 0,this.d=o):(o.previous=n,n.next=o),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((t,o)=>{a.push([o,t])}),a}fromJSON(a){this.clear();for(const[t,o]of a)this.set(t,o)}}e.$Fc=p;class f extends p{constructor(a,t=1){super(),this.n=a,this.o=Math.min(Math.max(0,t),1)}get limit(){return this.n}set limit(a){this.n=a,this.p()}get ratio(){return this.o}set ratio(a){this.o=Math.min(Math.max(0,a),1),this.p()}get(a,t=m.AsNew){return super.get(a,t)}peek(a){return super.get(a,m.None)}set(a,t){return super.set(a,t,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends f{constructor(a,t=1){super(a,t)}q(a){this.h(a)}set(a,t){return super.set(a,t),this.p(),this}}e.$Gc=d;class v extends f{constructor(a,t=1){super(a,t)}q(a){this.i(a)}set(a,t){return this.n<=this.size&&!this.has(a)&&this.q(Math.round(this.n*this.o)-1),super.set(a,t),this}}e.$Hc=v;class y{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let t=this.c.get(a)||0;return t===0?!1:(t--,t===0?this.c.delete(a):this.c.set(a,t),!0)}has(a){return this.c.has(a)}}e.$Ic=y;class ${constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[t,o]of a)this.set(t,o)}clear(){this.c.clear(),this.d.clear()}set(a,t){this.c.set(a,t),this.d.set(t,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const t=this.c.get(a);return t===void 0?!1:(this.c.delete(a),this.d.delete(t),!0)}forEach(a,t){this.c.forEach((o,n)=>{a.call(t,o,n,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=$;class S{constructor(){this.c=new Map}add(a,t){let o=this.c.get(a);o||(o=new Set,this.c.set(a,o)),o.add(t)}delete(a,t){const o=this.c.get(a);o&&(o.delete(t),o.size===0&&this.c.delete(a))}forEach(a,t){const o=this.c.get(a);o&&o.forEach(t)}get(a){const t=this.c.get(a);return t||new Set}}e.$Kc=S;function k(s,a){if(s===a)return!0;if(s.size!==a.size)return!1;for(const[t,o]of s)if(!a.has(t)||a.get(t)!==o)return!1;for(const[t]of a)if(!s.has(t))return!1;return!0}}),define(le[2],ue([0,1,21,141,31,91,78]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=g,e.$Oc=u,e.$Pc=m,e.$Qc=d,e.$Rc=v,e.$Sc=y,e.$Tc=$,e.$Uc=S,e.$Vc=k,e.$6c=R;const I=!1;let b=null;class l{constructor(){this.b=new Map}static{this.a=0}c(T){let j=this.b.get(T);return j||(j={parent:null,source:null,isSingleton:!1,value:T,idx:l.a++},this.b.set(T,j)),j}trackDisposable(T){const j=this.c(T);j.source||(j.source=new Error().stack)}setParent(T,j){const G=this.c(T);G.parent=j}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,j){const G=j.get(T);if(G)return G;const q=T.parent?this.f(this.c(T.parent),j):T;return j.set(T,q),q}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,G])=>G.source!==null&&!this.f(G,T).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(T=10,j){let G;if(j)G=j;else{const J=new Map,B=[...this.b.values()].filter(C=>C.source!==null&&!this.f(C,J).isSingleton);if(B.length===0)return;const _=new Set(B.map(C=>C.value));if(G=B.filter(C=>!(C.parent&&_.has(C.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function q(J){function B(C,W){for(;C.length>0&&W.some(F=>typeof F=="string"?F===C[0]:C[0].match(F));)C.shift()}const _=J.source.split(`
`).map(C=>C.trim().replace("at ","")).filter(C=>C!=="");return B(_,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),_.reverse()}const Q=new E.$Kc;for(const J of G){const B=q(J);for(let _=0;_<=B.length;_++)Q.add(B.slice(0,_).join(`
`),J)}G.sort((0,i.$8b)(J=>J.idx,i.$0b));let de="",x=0;for(const J of G.slice(0,T)){x++;const B=q(J),_=[];for(let C=0;C<B.length;C++){let W=B[C];W=`(shared with ${Q.get(B.slice(0,C+1).join(`
`)).size}/${G.length} leaks) at ${W}`;const H=Q.get(B.slice(0,C).join(`
`)),ne=(0,r.$c)([...H].map(V=>q(V)[C]),V=>V);delete ne[B[C]];for(const[V,ce]of Object.entries(ne))_.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${V}`);_.unshift(W)}de+=`


==================== Leaking disposable ${x}/${G.length}: ${J.value.constructor.name} ====================
${_.join(`
`)}
============================================================

`}return G.length>T&&(de+=`


... and ${G.length-T} more leaking disposables

`),{leaks:G,details:de}}}e.$Mc=l;function g(A){b=A}if(I){const A="__is_disposable_tracked__";g(new class{trackDisposable(T){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[A]||console.log(j)},3e3)}setParent(T,j){if(T&&T!==a.None)try{T[A]=!0}catch{}}markAsDisposed(T){if(T&&T!==a.None)try{T[A]=!0}catch{}}markAsSingleton(T){}})}function u(A){return b?.trackDisposable(A),A}function m(A){b?.markAsDisposed(A)}function p(A,T){b?.setParent(A,T)}function f(A,T){if(b)for(const j of A)b.setParent(j,T)}function d(A){return b?.markAsSingleton(A),A}function v(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function y(A){if(O.Iterable.is(A)){const T=[];for(const j of A)if(j)try{j.dispose()}catch(G){T.push(G)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function $(A){for(const T of A)v(T)&&T.dispose();return[]}function S(...A){const T=k(()=>y(A));return f(A,T),T}function k(A){const T=u({dispose:(0,D.$fb)(()=>{m(T),A()})});return T}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{y(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return p(T,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),p(T,null))}}e.$Wc=s;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,u(this),p(this.q,this)}dispose(){m(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}e.$Xc=a;class t{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&p(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&p(T,null),T}}e.$Yc=t;class o{constructor(T){this.a=new t,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=o;class n{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=n;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(T){let j=T;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,m(this))},this}}e.$2c=c;class h{constructor(){this.a=new Map}acquire(T,...j){let G=this.a.get(T);G||(G={counter:0,object:this.b(T,...j)},this.a.set(T,G));const{object:q}=G,Q=(0,D.$fb)(()=>{--G.counter===0&&(this.c(T,G.object),this.a.delete(T))});return G.counter++,{object:q,dispose:Q}}}e.$3c=h;class P{constructor(T){this.a=T}async acquire(T,...j){const G=this.a.acquire(T,...j);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(q){throw G.dispose(),q}}}e.$4c=P;class w{constructor(T){this.object=T}dispose(){}}e.$5c=w;function R(A){const T=new s;try{A(T)}finally{T.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,j,G=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this.a.get(T)?.dispose(),this.a.set(T,j)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}deleteAndLeak(T){const j=this.a.get(T);return this.a.delete(T),j}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=L}),define(le[92],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(le[79],ue([0,1,31]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0,e.$qm=E,e.$rm=O;const r=new i.$Gc(1e4);function E(l){return b(l,"NFC",r)}const D=new i.$Gc(1e4);function O(l){return b(l,"NFD",D)}const I=/[^\u0000-\u0080]/;function b(l,g,u){if(!l)return l;const m=u.get(l);if(m)return m;let p;return I.test(l)?p=l.normalize(g):p=l,u.set(l,p),p}e.$sm=function(){const l=/[\u0300-\u036f]/g;return function(g){return O(g).replace(l,"")}}()}),define(le[146],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0,e.$Om=i,e.rot=r,e.$Tm=I;function i(b,l,g){return Math.min(Math.max(b,l),g)}function r(b,l){return(l+b%l)%l}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Qm=E;class D{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rm=D;class O{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const g=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sm=O;function I(b,l,g,u,m,p,f,d){const v=f-g,y=d-u,$=m-g,S=p-u,k=b-g,s=l-u,a=v*v+y*y,t=v*$+y*S,o=v*k+y*s,n=$*$+S*S,c=$*k+S*s,h=1/(a*n-t*t),P=(n*o-t*c)*h,w=(a*c-t*o)*h;return P>=0&&w>=0&&P+w<1}}),function(){function K(E){const D=[];typeof E=="number"&&D.push("code/timeOrigin",E);function O(b){D.push(b,Date.now())}function I(){const b=[];for(let l=0;l<D.length;l+=2)b.push({name:D[l],startTime:D[l+1]});return b}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const O of performance.getEntriesByType("mark"))D.push({name:O.name,startTime:Math.round(E+O.startTime)});return D}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function i(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=i(r))}(),define(le[3],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=a,e.$E=P,e.$K=w,e.$h="en";let i=!1,r=!1,E=!1,D=!1,O=!1,I=!1,b=!1,l=!1,g=!1,u=!1,m,p=e.$h,f=e.$h,d,v;const y=globalThis;let $;typeof y.vscode<"u"&&typeof y.vscode.process<"u"?$=y.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const S=typeof $?.versions?.electron=="string",k=S&&$?.type==="renderer";if(typeof $=="object"){i=$.platform==="win32",r=$.platform==="darwin",E=$.platform==="linux",D=E&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,b=S,g=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$h,p=e.$h;const R=$.env.VSCODE_NLS_CONFIG;if(R)try{const L=JSON.parse(R);m=L.userLocale,f=L.osLocale,p=L.resolvedLanguage||e.$h,d=L.languagePack?.translationsConfigFile}catch{}O=!0}else typeof navigator=="object"&&!k?(v=navigator.userAgent,i=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,l=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=v.indexOf("Linux")>=0,u=v?.indexOf("Mobi")>=0,I=!0,p=globalThis._VSCODE_NLS_LANGUAGE||e.$h,m=navigator.language.toLowerCase(),f=m):console.error("Unable to resolve platform.");var s;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(s||(e.Platform=s={}));function a(R){switch(R){case s.Web:return"Web";case s.Mac:return"Mac";case s.Linux:return"Linux";case s.Windows:return"Windows"}}let t=s.Web;r?t=s.Mac:i?t=s.Windows:E&&(t=s.Linux),e.$j=i,e.$k=r,e.$l=E,e.$m=D,e.$n=O,e.$o=b,e.$p=I,e.$q=I&&typeof y.importScripts=="function",e.$r=e.$q?y.origin:void 0,e.$s=l,e.$t=u,e.$u=g,e.$v=t,e.$w=v,e.$x=p;var o;(function(R){function L(){return e.$x}R.value=L;function A(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}R.isDefaultVariant=A;function T(){return e.$x==="en"}R.isDefault=T})(o||(e.Language=o={})),e.$y=m,e.$z=f,e.$A=d,e.$B=typeof y.postMessage=="function"&&!y.importScripts,e.$C=(()=>{if(e.$B){const R=[];y.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let T=0,j=R.length;T<j;T++){const G=R[T];if(G.id===A.data.vscodeScheduleAsyncWork){R.splice(T,1),G.callback();return}}});let L=0;return A=>{const T=++L;R.push({id:T,callback:A}),y.postMessage({vscodeScheduleAsyncWork:T},"*")}}return R=>setTimeout(R)})();var n;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=r||l?n.Macintosh:i?n.Windows:n.Linux;let c=!0,h=!1;function P(){if(!h){h=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,c=new Uint16Array(R.buffer)[0]===513}return c}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function w(R){return parseFloat(R)>=20}}),define(le[37],ue([0,1,3]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const D=E.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return i.$j?"win32":i.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$gc=r.platform,e.$hc=r.arch});var At=this&&this.__createBinding||(Object.create?function(K,e,i,r){r===void 0&&(r=i);var E=Object.getOwnPropertyDescriptor(e,i);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[i]}}),Object.defineProperty(K,r,E)}:function(K,e,i,r){r===void 0&&(r=i),K[r]=e[i]}),Ot=this&&this.__setModuleDefault||(Object.create?function(K,e){Object.defineProperty(K,"default",{enumerable:!0,value:e})}:function(K,e){K.default=e}),Ie=this&&this.__importStar||function(K){if(K&&K.__esModule)return K;var e={};if(K!=null)for(var i in K)i!=="default"&&Object.prototype.hasOwnProperty.call(K,i)&&At(e,K,i);return Ot(e,K),e};define(le[9],ue([0,1,37]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,i=Ie(i);const r=65,E=97,D=90,O=122,I=46,b=47,l=92,g=58,u=63;class m extends Error{constructor(o,n,c){let h;typeof n=="string"&&n.indexOf("not ")===0?(h="must not be",n=n.replace(/^not /,"")):h="must be";const P=o.indexOf(".")!==-1?"property":"argument";let w=`The "${o}" ${P} ${h} of type ${n}`;w+=`. Received type ${typeof c}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function p(t,o){if(t===null||typeof t!="object")throw new m(o,"Object",t)}function f(t,o){if(typeof t!="string")throw new m(o,"string",t)}const d=i.$gc==="win32";function v(t){return t===b||t===l}function y(t){return t===b}function $(t){return t>=r&&t<=D||t>=E&&t<=O}function S(t,o,n,c){let h="",P=0,w=-1,R=0,L=0;for(let A=0;A<=t.length;++A){if(A<t.length)L=t.charCodeAt(A);else{if(c(L))break;L=b}if(c(L)){if(!(w===A-1||R===1))if(R===2){if(h.length<2||P!==2||h.charCodeAt(h.length-1)!==I||h.charCodeAt(h.length-2)!==I){if(h.length>2){const T=h.lastIndexOf(n);T===-1?(h="",P=0):(h=h.slice(0,T),P=h.length-1-h.lastIndexOf(n)),w=A,R=0;continue}else if(h.length!==0){h="",P=0,w=A,R=0;continue}}o&&(h+=h.length>0?`${n}..`:"..",P=2)}else h.length>0?h+=`${n}${t.slice(w+1,A)}`:h=t.slice(w+1,A),P=A-w-1;w=A,R=0}else L===I&&R!==-1?++R:R=-1}return h}function k(t){return t?`${t[0]==="."?"":"."}${t}`:""}function s(t,o){p(o,"pathObject");const n=o.dir||o.root,c=o.base||`${o.name||""}${k(o.ext)}`;return n?n===o.root?`${n}${c}`:`${n}${t}${c}`:c}e.$ic={resolve(...t){let o="",n="",c=!1;for(let h=t.length-1;h>=-1;h--){let P;if(h>=0){if(P=t[h],f(P,`paths[${h}]`),P.length===0)continue}else o.length===0?P=i.cwd():(P=i.env[`=${o}`]||i.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==o.toLowerCase()&&P.charCodeAt(2)===l)&&(P=`${o}\\`));const w=P.length;let R=0,L="",A=!1;const T=P.charCodeAt(0);if(w===1)v(T)&&(R=1,A=!0);else if(v(T))if(A=!0,v(P.charCodeAt(1))){let j=2,G=j;for(;j<w&&!v(P.charCodeAt(j));)j++;if(j<w&&j!==G){const q=P.slice(G,j);for(G=j;j<w&&v(P.charCodeAt(j));)j++;if(j<w&&j!==G){for(G=j;j<w&&!v(P.charCodeAt(j));)j++;(j===w||j!==G)&&(L=`\\\\${q}\\${P.slice(G,j)}`,R=j)}}}else R=1;else $(T)&&P.charCodeAt(1)===g&&(L=P.slice(0,2),R=2,w>2&&v(P.charCodeAt(2))&&(A=!0,R=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(c){if(o.length>0)break}else if(n=`${P.slice(R)}\\${n}`,c=A,A&&o.length>0)break}return n=S(n,!c,"\\",v),c?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){f(t,"path");const o=t.length;if(o===0)return".";let n=0,c,h=!1;const P=t.charCodeAt(0);if(o===1)return y(P)?"\\":t;if(v(P))if(h=!0,v(t.charCodeAt(1))){let R=2,L=R;for(;R<o&&!v(t.charCodeAt(R));)R++;if(R<o&&R!==L){const A=t.slice(L,R);for(L=R;R<o&&v(t.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&!v(t.charCodeAt(R));)R++;if(R===o)return`\\\\${A}\\${t.slice(L)}\\`;R!==L&&(c=`\\\\${A}\\${t.slice(L,R)}`,n=R)}}}else n=1;else $(P)&&t.charCodeAt(1)===g&&(c=t.slice(0,2),n=2,o>2&&v(t.charCodeAt(2))&&(h=!0,n=3));let w=n<o?S(t.slice(n),!h,"\\",v):"";return w.length===0&&!h&&(w="."),w.length>0&&v(t.charCodeAt(o-1))&&(w+="\\"),c===void 0?h?`\\${w}`:w:h?`${c}\\${w}`:`${c}${w}`},isAbsolute(t){f(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return v(n)||o>2&&$(n)&&t.charCodeAt(1)===g&&v(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let P=0;P<t.length;++P){const w=t[P];f(w,"path"),w.length>0&&(o===void 0?o=n=w:o+=`\\${w}`)}if(o===void 0)return".";let c=!0,h=0;if(typeof n=="string"&&v(n.charCodeAt(0))){++h;const P=n.length;P>1&&v(n.charCodeAt(1))&&(++h,P>2&&(v(n.charCodeAt(2))?++h:c=!1))}if(c){for(;h<o.length&&v(o.charCodeAt(h));)h++;h>=2&&(o=`\\${o.slice(h)}`)}return e.$ic.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o)return"";const n=e.$ic.resolve(t),c=e.$ic.resolve(o);if(n===c||(t=n.toLowerCase(),o=c.toLowerCase(),t===o))return"";let h=0;for(;h<t.length&&t.charCodeAt(h)===l;)h++;let P=t.length;for(;P-1>h&&t.charCodeAt(P-1)===l;)P--;const w=P-h;let R=0;for(;R<o.length&&o.charCodeAt(R)===l;)R++;let L=o.length;for(;L-1>R&&o.charCodeAt(L-1)===l;)L--;const A=L-R,T=w<A?w:A;let j=-1,G=0;for(;G<T;G++){const Q=t.charCodeAt(h+G);if(Q!==o.charCodeAt(R+G))break;Q===l&&(j=G)}if(G!==T){if(j===-1)return c}else{if(A>T){if(o.charCodeAt(R+G)===l)return c.slice(R+G+1);if(G===2)return c.slice(R+G)}w>T&&(t.charCodeAt(h+G)===l?j=G:G===2&&(j=3)),j===-1&&(j=0)}let q="";for(G=h+j+1;G<=P;++G)(G===P||t.charCodeAt(G)===l)&&(q+=q.length===0?"..":"\\..");return R+=j,q.length>0?`${q}${c.slice(R,L)}`:(c.charCodeAt(R)===l&&++R,c.slice(R,L))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$ic.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const n=o.charCodeAt(2);if(n!==u&&n!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if($(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){f(t,"path");const o=t.length;if(o===0)return".";let n=-1,c=0;const h=t.charCodeAt(0);if(o===1)return v(h)?t:".";if(v(h)){if(n=c=1,v(t.charCodeAt(1))){let R=2,L=R;for(;R<o&&!v(t.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&v(t.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&!v(t.charCodeAt(R));)R++;if(R===o)return t;R!==L&&(n=c=R+1)}}}}else $(h)&&t.charCodeAt(1)===g&&(n=o>2&&v(t.charCodeAt(2))?3:2,c=n);let P=-1,w=!0;for(let R=o-1;R>=c;--R)if(v(t.charCodeAt(R))){if(!w){P=R;break}}else w=!1;if(P===-1){if(n===-1)return".";P=n}return t.slice(0,P)},basename(t,o){o!==void 0&&f(o,"suffix"),f(t,"path");let n=0,c=-1,h=!0,P;if(t.length>=2&&$(t.charCodeAt(0))&&t.charCodeAt(1)===g&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,R=-1;for(P=t.length-1;P>=n;--P){const L=t.charCodeAt(P);if(v(L)){if(!h){n=P+1;break}}else R===-1&&(h=!1,R=P+1),w>=0&&(L===o.charCodeAt(w)?--w===-1&&(c=P):(w=-1,c=R))}return n===c?c=R:c===-1&&(c=t.length),t.slice(n,c)}for(P=t.length-1;P>=n;--P)if(v(t.charCodeAt(P))){if(!h){n=P+1;break}}else c===-1&&(h=!1,c=P+1);return c===-1?"":t.slice(n,c)},extname(t){f(t,"path");let o=0,n=-1,c=0,h=-1,P=!0,w=0;t.length>=2&&t.charCodeAt(1)===g&&$(t.charCodeAt(0))&&(o=c=2);for(let R=t.length-1;R>=o;--R){const L=t.charCodeAt(R);if(v(L)){if(!P){c=R+1;break}continue}h===-1&&(P=!1,h=R+1),L===I?n===-1?n=R:w!==1&&(w=1):n!==-1&&(w=-1)}return n===-1||h===-1||w===0||w===1&&n===h-1&&n===c+1?"":t.slice(n,h)},format:s.bind(null,"\\"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let c=0,h=t.charCodeAt(0);if(n===1)return v(h)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(v(h)){if(c=1,v(t.charCodeAt(1))){let j=2,G=j;for(;j<n&&!v(t.charCodeAt(j));)j++;if(j<n&&j!==G){for(G=j;j<n&&v(t.charCodeAt(j));)j++;if(j<n&&j!==G){for(G=j;j<n&&!v(t.charCodeAt(j));)j++;j===n?c=j:j!==G&&(c=j+1)}}}}else if($(h)&&t.charCodeAt(1)===g){if(n<=2)return o.root=o.dir=t,o;if(c=2,v(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;c=3}}c>0&&(o.root=t.slice(0,c));let P=-1,w=c,R=-1,L=!0,A=t.length-1,T=0;for(;A>=c;--A){if(h=t.charCodeAt(A),v(h)){if(!L){w=A+1;break}continue}R===-1&&(L=!1,R=A+1),h===I?P===-1?P=A:T!==1&&(T=1):P!==-1&&(T=-1)}return R!==-1&&(P===-1||T===0||T===1&&P===R-1&&P===w+1?o.base=o.name=t.slice(w,R):(o.name=t.slice(w,P),o.base=t.slice(w,R),o.ext=t.slice(P,R))),w>0&&w!==c?o.dir=t.slice(0,w-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(d){const t=/\\/g;return()=>{const o=i.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>i.cwd()})();e.$jc={resolve(...t){let o="",n=!1;for(let c=t.length-1;c>=-1&&!n;c--){const h=c>=0?t[c]:a();f(h,`paths[${c}]`),h.length!==0&&(o=`${h}/${o}`,n=h.charCodeAt(0)===b)}return o=S(o,!n,"/",y),n?`/${o}`:o.length>0?o:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===b,n=t.charCodeAt(t.length-1)===b;return t=S(t,!o,"/",y),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const c=t[n];f(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.$jc.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o||(t=e.$jc.resolve(t),o=e.$jc.resolve(o),t===o))return"";const n=1,c=t.length,h=c-n,P=1,w=o.length-P,R=h<w?h:w;let L=-1,A=0;for(;A<R;A++){const j=t.charCodeAt(n+A);if(j!==o.charCodeAt(P+A))break;j===b&&(L=A)}if(A===R)if(w>R){if(o.charCodeAt(P+A)===b)return o.slice(P+A+1);if(A===0)return o.slice(P+A)}else h>R&&(t.charCodeAt(n+A)===b?L=A:A===0&&(L=0));let T="";for(A=n+L+1;A<=c;++A)(A===c||t.charCodeAt(A)===b)&&(T+=T.length===0?"..":"/..");return`${T}${o.slice(P+L)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===b;let n=-1,c=!0;for(let h=t.length-1;h>=1;--h)if(t.charCodeAt(h)===b){if(!c){n=h;break}}else c=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&f(o,"ext"),f(t,"path");let n=0,c=-1,h=!0,P;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,R=-1;for(P=t.length-1;P>=0;--P){const L=t.charCodeAt(P);if(L===b){if(!h){n=P+1;break}}else R===-1&&(h=!1,R=P+1),w>=0&&(L===o.charCodeAt(w)?--w===-1&&(c=P):(w=-1,c=R))}return n===c?c=R:c===-1&&(c=t.length),t.slice(n,c)}for(P=t.length-1;P>=0;--P)if(t.charCodeAt(P)===b){if(!h){n=P+1;break}}else c===-1&&(h=!1,c=P+1);return c===-1?"":t.slice(n,c)},extname(t){f(t,"path");let o=-1,n=0,c=-1,h=!0,P=0;for(let w=t.length-1;w>=0;--w){const R=t.charCodeAt(w);if(R===b){if(!h){n=w+1;break}continue}c===-1&&(h=!1,c=w+1),R===I?o===-1?o=w:P!==1&&(P=1):o!==-1&&(P=-1)}return o===-1||c===-1||P===0||P===1&&o===c-1&&o===n+1?"":t.slice(o,c)},format:s.bind(null,"/"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===b;let c;n?(o.root="/",c=1):c=0;let h=-1,P=0,w=-1,R=!0,L=t.length-1,A=0;for(;L>=c;--L){const T=t.charCodeAt(L);if(T===b){if(!R){P=L+1;break}continue}w===-1&&(R=!1,w=L+1),T===I?h===-1?h=L:A!==1&&(A=1):h!==-1&&(A=-1)}if(w!==-1){const T=P===0&&n?1:P;h===-1||A===0||A===1&&h===w-1&&h===P+1?o.base=o.name=t.slice(T,w):(o.name=t.slice(T,h),o.base=t.slice(T,w),o.ext=t.slice(h,w))}return P>0?o.dir=t.slice(0,P-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=d?e.$ic.normalize:e.$jc.normalize,e.$lc=d?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=d?e.$ic.join:e.$jc.join,e.$nc=d?e.$ic.resolve:e.$jc.resolve,e.$oc=d?e.$ic.relative:e.$jc.relative,e.$pc=d?e.$ic.dirname:e.$jc.dirname,e.$qc=d?e.$ic.basename:e.$jc.basename,e.$rc=d?e.$ic.extname:e.$jc.extname,e.$sc=d?e.$ic.format:e.$jc.format,e.$tc=d?e.$ic.parse:e.$jc.parse,e.$uc=d?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=d?e.$ic.sep:e.$jc.sep,e.$wc=d?e.$ic.delimiter:e.$jc.delimiter}),define(le[80],ue([0,1,3]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=D,e.$pm=O;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var E;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function D(I,...b){const l=b.reduce((m,p)=>(m[p]=!0,m),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!l[m]).forEach(m=>{for(let p=0;p<g.length;p++)if(m.search(g[p])!==-1){delete I[m];break}})}function O(I){I&&(delete I.DEBUG,i.$l&&delete I.LD_PRELOAD)}}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var r in i)(typeof exports=="object"?exports:K)[r]=i[r]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function i(r){if(e[r])return e[r].exports;var E=e[r]={i:r,l:!1,exports:{}};return K[r].call(E.exports,E,E.exports,i),E.l=!0,E.exports}return i.m=K,i.c=e,i.d=function(r,E,D){i.o(r,E)||Object.defineProperty(r,E,{enumerable:!0,get:D})},i.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},i.t=function(r,E){if(1&E&&(r=i(r)),8&E||4&E&&typeof r=="object"&&r&&r.__esModule)return r;var D=Object.create(null);if(i.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:r}),2&E&&typeof r!="string")for(var O in r)i.d(D,O,function(I){return r[I]}.bind(null,O));return D},i.n=function(r){var E=r&&r.__esModule?function(){return r.default}:function(){return r};return i.d(E,"a",E),E},i.o=function(r,E){return Object.prototype.hasOwnProperty.call(r,E)},i.p="",i(i.s=0)}([function(K,e,i){(function(r){var E;e=K.exports=ce,E=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],l=0,g=l++;b[g]="0|[1-9]\\d*";var u=l++;b[u]="[0-9]+";var m=l++;b[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=l++;b[p]="("+b[g]+")\\.("+b[g]+")\\.("+b[g]+")";var f=l++;b[f]="("+b[u]+")\\.("+b[u]+")\\.("+b[u]+")";var d=l++;b[d]="(?:"+b[g]+"|"+b[m]+")";var v=l++;b[v]="(?:"+b[u]+"|"+b[m]+")";var y=l++;b[y]="(?:-("+b[d]+"(?:\\."+b[d]+")*))";var $=l++;b[$]="(?:-?("+b[v]+"(?:\\."+b[v]+")*))";var S=l++;b[S]="[0-9A-Za-z-]+";var k=l++;b[k]="(?:\\+("+b[S]+"(?:\\."+b[S]+")*))";var s=l++,a="v?"+b[p]+b[y]+"?"+b[k]+"?";b[s]="^"+a+"$";var t="[v=\\s]*"+b[f]+b[$]+"?"+b[k]+"?",o=l++;b[o]="^"+t+"$";var n=l++;b[n]="((?:<|>)?=?)";var c=l++;b[c]=b[u]+"|x|X|\\*";var h=l++;b[h]=b[g]+"|x|X|\\*";var P=l++;b[P]="[v=\\s]*("+b[h]+")(?:\\.("+b[h]+")(?:\\.("+b[h]+")(?:"+b[y]+")?"+b[k]+"?)?)?";var w=l++;b[w]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[$]+")?"+b[k]+"?)?)?";var R=l++;b[R]="^"+b[n]+"\\s*"+b[P]+"$";var L=l++;b[L]="^"+b[n]+"\\s*"+b[w]+"$";var A=l++;b[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=l++;b[T]="(?:~>?)";var j=l++;b[j]="(\\s*)"+b[T]+"\\s+",I[j]=new RegExp(b[j],"g");var G=l++;b[G]="^"+b[T]+b[P]+"$";var q=l++;b[q]="^"+b[T]+b[w]+"$";var Q=l++;b[Q]="(?:\\^)";var de=l++;b[de]="(\\s*)"+b[Q]+"\\s+",I[de]=new RegExp(b[de],"g");var x=l++;b[x]="^"+b[Q]+b[P]+"$";var J=l++;b[J]="^"+b[Q]+b[w]+"$";var B=l++;b[B]="^"+b[n]+"\\s*("+t+")$|^$";var _=l++;b[_]="^"+b[n]+"\\s*("+a+")$|^$";var C=l++;b[C]="(\\s*)"+b[n]+"\\s*("+t+"|"+b[P]+")",I[C]=new RegExp(b[C],"g");var W=l++;b[W]="^\\s*("+b[P]+")\\s+-\\s+("+b[P]+")\\s*$";var F=l++;b[F]="^\\s*("+b[w]+")\\s+-\\s+("+b[w]+")\\s*$";var H=l++;b[H]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)E(ne,b[ne]),I[ne]||(I[ne]=new RegExp(b[ne]));function V(ee,he){if(ee instanceof ce)return ee;if(typeof ee!="string"||ee.length>D||!(he?I[o]:I[s]).test(ee))return null;try{return new ce(ee,he)}catch{return null}}function ce(ee,he){if(ee instanceof ce){if(ee.loose===he)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof ce))return new ce(ee,he);E("SemVer",ee,he),this.loose=he;var fe=ee.trim().match(he?I[o]:I[s]);if(!fe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ve=+pe;if(ve>=0&&ve<O)return ve}return pe}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(ee,he){var fe=V(ee,he);return fe?fe.version:null},e.clean=function(ee,he){var fe=V(ee.trim().replace(/^[=v]+/,""),he);return fe?fe.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(ee){return E("SemVer.compare",this.version,this.loose,ee),ee instanceof ce||(ee=new ce(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ce.prototype.compareMain=function(ee){return ee instanceof ce||(ee=new ce(ee,this.loose)),Y(this.major,ee.major)||Y(this.minor,ee.minor)||Y(this.patch,ee.patch)},ce.prototype.comparePre=function(ee){if(ee instanceof ce||(ee=new ce(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var he=0;do{var fe=this.prerelease[he],pe=ee.prerelease[he];if(E("prerelease compare",he,fe,pe),fe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(fe===void 0)return-1;if(fe!==pe)return Y(fe,pe)}while(++he)},ce.prototype.inc=function(ee,he){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,he,fe,pe){typeof fe=="string"&&(pe=fe,fe=void 0);try{return new ce(ee,fe).inc(he,pe).version}catch{return null}},e.diff=function(ee,he){if(N(ee,he))return null;var fe=V(ee),pe=V(he);if(fe.prerelease.length||pe.prerelease.length){for(var ve in fe)if((ve==="major"||ve==="minor"||ve==="patch")&&fe[ve]!==pe[ve])return"pre"+ve;return"prerelease"}for(var ve in fe)if((ve==="major"||ve==="minor"||ve==="patch")&&fe[ve]!==pe[ve])return ve},e.compareIdentifiers=Y;var oe=/^[0-9]+$/;function Y(ee,he){var fe=oe.test(ee),pe=oe.test(he);return fe&&pe&&(ee=+ee,he=+he),fe&&!pe?-1:pe&&!fe?1:ee<he?-1:ee>he?1:0}function M(ee,he,fe){return new ce(ee,fe).compare(new ce(he,fe))}function Z(ee,he,fe){return M(ee,he,fe)>0}function U(ee,he,fe){return M(ee,he,fe)<0}function N(ee,he,fe){return M(ee,he,fe)===0}function ie(ee,he,fe){return M(ee,he,fe)!==0}function X(ee,he,fe){return M(ee,he,fe)>=0}function z(ee,he,fe){return M(ee,he,fe)<=0}function te(ee,he,fe,pe){var ve;switch(he){case"===":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),ve=ee===fe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),ve=ee!==fe;break;case"":case"=":case"==":ve=N(ee,fe,pe);break;case"!=":ve=ie(ee,fe,pe);break;case">":ve=Z(ee,fe,pe);break;case">=":ve=X(ee,fe,pe);break;case"<":ve=U(ee,fe,pe);break;case"<=":ve=z(ee,fe,pe);break;default:throw new TypeError("Invalid operator: "+he)}return ve}function ae(ee,he){if(ee instanceof ae){if(ee.loose===he)return ee;ee=ee.value}if(!(this instanceof ae))return new ae(ee,he);E("comparator",ee,he),this.loose=he,this.parse(ee),this.semver===me?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(ee,he){return Y(he,ee)},e.major=function(ee,he){return new ce(ee,he).major},e.minor=function(ee,he){return new ce(ee,he).minor},e.patch=function(ee,he){return new ce(ee,he).patch},e.compare=M,e.compareLoose=function(ee,he){return M(ee,he,!0)},e.rcompare=function(ee,he,fe){return M(he,ee,fe)},e.sort=function(ee,he){return ee.sort(function(fe,pe){return e.compare(fe,pe,he)})},e.rsort=function(ee,he){return ee.sort(function(fe,pe){return e.rcompare(fe,pe,he)})},e.gt=Z,e.lt=U,e.eq=N,e.neq=ie,e.gte=X,e.lte=z,e.cmp=te,e.Comparator=ae;var me={};function be(ee,he){if(ee instanceof be)return ee.loose===he?ee:new be(ee.raw,he);if(ee instanceof ae)return new be(ee.value,he);if(!(this instanceof be))return new be(ee,he);if(this.loose=he,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ye(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,he,fe,pe,ve,je,Oe,Re,We,Ke,Ze,ze,Je){return((he=ye(fe)?"":ye(pe)?">="+fe+".0.0":ye(ve)?">="+fe+"."+pe+".0":">="+he)+" "+(Re=ye(We)?"":ye(Ke)?"<"+(+We+1)+".0.0":ye(Ze)?"<"+We+"."+(+Ke+1)+".0":ze?"<="+We+"."+Ke+"."+Ze+"-"+ze:"<="+Re)).trim()}function xe(ee,he){for(var fe=0;fe<ee.length;fe++)if(!ee[fe].test(he))return!1;if(he.prerelease.length){for(fe=0;fe<ee.length;fe++)if(E(ee[fe].semver),ee[fe].semver!==me&&ee[fe].semver.prerelease.length>0){var pe=ee[fe].semver;if(pe.major===he.major&&pe.minor===he.minor&&pe.patch===he.patch)return!0}return!1}return!0}function Ae(ee,he,fe){try{he=new be(he,fe)}catch{return!1}return he.test(ee)}function $e(ee,he,fe,pe){var ve,je,Oe,Re,We;switch(ee=new ce(ee,pe),he=new be(he,pe),fe){case">":ve=Z,je=z,Oe=U,Re=">",We=">=";break;case"<":ve=U,je=X,Oe=Z,Re="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(ee,he,pe))return!1;for(var Ke=0;Ke<he.set.length;++Ke){var Ze=he.set[Ke],ze=null,Je=null;if(Ze.forEach(function(Qe){Qe.semver===me&&(Qe=new ae(">=0.0.0")),ze=ze||Qe,Je=Je||Qe,ve(Qe.semver,ze.semver,pe)?ze=Qe:Oe(Qe.semver,Je.semver,pe)&&(Je=Qe)}),ze.operator===Re||ze.operator===We||(!Je.operator||Je.operator===Re)&&je(ee,Je.semver)||Je.operator===We&&Oe(ee,Je.semver))return!1}return!0}ae.prototype.parse=function(ee){var he=this.loose?I[B]:I[_],fe=ee.match(he);if(!fe)throw new TypeError("Invalid comparator: "+ee);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ce(fe[2],this.loose):this.semver=me},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(ee){return E("Comparator.test",ee,this.loose),this.semver===me||(typeof ee=="string"&&(ee=new ce(ee,this.loose)),te(ee,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(ee,he){if(!(ee instanceof ae))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new be(ee.value,he),Ae(this.value,fe,he);if(ee.operator==="")return fe=new be(this.value,he),Ae(ee.semver,fe,he);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),je=this.semver.version===ee.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Re=te(this.semver,"<",ee.semver,he)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),We=te(this.semver,">",ee.semver,he)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||ve||je&&Oe||Re||We},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ee){var he=this.loose;ee=ee.trim(),E("range",ee,he);var fe=he?I[F]:I[W];ee=ee.replace(fe,Fe),E("hyphen replace",ee),ee=ee.replace(I[C],"$1$2$3"),E("comparator trim",ee,I[C]),ee=(ee=(ee=ee.replace(I[j],"$1~")).replace(I[de],"$1^")).split(/\s+/).join(" ");var pe=he?I[B]:I[_],ve=ee.split(" ").map(function(je){return function(Oe,Re){return E("comp",Oe),Oe=function(We,Ke){return We.trim().split(/\s+/).map(function(Ze){return function(ze,Je){E("caret",ze,Je);var Qe=Je?I[J]:I[x];return ze.replace(Qe,function(Ye,Ce,se,ge,we){var Ee;return E("caret",ze,Ye,Ce,se,ge,we),ye(Ce)?Ee="":ye(se)?Ee=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ye(ge)?Ee=Ce==="0"?">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+".0 <"+(+Ce+1)+".0.0":we?(E("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),Ee=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+ge+we+" <"+Ce+"."+se+"."+(+ge+1):">="+Ce+"."+se+"."+ge+we+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+ge+we+" <"+(+Ce+1)+".0.0"):(E("no pr"),Ee=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+ge+" <"+Ce+"."+se+"."+(+ge+1):">="+Ce+"."+se+"."+ge+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+ge+" <"+(+Ce+1)+".0.0"),E("caret return",Ee),Ee})}(Ze,Ke)}).join(" ")}(Oe,Re),E("caret",Oe),Oe=function(We,Ke){return We.trim().split(/\s+/).map(function(Ze){return function(ze,Je){var Qe=Je?I[q]:I[G];return ze.replace(Qe,function(Ye,Ce,se,ge,we){var Ee;return E("tilde",ze,Ye,Ce,se,ge,we),ye(Ce)?Ee="":ye(se)?Ee=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ye(ge)?Ee=">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":we?(E("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),Ee=">="+Ce+"."+se+"."+ge+we+" <"+Ce+"."+(+se+1)+".0"):Ee=">="+Ce+"."+se+"."+ge+" <"+Ce+"."+(+se+1)+".0",E("tilde return",Ee),Ee})}(Ze,Ke)}).join(" ")}(Oe,Re),E("tildes",Oe),Oe=function(We,Ke){return E("replaceXRanges",We,Ke),We.split(/\s+/).map(function(Ze){return function(ze,Je){ze=ze.trim();var Qe=Je?I[L]:I[R];return ze.replace(Qe,function(Ye,Ce,se,ge,we,Ee){E("xRange",ze,Ye,Ce,se,ge,we,Ee);var Me=ye(se),Be=Me||ye(ge),_e=Be||ye(we);return Ce==="="&&_e&&(Ce=""),Me?Ye=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&_e?(Be&&(ge=0),_e&&(we=0),Ce===">"?(Ce=">=",Be?(se=+se+1,ge=0,we=0):_e&&(ge=+ge+1,we=0)):Ce==="<="&&(Ce="<",Be?se=+se+1:ge=+ge+1),Ye=Ce+se+"."+ge+"."+we):Be?Ye=">="+se+".0.0 <"+(+se+1)+".0.0":_e&&(Ye=">="+se+"."+ge+".0 <"+se+"."+(+ge+1)+".0"),E("xRange return",Ye),Ye})}(Ze,Ke)}).join(" ")}(Oe,Re),E("xrange",Oe),Oe=function(We,Ke){return E("replaceStars",We,Ke),We.trim().replace(I[H],"")}(Oe,Re),E("stars",Oe),Oe}(je,he)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(je){return!!je.match(pe)})),ve=ve.map(function(je){return new ae(je,he)})},be.prototype.intersects=function(ee,he){if(!(ee instanceof be))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(pe){return ee.set.some(function(ve){return ve.every(function(je){return pe.intersects(je,he)})})})})},e.toComparators=function(ee,he){return new be(ee,he).set.map(function(fe){return fe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ce(ee,this.loose));for(var he=0;he<this.set.length;he++)if(xe(this.set[he],ee))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(ee,he,fe){var pe=null,ve=null;try{var je=new be(he,fe)}catch{return null}return ee.forEach(function(Oe){je.test(Oe)&&(pe&&ve.compare(Oe)!==-1||(ve=new ce(pe=Oe,fe)))}),pe},e.minSatisfying=function(ee,he,fe){var pe=null,ve=null;try{var je=new be(he,fe)}catch{return null}return ee.forEach(function(Oe){je.test(Oe)&&(pe&&ve.compare(Oe)!==1||(ve=new ce(pe=Oe,fe)))}),pe},e.validRange=function(ee,he){try{return new be(ee,he).range||"*"}catch{return null}},e.ltr=function(ee,he,fe){return $e(ee,he,"<",fe)},e.gtr=function(ee,he,fe){return $e(ee,he,">",fe)},e.outside=$e,e.prerelease=function(ee,he){var fe=V(ee,he);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ee,he,fe){return ee=new be(ee,fe),he=new be(he,fe),ee.intersects(he)},e.coerce=function(ee){if(ee instanceof ce)return ee;if(typeof ee!="string")return null;var he=ee.match(I[A]);return he==null?null:V((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,i(1))},function(K,e){var i,r,E=K.exports={};function D(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(v){if(i===setTimeout)return setTimeout(v,0);if((i===D||!i)&&setTimeout)return i=setTimeout,setTimeout(v,0);try{return i(v,0)}catch{try{return i.call(null,v,0)}catch{return i.call(this,v,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:D}catch{i=D}try{r=typeof clearTimeout=="function"?clearTimeout:O}catch{r=O}})();var b,l=[],g=!1,u=-1;function m(){g&&b&&(g=!1,b.length?l=b.concat(l):u=-1,l.length&&p())}function p(){if(!g){var v=I(m);g=!0;for(var y=l.length;y;){for(b=l,l=[];++u<y;)b&&b[u].run();u=-1,y=l.length}b=null,g=!1,function($){if(r===clearTimeout)return clearTimeout($);if((r===O||!r)&&clearTimeout)return r=clearTimeout,clearTimeout($);try{r($)}catch{try{return r.call(null,$)}catch{return r.call(this,$)}}}(v)}}function f(v,y){this.fun=v,this.array=y}function d(){}E.nextTick=function(v){var y=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)y[$-1]=arguments[$];l.push(new f(v,y)),l.length!==1||g||I(p)},f.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=d,E.addListener=d,E.once=d,E.off=d,E.removeListener=d,E.removeAllListeners=d,E.emit=d,E.prependListener=d,E.prependOnceListener=d,E.listeners=function(v){return[]},E.binding=function(v){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(v){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(le[147],ue([0,1]),function(K,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;class r{constructor(I,b,l){this.level=I,this.key=b,this.value=l,this.forward=[]}}const E=void 0;class D{constructor(I,b=2**16){this.comparator=I,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new r(this.c,E,E)}get size(){return this.f}clear(){this.e=new r(this.c,E,E),this.f=0}has(I){return!!D.g(this,I,this.comparator)}get(I){return D.g(this,I,this.comparator)?.value}set(I,b){return D.h(this,I,b,this.comparator)&&(this.f+=1),this}delete(I){const b=D.k(this,I,this.comparator);return b&&(this.f-=1),b}forEach(I,b){let l=this.e.forward[0];for(;l;)I.call(b,l.value,l.key,this),l=l.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this.e.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static g(I,b,l){let g=I.e;for(let u=I.d-1;u>=0;u--)for(;g.forward[u]&&l(g.forward[u].key,b)<0;)g=g.forward[u];if(g=g.forward[0],g&&l(g.key,b)===0)return g}static h(I,b,l,g){const u=[];let m=I.e;for(let p=I.d-1;p>=0;p--){for(;m.forward[p]&&g(m.forward[p].key,b)<0;)m=m.forward[p];u[p]=m}if(m=m.forward[0],m&&g(m.key,b)===0)return m.value=l,!1;{const p=D.j(I);if(p>I.d){for(let f=I.d;f<p;f++)u[f]=I.e;I.d=p}m=new r(p,b,l);for(let f=0;f<p;f++)m.forward[f]=u[f].forward[f],u[f].forward[f]=m;return!0}}static j(I,b=.5){let l=1;for(;Math.random()<b&&l<I.c;)l+=1;return l}static k(I,b,l){const g=[];let u=I.e;for(let m=I.d-1;m>=0;m--){for(;u.forward[m]&&l(u.forward[m].key,b)<0;)u=u.forward[m];g[m]=u}if(u=u.forward[0],!u||l(u.key,b)!==0)return!1;for(let m=0;m<I.d&&g[m].forward[m]===u;m++)g[m].forward[m]=u.forward[m];for(;I.d>0&&I.e.forward[I.d-1]===E;)I.d-=1;return!0}}e.$Ys=D}),define(le[60],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(D){return new r(D)}constructor(D){this.c=i&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ie=r}),define(le[4],ue([0,1,15,91,2,111,60]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$ke=e.Event=void 0,e.$le=p;const I=!1,b=!1,l=!1;var g;(function(q){q.None=()=>E.$Xc.None;function Q(Ae){if(l){const{onDidAddListener:$e}=Ae,ee=d.create();let he=0;Ae.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),$e?.()}}}function de(Ae,$e){return ce(Ae,()=>{},0,void 0,!0,void 0,$e)}q.defer=de;function x(Ae){return($e,ee=null,he)=>{let fe=!1,pe;return pe=Ae(ve=>{if(!fe)return pe?pe.dispose():fe=!0,$e.call(ee,ve)},null,he),fe&&pe.dispose(),pe}}q.once=x;function J(Ae,$e){return q.once(q.filter(Ae,$e))}q.onceIf=J;function B(Ae,$e,ee){return ne((he,fe=null,pe)=>Ae(ve=>he.call(fe,$e(ve)),null,pe),ee)}q.map=B;function _(Ae,$e,ee){return ne((he,fe=null,pe)=>Ae(ve=>{$e(ve),he.call(fe,ve)},null,pe),ee)}q.forEach=_;function C(Ae,$e,ee){return ne((he,fe=null,pe)=>Ae(ve=>$e(ve)&&he.call(fe,ve),null,pe),ee)}q.filter=C;function W(Ae){return Ae}q.signal=W;function F(...Ae){return($e,ee=null,he)=>{const fe=(0,E.$Uc)(...Ae.map(pe=>pe(ve=>$e.call(ee,ve))));return V(fe,he)}}q.any=F;function H(Ae,$e,ee,he){let fe=ee;return B(Ae,pe=>(fe=$e(fe,pe),fe),he)}q.reduce=H;function ne(Ae,$e){let ee;const he={onWillAddFirstListener(){ee=Ae(fe.fire,fe)},onDidRemoveLastListener(){ee?.dispose()}};$e||Q(he);const fe=new t(he);return $e?.add(fe),fe.event}function V(Ae,$e){return $e instanceof Array?$e.push(Ae):$e&&$e.add(Ae),Ae}function ce(Ae,$e,ee=100,he=!1,fe=!1,pe,ve){let je,Oe,Re,We=0,Ke;const Ze={leakWarningThreshold:pe,onWillAddFirstListener(){je=Ae(Je=>{We++,Oe=$e(Oe,Je),he&&!Re&&(ze.fire(Oe),Oe=void 0),Ke=()=>{const Qe=Oe;Oe=void 0,Re=void 0,(!he||We>1)&&ze.fire(Qe),We=0},typeof ee=="number"?(clearTimeout(Re),Re=setTimeout(Ke,ee)):Re===void 0&&(Re=0,queueMicrotask(Ke))})},onWillRemoveListener(){fe&&We>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,je.dispose()}};ve||Q(Ze);const ze=new t(Ze);return ve?.add(ze),ze.event}q.debounce=ce;function oe(Ae,$e=0,ee){return q.debounce(Ae,(he,fe)=>he?(he.push(fe),he):[fe],$e,void 0,!0,void 0,ee)}q.accumulate=oe;function Y(Ae,$e=(he,fe)=>he===fe,ee){let he=!0,fe;return C(Ae,pe=>{const ve=he||!$e(pe,fe);return he=!1,fe=pe,ve},ee)}q.latch=Y;function M(Ae,$e,ee){return[q.filter(Ae,$e,ee),q.filter(Ae,he=>!$e(he),ee)]}q.split=M;function Z(Ae,$e=!1,ee=[],he){let fe=ee.slice(),pe=Ae(Oe=>{fe?fe.push(Oe):je.fire(Oe)});he&&he.add(pe);const ve=()=>{fe?.forEach(Oe=>je.fire(Oe)),fe=null},je=new t({onWillAddFirstListener(){pe||(pe=Ae(Oe=>je.fire(Oe)),he&&he.add(pe))},onDidAddFirstListener(){fe&&($e?setTimeout(ve):ve())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return he&&he.add(je),je.event}q.buffer=Z;function U(Ae,$e){return(he,fe,pe)=>{const ve=$e(new ie);return Ae(function(je){const Oe=ve.evaluate(je);Oe!==N&&he.call(fe,Oe)},void 0,pe)}}q.chain=U;const N=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(ee=>($e(ee),ee)),this}filter($e){return this.f.push(ee=>$e(ee)?ee:N),this}reduce($e,ee){let he=ee;return this.f.push(fe=>(he=$e(he,fe),he)),this}latch($e=(ee,he)=>ee===he){let ee=!0,he;return this.f.push(fe=>{const pe=ee||!$e(fe,he);return ee=!1,he=fe,pe?fe:N}),this}evaluate($e){for(const ee of this.f)if($e=ee($e),$e===N)break;return $e}}function X(Ae,$e,ee=he=>he){const he=(...je)=>ve.fire(ee(...je)),fe=()=>Ae.on($e,he),pe=()=>Ae.removeListener($e,he),ve=new t({onWillAddFirstListener:fe,onDidRemoveLastListener:pe});return ve.event}q.fromNodeEventEmitter=X;function z(Ae,$e,ee=he=>he){const he=(...je)=>ve.fire(ee(...je)),fe=()=>Ae.addEventListener($e,he),pe=()=>Ae.removeEventListener($e,he),ve=new t({onWillAddFirstListener:fe,onDidRemoveLastListener:pe});return ve.event}q.fromDOMEventEmitter=z;function te(Ae){return new Promise($e=>x(Ae)($e))}q.toPromise=te;function ae(Ae){const $e=new t;return Ae.then(ee=>{$e.fire(ee)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}q.fromPromise=ae;function me(Ae,$e){return Ae(ee=>$e.fire(ee))}q.forward=me;function be(Ae,$e,ee){return $e(ee),Ae(he=>$e(he))}q.runAndSubscribe=be;class ye{constructor($e,ee){this._observable=$e,this.f=0,this.g=!1;const he={onWillAddFirstListener:()=>{$e.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};ee||Q(he),this.emitter=new t(he),ee&&ee.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,ee){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(Ae,$e){return new ye(Ae,$e).emitter.event}q.fromObservable=Fe;function xe(Ae){return($e,ee,he)=>{let fe=0,pe=!1;const ve={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(Ae.reportChanges(),pe&&(pe=!1,$e.call(ee)))},handlePossibleChange(){},handleChange(){pe=!0}};Ae.addObserver(ve),Ae.reportChanges();const je={dispose(){Ae.removeObserver(ve)}};return he instanceof E.$Wc?he.add(je):Array.isArray(he)&&he.push(je),je}}q.fromObservableLight=xe})(g||(e.Event=g={}));class u{static{this.all=new Set}static{this.f=0}constructor(Q){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Q}_${u.f++}`,u.all.add(this)}start(Q){this.g=new O.$ie,this.listenerCount=Q}stop(){if(this.g){const Q=this.g.elapsed();this.durations.push(Q),this.elapsedOverall+=Q,this.invocationCount+=1,this.g=void 0}}}e.$ke=u;let m=-1;function p(q){const Q=m;return m=q,{dispose(){m=Q}}}class f{static{this.f=1}constructor(Q,de,x=(f.f++).toString(16).padStart(3,"0")){this.j=Q,this.threshold=de,this.name=x,this.h=0}dispose(){this.g?.clear()}check(Q,de){const x=this.threshold;if(x<=0||de<x)return;this.g||(this.g=new Map);const J=this.g.get(Q.value)||0;if(this.g.set(Q.value,J+1),this.h-=1,this.h<=0){this.h=x*.5;const[B,_]=this.getMostFrequentStack(),C=`[${this.name}] potential listener LEAK detected, having ${de} listeners already. MOST frequent listener (${_}):`;console.warn(C),console.warn(B);const W=new v(C,B);this.j(W)}return()=>{const B=this.g.get(Q.value)||0;this.g.set(Q.value,B-1)}}getMostFrequentStack(){if(!this.g)return;let Q,de=0;for(const[x,J]of this.g)(!Q||de<J)&&(Q=[x,J],de=J);return Q}}class d{static create(){const Q=new Error;return new d(Q.stack??"")}constructor(Q){this.value=Q}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(Q,de){super(Q),this.name="ListenerLeakError",this.stack=de}}e.$me=v;class y extends Error{constructor(Q,de){super(Q),this.name="ListenerRefusalError",this.stack=de}}e.$ne=y;let $=0;class S{constructor(Q){this.value=Q,this.id=$++}}const k=2,s=(q,Q)=>{if(q instanceof S)Q(q);else for(let de=0;de<q.length;de++){const x=q[de];x&&Q(x)}};let a;if(I){const q=[];setInterval(()=>{q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(q.join(`
`)),q.length=0)},3e3),a=new FinalizationRegistry(Q=>{typeof Q=="string"&&q.push(Q)})}class t{constructor(Q){this.z=0,this.f=Q,this.g=m>0||this.f?.leakWarningThreshold?new f(Q?.onListenerError??i.$2,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new u(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const Q=this.u;queueMicrotask(()=>{s(Q,de=>de.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(Q,de,x)=>{if(this.g&&this.z>this.g.threshold**2){const W=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(W);const F=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],H=new y(`${W}. HINT: Stack shows most frequent listener (${F[1]}-times)`,F[0]);return(this.f?.onListenerError||i.$2)(H),E.$Xc.None}if(this.m)return E.$Xc.None;de&&(Q=Q.bind(de));const J=new S(Q);let B,_;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(J.stack=d.create(),B=this.g.check(J.stack,this.z+1)),b&&(J.stack=_??d.create()),this.u?this.u instanceof S?(this.w??=new n,this.u=[this.u,J]):this.u.push(J):(this.f?.onWillAddFirstListener?.(this),this.u=J,this.f?.onDidAddFirstListener?.(this)),this.z++;const C=(0,E.$Vc)(()=>{a?.unregister(C),B?.(),this.A(J)});if(x instanceof E.$Wc?x.add(C):Array.isArray(x)&&x.push(C),a){const W=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),F=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(W);a.register(C,F?.[2]??W,C)}return C},this.q}A(Q){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const de=this.u,x=de.indexOf(Q);if(x===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,de[x]=void 0;const J=this.w.current===this;if(this.z*k<=de.length){let B=0;for(let _=0;_<de.length;_++)de[_]?de[B++]=de[_]:J&&(this.w.end--,B<this.w.i&&this.w.i--);de.length=B}}B(Q,de){if(!Q)return;const x=this.f?.onListenerError||i.$2;if(!x){Q.value(de);return}try{Q.value(de)}catch(J){x(J)}}C(Q){const de=Q.current.u;for(;Q.i<Q.end;)this.B(de[Q.i++],Q.value);Q.reset()}fire(Q){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof S)this.B(this.u,Q);else{const de=this.w;de.enqueue(this,Q,this.u.length),this.C(de)}this.j?.stop()}hasListeners(){return this.z>0}}e.$oe=t;const o=()=>new n;e.$pe=o;class n{constructor(){this.i=-1,this.end=0}enqueue(Q,de,x){this.i=0,this.end=x,this.current=Q,this.value=de}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends t{async fireAsync(Q,de,x){if(this.u)for(this.h||(this.h=new D.$8c),s(this.u,J=>this.h.push([J.value,Q]));this.h.size>0&&!de.isCancellationRequested;){const[J,B]=this.h.shift(),_=[],C={...B,token:de,waitUntil:W=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");x&&(W=x(W,J)),_.push(W)}};try{J(C)}catch(W){(0,i.$2)(W);continue}Object.freeze(_),await Promise.allSettled(_).then(W=>{for(const F of W)F.status==="rejected"&&(0,i.$2)(F.reason)})}}}e.$qe=c;class h extends t{get isPaused(){return this.h!==0}constructor(Q){super(Q),this.h=0,this.s=new D.$8c,this.t=Q?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const Q=Array.from(this.s);this.s.clear(),super.fire(this.t(Q))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(Q){this.z&&(this.h!==0?this.s.push(Q):super.fire(Q))}}e.$re=h;class P extends h{constructor(Q){super(Q),this.k=Q.delay??100}fire(Q){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(Q)}}e.$se=P;class w extends t{constructor(Q){super(Q),this.h=[],this.k=Q?.merge}fire(Q){this.hasListeners()&&(this.h.push(Q),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(de=>super.fire(de)),this.h=[]}))}}e.$te=w;class R{constructor(){this.g=!1,this.h=[],this.f=new t({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(Q){const de={event:Q,listener:null};this.h.push(de),this.g&&this.m(de);const x=()=>{this.g&&this.o(de);const J=this.h.indexOf(de);this.h.splice(J,1)};return(0,E.$Vc)((0,r.$fb)(x))}j(){this.g=!0,this.h.forEach(Q=>this.m(Q))}k(){this.g=!1,this.h.forEach(Q=>this.o(Q))}m(Q){Q.listener=Q.event(de=>this.f.fire(de))}o(Q){Q.listener?.dispose(),Q.listener=null}dispose(){this.f.dispose();for(const Q of this.h)Q.listener?.dispose();this.h=[]}}e.$ue=R;class L{constructor(Q,de,x,J){this.f=new E.$Wc;const B=this.f.add(new R),_=this.f.add(new E.$7c);function C(W){_.set(W,B.add(J(W)))}for(const W of Q)C(W);this.f.add(de(W=>{C(W)})),this.f.add(x(W=>{_.deleteAndDispose(W)})),this.event=B.event}dispose(){this.f.dispose()}}e.$ve=L;class A{constructor(){this.f=[]}wrapEvent(Q,de,x){return(J,B,_)=>Q(C=>{const W=this.f[this.f.length-1];if(!de){W?W.buffers.push(()=>J.call(B,C)):J.call(B,C);return}const F=W;if(!F){J.call(B,de(x,C));return}F.items??=[],F.items.push(C),F.buffers.length===0&&W.buffers.push(()=>{F.reducedResult??=x?F.items.reduce(de,x):F.items.reduce(de),J.call(B,F.reducedResult)})},void 0,_)}bufferEvents(Q){const de={buffers:new Array};this.f.push(de);const x=Q();return this.f.pop(),de.buffers.forEach(J=>J()),x}}e.$we=A;class T{constructor(){this.f=!1,this.g=g.None,this.h=E.$Xc.None,this.j=new t({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(Q){this.g=Q,this.f&&(this.h.dispose(),this.h=Q(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$xe=T;class j{static const(Q){return new G(Q)}constructor(Q){this.g=Q,this.f=new t,this.onDidChange=this.f.event}get value(){return this.g}set value(Q){Q!==this.g&&(this.g=Q,this.f.fire(void 0))}}e.$ye=j;class G{constructor(Q){this.value=Q,this.onDidChange=g.None}}}),define(le[22],ue([0,1,4]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.CancellationToken=void 0,e.$Ae=I;const r=Object.freeze(function(b,l){const g=setTimeout(b.bind(l),0);return{dispose(){clearTimeout(g)}}});var E;(function(b){function l(g){return g===b.None||g===b.Cancelled||g instanceof D?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}b.isCancellationToken=l,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(E||(e.CancellationToken=E={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new i.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=E.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=E.None}}e.$ze=O;function I(b){const l=new O;return b.add({dispose(){l.cancel()}}),l.token}}),define(le[148],ue([0,1,22]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cf=e.$bf=e.$_e=void 0,e.$af=E;class r{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new i.$ze,l=this.b(b.token);return this.a={promise:l,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$_e=r;function E(I){return I}class D{constructor(b,l){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=E):(this.c=l,this.d=b.getCacheKey)}get(b){const l=this.d(b);return this.b!==l&&(this.b=l,this.a=this.c(b)),this.a}}e.$bf=D;class O{get cachedValues(){return this.a}constructor(b,l){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=E):(this.c=l,this.d=b.getCacheKey)}get(b){const l=this.d(b);if(this.b.has(l))return this.b.get(l);const g=this.c(b);return this.a.set(b,g),this.b.set(l,g),g}}e.$cf=O}),define(le[69],ue([0,1,15,2]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=E,e.$Ce=D,e.$De=O,e.$Ee=I,e.$Fe=l,e.$Ge=g,e.$He=u,e.$Ie=m,e.$Je=p,e.$Ke=f,e.$Le=d,e.$Me=v,e.$Ne=y,e.$Oe=$,e.$Pe=S;function E(k){const s=k;return s?typeof s.read=="function":!1}function D(k){const s=k;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}function O(k){const s=k;return s?D(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function I(k,s){return new b(k,s)}class b{constructor(s,a){this.e=s,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(a=>a(s))}h(s){this.c.error.length===0?(0,i.$2)(s):this.c.error.slice(0).forEach(a=>a(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,a){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(s,a){if(this.a.destroyed)return;let t;switch(s){case"data":t=this.c.data;break;case"end":t=this.c.end;break;case"error":t=this.c.error;break}if(t){const o=t.indexOf(a);o>=0&&t.splice(o,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(t=>t())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(k,s){const a=[];let t;for(;(t=k.read())!==null;)a.push(t);return s(a)}function g(k,s,a){const t=[];let o;for(;(o=k.read())!==null&&t.length<a;)t.push(o);return o===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o<"u"){const n=o;return o=void 0,n}return k.read()}}}function u(k,s){return new Promise((a,t)=>{const o=[];m(k,{onData:n=>{s&&o.push(n)},onError:n=>{s?t(n):a(void 0)},onEnd:()=>{a(s?s(o):void 0)}})})}function m(k,s,a){k.on("error",t=>{a?.isCancellationRequested||s.onError(t)}),k.on("end",()=>{a?.isCancellationRequested||s.onEnd()}),k.on("data",t=>{a?.isCancellationRequested||s.onData(t)})}function p(k,s){return new Promise((a,t)=>{const o=new r.$Wc,n=[],c=w=>{if(n.push(w),n.length>s)return o.dispose(),k.pause(),a({stream:k,buffer:n,ended:!1})},h=w=>(o.dispose(),t(w)),P=()=>(o.dispose(),a({stream:k,buffer:n,ended:!0}));o.add((0,r.$Vc)(()=>k.removeListener("error",h))),k.on("error",h),o.add((0,r.$Vc)(()=>k.removeListener("end",P))),k.on("end",P),o.add((0,r.$Vc)(()=>k.removeListener("data",c))),k.on("data",c)})}function f(k,s){const a=I(s);return a.end(k),a}function d(){const k=I(()=>{throw new Error("not supported")});return k.end(),k}function v(k){let s=!1;return{read:()=>s?null:(s=!0,k)}}function y(k,s,a){const t=I(a);return m(k,{onData:o=>t.write(s.data(o)),onError:o=>t.error(s.error?s.error(o):o),onEnd:()=>t.end()}),t}function $(k,s,a){let t=!1;return{read:()=>{const o=s.read();return t?o:(t=!0,o!==null?a([k,o]):k)}}}function S(k,s,a){let t=!1;const o=I(a);return m(s,{onData:n=>t?o.write(n):(t=!0,o.write(a([k,n]))),onError:n=>o.error(n),onEnd:()=>{t||(t=!0,o.write(k)),o.end()}}),o}}),define(le[17],ue([0,1,68,69]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=l,e.$Se=g,e.$Te=u,e.$Ue=m,e.$Ve=p,e.$We=f,e.$Xe=d,e.$Ye=v,e.$Ze=y,e.$1e=$,e.$2e=S,e.$3e=k,e.$4e=s,e.$5e=a,e.$6e=t,e.$7e=o,e.$8e=n,e.$9e=c,e.$0e=h,e.$$e=R,r=Ie(r);const E=typeof Buffer<"u",D=new i.$W(()=>new Uint8Array(256));let O,I;class b{static alloc(A){return E?new b(Buffer.allocUnsafe(A)):new b(new Uint8Array(A))}static wrap(A){return E&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new b(A)}static fromString(A,T){return!(T?.dontUseNodeBuffer||!1)&&E?new b(Buffer.from(A)):(O||(O=new TextEncoder),new b(O.encode(A)))}static fromByteArray(A){const T=b.alloc(A.length);for(let j=0,G=A.length;j<G;j++)T.buffer[j]=A[j];return T}static concat(A,T){if(typeof T>"u"){T=0;for(let q=0,Q=A.length;q<Q;q++)T+=A[q].byteLength}const j=b.alloc(T);let G=0;for(let q=0,Q=A.length;q<Q;q++){const de=A[q];j.set(de,G),G+=de.byteLength}return j}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=b.alloc(this.byteLength);return A.set(this),A}toString(){return E?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(A,T){return new b(this.buffer.subarray(A,T))}set(A,T){if(A instanceof b)this.buffer.set(A.buffer,T);else if(A instanceof Uint8Array)this.buffer.set(A,T);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),T);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return m(this.buffer,A)}writeUInt32BE(A,T){p(this.buffer,A,T)}readUInt32LE(A){return f(this.buffer,A)}writeUInt32LE(A,T){d(this.buffer,A,T)}readUInt8(A){return v(this.buffer,A)}writeUInt8(A,T){y(this.buffer,A,T)}indexOf(A,T=0){return l(this.buffer,A instanceof b?A.buffer:A,T)}}e.$Qe=b;function l(L,A,T=0){const j=A.byteLength,G=L.byteLength;if(j===0)return 0;if(j===1)return L.indexOf(A[0]);if(j>G-T)return-1;const q=D.value;q.fill(A.length);for(let J=0;J<A.length;J++)q[A[J]]=A.length-J-1;let Q=T+A.length-1,de=Q,x=-1;for(;Q<G;)if(L[Q]===A[de]){if(de===0){x=Q;break}Q--,de--}else Q+=Math.max(A.length-de,q[L[Q]]),de=A.length-1;return x}function g(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0}function u(L,A,T){L[T+0]=A&255,A=A>>>8,L[T+1]=A&255}function m(L,A){return L[A]*2**24+L[A+1]*2**16+L[A+2]*2**8+L[A+3]}function p(L,A,T){L[T+3]=A,A=A>>>8,L[T+2]=A,A=A>>>8,L[T+1]=A,A=A>>>8,L[T]=A}function f(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0|L[A+2]<<16>>>0|L[A+3]<<24>>>0}function d(L,A,T){L[T+0]=A&255,A=A>>>8,L[T+1]=A&255,A=A>>>8,L[T+2]=A&255,A=A>>>8,L[T+3]=A&255}function v(L,A){return L[A]}function y(L,A,T){L[T]=A}function $(L){return r.$Fe(L,A=>b.concat(A))}function S(L){return r.$Me(L)}function k(L){return r.$He(L,A=>b.concat(A))}async function s(L){return L.ended?b.concat(L.buffer):b.concat([...L.buffer,await k(L.stream)])}function a(L){return r.$Ke(L,A=>b.concat(A))}function t(L){return r.$Ne(L,{data:A=>typeof A=="string"?b.fromString(A):b.wrap(A)},A=>b.concat(A))}function o(L){return r.$Ee(A=>b.concat(A),L)}function n(L,A){return r.$Oe(L,A,T=>b.concat(T))}function c(L,A){return r.$Pe(L,A,T=>b.concat(T))}function h(L){let A=0,T=0,j=0;const G=new Uint8Array(Math.floor(L.length/4*3)),q=de=>{switch(T){case 3:G[j++]=A|de,T=0;break;case 2:G[j++]=A|de>>>2,A=de<<6,T=3;break;case 1:G[j++]=A|de>>>4,A=de<<4,T=2;break;default:A=de<<2,T=1}};for(let de=0;de<L.length;de++){const x=L.charCodeAt(de);if(x>=65&&x<=90)q(x-65);else if(x>=97&&x<=122)q(x-97+26);else if(x>=48&&x<=57)q(x-48+52);else if(x===43||x===45)q(62);else if(x===47||x===95)q(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${L[de]}`)}}const Q=j;for(;T>0;)q(0);return b.wrap(G).slice(0,Q)}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:L},A=!0,T=!1){const j=T?w:P;let G="";const q=L.byteLength%3;let Q=0;for(;Q<L.byteLength-q;Q+=3){const de=L[Q+0],x=L[Q+1],J=L[Q+2];G+=j[de>>>2],G+=j[(de<<4|x>>>4)&63],G+=j[(x<<2|J>>>6)&63],G+=j[J&63]}if(q===1){const de=L[Q+0];G+=j[de>>>2],G+=j[de<<4&63],A&&(G+="==")}else if(q===2){const de=L[Q+0],x=L[Q+1];G+=j[de>>>2],G+=j[(de<<4|x>>>4)&63],G+=j[x<<2&63],A&&(G+="=")}return G}}),define(le[149],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=void 0,e.$je=Symbol("MicrotaskDelay")}),define(le[12],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=i,e.$ig=r,e.$jg=E,e.$kg=D,e.$lg=O,e.$mg=I,e.$ng=b,e.$og=l,e.$pg=g,e.$qg=u,e.$rg=m,e.$sg=p,e.$tg=f,e.$ug=v,e.$vg=y,e.$wg=$,e.$xg=S,e.$yg=k,e.$zg=s;function i(a){return typeof a=="string"}function r(a){return Array.isArray(a)&&a.every(t=>i(t))}function E(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function D(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function O(a){return typeof a=="number"&&!isNaN(a)}function I(a){return!!a&&typeof a[Symbol.iterator]=="function"}function b(a){return a===!0||a===!1}function l(a){return typeof a>"u"}function g(a){return!u(a)}function u(a){return l(a)||a===null}function m(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function p(a){if(u(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function f(...a){const t=[];for(let o=0;o<a.length;o++){const n=a[o];if(u(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(n)}return t}const d=Object.prototype.hasOwnProperty;function v(a){if(!E(a))return!1;for(const t in a)if(d.call(a,t))return!1;return!0}function y(a){return typeof a=="function"}function $(...a){return a.length>0&&a.every(y)}function S(a,t){const o=Math.min(a.length,t.length);for(let n=0;n<o;n++)k(a[n],t[n])}function k(a,t){if(i(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(y(t)){try{if(a instanceof t)return}catch{}if(!u(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function s(a){return a}}),define(le[112],ue([0,1,12]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=E,e.$4j=D;const r=Object.create(null);function E(O,I){if((0,i.$hg)(I)){const b=r[I];if(b===void 0)throw new Error(`${O} references an unknown codicon: ${I}`);I=b}return r[O]=I,{id:O}}function D(){return r}}),define(le[150],ue([0,1,112]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=void 0,e.$5j={add:(0,i.$3j)("add",6e4),plus:(0,i.$3j)("plus",6e4),gistNew:(0,i.$3j)("gist-new",6e4),repoCreate:(0,i.$3j)("repo-create",6e4),lightbulb:(0,i.$3j)("lightbulb",60001),lightBulb:(0,i.$3j)("light-bulb",60001),repo:(0,i.$3j)("repo",60002),repoDelete:(0,i.$3j)("repo-delete",60002),gistFork:(0,i.$3j)("gist-fork",60003),repoForked:(0,i.$3j)("repo-forked",60003),gitPullRequest:(0,i.$3j)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$3j)("git-pull-request-abandoned",60004),recordKeys:(0,i.$3j)("record-keys",60005),keyboard:(0,i.$3j)("keyboard",60005),tag:(0,i.$3j)("tag",60006),gitPullRequestLabel:(0,i.$3j)("git-pull-request-label",60006),tagAdd:(0,i.$3j)("tag-add",60006),tagRemove:(0,i.$3j)("tag-remove",60006),person:(0,i.$3j)("person",60007),personFollow:(0,i.$3j)("person-follow",60007),personOutline:(0,i.$3j)("person-outline",60007),personFilled:(0,i.$3j)("person-filled",60007),gitBranch:(0,i.$3j)("git-branch",60008),gitBranchCreate:(0,i.$3j)("git-branch-create",60008),gitBranchDelete:(0,i.$3j)("git-branch-delete",60008),sourceControl:(0,i.$3j)("source-control",60008),mirror:(0,i.$3j)("mirror",60009),mirrorPublic:(0,i.$3j)("mirror-public",60009),star:(0,i.$3j)("star",60010),starAdd:(0,i.$3j)("star-add",60010),starDelete:(0,i.$3j)("star-delete",60010),starEmpty:(0,i.$3j)("star-empty",60010),comment:(0,i.$3j)("comment",60011),commentAdd:(0,i.$3j)("comment-add",60011),alert:(0,i.$3j)("alert",60012),warning:(0,i.$3j)("warning",60012),search:(0,i.$3j)("search",60013),searchSave:(0,i.$3j)("search-save",60013),logOut:(0,i.$3j)("log-out",60014),signOut:(0,i.$3j)("sign-out",60014),logIn:(0,i.$3j)("log-in",60015),signIn:(0,i.$3j)("sign-in",60015),eye:(0,i.$3j)("eye",60016),eyeUnwatch:(0,i.$3j)("eye-unwatch",60016),eyeWatch:(0,i.$3j)("eye-watch",60016),circleFilled:(0,i.$3j)("circle-filled",60017),primitiveDot:(0,i.$3j)("primitive-dot",60017),closeDirty:(0,i.$3j)("close-dirty",60017),debugBreakpoint:(0,i.$3j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$3j)("debug-breakpoint-disabled",60017),debugHint:(0,i.$3j)("debug-hint",60017),terminalDecorationSuccess:(0,i.$3j)("terminal-decoration-success",60017),primitiveSquare:(0,i.$3j)("primitive-square",60018),edit:(0,i.$3j)("edit",60019),pencil:(0,i.$3j)("pencil",60019),info:(0,i.$3j)("info",60020),issueOpened:(0,i.$3j)("issue-opened",60020),gistPrivate:(0,i.$3j)("gist-private",60021),gitForkPrivate:(0,i.$3j)("git-fork-private",60021),lock:(0,i.$3j)("lock",60021),mirrorPrivate:(0,i.$3j)("mirror-private",60021),close:(0,i.$3j)("close",60022),removeClose:(0,i.$3j)("remove-close",60022),x:(0,i.$3j)("x",60022),repoSync:(0,i.$3j)("repo-sync",60023),sync:(0,i.$3j)("sync",60023),clone:(0,i.$3j)("clone",60024),desktopDownload:(0,i.$3j)("desktop-download",60024),beaker:(0,i.$3j)("beaker",60025),microscope:(0,i.$3j)("microscope",60025),vm:(0,i.$3j)("vm",60026),deviceDesktop:(0,i.$3j)("device-desktop",60026),file:(0,i.$3j)("file",60027),fileText:(0,i.$3j)("file-text",60027),more:(0,i.$3j)("more",60028),ellipsis:(0,i.$3j)("ellipsis",60028),kebabHorizontal:(0,i.$3j)("kebab-horizontal",60028),mailReply:(0,i.$3j)("mail-reply",60029),reply:(0,i.$3j)("reply",60029),organization:(0,i.$3j)("organization",60030),organizationFilled:(0,i.$3j)("organization-filled",60030),organizationOutline:(0,i.$3j)("organization-outline",60030),newFile:(0,i.$3j)("new-file",60031),fileAdd:(0,i.$3j)("file-add",60031),newFolder:(0,i.$3j)("new-folder",60032),fileDirectoryCreate:(0,i.$3j)("file-directory-create",60032),trash:(0,i.$3j)("trash",60033),trashcan:(0,i.$3j)("trashcan",60033),history:(0,i.$3j)("history",60034),clock:(0,i.$3j)("clock",60034),folder:(0,i.$3j)("folder",60035),fileDirectory:(0,i.$3j)("file-directory",60035),symbolFolder:(0,i.$3j)("symbol-folder",60035),logoGithub:(0,i.$3j)("logo-github",60036),markGithub:(0,i.$3j)("mark-github",60036),github:(0,i.$3j)("github",60036),terminal:(0,i.$3j)("terminal",60037),console:(0,i.$3j)("console",60037),repl:(0,i.$3j)("repl",60037),zap:(0,i.$3j)("zap",60038),symbolEvent:(0,i.$3j)("symbol-event",60038),error:(0,i.$3j)("error",60039),stop:(0,i.$3j)("stop",60039),variable:(0,i.$3j)("variable",60040),symbolVariable:(0,i.$3j)("symbol-variable",60040),array:(0,i.$3j)("array",60042),symbolArray:(0,i.$3j)("symbol-array",60042),symbolModule:(0,i.$3j)("symbol-module",60043),symbolPackage:(0,i.$3j)("symbol-package",60043),symbolNamespace:(0,i.$3j)("symbol-namespace",60043),symbolObject:(0,i.$3j)("symbol-object",60043),symbolMethod:(0,i.$3j)("symbol-method",60044),symbolFunction:(0,i.$3j)("symbol-function",60044),symbolConstructor:(0,i.$3j)("symbol-constructor",60044),symbolBoolean:(0,i.$3j)("symbol-boolean",60047),symbolNull:(0,i.$3j)("symbol-null",60047),symbolNumeric:(0,i.$3j)("symbol-numeric",60048),symbolNumber:(0,i.$3j)("symbol-number",60048),symbolStructure:(0,i.$3j)("symbol-structure",60049),symbolStruct:(0,i.$3j)("symbol-struct",60049),symbolParameter:(0,i.$3j)("symbol-parameter",60050),symbolTypeParameter:(0,i.$3j)("symbol-type-parameter",60050),symbolKey:(0,i.$3j)("symbol-key",60051),symbolText:(0,i.$3j)("symbol-text",60051),symbolReference:(0,i.$3j)("symbol-reference",60052),goToFile:(0,i.$3j)("go-to-file",60052),symbolEnum:(0,i.$3j)("symbol-enum",60053),symbolValue:(0,i.$3j)("symbol-value",60053),symbolRuler:(0,i.$3j)("symbol-ruler",60054),symbolUnit:(0,i.$3j)("symbol-unit",60054),activateBreakpoints:(0,i.$3j)("activate-breakpoints",60055),archive:(0,i.$3j)("archive",60056),arrowBoth:(0,i.$3j)("arrow-both",60057),arrowDown:(0,i.$3j)("arrow-down",60058),arrowLeft:(0,i.$3j)("arrow-left",60059),arrowRight:(0,i.$3j)("arrow-right",60060),arrowSmallDown:(0,i.$3j)("arrow-small-down",60061),arrowSmallLeft:(0,i.$3j)("arrow-small-left",60062),arrowSmallRight:(0,i.$3j)("arrow-small-right",60063),arrowSmallUp:(0,i.$3j)("arrow-small-up",60064),arrowUp:(0,i.$3j)("arrow-up",60065),bell:(0,i.$3j)("bell",60066),bold:(0,i.$3j)("bold",60067),book:(0,i.$3j)("book",60068),bookmark:(0,i.$3j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$3j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$3j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$3j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$3j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$3j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$3j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$3j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$3j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$3j)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$3j)("briefcase",60076),broadcast:(0,i.$3j)("broadcast",60077),browser:(0,i.$3j)("browser",60078),bug:(0,i.$3j)("bug",60079),calendar:(0,i.$3j)("calendar",60080),caseSensitive:(0,i.$3j)("case-sensitive",60081),check:(0,i.$3j)("check",60082),checklist:(0,i.$3j)("checklist",60083),chevronDown:(0,i.$3j)("chevron-down",60084),chevronLeft:(0,i.$3j)("chevron-left",60085),chevronRight:(0,i.$3j)("chevron-right",60086),chevronUp:(0,i.$3j)("chevron-up",60087),chromeClose:(0,i.$3j)("chrome-close",60088),chromeMaximize:(0,i.$3j)("chrome-maximize",60089),chromeMinimize:(0,i.$3j)("chrome-minimize",60090),chromeRestore:(0,i.$3j)("chrome-restore",60091),circleOutline:(0,i.$3j)("circle-outline",60092),circle:(0,i.$3j)("circle",60092),debugBreakpointUnverified:(0,i.$3j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$3j)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$3j)("circle-slash",60093),circuitBoard:(0,i.$3j)("circuit-board",60094),clearAll:(0,i.$3j)("clear-all",60095),clippy:(0,i.$3j)("clippy",60096),closeAll:(0,i.$3j)("close-all",60097),cloudDownload:(0,i.$3j)("cloud-download",60098),cloudUpload:(0,i.$3j)("cloud-upload",60099),code:(0,i.$3j)("code",60100),collapseAll:(0,i.$3j)("collapse-all",60101),colorMode:(0,i.$3j)("color-mode",60102),commentDiscussion:(0,i.$3j)("comment-discussion",60103),creditCard:(0,i.$3j)("credit-card",60105),dash:(0,i.$3j)("dash",60108),dashboard:(0,i.$3j)("dashboard",60109),database:(0,i.$3j)("database",60110),debugContinue:(0,i.$3j)("debug-continue",60111),debugDisconnect:(0,i.$3j)("debug-disconnect",60112),debugPause:(0,i.$3j)("debug-pause",60113),debugRestart:(0,i.$3j)("debug-restart",60114),debugStart:(0,i.$3j)("debug-start",60115),debugStepInto:(0,i.$3j)("debug-step-into",60116),debugStepOut:(0,i.$3j)("debug-step-out",60117),debugStepOver:(0,i.$3j)("debug-step-over",60118),debugStop:(0,i.$3j)("debug-stop",60119),debug:(0,i.$3j)("debug",60120),deviceCameraVideo:(0,i.$3j)("device-camera-video",60121),deviceCamera:(0,i.$3j)("device-camera",60122),deviceMobile:(0,i.$3j)("device-mobile",60123),diffAdded:(0,i.$3j)("diff-added",60124),diffIgnored:(0,i.$3j)("diff-ignored",60125),diffModified:(0,i.$3j)("diff-modified",60126),diffRemoved:(0,i.$3j)("diff-removed",60127),diffRenamed:(0,i.$3j)("diff-renamed",60128),diff:(0,i.$3j)("diff",60129),diffSidebyside:(0,i.$3j)("diff-sidebyside",60129),discard:(0,i.$3j)("discard",60130),editorLayout:(0,i.$3j)("editor-layout",60131),emptyWindow:(0,i.$3j)("empty-window",60132),exclude:(0,i.$3j)("exclude",60133),extensions:(0,i.$3j)("extensions",60134),eyeClosed:(0,i.$3j)("eye-closed",60135),fileBinary:(0,i.$3j)("file-binary",60136),fileCode:(0,i.$3j)("file-code",60137),fileMedia:(0,i.$3j)("file-media",60138),filePdf:(0,i.$3j)("file-pdf",60139),fileSubmodule:(0,i.$3j)("file-submodule",60140),fileSymlinkDirectory:(0,i.$3j)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$3j)("file-symlink-file",60142),fileZip:(0,i.$3j)("file-zip",60143),files:(0,i.$3j)("files",60144),filter:(0,i.$3j)("filter",60145),flame:(0,i.$3j)("flame",60146),foldDown:(0,i.$3j)("fold-down",60147),foldUp:(0,i.$3j)("fold-up",60148),fold:(0,i.$3j)("fold",60149),folderActive:(0,i.$3j)("folder-active",60150),folderOpened:(0,i.$3j)("folder-opened",60151),gear:(0,i.$3j)("gear",60152),gift:(0,i.$3j)("gift",60153),gistSecret:(0,i.$3j)("gist-secret",60154),gist:(0,i.$3j)("gist",60155),gitCommit:(0,i.$3j)("git-commit",60156),gitCompare:(0,i.$3j)("git-compare",60157),compareChanges:(0,i.$3j)("compare-changes",60157),gitMerge:(0,i.$3j)("git-merge",60158),githubAction:(0,i.$3j)("github-action",60159),githubAlt:(0,i.$3j)("github-alt",60160),globe:(0,i.$3j)("globe",60161),grabber:(0,i.$3j)("grabber",60162),graph:(0,i.$3j)("graph",60163),gripper:(0,i.$3j)("gripper",60164),heart:(0,i.$3j)("heart",60165),home:(0,i.$3j)("home",60166),horizontalRule:(0,i.$3j)("horizontal-rule",60167),hubot:(0,i.$3j)("hubot",60168),inbox:(0,i.$3j)("inbox",60169),issueReopened:(0,i.$3j)("issue-reopened",60171),issues:(0,i.$3j)("issues",60172),italic:(0,i.$3j)("italic",60173),jersey:(0,i.$3j)("jersey",60174),json:(0,i.$3j)("json",60175),kebabVertical:(0,i.$3j)("kebab-vertical",60176),key:(0,i.$3j)("key",60177),law:(0,i.$3j)("law",60178),lightbulbAutofix:(0,i.$3j)("lightbulb-autofix",60179),linkExternal:(0,i.$3j)("link-external",60180),link:(0,i.$3j)("link",60181),listOrdered:(0,i.$3j)("list-ordered",60182),listUnordered:(0,i.$3j)("list-unordered",60183),liveShare:(0,i.$3j)("live-share",60184),loading:(0,i.$3j)("loading",60185),location:(0,i.$3j)("location",60186),mailRead:(0,i.$3j)("mail-read",60187),mail:(0,i.$3j)("mail",60188),markdown:(0,i.$3j)("markdown",60189),megaphone:(0,i.$3j)("megaphone",60190),mention:(0,i.$3j)("mention",60191),milestone:(0,i.$3j)("milestone",60192),gitPullRequestMilestone:(0,i.$3j)("git-pull-request-milestone",60192),mortarBoard:(0,i.$3j)("mortar-board",60193),move:(0,i.$3j)("move",60194),multipleWindows:(0,i.$3j)("multiple-windows",60195),mute:(0,i.$3j)("mute",60196),noNewline:(0,i.$3j)("no-newline",60197),note:(0,i.$3j)("note",60198),octoface:(0,i.$3j)("octoface",60199),openPreview:(0,i.$3j)("open-preview",60200),package:(0,i.$3j)("package",60201),paintcan:(0,i.$3j)("paintcan",60202),pin:(0,i.$3j)("pin",60203),play:(0,i.$3j)("play",60204),run:(0,i.$3j)("run",60204),plug:(0,i.$3j)("plug",60205),preserveCase:(0,i.$3j)("preserve-case",60206),preview:(0,i.$3j)("preview",60207),project:(0,i.$3j)("project",60208),pulse:(0,i.$3j)("pulse",60209),question:(0,i.$3j)("question",60210),quote:(0,i.$3j)("quote",60211),radioTower:(0,i.$3j)("radio-tower",60212),reactions:(0,i.$3j)("reactions",60213),references:(0,i.$3j)("references",60214),refresh:(0,i.$3j)("refresh",60215),regex:(0,i.$3j)("regex",60216),remoteExplorer:(0,i.$3j)("remote-explorer",60217),remote:(0,i.$3j)("remote",60218),remove:(0,i.$3j)("remove",60219),replaceAll:(0,i.$3j)("replace-all",60220),replace:(0,i.$3j)("replace",60221),repoClone:(0,i.$3j)("repo-clone",60222),repoForcePush:(0,i.$3j)("repo-force-push",60223),repoPull:(0,i.$3j)("repo-pull",60224),repoPush:(0,i.$3j)("repo-push",60225),report:(0,i.$3j)("report",60226),requestChanges:(0,i.$3j)("request-changes",60227),rocket:(0,i.$3j)("rocket",60228),rootFolderOpened:(0,i.$3j)("root-folder-opened",60229),rootFolder:(0,i.$3j)("root-folder",60230),rss:(0,i.$3j)("rss",60231),ruby:(0,i.$3j)("ruby",60232),saveAll:(0,i.$3j)("save-all",60233),saveAs:(0,i.$3j)("save-as",60234),save:(0,i.$3j)("save",60235),screenFull:(0,i.$3j)("screen-full",60236),screenNormal:(0,i.$3j)("screen-normal",60237),searchStop:(0,i.$3j)("search-stop",60238),server:(0,i.$3j)("server",60240),settingsGear:(0,i.$3j)("settings-gear",60241),settings:(0,i.$3j)("settings",60242),shield:(0,i.$3j)("shield",60243),smiley:(0,i.$3j)("smiley",60244),sortPrecedence:(0,i.$3j)("sort-precedence",60245),splitHorizontal:(0,i.$3j)("split-horizontal",60246),splitVertical:(0,i.$3j)("split-vertical",60247),squirrel:(0,i.$3j)("squirrel",60248),starFull:(0,i.$3j)("star-full",60249),starHalf:(0,i.$3j)("star-half",60250),symbolClass:(0,i.$3j)("symbol-class",60251),symbolColor:(0,i.$3j)("symbol-color",60252),symbolConstant:(0,i.$3j)("symbol-constant",60253),symbolEnumMember:(0,i.$3j)("symbol-enum-member",60254),symbolField:(0,i.$3j)("symbol-field",60255),symbolFile:(0,i.$3j)("symbol-file",60256),symbolInterface:(0,i.$3j)("symbol-interface",60257),symbolKeyword:(0,i.$3j)("symbol-keyword",60258),symbolMisc:(0,i.$3j)("symbol-misc",60259),symbolOperator:(0,i.$3j)("symbol-operator",60260),symbolProperty:(0,i.$3j)("symbol-property",60261),wrench:(0,i.$3j)("wrench",60261),wrenchSubaction:(0,i.$3j)("wrench-subaction",60261),symbolSnippet:(0,i.$3j)("symbol-snippet",60262),tasklist:(0,i.$3j)("tasklist",60263),telescope:(0,i.$3j)("telescope",60264),textSize:(0,i.$3j)("text-size",60265),threeBars:(0,i.$3j)("three-bars",60266),thumbsdown:(0,i.$3j)("thumbsdown",60267),thumbsup:(0,i.$3j)("thumbsup",60268),tools:(0,i.$3j)("tools",60269),triangleDown:(0,i.$3j)("triangle-down",60270),triangleLeft:(0,i.$3j)("triangle-left",60271),triangleRight:(0,i.$3j)("triangle-right",60272),triangleUp:(0,i.$3j)("triangle-up",60273),twitter:(0,i.$3j)("twitter",60274),unfold:(0,i.$3j)("unfold",60275),unlock:(0,i.$3j)("unlock",60276),unmute:(0,i.$3j)("unmute",60277),unverified:(0,i.$3j)("unverified",60278),verified:(0,i.$3j)("verified",60279),versions:(0,i.$3j)("versions",60280),vmActive:(0,i.$3j)("vm-active",60281),vmOutline:(0,i.$3j)("vm-outline",60282),vmRunning:(0,i.$3j)("vm-running",60283),watch:(0,i.$3j)("watch",60284),whitespace:(0,i.$3j)("whitespace",60285),wholeWord:(0,i.$3j)("whole-word",60286),window:(0,i.$3j)("window",60287),wordWrap:(0,i.$3j)("word-wrap",60288),zoomIn:(0,i.$3j)("zoom-in",60289),zoomOut:(0,i.$3j)("zoom-out",60290),listFilter:(0,i.$3j)("list-filter",60291),listFlat:(0,i.$3j)("list-flat",60292),listSelection:(0,i.$3j)("list-selection",60293),selection:(0,i.$3j)("selection",60293),listTree:(0,i.$3j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$3j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$3j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$3j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$3j)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$3j)("circle-small-filled",60298),debugStackframeDot:(0,i.$3j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$3j)("terminal-decoration-mark",60298),debugStackframe:(0,i.$3j)("debug-stackframe",60299),debugStackframeFocused:(0,i.$3j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$3j)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$3j)("symbol-string",60301),debugReverseContinue:(0,i.$3j)("debug-reverse-continue",60302),debugStepBack:(0,i.$3j)("debug-step-back",60303),debugRestartFrame:(0,i.$3j)("debug-restart-frame",60304),debugAlt:(0,i.$3j)("debug-alt",60305),callIncoming:(0,i.$3j)("call-incoming",60306),callOutgoing:(0,i.$3j)("call-outgoing",60307),menu:(0,i.$3j)("menu",60308),expandAll:(0,i.$3j)("expand-all",60309),feedback:(0,i.$3j)("feedback",60310),gitPullRequestReviewer:(0,i.$3j)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$3j)("group-by-ref-type",60311),ungroupByRefType:(0,i.$3j)("ungroup-by-ref-type",60312),account:(0,i.$3j)("account",60313),gitPullRequestAssignee:(0,i.$3j)("git-pull-request-assignee",60313),bellDot:(0,i.$3j)("bell-dot",60314),debugConsole:(0,i.$3j)("debug-console",60315),library:(0,i.$3j)("library",60316),output:(0,i.$3j)("output",60317),runAll:(0,i.$3j)("run-all",60318),syncIgnored:(0,i.$3j)("sync-ignored",60319),pinned:(0,i.$3j)("pinned",60320),githubInverted:(0,i.$3j)("github-inverted",60321),serverProcess:(0,i.$3j)("server-process",60322),serverEnvironment:(0,i.$3j)("server-environment",60323),pass:(0,i.$3j)("pass",60324),issueClosed:(0,i.$3j)("issue-closed",60324),stopCircle:(0,i.$3j)("stop-circle",60325),playCircle:(0,i.$3j)("play-circle",60326),record:(0,i.$3j)("record",60327),debugAltSmall:(0,i.$3j)("debug-alt-small",60328),vmConnect:(0,i.$3j)("vm-connect",60329),cloud:(0,i.$3j)("cloud",60330),merge:(0,i.$3j)("merge",60331),export:(0,i.$3j)("export",60332),graphLeft:(0,i.$3j)("graph-left",60333),magnet:(0,i.$3j)("magnet",60334),notebook:(0,i.$3j)("notebook",60335),redo:(0,i.$3j)("redo",60336),checkAll:(0,i.$3j)("check-all",60337),pinnedDirty:(0,i.$3j)("pinned-dirty",60338),passFilled:(0,i.$3j)("pass-filled",60339),circleLargeFilled:(0,i.$3j)("circle-large-filled",60340),circleLarge:(0,i.$3j)("circle-large",60341),circleLargeOutline:(0,i.$3j)("circle-large-outline",60341),combine:(0,i.$3j)("combine",60342),gather:(0,i.$3j)("gather",60342),table:(0,i.$3j)("table",60343),variableGroup:(0,i.$3j)("variable-group",60344),typeHierarchy:(0,i.$3j)("type-hierarchy",60345),typeHierarchySub:(0,i.$3j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$3j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$3j)("git-pull-request-create",60348),runAbove:(0,i.$3j)("run-above",60349),runBelow:(0,i.$3j)("run-below",60350),notebookTemplate:(0,i.$3j)("notebook-template",60351),debugRerun:(0,i.$3j)("debug-rerun",60352),workspaceTrusted:(0,i.$3j)("workspace-trusted",60353),workspaceUntrusted:(0,i.$3j)("workspace-untrusted",60354),workspaceUnknown:(0,i.$3j)("workspace-unknown",60355),terminalCmd:(0,i.$3j)("terminal-cmd",60356),terminalDebian:(0,i.$3j)("terminal-debian",60357),terminalLinux:(0,i.$3j)("terminal-linux",60358),terminalPowershell:(0,i.$3j)("terminal-powershell",60359),terminalTmux:(0,i.$3j)("terminal-tmux",60360),terminalUbuntu:(0,i.$3j)("terminal-ubuntu",60361),terminalBash:(0,i.$3j)("terminal-bash",60362),arrowSwap:(0,i.$3j)("arrow-swap",60363),copy:(0,i.$3j)("copy",60364),personAdd:(0,i.$3j)("person-add",60365),filterFilled:(0,i.$3j)("filter-filled",60366),wand:(0,i.$3j)("wand",60367),debugLineByLine:(0,i.$3j)("debug-line-by-line",60368),inspect:(0,i.$3j)("inspect",60369),layers:(0,i.$3j)("layers",60370),layersDot:(0,i.$3j)("layers-dot",60371),layersActive:(0,i.$3j)("layers-active",60372),compass:(0,i.$3j)("compass",60373),compassDot:(0,i.$3j)("compass-dot",60374),compassActive:(0,i.$3j)("compass-active",60375),azure:(0,i.$3j)("azure",60376),issueDraft:(0,i.$3j)("issue-draft",60377),gitPullRequestClosed:(0,i.$3j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$3j)("git-pull-request-draft",60379),debugAll:(0,i.$3j)("debug-all",60380),debugCoverage:(0,i.$3j)("debug-coverage",60381),runErrors:(0,i.$3j)("run-errors",60382),folderLibrary:(0,i.$3j)("folder-library",60383),debugContinueSmall:(0,i.$3j)("debug-continue-small",60384),beakerStop:(0,i.$3j)("beaker-stop",60385),graphLine:(0,i.$3j)("graph-line",60386),graphScatter:(0,i.$3j)("graph-scatter",60387),pieChart:(0,i.$3j)("pie-chart",60388),bracket:(0,i.$3j)("bracket",60175),bracketDot:(0,i.$3j)("bracket-dot",60389),bracketError:(0,i.$3j)("bracket-error",60390),lockSmall:(0,i.$3j)("lock-small",60391),azureDevops:(0,i.$3j)("azure-devops",60392),verifiedFilled:(0,i.$3j)("verified-filled",60393),newline:(0,i.$3j)("newline",60394),layout:(0,i.$3j)("layout",60395),layoutActivitybarLeft:(0,i.$3j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$3j)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$3j)("layout-panel-left",60398),layoutPanelCenter:(0,i.$3j)("layout-panel-center",60399),layoutPanelJustify:(0,i.$3j)("layout-panel-justify",60400),layoutPanelRight:(0,i.$3j)("layout-panel-right",60401),layoutPanel:(0,i.$3j)("layout-panel",60402),layoutSidebarLeft:(0,i.$3j)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$3j)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$3j)("layout-statusbar",60405),layoutMenubar:(0,i.$3j)("layout-menubar",60406),layoutCentered:(0,i.$3j)("layout-centered",60407),target:(0,i.$3j)("target",60408),indent:(0,i.$3j)("indent",60409),recordSmall:(0,i.$3j)("record-small",60410),errorSmall:(0,i.$3j)("error-small",60411),terminalDecorationError:(0,i.$3j)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$3j)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$3j)("arrow-circle-left",60413),arrowCircleRight:(0,i.$3j)("arrow-circle-right",60414),arrowCircleUp:(0,i.$3j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$3j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$3j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$3j)("layout-sidebar-left-off",60418),blank:(0,i.$3j)("blank",60419),heartFilled:(0,i.$3j)("heart-filled",60420),map:(0,i.$3j)("map",60421),mapHorizontal:(0,i.$3j)("map-horizontal",60421),foldHorizontal:(0,i.$3j)("fold-horizontal",60421),mapFilled:(0,i.$3j)("map-filled",60422),mapHorizontalFilled:(0,i.$3j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$3j)("fold-horizontal-filled",60422),circleSmall:(0,i.$3j)("circle-small",60423),bellSlash:(0,i.$3j)("bell-slash",60424),bellSlashDot:(0,i.$3j)("bell-slash-dot",60425),commentUnresolved:(0,i.$3j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$3j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$3j)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$3j)("search-fuzzy",60429),commentDraft:(0,i.$3j)("comment-draft",60430),send:(0,i.$3j)("send",60431),sparkle:(0,i.$3j)("sparkle",60432),insert:(0,i.$3j)("insert",60433),mic:(0,i.$3j)("mic",60434),thumbsdownFilled:(0,i.$3j)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$3j)("thumbsup-filled",60436),coffee:(0,i.$3j)("coffee",60437),snake:(0,i.$3j)("snake",60438),game:(0,i.$3j)("game",60439),vr:(0,i.$3j)("vr",60440),chip:(0,i.$3j)("chip",60441),piano:(0,i.$3j)("piano",60442),music:(0,i.$3j)("music",60443),micFilled:(0,i.$3j)("mic-filled",60444),repoFetch:(0,i.$3j)("repo-fetch",60445),copilot:(0,i.$3j)("copilot",60446),lightbulbSparkle:(0,i.$3j)("lightbulb-sparkle",60447),robot:(0,i.$3j)("robot",60448),sparkleFilled:(0,i.$3j)("sparkle-filled",60449),diffSingle:(0,i.$3j)("diff-single",60450),diffMultiple:(0,i.$3j)("diff-multiple",60451),surroundWith:(0,i.$3j)("surround-with",60452),share:(0,i.$3j)("share",60453),gitStash:(0,i.$3j)("git-stash",60454),gitStashApply:(0,i.$3j)("git-stash-apply",60455),gitStashPop:(0,i.$3j)("git-stash-pop",60456),vscode:(0,i.$3j)("vscode",60457),vscodeInsiders:(0,i.$3j)("vscode-insiders",60458),codeOss:(0,i.$3j)("code-oss",60459),runCoverage:(0,i.$3j)("run-coverage",60460),runAllCoverage:(0,i.$3j)("run-all-coverage",60461),coverage:(0,i.$3j)("coverage",60462),githubProject:(0,i.$3j)("github-project",60463),mapVertical:(0,i.$3j)("map-vertical",60464),foldVertical:(0,i.$3j)("fold-vertical",60464),mapVerticalFilled:(0,i.$3j)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$3j)("fold-vertical-filled",60465),goToSearch:(0,i.$3j)("go-to-search",60466),percentage:(0,i.$3j)("percentage",60467),sortPercentage:(0,i.$3j)("sort-percentage",60467),attach:(0,i.$3j)("attach",60468)}}),define(le[81],ue([0,1,112,150]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$6j=E;function E(){return Object.values(e.$8j)}e.$7j={dialogError:(0,i.$3j)("dialog-error","error"),dialogWarning:(0,i.$3j)("dialog-warning","warning"),dialogInfo:(0,i.$3j)("dialog-info","info"),dialogClose:(0,i.$3j)("dialog-close","close"),treeItemExpanded:(0,i.$3j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$3j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$3j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$3j)("tree-filter-clear","close"),treeItemLoading:(0,i.$3j)("tree-item-loading","loading"),menuSelection:(0,i.$3j)("menu-selection","check"),menuSubmenu:(0,i.$3j)("menu-submenu","chevron-right"),menuBarMore:(0,i.$3j)("menubar-more","more"),scrollbarButtonLeft:(0,i.$3j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$3j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$3j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$3j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$3j)("toolbar-more","more"),quickInputBack:(0,i.$3j)("quick-input-back","arrow-left"),dropDownButton:(0,i.$3j)("drop-down-button",60084),symbolCustomColor:(0,i.$3j)("symbol-customcolor",60252),exportIcon:(0,i.$3j)("export",60332),workspaceUnspecified:(0,i.$3j)("workspace-unspecified",60355),newLine:(0,i.$3j)("newline",60394),thumbsDownFilled:(0,i.$3j)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$3j)("thumbsup-filled",60436),gitFetch:(0,i.$3j)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$3j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$3j)("debug-breakpoint-pending",60377)},e.$8j={...r.$5j,...e.$7j}}),define(le[38],ue([0,1,12]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=r,e.$io=E,e.$jo=O,e.$ko=b,e.$lo=l,e.$mo=g,e.$no=u,e.$oo=m,e.$po=p,e.$qo=f,e.$ro=d,e.$so=v,e.$to=y;function r($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const S=Array.isArray($)?[]:{};return Object.entries($).forEach(([k,s])=>{S[k]=s&&typeof s=="object"?r(s):s}),S}function E($){if(!$||typeof $!="object")return $;const S=[$];for(;S.length>0;){const k=S.shift();Object.freeze(k);for(const s in k)if(D.call(k,s)){const a=k[s];typeof a=="object"&&!Object.isFrozen(a)&&!(0,i.$kg)(a)&&S.push(a)}}return $}const D=Object.prototype.hasOwnProperty;function O($,S){return I($,S,new Set)}function I($,S,k){if((0,i.$qg)($))return $;const s=S($);if(typeof s<"u")return s;if(Array.isArray($)){const a=[];for(const t of $)a.push(I(t,S,k));return a}if((0,i.$jg)($)){if(k.has($))throw new Error("Cannot clone recursive data-structure");k.add($);const a={};for(const t in $)D.call($,t)&&(a[t]=I($[t],S,k));return k.delete($),a}return $}function b($,S,k=!0){return(0,i.$jg)($)?((0,i.$jg)(S)&&Object.keys(S).forEach(s=>{s in $?k&&((0,i.$jg)($[s])&&(0,i.$jg)(S[s])?b($[s],S[s],k):$[s]=S[s]):$[s]=S[s]}),$):S}function l($,S){if($===S)return!0;if($==null||S===null||S===void 0||typeof $!=typeof S||typeof $!="object"||Array.isArray($)!==Array.isArray(S))return!1;let k,s;if(Array.isArray($)){if($.length!==S.length)return!1;for(k=0;k<$.length;k++)if(!l($[k],S[k]))return!1}else{const a=[];for(s in $)a.push(s);a.sort();const t=[];for(s in S)t.push(s);if(t.sort(),!l(a,t))return!1;for(k=0;k<a.length;k++)if(!l($[a[k]],S[a[k]]))return!1}return!0}function g($){const S=new Set;return JSON.stringify($,(k,s)=>{if((0,i.$jg)(s)||Array.isArray(s)){if(S.has(s))return"[Circular]";S.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function u($,S){const k=Object.create(null);return!$||!S||Object.keys(S).forEach(a=>{const t=$[a],o=S[a];l(t,o)||(k[a]=o)}),k}function m($,S){const k=S.toLowerCase(),s=Object.keys($).find(a=>a.toLowerCase()===k);return s?$[s]:$[S]}function p($,S){const k=Object.create(null);for(const[s,a]of Object.entries($))S(s,a)&&(k[s]=a);return k}function f($){let S=[];for(;Object.prototype!==$;)S=S.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return S}function d($){const S=[];for(const k of f($))typeof $[k]=="function"&&S.push(k);return S}function v($,S){const k=a=>function(){const t=Array.prototype.slice.call(arguments,0);return S(a,t)},s={};for(const a of $)s[a]=k(a);return s}function y($,S){const k={};for(const[s,a]of Object.entries($))k[s]=S(a,s);return k}}),define(le[113],ue([0,1,81]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$9j=E;var r;(function(O){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}O.isThemeColor=I})(r||(e.ThemeColor=r={}));function E(O){return{id:O}}var D;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function b($){const S=I.exec($.id);if(!S)return b(i.$8j.error);const[,k,s]=S,a=["codicon","codicon-"+k];return s&&a.push("codicon-modifier-"+s.substring(1)),a}O.asClassNameArray=b;function l($){return b($).join(" ")}O.asClassName=l;function g($){return"."+b($).join(".")}O.asCSSSelector=g;function u($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||r.isThemeColor($.color))}O.isThemeIcon=u;const m=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function p($){const S=m.exec($);if(!S)return;const[,k]=S;return{id:k}}O.fromString=p;function f($){return{id:$}}O.fromId=f;function d($,S){let k=$.id;const s=k.lastIndexOf("~");return s!==-1&&(k=k.substring(0,s)),S&&(k=`${k}~${S}`),{id:k}}O.modify=d;function v($){const S=$.id.lastIndexOf("~");if(S!==-1)return $.id.substring(S+1)}O.getModifier=v;function y($,S){return $.id===S.id&&$.color?.id===S.color?.id}O.isEqual=y})(D||(e.ThemeIcon=D={}))}),define(le[151],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$df=r,e.$ef=E;var i;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function r(D){return D<0?0:D>i.MAX_UINT_8?i.MAX_UINT_8:D|0}function E(D){return D<0?0:D>i.MAX_UINT_32?i.MAX_UINT_32:D|0}}),define(le[25],ue([0,1,148,39,68,151]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.$fg=e.$eg=e.GraphemeBreakType=e.$7f=e.$Yf=e.$Rf=e.$Qf=void 0,e.$ff=O,e.$gf=b,e.$hf=g,e.$if=u,e.$jf=m,e.$kf=p,e.$lf=f,e.$mf=d,e.$nf=v,e.$of=y,e.$pf=$,e.$qf=S,e.$rf=k,e.$sf=s,e.$tf=a,e.$uf=t,e.$vf=o,e.$wf=n,e.$xf=c,e.$yf=h,e.$zf=P,e.$Af=w,e.$Bf=R,e.$Cf=L,e.$Df=A,e.$Ef=T,e.$Ff=j,e.$Gf=G,e.$Hf=q,e.$If=Q,e.$Jf=de,e.$Kf=x,e.$Lf=J,e.$Mf=B,e.$Nf=_,e.$Of=C,e.$Pf=W,e.$Sf=V,e.$Tf=ce,e.$Uf=oe,e.$Vf=Y,e.$Wf=U,e.$Xf=ie,e.$Zf=X,e.$1f=z,e.$2f=te,e.$3f=ae,e.$4f=be,e.$5f=ye,e.$6f=xe,e.$8f=Ae,e.$9f=$e,e.$0f=ee,e.$$f=he,e.$_f=fe,e.$ag=pe,e.$bg=ve,e.$cg=je,e.$dg=Ze;function O(se){return!se||typeof se!="string"?!0:se.trim().length===0}const I=/{(\d+)}/g;function b(se,...ge){return ge.length===0?se:se.replace(I,function(we,Ee){const Me=parseInt(Ee,10);return isNaN(Me)||Me<0||Me>=ge.length?we:ge[Me]})}const l=/{([^}]+)}/g;function g(se,ge){return Object.keys(ge).length===0?se:se.replace(l,(we,Ee)=>ge[Ee]??we)}function u(se){return se.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function m(se){return se.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function p(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(se,ge){let we=0,Ee=se.indexOf(ge);for(;Ee!==-1;)we++,Ee=se.indexOf(ge,Ee+ge.length);return we}function d(se,ge,we="\u2026"){return se.length<=ge?se:`${se.substr(0,ge)}${we}`}function v(se,ge,we="\u2026"){if(se.length<=ge)return se;const Ee=Math.ceil(ge/2)-we.length/2,Me=Math.floor(ge/2)-we.length/2;return`${se.substr(0,Ee)}${we}${se.substr(se.length-Me)}`}function y(se,ge=" "){const we=$(se,ge);return S(we,ge)}function $(se,ge){if(!se||!ge)return se;const we=ge.length;if(we===0||se.length===0)return se;let Ee=0;for(;se.indexOf(ge,Ee)===Ee;)Ee=Ee+we;return se.substring(Ee)}function S(se,ge){if(!se||!ge)return se;const we=ge.length,Ee=se.length;if(we===0||Ee===0)return se;let Me=Ee,Be=-1;for(;Be=se.lastIndexOf(ge,Me-1),!(Be===-1||Be+we!==Me);){if(Be===0)return"";Me=Be}return se.substring(0,Me)}function k(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(se){return se.replace(/\*/g,"")}function a(se,ge,we={}){if(!se)throw new Error("Cannot create regex from empty string");ge||(se=p(se)),we.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let Ee="";return we.global&&(Ee+="g"),we.matchCase||(Ee+="i"),we.multiline&&(Ee+="m"),we.unicode&&(Ee+="u"),new RegExp(se,Ee)}function t(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function o(se){return se.split(/\r\n|\r|\n/)}function n(se){const ge=[],we=se.split(/(\r\n|\r|\n)/);for(let Ee=0;Ee<Math.ceil(we.length/2);Ee++)ge.push(we[2*Ee]+(we[2*Ee+1]??""));return ge}function c(se){for(let ge=0,we=se.length;ge<we;ge++){const Ee=se.charCodeAt(ge);if(Ee!==r.CharCode.Space&&Ee!==r.CharCode.Tab)return ge}return-1}function h(se,ge=0,we=se.length){for(let Ee=ge;Ee<we;Ee++){const Me=se.charCodeAt(Ee);if(Me!==r.CharCode.Space&&Me!==r.CharCode.Tab)return se.substring(ge,Ee)}return se.substring(ge,we)}function P(se,ge=se.length-1){for(let we=ge;we>=0;we--){const Ee=se.charCodeAt(we);if(Ee!==r.CharCode.Space&&Ee!==r.CharCode.Tab)return we}return-1}function w(se,ge,we){const Ee=[];let Me=0;for(const Be of se.matchAll(ge)){if(Ee.push(se.slice(Me,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Me=Be.index+Be[0].length,Ee.push(we(Be[0],...Be.slice(1),Be.index,se,Be.groups))}return Ee.push(se.slice(Me)),Promise.all(Ee).then(Be=>Be.join(""))}function R(se,ge){return se<ge?-1:se>ge?1:0}function L(se,ge,we=0,Ee=se.length,Me=0,Be=ge.length){for(;we<Ee&&Me<Be;we++,Me++){const rt=se.charCodeAt(we),at=ge.charCodeAt(Me);if(rt<at)return-1;if(rt>at)return 1}const _e=Ee-we,lt=Be-Me;return _e<lt?-1:_e>lt?1:0}function A(se,ge){return T(se,ge,0,se.length,0,ge.length)}function T(se,ge,we=0,Ee=se.length,Me=0,Be=ge.length){for(;we<Ee&&Me<Be;we++,Me++){let rt=se.charCodeAt(we),at=ge.charCodeAt(Me);if(rt===at)continue;if(rt>=128||at>=128)return L(se.toLowerCase(),ge.toLowerCase(),we,Ee,Me,Be);G(rt)&&(rt-=32),G(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const _e=Ee-we,lt=Be-Me;return _e<lt?-1:_e>lt?1:0}function j(se){return se>=r.CharCode.Digit0&&se<=r.CharCode.Digit9}function G(se){return se>=r.CharCode.a&&se<=r.CharCode.z}function q(se){return se>=r.CharCode.A&&se<=r.CharCode.Z}function Q(se,ge){return se.length===ge.length&&T(se,ge)===0}function de(se,ge){const we=ge.length;return ge.length>se.length?!1:T(se,ge,0,we)===0}function x(se,ge){const we=Math.min(se.length,ge.length);let Ee;for(Ee=0;Ee<we;Ee++)if(se.charCodeAt(Ee)!==ge.charCodeAt(Ee))return Ee;return we}function J(se,ge){const we=Math.min(se.length,ge.length);let Ee;const Me=se.length-1,Be=ge.length-1;for(Ee=0;Ee<we;Ee++)if(se.charCodeAt(Me-Ee)!==ge.charCodeAt(Be-Ee))return Ee;return we}function B(se){return 55296<=se&&se<=56319}function _(se){return 56320<=se&&se<=57343}function C(se,ge){return(se-55296<<10)+(ge-56320)+65536}function W(se,ge,we){const Ee=se.charCodeAt(we);if(B(Ee)&&we+1<ge){const Me=se.charCodeAt(we+1);if(_(Me))return C(Ee,Me)}return Ee}function F(se,ge){const we=se.charCodeAt(ge-1);if(_(we)&&ge>1){const Ee=se.charCodeAt(ge-2);if(B(Ee))return C(Ee,we)}return we}class H{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=F(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=W(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Qf=H;class ne{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new H(ge,we)}nextGraphemeLength(){const ge=We.getInstance(),we=this.c,Ee=we.offset;let Me=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Be=we.offset,_e=ge.getGraphemeBreakType(we.nextCodePoint());if(Oe(Me,_e)){we.setOffset(Be);break}Me=_e}return we.offset-Ee}prevGraphemeLength(){const ge=We.getInstance(),we=this.c,Ee=we.offset;let Me=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Be=we.offset,_e=ge.getGraphemeBreakType(we.prevCodePoint());if(Oe(_e,Me)){we.setOffset(Be);break}Me=_e}return Ee-we.offset}eol(){return this.c.eol()}}e.$Rf=ne;function V(se,ge){return new ne(se,ge).nextGraphemeLength()}function ce(se,ge){return new ne(se,ge).prevGraphemeLength()}function oe(se,ge){ge>0&&_(se.charCodeAt(ge))&&ge--;const we=ge+V(se,ge);return[we-ce(se,we),we]}function Y(se){const ge=new ne(se);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let M;function Z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(se){return M||(M=Z()),M.test(se)}const N=/^[\t\n\r\x20-\x7E]*$/;function ie(se){return N.test(se)}e.$Yf=/[\u2028\u2029]/;function X(se){return e.$Yf.test(se)}function z(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function te(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ae(se,ge,we=""){const Ee=se.trimStart();if(Ee.length<ge)return Ee;const Me=/\b/g;let Be=0;for(;Me.test(Ee)&&!(Ee.length-Me.lastIndex<ge);)Be=Me.lastIndex,Me.lastIndex+=1;return Be===0?Ee:we+Ee.substring(Be).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*be(se){let ge=0;for(const we of se.matchAll(me))ge!==we.index&&(yield{isCode:!1,str:se.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==se.length&&(yield{isCode:!1,str:se.substring(ge)})}function ye(se){return se&&(se=se.replace(me,"")),se}const Fe=/\\\[.*?\\\]/g;function xe(se){return ye(se).replace(Fe,"")}e.$7f=String.fromCharCode(r.CharCode.UTF8_BOM);function Ae(se){return!!(se&&se.length>0&&se.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(se){return Ae(se)?se.substr(1):se}function ee(se,ge){if(!se||!ge||se.length<ge.length)return!1;const we=ge.length,Ee=se.toLowerCase();let Me=0,Be=-1;for(;Me<we;){const _e=Ee.indexOf(ge[Me],Be+1);if(_e<0)return!1;Be=_e,Me++}return!0}function he(se,ge=!1){return se?(ge&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function fe(se){return se.charAt(0).toUpperCase()+se.slice(1)}function pe(se,ge=1){if(ge===0)return"";let we=-1;do we=se.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?se:(se[we-1]==="\r"&&we--,se.substr(0,we))}function ve(se){const ge=r.CharCode.Z-r.CharCode.A+1;return se=se%(2*ge),se<ge?String.fromCharCode(r.CharCode.a+se):String.fromCharCode(r.CharCode.A+se-ge)}function je(se){return We.getInstance().getGraphemeBreakType(se)}function Oe(se,ge){return se===Re.Other?ge!==Re.Extend&&ge!==Re.SpacingMark:se===Re.CR&&ge===Re.LF?!1:se===Re.Control||se===Re.CR||se===Re.LF||ge===Re.Control||ge===Re.CR||ge===Re.LF?!0:!(se===Re.L&&(ge===Re.L||ge===Re.V||ge===Re.LV||ge===Re.LVT)||(se===Re.LV||se===Re.V)&&(ge===Re.V||ge===Re.T)||(se===Re.LVT||se===Re.T)&&ge===Re.T||ge===Re.Extend||ge===Re.ZWJ||ge===Re.SpacingMark||se===Re.Prepend||se===Re.ZWJ&&ge===Re.Extended_Pictographic||se===Re.Regional_Indicator&&ge===Re.Regional_Indicator)}var Re;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(e.GraphemeBreakType=Re={}));class We{static{this.c=null}static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Ke()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Re.LF:ge===r.CharCode.CarriageReturn?Re.CR:Re.Control;if(ge<127)return Re.Other;const we=this.d,Ee=we.length/3;let Me=1;for(;Me<=Ee;)if(ge<we[3*Me])Me=2*Me;else if(ge>we[3*Me+1])Me=2*Me+1;else return we[3*Me+2];return Re.Other}}function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(se,ge){if(se===0)return 0;const we=ze(se,ge);if(we!==void 0)return we;const Ee=new H(ge,se);return Ee.prevCodePoint(),Ee.offset}function ze(se,ge){const we=new H(ge,se);let Ee=we.prevCodePoint();for(;Je(Ee)||Ee===Qe.emojiVariantSelector||Ee===Qe.enclosingKeyCap;){if(we.offset===0)return;Ee=we.prevCodePoint()}if(!te(Ee))return;let Me=we.offset;return Me>0&&we.prevCodePoint()===Qe.zwj&&(Me=we.offset),Me}function Je(se){return 127995<=se&&se<=127999}var Qe;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$eg="\xA0";class Ye{static{this.c=new E.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$bf({getCacheKey:JSON.stringify},ge=>{function we(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function Ee(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function Me(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Be=this.c.value;let _e=ge.filter(tt=>!tt.startsWith("_")&&tt in Be);_e.length===0&&(_e=["_default"]);let lt;for(const tt of _e){const ut=we(Be[tt]);lt=Me(lt,ut)}const rt=we(Be._common),at=Ee(rt,lt);return new Ye(at)})}static getInstance(ge){return Ye.d.get(Array.from(ge))}static{this.e=new E.$W(()=>Object.keys(Ye.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let we=0;we<ge.length;we++){const Ee=ge.codePointAt(we);if(typeof Ee=="number"&&this.isAmbiguous(Ee))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$fg=Ye;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(ge){return Ce.e().has(ge)}static containsInvisibleCharacter(ge){for(let we=0;we<ge.length;we++){const Ee=ge.codePointAt(we);if(typeof Ee=="number"&&Ce.isInvisibleCharacter(Ee))return!0}return!1}static get codePoints(){return Ce.e()}}e.$gg=Ce}),define(le[32],ue([0,1,39,9,3,25,12]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=I,e.$Bg=b,e.$Cg=l,e.$Dg=g,e.$Eg=u,e.$Fg=d,e.$Gg=v,e.$Hg=y,e.$Ig=$,e.$Jg=S,e.$Kg=k,e.$Lg=s,e.$Mg=a,e.$Ng=t,e.$Og=o,e.$Pg=n,e.$Qg=P;function I(w){return w===i.CharCode.Slash||w===i.CharCode.Backslash}function b(w){return w.replace(/[\\/]/g,r.$jc.sep)}function l(w){return w.indexOf("/")===-1&&(w=b(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function g(w,R=r.$jc.sep){if(!w)return"";const L=w.length,A=w.charCodeAt(0);if(I(A)){if(I(w.charCodeAt(1))&&!I(w.charCodeAt(2))){let j=3;const G=j;for(;j<L&&!I(w.charCodeAt(j));j++);if(G!==j&&!I(w.charCodeAt(j+1))){for(j+=1;j<L;j++)if(I(w.charCodeAt(j)))return w.slice(0,j+1).replace(/[\\/]/g,R)}}return R}else if($(A)&&w.charCodeAt(1)===i.CharCode.Colon)return I(w.charCodeAt(2))?w.slice(0,2)+R:w.slice(0,2);let T=w.indexOf("://");if(T!==-1){for(T+=3;T<L;T++)if(I(w.charCodeAt(T)))return w.slice(0,T+1)}return""}function u(w){if(!E.$j||!w||w.length<5)return!1;let R=w.charCodeAt(0);if(R!==i.CharCode.Backslash||(R=w.charCodeAt(1),R!==i.CharCode.Backslash))return!1;let L=2;const A=L;for(;L<w.length&&(R=w.charCodeAt(L),R!==i.CharCode.Backslash);L++);return!(A===L||(R=w.charCodeAt(L+1),isNaN(R)||R===i.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,p=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(w,R=E.$j){const L=R?m:p;return!(!w||w.length===0||/^\s+$/.test(w)||(L.lastIndex=0,L.test(w))||R&&f.test(w)||w==="."||w===".."||R&&w[w.length-1]==="."||R&&w.length!==w.trim().length||w.length>255)}function v(w,R,L){const A=w===R;return!L||A?A:!w||!R?!1:(0,D.$If)(w,R)}function y(w,R,L,A=r.sep){if(w===R)return!0;if(!w||!R||R.length>w.length)return!1;if(L){if(!(0,D.$Jf)(w,R))return!1;if(R.length===w.length)return!0;let j=R.length;return R.charAt(R.length-1)===A&&j--,w.charAt(j)===A}return R.charAt(R.length-1)!==A&&(R+=A),w.indexOf(R)===0}function $(w){return w>=i.CharCode.A&&w<=i.CharCode.Z||w>=i.CharCode.a&&w<=i.CharCode.z}function S(w,R){return E.$j&&w.endsWith(":")&&(w+=r.sep),(0,r.$lc)(w)||(w=(0,r.$mc)(R,w)),w=(0,r.$kc)(w),k(w)}function k(w){return E.$j?(w=(0,D.$qf)(w,r.sep),w.endsWith(":")&&(w+=r.sep)):(w=(0,D.$qf)(w,r.sep),w||(w=r.sep)),w}function s(w){const R=(0,r.$kc)(w);return E.$j?w.length>3?!1:a(R)&&(w.length===2||R.charCodeAt(2)===i.CharCode.Backslash):R===r.$jc.sep}function a(w,R=E.$j){return R?$(w.charCodeAt(0))&&w.charCodeAt(1)===i.CharCode.Colon:!1}function t(w,R=E.$j){return a(w,R)?w[0]:void 0}function o(w,R,L){return R.length>w.length?-1:w===R?0:(L&&(w=w.toLowerCase(),R=R.toLowerCase()),w.indexOf(R))}function n(w){const R=w.split(":");let L,A,T;for(const j of R){const G=Number(j);(0,O.$lg)(G)?A===void 0?A=G:T===void 0&&(T=G):L=L?[L,j].join(":"):j}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:A!==void 0?A:void 0,column:T!==void 0?T:A!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(w,R,L=8){let A="";for(let j=0;j<L;j++){let G;j===0&&E.$j&&!R&&(L===3||L===4)?G=h:G=c,A+=G.charAt(Math.floor(Math.random()*G.length))}let T;return R?T=`${R}-${A}`:T=A,w?(0,r.$mc)(w,T):T}}),define(le[47],ue([0,1,25]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Aj=void 0,e.$wj=r,e.$xj=E,e.$yj=D,e.$zj=I,e.$Bj=d,i=Ie(i);function r(y){return E(y,0)}function E(y,$){switch(typeof y){case"object":return y===null?D(349,$):Array.isArray(y)?b(y,$):l(y,$);case"string":return I(y,$);case"boolean":return O(y,$);case"number":return D(y,$);case"undefined":return D(937,$);default:return D(617,$)}}function D(y,$){return($<<5)-$+y|0}function O(y,$){return D(y?433:863,$)}function I(y,$){$=D(149417,$);for(let S=0,k=y.length;S<k;S++)$=D(y.charCodeAt(S),$);return $}function b(y,$){return $=D(104579,$),y.reduce((S,k)=>E(k,S),$)}function l(y,$){return $=D(181387,$),Object.keys(y).sort().reduce((S,k)=>(S=I(k,S),E(y[k],S)),$)}class g{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=E($,this.g),this.g}}e.$Aj=g;var u;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function m(y,$,S=32){const k=S-$,s=~((1<<k)-1);return(y<<$|(s&y)>>>k)>>>0}function p(y,$=0,S=y.byteLength,k=0){for(let s=0;s<S;s++)y[$+s]=k}function f(y,$,S="0"){for(;y.length<$;)y=S+y;return y}function d(y,$=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(S=>S.toString(16).padStart(2,"0")).join(""):f((y>>>0).toString(16),$/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const S=$.length;if(S===0)return;const k=this.p;let s=this.r,a=this.u,t,o;for(a!==0?(t=a,o=-1,a=0):(t=$.charCodeAt(0),o=0);;){let n=t;if(i.$Mf(t))if(o+1<S){const c=$.charCodeAt(o+1);i.$Nf(c)?(o++,n=i.$Of(t,c)):n=u.UNICODE_REPLACEMENT}else{a=t;break}else i.$Nf(t)&&(n=u.UNICODE_REPLACEMENT);if(s=this.w(k,s,n),o++,o<S)t=$.charCodeAt(o);else break}this.r=s,this.u=a}w($,S,k){return k<128?$[S++]=k:k<2048?($[S++]=192|(k&1984)>>>6,$[S++]=128|(k&63)>>>0):k<65536?($[S++]=224|(k&61440)>>>12,$[S++]=128|(k&4032)>>>6,$[S++]=128|(k&63)>>>0):($[S++]=240|(k&1835008)>>>18,$[S++]=128|(k&258048)>>>12,$[S++]=128|(k&4032)>>>6,$[S++]=128|(k&63)>>>0),S>=u.BLOCK_SIZE&&(this.y(),S-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,$[0]=$[u.BLOCK_SIZE+0],$[1]=$[u.BLOCK_SIZE+1],$[2]=$[u.BLOCK_SIZE+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=v.g,S=this.q;for(let P=0;P<64;P+=4)$.setUint32(P,S.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)$.setUint32(P,m($.getUint32(P-12,!1)^$.getUint32(P-32,!1)^$.getUint32(P-56,!1)^$.getUint32(P-64,!1),1),!1);let k=this.h,s=this.l,a=this.m,t=this.n,o=this.o,n,c,h;for(let P=0;P<80;P++)P<20?(n=s&a|~s&t,c=1518500249):P<40?(n=s^a^t,c=1859775393):P<60?(n=s&a|s&t|a&t,c=2400959708):(n=s^a^t,c=3395469782),h=m(k,5)+n+o+c+$.getUint32(P*4,!1)&4294967295,o=t,t=a,a=m(s,30),s=k,k=h;this.h=this.h+k&4294967295,this.l=this.l+s&4294967295,this.m=this.m+a&4294967295,this.n=this.n+t&4294967295,this.o=this.o+o&4294967295}}e.$Cj=v}),define(le[82],ue([0,1,25]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i=Ie(i);var r;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(r||(r={})),function(E){const D="error",O="warning",I="warn",b="info",l="ignore";function g(m){return m?i.$If(D,m)?E.Error:i.$If(O,m)||i.$If(I,m)?E.Warning:i.$If(b,m)?E.Info:E.Ignore:E.Ignore}E.fromValue=g;function u(m){switch(m){case E.Error:return D;case E.Warning:return O;case E.Info:return b;default:return l}}E.toString=u}(r||(r={})),e.default=r}),define(le[61],ue([0,1,21,39,25]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class D{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const d=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.$Ki=D;class O{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,E.$Cf)(f,this.b,0,f.length,this.c,this.d):(0,E.$Ef)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=O;class I{constructor(f=!0,d=!0){this.f=f,this.g=d}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let d=f.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===r.CharCode.Slash||this.f&&v===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===r.CharCode.Slash||this.f&&d===r.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,E.$Cf)(f,this.b,0,f.length,this.d,this.e):(0,E.$Ef)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=I;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class l{constructor(f,d){this.f=f,this.g=d,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(b.Path)),this.g(f)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===b.Scheme)return(0,E.$Df)(f,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,E.$Df)(f,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(f);if(this.d[this.e]===b.Query)return(0,E.$Bf)(f,this.c.query);if(this.d[this.e]===b.Fragment)return(0,E.$Bf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Ni=l;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(u||(u={}));class m{static forUris(f=()=>!1,d=()=>!1){return new m(new l(f,d))}static forPaths(f=!1){return new m(new I(void 0,!f))}static forStrings(){return new m(new D)}static forConfigKeys(){return new m(new O)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,d){if(d){const v=d.slice(0);(0,i.$Yb)(v);for(const y of v)this.set(y,f)}else{const v=f.slice(0);(0,i.$Yb)(v);for(const y of v)this.set(y[0],y[1])}}set(f,d){const v=this.b.reset(f);let y;this.c||(this.c=new g,this.c.segment=v.value());const $=[];for(y=this.c;;){const k=v.cmp(y.segment);if(k>0)y.left||(y.left=new g,y.left.segment=v.value()),$.push([u.Left,y]),y=y.left;else if(k<0)y.right||(y.right=new g,y.right.segment=v.value()),$.push([u.Right,y]),y=y.right;else if(v.hasNext())v.next(),y.mid||(y.mid=new g,y.mid.segment=v.value()),$.push([u.Mid,y]),y=y.mid;else break}const S=y.value;y.value=d,y.key=f;for(let k=$.length-1;k>=0;k--){const s=$[k][1];s.updateHeight();const a=s.balanceFactor();if(a<-1||a>1){const t=$[k][0],o=$[k+1][0];if(t===u.Right&&o===u.Right)$[k][1]=s.rotateLeft();else if(t===u.Left&&o===u.Left)$[k][1]=s.rotateRight();else if(t===u.Right&&o===u.Left)s.right=$[k+1][1]=$[k+1][1].rotateRight(),$[k][1]=s.rotateLeft();else if(t===u.Left&&o===u.Right)s.left=$[k+1][1]=$[k+1][1].rotateLeft(),$[k][1]=s.rotateRight();else throw new Error;if(k>0)switch($[k-1][0]){case u.Left:$[k-1][1].left=$[k][1];break;case u.Right:$[k-1][1].right=$[k][1];break;case u.Mid:$[k-1][1].mid=$[k][1];break}else this.c=$[0][1]}}return S}get(f){return this.d(f)?.value}d(f){const d=this.b.reset(f);let v=this.c;for(;v;){const y=d.cmp(v.segment);if(y>0)v=v.left;else if(y<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(f){const d=this.d(f);return!(d?.value===void 0&&d?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,d){const v=this.b.reset(f),y=[];let $=this.c;for(;$;){const S=v.cmp($.segment);if(S>0)y.push([u.Left,$]),$=$.left;else if(S<0)y.push([u.Right,$]),$=$.right;else if(v.hasNext())v.next(),y.push([u.Mid,$]),$=$.mid;else break}if($){if(d?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const S=this.f($.right);if(S.key){const{key:k,value:s,segment:a}=S;this.e(S.key,!1),$.key=k,$.value=s,$.segment=a}}else{const S=$.left??$.right;if(y.length>0){const[k,s]=y[y.length-1];switch(k){case u.Left:s.left=S;break;case u.Mid:s.mid=S;break;case u.Right:s.right=S;break}}else this.c=S}for(let S=y.length-1;S>=0;S--){const k=y[S][1];k.updateHeight();const s=k.balanceFactor();if(s>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),y[S][1]=k.rotateLeft()):s<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),y[S][1]=k.rotateRight()),S>0)switch(y[S-1][0]){case u.Left:y[S-1][1].left=y[S][1];break;case u.Right:y[S-1][1].right=y[S][1];break;case u.Mid:y[S-1][1].mid=y[S][1];break}else this.c=y[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const d=this.b.reset(f);let v=this.c,y;for(;v;){const $=d.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(d.hasNext())d.next(),y=v.value||y,v=v.mid;else break}return v&&v.value||y}findSuperstr(f){return this.g(f,!1)}g(f,d){const v=this.b.reset(f);let y=this.c;for(;y;){const $=v.cmp(y.segment);if($>0)y=y.left;else if($<0)y=y.right;else if(v.hasNext())v.next(),y=y.mid;else return y.mid?this.h(y.mid):d?y.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[d,v]of this)f(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const d=[];return this.j(f,d),d[Symbol.iterator]()}j(f,d){f&&(f.left&&this.j(f.left,d),f.value&&d.push([f.key,f.value]),f.mid&&this.j(f.mid,d),f.right&&this.j(f.right,d))}_isBalanced(){const f=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:f(d.left)&&f(d.right)};return f(this.c)}}e.$Oi=m}),define(le[7],ue([0,1,39,92,9,3]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=v,e.$zc=a,E=Ie(E);const O=/^\w[\w\d+.-]*$/,I=/^\//,b=/^\/\//;function l(h,P){if(!h.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!O.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!I.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(h,P){return!h&&!P?"file":h}function u(h,P){switch(h){case"https":case"http":case"file":P?P[0]!==p&&(P=p+P):P=p;break}return P}const m="",p="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(P){return P instanceof d?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,w,R,L,A,T=!1){typeof P=="object"?(this.scheme=P.scheme||m,this.authority=P.authority||m,this.path=P.path||m,this.query=P.query||m,this.fragment=P.fragment||m):(this.scheme=g(P,T),this.authority=w||m,this.path=u(this.scheme,R||m),this.query=L||m,this.fragment=A||m,l(this,T))}get fsPath(){return a(this,!1)}with(P){if(!P)return this;let{scheme:w,authority:R,path:L,query:A,fragment:T}=P;return w===void 0?w=this.scheme:w===null&&(w=m),R===void 0?R=this.authority:R===null&&(R=m),L===void 0?L=this.path:L===null&&(L=m),A===void 0?A=this.query:A===null&&(A=m),T===void 0?T=this.fragment:T===null&&(T=m),w===this.scheme&&R===this.authority&&L===this.path&&A===this.query&&T===this.fragment?this:new $(w,R,L,A,T)}static parse(P,w=!1){const R=f.exec(P);return R?new $(R[2]||m,c(R[4]||m),c(R[5]||m),c(R[7]||m),c(R[9]||m),w):new $(m,m,m,m,m)}static file(P){let w=m;if(D.$j&&(P=P.replace(/\\/g,p)),P[0]===p&&P[1]===p){const R=P.indexOf(p,2);R===-1?(w=P.substring(2),P=p):(w=P.substring(2,R),P=P.substring(R)||p)}return new $("file",w,P,m,m)}static from(P,w){return new $(P.scheme,P.authority,P.path,P.query,P.fragment,w)}static joinPath(P,...w){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return D.$j&&P.scheme==="file"?R=d.file(E.$ic.join(a(P,!0),...w)).path:R=E.$jc.join(P.path,...w),P.with({path:R})}toString(P=!1){return t(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof d)return P;{const w=new $(P);return w._formatted=P.external??null,w._fsPath=P._sep===y?P.fsPath??null:null,w}}else return P}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=d;function v(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const y=D.$j?1:void 0;class $ extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(P=!1){return P?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const P={$mid:r.MarshalledId.Uri};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=y),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const S={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function k(h,P,w){let R,L=-1;for(let A=0;A<h.length;A++){const T=h.charCodeAt(A);if(T>=i.CharCode.a&&T<=i.CharCode.z||T>=i.CharCode.A&&T<=i.CharCode.Z||T>=i.CharCode.Digit0&&T<=i.CharCode.Digit9||T===i.CharCode.Dash||T===i.CharCode.Period||T===i.CharCode.Underline||T===i.CharCode.Tilde||P&&T===i.CharCode.Slash||w&&T===i.CharCode.OpenSquareBracket||w&&T===i.CharCode.CloseSquareBracket||w&&T===i.CharCode.Colon)L!==-1&&(R+=encodeURIComponent(h.substring(L,A)),L=-1),R!==void 0&&(R+=h.charAt(A));else{R===void 0&&(R=h.substr(0,A));const j=S[T];j!==void 0?(L!==-1&&(R+=encodeURIComponent(h.substring(L,A)),L=-1),R+=j):L===-1&&(L=A)}}return L!==-1&&(R+=encodeURIComponent(h.substring(L))),R!==void 0?R:h}function s(h){let P;for(let w=0;w<h.length;w++){const R=h.charCodeAt(w);R===i.CharCode.Hash||R===i.CharCode.QuestionMark?(P===void 0&&(P=h.substr(0,w)),P+=S[R]):P!==void 0&&(P+=h[w])}return P!==void 0?P:h}function a(h,P){let w;return h.authority&&h.path.length>1&&h.scheme==="file"?w=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===i.CharCode.Slash&&(h.path.charCodeAt(1)>=i.CharCode.A&&h.path.charCodeAt(1)<=i.CharCode.Z||h.path.charCodeAt(1)>=i.CharCode.a&&h.path.charCodeAt(1)<=i.CharCode.z)&&h.path.charCodeAt(2)===i.CharCode.Colon?P?w=h.path.substr(1):w=h.path[1].toLowerCase()+h.path.substr(2):w=h.path,D.$j&&(w=w.replace(/\//g,"\\")),w}function t(h,P){const w=P?s:k;let R="",{scheme:L,authority:A,path:T,query:j,fragment:G}=h;if(L&&(R+=L,R+=":"),(A||L==="file")&&(R+=p,R+=p),A){let q=A.indexOf("@");if(q!==-1){const Q=A.substr(0,q);A=A.substr(q+1),q=Q.lastIndexOf(":"),q===-1?R+=w(Q,!1,!1):(R+=w(Q.substr(0,q),!1,!1),R+=":",R+=w(Q.substr(q+1),!1,!0)),R+="@"}A=A.toLowerCase(),q=A.lastIndexOf(":"),q===-1?R+=w(A,!1,!0):(R+=w(A.substr(0,q),!1,!0),R+=A.substr(q))}if(T){if(T.length>=3&&T.charCodeAt(0)===i.CharCode.Slash&&T.charCodeAt(2)===i.CharCode.Colon){const q=T.charCodeAt(1);q>=i.CharCode.A&&q<=i.CharCode.Z&&(T=`/${String.fromCharCode(q+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===i.CharCode.Colon){const q=T.charCodeAt(0);q>=i.CharCode.A&&q<=i.CharCode.Z&&(T=`${String.fromCharCode(q+32)}:${T.substr(2)}`)}R+=w(T,!0,!1)}return j&&(R+="?",R+=w(j,!1,!1)),G&&(R+="#",R+=P?G:k(G,!1,!1)),R}function o(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+o(h.substr(3)):h}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(h){return h.match(n)?h.replace(n,P=>o(P)):h}}),define(le[152],ue([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=r,e.$jr=E,e.$kr=D,e.log=I;function r(l){const g=l;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function E(l){const g=[];let u;try{const m=JSON.parse(l.arguments),p=m[m.length-1];p&&p.__$stack&&(m.pop(),u=p.__$stack),g.push(...m)}catch{g.push("Unable to log remote console arguments",l.arguments)}return{args:g,stack:u}}function D(l){if(typeof l!="string")return D(E(l).stack);const g=l;if(g){const u=O(g),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(m&&m.length===4)return{uri:i.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function O(l){if(!l)return l;const g=l.indexOf(`
`);return g===-1?l:l.substring(0,g)}function I(l,g){const{args:u,stack:m}=E(l),p=typeof u[0]=="string"&&u.length===1;let f=O(m);f&&(f=`(${f.trim()})`);let d=[];if(typeof u[0]=="string"?f&&p?d=[`%c[${g}] %c${u[0]} %c${f}`,b("blue"),b(""),b("grey")]:d=[`%c[${g}] %c${u[0]}`,b("blue"),b(""),...u.slice(1)]:d=[`%c[${g}]%`,b("blue"),...u],f&&!p&&d.push(f),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,d)}function b(l){return`color: ${l}`}}),define(le[83],ue([0,1,17,7,92]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=D,e.$ei=O,e.$fi=b;function D(l){return JSON.stringify(l,I)}function O(l){let g=JSON.parse(l);return g=b(g),g}function I(l,g){return g instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:g.source,flags:g.flags}:g}function b(l,g=0){if(!l||g>200)return l;if(typeof l=="object"){switch(l.$mid){case E.MarshalledId.Uri:return r.URI.revive(l);case E.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case E.MarshalledId.Date:return new Date(l.source)}if(l instanceof i.$Qe||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let u=0;u<l.length;++u)l[u]=b(l[u],g+1);else for(const u in l)Object.hasOwnProperty.call(l,u)&&(l[u]=b(l[u],g+1))}return l}}),define(le[11],ue([0,1,15,3,25,7,9]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Vg=e.$Ug=e.$Tg=e.Schemas=void 0,e.$Rg=b,e.$Sg=l,e.$Wg=u,i=Ie(i),r=Ie(r),O=Ie(O);var I;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting",f.outputChannel="output"})(I||(e.Schemas=I={}));function b(f,d){return D.URI.isUri(f)?(0,E.$If)(f.scheme,d):(0,E.$Jf)(f,d+":")}function l(f,...d){return d.some(v=>b(f,v))}e.$Tg="vscode-tkn",e.$Ug="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,v){this.f=u(d,v)}getServerRootPath(){return this.f}get g(){return O.$jc.join(this.f,I.vscodeRemoteResource)}set(d,v,y){this.a[d]=v,this.b[d]=y}setConnectionToken(d,v){this.c[d]=v}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(s){return i.$2(s),d}const v=d.authority;let y=this.a[v];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const $=this.b[v],S=this.c[v];let k=`path=${encodeURIComponent(d.path)}`;return typeof S=="string"&&(k+=`&${e.$Ug}=${encodeURIComponent(S)}`),D.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${y}:${$}`,path:this.g,query:k})}}e.$Vg=new g;function u(f,d){return O.$jc.join(d??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Xg="vs/../../extensions",e.$Yg="vs/../../node_modules",e.$Zg="vs/../../node_modules.asar",e.$1g="vs/../../node_modules.asar.unpacked",e.$2g="vscode-app";class m{static{this.a=e.$2g}asBrowserUri(d){const v=this.b(d,K);return this.uriToBrowserUri(v)}uriToBrowserUri(d){return d.scheme===I.vscodeRemote?e.$Vg.rewrite(d):d.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${m.a}`)?d.with({scheme:I.vscodeFileResource,authority:d.authority||m.a,query:null,fragment:null}):d}asFileUri(d){const v=this.b(d,K);return this.uriToFileUri(v)}uriToFileUri(d){return d.scheme===I.vscodeFileResource?d.with({scheme:I.file,authority:d.authority!==m.a?d.authority:null,query:null,fragment:null}):d}b(d,v){if(D.URI.isUri(d))return d;if(globalThis._VSCODE_FILE_ROOT){const y=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(y))return D.URI.joinPath(D.URI.parse(y,!0),d);const $=O.$mc(y,d);return D.URI.file($)}return D.URI.parse(v.toUrl(d))}}e.$3g=new m;var p;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const v="vscode-coi";function y(S){let k;typeof S=="string"?k=new URL(S).searchParams:S instanceof URL?k=S.searchParams:D.URI.isUri(S)&&(k=new URL(S.toString(!0)).searchParams);const s=k?.get(v);if(s)return d.get(s)}f.getHeadersFromQuery=y;function $(S,k,s){if(!globalThis.crossOriginIsolated)return;const a=k&&s?"3":s?"2":"1";S instanceof URLSearchParams?S.set(v,a):S[v]=a}f.addSearchParam=$})(p||(e.COI=p={}))}),define(le[153],ue([0,1,67,11,3,12,7]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=u,e.$xq=m,E=Ie(E);class I{constructor(f,d,v){this.id=f,this.dependencies=d,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,d,v)=>{typeof f!="string"&&(v=d,d=f,f=null),(typeof d!="object"||!Array.isArray(d))&&(v=d,d=null),this.c.push(new I(f,d,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const d=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!d){console.warn(`Did not receive a define call from script ${f}`);return}if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(f){return new Promise((d,v)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const $=()=>{y.removeEventListener("load",S),y.removeEventListener("error",k)},S=s=>{$(),d(this.c.pop())},k=s=>{$(),v(s)};y.addEventListener("load",S),y.addEventListener("error",k),this.f&&(f=this.f.createScriptURL(f)),y.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(y)})}async i(f){return this.f&&(f=this.f.createScriptURL(f)),i.$T?await new Promise((d,v)=>{K([f],d,v)}).then(Ie):importScripts(f),this.c.pop()}async j(f){try{const d=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,$=O.URI.parse(f).fsPath,S=d.readFileSync($).toString(),k=y.wrap(S.replace(/^#!.*/,""));return new v.Script(k).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const l=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function u(p,f,d){if(i.$T){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[p]&&(p=g[p]);const v=f?`${p}/${f}`:p;if(l.has(v))return l.get(v);let y;if(/^\w[\w\d+.-]*:\/\//.test(v))y=v;else{const s=`${i.$U&&d&&!E.$p?r.$Zg:r.$Yg}/${v}`;y=r.$3g.asBrowserUri(s).toString(!0)}const $=b.INSTANCE.load(y);return l.set(v,$),$}else return await new Promise((v,y)=>{K([p],v,y)}).then(Ie)}function m(p,f){(0,D.$rg)(i.$T);const v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,y=i.$U&&v&&!E.$p,$=`${p}/${f}`,k=`${y?r.$Zg:r.$Yg}/${$}`;return r.$3g.asBrowserUri(k).toString(!0)}}),define(le[18],ue([0,1,39,32,11,9,3,25,7]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0,e.$0g=l,e.$sh=u,e.$th=p,r=Ie(r),D=Ie(D);function l(f){return(0,b.$zc)(f,!0)}class g{constructor(d){this.a=d}compare(d,v,y=!1){return d===v?0:(0,I.$Bf)(this.getComparisonKey(d,y),this.getComparisonKey(v,y))}isEqual(d,v,y=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,y)===this.getComparisonKey(v,y)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,y=!1){if(d.scheme===v.scheme){if(d.scheme===E.Schemas.file)return r.$Hg(l(d),l(v),this.a(d))&&d.query===v.query&&(y||d.fragment===v.fragment);if((0,e.$oh)(d.authority,v.authority))return r.$Hg(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(y||d.fragment===v.fragment)}return!1}joinPath(d,...v){return b.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.$gh)(d)||d.authority}basename(d){return D.$jc.basename(d.path)}extname(d){return D.$jc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===E.Schemas.file?v=b.URI.file(D.$pc(l(d))).path:(v=D.$jc.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===E.Schemas.file?v=b.URI.file(D.$kc(l(d))).path:v=D.$jc.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.$oh)(d.authority,v.authority))return;if(d.scheme===E.Schemas.file){const S=D.$oc(l(d),l(v));return O.$j?r.$Bg(S):S}let y=d.path||"/";const $=v.path||"/";if(this.a(d)){let S=0;for(const k=Math.min(y.length,$.length);S<k&&!(y.charCodeAt(S)!==$.charCodeAt(S)&&y.charAt(S).toLowerCase()!==$.charAt(S).toLowerCase());S++);y=$.substr(0,S)+y.substr(S)}return D.$jc.relative(y,$)}resolvePath(d,v){if(d.scheme===E.Schemas.file){const y=b.URI.file(D.$nc(l(d),v));return d.with({authority:y.authority,path:y.path})}return v=r.$Cg(v),d.with({path:D.$jc.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,I.$If)(d,v)}hasTrailingPathSeparator(d,v=D.sep){if(d.scheme===E.Schemas.file){const y=l(d);return y.length>r.$Dg(y).length&&y[y.length-1]===v}else{const y=d.path;return y.length>1&&y.charCodeAt(y.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=D.sep){return(0,e.$ph)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=D.sep){let y=!1;if(d.scheme===E.Schemas.file){const $=l(d);y=$!==void 0&&$.length===r.$Dg($).length&&$[$.length-1]===v}else{v="/";const $=d.path;y=$.length===1&&$.charCodeAt($.length-1)===i.CharCode.Slash}return!y&&!(0,e.$ph)(d,v)?d.with({path:d.path+"/"}):d}}e.$$g=g,e.$_g=new g(()=>!1),e.$ah=new g(f=>f.scheme===E.Schemas.file?!O.$l:!0),e.$bh=new g(f=>!0),e.$ch=e.$_g.isEqual.bind(e.$_g),e.$dh=e.$_g.isEqualOrParent.bind(e.$_g),e.$eh=e.$_g.getComparisonKey.bind(e.$_g),e.$fh=e.$_g.basenameOrAuthority.bind(e.$_g),e.$gh=e.$_g.basename.bind(e.$_g),e.$hh=e.$_g.extname.bind(e.$_g),e.$ih=e.$_g.dirname.bind(e.$_g),e.$jh=e.$_g.joinPath.bind(e.$_g),e.$kh=e.$_g.normalizePath.bind(e.$_g),e.$lh=e.$_g.relativePath.bind(e.$_g),e.$mh=e.$_g.resolvePath.bind(e.$_g),e.$nh=e.$_g.isAbsolutePath.bind(e.$_g),e.$oh=e.$_g.isEqualAuthority.bind(e.$_g),e.$ph=e.$_g.hasTrailingPathSeparator.bind(e.$_g),e.$qh=e.$_g.removeTrailingPathSeparator.bind(e.$_g),e.$rh=e.$_g.addTrailingPathSeparator.bind(e.$_g);function u(f,d){const v=[];for(let y=0;y<f.length;y++){const $=d(f[y]);f.some((S,k)=>k===y?!1:(0,e.$dh)($,d(S)))||v.push(f[y])}return v}var m;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(v){const y=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(k=>{const[s,a]=k.split(":");s&&a&&y.set(s,a)});const S=v.path.substring(0,v.path.indexOf(";"));return S&&y.set(f.META_DATA_MIME,S),y}f.parseMetaData=d})(m||(e.DataUri=m={}));function p(f,d,v){if(d){let y=f.path;return y&&y[0]!==D.$jc.sep&&(y=D.$jc.sep+y),f.with({scheme:v,authority:d,path:y})}return f.with({scheme:v})}}),define(le[8],ue([0,1,22,15,4,2,18,3,149,68]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$0h=e.$9h=e.$8h=e.$7h=e.Promises=e.$6h=e.$5h=e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0,e.$uh=g,e.$vh=u,e.$wh=m,e.$xh=p,e.$yh=f,e.$zh=d,e.$Ah=v,e.$Bh=y,e.$Jh=h,e.$Kh=P,e.$Lh=w,e.$Mh=R,e.$Nh=L,e.$3h=W,e.$$h=N;function g(X){return!!X&&typeof X.then=="function"}function u(X){const z=new i.$ze,te=X(z.token),ae=new Promise((me,be)=>{const ye=z.token.onCancellationRequested(()=>{ye.dispose(),be(new r.$7)});Promise.resolve(te).then(Fe=>{ye.dispose(),z.dispose(),me(Fe)},Fe=>{ye.dispose(),z.dispose(),be(Fe)})});return new class{cancel(){z.cancel(),z.dispose()}then(me,be){return ae.then(me,be)}catch(me){return this.then(void 0,me)}finally(me){return ae.finally(me)}}}function m(X,z,te){return new Promise((ae,me)=>{const be=z.onCancellationRequested(()=>{be.dispose(),ae(te)});X.then(ae,me).finally(()=>be.dispose())})}function p(X,z){return new Promise((te,ae)=>{const me=z.onCancellationRequested(()=>{me.dispose(),ae(new r.$7)});X.then(te,ae).finally(()=>me.dispose())})}async function f(X){let z=-1;const te=X.map((ae,me)=>ae.then(be=>(z=me,be)));try{return await Promise.race(te)}finally{X.forEach((ae,me)=>{me!==z&&ae.cancel()})}}function d(X,z,te){let ae;const me=setTimeout(()=>{ae?.(void 0),te?.()},z);return Promise.race([X.finally(()=>clearTimeout(me)),new Promise(be=>ae=be)])}function v(X){return new Promise((z,te)=>{const ae=X();g(ae)?ae.then(z,te):z(ae)})}function y(){let X,z;return{promise:new Promise((ae,me)=>{X=ae,z=me}),resolve:X,reject:z}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=z,!this.b){const te=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(te,te).then(ae)})}return new Promise((te,ae)=>{this.b.then(te,ae)})}return this.a=z(),new Promise((te,ae)=>{this.a.then(me=>{this.a=null,te(me)},me=>{this.a=null,ae(me)})})}dispose(){this.f=!0}}e.$Ch=$;class S{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$Dh=S;class k{constructor(){this.a=new Map}queue(z,te){const me=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(z)===me&&this.a.delete(z)});return this.a.set(z,me),me}}e.$Eh=k;const s=(X,z)=>{let te=!0;const ae=setTimeout(()=>{te=!1,z()},X);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ae),te=!1}}},a=X=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,X())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class t{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,te=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((me,be)=>{this.d=me,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=te===b.$je?a(ae):s(te,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Fh=t;class o{constructor(z){this.a=new t(z),this.b=new $}trigger(z,te){return this.a.trigger(()=>this.b.queue(z),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Gh=o;class n{constructor(){this.a=!1,this.b=new Promise((z,te)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Hh=n;class c extends n{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$Ih=c;function h(X,z){return z?new Promise((te,ae)=>{const me=setTimeout(()=>{be.dispose(),te()},X),be=z.onCancellationRequested(()=>{clearTimeout(me),be.dispose(),ae(new r.$7)})}):u(te=>h(X,te))}function P(X,z=0,te){const ae=setTimeout(()=>{X(),te&&me.dispose()},z),me=(0,D.$Vc)(()=>{clearTimeout(ae),te?.deleteAndLeak(me)});return te?.add(me),me}function w(X){const z=[];let te=0;const ae=X.length;function me(){return te<ae?X[te++]():null}function be(ye){ye!=null&&z.push(ye);const Fe=me();return Fe?Fe.then(be):Promise.resolve(z)}return Promise.resolve(null).then(be)}function R(X,z=ae=>!!ae,te=null){let ae=0;const me=X.length,be=()=>{if(ae>=me)return Promise.resolve(te);const ye=X[ae++];return Promise.resolve(ye()).then(xe=>z(xe)?Promise.resolve(xe):be())};return be()}function L(X,z=ae=>!!ae,te=null){if(X.length===0)return Promise.resolve(te);let ae=X.length;const me=()=>{ae=-1;for(const be of X)be.cancel?.()};return new Promise((be,ye)=>{for(const Fe of X)Fe.then(xe=>{--ae>=0&&z(xe)?(me(),be(xe)):ae===0&&be(te)}).catch(xe=>{--ae>=0&&(me(),ye(xe))})})}class A{constructor(z){this.a=0,this.b=!1,this.f=z,this.g=[],this.d=0,this.h=new E.$oe}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,ae)=>{this.g.push({factory:z,c:te,e:ae}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const z=this.g.shift();this.d++;const te=z.factory();te.then(z.c,z.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Oh=A;class T extends A{constructor(){super(1)}}e.$Ph=T;class j{constructor(){this.a=new F,this.b=0}queue(z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,z())):this.a.run(this.b++,z())}}e.$Qh=j;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const z=new V;return this.b.add(z),z.p}g(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueSize(z,te=O.$_g){const ae=te.getComparisonKey(z);return this.a.get(ae)?.size??0}queueFor(z,te,ae=O.$_g){const me=ae.getComparisonKey(z);let be=this.a.get(me);if(!be){be=new T;const ye=this.f++,Fe=E.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$7c),this.d.set(ye,Fe),this.a.set(me,be)}return be.queue(te)}h(){this.g()&&this.j()}j(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Rh=G;class q{constructor(z,te){this.b=!1,this.a=-1,typeof z=="function"&&typeof te=="number"&&this.setIfNotSet(z,te)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,te){if(this.b)throw new r.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},te)}setIfNotSet(z,te){if(this.b)throw new r.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},te))}}e.$Sh=q;class Q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(z,te,ae=globalThis){if(this.f)throw new r.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=ae.setInterval(()=>{z()},te);this.d=(0,D.$Vc)(()=>{ae.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Th=Q;class de{constructor(z,te){this.b=-1,this.a=z,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Uh=de;class x{constructor(z,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=z,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Vh=x;class J extends de{constructor(z,te){super(z,te),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$Wh=J;class B extends D.$Xc{constructor(z,te){super(),this.g=z,this.h=te,this.a=[],this.b=this.B(new D.$Yc),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of z)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new de(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Xh=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Zh=(X,z)=>{(0,I.$C)(()=>{if(te)return;const ae=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Zh=(X,z,te)=>{const ae=X.requestIdleCallback(z,typeof te=="number"?{timeout:te}:void 0);let me=!1;return{dispose(){me||(me=!0,X.cancelIdleCallback(ae))}}},e.$Yh=X=>(0,e.$Zh)(globalThis,X)}();class _{constructor(z,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$Zh)(z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$1h=_;class C extends _{constructor(z){super(globalThis,z)}}e.$2h=C;async function W(X,z,te){let ae;for(let me=0;me<te;me++)try{return await X()}catch(be){ae=be,await h(z)}throw ae}class F{isRunning(z){return typeof z=="number"?this.a?.taskId===z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(z,te,ae){return this.a={taskId:z,cancel:()=>ae?.(),promise:te},te.then(()=>this.d(z),()=>this.d(z)),te}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this.b)this.b.run=z;else{const{promise:te,resolve:ae,reject:me}=y();this.b={run:z,promise:te,promiseResolve:ae,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$4h=F;class H{constructor(z,te=()=>Date.now()){this.d=z,this.f=te,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$5h=H;var ne;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(ne||(ne={}));class V{get isRejected(){return this.d?.outcome===ne.Rejected}get isResolved(){return this.d?.outcome===ne.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ne.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((z,te)=>{this.a=z,this.b=te})}complete(z){return new Promise(te=>{this.a(z),this.d={outcome:ne.Resolved,value:z},te()})}error(z){return new Promise(te=>{this.b(z),this.d={outcome:ne.Rejected,value:z},te()})}cancel(){return this.error(new r.$7)}}e.$6h=V;var ce;(function(X){async function z(ae){let me;const be=await Promise.all(ae.map(ye=>ye.then(Fe=>Fe,Fe=>{me||(me=Fe)})));if(typeof me<"u")throw me;return be}X.settled=z;function te(ae){return new Promise(async(me,be)=>{try{await ae(me,be)}catch(ye){be(ye)}})}X.withAsyncBody=te})(ce||(e.Promises=ce={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=z.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new r.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$7h=oe;class Y{constructor(z){this.b=z,this.a=new l.$W(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$8h=Y;var M;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(M||(M={}));class Z{static fromArray(z){return new Z(te=>{te.emitMany(z)})}static fromPromise(z){return new Z(async te=>{te.emitMany(await z)})}static fromPromises(z){return new Z(async te=>{await Promise.all(z.map(async ae=>te.emitOne(await ae)))})}static merge(z){return new Z(async te=>{await Promise.all(z.map(async ae=>{for await(const me of ae)te.emitOne(me)}))})}static{this.EMPTY=Z.fromArray([])}constructor(z,te){this.a=M.Initial,this.b=[],this.d=null,this.f=te,this.g=new E.$oe,queueMicrotask(async()=>{const ae={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(z(ae)),this.k()}catch(me){this.l(me)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===M.DoneError)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===M.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(z,te){return new Z(async ae=>{for await(const me of z)ae.emitOne(te(me))})}map(z){return Z.map(this,z)}static filter(z,te){return new Z(async ae=>{for await(const me of z)te(me)&&ae.emitOne(me)})}filter(z){return Z.filter(this,z)}static coalesce(z){return Z.filter(z,te=>!!te)}coalesce(){return Z.coalesce(this)}static async toPromise(z){const te=[];for await(const ae of z)te.push(ae);return te}toPromise(){return Z.toPromise(this)}h(z){this.a===M.Initial&&(this.b.push(z),this.g.fire())}j(z){this.a===M.Initial&&(this.b=this.b.concat(z),this.g.fire())}k(){this.a===M.Initial&&(this.a=M.DoneOK,this.g.fire())}l(z){this.a===M.Initial&&(this.a=M.DoneError,this.d=z,this.g.fire())}}e.$9h=Z;class U extends Z{constructor(z,te){super(te),this.m=z}cancel(){this.m.cancel()}}e.$0h=U;function N(X){const z=new i.$ze,te=X(z.token);return new U(z,async ae=>{const me=z.token.onCancellationRequested(()=>{me.dispose(),z.dispose(),ae.reject(new r.$7)});try{for await(const be of te){if(z.token.isCancellationRequested)return;ae.emitOne(be)}me.dispose(),z.dispose()}catch(be){me.dispose(),z.dispose(),ae.reject(be)}})}class ie{constructor(z){this.a=new V,this.b=new Z(me=>{if(te){me.reject(te);return}return ae&&me.emitMany(ae),this.d=be=>me.reject(be),this.f=be=>me.emitOne(be),this.a.p},z);let te,ae;this.f=me=>{ae||(ae=[]),ae.push(me)},this.d=me=>{te||(te=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(z){this.d(z),this.a.complete()}emitOne(z){this.f(z)}}e.$_h=ie}),define(le[114],ue([0,1,21,8,39,32,31,9,3,25]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=void 0,e.$yk=g,e.$Bk=d,e.$Ck=j,e.$Dk=G,e.$Ek=q,e.$Fk=Q,e.$Gk=de,e.$Hk=_;function g(){return Object.create(null)}e.$zk="**",e.$Ak="/";const u="[/\\\\]",m="[^/\\\\]",p=/\//g;function f(C,W){switch(C){case 0:return"";case 1:return`${m}*?`;default:return`(?:${u}|${m}+${u}${W?`|${u}${m}+`:""})*?`}}function d(C,W){if(!C)return[];const F=[];let H=!1,ne=!1,V="";for(const ce of C){switch(ce){case W:if(!H&&!ne){F.push(V),V="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}V+=ce}return V&&F.push(V),F}function v(C){if(!C)return"";let W="";const F=d(C,e.$Ak);if(F.every(H=>H===e.$zk))W=".*";else{let H=!1;F.forEach((ne,V)=>{if(ne===e.$zk){if(H)return;W+=f(2,V===F.length-1)}else{let ce=!1,oe="",Y=!1,M="";for(const Z of ne){if(Z!=="}"&&ce){oe+=Z;continue}if(Y&&(Z!=="]"||!M)){let U;Z==="-"?U=Z:(Z==="^"||Z==="!")&&!M?U="^":Z===e.$Ak?U="":U=(0,l.$kf)(Z),M+=U;continue}switch(Z){case"{":ce=!0;continue;case"[":Y=!0;continue;case"}":{const N=`(?:${d(oe,",").map(ie=>v(ie)).join("|")})`;W+=N,ce=!1,oe="";break}case"]":{W+="["+M+"]",Y=!1,M="";break}case"?":W+=m;continue;case"*":W+=f(1);continue;default:W+=(0,l.$kf)(Z)}}V<F.length-1&&(F[V+1]!==e.$zk||V+2<F.length)&&(W+=u)}H=ne===e.$zk})}return W}const y=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Gc(1e4),o=function(){return!1},n=function(){return null};function c(C,W){if(!C)return n;let F;typeof C!="string"?F=C.pattern:F=C,F=F.trim();const H=`${F}_${!!W.trimForExclusions}`;let ne=t.get(H);if(ne)return h(ne,C);let V;return y.test(F)?ne=w(F.substr(4),F):(V=$.exec(P(F,W)))?ne=R(V[1],F):(W.trimForExclusions?k:S).test(F)?ne=L(F,W):(V=s.exec(P(F,W)))?ne=A(V[1].substr(1),F,!0):(V=a.exec(P(F,W)))?ne=A(V[1],F,!1):ne=T(F),t.set(H,ne),h(ne,C)}function h(C,W){if(typeof W=="string")return C;const F=function(H,ne){return(0,D.$Hg)(H,W.base,!b.$l)?C((0,l.$pf)(H.substr(W.base.length),I.sep),ne):null};return F.allBasenames=C.allBasenames,F.allPaths=C.allPaths,F.basenames=C.basenames,F.patterns=C.patterns,F}function P(C,W){return W.trimForExclusions&&C.endsWith("/**")?C.substr(0,C.length-2):C}function w(C,W){return function(F,H){return typeof F=="string"&&F.endsWith(C)?W:null}}function R(C,W){const F=`/${C}`,H=`\\${C}`,ne=function(ce,oe){return typeof ce!="string"?null:oe?oe===C?W:null:ce===C||ce.endsWith(F)||ce.endsWith(H)?W:null},V=[C];return ne.basenames=V,ne.patterns=[W],ne.allBasenames=V,ne}function L(C,W){const F=B(C.slice(1,-1).split(",").map(oe=>c(oe,W)).filter(oe=>oe!==n),C),H=F.length;if(!H)return n;if(H===1)return F[0];const ne=function(oe,Y){for(let M=0,Z=F.length;M<Z;M++)if(F[M](oe,Y))return C;return null},V=F.find(oe=>!!oe.allBasenames);V&&(ne.allBasenames=V.allBasenames);const ce=F.reduce((oe,Y)=>Y.allPaths?oe.concat(Y.allPaths):oe,[]);return ce.length&&(ne.allPaths=ce),ne}function A(C,W,F){const H=I.sep===I.$jc.sep,ne=H?C:C.replace(p,I.sep),V=I.sep+ne,ce=I.$jc.sep+C;let oe;return F?oe=function(Y,M){return typeof Y=="string"&&(Y===ne||Y.endsWith(V)||!H&&(Y===C||Y.endsWith(ce)))?W:null}:oe=function(Y,M){return typeof Y=="string"&&(Y===ne||!H&&Y===C)?W:null},oe.allPaths=[(F?"*/":"./")+C],oe}function T(C){try{const W=new RegExp(`^${v(C)}$`);return function(F){return W.lastIndex=0,typeof F=="string"&&W.test(F)?C:null}}catch{return n}}function j(C,W,F){return!C||typeof W!="string"?!1:G(C)(W,void 0,F)}function G(C,W={}){if(!C)return o;if(typeof C=="string"||q(C)){const F=c(C,W);if(F===n)return o;const H=function(ne,V){return!!F(ne,V)};return F.allBasenames&&(H.allBasenames=F.allBasenames),F.allPaths&&(H.allPaths=F.allPaths),H}return x(C,W)}function q(C){const W=C;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function Q(C){return C.allBasenames||[]}function de(C){return C.allPaths||[]}function x(C,W){const F=B(Object.getOwnPropertyNames(C).map(oe=>J(oe,C[oe],W)).filter(oe=>oe!==n)),H=F.length;if(!H)return n;if(!F.some(oe=>!!oe.requiresSiblings)){if(H===1)return F[0];const oe=function(Z,U){let N;for(let ie=0,X=F.length;ie<X;ie++){const z=F[ie](Z,U);if(typeof z=="string")return z;(0,r.$uh)(z)&&(N||(N=[]),N.push(z))}return N?(async()=>{for(const ie of N){const X=await ie;if(typeof X=="string")return X}return null})():null},Y=F.find(Z=>!!Z.allBasenames);Y&&(oe.allBasenames=Y.allBasenames);const M=F.reduce((Z,U)=>U.allPaths?Z.concat(U.allPaths):Z,[]);return M.length&&(oe.allPaths=M),oe}const ne=function(oe,Y,M){let Z,U;for(let N=0,ie=F.length;N<ie;N++){const X=F[N];X.requiresSiblings&&M&&(Y||(Y=(0,I.$qc)(oe)),Z||(Z=Y.substr(0,Y.length-(0,I.$rc)(oe).length)));const z=X(oe,Y,Z,M);if(typeof z=="string")return z;(0,r.$uh)(z)&&(U||(U=[]),U.push(z))}return U?(async()=>{for(const N of U){const ie=await N;if(typeof ie=="string")return ie}return null})():null},V=F.find(oe=>!!oe.allBasenames);V&&(ne.allBasenames=V.allBasenames);const ce=F.reduce((oe,Y)=>Y.allPaths?oe.concat(Y.allPaths):oe,[]);return ce.length&&(ne.allPaths=ce),ne}function J(C,W,F){if(W===!1)return n;const H=c(C,F);if(H===n)return n;if(typeof W=="boolean")return H;if(W){const ne=W.when;if(typeof ne=="string"){const V=(ce,oe,Y,M)=>{if(!M||!H(ce,oe))return null;const Z=ne.replace("$(basename)",()=>Y),U=M(Z);return(0,r.$uh)(U)?U.then(N=>N?C:null):U?C:null};return V.requiresSiblings=!0,V}}return H}function B(C,W){const F=C.filter(oe=>!!oe.basenames);if(F.length<2)return C;const H=F.reduce((oe,Y)=>{const M=Y.basenames;return M?oe.concat(M):oe},[]);let ne;if(W){ne=[];for(let oe=0,Y=H.length;oe<Y;oe++)ne.push(W)}else ne=F.reduce((oe,Y)=>{const M=Y.patterns;return M?oe.concat(M):oe},[]);const V=function(oe,Y){if(typeof oe!="string")return null;if(!Y){let Z;for(Z=oe.length;Z>0;Z--){const U=oe.charCodeAt(Z-1);if(U===E.CharCode.Slash||U===E.CharCode.Backslash)break}Y=oe.substr(Z)}const M=H.indexOf(Y);return M!==-1?ne[M]:null};V.basenames=H,V.patterns=ne,V.allBasenames=H;const ce=C.filter(oe=>!oe.basenames);return ce.push(V),ce}function _(C,W){return(0,i.$wb)(C,W,(F,H)=>typeof F=="string"&&typeof H=="string"?F===H:typeof F!="string"&&typeof H!="string"?F.base===H.base&&F.pattern===H.pattern:!1)}}),define(le[48],ue([0,1,21,32,9,3,18,25]),function(K,e,i,r,E,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6w=b,e.$7w=g,e.$8w=m,e.$9w=p,e.$0w=y,e.$$w=S,e.$_w=k,e.$ax=s,e.$bx=a,e.$cx=t;function b(n,c){const{os:h,tildify:P,relative:w}=c;if(w){const A=l(n,w,h);if(typeof A=="string")return A}let R=n.fsPath;if(h===D.OperatingSystem.Windows&&!D.$j?R=R.replace(/\//g,"\\"):h!==D.OperatingSystem.Windows&&D.$j&&(R=R.replace(/\\/g,"/")),h!==D.OperatingSystem.Windows&&P?.userHome){const A=P.userHome.fsPath;let T;n.scheme!==P.userHome.scheme&&n.path[0]===E.$jc.sep&&n.path[1]!==E.$jc.sep?T=P.userHome.with({path:n.path}).fsPath:T=R,R=m(T,A,h)}return(h===D.OperatingSystem.Windows?E.$ic:E.$jc).normalize(g(R,h===D.OperatingSystem.Windows))}function l(n,c,h){const P=h===D.OperatingSystem.Windows?E.$ic:E.$jc,w=h===D.OperatingSystem.Linux?O.$_g:O.$bh,R=c.getWorkspace(),L=(0,i.$Qb)(R.folders);if(!L)return;n.scheme!==L.uri.scheme&&n.path[0]===E.$jc.sep&&n.path[1]!==E.$jc.sep&&(n=L.uri.with({path:n.path}));const A=c.getWorkspaceFolder(n);if(!A)return;let T;if(w.isEqual(A.uri,n)?T="":T=w.relativePath(A.uri,n)??"",T&&(T=P.normalize(T)),R.folders.length>1&&!c.noPrefix){const j=A.name?A.name:w.basenameOrAuthority(A.uri);T=T?`${j} \u2022 ${T}`:j}return T}function g(n,c=D.$j){return(0,r.$Mg)(n,c)?n.charAt(0).toUpperCase()+n.slice(1):n}let u=Object.create(null);function m(n,c,h=D.OS){if(h===D.OperatingSystem.Windows||!n||!c)return n;let P=u.original===c?u.normalized:void 0;P||(P=c,D.$j&&(P=(0,r.$Bg)(P)),P=`${(0,I.$qf)(P,E.$jc.sep)}${E.$jc.sep}`,u={original:c,normalized:P});let w=n;return D.$j&&(w=(0,r.$Bg)(w)),(h===D.OperatingSystem.Linux?w.startsWith(P):(0,I.$Jf)(w,P))?`~/${w.substr(P.length)}`:n}function p(n,c){return n.replace(/^~($|\/|\\)/,`${c}$1`)}const f="\u2026",d="\\\\",v="~";function y(n,c=E.sep){const h=new Array(n.length);let P=!1;for(let w=0;w<n.length;w++){const R=n[w];if(R===""){h[w]=`.${c}`;continue}if(!R){h[w]=R;continue}P=!0;let L="",A=R;A.indexOf(d)===0?(L=A.substr(0,A.indexOf(d)+d.length),A=A.substr(A.indexOf(d)+d.length)):A.indexOf(c)===0?(L=A.substr(0,A.indexOf(c)+c.length),A=A.substr(A.indexOf(c)+c.length)):A.indexOf(v)===0&&(L=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const T=A.split(c);for(let j=1;P&&j<=T.length;j++)for(let G=T.length-j;P&&G>=0;G--){P=!1;let q=T.slice(G,G+j).join(c);for(let Q=0;!P&&Q<n.length;Q++)if(Q!==w&&n[Q]&&n[Q].indexOf(q)>-1){const de=G+j===T.length,x=G>0&&n[Q].indexOf(c)>-1?c+q:q,J=n[Q].endsWith(x);P=!de||J}if(!P){let Q="";(T[0].endsWith(":")||L!=="")&&(G===1&&(G=0,j++,q=T[0]+c+q),G>0&&(Q=T[0]+c),Q=L+Q),G>0&&(Q=Q+f+c),Q=Q+q,G+j<T.length&&(Q=Q+c+f),h[w]=Q}}P&&(h[w]=R)}return h}var $;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})($||($={}));function S(n,c=Object.create(null)){const h=[];let P=!1,w="";for(const R of n)if(R==="$"||P&&R==="{")w&&h.push({value:w,type:$.TEXT}),w="",P=!0;else if(R==="}"&&P){const L=c[w];if(typeof L=="string")L.length&&h.push({value:L,type:$.VARIABLE});else if(L){const A=h[h.length-1];(!A||A.type!==$.SEPARATOR)&&h.push({value:L.label,type:$.SEPARATOR})}w="",P=!1}else w+=R;return w&&!P&&h.push({value:w,type:$.TEXT}),h.filter((R,L)=>{if(R.type===$.SEPARATOR){const A=h[L-1],T=h[L+1];return[A,T].every(j=>j&&(j.type===$.VARIABLE||j.type===$.TEXT)&&j.value.length>0)}return!0}).map(R=>R.value).join("")}function k(n,c){return D.$k||c?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$k?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(n,c){return D.$k||c?n.replace(/\(&&\w\)|&&/g,""):D.$j?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}function a(n){return n.replace(/&/g,"&&")}function t(n){if(n.endsWith("]")){const c=n.lastIndexOf(" [",n.length-2);if(c!==-1){const h=o(n.substring(0,c)),P=n.substring(c);return{name:h.name+P,parentPath:h.parentPath}}}return o(n)}function o(n){const c=n.indexOf("/")!==-1?E.$jc:E.$ic,h=c.basename(n),P=c.dirname(n);return h.length?{name:h,parentPath:P}:{name:P,parentPath:""}}}),define(le[154],ue([0,1,17,92,7]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=void 0,e.$Rn=b,e.$Sn=g,e.$Tn=u;function D(m){return m.toJSON()}class O{constructor(p){this.a=p}transformIncoming(p){const f=this.a.transformIncoming(p);return f===p?p:D(E.URI.from(f))}transformOutgoing(p){const f=this.a.transformOutgoing(p);return f===p?p:D(E.URI.from(f))}transformOutgoingURI(p){const f=this.a.transformOutgoing(p);return f===p?p:E.URI.from(f)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Pn=O,e.$Qn=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function I(m,p,f){if(!m||f>200)return null;if(typeof m=="object"){if(m instanceof E.URI)return p.transformOutgoing(m);for(const d in m)if(Object.hasOwnProperty.call(m,d)){const v=I(m[d],p,f+1);v!==null&&(m[d]=v)}}return null}function b(m,p){const f=I(m,p,0);return f===null?m:f}function l(m,p,f,d){if(!m||d>200)return null;if(typeof m=="object"){if(m.$mid===r.MarshalledId.Uri)return f?E.URI.revive(p.transformIncoming(m)):p.transformIncoming(m);if(m instanceof i.$Qe)return null;for(const v in m)if(Object.hasOwnProperty.call(m,v)){const y=l(m[v],p,f,d+1);y!==null&&(m[v]=y)}}return null}function g(m,p){const f=l(m,p,!1,0);return f===null?m:f}function u(m,p){const f=l(m,p,!0,0);return f===null?m:f}}),define(le[33],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=r;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(E){return i.test(E)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(I){for(let b=0;b<I.length;b++)I[b]=Math.floor(Math.random()*256);return I};const D=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){E(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let b=0,l="";return l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+="-",l+=O[D[b++]],l+=O[D[b++]],l+="-",l+=O[D[b++]],l+=O[D[b++]],l+="-",l+=O[D[b++]],l+=O[D[b++]],l+="-",l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l}}()}),define(le[155],ue([0,1,93,26,91]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$X=D,i=Ie(i),r=Ie(r);async function D(O,I){if(await new Promise((g,u)=>{const m=r.createReadStream(O),p=i.createHash("sha256");m.pipe(p);const f=(0,E.$fb)((d,v)=>{m.removeAllListeners(),p.removeAllListeners(),d?u(d):g(v)});m.once("error",f),m.once("end",f),p.once("error",f),p.once("data",d=>f(void 0,d.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(le[156],ue([0,1,27]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=D;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(O){const I=O.replace(/\-/g,":").toLowerCase();return!r.has(I)}function D(){const O=(0,i.networkInterfaces)();for(const I in O){const b=O[I];if(b){for(const{mac:l}of b)if(E(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[94],ue([0,1,27,61,33,156,3]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=void 0,e.$Wn=b,e.$Xn=u,e.$Yn=m,E=Ie(E),e.$Vn=new class{c(p){return this.a||(this.a=r.$Oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,f=0;const d=(0,i.networkInterfaces)();for(const v in d){const y=d[v];if(y)for(const{mac:$,internal:S}of y)S||(f+=1,this.c($.toUpperCase())&&(p+=1))}this.b=f>0?p/f:0}return this.b}};let I;async function b(p){return I||(I=(async()=>await l(p)||E.$5g())()),I}async function l(p){try{const f=await new Promise((v,y)=>{K(["crypto"],v,y)}).then(Ie),d=(0,D.$Un)();return f.createHash("sha256").update(d,"utf8").digest("hex")}catch(f){p(f);return}}const g="Software\\Microsoft\\SQMClient";async function u(p){if(O.$j){const f=await new Promise((d,v)=>{K(["@vscode/windows-registry"],d,v)}).then(Ie);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(d){return p(d),""}}return""}async function m(p){try{return await(await new Promise((v,y)=>{K(["@vscode/deviceid"],v,y)}).then(Ie)).getDeviceId()}catch(f){return p(f),""}}}),define(le[23],ue([0,1,26,27,157,8,32,79,9,3,18,7]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=S,e.whenDeleted=a,e.configureFlushOnWrite=h,e.writeFileSync=w,i=Ie(i);var m;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function p(x,J=m.UNLINK,B){if((0,O.$Lg)(x))throw new Error("rimraf - will refuse to recursively delete root");return J===m.UNLINK?d(x):f(x,B)}async function f(x,J=(0,O.$Qg)((0,r.tmpdir)())){try{try{await i.promises.rename(x,J)}catch(B){return B.code==="ENOENT"?void 0:d(x)}d(J).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function d(x){return i.promises.rm(x,{recursive:!0,force:!0,maxRetries:3})}function v(x){if((0,O.$Lg)(x))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(x,{recursive:!0,force:!0,maxRetries:3})}async function y(x,J){return k(await(J?$(x):i.promises.readdir(x)))}async function $(x){try{return await i.promises.readdir(x,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const J=[],B=await y(x);for(const _ of B){let C=!1,W=!1,F=!1;try{const H=await i.promises.lstat((0,b.$mc)(x,_));C=H.isFile(),W=H.isDirectory(),F=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}J.push({name:_,isFile:()=>C,isDirectory:()=>W,isSymbolicLink:()=>F})}return J}function S(x){return k(i.readdirSync(x))}function k(x){return x.map(J=>typeof J=="string"?l.$k?(0,I.$qm)(J):J:(J.name=l.$k?(0,I.$qm)(J.name):J.name,J))}async function s(x){const J=await y(x),B=[];for(const _ of J)await t.existsDirectory((0,b.$mc)(x,_))&&B.push(_);return B}function a(x,J=1e3){return new Promise(B=>{let _=!1;const C=setInterval(()=>{_||(_=!0,i.access(x,W=>{_=!1,W&&(clearInterval(C),B(void 0))}))},J)})}var t;(function(x){async function J(C){let W;try{if(W=await i.promises.lstat(C),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await i.promises.stat(C),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(l.$j&&F.code==="EACCES")try{return{stat:await i.promises.stat(await i.promises.readlink(C)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw H}throw F}}x.stat=J;async function B(C){try{const{stat:W,symbolicLink:F}=await x.stat(C);return W.isFile()&&F?.dangling!==!0}catch{}return!1}x.existsFile=B;async function _(C){try{const{stat:W,symbolicLink:F}=await x.stat(C);return W.isDirectory()&&F?.dangling!==!0}catch{}return!1}x.existsDirectory=_})(t||(e.SymlinkSupport=t={}));const o=new D.$Rh;function n(x,J,B){return o.queueFor(u.URI.file(x),()=>{const _=R(B);return new Promise((C,W)=>P(x,J,_,F=>F?W(F):C()))},g.$ah)}let c=!0;function h(x){c=x}function P(x,J,B,_){if(!c)return i.writeFile(x,J,{mode:B.mode,flag:B.flag},_);i.open(x,B.flag,B.mode,(C,W)=>{if(C)return _(C);i.writeFile(W,J,F=>{if(F)return i.close(W,()=>_(F));i.fdatasync(W,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),h(!1)),i.close(W,ne=>_(ne))))})})}function w(x,J,B){const _=R(B);if(!c)return i.writeFileSync(x,J,{mode:_.mode,flag:_.flag});const C=i.openSync(x,_.flag,_.mode);try{i.writeFileSync(C,J);try{i.fdatasyncSync(C)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),h(!1)}}finally{i.closeSync(C)}}function R(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function L(x,J,B=6e4){if(x!==J)try{l.$j&&typeof B=="number"?await A(x,J,Date.now(),B):await i.promises.rename(x,J)}catch(_){if(x.toLowerCase()!==J.toLowerCase()&&_.code==="EXDEV"||x.endsWith("."))await T(x,J,{preserveSymlinks:!1}),await p(x,m.MOVE);else throw _}}async function A(x,J,B,_,C=0){try{return await i.promises.rename(x,J)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-B>=_)throw console.error(`[node.js fs] rename failed after ${C} retries with error: ${W}`),W;if(C===0){let F=!1;try{const{stat:H}=await t.stat(J);H.isFile()||(F=!0)}catch{}if(F)throw W}return await(0,D.$Jh)(Math.min(100,C*10)),A(x,J,B,_,C+1)}}async function T(x,J,B){return G(x,J,{root:{source:x,target:J},options:B,handledSourcePaths:new Set})}const j=511;async function G(x,J,B){if(B.handledSourcePaths.has(x))return;B.handledSourcePaths.add(x);const{stat:_,symbolicLink:C}=await t.stat(x);if(C){if(B.options.preserveSymlinks)try{return await de(x,J,B)}catch{}if(C.dangling)return}return _.isDirectory()?q(x,J,_.mode&j,B):Q(x,J,_.mode&j)}async function q(x,J,B,_){await i.promises.mkdir(J,{recursive:!0,mode:B});const C=await y(x);for(const W of C)await G((0,b.$mc)(x,W),(0,b.$mc)(J,W),_)}async function Q(x,J,B){await i.promises.copyFile(x,J),await i.promises.chmod(J,B)}async function de(x,J,B){let _=await i.promises.readlink(x);(0,O.$Hg)(_,B.root.source,!l.$l)&&(_=(0,b.$mc)(B.root.target,_.substr(B.root.source.length+1))),await i.promises.symlink(_,J)}e.Promises=new class{get read(){return(x,J,B,_,C)=>new Promise((W,F)=>{i.read(x,J,B,_,C,(H,ne,V)=>H?F(H):W({bytesRead:ne,buffer:V}))})}get write(){return(x,J,B,_,C)=>new Promise((W,F)=>{i.write(x,J,B,_,C,(H,ne,V)=>H?F(H):W({bytesWritten:ne,buffer:V}))})}get fdatasync(){return(0,E.promisify)(i.fdatasync)}get open(){return(0,E.promisify)(i.open)}get close(){return(0,E.promisify)(i.close)}get realpath(){return(0,E.promisify)(i.realpath)}async exists(x){try{return await i.promises.access(x),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return s}get writeFile(){return n}get rm(){return p}get rename(){return L}get copy(){return T}}}),define(le[115],ue([0,1,26,9,3,25,23]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=I,e.$rr=b,e.$sr=l,e.$tr=g,i=Ie(i);function I(m){if(E.$l)return m;const p=(0,r.$pc)(m);if(m===p)return m;const f=((0,r.$qc)(m)||m).toLowerCase();try{const v=(0,O.readdirSync)(p).filter(y=>y.toLowerCase()===f);if(v.length===1){const y=I(p);if(y)return(0,r.$mc)(y,v[0])}else if(v.length>1){const y=v.indexOf(f);if(y>=0){const $=I(p);if($)return(0,r.$mc)($,v[y])}}}catch{}return null}async function b(m,p){if(E.$l)return m;const f=(0,r.$pc)(m);if(m===f)return m;const d=((0,r.$qc)(m)||m).toLowerCase();try{if(p?.isCancellationRequested)return null;const y=(await O.Promises.readdir(f)).filter($=>$.toLowerCase()===d);if(y.length===1){const $=await b(f,p);if($)return(0,r.$mc)($,y[0])}else if(y.length>1){const $=y.indexOf(d);if($>=0){const S=await b(f,p);if(S)return(0,r.$mc)(S,y[$])}}}catch{}return null}async function l(m){try{return await O.Promises.realpath(m)}catch{const f=u(m);return await i.promises.access(f,i.constants.R_OK),f}}function g(m){try{return i.realpathSync(m)}catch{const f=u(m);return i.accessSync(f,i.constants.R_OK),f}}function u(m){return(0,D.$qf)((0,r.$kc)(m),r.sep)}}),define(le[116],ue([0,1,95]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=void 0,e.$7g=r,e.$9g=D,i=Ie(i);function r(I,b,l,g=1){let u=!1;return new Promise(m=>{const p=setTimeout(()=>{if(!u)return u=!0,m(0)},l);E(I,b,g,f=>{if(!u)return u=!0,clearTimeout(p),m(f)})})}function E(I,b,l,g){if(b===0)return g(0);const u=new i.Socket;u.once("connect",()=>(O(u),E(I+l,b-1,l,g))),u.once("data",()=>{}),u.once("error",m=>(O(u),m.code!=="ECONNREFUSED"?E(I+l,b-1,l,g):g(I))),u.connect(I,"127.0.0.1")}e.$8g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(I,b,l,g="127.0.0.1"){let u=!1,m,p=1;const f=i.createServer({pauseOnConnect:!0});function d(v,y){u||(u=!0,f.removeAllListeners(),f.close(),m&&clearTimeout(m),y(v))}return new Promise(v=>{m=setTimeout(()=>{d(0,v)},l),f.on("listening",()=>{d(I,v)}),f.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&p<b?(I++,p++,f.listen(I,g)):d(0,v)}),f.on("close",()=>{d(0,v)}),f.listen(I,g)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),define(le[117],ue([0,1,27,9,23]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=$,e.$Am=S,i=Ie(i),r=Ie(r),E=Ie(E);const D=/^\d+$/,O=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(b||(b={}));let l;switch(process.arch){case"ia32":l=b.x86;break;case"arm":case"arm64":l=b.ARM;break;default:l=b.x64;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?b.ARM:b.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=b.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=b.x86:g=b.x64;class u{constructor(s,a,t){this.exePath=s,this.displayName=a,this.a=t}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:k=!1}={}){return k?l===b.x64?process.env["ProgramFiles(x86)"]||null:g===b.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:k=!1,findPreview:s=!1}={}){const a=m({useAlternateBitness:k});if(!a)return null;const t=r.$mc(a,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(t))return null;let o=-1,n=null;for(const P of await E.Promises.readdir(t)){let w=-1;if(s){const L=P.indexOf("-");if(L<0)continue;const A=P.substring(0,L);if(!D.test(A)||P.substring(L+1)!=="preview")continue;w=parseInt(A,10)}else{if(!D.test(P))continue;w=parseInt(P,10)}if(w<=o)continue;const R=r.$mc(t,P,"pwsh.exe");await E.SymlinkSupport.existsFile(R)&&(n=R,o=w)}if(!n)return null;const c=a.includes("x86")?" (x86)":"",h=s?" Preview":"";return new u(n,`PowerShell${h}${c}`,!0)}async function f({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const s=r.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:a,pwshMsixName:t}=k?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const o of await E.Promises.readdir(s))if(a.test(o)){const n=r.$mc(s,o,"pwsh.exe");return new u(n,t)}return null}function d(){const k=r.$mc(i.homedir(),".dotnet","tools","pwsh.exe");return new u(k,".NET Core PowerShell Global Tool")}function v(){const k=r.$mc(process.env.windir,l===b.x86&&g!==b.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(k,"Windows PowerShell",!0)}async function*y(){let k=await p();k&&(yield k),k=await p({useAlternateBitness:!0}),k&&(yield k),k=await f(),k&&(yield k),k=d(),k&&(yield k),k=await p({findPreview:!0}),k&&(yield k),k=await f({findPreview:!0}),k&&(yield k),k=await p({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=v(),k&&(yield k)}async function*$(){for await(const k of y())await k.exists()&&(yield k)}async function S(){for await(const k of $())return k;return null}}),define(le[96],ue([0,1,26,9,3,37,80,12,23]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Bm=l,e.$Cm=g,r=Ie(r),E=Ie(E),D=Ie(D),I=Ie(I),b=Ie(b),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function l(m=D.env){return m.comspec||"cmd.exe"}function g(m){let p=[],f=!1;const d=function(v){if(f){p.push(v);return}(!m.send(v,$=>{if($&&console.error($),f=!1,p.length>0){const S=p.slice(0);p=[],S.forEach(k=>d(k))}})||E.$j)&&(f=!0)};return{send:d}}var u;(function(m){async function p(f,d,v){if(r.$lc(f))return f;if(d===void 0&&(d=D.cwd()),r.$pc(f)!=="."||(v===void 0&&I.$hg(D.env.PATH)&&(v=D.env.PATH.split(r.$wc)),v===void 0||v.length===0))return r.$mc(d,f);async function $(S){if(await b.Promises.exists(S)){let k;try{k=await i.promises.stat(S)}catch(s){s.message.startsWith("EACCES")&&(k=await i.promises.lstat(S))}return k?!k.isDirectory():!1}return!1}for(const S of v){let k;if(r.$lc(S)?k=r.$mc(S,f):k=r.$mc(d,S,f),await $(k))return k;let s=k+".com";if(await $(s)||(s=k+".exe",await $(s)))return s}return r.$mc(d,f)}m.findExecutable=p})(u||(e.win32=u={}))}),define(le[118],ue([0,1,44,11]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=E;function E(O){return new Promise((I,b)=>{let l;const g=new Map;function u(p,f,d,v,y){const $=g.get(f);if(p===O||$){const S={name:m(d),cmd:d,pid:p,ppid:f,load:v,mem:y};g.set(p,S),p===O&&(l=S),$&&($.children||($.children=[]),$.children.push(S),$.children.length>1&&($.children=$.children.sort((k,s)=>k.pid-s.pid)))}}function m(p){const f=/--utility-sub-type=network/i,d=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,y=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(p))return"electron-crash-reporter";if(v.exec(p))return"winpty-agent";if(y.exec(p))return"conpty-agent";let S=$.exec(p);if(S&&S.length===2)return S[1]==="renderer"?"window":S[1]==="utility"?f.exec(p)?"utility-network-service":"utility-process":S[1]==="extensionHost"?"extension-host":S[1];const k=/[a-zA-Z-]+\.js/g;let s="";do S=k.exec(p),S&&(s+=S+" ");while(S);return s&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron-nodejs (${s})`:p}if(process.platform==="win32"){const p=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,d)=>{K(["@vscode/windows-process-tree"],f,d)}).then(Ie).then(f=>{f.getProcessList(O,d=>{if(!d){b(new Error(`Root process ${O} not found`));return}f.getProcessCpuUsage(d,v=>{const y=new Map;v.forEach($=>{const S=p($.commandLine||"");y.set($.pid,{name:m(S),cmd:S,pid:$.pid,ppid:$.ppid,load:$.cpu||0,mem:$.memory||0})}),l=y.get(O),l?(y.forEach($=>{const S=y.get($.ppid);S&&(S.children||(S.children=[]),S.children.push($))}),y.forEach($=>{$.children&&($.children=$.children.sort((S,k)=>S.pid-k.pid))}),I(l)):b(new Error(`Root process ${O} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let p=function(){let f=[l];const d=[];for(;f.length;){const y=f.shift();y&&(d.push(y.pid),y.children&&(f=f.concat(y.children)))}let v=JSON.stringify(r.$3g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+d.join(" "),(0,i.exec)(v,{},(y,$,S)=>{if(y||S)b(y||new Error(S.toString()));else{const k=$.toString().split(`
`);for(let s=0;s<d.length;s++){const a=g.get(d[s]);a.load=parseFloat(k[s])}if(!l){b(new Error(`Root process ${O} not found`));return}I(l)}})};(0,i.exec)("which ps",{},(f,d,v)=>{if(f||v)if(process.platform!=="linux")b(f||new Error(v.toString()));else{const y=JSON.stringify(r.$3g.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(y,{},($,S,k)=>{$||k?b($||new Error(k.toString())):(D(S,u),p())})}else{const y=d.toString().trim();(0,i.exec)(`${y} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(S,k,s)=>{S||s&&!s.includes("screen size is bogus")?b(S||new Error(s.toString())):(D(k,u),process.platform==="linux"?p():l?I(l):b(new Error(`Root process ${O} not found`)))})}})}})}function D(O,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=O.toString().split(`
`);for(const g of l){const u=b.exec(g.trim());u&&u.length===6&&I(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(le[119],ue([0,1,27,3,117,96]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=O,r=Ie(r),D=Ie(D);async function O(u,m){return u===r.OperatingSystem.Windows?r.$j?g():D.$Bm(m):b(u,m)}let I=null;function b(u,m){if(r.$l&&u===r.OperatingSystem.Macintosh||r.$k&&u===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let p;if(r.$j)p="/bin/bash";else{if(p=m.SHELL,!p)try{p=(0,i.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}I=p}return I}let l=null;async function g(){return l||(l=(await(0,E.$Am)()).exePath),l}}),function(){function K(){function e(){return process.uncHostAllowlist}function i(b){const l=new Set;if(Array.isArray(b))for(const g of b)typeof g=="string"&&l.add(g);return Array.from(l)}function r(){const b=e();return b?Array.from(b):[]}function E(b){if(process.platform!=="win32")return;const l=e();if(l)if(typeof b=="string")l.add(b.toLowerCase());else for(const g of i(b))E(g)}function D(b){if(typeof b!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const u of l){if(b.indexOf(u)!==0)continue;const p=b.indexOf("\\",u.length);if(p===-1)continue;const f=b.substring(u.length,p);if(f){g=f;break}}return g}function O(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:E,getUNCHost:D,disableUNCAccessRestrictions:O,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[158],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eY=e.$dY=void 0,e.$dY="vscode:contextmenu",e.$eY="vscode:onCloseContextMenu"});var ke=this&&this.__decorate||function(K,e,i,r){var E=arguments.length,D=E<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,i):r,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(K,e,i,r);else for(var I=K.length-1;I>=0;I--)(O=K[I])&&(D=(E<3?O(D):E>3?O(e,i,D):O(e,i))||D);return E>3&&D&&Object.defineProperty(e,i,D),D};define(le[45],ue([0,1,21,8,17,22,54,15,4,2,83,25,12]),function(K,e,i,r,E,D,O,I,b,l,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.ProxyChannel=e.$qi=e.$ni=e.$mi=e.$li=e.RequestInitiator=e.$ki=e.$hi=e.$gi=void 0,e.$ii=h,e.$ji=P,e.$oi=j,e.$pi=G,u=Ie(u);var p;(function(C){C[C.Promise=100]="Promise",C[C.PromiseCancel=101]="PromiseCancel",C[C.EventListen=102]="EventListen",C[C.EventDispose=103]="EventDispose"})(p||(p={}));function f(C){switch(C){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var d;(function(C){C[C.Initialize=200]="Initialize",C[C.PromiseSuccess=201]="PromiseSuccess",C[C.PromiseError=202]="PromiseError",C[C.PromiseErrorObj=203]="PromiseErrorObj",C[C.EventFire=204]="EventFire"})(d||(d={}));function v(C){switch(C){case d.Initialize:return"init";case d.PromiseSuccess:return"reply:";case d.PromiseError:case d.PromiseErrorObj:return"replyErr:";case d.EventFire:return"event:"}}var y;(function(C){C[C.Uninitialized=0]="Uninitialized",C[C.Idle=1]="Idle"})(y||(y={}));function $(C){let W=0;for(let F=0;;F+=7){const H=C.read(1);if(W|=(H.buffer[0]&127)<<F,!(H.buffer[0]&128))return W}}const S=o(0);function k(C,W){if(W===0){C.write(S);return}let F=0;for(let ne=W;ne!==0;ne=ne>>>7)F++;const H=E.$Qe.alloc(F);for(let ne=0;W!==0;ne++)H.buffer[ne]=W&127,W=W>>>7,W>0&&(H.buffer[ne]|=128);C.write(H)}class s{constructor(W){this.b=W,this.a=0}read(W){const F=this.b.slice(this.a,this.a+W);return this.a+=F.byteLength,F}}e.$gi=s;class a{constructor(){this.a=[]}get buffer(){return E.$Qe.concat(this.a)}write(W){this.a.push(W)}}e.$hi=a;var t;(function(C){C[C.Undefined=0]="Undefined",C[C.String=1]="String",C[C.Buffer=2]="Buffer",C[C.VSBuffer=3]="VSBuffer",C[C.Array=4]="Array",C[C.Object=5]="Object",C[C.Int=6]="Int"})(t||(t={}));function o(C){const W=E.$Qe.alloc(1);return W.writeUInt8(C,0),W}const n={Undefined:o(t.Undefined),String:o(t.String),Buffer:o(t.Buffer),VSBuffer:o(t.VSBuffer),Array:o(t.Array),Object:o(t.Object),Uint:o(t.Int)},c=typeof Buffer<"u";function h(C,W){if(typeof W>"u")C.write(n.Undefined);else if(typeof W=="string"){const F=E.$Qe.fromString(W);C.write(n.String),k(C,F.byteLength),C.write(F)}else if(c&&Buffer.isBuffer(W)){const F=E.$Qe.wrap(W);C.write(n.Buffer),k(C,F.byteLength),C.write(F)}else if(W instanceof E.$Qe)C.write(n.VSBuffer),k(C,W.byteLength),C.write(W);else if(Array.isArray(W)){C.write(n.Array),k(C,W.length);for(const F of W)h(C,F)}else if(typeof W=="number"&&(W|0)===W)C.write(n.Uint),k(C,W);else{const F=E.$Qe.fromString(JSON.stringify(W));C.write(n.Object),k(C,F.byteLength),C.write(F)}}function P(C){switch(C.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return C.read($(C)).toString();case t.Buffer:return C.read($(C)).buffer;case t.VSBuffer:return C.read($(C));case t.Array:{const F=$(C),H=[];for(let ne=0;ne<F;ne++)H.push(P(C));return H}case t.Object:return JSON.parse(C.read($(C)).toString());case t.Int:return $(C)}}class w{constructor(W,F,H=null,ne=1e3){this.h=W,this.j=F,this.k=H,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(V=>this.q(V)),this.m({type:d.Initialize})}registerChannel(W,F){this.b.set(W,F),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case d.Initialize:{const F=this.o([W.type]);this.k?.logOutgoing(F,0,R.OtherSide,v(W.type));return}case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:{const F=this.o([W.type,W.id],W.data);this.k?.logOutgoing(F,W.id,R.OtherSide,v(W.type),W.data);return}}}o(W,F=void 0){const H=new a;return h(H,W),h(H,F),this.p(H.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const F=new s(W),H=P(F),ne=P(F),V=H[0];switch(V){case p.Promise:return this.k?.logIncoming(W.byteLength,H[1],R.OtherSide,`${f(V)}: ${H[2]}.${H[3]}`,ne),this.s({type:V,id:H[1],channelName:H[2],name:H[3],arg:ne});case p.EventListen:return this.k?.logIncoming(W.byteLength,H[1],R.OtherSide,`${f(V)}: ${H[2]}.${H[3]}`,ne),this.t({type:V,id:H[1],channelName:H[2],name:H[3],arg:ne});case p.PromiseCancel:return this.k?.logIncoming(W.byteLength,H[1],R.OtherSide,`${f(V)}`),this.u({type:V,id:H[1]});case p.EventDispose:return this.k?.logIncoming(W.byteLength,H[1],R.OtherSide,`${f(V)}`),this.u({type:V,id:H[1]})}}s(W){const F=this.b.get(W.channelName);if(!F){this.v(W);return}const H=new D.$ze;let ne;try{ne=F.call(this.j,W.name,W.arg,H.token)}catch(oe){ne=Promise.reject(oe)}const V=W.id;ne.then(oe=>{this.m({id:V,data:oe,type:d.PromiseSuccess})},oe=>{oe instanceof Error?this.m({id:V,data:{message:oe.message,name:oe.name,stack:oe.stack?oe.stack.split(`
`):void 0},type:d.PromiseError}):this.m({id:V,data:oe,type:d.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.d.delete(W.id)});const ce=(0,l.$Vc)(()=>H.cancel());this.d.set(W.id,ce)}t(W){const F=this.b.get(W.channelName);if(!F){this.v(W);return}const H=W.id,V=F.listen(this.j,W.name,W.arg)(ce=>this.m({id:H,data:ce,type:d.EventFire}));this.d.set(W.id,V)}u(W){const F=this.d.get(W.id);F&&(F.dispose(),this.d.delete(W.id))}v(W){let F=this.g.get(W.channelName);F||(F=[],this.g.set(W.channelName,F));const H=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===p.Promise&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:d.PromiseError})},this.l);F.push({request:W,timeoutTimer:H})}w(W){const F=this.g.get(W);if(F){for(const H of F)switch(clearTimeout(H.timeoutTimer),H.request.type){case p.Promise:this.s(H.request);break;case p.EventListen:this.t(H.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}e.$ki=w;var R;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class L{constructor(W,F=null){this.l=W,this.a=!1,this.b=y.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$oe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=F}getChannel(W){const F=this;return{call(H,ne,V){return F.a?Promise.reject(new I.$7):F.m(W,H,ne,V)},listen(H,ne){return F.a?b.Event.None:F.o(W,H,ne)}}}m(W,F,H,ne=D.CancellationToken.None){const V=this.g++,ce=p.Promise,oe={id:V,type:ce,channelName:W,name:F,arg:H};if(ne.isCancellationRequested)return Promise.reject(new I.$7);let Y;return new Promise((Z,U)=>{if(ne.isCancellationRequested)return U(new I.$7);const N=()=>{const te=ae=>{switch(ae.type){case d.PromiseSuccess:this.f.delete(V),Z(ae.data);break;case d.PromiseError:{this.f.delete(V);const me=new Error(ae.data.message);me.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,me.name=ae.data.name,U(me);break}case d.PromiseErrorObj:this.f.delete(V),U(ae.data);break}};this.f.set(V,te),this.p(oe)};let ie=null;this.b===y.Idle?N():(ie=(0,r.$vh)(te=>this.u()),ie.then(()=>{ie=null,N()}));const X=()=>{ie?(ie.cancel(),ie=null):this.p({id:V,type:p.PromiseCancel}),U(new I.$7)},z=ne.onCancellationRequested(X);Y=(0,l.$Uc)((0,l.$Vc)(X),z),this.d.add(Y)}).finally(()=>{Y.dispose(),this.d.delete(Y)})}o(W,F,H){const ne=this.g++,V=p.EventListen,ce={id:ne,type:V,channelName:W,name:F,arg:H};let oe=null;const Y=new b.$oe({onWillAddFirstListener:()=>{oe=(0,r.$vh)(Z=>this.u()),oe.then(()=>{oe=null,this.d.add(Y),this.p(ce)})},onDidRemoveLastListener:()=>{oe?(oe.cancel(),oe=null):(this.d.delete(Y),this.p({id:ne,type:p.EventDispose}))}}),M=Z=>Y.fire(Z.data);return this.f.set(ne,M),Y.event}p(W){switch(W.type){case p.Promise:case p.EventListen:{const F=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(F,W.id,R.LocalSide,`${f(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case p.PromiseCancel:case p.EventDispose:{const F=this.q([W.type,W.id]);this.j?.logOutgoing(F,W.id,R.LocalSide,f(W.type));return}}}q(W,F=void 0){const H=new a;return h(H,W),h(H,F),this.r(H.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const F=new s(W),H=P(F),ne=P(F),V=H[0];switch(V){case d.Initialize:return this.j?.logIncoming(W.byteLength,0,R.LocalSide,v(V)),this.t({type:H[0]});case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:return this.j?.logIncoming(W.byteLength,H[1],R.LocalSide,v(V),ne),this.t({type:H[0],id:H[1],data:ne})}}t(W){if(W.type===d.Initialize){this.b=y.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}e.$li=L,ke([O.$ai],L.prototype,"onDidInitializePromise",null);class A{get connections(){const W=[];return this.f.forEach(F=>W.push(F)),W}constructor(W,F,H){this.a=new Map,this.f=new Set,this.g=new b.$oe,this.onDidAddConnection=this.g.event,this.h=new b.$oe,this.onDidRemoveConnection=this.h.event,this.j=new l.$Wc,this.j.add(W(({protocol:ne,onDidClientDisconnect:V})=>{const ce=b.Event.once(ne.onMessage);this.j.add(ce(oe=>{const Y=new s(oe),M=P(Y),Z=new w(ne,M,F,H),U=new L(ne,F);this.a.forEach((ie,X)=>Z.registerChannel(X,ie));const N={channelServer:Z,channelClient:U,ctx:M};this.f.add(N),this.g.fire(N),this.j.add(V(()=>{Z.dispose(),U.dispose(),this.f.delete(N),this.h.fire(N)}))}))}))}getChannel(W,F){const H=this;return{call(ne,V,ce){let oe;if((0,m.$vg)(F)){const M=(0,i.$5b)(H.connections.filter(F));oe=M?Promise.resolve(M):b.Event.toPromise(b.Event.filter(H.onDidAddConnection,F))}else oe=F.routeCall(H,ne,V);const Y=oe.then(M=>M.channelClient.getChannel(W));return j(Y).call(ne,V,ce)},listen(ne,V){if((0,m.$vg)(F))return H.k(W,F,ne,V);const ce=F.routeEvent(H,ne,V).then(oe=>oe.channelClient.getChannel(W));return j(ce).listen(ne,V)}}}k(W,F,H,ne){const V=this;let ce;const oe=new b.$oe({onWillAddFirstListener:()=>{ce=new l.$Wc;const Y=new b.$ue,M=new Map,Z=N=>{const X=N.channelClient.getChannel(W).listen(H,ne),z=Y.add(X);M.set(N,z)},U=N=>{const ie=M.get(N);ie&&(ie.dispose(),M.delete(N))};V.connections.filter(F).forEach(Z),b.Event.filter(V.onDidAddConnection,F)(Z,void 0,ce),V.onDidRemoveConnection(U,void 0,ce),Y.event(oe.fire,oe,ce),ce.add(Y)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return oe.event}registerChannel(W,F){this.a.set(W,F);for(const H of this.f)H.channelServer.registerChannel(W,F)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$mi=A;class T{constructor(W,F,H=null){const ne=new a;h(ne,F),W.send(ne.buffer),this.a=new L(W,H),this.d=new w(W,F,H)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,F){this.d.registerChannel(W,F)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ni=T;function j(C){return{call(W,F,H){return C.then(ne=>ne.call(W,F,H))},listen(W,F){const H=new b.$xe;return C.then(ne=>H.input=ne.listen(W,F)),H.event}}}function G(C){let W=!1;return{call(F,H,ne){return W?C.call(F,H,ne):(0,r.$Jh)(0).then(()=>W=!0).then(()=>C.call(F,H,ne))},listen(F,H){if(W)return C.listen(F,H);const ne=new b.$xe;return(0,r.$Jh)(0).then(()=>W=!0).then(()=>ne.input=C.listen(F,H)),ne.event}}}class q{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const F of W.connections)if(await Promise.resolve(this.a(F.ctx)))return Promise.resolve(F);return await b.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$qi=q;var Q;(function(C){function W(V,ce,oe){const Y=V,M=oe&&oe.disableMarshalling,Z=new Map;for(const U in Y)H(U)&&Z.set(U,b.Event.buffer(Y[U],!0,void 0,ce));return new class{listen(U,N,ie){const X=Z.get(N);if(X)return X;const z=Y[N];if(typeof z=="function"){if(ne(N))return z.call(Y,ie);if(H(N))return Z.set(N,b.Event.buffer(Y[N],!0,void 0,ce)),Z.get(N)}throw new I.$db(`Event not found: ${N}`)}call(U,N,ie){const X=Y[N];if(typeof X=="function"){if(!M&&Array.isArray(ie))for(let te=0;te<ie.length;te++)ie[te]=(0,g.$fi)(ie[te]);let z=X.apply(Y,ie);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new I.$db(`Method not found: ${N}`)}}}C.fromService=W;function F(V,ce){const oe=ce&&ce.disableMarshalling;return new Proxy({},{get(Y,M){if(typeof M=="string")return ce?.properties?.has(M)?ce.properties.get(M):ne(M)?function(Z){return V.listen(M,Z)}:H(M)?V.listen(M):async function(...Z){let U;ce&&!(0,m.$qg)(ce.context)?U=[ce.context,...Z]:U=Z;const N=await V.call(M,U);return oe?N:(0,g.$fi)(N)};throw new I.$db(`Property not found: ${String(M)}`)}})}C.toService=F;function H(V){return V[0]==="o"&&V[1]==="n"&&u.$Hf(V.charCodeAt(2))}function ne(V){return/^onDynamic/.test(V)&&u.$Hf(V.charCodeAt(9))}})(Q||(e.ProxyChannel=Q={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(C){if(Array.isArray(C))return C;if(C&&typeof C=="object"&&typeof C.toString=="function"){const W=C.toString();if(W!=="[object Object]")return W}return C}function J(C){return Array.isArray(C)?C.map(x):x(C)}function B(C,W,F,H,ne,V,ce){ce=J(ce);const oe=de[ne],Y=oe[H%oe.length];let M=[`%c[${C}]%c[${String(W).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(V)?(M=M.concat(ce),M.push(")")):M.push(ce),console.log.apply(console,M)}class _{constructor(W,F){this.d=W,this.f=F,this.a=0,this.b=0}logOutgoing(W,F,H,ne,V){this.b+=W,B(this.d,this.b,W,F,H,ne,V)}logIncoming(W,F,H,ne,V){this.a+=W,B(this.f,this.a,W,F,H,ne,V)}}e.$ri=_}),define(le[159],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lY=void 0;class i{constructor(E,D){this.a=E,this.onMessage=D}send(E){try{this.a.send("vscode:message",E.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$lY=i}),define(le[160],ue([0,1,17,4,45]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jY=e.$iY=void 0;class D{constructor(b){this.a=b,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?i.$Qe.wrap(l.data):i.$Qe.alloc(0)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}e.$iY=D;class O extends E.$ni{constructor(b,l){const g=new D(b);super(g,l),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$jY=O}),define(le[120],ue([0,1,17,4,2,45]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.ProtocolConstants=e.$si=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(n){n.enableDiagnostics=!1,n.records=[];const c=new WeakMap;let h=0;function P(R,L){if(!c.has(R)){const A=String(++h);c.set(R,A)}return c.get(R)}function w(R,L,A,T){if(!n.enableDiagnostics)return;const j=P(R,L);if(T instanceof i.$Qe||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const G=i.$Qe.alloc(T.byteLength);G.set(T),n.records.push({timestamp:Date.now(),id:j,label:L,type:A,buff:G})}else n.records.push({timestamp:Date.now(),id:j,label:L,type:A,data:T})}n.traceSocketEvent=w})(I||(e.SocketDiagnostics=I={}));var b;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let l=null;function g(){return l||(l=i.$Qe.alloc(0)),l}class u{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return g();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const L=this.a[0];return h&&(this.a.shift(),this.b-=c),L}if(this.a[0].byteLength>c){const L=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),L}const P=i.$Qe.alloc(c);let w=0,R=0;for(;c>0;){const L=this.a[R];if(L.byteLength>c){const A=L.slice(0,c);P.set(A,w),w+=c,h&&(this.a[R]=L.slice(c),this.b-=c),c-=c}else P.set(L,w),w+=L.byteLength,h?(this.a.shift(),this.b-=L.byteLength):R++,c-=L.byteLength}return P}}e.$si=u;var m;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(m||(m={}));function p(n){switch(n){case m.None:return"None";case m.Regular:return"Regular";case m.Control:return"Control";case m.Ack:return"Ack";case m.Disconnect:return"Disconnect";case m.ReplayRequest:return"ReplayRequest";case m.Pause:return"PauseWriting";case m.Resume:return"ResumeWriting";case m.KeepAlive:return"KeepAlive"}}var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class d{constructor(c,h,P,w){this.type=c,this.id=h,this.ack=P,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends E.$Xc{constructor(c){super(),this.f=this.B(new r.$oe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:f.HeaderLength,messageType:m.None,id:0,ack:0},this.a=c,this.b=!1,this.c=new u,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const P=this.g.messageType,w=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=f.HeaderLength,this.g.messageType=m.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,h),this.f.fire(new d(P,w,R,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class y{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=i.$Qe.alloc(f.HeaderLength);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:p(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,c.data),this.j(h,c.data)}g(c,h){const P=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,P}h(){const c=i.$Qe.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:c.byteLength}),this.c.write(c)}}class $ extends E.$Xc{constructor(c){super(),this.f=new r.$oe,this.onMessage=this.f.event,this.g=new r.$oe,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new y(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(h=>{h.type===m.Regular&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new d(m.Regular,0,0,c))}}e.$ti=$;class S extends D.$ni{static fromSocket(c,h){return new S(new $(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,P=null){super(c,h,P),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$ui=S;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$oe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$vi=k;class s{constructor(c){this.data=c,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,P=this.a;for(;P;)c[h++]=P.data,P=P.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new s(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class t{static{this.a=10}static{this.b=null}static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<t.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=t.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+t.a)*1e3;let P=0;for(let w=0;w<t.a;w++)c-this.c[w]<=h&&P++;return 1-P/t.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(c){this.v=new k,this.onControlMessage=this.v.event,this.w=new k,this.onMessage=this.w.event,this.x=new k,this.onDidDispose=this.x.event,this.y=new k,this.onSocketClose=this.y.event,this.z=new k,this.onSocketTimeout=this.z.event,this.t=c.loadEstimator??t.getInstance(),this.u=c.sendKeepAlive??!0,this.a=!1,this.c=new a,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new E.$Wc,this.p=c.socket,this.q=this.s.add(new y(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(h=>this.A(h))),this.s.add(this.p.onClose(h=>this.y.fire(h))),c.initialChunk&&this.r.acceptChunk(c.initialChunk),this.u?this.m=setInterval(()=>{this.E()},f.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const c=new d(m.Disconnect,0,0,g());this.q.write(c),this.q.flush()}}sendPause(){const c=new d(m.Pause,0,0,g());this.q.write(c)}sendResume(){const c=new d(m.Resume,0,0,g());this.q.write(c)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.s.dispose(),this.s=new E.$Wc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=c,this.q=this.s.add(new y(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(P=>this.A(P))),this.s.add(this.p.onClose(P=>this.y.fire(P))),this.r.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.j=this.h;const c=new d(m.Ack,0,this.j,g());this.q.write(c);const h=this.c.toArray();for(let P=0,w=h.length;P<w;P++)this.q.write(h[P]);this.C()}acceptDisconnect(){this.x.fire()}A(c){if(c.ack>this.f){this.f=c.ack;do{const h=this.c.peek();if(h&&h.id<=c.ack)this.c.pop();else break}while(!0)}switch(c.type){case m.None:break;case m.Regular:{if(c.id>this.h)if(c.id!==this.h+1){const h=Date.now();h-this.n>1e4&&(this.n=h,this.q.write(new d(m.ReplayRequest,0,0,g())))}else this.h=c.id,this.k=Date.now(),this.B(),this.w.fire(c.data);break}case m.Control:{this.v.fire(c.data);break}case m.Ack:break;case m.Disconnect:{this.x.fire();break}case m.ReplayRequest:{const h=this.c.toArray();for(let P=0,w=h.length;P<w;P++)this.q.write(h[P]);this.C();break}case m.Pause:{this.q.pause();break}case m.Resume:{this.q.resume();break}case m.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(c){const h=++this.d;this.j=this.h;const P=new d(m.Regular,h,this.j,c);this.c.push(P),this.a||(this.q.write(P),this.C())}sendControl(c){const h=new d(m.Control,0,0,c);this.q.write(h)}B(){if(this.h<=this.j||this.l)return;const c=Date.now()-this.k;if(c>=f.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},f.AcknowledgeTime-c+5)}C(){if(this.d<=this.f||this.g||this.a)return;const c=this.c.peek(),h=Date.now()-c.writtenTime,P=Date.now()-this.r.lastReadTime,w=Date.now()-this.o;if(h>=f.TimeoutTime&&P>=f.TimeoutTime&&w>=f.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:P});return}const R=Math.max(f.TimeoutTime-h,f.TimeoutTime-P,f.TimeoutTime-w,500);this.g=setTimeout(()=>{this.g=null,this.C()},R)}D(){if(this.h<=this.j)return;this.j=this.h;const c=new d(m.Ack,0,this.j,g());this.q.write(c)}E(){this.j=this.h;const c=new d(m.KeepAlive,0,this.j,g());this.q.write(c)}}e.$wi=o});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[35],ue([0,1,13,15,11]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fY=void 0,i=Ve(i);class D{constructor(){this.a=new WeakMap}on(I,b){const l=(g,...u)=>{this.b(I,g)&&b(g,...u)};return this.a.set(b,l),i.default.ipcMain.on(I,l),this}once(I,b){return i.default.ipcMain.once(I,(l,...g)=>{this.b(I,l)&&b(l,...g)}),this}handle(I,b){return i.default.ipcMain.handle(I,(l,...g)=>this.b(I,l)?b(l,...g):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return i.default.ipcMain.removeHandler(I),this}removeListener(I,b){const l=this.a.get(b);return l&&(i.default.ipcMain.removeListener(I,l),this.a.delete(b)),this}b(I,b){if(!I||!I.startsWith("vscode:"))return(0,r.$2)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const l=b.senderFrame,g=l.url;if(!g||g==="about:blank")return!0;let u="unknown";try{u=new URL(g).host}catch{return(0,r.$2)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${g}'.`),!1}return u!==E.$2g?((0,r.$2)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${u}'.`),!1):l.parent!==null?((0,r.$2)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${u}' is not a main frame.`),!1):!0}}e.$fY=new D}),define(le[161],ue([0,1,13,35,158]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gY=D;function D(){r.$fY.on(E.$dY,(I,b,l,g,u)=>{const m=O(I,g,l);m.popup({x:u?u.x:void 0,y:u?u.y:void 0,positioningItem:u?u.positioningItem:void 0,callback:()=>{m&&I.sender.send(E.$eY,b)}})})}function O(I,b,l){const g=new i.Menu;return l.forEach(u=>{let m;u.type==="separator"?m=new i.MenuItem({type:u.type}):Array.isArray(u.submenu)?m=new i.MenuItem({submenu:O(I,b,u.submenu),label:u.label}):m=new i.MenuItem({label:u.label,type:u.type,accelerator:u.accelerator,checked:u.checked,enabled:u.enabled,visible:u.visible,click:(p,f,d)=>I.sender.send(b,u.id,d)}),g.append(m)}),g}}),define(le[162],ue([0,1,35,17,4,2,45,159]),function(K,e,i,r,E,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mY=void 0;function b(g,u){const m=E.Event.fromNodeEventEmitter(i.$fY,u,(f,d)=>({event:f,message:d})),p=E.Event.filter(m,({event:f})=>f.sender.id===g);return E.Event.map(p,({message:f})=>f&&r.$Qe.wrap(f))}class l extends O.$mi{static{this.b=new Map}static d(){const u=E.Event.fromNodeEventEmitter(i.$fY,"vscode:hello",({sender:m})=>m);return E.Event.map(u,m=>{const p=m.id;l.b.get(p)?.dispose();const d=new E.$oe;l.b.set(p,(0,D.$Vc)(()=>d.fire()));const v=b(p,"vscode:message"),y=E.Event.any(E.Event.signal(b(p,"vscode:disconnect")),d.event);return{protocol:new I.$lY(m,v),onDidClientDisconnect:y}})}constructor(){super(l.d())}}e.$mY=l}),define(le[121],ue([0,1,35,4,33,160]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nY=void 0,e.$oY=I;class O extends D.$jY{constructor(l,g){super({addEventListener:(u,m)=>l.addListener(u,m),removeEventListener:(u,m)=>l.removeListener(u,m),postMessage:u=>l.postMessage(u),start:()=>l.start(),close:()=>l.close()},g)}}e.$nY=O;async function I(b){if(b.isDestroyed()||b.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,E.$5g)();b.webContents.send("vscode:createMessageChannel",l);const g=r.Event.fromNodeEventEmitter(i.$fY,"vscode:createMessageChannelResult",(m,p)=>({nonce:p,port:m.ports[0]})),{port:u}=await r.Event.toPromise(r.Event.once(r.Event.filter(g,m=>m.nonce===l)));return u}}),define(le[163],ue([0,1,44,8,17,22,152,15,4,2,38,96,80,45]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0,I=Ie(I);class f extends p.$ki{constructor(y){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",$=>E.$Qe.wrap(Buffer.from($,"base64")))},y),process.once("disconnect",()=>this.dispose())}}e.$mr=f;class d{constructor(y,$){this.i=y,this.j=$,this.c=new Set,this.g=new Map,this.h=new b.$oe,this.onDidProcessExit=this.h.event;const S=$&&$.timeout?$.timeout:6e4;this.b=new r.$Fh(S),this.d=null,this.f=null}getChannel(y){const $=this;return{call(S,k,s){return $.k(y,S,k,s)},listen(S,k){return $.l(y,S,k)}}}k(y,$,S,k=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(I.$8());this.b.cancel();const s=this.n(y),a=(0,r.$vh)(n=>s.call($,S,n)),t=k.onCancellationRequested(()=>a.cancel()),o=(0,l.$Vc)(()=>a.cancel());return this.c.add(o),a.finally(()=>{t.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(y,$,S){if(!this.b)return b.Event.None;this.b.cancel();let k;const s=new b.$oe({onWillAddFirstListener:()=>{k=this.n(y).listen($,S)(s.fire,s),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const y=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,g.$ho)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,m.$pm)($.env),this.d=(0,i.fork)(this.i,y,$);const S=new b.$oe,s=b.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,O.$ir)(h)){(0,O.log)(h,`IPC Library: ${this.j.serverName}`);return}S.fire(E.$Qe.wrap(Buffer.from(h,"base64")))}),a=this.j.useQueue?(0,u.$Cm)(this.d):this.d,t=h=>this.d&&this.d.connected&&a.send(h.buffer.toString("base64")),o=S.event,n={send:t,onMessage:o};this.f=new p.$li(n);const c=()=>this.o();process.once("exit",c),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,P)=>{process.removeListener("exit",c),s.dispose(),this.c.forEach(w=>(0,l.$Sc)(w)),this.c.clear(),h!==0&&P!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+P),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:P})})}return this.f}n(y){let $=this.g.get(y);return $||($=this.m.getChannel(y),this.g.set(y,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$nr=d}),define(le[122],ue([0,1,8,4,2,83,12]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=e.StorageState=e.StorageHint=void 0,e.$gq=b;var I;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function b(m){const p=m;return p?.changed instanceof Map||p?.deleted instanceof Set}var l;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(l||(e.StorageState=l={}));class g extends E.$Xc{static{this.a=100}constructor(p,f=Object.create(null)){super(),this.r=p,this.s=f,this.b=this.B(new r.$re),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new i.$Gh(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((f,d)=>this.w(d,f)),p.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(p,f){if(this.c===l.Closed)return;let d=!1;(0,O.$qg)(f)?d=this.f.delete(p):this.f.get(p)!==f&&(this.f.set(p,f),d=!0),d&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,f){const d=this.f.get(p);return(0,O.$qg)(d)?f:d}getBoolean(p,f){const d=this.get(p);return(0,O.$qg)(d)?f:d==="true"}getNumber(p,f){const d=this.get(p);return(0,O.$qg)(d)?f:parseInt(d,10)}getObject(p,f){const d=this.get(p);return(0,O.$qg)(d)?f:(0,D.$ei)(d)}async set(p,f,d=!1){if(this.c===l.Closed)return;if((0,O.$qg)(f))return this.delete(p,d);const v=(0,O.$jg)(f)||Array.isArray(f)?(0,D.$di)(f):String(f);if(this.f.get(p)!==v)return this.f.set(p,v),this.j.set(p,v),this.h.delete(p),this.b.fire({key:p,external:d}),this.D()}async delete(p,f=!1){if(!(this.c===l.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:f}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(!(this.c===l.Closed||this.m))return this.D(p)}async D(p){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$hq=g;class u{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((f,d)=>this.a.set(d,f)),p.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$iq=u}),define(le[164],ue([0,1,26,8,4,31,9,23]),function(K,e,i,r,E,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KY=void 0,i=Ie(i);class b{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return E.Event.None}static{this.a=2e3}static{this.b=256}constructor(u,m=Object.create(null)){this.g=u,this.h=m,this.c=(0,O.$qc)(this.g),this.d=new l(this.h.logging),this.f=this.n(this.g)}async getItems(){const u=await this.f,m=new Map;return(await this.s(u,"SELECT * FROM ItemTable")).forEach(f=>m.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${m.size} rows`),m}async updateItems(u){const m=await this.f;return this.j(m,u)}j(u,m){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${m.insert?(0,D.$Bc)(m.insert):"0"}), delete(${m.delete?(0,D.$Cc)(m.delete):"0"})`),this.t(u,()=>{const p=m.insert,f=m.delete;if(p&&p.size>0){const d=[];d.push([]);let v=0;p.forEach((y,$)=>{let S=d[v];S.length>b.b&&(v++,S=[],d.push(S)),S.push($,y)}),d.forEach(y=>{this.u(u,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,$=>$.run(y),()=>{const $=[];let S=0;return p.forEach((k,s)=>{$.push(s),S+=k.length}),`Keys: ${$.join(", ")} Length: ${S}`})})}if(f&&f.size){const d=[];d.push([]);let v=0;f.forEach(y=>{let $=d[v];$.length>b.b&&(v++,$=[],d.push($)),$.push(y)}),d.forEach(y=>{this.u(u,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,$=>$.run(y),()=>{const $=[];return f.forEach(S=>{$.push(S)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const u=await this.f;return this.q(u,"VACUUM")}async close(u){this.d.trace(`[storage ${this.c}] close()`);const m=await this.f;return this.k(m,u)}k(u,m){return new Promise((p,f)=>{u.db.close(d=>(d&&this.o(u,`[storage ${this.c}] close(): ${d}`),this.g===b.IN_MEMORY_PATH?p():!u.isErroneous&&!u.isInMemory?this.l().then(p,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),p())):typeof m=="function"?i.promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const y=()=>this.k(v,void 0);return this.j(v,{insert:m()}).then(()=>y(),$=>(y(),Promise.reject($)))})).then(p,f):f(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const u=this.m(this.g);return I.Promises.copy(this.g,u,{preserveSymlinks:!1})}m(u){return`${u}.backup`}async checkIntegrity(u){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${u})`);const m=await this.f,p=await this.r(m,u?"PRAGMA integrity_check":"PRAGMA quick_check"),f=u?p.integrity_check:p.quick_check;return m.isErroneous?`${f} (last error: ${m.lastError})`:m.isInMemory?`${f} (in-memory!)`:f}async n(u,m=!0){this.d.trace(`[storage ${this.c}] open(${u}, retryOnBusy: ${m})`);try{return await this.p(u)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&m)return await(0,r.$Jh)(b.a),this.n(u,!1);try{await i.promises.unlink(u);try{await I.Promises.rename(this.m(u),u,!1)}catch{}return await this.p(u)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(b.IN_MEMORY_PATH)}}}o(u,m){u.isErroneous=!0,u.lastError=m,this.d.error(m)}p(u){return new Promise((m,p)=>{new Promise((f,d)=>{K(["@vscode/sqlite3"],f,d)}).then(Ie).then(f=>{const d=this.d.isTracing?f.verbose().Database:f.Database,v={db:new d(u,y=>y?v.db&&y.code!=="SQLITE_CANTOPEN"?v.db.close(()=>p(y)):p(y):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(v),$=>v.db.close(()=>p($)))),isInMemory:u===b.IN_MEMORY_PATH};v.db.on("error",y=>this.o(v,`[storage ${this.c}] Error (event): ${y}`)),this.d.isTracing&&v.db.on("trace",y=>this.d.trace(`[storage ${this.c}] Trace (event): ${y}`))},p)})}q(u,m){return new Promise((p,f)=>{u.db.exec(m,d=>d?(this.o(u,`[storage ${this.c}] exec(): ${d}`),f(d)):p())})}r(u,m){return new Promise((p,f)=>{u.db.get(m,(d,v)=>d?(this.o(u,`[storage ${this.c}] get(): ${d}`),f(d)):p(v))})}s(u,m){return new Promise((p,f)=>{u.db.all(m,(d,v)=>d?(this.o(u,`[storage ${this.c}] all(): ${d}`),f(d)):p(v))})}t(u,m){return new Promise((p,f)=>{u.db.serialize(()=>{u.db.run("BEGIN TRANSACTION"),m(),u.db.run("END TRANSACTION",d=>d?(this.o(u,`[storage ${this.c}] transaction(): ${d}`),f(d)):p())})})}u(u,m,p,f){const d=u.db.prepare(m),v=y=>{this.o(u,`[storage ${this.c}] prepare(): ${y} (${m}). Details: ${f()}`)};d.on("error",v),p(d),d.finalize(y=>{y&&v(y),d.removeListener("error",v)})}}e.$KY=b;class l{static{this.a="VSCODE_TRACE_STORAGE"}constructor(u){u&&typeof u.logTrace=="function"&&process.env[l.a]&&(this.b=u.logTrace),u&&typeof u.logError=="function"&&(this.c=u.logError)}get isTracing(){return!!this.b}trace(u){this.b?.(u)}error(u){this.c?.(u)}}}),define(le[10],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=E,e.localize2=O;const i=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,b){let l;return b.length===0?l=I:l=I.replace(/\{(\d+)\}/g,(g,u)=>{const m=u[0],p=b[m];let f=g;return typeof p=="string"?f=p:(typeof p=="number"||typeof p=="boolean"||p===void 0||p===null)&&(f=String(p)),f}),i&&(l="\uFF3B"+l.replace(/[aouei]/g,"$&$&")+"\uFF3D"),l}function E(I,b,...l){return r(typeof I=="number"?D(I,b):b,l)}function D(I,b){const l=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof l!="string"){if(typeof b=="string")return b;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return l}function O(I,b,...l){let g;typeof I=="number"?g=D(I,b):g=b;const u=r(g,l);return{value:u,original:b===g?u:r(b,l)}}}),define(le[165],ue([0,1,10]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=l,e.$6m=g,e.$7m=u;const r=60,E=r*60,D=E*24,O=D*7,I=D*30,b=D*365;function l(m,p,f,d){typeof m!="number"&&(m=m.getTime());const v=Math.round((new Date().getTime()-m)/1e3);if(v<-30)return(0,i.localize)(42,null,l(new Date().getTime()+v*1e3,!1));if(!d&&v<30)return(0,i.localize)(43,null);let y;return v<r?(y=v,p?y===1?f?(0,i.localize)(44,null,y):(0,i.localize)(45,null,y):f?(0,i.localize)(46,null,y):(0,i.localize)(47,null,y):y===1?f?(0,i.localize)(48,null,y):(0,i.localize)(49,null,y):f?(0,i.localize)(50,null,y):(0,i.localize)(51,null,y)):v<E?(y=Math.floor(v/r),p?y===1?f?(0,i.localize)(52,null,y):(0,i.localize)(53,null,y):f?(0,i.localize)(54,null,y):(0,i.localize)(55,null,y):y===1?f?(0,i.localize)(56,null,y):(0,i.localize)(57,null,y):f?(0,i.localize)(58,null,y):(0,i.localize)(59,null,y)):v<D?(y=Math.floor(v/E),p?y===1?f?(0,i.localize)(60,null,y):(0,i.localize)(61,null,y):f?(0,i.localize)(62,null,y):(0,i.localize)(63,null,y):y===1?f?(0,i.localize)(64,null,y):(0,i.localize)(65,null,y):f?(0,i.localize)(66,null,y):(0,i.localize)(67,null,y)):v<O?(y=Math.floor(v/D),p?y===1?(0,i.localize)(68,null,y):(0,i.localize)(69,null,y):y===1?(0,i.localize)(70,null,y):(0,i.localize)(71,null,y)):v<I?(y=Math.floor(v/O),p?y===1?f?(0,i.localize)(72,null,y):(0,i.localize)(73,null,y):f?(0,i.localize)(74,null,y):(0,i.localize)(75,null,y):y===1?f?(0,i.localize)(76,null,y):(0,i.localize)(77,null,y):f?(0,i.localize)(78,null,y):(0,i.localize)(79,null,y)):v<b?(y=Math.floor(v/I),p?y===1?f?(0,i.localize)(80,null,y):(0,i.localize)(81,null,y):f?(0,i.localize)(82,null,y):(0,i.localize)(83,null,y):y===1?f?(0,i.localize)(84,null,y):(0,i.localize)(85,null,y):f?(0,i.localize)(86,null,y):(0,i.localize)(87,null,y)):(y=Math.floor(v/b),p?y===1?f?(0,i.localize)(88,null,y):(0,i.localize)(89,null,y):f?(0,i.localize)(90,null,y):(0,i.localize)(91,null,y):y===1?f?(0,i.localize)(92,null,y):(0,i.localize)(93,null,y):f?(0,i.localize)(94,null,y):(0,i.localize)(95,null,y))}function g(m,p){const f=Math.abs(m/1e3);return f<1?p?(0,i.localize)(96,null,m):(0,i.localize)(97,null,m):f<r?p?(0,i.localize)(98,null,Math.round(m)/1e3):(0,i.localize)(99,null,Math.round(m)/1e3):f<E?p?(0,i.localize)(100,null,Math.round(m/(1e3*r))):(0,i.localize)(101,null,Math.round(m/(1e3*r))):f<D?p?(0,i.localize)(102,null,Math.round(m/(1e3*E))):(0,i.localize)(103,null,Math.round(m/(1e3*E))):(0,i.localize)(104,null,Math.round(m/(1e3*D)))}function u(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[55],ue([0,1,21,12,10]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=b,e.$uj=l,e.$vj=g,i=Ie(i),r=Ie(r),E=Ie(E);function D(u,m){return m&&(u.stack||u.stacktrace)?E.localize(105,null,I(u),O(u.stack)||O(u.stacktrace)):I(u)}function O(u){return Array.isArray(u)?u.join(`
`):u}function I(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?E.localize(106,null,u.message):u.message||E.localize(107,null)}function b(u=null,m=!1){if(!u)return E.localize(108,null);if(Array.isArray(u)){const p=i.$Jb(u),f=b(p[0],m);return p.length>1?E.localize(109,null,f,p.length):f}if(r.$hg(u))return u;if(u.detail){const p=u.detail;if(p.error)return D(p.error,m);if(p.exception)return D(p.exception,m)}return u.stack?D(u,m):u.message?u.message:E.localize(110,null)}function l(u){const m=u;return m instanceof Error&&Array.isArray(m.actions)}function g(u,m){let p;return typeof u=="string"?p=new Error(u):p=u,p.actions=m,p}}),define(le[166],ue([0,1,10,43]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=E;function E(D){switch(D){case r.ParseErrorCode.InvalidSymbol:return(0,i.localize)(111,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(112,null);case r.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(113,null);case r.ParseErrorCode.ValueExpected:return(0,i.localize)(114,null);case r.ParseErrorCode.ColonExpected:return(0,i.localize)(115,null);case r.ParseErrorCode.CommaExpected:return(0,i.localize)(116,null);case r.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(117,null);case r.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(118,null);case r.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(119,null);default:return""}}}),define(le[167],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bib=i,e.$Cib=r;function i(E){return E&&E.hasOwnProperty("folderUri")}function r(E){return E&&E.hasOwnProperty("workspace")}}),define(le[168],ue([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=r,e.$Jgc=E,e.$Kgc=D;function r(O){return typeof O?.backupFolder=="string"}function E(O){let I=[];try{Array.isArray(O.workspaces)&&(I=O.workspaces.map(b=>({workspace:{id:b.id,configPath:i.URI.parse(b.configURIPath)},remoteAuthority:b.remoteAuthority})))}catch{}return I}function D(O){let I=[];try{Array.isArray(O.folders)&&(I=O.folders.map(b=>({folderUri:i.URI.parse(b.folderUri),remoteAuthority:b.remoteAuthority})))}catch{}return I}}),define(le[169],ue([0,1,39,15,10]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var D;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(D||(e.TokenType=D={}));function O(...g){switch(g.length){case 1:return(0,E.localize)(1691,null,g[0]);case 2:return(0,E.localize)(1692,null,g[0],g[1]);case 3:return(0,E.localize)(1693,null,g[0],g[1],g[2]);default:return}}const I=(0,E.localize)(1694,null),b=(0,E.localize)(1695,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return u.isTripleEq?"===":"==";case D.NotEq:return u.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return u.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return u.lexeme;case D.QuotedStr:return u.lexeme;case D.Error:return u.lexeme;case D.EOF:return"EOF";default:throw(0,r.$0)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case i.CharCode.OpenParen:this.k(D.LParen);break;case i.CharCode.CloseParen:this.k(D.RParen);break;case i.CharCode.ExclamationMark:if(this.h(i.CharCode.Equals)){const m=this.h(i.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:m})}else this.k(D.Neg);break;case i.CharCode.SingleQuote:this.o();break;case i.CharCode.Slash:this.q();break;case i.CharCode.Equals:if(this.h(i.CharCode.Equals)){const m=this.h(i.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:m})}else this.h(i.CharCode.Tilde)?this.k(D.RegexOp):this.l(O("==","=~"));break;case i.CharCode.LessThan:this.k(this.h(i.CharCode.Equals)?D.LtEq:D.Lt);break;case i.CharCode.GreaterThan:this.k(this.h(i.CharCode.Equals)?D.GtEq:D.Gt);break;case i.CharCode.Ampersand:this.h(i.CharCode.Ampersand)?this.k(D.And):this.l(O("&&"));break;case i.CharCode.Pipe:this.h(i.CharCode.Pipe)?this.k(D.Or):this.l(O("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?i.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const m=this.d,p=this.c.substring(this.d,this.e),f={type:D.Error,offset:this.d,lexeme:p};this.g.push({offset:m,lexeme:p,additionalInfo:u}),this.f.push(f)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const m=this.c.substring(this.d,this.e),p=l.b.get(m);p?this.k(p):this.f.push({type:D.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==i.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,m=!1,p=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(b);return}const d=this.c.charCodeAt(u);if(m)m=!1;else if(d===i.CharCode.Slash&&!p){u++;break}else d===i.CharCode.OpenSquareBracket?p=!0:d===i.CharCode.Backslash?m=!0:d===i.CharCode.CloseSquareBracket&&(p=!1);u++}for(;u<this.c.length&&l.a.has(this.c.charCodeAt(u));)u++;this.e=u;const f=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=l}),define(le[170],ue([0,1,4,2]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=void 0;class E{constructor(){this.a=new i.$oe,this.b=new i.$oe,this.c=new i.$oe,this.d=new i.$oe}static{this.ChannelName="extensionhostdebugservice"}call(I,b,l){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(I,b,l){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$3o=E;class D extends r.$Xc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,b,l){this.b.call("attach",[I,b,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,b){this.b.call("terminate",[I,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,b){return this.b.call("openExtensionDevelopmentHostWindow",[I,b])}}e.$4o=D}),define(le[171],ue([0,1,165,54,11,9,37,18,7]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=void 0,e.$0m=g,e.$$m=u,e.$8m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,D.$pc)(E.$3g.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,D.$mc)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,I.$jh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$jh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,i.$7m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$mc)(this.userDataPath,"logs",p)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$jh)(b.URI.file((0,D.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$jh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$jh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$jh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=O.env.VSCODE_PORTABLE;return p?b.URI.file((0,D.$mc)(p,"argv.json")):(0,I.$jh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,D.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,D.$nc)(p):(0,D.$kc)((0,D.$mc)(E.$3g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?b.URI.file((0,D.$nc)(p)):b.URI.file((0,D.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,D.$nc)(p);const f=O.env.VSCODE_EXTENSIONS;if(f)return f;const d=O.env.VSCODE_PORTABLE;return d?(0,D.$mc)(d,"extensions"):(0,I.$jh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(f=>/^[^:/?#]+?:\/\//.test(f)?b.URI.parse(f):b.URI.file((0,D.$kc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?b.URI.parse(p):b.URI.file((0,D.$kc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$8m.test(p))}get extensionLogLevel(){const p=[];for(const f of this.args.log||[]){const d=e.$8m.exec(f);d&&d[1]&&d[2]&&p.push([d[1],d[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,I.$jh)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=O.env.VSCODE_PORTABLE;return p?b.URI.file((0,D.$mc)(p,"policy.json")):(0,I.$jh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,f,d){this.a=p,this.b=f,this.c=d,this.editSessionId=this.args.editSessionId}}e.$9m=l,ke([r.$ai],l.prototype,"appRoot",null),ke([r.$ai],l.prototype,"userHome",null),ke([r.$ai],l.prototype,"userDataPath",null),ke([r.$ai],l.prototype,"appSettingsHome",null),ke([r.$ai],l.prototype,"tmpDir",null),ke([r.$ai],l.prototype,"cacheHome",null),ke([r.$ai],l.prototype,"stateResource",null),ke([r.$ai],l.prototype,"userRoamingDataHome",null),ke([r.$ai],l.prototype,"userDataSyncHome",null),ke([r.$ai],l.prototype,"sync",null),ke([r.$ai],l.prototype,"machineSettingsResource",null),ke([r.$ai],l.prototype,"workspaceStorageHome",null),ke([r.$ai],l.prototype,"localHistoryHome",null),ke([r.$ai],l.prototype,"keyboardLayoutResource",null),ke([r.$ai],l.prototype,"argvResource",null),ke([r.$ai],l.prototype,"isExtensionDevelopment",null),ke([r.$ai],l.prototype,"untitledWorkspacesHome",null),ke([r.$ai],l.prototype,"builtinExtensionsPath",null),ke([r.$ai],l.prototype,"extensionsPath",null),ke([r.$ai],l.prototype,"extensionDevelopmentLocationURI",null),ke([r.$ai],l.prototype,"extensionDevelopmentKind",null),ke([r.$ai],l.prototype,"extensionTestsLocationURI",null),ke([r.$ai],l.prototype,"debugExtensionHost",null),ke([r.$ai],l.prototype,"logLevel",null),ke([r.$ai],l.prototype,"extensionLogLevel",null),ke([r.$ai],l.prototype,"serviceMachineIdResource",null),ke([r.$ai],l.prototype,"disableTelemetry",null),ke([r.$ai],l.prototype,"disableWorkspaceTrust",null),ke([r.$ai],l.prototype,"useInMemorySecretStorage",null),ke([r.$ai],l.prototype,"policyFile",null);function g(m,p){return u(m["inspect-extensions"],m["inspect-brk-extensions"],5870,p,m.debugId,m.extensionEnvironment)}function u(m,p,f,d,v,y){const S=Number(p||m)||(d?null:f),k=S?!!p:!1;let s;if(y)try{s=JSON.parse(y)}catch{}return{port:S,break:k,debugId:v,env:s}}});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[123],ue([0,1,283,3,10]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=void 0,e.$Gm=I,e.$Hm=l,e.$Im=p,e.$Jm=f,i=Ve(i);const D={o:(0,E.localize)(1711,null),e:(0,E.localize)(1712,null),t:(0,E.localize)(1713,null)};e.$Em=["tunnel","serve-web"],e.$Fm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(1714,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(1715,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(1716,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(1717,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(1718,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(1719,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(1720,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(1721,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(1722,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(1723,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(1724,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(1725,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(1726,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(1727,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(1728,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(1729,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(1730,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(1731,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(1732,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(1733,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(1734,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(1735,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(1736,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(1737,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(1738,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(1739,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(1740,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(1741,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(1742,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(1743,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(1744,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(1745,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(1746,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(1747,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(1748,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(1749,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(d,v,y=O){const $=d.find(h=>h.length>0&&h[0]!=="-"),S={},k=["_"],s=[],a={};let t;for(const h in v){const P=v[h];P.type==="subcommand"?h===$&&(t=P):(P.alias&&(S[h]=P.alias),P.type==="string"||P.type==="string[]"?(k.push(h),P.deprecates&&k.push(...P.deprecates)):P.type==="boolean"&&(s.push(h),P.deprecates&&s.push(...P.deprecates)),P.global&&(a[h]=P))}if(t&&$){const h=a;for(const L in t.options)h[L]=t.options[L];const P=d.filter(L=>L!==$),w=y.getSubcommandReporter?y.getSubcommandReporter($):void 0,R=I(P,h,w);return{[$]:R,_:[]}}const o=(0,i.default)(d,{string:k,boolean:s,alias:S}),n={},c=o;n._=o._.map(h=>String(h)).filter(h=>h.length>0),delete c._;for(const h in v){const P=v[h];if(P.type==="subcommand")continue;P.alias&&delete c[P.alias];let w=c[h];if(P.deprecates)for(const R of P.deprecates)c.hasOwnProperty(R)&&(w||(w=c[R],w&&y.onDeprecatedOption(R,P.deprecationMessage||(0,E.localize)(1750,null,h))),delete c[R]);if(typeof w<"u"){if(P.type==="string[]"){if(Array.isArray(w)||(w=[w]),!P.allowEmptyValue){const R=w.filter(L=>L.length>0);R.length!==w.length&&(y.onEmptyValue(h),w=R.length>0?R:void 0)}}else P.type==="string"&&(Array.isArray(w)?(w=w.pop(),y.onMultipleValues(h,w)):!w&&!P.allowEmptyValue&&(y.onEmptyValue(h),w=void 0));n[h]=w,P.deprecationMessage&&y.onDeprecatedOption(h,P.deprecationMessage)}delete c[h]}for(const h in c)y.onUnknownOption(h);return n}function b(d,v){let y="";return v.args&&(Array.isArray(v.args)?y=` <${v.args.join("> <")}>`:y=` <${v.args}>`),v.alias?`-${v.alias} --${d}${y}`:`--${d}${y}`}function l(d,v){const y=[];for(const $ in d){const S=d[$],k=b($,S);y.push([k,S.description])}return g(y,v)}function g(d,v){const $=d.reduce((s,a)=>Math.max(s,a[0].length),12)+2+1;if(v-$<25)return d.reduce((s,a)=>s.concat([`  ${a[0]}`,`      ${a[1]}`]),[]);const S=v-$-1,k=[];for(const s of d){const a=s[0],t=m(s[1],S),o=u($-a.length-2);k.push("  "+a+o+t[0]);for(let n=1;n<t.length;n++)k.push(u($)+t[n])}return k}function u(d){return" ".repeat(d)}function m(d,v){const y=[];for(;d.length;){const $=d.length<v?d.length:d.lastIndexOf(" ",v),S=d.slice(0,$).trim();d=d.slice($),y.push(S)}return y}function p(d,v,y,$,S){const k=process.stdout.isTTY&&process.stdout.columns||80,s=S?.noInputFiles!==!0?`[${(0,E.localize)(1751,null)}...]`:"",a=[`${d} ${y}`];a.push(""),a.push(`${(0,E.localize)(1752,null)}: ${v} [${(0,E.localize)(1753,null)}]${s}`),a.push(""),S?.noPipe!==!0&&(r.$j?a.push((0,E.localize)(1754,null,v)):a.push((0,E.localize)(1755,null,v)),a.push(""));const t={},o=[];for(const n in $){const c=$[n];if(c.type==="subcommand")c.description&&o.push({command:n,description:c.description});else if(c.description&&c.cat){let h=t[c.cat];h||(t[c.cat]=h={}),h[n]=c}}for(const n in t){const c=n,h=t[c];h&&(a.push(D[c]),a.push(...l(h,k)),a.push(""))}return o.length&&(a.push((0,E.localize)(1756,null)),a.push(...g(o.map(n=>[n.command,n.description]),k)),a.push("")),a.join(`
`)}function f(d,v){return`${d||(0,E.localize)(1757,null)}
${v||(0,E.localize)(1758,null)}
${process.arch}`}});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[70],ue([0,1,284,10,123]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=I,e.$Lm=b,e.$Mm=l,e.$Nm=g,i=Ve(i);function D(u,m){const p=(S,k)=>{console.warn((0,r.localize)(1759,null,S,k))},f=S=>{console.warn((0,r.localize)(1760,null,S))},d=(S,k)=>{console.warn((0,r.localize)(1761,null,S,k))},v=S=>({onUnknownOption:k=>{E.$Em.includes(S)||console.warn((0,r.localize)(1762,null,k,S))},onMultipleValues:p,onEmptyValue:f,onDeprecatedOption:d,getSubcommandReporter:E.$Em.includes(S)?v:void 0}),y={onUnknownOption:S=>{console.warn((0,r.localize)(1763,null,S))},onMultipleValues:p,onEmptyValue:f,onDeprecatedOption:d,getSubcommandReporter:v},$=(0,E.$Gm)(u,E.$Fm,m?y:void 0);return $.goto&&$._.forEach(S=>(0,i.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(S),(0,r.localize)(1764,null))),$}function O(u){const m=u.findIndex(p=>!/^-/.test(p));if(m>-1)return[...u.slice(0,m),...u.slice(m+1)]}function I(u){let[,...m]=u;process.env.VSCODE_DEV&&(m=O(m)||[]);const p=!g(process.env);return D(m,p)}function b(u){let[,,...m]=u;return process.env.VSCODE_DEV&&(m=O(m)||[]),D(m,!0)}function l(u,...m){const p=u.indexOf("--");return p===-1?u.push(...m):u.splice(p,0,...m),u}function g(u){return u.VSCODE_CLI==="1"}}),function(){function K(e,i,r){function E(O,I){const b=D(O,I),l=[b];return e.isAbsolute(b)||l.unshift(r),e.resolve(...l)}function D(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,I);const g=O["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(u,"AppData","Roaming")}break;case"darwin":l=e.join(i.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,I)}return{getUserDataPath:E}}if(typeof define=="function")define(le[172],ue([97,27,37]),function(e,i,r){return K(e,i,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=K(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[98],ue([0,1,27,171,172]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0,e.$an=O,e.$bn=I;class D extends r.$9m{constructor(l,g){super(l,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,E.getUserDataPath)(l,g.nameShort)},g)}}e.$_m=D;function O(b,l){return(0,r.$$m)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,l,b.extensionEnvironment)}function I(b,l){return(0,r.$$m)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,l,b.extensionEnvironment)}}),define(le[173],ue([0,1,26,27,32]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=D;function D(O){const I=(0,E.$Qg)((0,r.tmpdir)());try{return(0,i.writeFileSync)(I,""),O&&console.log(`Marker file for --wait created: ${I}`),I}catch(b){O&&console.error(`Failed to create marker file for --wait: ${b}`);return}}}),define(le[174],ue([0,1,12,10]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=E;function E(O,I,b,l){try{D(O,I,b,l)}catch(g){O.error(g?.message??g)}return I}function D(O,I,b,l){const g=(u,m,p)=>{const f=u[m];if((0,i.$hg)(f)){const d=f,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const y=d.substr(1,v-2);let $=b[y];$===void 0&&l&&($=l[y]);const S=typeof $=="string"?$:$?.message,k=l?.[y],s=typeof k=="string"?k:k?.message;if(!S){s||O.warn(`[${I.name}]: ${(0,r.localize)(1812,null,y)}`);return}if(p&&(m==="title"||m==="category")&&s&&s!==S){const a={value:S,original:s};u[m]=a}else u[m]=S}}else if((0,i.$jg)(f))for(const d in f)f.hasOwnProperty(d)&&(d==="commands"?g(f,d,!0):g(f,d,p));else if(Array.isArray(f))for(let d=0;d<f.length;d++)g(f,d,p)};for(const u in I)I.hasOwnProperty(u)&&g(I,u)}}),define(le[175],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const i={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(i)}),define(le[84],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class i{constructor(E,D=[],O=!1){this.ctor=E,this.staticArguments=D,this.supportsDelayedInstantiation=O}}e.$Fi=i}),define(le[176],ue([0,1,84]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ws=D,e.$Xs=O;const r=[];var E;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function D(I,b,l){b instanceof i.$Fi||(b=new i.$Fi(b,[],!!l)),r.push([I,b])}function O(){return r}}),define(le[177],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;class i{constructor(D,O){this.key=D,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$zr=i;class r{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const O of this.a.values())O.outgoing.size===0&&D.push(O);return D}insertEdge(D,O){const I=this.lookupOrInsertNode(D),b=this.lookupOrInsertNode(O);I.outgoing.set(b.key,b),b.incoming.set(I.key,I)}removeNode(D){const O=this.b(D);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(D){const O=this.b(D);let I=this.a.get(O);return I||(I=new i(O,D),this.a.set(O,I)),I}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[O,I]of this.a)D.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,O]of this.a){const I=new Set([D]),b=this.c(O,I);if(b)return b}}c(D,O){for(const[I,b]of D.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const l=this.c(b,O);if(l)return l;O.delete(I)}}}e.$Ar=r}),define(le[6],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=E,e.$Ji=D;var i;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(i||(e._util=i={})),e.$Hi=E("instantiationService");function r(O,I,b){I[i.DI_TARGET]===I?I[i.DI_DEPENDENCIES].push({id:O,index:b}):(I[i.DI_DEPENDENCIES]=[{id:O,index:b}],I[i.DI_TARGET]=I)}function E(O){if(i.serviceIds.has(O))return i.serviceIds.get(O);const I=function(b,l,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,b,g)};return I.toString=()=>O,i.serviceIds.set(O,I),I}function D(O){return O}}),define(le[85],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0,e.$Dhc=(0,i.$Ii)("auxiliaryWindowsMainService")}),define(le[71],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0,e.$Lgc=(0,i.$Ii)("backupMainService")}),define(le[16],ue([0,1,12,7,6]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=D,e.$ej=O,e.$fj=b,e.$gj=l,e.$hj=g,e.$ij=u,e.$jj=m,e.$kj=f,e.$lj=d,e.$mj=v,i=Ie(i),e.$cj=(0,E.$Ii)("configurationService");function D(y){return y&&typeof y=="object"&&(!y.overrideIdentifier||typeof y.overrideIdentifier=="string")&&(!y.resource||y.resource instanceof r.URI)}function O(y){return y&&typeof y=="object"&&(!y.overrideIdentifiers||Array.isArray(y.overrideIdentifiers))&&!y.overrideIdentifier&&(!y.resource||y.resource instanceof r.URI)}var I;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.USER=2]="USER",y[y.USER_LOCAL=3]="USER_LOCAL",y[y.USER_REMOTE=4]="USER_REMOTE",y[y.WORKSPACE=5]="WORKSPACE",y[y.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",y[y.DEFAULT=7]="DEFAULT",y[y.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function b(y){switch(y){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function l(y){return y.applicationValue!==void 0||y.userValue!==void 0||y.userLocalValue!==void 0||y.userRemoteValue!==void 0||y.workspaceValue!==void 0||y.workspaceFolderValue!==void 0}function g(y,$){const S=Object.create(null);for(const k in y)u(S,k,y[k],$);return S}function u(y,$,S,k){const s=$.split("."),a=s.pop();let t=y;for(let o=0;o<s.length;o++){const n=s[o];let c=t[n];switch(typeof c){case"undefined":c=t[n]=Object.create(null);break;case"object":if(c===null){k(`Ignoring ${$} as ${s.slice(0,o+1).join(".")} is null`);return}break;default:k(`Ignoring ${$} as ${s.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}t=c}if(typeof t=="object"&&t!==null)try{t[a]=S}catch{k(`Ignoring ${$} as ${s.join(".")} is ${JSON.stringify(t)}`)}else k(`Ignoring ${$} as ${s.join(".")} is ${JSON.stringify(t)}`)}function m(y,$){const S=$.split(".");p(y,S)}function p(y,$){const S=$.shift();if($.length===0){delete y[S];return}if(Object.keys(y).indexOf(S)!==-1){const k=y[S];typeof k=="object"&&!Array.isArray(k)&&(p(k,$),Object.keys(k).length===0&&delete y[S])}}function f(y,$,S){function k(t,o){let n=t;for(const c of o){if(typeof n!="object"||n===null)return;n=n[c]}return n}const s=$.split("."),a=k(y,s);return typeof a>"u"?S:a}function d(y,$,S){Object.keys($).forEach(k=>{k!=="__proto__"&&(k in y?i.$jg(y[k])&&i.$jg($[k])?d(y[k],$[k],S):S&&(y[k]=$[k]):y[k]=$[k])})}function v(y){return y.replace(/[\[\]]/g,"")}}),define(le[124],ue([0,1,39,3,25,169,6,10,15]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=g,e.$Hj=o,e.$Ij=n,e.$2j=V;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",r.$k),l.set("isLinux",r.$l),l.set("isWindows",r.$j),l.set("isWeb",r.$p),l.set("isMacNative",r.$k&&!r.$p),l.set("isEdge",r.$I),l.set("isFirefox",r.$G),l.set("isChrome",r.$F),l.set("isSafari",r.$H);function g(Y,M){if(l.get(Y)!==void 0)throw(0,b.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(Y,M)}const u=Object.prototype.hasOwnProperty;var m;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const p={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(1671,null),d=(0,I.localize)(1672,null),v=(0,I.localize)(1673,null),y=(0,I.localize)(1674,null),$=(0,I.localize)(1675,null),S=(0,I.localize)(1676,null),k=(0,I.localize)(1677,null),s=(0,I.localize)(1678,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=p){this.k=M,this.d=new D.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const Z=this.l();if(!this.E()){const U=this.D(),N=U.type===D.TokenType.Str?S:void 0;throw this.h.push({message:$,offset:U.offset,lexeme:D.$Dj.getLexeme(U),additionalInfo:N}),a.c}return Z}catch(Z){if(Z!==a.c)throw Z;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(D.TokenType.Or);){const Z=this.o();M.push(Z)}return M.length===1?M[0]:t.or(...M)}o(){const M=[this.s()];for(;this.y(D.TokenType.And);){const Z=this.s();M.push(Z)}return M.length===1?M[0]:t.and(...M)}s(){if(this.y(D.TokenType.Neg)){const M=this.D();switch(M.type){case D.TokenType.True:return this.z(),h.INSTANCE;case D.TokenType.False:return this.z(),P.INSTANCE;case D.TokenType.LParen:{this.z();const Z=this.l();return this.A(D.TokenType.RParen,y),Z?.negate()}case D.TokenType.Str:return this.z(),j.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case D.TokenType.True:return this.z(),t.true();case D.TokenType.False:return this.z(),t.false();case D.TokenType.LParen:{this.z();const Z=this.l();return this.A(D.TokenType.RParen,y),Z}case D.TokenType.Str:{const Z=M.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==D.TokenType.RegexStr)throw this.B("REGEX",N);const ie=N.lexeme,X=ie.lastIndexOf("/"),z=X===ie.length-1?void 0:this.w(ie.substring(X+1));let te;try{te=new RegExp(ie.substring(1,X),z)}catch{throw this.B("REGEX",N)}return J.create(Z,te)}switch(N.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const ie=[N.lexeme];this.z();let X=this.D(),z=0;for(let ye=0;ye<N.lexeme.length;ye++)N.lexeme.charCodeAt(ye)===i.CharCode.OpenParen?z++:N.lexeme.charCodeAt(ye)===i.CharCode.CloseParen&&z--;for(;!this.E()&&X.type!==D.TokenType.And&&X.type!==D.TokenType.Or;){switch(X.type){case D.TokenType.LParen:z++;break;case D.TokenType.RParen:z--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let ye=0;ye<X.lexeme.length;ye++)X.lexeme.charCodeAt(ye)===i.CharCode.OpenParen?z++:N.lexeme.charCodeAt(ye)===i.CharCode.CloseParen&&z--}if(z<0)break;ie.push(D.$Dj.getLexeme(X)),this.z(),X=this.D()}const te=ie.join(""),ae=te.lastIndexOf("/"),me=ae===te.length-1?void 0:this.w(te.substring(ae+1));let be;try{be=new RegExp(te.substring(1,ae),me)}catch{throw this.B("REGEX",N)}return t.regex(Z,be)}case D.TokenType.QuotedStr:{const ie=N.lexeme;this.z();let X=null;if(!(0,E.$ff)(ie)){const z=ie.indexOf("/"),te=ie.lastIndexOf("/");if(z!==te&&z>=0){const ae=ie.slice(z+1,te),me=ie[te+1]==="i"?"i":"";try{X=new RegExp(ae,me)}catch{throw this.B("REGEX",N)}}}if(X===null)throw this.B("REGEX",N);return J.create(Z,X)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,v);const N=this.u();return t.notIn(Z,N)}switch(this.D().type){case D.TokenType.Eq:{this.z();const N=this.u();if(this.x().type===D.TokenType.QuotedStr)return t.equals(Z,N);switch(N){case"true":return t.has(Z);case"false":return t.not(Z);default:return t.equals(Z,N)}}case D.TokenType.NotEq:{this.z();const N=this.u();if(this.x().type===D.TokenType.QuotedStr)return t.notEquals(Z,N);switch(N){case"true":return t.not(Z);case"false":return t.has(Z);default:return t.notEquals(Z,N)}}case D.TokenType.Lt:return this.z(),de.create(Z,this.u());case D.TokenType.LtEq:return this.z(),x.create(Z,this.u());case D.TokenType.Gt:return this.z(),q.create(Z,this.u());case D.TokenType.GtEq:return this.z(),Q.create(Z,this.u());case D.TokenType.In:return this.z(),t.in(Z,this.u());default:return t.has(Z)}}case D.TokenType.EOF:throw this.h.push({message:k,offset:M.offset,lexeme:"",additionalInfo:s}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),M.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,Z){if(this.C(M))return this.z();throw this.B(Z,this.D())}B(M,Z,U){const N=(0,I.localize)(1679,null,M,D.$Dj.getLexeme(Z)),ie=Z.offset,X=D.$Dj.getLexeme(Z);return this.h.push({message:N,offset:ie,lexeme:X,additionalInfo:U}),a.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$Fj=a;class t{static false(){return h.INSTANCE}static true(){return P.INSTANCE}static has(M){return w.create(M)}static equals(M,Z){return R.create(M,Z)}static notEquals(M,Z){return T.create(M,Z)}static regex(M,Z){return J.create(M,Z)}static in(M,Z){return L.create(M,Z)}static notIn(M,Z){return A.create(M,Z)}static not(M){return j.create(M)}static and(...M){return C.create(M,null,!0)}static or(...M){return W.create(M,null,!0)}static greater(M,Z){return q.create(M,Z)}static greaterEquals(M,Z){return Q.create(M,Z)}static smaller(M,Z){return de.create(M,Z)}static smallerEquals(M,Z){return x.create(M,Z)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Gj=t;function o(Y){const M=new a({regexParsingWithErrorRecovery:!1});return Y.map(Z=>(M.parse(Z),M.lexingErrors.length>0?M.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,I.localize)(1680,null,U.additionalInfo):(0,I.localize)(1681,null),offset:U.offset,length:U.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function n(Y,M){const Z=Y?Y.substituteConstants():void 0,U=M?M.substituteConstants():void 0;return!Z&&!U?!0:!Z||!U?!1:Z.equals(U)}function c(Y,M){return Y.cmp(M)}class h{static{this.INSTANCE=new h}constructor(){this.type=m.False}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return P.INSTANCE}}e.$Jj=h;class P{static{this.INSTANCE=new P}constructor(){this.type=m.True}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return h.INSTANCE}}e.$Kj=P;class w{static create(M,Z=null){const U=l.get(M);return typeof U=="boolean"?U?P.INSTANCE:h.INSTANCE:new w(M,Z)}constructor(M,Z){this.key=M,this.c=Z,this.type=m.Defined}cmp(M){return M.type!==this.type?this.type-M.type:H(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=l.get(this.key);return typeof M=="boolean"?M?P.INSTANCE:h.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Lj=w;class R{static create(M,Z,U=null){if(typeof Z=="boolean")return Z?w.create(M,U):j.create(M,U);const N=l.get(M);return typeof N=="boolean"?Z===(N?"true":"false")?P.INSTANCE:h.INSTANCE:new R(M,Z,U)}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=m.Equals}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=l.get(this.c);if(typeof M=="boolean"){const Z=M?"true":"false";return this.d===Z?P.INSTANCE:h.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Mj=R;class L{static create(M,Z){return new L(M,Z)}constructor(M,Z){this.d=M,this.f=Z,this.type=m.In,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const Z=M.getValue(this.f),U=M.getValue(this.d);return Array.isArray(Z)?Z.includes(U):typeof U=="string"&&typeof Z=="object"&&Z!==null?u.call(Z,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Nj=L;class A{static create(M,Z){return new A(M,Z)}constructor(M,Z){this.d=M,this.f=Z,this.type=m.NotIn,this.c=L.create(M,Z)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=A;class T{static create(M,Z,U=null){if(typeof Z=="boolean")return Z?j.create(M,U):w.create(M,U);const N=l.get(M);return typeof N=="boolean"?Z===(N?"true":"false")?h.INSTANCE:P.INSTANCE:new T(M,Z,U)}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=m.NotEquals}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=l.get(this.c);if(typeof M=="boolean"){const Z=M?"true":"false";return this.d===Z?h.INSTANCE:P.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Pj=T;class j{static create(M,Z=null){const U=l.get(M);return typeof U=="boolean"?U?h.INSTANCE:P.INSTANCE:new j(M,Z)}constructor(M,Z){this.c=M,this.d=Z,this.type=m.Not}cmp(M){return M.type!==this.type?this.type-M.type:H(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=l.get(this.c);return typeof M=="boolean"?M?h.INSTANCE:P.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Qj=j;function G(Y,M){if(typeof Y=="string"){const Z=parseFloat(Y);isNaN(Z)||(Y=Z)}return typeof Y=="string"||typeof Y=="number"?M(Y):h.INSTANCE}class q{static create(M,Z,U=null){return G(Z,N=>new q(M,N,U))}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=m.Greater}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Rj=q;class Q{static create(M,Z,U=null){return G(Z,N=>new Q(M,N,U))}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=m.GreaterEquals}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=de.create(this.c,this.d,this)),this.f}}e.$Sj=Q;class de{static create(M,Z,U=null){return G(Z,N=>new de(M,N,U))}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=m.Smaller}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Tj=de;class x{static create(M,Z,U=null){return G(Z,N=>new x(M,N,U))}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=m.SmallerEquals}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Uj=x;class J{static create(M,Z){return new J(M,Z)}constructor(M,Z){this.d=M,this.f=Z,this.type=m.Regex,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const Z=this.f?this.f.source:"",U=M.f?M.f.source:"";return Z<U?-1:Z>U?1:0}equals(M){if(M.type===this.type){const Z=this.f?this.f.source:"",U=M.f?M.f.source:"";return this.d===M.d&&Z===U}return!1}substituteConstants(){return this}evaluate(M){const Z=M.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Vj=J;class B{static create(M){return new B(M)}constructor(M){this.c=M,this.type=m.NotRegex}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new B(this.c.map(M))}negate(){return this.c}}e.$Wj=B;function _(Y){let M=null;for(let Z=0,U=Y.length;Z<U;Z++){const N=Y[Z].substituteConstants();if(Y[Z]!==N&&M===null){M=[];for(let ie=0;ie<Z;ie++)M[ie]=Y[ie]}M!==null&&(M[Z]=N)}return M===null?Y:M}class C{static create(M,Z,U){return C.d(M,Z,U)}constructor(M,Z){this.expr=M,this.c=Z,this.type=m.And}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Z=0,U=this.expr.length;Z<U;Z++){const N=c(this.expr[Z],M.expr[Z]);if(N!==0)return N}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Z=0,U=this.expr.length;Z<U;Z++)if(!this.expr[Z].equals(M.expr[Z]))return!1;return!0}return!1}substituteConstants(){const M=_(this.expr);return M===this.expr?this:C.create(M,this.c,!1)}evaluate(M){for(let Z=0,U=this.expr.length;Z<U;Z++)if(!this.expr[Z].evaluate(M))return!1;return!0}static d(M,Z,U){const N=[];let ie=!1;for(const X of M)if(X){if(X.type===m.True){ie=!0;continue}if(X.type===m.False)return h.INSTANCE;if(X.type===m.And){N.push(...X.expr);continue}N.push(X)}if(N.length===0&&ie)return P.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(c);for(let X=1;X<N.length;X++)N[X-1].equals(N[X])&&(N.splice(X,1),X--);if(N.length===1)return N[0];for(;N.length>1;){const X=N[N.length-1];if(X.type!==m.Or)break;N.pop();const z=N.pop(),te=N.length===0,ae=W.create(X.expr.map(me=>C.create([me,z],null,U)),null,te);ae&&(N.push(ae),N.sort(c))}if(N.length===1)return N[0];if(U){for(let X=0;X<N.length;X++)for(let z=X+1;z<N.length;z++)if(N[X].negate().equals(N[z]))return h.INSTANCE;if(N.length===1)return N[0]}return new C(N,Z)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const Z of this.expr)M.push(...Z.keys());return M}map(M){return new C(this.expr.map(Z=>Z.map(M)),null)}negate(){if(!this.c){const M=[];for(const Z of this.expr)M.push(Z.negate());this.c=W.create(M,this,!0)}return this.c}}e.$Xj=C;class W{static create(M,Z,U){return W.d(M,Z,U)}constructor(M,Z){this.expr=M,this.c=Z,this.type=m.Or}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Z=0,U=this.expr.length;Z<U;Z++){const N=c(this.expr[Z],M.expr[Z]);if(N!==0)return N}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Z=0,U=this.expr.length;Z<U;Z++)if(!this.expr[Z].equals(M.expr[Z]))return!1;return!0}return!1}substituteConstants(){const M=_(this.expr);return M===this.expr?this:W.create(M,this.c,!1)}evaluate(M){for(let Z=0,U=this.expr.length;Z<U;Z++)if(this.expr[Z].evaluate(M))return!0;return!1}static d(M,Z,U){let N=[],ie=!1;if(M){for(let X=0,z=M.length;X<z;X++){const te=M[X];if(te){if(te.type===m.False){ie=!0;continue}if(te.type===m.True)return P.INSTANCE;if(te.type===m.Or){N=N.concat(te.expr);continue}N.push(te)}}if(N.length===0&&ie)return h.INSTANCE;N.sort(c)}if(N.length!==0){if(N.length===1)return N[0];for(let X=1;X<N.length;X++)N[X-1].equals(N[X])&&(N.splice(X,1),X--);if(N.length===1)return N[0];if(U){for(let X=0;X<N.length;X++)for(let z=X+1;z<N.length;z++)if(N[X].negate().equals(N[z]))return P.INSTANCE;if(N.length===1)return N[0]}return new W(N,Z)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const Z of this.expr)M.push(...Z.keys());return M}map(M){return new W(this.expr.map(Z=>Z.map(M)),null)}negate(){if(!this.c){const M=[];for(const Z of this.expr)M.push(Z.negate());for(;M.length>1;){const Z=M.shift(),U=M.shift(),N=[];for(const ie of oe(Z))for(const X of oe(U))N.push(C.create([ie,X],null,!1));M.unshift(W.create(N,null,!1))}this.c=W.create(M,this,!0)}return this.c}}e.$Yj=W;class F extends w{static{this.d=[]}static all(){return F.d.values()}constructor(M,Z,U){super(M,null),this.f=Z,typeof U=="object"?F.d.push({...U,key:M}):U!==!0&&F.d.push({key:M,description:U,type:Z!=null?typeof Z:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return R.create(this.key,M)}notEqualsTo(M){return T.create(this.key,M)}}e.$Zj=F,e.$1j=(0,O.$Ii)("contextKeyService");function H(Y,M){return Y<M?-1:Y>M?1:0}function ne(Y,M,Z,U){return Y<Z?-1:Y>Z?1:M<U?-1:M>U?1:0}function V(Y,M){if(Y.type===m.False||M.type===m.True)return!0;if(Y.type===m.Or)return M.type===m.Or?ce(Y.expr,M.expr):!1;if(M.type===m.Or){for(const Z of M.expr)if(V(Y,Z))return!0;return!1}if(Y.type===m.And){if(M.type===m.And)return ce(M.expr,Y.expr);for(const Z of Y.expr)if(V(Z,M))return!0;return!1}return Y.equals(M)}function ce(Y,M){let Z=0,U=0;for(;Z<Y.length&&U<M.length;){const N=Y[Z].cmp(M[U]);if(N<0)return!1;N===0&&Z++,U++}return Z===Y.length}function oe(Y){return Y.type===m.Or?Y.expr:[Y]}}),define(le[99],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Wm=e.ID=void 0,e.$Xm=r,e.ID="diagnosticsService",e.$Wm=(0,i.$Ii)(e.ID);function r(D){return!!D.hostName&&!!D.errorMessage}class E{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Ym=E});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[125],ue([0,1,18,82,10,6,48,3,38]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$fx=e.$ex=e.$dx=void 0,e.$gx=p,e.$hx=f,r=Ve(r),e.$dx=(0,D.$Ii)("dialogService");var l;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(l||(l={}));class g{a(v){return this.d(v,l.Confirmation)}b(v){return this.d(v,l.Prompt)}c(v){return this.d(v,l.Input)}d(v,y){const $=[];switch(y){case l.Confirmation:{const S=v;S.primaryButton?$.push(S.primaryButton):$.push((0,E.localize)(1696,null)),S.cancelButton?$.push(S.cancelButton):$.push((0,E.localize)(1697,null));break}case l.Prompt:{const S=v;Array.isArray(S.buttons)&&S.buttons.length>0&&$.push(...S.buttons.map(k=>k.label)),S.cancelButton&&(S.cancelButton===!0?$.push((0,E.localize)(1698,null)):typeof S.cancelButton=="string"?$.push(S.cancelButton):S.cancelButton.label?$.push(S.cancelButton.label):$.push((0,E.localize)(1699,null))),$.length===0&&$.push((0,E.localize)(1700,null));break}case l.Input:{const S=v;S.primaryButton?$.push(S.primaryButton):$.push((0,E.localize)(1701,null)),S.cancelButton?$.push(S.cancelButton):$.push((0,E.localize)(1702,null));break}}return $}e(v){if(typeof v=="string")return v;if(typeof v=="number")return v===r.default.Info?"info":v===r.default.Error?"error":v===r.default.Warning?"warning":"none"}f(v,y,$){const S=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&S.push(v.cancelButton);let k=S[y]?.run({checkboxChecked:$});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:$}}}e.$ex=g,e.$fx=(0,D.$Ii)("fileDialogService");var u;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(u||(e.ConfirmResult=u={}));const m=10;function p(d){const v=[];return v.push(...d.slice(0,m).map(y=>typeof y=="string"?y:(0,i.$gh)(y))),d.length>m&&(d.length-m===1?v.push((0,E.localize)(1703,null)):v.push((0,E.localize)(1704,null,d.length-m))),v.push(""),v.join(`
`)}function f(d,v){const y=(0,b.$ho)(d);let $=(y.buttons??[]).map(a=>(0,O.$ax)(a)),S=(d.buttons||[]).map((a,t)=>t),k=0,s=y.cancelId??$.length-1;if($.length>1){const a=typeof s=="number"?$[s]:void 0;if(I.$l||I.$k){if(typeof a=="string"&&$.length>1&&s!==1){$.splice(s,1),$.splice(1,0,a);const t=S[s];S.splice(s,1),S.splice(1,0,t),s=1}I.$l&&$.length>1&&($=$.reverse(),S=S.reverse(),k=$.length-1,typeof a=="string"&&(s=k-1))}else if(I.$j&&typeof a=="string"&&$.length>1&&s!==$.length-1){$.splice(s,1),$.push(a);const t=S[s];S.splice(s,1),S.push(t),s=$.length-1}}return y.buttons=$,y.defaultId=k,y.cancelId=s,y.noLink=!0,y.title=y.title||v.nameLong,{options:y,buttonIndeces:S}}}),define(le[100],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$1Y=e.$ZY=void 0,e.$2Y=D,e.$3Y=O,e.$ZY=(0,i.$Ii)("encryptionService"),e.$1Y=(0,i.$Ii)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var E;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(E||(e.KnownStorageProvider=E={}));function D(I){return I===E.kwallet||I===E.kwallet5||I===E.kwallet6}function O(I){return I===E.gnomeAny||I===E.gnomeLibsecret||I===E.gnomeKeyring}}),define(le[36],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,i.$Ii)("environmentService"),e.$Qi=(0,i.$Ji)(e.$Pi)}),define(le[178],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=void 0,e.$shc=(0,i.$Ii)("extensionHostStarter"),e.$thc="extensionHostStarter"}),define(le[179],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=e.$A$b=void 0,e.$A$b=(0,i.$Ii)("externalTerminal"),e.$B$b="Terminal.app"}),define(le[180],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0,e.$vhc=(0,i.$Ii)("externalTerminal")}),define(le[181],ue([0,1,44,54,11,9,3,80,23,96,10,179]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=e.$whc=void 0,i=Ie(i),D=Ie(D),O=Ie(O),b=Ie(b),l=Ie(l),g=Ie(g);const m=g.localize(1849,null);class p{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends p{static{this.b="cmd.exe"}openTerminal(s,a){return this.spawnTerminal(i,s,l.$Bm(),a)}spawnTerminal(s,a,t,o){const n=a.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=D.$qc(n,".exe").toLowerCase();if(c==="cmder")return s.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return n.indexOf(" ")>=0&&h.push(n),h.push(n),c==="wt"&&h.push("-d ."),new Promise((P,w)=>{const R=y(process),L=s.spawn(t,h,{cwd:o,env:R,detached:!0});L.on("error",w),L.on("exit",()=>P())})}async runInTerminal(s,a,t,o,n){const c="windowsExec"in n&&n.windowsExec?n.windowsExec:f.getDefaultTerminalWindows(),h=await f.f();return new Promise((P,w)=>{const R=`"${a} - ${m}"`,L=`"${t.join('" "')}" & pause`,A=Object.assign({},y(process),o);Object.keys(A).filter(Q=>A[Q]===null).forEach(Q=>delete A[Q]);const T={cwd:a,env:A,windowsVerbatimArguments:!0};let j,G;D.$qc(c,".exe")==="wt"?(j=c,G=["-d",".",f.b,"/c",L]):h?(j=h,G=["-d",".",c,"/c",L]):(j=f.b,G=["/c","start",R,"/wait",c,"/c",`"${L}"`]),i.spawn(j,G,T).on("error",Q=>{w($(Q))}),P(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const s=await l.win32.findExecutable("wt");return await b.Promises.exists(s)?s:void 0}catch{return}}}e.$whc=f,ke([r.$ai],f,"f",null);class d extends p{static{this.b="/usr/bin/osascript"}openTerminal(s,a){return this.spawnTerminal(i,s,a)}runInTerminal(s,a,t,o,n){const c=n.osxExec||u.$B$b;return new Promise((h,P)=>{if(c===u.$B$b||c==="iTerm.app"){const w=c===u.$B$b?"TerminalHelper":"iTermHelper",L=[E.$3g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`).fsPath,"-t",s||m,"-w",a];for(const j of t)L.push("-a"),L.push(j);if(o){const j=Object.assign({},y(process),o);for(const G in j){const q=j[G];q===null?(L.push("-u"),L.push(G)):(L.push("-e"),L.push(`${G}=${q}`))}}let A="";const T=i.spawn(d.b,L);T.on("error",j=>{P($(j))}),T.stderr.on("data",j=>{A+=j.toString()}),T.on("exit",j=>{if(j===0)h(void 0);else if(A){const G=A.split(`
`,1);P(new Error(G[0]))}else P(new Error(g.localize(1850,null,w,j)))})}else P(new Error(g.localize(1851,null,c)))})}spawnTerminal(s,a,t){const o=a.osxExec||u.$B$b;return new Promise((n,c)=>{const h=["-a",o];t&&h.push(t);const P=y(process),w=s.spawn("/usr/bin/open",h,{cwd:t,env:P});w.on("error",c),w.on("exit",()=>n())})}}e.$xhc=d;class v extends p{static{this.b=g.localize(1852,null)}openTerminal(s,a){return this.spawnTerminal(i,s,a)}runInTerminal(s,a,t,o,n){const c=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((h,P)=>{const w=[];c.then(R=>{R.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const L=`${S(t)}; echo; read -p "${v.b}" -n1;`;w.push(`''${L}''`);const A=Object.assign({},y(process),o);Object.keys(A).filter(q=>A[q]===null).forEach(q=>delete A[q]);const T={cwd:a,env:A};let j="";const G=i.spawn(R,w,T);G.on("error",q=>{P($(q))}),G.stderr.on("data",q=>{j+=q.toString()}),G.on("exit",q=>{if(q===0)h(void 0);else if(j){const Q=j.split(`
`,1);P(new Error(Q[0]))}else P(new Error(g.localize(1853,null,R,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!O.$l)v.d=Promise.resolve("xterm");else{const s=await b.Promises.exists("/etc/debian_version");v.d=new Promise(a=>{s?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return v.d}spawnTerminal(s,a,t){const o=a.linuxExec?Promise.resolve(a.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{o.then(h=>{const P=y(process),w=s.spawn(h,[],{cwd:t,env:P});w.on("error",c),w.on("exit",()=>n())})})}}e.$yhc=v;function y(k){const s={...k.env};return(0,I.$om)(s),s}function $(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(g.localize(1854,null,k.path)):k}function S(k){let s="";for(const a of k)a.indexOf(" ")>=0?s+='"'+a+'"':s+=a,s+=" ";return s}}),define(le[14],ue([0,1,61,9,25,12,7,10,6,3,11,68]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=m,e.$fl=v,e.$gl=$,e.$hl=S,e.$il=k,e.$jl=s,e.$kl=a,e.$ll=t,e.$ml=o,e.$nl=n,e.$ol=c,e.$ql=w,e.$rl=R,e.$sl=L,e.$tl=A,e.$ul=T,e.$xl=de,e.$Jl=W,e.$Kl=F,e.$Ml=ne,e.$dl=(0,b.$Ii)("fileService");function m(V){return V.create===!0}var p;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var f;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var d;(function(V){V[V.UPDATED=2]="UPDATED",V[V.ADDED=4]="ADDED",V[V.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function v(V){const ce=V;return!!ce&&typeof ce.onDidChange=="function"}var y;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function $(V){return!!(V.capabilities&y.FileReadWrite)}function S(V){return!!(V.capabilities&y.FileFolderCopy)}function k(V){return!!(V.capabilities&y.FileClone)}function s(V){return!!(V.capabilities&y.FileOpenReadWriteClose)}function a(V){return!!(V.capabilities&y.FileReadStream)}function t(V){return $(V)?!!(V.capabilities&y.FileAtomicRead):!1}function o(V){return $(V)?!!(V.capabilities&y.FileAtomicWrite):!1}function n(V){return!!(V.capabilities&y.FileAtomicDelete)}function c(V){return!!(V.capabilities&y.Readonly)}var h;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class P extends Error{static create(ce,oe){const Y=new P(ce.toString(),oe);return L(Y,oe),Y}constructor(ce,oe){super(ce),this.code=oe}}e.$pl=P;function w(V,ce){return P.create(V,ce)}function R(V){return V||w((0,I.localize)(1863,null),h.Unknown)}function L(V,ce){return V.name=ce?`${ce} (FileSystemError)`:"FileSystemError",V}function A(V){if(!V)return h.Unknown;if(V instanceof P)return V.code;const ce=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!ce)return h.Unknown;switch(ce[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function T(V){if(V instanceof x)return V.fileOperationResult;switch(A(V)){case h.FileNotFound:return _.FILE_NOT_FOUND;case h.FileIsADirectory:return _.FILE_IS_DIRECTORY;case h.FileNotADirectory:return _.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return _.FILE_WRITE_LOCKED;case h.NoPermissions:return _.FILE_PERMISSION_DENIED;case h.FileExists:return _.FILE_MOVE_CONFLICT;case h.FileTooLarge:return _.FILE_TOO_LARGE;default:return _.FILE_OTHER_ERROR}}var j;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class G{constructor(ce,oe,Y){this.resource=ce,this.operation=oe,this.target=Y}isOperation(ce){return this.operation===ce}}e.$vl=G;var q;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class Q{static{this.a=null}constructor(ce,oe){this.c=oe,this.b=void 0,this.d=new u.$W(()=>{const Y=i.$Oi.forUris(()=>this.c);return Y.fill(this.rawAdded.map(M=>[M,!0])),Y}),this.f=new u.$W(()=>{const Y=i.$Oi.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(M=>[M,!0])),Y}),this.g=new u.$W(()=>{const Y=i.$Oi.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(M=>[M,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ce){switch(Y.type){case q.ADDED:this.rawAdded.push(Y.resource);break;case q.UPDATED:this.rawUpdated.push(Y.resource);break;case q.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==Q.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=Q.a):this.b!==void 0&&(this.b=Q.a))}}contains(ce,...oe){return this.h(ce,{includeChildren:!1},...oe)}affects(ce,...oe){return this.h(ce,{includeChildren:!0},...oe)}h(ce,oe,...Y){if(!ce)return!1;const M=Y.length>0;return!!((!M||Y.includes(q.ADDED))&&(this.d.value.get(ce)||oe.includeChildren&&this.d.value.findSuperstr(ce))||(!M||Y.includes(q.UPDATED))&&(this.f.value.get(ce)||oe.includeChildren&&this.f.value.findSuperstr(ce))||(!M||Y.includes(q.DELETED))&&(this.g.value.findSubstr(ce)||oe.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$wl=Q;function de(V,ce,oe){return!V||!ce||V===ce||ce.length>V.length?!1:(ce.charAt(ce.length-1)!==r.sep&&(ce+=r.sep),oe?(0,E.$Jf)(V,ce):V.indexOf(ce)===0)}class x extends Error{constructor(ce,oe,Y){super(ce),this.fileOperationResult=oe,this.options=Y}}e.$yl=x;class J extends x{constructor(ce,oe,Y,M){super(ce,oe,M),this.fileOperationResult=oe,this.size=Y}}e.$zl=J;class B extends x{constructor(ce,oe,Y){super(ce,_.FILE_NOT_MODIFIED_SINCE,Y),this.stat=oe}}e.$Al=B;var _;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(_||(e.FileOperationResult=_={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var C;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(C||(e.FileKind=C={})),e.$Il="";function W(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}async function F(V,ce){if(!ce.hasProvider(O.URI.from({scheme:V.scheme})))return new Promise(oe=>{const Y=ce.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===V.scheme&&M.added&&(Y.dispose(),oe())})})}class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(ce){return(0,D.$lg)(ce)||(ce=0),ce<H.KB?(0,I.localize)(1864,null,ce.toFixed(0)):ce<H.MB?(0,I.localize)(1865,null,(ce/H.KB).toFixed(2)):ce<H.GB?(0,I.localize)(1866,null,(ce/H.MB).toFixed(2)):ce<H.TB?(0,I.localize)(1867,null,(ce/H.GB).toFixed(2)):(0,I.localize)(1868,null,(ce/H.TB).toFixed(2))}}e.$Ll=H;function ne(V){const ce=typeof V=="string"||V?.scheme===g.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===g.Schemas.file?1024*H.MB:ce?10*H.MB:l.$p?50*H.MB:1024*H.MB}}),define(le[126],ue([0,1,17,15,10,14]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=O;async function O(g,u,m,p,f,d){let v;try{await I(g,u,m,p,f,d)}catch(y){v=y}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&m.error(v),m.end()}}async function I(g,u,m,p,f,d){b(d);const v=await g.open(u,{create:!1});try{b(d);let y=0,$=0,S=f&&typeof f.length=="number"?f.length:void 0,k=i.$Qe.alloc(Math.min(f.bufferSize,typeof S=="number"?S:f.bufferSize)),s=f&&typeof f.position=="number"?f.position:0,a=0;do $=await g.read(v,s,k.buffer,a,k.byteLength-a),s+=$,a+=$,y+=$,typeof S=="number"&&(S-=$),a===k.byteLength&&(await m.write(p(k)),k=i.$Qe.alloc(Math.min(f.bufferSize,typeof S=="number"?S:f.bufferSize)),a=0);while($>0&&(typeof S!="number"||S>0)&&b(d)&&l(y,f));if(a>0){let t=a;typeof S=="number"&&(t=Math.min(a,S)),m.write(p(k.slice(0,t)))}}catch(y){throw(0,D.$rl)(y)}finally{await g.close(v)}}function b(g){if(g.isCancellationRequested)throw(0,r.$8)();return!0}function l(g,u){if(typeof u?.limits?.size=="number"&&g>u.limits.size)throw(0,D.$ql)((0,E.localize)(1896,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[62],ue([0,1,114,2,9,3,7,14]),function(K,e,i,r,E,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=void 0,e.$9q=b,e.$0q=l,e.$br=p,e.$cr=f,e.$dr=d,e.$er=v,e.$fr=$,e.$gr=S;function b(k){return typeof k.correlationId=="number"}function l(k){return k.recursive===!0}class g extends r.$Xc{static{this.a=5}constructor(s,a,t,o){super(),this.h=s,this.j=a,this.m=t,this.n=o,this.c=this.B(new r.$Yc),this.f=void 0,this.g=0}s(){const s=new r.$Wc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(a=>this.h(a))),s.add(this.b.onDidLogMessage(a=>this.j(a))),s.add(this.b.onDidError(a=>this.t(a.error,a.request)))}t(s,a){this.u(s,a)?this.g<g.a&&this.f?(this.y(`restarting watcher after unexpected error: ${s}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${s}`):this.y(s)}u(s,a){return!(!this.n.restartOnError||a||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}w(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}y(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}z(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$$q=g;class u extends g{constructor(s,a,t){super(s,a,t,{type:"node.js",restartOnError:!1})}}e.$_q=u;class m extends g{constructor(s,a,t){super(s,a,t,{type:"universal",restartOnError:!0})}}e.$ar=m;function p(k){return k.map(s=>({type:s.type,resource:O.URI.revive(s.resource),cId:s.cId}))}function f(k){const s=new y;for(const a of k)s.processEvent(a);return s.coalesce()}function d(k,s){return typeof s=="string"&&!s.startsWith(i.$zk)&&!(0,E.$lc)(s)?{base:k,pattern:s}:s}function v(k,s){const a=[];for(const t of s)a.push((0,i.$Dk)(d(k,t)));return a}class y{constructor(){this.a=new Set,this.b=new Map}c(s){return D.$l?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const a=this.b.get(this.c(s));let t=!1;if(a){const o=a.type,n=s.type;a.resource.fsPath!==s.resource.fsPath&&(s.type===I.FileChangeType.DELETED||s.type===I.FileChangeType.ADDED)?t=!0:o===I.FileChangeType.ADDED&&n===I.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(a)):o===I.FileChangeType.DELETED&&n===I.FileChangeType.ADDED?a.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&n===I.FileChangeType.UPDATED||(a.type=n)}else t=!0;t&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],a=[];return Array.from(this.a).filter(t=>t.type!==I.FileChangeType.DELETED?(s.push(t),!1):!0).sort((t,o)=>t.resource.fsPath.length-o.resource.fsPath.length).filter(t=>a.some(o=>(0,I.$xl)(t.resource.fsPath,o,!D.$l))?!1:(a.push(t.resource.fsPath),!0)).concat(s)}}function $(k,s){if(typeof s=="number")switch(k.type){case I.FileChangeType.ADDED:return(s&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(s&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(s&I.FileChangeFilter.UPDATED)===0}return!1}function S(k){if(typeof k=="number"){const s=[];return k&I.FileChangeFilter.ADDED&&s.push("Added"),k&I.FileChangeFilter.DELETED&&s.push("Deleted"),k&I.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(le[182],ue([0,1,17,55,15,4,2,69,33,14,62]),function(K,e,i,r,E,D,O,I,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MR=e.$LR=void 0,e.$LR="localFilesystem";class u extends O.$Xc{constructor(p,f){super(),this.a=p,this.b=f,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$oe),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$oe),this.onDidWatchError=this.g.event,this.h=(0,b.$5g)(),this.j()}get capabilities(){return this.c||(this.c=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=l.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=l.FileSystemProviderCapabilities.Trash)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,f){const{buffer:d}=await this.a.call("readFile",[p,f]);return d}readFileStream(p,f,d){const v=(0,I.$Ee)($=>i.$Qe.concat($.map(S=>i.$Qe.wrap(S))).buffer),y=new O.$Wc;return y.add(this.a.listen("readFileStream",[p,f])($=>{if($ instanceof i.$Qe)v.write($.buffer);else{if($==="end")v.end();else{let S;if($ instanceof Error)S=$;else{const k=$;S=(0,l.$ql)(k.message??(0,r.$tj)(k),k.code??l.FileSystemProviderErrorCode.Unknown)}v.error(S),v.end()}y.dispose()}})),y.add(d.onCancellationRequested(()=>{v.error((0,E.$8)()),v.end(),y.dispose()})),v}writeFile(p,f,d){return this.a.call("writeFile",[p,i.$Qe.wrap(f),d])}open(p,f){return this.a.call("open",[p,f])}close(p){return this.a.call("close",[p])}async read(p,f,d,v,y){const[$,S]=await this.a.call("read",[p,f,y]);return d.set($.buffer.slice(0,S),v),S}write(p,f,d,v,y){return this.a.call("write",[p,f,i.$Qe.wrap(d),v,y])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,f){return this.a.call("delete",[p,f])}rename(p,f,d){return this.a.call("rename",[p,f,d])}copy(p,f,d){return this.a.call("copy",[p,f,d])}cloneFile(p,f){return this.a.call("cloneFile",[p,f])}j(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const f=p;this.f.fire((0,g.$br)(f))}else{const f=p;this.g.fire(f)}}))}watch(p,f){const d=(0,b.$5g)();return this.a.call("watch",[this.h,d,p,f]),(0,O.$Vc)(()=>this.a.call("unwatch",[this.h,d]))}}e.$MR=u}),define(le[183],ue([0,1,26,2,62,4,14,7,8]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class l extends r.$Xc{constructor(){super(),this.a=this.B(new D.$oe),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$oe),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$oe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$7c),this.m=new Set,this.n=this.B(new b.$Gh(this.y())),this.r=5007,this.s=new b.$6h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,E.$9q)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new b.$6h;try{this.h.clear(),this.g.clear();for(const m of u)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const m=new r.$Wc;this.j.set(u.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(u,m),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,m){this.F(u,m)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,m),this.m.add(u.correlationId))}F(u,m){const p=this.O?.subscribe(u.path,(f,d)=>{m.isDisposed||(f?this.D(u,m):d?.type===O.FileChangeType.ADDED&&this.H(u))});return p?(m.add(p),!0):!1}G(u,m){let p=!1;const f=(d,v)=>{if(m.isDisposed)return;const y=this.I(d),$=this.I(v),S=p;p=y,!y&&($||S)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,i.watchFile)(u.path,{persistent:!1,interval:this.r},f)}catch(d){this.Q(`fs.watchFile() failed with error ${d} on path ${u.path} (correlationId: ${u.correlationId})`)}m.add((0,r.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,i.unwatchFile)(u.path,f)}catch(d){this.Q(`fs.unwatchFile() failed with error ${d} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const m={resource:I.URI.file(u.path),type:O.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([m]),this.J(m,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,m){if(this.R){const p=` >> normalized ${u.type===O.FileChangeType.ADDED?"[ADDED]":u.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(p,m)}}L(u,m){this.R&&this.P(`${u}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,E.$gr)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}e.$pr=l}),define(le[184],ue([0,1,26,8,22,32,2,79,9,3,18,7,115,23,14,62]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0,e.$vr=y;class v extends O.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(S,k,s,a,t,o){super(),this.s=S,this.t=k,this.u=s,this.w=a,this.y=t,this.z=o,this.c=this.B(new r.$Xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new r.$Wh(n=>this.M(n),v.b)),this.g=(0,d.$er)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,d.$er)(this.s.path,this.s.includes):void 0,this.j=(0,d.$9q)(this.s)?this.s.filter:void 0,this.m=new E.$ze,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const S=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const k=await i.promises.stat(S);if(this.m.token.isCancellationRequested)return;this.B(await this.G(S,k.isDirectory()))}catch(S){S.code!=="ENOENT"?this.O(S):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${S})`),this.D()}}D(){this.r=!0,this.w?.()}async F(S){let k=S.path;try{k=await p.Promises.realpath(S.path),S.path===k&&(k=await(0,m.$rr)(S.path,this.m.token)??S.path),S.path!==k&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${S.path}, real: ${k})`)}catch{}return k}async G(S,k){const s=new O.$Wc;return this.H(S,k,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(S,k,s)),s}H(S,k,s){if(k)return!1;const a=u.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(o,n)=>{if(!s.isDisposed)if(o){const c=await this.G(S,k);s.isDisposed?c.dispose():s.add(c)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:n.type,cId:this.s.correlationId},!0)});return t?(s.add(t),!0):!1}async I(S,k,s){if(l.$k&&(0,D.$Hg)(S,"/Volumes/",!0)){this.O(`Refusing to watch ${S} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new E.$ze(this.m.token);s.add((0,O.$Vc)(()=>a.dispose(!0)));const t=new O.$Wc;s.add(t);try{const o=u.URI.file(this.s.path),n=(0,b.$qc)(S),c=(0,i.watch)(S);t.add((0,O.$Vc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${S}'`);const h=new Set;if(k)try{for(const w of await p.Promises.readdir(S))h.add(w)}catch(w){this.O(w)}if(a.token.isCancellationRequested)return;const P=new Map;t.add((0,O.$Vc)(()=>{for(const[,w]of P)w.dispose();P.clear()})),c.on("error",(w,R)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${S} for changes using fs.watch() (${w}, ${R})`),this.D())}),c.on("change",(w,R)=>{if(a.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${w}"] ${R}`);let L="";if(R&&(L=R.toString(),l.$k&&(L=(0,I.$qm)(L))),!(!L||w!=="change"&&w!=="rename"))if(k)if(w==="rename"){P.get(L)?.dispose();const A=setTimeout(async()=>{if(P.delete(L),L===n&&!await p.Promises.exists(S)){this.J(o);return}if(a.token.isCancellationRequested)return;const T=await this.N((0,b.$mc)(S,L));if(a.token.isCancellationRequested)return;let j;T?h.has(L)?j=f.FileChangeType.UPDATED:(j=f.FileChangeType.ADDED,h.add(L)):(h.delete(L),j=f.FileChangeType.DELETED),this.L({resource:(0,g.$jh)(o,L),type:j,cId:this.s.correlationId})},v.a);P.set(L,(0,O.$Vc)(()=>clearTimeout(A)))}else{let A;h.has(L)?A=f.FileChangeType.UPDATED:(A=f.FileChangeType.ADDED,h.add(L)),this.L({resource:(0,g.$jh)(o,L),type:A,cId:this.s.correlationId})}else if(w==="rename"||L!==n){const A=setTimeout(async()=>{const T=await p.Promises.exists(S);a.token.isCancellationRequested||(T?(this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),t.add(await this.G(S,!1))):this.J(o))},v.a);t.clear(),t.add((0,O.$Vc)(()=>clearTimeout(A)))}else this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){a.token.isCancellationRequested||this.O(`Failed to watch ${S} for changes using fs.watch() (${o.toString()})`),this.D()}}J(S){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:S,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(S,k=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${S.type===f.FileChangeType.ADDED?"[ADDED]":S.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`),!k&&this.g.some(s=>s(S.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${S.resource.fsPath}`):!k&&this.h&&this.h.length>0&&!this.h.some(s=>s(S.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${S.resource.fsPath}`):this.f.work(S))}M(S){const k=(0,d.$cr)(S),s=[];for(const t of k){if((0,d.$fr)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}s.push(t)}if(s.length===0)return;if(this.z)for(const t of s)this.R(` >> normalized ${t.type===f.FileChangeType.ADDED?"[ADDED]":t.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(S){if(l.$l)return p.Promises.exists(S);try{const k=(0,b.$qc)(S);return(await p.Promises.readdir((0,b.$pc)(S))).some(a=>a===k)}catch(k){return this.Q(k),!1}}setVerboseLogging(S){this.z=S}O(S){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${S}`})}P(S){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${S}`})}Q(S){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${S}`})}R(S){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${S}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ur=v;async function y($,S,k,s,a=512){const t=await p.Promises.open($,"r"),o=Buffer.allocUnsafe(a),n=new E.$ze(s);let c,h=!1;const P={path:$,excludes:[],recursive:!1},w=new v(P,void 0,R=>{(async()=>{for(const{type:L}of R)if(L===f.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:A}=await p.Promises.read(t,o,0,a,null);if(!A||n.token.isCancellationRequested)break;S(o.slice(0,A))}}catch(A){c=new Error(A),n.dispose(!0)}finally{h=!1}}})()});return await w.ready,k(),new Promise((R,L)=>{n.token.onCancellationRequested(async()=>{w.dispose();try{await p.Promises.close(t)}catch(A){c=new Error(A)}c?L(c):R()})})}}),define(le[185],ue([0,1,4,114,183,3,184,32]),function(K,e,i,r,E,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class b extends E.$pr{constructor(g){super(),this.O=g,this.onDidError=i.Event.None,this.watchers=new Set}async N(g){g=this.Z(g);const u=[],m=new Set(Array.from(this.watchers));for(const p of g){const f=this.W(p);f&&(0,r.$Hk)(f.request.excludes,p.excludes)&&(0,r.$Hk)(f.request.includes,p.includes)?m.delete(f):u.push(p)}u.length&&this.P(`Request to start watching: ${u.map(p=>this.M(p)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(p=>this.M(p.request)).join(",")}`);for(const p of m)this.Y(p);for(const p of u)this.X(p)}W(g){for(const u of this.watchers)if(typeof g.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===g.correlationId)return u}else if((0,I.$Gg)(u.request.path,g.path,!D.$l))return u}X(g){const u=new O.$ur(g,this.O,p=>this.a.fire(p),()=>this.c.fire(g),p=>this.b.fire(p),this.R),m={request:g,instance:u};this.watchers.add(m)}async stop(){await super.stop();for(const g of this.watchers)this.Y(g)}Y(g){this.P("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}Z(g){const u=new Map;for(const m of g){const p=D.$l?m.path:m.path.toLowerCase();let f=u.get(m.correlationId);f||(f=new Map,u.set(m.correlationId,f)),f.has(p)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),f.set(p,m)}return Array.from(u.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(g){super.setVerboseLogging(g);for(const u of this.watchers)u.instance.setVerboseLogging(g)}P(g,u){this.R&&this.b.fire({type:"trace",message:this.bb(g,u)})}Q(g){this.b.fire({type:"warn",message:this.bb(g)})}bb(g,u){return u?`[File Watcher (node.js)] ${g} (${this.M(u.request)})`:`[File Watcher (node.js)] ${g}`}}e.$wr=b}),define(le[186],ue([0,1,62,185]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;class E extends i.$_q{constructor(O,I,b){super(O,I,b),this.s()}r(O){return O.add(new r.$wr(void 0))}}e.$xr=E}),define(le[187],ue([0,1,11,45,163,62]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class O extends D.$ar{constructor(b,l,g){super(b,l,g),this.s()}r(b){const l=b.add(new E.$nr(i.$3g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(l.onDidProcessExit(({code:g,signal:u})=>this.t(`terminated by itself with code ${g}, signal: ${u} (ETERM)`))),r.ProxyChannel.toService((0,r.$pi)(l.getChannel("watcher")))}}e.$or=O}),define(le[101],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class i{constructor(...E){this.a=new Map;for(const[D,O]of E)this.set(D,O)}set(E,D){const O=this.a.get(E);return this.a.set(E,D),O}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Gi=i}),define(le[188],ue([0,1,8,15,2,84,177,6,101,111]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0;const g=!1;class u extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class m{constructor(v=new b.$Gi,y=!1,$,S=g){this.i=v,this.j=y,this.k=$,this.l=S,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Hi,this),this._globalGraph=S?$?._globalGraph??new O.$Ar(k=>k):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Sc)(this.h),this.h.clear();for(const v of this.g)(0,E.$Rc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,y){this.m();const $=this,S=new class extends m{dispose(){$.h.delete(S),super.dispose()}}(v,this.j,this,this.l);return this.h.add(S),y?.add(S),S}invokeFunction(v,...y){this.m();const $=f.traceInvocation(this.l,v);let S=!1;try{return v({get:s=>{if(S)throw(0,r.$0)("service accessor is only valid during the invocation of its target method");const a=this.s(s,$);if(!a)throw new Error(`[invokeFunction] unknown service '${s}'`);return a}},...y)}finally{S=!0,$.stop()}}createInstance(v,...y){this.m();let $,S;return v instanceof D.$Fi?($=f.traceCreation(this.l,v.ctor),S=this.o(v.ctor,v.staticArguments.concat(y),$)):($=f.traceCreation(this.l,v),S=this.o(v,y,$)),$.stop(),S}o(v,y=[],$){const S=I._util.getServiceDependencies(v).sort((a,t)=>a.index-t.index),k=[];for(const a of S){const t=this.s(a.id,$);t||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${a.id}.`,!1),k.push(t)}const s=S.length>0?S[0].index:y.length;if(y.length!==s){console.trace(`[createInstance] First service dependency of ${v.name} at position ${s+1} conflicts with ${y.length} static arguments`);const a=s-y.length;a>0?y=y.concat(new Array(a)):y=y.slice(0,s)}return Reflect.construct(v,y.concat(k))}q(v,y){if(this.i.get(v)instanceof D.$Fi)this.i.set(v,y);else if(this.k)this.k.q(v,y);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const y=this.i.get(v);return!y&&this.k?this.k.r(v):y}s(v,y){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const $=this.r(v);return $ instanceof D.$Fi?this.u(v,$,y.branch(v,!0)):(y.branch(v,!1),$)}u(v,y,$){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,y,$)}finally{this.t.delete(v)}}v(v,y,$){const S=new O.$Ar(t=>t.id.toString());let k=0;const s=[{id:v,desc:y,_trace:$}],a=new Set;for(;s.length;){const t=s.pop();if(!a.has(String(t.id))){if(a.add(String(t.id)),S.lookupOrInsertNode(t),k++>1e3)throw new u(S);for(const o of I._util.getServiceDependencies(t.desc.ctor)){const n=this.r(o.id);if(n||this.y(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof D.$Fi){const c={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};S.insertEdge(t,c),s.push(c)}}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new u(S);break}for(const{data:o}of t){if(this.r(o.id)instanceof D.$Fi){const c=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,c)}S.removeNode(o)}}return this.r(v)}w(v,y,$=[],S,k){if(this.i.get(v)instanceof D.$Fi)return this.x(v,y,$,S,k,this.g);if(this.k)return this.k.w(v,y,$,S,k);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}x(v,y,$=[],S,k,s){if(S){const a=new m(void 0,this.j,this,this.l);a.c=String(v);const t=new Map,o=new i.$2h(()=>{const n=a.o(y,$,k);for(const[c,h]of t){const P=n[c];if(typeof P=="function")for(const w of h)w.disposable=P.apply(n,w.listener)}return t.clear(),s.add(n),n});return new Proxy(Object.create(null),{get(n,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let w=t.get(c);return w||(w=new l.$8c,t.set(c,w)),(L,A,T)=>{if(o.isInitialized)return o.value[c](L,A,T);{const j={listener:[L,A,T],disposable:void 0},G=w.push(j);return(0,E.$Vc)(()=>{G(),j.disposable?.dispose()})}}}if(c in n)return n[c];const h=o.value;let P=h[c];return typeof P!="function"||(P=P.bind(h),n[c]=P),P},set(n,c,h){return o.value[c]=h,!0},getPrototypeOf(n){return y.prototype}})}else{const a=this.o(y,$,k);return s.add(a),a}}y(v,y){if(y&&console.warn(v),this.j)throw new Error(v)}}e.$Br=m;var p;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(p||(p={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,y){return v?new f(p.Invocation,y.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,y){return v?new f(p.Creation,y.name):f.c}static{this.f=0}constructor(v,y){this.type=v,this.name=y,this.g=Date.now(),this.h=[]}branch(v,y){const $=new f(p.Branch,v.toString());return this.h.push([v,y,$]),$}stop(){const v=Date.now()-this.g;f.f+=v;let y=!1;function $(k,s){const a=[],t=new Array(k+1).join("	");for(const[o,n,c]of s.h)if(n&&c){y=!0,a.push(`${t}CREATES -> ${o}`);const h=$(k+1,c);h&&a.push(h)}else a.push(`${t}uses -> ${o}`);return a.join(`
`)}const S=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||y)&&f.all.add(S.join(`
`))}}e.$Cr=f}),define(le[189],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=e.$0ac=e.IssueSource=e.OldIssueType=void 0;var r;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(r||(e.OldIssueType=r={}));var E;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(E||(e.IssueSource=E={})),e.$0ac=(0,i.$Ii)("issueService"),e.$$ac=(0,i.$Ii)("processService")}),define(le[5],ue([0,1,10,55,4,47,2,31,3,18,12,7,124,6]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=d,e.log=y,e.$rk=P,e.$sk=w,e.$tk=R,e.$uk=L,i=Ie(i),e.$dk=(0,p.$Ii)("logService"),e.$ek=(0,p.$Ii)("loggerService");function f(){return new Date().toISOString()}function d(A){return(0,g.$lg)(A)}var v;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$gk=v.Info;function y(A,T,j){switch(T){case v.Trace:A.trace(j);break;case v.Debug:A.debug(j);break;case v.Info:A.info(j);break;case v.Warning:A.warn(j);break;case v.Error:A.error(j);break;case v.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function $(A,T=!1){let j="";for(let G=0;G<A.length;G++){let q=A[G];if(q instanceof Error&&(q=(0,r.$tj)(q,T)),typeof q=="object")try{q=JSON.stringify(q)}catch{}j+=(G>0?" ":"")+q}return j}class S extends O.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new E.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(T){this.b!==T&&(this.b=T,this.c.fire(this.b))}getLevel(){return this.b}f(T){return this.b!==v.Off&&this.b<=T}}e.$ik=S;class k extends S{constructor(T){super(),this.h=T}f(T){return this.h||super.f(T)}trace(T,...j){this.f(v.Trace)&&this.g(v.Trace,$([T,...j],!0))}debug(T,...j){this.f(v.Debug)&&this.g(v.Debug,$([T,...j]))}info(T,...j){this.f(v.Info)&&this.g(v.Info,$([T,...j]))}warn(T,...j){this.f(v.Warning)&&this.g(v.Warning,$([T,...j]))}error(T,...j){if(this.f(v.Error))if(T instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=T.stack,this.g(v.Error,$(G))}else this.g(v.Error,$([T,...j]))}flush(){}}e.$jk=k;class s extends S{constructor(T=e.$gk){super(),this.setLevel(T),this.g=!b.$j}trace(T,...j){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,T,...j):console.log(`[main ${f()}]`,T,...j))}debug(T,...j){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,T,...j):console.log(`[main ${f()}]`,T,...j))}info(T,...j){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,T,...j):console.log(`[main ${f()}]`,T,...j))}warn(T,...j){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,T,...j):console.warn(`[main ${f()}]`,T,...j))}error(T,...j){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,T,...j):console.error(`[main ${f()}]`,T,...j))}flush(){}}e.$kk=s;class a extends S{constructor(T=e.$gk,j=!0){super(),this.g=j,this.setLevel(T)}trace(T,...j){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",T,...j):console.log(T,...j))}debug(T,...j){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",T,...j):console.log(T,...j))}info(T,...j){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",T,...j):console.log(T,...j))}warn(T,...j){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",T,...j):console.log(T,...j))}error(T,...j){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",T,...j):console.error(T,...j))}flush(){}}e.$lk=a;class t extends S{constructor(T,j=e.$gk){super(),this.g=T,this.setLevel(j)}trace(T,...j){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(T),...j])}debug(T,...j){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(T),...j])}info(T,...j){this.f(v.Info)&&this.g.log(v.Info,[this.h(T),...j])}warn(T,...j){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(T),...j])}error(T,...j){this.f(v.Error)&&this.g.log(v.Error,[this.h(T),...j])}h(T){return typeof T=="string"?T:(0,r.$tj)(T,this.f(v.Trace))}flush(){}}e.$mk=t;class o extends S{constructor(T){super(),this.g=T,T.length&&this.setLevel(T[0].getLevel())}setLevel(T){for(const j of this.g)j.setLevel(T);super.setLevel(T)}trace(T,...j){for(const G of this.g)G.trace(T,...j)}debug(T,...j){for(const G of this.g)G.debug(T,...j)}info(T,...j){for(const G of this.g)G.info(T,...j)}warn(T,...j){for(const G of this.g)G.warn(T,...j)}error(T,...j){for(const G of this.g)G.error(T,...j)}flush(){for(const T of this.g)T.flush()}dispose(){for(const T of this.g)T.dispose();super.dispose()}}e.$nk=o;class n extends O.$Xc{constructor(T,j,G){if(super(),this.h=T,this.j=j,this.b=new I.$Dc,this.c=this.B(new E.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$oe),this.onDidChangeVisibility=this.g.event,G)for(const q of G)this.b.set(q.resource,{logger:void 0,info:q})}m(T){return(0,g.$hg)(T)?[...this.b.values()].find(j=>j.info.id===T):this.b.get(T)}getLogger(T){return this.m(T)?.logger}createLogger(T,j){const G=this.n(T),q=(0,g.$hg)(T)?T:j?.id??(0,D.$wj)(G.toString()).toString(16);let Q=this.b.get(G)?.logger;const de=j?.logLevel==="always"?v.Trace:j?.logLevel;Q||(Q=this.s(G,de??this.getLogLevel(G)??this.h,{...j,id:q}));const x={logger:Q,info:{resource:G,id:q,logLevel:de,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(x.info),this.b.set(G,x),Q}n(T){return(0,g.$hg)(T)?(0,l.$jh)(this.j,`${T}.log`):T}setLogLevel(T,j){if(u.URI.isUri(T)){const G=T,q=j,Q=this.b.get(G);Q&&q!==Q.info.logLevel&&(Q.info.logLevel=q===this.h?void 0:q,Q.logger?.setLevel(q),this.b.set(Q.info.resource,Q),this.f.fire([G,q]))}else{this.h=T;for(const[G,q]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(T,j){const G=this.m(T);G&&j!==!G.info.hidden&&(G.info.hidden=!j,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,j]))}getLogLevel(T){let j;return T&&(j=this.b.get(T)?.info.logLevel),j??this.h}registerLogger(T){const j=this.b.get(T.resource);j?j.info.hidden!==T.hidden&&this.setVisibility(T.resource,!T.hidden):(this.b.set(T.resource,{info:T,logger:void 0}),this.c.fire({added:[T],removed:[]}))}deregisterLogger(T){const j=this.b.get(T);j&&(j.logger&&j.logger.dispose(),this.b.delete(T),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const T of this.b.values())yield T.info}getRegisteredLogger(T){return this.b.get(T)?.info}dispose(){this.b.forEach(T=>T.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=n;class c{constructor(){this.onDidChangeLogLevel=new E.$oe().event}setLevel(T){}getLevel(){return v.Info}trace(T,...j){}debug(T,...j){}info(T,...j){}warn(T,...j){}error(T,...j){}critical(T,...j){}dispose(){}flush(){}}e.$pk=c;class h extends c{}e.$qk=h;function P(A){if(A.verbose)return v.Trace;if(typeof A.logLevel=="string"){const T=L(A.logLevel.toLowerCase());if(T!==void 0)return T}return e.$gk}function w(A){switch(A){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function R(A){switch(A){case v.Trace:return{original:"Trace",value:i.localize(1957,null)};case v.Debug:return{original:"Debug",value:i.localize(1958,null)};case v.Info:return{original:"Info",value:i.localize(1959,null)};case v.Warning:return{original:"Warning",value:i.localize(1960,null)};case v.Error:return{original:"Error",value:i.localize(1961,null)};case v.Off:return{original:"Off",value:i.localize(1962,null)}}}function L(A){switch(A){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$vk=new m.$Zj("logLevel",w(v.Info))});var re=this&&this.__param||function(K,e){return function(i,r){e(i,r,K)}};define(le[86],ue([0,1,44,97,67,11,60,36,6,5]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bS=e.$aS=void 0,e.$aS=(0,b.$Ii)("ICSSDevelopmentService");let g=class{constructor(m,p){this.b=m,this.c=p}get isEnabled(){return!this.b.isBuilt&&E.$T}getCssModules(){return this.a??=this.d(),this.a}async d(){if(!this.isEnabled)return[];const m=await new Promise((p,f)=>{K(["@vscode/ripgrep"],p,f)}).then(Ie);return await new Promise(p=>{const f=O.$ie.create(),d=[],v=new TextDecoder,y=D.$3g.asFileUri("").fsPath,$=(0,i.spawn)(m.rgPath,["-g","**/*.css","--files","--no-ignore",y],{});$.stdout.on("data",S=>{const k=v.decode(S,{stream:!0});d.push(k.split(`
`).filter(Boolean))}),$.on("error",S=>{this.c.error("[CSS_DEV] FAILED to compute CSS data",S),p([])}),$.on("close",()=>{const S=d.flat().map(k=>(0,r.relative)(y,k).replace(/\\/g,"/")).filter(Boolean).sort();p(S),this.c.info(`[CSS_DEV] DONE, ${S.length} css modules (${Math.round(f.elapsed())}ms)`)})})}};e.$bS=g,e.$bS=g=ke([re(0,I.$Pi),re(1,l.$dk)],g)}),define(le[190],ue([0,1,13,3,100,5]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;const O=i.safeStorage;let I=class{constructor(l){this.a=l,i.app.commandLine.getSwitchValue("password-store")===E.PasswordStoreCLIOption.basic&&(this.a.trace("[EncryptionMainService] setting usePlainTextEncryption to true..."),O.setUsePlainTextEncryption?.(!0),this.a.trace("[EncryptionMainService] set usePlainTextEncryption to true"))}async encrypt(l){this.a.trace("[EncryptionMainService] Encrypting value...");try{const g=JSON.stringify(O.encryptString(l));return this.a.trace("[EncryptionMainService] Encrypted value."),g}catch(g){throw this.a.error(g),g}}async decrypt(l){let g;try{if(g=JSON.parse(l),!g.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${l}`);const u=Buffer.from(g.data);this.a.trace("[EncryptionMainService] Decrypting value...");const m=O.decryptString(u);return this.a.trace("[EncryptionMainService] Decrypted value."),m}catch(u){throw this.a.error(u),u}}isEncryptionAvailable(){this.a.trace("[EncryptionMainService] Checking if encryption is available...");const l=O.isEncryptionAvailable();return this.a.trace("[EncryptionMainService] Encryption is available: ",l),Promise.resolve(l)}getKeyStorageProvider(){if(r.$j)return Promise.resolve(E.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(E.KnownStorageProvider.keychainAccess);if(O.getSelectedStorageBackend)try{this.a.trace("[EncryptionMainService] Getting selected storage backend...");const l=O.getSelectedStorageBackend();return this.a.trace("[EncryptionMainService] Selected storage backend: ",l),Promise.resolve(l)}catch(l){this.a.error(l)}return Promise.resolve(E.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");this.a.trace("[EncryptionMainService] Setting usePlainTextEncryption to true..."),O.setUsePlainTextEncryption(!0),this.a.trace("[EncryptionMainService] Set usePlainTextEncryption to true")}};e.$rhc=I,e.$rhc=I=ke([re(0,D.$dk)],I)}),define(le[191],ue([0,1,21,8,15,4,32,2,9,62,5]),function(K,e,i,r,E,D,O,I,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class u extends I.$Xc{constructor(p,f){super(),this.a=p,this.b=f,this.c=this.B(new D.$oe),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$oe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Gh(0)),this.w=[],this.y=this.B(new r.$Gh(0))}watch(p,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(p,f):this.z(p,f)}n(p,f){const d={path:this.J(p),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},v=(0,i.$Vb)(this.j,d);return this.r(),(0,I.$Vc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,E.$2)(p))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,l.$br)(f)),f=>this.G(f),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const f of this.j)(0,l.$0q)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const f of this.j)(0,l.$0q)(f)&&p.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,f){const d={path:this.J(p),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},v=(0,i.$Vb)(this.w,d);return this.C(),(0,I.$Vc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,E.$2)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,l.$br)(p)),p=>this.G(p),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.H(p)}H(p){this.a[p.type](p.message)}I(p){return(0,b.$kc)(p.fsPath)}J(p){const f=this.I(p);return(0,O.$Kg)(f)}}e.$hr=u}),define(le[192],ue([0,1,21,8,17,22,4,47,78,2,61,11,72,18,69,10,14,126,5,15]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;let s=class extends l.$Xc{static{k=this}constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new O.$oe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$oe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$oe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$oe),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$oe),this.Y=this.B(new O.$oe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$oe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Rh)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const n=new l.$Wc;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(c=>{const h=new v.$wl(c,!this.S(o));this.X.fire(h),h.hasCorrelation()||this.Y.fire(h)})),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(c=>this.Z.fire(new Error(c)))),n.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,l.$Vc)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,l.$Sc)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(n){o.push(n)}}),!this.h.has(t)&&await r.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return b.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,p.$nh)(t))throw new v.$yl((0,d.localize)(1869,null,this.sb(t)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const n=new S.$db;throw n.message=(0,d.localize)(1870,null,t.toString()),n}return o}async m(t){const o=await this.j(t);if((0,v.$jl)(o)||(0,v.$gl)(o)||(0,v.$kl)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const o=await this.j(t);if((0,v.$jl)(o)||(0,v.$gl)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.s(t,o)}catch(n){throw(0,v.$tl)(n)===v.FileSystemProviderErrorCode.FileNotFound?new v.$yl((0,d.localize)(1871,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$rl)(n)}}async s(t,o){const n=await this.j(t),c=this.S(n),h=o?.resolveTo,P=o?.resolveSingleChildDescendants,w=o?.resolveMetadata,R=await n.stat(t);let L;return this.t(n,t,R,void 0,!!w,(A,T)=>(L||(L=g.$Oi.forUris(()=>!c),L.set(t,!0),h&&L.fill(!0,h)),L.get(A.resource)||L.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&P?T===1:!1))}async t(t,o,n,c,h,P){const{providerExtUri:w}=this.R(t),R={resource:o,name:w.basename(o),isFile:(n.type&v.FileType.File)!==0,isDirectory:(n.type&v.FileType.Directory)!==0,isSymbolicLink:(n.type&v.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&v.FilePermission.Readonly)||!!(t.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((n.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Jl)({mtime:n.mtime,size:n.size}),children:void 0};if(R.isDirectory&&P(R,c)){try{const L=await t.readdir(o),A=await r.Promises.settled(L.map(async([T,j])=>{try{const G=w.joinPath(o,T),q=h?await t.stat(G):{type:j};return await this.t(t,G,q,L.length,h,P)}catch(G){return this.b.trace(G),null}}));R.children=(0,i.$Jb)(A)}catch(L){this.b.trace(L),R.children=[]}return R}return R}async resolveAll(t){return r.Promises.settled(t.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),n=await o.stat(t);return this.t(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.u(t,o)}catch(n){return n}return!0}async u(t,o){if(!o?.overwrite&&await this.exists(t))throw new v.$yl((0,d.localize)(1872,null,this.sb(t)),v.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(t,o=E.$Qe.fromString(""),n){await this.u(t,n);const c=await this.writeFile(t,o);return this.r.fire(new v.$vl(t,v.FileOperation.CREATE,c)),c}async writeFile(t,o,n){const c=this.qb(await this.n(t),t),{providerExtUri:h}=this.R(c);let P=n;if((0,v.$ml)(c)&&!P?.atomic){const w=c.enforceAtomicWriteFile?.(t);w&&(P={...n,atomic:w})}try{await this.w(c,t,P)||await this.U(c,h.dirname(t));let R;if((0,v.$gl)(c)&&!(o instanceof E.$Qe))if((0,f.$Ce)(o)){const L=await(0,f.$Je)(o,3);L.ended?R=E.$Qe.concat(L.buffer):R=L}else R=(0,f.$Ge)(o,L=>E.$Qe.concat(L),3);else R=o;!(0,v.$jl)(c)||(0,v.$gl)(c)&&R instanceof E.$Qe||(0,v.$gl)(c)&&(0,v.$ml)(c)&&P?.atomic?await this.hb(c,t,P,R):await this.db(c,t,P,R instanceof E.$Qe?(0,E.$2e)(R):R),this.r.fire(new v.$vl(t,v.FileOperation.WRITE))}catch(w){throw new v.$yl((0,d.localize)(1873,null,this.sb(t),(0,v.$rl)(w).toString()),(0,v.$ul)(w),P)}return this.resolve(t,{resolveMetadata:!0})}async w(t,o,n){const c=!!n?.unlock;if(c&&!(t.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,d.localize)(1874,null,this.sb(o)));if(!!n?.atomic){if(!(t.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,d.localize)(1875,null,this.sb(o)));if(!(t.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,d.localize)(1876,null,this.sb(o)));if(c)throw new Error((0,d.localize)(1877,null,this.sb(o)))}let P;try{P=await t.stat(o)}catch{return}if(P.type&v.FileType.Directory)throw new v.$yl((0,d.localize)(1878,null,this.sb(o)),v.FileOperationResult.FILE_IS_DIRECTORY,n);if(this.rb(o,P),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==v.$Il&&typeof P.mtime=="number"&&typeof P.size=="number"&&n.mtime<P.mtime&&n.etag!==(0,v.$Jl)({mtime:n.mtime,size:P.size}))throw new v.$yl((0,d.localize)(1879,null),v.FileOperationResult.FILE_MODIFIED_SINCE,n);return P}async readFile(t,o,n){const c=await this.m(t);return o?.atomic?this.z(c,t,o,n):this.C(c,t,o,n)}async z(t,o,n,c){return new Promise((h,P)=>{this.cb.queueFor(o,async()=>{try{const w=await this.C(t,o,n,c);h(w)}catch(w){P(w)}},this.R(t).providerExtUri)})}async C(t,o,n,c){const h=await this.D(t,o,{...n,preferUnbuffered:!0},c);return{...h,value:await(0,E.$3e)(h.value)}}async readFileStream(t,o,n){const c=await this.m(t);return this.D(c,t,o,n)}async D(t,o,n,c){const h=new D.$ze(c);let P=n;(0,v.$ll)(t)&&t.enforceAtomicReadFile?.(o)&&(P={...n,atomic:!0});const w=this.J(o,P).then(L=>L,L=>{throw h.dispose(!0),L});let R;try{return typeof P?.etag=="string"&&P.etag!==v.$Il&&await w,P?.atomic&&(0,v.$ll)(t)||!((0,v.$jl)(t)||(0,v.$kl)(t))||(0,v.$gl)(t)&&P?.preferUnbuffered?R=this.I(t,o,P):(0,v.$kl)(t)?R=this.G(t,o,h.token,P):R=this.H(t,o,h.token,P),R.on("end",()=>h.dispose()),R.on("error",()=>h.dispose()),{...await w,value:R}}catch(L){throw R&&await(0,f.$He)(R),this.F(L,o,P)}}F(t,o,n){const c=(0,d.localize)(1880,null,this.sb(o),(0,v.$rl)(t).toString());return t instanceof v.$Al?new v.$Al(c,t.stat,n):t instanceof v.$zl?new v.$zl(c,t.fileOperationResult,t.size,t.options):new v.$yl(c,(0,v.$ul)(t),n)}G(t,o,n,c=Object.create(null)){const h=t.readFileStream(o,c,n);return(0,f.$Ne)(h,{data:P=>P instanceof E.$Qe?P:E.$Qe.wrap(P),error:P=>this.F(P,o,c)},P=>E.$Qe.concat(P))}H(t,o,n,c=Object.create(null)){const h=(0,E.$7e)();return(0,y.$7q)(t,o,h,P=>P,{...c,bufferSize:this.a,errorTransformer:P=>this.F(P,o,c)},n),h}I(t,o,n){const c=(0,f.$Ee)(h=>E.$Qe.concat(h));return(async()=>{try{let h;n?.atomic&&(0,v.$ll)(t)?h=await t.readFile(o,{atomic:!0}):h=await t.readFile(o),typeof n?.position=="number"&&(h=h.slice(n.position)),typeof n?.length=="number"&&(h=h.slice(0,n.length)),this.L(o,h.byteLength,n),c.end(E.$Qe.wrap(h))}catch(h){c.error(h),c.end()}})(),c}async J(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new v.$yl((0,d.localize)(1881,null,this.sb(t)),v.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==v.$Il&&o.etag===n.etag)throw new v.$Al((0,d.localize)(1882,null),n,o);return this.L(t,n.size,o),n}L(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new v.$zl((0,d.localize)(1883,null,this.sb(t)),v.FileOperationResult.FILE_TOO_LARGE,o,n)}async canMove(t,o,n){return this.M(t,o,"move",n)}async canCopy(t,o,n){return this.M(t,o,"copy",n)}async M(t,o,n,c){if(t.toString()!==o.toString())try{const h=n==="move"?this.qb(await this.n(t),t):await this.m(t),P=this.qb(await this.n(o),o);await this.Q(h,t,P,o,n,c)}catch(h){return h}return!0}async move(t,o,n){const c=this.qb(await this.n(t),t),h=this.qb(await this.n(o),o),P=await this.N(c,t,h,o,"move",!!n),w=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$vl(t,P==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,w)),w}async copy(t,o,n){const c=await this.m(t),h=this.qb(await this.n(o),o),P=await this.N(c,t,h,o,"copy",!!n),w=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$vl(t,P==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,w)),w}async N(t,o,n,c,h,P){if(o.toString()===c.toString())return h;const{exists:w,isSameResourceWithDifferentPathCase:R}=await this.Q(t,o,n,c,h,P);if(w&&!R&&P&&await this.del(c,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(c)),h==="copy"){if(t===n&&(0,v.$hl)(t))await t.copy(o,c,{overwrite:P});else{const L=await this.resolve(o);L.isDirectory?await this.P(t,L,n,c):await this.O(t,o,n,c)}return h}else return t===n?(await t.rename(o,c,{overwrite:P}),h):(await this.N(t,o,n,c,"copy",P),await this.del(o,{recursive:!0}),"copy")}async O(t,o,n,c){if((0,v.$jl)(t)&&(0,v.$jl)(n))return this.jb(t,o,n,c);if((0,v.$jl)(t)&&(0,v.$gl)(n))return this.pb(t,o,n,c);if((0,v.$gl)(t)&&(0,v.$jl)(n))return this.nb(t,o,n,c);if((0,v.$gl)(t)&&(0,v.$gl)(n))return this.lb(t,o,n,c)}async P(t,o,n,c){await n.mkdir(c),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async h=>{const P=this.R(n).providerExtUri.joinPath(c,h.name);return h.isDirectory?this.P(t,await this.resolve(h.resource),n,P):this.O(t,h.resource,n,P)}))}async Q(t,o,n,c,h,P){let w=!1;if(t===n){const{providerExtUri:L,isPathCaseSensitive:A}=this.R(t);if(A||(w=L.isEqual(o,c)),w&&h==="copy")throw new Error((0,d.localize)(1884,null,this.sb(o),this.sb(c)));if(!w&&L.isEqualOrParent(c,o))throw new Error((0,d.localize)(1885,null,this.sb(o),this.sb(c)))}const R=await this.exists(c);if(R&&!w){if(!P)throw new v.$yl((0,d.localize)(1886,null,this.sb(o),this.sb(c)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(t===n){const{providerExtUri:L}=this.R(t);if(L.isEqualOrParent(o,c))throw new Error((0,d.localize)(1887,null,this.sb(o),this.sb(c)))}}return{exists:R,isSameResourceWithDifferentPathCase:w}}R(t){const o=this.S(t);return{providerExtUri:o?p.$_g:p.$bh,isPathCaseSensitive:o}}S(t){return!!(t.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const o=this.qb(await this.j(t),t);await this.U(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new v.$vl(t,v.FileOperation.CREATE,n)),n}async U(t,o){const n=[],{providerExtUri:c}=this.R(t);for(;!c.isEqual(o,c.dirname(o));)try{if(!((await t.stat(o)).type&v.FileType.Directory))throw new Error((0,d.localize)(1888,null,this.sb(o)));break}catch(h){if((0,v.$tl)(h)!==v.FileSystemProviderErrorCode.FileNotFound)throw h;n.push(c.basename(o)),o=c.dirname(o)}for(let h=n.length-1;h>=0;h--){o=c.joinPath(o,n[h]);try{await t.mkdir(o)}catch(P){if((0,v.$tl)(P)!==v.FileSystemProviderErrorCode.FileExists)throw P}}}async canDelete(t,o){try{await this.W(t,o)}catch(n){return n}return!0}async W(t,o){const n=this.qb(await this.j(t),t),c=!!o?.useTrash;if(c&&!(n.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,d.localize)(1889,null,this.sb(t)));const h=o?.atomic;if(h&&!(n.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,d.localize)(1890,null,this.sb(t)));if(c&&h)throw new Error((0,d.localize)(1891,null,this.sb(t)));let P;try{P=await n.stat(t)}catch{}if(P)this.rb(t,P);else throw new v.$yl((0,d.localize)(1892,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const R=await this.resolve(t);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,d.localize)(1893,null,this.sb(t)))}return n}async del(t,o){const n=await this.W(t,o);let c=o;if((0,v.$nl)(n)&&!c?.atomic){const R=n.enforceAtomicDelete?.(t);R&&(c={...o,atomic:R})}const h=!!c?.useTrash,P=!!c?.recursive,w=c?.atomic??!1;await n.delete(t,{recursive:P,useTrash:h,atomic:w}),this.r.fire(new v.$vl(t,v.FileOperation.DELETE))}async cloneFile(t,o){const n=await this.j(t),c=this.qb(await this.n(o),o);if(!(n===c&&this.R(n).providerExtUri.isEqual(t,o)))return n===c&&(0,v.$il)(n)?n.cloneFile(t,o):(await this.U(c,this.R(c).providerExtUri.dirname(o)),n===c&&(0,v.$hl)(n)?this.cb.queueFor(t,()=>n.copy(t,o,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(t,()=>this.O(n,t,c,o),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(t,o){return this.watch(t,{...o,correlationId:k.ab++})}watch(t,o={recursive:!1,excludes:[]}){const n=new l.$Wc;let c=!1,h=()=>{c=!0};n.add((0,l.$Vc)(()=>h())),(async()=>{try{const w=await this.bb(t,o);c?(0,l.$Sc)(w):h=()=>(0,l.$Sc)(w)}catch(w){this.b.error(w)}})();const P=o.correlationId;if(typeof P=="number"){const w=n.add(new O.$oe);return n.add(this.X.event(L=>{L.correlates(P)&&w.fire(L)})),{onDidChange:w.event,dispose:()=>n.dispose()}}return n}async bb(t,o){const n=await this.j(t),c=(0,I.$wj)([this.R(n).providerExtUri.getComparisonKey(t),o]);let h=this.$.get(c);return h||(h={count:0,disposable:n.watch(t,o)},this.$.set(c,h)),h.count+=1,(0,l.$Vc)(()=>{h&&(h.count--,h.count===0&&((0,l.$Sc)(h.disposable),this.$.delete(c)))})}dispose(){super.dispose();for(const[,t]of this.$)(0,l.$Sc)(t.disposable);this.$.clear()}async db(t,o,n,c){return this.cb.queueFor(o,async()=>{const h=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,f.$Ce)(c)||(0,f.$De)(c)?await this.eb(t,h,c):await this.fb(t,h,c)}catch(P){throw(0,v.$rl)(P)}finally{await t.close(h)}},this.R(t).providerExtUri)}async eb(t,o,n){let c=0,h;if((0,f.$De)(n)){if(n.buffer.length>0){const P=E.$Qe.concat(n.buffer);await this.gb(t,o,P,P.byteLength,c,0),c+=P.byteLength}if(n.ended)return;h=n.stream}else h=n;return new Promise((P,w)=>{(0,f.$Ie)(h,{onData:async R=>{h.pause();try{await this.gb(t,o,R,R.byteLength,c,0)}catch(L){return w(L)}c+=R.byteLength,setTimeout(()=>h.resume())},onError:R=>w(R),onEnd:()=>P()})})}async fb(t,o,n){let c=0,h;for(;(h=n.read())!==null;)await this.gb(t,o,h,h.byteLength,c,0),c+=h.byteLength}async gb(t,o,n,c,h,P){let w=0;for(;w<c;){const R=await t.write(o,h+w,n.buffer,P+w,c-w);w+=R}}async hb(t,o,n,c){return this.cb.queueFor(o,()=>this.ib(t,o,n,c),this.R(t).providerExtUri)}async ib(t,o,n,c){let h;c instanceof E.$Qe?h=c:(0,f.$Ce)(c)?h=await(0,E.$3e)(c):(0,f.$De)(c)?h=await(0,E.$4e)(c):h=(0,E.$1e)(c),await t.writeFile(o,h.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(t,o,n,c){return this.cb.queueFor(c,()=>this.kb(t,o,n,c),this.R(n).providerExtUri)}async kb(t,o,n,c){let h,P;try{h=await t.open(o,{create:!1}),P=await n.open(c,{create:!0,unlock:!1});const w=E.$Qe.alloc(this.a);let R=0,L=0,A=0;do A=await t.read(h,R,w.buffer,L,w.byteLength-L),await this.gb(n,P,w,A,R,L),R+=A,L+=A,L===w.byteLength&&(L=0);while(A>0)}catch(w){throw(0,v.$rl)(w)}finally{await r.Promises.settled([typeof h=="number"?t.close(h):Promise.resolve(),typeof P=="number"?n.close(P):Promise.resolve()])}}async lb(t,o,n,c){return this.cb.queueFor(c,()=>this.mb(t,o,n,c),this.R(n).providerExtUri)}async mb(t,o,n,c){return n.writeFile(c,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(t,o,n,c){return this.cb.queueFor(c,()=>this.ob(t,o,n,c),this.R(n).providerExtUri)}async ob(t,o,n,c){const h=await n.open(c,{create:!0,unlock:!1});try{const P=await t.readFile(o);await this.gb(n,h,E.$Qe.wrap(P),P.byteLength,0,0)}catch(P){throw(0,v.$rl)(P)}finally{await n.close(h)}}async pb(t,o,n,c){const h=await(0,E.$3e)(this.H(t,o,D.CancellationToken.None));await this.hb(n,c,void 0,h)}qb(t,o){if(t.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$yl((0,d.localize)(1894,null,this.sb(o)),v.FileOperationResult.FILE_PERMISSION_DENIED);return t}rb(t,o){if((o.permissions??0)&v.FilePermission.Readonly)throw new v.$yl((0,d.localize)(1895,null,this.sb(t)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(t){return t.scheme===u.Schemas.file?t.fsPath:t.toString(!0)}};e.$8q=s,e.$8q=s=k=ke([re(0,$.$dk)],s)}),define(le[102],ue([0,1,26,8,31,17,4,32,2,9,3,18,69,23,10,14,126,191,187,186]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class k extends y.$hr{static{this.L=!1}constructor(a,t){super(a,t),this.onDidChangeCapabilities=O.Event.None,this.P=new E.$Dc(o=>u.$ah.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,g.$l&&(this.M|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:t,symbolicLink:o}=await p.SymlinkSupport.stat(this.I(a));return{type:this.O(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:d.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const t=await p.Promises.readdir(this.I(a),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async n=>{try{let c;n.isSymbolicLink()?c=(await this.stat((0,u.$jh)(a,n.name))).type:c=this.O(n),o.push([n.name,c])}catch(c){this.a.trace(c)}})),o}catch(t){throw this.hb(t)}}O(a,t){let o;return t?.dangling?o=d.FileType.Unknown:a.isFile()?o=d.FileType.File:a.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,t&&(o|=d.FileType.SymbolicLink),o}async Q(a){const t=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const n=new r.$Hh;return this.P.set(a,n),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,b.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(a)===n&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),n.open()})}async readFile(a,t){let o;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),o=await this.Q(a));const n=this.I(a);return await i.promises.readFile(n)}catch(n){throw this.hb(n)}finally{o?.dispose()}}R(a){k.L&&this.a.trace(a)}readFileStream(a,t,o){const n=(0,m.$Ee)(c=>D.$Qe.concat(c.map(h=>D.$Qe.wrap(h))).buffer);return(0,v.$7q)(this,a,n,c=>c.buffer,{...t,bufferSize:256*1024},o),n}async writeFile(a,t,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(a)?this.U(a,(0,u.$jh)((0,u.$ih)(a),`${(0,u.$gh)(a)}${o.atomic.postfix}`),t,o):this.W(a,t,o)}async S(a){try{const t=this.I(a),{symbolicLink:o}=await p.SymlinkSupport.stat(t);if(o)return!1}catch{}return!0}async U(a,t,o,n){const c=new b.$Wc;try{c.add(await this.Q(a)),c.add(await this.Q(t)),await this.W(t,o,n,!0);try{await this.rename(t,a,{overwrite:!0})}catch(h){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw h}}finally{c.dispose()}}async W(a,t,o,n){let c;try{const h=this.I(a);if(!o.create||!o.overwrite){if(await p.Promises.exists(h)){if(!o.overwrite)throw(0,d.$ql)((0,f.localize)(1899,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.$ql)((0,f.localize)(1900,null),d.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(a,{create:!0,unlock:o.unlock},n),await this.write(c,0,t,0,t.byteLength)}catch(h){throw await this.ib(a,h)}finally{typeof c=="number"&&await this.close(c)}}static{this.$=!0}static configureFlushOnWrite(a){k.$=a}async open(a,t,o){const n=this.I(a);let c;(0,d.$el)(t)&&!o&&(c=await this.Q(a));let h;try{if((0,d.$el)(t)&&t.unlock)try{const{stat:w}=await p.SymlinkSupport.stat(n);w.mode&128||await i.promises.chmod(n,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let P;if((0,d.$el)(t)){if(g.$j)try{await i.promises.truncate(n,0),P="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}P||(P="w")}else P="r";h=await p.Promises.open(n,P)}catch(P){throw c?.dispose(),(0,d.$el)(t)?await this.ib(a,P):this.hb(P)}if(this.X.set(h,0),(0,d.$el)(t)&&this.Z.set(h,a),c){const P=this.Y.get(h);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${n})`),this.Y.set(h,c),P&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${n})`),P.dispose())}return h}async close(a){const t=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&k.$)try{await p.Promises.fdatasync(a)}catch(o){k.configureFlushOnWrite(!1),this.a.error(o)}return await p.Promises.close(a)}catch(o){throw this.hb(o)}finally{t&&(this.Y.get(a)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),t.dispose())}}async read(a,t,o,n,c){const h=this.ab(a,t);let P=null;try{P=(await p.Promises.read(a,o,n,c,h)).bytesRead}catch(w){throw this.hb(w)}finally{this.bb(a,h,P)}return P}ab(a,t){return t===this.X.get(a)?null:t}bb(a,t,o){const n=this.X.get(a);typeof n=="number"&&(typeof t=="number"||(typeof o=="number"?this.X.set(a,n+o):this.X.delete(a)))}async write(a,t,o,n,c){return(0,r.$3h)(()=>this.cb(a,t,o,n,c),100,3)}async cb(a,t,o,n,c){const h=this.ab(a,t);let P=null;try{P=(await p.Promises.write(a,o,n,c,h)).bytesWritten}catch(w){throw await this.ib(this.Z.get(a),w)}finally{this.bb(a,h,P)}return P}async mkdir(a){try{await i.promises.mkdir(this.I(a))}catch(t){throw this.hb(t)}}async delete(a,t){try{const o=this.I(a);if(t.recursive){let n;t?.atomic!==!1&&t.atomic.postfix&&(n=(0,l.$mc)((0,l.$pc)(o),`${(0,l.$qc)(o)}${t.atomic.postfix}`)),await p.Promises.rm(o,p.RimRafMode.MOVE,n)}else try{await i.promises.unlink(o)}catch(n){if(n.code==="EPERM"||n.code==="EISDIR"){let c=!1;try{const{stat:h,symbolicLink:P}=await p.SymlinkSupport.stat(o);c=h.isDirectory()&&!P}catch{}if(c)await i.promises.rmdir(o);else throw n}else throw n}}catch(o){throw this.hb(o)}}async rename(a,t,o){const n=this.I(a),c=this.I(t);if(n!==c)try{await this.db(a,t,"move",o.overwrite),await p.Promises.rename(n,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,f.localize)(1901,null,(0,l.$qc)(n),(0,l.$qc)((0,l.$pc)(c)),h.toString()))),this.hb(h)}}async copy(a,t,o){const n=this.I(a),c=this.I(t);if(n!==c)try{await this.db(a,t,"copy",o.overwrite),await p.Promises.copy(n,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,f.localize)(1902,null,(0,l.$qc)(n),(0,l.$qc)((0,l.$pc)(c)),h.toString()))),this.hb(h)}}async db(a,t,o,n){const c=this.I(a),h=this.I(t);let P=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(P=(0,I.$Gg)(c,h,!0)),P){if(o==="copy")throw(0,d.$ql)((0,f.localize)(1903,null),d.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const R=await this.N(a);if(!R)throw(0,d.$ql)((0,f.localize)(1904,null),d.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(t);if(L){if(!n)throw(0,d.$ql)((0,f.localize)(1905,null),d.FileSystemProviderErrorCode.FileExists);R.type&d.FileType.File&&L.type&d.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,t){return this.eb(a,t,!1)}async eb(a,t,o){const n=this.I(a),c=this.I(t),h=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Gg)(n,c,!h))return;const P=new b.$Wc;try{P.add(await this.Q(a)),P.add(await this.Q(t)),o&&await i.promises.mkdir((0,l.$pc)(c),{recursive:!0}),await i.promises.copyFile(n,c)}catch(w){if(w.code==="ENOENT"&&!o)return this.eb(a,t,!0);throw this.hb(w)}finally{P.dispose()}}t(a,t,o){return new $.$or(n=>a(n),n=>t(n),o)}F(a,t,o){return new S.$xr(n=>a(n),n=>t(n),o)}hb(a){if(a instanceof d.$pl)return a;let t=a,o;switch(a.code){case"ENOENT":o=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=d.FileSystemProviderErrorCode.Unknown;break;default:o=d.FileSystemProviderErrorCode.Unknown}return(0,d.$ql)(t,o)}async ib(a,t){let o=this.hb(t);if(a&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:n}=await p.SymlinkSupport.stat(this.I(a));n.mode&128||(o=(0,d.$ql)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(n){this.a.trace(n)}return o}}e.$yr=k}),define(le[193],ue([0,1,4,102,2,17,69,22]),function(K,e,i,r,E,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=void 0;class b extends E.$Xc{constructor(u,m){super(),this.a=u,this.b=m,this.F=new Map,this.G=new Map}call(u,m,p){const f=this.c(u);switch(m){case"stat":return this.g(f,p[0]);case"readdir":return this.h(f,p[0]);case"open":return this.r(f,p[0],p[1]);case"close":return this.s(p[0]);case"read":return this.t(p[0],p[1],p[2]);case"readFile":return this.j(f,p[0],p[1]);case"write":return this.u(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.n(f,p[0],p[1],p[2]);case"rename":return this.z(f,p[0],p[1],p[2]);case"copy":return this.C(f,p[0],p[1],p[2]);case"cloneFile":return this.D(f,p[0],p[1]);case"mkdir":return this.w(f,p[0]);case"delete":return this.y(f,p[0],p[1]);case"watch":return this.I(f,p[0],p[1],p[2],p[3]);case"unwatch":return this.J(p[0],p[1])}throw new Error(`IPC Command ${m} not found`)}listen(u,m,p){const f=this.c(u);switch(m){case"fileChange":return this.H(f,p[0]);case"readFileStream":return this.m(f,p[0],p[1])}throw new Error(`Unknown event ${m}`)}g(u,m){const p=this.f(u,m,!0);return this.a.stat(p)}h(u,m){const p=this.f(u,m);return this.a.readdir(p)}async j(u,m,p){const f=this.f(u,m,!0),d=await this.a.readFile(f,p);return D.$Qe.wrap(d)}m(u,m,p){const f=this.f(u,m,!0),d=new I.$ze,v=new i.$oe({onDidRemoveLastListener:()=>{d.cancel()}}),y=this.a.readFileStream(f,p,d.token);return(0,O.$Ie)(y,{onData:$=>v.fire(D.$Qe.wrap($)),onError:$=>v.fire($),onEnd:()=>{v.fire("end"),v.dispose(),d.dispose()}}),v.event}n(u,m,p,f){const d=this.f(u,m);return this.a.writeFile(d,p.buffer,f)}r(u,m,p){const f=this.f(u,m,!0);return this.a.open(f,p)}s(u){return this.a.close(u)}async t(u,m,p){const f=D.$Qe.alloc(p),v=await this.a.read(u,m,f.buffer,0,p);return[f,v]}u(u,m,p,f,d){return this.a.write(u,m,p.buffer,f,d)}w(u,m){const p=this.f(u,m);return this.a.mkdir(p)}y(u,m,p){const f=this.f(u,m);return this.a.delete(f,p)}z(u,m,p,f){const d=this.f(u,m),v=this.f(u,p);return this.a.rename(d,v,f)}C(u,m,p,f){const d=this.f(u,m),v=this.f(u,p);return this.a.copy(d,v,f)}D(u,m,p){const f=this.f(u,m),d=this.f(u,p);return this.a.cloneFile(f,d)}H(u,m){const p=new i.$oe({onWillAddFirstListener:()=>{this.F.set(m,this.L(u,p))},onDidRemoveLastListener:()=>{(0,E.$Sc)(this.F.get(m)),this.F.delete(m)}});return p.event}async I(u,m,p,f,d){const v=this.F.get(m);if(v){const y=this.f(u,f),$=v.watch(p,y,d);this.G.set(m+p,$)}}async J(u,m){const p=u+m,f=this.G.get(p);f&&((0,E.$Sc)(f),this.G.delete(p))}dispose(){super.dispose();for(const[,u]of this.G)u.dispose();this.G.clear();for(const[,u]of this.F)u.dispose();this.F.clear()}}e.$9s=b;class l extends E.$Xc{constructor(u,m,p,f){super(),this.c=u,this.f=p,this.g=f,this.a=new Map,this.b=this.B(new r.$yr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(m)}h(u){const m=this.B(new i.$oe);this.B(m.event(p=>{u.fire(p.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(p=>m.fire(p))),this.B(this.b.onDidWatchError(p=>u.fire(p)))}j(u){}m(u){}watch(u,m,p){const f=this.m(this.g);return Array.isArray(f)&&(p.excludes=[...p.excludes,...f]),this.a.set(u,this.b.watch(m,p)),(0,E.$Vc)(()=>{(0,E.$Sc)(this.a.get(u)),this.a.delete(u)})}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),super.dispose()}}e.$0s=l}),define(le[194],ue([0,1,13,10,3,7,14,9,193,154,55]),function(K,e,i,r,E,D,O,I,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class u extends b.$9s{constructor(f,d,v){super(f,d),this.M=v}c(f){return l.$Qn}f(f,d){return D.URI.revive(d)}async y(f,d,v){if(!v.useTrash)return super.y(f,d,v);const y=this.f(f,d),$=(0,I.$kc)(y.fsPath);try{await i.shell.trashItem($)}catch(S){throw(0,O.$ql)(E.$j?(0,r.localize)(1897,null,(0,I.$qc)($),(0,g.$tj)(S)):(0,r.localize)(1898,null,(0,I.$qc)($),(0,g.$tj)(S)),O.FileSystemProviderErrorCode.Unknown)}}L(f,d){return new m(f,d,this.b,this.M)}}e.$zhc=u;class m extends b.$0s{watch(f,d,v){if(v.recursive)throw(0,O.$ql)("Recursive file watching is not supported from main process for performance reasons.",O.FileSystemProviderErrorCode.Unavailable);return super.watch(f,d,v)}}}),define(le[195],ue([0,1,5]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class r extends i.$jk{constructor(D=i.$gk){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(O=>{this.n?.setLevel(O)}))}set logger(D){this.n=D;for(const{level:O,message:I}of this.m)(0,i.log)(D,O,I);this.m=[]}g(D,O){this.n?(0,i.log)(this.n,D,O):this.getLevel()<=D&&this.m.push({level:D,message:O})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$eec=r}),define(le[196],ue([0,1,7,4,5,2]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.$ys=void 0;class O extends E.$ok{constructor(u,m,p,f,d){super(m,p,f),this.r=u,this.t=d,this.B(d.listen("onDidChangeLogLevel",u)(v=>{(0,E.$fk)(v)?super.setLogLevel(v):super.setLogLevel(i.URI.revive(v[0]),v[1])})),this.B(d.listen("onDidChangeVisibility",u)(([v,y])=>super.setVisibility(i.URI.revive(v),y))),this.B(d.listen("onDidChangeLoggers",u)(({added:v,removed:y})=>{for(const $ of v)super.registerLogger({...$,resource:i.URI.revive($.resource)});for(const $ of y)super.deregisterLogger($.resource)}))}createConsoleMainLogger(){return new E.$mk({log:(u,m)=>{this.t.call("consoleLog",[u,m])}})}registerLogger(u){super.registerLogger(u),this.t.call("registerLogger",[u,this.r])}deregisterLogger(u){super.deregisterLogger(u),this.t.call("deregisterLogger",[u,this.r])}setLogLevel(u,m){super.setLogLevel(u,m),this.t.call("setLogLevel",[u,m])}setVisibility(u,m){super.setVisibility(u,m),this.t.call("setVisibility",[this.n(u),m])}s(u,m,p){return new I(this.t,u,m,p,this.r)}static setLogLevel(u,m,p){return u.call("setLogLevel",[m,p])}}e.$ys=O;class I extends E.$jk{constructor(u,m,p,f,d){super(f?.logLevel==="always"),this.r=u,this.s=m,this.m=!1,this.n=[],this.setLevel(p),this.r.call("createLogger",[m,f,d]).then(()=>{this.u(this.n),this.m=!0})}g(u,m){const p=[[u,m]];this.m?this.u(p):this.n.push(...p)}u(u){this.r.call("log",[this.s,u])}}class b{constructor(u,m){this.a=u,this.b=m}listen(u,m){const p=this.b(u);switch(m){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(d=>this.c(d,p)),removed:[...f.removed].map(d=>this.c(d,p))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,f=>[p.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,f=>(0,E.$fk)(f)?f:[p.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${m}`)}async call(u,m,p){const f=this.b(u);switch(m){case"setLogLevel":return(0,E.$fk)(p[0])?this.a.setLogLevel(p[0]):this.a.setLogLevel(i.URI.revive(f.transformIncoming(p[0][0])),p[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(d=>this.c(d,f)))}throw new Error(`Call not found: ${m}`)}c(u,m){return{...u,resource:m.transformOutgoingURI(u.resource)}}}e.$zs=b;class l extends D.$Xc{constructor(u,m){super(),m.call("setLogLevel",[u.getLogLevel()]),this.B(u.onDidChangeLogLevel(p=>m.call("setLogLevel",[p]))),m.call("getRegisteredLoggers").then(p=>{for(const f of p)u.registerLogger({...f,resource:i.URI.revive(f.resource)})}),this.B(m.listen("onDidChangeVisibility")(([p,f])=>u.setVisibility(i.URI.revive(p),f))),this.B(m.listen("onDidChangeLoggers")(({added:p,removed:f})=>{for(const d of p)u.registerLogger({...d,resource:i.URI.revive(d.resource)});for(const d of f)u.deregisterLogger(d.resource)}))}}e.$As=l}),define(le[197],ue([0,1,2,5]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class E extends i.$Xc{constructor(O,I=[]){super(),this.a=new r.$nk([O,...I]),this.B(O.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$4R=E}),define(le[198],ue([0,1,31,7,5]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;class D{constructor(I){this.b=I,this.a=new i.$Dc}listen(I,b,l){switch(b){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${b}`)}async call(I,b,l){switch(b){case"createLogger":this.c(r.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(r.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,E.$fk)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(r.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:r.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(l[0]))}throw new Error(`Call not found: ${b}`)}c(I,b,l){this.a.set(I,this.b.createLogger(I,b,l))}d(I,b){let l=console.log;switch(I){case E.LogLevel.Error:l=console.error;break;case E.LogLevel.Warning:l=console.warn;break;case E.LogLevel.Info:l=console.info;break}l.call(console,...b)}e(I,b){const l=this.a.get(I);if(!l)throw new Error("Create the logger before logging");for(const[g,u]of b)(0,E.log)(l,g,u)}}e.$xic=D}),define(le[199],ue([0,1,14,5]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0;var E;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(E||(E={}));async function D(l,g,u,m,p){try{const f=await new Promise((v,y)=>{K(["@vscode/spdlog"],v,y)}).then(Ie);f.setFlushOn(E.Trace);const d=await f.createAsyncRotatingLogger(l,g,u,m);return p?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(f){console.error(f)}return null}function O(l,g,u){switch(g){case r.LogLevel.Trace:l.trace(u);break;case r.LogLevel.Debug:l.debug(u);break;case r.LogLevel.Info:l.info(u);break;case r.LogLevel.Warning:l.warn(u);break;case r.LogLevel.Error:l.error(u);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function I(l,g){switch(g){case r.LogLevel.Trace:l.setLevel(E.Trace);break;case r.LogLevel.Debug:l.setLevel(E.Debug);break;case r.LogLevel.Info:l.setLevel(E.Info);break;case r.LogLevel.Warning:l.setLevel(E.Warning);break;case r.LogLevel.Error:l.setLevel(E.Error);break;case r.LogLevel.Off:l.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class b extends r.$jk{constructor(g,u,m,p,f){super(),this.m=[],this.setLevel(f),this.n=this.s(g,u,m,p),this.B(this.onDidChangeLogLevel(d=>{this.r&&I(this.r,d)}))}async s(g,u,m,p){const f=m?6:1,d=30/f*i.$Ll.MB,v=await D(g,u,d,f,p);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:y,message:$}of this.m)O(this.r,y,$);this.m=[]}}g(g,u){this.r?O(this.r,g,u):this.getLevel()<=g&&this.m.push({level:g,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$SR=b}),define(le[200],ue([0,1,33,5,199]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0;class D extends r.$ok{s(I,b,l){return new E.$SR((0,i.$5g)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,b)}}e.$TR=D}),define(le[73],ue([0,1,31,4,6,5,200]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=e.$6gc=void 0,e.$6gc=(0,E.$Ji)(D.$ek);class I extends O.$TR{constructor(){super(...arguments),this.u=new i.$Dc}createLogger(l,g,u){u!==void 0&&this.u.set(this.n(l),u);try{return super.createLogger(l,g)}catch(m){throw this.u.delete(this.n(l)),m}}registerLogger(l,g){g!==void 0&&this.u.set(l.resource,g),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const g=[];for(const u of super.getRegisteredLoggers())l===this.u.get(u.resource)&&g.push(u);return g}getOnDidChangeLogLevelEvent(l){return r.Event.filter(this.onDidChangeLogLevel,g=>(0,D.$fk)(g)||this.w(g[0],l))}getOnDidChangeVisibilityEvent(l){return r.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,l))}getOnDidChangeLoggersEvent(l){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(m=>this.w(m.resource,l)),removed:[...g.removed].filter(m=>this.w(m.resource,l))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(l){for(const[g,u]of this.u)u===l&&this.deregisterLogger(g)}w(l,g){const u=this.u.get(l);return u===void 0||u===g}dispose(){super.dispose(),this.u.clear()}}e.$7gc=I}),define(le[201],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=i,e.$Ohc=r,e.$Phc=E,e.$Qhc=D;function i(O){return O.submenu!==void 0}function r(O){return O.id==="vscode.menubar.separator"}function E(O){return O.uri!==void 0}function D(O){return!i(O)&&!r(O)&&!E(O)}}),define(le[40],ue([0,1,4,78,2,6]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=void 0,e.$wo=(0,D.$Ii)("policy");class O extends E.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$oe),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const g=Object.keys(this.f).length;return this.f={...l,...this.f},g!==Object.keys(this.f).length&&await this.j(l),r.Iterable.reduce(this.g.entries(),(u,[m,p])=>({...u,[m]:p}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(l,[g,u])=>({...l,[g]:{definition:u,value:this.g.get(g)}}),{})}}e.$xo=O;class I{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$yo=I}),define(le[202],ue([0,1,8,4,78,12,14,5,40]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;function l(u,m){const p=[];for(const f of new Set(E.Iterable.concat(u.keys(),m.keys())))u.get(f)!==m.get(f)&&p.push(f);return p}let g=class extends b.$xo{constructor(m,p,f){super(),this.m=m,this.n=p,this.s=f,this.c=this.B(new i.$Gh(500));const d=r.Event.filter(p.onDidFilesChange,v=>v.affects(m));this.B(p.watch(m)),this.B(d(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const p=await this.n.readFile(this.m),f=JSON.parse(p.value.toString());if(!(0,D.$jg)(f))throw new Error("Policy file isn't a JSON object");for(const d of Object.keys(f))this.f[d]&&m.set(d,f[d])}catch(p){p.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",p)}return m}async w(){const m=await this.u(),p=l(this.g,m);this.g=m,p.length>0&&this.h.fire(p)}};e.$Qic=g,e.$Qic=g=ke([re(1,O.$dl),re(2,I.$dk)],g)}),define(le[203],ue([0,1,4,2,40]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0;class D{constructor(b){this.b=b,this.a=new r.$Wc}listen(b,l){switch(l){case"onDidChange":return i.Event.map(this.b.onDidChange,g=>g.reduce((u,m)=>({...u,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$mic=D;class O extends E.$xo{constructor(b,l){super(),this.a=l;for(const g in b){const{definition:u,value:m}=b[g];this.f[g]=u,m!==void 0&&this.g.set(g,m)}this.a.listen("onDidChange")(g=>{for(const u in g){const m=g[u];m===null?this.g.delete(u):this.g.set(u,m)}this.h.fire(Object.keys(g))})}async j(b){const l=await this.a.call("updatePolicyDefinitions",b);for(const g in l)this.g.set(g,l[g])}}e.$nic=O}),define(le[204],ue([0,1,40,8,2,5]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;let O=class extends i.$xo{constructor(b,l){super(),this.m=b,this.n=l,this.a=new r.$Ch,this.b=this.B(new E.$Yc)}async j(b){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(b).length} policy definitions`);const{createWatcher:l}=await new Promise((g,u)=>{K(["@vscode/policy-watcher"],g,u)}).then(Ie);await this.a.queue(()=>new Promise((g,u)=>{try{this.b.value=l(this.n,b,m=>{this.t(m),g()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),u(m)}}))}t(b){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(b)}`);for(const l in b){const g=b[l];g===void 0?this.g.delete(l):this.g.set(l,g)}this.h.fire(Object.keys(b))}};e.$Pic=O,e.$Pic=O=ke([re(0,D.$dk)],O)}),define(le[63],ue([0,1,37]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const D=E.context.configuration();if(D)r=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:D.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(le[28],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,i.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"}),define(le[205],ue([0,1,8,5]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;let E=class{constructor(O,I,b){this.a=O,this.b=I,this.c=b}async inspect(O){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$Jh)(O);const b=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),b.profile}async d(){const O=this.a.webContents.debugger;O.attach(),await O.sendCommand("Profiler.enable")}async e(){const O=this.a.webContents.debugger;await O.sendCommand("Profiler.disable"),O.detach()}};e.$Chc=E,e.$Chc=E=ke([re(2,r.$dk)],E)}),define(le[74],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0,e.$Ogc=(0,i.$Ii)("protocolMainService")}),define(le[46],ue([0,1,143,12]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=void 0,i=Ie(i),r=Ie(r);class E{constructor(){this.a=new Map}add(O,I){i.ok(r.$hg(O)),i.ok(r.$jg(I)),i.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$uo=new E}),define(le[206],ue([0,1,4,145,46]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,E=Ie(E),e.$vo={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class O{constructor(){this.b=new i.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,g){this.a[D(l)]=g,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(l){const g=this.a[l];return g?(0,r.$$j)(g):void 0}hasSchemaContent(l){return!!this.a[l]}}const I=new O;E.$uo.add(e.$vo.JSONContribution,I)}),define(le[56],ue([0,1,21,4,12,10,16,206,46]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ConfigurationScope=e.$zo=e.EditPresentationTypes=void 0,e.$Ko=d,e.$Lo=v,e.$Mo=y,e.$No=S,e.$Oo=k,e.$Po=s,e.$Qo=a,E=Ie(E),D=Ie(D);var l;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$zo={Configuration:"base.contributions.configuration"};var g;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go="vscode://schemas/settings/resourceLanguage",e.$Ho="vscode://schemas/settings/configurationDefaults";const u=b.$uo.as(I.$vo.JSONContribution);class m{constructor(){this.a=[],this.i=new Set,this.j=new r.$oe,this.onDidSchemaChange=this.j.event,this.k=new r.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:D.localize(1660,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},u.registerSchema(e.$Go,this.h),this.z()}registerConfiguration(o,n=!0){this.registerConfigurations([o],n)}registerConfigurations(o,n=!0){const c=new Set;this.r(o,n,c),u.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:c})}deregisterConfigurations(o){const n=new Set;this.s(o,n),u.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:n})}updateConfigurations({add:o,remove:n}){const c=new Set;this.s(n,c),this.r(o,!1,c),u.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:c})}registerDefaultConfigurations(o){const n=new Set;this.l(o,n),this.j.fire(),this.k.fire({properties:n,defaultsOverrides:!0})}l(o,n){this.a.push(...o);const c=[];for(const{overrides:h,source:P}of o)for(const w in h){n.add(w);const R=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),L=h[w];if(R.configurationDefaultOverrides.push({value:L,source:P}),e.$Jo.test(w)){const A=this.o(w,L,P,R.configurationDefaultOverrideValue);if(!A)continue;R.configurationDefaultOverrideValue=A,this.n(w,A,P),c.push(...d(w))}else{const A=this.p(w,L,P,R.configurationDefaultOverrideValue);if(!A)continue;R.configurationDefaultOverrideValue=A;const T=this.e[w];T&&(this.A(w,T),this.w(w,T))}}this.q(c)}deregisterDefaultConfigurations(o){const n=new Set;this.m(o,n),this.j.fire(),this.k.fire({properties:n,defaultsOverrides:!0})}m(o,n){for(const c of o){const h=this.a.indexOf(c);h!==-1&&this.a.splice(h,1)}for(const{overrides:c,source:h}of o)for(const P in c){const w=this.b.get(P);if(!w)continue;const R=w.configurationDefaultOverrides.findIndex(L=>h?L.source?.id===h.id:L.value===c[P]);if(R!==-1){if(w.configurationDefaultOverrides.splice(R,1),w.configurationDefaultOverrides.length===0&&this.b.delete(P),e.$Jo.test(P)){let L;for(const A of w.configurationDefaultOverrides)L=this.o(P,A.value,A.source,L);L&&!E.$ug(L.value)?(w.configurationDefaultOverrideValue=L,this.n(P,L,h)):(this.b.delete(P),delete this.e[P],delete this.c.properties[P])}else{let L;for(const T of w.configurationDefaultOverrides)L=this.p(P,T.value,T.source,L);w.configurationDefaultOverrideValue=L;const A=this.e[P];A&&(this.A(P,A),this.w(P,A))}n.add(P)}}this.y()}n(o,n,c){const h={type:"object",default:n.value,description:D.localize(1661,null,(0,O.$mj)(o)),$ref:e.$Go,defaultDefaultValue:n.value,source:c,defaultValueSource:c};this.e[o]=h,this.c.properties[o]=h}o(o,n,c,h){const P=h?.value||{},w=h?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const R of Object.keys(n)){const L=n[R];if(E.$jg(L)&&(E.$og(P[R])||E.$jg(P[R]))){if(P[R]={...P[R]??{},...L},c)for(const T in L)w.set(`${R}.${T}`,c)}else P[R]=L,c?w.set(R,c):w.delete(R)}return{value:P,source:w}}p(o,n,c,h){const P=this.e[o],w=h?.value??P?.defaultDefaultValue;let R=c;if(E.$jg(n)&&(P!==void 0&&P.type==="object"||P===void 0&&(E.$og(w)||E.$jg(w)))){if(R=h?.source??new Map,!(R instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in n)c&&R.set(`${o}.${A}`,c);n={...E.$jg(w)?w:{},...n}}return{value:n,source:R}}deltaConfiguration(o){let n=!1;const c=new Set;o.removedDefaults&&(this.m(o.removedDefaults,c),n=!0),o.addedDefaults&&(this.l(o.addedDefaults,c),n=!0),o.removedConfigurations&&this.s(o.removedConfigurations,c),o.addedConfigurations&&this.r(o.addedConfigurations,!1,c),this.j.fire(),this.k.fire({properties:c,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const n of o)this.i.add(n);this.y()}r(o,n,c){o.forEach(h=>{this.u(h,n,h.extensionInfo,h.restrictedProperties,void 0,c),this.d.push(h),this.v(h)})}s(o,n){const c=h=>{if(h.properties)for(const P in h.properties){n.add(P);const w=this.e[P];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[P],this.x(P,h.properties[P])}h.allOf?.forEach(P=>c(P))};for(const h of o){c(h);const P=this.d.indexOf(h);P!==-1&&this.d.splice(P,1)}}u(o,n=!0,c,h,P=g.WINDOW,w){P=E.$qg(o.scope)?P:o.scope;const R=o.properties;if(R)for(const A in R){const T=R[A];if(n&&S(A,T)){delete R[A];continue}if(T.source=c,T.defaultDefaultValue=R[A].default,this.A(A,T),e.$Jo.test(A)?T.scope=void 0:(T.scope=E.$qg(T.scope)?P:T.scope,T.restricted=E.$qg(T.restricted)?!!h?.includes(A):T.restricted),R[A].hasOwnProperty("included")&&!R[A].included){this.g[A]=R[A],delete R[A];continue}else this.e[A]=R[A],R[A].policy?.name&&this.f.set(R[A].policy.name,A);!R[A].deprecationMessage&&R[A].markdownDeprecationMessage&&(R[A].deprecationMessage=R[A].markdownDeprecationMessage),w.add(A)}const L=o.allOf;if(L)for(const A of L)this.u(A,n,c,h,P,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[n,c]of this.b)c.configurationDefaultOverrideValue&&o.set(n,c.configurationDefaultOverrideValue);return o}v(o){const n=c=>{const h=c.properties;if(h)for(const w in h)this.w(w,h[w]);c.allOf?.forEach(n)};n(o)}w(o,n){switch(e.$Ao.properties[o]=n,n.scope){case g.APPLICATION:e.$Bo.properties[o]=n;break;case g.MACHINE:e.$Co.properties[o]=n;break;case g.MACHINE_OVERRIDABLE:e.$Do.properties[o]=n;break;case g.WINDOW:e.$Eo.properties[o]=n;break;case g.RESOURCE:e.$Fo.properties[o]=n;break;case g.LANGUAGE_OVERRIDABLE:e.$Fo.properties[o]=n,this.h.properties[o]=n;break}}x(o,n){switch(delete e.$Ao.properties[o],n.scope){case g.APPLICATION:delete e.$Bo.properties[o];break;case g.MACHINE:delete e.$Co.properties[o];break;case g.MACHINE_OVERRIDABLE:delete e.$Do.properties[o];break;case g.WINDOW:delete e.$Eo.properties[o];break;case g.RESOURCE:case g.LANGUAGE_OVERRIDABLE:delete e.$Fo.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const n=`[${o}]`,c={type:"object",description:D.localize(1662,null),errorMessage:D.localize(1663,null),$ref:e.$Go};this.A(n,c),e.$Ao.properties[n]=c,e.$Bo.properties[n]=c,e.$Co.properties[n]=c,e.$Do.properties[n]=c,e.$Eo.properties[n]=c,e.$Fo.properties[n]=c}}z(){const o={type:"object",description:D.localize(1664,null),errorMessage:D.localize(1665,null),$ref:e.$Go};e.$Ao.patternProperties[e.$Io]=o,e.$Bo.patternProperties[e.$Io]=o,e.$Co.patternProperties[e.$Io]=o,e.$Do.patternProperties[e.$Io]=o,e.$Eo.patternProperties[e.$Io]=o,e.$Fo.patternProperties[e.$Io]=o,this.j.fire()}A(o,n){const c=this.b.get(o)?.configurationDefaultOverrideValue;let h,P;c&&(!n.disallowConfigurationDefault||!c.source)&&(h=c.value,P=c.source),E.$og(h)&&(h=n.defaultDefaultValue,P=void 0),E.$og(h)&&(h=y(n.type)),n.default=h,n.defaultValueSource=P}}const p="\\[([^\\]]+)\\]",f=new RegExp(p,"g");e.$Io=`^(${p})+$`,e.$Jo=new RegExp(e.$Io);function d(t){const o=[];if(e.$Jo.test(t)){let n=f.exec(t);for(;n?.length;){const c=n[1].trim();c&&o.push(c),n=f.exec(t)}}return(0,i.$Ob)(o)}function v(t){return t.reduce((o,n)=>`${o}[${n}]`,"")}function y(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new m;b.$uo.add(e.$zo.Configuration,$);function S(t,o){return t.trim()?e.$Jo.test(t)?D.localize(1667,null,t):$.getConfigurationProperties()[t]!==void 0?D.localize(1668,null,t):o.policy?.name&&$.getPolicyConfigurations().get(o.policy?.name)!==void 0?D.localize(1669,null,t,o.policy?.name,$.getPolicyConfigurations().get(o.policy?.name)):null:D.localize(1666,null)}function k(){const t=[],o=$.getConfigurationProperties();for(const n of Object.keys(o))t.push([n,o[n].scope]);return t.push(["launch",g.RESOURCE]),t.push(["task",g.RESOURCE]),t}function s(t){const o={};for(const n of t){const c=n.properties;if(E.$jg(c))for(const h in c)o[h]=c[h];n.allOf&&Object.assign(o,s(n.allOf))}return o}function a(t){switch(t){case"application":return g.APPLICATION;case"machine":return g.MACHINE;case"resource":return g.RESOURCE;case"machine-overridable":return g.MACHINE_OVERRIDABLE;case"language-overridable":return g.LANGUAGE_OVERRIDABLE;default:return g.WINDOW}}}),define(le[127],ue([0,1,21,4,43,2,31,38,12,7,16,56,14,46]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Uo=e.$To=e.$So=e.$Ro=void 0,e.$Vo=k,i=Ie(i),E=Ie(E),I=Ie(I),b=Ie(b);function f(o){return Object.isFrozen(o)?o:I.$io(o)}class d{static createEmptyModel(n){return new d({},[],[],void 0,n)}constructor(n,c,h,P,w){this.b=n,this.c=c,this.d=h,this.raw=P,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(c=>{if(c instanceof d)return c;const h=new v("",this.f);return h.parseRaw(c),h.configurationModel});this.g=n.reduce((c,h)=>h===c?h:c.merge(h),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,g.$kj)(this.contents,n):this.contents}inspect(n,c){const h=this;return{get value(){return f(h.rawConfiguration.getValue(n))},get override(){return c?f(h.rawConfiguration.getOverrideValue(n,c)):void 0},get merged(){return f(c?h.rawConfiguration.override(c).getValue(n):h.rawConfiguration.getValue(n))},get overrides(){const P=[];for(const{contents:w,identifiers:R,keys:L}of h.rawConfiguration.overrides){const A=new d(w,L,[],void 0,h.f).getValue(n);A!==void 0&&P.push({identifiers:R,value:A})}return P.length?f(P):void 0}}}getOverrideValue(n,c){const h=this.j(c);return h?n?(0,g.$kj)(h,n):h:void 0}getKeysForOverrideIdentifier(n){const c=[];for(const h of this.overrides)h.identifiers.includes(n)&&c.push(...h.keys);return i.$Ob(c)}getAllOverrideIdentifiers(){const n=[];for(const c of this.overrides)n.push(...c.identifiers);return i.$Ob(n)}override(n){let c=this.a.get(n);return c||(c=this.h(n),this.a.set(n,c)),c}merge(...n){const c=I.$ho(this.contents),h=I.$ho(this.overrides),P=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const R of n)if(w.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(c,R.contents);for(const L of R.overrides){const[A]=h.filter(T=>i.$wb(T.identifiers,L.identifiers));A?(this.i(A.contents,L.contents),A.keys.push(...L.keys),A.keys=i.$Ob(A.keys)):h.push(I.$ho(L))}for(const L of R.keys)P.indexOf(L)===-1&&P.push(L)}return new d(c,P,h,w.every(R=>R instanceof d)?void 0:w,this.f)}h(n){const c=this.j(n);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const h={};for(const P of i.$Ob([...Object.keys(this.contents),...Object.keys(c)])){let w=this.contents[P];const R=c[P];R&&(typeof w=="object"&&typeof R=="object"?(w=I.$ho(w),this.i(w,R)):w=R),h[P]=w}return new d(h,this.keys,this.overrides,void 0,this.f)}i(n,c){for(const h of Object.keys(c)){if(h in n&&b.$jg(n[h])&&b.$jg(c[h])){this.i(n[h],c[h]);continue}n[h]=I.$ho(c[h])}}j(n){let c=null,h=null;const P=w=>{w&&(h?this.i(h,w):h=I.$ho(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===n?c=w.contents:w.identifiers.includes(n)&&P(w.contents);return P(c),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,c){this.k(n,c,!0)}setValue(n,c){this.k(n,c,!1)}removeValue(n){const c=this.keys.indexOf(n);c!==-1&&(this.keys.splice(c,1),(0,g.$jj)(this.contents,n),u.$Jo.test(n)&&this.overrides.splice(this.overrides.findIndex(h=>i.$wb(h.identifiers,(0,u.$Ko)(n))),1))}k(n,c,h){if((0,g.$ij)(this.contents,n,c,P=>this.f.error(P)),h=h||this.keys.indexOf(n)===-1,h&&this.keys.push(n),u.$Jo.test(n)){const P=(0,u.$Ko)(n),w={identifiers:P,keys:Object.keys(this.contents[n]),contents:(0,g.$hj)(this.contents[n],L=>this.f.error(L))},R=this.overrides.findIndex(L=>i.$wb(L.identifiers,P));R!==-1?this.overrides[R]=w:this.overrides.push(w)}}}e.$Ro=d;class v{constructor(n,c){this.f=n,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,c){if(!b.$qg(n)){const h=this.h(n);this.parseRaw(h,c)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,c){this.a=n;const{contents:h,keys:P,overrides:w,restricted:R,hasExcludedProperties:L}=this.i(n,c);this.b=new d(h,P,w,L?[n]:void 0,this.g),this.c=R||[]}h(n){let c={},h=null,P=[];const w=[],R=[];function L(T){Array.isArray(P)?P.push(T):h!==null&&(P[h]=T)}const A={onObjectBegin:()=>{const T={};L(T),w.push(P),P=T,h=null},onObjectProperty:T=>{h=T},onObjectEnd:()=>{P=w.pop()},onArrayBegin:()=>{const T=[];L(T),w.push(P),P=T,h=null},onArrayEnd:()=>{P=w.pop()},onLiteralValue:L,onError:(T,j,G)=>{R.push({error:T,offset:j,length:G})}};if(n)try{E.$9n(n,A),c=P[0]||{}}catch(T){this.g.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return c}i(n,c){const h=p.$uo.as(u.$zo.Configuration).getConfigurationProperties(),P=this.j(n,h,!0,c);n=P.raw;const w=(0,g.$hj)(n,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),R=Object.keys(n),L=this.l(n,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:w,keys:R,overrides:L,restricted:P.restricted,hasExcludedProperties:P.hasExcludedProperties}}j(n,c,h,P){let w=!1;if(!P?.scopes&&!P?.skipRestricted&&!P?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:w};const R={},L=[];for(const A in n)if(u.$Jo.test(A)&&h){const T=this.j(n[A],c,!1,P);R[A]=T.raw,w=w||T.hasExcludedProperties,L.push(...T.restricted)}else{const T=c[A],j=T?typeof T.scope<"u"?T.scope:u.ConfigurationScope.WINDOW:void 0;T?.restricted&&L.push(A),!P.exclude?.includes(A)&&(P.include?.includes(A)||(j===void 0||P.scopes===void 0||P.scopes.includes(j))&&!(P.skipRestricted&&T?.restricted))?R[A]=n[A]:w=!0}return{raw:R,restricted:L,hasExcludedProperties:w}}l(n,c){const h=[];for(const P of Object.keys(n))if(u.$Jo.test(P)){const w={};for(const R in n[P])w[R]=n[P][R];h.push({identifiers:(0,u.$Ko)(P),keys:Object.keys(w),contents:(0,g.$hj)(w,c)})}return h}}e.$So=v;class y extends D.$Xc{constructor(n,c,h,P,w){super(),this.c=n,this.f=c,this.g=P,this.h=w,this.b=this.B(new r.$oe),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),w),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(m.FileOperation.CREATE)||R.isOperation(m.FileOperation.COPY)||R.isOperation(m.FileOperation.DELETE)||R.isOperation(m.FileOperation.WRITE))&&h.isEqual(R.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$To=y;class ${constructor(n,c,h,P,w,R,L,A,T,j,G,q,Q){this.a=n,this.b=c,this.c=h,this.overrideIdentifiers=P,this.d=w,this.f=R,this.g=L,this.h=A,this.i=T,this.j=j,this.k=G,this.l=q,this.m=Q}get value(){return f(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class S{constructor(n,c,h,P,w,R,L,A,T,j){this.j=n,this.l=c,this.m=h,this.n=P,this.p=w,this.q=R,this.r=L,this.s=A,this.t=T,this.u=j,this.h=null,this.i=new O.$Dc,this.v=null}getValue(n,c,h){return this.w(n,c,h).getValue(n)}updateValue(n,c,h={}){let P;h.resource?(P=this.t.get(h.resource),P||(P=d.createEmptyModel(this.u),this.t.set(h.resource,P))):P=this.s,c===void 0?P.removeValue(n):P.setValue(n,c),h.resource||(this.h=null)}inspect(n,c,h){const P=this.w(n,c,h),w=this.A(c.resource,h),R=c.resource?this.t.get(c.resource)||this.s:this.s,L=new Set;for(const A of P.overrides)for(const T of A.identifiers)P.getOverrideValue(n,T)!==void 0&&L.add(T);return new $(n,c,P.getValue(n),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.q:void 0,w||void 0,R)}keys(n){const c=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,c){this.r.set(n,c),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,c){const h=[];if(!c){const{added:P,updated:w,removed:R}=a(this.j,n);c=[...P,...w,...R]}for(const P of c)for(const w of(0,u.$Ko)(P)){const R=this.j.getKeysForOverrideIdentifier(w),L=n.getKeysForOverrideIdentifier(w),A=[...L.filter(T=>R.indexOf(T)===-1),...R.filter(T=>L.indexOf(T)===-1),...R.filter(T=>!I.$lo(this.j.override(w).getValue(T),n.override(w).getValue(T)))];h.push([w,A])}return this.updateDefaultConfiguration(n),{keys:c,overrides:h}}compareAndUpdatePolicyConfiguration(n){const{added:c,updated:h,removed:P}=a(this.l,n),w=[...c,...h,...P];return w.length&&this.updatePolicyConfiguration(n),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.applicationConfiguration,n),R=[...c,...h,...P];return R.length&&this.updateApplicationConfiguration(n),{keys:R,overrides:w}}compareAndUpdateLocalUserConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.localUserConfiguration,n),R=[...c,...h,...P];return R.length&&this.updateLocalUserConfiguration(n),{keys:R,overrides:w}}compareAndUpdateRemoteUserConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.remoteUserConfiguration,n),R=[...c,...h,...P];return R.length&&this.updateRemoteUserConfiguration(n),{keys:R,overrides:w}}compareAndUpdateWorkspaceConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.workspaceConfiguration,n),R=[...c,...h,...P];return R.length&&this.updateWorkspaceConfiguration(n),{keys:R,overrides:w}}compareAndUpdateFolderConfiguration(n,c){const h=this.folderConfigurations.get(n),{added:P,updated:w,removed:R,overrides:L}=a(h,c),A=[...P,...w,...R];return(A.length||!h)&&this.updateFolderConfiguration(n,c),{keys:A,overrides:L}}compareAndDeleteFolderConfiguration(n){const c=this.folderConfigurations.get(n);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:h,updated:P,removed:w,overrides:R}=a(c,void 0);return{keys:[...h,...P,...w],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,c,h){let P=this.x(c,h);return c.overrideIdentifier&&(P=P.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(P=P.merge(this.l)),P}x({resource:n},c){let h=this.y();if(c&&n){const P=c.getFolder(n);P&&(h=this.z(P.uri)||h);const w=this.t.get(n);w&&(h=h.merge(w))}return h}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let c=this.i.get(n);if(!c){const h=this.y(),P=this.r.get(n);P?(c=h.merge(P),this.i.set(n,c)):c=h}return c}A(n,c){if(c&&n){const h=c.getFolder(n);if(h)return this.r.get(h.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,c)=>{const{contents:h,overrides:P,keys:w}=this.r.get(c);return n.push([c,{contents:h,overrides:P,keys:w}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(c=>n.add(c)),this.userConfiguration.keys.forEach(c=>n.add(c)),this.q.keys.forEach(c=>n.add(c)),this.r.forEach(c=>c.keys.forEach(h=>n.add(h))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(h=>n.add(h))),[...n.values()]}D(n){const c=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.q.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.r.forEach(h=>h.getKeysForOverrideIdentifier(n).forEach(P=>c.add(P))),[...c.values()]}static parse(n,c){const h=this.E(n.defaults,c),P=this.E(n.policy,c),w=this.E(n.application,c),R=this.E(n.user,c),L=this.E(n.workspace,c),A=n.folders.reduce((T,j)=>(T.set(l.URI.revive(j[0]),this.E(j[1],c)),T),new O.$Dc);return new S(h,P,w,R,d.createEmptyModel(c),L,A,d.createEmptyModel(c),new O.$Dc,c)}static E(n,c){return new d(n.contents,n.keys,n.overrides,void 0,c)}}e.$Uo=S;function k(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,c=new Map;for(const P of o)P.keys.forEach(w=>n.add(w)),P.overrides.forEach(([w,R])=>{const L=(0,O.$Ac)(c,w,new Set);R.forEach(A=>L.add(A))});const h=[];return c.forEach((P,w)=>h.push([w,[...P.values()]])),{keys:[...n.values()],overrides:h}}class s{constructor(n,c,h,P,w){this.change=n,this.f=c,this.g=h,this.h=P,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of n.keys)this.affectedKeys.add(R);for(const[,R]of n.overrides)for(const L of R)this.affectedKeys.add(L);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=S.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,c){const h=this.a+n,P=this.d.indexOf(h);if(P<0)return!1;const w=P+h.length;if(w>=this.d.length)return!1;const R=this.d.charCodeAt(w);if(R!==this.b&&R!==this.c)return!1;if(c){const L=this.previousConfiguration?this.previousConfiguration.getValue(n,c,this.f?.workspace):void 0,A=this.g.getValue(n,c,this.h);return!I.$lo(L,A)}return!0}}e.$Wo=s;function a(o,n){const{added:c,removed:h,updated:P}=t(n?.rawConfiguration,o?.rawConfiguration),w=[],R=o?.getAllOverrideIdentifiers()||[],L=n?.getAllOverrideIdentifiers()||[];if(n){const A=L.filter(T=>!R.includes(T));for(const T of A)w.push([T,n.getKeysForOverrideIdentifier(T)])}if(o){const A=R.filter(T=>!L.includes(T));for(const T of A)w.push([T,o.getKeysForOverrideIdentifier(T)])}if(n&&o){for(const A of R)if(L.includes(A)){const T=t({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:n.getOverrideValue(void 0,A)||{},keys:n.getKeysForOverrideIdentifier(A)});w.push([A,[...T.added,...T.removed,...T.updated]])}}return{added:c,removed:h,updated:P,overrides:w}}function t(o,n){const c=o?n?o.keys.filter(w=>n.keys.indexOf(w)===-1):[...o.keys]:[],h=n?o?n.keys.filter(w=>o.keys.indexOf(w)===-1):[...n.keys]:[],P=[];if(o&&n){for(const w of n.keys)if(o.keys.indexOf(w)!==-1){const R=(0,g.$kj)(n.contents,w),L=(0,g.$kj)(o.contents,w);I.$lo(R,L)||P.push(w)}}return{added:c,removed:h,updated:P}}}),define(le[207],ue([0,1,21,4,2,38,12,127,56,5,40,46]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=void 0;class m extends E.$Xc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new r.$oe),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ro.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$uo.as(b.$zo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:y})=>this.f(Array.from(v),y))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,y){this.j(v,u.$uo.as(b.$zo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Ro.createEmptyModel(this.c);const v=u.$uo.as(b.$zo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,y){const $=this.g();for(const S of v){const k=$[S],s=y[S];k!==void 0?this.b.setValue(S,k):s?this.b.setValue(S,s.default):this.b.removeValue(S)}}}e.$Xo=m;class p{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Ro.createEmptyModel(new l.$qk)}async initialize(){return this.configurationModel}}e.$Yo=p;let f=class extends E.$Xc{get configurationModel(){return this.b}constructor(v,y,$){super(),this.c=v,this.f=y,this.g=$,this.a=this.B(new r.$oe),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ro.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const y={},$=[],S=u.$uo.as(b.$zo.Configuration).getConfigurationProperties();for(const k of v){const s=S[k];if(!s){$.push(k);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}$.push(k),y[s.policy.name]={type:s.type}}}return(0,O.$ug)(y)||await this.f.updatePolicyDefinitions(y),$}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const y=u.$uo.as(b.$zo.Configuration).getPolicyConfigurations(),$=(0,i.$Jb)(v.map(S=>y.get(S)));this.m($,!0)}m(v,y){this.g.trace("PolicyConfiguration#update",v);const $=u.$uo.as(b.$zo.Configuration).getConfigurationProperties(),S=[],k=this.b.isEmpty();for(const s of v){const a=$[s]?.policy?.name;if(a){const t=this.f.getPolicyValue(a);(k?t!==void 0:!(0,D.$lo)(this.b.getValue(s),t))&&S.push([s,t])}else this.b.getValue(s)!==void 0&&S.push([s,void 0])}if(S.length){this.g.trace("PolicyConfiguration#changed",S);const s=this.b;this.b=I.$Ro.createEmptyModel(this.g);for(const a of s.keys)this.b.setValue(a,s.getValue(a));for(const[a,t]of S)t===void 0?this.b.removeValue(a):this.b.setValue(a,t);y&&this.a.fire(this.b)}}};e.$Zo=f,e.$Zo=f=ke([re(1,g.$wo),re(2,l.$dk)],f)}),define(le[208],ue([0,1,21,8,17,4,43,110,2,31,38,3,18,16,127,56,207,14,40]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0;class S extends b.$Xc{constructor(a,t,o,n){super(),this.m=a,this.n=n,this.h=this.B(new D.$oe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Xo(n)),this.c=o instanceof $.$yo?new v.$Yo:this.B(new v.$Zo(this.b,o,n)),this.f=this.B(new f.$To(this.m,{},m.$ah,t,n)),this.a=new f.$Uo(this.b.configurationModel,this.c.configurationModel,f.$Ro.createEmptyModel(n),f.$Ro.createEmptyModel(n),f.$Ro.createEmptyModel(n),f.$Ro.createEmptyModel(n),new l.$Dc,f.$Ro.createEmptyModel(n),new l.$Dc,n),this.j=new k(a,t,this),this.g=this.B(new r.$Uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:h})=>this.s(c,h))),this.B(this.c.onDidChangeConfiguration(c=>this.t(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Uo(a,t,f.$Ro.createEmptyModel(this.n),o,f.$Ro.createEmptyModel(this.n),f.$Ro.createEmptyModel(this.n),new l.$Dc,f.$Ro.createEmptyModel(this.n),new l.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const o=typeof a=="string"?a:void 0,n=(0,p.$dj)(a)?a:(0,p.$dj)(t)?t:{};return this.a.getValue(o,n,void 0)}async updateValue(a,t,o,n,c){const h=(0,p.$ej)(o)?o:(0,p.$dj)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,P=h?n:o;if(P!==void 0&&P!==p.ConfigurationTarget.USER_LOCAL&&P!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${P}.`);h?.overrideIdentifiers&&(h.overrideIdentifiers=(0,i.$Ob)(h.overrideIdentifiers),h.overrideIdentifiers=h.overrideIdentifiers.length?h.overrideIdentifiers:void 0);const w=this.inspect(a,{resource:h?.resource,overrideIdentifier:h?.overrideIdentifiers?h.overrideIdentifiers[0]:void 0});if(w.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,g.$lo)(t,w.defaultValue)&&(t=void 0),h?.overrideIdentifiers?.length&&h.overrideIdentifiers.length>1){const L=h.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(T=>(0,i.$wb)([...T.identifiers].sort(),L));A&&(h.overrideIdentifiers=A.identifiers)}const R=h?.overrideIdentifiers?.length?[(0,d.$Lo)(h.overrideIdentifiers),a]:[a];await this.j.write(R,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(o,t,p.ConfigurationTarget.USER)}s(a,t){const o=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(n,o,p.ConfigurationTarget.DEFAULT)}t(a){const t=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(a);this.u(o,t,p.ConfigurationTarget.DEFAULT)}u(a,t,o){const n=new f.$Wo(a,{data:t},this.a,void 0,this.n);n.source=o,this.h.fire(n)}}e.$1o=S;class k{constructor(a,t,o){this.b=a,this.c=t,this.d=o,this.a=new r.$Ph}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(h){if(h.fileOperationResult===y.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw h}const n=[];if((0,O.$2n)(o,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.f(o,a,t);o=(0,I.$go)(o,c),await this.c.writeFile(this.b,E.$Qe.fromString(o))}f(a,t,o){const{tabSize:n,insertSpaces:c,eol:h}=this.h;if(!t.length){const P=JSON.stringify(o,null,c?" ".repeat(n):"	");return[{content:P,length:P.length,offset:0}]}return(0,I.$do)(a,t,o,{tabSize:n,insertSpaces:c,eol:h})}get h(){if(!this.g){let a=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[209],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=e.$Cic=void 0,e.$Cic="request",e.$Dic="remoteResourceHandler";class i{async routeCall(E,D,O){if(D!==e.$Cic)throw new Error(`Call not found: ${D}`);const I=O[0];if(I?.authority){const b=E.connections.find(l=>l.ctx===I.authority);if(b)return b}throw new Error("Caller not found")}routeEvent(E,D){throw new Error(`Event not found: ${D}`)}}e.$Eic=i}),define(le[210],ue([0,1,15,6]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.RemoteAuthorityResolverErrorCode=e.$Wl=e.$Vl=e.RemoteConnectionType=e.$Ul=void 0,e.$Yl=l,e.$Ul=(0,r.$Ii)("remoteAuthorityResolverService");var E;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class D{constructor(u){this.id=u,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Vl=D;class O{constructor(u,m){this.host=u,this.port=m,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wl=O;var I;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class b extends i.$db{static isNotAvailable(u){return u instanceof b&&u._code===I.NotAvailable}static isTemporarilyNotAvailable(u){return u instanceof b&&u._code===I.TemporarilyNotAvailable}static isNoResolverFound(u){return u instanceof b&&u._code===I.NoResolverFound}static isInvalidAuthority(u){return u instanceof b&&u._code===I.InvalidAuthority}static isHandled(u){return u instanceof b&&u.isHandled}constructor(u,m=I.Unknown,p){super(u),this._message=u,this._code=m,this._detail=p,this.isHandled=m===I.NotAvailable&&p===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Xl=b;function l(g){const u=g.indexOf("+");return u===-1?g:g.substring(0,u)}}),define(le[211],ue([0,1,8,17,22,15,4,2,11,72,60,33,120,210]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$4l=w,e.$5l=R,e.$6l=A,l=Ie(l);const f=30*1e3;var d;(function(oe){oe[oe.Management=1]="Management",oe[oe.ExtensionHost=2]="ExtensionHost",oe[oe.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function v(oe){switch(oe){case d.Management:return"Management";case d.ExtensionHost:return"ExtensionHost";case d.Tunnel:return"Tunnel"}}function y(oe){const Y=new E.$ze;return setTimeout(()=>Y.cancel(),oe),Y.token}function $(oe,Y){if(oe.isCancellationRequested||Y.isCancellationRequested)return E.CancellationToken.Cancelled;const M=new E.$ze;return oe.onCancellationRequested(()=>M.cancel()),Y.onCancellationRequested(()=>M.cancel()),M.token}class S{get didTimeout(){return this.c==="timedout"}constructor(Y){this.c="pending",this.d=new I.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$Bh)(),Y.isCancellationRequested?this.h():this.d.add(Y.onCancellationRequested(()=>this.h()))}registerDisposable(Y){this.c==="pending"?this.d.add(Y):Y.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Y=new Error("Time limit reached");return Y.code="ETIMEDOUT",Y.syscall="connect",Y}resolve(Y){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Y))}reject(Y){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Y))}}function k(oe,Y){const M=new S(Y);return M.registerDisposable(oe.onControlMessage(Z=>{const U=JSON.parse(Z.toString()),N=W(U);N?M.reject(N):M.resolve(U)})),M.promise}function s(oe,Y,M,Z,U,N,ie,X){const z=new S(X),te=g.$ie.create(!1);return oe.info(`Creating a socket (${ie})...`),l.mark(`code/willCreateSocket/${N}`),Y.connect(M,Z,U,ie).then(ae=>{z.didTimeout?(l.mark(`code/didCreateSocketError/${N}`),oe.info(`Creating a socket (${ie}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(l.mark(`code/didCreateSocketOK/${N}`),oe.info(`Creating a socket (${ie}) was successful after ${te.elapsed()} ms.`),z.resolve(ae))},ae=>{l.mark(`code/didCreateSocketError/${N}`),oe.info(`Creating a socket (${ie}) returned an error after ${te.elapsed()} ms.`),oe.error(ae),z.reject(ae)}),z.promise}function a(oe,Y){const M=new S(Y);return oe.then(Z=>{M.didTimeout||M.resolve(Z)},Z=>{M.didTimeout||M.reject(Z)}),M.promise}async function t(oe,Y,M,Z){const U=V(oe,Y);oe.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let N;try{N=await s(oe.logService,oe.remoteSocketFactoryService,oe.connectTo,b.$Vg.getServerRootPath(),`reconnectionToken=${oe.reconnectionToken}&reconnection=${oe.reconnectionProtocol?"true":"false"}`,v(Y),`renderer-${v(Y)}-${oe.reconnectionToken}`,Z)}catch(ae){throw oe.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),oe.logService.error(ae),ae}oe.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let ie,X;oe.reconnectionProtocol?(oe.reconnectionProtocol.beginAcceptReconnection(N,null),ie=oe.reconnectionProtocol,X=!1):(ie=new m.$wi({socket:N}),X=!0),oe.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const z=await a(oe.signService.createNewMessage((0,u.$5g)()),Z),te={type:"auth",auth:oe.connectionToken||"00000000000000000000",data:z.data};ie.sendControl(r.$Qe.fromString(JSON.stringify(te)));try{const ae=await k(ie,$(Z,y(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Fe=new Error("Unexpected handshake message");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}if(oe.logService.trace(`${U} 4/6. received SignRequest control message.`),!await a(oe.signService.validate(z,ae.signedData),Z)){const Fe=new Error("Refused to connect to unsupported server");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}const be=await a(oe.signService.sign(ae.data),Z),ye={type:"connectionType",commit:oe.commit,signedData:be,desiredConnectionType:Y};return M&&(ye.args=M),oe.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(r.$Qe.fromString(JSON.stringify(ye))),{protocol:ie,ownsProtocol:X}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(oe.logService.error(`${U} the handshake timed out. Error:`),oe.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(oe.logService.error(`${U} received error control message when negotiating connection. Error:`),oe.logService.error(ae)),X&&C(ie),ae}}async function o(oe,Y,M,Z){const U=Date.now(),N=V(oe,Y),{protocol:ie,ownsProtocol:X}=await t(oe,Y,M,Z),z=new S(Z);return z.registerDisposable(ie.onControlMessage(te=>{const ae=JSON.parse(te.toString()),me=W(ae);me?(oe.logService.error(`${N} received error control message when negotiating connection. Error:`),oe.logService.error(me),X&&C(ie),z.reject(me)):(oe.reconnectionProtocol?.endAcceptReconnection(),oe.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ce(U)}!`),z.resolve({protocol:ie,firstMessage:ae}))})),z.promise}async function n(oe,Y){const{protocol:M}=await o(oe,d.Management,void 0,Y);return{protocol:M}}async function c(oe,Y,M){const{protocol:Z,firstMessage:U}=await o(oe,d.ExtensionHost,Y,M),N=U&&U.debugPort;return{protocol:Z,debugPort:N}}async function h(oe,Y,M){const Z=Date.now(),U=V(oe,d.Tunnel),{protocol:N}=await t(oe,d.Tunnel,Y,M);return oe.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${ce(Z)}!`),N}async function P(oe,Y,M){const{connectTo:Z,connectionToken:U}=await oe.addressProvider.getAddress();return{commit:oe.commit,quality:oe.quality,connectTo:Z,connectionToken:U,reconnectionToken:Y,reconnectionProtocol:M,remoteSocketFactoryService:oe.remoteSocketFactoryService,signService:oe.signService,logService:oe.logService}}async function w(oe,Y,M){return L(oe,async Z=>{const{protocol:U}=await n(Z,E.CancellationToken.None);return new B(oe,Y,M,Z.reconnectionToken,U)})}async function R(oe,Y){return L(oe,async M=>{const{protocol:Z,debugPort:U}=await c(M,Y,E.CancellationToken.None);return new _(oe,Y,M.reconnectionToken,Z,U)})}async function L(oe,Y){for(let Z=1;;Z++)try{const U=(0,u.$5g)(),N=await P(oe,U,null);return await Y(N)}catch(U){if(Z<5)oe.logService.error(`[remote-connection][attempt ${Z}] An error occurred in initial connection! Will retry... Error:`),oe.logService.error(U);else throw oe.logService.error(`[remote-connection][attempt ${Z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),oe.logService.error(U),J.triggerPermanentFailure(0,0,p.$Xl.isHandled(U)),U}}async function A(oe,Y,M){const Z=await P(oe,(0,u.$5g)(),null);return await h(Z,{host:Y,port:M},E.CancellationToken.None)}function T(oe){return(0,i.$vh)(Y=>new Promise((M,Z)=>{const U=setTimeout(M,oe*1e3);Y.onCancellationRequested(()=>{clearTimeout(U),M()})}))}var j;(function(oe){oe[oe.ConnectionLost=0]="ConnectionLost",oe[oe.ReconnectionWait=1]="ReconnectionWait",oe[oe.ReconnectionRunning=2]="ReconnectionRunning",oe[oe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",oe[oe.ConnectionGain=4]="ConnectionGain"})(j||(e.PersistentConnectionEventType=j={}));class G{constructor(Y,M){this.reconnectionToken=Y,this.millisSinceLastIncomingData=M,this.type=j.ConnectionLost}}e.$7l=G;class q{constructor(Y,M,Z,U){this.reconnectionToken=Y,this.millisSinceLastIncomingData=M,this.durationSeconds=Z,this.c=U,this.type=j.ReconnectionWait}skipWait(){this.c.cancel()}}e.$8l=q;class Q{constructor(Y,M,Z){this.reconnectionToken=Y,this.millisSinceLastIncomingData=M,this.attempt=Z,this.type=j.ReconnectionRunning}}e.$9l=Q;class de{constructor(Y,M,Z){this.reconnectionToken=Y,this.millisSinceLastIncomingData=M,this.attempt=Z,this.type=j.ConnectionGain}}e.$0l=de;class x{constructor(Y,M,Z,U){this.reconnectionToken=Y,this.millisSinceLastIncomingData=M,this.attempt=Z,this.handled=U,this.type=j.ReconnectionPermanentFailure}}e.$$l=x;class J extends I.$Xc{static triggerPermanentFailure(Y,M,Z){this._permanentFailure=!0,this.f=Y,this.g=M,this.h=Z,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Y=>Y.y())}static debugPauseSocketWriting(){this.j.forEach(Y=>Y.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||J._permanentFailure}constructor(Y,M,Z,U,N){super(),this.t=Y,this.u=M,this.reconnectionToken=Z,this.protocol=U,this.w=N,this.m=this.B(new O.$oe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new de(this.reconnectionToken,0,0)),this.B(U.onSocketClose(ie=>{const X=ne(this.t,this.reconnectionToken,!0);ie?ie.type===m.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${X} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.u.logService.error(ie.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.u.logService.error(ie.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(ie=>{const X=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.y()})),J.j.push(this),this.B((0,I.$Vc)(()=>{const ie=J.j.indexOf(this);ie>=0&&J.j.splice(ie,1)})),this.n&&this.D(J.f,J.g,J.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Y=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let Z=-1;do{Z++;const U=Z<M.length?M[Z]:M[M.length-1];try{if(U>0){const ie=T(U);this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,ie)),this.u.logService.info(`${Y} waiting for ${U} seconds before reconnecting...`);try{await ie}catch{}}if(this.n){this.u.logService.error(`${Y} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1)),this.u.logService.info(`${Y} resolving connection...`);const N=await P(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Y} connecting to ${N.connectTo}...`),await this.G(N,y(f)),this.u.logService.info(`${Y} reconnected!`),this.m.fire(new de(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Y} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(Z>360){this.u.logService.error(`${Y} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(p.$Xl.isTemporarilyNotAvailable(N)){this.u.logService.info(`${Y} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this.u.logService.info(`${Y} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if((0,D.$6)(N)){this.u.logService.info(`${Y} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if(N instanceof p.$Xl){this.u.logService.error(`${Y} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,p.$Xl.isHandled(N));break}this.u.logService.error(`${Y} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}}while(!this.n&&!this.s)}C(Y,M,Z){this.w?J.triggerPermanentFailure(Y,M,Z):this.D(Y,M,Z)}D(Y,M,Z){this.m.fire(new x(this.reconnectionToken,Y,M,Z)),C(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_l=J;class B extends J{constructor(Y,M,Z,U,N){super(d.Management,Y,U,N,!0),this.client=this.B(new m.$ui(N,{remoteAuthority:M,clientId:Z},Y.ipcLogger))}async G(Y,M){await n(Y,M)}}e.$am=B;class _ extends J{constructor(Y,M,Z,U,N){super(d.ExtensionHost,Y,Z,U,!1),this.H=M,this.debugPort=N}async G(Y,M){await c(Y,this.H,M)}}e.$bm=_;function C(oe){try{oe.acceptDisconnect();const Y=oe.getSocket();oe.dispose(),Y.dispose()}catch(Y){(0,D.$2)(Y)}}function W(oe){if(oe&&oe.type==="error"){const Y=new Error(`Connection error: ${oe.reason}`);return Y.code="VSCODE_CONNECTION_ERROR",Y}return null}function F(oe,Y){for(;oe.length<Y;)oe+=" ";return oe}function H(oe,Y){return`[remote-connection][${F(v(oe),13)}][${Y.substr(0,5)}\u2026]`}function ne(oe,Y,M){return`${H(oe,Y)}[${M?"reconnect":"initial"}]`}function V(oe,Y){return`${ne(Y,oe.reconnectionToken,!!oe.reconnectionProtocol)}[${oe.connectTo}]`}function ce(oe){return`${Date.now()-oe} ms`}}),define(le[75],ue([0,1,11]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=r,e.$ln=E,e.$mn=D,e.$nn=O;function r(b){return b.scheme===i.Schemas.vscodeRemote?b.authority:void 0}function E(b){if(!b)return;const l=b.indexOf("+");return l<0?b:b.substr(0,l)}function D(b){const{host:l,port:g}=I(b);if(typeof g>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:g}}function O(b,l){let{host:g,port:u}=I(b);return typeof u>"u"&&(u=l),{host:g,port:u}}function I(b){const l=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const g=b.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const u=b.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:b,port:void 0}}}),define(le[87],ue([0,1,25,6,75]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$wn=e.$vn=e.$un=e.TargetPlatform=e.ExtensionType=e.$tn=e.$rn=e.$qn=e.$pn=e.$on=void 0,e.$sn=D,e.$xn=u,e.$yn=m,e.$zn=p,e.$An=f,e.$Bn=d,e.$Cn=v,i=Ie(i),e.$on="extensions.user.cache",e.$pn="extensions.builtin.cache",e.$qn="undefined_publisher",e.$rn=["ui","workspace","web"];function D(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$tn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class b{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,S){if(typeof $>"u"||$===null)return typeof S>"u"||S===null;if(typeof S>"u"||S===null)return!1;if(typeof $=="string"||typeof S=="string"){const k=typeof $=="string"?$:$.value,s=typeof S=="string"?S:S.value;return i.$If(k,s)}return $._lower===S._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$un=b;class l{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const S of $)this.add(S)}add($){this.c.add(b.toKey($))}delete($){return this.c.delete(b.toKey($))}has($){return this.c.has(b.toKey($))}}e.$vn=l;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(b.toKey($))}get($){return this.c.get(b.toKey($))}has($){return this.c.has(b.toKey($))}set($,S){this.c.set(b.toKey($),S)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$wn=g;function u(y){return m(y)}function m(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function p(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function f(y,$){if($){const S=`onResolveRemoteAuthority:${(0,E.$ln)($)}`;return!!y.activationEvents?.includes(S)}return!1}function d(y){return y.map($=>{const[S,k]=$.split("@");return{proposalName:S,version:k?parseInt(k):void 0}})}function v(y){return y.map($=>$.split("@")[0])}e.$Dn=(0,r.$Ii)("IBuiltinExtensionsScannerService")}),define(le[128],ue([0,1,3,10,87,6]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.ExtensionManagementErrorCode=e.$pp=e.ExtensionGalleryErrorCode=e.$op=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=void 0,e.$ip=I,e.$jp=b,e.$kp=l,e.$lp=g,e.$mp=u,e.$np=m,e.$bp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$cp=new RegExp(e.$bp),e.$dp="__web_extension",e.$ep="skipWalkthrough",e.$fp="extensionInstallSource",e.$gp="dependecyOrPackExtensionInstall",e.$hp="clientTargetPlatform";var O;(function(s){s.COMMAND="command",s.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function I(s){switch(s){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function b(s){switch(s){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function l(s,a){switch(s){case i.Platform.Windows:return a==="x64"?E.TargetPlatform.WIN32_X64:a==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case i.Platform.Linux:return a==="x64"?E.TargetPlatform.LINUX_X64:a==="arm64"?E.TargetPlatform.LINUX_ARM64:a==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?E.TargetPlatform.ALPINE_X64:a==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case i.Platform.Mac:return a==="x64"?E.TargetPlatform.DARWIN_X64:a==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case i.Platform.Web:return E.TargetPlatform.WEB}}function g(s,a){return a===E.TargetPlatform.WEB&&!s.includes(E.TargetPlatform.WEB)}function u(s,a,t){return g(a,t)?!1:s===E.TargetPlatform.UNDEFINED||s===E.TargetPlatform.UNIVERSAL?!0:s===E.TargetPlatform.UNKNOWN?!1:s===t}function m(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}var p;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var f;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var d;(function(s){s.Install="install",s.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$op=(0,D.$Ii)("extensionGalleryService");var y;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed",s.DownloadFailedWriting="DownloadFailedWriting",s.Offline="Offline"})(y||(e.ExtensionGalleryErrorCode=y={}));class $ extends Error{constructor(a,t){super(a),this.code=t,this.name=t}}e.$pp=$;var S;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleApi="IncompatibleApi",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.DownloadFailedWriting="DownloadFailedWriting",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.ScanningExtension="ScanningExtension",s.ReadUninstalled="ReadUninstalled",s.UnsetUninstalled="UnsetUninstalled",s.Delete="Delete",s.Rename="Rename",s.IntializeDefaultProfile="IntializeDefaultProfile",s.AddToProfile="AddToProfile",s.InstalledExtensionNotFound="InstalledExtensionNotFound",s.PostInstall="PostInstall",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Cancelled="Cancelled",s.Unknown="Unknown",s.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));class k extends Error{constructor(a,t){super(a),this.code=t,this.name=t}}e.$qp=k,e.$rp=(0,D.$Ii)("extensionManagementService"),e.$sp="extensionsIdentifiers/disabled",e.$tp="extensionsIdentifiers/enabled",e.$up=(0,D.$Ii)("IGlobalExtensionEnablementService"),e.$vp=(0,D.$Ii)("IExtensionTipsService"),e.$wp=(0,r.localize2)(1778,"Extensions"),e.$xp=(0,r.localize2)(1779,"Preferences")});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[212],ue([0,1,18,82,10,213,87,175]),function(K,e,i,r,E,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=g,e.$4p=u,e.$5p=m,e.$6p=p,e.$7p=f,e.$8p=d,e.$9p=v,e.$0p=y,r=Ve(r),E=Ie(E),D=Ie(D);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function g(k){return k=k.trim(),k==="*"||b.test(k)}function u(k){if(!g(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=k.match(b);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}function m(k){if(!k)return null;const s=k.majorBase,a=k.majorMustEqual,t=k.minorBase;let o=k.minorMustEqual;const n=k.patchBase;let c=k.patchMustEqual;k.hasCaret&&(s===0||(o=!1),c=!1);let h=0;if(k.preRelease){const P=l.exec(k.preRelease);if(P){const[,w,R,L]=P;h=Date.UTC(Number(w),Number(R)-1,Number(L))}}return{majorBase:s,majorMustEqual:a,minorBase:t,minorMustEqual:o,patchBase:n,patchMustEqual:c,isMinimum:k.hasGreaterEquals,notBefore:h}}function p(k,s,a){let t;typeof k=="string"?t=m(u(k)):t=k;let o;s instanceof Date?o=s.getTime():typeof s=="string"&&(o=new Date(s).getTime());let n;if(typeof a=="string"?n=m(u(a)):n=a,!t||!n)return!1;const c=t.majorBase,h=t.minorBase,P=t.patchBase;let w=n.majorBase,R=n.minorBase,L=n.patchBase;const A=n.notBefore;let T=n.majorMustEqual,j=n.minorMustEqual,G=n.patchMustEqual;return n.isMinimum?c>w?!0:c<w?!1:h>R?!0:h<R||o&&o<A?!1:P>=L:(c===1&&w===0&&(!T||!j||!G)&&(w=1,R=0,L=0,T=!0,j=!1,G=!1),c<w?!1:c>w?!T:h<R?!1:h>R?!j:P<L?!1:P>L?!G:!(o&&o<A))}function f(k,s,a,t,o,n){const c=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return c.push([r.default.Error,E.localize(1830,null)]),c;if(typeof t.name!="string")return c.push([r.default.Error,E.localize(1831,null,"name")]),c;if(typeof t.version!="string")return c.push([r.default.Error,E.localize(1832,null,"version")]),c;if(!t.engines)return c.push([r.default.Error,E.localize(1833,null,"engines")]),c;if(typeof t.engines.vscode!="string")return c.push([r.default.Error,E.localize(1834,null,"engines.vscode")]),c;if(typeof t.extensionDependencies<"u"&&!S(t.extensionDependencies))return c.push([r.default.Error,E.localize(1835,null,"extensionDependencies")]),c;if(typeof t.activationEvents<"u"){if(!S(t.activationEvents))return c.push([r.default.Error,E.localize(1836,null,"activationEvents")]),c;if(typeof t.main>"u"&&typeof t.browser>"u")return c.push([r.default.Error,E.localize(1837,null,"activationEvents","main","browser")]),c}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&c.push([r.default.Warning,E.localize(1838,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return c.push([r.default.Error,E.localize(1839,null,"main")]),c;{const w=(0,i.$jh)(a,t.main);(0,i.$dh)(w,a)||c.push([r.default.Warning,E.localize(1840,null,w.path,a.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return c.push([r.default.Error,E.localize(1841,null,"browser")]),c;{const w=(0,i.$jh)(a,t.browser);(0,i.$dh)(w,a)||c.push([r.default.Warning,E.localize(1842,null,w.path,a.path)])}}if(!D.valid(t.version))return c.push([r.default.Error,E.localize(1843,null)]),c;const h=[];if(!d(k,s,t,o,h))for(const w of h)c.push([r.default.Error,w]);if(n&&t.enabledApiProposals?.length){const w=[];if(!y([...t.enabledApiProposals],w))for(const R of w)c.push([r.default.Error,R])}return c}function d(k,s,a,t,o){return t||typeof a.main>"u"&&typeof a.browser>"u"?!0:$(k,s,a.engines.vscode,o)}function v(k,s,a){return k==="*"||$(s,a,k)}function y(k,s){if(k.length===0)return!0;const a=Array.isArray(s)?s:void 0,t=(a?void 0:s)??I.allApiProposals,o=[],n=(0,O.$Bn)(k);for(const{proposalName:c,version:h}of n){const P=t[c];P&&h&&P.version!==h&&o.push(E.localize(1844,null,c))}return a?.push(...o),o.length===0}function $(k,s,a,t=[]){const o=m(u(a));if(!o)return t.push(E.localize(1845,null,a)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return t.push(E.localize(1846,null,a)),!1}else if(!o.majorMustEqual)return t.push(E.localize(1847,null,a)),!1;return p(k,s,o)?!0:(t.push(E.localize(1848,null,k,a)),!1)}function S(k){if(!Array.isArray(k))return!1;for(let s=0,a=k.length;s<a;s++)if(typeof k[s]!="string")return!1;return!0}}),define(le[214],ue([0,1,2,6]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0,e.$Zl=(0,r.$Ii)("remoteSocketFactoryService");class E{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,i.$Vc)(()=>{const b=this.a[O]?.indexOf(I);typeof b=="number"&&b>=0&&this.a[O]?.splice(b,1)})}b(O){return(this.a[O.type]||[]).find(b=>b.supports(O))}connect(O,I,b,l){const g=this.b(O);if(!g)throw new Error(`No socket factory found for ${O}`);return g.connect(O,I,b,l)}}e.$1l=E}),define(le[215],ue([0,1,26,27,44,97]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=I,i=Ie(i),r=Ie(r),E=Ie(E),D=Ie(D);let O;async function I(p=!1){return(O===void 0||p)&&(O=b()),O}async function b(){const p=l();if(p===void 0)return!1;if(p>=22e3){const f=u();if(f)return new Promise(d=>{try{E.execFile(f,["--status"],v=>d(!v))}catch{d(!1)}})}else{const f=m();if(f)try{if((await i.promises.stat(f)).isFile())return!0}catch{}}return!1}function l(){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(p)return parseInt(p[3])}function g(p){const f=process.env.SystemRoot;if(f){const d=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(f,d?"Sysnative":"System32",p)}}function u(){return g("wsl.exe")}function m(){return g("lxss\\LxssManager.dll")}}),define(le[49],ue([0,1,17,15,2,10,56,6,5,46]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0,e.$aq=m,e.$bq=p,e.$cq=f,e.$dq=d,e.$eq=v,e.$fq=y,e.$$p=(0,I.$Ii)("requestService");class g{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?s[a]="*****":s[a]=this.b[a];this.a=s}return this.a}}class u extends E.$Xc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,D.localize)(2048,null),when:b.$vk.isEqualTo((0,b.$sk)(b.LogLevel.Trace)).serialize()})}async c(s,a,t){const o=`${s} #${++this.b}: ${a.url}`;this.a.trace(`${o} - begin`,a.type,new g(a.headers??{}));try{const n=await t();return this.a.trace(`${o} - end`,a.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${o} - error`,a.type,(0,r.$_)(n)),n}}}e.$_p=u;function m(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}function p(k){return k.res.statusCode===204}async function f(k){return p(k)?null:(await(0,i.$3e)(k.stream)).toString()}async function d(k){if(!m(k))throw new Error("Server returned "+k.res.statusCode);return f(k)}async function v(k){if(!m(k))throw new Error("Server returned "+k.res.statusCode);if(p(k))return null;const a=(await(0,i.$3e)(k.stream)).toString();try{return JSON.parse(a)}catch(t){throw t.message+=`:
`+a,t}}function y(k){S(k)}let $;function S(k){const s=l.$uo.as(O.$zo.Configuration),a=$;$={id:"http",order:15,title:(0,D.localize)(2049,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2050,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2051,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(2052,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,D.localize)(2053,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(2054,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(2055,null),(0,D.localize)(2056,null),(0,D.localize)(2057,null),(0,D.localize)(2058,null)],default:"override",description:(0,D.localize)(2059,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(2060,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(2061,null),restricted:!0}}},s.updateConfigurations({add:[$],remove:a?[a]:[]})}S(O.ConfigurationScope.APPLICATION)}),define(le[216],ue([0,1,17,22]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=void 0;class E{constructor(I){this.a=I}listen(I,b){throw new Error("Invalid listen")}call(I,b,l,g=r.CancellationToken.None){switch(b){case"request":return this.a.request(l[0],g).then(async({res:u,stream:m})=>{const p=await(0,i.$3e)(m);return[{statusCode:u.statusCode,headers:u.headers},p]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"lookupAuthorization":return this.a.lookupAuthorization(l[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$hs=E;class D{constructor(I){this.a=I}async request(I,b){const[l,g]=await this.a.call("request",[I],b);return{res:l,stream:(0,i.$5e)(g)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async lookupKerberosAuthorization(I){return this.a.call("lookupKerberosAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$is=D}),define(le[217],ue([0,1,218,12]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=D;function E(O,I){return O.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:O.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function D(O,I,b={}){const l=(0,i.parse)(O),g=b.proxyUrl||E(l,I);if(!g)return null;const u=(0,i.parse)(g);if(!/^https?:$/.test(u.protocol||""))return null;const m={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,r.$ng)(b.strictSSL)?b.strictSSL:!0};if(l.protocol==="http:"){const p=await new Promise((f,d)=>{K(["http-proxy-agent"],f,d)}).then(Ie);return new p.HttpProxyAgent(g,m)}else{const p=await new Promise((f,d)=>{K(["https-proxy-agent"],f,d)}).then(Ie);return new p.HttpsProxyAgent(g,m)}}}),define(le[219],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=e.$Whc=void 0,e.$Whc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Xhc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Yhc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[103],ue([0,1,44,9,10,22,55,15,3,33,119,70,8,146]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=d;let f;async function d(y,$,S,k){return S["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Nm)(k)&&!S["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Nm)(k)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=m.Promises.withAsyncBody(async(s,a)=>{const t=new D.$ze;let o=1e4;const n=y.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(o=(0,p.$Om)(n,1,120)*1e3);const c=setTimeout(()=>{t.dispose(!0),a(new Error((0,E.localize)(2062,null)))},o);try{s(await v($,t.token))}catch(h){!(0,I.$6)(h)&&!t.token.isCancellationRequested?a(new Error((0,E.localize)(2063,null,(0,O.$tj)(h)))):s({})}finally{clearTimeout(c),t.dispose()}})),f)}async function v(y,$){const S=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",S);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",k);const s=(0,l.$5g)().replace(/-/g,"").substr(0,12),a=new RegExp(s+"({.*})"+s),t={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};y.trace("getUnixShellEnvironment#env",t);const o=await(0,g.$Dm)(b.OS,t);return y.trace("getUnixShellEnvironment#shell",o),new Promise((n,c)=>{if($.isCancellationRequested)return c(new I.$7);const h=(0,r.$qc)(o);let P,w;const R="";/^pwsh(-preview)?$/.test(h)?(P=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,w=["-Login","-Command"]):h==="nu"?(P=`^'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,w=["-i","-l","-c"]):h==="xonsh"?(P=`import os, json; print("${s}", json.dumps(dict(os.environ)), "${s}")`,w=["-i","-l","-c"]):(P=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,h==="tcsh"||h==="csh"?w=["-ic"]:w=["-i","-l","-c"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),P);const L=(0,i.spawn)(o,[...w,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:t});$.onCancellationRequested(()=>(L.kill(),c(new I.$7))),L.on("error",j=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,O.$tj)(j)),c(j)});const A=[];L.stdout.on("data",j=>A.push(j));const T=[];L.stderr.on("data",j=>T.push(j)),L.on("close",(j,G)=>{const q=Buffer.concat(A).toString("utf8");y.trace("getUnixShellEnvironment#raw",q);const Q=Buffer.concat(T).toString("utf8");if(Q.trim()&&y.trace("getUnixShellEnvironment#stderr",Q),j||G)return c(new Error((0,E.localize)(2064,null,j,G)));const de=a.exec(q),x=de?de[1]:"{}";try{const J=JSON.parse(x);S?J.ELECTRON_RUN_AS_NODE=S:delete J.ELECTRON_RUN_AS_NODE,k?J.ELECTRON_NO_ATTACH_CONSOLE=k:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.VSCODE_RESOLVING_ENVIRONMENT,delete J.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",J),n(J)}catch(J){y.error("getUnixShellEnvironment#errorCaught",(0,O.$tj)(J)),c(J)}})})}}),define(le[220],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(E){try{const D=await this.c();if(D){const O=String(i.a++);return this.b.set(O,D),{id:O,data:D.createNewMessage(E)}}}catch{}return{id:"",data:E}}async validate(E,D){if(!E.id)return!0;const O=this.b.get(E.id);if(!O)return!1;this.b.delete(E.id);try{return O.validate(D)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(E){try{return await this.d(E)}catch{}return E}}e.$Gdc=i}),define(le[104],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0,e.$2l="signService",e.$3l=(0,i.$Ii)(e.$2l)}),define(le[221],ue([0,1,153,220]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;class E extends r.$Gdc{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(I=>new I.signer().sign(O))}async h(){return(0,i.$wq)("vsda","index.js")}}e.$Oic=E}),define(le[34],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VR=e.$UR=void 0,e.$UR=(0,i.$Ii)("stateReadService"),e.$VR=(0,i.$Ii)("stateService")}),define(le[129],ue([0,1,8,17,2,12,36,14,5]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=e.$XR=e.$WR=e.SaveStrategy=void 0;var l;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class g extends E.$Xc{constructor(f,d,v,y){super(),this.h=f,this.j=d,this.m=v,this.n=y,this.a=Object.create(null),this.b="",this.c=this.B(new i.$Gh(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(f)}}getItem(f,d){const v=this.a[f];return(0,D.$qg)(v)?d:v}setItem(f,d){this.setItems([{key:f,data:d}])}setItems(f){let d=!1;for(const{key:v,data:y}of f)this.a[v]!==y&&((0,D.$qg)(y)?(0,D.$og)(this.a[v])||(this.a[v]=void 0,d=!0):(this.a[v]=y,d=!0));d&&this.s()}removeItem(f){(0,D.$og)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,r.$Qe.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(d){this.m.error(d)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$WR=g;let u=class extends E.$Xc{constructor(f,d,v,y){super(),this.a=this.B(new g(d.stateResource,f,v,y))}async init(){await this.a.init()}getItem(f,d){return this.a.getItem(f,d)}};e.$XR=u,e.$XR=u=ke([re(1,O.$Pi),re(2,b.$dk),re(3,I.$dl)],u);class m extends u{setItem(f,d){this.a.setItem(f,d)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$YR=m}),define(le[130],ue([0,1,3,37,33]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=O,e.$zp=I;function D(b){if(i.$v===i.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function O(b,l,g,u,m,p,f,d,v,y){const $=Object.create(null);$["common.machineId"]=p,$["common.sqmId"]=f,$["common.devDeviceId"]=d,$.sessionID=(0,E.$5g)()+Date.now(),$.commitHash=u,$.version=m,$["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,i.$i)(i.$v),$["common.nodePlatform"]=r.$gc,$["common.nodeArch"]=g,$["common.product"]=y||"desktop",v&&($["common.msftInternal"]=v);let S=0;const k=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-k,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),i.$m&&($["common.snap"]="true");const s=D(l);return s&&($["common.platformDetail"]=s),$}function I(b){const l=r.env.USERDNSDOMAIN;if(!l)return!1;const g=l.toLowerCase();return b.some(u=>g===u)}}),define(le[24],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,i.$Ii)("telemetryService"),e.$dm=(0,i.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var r;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var E;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(le[222],ue([0,1,26,27,8,43,11,9,3,60,7,94,23,118,99,14,28,24]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0,e.$4s=S,e.$5s=s,e.$6s=a,i=Ie(i),r=Ie(r);const $=new Map;async function S(o,n){const c=`${o}::${n.join(":")}`,h=$.get(c);if(h)return h;const P=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],w=new Map,R=new Map,L=2e4;function A(j,G,q,Q){const de=G.substring(j.length+1);return E.Promises.withAsyncBody(async x=>{let J;Q.readdirCount++;try{J=await m.Promises.readdir(G,{withFileTypes:!0})}catch{x();return}if(Q.count>=L){Q.count+=J.length,Q.maxReached=!0,x();return}let B=J.length;if(B===0){x();return}let _=J;Q.count+J.length>L&&(Q.maxReached=!0,B=L-Q.count,_=J.slice(0,B)),Q.count+=J.length;for(const C of _)if(C.isDirectory()){if(q.includes(C.name)||await A(j,(0,I.$mc)(G,C.name),q,Q),--B===0){x();return}}else{const W=C.name.lastIndexOf(".");if(W>=0){const F=C.name.substring(W+1);F&&w.set(F,(w.get(F)??0)+1)}for(const F of P)F.relativePathPattern?.test(de)!==!1&&F.filePattern.test(C.name)&&R.set(F.tag,(R.get(F.tag)??0)+1);if(--B===0){x();return}}})}const T=E.Promises.withAsyncBody(async j=>{const G={count:0,maxReached:!1,readdirCount:0},q=new l.$ie(!0);await A(o,o,n,G);const Q=await a(o);j({configFiles:k(R),fileTypes:k(w),fileCount:G.count,maxFilesReached:G.maxReached,launchConfigFiles:Q,totalScanTime:q.elapsed(),totalReaddirCount:G.readdirCount})});return $.set(c,T),T}function k(o){return Array.from(o.entries(),([n,c])=>({name:n,count:c})).sort((n,c)=>c.count-n.count)}function s(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/d.$Ll.GB).toFixed(2)}GB (${(r.freemem()/d.$Ll.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$Vn.value()*100)}%`},n=r.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}async function a(o){try{const n=new Map,c=(0,I.$mc)(o,".vscode","launch.json"),h=await i.promises.readFile(c),P=[],w=(0,D.$2n)(h.toString(),P);if(P.length)return console.log(`Unable to parse ${c}`),[];if((0,D.$0n)(w)==="object"&&w.configurations)for(const R of w.configurations){const L=R.type;L&&(n.has(L)?n.set(L,n.get(L)+1):n.set(L,1))}return k(n)}catch{return[]}}let t=class{constructor(n,c){this.c=n,this.d=c}f(n){const c=[];return c.push(`OS Version:       ${n.os}`),c.push(`CPUs:             ${n.cpus}`),c.push(`Memory (System):  ${n.memory}`),c.push(`VM:               ${n.vmHint}`),c.join(`
`)}g(n){const c=[];c.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),c.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const h=r.cpus();return h&&h.length>0&&c.push(`CPUs:             ${h[0].model} (${h.length} x ${h[0].speed})`),c.push(`Memory (System):  ${(r.totalmem()/d.$Ll.GB).toFixed(2)}GB (${(r.freemem()/d.$Ll.GB).toFixed(2)}GB free)`),b.$j||c.push(`Load (avg):       ${r.loadavg().map(P=>Math.round(P)).join(", ")}`),c.push(`VM:               ${Math.round(u.$Vn.value()*100)}%`),c.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),c.push(`Process Argv:     ${n.mainArguments.join(" ")}`),c.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),c.join(`
`)}async getPerformanceInfo(n,c){return Promise.all([(0,p.$3s)(n.mainPID),this.k(n)]).then(async h=>{let[P,w]=h,R=this.m(n,P);return c.forEach(L=>{if((0,f.$Xm)(L))R+=`
${L.errorMessage}`,w+=`
${L.errorMessage}`;else if(R+=`

Remote: ${L.hostName}`,L.processes&&(R+=`
${this.m(n,L.processes)}`),L.workspaceMetadata){w+=`
|  Remote: ${L.hostName}`;for(const A of Object.keys(L.workspaceMetadata)){const T=L.workspaceMetadata[A];let j=`${T.fileCount} files`;T.maxFilesReached&&(j=`more than ${j}`),w+=`|    Folder (${A}): ${j}`,w+=this.h(T)}}}),{processInfo:R,workspaceInfo:w}})}async getSystemInfo(n,c){const{memory:h,vmHint:P,os:w,cpus:R}=s(),L={os:w,memory:h,cpus:R,vmHint:P,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:c};return b.$j||(L.load=`${r.loadavg().map(A=>Math.round(A)).join(", ")}`),b.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(n,c){const h=[];return(0,p.$3s)(n.mainPID).then(async P=>(h.push(""),h.push(this.g(n)),h.push(""),h.push(this.m(n,P)),n.windows.some(w=>w.folderURIs&&w.folderURIs.length>0&&!w.remoteAuthority)&&(h.push(""),h.push("Workspace Stats: "),h.push(await this.k(n))),c.forEach(w=>{if((0,f.$Xm)(w))h.push(`
${w.errorMessage}`);else if(h.push(`

`),h.push(`Remote:           ${w.hostName}`),h.push(this.f(w.machineInfo)),w.processes&&h.push(this.m(n,w.processes)),w.workspaceMetadata)for(const R of Object.keys(w.workspaceMetadata)){const L=w.workspaceMetadata[R];let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),h.push(`Folder (${R}): ${A}`),h.push(this.h(L))}}),h.push(""),h.push(""),h.join(`
`)))}h(n){const c=[];let P=0;const w=(T,j)=>{const G=` ${T}(${j})`;P+G.length>60?(c.push(R),R="|                 ",P=R.length):P+=G.length,R+=G};let R="|      File types:";const L=10,A=n.fileTypes.length>L?L:n.fileTypes.length;for(let T=0;T<A;T++){const j=n.fileTypes[T];w(j.name,j.count)}if(c.push(R),n.configFiles.length>=0&&(R="|      Conf files:",P=0,n.configFiles.forEach(T=>{w(T.name,T.count)}),c.push(R)),n.launchConfigFiles.length>0){let T="|      Launch Configs:";n.launchConfigFiles.forEach(j=>{const G=j.count>1?` ${j.name}(${j.count})`:` ${j.name}`;T+=G}),c.push(T)}return c.join(`
`)}j(n){const c=Math.max(...Object.keys(n).map(h=>h.length));return Object.keys(n).map(h=>`${h}:  ${" ".repeat(c-h.length)}  ${n[h]}`).join(`
                  `)}k(n){const c=[],h=[];return n.windows.forEach(P=>{P.folderURIs.length===0||P.remoteAuthority||(c.push(`|  Window (${P.title})`),P.folderURIs.forEach(w=>{const R=g.URI.revive(w);if(R.scheme===O.Schemas.file){const L=R.fsPath;h.push(S(L,["node_modules",".git"]).then(A=>{let T=`${A.fileCount} files`;A.maxFilesReached&&(T=`more than ${T}`),c.push(`|    Folder (${(0,I.$qc)(L)}): ${T}`),c.push(this.h(A))}).catch(A=>{c.push(`|      Error: Unable to collect workspace stats for folder ${L} (${A.toString()})`)}))}else c.push(`|    Folder (${R.toString()}): Workspace stats not available.`)}))}),Promise.all(h).then(P=>c.join(`
`)).catch(P=>`Unable to collect workspace stats: ${P}`)}m(n,c){const h=new Map;n.windows.forEach(w=>h.set(w.pid,`window [${w.id}] (${w.title})`)),n.pidToNames.forEach(({pid:w,name:R})=>h.set(w,R));const P=[];return P.push("CPU %	Mem MB	   PID	Process"),c&&this.n(n.mainPID,h,P,c,0),P.join(`
`)}n(n,c,h,P,w){const R=w===0;let L;R?L=P.pid===n?`${this.d.applicationName} main`:"remote agent":c.has(P.pid)?L=c.get(P.pid):L=`${"  ".repeat(w)} ${P.name}`;const A=process.platform==="win32"?P.mem:r.totalmem()*(P.mem/100);h.push(`${P.load.toFixed(0).padStart(5," ")}	${(A/d.$Ll.MB).toFixed(0).padStart(6," ")}	${P.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(P.children)&&P.children.forEach(T=>this.n(n,c,h,T,w+1))}async getWorkspaceFileExtensions(n){const c=new Set;for(const{uri:h}of n.folders){const P=g.URI.revive(h);if(P.scheme!==O.Schemas.file)continue;const w=P.fsPath;try{(await S(w,["node_modules",".git"])).fileTypes.forEach(L=>c.add(L.name))}catch{}}return{extensions:[...c]}}async reportWorkspaceStats(n){for(const{uri:c}of n.folders){const h=g.URI.revive(c);if(h.scheme!==O.Schemas.file)continue;const P=h.fsPath;try{const w=await S(P,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),w.fileTypes.forEach(R=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:R.name,count:R.count})}),w.launchConfigFiles.forEach(R=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:R.name,count:R.count})}),w.configFiles.forEach(R=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:R.name,count:R.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:w.totalScanTime,reachedLimit:w.maxFilesReached,fileCount:w.fileCount,readdirCount:w.totalReaddirCount})}catch{}}}};e.$7s=t,e.$7s=t=ke([re(0,y.$cm),re(1,v.$wk)],t)}),define(le[223],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=void 0;class i{constructor(D){this.b=D}listen(D,O){throw new Error(`Event not found: ${O}`)}call(D,O,{eventName:I,data:b}){return this.b.forEach(l=>l.log(I,b)),Promise.resolve(null)}}e.$2hc=i;class r{constructor(D){this.b=D}log(D,O){return this.b.call("log",{eventName:D,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$3hc=r}),define(le[57],ue([0,1,38,12,75,130,24]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=void 0,e.$Hp=g,e.$Ip=u,e.$Jp=m,e.$Kp=p,e.$Lp=d,e.$Mp=y,e.$Np=$,e.$Op=s;class I{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$Ap=I;class b{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Bp=b,e.$Cp=new b;class l{async publicLog(t,o,n){}async publicLogError(t,o,n){}}e.$Dp=l,e.$Ep="telemetry",e.$Fp="extensionTelemetryLog",e.$Gp={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!a.enableTelemetry)}function u(a,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function m(a){const t=a.getValue(O.$lm),o=a.getValue(O.$mm);if(a.getValue(O.$nm)===!1||o===!1)return O.TelemetryLevel.NONE;switch(t??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function p(a){const t={},o={},n={};v(a,n);for(let c in n){c=c.length>150?c.substr(c.length-149):c;const h=n[c];typeof h=="number"?o[c]=h:typeof h=="boolean"?o[c]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${h.length}`),t[c]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(t[c]=h)}return{properties:t,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(a){if(!a)return"none";const t=(0,E.$ln)(a);return f.has(t)?t:"other"}function v(a,t,o=0,n){if(a)for(const c of Object.getOwnPropertyNames(a)){const h=a[c],P=n?n+c:c;Array.isArray(h)?t[P]=(0,i.$mo)(h):h instanceof Date?t[P]=h.toISOString():(0,r.$jg)(h)?o<2?v(h,t,o+1,P+"."):t[P]=(0,i.$mo)(h):t[P]=h}}function y(a,t){const o=a.msftInternalDomains||[],n=t.getValue("telemetry.internalTesting");return(0,D.$zp)(o)||n}function $(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function S(a,t){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let o=a;const n=[];for(const w of t)for(;;){const R=w.exec(a);if(!R)break;n.push([R.index,w.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(o="";;){const w=h.exec(a);if(!w)break;const R=n.some(([L,A])=>w.index<A&&L<h.lastIndex);!c.test(w[0])&&!R&&(o+=a.substring(P,w.index)+"<REDACTED: user-file-path>",P=h.lastIndex)}return P<a.length&&(o+=a.substr(P)),o}function k(a){if(!a)return a;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of t)if(o.regex.test(a))return`<REDACTED: ${o.label}>`;return a}function s(a,t){return(0,i.$jo)(a,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let n=o.replaceAll("%20"," ");n=S(n,t);for(const c of t)n=n.replace(c,"");return n=k(n),n}})}}),define(le[131],ue([0,1,25,128,87,3,7,15,37,57]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Qp=void 0,e.$Pp=g,e.$Rp=f,e.$Sp=d,e.$Tp=v,e.$Up=y,e.$Vp=$,e.$Wp=S,e.$Xp=k,e.$Zp=s,e.$1p=t;function g(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,i.$Df)(o.id,n.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const c=n.manifest?n.manifest.version:n.version,h=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,c,h)}static parse(n){const c=u.exec(n);return c&&c[1]&&c[2]?new m({id:c[1]},c[2],c[4]||void 0):null}constructor(n,c,h=E.TargetPlatform.UNDEFINED){this.identifier=n,this.version=c,this.targetPlatform=h,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?g(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Qp=m;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const n=p.exec(o);return n&&n[1]?[v(n[1]),n[2]]:[v(o),void 0]}function d(o,n){return`${o}.${n}`}function v(o){return o.toLowerCase()}function y(o,n){return v(d(o??E.$qn,n))}function $(o,n){const c=[],h=P=>{for(const w of c)if(w.some(R=>g(n(R),n(P))))return w;return null};for(const P of o){const w=h(P);w?w.push(P):c.push([P])}return c}function S(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function k(o){return{id:new l.$Ap(o.identifier.id),name:new l.$Ap(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Yp=new E.$un("pprice.better-merge");function s(o,n){const c=[],h=n.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const P=h.shift();if(P&&c.every(w=>!g(w.identifier,{id:P}))){const w=o.filter(R=>g(R.identifier,{id:P}));w.length===1&&(c.push(w[0]),h.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function a(o,n){if(!D.$l)return!1;let c;try{c=(await o.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await o.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(P){n.debug("Error while getting the os-release file.",(0,I.$_)(P))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(o,n){const c=await a(o,n),h=(0,r.$kp)(c?"alpine":D.$v,b.$hc);return n.debug("ComputeTargetPlatform:",h),h}});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[224],ue([0,1,2,38,3,25,10,16,56,63,28,46,24,57]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0,l=Ve(l);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(y,$,S){this.k=$,this.l=S,this.d={},this.i=new i.$Wc,this.j=[],this.b=y.appenders,this.c=y.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=y.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!y.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,D.$kf)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$kf)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(m.$lm)||k.affectsConfiguration(m.$nm)||k.affectsConfiguration(m.$mm))&&this.m()}))}setExperimentProperty(y,$){this.d[y]=$}m(){let y=(0,p.$Jp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const S=$.usage?m.TelemetryLevel.USAGE:$.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;y=Math.min(y,S)}this.g=y}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(y,$,S){this.g<$||(S=(0,r.$ko)(S,this.d),S=(0,p.$Op)(S,this.j),S=(0,r.$ko)(S,this.c),this.b.forEach(k=>k.log(y,S)))}publicLog(y,$){this.n(y,m.TelemetryLevel.USAGE,$)}publicLog2(y,$){this.publicLog(y,$)}publicLogError(y,$){this.h&&this.n(y,m.TelemetryLevel.ERROR,$)}publicLogError2(y,$){this.publicLogError(y,$)}};e.$ms=f,e.$ms=f=ke([re(1,I.$cj),re(2,g.$wk)],f);function d(){const v=(0,O.localize)(2066,null,l.default.nameLong),y=l.default.privacyStatementUrl?(0,O.localize)(2068,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,O.localize)(2067,null,"https://aka.ms/vscode-telemetry"),$=E.$p?"":(0,O.localize)(2069,null),S=(0,O.localize)(2070,null),k=(0,O.localize)(2071,null),s=(0,O.localize)(2072,null),a=(0,O.localize)(2073,null),t=`
|       | ${S} | ${k} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,O.localize)(2074,null);return`
${v} ${y} ${$}

&nbsp;

${a}
${t}

&nbsp;

${o}
`}u.$uo.as(b.$zo.Configuration).registerConfiguration({id:m.$km,order:1,type:"object",title:(0,O.localize)(2075,null),properties:{[m.$lm]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,O.localize)(2076,null),(0,O.localize)(2077,null),(0,O.localize)(2078,null),(0,O.localize)(2079,null)],markdownDescription:d(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$uo.as(b.$zo.Configuration).registerConfiguration({id:m.$km,order:110,type:"object",title:(0,O.localize)(2080,null),properties:{[m.$nm]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,O.localize)(2082,null,l.default.nameLong,l.default.privacyStatementUrl):(0,O.localize)(2081,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(2083,null,`\`#${m.$lm}#\``),scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[225],ue([0,1,3,94,24]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=D,e.$sic=O,e.$tic=I;async function D(b,l){let g=b.getItem(E.$hm);return(typeof g!="string"||i.$k&&g==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(g=await(0,r.$Wn)(l.error.bind(l))),g}async function O(b,l){let g=b.getItem(E.$im);return typeof g!="string"&&(g=await(0,r.$Xn)(l.error.bind(l))),g}async function I(b,l){let g=b.getItem(E.$jm);return typeof g!="string"&&(g=await(0,r.$Yn)(l.error.bind(l))),g}}),define(le[226],ue([0,1,24,225]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=E,e.$vic=D,e.$wic=O;async function E(I,b){const l=await(0,r.$ric)(I,b);return I.setItem(i.$hm,l),l}async function D(I,b){const l=await(0,r.$sic)(I,b);return I.setItem(i.$im,l),l}async function O(I,b){const l=await(0,r.$tic)(I,b);return I.setItem(i.$jm,l),l}}),define(le[132],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(le[227],ue([0,1,3,132]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;const E=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((u,m)=>{this.d(u,m);const p=u.map.entries();let f=p.next();for(;!f.done;){const d=f.value[1],v=f.value[0];let y=this.a.get(v);if(y||(y=[],this.a.set(v,y)),y.length>0&&y[0].type===r.EnvironmentVariableMutatorType.Replace){f=p.next();continue}const $={extensionIdentifier:m,value:d.value,type:d.type,scope:d.scope,variable:d.variable,options:d.options};$.scope||delete $.scope,y.unshift($),f=p.next()}})}async applyToProcessEnvironment(g,u,m){let p;i.$j&&(p={},Object.keys(g).forEach(f=>p[f.toLowerCase()]=f));for(const[f,d]of this.getVariableMap(u)){const v=i.$j&&p[f.toLowerCase()]||f;for(const y of d){const $=m?await m(y.value):y.value;if(y.options?.applyAtProcessCreation??!0)switch(y.type){case r.EnvironmentVariableMutatorType.Append:g[v]=(g[v]||"")+$;break;case r.EnvironmentVariableMutatorType.Prepend:g[v]=$+(g[v]||"");break;case r.EnvironmentVariableMutatorType.Replace:g[v]=$;break}if(y.options?.applyAtShellIntegration??!1){const S=`VSCODE_ENV_${E.get(y.type)}`;g[S]=(g[S]?g[S]+":":"")+f+"="+this.c($)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,u){const m=new Map,p=new Map,f=new Map;if(g.getVariableMap(u).forEach((d,v)=>{const y=this.getVariableMap(u).get(v),$=I(d,y);$&&m.set(v,$)}),this.getVariableMap(u).forEach((d,v)=>{const y=g.getVariableMap(u).get(v),$=I(d,y);$&&f.set(v,$)}),this.getVariableMap(u).forEach((d,v)=>{const y=g.getVariableMap(u).get(v),$=b(d,y);$&&p.set(v,$)}),!(m.size===0&&p.size===0&&f.size===0))return{added:m,changed:p,removed:f}}getVariableMap(g){const u=new Map;for(const m of this.a.values()){const p=m.filter(f=>O(f,g));p.length>0&&u.set(p[0].variable,p)}return u}getDescriptionMap(g){const u=new Map;for(const m of this.b.values()){const p=m.filter(f=>O(f,g,!0));for(const f of p)u.set(f.extensionIdentifier,f.description)}return u}d(g,u){if(!g.descriptionMap)return;const m=g.descriptionMap.entries();let p=m.next();for(;!p.done;){const f=p.value[1],d=p.value[0];let v=this.b.get(d);v||(v=[],this.b.set(d,v));const y={extensionIdentifier:u,scope:f.scope,description:f.description};y.scope||delete y.scope,v.push(y),p=m.next()}}}e.$Qs=D;function O(l,g,u=!1){return l.scope?!!(l.scope.workspaceFolder&&g?.workspaceFolder&&l.scope.workspaceFolder.index===g.workspaceFolder.index):u?g===l.scope:!0}function I(l,g){if(!g)return l;const u=new Set;g.forEach(p=>u.add(p.extensionIdentifier));const m=[];return l.forEach(p=>{u.has(p.extensionIdentifier)||m.push(p)}),m.length===0?void 0:m}function b(l,g){if(!g)return;const u=new Map;g.forEach(p=>u.set(p.extensionIdentifier,p));const m=[];return l.forEach(p=>{const f=u.get(p.extensionIdentifier);f&&(p.type!==f.type||p.value!==f.value||p.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&m.push(f)}),m.length===0?void 0:m}}),define(le[228],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=i,e.$Ls=r,e.$Ms=E,e.$Ns=D,e.$Os=O,e.$Ps=I;function i(b){return[...b.entries()]}function r(b){return b?[...b.entries()]:[]}function E(b){return new Map(b)}function D(b){return new Map(b??[])}function O(b){return Array.from(b.entries()).map(l=>[l[0],i(l[1].map),r(l[1].descriptionMap)])}function I(b){return new Map(b.map(l=>[l[0],{map:E(l[1]),descriptionMap:D(l[2])}]))}}),define(le[229],ue([0,1,8,22,4,2,5]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=void 0;let I=class extends D.$Xc{constructor(l,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$oe),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,D.$Vc)(()=>{for(const u of this.f.values())(0,D.$Sc)(u)}))}createRequest(l){return new Promise((g,u)=>{const m=++this.a;this.c.set(m,g),this.g.fire({requestId:m,...l});const p=new r.$ze;(0,i.$Jh)(this.b,p.token).then(()=>u(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,D.$Vc)(()=>p.cancel())])})}acceptReply(l,g){const u=this.c.get(l);u?(this.c.delete(l),(0,D.$Sc)(this.f.get(l)||[]),this.f.delete(l),u(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$Bs=I,e.$Bs=I=ke([re(1,O.$dk)],I)}),define(le[76],ue([0,1,6,124,46]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$us=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ts=void 0,e.$ts=new r.$Zj("terminalTabFocusMode",!1,!0);var D;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var O;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var I;(function(a){a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(I||(e.PosixShellType=I={}));var b;(function(a){a.CommandPrompt="cmd",a.Wsl="wsl",a.GitBash="gitbash"})(b||(e.WindowsShellType=b={}));var l;(function(a){a.PowerShell="pwsh",a.Python="python",a.Julia="julia",a.NuShell="nu"})(l||(e.GeneralShellType=l={}));var g;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(g||(e.TitleEventSource=g={}));var u;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(u||(e.TerminalIpcChannels=u={}));var m;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(m||(e.ProcessPropertyType=m={})),e.$us=(0,i.$Ii)("ptyService");var p;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var f;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var d;(function(a){a.TerminalView="view",a.Editor="editor"})(d||(e.TerminalLocationString=d={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var y;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(y||(e.FlowControlConstants=y={}));var $;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var S;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(S||(e.ShellIntegrationStatus=S={}));var k;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(k||(e.TerminalExitReason=k={})),e.$vs={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}E.$uo.add(e.$vs.Backend,new s),e.$ws=(0,i.$Ii)("localPtyService"),e.$xs=(0,i.$Ii)("terminalLogService")}),define(le[230],ue([0,1,81,7,10,113]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=O,e.$Ds=l,e.$Es=g,e.$Fs=u;function O(m,p){const f=[{name:null,description:(0,E.localize)(2116,null)}];return f.push(...m.map(d=>({name:d.profileName,description:I(d)}))),p&&f.push(...p.map(d=>({name:d.title,description:b(d)}))),{values:f.map(d=>d.name),markdownDescriptions:f.map(d=>d.description)}}function I(m){let p=`$(${D.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:i.$8j.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?p+=`
- args: "${m.args}"`:p+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(p+=`
- overrideName: ${m.overrideName}`),m.color&&(p+=`
- color: ${m.color}`),m.env&&(p+=`
- env: ${JSON.stringify(m.env)}`),p}function b(m){return`$(${D.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:i.$8j.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function l(m,p){if(!m&&!p)return!0;if(typeof m=="string"&&typeof p=="string")return m===p;if(Array.isArray(m)&&Array.isArray(p)){if(m.length!==p.length)return!1;for(let f=0;f<m.length;f++)if(m[f]!==p[f])return!1;return!0}return!1}function g(m,p){if(!m&&!p)return!0;if(!m||!p)return!1;if(D.ThemeIcon.isThemeIcon(m)&&D.ThemeIcon.isThemeIcon(p))return m.id===p.id&&m.color===p.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof p=="object"&&"light"in p&&"dark"in p){const f=m,d=p;if((r.URI.isUri(f.light)||u(f.light))&&(r.URI.isUri(f.dark)||u(f.dark))&&(r.URI.isUri(d.light)||u(d.light))&&(r.URI.isUri(d.dark)||u(d.dark)))return f.light.path===d.light.path&&f.dark.path===d.dark.path}if(r.URI.isUri(m)&&r.URI.isUri(p)||u(m)||u(p)){const f=m,d=p;return f.path===d.path&&f.scheme===d.scheme}return!1}function u(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}}),define(le[231],ue([0,1,81,3,10,56,46,76,230]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=e.$Gs=void 0,e.$Is=f,e.$Js=v,e.$Gs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Hs={type:"string",enum:Array.from((0,i.$6j)(),y=>y.id),markdownEnumDescriptions:Array.from((0,i.$6j)(),y=>`$(${y.id})`)};const l={args:{description:(0,E.localize)(2085,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(2086,null),type:"boolean"},icon:{description:(0,E.localize)(2087,null),...e.$Hs},color:{description:(0,E.localize)(2088,null),...e.$Gs},env:{markdownDescription:(0,E.localize)(2089,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},g={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(2090,null),type:["string","array"],items:{type:"string"}},...l}},u={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(2091,null),type:["string"],items:{type:"string"}},...l}};function m(y){const $=y===r.Platform.Linux?"linux":y===r.Platform.Mac?"osx":"windows";return(0,E.localize)(2092,null,(0,r.$i)(y),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,E.localize)(2093,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(2094,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(2095,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(2096,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:m(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(2097,null),enum:["PowerShell","Git Bash"]},...l}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2098,null),type:"string"},id:{description:(0,E.localize)(2099,null),type:"string"},title:{description:(0,E.localize)(2100,null),type:"string"},...l}},{type:"null"},g]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:m(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2101,null),type:"string"},id:{description:(0,E.localize)(2102,null),type:"string"},title:{description:(0,E.localize)(2103,null),type:"string"},...l}},{type:"null"},g]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:m(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2104,null),type:"string"},id:{description:(0,E.localize)(2105,null),type:"string"},title:{description:(0,E.localize)(2106,null),type:"string"},...l}},{type:"null"},g]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(2107,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,E.localize)(2108,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(2109,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,E.localize)(2110,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(2111,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){O.$uo.as(D.$zo.Configuration).registerConfiguration(p),v()}let d;function v(y,$){const S=O.$uo.as(D.$zo.Configuration);let k;y&&(k=(0,b.$Cs)(y?.profiles,$));const s=d;d={id:"terminal",order:100,title:(0,E.localize)(2112,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(2113,null),type:["string","null"],default:null,enum:y?.os===r.OperatingSystem.Linux?k?.values:void 0,markdownEnumDescriptions:y?.os===r.OperatingSystem.Linux?k?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(2114,null),type:["string","null"],default:null,enum:y?.os===r.OperatingSystem.Macintosh?k?.values:void 0,markdownEnumDescriptions:y?.os===r.OperatingSystem.Macintosh?k?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(2115,null),type:["string","null"],default:null,enum:y?.os===r.OperatingSystem.Windows?k?.values:void 0,markdownEnumDescriptions:y?.os===r.OperatingSystem.Windows?k?.markdownDescriptions:void 0}}},S.updateConfigurations({add:[d],remove:s?[s]:[]})}}),define(le[232],ue([0,1,27,11,38,9,3,37,25,12,23,132,228,227]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=f,e.$Ss=d,e.$Ts=v,i=Ie(i),D=Ie(D),I=Ie(I),g=Ie(g);function f(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let P=0;return h&&h.length===4&&(P=parseInt(h[3])),P}async function d(h,P,w,R=I.env,L=g.Promises.exists){if(D.$lc(h))return await L(h)?h:void 0;if(P===void 0&&(P=I.cwd()),D.$pc(h)!=="."){const G=D.$mc(P,h);return await L(G)?G:void 0}const T=(0,E.$oo)(R,"PATH");if(w===void 0&&(0,l.$hg)(T)&&(w=T.split(D.$wc)),w===void 0||w.length===0){const G=D.$mc(P,h);return await L(G)?G:void 0}for(const G of w){let q;if(D.$lc(G)?q=D.$mc(G,h):q=D.$mc(P,G,h),await L(q))return q;if(O.$j){let Q=q+".com";if(await L(Q)||(Q=q+".exe",await L(Q)))return Q}}const j=D.$mc(P,h);return await L(j)?j:void 0}function v(h,P,w,R,L){const A=O.$j&&(!P.windowsEnableConpty||f()<18309);if(!P.shellIntegration.enabled||!h.executable||h.isFeatureTerminal&&!h.forceShellIntegration||h.ignoreShellIntegration||A)return;const T=h.args,j=I.$gc==="win32"?D.$qc(h.executable).toLowerCase():D.$qc(h.executable),G=D.$pc(r.$3g.asFileUri("").fsPath);let q;const Q={VSCODE_INJECTION:"1"};if(P.shellIntegration.nonce&&(Q.VSCODE_NONCE=P.shellIntegration.nonce),O.$j){if(j==="pwsh.exe"||j==="powershell.exe")return!T||n(T)?q=S.get($.WindowsPwsh):o(T)&&(q=S.get($.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G,""),Q.VSCODE_STABLE=L.quality==="stable"?"1":"0",P.shellIntegration.suggestEnabled&&(Q.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:Q}):void 0;if(j==="bash.exe")return!T||T.length===0?q=S.get($.Bash):c(T)&&(Q.VSCODE_SHELL_LOGIN="1",y(P,Q),q=S.get($.Bash)),q?(q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G),Q.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:Q}):void 0;R.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(j){case"bash":return!T||T.length===0?q=S.get($.Bash):c(T)&&(Q.VSCODE_SHELL_LOGIN="1",y(P,Q),q=S.get($.Bash)),q?(q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G),Q.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:Q}):void 0;case"fish":{const de=w?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=D.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Q.XDG_DATA_DIRS=`${de}:${x}`,y(P,Q),{newArgs:void 0,envMixin:Q}}case"pwsh":return!T||n(T)?q=S.get($.Pwsh):o(T)&&(q=S.get($.PwshLogin)),q?(P.shellIntegration.suggestEnabled&&(Q.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G,""),Q.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:Q}):void 0;case"zsh":{if(!T||T.length===0?q=S.get($.Zsh):c(T)?(q=S.get($.ZshLogin),y(P,Q)):(T===S.get($.Zsh)||T===S.get($.ZshLogin))&&(q=T),!q)return;q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G);let de;try{de=i.userInfo().username}catch{de="unknown"}const x=D.$mc(i.tmpdir(),`${de}-${L.applicationName}-zsh`);Q.ZDOTDIR=x;const J=w?.ZDOTDIR??i.homedir()??"~";Q.USER_ZDOTDIR=J;const B=[];return B.push({source:D.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$mc(x,".zshrc")}),B.push({source:D.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$mc(x,".zprofile")}),B.push({source:D.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$mc(x,".zshenv")}),B.push({source:D.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$mc(x,".zlogin")}),{newArgs:q,envMixin:Q,filesToCopy:B}}}R.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}function y(h,P){if(O.$k&&h.environmentVariableCollections){const w=(0,m.$Ps)(h.environmentVariableCollections),L=new p.$Qs(w).getVariableMap({workspaceFolder:h.workspaceFolder}).get("PATH"),A=[];if(L)for(const T of L)T.type===u.EnvironmentVariableMutatorType.Prepend&&A.push(T.value);A.length>0&&(P.VSCODE_PATH_PREFIX=A.join(""))}}var $;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})($||($={}));const S=new Map;S.set($.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),S.set($.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),S.set($.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),S.set($.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),S.set($.Zsh,["-i"]),S.set($.ZshLogin,["-il"]),S.set($.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],s=["--login","-l"],a=["-i","--interactive"],t=["-nol","-nologo"];function o(h){return typeof h=="string"?k.includes(h.toLowerCase()):h.length===1&&k.includes(h[0].toLowerCase())||h.length===2&&(k.includes(h[0].toLowerCase())||k.includes(h[1].toLowerCase()))&&(t.includes(h[0].toLowerCase())||t.includes(h[1].toLowerCase()))}function n(h){return typeof h=="string"?t.includes(h.toLowerCase()):h.length===0||h?.length===1&&t.includes(h[0].toLowerCase())}function c(h){return typeof h!="string"&&(h=h.filter(P=>!a.includes(P.toLowerCase()))),h==="string"&&s.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&s.includes(h[0].toLowerCase())}}),define(le[233],ue([0,1,26,44,81,9,3,12,23,117,76,232,97]),function(K,e,i,r,E,D,O,I,b,l,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=v,i=Ie(i),r=Ie(r),b=Ie(b);var p;(function(w){w.UnixShellsPath="/etc/shells"})(p||(p={}));let f,d=!0;function v(w,R,L,A,T=process.env,j,G,q,Q){return j=j||{existsFile:b.SymlinkSupport.existsFile,readFile:i.promises.readFile},O.$j?y(L,j,T,G,A.getValue(g.TerminalSettingId.UseWslProfiles)!==!1,w&&typeof w=="object"?{...w}:A.getValue(g.TerminalSettingId.ProfilesWindows),typeof R=="string"?R:A.getValue(g.TerminalSettingId.DefaultProfileWindows),Q,q):c(j,G,L,w&&typeof w=="object"?{...w}:A.getValue(O.$l?g.TerminalSettingId.ProfilesLinux:g.TerminalSettingId.ProfilesMacOs),typeof R=="string"?R:A.getValue(O.$l?g.TerminalSettingId.DefaultProfileLinux:g.TerminalSettingId.DefaultProfileMacOs),Q,q,T)}async function y(w,R,L,A,T,j,G,q,Q){const de=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${de?"Sysnative":"System32"}`;let J=!1;(0,u.$Rs)()>=16299&&(J=!0),await s(q);const B=new Map;if(w){B.set("PowerShell",{source:g.ProfileSource.Pwsh,icon:E.$8j.terminalPowershell,isAutoDetected:!0}),B.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:E.$8j.terminalPowershell,isAutoDetected:!0}),B.set("Git Bash",{source:g.ProfileSource.GitBash,isAutoDetected:!0}),B.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:E.$8j.terminalCmd,isAutoDetected:!0}),B.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),B.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:E.$8j.terminalBash,isAutoDetected:!0});const C=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;B.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",C],requiresPath:process.env.CMDER_ROOT?C:{path:C,isUnsafe:!0},isAutoDetected:!0})}h(j,B);const _=await $(B.entries(),G,R,L,A,Q);if(w&&T)try{const C=await o(`${x}\\${J?"wsl":"bash"}.exe`,G);for(const W of C)(!j||!(W.profileName in j))&&_.push(W)}catch{d&&(A?.trace("WSL is not installed, so could not detect WSL profiles"),d=!1)}return _}async function $(w,R,L,A=process.env,T,j){const G=[];for(const[q,Q]of w)G.push(S(q,Q,R,L,A,T,j));return(await Promise.all(G)).filter(q=>!!q)}async function S(w,R,L,A,T=process.env,j,G){if(R===null)return;let q,Q,de;if("source"in R&&!("path"in R)){const _=f?.get(R.source);if(!_)return;q=_.paths,Q=R.args||_.args,R.icon?de=k(R.icon):_.icon&&(de=_.icon)}else q=Array.isArray(R.path)?R.path:[R.path],Q=O.$j||Array.isArray(R.args)?R.args:void 0,de=k(R.icon);let x;if(G){const _=q.map(W=>typeof W=="string"?W:W.path),C=await G(_);x=new Array(q.length);for(let W=0;W<q.length;W++)typeof q[W]=="string"?x[W]=C[W]:x[W]={path:C[W],isUnsafe:!0}}else x=q.slice();let J;if(R.requiresPath){let _;if((0,I.$hg)(R.requiresPath)?_=R.requiresPath:(_=R.requiresPath.path,R.requiresPath.isUnsafe&&(J=_)),!await A.existsFile(_))return}const B=await P(w,L,x,A,T,Q,R.env,R.overrideName,R.isAutoDetected,J);if(!B){j?.debug("Terminal profile not validated",w,q);return}return B.isAutoDetected=R.isAutoDetected,B.icon=de,B.color=R.color,B}function k(w){return typeof w=="string"?{id:w}:w}async function s(w){if(f&&!w)return;const[R,L]=await Promise.all([a(),w||t()]);f=new Map,f.set(g.ProfileSource.GitBash,{profileName:"Git Bash",paths:R,args:["--login","-i"]}),f.set(g.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:E.$8j.terminalPowershell})}async function a(){const w=new Set,R=await(0,u.$Ss)("git.exe");if(R){const T=(0,m.dirname)(R);w.add((0,m.resolve)(T,"../.."))}function L(T,j){j&&T.add(j)}L(w,process.env.ProgramW6432),L(w,process.env.ProgramFiles),L(w,process.env["ProgramFiles(X86)"]),L(w,`${process.env.LocalAppData}\\Program`);const A=[];for(const T of w)A.push(`${T}\\Git\\bin\\bash.exe`,`${T}\\Git\\usr\\bin\\bash.exe`,`${T}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function t(){const w=[];for await(const R of(0,l.$zm)())w.push(R.exePath);return w}async function o(w,R){const L=[],A=await new Promise((G,q)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Q,de)=>{if(Q)return q("Problem occurred when getting wsl distros");G(de)})});if(!A)return[];const T=new RegExp(/[\r?\n]/),j=A.split(T).filter(G=>G.trim().length>0&&G!=="");for(const G of j){if(G===""||G.startsWith("docker-desktop"))continue;const q=`${G} (WSL)`,Q={profileName:q,path:w,args:["-d",`${G}`],isDefault:q===R,icon:n(G),isAutoDetected:!1};L.push(Q)}return L}function n(w){return w.includes("Ubuntu")?E.$8j.terminalUbuntu:w.includes("Debian")?E.$8j.terminalDebian:E.$8j.terminalLinux}async function c(w,R,L,A,T,j,G,q){const Q=new Map;if(L&&await w.existsFile(p.UnixShellsPath)){const de=(await w.readFile(p.UnixShellsPath)).toString(),x=(j||de.split(`
`)).map(B=>{const _=B.indexOf("#");return _===-1?B:B.substring(0,_)}).filter(B=>B.trim().length>0),J=new Map;for(const B of x){let _=(0,D.$qc)(B),C=J.get(_)||0;C++,C>1&&(_=`${_} (${C})`),J.set(_,C),Q.set(_,{path:B,isAutoDetected:!0})}}return h(A,Q),await $(Q.entries(),T,w,q,R,G)}function h(w,R){if(w)for(const[L,A]of Object.entries(w))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?R.delete(L):(A.icon=A.icon||R.get(L)?.icon,R.set(L,A))}async function P(w,R,L,A,T,j,G,q,Q,de){if(L.length===0)return Promise.resolve(void 0);const x=L.shift();if(x==="")return P(w,R,L,A,T,j,G,q,Q);const J=typeof x!="string"&&x.isUnsafe,B=typeof x=="string"?x:x.path,_={profileName:w,path:B,args:j,env:G,overrideName:q,isAutoDetected:Q,isDefault:w===R,isUnsafePath:J,requiresUnsafePath:de};if((0,D.$qc)(B)===B){const W=T.PATH?T.PATH.split(D.$wc):void 0,F=await(0,u.$Ss)(B,void 0,W,void 0,A.existsFile);return F?(_.path=F,_.isFromPath=!0,_):P(w,R,L,A,T,j)}return await A.existsFile((0,D.$kc)(B))?_:P(w,R,L,A,T,j,G,q,Q)}}),define(le[234],ue([0,1,4,2,3,45,16,5,196,103,229,76,231,233,119,60]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;var v;(function($){$[$.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let y=class extends r.$Xc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(S,k,s,a){super(),this.M=S,this.N=k,this.O=s,this.P=a,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$oe),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$oe),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$oe),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$oe),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$oe),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$oe),this.onProcessData=this.D.event,this.F=this.B(new i.$oe),this.onProcessReady=this.F.event,this.G=this.B(new i.$oe),this.onProcessReplay=this.G.event,this.H=this.B(new i.$oe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$oe),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$oe),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$oe),this.onProcessExit=this.L.event,(0,m.$Is)(),this.B(this.M),this.B((0,r.$Vc)(()=>this.W())),this.j=this.B(new g.$Bs(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(i.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(u.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$j)return process.env;try{return await(0,l.$Um)(this.N,this.O,{_:[]},process.env)}catch(S){return this.O.error("ptyHost was unable to resolve shell environment",S),{}}}U(){const S=this.M.start(),k=S.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(k.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(S.onDidProcessExit(t=>{this.u.fire(t.code),!this.m&&!this.q.isDisposed&&(this.n<=v.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const a=D.ProxyChannel.toService(k.getChannel(u.TerminalIpcChannels.PtyHost));return this.B(a.onProcessData(t=>this.D.fire(t))),this.B(a.onProcessReady(t=>this.F.fire(t))),this.B(a.onProcessExit(t=>this.L.fire(t))),this.B(a.onDidChangeProperty(t=>this.J.fire(t))),this.B(a.onProcessReplay(t=>this.G.fire(t))),this.B(a.onProcessOrphanQuestion(t=>this.H.fire(t))),this.B(a.onDidRequestDetach(t=>this.I.fire(t))),this.B(new b.$As(this.P,k.getChannel(u.TerminalIpcChannels.Logger))),this.a=S,this.b=a,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async t=>{t.affectsConfiguration(u.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[S,a]}async createProcess(S,k,s,a,t,o,n,c,h,P,w){const R=setTimeout(()=>this.$(),u.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(S,k,s,a,t,o,n,c,h,P,w);return clearTimeout(R),L}updateTitle(S,k,s){return this.f.updateTitle(S,k,s)}updateIcon(S,k,s,a){return this.f.updateIcon(S,k,s,a)}attachToProcess(S){return this.f.attachToProcess(S)}detachFromProcess(S,k){return this.f.detachFromProcess(S,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(S){return this.f.start(S)}shutdown(S,k){return this.f.shutdown(S,k)}input(S,k){return this.f.input(S,k)}processBinary(S,k){return this.f.processBinary(S,k)}resize(S,k,s){return this.f.resize(S,k,s)}clearBuffer(S){return this.f.clearBuffer(S)}acknowledgeDataEvent(S,k){return this.f.acknowledgeDataEvent(S,k)}setUnicodeVersion(S,k){return this.f.setUnicodeVersion(S,k)}getInitialCwd(S){return this.f.getInitialCwd(S)}getCwd(S){return this.f.getCwd(S)}async getLatency(){const S=new d.$ie,k=await this.f.getLatency();return S.stop(),[{label:"ptyhostservice<->ptyhost",latency:S.elapsed()},...k]}orphanQuestionReply(S){return this.f.orphanQuestionReply(S)}installAutoReply(S,k){return this.f.installAutoReply(S,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(S){return this.f.uninstallAutoReply(S)}getDefaultSystemShell(S){return this.g?.getDefaultSystemShell(S)??(0,f.$Dm)(S??E.OS,process.env)}async getProfiles(S,k,s,a=!1){const t=await this.S();return(0,p.$Us)(k,s,a,this.N,t,void 0,this.O,this.bb.bind(this,S))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(S,k){return this.f.getWslPath(S,k)}getRevivedPtyNewId(S,k){return this.f.getRevivedPtyNewId(S,k)}setTerminalLayoutInfo(S){return this.f.setTerminalLayoutInfo(S)}async getTerminalLayoutInfo(S){return this.g?.getTerminalLayoutInfo(S)}async requestDetachInstance(S,k){return this.f.requestDetachInstance(S,k)}async acceptDetachInstanceReply(S,k){return this.f.acceptDetachInstanceReply(S,k)}async freePortKillProcess(S){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(S)}async serializeTerminalState(S){return this.f.serializeTerminalState(S)}async reviveTerminalProcesses(S,k,s){return this.f.reviveTerminalProcesses(S,k,s)}async refreshProperty(S,k){return this.f.refreshProperty(S,k)}async updateProperty(S,k,s){return this.f.updateProperty(S,k,s)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(S){this.ab(),this.s=setTimeout(()=>this.Y(),S?u.HeartbeatConstants.ConnectingBeatInterval:u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(S,k){return this.j.createRequest({workspaceId:S,originalText:k})}async acceptPtyHostResolvedVariables(S,k){this.j.acceptReply(S,k)}};e.$Vs=y,e.$Vs=y=ke([re(1,O.$cj),re(2,I.$dk),re(3,I.$ek)],y)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[77],ue([0,1,13,4,2,3,16,6,34]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0,i=Ve(i);const l="#FFFFFF",g="#1E1E1E",u="#000000",m="#FFFFFF",p="theme",f="themeBackground",d="windowSplash";var v;(function($){$.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",$.SYSTEM_COLOR_THEME="window.systemColorTheme"})(v||(v={})),e.$Pgc=(0,I.$Ii)("themeMainService");let y=class extends E.$Xc{constructor(S,k){super(),this.b=S,this.c=k,this.a=this.B(new r.$oe),this.onDidChangeColorScheme=this.a.event,D.$l||this.B(this.c.onDidChangeConfiguration(s=>{(s.affectsConfiguration(v.SYSTEM_COLOR_THEME)||s.affectsConfiguration(v.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(i.default.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$l||this.c.getValue(v.DETECT_COLOR_SCHEME))i.default.nativeTheme.themeSource="system";else switch(this.c.getValue(v.SYSTEM_COLOR_THEME)){case"dark":i.default.nativeTheme.themeSource="dark";break;case"light":i.default.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.default.nativeTheme.themeSource="light";break;case"vs-dark":i.default.nativeTheme.themeSource="dark";break;default:i.default.nativeTheme.themeSource="system"}break;default:i.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$j){if(i.default.nativeTheme.shouldUseHighContrastColors)return{dark:i.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$k){if(i.default.nativeTheme.shouldUseInvertedColorScheme||i.default.nativeTheme.shouldUseHighContrastColors)return{dark:i.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$l&&i.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const S=this.getColorScheme();if(S.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return S.dark?u:m;let k=this.b.getItem(f,null);if(!k)switch(this.g()){case"vs":k=l;break;case"hc-black":k=u;break;case"hc-light":k=m;break;default:k=g}return D.$k&&k.toUpperCase()===g&&(k="#171717"),k}g(){switch(this.b.getItem(p,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(S,k){this.b.setItems([{key:p,data:k.baseTheme},{key:f,data:k.colorInfo.background},{key:d,data:k}]),typeof S=="number"&&this.h(S,k),this.f()}h(S,k){for(const s of i.default.BrowserWindow.getAllWindows())if(s.id===S){s.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(d)}};e.$Qgc=y,e.$Qgc=y=ke([re(0,b.$VR),re(1,O.$cj)],y)}),define(le[133],ue([0,1,4,2,3,7,16,6,5]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=e.$Uw=e.$Rw=e.$Pw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Lw=e.$Kw=void 0,e.$Mw=u,e.$Nw=p,e.$Ow=f,e.$Qw=d,e.$Sw=v,e.$Tw=y,e.$Kw=(0,I.$Ii)("tunnelService"),e.$Lw=(0,I.$Ii)("sharedTunnelsService");var l;(function(k){k.Http="http",k.Https="https"})(l||(e.TunnelProtocol=l={}));var g;(function(k){k.ConstantPrivate="constantPrivate",k.Private="private",k.Public="public"})(g||(e.TunnelPrivacyId=g={}));function u(k){return!!k.forwardPort}var m;(function(k){k[k.Notify=1]="Notify",k[k.OpenBrowser=2]="OpenBrowser",k[k.OpenPreview=3]="OpenPreview",k[k.Silent=4]="Silent",k[k.Ignore=5]="Ignore",k[k.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function p(k){if(k.scheme!=="http"&&k.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(k.authority);if(s)return{address:s[1],port:+s[2]}}function f(k){if(k.scheme!=="http"&&k.scheme!=="https"||!k.query)return;const s=k.query.split("&");for(const a of s){const t=a.split("=")[1];if(/^https?:/.exec(t)){const o=p(D.URI.parse(t));if(o)return o}}}e.$Pw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(k){return e.$Pw.indexOf(k)>=0}e.$Rw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(k){return e.$Rw.indexOf(k)>=0}function y(k,s,a,t){if(a===E.OperatingSystem.Windows)return!1;if(a===E.OperatingSystem.Macintosh&&v(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(o?.length===4&&parseInt(o[1])>=18)return!1}return k<1024}class ${constructor(s,a,t){this.remoteAddress=s,this.localAddress=a,this.b=t,this.a=new i.$oe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Uw=$;let S=class extends r.$Xc{constructor(s,a){super(),this.r=s,this.s=a,this.a=new i.$oe,this.onTunnelOpened=this.a.event,this.b=new i.$oe,this.onTunnelClosed=this.b.event,this.c=new i.$oe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const s=this.s.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.g=s,s?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.h=s.elevation,this.m=s.privacyOptions,this.j=s.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const s=[],a=Array.from(this.f.values());for(const t of a){const o=Array.from(t.values());for(const n of o){const c=await n.value;c&&typeof c!="string"&&s.push(c)}}return s}async dispose(){super.dispose();for(const s of this.f.values()){for(const{value:a}of s.values())await a.then(t=>typeof t!="string"?t?.dispose():void 0);s.clear()}this.f.clear()}setEnvironmentTunnel(s,a,t,o,n){this.z(s,a,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:a,localAddress:t,privacy:o,protocol:n,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,a){(v(s)||d(s))&&(s=e.$Pw[0]);const t=this.D(s,a);if(t)return++t.refcount,t.value}openTunnel(s,a,t,o,n,c=!1,h,P){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${t} on local port ${n}.`);const w=this.g??s;if(!w)return;if(a||(a="localhost"),o||(o=this.t),this.g&&this.n.has(t)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(w,a,t,o,n,c,h,P);return R?R.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(a,t),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(a,t);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const A=this.w(L);return(L.tunnelRemoteHost!==a||L.tunnelRemotePort!==t)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&L.privacy!==h&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(A),A}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const a=this.f.get(s.tunnelRemoteHost);if(a){const t=a.get(s.tunnelRemotePort);t&&(t.refcount--,await this.y(s.tunnelRemoteHost,s.tunnelRemotePort,t))}}}}async y(s,a,t){if(t.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${a}.`);const o=t.value.then(async n=>{n&&typeof n!="string"&&(await n.dispose(!0),this.b.fire({host:n.tunnelRemoteHost,port:n.tunnelRemotePort}))});return this.f.has(s)&&this.f.get(s).delete(a),o}}async closeTunnel(s,a){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${a} `);const t=this.f.get(s);if(t&&t.has(a)){const o=t.get(a);o.refcount=0,await this.y(s,a,o)}}z(s,a,t){this.f.has(s)||this.f.set(s,new Map),this.f.get(s).set(a,{refcount:1,value:t})}async C(s,a){const t=this.f.get(s);if(t){const o=t.get(a),n=o?await o.value:void 0;(!n||typeof n=="string")&&t.delete(a),t.size===0&&this.f.delete(s)}}D(s,a){const t=[s];d(s)?(t.push(...e.$Pw),t.push(...e.$Rw)):v(s)&&t.push(...e.$Rw);const o=t.map(n=>this.f.get(n));for(const n of o){const c=n?.get(a);if(c)return c}}canTunnel(s){return!!p(s)}G(s,a,t,o,n,c,h){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${t} on local port ${o}.`);const P=t;this.n.add(P);const w=o===void 0?t:o,R={elevationRequired:n?this.isPortPrivileged(w):!1},L={remoteAddress:{host:a,port:t},localAddressPort:o,privacy:c,public:c?c!==g.Private:void 0,protocol:h},A=s.forwardPort(L,R);return A?(this.z(a,t,A),A.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(P)})):this.n.delete(P),A}};e.$Vw=S,e.$Vw=S=ke([re(0,b.$dk),re(1,O.$cj)],S)}),define(le[50],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eZ=e.$dZ=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.Disabled="disabled",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(r||(e.StateType=r={}));var E;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(E||(e.UpdateType=E={}));var D;(function(O){O[O.NotBuilt=0]="NotBuilt",O[O.DisabledByEnvironment=1]="DisabledByEnvironment",O[O.ManuallyDisabled=2]="ManuallyDisabled",O[O.MissingConfiguration=3]="MissingConfiguration",O[O.InvalidConfiguration=4]="InvalidConfiguration",O[O.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$dZ={Uninitialized:{type:r.Uninitialized},Disabled:O=>({type:r.Disabled,reason:O}),Idle:(O,I)=>({type:r.Idle,updateType:O,error:I}),CheckingForUpdates:O=>({type:r.CheckingForUpdates,explicit:O}),AvailableForDownload:O=>({type:r.AvailableForDownload,update:O}),Downloading:{type:r.Downloading},Downloaded:O=>({type:r.Downloaded,update:O}),Updating:O=>({type:r.Updating,update:O}),Ready:O=>({type:r.Ready,update:O})},e.$eZ=(0,i.$Ii)("updateService")}),define(le[235],ue([0,1,3,10,56,46]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$uo.as(E.$zo.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(2429,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(2430,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(2431,null),(0,r.localize)(2432,null),(0,r.localize)(2433,null),(0,r.localize)(2434,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(2435,null),deprecationMessage:(0,r.localize)(2436,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:E.ConfigurationScope.APPLICATION,title:(0,r.localize)(2437,null),description:(0,r.localize)(2438,null),included:i.$j&&!i.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(2439,null),tags:["usesOnlineServices"]}}})}),define(le[236],ue([0,1,4,50]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=void 0;class E{constructor(I){this.a=I}listen(I,b){switch(b){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${b}`)}call(I,b,l){switch(b){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${b}`)}}e.$4hc=E;class D{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new i.$oe,this.onStateChange=this.a.event,this.b=r.$dZ.Uninitialized,this.c.listen("onStateChange")(b=>this.state=b),this.c.call("_getInitialState").then(b=>this.state=b)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$5hc=D}),define(le[41],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,i.$Ii)("IUriIdentityService")}),define(le[237],ue([0,1,41,176,14,18,147,4,2]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class l{static{this._clock=0}constructor(m){this.uri=m,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let g=class{constructor(m){this.g=m,this.c=new b.$Wc,this.f=2**16;const p=new Map,f=d=>{let v=p.get(d.scheme);return v===void 0&&(v=m.hasProvider(d)&&!this.g.hasCapability(d,E.FileSystemProviderCapabilities.PathCaseSensitive),p.set(d.scheme,v)),v};this.c.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(d=>{p.delete(d.scheme)})),this.extUri=new D.$$g(f),this.d=new O.$Ys((d,v)=>this.extUri.compare(d,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,D.$kh)(m));const p=this.d.get(m);return p?p.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new l(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((f,d)=>f[1].time<d[1].time?1:f[1].time>d[1].time?-1:0);l._clock=0,this.d.clear();const p=this.f*.5;for(let f=0;f<p;f++)this.d.set(m[f][0],m[f][1].touch())}};e.$Zs=g,e.$Zs=g=ke([re(0,E.$dl)],g),(0,r.$Ws)(i.$Nl,g,r.InstantiationType.Delayed)}),define(le[134],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Y=void 0,e.$7Y=(0,i.$Ii)("urlService")}),define(le[238],ue([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=e.$_hc=void 0;class r{constructor(I){this.a=I}listen(I,b){throw new Error(`Event not found: ${b}`)}call(I,b,l){switch(b){case"handleURL":return this.a.handleURL(i.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${b}`)}}e.$_hc=r;class E{constructor(I){this.a=I}handleURL(I,b){return this.a.call("handleURL",[I.toJSON(),b])}}e.$aic=E;class D{constructor(I,b){this.a=I,this.b=b}async routeCall(I,b,l,g){if(b!=="handleURL")throw new Error(`Call not found: ${b}`);if(Array.isArray(l)&&l.length>0){const u=i.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",u.toString(!0)),u.query){const m=/\bwindowId=(\d+)/.exec(u.query);if(m){const p=m[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${p}"`,u.toString(!0));const f=new RegExp(`window:${p}`),d=I.connections.find(v=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),f.test(v.ctx)));if(d)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",u.toString(!0)),d;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",u.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",u.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,b,l,g)}routeEvent(I,b){throw new Error(`Event not found: ${b}`)}}e.$bic=D}),define(le[239],ue([0,1,8,2,7,28]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Y=e.$8Y=void 0;class O extends r.$Xc{constructor(){super(...arguments),this.a=new Set}open(l,g){const u=[...this.a.values()];return(0,i.$Mh)(u.map(m=>()=>m.handleURL(l,g)),void 0,!1).then(m=>m||!1)}registerHandler(l){return this.a.add(l),(0,r.$Vc)(()=>this.a.delete(l))}}e.$8Y=O;let I=class extends O{constructor(l){super(),this.b=l}create(l){let{authority:g,path:u,query:m,fragment:p}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&u&&u.indexOf("/")!==0&&(u=`/${u}`),E.URI.from({scheme:this.b.urlProtocol,authority:g,path:u,query:m,fragment:p})}};e.$9Y=I,e.$9Y=I=ke([re(0,D.$wk)],I)}),define(le[240],ue([0,1,13,8,4,2,3,7]),function(K,e,i,r,E,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;class b extends D.$Xc{constructor(g,u,m,p,f,d){if(super(),this.c=u,this.f=d,this.a=[],this.b=0,g&&(d.trace("ElectronURLListener initialUrisToHandle:",g.map($=>$.originalUrl)),this.a=g),O.$j){const $=p.isBuilt?[]:[`"${p.appRoot}"`];$.push("--open-url","--"),i.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,$)}const v=E.Event.map(E.Event.fromNodeEventEmitter(i.app,"open-url",($,S)=>({event:$,url:S})),({event:$,url:S})=>($.preventDefault(),S));this.B(v($=>{const S=this.g($);S&&this.c.open(S,{originalUrl:$})})),m.getWindows().filter($=>$.isReady).length>0?(d.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(d.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(E.Event.once(m.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return I.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const u of this.a)await this.c.open(u.uri,{originalUrl:u.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",u.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",u.originalUrl),g.push(u));g.length!==0&&(this.a=g,(0,r.$Kh)(()=>this.h(),500,this.q))}}e.$cic=b}),define(le[241],ue([0,1,4,2,14,61,31]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=void 0;class I extends r.$Xc{constructor(l,g,u,m,p,f){super(),this.f=l,this.g=g,this.h=u,this.j=m,this.m=p,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$oe),this.onDidChangeFile=this.a.event,this.b=D.$Oi.forUris(()=>!(this.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new O.$Ec(d=>this.m.extUri.getComparisonKey(this.t(d))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(d=>this.s(d)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,g){return this.g.open(this.t(l),g)}close(l){return this.g.close(l)}read(l,g,u,m,p){return this.g.read(l,g,u,m,p)}write(l,g,u,m,p){return this.g.write(l,g,u,m,p)}watch(l,g){this.b.set(l,l);const u=this.g.watch(this.t(l),g);return(0,r.$Vc)(()=>{this.b.delete(l),u.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,g,u){return this.g.rename(this.t(l),this.t(g),u)}readFile(l,g){return this.g.readFile(this.t(l),g)}readFileStream(l,g,u){return this.g.readFileStream(this.t(l),g,u)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,g,u){return this.g.writeFile(this.t(l),g,u)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,g){return this.g.delete(this.t(l),g)}copy(l,g,u){if((0,E.$hl)(this.g))return this.g.copy(this.t(l),this.t(g),u);throw new Error("copy not supported")}cloneFile(l,g){if((0,E.$il)(this.g))return this.g.cloneFile(this.t(l),this.t(g));throw new Error("clone not supported")}s(l){const g=[];for(const u of l){if(u.resource.scheme!==this.f)continue;const m=this.u(u.resource);this.b.findSubstr(m)&&g.push({resource:m,type:u.type,cId:u.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$Ric=I}),define(le[242],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0,e.$yic="utilityProcessWorker"}),define(le[243],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0,e.$dic=(0,i.$Ii)("webviewManagerService")}),define(le[244],ue([0,1,13,2,11,7]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class O extends r.$Xc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const b=this.b.bind(this);i.protocol.registerFileProtocol(E.Schemas.vscodeWebview,b)}b(b,l){try{const g=D.URI.parse(b.url),u=O.a.get(g.path);if(typeof u=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${u}`,p=E.$3g.asFileUri(m);return l({path:p.fsPath,headers:{...E.COI.getHeadersFromQuery(b.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$eic=O});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[51],ue([0,1,3,63]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tE=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$kE=void 0,e.$lE=E,e.$mE=D,e.$nE=O,e.$oE=I,e.$pE=b,e.$qE=m,e.$rE=p,e.$sE=f,e.$uE=d,e.$vE=v,e.$wE=y,r=Ve(r),e.$kE={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function E($){return typeof $.parentId=="number"}function D($){return!!$.workspaceUri}function O($){return!!$.folderUri}function I($){return!!$.fileUri}function b($){const S=p($),k=$.getValue("window.menuBarVisibility");return k==="default"||S&&k==="compact"||i.$k&&i.$n?"classic":k}var l;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(l||(e.TitleBarSetting=l={}));var g;(function($){$.NATIVE="native",$.CUSTOM="custom"})(g||(e.TitlebarStyle=g={}));var u;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(u||(e.CustomTitleBarVisibility=u={}));function m($,S){return!0}function p($,S){return S||(S=f($)),S===g.NATIVE}function f($){if(i.$p)return g.CUSTOM;const S=$.getValue("window");if(S){if(i.$k&&S.nativeTabs===!0||i.$k&&S.nativeFullScreen===!1)return g.NATIVE;const a=S.titleBarStyle;if(a===g.NATIVE||a===g.CUSTOM)return a}return i.$l?g.NATIVE:g.CUSTOM}e.$tE=35;function d($){if(i.$k||i.$p||p($))return!1;if(i.$l){const S=$.getValue("window.experimentalControlOverlay");return typeof S=="boolean"?S:r.default.quality!=="stable"}return!0}function v($){const S=$.getValue("window");return!S||typeof S.nativeFullScreen!="boolean"||S.nativeTabs?!0:S.nativeFullScreen!==!1}function y($=0){return Math.pow(1.2,$)}});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[52],ue([0,1,13]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Hgc=e.$Ggc=e.UnloadReason=e.LoadReason=void 0,i=Ve(i);var r;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var E;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(E||(e.UnloadReason=E={}));const D=function(l=I.Normal){return{width:1024,height:768,mode:l}};e.$Ggc=D;const O=function(){const u=i.default.screen.getPrimaryDisplay().workArea,m=Math.max(u.x+u.width/2-800/2,0),p=Math.max(u.y+u.height/2-600/2,0);return{x:m,y:p,width:800,height:600,mode:I.Normal}};e.$Hgc=O;var I;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var b;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(b||(e.WindowError=b={}))}),define(le[245],ue([0,1,8,4,2]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;class D extends E.$Xc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:b,getActiveWindowId:l}){super(),this.a=this.B(new E.$Wc),r.Event.latch(r.Event.any(I,b))(this.f,this,this.a),this.b=(0,i.$vh)(()=>l()),(async()=>{try{const u=await this.b;this.c=typeof this.c=="number"?this.c:u}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$kic=D}),define(le[30],ue([0,1,10,9,61,18,7,6,11]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=l,e.$Ti=g,e.$Wi=u,e.$Xi=m,e.$Yi=p,e.$Zi=d,e.$1i=v,e.$4i=S,e.$9i=k,e.$0i=s,e.$_i=a,e.$aj=t,e.$bj=o,e.$Ri=(0,I.$Ii)("contextService");function l(n){const c=n;return typeof c?.id=="string"&&O.URI.isUri(c.uri)}function g(n){return typeof n?.id=="string"&&!l(n)&&!m(n)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function u(n,c){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,r.$qc)(n)}:c?e.$Ui:e.$Vi;const h=n;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function m(n){const c=n;return typeof c?.id=="string"&&O.URI.isUri(c.configPath)}function p(n){const c=n;if(c?.uri)return{id:c.id,uri:O.URI.revive(c.uri)};const h=n;if(h?.configPath)return{id:h.id,configPath:O.URI.revive(h.configPath)};if(n?.id)return{id:n.id}}var f;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function d(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function v(n){const c=n;return!!(c&&typeof c=="object"&&O.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class y{constructor(c,h,P,w,R){this.h=c,this.j=P,this.k=w,this.l=R,this.c=E.$Oi.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=E.$Oi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=y;class ${constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,D.$jh)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=$;function S(n){return new $({uri:n,index:0,name:(0,D.$fh)(n)},{uri:n.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,i.localize)(2487,null),extensions:[e.$5i]}],e.$8i="workspace.json";function k(n,c){return D.$ah.isEqualOrParent(n,c.untitledWorkspacesHome)}function s(n){let c;return O.URI.isUri(n)?c=n:c=n.configuration,c?.scheme===b.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(n){return n.id===e.$$i}function t(n,c){return!k(n,c)&&!s(n)}function o(n){return(typeof n=="string"?(0,r.$rc)(n):(0,D.$hh)(n))===e.$6i}});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[53],ue([0,1,13,8,47,48,2,79,3,23,10,125,6,5,28,30]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0,i=Ve(i),e.$Mgc=(0,m.$Ii)("dialogMainService");let v=class{constructor($,S){this.d=$,this.e=S,this.a=new Map,this.b=new Map,this.c=new r.$Ph}pickFileFolder($,S){return this.f({...$,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(1705,null)},S)}pickFolder($,S){return this.f({...$,pickFolders:!0,title:(0,g.localize)(1706,null)},S)}pickFile($,S){return this.f({...$,pickFiles:!0,title:(0,g.localize)(1707,null)},S)}pickWorkspace($,S){const k=(0,g.localize)(1708,null),s=(0,D.$ax)((0,g.localize)(1709,null)),a=d.$7i;return this.f({...$,pickFiles:!0,title:k,filters:a,buttonLabel:s},S)}async f($,S){const k={title:$.title,buttonLabel:$.buttonLabel,filters:$.filters,defaultPath:$.defaultPath};(typeof $.pickFiles=="boolean"||typeof $.pickFolders=="boolean")&&(k.properties=void 0,$.pickFiles&&$.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",$.pickFolders?"openDirectory":"openFile","createDirectory"]),b.$k&&k.properties.push("treatPackageAsDirectory");const s=await this.showOpenDialog(k,(S||i.default.BrowserWindow.getFocusedWindow())??void 0);if(s&&s.filePaths&&s.filePaths.length>0)return s.filePaths}g($){if($){let S=this.b.get($.id);return S||(S=new r.$Ph,this.b.set($.id,S)),S}else return this.c}showMessageBox($,S){return this.g(S).queue(async()=>{const{options:k,buttonIndeces:s}=(0,u.$hx)($,this.e);let a;return S?a=await i.default.dialog.showMessageBox(S,k):a=await i.default.dialog.showMessageBox(k),{response:s[a.response],checkboxChecked:a.checkboxChecked}})}async showSaveDialog($,S){const k=this.j($,S);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(S).queue(async()=>{let s;return S?s=await i.default.dialog.showSaveDialog(S,$):s=await i.default.dialog.showSaveDialog($),s.filePath=this.h(s.filePath),s})}finally{(0,O.$Sc)(k)}}h($){return $&&b.$k&&($=(0,I.$qm)($)),$}i($){return $.map(S=>this.h(S))}async showOpenDialog($,S){$.defaultPath&&(await l.Promises.exists($.defaultPath)||($.defaultPath=void 0));const k=this.j($,S);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(S).queue(async()=>{let s;return S?s=await i.default.dialog.showOpenDialog(S,$):s=await i.default.dialog.showOpenDialog($),s.filePaths=this.i(s.filePaths),s})}finally{(0,O.$Sc)(k)}}j($,S){if(!S)return O.$Xc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",$);let k=this.a.get(S.id);k||(k=new Set,this.a.set(S.id,k));const s=(0,E.$wj)($);if(!k.has(s))return this.d.trace("[DialogMainService]: new file dialog lock created",$),k.add(s),(0,O.$Vc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",$),k?.delete(s),k?.size===0&&this.a.delete(S.id)})}};e.$Ngc=v,e.$Ngc=v=ke([re(0,p.$dk),re(1,f.$wk)],v)}),define(le[246],ue([0,1,4,2,83,30]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class O extends r.$Xc{static{this.a=100}constructor(b,l){super(),this.f=b,this.g=l,this.b=this.B(new i.$oe),this.c=new Map,this.h(l.applicationStorage,this.b)}h(b,l){this.B(i.Event.debounce(b.onDidChangeStorage,(g,u)=>(g?g.push(u):g=[u],g),O.a)(g=>{g.length&&l.fire(this.j(g,b))}))}j(b,l){const g=new Map,u=new Set;return b.forEach(m=>{const p=l.get(m.key);typeof p=="string"?g.set(m.key,p):u.add(m.key)}),{changed:Array.from(g.entries()),deleted:Array.from(u.values())}}listen(b,l,g){switch(l){case"onDidChangeStorage":{const u=g.profile?(0,E.$fi)(g.profile):void 0;if(!u)return this.b.event;let m=this.c.get(u.id);return m||(m=this.B(new i.$oe),this.h(this.g.profileStorage(u),m),this.c.set(u.id,m)),m.event}}throw new Error(`Event not found: ${l}`)}async call(b,l,g){const u=g.profile?(0,E.$fi)(g.profile):void 0,m=(0,D.$Yi)(g.workspace),p=await this.m(u,m);switch(l){case"getItems":return Array.from(p.items.entries());case"updateItems":{const f=g;if(f.insert)for(const[d,v]of f.insert)p.set(d,v);f.delete?.forEach(d=>p.delete(d));break}case"optimize":return p.optimize();case"isUsed":{const f=g.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${l}`)}}async m(b,l){let g;l?g=this.g.workspaceStorage(l):b?g=this.g.profileStorage(b):g=this.g.applicationStorage;try{await g.init()}catch(u){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":b?"profile":"application"} storage due to ${u}`)}return g}}e.$1hc=O}),define(le[42],ue([0,1,47,4,2,18,7,10,36,14,6,5,30,31,41,8,33,25,12]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=k,e.$Ql=s,e.$Rl=a;var S;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(S||(e.ProfileResourceType=S={}));function k(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&O.URI.isUri(c.location)&&O.URI.isUri(c.globalStorageHome)&&O.URI.isUri(c.settingsResource)&&O.URI.isUri(c.keybindingsResource)&&O.URI.isUri(c.tasksResource)&&O.URI.isUri(c.snippetsHome)&&O.URI.isUri(c.extensionsResource))}e.$Pl=(0,g.$Ii)("IUserDataProfilesService");function s(n,c){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:O.URI.revive(n.location).with({scheme:c}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:c}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:c}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:c}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:c}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:c}),extensionsResource:O.URI.revive(n.extensionsResource).with({scheme:c}),cacheHome:O.URI.revive(n.cacheHome).with({scheme:c}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function a(n,c,h,P,w,R){return{id:n,name:c,location:h,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:R&&w?.useDefaultFlags?.globalState?R.globalStorageHome:(0,D.$jh)(h,"globalStorage"),settingsResource:R&&w?.useDefaultFlags?.settings?R.settingsResource:(0,D.$jh)(h,"settings.json"),keybindingsResource:R&&w?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,D.$jh)(h,"keybindings.json"),tasksResource:R&&w?.useDefaultFlags?.tasks?R.tasksResource:(0,D.$jh)(h,"tasks.json"),snippetsHome:R&&w?.useDefaultFlags?.snippets?R.snippetsHome:(0,D.$jh)(h,"snippets"),extensionsResource:R&&w?.useDefaultFlags?.extensions?R.extensionsResource:(0,D.$jh)(h,"extensions.json"),cacheHome:(0,D.$jh)(P,n),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let t=class extends E.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,P,w){super(),this.t=c,this.u=h,this.w=P,this.y=w,this.f=!0,this.h=this.B(new r.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new p.$Dc,workspaces:new p.$Dc,emptyWindows:new Map},this.profilesHome=(0,D.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,$.$hg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}h.push(a((0,D.$gh)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},c))}}catch(R){this.y.error(R)}const P=new p.$Dc,w=new Map;if(h.length)try{const R=this.Q();if(R.workspaces)for(const[L,A]of Object.entries(R.workspaces)){const T=O.URI.parse(L),j=h.find(G=>G.id===A);j&&P.set(T,j)}if(R.emptyWindows)for(const[L,A]of Object.entries(R.emptyWindows)){const T=h.find(j=>j.id===A);T&&w.set(L,T)}}catch(R){this.y.error(R)}this.z={profiles:h,workspaces:P,emptyWindows:w}}return this.z}D(){const c=a("__default__profile__",(0,I.localize)(2440,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",P=new RegExp(`${(0,y.$kf)(h)}\\s(\\d+)`);let w=0;for(const L of this.profiles){const A=P.exec(L.name),T=A?parseInt(A[1]):0;w=T>w?T:w}const R=`${h} ${w+1}`;return this.createProfile((0,i.$wj)((0,v.$5g)()).toString(16),R,{transient:!0},c)}async createNamedProfile(c,h,P){return this.createProfile((0,i.$wj)((0,v.$5g)()).toString(16),c,h,P)}async createProfile(c,h,P,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(c,h,P);return w&&await this.setProfileForWorkspace(w,R),R}async F(c,h,P){if(!(0,$.$hg)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(h);return w||(w=(async()=>{try{if(this.profiles.find(T=>T.name===h||T.id===c))throw new Error(`Profile with ${h} name already exists`);const L=a(c,h,(0,D.$jh)(this.profilesHome,c),this.g,P,this.defaultProfile);await this.u.createFolder(L.location);const A=[];return this.j.fire({profile:L,join(T){A.push(T)}}),await d.Promises.settled(A),this.I([L],[],[]),L}finally{this.r.delete(h)}})(),this.r.set(h,w)),w}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let P=this.profiles.find(w=>w.id===c.id);if(!P)throw new Error(`Profile '${c.name}' does not exist`);return P=a(P.id,h.name??P.name,P.location,this.g,{shortName:h.shortName??P.shortName,icon:h.icon===null?void 0:h.icon??P.icon,transient:h.transient??P.isTransient,useDefaultFlags:h.useDefaultFlags??P.useDefaultFlags},this.defaultProfile),this.I([],[],[P]),P}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(w=>w.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const P=[];this.m.fire({profile:h,join(w){P.push(w)}});try{await Promise.allSettled(P)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(w){(0,l.$ul)(w)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=this.profiles.find(w=>w.id===h.id);if(!P)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,P)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(P=>!this.w.extUri.isEqual(P.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c),P=O.URI.isUri(h)?this.C.workspaces.get(h):this.C.emptyWindows.get(h);return P||((0,m.$Si)(c)?this.s.folders.get(c.uri):(0,m.$Xi)(c)?this.s.workspaces.get(c.configPath):this.s.emptyWindows.get(c.id))}G(c){return(0,m.$Si)(c)?c.uri:(0,m.$Xi)(c)?c.configPath:c.id}H(c){return!!([...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.folders.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,P){const w=[...this.profiles,...c],R=[],L=this.s.profiles;this.s.profiles=[];for(let A of w){if(A.isDefault||h.some(j=>A.id===j.id))continue;A=P.find(j=>A.id===j.id)??A;const T=L.find(j=>A.id===j.id);if(A.isTransient)this.s.profiles.push(A);else{if(T){for(const[j,G]of this.s.emptyWindows.entries())if(A.id===G.id){this.L({id:j},A);break}for(const[j,G]of this.s.workspaces.entries())if(A.id===G.id){this.L({id:"",configPath:j},A);break}for(const[j,G]of this.s.folders.entries())if(A.id===G.id){this.L({id:"",uri:j},A);break}}R.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(c,h,P)}J(c,h,P){this.h.fire({added:c,removed:h,updated:P,all:this.profiles})}L(c,h,P){if(P=h?.isTransient?!0:P,P)(0,m.$Si)(c)?(this.s.folders.delete(c.uri),h&&this.s.folders.set(c.uri,h)):(0,m.$Xi)(c)?(this.s.workspaces.delete(c.configPath),h&&this.s.workspaces.set(c.configPath,h)):(this.s.emptyWindows.delete(c.id),h&&this.s.emptyWindows.set(c.id,h));else{this.L(c,void 0,!0);const w=this.G(c);O.URI.isUri(w)?(this.C.workspaces.delete(w),h&&this.C.workspaces.set(w,h)):(this.C.emptyWindows.delete(w),h&&this.C.emptyWindows.set(w,h)),this.M()}}M(){const c={};for(const[P,w]of this.C.workspaces.entries())c[P.toString()]=w.id;const h={};for(const[P,w]of this.C.emptyWindows.entries())h[P.toString()]=w.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},P=this.D();if(c.workspaces)for(const[R,L]of Object.entries(c.workspaces)){const A=O.URI.parse(L);h[R]=this.w.extUri.isEqual(A,P.location)?P.id:this.w.extUri.basename(A)}const w={};if(c.emptyWindows)for(const[R,L]of Object.entries(c.emptyWindows)){const A=O.URI.parse(L);w[R]=this.w.extUri.isEqual(A,P.location)?P.id:this.w.extUri.basename(A)}return{workspaces:h,emptyWindows:w}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Sl=t,e.$Sl=t=ke([re(0,b.$Pi),re(1,l.$dl),re(2,f.$Nl),re(3,u.$dk)],t);class o extends t{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Tl=o}),define(le[88],ue([0,1,8,17,2,4,31,7,128,131,14,6,5,42,41,12,15,24]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=e.$Nq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class S extends Error{constructor(o,n){super(o),this.code=n}}e.$Nq=S,e.$Oq=(0,u.$Ii)("IExtensionsProfileScannerService");let k=class extends E.$Xc{constructor(o,n,c,h,P,w){super(),this.j=o,this.m=n,this.n=c,this.r=h,this.s=P,this.t=w,this.b=this.B(new D.$oe),this.onAddExtensions=this.b.event,this.c=this.B(new D.$oe),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$oe),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$oe),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Dc}scanProfileExtensions(o,n){return this.u(o,void 0,n)}async addExtensionsToProfile(o,n,c){const h=[],P=[];try{return await this.u(n,w=>{const R=[];if(c)R.push(...w);else for(const L of w)o.some(([A])=>(0,l.$Pp)(A.identifier,L.identifier)&&A.manifest.version!==L.version)?h.push(L):R.push(L);for(const[L,A]of o){const T=R.findIndex(G=>(0,l.$Pp)(G.identifier,L.identifier)&&G.version===L.manifest.version),j={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:A};T===-1?(P.push(j),R.push(j)):R.splice(T,1,j)}return P.length&&this.b.fire({extensions:P,profileLocation:n}),h.length&&this.f.fire({extensions:h,profileLocation:n}),R}),P.length&&this.c.fire({extensions:P,profileLocation:n}),h.length&&this.g.fire({extensions:h,profileLocation:n}),P}catch(w){throw P.length&&this.c.fire({extensions:P,error:w,profileLocation:n}),h.length&&this.g.fire({extensions:h,error:w,profileLocation:n}),w}}async updateMetadata(o,n){const c=[];return await this.u(n,h=>{const P=[];for(const w of h){const R=o.find(([L])=>(0,l.$Pp)(L.identifier,w.identifier)&&L.manifest.version===w.version);R&&(w.metadata={...w.metadata,...R[1]},c.push(w)),P.push(w)}return P}),c}async removeExtensionFromProfile(o,n){const c=[];try{await this.u(n,h=>{const P=[];for(const w of h)(0,l.$Pp)(w.identifier,o.identifier)?c.push(w):P.push(w);return c.length&&this.f.fire({extensions:c,profileLocation:n}),P}),c.length&&this.g.fire({extensions:c,profileLocation:n})}catch(h){throw c.length&&this.g.fire({extensions:c,error:h,profileLocation:n}),h}}async u(o,n,c){return this.F(o).queue(async()=>{let h=[],P;try{const w=await this.m.readFile(o);P=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,g.$ul)(w)!==g.FileOperationResult.FILE_NOT_FOUND)throw w;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(P=await this.D()),!P&&c?.bailOutWhenFileNotFound)throw new S((0,v.$_)(w),$.ERROR_PROFILE_NOT_FOUND)}if(P){Array.isArray(P)||this.w(o);let w=!1;for(const R of P){s(R)||this.w(o);let L;if((0,d.$hg)(R.relativeLocation)&&R.relativeLocation)L=this.z(R.relativeLocation);else if((0,d.$hg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{L=I.URI.revive(R.location);const A=this.y(L);A&&(w=!0,R.relativeLocation=A)}(0,d.$og)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(w=!0,R.metadata.hasPreReleaseVersion=!0),h.push({identifier:R.identifier,location:L,version:R.version,metadata:R.metadata})}w&&await this.m.writeFile(o,r.$Qe.fromString(JSON.stringify(P)))}if(n){h=n(h);const w=h.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(o,r.$Qe.fromString(JSON.stringify(w)))}return h})}w(o){const n=new S(`Invalid extensions content in ${o.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let c;try{c=(await this.m.readFile(o)).value.toString()}catch(P){if((0,g.$ul)(P)===g.FileOperationResult.FILE_NOT_FOUND)return;throw P}this.t.info("Migrating extensions from old default profile location",o.toString());let h;try{const P=JSON.parse(c);Array.isArray(P)&&P.every(w=>s(w))?h=P:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",P)}catch(P){this.t.error(P)}if(h)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Qe.fromString(JSON.stringify(h)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(P){if((0,g.$ul)(P)===g.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw P}try{await this.m.del(o)}catch(P){(0,g.$ul)(P)!==g.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}try{await this.m.del(n)}catch(P){(0,g.$ul)(P)!==g.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}return h})()),this.C}F(o){let n=this.h.get(o);return n||(n=new i.$Ph,this.h.set(o,n)),n}};e.$Pq=k,e.$Pq=k=ke([re(1,g.$dl),re(2,p.$Pl),re(3,f.$Nl),re(4,y.$cm),re(5,m.$dk)],k);function s(t){return(0,d.$jg)(t)&&(0,b.$np)(t.identifier)&&(a(t.location)||(0,d.$hg)(t.location)&&t.location)&&((0,d.$og)(t.relativeLocation)||(0,d.$hg)(t.relativeLocation))&&t.version&&(0,d.$hg)(t.version)}function a(t){return t?(0,d.$hg)(t.path)&&(0,d.$hg)(t.scheme):!1}});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[135],ue([0,1,21,8,38,17,15,43,166,2,11,9,3,18,213,82,12,7,10,36,131,87,212,14,6,5,28,4,83,88,42,41,174]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t,o,n,c,h,P,w,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Uq=e.$Tq=e.$Sq=e.Translations=void 0,e.$Vq=de,E=Ie(E),u=Ie(u),m=Ie(m),f=Ie(f),d=Ve(d);var T;(function(J){function B(_,C){if(_===C)return!0;const W=Object.keys(_),F=new Set;for(const H of Object.keys(C))F.add(H);if(W.length!==F.size)return!1;for(const H of W){if(_[H]!==C[H])return!1;F.delete(H)}return F.size===0}J.equals=B})(T||(e.Translations=T={})),e.$Sq=(0,o.$Ii)("IExtensionsScannerService");let j=class extends l.$Xc{constructor(B,_,C,W,F,H,ne,V,ce,oe,Y,M){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=_,this.r=C,this.s=W,this.t=F,this.u=H,this.w=ne,this.y=V,this.z=ce,this.C=oe,this.D=Y,this.F=M,this.g=this.B(new h.$oe),this.onDidChangeCache=this.g.event,this.h=(0,p.$jh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Q,this.s,this.h)),this.m=this.B(this.F.createInstance(Q,this.s,this.h)),this.n=this.B(this.F.createInstance(q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(s.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(s.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,k.$1p)(this.w,this.y)),this.G}async scanAllExtensions(B,_,C){const[W,F]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(_)]),H=C?await this.scanExtensionsUnderDevelopment(B,[...W,...F]):[];return this.L(W,F,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const _=[];_.push(this.M(!!B.useCache,B.language)),_.push(this.N(B.language,!!B.checkControlFile));const[C,W]=await Promise.all(_);return this.J([...C,...W],s.ExtensionType.System,B,!1)}async scanUserExtensions(B){const _=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const C=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(_,!!B.profileLocation,s.ExtensionType.User,!B.includeUninstalled,B.language,!0,C,B.productVersion??this.R()),F=B.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let H;try{H=await F.scanExtensions(W)}catch(ne){if(ne instanceof w.$Nq&&ne.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),H=await F.scanExtensions(W);else throw ne}return H=await this.J(H,s.ExtensionType.User,B,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(B,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const C=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===g.Schemas.file).map(async W=>{const F=await this.P(W,!1,s.ExtensionType.User,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(F)).map(ne=>(ne.type=_.find(V=>(0,k.$Pp)(V.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,F)))}))).flat();return this.J(C,"development",B,!0)}return[]}async scanExistingExtension(B,_,C){const W=await this.P(B,!1,_,!0,C.language,!0,void 0,C.productVersion??this.R()),F=await this.n.scanExtension(W);return!F||!C.includeInvalid&&!F.isValid?null:F}async scanOneOrMultipleExtensions(B,_,C){const W=await this.P(B,!1,_,!0,C.language,!0,void 0,C.productVersion??this.R()),F=await this.n.scanOneOrMultipleExtensions(W);return this.J(F,_,C,!0)}async scanMultipleExtensions(B,_,C){const W=[];return await Promise.all(B.map(async F=>{const H=await this.scanOneOrMultipleExtensions(F,_,C);W.push(...H)})),this.J(W,_,C,!0)}async scanMetadata(B){const _=(0,p.$jh)(B,"package.json"),C=(await this.w.readFile(_)).value.toString();return JSON.parse(C).__metadata}async updateMetadata(B,_){const C=(0,p.$jh)(B,"package.json"),W=(await this.w.readFile(C)).value.toString(),F=JSON.parse(W);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,F.__metadata={...F.__metadata,..._},await this.w.writeFile((0,p.$jh)(B,"package.json"),D.$Qe.fromString(JSON.stringify(F,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof w.$Nq&&B.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Qe.fromString(JSON.stringify([])))}catch(_){(0,t.$ul)(_)!==t.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$_)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,_,C,W){return C.includeAllVersions||(B=this.L(_===s.ExtensionType.System?B:void 0,_===s.ExtensionType.User?B:void 0,_==="development"?B:void 0,await this.getTargetPlatform(),W)),C.includeInvalid||(B=B.filter(F=>F.isValid)),B.sort((F,H)=>{const ne=u.$qc(F.location.fsPath),V=u.$qc(H.location.fsPath);return ne<V?-1:ne>V?1:0})}L(B,_,C,W,F){const H=(V,ce,oe)=>{if(V.isValid&&!ce.isValid)return!1;if(V.isValid===ce.isValid){if(F&&f.gt(V.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(f.eq(V.manifest.version,ce.manifest.version)){if(V.type===s.ExtensionType.System)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===W)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return oe?this.y.warn(`Overwriting user extension ${V.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${V.location.path} with ${ce.location.path}.`),!0},ne=new s.$wn;return B?.forEach(V=>{const ce=ne.get(V.identifier.id);(!ce||H(ce,V,!1))&&ne.set(V.identifier.id,V)}),_?.forEach(V=>{const ce=ne.get(V.identifier.id);if(!ce&&B&&V.type===s.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!ce||H(ce,V,!1))&&ne.set(V.identifier.id,V)}),C?.forEach(V=>{const ce=ne.get(V.identifier.id);(!ce||H(ce,V,!0))&&ne.set(V.identifier.id,V),ne.set(V.identifier.id,V)}),[...ne.values()]}async M(B,_){this.y.trace("Started scanning system extensions");const C=await this.P(this.systemExtensionsLocation,!1,s.ExtensionType.System,!0,_,!0,void 0,this.R()),F=await(B&&!C.devMode?this.j:this.n).scanExtensions(C);return this.y.trace("Scanned system extensions:",F.length),F}async N(B,_){const C=this.z.isBuilt?[]:this.C.builtInExtensions;if(!C?.length)return[];this.y.trace("Started scanning dev system extensions");const W=_?await this.O():{},F=[],H=y.URI.file(u.$kc(u.$mc(g.$3g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of C){const ce=W[V.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":F.push((0,p.$jh)(H,V.name));break;default:F.push(y.URI.file(ce));break}}const ne=await Promise.all(F.map(async V=>this.n.scanExtension(await this.P(V,!1,s.ExtensionType.System,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,i.$Jb)(ne)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,_,C,W,F,H,ne,V){const ce=await this.f(F??m.$x),oe=await this.Q(B),Y=_&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=Y?await this.Q(Y):void 0;return new G(B,oe,Y,M,_,ne,C,W,H,V.version,V.date,this.C.commit,!this.z.isBuilt,F,ce)}async Q(B){try{const _=await this.w.stat(B);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Tq=j,e.$Tq=j=ke([re(4,R.$Pl),re(5,w.$Oq),re(6,t.$dl),re(7,n.$dk),re(8,S.$Pi),re(9,c.$wk),re(10,L.$Nl),re(11,o.$Hi)],j);class G{constructor(B,_,C,W,F,H,ne,V,ce,oe,Y,M,Z,U,N){this.location=B,this.mtime=_,this.applicationExtensionslocation=C,this.applicationExtensionslocationMtime=W,this.profile=F,this.profileScanOptions=H,this.type=ne,this.excludeObsolete=V,this.validate=ce,this.productVersion=oe,this.productDate=Y,this.productCommit=M,this.devMode=Z,this.language=U,this.translations=N}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,_){return(0,p.$ch)(B.location,_.location)&&B.mtime===_.mtime&&(0,p.$ch)(B.applicationExtensionslocation,_.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&B.profile===_.profile&&E.$lo(B.profileScanOptions,_.profileScanOptions)&&B.type===_.type&&B.excludeObsolete===_.excludeObsolete&&B.validate===_.validate&&B.productVersion===_.productVersion&&B.productDate===_.productDate&&B.productCommit===_.productCommit&&B.devMode===_.devMode&&B.language===_.language&&T.equals(B.translations,_.translations)}}e.$Uq=G;let q=class extends l.$Xc{constructor(B,_,C,W,F,H,ne){super(),this.g=B,this.h=_,this.j=C,this.m=W,this.n=H,this.r=ne,this.f=F.extensionsEnabledWithApiProposalVersion?.map(V=>V.toLowerCase())??[]}async scanExtensions(B){const _=B.profile?await this.t(B):await this.s(B);let C={};if(B.excludeObsolete&&B.type===s.ExtensionType.User)try{const W=(await this.m.readFile(this.g)).value.toString();C=JSON.parse(W)}catch{}return(0,v.$ug)(C)?_:_.filter(W=>!C[k.$Qp.create(W).toString()])}async s(B){const _=await this.m.resolve(B.location);if(!_.children?.length)return[];const C=await Promise.all(_.children.map(async W=>{if(!W.isDirectory||B.type===s.ExtensionType.User&&(0,p.$gh)(W.resource).indexOf(".")===0)return null;const F=new G(W.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(F)}));return(0,i.$Jb)(C).sort((W,F)=>W.location.path<F.location.path?-1:1)}async t(B){let _=await this.u(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.j.extUri.isEqual(B.location,B.applicationExtensionslocation)){_=_.filter(W=>!W.metadata?.isApplicationScoped);const C=await this.u(B.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,B);_.push(...C)}return _}async u(B,_,C){const W=await this.h.scanProfileExtensions(B,C.profileScanOptions);if(!W.length)return[];const F=await Promise.all(W.map(async H=>{if(_(H)){const ne=new G(H.location,C.mtime,C.applicationExtensionslocation,C.applicationExtensionslocationMtime,C.profile,C.profileScanOptions,C.type,C.excludeObsolete,C.validate,C.productVersion,C.productDate,C.productCommit,C.devMode,C.language,C.translations);return this.scanExtension(ne,H.metadata)}return null}));return(0,i.$Jb)(F)}async scanOneOrMultipleExtensions(B){try{if(await this.m.exists((0,p.$jh)(B.location,"package.json"))){const _=await this.scanExtension(B);return _?[_]:[]}else return await this.scanExtensions(B)}catch(_){return this.r.error(`Error scanning extensions at ${B.location.path}:`,(0,O.$_)(_)),[]}}async scanExtension(B,_){try{let C=await this.w(B.location);if(C){C.publisher||(C.publisher=s.$qn),_=_??C.__metadata,delete C.__metadata;const W=(0,k.$Up)(C.publisher,C.name),F=_?.id?{id:W,uuid:_.id}:{id:W},H=_?.isSystem?s.ExtensionType.System:B.type,ne=H===s.ExtensionType.System||!!_?.isBuiltin;C=await this.y(B.location,C,G.createNlsConfiguration(B));let V={type:H,identifier:F,manifest:C,location:B.location,isBuiltin:ne,targetPlatform:_?.targetPlatform??s.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return B.validate&&(V=this.validate(V,B)),C.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(W.toLowerCase()))&&(C.originalEnabledApiProposals=C.enabledApiProposals,C.enabledApiProposals=(0,s.$Cn)([...C.enabledApiProposals])),V}}catch(C){B.type!==s.ExtensionType.System&&this.r.error(C)}return null}validate(B,_){let C=!0;const W=this.n.isBuilt&&this.f.includes(B.identifier.id.toLowerCase()),F=(0,a.$7p)(_.productVersion,_.productDate,_.location,B.manifest,B.isBuiltin,W);for(const[H,ne]of F)H===d.default.Error&&(C=!1,this.r.error(this.F(_.location,ne)));return B.isValid=C,B.validations=F,B}async w(B){const _=(0,p.$jh)(B,"package.json");let C;try{C=(await this.m.readFile(_)).value.toString()}catch(F){return(0,t.$ul)(F)!==t.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(B,(0,$.localize)(1813,null,_.path,F.message))),null}let W;try{W=JSON.parse(C)}catch{const H=[];(0,I.$2n)(C,H);for(const ne of H)this.r.error(this.F(B,(0,$.localize)(1814,null,_.path,ne.offset,ne.length,(0,b.$Qq)(ne.error))));return null}return(0,I.$0n)(W)!=="object"?(this.r.error(this.F(B,(0,$.localize)(1815,null,_.path))),null):W}async y(B,_,C){const W=await this.z(B,_,C);if(W)try{const F=[],H=await this.C(W.default,F);if(F.length>0)return F.forEach(V=>{this.r.error(this.F(B,(0,$.localize)(1816,null,W.default?.path,(0,b.$Qq)(V.error))))}),_;if((0,I.$0n)(W)!=="object")return this.r.error(this.F(B,(0,$.localize)(1817,null,W.default?.path))),_;const ne=W.values||Object.create(null);return(0,A.$Rq)(this.r,_,ne,H)}catch{}return _}async z(B,_,C){const W=(0,p.$jh)(B,"package.nls.json"),F=(ce,oe)=>{oe.forEach(Y=>{this.r.error(this.F(B,(0,$.localize)(1818,null,ce?.path,(0,b.$Qq)(Y.error))))})},H=ce=>{this.r.error(this.F(B,(0,$.localize)(1819,null,ce?.path)))},ne=`${_.publisher}.${_.name}`,V=C.translations[ne];if(V)try{const ce=y.URI.file(V),oe=(await this.m.readFile(ce)).value.toString(),Y=[],M=(0,I.$2n)(oe,Y);return Y.length>0?(F(ce,Y),{values:void 0,default:W}):(0,I.$0n)(M)!=="object"?(H(ce),{values:void 0,default:W}):{values:M.contents?M.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.m.exists(W))return;let oe;try{oe=await this.D(B,C)}catch{return}if(!oe.localized)return{values:void 0,default:oe.original};try{const Y=(await this.m.readFile(oe.localized)).value.toString(),M=[],Z=(0,I.$2n)(Y,M);return M.length>0?(F(oe.localized,M),{values:void 0,default:oe.original}):(0,I.$0n)(Z)!=="object"?(H(oe.localized),{values:void 0,default:oe.original}):{values:Z,default:oe.original}}catch{return{values:void 0,default:oe.original}}}}async C(B,_){if(B)try{const C=(await this.m.readFile(B)).value.toString();return(0,I.$2n)(C,_)}catch{}}D(B,_){return new Promise((C,W)=>{const F=H=>{const ne=(0,p.$jh)(B,`package.nls.${H}.json`);this.m.exists(ne).then(V=>{V&&C({localized:ne,original:(0,p.$jh)(B,"package.nls.json")});const ce=H.lastIndexOf("-");ce===-1?C({localized:(0,p.$jh)(B,"package.nls.json"),original:null}):(H=H.substring(0,ce),F(H))})};if(_.devMode||_.pseudo||!_.language)return C({localized:(0,p.$jh)(B,"package.nls.json"),original:null});F(_.language)})}F(B,_){return`[${B.path}]: ${_}`}};q=ke([re(1,w.$Oq),re(2,L.$Nl),re(3,t.$dl),re(4,c.$wk),re(5,S.$Pi),re(6,n.$dk)],q);let Q=class extends q{constructor(B,_,C,W,F,H,ne,V,ce){super(_,W,F,H,ne,V,ce),this.J=B,this.L=C,this.H=this.B(new r.$Gh(3e3)),this.I=this.B(new h.$oe),this.onDidChangeCache=this.I.event}async scanExtensions(B){const _=this.P(B),C=await this.M(_);if(this.G=B,C&&C.input&&G.equals(C.input,this.G))return this.r.debug("Using cached extensions scan result",B.type===s.ExtensionType.System?"system":"user",B.location.toString()),this.H.trigger(()=>this.O()),C.result.map(F=>(F.location=y.URI.revive(F.location),F));const W=await super.scanExtensions(B);return await this.N(_,{input:B,result:W}),W}async M(B){try{const _=await this.m.readFile(B),C=JSON.parse(_.value.toString());return{result:C.result,input:(0,P.$fi)(C.input)}}catch(_){this.r.debug("Error while reading the extension cache file:",B.path,(0,O.$_)(_))}return null}async N(B,_){try{await this.m.writeFile(B,D.$Qe.fromString(JSON.stringify(_)))}catch(C){this.r.debug("Error while writing the extension cache file:",B.path,(0,O.$_)(C))}}async O(){if(!this.G)return;const B=this.P(this.G),_=await this.M(B);if(!_)return;const C=_.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!E.$lo(W,C))try{this.r.info("Invalidating Cache",C,W),await this.m.del(B),this.I.fire()}catch(F){this.r.error(F)}}P(B){const _=this.Q(B);return this.j.extUri.joinPath(_.cacheHome,B.type===s.ExtensionType.System?s.$pn:s.$on)}Q(B){return B.type===s.ExtensionType.System?this.L.defaultProfile:B.profile?this.j.extUri.isEqual(B.location,this.J.extensionsResource)?this.J:this.L.profiles.find(_=>this.j.extUri.isEqual(B.location,_.extensionsResource))??this.J:this.L.defaultProfile}};Q=ke([re(2,R.$Pl),re(3,w.$Oq),re(4,L.$Nl),re(5,t.$dl),re(6,c.$wk),re(7,S.$Pi),re(8,n.$dk)],Q);function de(J,B){const _=(0,k.$Sp)(J.manifest.publisher,J.manifest.name);return{id:_,identifier:new s.$un(_),isBuiltin:J.type===s.ExtensionType.System,isUserBuiltin:J.type===s.ExtensionType.User&&J.isBuiltin,isUnderDevelopment:B,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,publisherDisplayName:J.publisherDisplayName,...J.manifest}}class x extends j{constructor(B,_,C,W,F,H,ne,V,ce,oe,Y,M){super(B,_,(0,p.$jh)(C,".vscode-oss-dev","extensions","control.json"),W,F,H,ne,V,ce,oe,Y,M),this.S=(async()=>{if(m.$A)try{const Z=await this.w.readFile(y.URI.file(m.$A));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$Wq=x}),define(le[247],ue([0,1,5,42,41,24,88,14,36,7]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=void 0;let g=class extends O.$Pq{constructor(m,p,f,d,v,y){super(l.URI.file(m.extensionsPath),p,f,d,v,y)}};e.$3R=g,e.$3R=g=ke([re(0,b.$Qi),re(1,I.$dl),re(2,r.$Pl),re(3,E.$Nl),re(4,D.$cm),re(5,i.$dk)],g)}),define(le[248],ue([0,1,7,36,88,135,14,6,5,28,41,42]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;let m=class extends D.$Wq{constructor(f,d,v,y,$,S,k,s){super(i.URI.file($.builtinExtensionsPath),i.URI.file($.extensionsPath),$.userHome,f.defaultProfile,f,d,v,y,$,S,k,s)}};e.$oic=m,e.$oic=m=ke([re(0,u.$Pl),re(1,E.$Oq),re(2,O.$dl),re(3,b.$dk),re(4,r.$Qi),re(5,l.$wk),re(6,g.$Nl),re(7,I.$Hi)],m)}),define(le[249],ue([0,1,13,2,11,9,3,61,7,33,35,36,5,42]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;let f=class extends r.$Xc{constructor(v,y,$){super(),this.c=v,this.f=$,this.a=I.$Oi.forPaths(!O.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(y.defaultProfile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:v}=i.session;v.protocol.registerFileProtocol(E.Schemas.vscodeFileResource,(y,$)=>this.j(y,$)),v.protocol.interceptFileProtocol(E.Schemas.file,(y,$)=>this.h(y,$)),this.B((0,r.$Vc)(()=>{v.protocol.unregisterProtocol(E.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(E.Schemas.file)}))}addValidFileRoot(v){const y=(0,D.$kc)(v);return this.a.get(y)?r.$Xc.None:(this.a.set(y,!0),(0,r.$Vc)(()=>this.a.delete(y)))}h(v,y){const $=b.URI.parse(v.url);return this.f.error(`Refused to load resource ${$.fsPath} from ${E.Schemas.file}: protocol (original URL: ${v.url})`),y({error:-3})}j(v,y){const $=this.m(v);let S;if(this.c.crossOriginIsolated){const k=(0,D.$qc)($);k==="workbench.html"||k==="workbench-dev.html"||k==="workbench.esm.html"||k==="workbench-dev.esm.html"?S=E.COI.CoopAndCoep:S=E.COI.getHeadersFromQuery(v.url)}return this.a.findSubstr($)?y({path:$,headers:S}):this.b.has((0,D.$rc)($).toLowerCase())?y({path:$}):(this.f.error(`${E.Schemas.vscodeFileResource}: Refused to load resource ${$} from ${E.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),y({error:-3}))}m(v){const y=b.URI.parse(v.url),$=E.$3g.uriToFileUri(y);return(0,D.$kc)($.fsPath)}createIPCObjectUrl(){let v;const y=b.URI.from({scheme:"vscode",path:(0,l.$5g)()}),$=y.toString(),S=async()=>v;return g.$fY.handle($,S),this.f.trace(`IPC Object URL: Registered new channel ${$}.`),{resource:y,update:k=>v=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${$}.`),g.$fY.removeHandler($)}}}};e.$Iic=f,e.$Iic=f=ke([re(0,u.$Qi),re(1,p.$Pl),re(2,m.$dk)],f)}),define(le[64],ue([0,1,8,4,2,72,12,122,6,42]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$nq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$lq=e.$kq=e.$jq=void 0,e.$mq=p,e.$oq=d,e.$qq=y,e.$jq="__$__isNewStorageMarker",e.$kq="__$__targetStorageMarker",e.$lq=(0,b.$Ii)("storageService");var g;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var u;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var m;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function p($){const S=$.get(e.$kq);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}class f extends E.$Xc{static{this.a=60*1e3}constructor(S={flushInterval:f.a}){super(),this.m=S,this.b=this.B(new r.$re),this.c=this.B(new r.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new i.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(S,k,s){return r.Event.filter(this.b.event,a=>a.scope===S&&(k===void 0||a.key===k),s)}n(){this.j.value=(0,i.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(S,k){const{key:s,external:a}=k;if(s===e.$kq){switch(S){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:S})}else this.b.fire({scope:S,key:s,target:this.J(S)[s],external:a})}w(S){this.f.fire({reason:S})}get(S,k,s){return this.P(k)?.get(S,s)}getBoolean(S,k,s){return this.P(k)?.getBoolean(S,s)}getNumber(S,k,s){return this.P(k)?.getNumber(S,s)}getObject(S,k,s){return this.P(k)?.getObject(S,s)}storeAll(S,k){this.y(()=>{for(const s of S)this.store(s.key,s.value,s.scope,s.target,k)})}store(S,k,s,a,t=!1){if((0,O.$qg)(k)){this.remove(S,s,t);return}this.y(()=>{this.z(S,s,a),this.P(s)?.set(S,k,t)})}remove(S,k,s=!1){this.y(()=>{this.z(S,k,void 0),this.P(k)?.delete(S,s)})}y(S){this.b.pause(),this.c.pause();try{S()}finally{this.b.resume(),this.c.resume()}}keys(S,k){const s=[],a=this.J(S);for(const t of Object.keys(a))a[t]===k&&s.push(t);return s}z(S,k,s,a=!1){const t=this.J(k);typeof s=="number"?t[S]!==s&&(t[S]=s,this.P(k)?.set(e.$kq,JSON.stringify(t),a)):typeof t[S]=="number"&&(delete t[S],this.P(k)?.set(e.$kq,JSON.stringify(t),a))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(S){switch(S){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(S){const k=this.P(S);return k?p(k):Object.create(null)}isNew(S){return this.getBoolean(e.$jq,S)===!0}async flush(S=g.NONE){this.f.fire({reason:S});const k=this.P(u.APPLICATION),s=this.P(u.PROFILE),a=this.P(u.WORKSPACE);switch(S){case g.NONE:await i.Promises.settled([k?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await i.Promises.settled([k?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.P(u.APPLICATION)?.items??new Map,k=this.P(u.PROFILE)?.items??new Map,s=this.P(u.WORKSPACE)?.items??new Map;return y(S,k,s,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(S){return await this.flush(),this.P(S)?.optimize()}async switch(S,k){return this.w(g.NONE),(0,l.$Ol)(S)?this.R(S,k):this.S(S,k)}M(S,k){return!(S.id===k.id||d(k)&&d(S))}N(S,k,s){this.y(()=>{const a=new Set;for(const[t,o]of S)a.add(t),k.get(t)!==o&&this.u(s,{key:t,external:!0});for(const[t]of k.items)a.has(t)||this.u(s,{key:t,external:!0})})}}e.$nq=f;function d($){return $.isDefault||!!$.useDefaultFlags?.globalState}class v extends f{constructor(){super(),this.U=this.B(new I.$hq(new I.$iq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$hq(new I.$iq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$hq(new I.$iq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(S=>this.u(u.WORKSPACE,S))),this.B(this.W.onDidChangeStorage(S=>this.u(u.PROFILE,S))),this.B(this.U.onDidChangeStorage(S=>this.u(u.APPLICATION,S)))}P(S){switch(S){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(S){switch(S){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(S){return!1}}e.$pq=v;async function y($,S,k,s,a,t){const o=T=>{try{return JSON.parse(T)}catch{return T}},n=new Map,c=new Map;$.forEach((T,j)=>{n.set(j,T),c.set(j,o(T))});const h=new Map,P=new Map;S.forEach((T,j)=>{h.set(j,T),P.set(j,o(T))});const w=new Map,R=new Map;k.forEach((T,j)=>{w.set(j,T),R.set(j,o(T))}),console.group(s!==a?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const L=[];if(n.forEach((T,j)=>{L.push({key:j,value:T})}),console.table(L),console.groupEnd(),console.log(c),s!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const T=[];h.forEach((j,G)=>{T.push({key:G,value:j})}),console.table(T),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${t})`);const A=[];w.forEach((T,j)=>{A.push({key:j,value:T})}),console.table(A),console.groupEnd(),console.log(R)}}),define(le[250],ue([0,1,17,33,64]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=D;async function D(O,I,b){let l=b&&b.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(l)return l;try{const u=(await I.readFile(O.serviceMachineIdResource)).value.toString();l=(0,r.$4g)(u)?u:null}catch{l=null}if(!l){l=(0,r.$5g)();try{await I.writeFile(O.serviceMachineIdResource,i.$Qe.fromString(l))}catch{}}return b?.store("storage.serviceMachineId",l,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),l}}),define(le[251],ue([0,1,250,24,57]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=D;async function D(O,I,b,l,g,u,m){const p={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${I.nameShort})`};if((0,E.$Hp)(I,b)&&(0,E.$Jp)(l)===r.TelemetryLevel.USAGE){const f=await(0,i.$rq)(b,g,u);p["X-Market-User-Id"]=f,p["VSCode-SessionId"]=m.machineId||f}return p}}),define(le[252],ue([0,1,26,21,8,4,2,9,60,7,23,122,164,5,64,24,30,11]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=e.$bhc=e.$ahc=void 0,i=Ie(i);class $ extends O.$Xc{static{this.a=2e3}get storage(){return this.f}constructor(n,c){super(),this.m=n,this.n=c,this.b=this.B(new D.$oe),this.onDidChangeStorage=this.b.event,this.c=this.B(new D.$oe),this.onDidCloseStorage=this.c.event,this.f=this.B(new u.$hq(new u.$iq,{hint:u.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new E.$6h,this.whenInit=this.h.p,this.j=u.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===u.StorageState.None)try{const n=this.B(await this.t());this.f.dispose(),this.f=n,this.B(n.onDidChangeStorage(h=>this.b.fire(h))),await this.s(n);const c=n.getBoolean(f.$jq);c===void 0?n.set(f.$jq,!0):c&&n.set(f.$jq,!1)}catch(n){this.m.error(`[storage main] initialize(): Unable to init storage due to ${n}`)}finally{this.j=u.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?n=>this.m.trace(n):void 0,logError:n=>this.m.error(n)}}s(n){return n.init()}get items(){return this.f.items}get(n,c){return this.f.get(n,c)}set(n,c){return this.f.set(n,c)}delete(n){return this.f.delete(n)}optimize(){return this.f.optimize()}async close(){const n=new b.$ie(!1);await this.w(),n.stop(),n.elapsed()>$.a&&await this.u(n),this.c.fire()}async u(n){if(this.path)try{const c=(0,r.top)(Array.from(this.f.items.entries()).map(([P,w])=>({key:P,length:w.length})),(P,w)=>w.length-P.length,5).map(P=>`${P.key}:${P.length}`).join(", "),h=(await this.n.stat(l.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${n.elapsed()}ms, DB size: ${h}b, Large Keys: ${c}`)}catch(c){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",c)}}async w(){this.g&&await this.g,this.j=u.StorageState.Closed,await this.f.close()}}class S extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$mc)(this.z.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,S.y)}constructor(n,c,h,P){super(h,P),this.z=n,this.C=c}async t(){return new u.$hq(new m.$KY(this.path??m.$KY.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:u.StorageHint.STORAGE_IN_MEMORY})}}class k extends S{constructor(n,c,h,P){super(n,c,h,P)}}e.$ahc=k;class s extends S{constructor(n,c,h,P){super(c.defaultProfile,n,h,P)}async s(n){await super.s(n),this.G(n)}G(n){n.get(d.$fm,void 0)===void 0&&n.set(d.$fm,new Date().toUTCString());const h=n.get(d.$em,void 0),P=new Date().toUTCString();n.set(d.$gm,typeof h>"u"?null:h),n.set(d.$em,P)}}e.$bhc=s;class a extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$mc)(this.F.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,this.C.id,a.y)}constructor(n,c,h,P,w){super(h,w),this.C=n,this.D=c,this.F=P}async t(){const{storageFilePath:n,wasCreated:c}=await this.H();return new u.$hq(new m.$KY(n,{logging:this.r()}),{hint:this.D.useInMemoryStorage?u.StorageHint.STORAGE_IN_MEMORY:c?u.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:m.$KY.IN_MEMORY_PATH,wasCreated:!0};const n=(0,I.$mc)(this.F.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,this.C.id),c=(0,I.$mc)(n,a.y);return await g.Promises.exists(n)?{storageFilePath:c,wasCreated:!1}:(await i.promises.mkdir(n,{recursive:!0}),this.I(n),{storageFilePath:c,wasCreated:!0})}async I(n){let c;if((0,v.$Si)(this.C)?c={folder:this.C.uri.toString()}:(0,v.$Xi)(this.C)&&(c={workspace:this.C.configPath.toString()}),c)try{const h=(0,I.$mc)(n,a.z);await g.Promises.exists(h)||await g.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.$chc=a;class t extends ${get path(){}async t(){return new u.$hq(new u.$iq,{hint:u.StorageHint.STORAGE_IN_MEMORY})}}e.$dhc=t}),define(le[253],ue([0,1,4,2,64]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;class D extends r.$Xc{constructor(I,b,l){super(),this.b=I,this.c=b,this.f=l;const g=this.B(new r.$Yc);this.a=this.B(new i.$oe({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Wc;return I.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(b,l)=>(b?b.push(l.key):b=[l.key],b),100)(b=>this.h(b))),I.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(b,l)=>{b||(b=new Map);let g=b.get(l.profile.id);return g||b.set(l.profile.id,g={profile:l.profile,keys:[],storage:l.storage}),g.keys.push(l.key),b},100)(b=>this.j(b))),I}h(I){const b=I.includes(E.$kq)?[this.c.defaultProfile]:[],l=[];if(I=I.filter(g=>g!==E.$kq),I.length){const g=(0,E.$mq)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:I.map(u=>({key:u,scope:E.StorageScope.PROFILE,target:g[u]}))})}this.m(b,l)}j(I){const b=[],l=new Map;for(const[g,u]of I.entries()){u.keys.includes(E.$kq)&&b.push(u.profile);const m=u.keys.filter(p=>p!==E.$kq);if(m.length){const p=(0,E.$mq)(u.storage.storage);l.set(g,{profile:u.profile,changes:m.map(f=>({key:f,scope:E.StorageScope.PROFILE,target:p[f]}))})}}this.m(b,[...l.values()])}m(I,b){(I.length||b.length)&&this.a.fire({valueChanges:b,targetChanges:I})}listen(I,b,l){switch(b){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${b}`)}async call(I,b){throw new Error(`Call not found: ${b}`)}}e.$qic=D}),define(le[254],ue([0,1,7,36,14,5,34,41,42,12,129]),function(K,e,i,r,E,D,O,I,b,l,g){"use strict";var u,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=e.$1R=e.$ZR=void 0;let p=class extends b.$Sl{static{u=this}static{this.a="profileAssociationsMigration"}constructor(y,$,S,k,s){super(S,k,$,s),this.U=y,this.W=S}O(){return this.U.getItem(u.b,[]).map($=>({...$,location:(0,l.$hg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):i.URI.revive($.location)}))}Q(){const y=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?y:this.N(y)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$ZR=p,e.$ZR=p=u=ke([re(0,O.$UR),re(1,I.$Nl),re(2,r.$Qi),re(3,E.$dl),re(4,D.$dk)],p);let f=m=class extends p{constructor(y,$,S,k,s){super(y,$,S,k,s),this.$=y}P(y){y.length?this.$.setItem(m.b,y.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(m.b)}O(){const y=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(y),this.$.setItem("userDataProfilesMigration",!0)),y}R(y){y.emptyWindows||y.workspaces?this.$.setItem(m.c,y):this.$.removeItem(m.c)}Q(){const y="workspaceAndProfileInfo",$=this.$.getItem(y,void 0);if($){this.$.removeItem(y);const k=$.reduce((s,{workspace:a,profile:t})=>(s[i.URI.revive(a).toString()]=i.URI.revive(t).toString(),s),{});this.$.setItem(m.c,{workspaces:k})}const S=super.Q();return this.$.getItem(m.a,!1)||(this.R(S),this.$.setItem(m.a,!0)),S}};e.$1R=f,e.$1R=f=m=ke([re(0,O.$VR),re(1,I.$Nl),re(2,r.$Qi),re(3,E.$dl),re(4,D.$dk)],f);let d=class extends f{constructor(y,$,S,k){super(new g.$YR(g.SaveStrategy.IMMEDIATE,$,k,S),y,$,S,k)}async init(){return await this.$.init(),super.init()}};e.$2R=d,e.$2R=d=ke([re(0,I.$Nl),re(1,r.$Qi),re(2,E.$dl),re(3,D.$dk)],d)}),define(le[58],ue([0,1,36,14,6,5,41,42,254,34]),function(K,e,i,r,E,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=void 0,e.$Ugc=(0,E.$Ji)(I.$Pl);let g=class extends b.$1R{constructor(m,p,f,d,v){super(m,p,f,d,v)}getAssociatedEmptyWindows(){const m=[];for(const p of this.C.emptyWindows.keys())m.push({id:p});return m}};e.$Vgc=g,e.$Vgc=g=ke([re(0,l.$VR),re(1,O.$Nl),re(2,i.$Qi),re(3,r.$dl),re(4,D.$dk)],g)}),define(le[136],ue([0,1,18,7,30]),function(K,e,i,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=D,e.$Xgc=O,e.$Ygc=I;async function D(b,l,g){for(const m of b){const p=m.openedWorkspace;if((0,E.$Xi)(p)){const f=await g(p);if(f){if(f.folders.some(d=>i.$ah.isEqualOrParent(l,d.uri)))return m}else if(i.$ah.isEqualOrParent(l,p.configPath))return m}}const u=b.filter(m=>(0,E.$Si)(m.openedWorkspace)&&i.$ah.isEqualOrParent(l,m.openedWorkspace.uri));if(u.length)return u.sort((m,p)=>-(m.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}function O(b,l){for(const g of b)if((0,E.$Xi)(g.openedWorkspace)&&i.$ah.isEqual(g.openedWorkspace.configPath,l)||(0,E.$Si)(g.openedWorkspace)&&i.$ah.isEqual(g.openedWorkspace.uri,l))return g}function I(b,l){const g=u=>l.some(m=>i.$ah.isEqual(r.URI.file(m),r.URI.file(u)));for(const u of b)if(u.config?.extensionDevelopmentPath?.some(m=>g(m)))return u}}),define(le[105],ue([0,1,32,43,110,48,11,9,3,18,7,6,75,30]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dib=void 0,e.$Eib=f,e.$Fib=d,e.$Gib=v,e.$Hib=y,e.$Iib=k,e.$Jib=a,e.$Kib=t,e.$Lib=P,e.$Mib=w,r=Ie(r),E=Ie(E),e.$Dib=(0,u.$Ii)("workspacesService");function f(R){return R.hasOwnProperty("workspace")}function d(R){return R.hasOwnProperty("folderUri")}function v(R){return R.hasOwnProperty("fileUri")}function y(R){return $(R)||S(R)}function $(R){const L=R;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function S(R){const L=R;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function k(R,L,A,T,j){if(R.scheme!==T.scheme)return{name:A,uri:R.toString(!0)};let G=L?void 0:j.relativePath(T,R);if(G!==void 0)G.length===0?G=".":b.$j&&(G=s(G));else if(R.scheme===O.Schemas.file)G=R.fsPath,b.$j&&(G=s(G));else if(j.isEqualAuthority(R.authority,T.authority))G=R.path;else return{name:A,uri:R.toString(!0)};return{name:A,path:G}}function s(R){return R=(0,D.$7w)(R),(0,i.$Eg)(R)||(R=(0,i.$Bg)(R)),R}function a(R,L,A){const T=[],j=new Set,G=A.dirname(L);for(const q of R){let Q;if($(q))q.path&&(Q=A.resolvePath(G,q.path));else if(S(q))try{Q=g.URI.parse(q.uri),Q.path[0]!==I.$jc.sep&&(Q=Q.with({path:I.$jc.sep+Q.path}))}catch(de){console.warn(de)}if(Q){const de=A.getComparisonKey(Q);if(!j.has(de)){j.add(de);const x=q.name||A.basenameOrAuthority(Q);T.push(new p.$3i({uri:Q,name:x,index:T.length},q))}}}return T}function t(R,L,A,T,j){const G=o(L,R),q=j.dirname(L),Q=j.dirname(T),de=[];for(const _ of G.folders){const C=$(_)?j.resolvePath(q,_.path):g.URI.parse(_.uri);let W;A?W=!1:W=!$(_)||(0,I.$lc)(_.path),de.push(k(C,W,_.name,Q,j))}const x={insertSpaces:!1,tabSize:4,eol:b.$l||b.$k?`
`:`\r
`},J=E.$do(R,["folders"],de,x);let B=E.$go(R,J);return(0,l.$oh)(G.remoteAuthority,(0,m.$kn)(T))&&(B=E.$go(B,E.$co(B,["remoteAuthority"],x))),B}function o(R,L){const A=r.$2n(L);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(T=>y(T));else throw new Error(`${R} looks like an invalid workspace file.`);return A}function n(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function c(R){return typeof R.folderUri=="string"}function h(R){return typeof R.fileUri=="string"}function P(R,L){const A={workspaces:[],files:[]};if(R){const T=function(G,q){for(let Q=0;Q<G.length;Q++)try{q(G[Q],Q)}catch(de){L.warn(`Error restoring recent entry ${JSON.stringify(G[Q])}: ${de.toString()}. Skip entry.`)}},j=R;Array.isArray(j.entries)&&T(j.entries,G=>{const q=G.label,Q=G.remoteAuthority;n(G)?A.workspaces.push({label:q,remoteAuthority:Q,workspace:{id:G.workspace.id,configPath:g.URI.parse(G.workspace.configPath)}}):c(G)?A.workspaces.push({label:q,remoteAuthority:Q,folderUri:g.URI.parse(G.folderUri)}):h(G)&&A.files.push({label:q,remoteAuthority:Q,fileUri:g.URI.parse(G.fileUri)})})}return A}function w(R){const L={entries:[]};for(const A of R.workspaces)d(A)?L.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):L.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of R.files)L.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return L}}),define(le[106],ue([0,1,93,11,3,18]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0,e.$1gc=O,e.$2gc=I,e.$3gc=b,e.$Zgc=128/4;function O(l){function g(){let u=l.scheme===r.Schemas.file?(0,D.$0g)(l):l.toString();return E.$l||(u=u.toLowerCase()),(0,i.createHash)("md5").update(u).digest("hex")}return{id:g(),configPath:l}}function I(l,g){function u(){if(l.scheme!==r.Schemas.file)return(0,i.createHash)("md5").update(l.toString()).digest("hex");if(!g)return;let p;return E.$l?p=g.ino:E.$k?p=g.birthtime.getTime():E.$j&&(typeof g.birthtimeMs=="number"?p=Math.floor(g.birthtimeMs):p=g.birthtime.getTime()),(0,i.createHash)("md5").update(l.fsPath).update(p?String(p):"").digest("hex")}const m=u();if(typeof m=="string")return{id:m,uri:l}}function b(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[107],ue([0,1,93,95,27,255,17,15,4,2,9,3,33,45,120]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$zi=e.$yi=e.$xi=void 0,e.$Ai=n,e.$Bi=c,e.$Di=w,e.$Ei=R;const d=3e4;class v{traceSocketEvent(A,T){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,T)}constructor(A,T=""){this.f=!0,this.debugLabel=T,this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=G=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:G?.code,message:G?.message}),G){if(G.code==="EPIPE")return;(0,I.$2)(G)}},this.socket.on("error",this.a);let j;this.b=G=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:G}),this.f=!1,j&&clearTimeout(j)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,j=setTimeout(()=>A.destroy(),d)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(A){const T=j=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,j),A(O.$Qe.wrap(j))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(A){const T=j=>{A({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:j,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(A){const T=()=>{A()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(A){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,A),this.socket.write(A.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,I.$2)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,I.$2)(T)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((A,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$xi=v;var y;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(y||(y={}));var $;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})($||($={}));class S extends l.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(A,T){this.socket.traceSocketEvent(A,T)}constructor(A,T,j,G){super(),this.f=this.B(new b.$oe),this.g=this.B(new b.$oe),this.h=!1,this.j={state:$.PeekHeader,readLen:y.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:j?.byteLength||0,recordInflateBytes:G}),this.a=this.B(new k(this,T,j,G,this.f,(q,Q)=>this.m(q,Q))),this.B(this.a.onError(q=>{console.error(q),(0,I.$2)(q),this.g.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:q})})),this.b=new f.$si,this.B(this.socket.onData(q=>this.n(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this.f.event(A)}onClose(A){return this.g.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let T=0;for(;T<A.byteLength;)this.a.writeMessage(A.slice(T,Math.min(T+y.MaxWebSocketMessageLength,A.byteLength)),{compressed:!0,opcode:2}),T+=y.MaxWebSocketMessageLength}m(A,{compressed:T,opcode:j}){if(this.h)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,A);let G=y.MinHeaderByteSize;A.byteLength<126?G+=0:A.byteLength<2**16?G+=2:G+=8;const q=O.$Qe.alloc(G),Q=T?64:0,de=j&15;if(q.writeUInt8(128|Q|de,0),A.byteLength<126)q.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){q.writeUInt8(126,1);let x=1;q.writeUInt8(A.byteLength>>>8&255,++x),q.writeUInt8(A.byteLength>>>0&255,++x)}else{q.writeUInt8(127,1);let x=1;q.writeUInt8(0,++x),q.writeUInt8(0,++x),q.writeUInt8(0,++x),q.writeUInt8(0,++x),q.writeUInt8(A.byteLength>>>24&255,++x),q.writeUInt8(A.byteLength>>>16&255,++x),q.writeUInt8(A.byteLength>>>8&255,++x),q.writeUInt8(A.byteLength>>>0&255,++x)}this.socket.write(O.$Qe.concat([q,A]))}end(){this.h=!0,this.socket.end()}n(A){if(A.byteLength!==0){for(this.b.acceptChunk(A);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const T=this.b.peek(this.j.readLen),j=T.readUInt8(0),G=(j&128)>>>7,q=(j&64)>>>6,Q=j&15,de=T.readUInt8(1),x=(de&128)>>>7,J=de&127;this.j.state=$.ReadHeader,this.j.readLen=y.MinHeaderByteSize+(x?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=G,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!G,this.j.mask=0,this.j.opcode=Q,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const T=this.b.read(this.j.readLen),j=T.readUInt8(1),G=(j&128)>>>7;let q=j&127,Q=1;q===126?q=T.readUInt8(++Q)*2**8+T.readUInt8(++Q):q===127&&(q=T.readUInt8(++Q)*0+T.readUInt8(++Q)*0+T.readUInt8(++Q)*0+T.readUInt8(++Q)*0+T.readUInt8(++Q)*2**24+T.readUInt8(++Q)*2**16+T.readUInt8(++Q)*2**8+T.readUInt8(++Q));let de=0;G&&(de=T.readUInt8(++Q)*2**24+T.readUInt8(++Q)*2**16+T.readUInt8(++Q)*2**8+T.readUInt8(++Q)),this.j.state=$.ReadBody,this.j.readLen=q,this.j.mask=de,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const T=this.b.read(this.j.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,T),t(T,this.j.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,T),this.j.state=$.PeekHeader,this.j.readLen=y.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(T,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(T,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$yi=S;class k extends l.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Qe.alloc(0)}constructor(A,T,j,G,q,Q){super(),this.n=A,this.r=q,this.s=Q,this.a=this.B(new b.$oe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$oe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$oe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,T?(this.b=this.B(new s(this.n,G,j,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(de=>this.a.fire(de))),this.B(this.f.onError(de=>this.a.fire(de)))):(this.b=null,this.f=null)}writeMessage(A,T){this.g.push({data:A,options:T}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:A,options:T}=this.g.shift();if(this.f&&T.compressed){const j=await this.w(this.f,A);this.s(j,T)}else this.s(A,{...T,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(A,T){return new Promise((j,G)=>{A.write(T),A.flush(q=>j(q))})}acceptFrame(A,T,j){this.h.push({data:A,isCompressed:T,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const A=this.h.shift();if(this.b&&A.isCompressed){const T=await this.C(this.b,A.data,A.isLastFrameOfMessage);this.r.fire(T)}else this.r.fire(A.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(A,T,j){return new Promise((G,q)=>{A.write(T),j&&A.write(O.$Qe.fromByteArray([0,0,255,255])),A.flush(Q=>G(Q))})}}class s extends l.$Xc{get recordedInflateBytes(){return this.j?O.$Qe.concat(this.f):O.$Qe.alloc(0)}constructor(A,T,j,G){super(),this.h=A,this.j=T,this.a=this.B(new b.$oe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(G),this.b.on("error",q=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,q),this.g.push(O.$Qe.wrap(q))}),j&&(this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(A){this.j&&this.f.push(A.clone()),this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,A),this.b.write(A.buffer)}flush(A){this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const T=O.$Qe.concat(this.g);this.g.length=0,A(T)})}}class a extends l.$Xc{constructor(A,T){super(),this.g=A,this.a=this.B(new b.$oe),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,j),this.f.push(O.$Qe.wrap(j))})}write(A){this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,A.buffer),this.b.write(A.buffer)}flush(A){this.b.flush(2,()=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let T=O.$Qe.concat(this.f);this.f.length=0,T=T.slice(0,T.byteLength-4),A(T)})}}function t(L,A){if(A===0)return;const T=L.byteLength>>>2;for(let x=0;x<T;x++){const J=L.readUInt32BE(x*4);L.writeUInt32BE(J^A,x*4)}const j=T*4,G=L.byteLength-j,q=A>>>24&255,Q=A>>>16&255,de=A>>>8&255;G>=1&&L.writeUInt8(L.readUInt8(j)^q,j),G>=2&&L.writeUInt8(L.readUInt8(j+1)^Q,j+1),G>=3&&L.writeUInt8(L.readUInt8(j+2)^de,j+2)}e.$zi=process.env.XDG_RUNTIME_DIR;const o={[u.Platform.Linux]:107,[u.Platform.Mac]:103};function n(){const L=(0,m.$5g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const A=process.platform!=="darwin"&&e.$zi?e.$zi:(0,E.tmpdir)(),T=(0,g.$mc)(A,`vscode-ipc-${L}.sock`);return h(T),T}function c(L,A,T){const G=(0,i.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${G}-${T}-${A}-sock`;const q=T.substr(0,4),Q=A.substr(0,6);let de;return process.platform!=="darwin"&&e.$zi&&!process.env.VSCODE_PORTABLE?de=(0,g.$mc)(e.$zi,`vscode-${G}-${q}-${Q}.sock`):de=(0,g.$mc)(L,`${q}-${Q}.sock`),h(de),de}function h(L){const A=o[u.$v];typeof A=="number"&&L.length>=A&&console.warn(`WARNING: IPC handle "${L}" is longer than ${A} chars, try a shorter --user-data-dir`)}class P extends p.$mi{static b(A){const T=b.Event.fromNodeEventEmitter(A,"connection");return b.Event.map(T,j=>({protocol:new f.$ti(new v(j,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(j,"close"))}))}constructor(A){super(P.b(A)),this.d=A}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ci=P;function w(L){return new Promise((A,T)=>{const j=(0,r.createServer)();j.on("error",T),j.listen(L,()=>{j.removeListener("error",T),A(new P(j))})})}function R(L,A){return new Promise((T,j)=>{const G=(0,r.createConnection)(L,()=>{G.removeListener("error",j),T(f.$ui.fromSocket(new v(G,`ipc-client${A}`),A))});G.once("error",j)})}}),define(le[20],ue([0,1,54,9,3,107,36,98,6]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=e.$Egc=void 0,e.$Egc=(0,b.$Ji)(O.$Pi);class l extends I.$_m{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$mc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$Bi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$mc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(E.$l){for(const u in process.env)if(u.endsWith("_VSCODE_SNAP_ORIG")){const m=u.slice(0,-17);if(this.d[m])continue;process.env[m]&&(this.d[m]=process.env[m]),process.env[u]?process.env[m]=process.env[u]:delete process.env[m]}}}restoreSnapExportedVariables(){if(E.$l)for(const u in this.d)process.env[u]=this.d[u],delete this.d[u]}}e.$Fgc=l,ke([i.$ai],l.prototype,"backupHome",null),ke([i.$ai],l.prototype,"mainIPCHandle",null),ke([i.$ai],l.prototype,"mainLockfile",null),ke([i.$ai],l.prototype,"disableUpdates",null),ke([i.$ai],l.prototype,"crossOriginIsolated",null),ke([i.$ai],l.prototype,"codeCachePath",null),ke([i.$ai],l.prototype,"useCodeCache",null)}),define(le[256],ue([0,1,93,32,11,9,3,18,23,168,16,20,34,14,5,167,30,106]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;let S=class{static{$=this}static{this.a="backupWorkspaces"}constructor(s,a,t,o){this.j=s,this.k=a,this.l=t,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$ah,this.i={isEqual:(n,c)=>(0,r.$Gg)(n,c,!O.$l)}}async initialize(){const s=this.m.getItem($.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(s.emptyWindows),this.d=await this.u((0,l.$Jgc)(s)),this.e=await this.v((0,l.$Kgc)(s)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==p.$Cl.OFF}q(){return this.s()===p.$Cl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||p.$Cl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(s,a){this.d.some(o=>s.workspace.id===o.workspace.id)||(this.d.push(s),this.C());const t=(0,D.$mc)(this.c,s.workspace.id);return a?this.t(t,a).then(()=>t):t}async t(s,a){if(await b.Promises.exists(s)&&await this.z(s),await b.Promises.exists(a))try{await b.Promises.rename(a,s,!1)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(s){return this.e.some(a=>this.h.isEqual(s.folderUri,a.folderUri))||(this.e.push(s),this.C()),(0,D.$mc)(this.c,this.D(s))}registerEmptyWindowBackup(s){return this.g.some(a=>!!a.backupFolder&&this.i.isEqual(a.backupFolder,s.backupFolder))||(this.g.push(s),this.C()),(0,D.$mc)(this.c,s.backupFolder)}async u(s){if(!Array.isArray(s))return[];const a=new Set,t=[];for(const o of s){const n=o.workspace;if(!(0,v.$Xi)(n))return[];if(!a.has(n.id)){a.add(n.id);const c=(0,D.$mc)(this.c,n.id);await this.B(c)?n.configPath.scheme!==E.Schemas.file||await b.Promises.exists(n.configPath.fsPath)?t.push(o):await this.z(c):await this.x(c)}}return t}async v(s){if(!Array.isArray(s))return[];const a=[],t=new Set;for(const o of s){const n=o.folderUri,c=this.h.getComparisonKey(n);if(!t.has(c)){t.add(c);const h=(0,D.$mc)(this.c,this.D(o));await this.B(h)?n.scheme!==E.Schemas.file||await b.Promises.exists(n.fsPath)?a.push(o):await this.z(h):await this.x(h)}}return a}async w(s){if(!Array.isArray(s))return[];const a=[],t=new Set;for(const o of s){const n=o.backupFolder;if(typeof n!="string")return[];if(!t.has(n)){t.add(n);const c=(0,D.$mc)(this.c,n);await this.B(c)?a.push(o):await this.x(c)}}return a}async x(s){try{await b.Promises.rm(s,b.RimRafMode.MOVE)}catch(a){this.l.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}y(){let s=(0,y.$3gc)();for(;this.g.some(a=>!!a.backupFolder&&this.i.isEqual(a.backupFolder,s.id));)s=(0,y.$3gc)();return{backupFolder:s.id}}async z(s){const a=this.y(),t=(0,D.$mc)(this.c,a.backupFolder);try{await b.Promises.rename(s,t,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(a),!0}async getDirtyWorkspaces(){const s=[];for(const a of this.d)await this.A(a)&&s.push(a);for(const a of this.e)await this.A(a)&&s.push(a);return s}A(s){let a;return(0,l.$Igc)(s)?a=(0,D.$mc)(this.c,s.backupFolder):(0,d.$Bib)(s)?a=(0,D.$mc)(this.c,this.D(s)):a=(0,D.$mc)(this.c,s.workspace.id),this.B(a)}async B(s){try{const a=await b.Promises.readdir(s);for(const t of a)try{if((await b.Promises.readdir((0,D.$mc)(s,t))).length>0)return!0}catch{}}catch{}return!1}C(){const s={workspaces:this.d.map(({workspace:a,remoteAuthority:t})=>{const o={id:a.id,configURIPath:a.configPath.toString()};return t&&(o.remoteAuthority=t),o}),folders:this.e.map(({folderUri:a,remoteAuthority:t})=>{const o={folderUri:a.toString()};return t&&(o.remoteAuthority=t),o}),emptyWindows:this.g.map(({backupFolder:a,remoteAuthority:t})=>{const o={backupFolder:a};return t&&(o.remoteAuthority=t),o})};this.m.setItem($.a,s)}D(s){const a=s.folderUri;let t;return a.scheme===E.Schemas.file?t=O.$l?a.fsPath:a.fsPath.toLowerCase():t=a.toString().toLowerCase(),(0,i.createHash)("md5").update(t).digest("hex")}};e.$khc=S,e.$khc=S=$=ke([re(0,u.$Egc),re(1,g.$cj),re(2,f.$dk),re(3,m.$VR)],S)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[19],ue([0,1,13,35,8,4,2,3,37,12,6,5,34,52,20]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.LifecycleMainPhase=e.ShutdownReason=e.$$gc=void 0,i=Ve(i),e.$$gc=(0,g.$Ii)("lifecycleMainService");var v;(function(S){S[S.QUIT=1]="QUIT",S[S.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var y;(function(S){S[S.Starting=1]="Starting",S[S.Ready=2]="Ready",S[S.AfterWindowOpen=3]="AfterWindowOpen",S[S.Eventually=4]="Eventually"})(y||(e.LifecycleMainPhase=y={}));let $=class extends O.$Xc{static{d=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(k,s,a){super(),this.F=k,this.G=s,this.H=a,this.c=this.B(new D.$oe),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$oe),this.onWillShutdown=this.f.event,this.g=this.B(new D.$oe),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$oe),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=y.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(y.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(d.b),this.m&&this.G.removeItem(d.b)}J(){const k=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(v.QUIT))};i.default.app.addListener("before-quit",k);const s=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&i.default.app.quit()};i.default.app.addListener("window-all-closed",s),i.default.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(v.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.default.app.removeListener("before-quit",k),i.default.app.removeListener("window-all-closed",s),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.default.app.quit()})})}L(k){if(this.y)return this.y;const s=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:k,join(t,o){s.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{s.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await E.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(k){if(k<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===k)return;this.S(`lifecycle (main): phase changed (value: ${k})`),this.n=k;const s=this.C.get(this.n);s&&(s.open(),this.C.delete(this.n))}async when(k){if(k<=this.n)return;let s=this.C.get(k);s||(s=new E.$Hh,this.C.set(k,s)),await s.wait()}registerWindow(k){const s=new O.$Wc;this.t++,s.add(k.onWillLoad(t=>this.g.fire({window:k,workspace:t.workspace,reason:t.reason})));const a=(0,l.$sg)(k.win);s.add(D.Event.fromNodeEventEmitter(a,"close")(t=>{const o=k.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${k.id}`),t.preventDefault(),this.unload(k,p.UnloadReason.CLOSE).then(n=>{if(n){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(k),k.close()})})),s.add(D.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${k.id}`),this.t--,s.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(v.QUIT)}))}registerAuxWindow(k){const s=(0,l.$sg)(k.win),a=new O.$Wc;a.add(D.Event.fromNodeEventEmitter(s,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${k.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(D.Event.fromNodeEventEmitter(s,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${k.id}`),a.dispose()}))}async reload(k,s){await this.unload(k,p.UnloadReason.RELOAD)||k.reload(s)}unload(k,s){const a=this.z.get(k.id);if(a)return a;const t=this.M(k,s).finally(()=>{this.z.delete(k.id)});return this.z.set(k.id,t),t}async M(k,s){if(!k.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${k.id}`);const a=this.j?p.UnloadReason.QUIT:s,t=await this.P(k,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${k.id})`),this.N(t)):(await this.Q(k,a),!1)}N(k){return k?(this.O(!0),this.j=!1,!0):!1}O(k){this.w&&(this.w(k),this.w=void 0,this.u=void 0)}P(k,s){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,n=`vscode:cancel${t}`;r.$fY.once(o,()=>{a(!1)}),r.$fY.once(n,()=>{a(!0)}),k.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:n,reason:s})})}Q(k,s){return new Promise(a=>{const o=`vscode:reply${this.s++}`;r.$fY.once(o,()=>a()),k.send("vscode:onWillUnload",{replyChannel:o,reason:s})})}quit(k){return this.R(k).then(s=>{if(!s&&k)try{if(I.$j){const a=(0,b.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return s})}R(k){return this.S(`Lifecycle#quit() - begin (willRestart: ${k})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(k&&this.G.setItem(d.b,!0),this.u=new Promise(s=>{this.w=s,this.S("Lifecycle#quit() - calling app.quit()"),i.default.app.quit()}),this.u)}S(k){this.H.args["enable-smoke-test-driver"]?this.F.info(k):this.F.trace(k)}setRelaunchHandler(k){this.D=k}async relaunch(k){this.S("Lifecycle#relaunch()");const s=process.argv.slice(1);if(k?.addArgs&&s.push(...k.addArgs),k?.removeArgs)for(const o of k.removeArgs){const n=s.indexOf(o);n>=0&&s.splice(n,1)}const a=()=>{this.D?.handleRelaunch(k)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.default.app.relaunch({args:s}))};i.default.app.once("quit",a),await this.quit(!0)&&i.default.app.removeListener("quit",a)}async kill(k){this.S("Lifecycle#kill()"),await this.L(v.KILL),await Promise.race([(0,E.$Jh)(1e3),(async()=>{for(const s of i.default.BrowserWindow.getAllWindows())if(s&&!s.isDestroyed()){let a;s.webContents&&!s.webContents.isDestroyed()?a=new Promise(t=>s.once("closed",t)):a=Promise.resolve(),s.destroy(),await a}})()]),i.default.app.exit(k)}};e.$_gc=$,e.$_gc=$=d=ke([re(0,u.$dk),re(1,m.$VR),re(2,f.$Egc)],$)}),define(le[257],ue([0,1,3,4,2,6,19]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=void 0,i=Ie(i),e.$Ihc=(0,D.$Ii)("keyboardLayoutMainService");let I=class extends E.$Xc{constructor(g){super(),this.a=this.B(new r.$oe),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(O.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((u,m)=>{K(["native-keymap"],u,m)}).then(Ie);this.c=b(g),i.$u||g.onDidChangeKeyboardLayout(()=>{this.c=b(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Jhc=I,e.$Jhc=I=ke([re(0,O.$$gc)],I);function b(l){const g=l.getKeyMap(),u=l.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:u}}}),define(le[258],ue([0,1,218,8,17,15,12,16,36,103,5,49,217,255]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0,e.$ls=v;let f=class extends u.$_p{constructor($,S,k,s){super(s),this.m=$,this.n=S,this.r=k,this.s(),this.B($.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,S){const{f:k,g:s}=this;let a;try{a=await(0,l.$Um)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$_)(n)))}const t={...process.env,...a},o=$.agent?$.agent:await(0,m.$js)($.url||"",t,{proxyUrl:k,strictSSL:s});return $.agent=o,$.strictSSL=s,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>v($,S))}async resolveProxy($){}async lookupAuthorization($){}async lookupKerberosAuthorization($){try{const S=await new Promise((o,n)=>{K(["kerberos"],o,n)}).then(Ie),k=new URL($),s=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${k}`,`spn:${s}`),"Negotiate "+await(await S.initializeClient(s)).step("")}catch(S){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",S);return}}async loadCertificates(){return(await new Promise((S,k)=>{K(["@vscode/proxy-agent"],S,k)}).then(Ie)).loadSystemCertificates({log:this.r})}};e.$ks=f,e.$ks=f=ke([re(0,I.$cj),re(1,b.$Qi),re(2,g.$dk),re(3,g.$ek)],f);async function d(y){return((0,i.parse)(y.url).protocol==="https:"?await new Promise((k,s)=>{K(["https"],k,s)}).then(Ie):await new Promise((k,s)=>{K(["http"],k,s)}).then(Ie)).request}async function v(y,$){return r.Promises.withAsyncBody(async(S,k)=>{const s=(0,i.parse)(y.url),a=y.getRawRequest?y.getRawRequest(y):await d(y),t={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,O.$ng)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(t.auth=y.user+":"+y.password);const o=a(t,n=>{const c=(0,O.$lg)(y.followRedirects)?y.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&c>0&&n.headers.location)v({...y,url:n.headers.location,followRedirects:c-1},$).then(S,k);else{let h=n;!y.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(h=n.pipe((0,p.createGunzip)())),S({res:n,stream:(0,E.$6e)(h)})}});o.on("error",k),y.timeout&&o.setTimeout(y.timeout),y.isChromiumNetwork&&o.removeHeader("Content-Length"),y.data&&typeof y.data=="string"&&o.write(y.data),o.end(),$.onCancellationRequested(()=>{o.abort(),k(new D.$7)})})}}),define(le[259],ue([0,1,13,258]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;function E(O){return i.net.request}class D extends r.$ks{request(I,b){return super.request({...I||{},getRawRequest:E,isChromiumNetwork:!0},b)}}e.$Nic=D}),define(le[89],ue([0,1,7,4,2,36,14,6,19,5,64,252,42,58,41,11]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.$ghc=e.$fhc=e.$ehc=void 0,e.$ehc=(0,I.$Ii)("storageMainService");let v=class extends E.$Xc{constructor(S,k,s,a,t,o){super(),this.c=S,this.f=k,this.g=s,this.h=a,this.j=t,this.m=o,this.a=void 0,this.b=this.B(new r.$oe),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(b.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(S=>{S.window.profile&&this.profileStorage(S.window.profile).init(),S.workspace&&this.workspaceStorage(S.workspace).init()})),this.B(this.h.onWillShutdown(S=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=S.reason,S.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)S.join("profileStorage",k.close());for(const[,k]of this.w)S.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(S=>{S.join((async()=>{await this.j.exists(S.profile.globalStorageHome)||await this.j.createFolder(S.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(S=>{const k=this.t.get(S.profile.id);k&&S.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const S=new u.$bhc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),S}profileStorage(S){if((0,g.$oq)(S))return this.applicationStorage;let k=this.t.get(S.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${S.name})`),k=this.B(this.u(S)),this.t.set(S.id,k);const s=this.B(k.onDidChangeStorage(a=>this.b.fire({...a,storage:k,profile:S})));this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${S.name})`),this.t.delete(S.id),s.dispose()}))}return k}u(S){return this.a===b.ShutdownReason.KILL?new u.$dhc(this.c,this.j):new u.$ahc(S,this.n(),this.c,this.j)}workspaceStorage(S){let k=this.w.get(S.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${S.id})`),k=this.B(this.y(S)),this.w.set(S.id,k),this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${S.id})`),this.w.delete(S.id)}))),k}y(S){return this.a===b.ShutdownReason.KILL?new u.$dhc(this.c,this.j):new u.$chc(S,this.n(),this.c,this.f,this.j)}isUsed(S){const k=i.URI.file(S);for(const s of[this.applicationStorage,...this.t.values(),...this.w.values()])if(s.path&&this.m.extUri.isEqualOrParent(i.URI.file(s.path),k))return!0;return!1}};e.$fhc=v,e.$fhc=v=ke([re(0,l.$dk),re(1,D.$Pi),re(2,p.$Ugc),re(3,b.$$gc),re(4,O.$dl),re(5,f.$Nl)],v),e.$ghc=(0,I.$Ii)("applicationStorageMainService");let y=class extends g.$nq{constructor(S,k){super(),this.s=S,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(S){if(S===g.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(S){if(S===g.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$hhc=y,e.$hhc=y=ke([re(0,m.$Pl),re(1,e.$ehc)],y)}),define(le[260],ue([0,1,95,27,116,107,8,2,3,16,5,28,211,214,104,133,17]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=e.$Lic=e.$Kic=e.$Jic=void 0,i=Ie(i),r=Ie(r);async function y(a,t,o,n,c){let h;for(let P=3;P&&(h?.dispose(),h=await new $(a,t,o,n,c).waitForReady(),!(c&&E.$8g[c]||!E.$8g[h.tunnelLocalPort]));P--);return h}class $ extends I.$Xc{constructor(t,o,n,c,h){super(),this.m=o,this.n=h,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=t,this.b=i.createServer(),this.c=new O.$Hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=P=>this.r(P),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const t=this.n??this.tunnelRemotePort,o=(0,d.$Sw)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,E.$9g)(t,2,1e3,o),c=null;return this.b.listen(n,this.m),await this.c.wait(),c=this.b.address(),c||(n=0,this.b.listen(n,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(t){t.pause();const o=(0,d.$Qw)(this.tunnelRemoteHost)||(0,d.$Sw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,m.$6l)(this.a,o,this.tunnelRemotePort),c=n.getSocket(),h=n.readEntireBuffer();n.dispose(),h.byteLength>0&&t.write(h.buffer),t.on("end",()=>{t.localAddress&&this.j.delete(t.localAddress),c.end()}),t.on("close",()=>c.end()),t.on("error",()=>{t.localAddress&&this.j.delete(t.localAddress),c instanceof D.$xi?c.socket.destroy():c.end()}),c instanceof D.$xi?this.t(t,c):this.s(t,c),t.localAddress&&this.j.set(t.localAddress,()=>{t.end(),c.end()})}s(t,o){o.onClose(()=>t.destroy()),o.onEnd(()=>t.end()),o.onData(n=>t.write(n.buffer)),t.on("data",n=>o.write(v.$Qe.wrap(n))),t.resume()}t(t,o){const n=o.socket;n.on("end",()=>t.end()),n.on("close",()=>t.end()),n.on("error",()=>{t.destroy()}),n.pipe(t),t.pipe(n)}}e.$Jic=$;let S=class extends d.$Vw{constructor(t,o,n,c,h){super(o,h),this.H=t,this.I=n,this.J=c}isPortPrivileged(t){return(0,d.$Tw)(t,this.t,b.OS,r.release())}F(t,o,n,c,h,P,w,R){const L=this.D(o,n);if(L)return++L.refcount,L.value;if((0,d.$Mw)(t))return this.G(t,o,n,h,P,w,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${n} on local port ${h}.`);const A={commit:this.J.commit,quality:this.J.quality,addressProvider:t,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},T=y(A,c,o,n,h);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,n,T),T}}};e.$Kic=S,e.$Kic=S=ke([re(0,p.$Zl),re(1,g.$dk),re(2,f.$3l),re(3,u.$wk),re(4,l.$cj)],S);let k=class extends S{constructor(t,o,n,c,h){super(t,o,n,c,h)}};e.$Lic=k,e.$Lic=k=ke([re(0,p.$Zl),re(1,g.$dk),re(2,f.$3l),re(3,u.$wk),re(4,l.$cj)],k);let s=class extends I.$Xc{constructor(t,o,n,c,h){super(),this.b=t,this.c=o,this.f=n,this.g=c,this.h=h,this.a=new Map}async openTunnel(t,o,n,c,h,P,w,R,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${c} on local port ${P}.`),!this.a.has(t)){const A=new k(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(t,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(t))})}return this.a.get(t).openTunnel(o,n,c,h,P,w,R,L)}};e.$Mic=s,e.$Mic=s=ke([re(0,p.$Zl),re(1,g.$dk),re(2,u.$wk),re(3,f.$3l),re(4,l.$cj)],s)}),define(le[108],ue([0,1,8,22,4,16,20,19,5,28,49,50]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0,e.$6hc=m;function m(f,d,v){return`${v.updateUrl}/api/update/${f}/${d}/${v.commit}`}let p=class{get state(){return this.b}d(d){this.j.info("update#setState",d.type),this.b=d,this.c.fire(d)}constructor(d,v,y,$,S,k){this.f=d,this.g=v,this.h=y,this.i=$,this.j=S,this.k=k,this.b=u.$dZ.Uninitialized,this.c=new E.$oe,this.onStateChange=this.c.event,d.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(u.$dZ.Disabled(u.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(u.$dZ.Disabled(u.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(u.$dZ.Disabled(u.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.g.getValue("update.mode"),v=this.m(d);if(!v){this.d(u.$dZ.Disabled(u.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(v),!this.a){this.d(u.$dZ.Disabled(u.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const y=new URL(this.a);y.searchParams.set("prss","true"),this.a=y.toString()}if(this.d(u.$dZ.Idle(this.q())),d==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,y=>this.j.error(y))}m(d){return d==="none"?void 0:this.k.quality}n(d=60*60*1e3){return(0,i.$Jh)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(d){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.t(d)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.o(this.state)}async o(d){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(v){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(v);return}}async _applySpecificUpdate(d){}q(){return u.UpdateType.Archive}r(){}};e.$7hc=p,e.$7hc=p=ke([re(0,I.$$gc),re(1,D.$cj),re(2,O.$Egc),re(3,g.$$p),re(4,b.$dk),re(5,l.$wk)],p)}),define(le[261],ue([0,1,13,54,4,47,2,16,20,19,5,28,49,24,50,108]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0,i=Ie(i);let v=class extends d.$7hc{get v(){return E.Event.fromNodeEventEmitter(i.autoUpdater,"error",($,S)=>S)}get w(){return E.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return E.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return E.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",($,S,k,s)=>({version:k,productVersion:k,timestamp:s}))}constructor($,S,k,s,a,t,o){super($,S,s,a,t,o),this.z=k,this.u=new O.$Wc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.z.publicLog2("update:error",{messageHash:String((0,D.$wj)(String($)))}),this.j.error("UpdateService error:",$);const S=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?$:void 0;this.d(f.$dZ.Idle(f.UpdateType.Archive,S))}s($){let S;this.k.darwinUniversalAssetId?S=this.k.darwinUniversalAssetId:S=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,d.$6hc)(S,$,this.k);try{i.autoUpdater.setFeedURL({url:k})}catch(s){this.j.error("Failed to set update feed URL",s);return}return k}t($){this.d(f.$dZ.CheckingForUpdates($)),i.autoUpdater.checkForUpdates()}E(){this.state.type===f.StateType.CheckingForUpdates&&this.d(f.$dZ.Downloading)}F($){this.state.type===f.StateType.Downloading&&(this.d(f.$dZ.Downloaded($)),this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$dZ.Ready($)))}G(){this.state.type===f.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$dZ.Idle(f.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$8hc=v,ke([r.$ai],v.prototype,"v",null),ke([r.$ai],v.prototype,"w",null),ke([r.$ai],v.prototype,"x",null),ke([r.$ai],v.prototype,"y",null),e.$8hc=v=ke([re(0,l.$$gc),re(1,I.$cj),re(2,p.$cm),re(3,b.$Egc),re(4,m.$$p),re(5,g.$dk),re(6,u.$wk)],v)}),define(le[262],ue([0,1,44,26,8,4,9,20,19,5,24,50]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0,O=Ie(O);let m=class{get state(){return this.a}d(d){this.g.info("update#setState",d.type),this.a=d,this.b.fire(d)}constructor(d,v,y){if(this.f=d,this.g=y,this.a=u.$dZ.Uninitialized,this.b=new D.$oe,this.onStateChange=this.b.event,v.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(u.$dZ.Idle(this.k())),this.h(30*1e3).then(void 0,$=>this.g.error($))}h(d=60*60*1e3){return(0,E.$Jh)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(d){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.m(d)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.i(this.state)}i(d){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return u.UpdateType.Snap}l(){}async _applySpecificUpdate(d){}};m=ke([re(0,b.$$gc),re(1,I.$Egc),re(2,l.$dk)],m);let p=class extends m{constructor(d,v,y,$,S,k){super(y,$,S),this.o=d,this.p=v,this.q=k;const s=(0,r.watch)(O.$pc(this.o)),a=D.Event.fromNodeEventEmitter(s,"change",(c,h)=>h),t=D.Event.filter(a,c=>c==="current"),n=D.Event.debounce(t,(c,h)=>h,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{n.dispose(),s.close()})}m(){this.d(u.$dZ.CheckingForUpdates(!1)),this.u().then(d=>{d?this.d(u.$dZ.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$dZ.Idle(u.UpdateType.Snap)))},d=>{this.g.error(d),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$dZ.Idle(u.UpdateType.Snap,d.message||d))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+O.$qc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const d=await new Promise((y,$)=>(0,r.realpath)(`${O.$pc(this.o)}/current`,(S,k)=>S?$(S):y(k))),v=O.$qc(d);return this.p!==v}isLatestVersion(){return this.u().then(void 0,d=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$0hc=p,e.$0hc=p=ke([re(2,b.$$gc),re(3,I.$Egc),re(4,l.$dk),re(5,g.$cm)],p)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[29],ue([0,1,13,142,9,3,16,20,6,28,77,51,52]),function(K,e,i,r,E,D,O,I,b,l,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Rgc=void 0,e.$Sgc=f,e.$Tgc=d,i=Ve(i),e.$Rgc=(0,b.$Ii)("windowsMainService");var p;(function(y){y[y.CLI=0]="CLI",y[y.DOCK=1]="DOCK",y[y.MENU=2]="MENU",y[y.DIALOG=3]="DIALOG",y[y.DESKTOP=4]="DESKTOP",y[y.API=5]="API",y[y.LINK=6]="LINK"})(p||(e.OpenContext=p={}));function f(y,$,S,k){const s=y.get(g.$Pgc),a=y.get(l.$wk),t=y.get(O.$cj),o=y.get(I.$Egc),n=t.getValue("window"),c={backgroundColor:s.getBackgroundColor(),minWidth:u.$kE.WIDTH,minHeight:u.$kE.HEIGHT,title:a.nameLong,show:$.mode!==m.WindowMode.Maximized&&$.mode!==m.WindowMode.Fullscreen,x:$.x,y:$.y,width:$.width,height:$.height,webPreferences:{...k,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.$wE)($.zoomLevel??n?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(D.$l?c.icon=(0,E.$mc)(o.appRoot,"resources/linux/code.png"):D.$j&&!o.isBuilt&&(c.icon=(0,E.$mc)(o.appRoot,"resources/win32/code_150x150.png")),D.$k&&(c.acceptFirstMouse=!0,n?.clickThroughInactive===!1&&(c.acceptFirstMouse=!1)),S?.disableFullscreen?c.fullscreen=!1:D.$k&&!(0,u.$vE)(t)&&(c.fullscreenable=!1),D.$k&&n?.nativeTabs===!0&&(c.tabbingIdentifier=a.nameShort),!(0,u.$rE)(t,S?.forceNativeTitlebar?u.TitlebarStyle.NATIVE:void 0)&&(c.titleBarStyle="hidden",D.$k||(c.frame=!1),(0,u.$uE)(t))){const w=s.getWindowSplash()?.colorInfo.titleBarBackground??s.getBackgroundColor(),R=r.$tu.fromHex(w).isDarker()?"#FFFFFF":"#000000";c.titleBarOverlay={height:29,color:w,symbolColor:R}}return c}function d(y){let $,S=Number.MIN_VALUE;for(const k of y)k.lastFocusTime>S&&(S=k.lastFocusTime,$=k);return $}var v;(function(y){function $(k,s,a=i.default.screen.getAllDisplays()){if(k.trace(`window#validateWindowState: validating window state on ${a.length} display(s)`,s),typeof s.x!="number"||typeof s.y!="number"||typeof s.width!="number"||typeof s.height!="number"){k.trace("window#validateWindowState: unexpected type of state values");return}if(s.width<=0||s.height<=0){k.trace("window#validateWindowState: unexpected negative values");return}if(a.length===1){const n=S(a[0]);if(k.trace("window#validateWindowState: single monitor working area",n),n){let c=function(){!s||typeof s.x!="number"||typeof s.y!="number"||!n||(s.x<n.x&&(s.x=n.x),s.y<n.y&&(s.y=n.y))};c(),s.width>n.width&&(s.width=n.width),s.height>n.height&&(s.height=n.height),s.x>n.x+n.width-128&&(s.x=n.x+n.width-s.width),s.y>n.y+n.height-128&&(s.y=n.y+n.height-s.height),c()}return s}if(s.display&&s.mode===m.WindowMode.Fullscreen){const n=a.find(c=>c.id===s.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){k.trace("window#validateWindowState: restoring fullscreen to previous display");const c=(0,m.$Ggc)(m.WindowMode.Fullscreen);return c.x=n.bounds.x,c.y=n.bounds.y,c}}let t,o;try{t=i.default.screen.getDisplayMatching({x:s.x,y:s.y,width:s.width,height:s.height}),o=S(t),k.trace("window#validateWindowState: multi-monitor working area",o)}catch(n){k.error("window#validateWindowState: error finding display for window state",n)}if(t&&o&&s.x+s.width>o.x&&s.y+s.height>o.y&&s.x<o.x+o.width&&s.y<o.y+o.height)return s;k.trace("window#validateWindowState: state is outside of the multi-monitor working area")}y.validateWindowState=$;function S(k){if(k.workArea.width>0&&k.workArea.height>0)return k.workArea;if(k.bounds.width>0&&k.bounds.height>0)return k.bounds}})(v||(e.WindowStateValidator=v={}))}),define(le[263],ue([0,1,95,170,123,29]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class O extends r.$3o{constructor(b){super(),this.f=b}call(b,l,g){return l==="openExtensionDevelopmentHostWindow"?this.g(g[0],g[1]):super.call(b,l,g)}async g(b,l){const g=(0,E.$Gm)(b,E.$Fm);g.debugRenderer=l;const u=g.extensionDevelopmentPath;if(!u)return{success:!1};const[m]=await this.f.openExtensionDevelopmentHostWindow(u,{context:D.OpenContext.API,cli:g,forceProfile:g.profile,forceTempProfile:g["profile-temp"]});if(!l)return{success:!0};const p=m.win;if(!p)return{success:!0};const f=p.webContents.debugger;let d=f.isAttached()?1/0:0;const v=(0,i.createServer)(y=>{d++===0&&f.attach();let $=!1;const S=a=>{$||y.write(JSON.stringify(a)+"\0")},k=(a,t,o,n)=>S({method:t,params:o,sessionId:n});p.on("close",()=>{f.removeListener("message",k),y.end(),$=!0}),f.addListener("message",k);let s=Buffer.alloc(0);y.on("data",a=>{s=Buffer.concat([s,a]);for(let t=s.indexOf(0);t!==-1;t=s.indexOf(0)){let o;try{const n=s.slice(0,t).toString("utf8");s=s.slice(t+1),o=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}f.sendCommand(o.method,o.params,o.sessionId).then(n=>S({id:o.id,sessionId:o.sessionId,result:n})).catch(n=>S({id:o.id,sessionId:o.sessionId,error:{code:0,message:n.message}}))}}),y.on("error",a=>{console.error("error on cdp pipe:",a)}),y.on("close",()=>{$=!0,--d===0&&f.detach()})});return await new Promise(y=>v.listen(0,y)),p.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$lhc=O}),define(le[264],ue([0,1,13,21,3,7,23,16,70,6,5,134,29]),function(K,e,i,r,E,D,O,I,b,l,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=e.$Lhc=e.ID=void 0,e.ID="launchMainService",e.$Lhc=(0,l.$Ii)(e.ID);let p=class{constructor(d,v,y,$){this.a=d,this.b=v,this.c=y,this.d=$}async start(d,v){this.a.trace("Received data from other instance: ",d,v),E.$k&&i.app.focus({steal:!0});const y=this.e(d);if(y.length){let $=Promise.resolve();if(this.b.getWindowCount()===0){const S=(0,r.$Qb)(await this.b.openEmptyWindow({context:m.OpenContext.DESKTOP}));S&&($=S.ready())}$.then(()=>{for(const{uri:S,originalUrl:k}of y)this.c.open(S,{originalUrl:k})})}else return this.f(d,v)}e(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,r.$Jb)(d._urls.map(v=>{try{return{uri:D.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async f(d,v){const y=(0,b.$Nm)(v)?m.OpenContext.CLI:m.OpenContext.DESKTOP;let $=[];const S=d.wait&&d.waitMarkerFilePath?D.URI.file(d.waitMarkerFilePath):void 0,k=d.remote||void 0,s={context:y,cli:d,userEnv:d["preserve-env"]||y===m.OpenContext.CLI?v:void 0,waitMarkerFileURI:S,remoteAuthority:k,forceProfile:d.profile,forceTempProfile:d["profile-temp"]};if(d.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,s);else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let a=!1;if(d["new-window"]||s.forceProfile||s.forceTempProfile)a=!0;else if(d["reuse-window"])a=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!E.$k}if(a)$=await this.b.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const t=this.b.getLastActiveWindow();t?(this.b.openExistingWindow(t,s),$=[t]):$=await this.b.open({...s,forceEmpty:!0})}}else $=await this.b.open({...s,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,mergeMode:d.merge,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],gotoLineMode:d.goto});if(S&&$.length===1&&$[0])return Promise.race([$[0].whenClosedOrLoaded,(0,O.whenDeleted)(S.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Mhc=p,e.$Mhc=p=ke([re(0,g.$dk),re(1,m.$Rgc),re(2,u.$7Y),re(3,I.$cj)],p)}),define(le[137],ue([0,1,13,22,4,47,2,7,33,16,100,20,6,5,64,89,29]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=e.$ihc=void 0,e.$ihc=(0,m.$Ii)("proxyAuthService");let y=class extends O.$Xc{constructor(S,k,s,a,t,o){super(),this.h=S,this.m=k,this.n=s,this.r=a,this.s=t,this.t=o,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.u()}u(){const S=E.Event.fromNodeEventEmitter(i.app,"login",(k,s,a,t,o)=>({event:k,authInfo:{...t,attempt:a.firstAuthAttempt?1:2},callback:o}));this.B(S(this.w,this))}async lookupAuthorization(S){return this.w({authInfo:S})}async w({event:S,authInfo:k,callback:s}){if(!k.isProxy)return;S?.preventDefault();const a=String((0,D.$wj)({scheme:k.scheme,host:k.host,port:k.port}));let t,o=this.b.get(a);if(o)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await o;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.y(k,a),this.b.set(a,o);try{t=await o}finally{this.b.delete(a)}}return s?.(t?.username,t?.password),t}async y(S,k){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const s=await this.z(S,k);if(s)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),s;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async z(S,k){if(this.h.trace("auth#doResolveProxyCredentials - enter",S),this.t.extensionTestsLocationURI){const h=this.s.getValue("integration-test.http.proxyAuth");if(h){const P=h.indexOf(":");return P!==-1?{username:h.substring(0,P),password:h.substring(P+1)}:{username:h,password:""}}return}const s=(this.s.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(s?.indexOf("@")!==-1){const h=I.URI.parse(s),P=h.authority.indexOf("@");if(P!==-1){if(S.attempt>1){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const w=h.authority.substring(0,P),R=w.indexOf(":");return R!==-1?{username:w.substring(0,R),password:w.substring(R+1)}:{username:w,password:""}}}const a=S.attempt===1&&this.g.get(k);if(a){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:h,password:P}=a;return{username:h,password:P}}let t,o;try{const h=this.r.get(this.a+k,f.StorageScope.APPLICATION);if(h){const P=JSON.parse(await this.n.decrypt(h));t=P.username,o=P.password}}catch(h){this.h.error(h)}if(S.attempt===1&&typeof t=="string"&&typeof o=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(k,{username:t,password:o}),{username:t,password:o};const n=this.c,c=this.c=(async()=>{await n;const h=await this.C(S,k,t,o);return this.c===c&&(this.c=void 0),h})();return c}async C(S,k,s,a){if(this.f.has(k)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const t=this.m.getFocusedWindow()||this.m.getLastActiveWindow();if(!t){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const o=this.g.get(k),n={authInfo:S,username:o?.username??s,password:o?.password??a,replyChannel:`vscode:proxyAuthResponse:${(0,b.$5g)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,n);const c=await new Promise(h=>{const P=async(w,R,L)=>{if(R===n.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",P),L){const A={username:L.username,password:L.password};try{if(L.remember){const T=await this.n.encrypt(JSON.stringify(A));this.r.store(this.a+k,T,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.r.remove(this.a+k,f.StorageScope.APPLICATION)}catch(T){this.h.error(T)}h({username:A.username,password:A.password})}else this.f.add(k),h(void 0)};t.win?.webContents.on("ipc-message",P)});return this.g.set(k,c),c}};e.$jhc=y,e.$jhc=y=ke([re(0,p.$dk),re(1,v.$Rgc),re(2,g.$1Y),re(3,d.$ghc),re(4,l.$cj),re(5,u.$Egc)],y)}),define(le[265],ue([0,1,2,19,52,58,30,8,29]),function(K,e,i,r,E,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;let l=class extends i.$Xc{constructor(u,m,p){super(),this.a=m,this.b=p,this.B(u.onWillLoadWindow(f=>{f.reason===E.LoadReason.LOAD&&this.c(f.window)})),this.B(u.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Uh(()=>this.g(),30*1e3)).schedule()}async c(u){const m=this.f(u),p=this.a.getProfileForWorkspace(m);p?.isTransient&&(this.a.unsetWorkspace(m,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(u){return u.openedWorkspace??(0,O.$Wi)(u.backupPath,u.isExtensionDevelopmentHost)}g(){const u=this.a.getAssociatedEmptyWindows();if(u.length===0)return;const m=this.b.getWindows().map(p=>this.f(p));for(const p of u)m.some(f=>f.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$pic=l,e.$pic=l=ke([re(0,r.$$gc),re(1,D.$Ugc),re(2,b.$Rgc)],l)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[65],ue([0,1,13,2,4,5,285,8,11,29,82,24,19,80,38,3,109,12]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=void 0,g=Ve(g);function S(a){return typeof a.responseWindowId=="number"}let k=class extends r.$Xc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,o,n){super(),this.w=t,this.y=o,this.z=n,this.c=String(++$.a),this.f=this.B(new E.$oe),this.onStdout=this.f.event,this.g=this.B(new E.$oe),this.onStderr=this.g.event,this.h=this.B(new E.$oe),this.onMessage=this.h.event,this.j=this.B(new E.$oe),this.onSpawn=this.j.event,this.m=this.B(new E.$oe),this.onExit=this.m.event,this.n=this.B(new E.$oe),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,o){let n;switch(this.t?.correlationId?n=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:n=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case g.default.Error:this.w.error(n);break;case g.default.Warning:this.w.warn(n);break;case g.default.Info:this.w.trace(n);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(t){const o=this.F(t);return o&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",g.default.Info),o}F(t){if(!this.D())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,n=b.$3g.asFileUri("bootstrap-fork.js").fsPath,c=this.t.args??[],h=this.t.execArgv??[],P=this.t.allowLoadingUnsignedLibraries,w=this.t.forceAllocationsToV8Sandbox,R=this.t.respondToAuthRequestsFromMainProcess,L="pipe",A=this.G(t);return this.C("creating new...",g.default.Info),this.r=i.utilityProcess.fork(n,c,(0,y.$zg)({serviceName:o,env:A,execArgv:h,allowLoadingUnsignedLibraries:P,forceAllocationsToV8Sandbox:w,respondToAuthRequestsFromMainProcess:R,stdio:L})),this.H(this.r,this.t,o),!0}G(t){const o=t.env?{...t.env}:{...(0,f.$ho)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,d.$j&&((0,v.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,p.$pm)(o);for(const n of Object.keys(o))o[n]=String(o[n]);return o}H(t,o,n){if(t.stdout){const c=new O.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(t.stdout,"data")(h=>this.f.fire(typeof h=="string"?h:c.write(h))))}if(t.stderr){const c=new O.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(t.stderr,"data")(h=>this.g.fire(typeof h=="string"?h:c.write(h))))}this.B(E.Event.fromNodeEventEmitter(t,"message")(c=>this.h.fire(c))),this.B(E.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:S(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.C("successfully created",g.default.Info),this.j.fire(t.pid)})),this.B(E.Event.fromNodeEventEmitter(t,"exit")(c=>{const h=this.I(c)?0:c;this.C(`received exit event with code ${h}`,g.default.Info),this.m.fire({pid:this.s,code:h,signal:"unknown"}),this.J()})),this.B(E.Event.fromNodeEventEmitter(i.app,"child-process-gone",(c,h)=>({event:c,details:h}))(({details:c})=>{c.type==="Utility"&&c.name===n&&!this.I(c.exitCode)&&(this.C(`crashed with code ${c.exitCode} and reason '${c.reason}'`,g.default.Error),this.y.publicLog2("utilityprocesscrash",{type:o.type,reason:c.reason,code:c.exitCode}),this.n.fire({pid:this.s,code:c.exitCode,reason:c.reason}),this.J())}))}once(t,o){const n=this.B(this.h.event(c=>{c===t&&(n.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:n}=new i.MessageChannelMain;return this.postMessage(t,[n]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",g.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",g.default.Info),this.r.kill()?(this.C("successfully killed the process",g.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",g.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",g.default.Info),await Promise.race([E.Event.toPromise(this.onExit),(0,I.$Jh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$mhc=k,e.$mhc=k=$=ke([re(0,D.$dk),re(1,u.$cm),re(2,m.$$gc)],k);let s=class extends k{constructor(t,o,n,c){super(t,n,c),this.L=o}start(t){const o=this.L.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.F(t))return!1;this.M(o.win,t);const c=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[c]),!0}M(t,o){o.windowLifecycleBound&&(this.B(E.Event.filter(this.z.onWillLoadWindow,n=>n.window.win===t)(()=>this.kill())),this.B(E.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$nhc=s,e.$nhc=s=ke([re(0,D.$dk),re(1,l.$Rgc),re(2,u.$cm),re(3,m.$$gc)],s)}),define(le[266],ue([0,1,8,15,4,2,19,5,24,65,29]),function(K,e,i,r,E,D,O,I,b,l,g){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;let m=class extends D.$Xc{static{u=this}static{this.a=0}constructor(f,d,v,y){super(),this.f=f,this.g=d,this.h=v,this.j=y,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(f){const d=this.b.get(f);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(f){return this.m(f).onStdout}onDynamicStderr(f){return this.m(f).onStderr}onDynamicMessage(f){return this.m(f).onMessage}onDynamicExit(f){return this.m(f).onExit}async createExtensionHost(){if(this.c)throw(0,r.$8)();const f=String(++u.a),d=new l.$nhc(this.f,this.h,this.j,this.g);this.b.set(f,d);const v=d.onExit(({pid:y,code:$,signal:S})=>{v.dispose(),this.f.info(`Extension host with pid ${y} exited with code: ${$}, signal: ${S}.`),setTimeout(()=>{d.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(y,0),this.f.error(`Extension host with pid ${y} still exists, forcefully killing it...`),process.kill(y)}catch{}},1e3)});return{id:f}}async start(f,d){if(this.c)throw(0,r.$8)();const v=this.m(f);return v.start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:f}),{pid:await E.Event.toPromise(v.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,r.$8)();const d=this.b.get(f);return d?d.enableInspectPort():!1}async kill(f){if(this.c)throw(0,r.$8)();const d=this.b.get(f);d&&d.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const d=[];for(const[,v]of this.b)d.push(v.waitForExit(f));return i.Promises.settled(d).then(()=>{})}};e.$uhc=m,e.$uhc=m=u=ke([re(0,I.$dk),re(1,O.$$gc),re(2,g.$Rgc),re(3,b.$cm)],m)}),define(le[267],ue([0,1,35,8,2,20,19,5,42,40,73,65,57,98,12,219,4]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;let y=class extends E.$Xc{constructor(S,k,s,a,t,o,n,c,h){super(),this.g=S,this.h=k,this.j=s,this.m=a,this.n=t,this.r=o,this.s=n,this.t=c,this.u=h,this.a=new r.$Hh,this.b=void 0,this.c=void 0,this.f=this.B(new v.$oe),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){i.$fY.on(d.$Xhc.request,(S,k)=>this.y(S,k,d.$Xhc.response)),i.$fY.on(d.$Yhc.request,(S,k)=>this.y(S,k,d.$Yhc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(S,k,s){this.s.trace(`[SharedProcess] onWindowConnection for: ${s}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(s);if(S.sender.isDestroyed())return a.close();S.sender.postMessage(s,k,[a])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(d.$Whc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const S=new r.$6h;this.b?.once(d.$Whc.initDone,()=>S.complete()),await S.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const S=new r.$6h;this.b?.once(d.$Whc.ipcReady,()=>S.complete()),await S.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new u.$mhc(this.s,m.$Cp,this.r)),this.c=this.b.onMessage(s=>{typeof s.warning=="string"?this.s.warn(s.warning):typeof s.error=="string"&&this.s.error(s.error)});const S=(0,p.$bn)(this.m.args,this.m.isBuilt);let k;S.port&&(k=["--nolazy"],S.break?k.push(`--inspect-brk=${S.port}`):k.push(`--inspect=${S.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:k}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(S){return await this.F,(0,f.$sg)(this.b).connect(S)}};e.$Zhc=y,e.$Zhc=y=ke([re(3,D.$Egc),re(4,b.$Pl),re(5,O.$$gc),re(6,I.$dk),re(7,g.$6gc),re(8,l.$wo)],y)}),define(le[268],ue([0,1,20,98,19,5,57,76,65,121,35,2,4,38,16,11]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;let v=class extends u.$Xc{constructor($,S,k,s,a){super(),this.f=$,this.g=S,this.h=k,this.j=s,this.m=a,this.a=void 0,this.b=new m.$oe,this.onRequestConnection=this.b.event,this.c=new m.$oe,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),g.$fY.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,u.$Vc)(()=>{g.$fY.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new b.$mhc(this.m,O.$Cp,this.j);const $=(0,r.$an)(this.h.args,this.h.isBuilt),S=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:S,args:["--logsPath",this.h.logsHome.with({scheme:d.Schemas.file}).fsPath],env:this.n()});const k=this.a.connect(),s=new l.$nY(k,"ptyHost"),a=new u.$Wc;return a.add(s),a.add((0,u.$Vc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:s,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,p.$ho)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},S=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);S&&typeof S=="number"&&($.VSCODE_LATENCY=String(S));const k=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return k&&typeof k=="number"&&($.VSCODE_STARTUP_DELAY=String(k)),this.h.restoreSnapExportedVariables(),$}r($,S){this.b.fire();const k=this.a.connect();if($.sender.isDestroyed()){k.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",S,[k])}};e.$Bic=v,e.$Bic=v=ke([re(1,f.$cj),re(2,i.$Egc),re(3,E.$$gc),re(4,D.$dk)],v)}),define(le[269],ue([0,1,2,6,5,29,65,24,47,4,8,19]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=e.$zic=void 0,e.$zic=(0,r.$Ii)("utilityProcessWorker");let m=class extends i.$Xc{constructor(d,v,y,$){super(),this.b=d,this.c=v,this.f=y,this.g=$,this.a=new Map}async createWorker(d){const v=`window: ${d.reply.windowId}, moduleId: ${d.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${v})`);const y=this.h(d);this.a.has(y)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(d));const $=new p(this.b,this.c,this.f,this.g,d);if(!$.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(y,$);const S=new g.$6h;return l.Event.once($.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(y),S.complete({reason:k})}),S.p}h(d){return(0,b.$wj)({moduleId:d.process.moduleId,windowId:d.reply.windowId})}async disposeWorker(d){const v=this.h(d),y=this.a.get(v);y&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${d.reply.windowId}, moduleId: ${d.process.moduleId})`),y.kill(),y.dispose(),this.a.delete(v))}};e.$Aic=m,e.$Aic=m=ke([re(0,E.$dk),re(1,D.$Rgc),re(2,I.$cm),re(3,u.$$gc)],m);let p=class extends i.$Xc{constructor(d,v,y,$,S){super(),this.c=d,this.f=v,this.g=y,this.h=$,this.j=S,this.a=this.B(new l.$oe),this.onDidTerminate=this.a.event,this.b=this.B(new O.$nhc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(d=>this.a.fire({code:d.code,signal:d.signal}))),this.B(this.b.onCrash(d=>this.a.fire({code:d.code,signal:"ECRASH"})))}spawn(){const v=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};p=ke([re(0,E.$dk),re(1,D.$Rgc),re(2,I.$cm),re(3,u.$$gc)],p)}),define(le[270],ue([0,1,13,4,2,244,29]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;let I=class extends E.$Xc{constructor(l){super(),this.b=l,this.a=this.B(new r.$oe),this.onFoundInFrame=this.a.event,this.B(new D.$eic)}async setIgnoreMenuShortcuts(l,g){let u;if(typeof l.windowId=="number"){const{windowId:m}=l,p=this.b.getWindowById(m);if(!p?.win)throw new Error(`Invalid windowId: ${m}`);u=p.win.webContents}else{const{webContentsId:m}=l;if(u=i.webContents.fromId(m),!u)throw new Error(`Invalid webContentsId: ${m}`)}u.isDestroyed()||u.setIgnoreMenuShortcuts(g)}async findInFrame(l,g,u,m){const f=this.c(l,g);if(typeof f.findInFrame=="function"){f.findInFrame(u,{findNext:m.findNext,forward:m.forward});const d=(v,y)=>{y.finalUpdate&&(this.a.fire(y),f.removeListener("found-in-frame",d))};f.on("found-in-frame",d)}}async stopFindInFrame(l,g,u){const p=this.c(l,g);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(u.keepSelection?"keepSelection":"clearSelection")}c(l,g){const u=this.b.getWindowById(l.windowId);if(!u?.win)throw new Error(`Invalid windowId: ${l}`);const m=u.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===g);if(!m)throw new Error(`Unknown frame: ${g}`);return m}};e.$fic=I,e.$fic=I=ke([re(0,O.$Rgc)],I)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[271],ue([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0,e.$hic=v,e.$iic=$,i=Ve(i);let d=class extends r.$Xc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(s,a,t,o,n){super(),this.g=s,this.h=a,this.j=t,this.m=o,this.n=n,this.b=v(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){i.default.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(s=>this.u(s))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(s=>{s.newCount-s.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(s=>this.u(s)))}s(){this.f=!0,this.t()}t(){const s=new Set,a={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!a.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(c=>!c.isExtensionDevelopmentHost)),n&&(a.lastActiveWindow=this.w(n),a.lastActiveWindow.uiState.mode===m.WindowMode.Fullscreen&&s.add(a.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);t&&(a.lastPluginDevelopmentHostWindow=this.w(t),a.lastPluginDevelopmentHostWindow.uiState.mode===m.WindowMode.Fullscreen&&(s.has(a.lastPluginDevelopmentHostWindow.uiState.display)?E.$k&&!t.win?.isSimpleFullScreen()&&(a.lastPluginDevelopmentHostWindow.uiState.mode=m.WindowMode.Normal):s.add(a.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(a.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const c=this.w(n);return c.uiState.mode===m.WindowMode.Fullscreen&&(s.has(c.uiState.display)?E.$k&&c.windowId!==a.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(c.uiState.mode=m.WindowMode.Normal):s.add(c.uiState.display)),c}));const o=$(a);this.h.setItem(f.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(s){if(this.j.quitRequested)return;const a=this.w(s);s.isExtensionDevelopmentHost&&!s.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=a:!s.isExtensionDevelopmentHost&&s.openedWorkspace&&this.b.openedWindows.forEach(t=>{const o=(0,p.$Xi)(s.openedWorkspace)&&t.workspace?.id===s.openedWorkspace.id,n=(0,p.$Si)(s.openedWorkspace)&&t.folderUri&&D.$ah.isEqual(t.folderUri,s.openedWorkspace.uri);(o||n)&&(t.uiState=a.uiState)}),this.g.getWindowCount()===1&&(this.c=a)}w(s){return{windowId:s.id,workspace:(0,p.$Xi)(s.openedWorkspace)?s.openedWorkspace:void 0,folderUri:(0,p.$Si)(s.openedWorkspace)?s.openedWorkspace.uri:void 0,backupPath:s.backupPath,remoteAuthority:s.remoteAuthority,uiState:s.serializeWindowState()}}getNewWindowState(s){const a=this.z(s),t=this.n.getValue("window");if(a.mode===m.WindowMode.Fullscreen){let o;a.hasDefaultState?o=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||t?.restoreFullscreen),o||(a.mode=m.WindowMode.Normal)}return a}z(s){const a=this.g.getLastActiveWindow();if(!s.extensionTestsPath){if(s.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const P=s.workspace;if((0,p.$Xi)(P)){const R=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===P.id).map(L=>L.uiState);if(R.length)return R[0]}if((0,p.$Si)(P)){const R=this.state.openedWindows.filter(L=>L.folderUri&&D.$ah.isEqual(L.folderUri,P.uri)).map(L=>L.uiState);if(R.length)return R[0]}else if(s.backupPath){const R=this.state.openedWindows.filter(L=>L.backupPath===s.backupPath).map(L=>L.uiState);if(R.length)return R[0]}const w=this.c||this.state.lastActiveWindow;if(!a&&w)return w.uiState}let t;const o=i.default.screen.getAllDisplays();if(o.length===1)t=o[0];else{if(E.$k){const P=i.default.screen.getCursorScreenPoint();t=i.default.screen.getDisplayNearestPoint(P)}!t&&a&&(t=i.default.screen.getDisplayMatching(a.getBounds())),t||(t=i.default.screen.getPrimaryDisplay()||o[0])}let n=(0,m.$Ggc)();n.x=Math.round(t.bounds.x+t.bounds.width/2-n.width/2),n.y=Math.round(t.bounds.y+t.bounds.height/2-n.height/2);const c=this.n.getValue("window");let h=!0;if(c?.newWindowDimensions){if(c.newWindowDimensions==="maximized")n.mode=m.WindowMode.Maximized,h=!1;else if(c.newWindowDimensions==="fullscreen")n.mode=m.WindowMode.Fullscreen,h=!1;else if((c.newWindowDimensions==="inherit"||c.newWindowDimensions==="offset")&&a){const P=a.serializeWindowState();P.mode===m.WindowMode.Fullscreen?n.mode=m.WindowMode.Fullscreen:n={...P,zoomLevel:void 0},h=n.mode!==m.WindowMode.Fullscreen&&c.newWindowDimensions==="offset"}}return h&&(n=this.C(n)),n.hasDefaultState=!0,n}C(s){if(this.g.getWindows().length===0)return s;s.x=typeof s.x=="number"?s.x:0,s.y=typeof s.y=="number"?s.y:0;const a=this.g.getWindows().map(t=>t.getBounds());for(;a.some(t=>t.x===s.x||t.y===s.y);)s.x+=30,s.y+=30;return s}};e.$gic=d,e.$gic=d=f=ke([re(0,u.$Rgc),re(1,g.$VR),re(2,b.$$gc),re(3,l.$dk),re(4,I.$cj)],d);function v(k){const s={openedWindows:[]},a=k||{openedWindows:[]};return a.lastActiveWindow&&(s.lastActiveWindow=y(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(s.lastPluginDevelopmentHostWindow=y(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(s.openedWindows=a.openedWindows.map(t=>y(t))),s}function y(k){const s={uiState:k.uiState};return k.backupPath&&(s.backupPath=k.backupPath),k.remoteAuthority&&(s.remoteAuthority=k.remoteAuthority),k.folder&&(s.folderUri=O.URI.parse(k.folder)),k.workspaceIdentifier&&(s.workspace={id:k.workspaceIdentifier.id,configPath:O.URI.parse(k.workspaceIdentifier.configURIPath)}),s}function $(k){return{lastActiveWindow:k.lastActiveWindow&&S(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&S(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(s=>S(s))}}function S(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[59],ue([0,1,26,13,4,43,2,11,9,18,23,10,71,53,20,6,5,58,136,30,105,106]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=void 0,i=Ie(i),r=Ve(r),e.$4gc=(0,d.$Ii)("workspacesManagementMainService");let a=class extends O.$Xc{constructor(o,n,c,h,P){super(),this.g=o,this.h=n,this.j=c,this.m=h,this.n=P,this.a=this.B(new E.$oe),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new E.$oe),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await g.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(n=>(0,l.$jh)(this.c,n,S.$8i));for(const n of o){const c=(0,s.$1gc)(n),h=await this.resolveLocalWorkspace(n);h?this.f.push({workspace:c,remoteAuthority:h.remoteAuthority}):await this.deleteUntitledWorkspace(c)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,n=>i.promises.readFile(n,"utf8"))}r(o,n){if(this.s(o)&&o.scheme===I.Schemas.file)try{const c=n(o.fsPath);return c instanceof Promise?c.then(h=>this.t(o,h),h=>{}):this.t(o,c)}catch{return}}s(o){return(0,S.$9i)(o,this.g)||(0,S.$bj)(o)}t(o,n){try{const c=this.u(o,n),h=(0,s.$1gc)(o);return{id:h.id,configPath:h.configPath,folders:(0,k.$Jib)(c.folders,h.configPath,l.$ah),remoteAuthority:c.remoteAuthority,transient:c.transient}}catch(c){this.h.warn(c.toString())}}u(o,n){const c=(0,D.$2n)(n);if(c&&Array.isArray(c.folders))c.folders=c.folders.filter(h=>(0,k.$Hib)(h));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return c}async createUntitledWorkspace(o,n){const{workspace:c,storedWorkspace:h}=this.w(o,n),P=c.configPath.fsPath;return await i.promises.mkdir((0,b.$pc)(P),{recursive:!0}),await g.Promises.writeFile(P,JSON.stringify(h,null,"	")),this.f.push({workspace:c,remoteAuthority:n}),c}w(o=[],n){const c=(Date.now()+Math.round(Math.random()*1e3)).toString(),h=(0,l.$jh)(this.c,c),P=(0,l.$jh)(h,S.$8i),w=[];for(const R of o)w.push((0,k.$Iib)(R.uri,!0,R.name,h,l.$ah));return{workspace:(0,s.$1gc)(P),storedWorkspace:{folders:w,remoteAuthority:n}}}async getWorkspaceIdentifier(o){return(0,s.$1gc)(o)}isUntitledWorkspace(o){return(0,S.$9i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const n=(0,l.$0g)(o.configPath);try{await g.Promises.rm((0,b.$pc)(n));const c=(0,b.$mc)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await g.Promises.exists(c)&&await g.Promises.writeFile((0,b.$mc)(c,"obsolete"),""),this.f=this.f.filter(h=>h.workspace.id!==o.id)}catch(c){this.h.warn(`Unable to delete untitled workspace ${n} (${c}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,n,c){if(!o||!o.win||!o.isReady||!await this.z(o,n,c))return;const P=await this.C(o,(0,s.$1gc)(c));if(P)return this.b.fire({window:o,workspace:P.workspace}),P}async z(o,n,c){return c?(0,S.$Xi)(o.openedWorkspace)&&l.$ah.isEqual(o.openedWorkspace.configPath,c)?!1:(0,$.$Xgc)(n,c)?(await this.n.showMessageBox({type:"info",buttons:[(0,u.localize)(2498,null)],message:(0,u.localize)(2499,null,(0,l.$gh)(c)),detail:(0,u.localize)(2500,null)},r.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,n){if(!o.config)return;o.focus();let c;return o.config.extensionDevelopmentPath||(o.config.backupPath?c=await this.m.registerWorkspaceBackup({workspace:n,remoteAuthority:o.remoteAuthority},o.config.backupPath):c=this.m.registerWorkspaceBackup({workspace:n,remoteAuthority:o.remoteAuthority})),(0,S.$Xi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=n,o.config.backupPath=c,{workspace:n,backupPath:c}}};e.$5gc=a,e.$5gc=a=ke([re(0,f.$Egc),re(1,v.$dk),re(2,y.$Ugc),re(3,m.$Lgc),re(4,p.$Mgc)],a)}),define(le[138],ue([0,1,13,35,22,6,29,30,59,12,5,65]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=e.ID=void 0,e.ID="diagnosticsMainService",e.$phc=(0,D.$Ii)(e.ID);let m=class{constructor(f,d,v){this.a=f,this.b=d,this.c=v}async getRemoteDiagnostics(f){const d=this.a.getWindows();return(await Promise.all(d.map(async y=>{const $=y.remoteAuthority;if(!$)return;const S=`vscode:getDiagnosticInfoResponse${y.id}`,k={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(y):void 0};return new Promise(s=>{y.sendWhenReady("vscode:getDiagnosticInfo",E.CancellationToken.None,{replyChannel:S,args:k}),r.$fY.once(S,(a,t)=>{t||s({hostName:$,errorMessage:`Unable to resolve connection to '${$}'.`}),s(t)}),setTimeout(()=>{s({hostName:$,errorMessage:`Connection to '${$}' could not be established`})},5e3)})}))).filter(y=>!!y)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const v of i.BrowserWindow.getAllWindows()){const y=this.a.getWindowById(v.id);y?f.push(await this.d(y)):f.push(this.e(v))}const d=[];for(const{pid:v,name:y}of u.$mhc.getAll())d.push({pid:v,name:y});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:d,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(f){const d=await this.f(f),v=(0,l.$sg)(f.win);return this.e(v,d,f.remoteAuthority)}e(f,d=[],v){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:d,remoteAuthority:v}}async f(f){const d=[],v=f.openedWorkspace;if((0,I.$Si)(v))d.push(v.uri);else if((0,I.$Xi)(v)){const y=await this.b.resolveLocalWorkspace(v.configPath);y&&y.folders.forEach(S=>{d.push(S.uri)})}return d}};e.$qhc=m,e.$qhc=m=ke([re(0,O.$Rgc),re(1,b.$4gc),re(2,g.$dk)],m)}),define(le[66],ue([0,1,26,44,13,27,157,54,4,2,11,9,3,7,115,94,23,116,10,53,20,6,19,5,28,77,29,30,59,17,215,205,85,15,16,137,49]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t,o,n,c,h,P,w,R,L,A,T,j,G,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0,i=Ie(i),e.$Ehc=(0,s.$Ii)("nativeHostMainService");let Q=class extends l.$Xc{constructor(x,J,B,_,C,W,F,H,ne,V,ce,oe){super(),this.a=x,this.b=J,this.c=B,this.f=_,this.g=C,this.h=W,this.j=F,this.m=H,this.n=ne,this.r=V,this.s=ce,this.t=oe,this.onDidOpenMainWindow=b.Event.map(this.a.onDidOpenWindow,Y=>Y.id),this.onDidTriggerWindowSystemContextMenu=b.Event.any(b.Event.map(this.a.onDidTriggerSystemContextMenu,({window:Y,x:M,y:Z})=>({windowId:Y.id,x:M,y:Z})),b.Event.map(this.b.onDidTriggerSystemContextMenu,({window:Y,x:M,y:Z})=>({windowId:Y.id,x:M,y:Z}))),this.onDidMaximizeWindow=b.Event.any(b.Event.map(this.a.onDidMaximizeWindow,Y=>Y.id),b.Event.map(this.b.onDidMaximizeWindow,Y=>Y.id)),this.onDidUnmaximizeWindow=b.Event.any(b.Event.map(this.a.onDidUnmaximizeWindow,Y=>Y.id),b.Event.map(this.b.onDidUnmaximizeWindow,Y=>Y.id)),this.onDidChangeWindowFullScreen=b.Event.any(b.Event.map(this.a.onDidChangeFullScreen,Y=>({windowId:Y.window.id,fullscreen:Y.fullscreen})),b.Event.map(this.b.onDidChangeFullScreen,Y=>({windowId:Y.window.id,fullscreen:Y.fullscreen}))),this.onDidBlurMainWindow=b.Event.filter(b.Event.fromNodeEventEmitter(E.app,"browser-window-blur",(Y,M)=>M.id),Y=>!!this.a.getWindowById(Y)),this.onDidFocusMainWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),b.Event.filter(b.Event.fromNodeEventEmitter(E.app,"browser-window-focus",(Y,M)=>M.id),Y=>!!this.a.getWindowById(Y))),this.onDidBlurMainOrAuxiliaryWindow=b.Event.any(this.onDidBlurMainWindow,b.Event.map(b.Event.filter(b.Event.fromNodeEventEmitter(E.app,"browser-window-blur",(Y,M)=>this.b.getWindowByWebContents(M.webContents)),Y=>!!Y),Y=>Y.id)),this.onDidFocusMainOrAuxiliaryWindow=b.Event.any(this.onDidFocusMainWindow,b.Event.map(b.Event.filter(b.Event.fromNodeEventEmitter(E.app,"browser-window-focus",(Y,M)=>this.b.getWindowByWebContents(M.webContents)),Y=>!!Y),Y=>Y.id)),this.onDidResumeOS=b.Event.fromNodeEventEmitter(E.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.u=this.B(new b.$oe),this.onDidChangePassword=this.u.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(E.screen,"display-metrics-changed",(Y,M,Z)=>Z),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),b.Event.fromNodeEventEmitter(E.screen,"display-added"),b.Event.fromNodeEventEmitter(E.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(x,J){const B=this.a.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace??(0,h.$Wi)(C.backupPath,C.isExtensionDevelopmentHost),title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()})),_=[];return J.includeAuxiliaryWindows&&_.push(...this.b.getWindows().map(C=>({id:C.id,parentId:C.parentId,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename()}))),[...B,..._]}async getWindowCount(x){return this.a.getWindowCount()}async getActiveWindowId(x){const J=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(J)return J.id}async getActiveWindowPosition(){const x=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(x)return x.getBounds()}openWindow(x,J,B){return Array.isArray(J)?this.w(x,J,B):this.z(x,J)}async w(x,J,B=Object.create(null)){J.length>0&&await this.a.open({context:c.OpenContext.API,contextWindowId:x,urisToOpen:J,cli:this.g.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async z(x,J){await this.a.openEmptyWindow({context:c.OpenContext.API,contextWindowId:x},J)}async isFullScreen(x,J){return this.H(J?.targetWindowId,x)?.isFullScreen??!1}async toggleFullScreen(x,J){this.H(J?.targetWindowId,x)?.toggleFullScreen()}async handleTitleDoubleClick(x,J){this.H(J?.targetWindowId,x)?.handleTitleDoubleClick()}async getCursorScreenPoint(x){const J=E.screen.getCursorScreenPoint(),B=E.screen.getDisplayNearestPoint(J);return{point:J,display:B.bounds}}async isMaximized(x,J){return this.H(J?.targetWindowId,x)?.win?.isMaximized()??!1}async maximizeWindow(x,J){this.H(J?.targetWindowId,x)?.win?.maximize()}async unmaximizeWindow(x,J){this.H(J?.targetWindowId,x)?.win?.unmaximize()}async minimizeWindow(x,J){this.H(J?.targetWindowId,x)?.win?.minimize()}async moveWindowTop(x,J){this.H(J?.targetWindowId,x)?.win?.moveTop()}async positionWindow(x,J,B){const _=this.H(B?.targetWindowId,x);if(_?.win){if(_.win.isFullScreen()){const C=b.Event.toPromise(b.Event.once(b.Event.fromNodeEventEmitter(_.win,"leave-full-screen")));_.win.setFullScreen(!1),await C}_.win.setBounds(J)}}async updateWindowControls(x,J){this.H(J?.targetWindowId,x)?.updateWindowControls(J)}async focusWindow(x,J){this.H(J?.targetWindowId,x)?.focus({force:J?.force??!1})}async setMinimumSize(x,J,B){const _=this.I(x);if(_?.win){const[C,W]=_.win.getSize(),[F,H]=_.win.getMinimumSize(),[ne,V]=[J??F,B??H],[ce,oe]=[Math.max(C,ne),Math.max(W,V)];(F!==ne||H!==V)&&_.win.setMinimumSize(ne,V),(C!==ce||W!==oe)&&_.win.setSize(ce,oe)}}async saveWindowSplash(x,J){this.m.saveWindowSplash(x,J)}async installShellCommand(x){const{source:J,target:B}=await this.C();try{const{symbolicLink:_}=await v.SymlinkSupport.stat(J);if(_&&!_.dangling){const C=await(0,f.$sr)(J);if(B===C)return}await i.promises.unlink(J)}catch(_){if(_.code!=="ENOENT")throw _}try{await i.promises.symlink(B,J)}catch(_){if(_.code!=="EACCES"&&_.code!=="ENOENT")throw _;const{response:C}=await this.showMessageBox(x,{type:"info",message:(0,$.localize)(2002,null,this.j.nameShort),buttons:[(0,$.localize)(2003,null),(0,$.localize)(2004,null)]});if(C===1)throw new T.$7;try{const W=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${J}'\\" with administrator privileges"`;await(0,O.promisify)(r.exec)(W)}catch{throw new Error((0,$.localize)(2005,null,J))}}}async uninstallShellCommand(x){const{source:J}=await this.C();try{await i.promises.unlink(J)}catch(B){switch(B.code){case"EACCES":{const{response:_}=await this.showMessageBox(x,{type:"info",message:(0,$.localize)(2006,null,this.j.nameShort),buttons:[(0,$.localize)(2007,null),(0,$.localize)(2008,null)]});if(_===1)throw new T.$7;try{const C=`osascript -e "do shell script \\"rm '${J}'\\" with administrator privileges"`;await(0,O.promisify)(r.exec)(C)}catch{throw new Error((0,$.localize)(2009,null,J))}break}case"ENOENT":break;default:throw B}}}async C(){const x=(0,u.$nc)(this.g.appRoot,"bin","code"),J=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(x))throw new Error((0,$.localize)(2010,null,x));return{source:J,target:x}}async showMessageBox(x,J){const B=this.H(J?.targetWindowId,x);return this.c.showMessageBox(J,B?.win??void 0)}async showSaveDialog(x,J){const B=this.H(J?.targetWindowId,x);return this.c.showSaveDialog(J,B?.win??void 0)}async showOpenDialog(x,J){const B=this.H(J?.targetWindowId,x);return this.c.showOpenDialog(J,B?.win??void 0)}async pickFileFolderAndOpen(x,J){const B=await this.c.pickFileFolder(J);B&&await this.D(await Promise.all(B.map(async _=>await v.SymlinkSupport.existsDirectory(_)?{folderUri:p.URI.file(_)}:{fileUri:p.URI.file(_)})),J,x)}async pickFolderAndOpen(x,J){const B=await this.c.pickFolder(J);B&&await this.D(B.map(_=>({folderUri:p.URI.file(_)})),J,x)}async pickFileAndOpen(x,J){const B=await this.c.pickFile(J);B&&await this.D(B.map(_=>({fileUri:p.URI.file(_)})),J,x)}async pickWorkspaceAndOpen(x,J){const B=await this.c.pickWorkspace(J);B&&await this.D(B.map(_=>({workspaceUri:p.URI.file(_)})),J,x)}async D(x,J,B){await this.a.open({context:c.OpenContext.DIALOG,contextWindowId:B,cli:this.g.args,urisToOpen:x,forceNewWindow:J.forceNewWindow})}async showItemInFolder(x,J){E.shell.showItemInFolder(J)}async setRepresentedFilename(x,J,B){this.H(B?.targetWindowId,x)?.setRepresentedFilename(J)}async setDocumentEdited(x,J,B){this.H(B?.targetWindowId,x)?.setDocumentEdited(J)}async openExternal(x,J,B){this.g.unsetSnapExportedVariables();try{(0,g.$Sg)(J,g.Schemas.http,g.Schemas.https)?this.F(J,B):E.shell.openExternal(J)}finally{this.g.restoreSnapExportedVariables()}return!0}async F(x,J){const B=J??this.r.getValue("workbench.externalBrowser");if(!B)return E.shell.openExternal(x);if((B.includes(u.$jc.sep)||B.includes(u.$ic.sep))&&!await v.Promises.exists(B))return this.h.error(`Configured external browser path does not exist: ${B}`),E.shell.openExternal(x);try{const{default:_}=await new Promise((W,F)=>{K(["open"],W,F)}).then(Ie);(await _(x,{app:{name:Object.hasOwn(_.apps,B)?_.apps[B]:B}})).stderr?.once("data",W=>(this.h.error(`Error openening external URL '${x}' using browser '${B}': ${W.toString()}`),E.shell.openExternal(x)))}catch(_){return this.h.error(`Unable to open external URL '${x}' using browser '${B}' due to ${_}.`),E.shell.openExternal(x)}}moveItemToTrash(x,J){return E.shell.trashItem(J)}async isAdmin(){let x;return m.$j?x=(await new Promise((J,B)=>{K(["native-is-elevated"],J,B)}).then(Ie)).default():x=process.getuid?.()===0,x}async writeElevated(x,J,B,_){const C=await new Promise((W,F)=>{K(["@vscode/sudo-prompt"],W,F)}).then(Ie);return new Promise((W,F)=>{const H=[`"${this.G}"`];_?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${J.fsPath}"`,`"${B.fsPath}"`);const ne={name:this.j.nameLong.replace("-",""),icns:m.$k&&this.g.isBuilt?(0,u.$mc)((0,u.$pc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};C.exec(H.join(" "),ne,(V,ce,oe)=>{ce&&this.h.trace(`[sudo-prompt] received stdout: ${ce}`),oe&&this.h.trace(`[sudo-prompt] received stderr: ${oe}`),V?F(V):W(void 0)})})}async isRunningUnderARM64Translation(){return m.$l||m.$j?!1:E.app.runningUnderARM64Translation}get G(){return m.$j?this.g.isBuilt?(0,u.$mc)((0,u.$pc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,u.$mc)(this.g.appRoot,"scripts","code-cli.bat"):m.$l?this.g.isBuilt?(0,u.$mc)((0,u.$pc)(process.execPath),"bin",`${this.j.applicationName}`):(0,u.$mc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,u.$mc)(this.g.appRoot,"bin","code"):(0,u.$mc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return d.$Vn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return m.$j&&(0,R.$Bhc)()}async getProcessId(x){return this.H(void 0,x)?.win?.webContents.getOSProcessId()}async killProcess(x,J,B){process.kill(J,B)}async readClipboardText(x,J){return E.clipboard.readText(J)}async writeClipboardText(x,J,B){return E.clipboard.writeText(J,B)}async readClipboardFindText(x){return E.clipboard.readFindText()}async writeClipboardFindText(x,J){return E.clipboard.writeFindText(J)}async writeClipboardBuffer(x,J,B,_){return E.clipboard.writeBuffer(J,Buffer.from(B.buffer),_)}async readClipboardBuffer(x,J){return w.$Qe.wrap(E.clipboard.readBuffer(J))}async hasClipboard(x,J,B){return E.clipboard.has(J,B)}async newWindowTab(){await this.a.open({context:c.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){E.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){E.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){E.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){E.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){E.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(x,J){this.I(x)?.updateTouchBar(J)}async notifyReady(x){this.I(x)?.setReady()}async relaunch(x,J){return this.f.relaunch(J)}async reload(x,J){const B=this.I(x);if(B){if((0,h.$Xi)(B.openedWorkspace)){const _=B.openedWorkspace.configPath;if(_.scheme===g.Schemas.file&&(await this.n.resolveLocalWorkspace(_))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.f.reload(B,J?.disableExtensions!==void 0?{_:[],"disable-extensions":J.disableExtensions}:void 0)}}async closeWindow(x,J){return this.H(J?.targetWindowId,x)?.win?.close()}async quit(x){const J=this.a.getLastActiveWindow();J?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&J.win?J.win.close():this.f.quit()}async exit(x,J){await this.f.kill(J)}async resolveProxy(x,J){if(this.g.extensionTestsLocationURI){const C=this.r.getValue("integration-test.http.proxy");if(C)return C}return this.I(x)?.win?.webContents?.session?.resolveProxy(J)}async lookupAuthorization(x,J){return this.t.lookupAuthorization(J)}async lookupKerberosAuthorization(x,J){return this.s.lookupKerberosAuthorization(J)}async loadCertificates(x){return this.s.loadCertificates()}findFreePort(x,J,B,_,C=1){return(0,y.$7g)(J,B,_,C)}async openDevTools(x,J){this.H(J?.targetWindowId,x)?.win?.webContents.openDevTools(J?.mode?{mode:J.mode,activate:J.activate}:void 0)}async toggleDevTools(x,J){this.H(J?.targetWindowId,x)?.win?.webContents.toggleDevTools()}async profileRenderer(x,J,B){const _=this.I(x);if(!_||!_.win)throw new Error;return await new L.$Chc(_.win,J,this.h).inspect(B)}async windowsGetStringRegKey(x,J,B,_){if(!m.$j)return;const C=await new Promise((W,F)=>{K(["@vscode/windows-registry"],W,F)}).then(Ie);try{return C.GetStringRegKey(J,B,_)}catch{return}}H(x,J){return this.I(x)??this.J(x)??this.I(J)}I(x){if(typeof x=="number")return this.a.getWindowById(x)}J(x){if(typeof x!="number")return;const J=E.webContents.fromId(x);if(J)return this.b.getWindowByWebContents(J)}};e.$Fhc=Q,ke([I.$ai],Q.prototype,"G",null),e.$Fhc=Q=ke([re(0,c.$Rgc),re(1,A.$Dhc),re(2,S.$Mgc),re(3,a.$$gc),re(4,k.$Egc),re(5,t.$dk),re(6,o.$wk),re(7,n.$Pgc),re(8,P.$4gc),re(9,j.$cj),re(10,q.$$p),re(11,G.$ihc)],Q)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[272],ue([0,1,13,27,8,22,2,11,3,35,10,53,20,5,66,63,74,51,29,67,86]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0,d=Ve(d);let a=class{static{s=this}static{this.a="#1E1E1E"}constructor(o,n,c,h,P,w,R,L){this.d=o,this.e=n,this.f=c,this.g=h,this.h=P,this.i=w,this.j=R,this.k=L,this.b=null,this.c=null}async openReporter(o){if(this.b)this.b&&this.l(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const n=new O.$Wc,c=n.add(this.i.createIPCObjectUrl()),h=this.n(this.c,700,800);this.b=this.m(h,c,{backgroundColor:o.styles.backgroundColor,title:(0,g.localize)(1907,null),zoomLevel:o.zoomLevel,alwaysOnTop:!1},"issue-reporter"),c.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:o,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:d.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},cssModules:this.k.isEnabled?await this.k.getCssModules():void 0}),this.b.loadURL(I.$3g.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.${S.$T?"esm.":""}html`).toString(!0)),this.b.on("close",()=>{this.b=null,n.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,n.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(o){this.f.error(o)}}async $showConfirmCloseDialog(){if(this.b){const{response:o}=await this.g.showMessageBox({type:"warning",message:(0,g.localize)(1908,null),buttons:[(0,g.localize)(1909,null),(0,g.localize)(1910,null)]},this.b);o===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:o}=await this.g.showMessageBox({type:"warning",message:(0,g.localize)(1911,null),buttons:[(0,g.localize)(1912,null),(0,g.localize)(1913,null)]},this.b);return o===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const o=this.j.getWindowById(this.c.id);if(!o)throw new Error("Window not found");return o}async $sendReporterMenu(o,n){const c=this.issueReporterWindowCheck(),h="vscode:triggerReporterMenu",P=new D.$ze;return c.sendWhenReady(h,P.token,{replyChannel:h,extensionId:o,extensionName:n}),await(0,E.$zh)(new Promise(R=>l.$fY.once(`vscode:triggerReporterMenuResponse:${o}`,(L,A)=>R(A))),5e3,()=>{this.f.error(`Error: Extension ${o} timed out waiting for menu response`),P.cancel()})}async $closeReporter(){this.b?.close()}l(o){o.isMinimized()&&o.restore(),o.focus()}m(o,n,c,h){const P=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:c.title,backgroundColor:c.backgroundColor||s.a,webPreferences:{preload:I.$3g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,y.$wE)(c.zoomLevel),sandbox:!0},alwaysOnTop:c.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}n(o,n,c){let h;const P=i.screen.getAllDisplays();if(P.length===1)h=P[0];else{if(b.$k){const L=i.screen.getCursorScreenPoint();h=i.screen.getDisplayNearestPoint(L)}!h&&o&&(h=i.screen.getDisplayMatching(o.getBounds())),h||(h=i.screen.getPrimaryDisplay()||P[0])}const w=h.bounds,R={width:n,height:c,x:w.x+w.width/2-n/2,y:w.y+w.height/2-c/2};return w.width>0&&w.height>0&&(R.x<w.x&&(R.x=w.x),R.y<w.y&&(R.y=w.y),R.x>w.x+w.width&&(R.x=w.x),R.y>w.y+w.height&&(R.y=w.y),R.width>w.width&&(R.width=w.width),R.height>w.height&&(R.height=w.height)),R}};e.$Ghc=a,e.$Ghc=a=s=ke([re(1,m.$Egc),re(2,p.$dk),re(3,u.$Mgc),re(4,f.$Ehc),re(5,v.$Ogc),re(6,$.$Rgc),re(7,k.$aS)],a)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[273],ue([0,1,13,32,2,11,3,118,35,10,99,138,53,20,86,5,66,63,28,74,34,65,51,67]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0,y=Ve(y);const n="issue.processExplorerWindowState";let c=class{static{o=this}static{this.a="#1E1E1E"}constructor(w,R,L,A,T,j,G,q,Q,de,x){this.d=w,this.f=R,this.g=L,this.h=A,this.i=T,this.j=j,this.k=G,this.l=q,this.m=Q,this.n=de,this.o=x,this.b=null,this.c=null,this.p()}p(){b.$fY.on("vscode:listProcesses",async w=>{const R=[];try{R.push({name:(0,l.localize)(1914,null),rootProcess:await(0,I.$3s)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(A=>{(0,g.$Xm)(A)?R.push({name:A.hostName,rootProcess:A}):A.processes&&R.push({name:A.hostName,rootProcess:A.processes})})}catch(L){this.g.error(`Listing processes failed: ${L}`)}this.t(w,"vscode:listProcessesResponse",R)}),b.$fY.on("vscode:workbenchCommand",(w,R)=>{const{id:L,from:A,args:T}=R;let j;switch(A){case"processExplorer":j=this.c;break;default:throw new Error(`Unexpected command source: ${A}`)}j?.webContents.send("vscode:runAction",{id:L,from:A,args:T})}),b.$fY.on("vscode:closeProcessExplorer",w=>{this.b?.close()}),b.$fY.on("vscode:pidToNameRequest",async w=>{const R=await this.i.getMainDiagnostics(),L=[];for(const A of R.windows)L.push([A.pid,`window [${A.id}] (${A.title})`]);for(const{pid:A,name:T}of s.$mhc.getAll())L.push([A,T]);this.t(w,"vscode:pidToNameResponse",L)})}async openProcessExplorer(w){if(!this.b&&(this.c=i.BrowserWindow.getFocusedWindow(),this.c)){const R=new E.$Wc,L=R.add(this.l.createIPCObjectUrl()),A=this.n.getItem(n,void 0),T=h(A)?A:this.r(this.c,800,500);this.b=this.s(T,L,{backgroundColor:w.styles.backgroundColor,title:(0,l.localize)(1915,null),zoomLevel:w.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:w,product:y.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},cssModules:this.o.isEnabled?await this.o.getCssModules():void 0}),this.b.loadURL(D.$3g.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.${t.$T?"esm.":""}html`).toString(!0)),this.b.on("close",()=>{this.b=null,R.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,R.dispose())});const j=()=>{if(!this.b)return;const G=this.b.getSize(),q=this.b.getPosition();if(!G||!q)return;const Q={width:G[0],height:G[1],x:q[0],y:q[1]};this.n.setItem(n,Q)};this.b.on("moved",j),this.b.on("resized",j)}this.b&&this.q(this.b)}q(w){w.isMinimized()&&w.restore(),w.focus()}r(w,R,L){let A;const T=i.screen.getAllDisplays();if(T.length===1)A=T[0];else{if(O.$k){const q=i.screen.getCursorScreenPoint();A=i.screen.getDisplayNearestPoint(q)}!A&&w&&(A=i.screen.getDisplayMatching(w.getBounds())),A||(A=i.screen.getPrimaryDisplay()||T[0])}const j=A.bounds,G={width:R,height:L,x:j.x+j.width/2-R/2,y:j.y+j.height/2-L/2};return j.width>0&&j.height>0&&(G.x<j.x&&(G.x=j.x),G.y<j.y&&(G.y=j.y),G.x>j.x+j.width&&(G.x=j.x),G.y>j.y+j.height&&(G.y=j.y),G.width>j.width&&(G.width=j.width),G.height>j.height&&(G.height=j.height)),G}async stopTracing(){if(!this.f.args.trace)return;const w=await i.contentTracing.stopRecording(`${(0,r.$Qg)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,l.localize)(1916,null),detail:(0,l.localize)(1917,null,w),buttons:[(0,l.localize)(1918,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,w)}async getSystemStatus(){const[w,R]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(w,R)}async $getSystemInfo(){const[w,R]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(w,R)}async $getPerformanceInfo(){try{const[w,R]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(w,R)}catch(w){throw this.g.warn("issueService#getPerformanceInfo ",w.message),w}}s(w,R,L,A){const T=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:w.width,height:w.height,minWidth:300,minHeight:200,x:w.x,y:w.y,title:L.title,backgroundColor:L.backgroundColor||o.a,webPreferences:{preload:D.$3g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${R.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.$wE)(L.zoomLevel),sandbox:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}t(w,R,...L){w.sender.isDestroyed()||w.sender.send(R,...L)}async closeProcessExplorer(){this.b?.close()}};e.$Hhc=c,e.$Hhc=c=o=ke([re(1,p.$Egc),re(2,d.$dk),re(3,g.$Wm),re(4,u.$phc),re(5,m.$Mgc),re(6,v.$Ehc),re(7,S.$Ogc),re(8,$.$wk),re(9,k.$VR),re(10,f.$aS)],c);function h(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(le[274],ue([0,1,22,16,20,19,5,66,28,49,24,50,108]),function(K,e,i,r,E,D,O,I,b,l,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;let p=class extends m.$7hc{constructor(d,v,y,$,S,k,s,a){super(d,v,$,S,k,a),this.e=y,this.u=s}s(d){return(0,m.$6hc)(`linux-${process.arch}`,d,this.k)}t(d){this.a&&(this.d(u.$dZ.CheckingForUpdates(d)),this.i.request({url:this.a},i.CancellationToken.None).then(l.$eq).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!d}),this.d(u.$dZ.Idle(u.UpdateType.Archive))):this.d(u.$dZ.AvailableForDownload(v))}).then(void 0,v=>{this.j.error(v);const y=d?v.message||v:void 0;this.d(u.$dZ.Idle(u.UpdateType.Archive,y))}))}async o(d){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):d.update.url&&this.u.openExternal(void 0,d.update.url),this.d(u.$dZ.Idle(u.UpdateType.Archive))}};e.$9hc=p,e.$9hc=p=ke([re(0,D.$$gc),re(1,r.$cj),re(2,g.$cm),re(3,E.$Egc),re(4,l.$$p),re(5,O.$dk),re(6,I.$Ehc),re(7,b.$wk)],p)}),define(le[275],ue([0,1,44,26,27,8,22,54,47,9,7,155,23,16,20,14,19,5,66,28,49,24,50,108]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0,r=Ie(r),l=Ie(l),m=Ie(m);async function o(P,w=1e3){for(;!P();)await(0,D.$Jh)(w)}let n;function c(){return typeof n>"u"&&(n=r.existsSync(l.$mc(l.$pc(process.execPath),"unins000.exe"))?a.UpdateType.Setup:a.UpdateType.Archive),n}let h=class extends t.$7hc{get cachePath(){const w=l.$mc((0,E.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(w,{recursive:!0}).then(()=>w)}constructor(w,R,L,A,T,j,G,q,Q){super(w,R,A,T,j,Q),this.u=L,this.v=G,this.w=q,w.setRelaunchHandler(this)}handleRelaunch(w){return w?.addArgs||w?.removeArgs||this.state.type!==a.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(a.$dZ.Disabled(a.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(w){let R=`win32-${process.arch}`;return c()===a.UpdateType.Archive?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,t.$6hc)(R,w,this.k)}t(w){this.a&&(this.d(a.$dZ.CheckingForUpdates(w)),this.i.request({url:this.a},O.CancellationToken.None).then(k.$eq).then(R=>{const L=c();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!w}),this.d(a.$dZ.Idle(L)),Promise.resolve(null)):L===a.UpdateType.Archive?(this.d(a.$dZ.AvailableForDownload(R)),Promise.resolve(null)):(this.d(a.$dZ.Downloading),this.C(R.version).then(()=>this.B(R.version).then(A=>m.Promises.exists(A).then(T=>{if(T)return Promise.resolve(A);const j=`${A}.tmp`;return this.i.request({url:R.url},O.CancellationToken.None).then(G=>this.v.writeFile(g.URI.file(j),G.stream)).then(R.sha256hash?()=>(0,u.$$X)(j,R.sha256hash):()=>{}).then(()=>m.Promises.rename(j,A,!1)).then(()=>A)})).then(A=>{this.e={packagePath:A},this.d(a.$dZ.Downloaded(R)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(a.$dZ.Ready(R))})))}).then(void 0,R=>{this.u.publicLog2("update:error",{messageHash:String((0,b.$wj)(String(R)))}),this.j.error(R);const L=w?R.message||R:void 0;this.d(a.$dZ.Idle(c(),L))}))}async o(w){w.update.url&&this.w.openExternal(void 0,w.update.url),this.d(a.$dZ.Idle(c()))}async B(w){const R=await this.cachePath;return l.$mc(R,`CodeSetup-${this.k.quality}-${w}.exe`)}async C(w=null){const R=w?j=>!new RegExp(`${this.k.quality}-${w}\\.exe$`).test(j):()=>!0,L=await this.cachePath,T=(await m.Promises.readdir(L)).filter(R).map(async j=>{try{await r.promises.unlink(l.$mc(L,j))}catch{}});await Promise.all(T)}async p(){if(this.state.type!==a.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const w=this.state.update;this.d(a.$dZ.Updating(w));const R=await this.cachePath;this.e.updateFilePath=l.$mc(R,`CodeSetup-${this.k.quality}-${w.version}.flag`),await m.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(a.$dZ.Idle(c()))});const A=`${this.k.win32MutexName}-ready`,T=await new Promise((j,G)=>{K(["@vscode/windows-mutex"],j,G)}).then(Ie);o(()=>T.isActive(A)).then(()=>this.d(a.$dZ.Ready(w)))}r(){this.state.type!==a.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return c()}async _applySpecificUpdate(w){if(this.state.type!==a.StateType.Idle)return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(a.$dZ.Downloading),this.e={packagePath:w},this.d(a.$dZ.Downloaded(L)),R?this.k.target==="user"&&this.p():this.d(a.$dZ.Ready(L))}};e.$$hc=h,ke([I.$ai],h.prototype,"cachePath",null),e.$$hc=h=ke([re(0,v.$$gc),re(1,p.$cj),re(2,s.$cm),re(3,f.$Egc),re(4,k.$$p),re(5,y.$dk),re(6,d.$dl),re(7,$.$Ehc),re(8,S.$wk)],h)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[139],ue([0,1,13,8,22,55,4,2,11,72,3,7,10,27,71,16,53,20,70,14,19,5,28,74,251,89,24,113,77,51,29,30,59,52,40,34,58,73,21,6,67]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t,o,n,c,h,P,w,R,L,A,T,j,G,q,Q,de,x,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0,i=Ve(i);var B;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(B||(B={}));class _ extends I.$Xc{get lastFocusTime(){return this.j}get win(){return this.m}n(F,H){this.m=F,this.B(O.Event.fromNodeEventEmitter(F,"maximize")(()=>this.b.fire())),this.B(O.Event.fromNodeEventEmitter(F,"unmaximize")(()=>this.c.fire())),this.B(O.Event.fromNodeEventEmitter(F,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(O.Event.fromNodeEventEmitter(F,"focus")(()=>{this.j=Date.now()})),this.B(O.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(O.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const ne=!(0,w.$rE)(this.r,H?.titleBarStyle==="hidden"?w.TitlebarStyle.CUSTOM:void 0);if(g.$k&&ne&&F.setSheetOffset((0,g.$K)((0,p.release)())?28:22),ne&&((0,w.$uE)(this.r)||g.$k)){const V=this.s.getItem(_.D);V?this.updateWindowControls({height:V}):this.updateWindowControls({height:w.$tE})}g.$j&&ne&&F.hookWindowMessage(278,()=>{const[ce,oe]=F.getPosition(),Y=i.default.screen.getCursorScreenPoint(),M=Y.x-ce,Z=Y.y-oe;return!(M>30&&Z>=0&&Z<=Math.max(F.getBounds().height*.15,35))||(F.setEnabled(!1),F.setEnabled(!0),this.f.fire({x:M,y:Z})),0}),this.t.args["open-devtools"]===!0&&F.webContents.openDevTools(),g.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(F,H,ne,V){super(),this.r=F,this.s=H,this.t=ne,this.u=V,this.a=this.B(new O.$oe),this.onDidClose=this.a.event,this.b=this.B(new O.$oe),this.onDidMaximize=this.b.event,this.c=this.B(new O.$oe),this.onDidUnmaximize=this.c.event,this.f=this.B(new O.$oe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new O.$oe),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new O.$oe),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,w.$uE)(this.r),this.G=void 0,this.H=void 0}w(F,H=i.default.screen.getAllDisplays().length>0){const ne=this.r.getValue("window"),V=g.$k&&ne?.nativeTabs===!0;(g.$k||g.$j)&&H&&(!V||i.default.BrowserWindow.getAllWindows().length===1)&&[F.width,F.height,F.x,F.y].every(ce=>typeof ce=="number")&&this.m?.setBounds({width:F.width,height:F.height,x:F.x,y:F.y}),(F.mode===T.WindowMode.Maximized||F.mode===T.WindowMode.Fullscreen)&&(this.m?.maximize(),F.mode===T.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(F){g.$k?this.win?.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return g.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(F){g.$k&&this.win?.setDocumentEdited(F),this.C=F}isDocumentEdited(){return g.$k?!!this.win?.isDocumentEdited():!!this.C}focus(F){g.$k&&F?.force&&i.default.app.focus({steal:!0});const H=this.win;H&&(H.isMinimized()&&H.restore(),H.focus())}handleTitleDoubleClick(){const F=this.win;if(F)if(g.$k)switch(i.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":F.minimize();break;case"None":break;case"Maximize":default:F.isMaximized()?F.unmaximize():F.maximize()}else F.isMaximized()?F.unmaximize():F.maximize()}static{this.D="windowControlHeight"}updateWindowControls(F){const H=this.win;if(H){if(F.height&&this.s.setItem(C.D,F.height),this.F)H.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(g.$k&&F.height!==void 0){const ne=(F.height-15)/2;ne?H.setWindowButtonPosition({x:ne,y:ne}):H.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(F,H){(0,w.$vE)(this.r)?this.J(F,H):this.M(F)}get isFullScreen(){if(g.$k&&typeof this.G=="boolean")return this.G;const F=this.win,H=F?.isFullScreen(),ne=F?.isSimpleFullScreen();return!!(H||ne)}J(F,H){const ne=this.win;ne?.isSimpleFullScreen()&&ne?.setSimpleFullScreen(!1),this.L(F,H)}L(F,H){if(g.$k){this.G=F;const V=this.H=new r.$6h;(async()=>{const ce=await Promise.race([V.p,(0,r.$Jh)(1e4).then(()=>!1)]);this.H===V&&(this.G=void 0,this.H=void 0,!ce&&F&&H&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(F)}M(F){const H=this.win;H?.isFullScreen()&&this.L(!1,!1),H?.setSimpleFullScreen(F),H?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$8gc=_;let C=class extends _{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const F=this.hb.profiles.find(H=>H.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Wi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(F,H,ne,V,ce,oe,Y,M,Z,U,N,ie,X,z,te,ae,me,be,ye,Fe,xe){super(U,Fe,V,H),this.fb=ne,this.gb=ce,this.hb=oe,this.ib=Y,this.jb=M,this.kb=Z,this.lb=N,this.mb=ie,this.nb=X,this.ob=z,this.pb=te,this.qb=ae,this.rb=me,this.sb=be,this.tb=ye,this.N=this.B(new O.$oe),this.onWillLoad=this.N.event,this.O=this.B(new O.$oe),this.onDidSignalReady=this.O.event,this.P=this.B(new O.$oe),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=B.NONE;{const[Ae,$e]=this.Eb(F.state);this.U=Ae,this.u.trace("window#ctor: using window state",Ae);const ee=xe.invokeFunction(R.$Sgc,this.U,void 0,{preload:b.$3g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.default.BrowserWindow(ee),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m,ee),this.w(this.U,$e),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=B.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.X.push(F)})}get isReady(){return this.ub===B.READY}get whenClosedOrLoaded(){return new Promise(F=>{function H(){ne.dispose(),V.dispose(),F()}const ne=this.onDidClose(()=>H()),V=this.onWillLoad(()=>H())})}vb(){this.B(O.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(T.WindowError.UNRESPONSIVE))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(H,ne)=>ne)(H=>this.yb(T.WindowError.PROCESS_GONE,{...H}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(H,ne,V)=>({exitCode:ne,reason:V}))(({exitCode:H,reason:ne})=>this.yb(T.WindowError.LOAD,{reason:ne,exitCode:H}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(H=>H.preventDefault())),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",E.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",E.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(H=>this.Bb(H))),this.B(this.mb.onDidDeleteUntitledWorkspace(H=>this.Ab(H)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(H,ne)=>{const V=await this.xb();ne({cancel:!1,requestHeaders:Object.assign(H.requestHeaders,V)})})}xb(){return this.wb||(this.wb=(0,o.$sq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(F,H){switch(F){case T.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break;case T.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case T.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:F,reason:H?.reason,code:H?.exitCode}),F){case T.WindowError.UNRESPONSIVE:case T.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(F===T.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:ne,checkboxChecked:V}=await this.pb.showMessageBox({type:"warning",buttons:[(0,m.localize)(2461,null),(0,m.localize)(2462,null),(0,m.localize)(2463,null)],message:(0,m.localize)(2464,null),detail:(0,m.localize)(2465,null),checkboxLabel:this.S?.workspace?(0,m.localize)(2466,null):void 0},this.m);if(ne!==2){const ce=ne===0;await this.zb(ce,V)}}else if(F===T.WindowError.PROCESS_GONE){let ne;H?ne=(0,m.localize)(2468,null,H.reason,H.exitCode??"<unknown>"):ne=(0,m.localize)(2467,null);const{response:V,checkboxChecked:ce}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,m.localize)(2469,null):(0,m.localize)(2470,null),(0,m.localize)(2471,null)],message:ne,detail:this.S?.workspace?(0,m.localize)(2472,null):(0,m.localize)(2473,null),checkboxLabel:this.S?.workspace?(0,m.localize)(2474,null):void 0},this.m),oe=V===0;await this.zb(oe,ce)}break}}async zb(F,H){const ne=this.S?.workspace;if(H&&ne)try{const V=this.kb.workspaceStorage(ne);await V.init(),V.delete("memento/workbench.parts.editor"),await V.close()}catch(V){this.u.error(V)}this.P.fire();try{if(F&&this.S){let V,ce;(0,L.$Si)(ne)?V={folderUri:ne.uri}:(0,L.$Xi)(ne)?V={workspaceUri:ne.configPath}:ce=!0,(0,de.$Qb)(await this.tb.open({context:R.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:V?[V]:void 0,forceEmpty:ce,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(F){this.S?.workspace?.id===F.id&&(this.S.workspace=void 0)}Bb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const H=this.Gb();H!==this.W&&(this.W=H,this.Hb(H))}if(!F||F.affectsConfiguration("http.proxy")||F.affectsConfiguration("http.noProxy")){let H=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(H?.indexOf("@")!==-1){const V=u.URI.parse(H),ce=V.authority.indexOf("@");ce!==-1&&(H=V.with({authority:V.authority.substring(ce+1)}).toString())}H?.endsWith("/")&&(H=H.substr(0,H.length-1));const ne=(this.r.getValue("http.noProxy")||[]).map(V=>V.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((H||"").indexOf("@")===-1&&(H!==this.Z||ne!==this.$)){this.Z=H,this.$=ne;const V=H||"",ce=ne?`${ne},<local>`:"<local>";this.u.trace(`Setting proxy to '${V}', bypassing '${ce}'`),this.m.webContents.session.setProxy({proxyRules:V,proxyBypassRules:ce,pacScript:""}),i.default.app.setProxy({proxyRules:V,proxyBypassRules:ce,pacScript:""})}}}addTabbedWindow(F){g.$k&&F.win&&this.m.addTabbedWindow(F.win)}load(F,H=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!H.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),H.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(F,H),this.ub===B.NONE?this.S=F:this.db=F,this.ub=B.NAVIGATING,this.m.loadURL(b.$3g.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.${J.$T?"esm.":""}html`).toString(!0));const ne=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Uh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:F.workspace,reason:H.isReload?T.LoadReason.RELOAD:ne?T.LoadReason.LOAD:T.LoadReason.INITIAL})}Cb(F,H){const ne=(this.S??this.db)?.userEnv;if(ne){const V=(0,$.$Nm)(ne)&&!(0,$.$Nm)(F.userEnv),ce=this.isExtensionDevelopmentHost;(V||ce)&&(F.userEnv={...ne,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),H.disableExtensions!==void 0&&(F["disable-extensions"]=H.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.lb.getWindowSplash(),F.zoomLevel=this.Jb(),F.isCustomZoomLevel=typeof this.ab=="number",F.isCustomZoomLevel&&F.partsSplash&&(F.partsSplash.zoomLevel=F.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),F.perfMarks=(0,l.getMarks)(),this.bb.update(F)}async reload(F){const H=Object.assign({},this.S);H.workspace=await this.Db(H),delete H.filesToOpenOrCreate,delete H.filesToDiff,delete H.filesToMerge,delete H.filesToWait,this.isExtensionDevelopmentHost&&F&&(H.verbose=F.verbose,H.debugId=F.debugId,H.extensionEnvironment=F.extensionEnvironment,H["inspect-extensions"]=F["inspect-extensions"],H["inspect-brk-extensions"]=F["inspect-brk-extensions"],H["extensions-dir"]=F["extensions-dir"]),H.accessibilitySupport=i.default.app.isAccessibilitySupportEnabled(),H.isInitialStartup=!1,H.policiesData=this.gb.serialize(),H.continueOn=this.t.continueOn,H.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},H.logLevel=this.fb.getLogLevel(),H.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(H,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async Db(F){if((0,L.$Xi)(F.workspace)){const H=F.workspace.configPath;if(H.scheme===b.Schemas.file&&!await this.ib.exists(H))return}else if((0,L.$Si)(F.workspace)){const H=F.workspace.uri;if(H.scheme===b.Schemas.file&&!await this.ib.exists(H))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,T.$Ggc)();if(this.isFullScreen){let ne;try{ne=i.default.screen.getDisplayMatching(this.getBounds())}catch{}const V=(0,T.$Ggc)();return{mode:T.WindowMode.Fullscreen,display:ne?ne.id:void 0,width:this.U.width||V.width,height:this.U.height||V.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const F=Object.create(null);let H;if(!g.$k&&this.m.isMaximized()?H=T.WindowMode.Maximized:H=T.WindowMode.Normal,H===T.WindowMode.Maximized?F.mode=T.WindowMode.Maximized:F.mode=T.WindowMode.Normal,H===T.WindowMode.Normal||H===T.WindowMode.Maximized){let ne;H===T.WindowMode.Normal?ne=this.getBounds():ne=this.m.getNormalBounds(),F.x=ne.x,F.y=ne.y,F.width=ne.width,F.height=ne.height}return F.zoomLevel=this.ab,F}Eb(F){(0,l.mark)("code/willRestoreCodeWindowState");let H=!1;if(F){this.ab=F.zoomLevel;try{const ne=i.default.screen.getAllDisplays();H=ne.length>1,F=R.WindowStateValidator.validateWindowState(this.u,F,ne)}catch(ne){this.u.warn(`Unexpected error validating window state: ${ne}
${ne.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[F||(0,T.$Ggc)(),H]}getBounds(){const[F,H]=this.m.getPosition(),[ne,V]=this.m.getSize();return{x:F,y:H,width:ne,height:V}}I(F,H){super.I(F,H),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",E.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let F=(0,w.$pE)(this.r);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Hb(F,H=!0){g.$k||(F==="toggle"&&H&&this.send("vscode:showInfoMessage",(0,m.localize)(2475,null)),F==="hidden"?setTimeout(()=>{this.Ib(F)}):this.Ib(F))}Ib(F){const H=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!H),this.m.autoHideMenuBar=H;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(F){this.ab=F}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(F,H,...ne){this.isReady?this.send(F,...ne):this.ready().then(()=>{H.isCancellationRequested||this.send(F,...ne)})}send(F,...H){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...H)}catch(ne){this.u.warn(`Error sending IPC message to channel '${F}' of window ${this.Q}: ${(0,D.$tj)(ne)}`)}}}updateTouchBar(F){g.$k&&this.Y.forEach((H,ne)=>{const V=F[ne];H.segments=this.Mb(V)})}Kb(){if(g.$k){for(let F=0;F<10;F++){const H=this.Lb();this.Y.push(H)}this.m.setTouchBar(new i.default.TouchBar({items:this.Y}))}}Lb(F=[]){const H=this.Mb(F),ne=new i.default.TouchBar.TouchBarSegmentedControl({segments:H,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",E.CancellationToken.None,{id:ne.segments[V].id,from:"touchbar"})}});return ne}Mb(F=[]){return F.map(ne=>{let V;ne.icon&&!h.ThemeIcon.isThemeIcon(ne.icon)&&ne.icon?.dark?.scheme===b.Schemas.file&&(V=i.default.nativeImage.createFromPath(u.URI.revive(ne.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let ce;return typeof ne.title=="string"?ce=ne.title:ce=ne.title.value,{id:ne.id,label:V?void 0:ce,icon:V}})}matches(F){return this.m?.webContents.id===F.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$9gc=C,e.$9gc=C=ke([re(1,s.$dk),re(2,Q.$6gc),re(3,y.$Egc),re(4,j.$wo),re(5,q.$Ugc),re(6,S.$dl),re(7,n.$ghc),re(8,n.$ehc),re(9,d.$cj),re(10,P.$Pgc),re(11,A.$4gc),re(12,f.$Lgc),re(13,c.$cm),re(14,v.$Mgc),re(15,k.$$gc),re(16,a.$wk),re(17,t.$Ogc),re(18,R.$Rgc),re(19,G.$VR),re(20,x.$Hi)],C)}),define(le[276],ue([0,1,13,3,16,20,19,5,34,51,52,139]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;let m=class extends u.$8gc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,d,v,y,$,S){super(y,$,d,v),this.O=f,this.P=S,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(f){this.q.isDisposed||this.O.isDestroyed()||(this.Q(f),f&&!this.N&&(this.N=!0,this.w({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?g.WindowMode.Maximized:g.WindowMode.Normal})))}Q(f){if(this.m)return;const d=i.BrowserWindow.fromWebContents(this.O);d&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(d,f),d.setMenu(null),(r.$j||r.$l)&&(0,l.$rE)(this.r,f?.titleBarStyle==="hidden"?l.TitlebarStyle.CUSTOM:void 0)&&d.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(f){return this.O.id===f.id}};e.$0gc=m,e.$0gc=m=ke([re(1,D.$Egc),re(2,I.$dk),re(3,E.$cj),re(4,b.$VR),re(5,O.$$gc)],m)}),define(le[277],ue([0,1,13,4,2,11,35,276,6,5,52,29]),function(K,e,i,r,E,D,O,I,b,l,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;let m=class extends E.$Xc{constructor(f,d){super(),this.h=f,this.j=d,this.a=this.B(new r.$oe),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$oe),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$oe),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$oe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(f,d)=>{const v=this.getWindowByWebContents(d.webContents);if(v)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow();else{const y=new E.$Wc;y.add(r.Event.fromNodeEventEmitter(d.webContents,"did-create-window",($,S)=>({browserWindow:$,details:S}))(({browserWindow:$,details:S})=>{const k=this.getWindowByWebContents($.webContents);k&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),k.tryClaimWindow(S.options))})),y.add(r.Event.fromNodeEventEmitter(d,"closed")(()=>y.dispose()))}}),O.$fY.handle("vscode:registerAuxiliaryWindow",async(f,d)=>{const v=this.getWindowByWebContents(f.sender);return v&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=d),f.sender.id})}createWindow(f){const{state:d,overrides:v}=this.n(f);return this.h.invokeFunction(u.$Sgc,d,v,{preload:D.$3g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const d={},v={},y=f.features.split(",");for(const S of y){const[k,s]=S.split("=");switch(k){case"width":d.width=parseInt(s,10);break;case"height":d.height=parseInt(s,10);break;case"left":d.x=parseInt(s,10);break;case"top":d.y=parseInt(s,10);break;case"window-maximized":d.mode=g.WindowMode.Maximized;break;case"window-fullscreen":d.mode=g.WindowMode.Fullscreen;break;case"window-disable-fullscreen":v.disableFullscreen=!0;break;case"window-native-titlebar":v.forceNativeTitlebar=!0;break}}const $=u.WindowStateValidator.validateWindowState(this.j,d)??(0,g.$Hgc)();return this.j.trace("[aux window] using window state",$),{state:$,overrides:v}}registerWindow(f){const d=new E.$Wc,v=this.h.createInstance(I.$0gc,f);this.g.set(v.id,v),d.add((0,E.$Vc)(()=>this.g.delete(v.id))),d.add(v.onDidMaximize(()=>this.a.fire(v))),d.add(v.onDidUnmaximize(()=>this.b.fire(v))),d.add(v.onDidEnterFullScreen(()=>this.c.fire({window:v,fullscreen:!0}))),d.add(v.onDidLeaveFullScreen(()=>this.c.fire({window:v,fullscreen:!1}))),d.add(v.onDidTriggerSystemContextMenu(({x:y,y:$})=>this.f.fire({window:v,x:y,y:$}))),r.Event.once(v.onDidClose)(()=>d.dispose())}getWindowByWebContents(f){const d=this.g.get(f.id);return d?.matches(f)?d:void 0}getFocusedWindow(){const f=i.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,u.$Tgc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Fic=m,e.$Fic=m=ke([re(0,b.$Hi),re(1,l.$dk)],m)}),define(le[90],ue([0,1,13,21,8,4,48,2,11,3,18,7,23,10,6,19,5,64,89,105,30,59,31,53]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,f.$Ii)("workspacesHistoryMainService");let n=class extends I.$Xc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(h,P,w,R,L){super(),this.f=h,this.g=P,this.h=w,this.j=R,this.m=L,this.c=this.B(new D.$oe),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new E.$Gh(800)),this.n()}n(){this.h.when(d.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(h=>this.addRecentlyOpened([{workspace:h.workspace,remoteAuthority:h.window.remoteAuthority}])))}async addRecentlyOpened(h){let P=[],w=[];for(const L of h)if((0,S.$Eib)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(P,L.workspace)&&P.push(L);else if((0,S.$Fib)(L))this.y(P,L.folderUri)||P.push(L);else{const A=this.z(w,L.fileUri),T=L.fileUri.scheme===b.Schemas.file&&o.G.indexOf((0,g.$gh)(L.fileUri))>=0;!A&&!T&&(w.push(L),l.$j&&L.fileUri.scheme===b.Schemas.file&&i.app.addRecentDocument(L.fileUri.fsPath))}const R=await this.r({workspaces:P,files:w});P=R.workspaces,w=R.files,P.length>o.a&&(P.length=o.a),w.length>o.a&&(w.length=o.a),await this.t({workspaces:P,files:w}),this.c.fire(),l.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(h){const P=A=>{const T=this.u(A);for(const j of h)if(g.$ah.isEqual(j,T))return!1;return!0},w=await this.getRecentlyOpened(),R=w.workspaces.filter(P),L=w.files.filter(P);(R.length!==w.workspaces.length||L.length!==w.files.length)&&(await this.t({files:L,workspaces:R}),this.c.fire(),l.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(h){if(h?.confirm){const{response:P}=await this.m.showMessageBox({type:"warning",buttons:[(0,p.localize)(2488,null),(0,p.localize)(2489,null)],message:(0,p.localize)(2490,null),detail:(0,p.localize)(2491,null),cancelId:1});if(P!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(h){const P=new a.$Dc(L=>g.$ah.getComparisonKey(L));if(h?.workspaces)for(const L of h.workspaces)P.set(this.u(L),L);const w=new a.$Dc(L=>g.$ah.getComparisonKey(L));if(h?.files)for(const L of h.files)w.set(this.u(L),L);const R=await this.s();for(const L of R.workspaces){const A=P.get(this.u(L));A?A.label=A.label??L.label:P.set(this.u(L),L)}for(const L of R.files){const A=w.get(this.u(L));A?A.label=A.label??L.label:w.set(this.u(L),L)}return{workspaces:[...P.values()],files:[...w.values()]}}async s(){await this.j.whenReady;let h;const P=this.j.get(o.b,y.StorageScope.APPLICATION);if(typeof P=="string")try{h=JSON.parse(P)}catch(w){this.f.error("Unexpected error parsing opened paths list",w)}return(0,S.$Lib)(h,this.f)}async t(h){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,S.$Mib)(h)),y.StorageScope.APPLICATION,y.StorageTarget.MACHINE)}u(h){return(0,S.$Fib)(h)?h.folderUri:(0,S.$Gib)(h)?h.fileUri:h.workspace.configPath}w(h,P){return!!h.find(w=>(0,S.$Eib)(w)&&w.workspace.id===P.id)}y(h,P){return!!h.find(w=>(0,S.$Fib)(w)&&g.$ah.isEqual(w.folderUri,P))}z(h,P){return!!h.find(w=>g.$ah.isEqual(w.fileUri,P))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){l.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$j)return;const h=[];if(h.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(2492,null),description:(0,p.localize)(2493,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const P=[];for(const L of i.app.getJumpListSettings().removedItems){const A=L.args;if(A){const T=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);T&&P.push(u.URI.parse(T[2]))}}await this.removeRecentlyOpened(P);let w=!1;const R=(0,r.$Jb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const A=(0,S.$Eib)(L)?L.workspace:L.folderUri,{title:T,description:j}=this.L(A,L.label);let G;return u.URI.isUri(A)?G=`--folder-uri "${A.toString()}"`:(w=!0,G=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:T.substr(0,255),description:j.substr(0,255),program:process.execPath,args:G,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&h.push({type:"custom",name:w?(0,p.localize)(2494,null):(0,p.localize)(2495,null),items:R})}h.push({type:"recent"});try{const P=i.app.setJumpList(h);P&&P!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${P}`)}catch(P){this.f.warn("updateWindowsJumpList#setJumpList",P)}}L(h,P){if(P)return{title:(0,O.$cx)(P).name,description:P};if(u.URI.isUri(h))return{title:(0,g.$gh)(h),description:this.M(h)};if(this.g.isUntitledWorkspace(h))return{title:(0,p.localize)(2496,null),description:""};let w=(0,g.$gh)(h.configPath);return w.endsWith(k.$5i)&&(w=w.substr(0,w.length-k.$5i.length-1)),{title:(0,p.localize)(2497,null,w),description:this.M(h.configPath)}}M(h){return h.scheme==="file"?(0,O.$7w)(h.fsPath):h.toString()}async N(){if(!l.$k)return;i.app.clearRecentDocuments();const h=await this.getRecentlyOpened(),P=[];let w=0;for(let L=0;L<h.workspaces.length&&w<o.C;L++){const A=this.u(h.workspaces[L]);if(A.scheme===b.Schemas.file){const T=(0,g.$0g)(A);await m.Promises.exists(T)&&(P.push(T),w++)}}const R=[];for(let L=0;L<h.files.length&&w<o.D;L++){const A=this.u(h.files[L]);if(A.scheme===b.Schemas.file){const T=(0,g.$0g)(A);if(o.G.includes((0,g.$gh)(A))||P.includes(T))continue;await m.Promises.exists(T)&&(R.push(T),w++)}}R.reverse().forEach(L=>i.app.addRecentDocument(L)),P.reverse().forEach(L=>i.app.addRecentDocument(L))}};e.$Shc=n,e.$Shc=n=o=ke([re(0,v.$dk),re(1,s.$4gc),re(2,d.$$gc),re(3,$.$ghc),re(4,t.$Mgc)],n)}),define(le[278],ue([0,1,13,8,22,48,3,7,10,85,16,20,19,5,201,66,28,34,24,50,51,29,90,2]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0,b=Ie(b);const n="menu";let c=class extends t.$Xc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(w,R,L,A,T,j,G,q,Q,de,x,J){super(),this.t=w,this.u=R,this.w=L,this.y=A,this.z=T,this.C=j,this.D=G,this.F=q,this.G=Q,this.H=de,this.I=x,this.J=J,this.s=Object.create(null),this.h=new r.$Uh(()=>this.R(),0),this.j=new r.$Uh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(O.$k||(0,k.$rE)(R))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const w=this.D.getItem(o.a);w&&(w.menus&&(this.n=w.menus),w.keybindings&&(this.r=w.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(j,G,q)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:s.OpenContext.MENU,contextWindowId:G?.id})},this.s["workbench.action.newWindow"]=(j,G,q)=>this.w.openEmptyWindow({context:s.OpenContext.MENU,contextWindowId:G?.id}),this.s["workbench.action.files.openFileFolder"]=(j,G,q)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.files.openFolder"]=(j,G,q)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.openWorkspace"]=(j,G,q)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const w=this.I.youTubeUrl;w&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(w,"openYouTubeUrl"));const R=this.I.requestFeatureUrl;R&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(R,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const A=this.I.licenseUrl;A&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(O.$x){const j=A.indexOf("?")>0?"&":"?";this.ob(`${A}${j}lang=${O.$x}`,"openLicenseUrl")}else this.ob(A,"openLicenseUrl")});const T=this.I.privacyStatementUrl;T&&A&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(T,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(w=>this.S(w))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const w=this.u.getValue("window.enableMenuBarMnemonics");return typeof w!="boolean"?!0:w}get P(){if(!O.$k)return!1;const w=this.u.getValue("window.nativeTabs");return typeof w!="boolean"?!1:w}updateMenu(w,R){this.n=w.menus,this.r=w.keybindings,this.D.setItem(o.a,w),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(w){O.$k&&(w.oldCount===0&&w.newCount>0||w.oldCount>0&&w.newCount===0)&&(this.f=w.newCount===0,this.Q())}U(){if(!O.$k)return;const w=i.BrowserWindow.getFocusedWindow();this.g=!w||!!this.J.getWindowByWebContents(w.webContents),this.Q()}W(){const w=i.Menu.getApplicationMenu();if(w&&this.m.push(w),Object.keys(this.n).length===0){this.X(O.$k?new i.Menu:null);return}const R=new i.Menu;let L;if(O.$k){const T=new i.Menu;L=new i.MenuItem({label:this.I.nameShort,submenu:T}),this.Y(T),R.append(L)}if(O.$k&&!this.c){this.c=!0;const T=new i.Menu;T.append(new i.MenuItem({label:this.qb(b.localize(1966,null)),click:()=>this.w.openEmptyWindow({context:s.OpenContext.DOCK})})),i.app.dock.setMenu(T)}if(this.$("File")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1967,null)),submenu:T});this.bb(T,"File"),R.append(j)}if(this.$("Edit")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1968,null)),submenu:T});this.bb(T,"Edit"),R.append(j)}if(this.$("Selection")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1969,null)),submenu:T});this.bb(T,"Selection"),R.append(j)}if(this.$("View")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1970,null)),submenu:T});this.bb(T,"View"),R.append(j)}if(this.$("Go")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1971,null)),submenu:T});this.bb(T,"Go"),R.append(j)}if(this.$("Run")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1972,null)),submenu:T});this.bb(T,"Run"),R.append(j)}if(this.$("Terminal")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1973,null)),submenu:T});this.bb(T,"Terminal"),R.append(j)}let A;if(this.$("Window")){const T=new i.Menu;A=new i.MenuItem({label:this.qb(b.localize(1974,null)),submenu:T,role:"window"}),this.hb(T)}if(A&&R.append(A),this.$("Help")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1975,null)),submenu:T,role:"help"});this.bb(T,"Help"),R.append(j)}R.items&&R.items.length>0?this.X(R):this.X(null),this.j.schedule()}X(w){if(i.Menu.setApplicationMenu(w),w)for(const R of this.J.getWindows())R.win?.setMenu(null)}Y(w){const R=this.jb(b.localize(1976,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let A;if(this.$("Preferences")){const J=new i.Menu;this.bb(J,"Preferences"),A=new i.MenuItem({label:this.qb(b.localize(1977,null)),submenu:J})}const T=new i.Menu,j=new i.MenuItem({label:b.localize(1978,null),role:"services",submenu:T}),G=new i.MenuItem({label:b.localize(1979,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),q=new i.MenuItem({label:b.localize(1980,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new i.MenuItem({label:b.localize(1981,null),role:"unhide"}),de=new i.MenuItem(this.nb("workbench.action.quit",{label:b.localize(1982,null,this.I.nameLong),click:async(J,B,_)=>{const C=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||C?.win?.isMinimized())&&await this.Z(_)&&this.H.quit(void 0)}})),x=[R];x.push(...L),A&&x.push(h(),A),x.push(h(),j,h(),G,q,Q,h(),de),x.forEach(J=>w.append(J))}async Z(w){if(this.w.getWindowCount()===0)return!0;const R=this.u.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.fb(w)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[b.localize(1983,null),b.localize(1984,null)],message:b.localize(1985,null)});return L===0}return!0}$(w){if(!O.$k&&!(0,k.$rE)(this.u))return!1;switch(w){case"File":case"Help":if(O.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[w];case"Window":if(O.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[w]}}ab(w,R){R.forEach(L=>{if((0,f.$Ohc)(L))w.append(h());else if((0,f.$Nhc)(L)){const A=new i.Menu,T=new i.MenuItem({label:this.qb(L.label),submenu:A});this.ab(A,L.submenu.items),w.append(T)}else(0,f.$Phc)(L)?w.append(this.db(L)):(0,f.$Qhc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(w),O.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?w.append(new i.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):w.append(this.jb(L.label,L.id,!1,L.checked)):w.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):w.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(w,R){this.n&&this.n[R]&&this.ab(w,this.n[R].items)}cb(w){const R=this.ib();R.length&&(R.forEach(L=>w.append(L)),w.append(h()))}db(w){const R=I.URI.revive(w.uri),L=w.id,A=L==="openRecentFile"?{fileUri:R}:L==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new i.MenuItem(this.nb(L,{label:w.label,click:async(T,j,G)=>{const q=this.eb(G);(await this.w.open({context:s.OpenContext.MENU,cli:this.y.args,urisToOpen:[A],forceNewWindow:q,gotoLineMode:!1,remoteAuthority:w.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([R])}},!1))}eb(w){return!!(w&&(!O.$k&&(w.ctrlKey||w.shiftKey)||O.$k&&(w.metaKey||w.altKey)))}fb(w){return!!(w.triggeredByAccelerator||w.altKey||w.ctrlKey||w.metaKey||w.shiftKey)}gb(w,R,L){const A={label:this.qb(w),role:L,enabled:!0};return new i.MenuItem(this.mb(R,A))}hb(w){const R=new i.MenuItem({label:b.localize(1986,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new i.MenuItem({label:b.localize(1987,null),role:"zoom",enabled:this.w.getWindowCount()>0}),A=new i.MenuItem({label:b.localize(1988,null),role:"front",enabled:this.w.getWindowCount()>0}),T=this.jb(b.localize(1989,null),"workbench.action.switchWindow"),j=[];this.P&&(j.push(h()),j.push(this.jb(b.localize(1990,null),"workbench.action.newWindowTab")),j.push(this.gb(b.localize(1991,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.gb(b.localize(1992,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.gb(b.localize(1993,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.gb(b.localize(1994,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,L,h(),T,...j,h(),A].forEach(G=>w.append(G))}ib(){switch(this.t.state.type){case S.StateType.Idle:return[new i.MenuItem({label:this.qb(b.localize(1995,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case S.StateType.CheckingForUpdates:return[new i.MenuItem({label:b.localize(1996,null),enabled:!1})];case S.StateType.AvailableForDownload:return[new i.MenuItem({label:this.qb(b.localize(1997,null)),click:()=>{this.t.downloadUpdate()}})];case S.StateType.Downloading:return[new i.MenuItem({label:b.localize(1998,null),enabled:!1})];case S.StateType.Downloaded:return O.$k?[]:[new i.MenuItem({label:this.qb(b.localize(1999,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case S.StateType.Updating:return[new i.MenuItem({label:b.localize(2e3,null),enabled:!1})];case S.StateType.Ready:return[new i.MenuItem({label:this.qb(b.localize(2001,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(w,R,L,A){const T=this.qb(w),j=typeof R=="function"?R:(x,J,B)=>{const _=x?x.userSettingsLabel:null;let C=R;Array.isArray(R)&&(C=this.eb(B)?R[1]:R[0]),_&&B.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:_}):this.lb({type:"commandId",commandId:C})},G=typeof L=="boolean"?L:this.w.getWindowCount()>0,q=typeof A=="boolean"?A:!1,Q={label:T,click:j,enabled:G};q&&(Q.type="checkbox",Q.checked=q);let de;return typeof R=="string"?de=R:Array.isArray(R)&&(de=R[0]),O.$k&&(de==="editor.action.clipboardCutAction"?Q.role="cut":de==="editor.action.clipboardCopyAction"?Q.role="copy":de==="editor.action.clipboardPasteAction"&&(Q.role="paste"),de==="undo"?Q.click=this.kb(j,{inDevTools:x=>x.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):de==="redo"?Q.click=this.kb(j,{inDevTools:x=>x.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):de==="editor.action.selectAll"&&(Q.click=this.kb(j,{inDevTools:x=>x.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.mb(de,Q))}kb(w,R){return(L,A,T)=>{const j=i.BrowserWindow.getFocusedWindow();if(!j)return R.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return R.inDevTools(j.webContents.devToolsWebContents);w(L,A||j,T)}}lb(w){let R=i.BrowserWindow.getFocusedWindow();if(R){const A=this.J.getWindowByWebContents(R.webContents);A&&(R=this.w.getWindowById(A.parentId)?.win??null)}if(!R){const A=this.w.getLastActiveWindow();A?.win?.isMinimized()&&(R=A.win)}const L=R?this.w.getWindowById(R.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",w),O.$k&&!this.y.isBuilt&&!L.isReady&&(w.type==="commandId"&&w.commandId==="workbench.action.toggleDevTools"||w.type!=="commandId"&&w.userSettingsLabel==="alt+cmd+i"))return!1;if(w.type==="commandId"){const A={id:w.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",E.CancellationToken.None,A)}else{const A={userSettingsLabel:w.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",E.CancellationToken.None,A)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",w),!1}mb(w,R){const L=typeof w=="string"?this.r[w]:void 0;if(L?.label){if(L.isNative!==!1)R.accelerator=L.label,R.userSettingsLabel=L.userSettingsLabel;else if(typeof R.label=="string"){const A=R.label.indexOf("[");A>=0?R.label=`${R.label.substr(0,A)} [${L.label}]`:R.label=`${R.label} [${L.label}]`}}else R.accelerator=void 0;return R}nb(w,R,L=!R.accelerator){L&&(R=this.mb(w,R));const A=R.click;return R.click=(T,j,G)=>{this.pb(w),A?.(T,j,G)},R}ob(w,R){this.H.openExternal(void 0,w),this.pb(R)}pb(w){this.z.publicLog2("workbenchActionExecuted",{id:w,from:n})}qb(w){return(0,D.$_w)(w,!this.O)}};e.$Thc=c,e.$Thc=c=o=ke([re(0,S.$eZ),re(1,g.$cj),re(2,s.$Rgc),re(3,u.$Egc),re(4,$.$cm),re(5,a.$Rhc),re(6,y.$VR),re(7,m.$$gc),re(8,p.$dk),re(9,d.$Ehc),re(10,v.$wk),re(11,l.$Dhc)],c);function h(){return new i.MenuItem({type:"separator"})}}),define(le[279],ue([0,1,6,19,5,278,2]),function(K,e,i,r,E,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=e.$Uhc=void 0,e.$Uhc=(0,i.$Ii)("menubarMainService");let I=class extends O.$Xc{constructor(l,g,u){super(),this.b=l,this.c=g,this.f=u,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$Thc))}async updateMenubar(l,g){this.f.trace("menubarService#updateMenubar",l),(await this.a).updateMenu(g,l)}};e.$Vhc=I,e.$Vhc=I=ke([re(0,i.$Hi),re(1,r.$$gc),re(2,E.$dk)],I)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[280],ue([0,1,26,13,109,27,21,22,39,4,32,48,2,11,9,72,3,37,18,12,7,10,71,16,53,20,14,6,19,5,63,74,75,34,51,139,29,136,271,30,106,90,59,52,77,40,58,73,85,86]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t,o,n,c,h,P,w,R,L,A,T,j,G,q,Q,de,x,J,B,_,C,W,F,H,ne,V,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0,i=Ie(i),R=Ve(R);function oe(Z){return(0,x.$Xi)(Z?.workspace)}function Y(Z){return(0,x.$Si)(Z?.workspace)}let M=class extends m.$Xc{constructor(U,N,ie,X,z,te,ae,me,be,ye,Fe,xe,Ae,$e,ee,he,fe,pe,ve,je,Oe,Re){super(),this.s=U,this.t=N,this.u=ie,this.w=X,this.z=z,this.C=te,this.D=ae,this.F=me,this.G=be,this.H=ye,this.I=Fe,this.J=xe,this.L=Ae,this.M=$e,this.N=ee,this.O=he,this.P=fe,this.Q=pe,this.R=ve,this.S=je,this.U=Oe,this.W=Re,this.a=this.B(new l.$oe),this.onDidOpenWindow=this.a.event,this.b=this.B(new l.$oe),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new l.$oe),this.onDidDestroyWindow=this.c.event,this.f=this.B(new l.$oe),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new l.$oe),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new l.$oe),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new l.$oe),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new l.$oe),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new de.$gic(this,this.D,this.I,this.z,this.L)),this.X()}X(){this.B(this.N.onDidEnterWorkspace(U=>this.b.fire(U.window))),this.B(this.onDidSignalReadyWindow(U=>{if(U.config?.extensionDevelopmentPath||U.config?.extensionTestsPath){const N=new m.$Wc;if(N.add(l.Event.any(U.onDidClose,U.onDidDestroy)(()=>N.dispose())),U.config.extensionDevelopmentPath)for(const ie of U.config.extensionDevelopmentPath)N.add(this.R.addValidFileRoot(ie));U.config.extensionTestsPath&&N.add(this.R.addValidFileRoot(U.config.extensionTestsPath))}}))}openEmptyWindow(U,N){const ie=this.G.args,X=N?.remoteAuthority||void 0,z=!0,te=N?.forceReuseWindow,ae=!te;return this.open({...U,cli:ie,forceEmpty:z,forceNewWindow:ae,forceReuseWindow:te,remoteAuthority:X,forceTempProfile:N?.forceTempProfile,forceProfile:N?.forceProfile})}openExistingWindow(U,N){U.focus(),this.Y(N,[U])}async open(U){this.z.trace("windowsManager#open"),U.addMode&&(U.initialStartup||!this.getLastActiveWindow())&&(U.addMode=!1);const N=[],ie=[],X=[],z=[],te=[];let ae,me=0;const be=await this.eb(U);this.z.trace("windowsManager#open pathsToOpen",be);for(const $e of be)Y($e)?U.addMode?N.push($e):ie.push($e):oe($e)?X.push($e):$e.fileUri?(ae||(ae={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:$e.remoteAuthority}),ae.filesToOpenOrCreate.push($e)):$e.backupPath?te.push({backupFolder:(0,f.$qc)($e.backupPath),remoteAuthority:$e.remoteAuthority}):me++;U.diffMode&&ae&&ae.filesToOpenOrCreate.length>=2&&(ae.filesToDiff=ae.filesToOpenOrCreate.slice(0,2),ae.filesToOpenOrCreate=[]),U.mergeMode&&ae&&ae.filesToOpenOrCreate.length===4&&(ae.filesToMerge=ae.filesToOpenOrCreate.slice(0,4),ae.filesToOpenOrCreate=[],ae.filesToDiff=[]),ae&&U.waitMarkerFileURI&&(ae.filesToWait={paths:(0,O.$Jb)([...ae.filesToDiff,ae.filesToMerge[3],...ae.filesToOpenOrCreate]),waitMarkerFileUri:U.waitMarkerFileURI}),U.initialStartup?(z.push(...this.N.getUntitledWorkspaces()),X.push(...z),te.push(...this.J.getEmptyWindowBackups())):te.length=0;const{windows:ye,filesOpenedInWindow:Fe}=await this.Z(U,X,ie,te,me,ae,N);if(this.z.trace(`windowsManager#open used window count ${ye.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${ie.length}, emptyToRestore: ${te.length}, emptyToOpen: ${me})`),ye.length>1)if(Fe)Fe.focus();else{const $e=this.r.state.lastActiveWindow&&!U.forceEmpty&&!U.cli._.length&&!U.cli["file-uri"]&&!U.cli["folder-uri"]&&!(U.urisToOpen&&U.urisToOpen.length);let ee=!0,he=!0;if($e){const fe=ye.filter(pe=>this.r.state.lastActiveWindow&&pe.backupPath===this.r.state.lastActiveWindow.backupPath);fe.length&&(fe[0].focus(),ee=!1,he=!1)}if(ee)for(let fe=ye.length-1;fe>=0;fe--){const pe=ye[fe];if(!(pe.openedWorkspace&&z.some(ve=>pe.openedWorkspace&&ve.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&te.some(ve=>pe.backupPath&&ve.backupFolder===(0,f.$qc)(pe.backupPath)))){pe.focus(),he=!1;break}}he&&ye[ye.length-1].focus()}const xe=ae&&ae.filesToDiff.length>0,Ae=ae&&ae.filesToMerge.length>0;if(!ye.some($e=>$e.isExtensionDevelopmentHost)&&!xe&&!Ae&&!U.noRecentEntry){const $e=[];for(const ee of be)oe(ee)&&!ee.transient?$e.push({label:ee.label,workspace:ee.workspace,remoteAuthority:ee.remoteAuthority}):Y(ee)?$e.push({label:ee.label,folderUri:ee.workspace.uri,remoteAuthority:ee.remoteAuthority}):ee.fileUri&&$e.push({label:ee.label,fileUri:ee.fileUri,remoteAuthority:ee.remoteAuthority});this.M.addRecentlyOpened($e)}return this.Y(U,ye),ye}Y(U,N){const ie=U.waitMarkerFileURI;U.context===q.OpenContext.CLI&&ie&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.Q.del(ie)}catch{}})()}async Z(U,N,ie,X,z,te,ae){const me=[];let be;function ye(fe,pe){me.push(fe),pe&&(be=fe,te=void 0)}let{openFolderInNewWindow:Fe,openFilesInNewWindow:xe}=this.qb(U);if(!U.initialStartup&&ae.length>0){const fe=ae[0].remoteAuthority,pe=this.wb(fe);pe&&ye(this.bb(pe,ae.map(ve=>ve.workspace.uri)))}const Ae=ie.length+N.length+X.length;if(te&&Ae===0){const fe=te.filesToOpenOrCreate[0]||te.filesToDiff[0]||te.filesToMerge[3],pe=this.getWindows().filter(je=>te&&(0,$.$oh)(je.remoteAuthority,te.remoteAuthority));let ve;fe?.fileUri&&!xe&&((U.context===q.OpenContext.DESKTOP||U.context===q.OpenContext.CLI||U.context===q.OpenContext.DOCK||U.context===q.OpenContext.LINK)&&(ve=await(0,Q.$Wgc)(pe,fe.fileUri,async je=>je.configPath.scheme===p.Schemas.file?this.N.resolveLocalWorkspace(je.configPath):void 0)),ve||(ve=this.xb(pe))),ve?(0,x.$Xi)(ve.openedWorkspace)?N.push({workspace:ve.openedWorkspace,remoteAuthority:ve.remoteAuthority}):(0,x.$Si)(ve.openedWorkspace)?ie.push({workspace:ve.openedWorkspace,remoteAuthority:ve.remoteAuthority}):ye(this.$(U,ve,te),!0):ye(await this.rb({userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,filesToOpen:te,forceNewWindow:!0,remoteAuthority:te.remoteAuthority,forceNewTabbedWindow:U.forceNewTabbedWindow,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile}),!0)}const $e=(0,O.$Ob)(N,fe=>fe.workspace.id);if($e.length>0){const fe=(0,O.$Jb)($e.map(pe=>(0,Q.$Xgc)(this.getWindows(),pe.workspace.configPath)));if(fe.length>0){const pe=fe[0],ve=(0,$.$oh)(te?.remoteAuthority,pe.remoteAuthority)?te:void 0;ye(this.$(U,pe,ve),!!ve),Fe=!0}for(const pe of $e){if(fe.some(Oe=>Oe.openedWorkspace&&Oe.openedWorkspace.id===pe.workspace.id))continue;const ve=pe.remoteAuthority,je=(0,$.$oh)(te?.remoteAuthority,ve)?te:void 0;ye(await this.db(U,pe,Fe,je),!!je),Fe=!0}}const ee=(0,O.$Ob)(ie,fe=>$.$ah.getComparisonKey(fe.workspace.uri));if(ee.length>0){const fe=(0,O.$Jb)(ee.map(pe=>(0,Q.$Xgc)(this.getWindows(),pe.workspace.uri)));if(fe.length>0){const pe=fe[0],ve=(0,$.$oh)(te?.remoteAuthority,pe.remoteAuthority)?te:void 0;ye(this.$(U,pe,ve),!!ve),Fe=!0}for(const pe of ee){if(fe.some(Oe=>(0,x.$Si)(Oe.openedWorkspace)&&$.$ah.isEqual(Oe.openedWorkspace.uri,pe.workspace.uri)))continue;const ve=pe.remoteAuthority,je=(0,$.$oh)(te?.remoteAuthority,ve)?te:void 0;ye(await this.db(U,pe,Fe,je),!!je),Fe=!0}}const he=(0,O.$Ob)(X,fe=>fe.backupFolder);if(he.length>0)for(const fe of he){const pe=fe.remoteAuthority,ve=(0,$.$oh)(te?.remoteAuthority,pe)?te:void 0;ye(await this.cb(U,!0,pe,ve,fe),!!ve),Fe=!0}if(me.length===0||te){te&&!z&&z++;const fe=te?te.remoteAuthority:U.remoteAuthority;for(let pe=0;pe<z;pe++)ye(await this.cb(U,Fe,fe,te),!!te),Fe=!0}return{windows:(0,O.$Ob)(me),filesOpenedInWindow:be}}$(U,N,ie){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:ie}),this.ab(N);const X={filesToOpenOrCreate:ie?.filesToOpenOrCreate,filesToDiff:ie?.filesToDiff,filesToMerge:ie?.filesToMerge,filesToWait:ie?.filesToWait,termProgram:U?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",I.CancellationToken.None,X),N}ab(U){let N=U;const ie=r.BrowserWindow.getFocusedWindow();if(ie&&ie.id!==U.id){const X=this.U.getWindowByWebContents(ie.webContents);X&&X.parentId===U.id&&(N=X)}N.focus()}bb(U,N){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),U.focus();const ie={foldersToAdd:N};return U.sendWhenReady("vscode:addFolders",I.CancellationToken.None,ie),U}cb(U,N,ie,X,z){this.z.trace("windowsManager#doOpenEmpty",{restore:!!z,remoteAuthority:ie,filesToOpen:X,forceNewWindow:N});let te;return!N&&typeof U.contextWindowId=="number"&&(te=this.getWindowById(U.contextWindowId)),this.rb({userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,remoteAuthority:ie,forceNewWindow:N,forceNewTabbedWindow:U.forceNewTabbedWindow,filesToOpen:X,windowToUse:te,emptyWindowBackupInfo:z,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}db(U,N,ie,X,z){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:X}),!ie&&!z&&typeof U.contextWindowId=="number"&&(z=this.getWindowById(U.contextWindowId)),this.rb({workspace:N.workspace,userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:ie,forceNewTabbedWindow:U.forceNewTabbedWindow,filesToOpen:X,windowToUse:z,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async eb(U){let N,ie=!1,X=!1;if(U.urisToOpen&&U.urisToOpen.length>0?(N=await this.fb(U),ie=!0):U.forceEmpty?N=[Object.create(null)]:U.cli._.length||U.cli["folder-uri"]||U.cli["file-uri"]?(N=await this.gb(U.cli),N.length===0&&N.push(Object.create(null)),ie=!0):(N=await this.ib(),N.length===0&&N.push(Object.create(null)),X=!0),!U.addMode&&ie){const z=N.filter(te=>Y(te));if(z.length>1){const te=z[0].remoteAuthority;if(z.every(ae=>(0,$.$oh)(ae.remoteAuthority,te))){const ae=await this.N.createUntitledWorkspace(z.map(me=>({uri:me.workspace.uri})));N.push({workspace:ae,remoteAuthority:te}),N=N.filter(me=>!Y(me))}}}if(U.initialStartup&&!X&&this.L.getValue("window")?.restoreWindows==="preserve"){const z=await this.ib();N.unshift(...z.filter(te=>oe(te)||Y(te)||te.backupPath))}return N}async fb(U){const N={gotoLineMode:U.gotoLineMode,remoteAuthority:U.remoteAuthority},ie=await Promise.all((0,O.$Jb)(U.urisToOpen||[]).map(async X=>{const z=await this.kb(X,N);if(z)return z.label=X.label,z;const te=this.mb(X);this.P.showMessageBox({type:"info",buttons:[(0,s.localize)(2476,null)],message:te.scheme===p.Schemas.file?(0,s.localize)(2477,null):(0,s.localize)(2478,null),detail:te.scheme===p.Schemas.file?(0,s.localize)(2479,null,(0,u.$6w)(te,{os:v.OS,tildify:this.G})):(0,s.localize)(2480,null,te.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,O.$Jb)(ie)}async gb(U){const N=[],ie={ignoreFileNotFound:!0,gotoLineMode:U.goto,remoteAuthority:U.remote||void 0,forceOpenWorkspaceAsFile:U.diff&&U._.length===2||U.merge&&U._.length===4},X=U["folder-uri"];if(X){const ae=await Promise.all(X.map(me=>{const be=this.hb(me);if(be)return this.kb({folderUri:be},ie)}));N.push(...(0,O.$Jb)(ae))}const z=U["file-uri"];if(z){const ae=await Promise.all(z.map(me=>{const be=this.hb(me);if(be)return this.kb((0,x.$bj)(me)?{workspaceUri:be}:{fileUri:be},ie)}));N.push(...(0,O.$Jb)(ae))}const te=await Promise.all(U._.map(ae=>ie.remoteAuthority?this.pb(ae,ie):this.nb(ae,ie)));return N.push(...(0,O.$Jb)(te)),N}hb(U){try{const N=k.URI.parse(U);if(!N.scheme){this.z.error(`Invalid URI input string, scheme missing: ${U}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.z.error(`Invalid URI input string: ${U}, ${N.message}`)}}async ib(){const U=this.jb();switch(U){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];U!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const ie=await Promise.all(N.map(async X=>{if(X.workspace){const z=await this.kb({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});if(oe(z))return z}else if(X.folderUri){const z=await this.kb({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});if(Y(z))return z}else if(U!=="folders"&&X.backupPath)return{backupPath:X.backupPath,remoteAuthority:X.remoteAuthority}}));return(0,O.$Jb)(ie)}}}jb(){let U;return this.I.wasRestarted?U="all":(U=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(U)||(U="all")),U}async kb(U,N=Object.create(null)){const ie=this.mb(U);return ie.scheme===p.Schemas.file?((0,j.$oE)(U)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.nb(ie.fsPath,N)):this.lb(U,N)}lb(U,N){let ie=this.mb(U);const X=(0,A.$kn)(ie)||N.remoteAuthority;if(ie=(0,$.$qh)((0,$.$kh)(ie)),(0,j.$oE)(U)){if(N.gotoLineMode){const{path:z,line:te,column:ae}=(0,g.$Pg)(ie.path);return{fileUri:ie.with({path:z}),options:{selection:te?{startLineNumber:te,startColumn:ae||1}:void 0},remoteAuthority:X}}return{fileUri:ie,remoteAuthority:X}}else if((0,j.$mE)(U))return{workspace:(0,J.$1gc)(ie),remoteAuthority:X};return{workspace:(0,J.$2gc)(ie),remoteAuthority:X}}mb(U){return(0,j.$mE)(U)?U.workspaceUri:(0,j.$nE)(U)?U.folderUri:U.fileUri}async nb(U,N,ie){let X,z;N.gotoLineMode&&({path:U,line:X,column:z}=(0,g.$Pg)(U)),U=(0,g.$Jg)((0,f.$kc)(U),(0,y.cwd)());try{const te=await i.promises.stat(U);if(te.isFile()){if(!N.forceOpenWorkspaceAsFile){const ae=await this.N.resolveLocalWorkspace(k.URI.file(U));if(ae)return ae.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:ae.id,configPath:ae.configPath},type:c.FileType.File,exists:!0,remoteAuthority:ae.remoteAuthority,transient:ae.transient}}return{fileUri:k.URI.file(U),type:c.FileType.File,exists:!0,options:{selection:X?{startLineNumber:X,startColumn:z||1}:void 0}}}else{if(te.isDirectory())return{workspace:(0,J.$2gc)(k.URI.file(U),te),type:c.FileType.Directory,exists:!0};if(!v.$j&&U==="/dev/null")return{fileUri:k.URI.file(U),type:c.FileType.File,exists:!0}}}catch(te){if(te.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!ie)return this.ob(U,N);const ae=k.URI.file(U);if(this.M.removeRecentlyOpened([ae]),N.ignoreFileNotFound)return{fileUri:ae,type:c.FileType.File,exists:!1}}}async ob(U,N){const ie=k.URI.file(U),{response:X,checkboxChecked:z}=await this.P.showMessageBox({type:"warning",buttons:[(0,s.localize)(2481,null),(0,s.localize)(2482,null),(0,s.localize)(2483,null)],message:(0,s.localize)(2484,null,ie.authority),detail:(0,s.localize)(2485,null,(0,u.$6w)(ie,{os:v.OS,tildify:this.G})),checkboxLabel:(0,s.localize)(2486,null,ie.authority),cancelId:1});if(X===0){if((0,E.addUNCHostToAllowlist)(ie.authority),z){const te={channel:"vscode:configureAllowedUNCHost",args:ie.authority};this.sendToFocused(te.channel,te.args),this.sendToOpeningWindow(te.channel,te.args)}return this.nb(U,N,!0)}if(X===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.ob(U,N)}pb(U,N){const ie=U.charCodeAt(0),X=N.remoteAuthority;let z,te;N.gotoLineMode&&({path:U,line:z,column:te}=(0,g.$Pg)(U)),ie!==b.CharCode.Slash&&((0,g.$Ig)(ie)&&U.charCodeAt(U.charCodeAt(1))===b.CharCode.Colon&&(U=(0,g.$Bg)(U)),U=`/${U}`);const ae=k.URI.from({scheme:p.Schemas.vscodeRemote,authority:X,path:U});if(U.charCodeAt(U.length-1)!==b.CharCode.Slash){if((0,x.$bj)(U))return N.forceOpenWorkspaceAsFile?{fileUri:ae,options:{selection:z?{startLineNumber:z,startColumn:te||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,J.$1gc)(ae),remoteAuthority:X};if(N.gotoLineMode||f.$jc.basename(U).indexOf(".")!==-1)return{fileUri:ae,options:{selection:z?{startLineNumber:z,startColumn:te||1}:void 0},remoteAuthority:X}}return{workspace:(0,J.$2gc)(ae),remoteAuthority:X}}qb(U){const N=this.L.getValue("window"),ie=N?.openFoldersInNewWindow||"default",X=N?.openFilesInNewWindow||"off";let z=(U.preferNewWindow||U.forceNewWindow)&&!U.forceReuseWindow;!U.forceNewWindow&&!U.forceReuseWindow&&(ie==="on"||ie==="off")&&(z=ie==="on");let te=!1;return U.forceNewWindow||U.forceReuseWindow?te=!!U.forceNewWindow&&!U.forceReuseWindow:(v.$k?U.context===q.OpenContext.DOCK&&(te=!0):U.context!==q.OpenContext.DIALOG&&U.context!==q.OpenContext.MENU&&!(U.userEnv&&U.userEnv.TERM_PROGRAM==="vscode")&&(te=!0),!U.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(te=X==="on")),{openFolderInNewWindow:!!z,openFilesInNewWindow:te}}async openExtensionDevelopmentHostWindow(U,N){const ie=(0,Q.$Ygc)(this.getWindows(),U);if(ie)return this.I.reload(ie,N.cli),ie.focus(),[ie];let X=N.cli["folder-uri"]||[],z=N.cli["file-uri"]||[],te=N.cli._;if(!te.length&&!X.length&&!z.length&&!N.cli.extensionTestsPath){const be=this.r.state.lastPluginDevelopmentHostWindow,ye=be?.workspace??be?.folderUri;ye&&(k.URI.isUri(ye)?ye.scheme===p.Schemas.file?te=[ye.fsPath]:X=[ye.toString()]:ye.configPath.scheme===p.Schemas.file?te=[(0,$.$0g)(ye.configPath)]:z=[ye.configPath.toString()])}let ae=N.remoteAuthority;for(const be of U)if(be.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ye=k.URI.parse(be),Fe=(0,A.$kn)(ye);Fe&&(ae?(0,$.$oh)(Fe,ae)||this.z.error("more than one extension development path authority"):ae=Fe)}te=te.filter(be=>{const ye=k.URI.file(be);return(0,Q.$Xgc)(this.getWindows(),ye)?!1:(0,$.$oh)((0,A.$kn)(ye),ae)}),X=X.filter(be=>{const ye=this.hb(be);return ye&&(0,Q.$Xgc)(this.getWindows(),ye)?!1:ye?(0,$.$oh)((0,A.$kn)(ye),ae):!1}),z=z.filter(be=>{const ye=this.hb(be);return ye&&(0,Q.$Xgc)(this.getWindows(),ye)?!1:ye?(0,$.$oh)((0,A.$kn)(ye),ae):!1}),N.cli._=te,N.cli["folder-uri"]=X,N.cli["file-uri"]=z;const me={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!te.length&&!X.length&&!z.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:ae,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(me)}async rb(U){const N=this.L.getValue("window"),ie=this.getLastActiveWindow(),z=(N?.newWindowProfile?this.H.profiles.find(me=>me.name===N.newWindowProfile):void 0)??ie?.profile??this.H.defaultProfile;let te;!U.forceNewWindow&&!U.forceNewTabbedWindow&&(te=U.windowToUse||ie,te&&te.focus());const ae={...this.G.args,...U.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:U.emptyWindowBackupInfo?(0,f.$mc)(this.G.backupHome,U.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:z},homeDir:this.G.userHome.with({scheme:p.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:p.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:U.remoteAuthority,workspace:U.workspace,userEnv:{...this.w,...U.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:U.filesToOpen?.filesToOpenOrCreate,filesToDiff:U.filesToOpen?.filesToDiff,filesToMerge:U.filesToOpen?.filesToMerge,filesToWait:U.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:p.Schemas.file}).fsPath,product:R.default,isInitialStartup:U.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn,cssModules:this.W.isEnabled?await this.W.getCssModules():void 0};if(te){const me=te.config;!ae.extensionDevelopmentPath&&me?.extensionDevelopmentPath&&(ae.extensionDevelopmentPath=me.extensionDevelopmentPath,ae.extensionDevelopmentKind=me.extensionDevelopmentKind,ae["enable-proposed-api"]=me["enable-proposed-api"],ae.verbose=me.verbose,ae["inspect-extensions"]=me["inspect-extensions"],ae["inspect-brk-extensions"]=me["inspect-brk-extensions"],ae.debugId=me.debugId,ae.extensionEnvironment=me.extensionEnvironment,ae["extensions-dir"]=me["extensions-dir"],ae["disable-extensions"]=me["disable-extensions"]),ae.loggers={global:ae.loggers.global,window:me?.loggers.window??ae.loggers.window}}else{const me=this.r.getNewWindowState(ae);(0,d.mark)("code/willCreateCodeWindow");const be=te=this.O.createInstance(G.$9gc,{state:me,extensionDevelopmentPath:ae.extensionDevelopmentPath,isExtensionTestHost:!!ae.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),U.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(be),this.n.set(be.id,be),this.a.fire(be),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ye=new m.$Wc;ye.add(be.onDidSignalReady(()=>this.b.fire(be))),ye.add(l.Event.once(be.onDidClose)(()=>this.ub(be,ye))),ye.add(l.Event.once(be.onDidDestroy)(()=>this.vb(be))),ye.add(be.onDidMaximize(()=>this.g.fire(be))),ye.add(be.onDidUnmaximize(()=>this.h.fire(be))),ye.add(be.onDidEnterFullScreen(()=>this.j.fire({window:be,fullscreen:!0}))),ye.add(be.onDidLeaveFullScreen(()=>this.j.fire({window:be,fullscreen:!1}))),ye.add(be.onDidTriggerSystemContextMenu(({x:xe,y:Ae})=>this.m.fire({window:be,x:xe,y:Ae})));const Fe=(0,S.$sg)(be.win?.webContents);Fe.removeAllListeners("devtools-reload-page"),ye.add(l.Event.fromNodeEventEmitter(Fe,"devtools-reload-page")(()=>this.I.reload(be))),this.I.registerWindow(be)}return ae.windowId=te.id,te.isReady?this.I.unload(te,C.UnloadReason.LOAD).then(async me=>{me||await this.sb(te,ae,U,z)}):await this.sb(te,ae,U,z),te}async sb(U,N,ie,X){if(N.extensionDevelopmentPath||((0,x.$Xi)(N.workspace)?N.backupPath=this.J.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,x.$Si)(N.workspace)?N.backupPath=this.J.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.J.registerEmptyWindowBackup({backupFolder:ie.emptyWindowBackupInfo?.backupFolder??(0,J.$3gc)().id,remoteAuthority:N.remoteAuthority})),this.H.isEnabled()){const z=N.workspace??(0,x.$Wi)(N.backupPath,!1),te=this.tb(ie,z,X),ae=te instanceof Promise?await te:te;N.profiles.profile=ae,N.extensionDevelopmentPath||await this.H.setProfileForWorkspace(z,ae)}U.load(N)}tb(U,N,ie){return U.forceProfile?this.H.profiles.find(X=>X.name===U.forceProfile)??this.H.createNamedProfile(U.forceProfile):U.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(N)??ie}ub(U,N){this.n.delete(U.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}vb(U){this.n.delete(U.id),this.c.fire(U)}getFocusedWindow(){const U=r.BrowserWindow.getFocusedWindow();if(U)return this.getWindowById(U.id)}getLastActiveWindow(){return this.xb(this.getWindows())}wb(U){return this.xb(this.getWindows().filter(N=>(0,$.$oh)(N.remoteAuthority,U)))}xb(U){return(0,q.$Tgc)(U)}sendToFocused(U,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(U,I.CancellationToken.None,...N)}sendToOpeningWindow(U,...N){this.B(l.Event.once(this.onDidSignalReadyWindow)(ie=>{ie.sendWhenReady(U,I.CancellationToken.None,...N)}))}sendToAll(U,N,ie){for(const X of this.getWindows())ie&&ie.indexOf(X.id)>=0||X.sendWhenReady(U,I.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(U){return this.n.get(U)}getWindowByWebContents(U){const N=r.BrowserWindow.fromWebContents(U);if(!N)return;const ie=this.getWindowById(N.id);return ie?.matches(U)?ie:void 0}};e.$jic=M,e.$jic=M=ke([re(4,w.$dk),re(5,ne.$6gc),re(6,T.$VR),re(7,F.$wo),re(8,n.$Egc),re(9,H.$Ugc),re(10,P.$$gc),re(11,a.$Lgc),re(12,t.$cj),re(13,B.$Rhc),re(14,_.$4gc),re(15,h.$Hi),re(16,o.$Mgc),re(17,c.$dl),re(18,L.$Ogc),re(19,W.$Pgc),re(20,V.$Dhc),re(21,ce.$aS)],M)}),define(le[281],ue([0,1,71,29,90,59]),function(K,e,i,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;let O=class{constructor(b,l,g,u){this.a=b,this.b=l,this.c=g,this.d=u,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(b,l){const g=this.b.getWindowById(b);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),l)}createUntitledWorkspace(b,l,g){return this.a.createUntitledWorkspace(l,g)}deleteUntitledWorkspace(b,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(b,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(b){return this.c.getRecentlyOpened()}addRecentlyOpened(b,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(b,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(b){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$lic=O,e.$lic=O=ke([re(0,D.$4gc),re(1,r.$Rgc),re(2,E.$Rhc),re(3,i.$Lgc)],O)}),define(le[282],ue([0,1,13,109,35,27,17,55,15,4,286,48,2,11,9,3,12,7,33,161,45,162,121,137,10,71,256,16,263,99,138,53,100,190,20,70,103,178,266,180,181,182,14,194,102,84,6,101,189,272,273,257,264,19,5,279,66,28,75,267,104,34,246,89,130,24,223,224,57,50,236,261,274,262,275,134,238,239,240,243,270,51,29,280,245,30,105,90,281,59,40,203,58,216,49,88,135,248,265,253,8,226,247,198,73,269,242,21,76,268,234,209,68,85,277,79,86]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t,o,n,c,h,P,w,R,L,A,T,j,G,q,Q,de,x,J,B,_,C,W,F,H,ne,V,ce,oe,Y,M,Z,U,N,ie,X,z,te,ae,me,be,ye,Fe,xe,Ae,$e,ee,he,fe,pe,ve,je,Oe,Re,We,Ke,Ze,ze,Je,Qe,Ye,Ce,se,ge,we,Ee,Me,Be,_e,lt,rt,at,tt,ut,ct,ft,gt,Tt,mt,$t,Lt,jt,Mt,pt,Ft,Et,dt,Nt,Ct,wt,Wt,St,Bt,kt,Pt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0;let yt=class extends m.$Xc{static{bt=this}static{this.a={[p.Schemas.file]:"security.promptForLocalFileProtocolHandling",[p.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(De,Te,Le,Se,Pe,qe,Ge,Xe,Ne,He,Ue,et){super(),this.g=De,this.h=Te,this.j=Le,this.m=Se,this.n=Pe,this.s=qe,this.t=Ge,this.u=Xe,this.w=Ne,this.y=He,this.z=Ue,this.C=et,this.D(),this.F()}D(){const De=Ne=>Ne?.startsWith(`${p.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((Ne,He,Ue,et)=>De(et.requestingUrl)?Ue(Te.has(He)):Ue(!1)),i.session.defaultSession.setPermissionCheckHandler((Ne,He,Ue,et)=>De(et.requestingUrl)?Te.has(He):!1);const Le=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,p.Schemas.vscodeManagedRemoteResource,"devtools"]),Se=Ne=>{for(let He=Ne;He;He=He.parent)if(He.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ne=>Ne.resourceType==="xhr"||Se(Ne.frame),qe=Ne=>{const He=Ne.frame;if(!He||!this.b)return!1;const Ue=i.BrowserWindow.getAllWindows();for(const et of Ue)if(He.processId===et.webContents.mainFrame.processId)return!0;return!1},Ge=(Ne,He)=>{if(Ne.path!=="/index.html")return!0;const Ue=He.frame;if(!Ue||!this.b)return!1;for(const et of this.b.getWindows())if(et.win&&Ue.processId===et.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((Ne,He)=>{const Ue=y.URI.parse(Ne.url);return Ue.scheme===p.Schemas.vscodeWebview&&!Ge(Ue,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),He({cancel:!0})):Ue.scheme===p.Schemas.vscodeFileResource&&!qe(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),He({cancel:!0})):Ue.path.endsWith(".svg")&&!Le.has(Ue.scheme)?He({cancel:!Pe(Ne)}):He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,He)=>{const Ue=Ne.responseHeaders,et=Ue["content-type"]||Ue["Content-Type"];if(et&&Array.isArray(et)){const it=y.URI.parse(Ne.url);if(it.path.endsWith(".svg")&&Le.has(it.scheme))return Ue["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:Ue});if(!it.path.endsWith(p.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return He({cancel:!Pe(Ne)})}return He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,He)=>{if(Ne.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ue=Ne.responseHeaders??Object.create(null);if(Ue["Access-Control-Allow-Origin"]===void 0)return Ue["Access-Control-Allow-Origin"]=["*"],He({cancel:!1,responseHeaders:Ue})}return He({cancel:!1})});const Xe=i.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.s.codeCachePath&&Xe.setCodeCachePath((0,f.$mc)(this.s.codeCachePath,"chrome")),d.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,b.setUnexpectedErrorHandler)(Le=>this.G(Le)),process.on("uncaughtException",Le=>{(0,b.$1)(Le)||(0,b.$2)(Le)}),process.on("unhandledRejection",Le=>(0,b.$2)(Le)),l.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,S.$gY)(),i.app.on("accessibility-support-changed",(Le,Se)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Se)}),i.app.on("activate",async(Le,Se)=>{this.m.trace("app#activate"),Se||await this.b?.openEmptyWindow({context:Ye.OpenContext.DOCK})}),i.app.on("web-contents-created",(Le,Se)=>{Se?.opener?.url.startsWith(`${p.Schemas.vscodeFileResource}://${p.$2g}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(Se)),Se.on("will-navigate",Pe=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),Se.setWindowOpenHandler(Pe=>Pe.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Pe)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Pe.url}}`),this.f?.openExternal(void 0,Pe.url),{action:"deny"}))});let De=[],Te;i.app.on("open-file",(Le,Se)=>{Se=(0,kt.$qm)(Se),this.m.trace("app#open-file: ",Se),Le.preventDefault(),De.push((0,ge.$bj)(Se)?{workspaceUri:y.URI.file(Se)}:{fileUri:y.URI.file(Se)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Ye.OpenContext.DOCK,cli:this.s.args,urisToOpen:De,gotoLineMode:!1,preferNewWindow:!0}),De=[],Te=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ye.OpenContext.DESKTOP})}),E.$fY.handle("vscode:fetchShellEnv",Le=>{const Se=this.b?.getWindowByWebContents(Le.sender);let Pe,qe;return Se?.config?(Pe=Se.config,qe={...process.env,...Se.config.userEnv}):(Pe=this.s.args,qe=process.env),this.W(Pe,qe,!1)}),E.$fY.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),E.$fY.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),E.$fY.on("vscode:reloadWindow",Le=>Le.sender.reload()),E.$fY.handle("vscode:notifyZoomLevel",async(Le,Se)=>{const Pe=this.b?.getWindowByWebContents(Le.sender);Pe&&Pe.notifyZoomLevel(Se)})}G(De){if(De){const Te={message:`[uncaught exception in main]: ${De.message}`,stack:De.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${De}`),De.stack&&this.m.error(De.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const De=this.z.win32AppUserModelId;d.$j&&De&&i.app.setAppUserModelId(De);try{d.$k&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.m.error(Ue)}const Te=new s.$mY;l.Event.once(this.t.onWillShutdown)(Ue=>{Ue.reason===Z.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[Le,Se,Pe]=await Promise.all([(0,$t.$uic)(this.w,this.m),(0,$t.$vic)(this.w,this.m),(0,$t.$wic)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:qe,sharedProcessClient:Ge}=this.O(Le,Se,Pe),Xe=await this.P(Le,Se,Pe,qe);Xe.invokeFunction(Ue=>Ue.get(t.$ihc)),this.B(Xe.createInstance(gt.$pic)),Xe.invokeFunction(Ue=>this.Q(Ue,Te,Ge));const Ne=await Xe.invokeFunction(Ue=>this.H(Ue,Te));this.I(Te),this.t.phase=Z.LifecycleMainPhase.Ready,await Xe.invokeFunction(Ue=>this.R(Ue,Ne)),this.t.phase=Z.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Uh(()=>{this.B((0,mt.$Yh)(()=>this.t.phase=Z.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(De,Te){const Le=this.b=De.get(Ye.$Rgc),Se=De.get(Re.$7Y),Pe=this.f=De.get(ie.$Ehc),qe=De.get(L.$Mgc),Ge=this;Se.registerHandler({async handleURL(it,ot){return Ge.N(Le,qe,Se,it,ot)}});const Xe=this.B(new se.$kic({onDidOpenMainWindow:Pe.onDidOpenMainWindow,onDidFocusMainWindow:Pe.onDidFocusMainWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Ne=new k.$qi(it=>Xe.getActiveClientId().then(ot=>it===ot)),He=new We.$bic(Ne,this.m),Ue=Te.getChannel("urlHandler",He);Se.registerHandler(new We.$aic(Ue));const et=await this.J(Le,qe);return this.B(new Ze.$cic(et?.urls,Se,Le,this.s,this.z,this.m)),et}I(De){const Te=()=>({statusCode:404,data:"Not found"}),Le=new Wt.$W(()=>De.getChannel(wt.$Dic,new wt.$Eic));i.protocol.registerBufferProtocol(p.Schemas.vscodeManagedRemoteResource,(Se,Pe)=>{const qe=y.URI.parse(Se.url);if(!qe.authority.startsWith("window:"))return Pe(Te());Le.value.call(wt.$Cic,[qe]).then(Ge=>Pe({...Ge,data:Buffer.from(Ge.body,"base64")}),Ge=>{this.m.warn("error dispatching remote resource call",Ge),Pe({statusCode:500,data:String(Ge)})})})}async J(De,Te){const Le=this.s.args["open-url"]?this.s.args._urls||[]:[];Le.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Le.length+Se.length===0)return;const Pe=[...Le,...Se].map(Xe=>{try{return{uri:y.URI.parse(Xe),originalUrl:Xe}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Xe);return}}),qe=[],Ge=[];for(const Xe of Pe){if(!Xe)continue;const Ne=this.M(Xe.uri);if(Ne)if(await this.L(Ne,De,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Xe.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Xe.uri.toString(!0),Ne),qe.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Xe.uri.toString(!0)),Ge.push(Xe)}return{urls:Ge,openables:qe}}async L(De,Te,Le){let Se,Pe;if((0,Qe.$mE)(De)?(Se=De.workspaceUri,Pe=(0,o.localize)(143,null,Se.scheme===p.Schemas.file?(0,u.$6w)(Se,{os:d.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)):(0,Qe.$nE)(De)?(Se=De.folderUri,Pe=(0,o.localize)(144,null,Se.scheme===p.Schemas.file?(0,u.$6w)(Se,{os:d.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)):(Se=De.fileUri,Pe=(0,o.localize)(145,null,Se.scheme===p.Schemas.file?(0,u.$6w)(Se,{os:d.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)),Se.scheme!==p.Schemas.file&&Se.scheme!==p.Schemas.vscodeRemote||this.u.getValue(bt.a[Se.scheme])===!1)return!1;const{response:Ge,checkboxChecked:Xe}=await Le.showMessageBox({type:"warning",buttons:[(0,o.localize)(146,null),(0,o.localize)(147,null)],message:Pe,detail:(0,o.localize)(148,null),checkboxLabel:Se.scheme===p.Schemas.file?(0,o.localize)(149,null):(0,o.localize)(150,null),cancelId:1});if(Ge!==0)return!0;if(Xe){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:Se.scheme===p.Schemas.file?"local":"remote"};Te.sendToFocused(Ne.channel,Ne.args),Te.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}M(De){if(De.path){if(De.authority===p.Schemas.file){const Te=y.URI.file(De.fsPath);return(0,ge.$bj)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(De.authority===p.Schemas.vscodeRemote){const Te=De.path.indexOf(f.$jc.sep,1);let Le,Se;Te!==-1?(Le=De.path.substring(1,Te),Se=De.path.substring(Te)):(Le=De.path.substring(1),Se="/");let Pe=De.query;const qe=new URLSearchParams(De.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),Pe=qe.toString());const Ge=y.URI.from({scheme:p.Schemas.vscodeRemote,authority:Le,path:Se,query:Pe,fragment:De.fragment});return(0,ge.$bj)(Se)?{workspaceUri:Ge}:/:[\d]+$/.test(Se)?{fileUri:Ge}:{folderUri:Ge}}}}async N(De,Te,Le,Se,Pe){this.m.trace("app#handleProtocolUrl():",Se.toString(!0),Pe),Se.scheme===this.z.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:y.URI.parse(Se.query).path,query:""}));let qe=!1;const Ge=new URLSearchParams(Se.query);Ge.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Ge.delete("windowId"),Se=Se.with({query:Ge.toString()}),qe=!0):d.$k&&De.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),qe=!0);const Xe=Ge.get("continueOn");Xe!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),Ge.delete("continueOn"),Se=Se.with({query:Ge.toString()}),this.s.continueOn=Xe??void 0);const Ne=this.M(Se);return Ne?await this.L(Ne,De,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,Se.toString(!0)),(0,Et.$Qb)(await De.open({context:Ye.OpenContext.LINK,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,Et.$Qb)(await De.open({context:Ye.OpenContext.LINK,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,z.$kn)(Se)}))?.ready(),Le.open(Se,Pe)):(this.m.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Pe),!1)}O(De,Te,Le){const Se=this.B(this.j.createInstance(te.$Zhc,De,Te,Le));this.B(Se.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ge=await Se.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new a.$nY(Ge,"main")})();return{sharedProcessReady:(async()=>(await Se.whenReady(),Pe))(),sharedProcessClient:Pe}}async P(De,Te,Le,Se){const Pe=new ne.$Gi;switch(process.platform){case"win32":Pe.set(he.$eZ,new F.$Fi(Oe.$$hc));break;case"linux":d.$m?Pe.set(he.$eZ,new F.$Fi(je.$0hc,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(he.$eZ,new F.$Fi(ve.$9hc));break;case"darwin":Pe.set(he.$eZ,new F.$Fi(pe.$8hc));break}Pe.set(Ye.$Rgc,new F.$Fi(Ce.$jic,[De,Te,Le,this.h],!1)),Pe.set(St.$Dhc,new F.$Fi(Bt.$Fic,void 0,!1));const qe=new L.$Ngc(this.m,this.z);Pe.set(L.$Mgc,qe),Pe.set(M.$Lhc,new F.$Fi(M.$Mhc,void 0,!1)),Pe.set(R.$phc,new F.$Fi(R.$qhc,void 0,!1)),Pe.set(w.$Wm,k.ProxyChannel.toService((0,k.$oi)(Se.then(Ue=>Ue.getChannel("diagnostics"))))),Pe.set(V.$0ac,new F.$Fi(ce.$Ghc,[this.h])),Pe.set(V.$$ac,new F.$Fi(oe.$Hhc,[this.h])),Pe.set(A.$1Y,new F.$Fi(T.$rhc)),Pe.set(Y.$Ihc,new F.$Fi(Y.$Jhc)),Pe.set(ie.$Ehc,new F.$Fi(ie.$Fhc,void 0,!1)),Pe.set(ze.$dic,new F.$Fi(Je.$fic)),Pe.set(N.$Uhc,new F.$Fi(N.$Vhc)),Pe.set(Q.$shc,new F.$Fi(de.$uhc)),Pe.set(ye.$ehc,new F.$Fi(ye.$fhc)),Pe.set(ye.$ghc,new F.$Fi(ye.$hhc));const Ge=new Nt.$Bic({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Xe=new Ct.$Vs(Ge,this.u,this.m,this.n);Pe.set(dt.$ws,Xe),d.$j?Pe.set(x.$vhc,new F.$Fi(J.$whc)):d.$k?Pe.set(x.$vhc,new F.$Fi(J.$xhc)):d.$l&&Pe.set(x.$vhc,new F.$Fi(J.$yhc));const Ne=new c.$khc(this.s,this.u,this.m,this.w);Pe.set(n.$Lgc,Ne);const He=new Be.$5gc(this.s,this.m,this.C,Ne,qe);if(Pe.set(Be.$4gc,He),Pe.set(we.$Dib,new F.$Fi(Me.$lic,void 0,!1)),Pe.set(Ee.$Rhc,new F.$Fi(Ee.$Shc,void 0,!1)),Pe.set(Re.$7Y,new F.$Fi(Ke.$9Y,void 0,!1)),(0,ee.$Hp)(this.z,this.s)){const Ue=(0,ee.$Mp)(this.z,this.u),et=(0,k.$oi)(Se.then(vt=>vt.getChannel("telemetryAppender"))),it=new Ae.$3hc(et),ot=(0,Fe.$yp)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,De,Te,Le,Ue),nt=(0,ee.$Np)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Pe.set(xe.$cm,new F.$Fi($e.$ms,[ht],!1))}else Pe.set(xe.$cm,ee.$Cp);return Pe.set(ut.$Oq,new F.$Fi(Lt.$3R,void 0,!0)),Pe.set(ct.$Sq,new F.$Fi(ft.$oic,void 0,!0)),Pe.set(pt.$zic,new F.$Fi(pt.$Aic,void 0,!0)),Pe.set(t.$ihc,new F.$Fi(t.$jhc)),Pe.set(Pt.$aS,new F.$Fi(Pt.$bS,void 0,!0)),await mt.Promises.settled([Ne.initialize(),He.initialize()]),this.j.createChild(Pe)}Q(De,Te,Le){const Se=this.B(new m.$Wc),Pe=k.ProxyChannel.fromService(De.get(M.$Lhc),Se,{disableMarshalling:!0});this.g.registerChannel("launch",Pe);const qe=k.ProxyChannel.fromService(De.get(R.$phc),Se,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const Ge=Se.add(new lt.$mic(De.get(_e.$wo)));Te.registerChannel("policy",Ge),Le.then(st=>st.registerChannel("policy",Ge));const Xe=this.y.getProvider(p.Schemas.file);(0,v.$rg)(Xe instanceof W.$yr);const Ne=Se.add(new C.$zhc(Xe,this.m,this.s));Te.registerChannel(B.$LR,Ne),Le.then(st=>st.registerChannel(B.$LR,Ne));const He=k.ProxyChannel.fromService(De.get(rt.$Ugc),Se);Te.registerChannel("userDataProfiles",He),Le.then(st=>st.registerChannel("userDataProfiles",He));const Ue=new at.$hs(De.get(tt.$$p));Le.then(st=>st.registerChannel("request",Ue));const et=new fe.$4hc(De.get(he.$eZ));Te.registerChannel("update",et);const it=k.ProxyChannel.fromService(De.get(V.$0ac),Se);Te.registerChannel("issue",it);const ot=k.ProxyChannel.fromService(De.get(V.$$ac),Se);Te.registerChannel("process",ot);const nt=k.ProxyChannel.fromService(De.get(A.$1Y),Se);Te.registerChannel("encryption",nt);const ht=k.ProxyChannel.fromService(De.get(ae.$3l),Se);Te.registerChannel("sign",ht);const vt=k.ProxyChannel.fromService(De.get(Y.$Ihc),Se);Te.registerChannel("keyboardLayout",vt),this.f=De.get(ie.$Ehc);const It=k.ProxyChannel.fromService(this.f,Se);Te.registerChannel("nativeHost",It),Le.then(st=>st.registerChannel("nativeHost",It));const Ut=k.ProxyChannel.fromService(De.get(we.$Dib),Se);Te.registerChannel("workspaces",Ut);const zt=k.ProxyChannel.fromService(De.get(N.$Uhc),Se);Te.registerChannel("menubar",zt);const qt=k.ProxyChannel.fromService(De.get(Re.$7Y),Se);Te.registerChannel("url",qt);const Ht=k.ProxyChannel.fromService(De.get(ze.$dic),Se);Te.registerChannel("webview",Ht);const Rt=Se.add(new be.$1hc(this.m,De.get(ye.$ehc)));Te.registerChannel("storage",Rt),Le.then(st=>st.registerChannel("storage",Rt));const Vt=Se.add(new Tt.$qic(De.get(ye.$ehc),De.get(rt.$Ugc),this.m));Le.then(st=>st.registerChannel("profileStorageListener",Vt));const xt=k.ProxyChannel.fromService(De.get(dt.$ws),Se);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,xt);const Gt=k.ProxyChannel.fromService(De.get(x.$vhc),Se);Te.registerChannel("externalTerminal",Gt);const Dt=new jt.$xic(De.get(Mt.$6gc));Te.registerChannel("logger",Dt),Le.then(st=>st.registerChannel("logger",Dt));const Kt=new P.$lhc(De.get(Ye.$Rgc));Te.registerChannel("extensionhostdebugservice",Kt);const Xt=k.ProxyChannel.fromService(De.get(Q.$shc),Se);Te.registerChannel(Q.$thc,Xt);const Qt=k.ProxyChannel.fromService(De.get(pt.$zic),Se);Te.registerChannel(Ft.$yic,Qt)}async R(De,Te){const Le=this.b=De.get(Ye.$Rgc);this.c=De.get(St.$Dhc);const Se=(0,G.$Nm)(process.env)?Ye.OpenContext.CLI:Ye.OpenContext.DESKTOP,Pe=this.s.args;if(Te){if(Te.openables.length>0)return Le.open({context:Se,cli:Pe,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),Le.open({context:Se,cli:Pe,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,Ge=Pe._.length,Xe=!!Pe["folder-uri"],Ne=!!Pe["file-uri"],He=Pe["skip-add-to-recently-opened"]===!0,Ue=Pe.wait&&Pe.waitMarkerFilePath?y.URI.file(Pe.waitMarkerFilePath):void 0,et=Pe.remote||void 0,it=Pe.profile,ot=Pe["profile-temp"];if(!Ge&&!Xe&&!Ne){if(Pe["new-window"]||it||ot)return Le.open({context:Se,cli:Pe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:Ue,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(qe.length)return Le.open({context:Ye.OpenContext.DOCK,cli:Pe,urisToOpen:qe.map(nt=>(nt=(0,kt.$qm)(nt),(0,ge.$bj)(nt)?{workspaceUri:y.URI.file(nt)}:{fileUri:y.URI.file(nt)})),noRecentEntry:He,waitMarkerFileURI:Ue,initialStartup:!0})}return Le.open({context:Se,cli:Pe,forceNewWindow:Pe["new-window"],diffMode:Pe.diff,mergeMode:Pe.merge,noRecentEntry:He,waitMarkerFileURI:Ue,gotoLineMode:Pe.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}S(){this.U(),i.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(De,Te)=>{Te({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),this.W(this.s.args,process.env,!0),this.X(),d.$k&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const De=this.z.win32MutexName;if(d.$j&&De)try{const Te=await new Promise((Se,Pe)=>{K(["@vscode/windows-mutex"],Se,Pe)}).then(Ie),Le=new Te.Mutex(De);l.Event.once(this.t.onWillShutdown)(()=>Le.release())}catch(Te){this.m.error(Te)}}async W(De,Te,Le){try{return await(0,q.$Um)(this.u,this.m,De,Te)}catch(Se){const Pe=(0,I.$tj)(Se);Le?this.b?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.m.error(Pe)}return{}}async X(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),Le=(0,g.parse)(Te),Pe=(0,ee.$Jp)(this.u)>=xe.TelemetryLevel.CRASH;if(Le["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Pe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$5g)()}"`,"}"],Ge=Te.substring(0,Te.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,O.$Qe.fromString(Ge))}else{const qe=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Pe},`);qe!==Te&&await this.y.writeFile(this.s.argvResource,O.$Qe.fromString(qe))}}catch(De){this.m.error(De),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$Gic=yt,e.$Gic=yt=bt=ke([re(2,H.$Hi),re(3,U.$dk),re(4,U.$ek),re(5,j.$Egc),re(6,Z.$$gc),re(7,h.$cj),re(8,me.$VR),re(9,_.$dl),re(10,X.$wk),re(11,rt.$Ugc)],yt)});var Ve=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[287],ue([0,1,13,26,7,21,8,55,15,32,4,48,11,9,72,3,37,25,23,45,107,282,10,16,208,222,20,70,173,14,192,102,84,188,101,19,195,5,63,28,74,249,133,260,49,259,104,221,34,57,77,58,40,204,202,2,41,237,73,197,125,129,241,109,235]),function(K,e,i,r,E,D,O,I,b,l,g,u,m,p,f,d,v,y,$,S,k,s,a,t,o,n,c,h,P,w,R,L,A,T,j,G,q,Q,de,x,J,B,_,C,W,F,H,ne,V,ce,oe,Y,M,Z,U,N,ie,X,z,te,ae,me,be,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),de=Ve(de);class Fe{main(){try{this.a()}catch($e){console.error($e.message),i.app.exit(1)}}async a(){(0,b.setUnexpectedErrorHandler)(Re=>console.error(Re));const[$e,ee,he,fe,pe,ve,je,Oe]=this.b();try{try{await this.d(he,Oe,fe,pe,je)}catch(Re){throw this.g(he,je,Re),Re}await $e.invokeFunction(async Re=>{const We=Re.get(Q.$dk),Ke=Re.get(G.$$gc),Ze=Re.get(w.$dl),ze=Re.get(Q.$ek),Je=await this.f(We,he,Ke,$e,je,!0);return $.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Qe=>{We.warn(`app#startup(): Error writing main lockfile: ${Qe.stack}`)}),ve.logger=ze.createLogger("main",{name:(0,a.localize)(151,null)}),g.Event.once(Ke.onWillShutdown)(Qe=>{Ze.dispose(),fe.dispose(),Qe.join("instanceLockfile",r.promises.unlink(he.mainLockfile).catch(()=>{}))}),$e.createInstance(s.$Gic,Je,ee).startup()})}catch(Re){$e.invokeFunction(this.j,Re)}}b(){const $e=new j.$Gi,ee=new N.$Wc;process.once("exit",()=>ee.dispose());const he={_serviceBrand:void 0,...de.default};$e.set(x.$wk,he);const fe=new c.$Fgc(this.k(),he),pe=this.c(fe);$e.set(c.$Egc,fe);const ve=new z.$7gc((0,Q.$rk)(fe),fe.logsHome);$e.set(z.$6gc,ve);const je=new q.$eec(ve.getLogLevel()),Oe=ee.add(new te.$4R(je,[new Q.$kk(ve.getLogLevel())]));$e.set(Q.$dk,Oe);const Re=new R.$8q(Oe);$e.set(w.$dl,Re);const We=new L.$yr(Oe);Re.registerProvider(m.Schemas.file,We);const Ke=new X.$Zs(Re);$e.set(ie.$Nl,Ke);const Ze=new me.$YR(me.SaveStrategy.DELAYED,fe,Oe,Re);$e.set(V.$UR,Ze),$e.set(V.$VR,Ze);const ze=new Y.$Vgc(Ze,Ke,fe,Re,Oe);$e.set(Y.$Ugc,ze),Re.registerProvider(m.Schemas.vscodeUserData,new be.$Ric(m.Schemas.file,We,m.Schemas.vscodeUserData,ze,Ke,Oe));const Je=d.$j&&he.win32RegValueName?ee.add(new Z.$Pic(Oe,he.win32RegValueName)):fe.policyFile?ee.add(new U.$Qic(fe.policyFile,Re,Oe)):new M.$yo;$e.set(M.$wo,Je);const Qe=new o.$1o(ze.defaultProfile.settingsResource,Re,Je,Oe);return $e.set(t.$cj,Qe),$e.set(G.$$gc,new A.$Fi(G.$_gc,void 0,!1)),$e.set(W.$$p,new A.$Fi(F.$Nic,void 0,!0)),$e.set(oe.$Pgc,new A.$Fi(oe.$Qgc)),$e.set(H.$3l,new A.$Fi(ne.$Oic,void 0,!1)),$e.set(_.$Kw,new A.$Fi(C.$Lic)),$e.set(J.$Ogc,new B.$Iic(fe,ze,Oe)),[new T.$Br($e,!0),pe,fe,Qe,Ze,je,he,ze]}c($e){const ee={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const fe=process.env[he];typeof fe=="string"&&(ee[he]=fe)}),Object.assign(process.env,ee),ee}async d($e,ee,he,fe,pe){await O.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:m.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:m.Schemas.file}).fsPath,$e.backupHome].map(ve=>ve?r.promises.mkdir(ve,{recursive:!0}):void 0)),fe.init(),he.initialize()]),ee.init()}e($e){if(d.$j){const ee=(0,ye.getUNCHost)($e);ee&&(0,ye.addUNCHostToAllowlist)(ee)}return $e}async f($e,ee,he,fe,pe,ve){let je;try{(0,f.mark)("code/willStartMainServer"),je=await(0,k.$Di)(ee.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),g.Event.once(he.onWillShutdown)(()=>je.dispose())}catch(Oe){if(Oe.code!=="EADDRINUSE")throw this.g(ee,pe,Oe),Oe;let Re;try{Re=await(0,k.$Ei)(ee.mainIPCHandle,"main")}catch(ze){if(!ve||d.$j||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.h((0,a.localize)(152,null,pe.nameShort),(0,a.localize)(153,null),pe),ze;try{(0,r.unlinkSync)(ee.mainIPCHandle)}catch(Je){throw $e.warn("Could not delete obsolete instance handle",Je),Je}return this.f($e,ee,he,fe,pe,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${pe.nameShort} is running.`;throw $e.error(ze),Re.dispose(),new Error(ze)}let We;!ee.args.wait&&!ee.args.status&&(We=setTimeout(()=>{this.h((0,a.localize)(154,null,pe.nameShort),(0,a.localize)(155,null),pe)},1e4));const Ke=S.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0}),Ze=S.ProxyChannel.toService(Re.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return fe.invokeFunction(async()=>{const ze=new n.$7s(ce.$Cp,pe),Je=await Ze.getMainDiagnostics(),Qe=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ye=await ze.getDiagnostics(Je,Qe);throw console.log(Ye),new b.$cb});throw d.$j&&await this.i(Ke,$e),$e.trace("Sending env to running instance..."),await Ke.start(ee.args,process.env),Re.dispose(),We&&clearTimeout(We),new b.$cb("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,a.localize)(156,null,pe.nameShort)),new b.$cb("Terminating...");return process.env.VSCODE_PID=String(process.pid),je}g($e,ee,he){if(he.code==="EACCES"||he.code==="EPERM"){const fe=(0,D.$Jb)([$e.userDataPath,$e.extensionsPath,k.$zi]).map(pe=>(0,u.$6w)(E.URI.file(pe),{os:d.OS,tildify:$e}));this.h((0,a.localize)(157,null),(0,a.localize)(158,null,(0,I.$tj)(he),fe.join(`
`)),ee)}}h($e,ee,he){i.dialog.showMessageBoxSync((0,ae.$hx)({type:"warning",buttons:[(0,a.localize)(159,null)],message:$e,detail:ee},he).options)}async i($e,ee){if(d.$j){const he=await $e.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((fe,pe)=>{K(["windows-foreground-love"],fe,pe)}).then(Ie)).allowSetForegroundWindow(he)}catch(fe){ee.error(fe)}}}j($e,ee){const he=$e.get(Q.$dk),fe=$e.get(G.$$gc);let pe=0;ee&&(ee.isExpected?ee.message&&he.trace(ee.message):(pe=1,ee.stack?he.error(ee.stack):he.error(`Startup error: ${ee.toString()}`))),fe.kill(pe)}k(){const $e=this.l((0,h.$Km)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const ee=(0,P.$Hic)($e.verbose);ee&&((0,h.$Mm)(process.argv,"--waitMarkerFilePath",ee),$e.waitMarkerFilePath=ee)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const ee=this.m($e._,$e.goto);$e._=ee}return $e}m($e,ee){const he=(0,v.cwd)(),fe=$e.map(je=>{let Oe=String(je),Re;ee&&(Re=(0,l.$Pg)(Oe),Oe=Re.path),Oe&&(Oe=this.n(he,Oe));const We=(0,l.$Jg)(Oe,he),Ke=(0,p.$qc)(We);return Ke&&!(0,l.$Fg)(Ke)?null:ee&&Re?(Re.path=We,this.o(Re)):We}),pe=d.$j||d.$k,ve=(0,D.$Ob)(fe,je=>je&&pe?je.toLowerCase():je||"");return(0,D.$Jb)(ve)}n($e,ee){return d.$j&&(ee=(0,y.$qf)(ee,'"')),ee=(0,y.$of)((0,y.$of)(ee," "),"	"),d.$j&&(ee=(0,p.$nc)($e,ee),ee=(0,y.$qf)(ee,".")),ee}o($e){const ee=[$e.path];return typeof $e.line=="number"&&ee.push(String($e.line)),typeof $e.column=="number"&&ee.push(String($e.column)),ee.join(":")}}new Fe().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e2b54301a5745870f6b95d81c91fb3e9557d4f08/core/vs/code/electron-main/main.js.map
