/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/amdX","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/request/common/request","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],he=function(Z){for(var e=[],P=0,S=Z.length;P<S;P++)e[P]=le[Z[P]];return e};define(le[75],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=e.$T=void 0,e.$T=!1,e.$U=!0;var P;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class S{static get(){const I=new Map,C=new Map,O=new Map,w=new Map;function l(m,k){m.has(k.detail)||m.set(k.detail,-k.timestamp)}function h(m,k){const b=m.get(k.detail);b&&(b>=0||m.set(k.detail,b+k.timestamp))}let u=[];typeof Z=="function"&&typeof Z.getStats=="function"&&(u=Z.getStats().slice(0).sort((m,k)=>m.timestamp-k.timestamp));for(const m of u)switch(m.type){case P.BeginLoadingScript:l(I,m);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:h(I,m);break;case P.BeginInvokeFactory:l(C,m);break;case P.EndInvokeFactory:h(C,m);break;case P.NodeBeginNativeRequire:l(O,m);break;case P.NodeEndNativeRequire:h(O,m);break;case P.NodeBeginEvaluatingScript:l(w,m);break;case P.NodeEndEvaluatingScript:h(w,m);break}let p=0;O.forEach(m=>p+=m);function f(m){const k=[];return m.forEach((b,d)=>k.push([d,b])),k}return{amdLoad:f(I),amdInvoke:f(C),nodeRequire:f(O),nodeEval:f(w),nodeRequireTotal:p}}static toMarkdownTable(I,C){let O="";const w=[];return I.forEach((l,h)=>{w[h]=l.length}),C.forEach(l=>{l.forEach((h,u)=>{typeof h>"u"&&(h=l[u]="-");const p=h.toString().length;w[u]=Math.max(p,w[u])})}),I.forEach((l,h)=>{O+=`| ${l+" ".repeat(w[h]-l.toString().length)} `}),O+=`|
`,I.forEach((l,h)=>{O+=`| ${"-".repeat(w[h])} `}),O+=`|
`,C.forEach(l=>{l.forEach((h,u)=>{typeof h<"u"&&(O+=`| ${h+" ".repeat(w[u]-h.toString().length)} `)}),O+=`|
`}),O}}e.$V=S}),define(le[55],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=S,e.$bi=v,e.$ci=I;function P(C){return(O,w,l)=>{let h=null,u=null;if(typeof l.value=="function"?(h="value",u=l.value):typeof l.get=="function"&&(h="get",u=l.get),!u)throw new Error("not supported");l[h]=C(u,w)}}function S(C,O,w){let l=null,h=null;if(typeof w.value=="function"?(l="value",h=w.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(l="get",h=w.get),!h)throw new Error("not supported");const u=`$memoize$${O}`;w[l]=function(...p){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,p)}),this[u]}}function v(C,O,w){return P((l,h)=>{const u=`$debounce$${h}`,p=`$debounce$result$${h}`;return function(...f){this[p]||(this[p]=w?w():void 0),clearTimeout(this[u]),O&&(this[p]=O(this[p],...f),f=[this[p]]),this[u]=setTimeout(()=>{l.apply(this,f),this[p]=w?w():void 0},C)}})}function I(C,O,w){return P((l,h)=>{const u=`$throttle$timer$${h}`,p=`$throttle$result$${h}`,f=`$throttle$lastRun$${h}`,m=`$throttle$pending$${h}`;return function(...k){if(this[p]||(this[p]=w?w():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),O&&(this[p]=O(this[p],...k)),this[m])return;const b=this[f]+C;b<=Date.now()?(this[f]=Date.now(),l.apply(this,[this[p]]),this[p]=w?w():void 0):(this[m]=!0,this[u]=setTimeout(()=>{this[m]=!1,this[f]=Date.now(),l.apply(this,[this[p]]),this[p]=w?w():void 0},b-Date.now()))}})}}),define(le[76],he([0,1,7]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=S,e.$hd=v,e.$id=I,e.$jd=C,e.$kd=O,e.$ld=w;function S(l,h){if(!l)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function v(l,h="Unreachable"){throw new Error(h)}function I(l,h="unexpected state"){if(!l)throw new P.$eb(`Assertion Failed: ${h}`)}function C(l){l||(0,P.$2)(new P.$eb("Soft Assertion Failed"))}function O(l){if(!l()){debugger;l(),(0,P.$2)(new P.$eb("Assertion Failed"))}}function w(l,h){let u=0;for(;u<l.length-1;){const p=l[u],f=l[u+1];if(!h(p,f))return!1;u++}return!0}}),define(le[34],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Zn=C,e.$1n=u,e.$2n=p,e.$3n=f,e.$4n=m,e.$5n=k,e.$6n=b,e.$7n=d,e.$8n=$,e.$9n=R,e.$0n=y;var P;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var S;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(S||(e.SyntaxKind=S={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v||(e.ParseErrorCode=v={}));var I;(function(i){i.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function C(i,a=!1){let n=0;const r=i.length;let t="",s=0,o=S.Unknown,c=P.None;function g(Y){let ne=0,ae=0;for(;ne<Y;){const ue=i.charCodeAt(n);if(ue>=h._0&&ue<=h._9)ae=ae*16+ue-h._0;else if(ue>=h.A&&ue<=h.F)ae=ae*16+ue-h.A+10;else if(ue>=h.a&&ue<=h.f)ae=ae*16+ue-h.a+10;else break;n++,ne++}return ne<Y&&(ae=-1),ae}function N(Y){n=Y,t="",s=0,o=S.Unknown,c=P.None}function T(){const Y=n;if(i.charCodeAt(n)===h._0)n++;else for(n++;n<i.length&&l(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===h.dot)if(n++,n<i.length&&l(i.charCodeAt(n)))for(n++;n<i.length&&l(i.charCodeAt(n));)n++;else return c=P.UnexpectedEndOfNumber,i.substring(Y,n);let ne=n;if(n<i.length&&(i.charCodeAt(n)===h.E||i.charCodeAt(n)===h.e))if(n++,(n<i.length&&i.charCodeAt(n)===h.plus||i.charCodeAt(n)===h.minus)&&n++,n<i.length&&l(i.charCodeAt(n))){for(n++;n<i.length&&l(i.charCodeAt(n));)n++;ne=n}else c=P.UnexpectedEndOfNumber;return i.substring(Y,ne)}function A(){let Y="",ne=n;for(;;){if(n>=r){Y+=i.substring(ne,n),c=P.UnexpectedEndOfString;break}const ae=i.charCodeAt(n);if(ae===h.doubleQuote){Y+=i.substring(ne,n),n++;break}if(ae===h.backslash){if(Y+=i.substring(ne,n),n++,n>=r){c=P.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case h.doubleQuote:Y+='"';break;case h.backslash:Y+="\\";break;case h.slash:Y+="/";break;case h.b:Y+="\b";break;case h.f:Y+="\f";break;case h.n:Y+=`
`;break;case h.r:Y+="\r";break;case h.t:Y+="	";break;case h.u:{const me=g(4);me>=0?Y+=String.fromCharCode(me):c=P.InvalidUnicode;break}default:c=P.InvalidEscapeCharacter}ne=n;continue}if(ae>=0&&ae<=31)if(w(ae)){Y+=i.substring(ne,n),c=P.UnexpectedEndOfString;break}else c=P.InvalidCharacter;n++}return Y}function D(){if(t="",c=P.None,s=n,n>=r)return s=r,o=S.EOF;let Y=i.charCodeAt(n);if(O(Y)){do n++,t+=String.fromCharCode(Y),Y=i.charCodeAt(n);while(O(Y));return o=S.Trivia}if(w(Y))return n++,t+=String.fromCharCode(Y),Y===h.carriageReturn&&i.charCodeAt(n)===h.lineFeed&&(n++,t+=`
`),o=S.LineBreakTrivia;switch(Y){case h.openBrace:return n++,o=S.OpenBraceToken;case h.closeBrace:return n++,o=S.CloseBraceToken;case h.openBracket:return n++,o=S.OpenBracketToken;case h.closeBracket:return n++,o=S.CloseBracketToken;case h.colon:return n++,o=S.ColonToken;case h.comma:return n++,o=S.CommaToken;case h.doubleQuote:return n++,t=A(),o=S.StringLiteral;case h.slash:{const ne=n-1;if(i.charCodeAt(n+1)===h.slash){for(n+=2;n<r&&!w(i.charCodeAt(n));)n++;return t=i.substring(ne,n),o=S.LineCommentTrivia}if(i.charCodeAt(n+1)===h.asterisk){n+=2;const ae=r-1;let ue=!1;for(;n<ae;){if(i.charCodeAt(n)===h.asterisk&&i.charCodeAt(n+1)===h.slash){n+=2,ue=!0;break}n++}return ue||(n++,c=P.UnexpectedEndOfComment),t=i.substring(ne,n),o=S.BlockCommentTrivia}return t+=String.fromCharCode(Y),n++,o=S.Unknown}case h.minus:if(t+=String.fromCharCode(Y),n++,n===r||!l(i.charCodeAt(n)))return o=S.Unknown;case h._0:case h._1:case h._2:case h._3:case h._4:case h._5:case h._6:case h._7:case h._8:case h._9:return t+=T(),o=S.NumericLiteral;default:for(;n<r&&F(Y);)n++,Y=i.charCodeAt(n);if(s!==n){switch(t=i.substring(s,n),t){case"true":return o=S.TrueKeyword;case"false":return o=S.FalseKeyword;case"null":return o=S.NullKeyword}return o=S.Unknown}return t+=String.fromCharCode(Y),n++,o=S.Unknown}}function F(Y){if(O(Y)||w(Y))return!1;switch(Y){case h.closeBrace:case h.closeBracket:case h.openBrace:case h.openBracket:case h.doubleQuote:case h.colon:case h.comma:case h.slash:return!1}return!0}function x(){let Y;do Y=D();while(Y>=S.LineCommentTrivia&&Y<=S.Trivia);return Y}return{setPosition:N,getPosition:()=>n,scan:a?x:D,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>c}}function O(i){return i===h.space||i===h.tab||i===h.verticalTab||i===h.formFeed||i===h.nonBreakingSpace||i===h.ogham||i>=h.enQuad&&i<=h.zeroWidthSpace||i===h.narrowNoBreakSpace||i===h.mathematicalSpace||i===h.ideographicSpace||i===h.byteOrderMark}function w(i){return i===h.lineFeed||i===h.carriageReturn||i===h.lineSeparator||i===h.paragraphSeparator}function l(i){return i>=h._0&&i<=h._9}var h;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(h||(h={}));function u(i,a){const n=[],r=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function c(g,N,T,A){s.value=g,s.offset=N,s.length=T,s.type=A,s.colonOffset=void 0,t=s}try{R(i,{onObjectBegin:(g,N)=>{if(a<=g)throw r;t=void 0,o=a>g,n.push("")},onObjectProperty:(g,N,T)=>{if(a<N||(c(g,N,T,"property"),n[n.length-1]=g,a<=N+T))throw r},onObjectEnd:(g,N)=>{if(a<=g)throw r;t=void 0,n.pop()},onArrayBegin:(g,N)=>{if(a<=g)throw r;t=void 0,n.push(0)},onArrayEnd:(g,N)=>{if(a<=g)throw r;t=void 0,n.pop()},onLiteralValue:(g,N,T)=>{if(a<N||(c(g,N,T,y(g)),a<=N+T))throw r},onSeparator:(g,N,T)=>{if(a<=N)throw r;if(g===":"&&t&&t.type==="property")t.colonOffset=N,o=!1,t=void 0;else if(g===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(g){if(g!==r)throw g}return{path:n,previousNode:t,isAtPropertyKey:o,matches:g=>{let N=0;for(let T=0;N<g.length&&T<n.length;T++)if(g[N]===n[T]||g[N]==="*")N++;else if(g[N]!=="**")return!1;return N===g.length}}}function p(i,a=[],n=I.DEFAULT){let r=null,t=[];const s=[];function o(g){Array.isArray(t)?t.push(g):r!==null&&(t[r]=g)}return R(i,{onObjectBegin:()=>{const g={};o(g),s.push(t),t=g,r=null},onObjectProperty:g=>{r=g},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const g=[];o(g),s.push(t),t=g,r=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:o,onError:(g,N,T)=>{a.push({error:g,offset:N,length:T})}},n),t[0]}function f(i,a=[],n=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(g){r.type==="property"&&(r.length=g-r.offset,r=r.parent)}function s(g){return r.children.push(g),g}R(i,{onObjectBegin:g=>{r=s({type:"object",offset:g,length:-1,parent:r,children:[]})},onObjectProperty:(g,N,T)=>{r=s({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:g,offset:N,length:T,parent:r})},onObjectEnd:(g,N)=>{r.length=g+N-r.offset,r=r.parent,t(g+N)},onArrayBegin:(g,N)=>{r=s({type:"array",offset:g,length:-1,parent:r,children:[]})},onArrayEnd:(g,N)=>{r.length=g+N-r.offset,r=r.parent,t(g+N)},onLiteralValue:(g,N,T)=>{s({type:y(g),offset:N,length:T,parent:r,value:g}),t(N+T)},onSeparator:(g,N,T)=>{r.type==="property"&&(g===":"?r.colonOffset=N:g===","&&t(N))},onError:(g,N,T)=>{a.push({error:g,offset:N,length:T})}},n);const c=r.children[0];return c&&delete c.parent,c}function m(i,a){if(!i)return;let n=i;for(const r of a)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],t=!0;break}if(!t)return}else{const t=r;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function k(i){if(!i.parent||!i.parent.children)return[];const a=k(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;a.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&a.push(n)}return a}function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const a=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(a[n.children[0].value]=b(r))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function d(i,a,n=!1){return a>=i.offset&&a<i.offset+i.length||n&&a===i.offset+i.length}function $(i,a,n=!1){if(d(i,a,n)){const r=i.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=a;t++){const s=$(r[t],a,n);if(s)return s}return i}}function R(i,a,n=I.DEFAULT){const r=C(i,!1);function t(X){return X?()=>X(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(X){return X?ie=>X(ie,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),c=s(a.onObjectProperty),g=t(a.onObjectEnd),N=t(a.onArrayBegin),T=t(a.onArrayEnd),A=s(a.onLiteralValue),D=s(a.onSeparator),F=t(a.onComment),x=s(a.onError),Y=n&&n.disallowComments,ne=n&&n.allowTrailingComma;function ae(){for(;;){const X=r.scan();switch(r.getTokenError()){case P.InvalidUnicode:ue(v.InvalidUnicode);break;case P.InvalidEscapeCharacter:ue(v.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:ue(v.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:Y||ue(v.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:ue(v.UnexpectedEndOfString);break;case P.InvalidCharacter:ue(v.InvalidCharacter);break}switch(X){case S.LineCommentTrivia:case S.BlockCommentTrivia:Y?ue(v.InvalidCommentToken):F();break;case S.Unknown:ue(v.InvalidSymbol);break;case S.Trivia:case S.LineBreakTrivia:break;default:return X}}}function ue(X,ie=[],se=[]){if(x(X),ie.length+se.length>0){let L=r.getToken();for(;L!==S.EOF;){if(ie.indexOf(L)!==-1){ae();break}else if(se.indexOf(L)!==-1)break;L=ae()}}}function me(X){const ie=r.getTokenValue();return X?A(ie):c(ie),ae(),!0}function W(){switch(r.getToken()){case S.NumericLiteral:{let X=0;try{X=JSON.parse(r.getTokenValue()),typeof X!="number"&&(ue(v.InvalidNumberFormat),X=0)}catch{ue(v.InvalidNumberFormat)}A(X);break}case S.NullKeyword:A(null);break;case S.TrueKeyword:A(!0);break;case S.FalseKeyword:A(!1);break;default:return!1}return ae(),!0}function _(){return r.getToken()!==S.StringLiteral?(ue(v.PropertyNameExpected,[],[S.CloseBraceToken,S.CommaToken]),!1):(me(!1),r.getToken()===S.ColonToken?(D(":"),ae(),H()||ue(v.ValueExpected,[],[S.CloseBraceToken,S.CommaToken])):ue(v.ColonExpected,[],[S.CloseBraceToken,S.CommaToken]),!0)}function M(){o(),ae();let X=!1;for(;r.getToken()!==S.CloseBraceToken&&r.getToken()!==S.EOF;){if(r.getToken()===S.CommaToken){if(X||ue(v.ValueExpected,[],[]),D(","),ae(),r.getToken()===S.CloseBraceToken&&ne)break}else X&&ue(v.CommaExpected,[],[]);_()||ue(v.ValueExpected,[],[S.CloseBraceToken,S.CommaToken]),X=!0}return g(),r.getToken()!==S.CloseBraceToken?ue(v.CloseBraceExpected,[S.CloseBraceToken],[]):ae(),!0}function q(){N(),ae();let X=!1;for(;r.getToken()!==S.CloseBracketToken&&r.getToken()!==S.EOF;){if(r.getToken()===S.CommaToken){if(X||ue(v.ValueExpected,[],[]),D(","),ae(),r.getToken()===S.CloseBracketToken&&ne)break}else X&&ue(v.CommaExpected,[],[]);H()||ue(v.ValueExpected,[],[S.CloseBracketToken,S.CommaToken]),X=!0}return T(),r.getToken()!==S.CloseBracketToken?ue(v.CloseBracketExpected,[S.CloseBracketToken],[]):ae(),!0}function H(){switch(r.getToken()){case S.OpenBracketToken:return q();case S.OpenBraceToken:return M();case S.StringLiteral:return me(!0);default:return W()}}return ae(),r.getToken()===S.EOF?n.allowEmptyContent?!0:(ue(v.ValueExpected,[],[]),!1):H()?(r.getToken()!==S.EOF&&ue(v.EndOfFileExpected,[],[]),!0):(ue(v.ValueExpected,[],[]),!1)}function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[77],he([0,1,34]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=S,e.$_n=v,e.$ao=O,e.$bo=w;function S(l,h,u){let p,f,m,k,b;if(h){for(k=h.offset,b=k+h.length,m=k;m>0&&!w(l,m-1);)m--;let c=b;for(;c<l.length&&!w(l,c);)c++;f=l.substring(m,c),p=C(f,u)}else f=l,p=0,m=0,k=0,b=l.length;const d=O(u,l);let $=!1,R=0,y;u.insertSpaces?y=I(" ",u.tabSize||4):y="	";const i=(0,P.$Zn)(f,!1);let a=!1;function n(){return d+I(y,p+R)}function r(){let c=i.scan();for($=!1;c===P.SyntaxKind.Trivia||c===P.SyntaxKind.LineBreakTrivia;)$=$||c===P.SyntaxKind.LineBreakTrivia,c=i.scan();return a=c===P.SyntaxKind.Unknown||i.getTokenError()!==P.ScanError.None,c}const t=[];function s(c,g,N){!a&&g<b&&N>k&&l.substring(g,N)!==c&&t.push({offset:g,length:N-g,content:c})}let o=r();if(o!==P.SyntaxKind.EOF){const c=i.getTokenOffset()+m,g=I(y,p);s(g,m,c)}for(;o!==P.SyntaxKind.EOF;){let c=i.getTokenOffset()+i.getTokenLength()+m,g=r(),N="";for(;!$&&(g===P.SyntaxKind.LineCommentTrivia||g===P.SyntaxKind.BlockCommentTrivia);){const A=i.getTokenOffset()+m;s(" ",c,A),c=i.getTokenOffset()+i.getTokenLength()+m,N=g===P.SyntaxKind.LineCommentTrivia?n():"",g=r()}if(g===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(R--,N=n());else if(g===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(R--,N=n());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:R++,N=n();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:N=n();break;case P.SyntaxKind.BlockCommentTrivia:$?N=n():N=" ";break;case P.SyntaxKind.ColonToken:N=" ";break;case P.SyntaxKind.StringLiteral:if(g===P.SyntaxKind.ColonToken){N="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:g===P.SyntaxKind.LineCommentTrivia||g===P.SyntaxKind.BlockCommentTrivia?N=" ":g!==P.SyntaxKind.CommaToken&&g!==P.SyntaxKind.EOF&&(a=!0);break;case P.SyntaxKind.Unknown:a=!0;break}$&&(g===P.SyntaxKind.LineCommentTrivia||g===P.SyntaxKind.BlockCommentTrivia)&&(N=n())}const T=i.getTokenOffset()+m;s(N,c,T),o=g}return t}function v(l,h){const u=JSON.stringify(l,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?u.replace(/\r\n|\r|\n/g,h.eol):u}function I(l,h){let u="";for(let p=0;p<h;p++)u+=l;return u}function C(l,h){let u=0,p=0;const f=h.tabSize||4;for(;u<l.length;){const m=l.charAt(u);if(m===" ")p++;else if(m==="	")p+=f;else break;u++}return Math.floor(p/f)}function O(l,h){for(let u=0;u<h.length;u++){const p=h.charAt(u);if(p==="\r")return u+1<h.length&&h.charAt(u+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return l&&l.eol||`
`}function w(l,h){return`\r
`.indexOf(l.charAt(h))!==-1}}),define(le[78],he([0,1,34,77]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=v,e.$do=I,e.$eo=C,e.$fo=O,e.$go=w;function v(l,h,u){return I(l,h,void 0,u)}function I(l,h,u,p,f){const m=h.slice(),k=[],b=(0,P.$3n)(l,k);let d,$;for(;m.length>0&&($=m.pop(),d=(0,P.$4n)(b,m),d===void 0&&u!==void 0);)typeof $=="string"?u={[$]:u}:u=[u];if(d)if(d.type==="object"&&typeof $=="string"&&Array.isArray(d.children)){const R=(0,P.$4n)(d,[$]);if(R!==void 0)if(u===void 0){if(!R.parent)throw new Error("Malformed AST");const y=d.children.indexOf(R.parent);let i,a=R.parent.offset+R.parent.length;if(y>0){const n=d.children[y-1];i=n.offset+n.length}else i=d.offset+1,d.children.length>1&&(a=d.children[1].offset);return C(l,{offset:i,length:a-i,content:""},p)}else return C(l,{offset:R.offset,length:R.length,content:JSON.stringify(u)},p);else{if(u===void 0)return[];const y=`${JSON.stringify($)}: ${JSON.stringify(u)}`,i=f?f(d.children.map(n=>n.children[0].value)):d.children.length;let a;if(i>0){const n=d.children[i-1];a={offset:n.offset+n.length,length:0,content:","+y}}else d.children.length===0?a={offset:d.offset+1,length:0,content:y}:a={offset:d.offset+1,length:0,content:y+","};return C(l,a,p)}}else if(d.type==="array"&&typeof $=="number"&&Array.isArray(d.children))if(u!==void 0){const R=`${JSON.stringify(u)}`;let y;if(d.children.length===0||$===0)y={offset:d.offset+1,length:0,content:d.children.length===0?R:R+","};else{const i=$===-1||$>d.children.length?d.children.length:$,a=d.children[i-1];y={offset:a.offset+a.length,length:0,content:","+R}}return C(l,y,p)}else{const R=$,y=d.children[R];let i;if(d.children.length===1)i={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===R){const a=d.children[R-1],n=a.offset+a.length,r=d.offset+d.length;i={offset:n,length:r-2-n,content:""}}else i={offset:y.offset,length:d.children[R+1].offset-y.offset,content:""};return C(l,i,p)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${d.type}`);else return u===void 0?[]:C(l,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(u)},p)}function C(l,h,u){let p=O(l,h),f=h.offset,m=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;f>0&&!(0,S.$bo)(p,f-1);)f--;for(;m<p.length&&!(0,S.$bo)(p,m);)m++}const k=(0,S.$$n)(p,{offset:f,length:m-f},u);for(let d=k.length-1;d>=0;d--){const $=k[d];p=O(p,$),f=Math.min(f,$.offset),m=Math.max(m,$.offset+$.length),m+=$.content.length-$.length}const b=l.length-(p.length-m)-f;return[{offset:f,length:b,content:p.substring(f,m)}]}function O(l,h){return l.substring(0,h.offset)+h.content+l.substring(h.offset+h.length)}function w(l,h){const u=h.slice(0).sort((f,m)=>{const k=f.offset-m.offset;return k===0?f.length-m.length:k});let p=l.length;for(let f=u.length-1;f>=0;f--){const m=u[f];if(m.offset+m.length<=p)l=O(l,m);else throw new Error("Overlapping edit");p=m.offset}return l}}),define(le[79],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=P;function P(I){let C=!1;const O=new Map,w=new Map;if(v(I,k=>{if(I===k)return!0;const b=JSON.stringify(k);if(b.length<30)return!0;const d=O.get(b);if(!d){const $={schemas:[k]};return O.set(b,$),w.set(k,$),!0}return d.schemas.push(k),w.set(k,d),C=!0,!1}),O.clear(),!C)return JSON.stringify(I);let h="$defs";for(;I.hasOwnProperty(h);)h+="_";const u=[];function p(k){return JSON.stringify(k,(b,d)=>{if(d!==k){const $=w.get(d);if($&&$.schemas.length>1)return $.id||($.id=`_${u.length}`,u.push($.schemas[0])),{$ref:`#/${h}/${$.id}`}}return d})}const f=p(I),m=[];for(let k=0;k<u.length;k++)m.push(`"_${k}":${p(u[k])}`);return m.length?`${f.substring(0,f.length-1)},"${h}":{${m.join(",")}}}`:f}function S(I){return typeof I=="object"&&I!==null}function v(I,C){if(!I||typeof I!="object")return;const O=(...f)=>{for(const m of f)S(m)&&u.push(m)},w=(...f)=>{for(const m of f)if(S(m))for(const k in m){const b=m[k];S(b)&&u.push(b)}},l=(...f)=>{for(const m of f)if(Array.isArray(m))for(const k of m)S(k)&&u.push(k)},h=f=>{if(Array.isArray(f))for(const m of f)S(m)&&u.push(m);else S(f)&&u.push(f)},u=[I];let p=u.pop();for(;p;)C(p)&&(O(p.additionalItems,p.additionalProperties,p.not,p.contains,p.propertyNames,p.if,p.then,p.else,p.unevaluatedItems,p.unevaluatedProperties),w(p.definitions,p.$defs,p.properties,p.patternProperties,p.dependencies,p.dependentSchemas),l(p.anyOf,p.allOf,p.oneOf,p.prefixItems),h(p.items)),p=u.pop()}}),define(le[80],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0,e.$Om=P,e.rot=S,e.$Tm=O;function P(w,l,h){return Math.min(Math.max(w,l),h)}function S(w,l){return(l+w%l)%l}class v{constructor(){this.a=0}getNext(){return this.a++}}e.$Qm=v;class I{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rm=I;class C{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const h=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sm=C;function O(w,l,h,u,p,f,m,k){const b=m-h,d=k-u,$=p-h,R=f-u,y=w-h,i=l-u,a=b*b+d*d,n=b*$+d*R,r=b*y+d*i,t=$*$+R*R,s=$*y+R*i,o=1/(a*t-n*n),c=(t*r-n*s)*o,g=(a*s-n*r)*o;return c>=0&&g>=0&&c+g<1}}),function(){function Z(v){const I=[];typeof v=="number"&&I.push("code/timeOrigin",v);function C(w){I.push(w,Date.now())}function O(){const w=[];for(let l=0;l<I.length;l+=2)w.push({name:I[l],startTime:I[l+1]});return w}return{mark:C,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const C of performance.getEntriesByType("mark"))I.push({name:C.name,startTime:Math.round(v+C.startTime)});return I}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function P(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=P(S))}(),define(le[56],he([0,1,12]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=I,e.$pm=C;var S;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(S||(e.Source=S={}));var v;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(v||(e.TerminateResponseCode=v={}));function I(O,...w){const l=w.reduce((p,f)=>(p[f]=!0,p),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(p=>!l[p]).forEach(p=>{for(let f=0;f<h.length;f++)if(p.search(h[f])!==-1){delete O[p];break}})}function C(O){O&&(delete O.DEBUG,P.$l&&delete O.LD_PRELOAD)}}),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var S in P)(typeof exports=="object"?exports:Z)[S]=P[S]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function P(S){if(e[S])return e[S].exports;var v=e[S]={i:S,l:!1,exports:{}};return Z[S].call(v.exports,v,v.exports,P),v.l=!0,v.exports}return P.m=Z,P.c=e,P.d=function(S,v,I){P.o(S,v)||Object.defineProperty(S,v,{enumerable:!0,get:I})},P.r=function(S){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},P.t=function(S,v){if(1&v&&(S=P(S)),8&v||4&v&&typeof S=="object"&&S&&S.__esModule)return S;var I=Object.create(null);if(P.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:S}),2&v&&typeof S!="string")for(var C in S)P.d(I,C,function(O){return S[O]}.bind(null,C));return I},P.n=function(S){var v=S&&S.__esModule?function(){return S.default}:function(){return S};return P.d(v,"a",v),v},P.o=function(S,v){return Object.prototype.hasOwnProperty.call(S,v)},P.p="",P(P.s=0)}([function(Z,e,P){(function(S){var v;e=Z.exports=L,v=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],w=e.src=[],l=0,h=l++;w[h]="0|[1-9]\\d*";var u=l++;w[u]="[0-9]+";var p=l++;w[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=l++;w[f]="("+w[h]+")\\.("+w[h]+")\\.("+w[h]+")";var m=l++;w[m]="("+w[u]+")\\.("+w[u]+")\\.("+w[u]+")";var k=l++;w[k]="(?:"+w[h]+"|"+w[p]+")";var b=l++;w[b]="(?:"+w[u]+"|"+w[p]+")";var d=l++;w[d]="(?:-("+w[k]+"(?:\\."+w[k]+")*))";var $=l++;w[$]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var R=l++;w[R]="[0-9A-Za-z-]+";var y=l++;w[y]="(?:\\+("+w[R]+"(?:\\."+w[R]+")*))";var i=l++,a="v?"+w[f]+w[d]+"?"+w[y]+"?";w[i]="^"+a+"$";var n="[v=\\s]*"+w[m]+w[$]+"?"+w[y]+"?",r=l++;w[r]="^"+n+"$";var t=l++;w[t]="((?:<|>)?=?)";var s=l++;w[s]=w[u]+"|x|X|\\*";var o=l++;w[o]=w[h]+"|x|X|\\*";var c=l++;w[c]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[d]+")?"+w[y]+"?)?)?";var g=l++;w[g]="[v=\\s]*("+w[s]+")(?:\\.("+w[s]+")(?:\\.("+w[s]+")(?:"+w[$]+")?"+w[y]+"?)?)?";var N=l++;w[N]="^"+w[t]+"\\s*"+w[c]+"$";var T=l++;w[T]="^"+w[t]+"\\s*"+w[g]+"$";var A=l++;w[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=l++;w[D]="(?:~>?)";var F=l++;w[F]="(\\s*)"+w[D]+"\\s+",O[F]=new RegExp(w[F],"g");var x=l++;w[x]="^"+w[D]+w[c]+"$";var Y=l++;w[Y]="^"+w[D]+w[g]+"$";var ne=l++;w[ne]="(?:\\^)";var ae=l++;w[ae]="(\\s*)"+w[ne]+"\\s+",O[ae]=new RegExp(w[ae],"g");var ue=l++;w[ue]="^"+w[ne]+w[c]+"$";var me=l++;w[me]="^"+w[ne]+w[g]+"$";var W=l++;w[W]="^"+w[t]+"\\s*("+n+")$|^$";var _=l++;w[_]="^"+w[t]+"\\s*("+a+")$|^$";var M=l++;w[M]="(\\s*)"+w[t]+"\\s*("+n+"|"+w[c]+")",O[M]=new RegExp(w[M],"g");var q=l++;w[q]="^\\s*("+w[c]+")\\s+-\\s+("+w[c]+")\\s*$";var H=l++;w[H]="^\\s*("+w[g]+")\\s+-\\s+("+w[g]+")\\s*$";var X=l++;w[X]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)v(ie,w[ie]),O[ie]||(O[ie]=new RegExp(w[ie]));function se(B,ee){if(B instanceof L)return B;if(typeof B!="string"||B.length>I||!(ee?O[r]:O[i]).test(B))return null;try{return new L(B,ee)}catch{return null}}function L(B,ee){if(B instanceof L){if(B.loose===ee)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof L))return new L(B,ee);v("SemVer",B,ee),this.loose=ee;var te=B.trim().match(ee?O[r]:O[i]);if(!te)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var Pe=+ge;if(Pe>=0&&Pe<C)return Pe}return ge}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=se,e.valid=function(B,ee){var te=se(B,ee);return te?te.version:null},e.clean=function(B,ee){var te=se(B.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(B){return v("SemVer.compare",this.version,this.loose,B),B instanceof L||(B=new L(B,this.loose)),this.compareMain(B)||this.comparePre(B)},L.prototype.compareMain=function(B){return B instanceof L||(B=new L(B,this.loose)),z(this.major,B.major)||z(this.minor,B.minor)||z(this.patch,B.patch)},L.prototype.comparePre=function(B){if(B instanceof L||(B=new L(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],ge=B.prerelease[ee];if(v("prerelease compare",ee,te,ge),te===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(te===void 0)return-1;if(te!==ge)return z(te,ge)}while(++ee)},L.prototype.inc=function(B,ee){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,ee,te,ge){typeof te=="string"&&(ge=te,te=void 0);try{return new L(B,te).inc(ee,ge).version}catch{return null}},e.diff=function(B,ee){if(J(B,ee))return null;var te=se(B),ge=se(ee);if(te.prerelease.length||ge.prerelease.length){for(var Pe in te)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&te[Pe]!==ge[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in te)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&te[Pe]!==ge[Pe])return Pe},e.compareIdentifiers=z;var V=/^[0-9]+$/;function z(B,ee){var te=V.test(B),ge=V.test(ee);return te&&ge&&(B=+B,ee=+ee),te&&!ge?-1:ge&&!te?1:B<ee?-1:B>ee?1:0}function E(B,ee,te){return new L(B,te).compare(new L(ee,te))}function j(B,ee,te){return E(B,ee,te)>0}function Q(B,ee,te){return E(B,ee,te)<0}function J(B,ee,te){return E(B,ee,te)===0}function G(B,ee,te){return E(B,ee,te)!==0}function U(B,ee,te){return E(B,ee,te)>=0}function K(B,ee,te){return E(B,ee,te)<=0}function re(B,ee,te,ge){var Pe;switch(ee){case"===":typeof B=="object"&&(B=B.version),typeof te=="object"&&(te=te.version),Pe=B===te;break;case"!==":typeof B=="object"&&(B=B.version),typeof te=="object"&&(te=te.version),Pe=B!==te;break;case"":case"=":case"==":Pe=J(B,te,ge);break;case"!=":Pe=G(B,te,ge);break;case">":Pe=j(B,te,ge);break;case">=":Pe=U(B,te,ge);break;case"<":Pe=Q(B,te,ge);break;case"<=":Pe=K(B,te,ge);break;default:throw new TypeError("Invalid operator: "+ee)}return Pe}function ce(B,ee){if(B instanceof ce){if(B.loose===ee)return B;B=B.value}if(!(this instanceof ce))return new ce(B,ee);v("comparator",B,ee),this.loose=ee,this.parse(B),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(B,ee){return z(ee,B)},e.major=function(B,ee){return new L(B,ee).major},e.minor=function(B,ee){return new L(B,ee).minor},e.patch=function(B,ee){return new L(B,ee).patch},e.compare=E,e.compareLoose=function(B,ee){return E(B,ee,!0)},e.rcompare=function(B,ee,te){return E(ee,B,te)},e.sort=function(B,ee){return B.sort(function(te,ge){return e.compare(te,ge,ee)})},e.rsort=function(B,ee){return B.sort(function(te,ge){return e.rcompare(te,ge,ee)})},e.gt=j,e.lt=Q,e.eq=J,e.neq=G,e.gte=U,e.lte=K,e.cmp=re,e.Comparator=ce;var fe={};function we(B,ee){if(B instanceof we)return B.loose===ee?B:new we(B.raw,ee);if(B instanceof ce)return new we(B.value,ee);if(!(this instanceof we))return new we(B,ee);if(this.loose=ee,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function de(B){return!B||B.toLowerCase()==="x"||B==="*"}function pe(B,ee,te,ge,Pe,Ae,ke,Te,Re,Ce,qe,De,Le){return((ee=de(te)?"":de(ge)?">="+te+".0.0":de(Pe)?">="+te+"."+ge+".0":">="+ee)+" "+(Te=de(Re)?"":de(Ce)?"<"+(+Re+1)+".0.0":de(qe)?"<"+Re+"."+(+Ce+1)+".0":De?"<="+Re+"."+Ce+"."+qe+"-"+De:"<="+Te)).trim()}function ye(B,ee){for(var te=0;te<B.length;te++)if(!B[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<B.length;te++)if(v(B[te].semver),B[te].semver!==fe&&B[te].semver.prerelease.length>0){var ge=B[te].semver;if(ge.major===ee.major&&ge.minor===ee.minor&&ge.patch===ee.patch)return!0}return!1}return!0}function $e(B,ee,te){try{ee=new we(ee,te)}catch{return!1}return ee.test(B)}function ve(B,ee,te,ge){var Pe,Ae,ke,Te,Re;switch(B=new L(B,ge),ee=new we(ee,ge),te){case">":Pe=j,Ae=K,ke=Q,Te=">",Re=">=";break;case"<":Pe=Q,Ae=U,ke=j,Te="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(B,ee,ge))return!1;for(var Ce=0;Ce<ee.set.length;++Ce){var qe=ee.set[Ce],De=null,Le=null;if(qe.forEach(function(je){je.semver===fe&&(je=new ce(">=0.0.0")),De=De||je,Le=Le||je,Pe(je.semver,De.semver,ge)?De=je:ke(je.semver,Le.semver,ge)&&(Le=je)}),De.operator===Te||De.operator===Re||(!Le.operator||Le.operator===Te)&&Ae(B,Le.semver)||Le.operator===Re&&ke(B,Le.semver))return!1}return!0}ce.prototype.parse=function(B){var ee=this.loose?O[W]:O[_],te=B.match(ee);if(!te)throw new TypeError("Invalid comparator: "+B);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new L(te[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(B){return v("Comparator.test",B,this.loose),this.semver===fe||(typeof B=="string"&&(B=new L(B,this.loose)),re(B,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(B,ee){if(!(B instanceof ce))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new we(B.value,ee),$e(this.value,te,ee);if(B.operator==="")return te=new we(this.value,ee),$e(B.semver,te,ee);var ge=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ae=this.semver.version===B.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Te=re(this.semver,"<",B.semver,ee)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Re=re(this.semver,">",B.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ge||Pe||Ae&&ke||Te||Re},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(B){var ee=this.loose;B=B.trim(),v("range",B,ee);var te=ee?O[H]:O[q];B=B.replace(te,pe),v("hyphen replace",B),B=B.replace(O[M],"$1$2$3"),v("comparator trim",B,O[M]),B=(B=(B=B.replace(O[F],"$1~")).replace(O[ae],"$1^")).split(/\s+/).join(" ");var ge=ee?O[W]:O[_],Pe=B.split(" ").map(function(Ae){return function(ke,Te){return v("comp",ke),ke=function(Re,Ce){return Re.trim().split(/\s+/).map(function(qe){return function(De,Le){v("caret",De,Le);var je=Le?O[me]:O[ue];return De.replace(je,function(Ue,Se,Ie,Oe,Ne){var Fe;return v("caret",De,Ue,Se,Ie,Oe,Ne),de(Se)?Fe="":de(Ie)?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":de(Oe)?Fe=Se==="0"?">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+".0 <"+(+Se+1)+".0.0":Ne?(v("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Fe=Se==="0"?Ie==="0"?">="+Se+"."+Ie+"."+Oe+Ne+" <"+Se+"."+Ie+"."+(+Oe+1):">="+Se+"."+Ie+"."+Oe+Ne+" <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+"."+Oe+Ne+" <"+(+Se+1)+".0.0"):(v("no pr"),Fe=Se==="0"?Ie==="0"?">="+Se+"."+Ie+"."+Oe+" <"+Se+"."+Ie+"."+(+Oe+1):">="+Se+"."+Ie+"."+Oe+" <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+"."+Oe+" <"+(+Se+1)+".0.0"),v("caret return",Fe),Fe})}(qe,Ce)}).join(" ")}(ke,Te),v("caret",ke),ke=function(Re,Ce){return Re.trim().split(/\s+/).map(function(qe){return function(De,Le){var je=Le?O[Y]:O[x];return De.replace(je,function(Ue,Se,Ie,Oe,Ne){var Fe;return v("tilde",De,Ue,Se,Ie,Oe,Ne),de(Se)?Fe="":de(Ie)?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":de(Oe)?Fe=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0":Ne?(v("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Fe=">="+Se+"."+Ie+"."+Oe+Ne+" <"+Se+"."+(+Ie+1)+".0"):Fe=">="+Se+"."+Ie+"."+Oe+" <"+Se+"."+(+Ie+1)+".0",v("tilde return",Fe),Fe})}(qe,Ce)}).join(" ")}(ke,Te),v("tildes",ke),ke=function(Re,Ce){return v("replaceXRanges",Re,Ce),Re.split(/\s+/).map(function(qe){return function(De,Le){De=De.trim();var je=Le?O[T]:O[N];return De.replace(je,function(Ue,Se,Ie,Oe,Ne,Fe){v("xRange",De,Ue,Se,Ie,Oe,Ne,Fe);var Ve=de(Ie),Me=Ve||de(Oe),Be=Me||de(Ne);return Se==="="&&Be&&(Se=""),Ve?Ue=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Be?(Me&&(Oe=0),Be&&(Ne=0),Se===">"?(Se=">=",Me?(Ie=+Ie+1,Oe=0,Ne=0):Be&&(Oe=+Oe+1,Ne=0)):Se==="<="&&(Se="<",Me?Ie=+Ie+1:Oe=+Oe+1),Ue=Se+Ie+"."+Oe+"."+Ne):Me?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),v("xRange return",Ue),Ue})}(qe,Ce)}).join(" ")}(ke,Te),v("xrange",ke),ke=function(Re,Ce){return v("replaceStars",Re,Ce),Re.trim().replace(O[X],"")}(ke,Te),v("stars",ke),ke}(Ae,ee)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(ge)})),Pe=Pe.map(function(Ae){return new ce(Ae,ee)})},we.prototype.intersects=function(B,ee){if(!(B instanceof we))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(ge){return B.set.some(function(Pe){return Pe.every(function(Ae){return ge.intersects(Ae,ee)})})})})},e.toComparators=function(B,ee){return new we(B,ee).set.map(function(te){return te.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},we.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new L(B,this.loose));for(var ee=0;ee<this.set.length;ee++)if(ye(this.set[ee],B))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(B,ee,te){var ge=null,Pe=null;try{var Ae=new we(ee,te)}catch{return null}return B.forEach(function(ke){Ae.test(ke)&&(ge&&Pe.compare(ke)!==-1||(Pe=new L(ge=ke,te)))}),ge},e.minSatisfying=function(B,ee,te){var ge=null,Pe=null;try{var Ae=new we(ee,te)}catch{return null}return B.forEach(function(ke){Ae.test(ke)&&(ge&&Pe.compare(ke)!==1||(Pe=new L(ge=ke,te)))}),ge},e.validRange=function(B,ee){try{return new we(B,ee).range||"*"}catch{return null}},e.ltr=function(B,ee,te){return ve(B,ee,"<",te)},e.gtr=function(B,ee,te){return ve(B,ee,">",te)},e.outside=ve,e.prerelease=function(B,ee){var te=se(B,ee);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(B,ee,te){return B=new we(B,te),ee=new we(ee,te),B.intersects(ee)},e.coerce=function(B){if(B instanceof L)return B;if(typeof B!="string")return null;var ee=B.match(O[A]);return ee==null?null:se((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,P(1))},function(Z,e){var P,S,v=Z.exports={};function I(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function O(b){if(P===setTimeout)return setTimeout(b,0);if((P===I||!P)&&setTimeout)return P=setTimeout,setTimeout(b,0);try{return P(b,0)}catch{try{return P.call(null,b,0)}catch{return P.call(this,b,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:I}catch{P=I}try{S=typeof clearTimeout=="function"?clearTimeout:C}catch{S=C}})();var w,l=[],h=!1,u=-1;function p(){h&&w&&(h=!1,w.length?l=w.concat(l):u=-1,l.length&&f())}function f(){if(!h){var b=O(p);h=!0;for(var d=l.length;d;){for(w=l,l=[];++u<d;)w&&w[u].run();u=-1,d=l.length}w=null,h=!1,function($){if(S===clearTimeout)return clearTimeout($);if((S===C||!S)&&clearTimeout)return S=clearTimeout,clearTimeout($);try{S($)}catch{try{return S.call(null,$)}catch{return S.call(this,$)}}}(b)}}function m(b,d){this.fun=b,this.array=d}function k(){}v.nextTick=function(b){var d=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)d[$-1]=arguments[$];l.push(new m(b,d)),l.length!==1||h||O(f)},m.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=k,v.addListener=k,v.once=k,v.off=k,v.removeListener=k,v.removeAllListeners=k,v.emit=k,v.prependListener=k,v.prependOnceListener=k,v.listeners=function(b){return[]},v.binding=function(b){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(b){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(le[81],he([0,1]),function(Z,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;class S{constructor(O,w,l){this.level=O,this.key=w,this.value=l,this.forward=[]}}const v=void 0;class I{constructor(O,w=2**16){this.comparator=O,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new S(this.c,v,v)}get size(){return this.f}clear(){this.e=new S(this.c,v,v),this.f=0}has(O){return!!I.g(this,O,this.comparator)}get(O){return I.g(this,O,this.comparator)?.value}set(O,w){return I.h(this,O,w,this.comparator)&&(this.f+=1),this}delete(O){const w=I.k(this,O,this.comparator);return w&&(this.f-=1),w}forEach(O,w){let l=this.e.forward[0];for(;l;)O.call(w,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",w=this.e.forward[0];for(;w;)O+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return O}static g(O,w,l){let h=O.e;for(let u=O.d-1;u>=0;u--)for(;h.forward[u]&&l(h.forward[u].key,w)<0;)h=h.forward[u];if(h=h.forward[0],h&&l(h.key,w)===0)return h}static h(O,w,l,h){const u=[];let p=O.e;for(let f=O.d-1;f>=0;f--){for(;p.forward[f]&&h(p.forward[f].key,w)<0;)p=p.forward[f];u[f]=p}if(p=p.forward[0],p&&h(p.key,w)===0)return p.value=l,!1;{const f=I.j(O);if(f>O.d){for(let m=O.d;m<f;m++)u[m]=O.e;O.d=f}p=new S(f,w,l);for(let m=0;m<f;m++)p.forward[m]=u[m].forward[m],u[m].forward[m]=p;return!0}}static j(O,w=.5){let l=1;for(;Math.random()<w&&l<O.c;)l+=1;return l}static k(O,w,l){const h=[];let u=O.e;for(let p=O.d-1;p>=0;p--){for(;u.forward[p]&&l(u.forward[p].key,w)<0;)u=u.forward[p];h[p]=u}if(u=u.forward[0],!u||l(u.key,w)!==0)return!1;for(let p=0;p<O.d&&h[p].forward[p]===u;p++)h[p].forward[p]=u.forward[p];for(;O.d>0&&O.e.forward[O.d-1]===v;)O.d-=1;return!0}}e.$Ys=I}),define(le[47],he([0,1,7,2]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=v,e.$Ce=I,e.$De=C,e.$Ee=O,e.$Fe=l,e.$Ge=h,e.$He=u,e.$Ie=p,e.$Je=f,e.$Ke=m,e.$Le=k,e.$Me=b,e.$Ne=d,e.$Oe=$,e.$Pe=R;function v(y){const i=y;return i?typeof i.read=="function":!1}function I(y){const i=y;return i?[i.on,i.pause,i.resume,i.destroy].every(a=>typeof a=="function"):!1}function C(y){const i=y;return i?I(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function O(y,i){return new w(y,i)}class w{constructor(i,a){this.e=i,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(a=>a(i))}h(i){this.c.error.length===0?(0,P.$2)(i):this.c.error.slice(0).forEach(a=>a(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,a){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(i,a){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(a);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(y,i){const a=[];let n;for(;(n=y.read())!==null;)a.push(n);return i(a)}function h(y,i,a){const n=[];let r;for(;(r=y.read())!==null&&n.length<a;)n.push(r);return r===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return y.read()}}}function u(y,i){return new Promise((a,n)=>{const r=[];p(y,{onData:t=>{i&&r.push(t)},onError:t=>{i?n(t):a(void 0)},onEnd:()=>{a(i?i(r):void 0)}})})}function p(y,i,a){y.on("error",n=>{a?.isCancellationRequested||i.onError(n)}),y.on("end",()=>{a?.isCancellationRequested||i.onEnd()}),y.on("data",n=>{a?.isCancellationRequested||i.onData(n)})}function f(y,i){return new Promise((a,n)=>{const r=new S.$Wc,t=[],s=g=>{if(t.push(g),t.length>i)return r.dispose(),y.pause(),a({stream:y,buffer:t,ended:!1})},o=g=>(r.dispose(),n(g)),c=()=>(r.dispose(),a({stream:y,buffer:t,ended:!0}));r.add((0,S.$Vc)(()=>y.removeListener("error",o))),y.on("error",o),r.add((0,S.$Vc)(()=>y.removeListener("end",c))),y.on("end",c),r.add((0,S.$Vc)(()=>y.removeListener("data",s))),y.on("data",s)})}function m(y,i){const a=O(i);return a.end(y),a}function k(){const y=O(()=>{throw new Error("not supported")});return y.end(),y}function b(y){let i=!1;return{read:()=>i?null:(i=!0,y)}}function d(y,i,a){const n=O(a);return p(y,{onData:r=>n.write(i.data(r)),onError:r=>n.error(i.error?i.error(r):r),onEnd:()=>n.end()}),n}function $(y,i,a){let n=!1;return{read:()=>{const r=i.read();return n?r:(n=!0,r!==null?a([y,r]):y)}}}function R(y,i,a){let n=!1;const r=O(a);return p(i,{onData:t=>n?r.write(t):(n=!0,r.write(a([y,t]))),onError:t=>r.error(t),onEnd:()=>{n||(n=!0,r.write(y)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(Z,e,P,S){S===void 0&&(S=P);var v=Object.getOwnPropertyDescriptor(e,P);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(Z,S,v)}:function(Z,e,P,S){S===void 0&&(S=P),Z[S]=e[P]}),xe=this&&this.__setModuleDefault||(Object.create?function(Z,e){Object.defineProperty(Z,"default",{enumerable:!0,value:e})}:function(Z,e){Z.default=e}),be=this&&this.__importStar||function(Z){if(Z&&Z.__esModule)return Z;var e={};if(Z!=null)for(var P in Z)P!=="default"&&Object.prototype.hasOwnProperty.call(Z,P)&&We(e,Z,P);return xe(e,Z),e};define(le[13],he([0,1,147,47]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=l,e.$Se=h,e.$Te=u,e.$Ue=p,e.$Ve=f,e.$We=m,e.$Xe=k,e.$Ye=b,e.$Ze=d,e.$1e=$,e.$2e=R,e.$3e=y,e.$4e=i,e.$5e=a,e.$6e=n,e.$7e=r,e.$8e=t,e.$9e=s,e.$0e=o,e.$$e=N,S=be(S);const v=typeof Buffer<"u",I=new P.$W(()=>new Uint8Array(256));let C,O;class w{static alloc(A){return v?new w(Buffer.allocUnsafe(A)):new w(new Uint8Array(A))}static wrap(A){return v&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new w(A)}static fromString(A,D){return!(D?.dontUseNodeBuffer||!1)&&v?new w(Buffer.from(A)):(C||(C=new TextEncoder),new w(C.encode(A)))}static fromByteArray(A){const D=w.alloc(A.length);for(let F=0,x=A.length;F<x;F++)D.buffer[F]=A[F];return D}static concat(A,D){if(typeof D>"u"){D=0;for(let Y=0,ne=A.length;Y<ne;Y++)D+=A[Y].byteLength}const F=w.alloc(D);let x=0;for(let Y=0,ne=A.length;Y<ne;Y++){const ae=A[Y];F.set(ae,x),x+=ae.byteLength}return F}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=w.alloc(this.byteLength);return A.set(this),A}toString(){return v?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(A,D){return new w(this.buffer.subarray(A,D))}set(A,D){if(A instanceof w)this.buffer.set(A.buffer,D);else if(A instanceof Uint8Array)this.buffer.set(A,D);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),D);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return p(this.buffer,A)}writeUInt32BE(A,D){f(this.buffer,A,D)}readUInt32LE(A){return m(this.buffer,A)}writeUInt32LE(A,D){k(this.buffer,A,D)}readUInt8(A){return b(this.buffer,A)}writeUInt8(A,D){d(this.buffer,A,D)}indexOf(A,D=0){return l(this.buffer,A instanceof w?A.buffer:A,D)}}e.$Qe=w;function l(T,A,D=0){const F=A.byteLength,x=T.byteLength;if(F===0)return 0;if(F===1)return T.indexOf(A[0]);if(F>x-D)return-1;const Y=I.value;Y.fill(A.length);for(let me=0;me<A.length;me++)Y[A[me]]=A.length-me-1;let ne=D+A.length-1,ae=ne,ue=-1;for(;ne<x;)if(T[ne]===A[ae]){if(ae===0){ue=ne;break}ne--,ae--}else ne+=Math.max(A.length-ae,Y[T[ne]]),ae=A.length-1;return ue}function h(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0}function u(T,A,D){T[D+0]=A&255,A=A>>>8,T[D+1]=A&255}function p(T,A){return T[A]*2**24+T[A+1]*2**16+T[A+2]*2**8+T[A+3]}function f(T,A,D){T[D+3]=A,A=A>>>8,T[D+2]=A,A=A>>>8,T[D+1]=A,A=A>>>8,T[D]=A}function m(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0|T[A+2]<<16>>>0|T[A+3]<<24>>>0}function k(T,A,D){T[D+0]=A&255,A=A>>>8,T[D+1]=A&255,A=A>>>8,T[D+2]=A&255,A=A>>>8,T[D+3]=A&255}function b(T,A){return T[A]}function d(T,A,D){T[D]=A}function $(T){return S.$Fe(T,A=>w.concat(A))}function R(T){return S.$Me(T)}function y(T){return S.$He(T,A=>w.concat(A))}async function i(T){return T.ended?w.concat(T.buffer):w.concat([...T.buffer,await y(T.stream)])}function a(T){return S.$Ke(T,A=>w.concat(A))}function n(T){return S.$Ne(T,{data:A=>typeof A=="string"?w.fromString(A):w.wrap(A)},A=>w.concat(A))}function r(T){return S.$Ee(A=>w.concat(A),T)}function t(T,A){return S.$Oe(T,A,D=>w.concat(D))}function s(T,A){return S.$Pe(T,A,D=>w.concat(D))}function o(T){let A=0,D=0,F=0;const x=new Uint8Array(Math.floor(T.length/4*3)),Y=ae=>{switch(D){case 3:x[F++]=A|ae,D=0;break;case 2:x[F++]=A|ae>>>2,A=ae<<6,D=3;break;case 1:x[F++]=A|ae>>>4,A=ae<<4,D=2;break;default:A=ae<<2,D=1}};for(let ae=0;ae<T.length;ae++){const ue=T.charCodeAt(ae);if(ue>=65&&ue<=90)Y(ue-65);else if(ue>=97&&ue<=122)Y(ue-97+26);else if(ue>=48&&ue<=57)Y(ue-48+52);else if(ue===43||ue===45)Y(62);else if(ue===47||ue===95)Y(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ae]}`)}}const ne=F;for(;D>0;)Y(0);return w.wrap(x).slice(0,ne)}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:T},A=!0,D=!1){const F=D?g:c;let x="";const Y=T.byteLength%3;let ne=0;for(;ne<T.byteLength-Y;ne+=3){const ae=T[ne+0],ue=T[ne+1],me=T[ne+2];x+=F[ae>>>2],x+=F[(ae<<4|ue>>>4)&63],x+=F[(ue<<2|me>>>6)&63],x+=F[me&63]}if(Y===1){const ae=T[ne+0];x+=F[ae>>>2],x+=F[ae<<4&63],A&&(x+="==")}else if(Y===2){const ae=T[ne+0],ue=T[ne+1];x+=F[ae>>>2],x+=F[(ae<<4|ue>>>4)&63],x+=F[ue<<2&63],A&&(x+="=")}return x}}),define(le[27],he([0,1,3]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=S,e.$io=v,e.$jo=C,e.$ko=w,e.$lo=l,e.$mo=h,e.$no=u,e.$oo=p,e.$po=f,e.$qo=m,e.$ro=k,e.$so=b,e.$to=d;function S($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const R=Array.isArray($)?[]:{};return Object.entries($).forEach(([y,i])=>{R[y]=i&&typeof i=="object"?S(i):i}),R}function v($){if(!$||typeof $!="object")return $;const R=[$];for(;R.length>0;){const y=R.shift();Object.freeze(y);for(const i in y)if(I.call(y,i)){const a=y[i];typeof a=="object"&&!Object.isFrozen(a)&&!(0,P.$kg)(a)&&R.push(a)}}return $}const I=Object.prototype.hasOwnProperty;function C($,R){return O($,R,new Set)}function O($,R,y){if((0,P.$qg)($))return $;const i=R($);if(typeof i<"u")return i;if(Array.isArray($)){const a=[];for(const n of $)a.push(O(n,R,y));return a}if((0,P.$jg)($)){if(y.has($))throw new Error("Cannot clone recursive data-structure");y.add($);const a={};for(const n in $)I.call($,n)&&(a[n]=O($[n],R,y));return y.delete($),a}return $}function w($,R,y=!0){return(0,P.$jg)($)?((0,P.$jg)(R)&&Object.keys(R).forEach(i=>{i in $?y&&((0,P.$jg)($[i])&&(0,P.$jg)(R[i])?w($[i],R[i],y):$[i]=R[i]):$[i]=R[i]}),$):R}function l($,R){if($===R)return!0;if($==null||R===null||R===void 0||typeof $!=typeof R||typeof $!="object"||Array.isArray($)!==Array.isArray(R))return!1;let y,i;if(Array.isArray($)){if($.length!==R.length)return!1;for(y=0;y<$.length;y++)if(!l($[y],R[y]))return!1}else{const a=[];for(i in $)a.push(i);a.sort();const n=[];for(i in R)n.push(i);if(n.sort(),!l(a,n))return!1;for(y=0;y<a.length;y++)if(!l($[a[y]],R[a[y]]))return!1}return!0}function h($){const R=new Set;return JSON.stringify($,(y,i)=>{if((0,P.$jg)(i)||Array.isArray(i)){if(R.has(i))return"[Circular]";R.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function u($,R){const y=Object.create(null);return!$||!R||Object.keys(R).forEach(a=>{const n=$[a],r=R[a];l(n,r)||(y[a]=r)}),y}function p($,R){const y=R.toLowerCase(),i=Object.keys($).find(a=>a.toLowerCase()===y);return i?$[i]:$[R]}function f($,R){const y=Object.create(null);for(const[i,a]of Object.entries($))R(i,a)&&(y[i]=a);return y}function m($){let R=[];for(;Object.prototype!==$;)R=R.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return R}function k($){const R=[];for(const y of m($))typeof $[y]=="function"&&R.push(y);return R}function b($,R){const y=a=>function(){const n=Array.prototype.slice.call(arguments,0);return R(a,n)},i={};for(const a of $)i[a]=y(a);return i}function d($,R){const y={};for(const[i,a]of Object.entries($))y[i]=R(a,i);return y}}),define(le[43],he([0,1,31]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Aj=void 0,e.$wj=S,e.$xj=v,e.$yj=I,e.$zj=O,e.$Bj=k,P=be(P);function S(d){return v(d,0)}function v(d,$){switch(typeof d){case"object":return d===null?I(349,$):Array.isArray(d)?w(d,$):l(d,$);case"string":return O(d,$);case"boolean":return C(d,$);case"number":return I(d,$);case"undefined":return I(937,$);default:return I(617,$)}}function I(d,$){return($<<5)-$+d|0}function C(d,$){return I(d?433:863,$)}function O(d,$){$=I(149417,$);for(let R=0,y=d.length;R<y;R++)$=I(d.charCodeAt(R),$);return $}function w(d,$){return $=I(104579,$),d.reduce((R,y)=>v(y,R),$)}function l(d,$){return $=I(181387,$),Object.keys(d).sort().reduce((R,y)=>(R=O(y,R),v(d[y],R)),$)}class h{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=v($,this.g),this.g}}e.$Aj=h;var u;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function p(d,$,R=32){const y=R-$,i=~((1<<y)-1);return(d<<$|(i&d)>>>y)>>>0}function f(d,$=0,R=d.byteLength,y=0){for(let i=0;i<R;i++)d[$+i]=y}function m(d,$,R="0"){for(;d.length<$;)d=R+d;return d}function k(d,$=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(R=>R.toString(16).padStart(2,"0")).join(""):m((d>>>0).toString(16),$/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const R=$.length;if(R===0)return;const y=this.p;let i=this.r,a=this.u,n,r;for(a!==0?(n=a,r=-1,a=0):(n=$.charCodeAt(0),r=0);;){let t=n;if(P.$Mf(n))if(r+1<R){const s=$.charCodeAt(r+1);P.$Nf(s)?(r++,t=P.$Of(n,s)):t=u.UNICODE_REPLACEMENT}else{a=n;break}else P.$Nf(n)&&(t=u.UNICODE_REPLACEMENT);if(i=this.w(y,i,t),r++,r<R)n=$.charCodeAt(r);else break}this.r=i,this.u=a}w($,R,y){return y<128?$[R++]=y:y<2048?($[R++]=192|(y&1984)>>>6,$[R++]=128|(y&63)>>>0):y<65536?($[R++]=224|(y&61440)>>>12,$[R++]=128|(y&4032)>>>6,$[R++]=128|(y&63)>>>0):($[R++]=240|(y&1835008)>>>18,$[R++]=128|(y&258048)>>>12,$[R++]=128|(y&4032)>>>6,$[R++]=128|(y&63)>>>0),R>=u.BLOCK_SIZE&&(this.y(),R-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,$[0]=$[u.BLOCK_SIZE+0],$[1]=$[u.BLOCK_SIZE+1],$[2]=$[u.BLOCK_SIZE+2]),R}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),k(this.h)+k(this.l)+k(this.m)+k(this.n)+k(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=b.g,R=this.q;for(let c=0;c<64;c+=4)$.setUint32(c,R.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)$.setUint32(c,p($.getUint32(c-12,!1)^$.getUint32(c-32,!1)^$.getUint32(c-56,!1)^$.getUint32(c-64,!1),1),!1);let y=this.h,i=this.l,a=this.m,n=this.n,r=this.o,t,s,o;for(let c=0;c<80;c++)c<20?(t=i&a|~i&n,s=1518500249):c<40?(t=i^a^n,s=1859775393):c<60?(t=i&a|i&n|a&n,s=2400959708):(t=i^a^n,s=3395469782),o=p(y,5)+t+r+s+$.getUint32(c*4,!1)&4294967295,r=n,n=a,a=p(i,30),i=y,y=o;this.h=this.h+y&4294967295,this.l=this.l+i&4294967295,this.m=this.m+a&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.$Cj=b}),define(le[57],he([0,1,31]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=be(P);var S;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(S||(S={})),function(v){const I="error",C="warning",O="warn",w="info",l="ignore";function h(p){return p?P.$If(I,p)?v.Error:P.$If(C,p)||P.$If(O,p)?v.Warning:P.$If(w,p)?v.Info:v.Ignore:v.Ignore}v.fromValue=h;function u(p){switch(p){case v.Error:return I;case v.Warning:return C;case v.Info:return w;default:return l}}v.toString=u}(S||(S={})),e.default=S}),define(le[82],he([0,1,11]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=S,e.$jr=v,e.$kr=I,e.log=O;function S(l){const h=l;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function v(l){const h=[];let u;try{const p=JSON.parse(l.arguments),f=p[p.length-1];f&&f.__$stack&&(p.pop(),u=f.__$stack),h.push(...p)}catch{h.push("Unable to log remote console arguments",l.arguments)}return{args:h,stack:u}}function I(l){if(typeof l!="string")return I(v(l).stack);const h=l;if(h){const u=C(h),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(p&&p.length===4)return{uri:P.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function C(l){if(!l)return l;const h=l.indexOf(`
`);return h===-1?l:l.substring(0,h)}function O(l,h){const{args:u,stack:p}=v(l),f=typeof u[0]=="string"&&u.length===1;let m=C(p);m&&(m=`(${m.trim()})`);let k=[];if(typeof u[0]=="string"?m&&f?k=[`%c[${h}] %c${u[0]} %c${m}`,w("blue"),w(""),w("grey")]:k=[`%c[${h}] %c${u[0]}`,w("blue"),w(""),...u.slice(1)]:k=[`%c[${h}]%`,w("blue"),...u],m&&!f&&k.push(m),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,k)}function w(l){return`color: ${l}`}}),define(le[48],he([0,1,13,11,148]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=I,e.$ei=C,e.$fi=w;function I(l){return JSON.stringify(l,O)}function C(l){let h=JSON.parse(l);return h=w(h),h}function O(l,h){return h instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:h.source,flags:h.flags}:h}function w(l,h=0){if(!l||h>200)return l;if(typeof l=="object"){switch(l.$mid){case v.MarshalledId.Uri:return S.URI.revive(l);case v.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case v.MarshalledId.Date:return new Date(l.source)}if(l instanceof P.$Qe||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let u=0;u<l.length;++u)l[u]=w(l[u],h+1);else for(const u in l)Object.hasOwnProperty.call(l,u)&&(l[u]=w(l[u],h+1))}return l}}),define(le[58],he([0,1,75,14,12,3,11]),function(Z,e,P,S,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=u,e.$xq=p,v=be(v);class O{constructor(m,k,b){this.id=m,this.dependencies=k,this.callback=b}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,k,b)=>{typeof m!="string"&&(b=k,k=m,m=null),(typeof k!="object"||!Array.isArray(k))&&(b=k,k=null),this.c.push(new O(m,k,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const k=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!k){console.warn(`Did not receive a define call from script ${m}`);return}if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(m){return new Promise((k,b)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const $=()=>{d.removeEventListener("load",R),d.removeEventListener("error",y)},R=i=>{$(),k(this.c.pop())},y=i=>{$(),b(i)};d.addEventListener("load",R),d.addEventListener("error",y),this.f&&(m=this.f.createScriptURL(m)),d.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(d)})}async i(m){return this.f&&(m=this.f.createScriptURL(m)),P.$T?await new Promise((k,b)=>{Z([m],k,b)}).then(be):importScripts(m),this.c.pop()}async j(m){try{const k=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,$=C.URI.parse(m).fsPath,R=k.readFileSync($).toString(),y=d.wrap(R.replace(/^#!.*/,""));return new b.Script(y).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const l=new Map;let h={};typeof globalThis.require=="object"&&(h=globalThis.require.paths??{});async function u(f,m,k){if(P.$T){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),h[f]&&(f=h[f]);const b=m?`${f}/${m}`:f;if(l.has(b))return l.get(b);let d;if(/^\w[\w\d+.-]*:\/\//.test(b))d=b;else{const i=`${P.$U&&k&&!v.$p?S.$Zg:S.$Yg}/${b}`;d=S.$3g.asBrowserUri(i).toString(!0)}const $=w.INSTANCE.load(d);return l.set(b,$),$}else return await new Promise((b,d)=>{Z([f],b,d)}).then(be)}function p(f,m){(0,I.$rg)(P.$T);const b=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,d=P.$U&&b&&!v.$p,$=`${f}/${m}`,y=`${d?S.$Zg:S.$Yg}/${$}`;return S.$3g.asBrowserUri(y).toString(!0)}}),define(le[28],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=S;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(v){return P.test(v)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(O){for(let w=0;w<O.length;w++)O[w]=Math.floor(Math.random()*256);return O};const I=new Uint8Array(16),C=[];for(let O=0;O<256;O++)C.push(O.toString(16).padStart(2,"0"));return function(){v(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let w=0,l="";return l+=C[I[w++]],l+=C[I[w++]],l+=C[I[w++]],l+=C[I[w++]],l+="-",l+=C[I[w++]],l+=C[I[w++]],l+="-",l+=C[I[w++]],l+=C[I[w++]],l+="-",l+=C[I[w++]],l+=C[I[w++]],l+="-",l+=C[I[w++]],l+=C[I[w++]],l+=C[I[w++]],l+=C[I[w++]],l+=C[I[w++]],l+=C[I[w++]],l}}()}),define(le[83],he([0,1,35]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=I;const S=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(C){const O=C.replace(/\-/g,":").toLowerCase();return!S.has(O)}function I(){const C=(0,P.networkInterfaces)();for(const O in C){const w=C[O];if(w){for(const{mac:l}of w)if(v(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[84],he([0,1,35,49,28,83,12]),function(Z,e,P,S,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=void 0,e.$Wn=w,e.$Xn=u,e.$Yn=p,v=be(v),e.$Vn=new class{c(f){return this.a||(this.a=S.$Oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(f)}value(){if(this.b===void 0){let f=0,m=0;const k=(0,P.networkInterfaces)();for(const b in k){const d=k[b];if(d)for(const{mac:$,internal:R}of d)R||(m+=1,this.c($.toUpperCase())&&(f+=1))}this.b=m>0?f/m:0}return this.b}};let O;async function w(f){return O||(O=(async()=>await l(f)||v.$5g())()),O}async function l(f){try{const m=await new Promise((b,d)=>{Z(["crypto"],b,d)}).then(be),k=(0,I.$Un)();return m.createHash("sha256").update(k,"utf8").digest("hex")}catch(m){f(m);return}}const h="Software\\Microsoft\\SQMClient";async function u(f){if(C.$j){const m=await new Promise((k,b)=>{Z(["@vscode/windows-registry"],k,b)}).then(be);try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch(k){return f(k),""}}return""}async function p(f){try{return await(await new Promise((b,d)=>{Z(["@vscode/deviceid"],b,d)}).then(be)).getDeviceId()}catch(m){return f(m),""}}}),define(le[85],he([0,1,35,15,29]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=$,e.$Am=R,P=be(P),S=be(S),v=be(v);const I=/^\d+$/,C=/^Microsoft.PowerShell_.*/,O=/^Microsoft.PowerShellPreview_.*/;var w;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(w||(w={}));let l;switch(process.arch){case"ia32":l=w.x86;break;case"arm":case"arm64":l=w.ARM;break;default:l=w.x64;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?w.ARM:w.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=w.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=w.x86:h=w.x64;class u{constructor(i,a,n){this.exePath=i,this.displayName=a,this.a=n}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:y=!1}={}){return y?l===w.x64?process.env["ProgramFiles(x86)"]||null:h===w.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:y=!1,findPreview:i=!1}={}){const a=p({useAlternateBitness:y});if(!a)return null;const n=S.$mc(a,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(n))return null;let r=-1,t=null;for(const c of await v.Promises.readdir(n)){let g=-1;if(i){const T=c.indexOf("-");if(T<0)continue;const A=c.substring(0,T);if(!I.test(A)||c.substring(T+1)!=="preview")continue;g=parseInt(A,10)}else{if(!I.test(c))continue;g=parseInt(c,10)}if(g<=r)continue;const N=S.$mc(n,c,"pwsh.exe");await v.SymlinkSupport.existsFile(N)&&(t=N,r=g)}if(!t)return null;const s=a.includes("x86")?" (x86)":"",o=i?" Preview":"";return new u(t,`PowerShell${o}${s}`,!0)}async function m({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const i=S.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:a,pwshMsixName:n}=y?{pwshMsixDirRegex:O,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await v.Promises.readdir(i))if(a.test(r)){const t=S.$mc(i,r,"pwsh.exe");return new u(t,n)}return null}function k(){const y=S.$mc(P.homedir(),".dotnet","tools","pwsh.exe");return new u(y,".NET Core PowerShell Global Tool")}function b(){const y=S.$mc(process.env.windir,l===w.x86&&h!==w.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(y,"Windows PowerShell",!0)}async function*d(){let y=await f();y&&(yield y),y=await f({useAlternateBitness:!0}),y&&(yield y),y=await m(),y&&(yield y),y=k(),y&&(yield y),y=await f({findPreview:!0}),y&&(yield y),y=await m({findPreview:!0}),y&&(yield y),y=await f({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=b(),y&&(yield y)}async function*$(){for await(const y of d())await y.exists()&&(yield y)}async function R(){for await(const y of $())return y;return null}}),define(le[59],he([0,1,32,15,12,36,56,3,29]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Bm=l,e.$Cm=h,S=be(S),v=be(v),I=be(I),O=be(O),w=be(w),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function l(p=I.env){return p.comspec||"cmd.exe"}function h(p){let f=[],m=!1;const k=function(b){if(m){f.push(b);return}(!p.send(b,$=>{if($&&console.error($),m=!1,f.length>0){const R=f.slice(0);f=[],R.forEach(y=>k(y))}})||v.$j)&&(m=!0)};return{send:k}}var u;(function(p){async function f(m,k,b){if(S.$lc(m))return m;if(k===void 0&&(k=I.cwd()),S.$pc(m)!=="."||(b===void 0&&O.$hg(I.env.PATH)&&(b=I.env.PATH.split(S.$wc)),b===void 0||b.length===0))return S.$mc(k,m);async function $(R){if(await w.Promises.exists(R)){let y;try{y=await P.promises.stat(R)}catch(i){i.message.startsWith("EACCES")&&(y=await P.promises.lstat(R))}return y?!y.isDirectory():!1}return!1}for(const R of b){let y;if(S.$lc(R)?y=S.$mc(R,m):y=S.$mc(k,R,m),await $(y))return y;let i=y+".com";if(await $(i)||(i=y+".exe",await $(i)))return i}return S.$mc(k,m)}p.findExecutable=f})(u||(e.win32=u={}))}),define(le[86],he([0,1,35,12,85,59]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=C,S=be(S),I=be(I);async function C(u,p){return u===S.OperatingSystem.Windows?S.$j?h():I.$Bm(p):w(u,p)}let O=null;function w(u,p){if(S.$l&&u===S.OperatingSystem.Macintosh||S.$k&&u===S.OperatingSystem.Linux)return"/bin/bash";if(!O){let f;if(S.$j)f="/bin/bash";else{if(f=p.SHELL,!f)try{f=(0,P.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}O=f}return O}let l=null;async function h(){return l||(l=(await(0,v.$Am)()).exePath),l}});var Ee=this&&this.__decorate||function(Z,e,P,S){var v=arguments.length,I=v<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,P):S,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(Z,e,P,S);else for(var O=Z.length-1;O>=0;O--)(C=Z[O])&&(I=(v<3?C(I):v>3?C(e,P,I):C(e,P))||I);return v>3&&I&&Object.defineProperty(e,P,I),I};define(le[60],he([0,1,19,8,13,21,55,7,4,2,48,31,3]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.ProxyChannel=e.$qi=e.$ni=e.$mi=e.$li=e.RequestInitiator=e.$ki=e.$hi=e.$gi=void 0,e.$ii=o,e.$ji=c,e.$oi=F,e.$pi=x,u=be(u);var f;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(f||(f={}));function m(M){switch(M){case f.Promise:return"req";case f.PromiseCancel:return"cancel";case f.EventListen:return"subscribe";case f.EventDispose:return"unsubscribe"}}var k;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(k||(k={}));function b(M){switch(M){case k.Initialize:return"init";case k.PromiseSuccess:return"reply:";case k.PromiseError:case k.PromiseErrorObj:return"replyErr:";case k.EventFire:return"event:"}}var d;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(d||(d={}));function $(M){let q=0;for(let H=0;;H+=7){const X=M.read(1);if(q|=(X.buffer[0]&127)<<H,!(X.buffer[0]&128))return q}}const R=r(0);function y(M,q){if(q===0){M.write(R);return}let H=0;for(let ie=q;ie!==0;ie=ie>>>7)H++;const X=v.$Qe.alloc(H);for(let ie=0;q!==0;ie++)X.buffer[ie]=q&127,q=q>>>7,q>0&&(X.buffer[ie]|=128);M.write(X)}class i{constructor(q){this.b=q,this.a=0}read(q){const H=this.b.slice(this.a,this.a+q);return this.a+=H.byteLength,H}}e.$gi=i;class a{constructor(){this.a=[]}get buffer(){return v.$Qe.concat(this.a)}write(q){this.a.push(q)}}e.$hi=a;var n;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(n||(n={}));function r(M){const q=v.$Qe.alloc(1);return q.writeUInt8(M,0),q}const t={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(M,q){if(typeof q>"u")M.write(t.Undefined);else if(typeof q=="string"){const H=v.$Qe.fromString(q);M.write(t.String),y(M,H.byteLength),M.write(H)}else if(s&&Buffer.isBuffer(q)){const H=v.$Qe.wrap(q);M.write(t.Buffer),y(M,H.byteLength),M.write(H)}else if(q instanceof v.$Qe)M.write(t.VSBuffer),y(M,q.byteLength),M.write(q);else if(Array.isArray(q)){M.write(t.Array),y(M,q.length);for(const H of q)o(M,H)}else if(typeof q=="number"&&(q|0)===q)M.write(t.Uint),y(M,q);else{const H=v.$Qe.fromString(JSON.stringify(q));M.write(t.Object),y(M,H.byteLength),M.write(H)}}function c(M){switch(M.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return M.read($(M)).toString();case n.Buffer:return M.read($(M)).buffer;case n.VSBuffer:return M.read($(M));case n.Array:{const H=$(M),X=[];for(let ie=0;ie<H;ie++)X.push(c(M));return X}case n.Object:return JSON.parse(M.read($(M)).toString());case n.Int:return $(M)}}class g{constructor(q,H,X=null,ie=1e3){this.h=q,this.j=H,this.k=X,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:k.Initialize})}registerChannel(q,H){this.b.set(q,H),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case k.Initialize:{const H=this.o([q.type]);this.k?.logOutgoing(H,0,N.OtherSide,b(q.type));return}case k.PromiseSuccess:case k.PromiseError:case k.EventFire:case k.PromiseErrorObj:{const H=this.o([q.type,q.id],q.data);this.k?.logOutgoing(H,q.id,N.OtherSide,b(q.type),q.data);return}}}o(q,H=void 0){const X=new a;return o(X,q),o(X,H),this.p(X.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const H=new i(q),X=c(H),ie=c(H),se=X[0];switch(se){case f.Promise:return this.k?.logIncoming(q.byteLength,X[1],N.OtherSide,`${m(se)}: ${X[2]}.${X[3]}`,ie),this.s({type:se,id:X[1],channelName:X[2],name:X[3],arg:ie});case f.EventListen:return this.k?.logIncoming(q.byteLength,X[1],N.OtherSide,`${m(se)}: ${X[2]}.${X[3]}`,ie),this.t({type:se,id:X[1],channelName:X[2],name:X[3],arg:ie});case f.PromiseCancel:return this.k?.logIncoming(q.byteLength,X[1],N.OtherSide,`${m(se)}`),this.u({type:se,id:X[1]});case f.EventDispose:return this.k?.logIncoming(q.byteLength,X[1],N.OtherSide,`${m(se)}`),this.u({type:se,id:X[1]})}}s(q){const H=this.b.get(q.channelName);if(!H){this.v(q);return}const X=new I.$ze;let ie;try{ie=H.call(this.j,q.name,q.arg,X.token)}catch(V){ie=Promise.reject(V)}const se=q.id;ie.then(V=>{this.m({id:se,data:V,type:k.PromiseSuccess})},V=>{V instanceof Error?this.m({id:se,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split(`
`):void 0},type:k.PromiseError}):this.m({id:se,data:V,type:k.PromiseErrorObj})}).finally(()=>{L.dispose(),this.d.delete(q.id)});const L=(0,l.$Vc)(()=>X.cancel());this.d.set(q.id,L)}t(q){const H=this.b.get(q.channelName);if(!H){this.v(q);return}const X=q.id,se=H.listen(this.j,q.name,q.arg)(L=>this.m({id:X,data:L,type:k.EventFire}));this.d.set(q.id,se)}u(q){const H=this.d.get(q.id);H&&(H.dispose(),this.d.delete(q.id))}v(q){let H=this.g.get(q.channelName);H||(H=[],this.g.set(q.channelName,H));const X=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===f.Promise&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:k.PromiseError})},this.l);H.push({request:q,timeoutTimer:X})}w(q){const H=this.g.get(q);if(H){for(const X of H)switch(clearTimeout(X.timeoutTimer),X.request.type){case f.Promise:this.s(X.request);break;case f.EventListen:this.t(X.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}e.$ki=g;var N;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(N||(e.RequestInitiator=N={}));class T{constructor(q,H=null){this.l=q,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$oe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=H}getChannel(q){const H=this;return{call(X,ie,se){return H.a?Promise.reject(new O.$7):H.m(q,X,ie,se)},listen(X,ie){return H.a?w.Event.None:H.o(q,X,ie)}}}m(q,H,X,ie=I.CancellationToken.None){const se=this.g++,L=f.Promise,V={id:se,type:L,channelName:q,name:H,arg:X};if(ie.isCancellationRequested)return Promise.reject(new O.$7);let z;return new Promise((j,Q)=>{if(ie.isCancellationRequested)return Q(new O.$7);const J=()=>{const re=ce=>{switch(ce.type){case k.PromiseSuccess:this.f.delete(se),j(ce.data);break;case k.PromiseError:{this.f.delete(se);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,Q(fe);break}case k.PromiseErrorObj:this.f.delete(se),Q(ce.data);break}};this.f.set(se,re),this.p(V)};let G=null;this.b===d.Idle?J():(G=(0,S.$vh)(re=>this.u()),G.then(()=>{G=null,J()}));const U=()=>{G?(G.cancel(),G=null):this.p({id:se,type:f.PromiseCancel}),Q(new O.$7)},K=ie.onCancellationRequested(U);z=(0,l.$Uc)((0,l.$Vc)(U),K),this.d.add(z)}).finally(()=>{z.dispose(),this.d.delete(z)})}o(q,H,X){const ie=this.g++,se=f.EventListen,L={id:ie,type:se,channelName:q,name:H,arg:X};let V=null;const z=new w.$oe({onWillAddFirstListener:()=>{V=(0,S.$vh)(j=>this.u()),V.then(()=>{V=null,this.d.add(z),this.p(L)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(z),this.p({id:ie,type:f.EventDispose}))}}),E=j=>z.fire(j.data);return this.f.set(ie,E),z.event}p(q){switch(q.type){case f.Promise:case f.EventListen:{const H=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(H,q.id,N.LocalSide,`${m(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case f.PromiseCancel:case f.EventDispose:{const H=this.q([q.type,q.id]);this.j?.logOutgoing(H,q.id,N.LocalSide,m(q.type));return}}}q(q,H=void 0){const X=new a;return o(X,q),o(X,H),this.r(X.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const H=new i(q),X=c(H),ie=c(H),se=X[0];switch(se){case k.Initialize:return this.j?.logIncoming(q.byteLength,0,N.LocalSide,b(se)),this.t({type:X[0]});case k.PromiseSuccess:case k.PromiseError:case k.EventFire:case k.PromiseErrorObj:return this.j?.logIncoming(q.byteLength,X[1],N.LocalSide,b(se),ie),this.t({type:X[0],id:X[1],data:ie})}}t(q){if(q.type===k.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}e.$li=T,Ee([C.$ai],T.prototype,"onDidInitializePromise",null);class A{get connections(){const q=[];return this.f.forEach(H=>q.push(H)),q}constructor(q,H,X){this.a=new Map,this.f=new Set,this.g=new w.$oe,this.onDidAddConnection=this.g.event,this.h=new w.$oe,this.onDidRemoveConnection=this.h.event,this.j=new l.$Wc,this.j.add(q(({protocol:ie,onDidClientDisconnect:se})=>{const L=w.Event.once(ie.onMessage);this.j.add(L(V=>{const z=new i(V),E=c(z),j=new g(ie,E,H,X),Q=new T(ie,H);this.a.forEach((G,U)=>j.registerChannel(U,G));const J={channelServer:j,channelClient:Q,ctx:E};this.f.add(J),this.g.fire(J),this.j.add(se(()=>{j.dispose(),Q.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(q,H){const X=this;return{call(ie,se,L){let V;if((0,p.$vg)(H)){const E=(0,P.$5b)(X.connections.filter(H));V=E?Promise.resolve(E):w.Event.toPromise(w.Event.filter(X.onDidAddConnection,H))}else V=H.routeCall(X,ie,se);const z=V.then(E=>E.channelClient.getChannel(q));return F(z).call(ie,se,L)},listen(ie,se){if((0,p.$vg)(H))return X.k(q,H,ie,se);const L=H.routeEvent(X,ie,se).then(V=>V.channelClient.getChannel(q));return F(L).listen(ie,se)}}}k(q,H,X,ie){const se=this;let L;const V=new w.$oe({onWillAddFirstListener:()=>{L=new l.$Wc;const z=new w.$ue,E=new Map,j=J=>{const U=J.channelClient.getChannel(q).listen(X,ie),K=z.add(U);E.set(J,K)},Q=J=>{const G=E.get(J);G&&(G.dispose(),E.delete(J))};se.connections.filter(H).forEach(j),w.Event.filter(se.onDidAddConnection,H)(j,void 0,L),se.onDidRemoveConnection(Q,void 0,L),z.event(V.fire,V,L),L.add(z)},onDidRemoveLastListener:()=>{L?.dispose(),L=void 0}});return V.event}registerChannel(q,H){this.a.set(q,H);for(const X of this.f)X.channelServer.registerChannel(q,H)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$mi=A;class D{constructor(q,H,X=null){const ie=new a;o(ie,H),q.send(ie.buffer),this.a=new T(q,X),this.d=new g(q,H,X)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,H){this.d.registerChannel(q,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ni=D;function F(M){return{call(q,H,X){return M.then(ie=>ie.call(q,H,X))},listen(q,H){const X=new w.$xe;return M.then(ie=>X.input=ie.listen(q,H)),X.event}}}function x(M){let q=!1;return{call(H,X,ie){return q?M.call(H,X,ie):(0,S.$Jh)(0).then(()=>q=!0).then(()=>M.call(H,X,ie))},listen(H,X){if(q)return M.listen(H,X);const ie=new w.$xe;return(0,S.$Jh)(0).then(()=>q=!0).then(()=>ie.input=M.listen(H,X)),ie.event}}}class Y{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const H of q.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await w.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$qi=Y;var ne;(function(M){function q(se,L,V){const z=se,E=V&&V.disableMarshalling,j=new Map;for(const Q in z)X(Q)&&j.set(Q,w.Event.buffer(z[Q],!0,void 0,L));return new class{listen(Q,J,G){const U=j.get(J);if(U)return U;const K=z[J];if(typeof K=="function"){if(ie(J))return K.call(z,G);if(X(J))return j.set(J,w.Event.buffer(z[J],!0,void 0,L)),j.get(J)}throw new O.$db(`Event not found: ${J}`)}call(Q,J,G){const U=z[J];if(typeof U=="function"){if(!E&&Array.isArray(G))for(let re=0;re<G.length;re++)G[re]=(0,h.$fi)(G[re]);let K=U.apply(z,G);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new O.$db(`Method not found: ${J}`)}}}M.fromService=q;function H(se,L){const V=L&&L.disableMarshalling;return new Proxy({},{get(z,E){if(typeof E=="string")return L?.properties?.has(E)?L.properties.get(E):ie(E)?function(j){return se.listen(E,j)}:X(E)?se.listen(E):async function(...j){let Q;L&&!(0,p.$qg)(L.context)?Q=[L.context,...j]:Q=j;const J=await se.call(E,Q);return V?J:(0,h.$fi)(J)};throw new O.$db(`Property not found: ${String(E)}`)}})}M.toService=H;function X(se){return se[0]==="o"&&se[1]==="n"&&u.$Hf(se.charCodeAt(2))}function ie(se){return/^onDynamic/.test(se)&&u.$Hf(se.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const q=M.toString();if(q!=="[object Object]")return q}return M}function me(M){return Array.isArray(M)?M.map(ue):ue(M)}function W(M,q,H,X,ie,se,L){L=me(L);const V=ae[ie],z=V[X%V.length];let E=[`%c[${M}]%c[${String(q).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(se)?(E=E.concat(L),E.push(")")):E.push(L),console.log.apply(console,E)}class _{constructor(q,H){this.d=q,this.f=H,this.a=0,this.b=0}logOutgoing(q,H,X,ie,se){this.b+=q,W(this.d,this.b,q,H,X,ie,se)}logIncoming(q,H,X,ie,se){this.a+=q,W(this.f,this.a,q,H,X,ie,se)}}e.$ri=_}),define(le[87],he([0,1,61,8,13,21,82,7,4,2,27,59,56,60]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0,O=be(O);class m extends f.$ki{constructor(d){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",$=>v.$Qe.wrap(Buffer.from($,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$mr=m;class k{constructor(d,$){this.i=d,this.j=$,this.c=new Set,this.g=new Map,this.h=new w.$oe,this.onDidProcessExit=this.h.event;const R=$&&$.timeout?$.timeout:6e4;this.b=new S.$Fh(R),this.d=null,this.f=null}getChannel(d){const $=this;return{call(R,y,i){return $.k(d,R,y,i)},listen(R,y){return $.l(d,R,y)}}}k(d,$,R,y=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(O.$8());this.b.cancel();const i=this.n(d),a=(0,S.$vh)(t=>i.call($,R,t)),n=y.onCancellationRequested(()=>a.cancel()),r=(0,l.$Vc)(()=>a.cancel());return this.c.add(r),a.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(d,$,R){if(!this.b)return w.Event.None;this.b.cancel();let y;const i=new w.$oe({onWillAddFirstListener:()=>{y=this.n(d).listen($,R)(i.fire,i),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,h.$ho)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,p.$pm)($.env),this.d=(0,P.fork)(this.i,d,$);const R=new w.$oe,i=w.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,C.$ir)(o)){(0,C.log)(o,`IPC Library: ${this.j.serverName}`);return}R.fire(v.$Qe.wrap(Buffer.from(o,"base64")))}),a=this.j.useQueue?(0,u.$Cm)(this.d):this.d,n=o=>this.d&&this.d.connected&&a.send(o.buffer.toString("base64")),r=R.event,t={send:n,onMessage:r};this.f=new f.$li(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",s),i.dispose(),this.c.forEach(g=>(0,l.$Sc)(g)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(d){let $=this.g.get(d);return $||($=this.m.getChannel(d),this.g.set(d,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$nr=k}),define(le[88],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0,e.$_o=S;const P="Offline";function S(I){return I instanceof v?!0:I instanceof Error&&I.name===P&&I.message===P}class v extends Error{constructor(){super(P),this.name=this.message}}e.$ap=v}),define(le[89],he([0,1,8,4,2,48,3]),function(Z,e,P,S,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=e.StorageState=e.StorageHint=void 0,e.$gq=w;var O;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function w(p){const f=p;return f?.changed instanceof Map||f?.deleted instanceof Set}var l;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(l||(e.StorageState=l={}));class h extends v.$Xc{static{this.a=100}constructor(f,m=Object.create(null)){super(),this.r=f,this.s=m,this.b=this.B(new S.$re),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$Gh(h.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((m,k)=>this.w(k,m)),f.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(f,m){if(this.c===l.Closed)return;let k=!1;(0,C.$qg)(m)?k=this.f.delete(f):this.f.get(f)!==m&&(this.f.set(f,m),k=!0),k&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,m){const k=this.f.get(f);return(0,C.$qg)(k)?m:k}getBoolean(f,m){const k=this.get(f);return(0,C.$qg)(k)?m:k==="true"}getNumber(f,m){const k=this.get(f);return(0,C.$qg)(k)?m:parseInt(k,10)}getObject(f,m){const k=this.get(f);return(0,C.$qg)(k)?m:(0,I.$ei)(k)}async set(f,m,k=!1){if(this.c===l.Closed)return;if((0,C.$qg)(m))return this.delete(f,k);const b=(0,C.$jg)(m)||Array.isArray(m)?(0,I.$di)(m):String(m);if(this.f.get(f)!==b)return this.f.set(f,b),this.j.set(f,b),this.h.delete(f),this.b.fire({key:f,external:k}),this.D()}async delete(f,m=!1){if(!(this.c===l.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:m}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(!(this.c===l.Closed||this.m))return this.D(f)}async D(f){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$hq=h;class u{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((m,k)=>this.a.set(k,m)),f.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$iq=u}),define(le[90],he([0,1,5]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=l,e.$6m=h,e.$7m=u;const S=60,v=S*60,I=v*24,C=I*7,O=I*30,w=I*365;function l(p,f,m,k){typeof p!="number"&&(p=p.getTime());const b=Math.round((new Date().getTime()-p)/1e3);if(b<-30)return(0,P.localize)(42,null,l(new Date().getTime()+b*1e3,!1));if(!k&&b<30)return(0,P.localize)(43,null);let d;return b<S?(d=b,f?d===1?m?(0,P.localize)(44,null,d):(0,P.localize)(45,null,d):m?(0,P.localize)(46,null,d):(0,P.localize)(47,null,d):d===1?m?(0,P.localize)(48,null,d):(0,P.localize)(49,null,d):m?(0,P.localize)(50,null,d):(0,P.localize)(51,null,d)):b<v?(d=Math.floor(b/S),f?d===1?m?(0,P.localize)(52,null,d):(0,P.localize)(53,null,d):m?(0,P.localize)(54,null,d):(0,P.localize)(55,null,d):d===1?m?(0,P.localize)(56,null,d):(0,P.localize)(57,null,d):m?(0,P.localize)(58,null,d):(0,P.localize)(59,null,d)):b<I?(d=Math.floor(b/v),f?d===1?m?(0,P.localize)(60,null,d):(0,P.localize)(61,null,d):m?(0,P.localize)(62,null,d):(0,P.localize)(63,null,d):d===1?m?(0,P.localize)(64,null,d):(0,P.localize)(65,null,d):m?(0,P.localize)(66,null,d):(0,P.localize)(67,null,d)):b<C?(d=Math.floor(b/I),f?d===1?(0,P.localize)(68,null,d):(0,P.localize)(69,null,d):d===1?(0,P.localize)(70,null,d):(0,P.localize)(71,null,d)):b<O?(d=Math.floor(b/C),f?d===1?m?(0,P.localize)(72,null,d):(0,P.localize)(73,null,d):m?(0,P.localize)(74,null,d):(0,P.localize)(75,null,d):d===1?m?(0,P.localize)(76,null,d):(0,P.localize)(77,null,d):m?(0,P.localize)(78,null,d):(0,P.localize)(79,null,d)):b<w?(d=Math.floor(b/O),f?d===1?m?(0,P.localize)(80,null,d):(0,P.localize)(81,null,d):m?(0,P.localize)(82,null,d):(0,P.localize)(83,null,d):d===1?m?(0,P.localize)(84,null,d):(0,P.localize)(85,null,d):m?(0,P.localize)(86,null,d):(0,P.localize)(87,null,d)):(d=Math.floor(b/w),f?d===1?m?(0,P.localize)(88,null,d):(0,P.localize)(89,null,d):m?(0,P.localize)(90,null,d):(0,P.localize)(91,null,d):d===1?m?(0,P.localize)(92,null,d):(0,P.localize)(93,null,d):m?(0,P.localize)(94,null,d):(0,P.localize)(95,null,d))}function h(p,f){const m=Math.abs(p/1e3);return m<1?f?(0,P.localize)(96,null,p):(0,P.localize)(97,null,p):m<S?f?(0,P.localize)(98,null,Math.round(p)/1e3):(0,P.localize)(99,null,Math.round(p)/1e3):m<v?f?(0,P.localize)(100,null,Math.round(p/(1e3*S))):(0,P.localize)(101,null,Math.round(p/(1e3*S))):m<I?f?(0,P.localize)(102,null,Math.round(p/(1e3*v))):(0,P.localize)(103,null,Math.round(p/(1e3*v))):(0,P.localize)(104,null,Math.round(p/(1e3*I)))}function u(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[38],he([0,1,19,3,5]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=w,e.$uj=l,e.$vj=h,P=be(P),S=be(S),v=be(v);function I(u,p){return p&&(u.stack||u.stacktrace)?v.localize(105,null,O(u),C(u.stack)||C(u.stacktrace)):O(u)}function C(u){return Array.isArray(u)?u.join(`
`):u}function O(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?v.localize(106,null,u.message):u.message||v.localize(107,null)}function w(u=null,p=!1){if(!u)return v.localize(108,null);if(Array.isArray(u)){const f=P.$Jb(u),m=w(f[0],p);return f.length>1?v.localize(109,null,m,f.length):m}if(S.$hg(u))return u;if(u.detail){const f=u.detail;if(f.error)return I(f.error,p);if(f.exception)return I(f.exception,p)}return u.stack?I(u,p):u.message?u.message:v.localize(110,null)}function l(u){const p=u;return p instanceof Error&&Array.isArray(p.actions)}function h(u,p){let f;return typeof u=="string"?f=new Error(u):f=u,f.actions=p,f}}),define(le[91],he([0,1,5,34]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=v;function v(I){switch(I){case S.ParseErrorCode.InvalidSymbol:return(0,P.localize)(111,null);case S.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(112,null);case S.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(113,null);case S.ParseErrorCode.ValueExpected:return(0,P.localize)(114,null);case S.ParseErrorCode.ColonExpected:return(0,P.localize)(115,null);case S.ParseErrorCode.CommaExpected:return(0,P.localize)(116,null);case S.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(117,null);case S.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(118,null);case S.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(119,null);default:return""}}}),define(le[50],he([0,1,32,8,15,3,29,5]),function(Z,e,P,S,v,I,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0,e.zip=b,e.$Iq=d,e.$Jq=R,v=be(v),O=be(O),e.$Fq="end of central directory record signature not found";const w=new RegExp(e.$Fq);class l extends Error{constructor(i,a){let n=a.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=a}}e.$Gq=l;function h(y){const i=y.externalFileAttributes>>16||33188;return[448,56,7].map(a=>i&a).reduce((a,n)=>a+n,i&61440)}function u(y){if(y instanceof l)return y;let i;return w.test(y.message)&&(i="CorruptZip"),new l(i,y)}function p(y,i,a,n,r,t){const s=v.$pc(i),o=v.$mc(n,s);if(!o.startsWith(n))return Promise.reject(new Error(O.localize(140,null,i)));const c=v.$mc(n,i);let g;return t.onCancellationRequested(()=>{g?.destroy()}),Promise.resolve(P.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,T)=>{if(!t.isCancellationRequested)try{g=(0,P.createWriteStream)(c,{mode:a}),g.once("close",()=>N()),g.once("error",T),y.once("error",T),y.pipe(g)}catch(A){T(A)}}))}function f(y,i,a,n){let r=(0,S.$vh)(()=>Promise.resolve()),t=0;const s=n.onCancellationRequested(()=>{r.cancel(),y.close()});return new Promise((o,c)=>{const g=new S.$Dh,N=T=>{T.isCancellationRequested||(t++,y.readEntry())};y.once("error",c),y.once("close",()=>r.then(()=>{n.isCancellationRequested||y.entryCount===t?o():c(new l("Incomplete",new Error(O.localize(141,null,t,y.entryCount))))},c)),y.readEntry(),y.on("entry",T=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(T.fileName)){N(n);return}const A=T.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(A)){const x=v.$mc(i,A);r=(0,S.$vh)(Y=>P.promises.mkdir(x,{recursive:!0}).then(()=>N(Y)).then(void 0,c));return}const D=k(y,T),F=h(T);r=(0,S.$vh)(x=>g.queue(()=>D.then(Y=>p(Y,A,F,i,a,x).then(()=>N(x)))).then(null,c))})}).finally(()=>s.dispose())}async function m(y,i=!1){const{open:a}=await new Promise((n,r)=>{Z(["yauzl"],n,r)}).then(be);return new Promise((n,r)=>{a(y,i?{lazyEntries:!0}:void 0,(t,s)=>{t?r(u(t)):n((0,I.$sg)(s))})})}function k(y,i){return new Promise((a,n)=>{y.openReadStream(i,(r,t)=>{r?n(u(r)):a((0,I.$sg)(t))})})}async function b(y,i){const{ZipFile:a}=await new Promise((n,r)=>{Z(["yazl"],n,r)}).then(be);return new Promise((n,r)=>{const t=new a;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,P.createWriteStream)(y);t.outputStream.pipe(s),t.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(y))})}function d(y,i,a={},n){const r=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let t=m(y,!0);return a.overwrite&&(t=t.then(s=>C.Promises.rm(i).then(()=>s))),t.then(s=>f(s,i,{sourcePathRegex:r},n))}function $(y,i){return m(y).then(a=>new Promise((n,r)=>{a.on("entry",t=>{t.fileName===i&&k(a,t).then(s=>n(s),s=>r(s))}),a.once("close",()=>r(new Error(O.localize(142,null,i))))}))}function R(y,i){return $(y,i).then(a=>new Promise((n,r)=>{const t=[];a.once("error",r),a.on("data",s=>t.push(s)),a.on("end",()=>n(Buffer.concat(t)))}))}}),define(le[92],he([0,1,93,7,5]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var I;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(I||(e.TokenType=I={}));function C(...h){switch(h.length){case 1:return(0,v.localize)(1691,null,h[0]);case 2:return(0,v.localize)(1692,null,h[0],h[1]);case 3:return(0,v.localize)(1693,null,h[0],h[1],h[2]);default:return}}const O=(0,v.localize)(1694,null),w=(0,v.localize)(1695,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case I.LParen:return"(";case I.RParen:return")";case I.Neg:return"!";case I.Eq:return u.isTripleEq?"===":"==";case I.NotEq:return u.isTripleEq?"!==":"!=";case I.Lt:return"<";case I.LtEq:return"<=";case I.Gt:return">=";case I.GtEq:return">=";case I.RegexOp:return"=~";case I.RegexStr:return u.lexeme;case I.True:return"true";case I.False:return"false";case I.In:return"in";case I.Not:return"not";case I.And:return"&&";case I.Or:return"||";case I.Str:return u.lexeme;case I.QuotedStr:return u.lexeme;case I.Error:return u.lexeme;case I.EOF:return"EOF";default:throw(0,S.$0)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",I.Not],["in",I.In],["false",I.False],["true",I.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(I.LParen);break;case P.CharCode.CloseParen:this.k(I.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const p=this.h(P.CharCode.Equals);this.f.push({type:I.NotEq,offset:this.d,isTripleEq:p})}else this.k(I.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const p=this.h(P.CharCode.Equals);this.f.push({type:I.Eq,offset:this.d,isTripleEq:p})}else this.h(P.CharCode.Tilde)?this.k(I.RegexOp):this.l(C("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?I.LtEq:I.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?I.GtEq:I.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(I.And):this.l(C("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(I.Or):this.l(C("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(I.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const p=this.d,f=this.c.substring(this.d,this.e),m={type:I.Error,offset:this.d,lexeme:f};this.g.push({offset:p,lexeme:f,additionalInfo:u}),this.f.push(m)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const p=this.c.substring(this.d,this.e),f=l.b.get(p);f?this.k(f):this.f.push({type:I.Str,lexeme:p,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:I.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,p=!1,f=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(w);return}const k=this.c.charCodeAt(u);if(p)p=!1;else if(k===P.CharCode.Slash&&!f){u++;break}else k===P.CharCode.OpenSquareBracket?f=!0:k===P.CharCode.Backslash?p=!0:k===P.CharCode.CloseSquareBracket&&(f=!1);u++}for(;u<this.c.length&&l.a.has(this.c.charCodeAt(u));)u++;this.e=u;const m=this.c.substring(this.d,this.e);this.f.push({type:I.RegexStr,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=l}),define(le[94],he([0,1,90,55,14,15,36,16,11]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=void 0,e.$0m=h,e.$$m=u,e.$8m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,I.$pc)(v.$3g.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,I.$mc)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,O.$jh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$jh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.$7m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$mc)(this.userDataPath,"logs",f)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$jh)(w.URI.file((0,I.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$jh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$jh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$jh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?w.URI.file((0,I.$mc)(f,"argv.json")):(0,O.$jh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,I.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,I.$nc)(f):(0,I.$kc)((0,I.$mc)(v.$3g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?w.URI.file((0,I.$nc)(f)):w.URI.file((0,I.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,I.$nc)(f);const m=C.env.VSCODE_EXTENSIONS;if(m)return m;const k=C.env.VSCODE_PORTABLE;return k?(0,I.$mc)(k,"extensions"):(0,O.$jh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(m=>/^[^:/?#]+?:\/\//.test(m)?w.URI.parse(m):w.URI.file((0,I.$kc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,I.$kc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$8m.test(f))}get extensionLogLevel(){const f=[];for(const m of this.args.log||[]){const k=e.$8m.exec(m);k&&k[1]&&k[2]&&f.push([k[1],k[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,O.$jh)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=C.env.VSCODE_PORTABLE;return f?w.URI.file((0,I.$mc)(f,"policy.json")):(0,O.$jh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,m,k){this.a=f,this.b=m,this.c=k,this.editSessionId=this.args.editSessionId}}e.$9m=l,Ee([S.$ai],l.prototype,"appRoot",null),Ee([S.$ai],l.prototype,"userHome",null),Ee([S.$ai],l.prototype,"userDataPath",null),Ee([S.$ai],l.prototype,"appSettingsHome",null),Ee([S.$ai],l.prototype,"tmpDir",null),Ee([S.$ai],l.prototype,"cacheHome",null),Ee([S.$ai],l.prototype,"stateResource",null),Ee([S.$ai],l.prototype,"userRoamingDataHome",null),Ee([S.$ai],l.prototype,"userDataSyncHome",null),Ee([S.$ai],l.prototype,"sync",null),Ee([S.$ai],l.prototype,"machineSettingsResource",null),Ee([S.$ai],l.prototype,"workspaceStorageHome",null),Ee([S.$ai],l.prototype,"localHistoryHome",null),Ee([S.$ai],l.prototype,"keyboardLayoutResource",null),Ee([S.$ai],l.prototype,"argvResource",null),Ee([S.$ai],l.prototype,"isExtensionDevelopment",null),Ee([S.$ai],l.prototype,"untitledWorkspacesHome",null),Ee([S.$ai],l.prototype,"builtinExtensionsPath",null),Ee([S.$ai],l.prototype,"extensionsPath",null),Ee([S.$ai],l.prototype,"extensionDevelopmentLocationURI",null),Ee([S.$ai],l.prototype,"extensionDevelopmentKind",null),Ee([S.$ai],l.prototype,"extensionTestsLocationURI",null),Ee([S.$ai],l.prototype,"debugExtensionHost",null),Ee([S.$ai],l.prototype,"logLevel",null),Ee([S.$ai],l.prototype,"extensionLogLevel",null),Ee([S.$ai],l.prototype,"serviceMachineIdResource",null),Ee([S.$ai],l.prototype,"disableTelemetry",null),Ee([S.$ai],l.prototype,"disableWorkspaceTrust",null),Ee([S.$ai],l.prototype,"useInMemorySecretStorage",null),Ee([S.$ai],l.prototype,"policyFile",null);function h(p,f){return u(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}function u(p,f,m,k,b,d){const R=Number(f||p)||(k?null:m),y=R?!!f:!1;let i;if(d)try{i=JSON.parse(d)}catch{}return{port:R,break:y,debugId:b,env:i}}}),function(){function Z(e,P,S){function v(C,O){const w=I(C,O),l=[w];return e.isAbsolute(w)||l.unshift(S),e.resolve(...l)}function I(C,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,O);const h=C["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(u,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,O)}return{getUserDataPath:v}}if(typeof define=="function")define(le[95],he([149,35,36]),function(e,P,S){return Z(e,P,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=Z(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[96],he([0,1,35,94,95]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0,e.$an=C,e.$bn=O;class I extends S.$9m{constructor(l,h){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,v.getUserDataPath)(l,h.nameShort)},h)}}e.$_m=I;function C(w,l){return(0,S.$$m)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,l,w.extensionEnvironment)}function O(w,l){return(0,S.$$m)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,l,w.extensionEnvironment)}}),define(le[97],he([0,1,3,5]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=v;function v(C,O,w,l){try{I(C,O,w,l)}catch(h){C.error(h?.message??h)}return O}function I(C,O,w,l){const h=(u,p,f)=>{const m=u[p];if((0,P.$hg)(m)){const k=m,b=k.length;if(b>1&&k[0]==="%"&&k[b-1]==="%"){const d=k.substr(1,b-2);let $=w[d];$===void 0&&l&&($=l[d]);const R=typeof $=="string"?$:$?.message,y=l?.[d],i=typeof y=="string"?y:y?.message;if(!R){i||C.warn(`[${O.name}]: ${(0,S.localize)(1812,null,d)}`);return}if(f&&(p==="title"||p==="category")&&i&&i!==R){const a={value:R,original:i};u[p]=a}else u[p]=R}}else if((0,P.$jg)(m))for(const k in m)m.hasOwnProperty(k)&&(k==="commands"?h(m,k,!0):h(m,k,f));else if(Array.isArray(m))for(let k=0;k<m.length;k++)h(m,k,f)};for(const u in O)O.hasOwnProperty(u)&&h(O,u)}}),define(le[98],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const P={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(P)}),define(le[51],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class P{constructor(v,I=[],C=!1){this.ctor=v,this.staticArguments=I,this.supportsDelayedInstantiation=C}}e.$Fi=P}),define(le[99],he([0,1,51]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ws=I,e.$Xs=C;const S=[];var v;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(v||(e.InstantiationType=v={}));function I(O,w,l){w instanceof P.$Fi||(w=new P.$Fi(w,[],!!l)),S.push([O,w])}function C(){return S}}),define(le[100],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;class P{constructor(I,C){this.key=I,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$zr=P;class S{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const C of this.a.values())C.outgoing.size===0&&I.push(C);return I}insertEdge(I,C){const O=this.lookupOrInsertNode(I),w=this.lookupOrInsertNode(C);O.outgoing.set(w.key,w),w.incoming.set(O.key,O)}removeNode(I){const C=this.b(I);this.a.delete(C);for(const O of this.a.values())O.outgoing.delete(C),O.incoming.delete(C)}lookupOrInsertNode(I){const C=this.b(I);let O=this.a.get(C);return O||(O=new P(C,I),this.a.set(C,O)),O}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[C,O]of this.a)I.push(`${C}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,C]of this.a){const O=new Set([I]),w=this.c(C,O);if(w)return w}}c(I,C){for(const[O,w]of I.outgoing){if(C.has(O))return[...C,O].join(" -> ");C.add(O);const l=this.c(w,C);if(l)return l;C.delete(O)}}}e.$Ar=S}),define(le[30],he([0,1,3,11,10]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=I,e.$ej=C,e.$fj=w,e.$gj=l,e.$hj=h,e.$ij=u,e.$jj=p,e.$kj=m,e.$lj=k,e.$mj=b,P=be(P),e.$cj=(0,v.$Ii)("configurationService");function I(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof S.URI)}function C(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof S.URI)}var O;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function w(d){switch(d){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function h(d,$){const R=Object.create(null);for(const y in d)u(R,y,d[y],$);return R}function u(d,$,R,y){const i=$.split("."),a=i.pop();let n=d;for(let r=0;r<i.length;r++){const t=i[r];let s=n[t];switch(typeof s){case"undefined":s=n[t]=Object.create(null);break;case"object":if(s===null){y(`Ignoring ${$} as ${i.slice(0,r+1).join(".")} is null`);return}break;default:y(`Ignoring ${$} as ${i.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[a]=R}catch{y(`Ignoring ${$} as ${i.join(".")} is ${JSON.stringify(n)}`)}else y(`Ignoring ${$} as ${i.join(".")} is ${JSON.stringify(n)}`)}function p(d,$){const R=$.split(".");f(d,R)}function f(d,$){const R=$.shift();if($.length===0){delete d[R];return}if(Object.keys(d).indexOf(R)!==-1){const y=d[R];typeof y=="object"&&!Array.isArray(y)&&(f(y,$),Object.keys(y).length===0&&delete d[R])}}function m(d,$,R){function y(n,r){let t=n;for(const s of r){if(typeof t!="object"||t===null)return;t=t[s]}return t}const i=$.split("."),a=y(d,i);return typeof a>"u"?R:a}function k(d,$,R){Object.keys($).forEach(y=>{y!=="__proto__"&&(y in d?P.$jg(d[y])&&P.$jg($[y])?k(d[y],$[y],R):R&&(d[y]=$[y]):d[y]=$[y])})}function b(d){return d.replace(/[\[\]]/g,"")}}),define(le[101],he([0,1,93,12,31,92,10,5,7]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=h,e.$Hj=r,e.$Ij=t,e.$2j=se;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",S.$k),l.set("isLinux",S.$l),l.set("isWindows",S.$j),l.set("isWeb",S.$p),l.set("isMacNative",S.$k&&!S.$p),l.set("isEdge",S.$I),l.set("isFirefox",S.$G),l.set("isChrome",S.$F),l.set("isSafari",S.$H);function h(z,E){if(l.get(z)!==void 0)throw(0,w.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(z,E)}const u=Object.prototype.hasOwnProperty;var p;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const f={regexParsingWithErrorRecovery:!0},m=(0,O.localize)(1671,null),k=(0,O.localize)(1672,null),b=(0,O.localize)(1673,null),d=(0,O.localize)(1674,null),$=(0,O.localize)(1675,null),R=(0,O.localize)(1676,null),y=(0,O.localize)(1677,null),i=(0,O.localize)(1678,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(E=f){this.k=E,this.d=new I.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(E){if(E===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(E).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const Q=this.D(),J=Q.type===I.TokenType.Str?R:void 0;throw this.h.push({message:$,offset:Q.offset,lexeme:I.$Dj.getLexeme(Q),additionalInfo:J}),a.c}return j}catch(j){if(j!==a.c)throw j;return}}l(){return this.m()}m(){const E=[this.o()];for(;this.y(I.TokenType.Or);){const j=this.o();E.push(j)}return E.length===1?E[0]:n.or(...E)}o(){const E=[this.s()];for(;this.y(I.TokenType.And);){const j=this.s();E.push(j)}return E.length===1?E[0]:n.and(...E)}s(){if(this.y(I.TokenType.Neg)){const E=this.D();switch(E.type){case I.TokenType.True:return this.z(),o.INSTANCE;case I.TokenType.False:return this.z(),c.INSTANCE;case I.TokenType.LParen:{this.z();const j=this.l();return this.A(I.TokenType.RParen,d),j?.negate()}case I.TokenType.Str:return this.z(),F.create(E.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",E)}}return this.t()}t(){const E=this.D();switch(E.type){case I.TokenType.True:return this.z(),n.true();case I.TokenType.False:return this.z(),n.false();case I.TokenType.LParen:{this.z();const j=this.l();return this.A(I.TokenType.RParen,d),j}case I.TokenType.Str:{const j=E.lexeme;if(this.z(),this.y(I.TokenType.RegexOp)){const J=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),J.type!==I.TokenType.RegexStr)throw this.B("REGEX",J);const G=J.lexeme,U=G.lastIndexOf("/"),K=U===G.length-1?void 0:this.w(G.substring(U+1));let re;try{re=new RegExp(G.substring(1,U),K)}catch{throw this.B("REGEX",J)}return me.create(j,re)}switch(J.type){case I.TokenType.RegexStr:case I.TokenType.Error:{const G=[J.lexeme];this.z();let U=this.D(),K=0;for(let de=0;de<J.lexeme.length;de++)J.lexeme.charCodeAt(de)===P.CharCode.OpenParen?K++:J.lexeme.charCodeAt(de)===P.CharCode.CloseParen&&K--;for(;!this.E()&&U.type!==I.TokenType.And&&U.type!==I.TokenType.Or;){switch(U.type){case I.TokenType.LParen:K++;break;case I.TokenType.RParen:K--;break;case I.TokenType.RegexStr:case I.TokenType.QuotedStr:for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===P.CharCode.OpenParen?K++:J.lexeme.charCodeAt(de)===P.CharCode.CloseParen&&K--}if(K<0)break;G.push(I.$Dj.getLexeme(U)),this.z(),U=this.D()}const re=G.join(""),ce=re.lastIndexOf("/"),fe=ce===re.length-1?void 0:this.w(re.substring(ce+1));let we;try{we=new RegExp(re.substring(1,ce),fe)}catch{throw this.B("REGEX",J)}return n.regex(j,we)}case I.TokenType.QuotedStr:{const G=J.lexeme;this.z();let U=null;if(!(0,v.$ff)(G)){const K=G.indexOf("/"),re=G.lastIndexOf("/");if(K!==re&&K>=0){const ce=G.slice(K+1,re),fe=G[re+1]==="i"?"i":"";try{U=new RegExp(ce,fe)}catch{throw this.B("REGEX",J)}}}if(U===null)throw this.B("REGEX",J);return me.create(j,U)}default:throw this.B("REGEX",this.D())}}if(this.y(I.TokenType.Not)){this.A(I.TokenType.In,b);const J=this.u();return n.notIn(j,J)}switch(this.D().type){case I.TokenType.Eq:{this.z();const J=this.u();if(this.x().type===I.TokenType.QuotedStr)return n.equals(j,J);switch(J){case"true":return n.has(j);case"false":return n.not(j);default:return n.equals(j,J)}}case I.TokenType.NotEq:{this.z();const J=this.u();if(this.x().type===I.TokenType.QuotedStr)return n.notEquals(j,J);switch(J){case"true":return n.not(j);case"false":return n.has(j);default:return n.notEquals(j,J)}}case I.TokenType.Lt:return this.z(),ae.create(j,this.u());case I.TokenType.LtEq:return this.z(),ue.create(j,this.u());case I.TokenType.Gt:return this.z(),Y.create(j,this.u());case I.TokenType.GtEq:return this.z(),ne.create(j,this.u());case I.TokenType.In:return this.z(),n.in(j,this.u());default:return n.has(j)}}case I.TokenType.EOF:throw this.h.push({message:y,offset:E.offset,lexeme:"",additionalInfo:i}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const E=this.D();switch(E.type){case I.TokenType.Str:case I.TokenType.QuotedStr:return this.z(),E.lexeme;case I.TokenType.True:return this.z(),"true";case I.TokenType.False:return this.z(),"false";case I.TokenType.In:return this.z(),"in";default:return""}}w(E){return E.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(E){return this.C(E)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(E,j){if(this.C(E))return this.z();throw this.B(j,this.D())}B(E,j,Q){const J=(0,O.localize)(1679,null,E,I.$Dj.getLexeme(j)),G=j.offset,U=I.$Dj.getLexeme(j);return this.h.push({message:J,offset:G,lexeme:U,additionalInfo:Q}),a.c}C(E){return this.D().type===E}D(){return this.f[this.g]}E(){return this.D().type===I.TokenType.EOF}}e.$Fj=a;class n{static false(){return o.INSTANCE}static true(){return c.INSTANCE}static has(E){return g.create(E)}static equals(E,j){return N.create(E,j)}static notEquals(E,j){return D.create(E,j)}static regex(E,j){return me.create(E,j)}static in(E,j){return T.create(E,j)}static notIn(E,j){return A.create(E,j)}static not(E){return F.create(E)}static and(...E){return M.create(E,null,!0)}static or(...E){return q.create(E,null,!0)}static greater(E,j){return Y.create(E,j)}static greaterEquals(E,j){return ne.create(E,j)}static smaller(E,j){return ae.create(E,j)}static smallerEquals(E,j){return ue.create(E,j)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(E){return E==null?void 0:this.c.parse(E)}}e.$Gj=n;function r(z){const E=new a({regexParsingWithErrorRecovery:!1});return z.map(j=>(E.parse(j),E.lexingErrors.length>0?E.lexingErrors.map(Q=>({errorMessage:Q.additionalInfo?(0,O.localize)(1680,null,Q.additionalInfo):(0,O.localize)(1681,null),offset:Q.offset,length:Q.lexeme.length})):E.parsingErrors.length>0?E.parsingErrors.map(Q=>({errorMessage:Q.additionalInfo?`${Q.message}. ${Q.additionalInfo}`:Q.message,offset:Q.offset,length:Q.lexeme.length})):[]))}function t(z,E){const j=z?z.substituteConstants():void 0,Q=E?E.substituteConstants():void 0;return!j&&!Q?!0:!j||!Q?!1:j.equals(Q)}function s(z,E){return z.cmp(E)}class o{static{this.INSTANCE=new o}constructor(){this.type=p.False}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return c.INSTANCE}}e.$Jj=o;class c{static{this.INSTANCE=new c}constructor(){this.type=p.True}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return o.INSTANCE}}e.$Kj=c;class g{static create(E,j=null){const Q=l.get(E);return typeof Q=="boolean"?Q?c.INSTANCE:o.INSTANCE:new g(E,j)}constructor(E,j){this.key=E,this.c=j,this.type=p.Defined}cmp(E){return E.type!==this.type?this.type-E.type:X(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=l.get(this.key);return typeof E=="boolean"?E?c.INSTANCE:o.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Lj=g;class N{static create(E,j,Q=null){if(typeof j=="boolean")return j?g.create(E,Q):F.create(E,Q);const J=l.get(E);return typeof J=="boolean"?j===(J?"true":"false")?c.INSTANCE:o.INSTANCE:new N(E,j,Q)}constructor(E,j,Q){this.c=E,this.d=j,this.f=Q,this.type=p.Equals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=l.get(this.c);if(typeof E=="boolean"){const j=E?"true":"false";return this.d===j?c.INSTANCE:o.INSTANCE}return this}evaluate(E){return E.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(E){return E.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Mj=N;class T{static create(E,j){return new T(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=p.In,this.c=null}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.d,this.f,E.d,E.f)}equals(E){return E.type===this.type?this.d===E.d&&this.f===E.f:!1}substituteConstants(){return this}evaluate(E){const j=E.getValue(this.f),Q=E.getValue(this.d);return Array.isArray(j)?j.includes(Q):typeof Q=="string"&&typeof j=="object"&&j!==null?u.call(j,Q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(E){return E.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Nj=T;class A{static create(E,j){return new A(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=p.NotIn,this.c=T.create(E,j)}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(E){return E.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=A;class D{static create(E,j,Q=null){if(typeof j=="boolean")return j?F.create(E,Q):g.create(E,Q);const J=l.get(E);return typeof J=="boolean"?j===(J?"true":"false")?o.INSTANCE:c.INSTANCE:new D(E,j,Q)}constructor(E,j,Q){this.c=E,this.d=j,this.f=Q,this.type=p.NotEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=l.get(this.c);if(typeof E=="boolean"){const j=E?"true":"false";return this.d===j?o.INSTANCE:c.INSTANCE}return this}evaluate(E){return E.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(E){return E.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Pj=D;class F{static create(E,j=null){const Q=l.get(E);return typeof Q=="boolean"?Q?o.INSTANCE:c.INSTANCE:new F(E,j)}constructor(E,j){this.c=E,this.d=j,this.type=p.Not}cmp(E){return E.type!==this.type?this.type-E.type:X(this.c,E.c)}equals(E){return E.type===this.type?this.c===E.c:!1}substituteConstants(){const E=l.get(this.c);return typeof E=="boolean"?E?o.INSTANCE:c.INSTANCE:this}evaluate(E){return!E.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(E){return E.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$Qj=F;function x(z,E){if(typeof z=="string"){const j=parseFloat(z);isNaN(j)||(z=j)}return typeof z=="string"||typeof z=="number"?E(z):o.INSTANCE}class Y{static create(E,j,Q=null){return x(j,J=>new Y(E,J,Q))}constructor(E,j,Q){this.c=E,this.d=j,this.f=Q,this.type=p.Greater}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Rj=Y;class ne{static create(E,j,Q=null){return x(j,J=>new ne(E,J,Q))}constructor(E,j,Q){this.c=E,this.d=j,this.f=Q,this.type=p.GreaterEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Sj=ne;class ae{static create(E,j,Q=null){return x(j,J=>new ae(E,J,Q))}constructor(E,j,Q){this.c=E,this.d=j,this.f=Q,this.type=p.Smaller}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Tj=ae;class ue{static create(E,j,Q=null){return x(j,J=>new ue(E,J,Q))}constructor(E,j,Q){this.c=E,this.d=j,this.f=Q,this.type=p.SmallerEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Uj=ue;class me{static create(E,j){return new me(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=p.Regex,this.c=null}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.d<E.d)return-1;if(this.d>E.d)return 1;const j=this.f?this.f.source:"",Q=E.f?E.f.source:"";return j<Q?-1:j>Q?1:0}equals(E){if(E.type===this.type){const j=this.f?this.f.source:"",Q=E.f?E.f.source:"";return this.d===E.d&&j===Q}return!1}substituteConstants(){return this}evaluate(E){const j=E.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const E=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${E}`}keys(){return[this.d]}map(E){return E.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$Vj=me;class W{static create(E){return new W(E)}constructor(E){this.c=E,this.type=p.NotRegex}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(E){return new W(this.c.map(E))}negate(){return this.c}}e.$Wj=W;function _(z){let E=null;for(let j=0,Q=z.length;j<Q;j++){const J=z[j].substituteConstants();if(z[j]!==J&&E===null){E=[];for(let G=0;G<j;G++)E[G]=z[G]}E!==null&&(E[j]=J)}return E===null?z:E}class M{static create(E,j,Q){return M.d(E,j,Q)}constructor(E,j){this.expr=E,this.c=j,this.type=p.And}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let j=0,Q=this.expr.length;j<Q;j++){const J=s(this.expr[j],E.expr[j]);if(J!==0)return J}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let j=0,Q=this.expr.length;j<Q;j++)if(!this.expr[j].equals(E.expr[j]))return!1;return!0}return!1}substituteConstants(){const E=_(this.expr);return E===this.expr?this:M.create(E,this.c,!1)}evaluate(E){for(let j=0,Q=this.expr.length;j<Q;j++)if(!this.expr[j].evaluate(E))return!1;return!0}static d(E,j,Q){const J=[];let G=!1;for(const U of E)if(U){if(U.type===p.True){G=!0;continue}if(U.type===p.False)return o.INSTANCE;if(U.type===p.And){J.push(...U.expr);continue}J.push(U)}if(J.length===0&&G)return c.INSTANCE;if(J.length!==0){if(J.length===1)return J[0];J.sort(s);for(let U=1;U<J.length;U++)J[U-1].equals(J[U])&&(J.splice(U,1),U--);if(J.length===1)return J[0];for(;J.length>1;){const U=J[J.length-1];if(U.type!==p.Or)break;J.pop();const K=J.pop(),re=J.length===0,ce=q.create(U.expr.map(fe=>M.create([fe,K],null,Q)),null,re);ce&&(J.push(ce),J.sort(s))}if(J.length===1)return J[0];if(Q){for(let U=0;U<J.length;U++)for(let K=U+1;K<J.length;K++)if(J[U].negate().equals(J[K]))return o.INSTANCE;if(J.length===1)return J[0]}return new M(J,j)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(const j of this.expr)E.push(...j.keys());return E}map(E){return new M(this.expr.map(j=>j.map(E)),null)}negate(){if(!this.c){const E=[];for(const j of this.expr)E.push(j.negate());this.c=q.create(E,this,!0)}return this.c}}e.$Xj=M;class q{static create(E,j,Q){return q.d(E,j,Q)}constructor(E,j){this.expr=E,this.c=j,this.type=p.Or}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let j=0,Q=this.expr.length;j<Q;j++){const J=s(this.expr[j],E.expr[j]);if(J!==0)return J}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let j=0,Q=this.expr.length;j<Q;j++)if(!this.expr[j].equals(E.expr[j]))return!1;return!0}return!1}substituteConstants(){const E=_(this.expr);return E===this.expr?this:q.create(E,this.c,!1)}evaluate(E){for(let j=0,Q=this.expr.length;j<Q;j++)if(this.expr[j].evaluate(E))return!0;return!1}static d(E,j,Q){let J=[],G=!1;if(E){for(let U=0,K=E.length;U<K;U++){const re=E[U];if(re){if(re.type===p.False){G=!0;continue}if(re.type===p.True)return c.INSTANCE;if(re.type===p.Or){J=J.concat(re.expr);continue}J.push(re)}}if(J.length===0&&G)return o.INSTANCE;J.sort(s)}if(J.length!==0){if(J.length===1)return J[0];for(let U=1;U<J.length;U++)J[U-1].equals(J[U])&&(J.splice(U,1),U--);if(J.length===1)return J[0];if(Q){for(let U=0;U<J.length;U++)for(let K=U+1;K<J.length;K++)if(J[U].negate().equals(J[K]))return c.INSTANCE;if(J.length===1)return J[0]}return new q(J,j)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(const j of this.expr)E.push(...j.keys());return E}map(E){return new q(this.expr.map(j=>j.map(E)),null)}negate(){if(!this.c){const E=[];for(const j of this.expr)E.push(j.negate());for(;E.length>1;){const j=E.shift(),Q=E.shift(),J=[];for(const G of V(j))for(const U of V(Q))J.push(M.create([G,U],null,!1));E.unshift(q.create(J,null,!1))}this.c=q.create(E,this,!0)}return this.c}}e.$Yj=q;class H extends g{static{this.d=[]}static all(){return H.d.values()}constructor(E,j,Q){super(E,null),this.f=j,typeof Q=="object"?H.d.push({...Q,key:E}):Q!==!0&&H.d.push({key:E,description:Q,type:j!=null?typeof j:void 0})}bindTo(E){return E.createKey(this.key,this.f)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return N.create(this.key,E)}notEqualsTo(E){return D.create(this.key,E)}}e.$Zj=H,e.$1j=(0,C.$Ii)("contextKeyService");function X(z,E){return z<E?-1:z>E?1:0}function ie(z,E,j,Q){return z<j?-1:z>j?1:E<Q?-1:E>Q?1:0}function se(z,E){if(z.type===p.False||E.type===p.True)return!0;if(z.type===p.Or)return E.type===p.Or?L(z.expr,E.expr):!1;if(E.type===p.Or){for(const j of E.expr)if(se(z,j))return!0;return!1}if(z.type===p.And){if(E.type===p.And)return L(E.expr,z.expr);for(const j of z.expr)if(se(j,E))return!0;return!1}return z.equals(E)}function L(z,E){let j=0,Q=0;for(;j<z.length&&Q<E.length;){const J=z[j].cmp(E[Q]);if(J<0)return!1;J===0&&j++,Q++}return j===z.length}function V(z){return z.type===p.Or?z.expr:[z]}}),define(le[62],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=void 0,e.$5o=(0,P.$Ii)("downloadService")}),define(le[17],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,P.$Ii)("environmentService"),e.$Qi=(0,P.$Ji)(e.$Pi)}),define(le[63],he([0,1,13,7,5,9]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=C;async function C(h,u,p,f,m,k){let b;try{await O(h,u,p,f,m,k)}catch(d){b=d}finally{b&&m.errorTransformer&&(b=m.errorTransformer(b)),typeof b<"u"&&p.error(b),p.end()}}async function O(h,u,p,f,m,k){w(k);const b=await h.open(u,{create:!1});try{w(k);let d=0,$=0,R=m&&typeof m.length=="number"?m.length:void 0,y=P.$Qe.alloc(Math.min(m.bufferSize,typeof R=="number"?R:m.bufferSize)),i=m&&typeof m.position=="number"?m.position:0,a=0;do $=await h.read(b,i,y.buffer,a,y.byteLength-a),i+=$,a+=$,d+=$,typeof R=="number"&&(R-=$),a===y.byteLength&&(await p.write(f(y)),y=P.$Qe.alloc(Math.min(m.bufferSize,typeof R=="number"?R:m.bufferSize)),a=0);while($>0&&(typeof R!="number"||R>0)&&w(k)&&l(d,m));if(a>0){let n=a;typeof R=="number"&&(n=Math.min(a,R)),p.write(f(y.slice(0,n)))}}catch(d){throw(0,I.$rl)(d)}finally{await h.close(b)}}function w(h){if(h.isCancellationRequested)throw(0,S.$8)();return!0}function l(h,u){if(typeof u?.limits?.size=="number"&&h>u.limits.size)throw(0,I.$ql)((0,v.localize)(1896,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[102],he([0,1,32,2,52,4,9,11,8]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class l extends S.$Xc{constructor(){super(),this.a=this.B(new I.$oe),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$oe),this.onDidLogMessage=this.b.event,this.c=this.B(new I.$oe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new S.$7c),this.m=new Set,this.n=this.B(new w.$Gh(this.y())),this.r=5007,this.s=new w.$6h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,v.$9q)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new w.$6h;try{this.h.clear(),this.g.clear();for(const p of u)this.u(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||(this.j.deleteAndDispose(p),this.m.delete(p));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(p=>!this.j.has(p.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const p=new S.$Wc;this.j.set(u.correlationId,p),await this.s.p,!p.isDisposed&&(this.D(u,p),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,p){this.F(u,p)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,p),this.m.add(u.correlationId))}F(u,p){const f=this.O?.subscribe(u.path,(m,k)=>{p.isDisposed||(m?this.D(u,p):k?.type===C.FileChangeType.ADDED&&this.H(u))});return f?(p.add(f),!0):!1}G(u,p){let f=!1;const m=(k,b)=>{if(p.isDisposed)return;const d=this.I(k),$=this.I(b),R=f;f=d,!d&&($||R)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,P.watchFile)(u.path,{persistent:!1,interval:this.r},m)}catch(k){this.Q(`fs.watchFile() failed with error ${k} on path ${u.path} (correlationId: ${u.correlationId})`)}p.add((0,S.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,P.unwatchFile)(u.path,m)}catch(k){this.Q(`fs.unwatchFile() failed with error ${k} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const p={resource:O.URI.file(u.path),type:C.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([p]),this.J(p,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,p){if(this.R){const f=` >> normalized ${u.type===C.FileChangeType.ADDED?"[ADDED]":u.type===C.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(f,p)}}L(u,p){this.R&&this.P(`${u}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,v.$gr)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}e.$pr=l}),define(le[103],he([0,1,4,150,102,12,151,64]),function(Z,e,P,S,v,I,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class w extends v.$pr{constructor(h){super(),this.O=h,this.onDidError=P.Event.None,this.watchers=new Set}async N(h){h=this.Z(h);const u=[],p=new Set(Array.from(this.watchers));for(const f of h){const m=this.W(f);m&&(0,S.$Hk)(m.request.excludes,f.excludes)&&(0,S.$Hk)(m.request.includes,f.includes)?p.delete(m):u.push(f)}u.length&&this.P(`Request to start watching: ${u.map(f=>this.M(f)).join(",")}`),p.size&&this.P(`Request to stop watching: ${Array.from(p).map(f=>this.M(f.request)).join(",")}`);for(const f of p)this.Y(f);for(const f of u)this.X(f)}W(h){for(const u of this.watchers)if(typeof h.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===h.correlationId)return u}else if((0,O.$Gg)(u.request.path,h.path,!I.$l))return u}X(h){const u=new C.$ur(h,this.O,f=>this.a.fire(f),()=>this.c.fire(h),f=>this.b.fire(f),this.R),p={request:h,instance:u};this.watchers.add(p)}async stop(){await super.stop();for(const h of this.watchers)this.Y(h)}Y(h){this.P("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}Z(h){const u=new Map;for(const p of h){const f=I.$l?p.path:p.path.toLowerCase();let m=u.get(p.correlationId);m||(m=new Map,u.set(p.correlationId,m)),m.has(f)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(p)}`),m.set(f,p)}return Array.from(u.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const u of this.watchers)u.instance.setVerboseLogging(h)}P(h,u){this.R&&this.b.fire({type:"trace",message:this.bb(h,u)})}Q(h){this.b.fire({type:"warn",message:this.bb(h)})}bb(h,u){return u?`[File Watcher (node.js)] ${h} (${this.M(u.request)})`:`[File Watcher (node.js)] ${h}`}}e.$wr=w}),define(le[104],he([0,1,52,103]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;class v extends P.$_q{constructor(C,O,w){super(C,O,w),this.s()}r(C){return C.add(new S.$wr(void 0))}}e.$xr=v}),define(le[105],he([0,1,14,60,87,52]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class C extends I.$ar{constructor(w,l,h){super(w,l,h),this.s()}r(w){const l=w.add(new v.$nr(P.$3g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(l.onDidProcessExit(({code:h,signal:u})=>this.t(`terminated by itself with code ${h}, signal: ${u} (ETERM)`))),S.ProxyChannel.toService((0,S.$pi)(l.getChannel("watcher")))}}e.$or=C}),define(le[65],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class P{constructor(...v){this.a=new Map;for(const[I,C]of v)this.set(I,C)}set(v,I){const C=this.a.get(v);return this.a.set(v,I),C}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}e.$Gi=P}),define(le[106],he([0,1,8,7,2,51,100,10,65,152]),function(Z,e,P,S,v,I,C,O,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0;const h=!1;class u extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class p{constructor(b=new w.$Gi,d=!1,$,R=h){this.i=b,this.j=d,this.k=$,this.l=R,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Hi,this),this._globalGraph=R?$?._globalGraph??new C.$Ar(y=>y):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Sc)(this.h),this.h.clear();for(const b of this.g)(0,v.$Rc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,d){this.m();const $=this,R=new class extends p{dispose(){$.h.delete(R),super.dispose()}}(b,this.j,this,this.l);return this.h.add(R),d?.add(R),R}invokeFunction(b,...d){this.m();const $=m.traceInvocation(this.l,b);let R=!1;try{return b({get:i=>{if(R)throw(0,S.$0)("service accessor is only valid during the invocation of its target method");const a=this.s(i,$);if(!a)throw new Error(`[invokeFunction] unknown service '${i}'`);return a}},...d)}finally{R=!0,$.stop()}}createInstance(b,...d){this.m();let $,R;return b instanceof I.$Fi?($=m.traceCreation(this.l,b.ctor),R=this.o(b.ctor,b.staticArguments.concat(d),$)):($=m.traceCreation(this.l,b),R=this.o(b,d,$)),$.stop(),R}o(b,d=[],$){const R=O._util.getServiceDependencies(b).sort((a,n)=>a.index-n.index),y=[];for(const a of R){const n=this.s(a.id,$);n||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${a.id}.`,!1),y.push(n)}const i=R.length>0?R[0].index:d.length;if(d.length!==i){console.trace(`[createInstance] First service dependency of ${b.name} at position ${i+1} conflicts with ${d.length} static arguments`);const a=i-d.length;a>0?d=d.concat(new Array(a)):d=d.slice(0,i)}return Reflect.construct(b,d.concat(y))}q(b,d){if(this.i.get(b)instanceof I.$Fi)this.i.set(b,d);else if(this.k)this.k.q(b,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const d=this.i.get(b);return!d&&this.k?this.k.r(b):d}s(b,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const $=this.r(b);return $ instanceof I.$Fi?this.u(b,$,d.branch(b,!0)):(d.branch(b,!1),$)}u(b,d,$){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,d,$)}finally{this.t.delete(b)}}v(b,d,$){const R=new C.$Ar(n=>n.id.toString());let y=0;const i=[{id:b,desc:d,_trace:$}],a=new Set;for(;i.length;){const n=i.pop();if(!a.has(String(n.id))){if(a.add(String(n.id)),R.lookupOrInsertNode(n),y++>1e3)throw new u(R);for(const r of O._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof I.$Fi){const s={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};R.insertEdge(n,s),i.push(s)}}}}for(;;){const n=R.roots();if(n.length===0){if(!R.isEmpty())throw new u(R);break}for(const{data:r}of n){if(this.r(r.id)instanceof I.$Fi){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}R.removeNode(r)}}return this.r(b)}w(b,d,$=[],R,y){if(this.i.get(b)instanceof I.$Fi)return this.x(b,d,$,R,y,this.g);if(this.k)return this.k.w(b,d,$,R,y);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(b,d,$=[],R,y,i){if(R){const a=new p(void 0,this.j,this,this.l);a.c=String(b);const n=new Map,r=new P.$2h(()=>{const t=a.o(d,$,y);for(const[s,o]of n){const c=t[s];if(typeof c=="function")for(const g of o)g.disposable=c.apply(t,g.listener)}return n.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let g=n.get(s);return g||(g=new l.$8c,n.set(s,g)),(T,A,D)=>{if(r.isInitialized)return r.value[s](T,A,D);{const F={listener:[T,A,D],disposable:void 0},x=g.push(F);return(0,v.$Vc)(()=>{x(),F.disposable?.dispose()})}}}if(s in t)return t[s];const o=r.value;let c=o[s];return typeof c!="function"||(c=c.bind(o),t[s]=c),c},set(t,s,o){return r.value[s]=o,!0},getPrototypeOf(t){return d.prototype}})}else{const a=this.o(d,$,y);return i.add(a),a}}y(b,d){if(d&&console.warn(b),this.j)throw new Error(b)}}e.$Br=p;var f;(function(k){k[k.None=0]="None",k[k.Creation=1]="Creation",k[k.Invocation=2]="Invocation",k[k.Branch=3]="Branch"})(f||(f={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(f.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,d){return b?new m(f.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(b,d){return b?new m(f.Creation,d.name):m.c}static{this.f=0}constructor(b,d){this.type=b,this.name=d,this.g=Date.now(),this.h=[]}branch(b,d){const $=new m(f.Branch,b.toString());return this.h.push([b,d,$]),$}stop(){const b=Date.now()-this.g;m.f+=b;let d=!1;function $(y,i){const a=[],n=new Array(y+1).join("	");for(const[r,t,s]of i.h)if(t&&s){d=!0,a.push(`${n}CREATES -> ${r}`);const o=$(y+1,s);o&&a.push(o)}else a.push(`${n}uses -> ${r}`);return a.join(`
`)}const R=[`${this.type===f.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(b>2||d)&&m.all.add(R.join(`
`))}}e.$Cr=m}),define(le[6],he([0,1,5,38,4,43,2,25,12,16,3,11,101,10]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=k,e.log=d,e.$rk=c,e.$sk=g,e.$tk=N,e.$uk=T,P=be(P),e.$dk=(0,f.$Ii)("logService"),e.$ek=(0,f.$Ii)("loggerService");function m(){return new Date().toISOString()}function k(A){return(0,h.$lg)(A)}var b;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$gk=b.Info;function d(A,D,F){switch(D){case b.Trace:A.trace(F);break;case b.Debug:A.debug(F);break;case b.Info:A.info(F);break;case b.Warning:A.warn(F);break;case b.Error:A.error(F);break;case b.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function $(A,D=!1){let F="";for(let x=0;x<A.length;x++){let Y=A[x];if(Y instanceof Error&&(Y=(0,S.$tj)(Y,D)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}F+=(x>0?" ":"")+Y}return F}class R extends C.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new v.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==b.Off&&this.b<=D}}e.$ik=R;class y extends R{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...F){this.f(b.Trace)&&this.g(b.Trace,$([D,...F],!0))}debug(D,...F){this.f(b.Debug)&&this.g(b.Debug,$([D,...F]))}info(D,...F){this.f(b.Info)&&this.g(b.Info,$([D,...F]))}warn(D,...F){this.f(b.Warning)&&this.g(b.Warning,$([D,...F]))}error(D,...F){if(this.f(b.Error))if(D instanceof Error){const x=Array.prototype.slice.call(arguments);x[0]=D.stack,this.g(b.Error,$(x))}else this.g(b.Error,$([D,...F]))}flush(){}}e.$jk=y;class i extends R{constructor(D=e.$gk){super(),this.setLevel(D),this.g=!w.$j}trace(D,...F){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,D,...F):console.log(`[main ${m()}]`,D,...F))}debug(D,...F){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,D,...F):console.log(`[main ${m()}]`,D,...F))}info(D,...F){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,D,...F):console.log(`[main ${m()}]`,D,...F))}warn(D,...F){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,D,...F):console.warn(`[main ${m()}]`,D,...F))}error(D,...F){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,D,...F):console.error(`[main ${m()}]`,D,...F))}flush(){}}e.$kk=i;class a extends R{constructor(D=e.$gk,F=!0){super(),this.g=F,this.setLevel(D)}trace(D,...F){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...F):console.log(D,...F))}debug(D,...F){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...F):console.log(D,...F))}info(D,...F){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...F):console.log(D,...F))}warn(D,...F){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...F):console.log(D,...F))}error(D,...F){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...F):console.error(D,...F))}flush(){}}e.$lk=a;class n extends R{constructor(D,F=e.$gk){super(),this.g=D,this.setLevel(F)}trace(D,...F){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(D),...F])}debug(D,...F){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(D),...F])}info(D,...F){this.f(b.Info)&&this.g.log(b.Info,[this.h(D),...F])}warn(D,...F){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(D),...F])}error(D,...F){this.f(b.Error)&&this.g.log(b.Error,[this.h(D),...F])}h(D){return typeof D=="string"?D:(0,S.$tj)(D,this.f(b.Trace))}flush(){}}e.$mk=n;class r extends R{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const F of this.g)F.setLevel(D);super.setLevel(D)}trace(D,...F){for(const x of this.g)x.trace(D,...F)}debug(D,...F){for(const x of this.g)x.debug(D,...F)}info(D,...F){for(const x of this.g)x.info(D,...F)}warn(D,...F){for(const x of this.g)x.warn(D,...F)}error(D,...F){for(const x of this.g)x.error(D,...F)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose();super.dispose()}}e.$nk=r;class t extends C.$Xc{constructor(D,F,x){if(super(),this.h=D,this.j=F,this.b=new O.$Dc,this.c=this.B(new v.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$oe),this.onDidChangeVisibility=this.g.event,x)for(const Y of x)this.b.set(Y.resource,{logger:void 0,info:Y})}m(D){return(0,h.$hg)(D)?[...this.b.values()].find(F=>F.info.id===D):this.b.get(D)}getLogger(D){return this.m(D)?.logger}createLogger(D,F){const x=this.n(D),Y=(0,h.$hg)(D)?D:F?.id??(0,I.$wj)(x.toString()).toString(16);let ne=this.b.get(x)?.logger;const ae=F?.logLevel==="always"?b.Trace:F?.logLevel;ne||(ne=this.s(x,ae??this.getLogLevel(x)??this.h,{...F,id:Y}));const ue={logger:ne,info:{resource:x,id:Y,logLevel:ae,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(ue.info),this.b.set(x,ue),ne}n(D){return(0,h.$hg)(D)?(0,l.$jh)(this.j,`${D}.log`):D}setLogLevel(D,F){if(u.URI.isUri(D)){const x=D,Y=F,ne=this.b.get(x);ne&&Y!==ne.info.logLevel&&(ne.info.logLevel=Y===this.h?void 0:Y,ne.logger?.setLevel(Y),this.b.set(ne.info.resource,ne),this.f.fire([x,Y]))}else{this.h=D;for(const[x,Y]of this.b.entries())this.b.get(x)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,F){const x=this.m(D);x&&F!==!x.info.hidden&&(x.info.hidden=!F,this.b.set(x.info.resource,x),this.g.fire([x.info.resource,F]))}getLogLevel(D){let F;return D&&(F=this.b.get(D)?.info.logLevel),F??this.h}registerLogger(D){const F=this.b.get(D.resource);F?F.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const F=this.b.get(D);F&&(F.logger&&F.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=t;class s{constructor(){this.onDidChangeLogLevel=new v.$oe().event}setLevel(D){}getLevel(){return b.Info}trace(D,...F){}debug(D,...F){}info(D,...F){}warn(D,...F){}error(D,...F){}critical(D,...F){}dispose(){}flush(){}}e.$pk=s;class o extends s{}e.$qk=o;function c(A){if(A.verbose)return b.Trace;if(typeof A.logLevel=="string"){const D=T(A.logLevel.toLowerCase());if(D!==void 0)return D}return e.$gk}function g(A){switch(A){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function N(A){switch(A){case b.Trace:return{original:"Trace",value:P.localize(1957,null)};case b.Debug:return{original:"Debug",value:P.localize(1958,null)};case b.Info:return{original:"Info",value:P.localize(1959,null)};case b.Warning:return{original:"Warning",value:P.localize(1960,null)};case b.Error:return{original:"Error",value:P.localize(1961,null)};case b.Off:return{original:"Off",value:P.localize(1962,null)}}}function T(A){switch(A){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$vk=new p.$Zj("logLevel",g(b.Info))}),define(le[107],he([0,1,19,8,7,4,64,2,15,52,6]),function(Z,e,P,S,v,I,C,O,w,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class u extends O.$Xc{constructor(f,m){super(),this.a=f,this.b=m,this.c=this.B(new I.$oe),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$oe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new S.$Gh(0)),this.w=[],this.y=this.B(new S.$Gh(0))}watch(f,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(f,m):this.z(f,m)}n(f,m){const k={path:this.J(f),excludes:m.excludes,includes:m.includes,recursive:m.recursive,filter:m.filter,correlationId:m.correlationId},b=(0,P.$Vb)(this.j,k);return this.r(),(0,O.$Vc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(f=>(0,v.$2)(f))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,l.$br)(m)),m=>this.G(m),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const f=this.b?.watcher?.recursive?.usePolling;if(f===!0)for(const m of this.j)(0,l.$0q)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const m of this.j)(0,l.$0q)(m)&&f.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(f,m){const k={path:this.J(f),excludes:m.excludes,includes:m.includes,recursive:!1,filter:m.filter,correlationId:m.correlationId},b=(0,P.$Vb)(this.w,k);return this.C(),(0,O.$Vc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(f=>(0,v.$2)(f))}D(){return this.u||(this.u=this.B(this.F(f=>this.c.fire((0,l.$br)(f)),f=>this.G(f),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.u.watch(this.w)}G(f){f.type==="error"&&this.g.fire(f.message),this.H(f)}H(f){this.a[f.type](f.message)}I(f){return(0,w.$kc)(f.fsPath)}J(f){const m=this.I(f);return(0,C.$Kg)(m)}}e.$hr=u});var oe=this&&this.__param||function(Z,e){return function(P,S){e(P,S,Z)}};define(le[108],he([0,1,19,8,13,21,4,43,66,2,49,14,109,16,47,5,9,63,6,7]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$,R){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;let i=class extends l.$Xc{static{y=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new C.$oe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$oe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$oe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$oe),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$oe),this.Y=this.B(new C.$oe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$oe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new S.$Rh)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${n}`);const t=new l.$Wc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(s=>{const o=new b.$wl(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,l.$Vc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,l.$Sc)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await S.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return w.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,f.$nh)(n))throw new b.$yl((0,k.localize)(1869,null,this.sb(n)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new R.$db;throw t.message=(0,k.localize)(1870,null,n.toString()),t}return r}async m(n){const r=await this.j(n);if((0,b.$jl)(r)||(0,b.$gl)(r)||(0,b.$kl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,b.$jl)(r)||(0,b.$gl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(t){throw(0,b.$tl)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$yl((0,k.localize)(1871,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$rl)(t)}}async s(n,r){const t=await this.j(n),s=this.S(t),o=r?.resolveTo,c=r?.resolveSingleChildDescendants,g=r?.resolveMetadata,N=await t.stat(n);let T;return this.t(t,n,N,void 0,!!g,(A,D)=>(T||(T=h.$Oi.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(A.resource)||T.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&c?D===1:!1))}async t(n,r,t,s,o,c){const{providerExtUri:g}=this.R(n),N={resource:r,name:g.basename(r),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(n.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Jl)({mtime:t.mtime,size:t.size}),children:void 0};if(N.isDirectory&&c(N,s)){try{const T=await n.readdir(r),A=await S.Promises.settled(T.map(async([D,F])=>{try{const x=g.joinPath(r,D),Y=o?await n.stat(x):{type:F};return await this.t(n,x,Y,T.length,o,c)}catch(x){return this.b.trace(x),null}}));N.children=(0,P.$Jb)(A)}catch(T){this.b.trace(T),N.children=[]}return N}return N}async resolveAll(n){return S.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.t(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(t){return t}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new b.$yl((0,k.localize)(1872,null,this.sb(n)),b.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=v.$Qe.fromString(""),t){await this.u(n,t);const s=await this.writeFile(n,r);return this.r.fire(new b.$vl(n,b.FileOperation.CREATE,s)),s}async writeFile(n,r,t){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let c=t;if((0,b.$ml)(s)&&!c?.atomic){const g=s.enforceAtomicWriteFile?.(n);g&&(c={...t,atomic:g})}try{await this.w(s,n,c)||await this.U(s,o.dirname(n));let N;if((0,b.$gl)(s)&&!(r instanceof v.$Qe))if((0,m.$Ce)(r)){const T=await(0,m.$Je)(r,3);T.ended?N=v.$Qe.concat(T.buffer):N=T}else N=(0,m.$Ge)(r,T=>v.$Qe.concat(T),3);else N=r;!(0,b.$jl)(s)||(0,b.$gl)(s)&&N instanceof v.$Qe||(0,b.$gl)(s)&&(0,b.$ml)(s)&&c?.atomic?await this.hb(s,n,c,N):await this.db(s,n,c,N instanceof v.$Qe?(0,v.$2e)(N):N),this.r.fire(new b.$vl(n,b.FileOperation.WRITE))}catch(g){throw new b.$yl((0,k.localize)(1873,null,this.sb(n),(0,b.$rl)(g).toString()),(0,b.$ul)(g),c)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,t){const s=!!t?.unlock;if(s&&!(n.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,k.localize)(1874,null,this.sb(r)));if(!!t?.atomic){if(!(n.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,k.localize)(1875,null,this.sb(r)));if(!(n.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,k.localize)(1876,null,this.sb(r)));if(s)throw new Error((0,k.localize)(1877,null,this.sb(r)))}let c;try{c=await n.stat(r)}catch{return}if(c.type&b.FileType.Directory)throw new b.$yl((0,k.localize)(1878,null,this.sb(r)),b.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(r,c),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Il&&typeof c.mtime=="number"&&typeof c.size=="number"&&t.mtime<c.mtime&&t.etag!==(0,b.$Jl)({mtime:t.mtime,size:c.size}))throw new b.$yl((0,k.localize)(1879,null),b.FileOperationResult.FILE_MODIFIED_SINCE,t);return c}async readFile(n,r,t){const s=await this.m(n);return r?.atomic?this.z(s,n,r,t):this.C(s,n,r,t)}async z(n,r,t,s){return new Promise((o,c)=>{this.cb.queueFor(r,async()=>{try{const g=await this.C(n,r,t,s);o(g)}catch(g){c(g)}},this.R(n).providerExtUri)})}async C(n,r,t,s){const o=await this.D(n,r,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,v.$3e)(o.value)}}async readFileStream(n,r,t){const s=await this.m(n);return this.D(s,n,r,t)}async D(n,r,t,s){const o=new I.$ze(s);let c=t;(0,b.$ll)(n)&&n.enforceAtomicReadFile?.(r)&&(c={...t,atomic:!0});const g=this.J(r,c).then(T=>T,T=>{throw o.dispose(!0),T});let N;try{return typeof c?.etag=="string"&&c.etag!==b.$Il&&await g,c?.atomic&&(0,b.$ll)(n)||!((0,b.$jl)(n)||(0,b.$kl)(n))||(0,b.$gl)(n)&&c?.preferUnbuffered?N=this.I(n,r,c):(0,b.$kl)(n)?N=this.G(n,r,o.token,c):N=this.H(n,r,o.token,c),N.on("end",()=>o.dispose()),N.on("error",()=>o.dispose()),{...await g,value:N}}catch(T){throw N&&await(0,m.$He)(N),this.F(T,r,c)}}F(n,r,t){const s=(0,k.localize)(1880,null,this.sb(r),(0,b.$rl)(n).toString());return n instanceof b.$Al?new b.$Al(s,n.stat,t):n instanceof b.$zl?new b.$zl(s,n.fileOperationResult,n.size,n.options):new b.$yl(s,(0,b.$ul)(n),t)}G(n,r,t,s=Object.create(null)){const o=n.readFileStream(r,s,t);return(0,m.$Ne)(o,{data:c=>c instanceof v.$Qe?c:v.$Qe.wrap(c),error:c=>this.F(c,r,s)},c=>v.$Qe.concat(c))}H(n,r,t,s=Object.create(null)){const o=(0,v.$7e)();return(0,d.$7q)(n,r,o,c=>c,{...s,bufferSize:this.a,errorTransformer:c=>this.F(c,r,s)},t),o}I(n,r,t){const s=(0,m.$Ee)(o=>v.$Qe.concat(o));return(async()=>{try{let o;t?.atomic&&(0,b.$ll)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),s.end(v.$Qe.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new b.$yl((0,k.localize)(1881,null,this.sb(n)),b.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==b.$Il&&r.etag===t.etag)throw new b.$Al((0,k.localize)(1882,null),t,r);return this.L(n,t.size,r),t}L(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new b.$zl((0,k.localize)(1883,null,this.sb(n)),b.FileOperationResult.FILE_TOO_LARGE,r,t)}async canMove(n,r,t){return this.M(n,r,"move",t)}async canCopy(n,r,t){return this.M(n,r,"copy",t)}async M(n,r,t,s){if(n.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(n),n):await this.m(n),c=this.qb(await this.n(r),r);await this.Q(o,n,c,r,t,s)}catch(o){return o}return!0}async move(n,r,t){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),c=await this.N(s,n,o,r,"move",!!t),g=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$vl(n,c==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,g)),g}async copy(n,r,t){const s=await this.m(n),o=this.qb(await this.n(r),r),c=await this.N(s,n,o,r,"copy",!!t),g=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$vl(n,c==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,g)),g}async N(n,r,t,s,o,c){if(r.toString()===s.toString())return o;const{exists:g,isSameResourceWithDifferentPathCase:N}=await this.Q(n,r,t,s,o,c);if(g&&!N&&c&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),o==="copy"){if(n===t&&(0,b.$hl)(n))await n.copy(r,s,{overwrite:c});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,t,s):await this.O(n,r,t,s)}return o}else return n===t?(await n.rename(r,s,{overwrite:c}),o):(await this.N(n,r,t,s,"copy",c),await this.del(r,{recursive:!0}),"copy")}async O(n,r,t,s){if((0,b.$jl)(n)&&(0,b.$jl)(t))return this.jb(n,r,t,s);if((0,b.$jl)(n)&&(0,b.$gl)(t))return this.pb(n,r,t,s);if((0,b.$gl)(n)&&(0,b.$jl)(t))return this.nb(n,r,t,s);if((0,b.$gl)(n)&&(0,b.$gl)(t))return this.lb(n,r,t,s)}async P(n,r,t,s){await t.mkdir(s),Array.isArray(r.children)&&await S.Promises.settled(r.children.map(async o=>{const c=this.R(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),t,c):this.O(n,o.resource,t,c)}))}async Q(n,r,t,s,o,c){let g=!1;if(n===t){const{providerExtUri:T,isPathCaseSensitive:A}=this.R(n);if(A||(g=T.isEqual(r,s)),g&&o==="copy")throw new Error((0,k.localize)(1884,null,this.sb(r),this.sb(s)));if(!g&&T.isEqualOrParent(s,r))throw new Error((0,k.localize)(1885,null,this.sb(r),this.sb(s)))}const N=await this.exists(s);if(N&&!g){if(!c)throw new b.$yl((0,k.localize)(1886,null,this.sb(r),this.sb(s)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(n===t){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,k.localize)(1887,null,this.sb(r),this.sb(s)))}}return{exists:N,isSameResourceWithDifferentPathCase:g}}R(n){const r=this.S(n);return{providerExtUri:r?f.$_g:f.$bh,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$vl(n,b.FileOperation.CREATE,t)),t}async U(n,r){const t=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&b.FileType.Directory))throw new Error((0,k.localize)(1888,null,this.sb(r)));break}catch(o){if((0,b.$tl)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(r)),r=s.dirname(r)}for(let o=t.length-1;o>=0;o--){r=s.joinPath(r,t[o]);try{await n.mkdir(r)}catch(c){if((0,b.$tl)(c)!==b.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(n,r){try{await this.W(n,r)}catch(t){return t}return!0}async W(n,r){const t=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(t.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,k.localize)(1889,null,this.sb(n)));const o=r?.atomic;if(o&&!(t.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,k.localize)(1890,null,this.sb(n)));if(s&&o)throw new Error((0,k.localize)(1891,null,this.sb(n)));let c;try{c=await t.stat(n)}catch{}if(c)this.rb(n,c);else throw new b.$yl((0,k.localize)(1892,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const N=await this.resolve(n);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,k.localize)(1893,null,this.sb(n)))}return t}async del(n,r){const t=await this.W(n,r);let s=r;if((0,b.$nl)(t)&&!s?.atomic){const N=t.enforceAtomicDelete?.(n);N&&(s={...r,atomic:N})}const o=!!s?.useTrash,c=!!s?.recursive,g=s?.atomic??!1;await t.delete(n,{recursive:c,useTrash:o,atomic:g}),this.r.fire(new b.$vl(n,b.FileOperation.DELETE))}async cloneFile(n,r){const t=await this.j(n),s=this.qb(await this.n(r),r);if(!(t===s&&this.R(t).providerExtUri.isEqual(n,r)))return t===s&&(0,b.$il)(t)?t.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),t===s&&(0,b.$hl)(t)?this.cb.queueFor(n,()=>t.copy(n,r,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(n,()=>this.O(t,n,s,r),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:y.ab++})}watch(n,r={recursive:!1,excludes:[]}){const t=new l.$Wc;let s=!1,o=()=>{s=!0};t.add((0,l.$Vc)(()=>o())),(async()=>{try{const g=await this.bb(n,r);s?(0,l.$Sc)(g):o=()=>(0,l.$Sc)(g)}catch(g){this.b.error(g)}})();const c=r.correlationId;if(typeof c=="number"){const g=t.add(new C.$oe);return t.add(this.X.event(T=>{T.correlates(c)&&g.fire(T)})),{onDidChange:g.event,dispose:()=>t.dispose()}}return t}async bb(n,r){const t=await this.j(n),s=(0,O.$wj)([this.R(t).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:t.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,l.$Vc)(()=>{o&&(o.count--,o.count===0&&((0,l.$Sc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,l.$Sc)(n.disposable);this.$.clear()}async db(n,r,t,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,m.$Ce)(s)||(0,m.$De)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(c){throw(0,b.$rl)(c)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,t){let s=0,o;if((0,m.$De)(t)){if(t.buffer.length>0){const c=v.$Qe.concat(t.buffer);await this.gb(n,r,c,c.byteLength,s,0),s+=c.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((c,g)=>{(0,m.$Ie)(o,{onData:async N=>{o.pause();try{await this.gb(n,r,N,N.byteLength,s,0)}catch(T){return g(T)}s+=N.byteLength,setTimeout(()=>o.resume())},onError:N=>g(N),onEnd:()=>c()})})}async fb(n,r,t){let s=0,o;for(;(o=t.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,t,s,o,c){let g=0;for(;g<s;){const N=await n.write(r,o+g,t.buffer,c+g,s-g);g+=N}}async hb(n,r,t,s){return this.cb.queueFor(r,()=>this.ib(n,r,t,s),this.R(n).providerExtUri)}async ib(n,r,t,s){let o;s instanceof v.$Qe?o=s:(0,m.$Ce)(s)?o=await(0,v.$3e)(s):(0,m.$De)(s)?o=await(0,v.$4e)(s):o=(0,v.$1e)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(n,r,t,s){return this.cb.queueFor(s,()=>this.kb(n,r,t,s),this.R(t).providerExtUri)}async kb(n,r,t,s){let o,c;try{o=await n.open(r,{create:!1}),c=await t.open(s,{create:!0,unlock:!1});const g=v.$Qe.alloc(this.a);let N=0,T=0,A=0;do A=await n.read(o,N,g.buffer,T,g.byteLength-T),await this.gb(t,c,g,A,N,T),N+=A,T+=A,T===g.byteLength&&(T=0);while(A>0)}catch(g){throw(0,b.$rl)(g)}finally{await S.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async lb(n,r,t,s){return this.cb.queueFor(s,()=>this.mb(n,r,t,s),this.R(t).providerExtUri)}async mb(n,r,t,s){return t.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,t,s){return this.cb.queueFor(s,()=>this.ob(n,r,t,s),this.R(t).providerExtUri)}async ob(n,r,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const c=await n.readFile(r);await this.gb(t,o,v.$Qe.wrap(c),c.byteLength,0,0)}catch(c){throw(0,b.$rl)(c)}finally{await t.close(o)}}async pb(n,r,t,s){const o=await(0,v.$3e)(this.H(n,r,I.CancellationToken.None));await this.hb(t,s,void 0,o)}qb(n,r){if(n.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$yl((0,k.localize)(1894,null,this.sb(r)),b.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$yl((0,k.localize)(1895,null,this.sb(n)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}};e.$8q=i,e.$8q=i=y=Ee([oe(0,$.$dk)],i)}),define(le[110],he([0,1,32,8,25,13,4,64,2,15,12,16,47,29,5,9,63,107,105,104]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class y extends d.$hr{static{this.L=!1}constructor(a,n){super(a,n),this.onDidChangeCapabilities=C.Event.None,this.P=new v.$Dc(r=>u.$ah.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=k.FileSystemProviderCapabilities.FileReadWrite|k.FileSystemProviderCapabilities.FileOpenReadWriteClose|k.FileSystemProviderCapabilities.FileReadStream|k.FileSystemProviderCapabilities.FileFolderCopy|k.FileSystemProviderCapabilities.FileWriteUnlock|k.FileSystemProviderCapabilities.FileAtomicRead|k.FileSystemProviderCapabilities.FileAtomicWrite|k.FileSystemProviderCapabilities.FileAtomicDelete|k.FileSystemProviderCapabilities.FileClone,h.$l&&(this.M|=k.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:n,symbolicLink:r}=await f.SymlinkSupport.stat(this.I(a));return{type:this.O(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:k.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const n=await f.Promises.readdir(this.I(a),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,u.$jh)(a,t.name))).type:s=this.O(t),r.push([t.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.hb(n)}}O(a,n){let r;return n?.dangling?r=k.FileType.Unknown:a.isFile()?r=k.FileType.File:a.isDirectory()?r=k.FileType.Directory:r=k.FileType.Unknown,n&&(r|=k.FileType.SymbolicLink),r}async Q(a){const n=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const t=new S.$Hh;return this.P.set(a,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,w.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(a)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),t.open()})}async readFile(a,n){let r;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),r=await this.Q(a));const t=this.I(a);return await P.promises.readFile(t)}catch(t){throw this.hb(t)}finally{r?.dispose()}}R(a){y.L&&this.a.trace(a)}readFileStream(a,n,r){const t=(0,p.$Ee)(s=>I.$Qe.concat(s.map(o=>I.$Qe.wrap(o))).buffer);return(0,b.$7q)(this,a,t,s=>s.buffer,{...n,bufferSize:256*1024},r),t}async writeFile(a,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(a)?this.U(a,(0,u.$jh)((0,u.$ih)(a),`${(0,u.$gh)(a)}${r.atomic.postfix}`),n,r):this.W(a,n,r)}async S(a){try{const n=this.I(a),{symbolicLink:r}=await f.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async U(a,n,r,t){const s=new w.$Wc;try{s.add(await this.Q(a)),s.add(await this.Q(n)),await this.W(n,r,t,!0);try{await this.rename(n,a,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async W(a,n,r,t){let s;try{const o=this.I(a);if(!r.create||!r.overwrite){if(await f.Promises.exists(o)){if(!r.overwrite)throw(0,k.$ql)((0,m.localize)(1899,null),k.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,k.$ql)((0,m.localize)(1900,null),k.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(a,{create:!0,unlock:r.unlock},t),await this.write(s,0,n,0,n.byteLength)}catch(o){throw await this.ib(a,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(a){y.$=a}async open(a,n,r){const t=this.I(a);let s;(0,k.$el)(n)&&!r&&(s=await this.Q(a));let o;try{if((0,k.$el)(n)&&n.unlock)try{const{stat:g}=await f.SymlinkSupport.stat(t);g.mode&128||await P.promises.chmod(t,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let c;if((0,k.$el)(n)){if(h.$j)try{await P.promises.truncate(t,0),c="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}c||(c="w")}else c="r";o=await f.Promises.open(t,c)}catch(c){throw s?.dispose(),(0,k.$el)(n)?await this.ib(a,c):this.hb(c)}if(this.X.set(o,0),(0,k.$el)(n)&&this.Z.set(o,a),s){const c=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.Y.set(o,s),c&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),c.dispose())}return o}async close(a){const n=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&y.$)try{await f.Promises.fdatasync(a)}catch(r){y.configureFlushOnWrite(!1),this.a.error(r)}return await f.Promises.close(a)}catch(r){throw this.hb(r)}finally{n&&(this.Y.get(a)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),n.dispose())}}async read(a,n,r,t,s){const o=this.ab(a,n);let c=null;try{c=(await f.Promises.read(a,r,t,s,o)).bytesRead}catch(g){throw this.hb(g)}finally{this.bb(a,o,c)}return c}ab(a,n){return n===this.X.get(a)?null:n}bb(a,n,r){const t=this.X.get(a);typeof t=="number"&&(typeof n=="number"||(typeof r=="number"?this.X.set(a,t+r):this.X.delete(a)))}async write(a,n,r,t,s){return(0,S.$3h)(()=>this.cb(a,n,r,t,s),100,3)}async cb(a,n,r,t,s){const o=this.ab(a,n);let c=null;try{c=(await f.Promises.write(a,r,t,s,o)).bytesWritten}catch(g){throw await this.ib(this.Z.get(a),g)}finally{this.bb(a,o,c)}return c}async mkdir(a){try{await P.promises.mkdir(this.I(a))}catch(n){throw this.hb(n)}}async delete(a,n){try{const r=this.I(a);if(n.recursive){let t;n?.atomic!==!1&&n.atomic.postfix&&(t=(0,l.$mc)((0,l.$pc)(r),`${(0,l.$qc)(r)}${n.atomic.postfix}`)),await f.Promises.rm(r,f.RimRafMode.MOVE,t)}else try{await P.promises.unlink(r)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:c}=await f.SymlinkSupport.stat(r);s=o.isDirectory()&&!c}catch{}if(s)await P.promises.rmdir(r);else throw t}else throw t}}catch(r){throw this.hb(r)}}async rename(a,n,r){const t=this.I(a),s=this.I(n);if(t!==s)try{await this.db(a,n,"move",r.overwrite),await f.Promises.rename(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,m.localize)(1901,null,(0,l.$qc)(t),(0,l.$qc)((0,l.$pc)(s)),o.toString()))),this.hb(o)}}async copy(a,n,r){const t=this.I(a),s=this.I(n);if(t!==s)try{await this.db(a,n,"copy",r.overwrite),await f.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,m.localize)(1902,null,(0,l.$qc)(t),(0,l.$qc)((0,l.$pc)(s)),o.toString()))),this.hb(o)}}async db(a,n,r,t){const s=this.I(a),o=this.I(n);let c=!1;if(!!(this.capabilities&k.FileSystemProviderCapabilities.PathCaseSensitive)||(c=(0,O.$Gg)(s,o,!0)),c){if(r==="copy")throw(0,k.$ql)((0,m.localize)(1903,null),k.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const N=await this.N(a);if(!N)throw(0,k.$ql)((0,m.localize)(1904,null),k.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(n);if(T){if(!t)throw(0,k.$ql)((0,m.localize)(1905,null),k.FileSystemProviderErrorCode.FileExists);N.type&k.FileType.File&&T.type&k.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,n){return this.eb(a,n,!1)}async eb(a,n,r){const t=this.I(a),s=this.I(n),o=!!(this.capabilities&k.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Gg)(t,s,!o))return;const c=new w.$Wc;try{c.add(await this.Q(a)),c.add(await this.Q(n)),r&&await P.promises.mkdir((0,l.$pc)(s),{recursive:!0}),await P.promises.copyFile(t,s)}catch(g){if(g.code==="ENOENT"&&!r)return this.eb(a,n,!0);throw this.hb(g)}finally{c.dispose()}}t(a,n,r){return new $.$or(t=>a(t),t=>n(t),r)}F(a,n,r){return new R.$xr(t=>a(t),t=>n(t),r)}hb(a){if(a instanceof k.$pl)return a;let n=a,r;switch(a.code){case"ENOENT":r=k.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=k.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=k.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=k.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=k.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=k.FileSystemProviderErrorCode.Unknown;break;default:r=k.FileSystemProviderErrorCode.Unknown}return(0,k.$ql)(n,r)}async ib(a,n){let r=this.hb(n);if(a&&r.code===k.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await f.SymlinkSupport.stat(this.I(a));t.mode&128||(r=(0,k.$ql)(n,k.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return r}}e.$yr=y}),define(le[111],he([0,1,2,6]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class v extends P.$Xc{constructor(C,O=[]){super(),this.a=new S.$nk([C,...O]),this.B(C.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...O){this.a.trace(C,...O)}debug(C,...O){this.a.debug(C,...O)}info(C,...O){this.a.info(C,...O)}warn(C,...O){this.a.warn(C,...O)}error(C,...O){this.a.error(C,...O)}flush(){this.a.flush()}}e.$4R=v}),define(le[112],he([0,1,9,6]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0;var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v||(v={}));async function I(l,h,u,p,f){try{const m=await new Promise((b,d)=>{Z(["@vscode/spdlog"],b,d)}).then(be);m.setFlushOn(v.Trace);const k=await m.createAsyncRotatingLogger(l,h,u,p);return f?k.clearFormatters():k.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),k}catch(m){console.error(m)}return null}function C(l,h,u){switch(h){case S.LogLevel.Trace:l.trace(u);break;case S.LogLevel.Debug:l.debug(u);break;case S.LogLevel.Info:l.info(u);break;case S.LogLevel.Warning:l.warn(u);break;case S.LogLevel.Error:l.error(u);break;case S.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function O(l,h){switch(h){case S.LogLevel.Trace:l.setLevel(v.Trace);break;case S.LogLevel.Debug:l.setLevel(v.Debug);break;case S.LogLevel.Info:l.setLevel(v.Info);break;case S.LogLevel.Warning:l.setLevel(v.Warning);break;case S.LogLevel.Error:l.setLevel(v.Error);break;case S.LogLevel.Off:l.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class w extends S.$jk{constructor(h,u,p,f,m){super(),this.m=[],this.setLevel(m),this.n=this.s(h,u,p,f),this.B(this.onDidChangeLogLevel(k=>{this.r&&O(this.r,k)}))}async s(h,u,p,f){const m=p?6:1,k=30/m*P.$Ll.MB,b=await I(h,u,k,m,f);if(b){this.r=b,O(this.r,this.getLevel());for(const{level:d,message:$}of this.m)C(this.r,d,$);this.m=[]}}g(h,u){this.r?C(this.r,h,u):this.getLevel()<=h&&this.m.push({level:h,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$SR=w}),define(le[113],he([0,1,28,6,112]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0;class I extends S.$ok{s(O,w,l){return new v.$SR((0,P.$5g)(),O.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,w)}}e.$TR=I}),define(le[39],he([0,1,4,66,2,10]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=void 0,e.$wo=(0,I.$Ii)("policy");class C extends v.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$oe),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const h=Object.keys(this.f).length;return this.f={...l,...this.f},h!==Object.keys(this.f).length&&await this.j(l),S.Iterable.reduce(this.g.entries(),(u,[p,f])=>({...u,[p]:f}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return S.Iterable.reduce(Object.entries(this.f),(l,[h,u])=>({...l,[h]:{definition:u,value:this.g.get(h)}}),{})}}e.$xo=C;class O{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$yo=O}),define(le[114],he([0,1,8,4,66,3,9,6,39]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;function l(u,p){const f=[];for(const m of new Set(v.Iterable.concat(u.keys(),p.keys())))u.get(m)!==p.get(m)&&f.push(m);return f}let h=class extends w.$xo{constructor(p,f,m){super(),this.m=p,this.n=f,this.s=m,this.c=this.B(new P.$Gh(500));const k=S.Event.filter(f.onDidFilesChange,b=>b.affects(p));this.B(f.watch(p)),this.B(k(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const f=await this.n.readFile(this.m),m=JSON.parse(f.value.toString());if(!(0,I.$jg)(m))throw new Error("Policy file isn't a JSON object");for(const k of Object.keys(m))this.f[k]&&p.set(k,m[k])}catch(f){f.fileOperationResult!==C.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",f)}return p}async w(){const p=await this.u(),f=l(this.g,p);this.g=p,f.length>0&&this.h.fire(f)}};e.$Qic=h,e.$Qic=h=Ee([oe(1,C.$dl),oe(2,O.$dk)],h)}),define(le[115],he([0,1,39,8,2,6]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;let C=class extends P.$xo{constructor(w,l){super(),this.m=w,this.n=l,this.a=new S.$Ch,this.b=this.B(new v.$Yc)}async j(w){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`);const{createWatcher:l}=await new Promise((h,u)=>{Z(["@vscode/policy-watcher"],h,u)}).then(be);await this.a.queue(()=>new Promise((h,u)=>{try{this.b.value=l(this.n,w,p=>{this.t(p),h()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),u(p)}}))}t(w){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const l in w){const h=w[l];h===void 0?this.g.delete(l):this.g.set(l,h)}this.h.fire(Object.keys(w))}};e.$Pic=C,e.$Pic=C=Ee([oe(0,I.$dk)],C)}),define(le[33],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,P.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"}),define(le[37],he([0,1,76,3]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=void 0,P=be(P),S=be(S);class v{constructor(){this.a=new Map}add(C,O){P.ok(S.$hg(C)),P.ok(S.$jg(O)),P.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,O)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$uo=new v}),define(le[116],he([0,1,4,79,37]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,v=be(v),e.$vo={JSONContribution:"base.contributions.json"};function I(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class C{constructor(){this.b=new P.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,h){this.a[I(l)]=h,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(l){const h=this.a[l];return h?(0,S.$$j)(h):void 0}hasSchemaContent(l){return!!this.a[l]}}const O=new C;v.$uo.add(e.$vo.JSONContribution,O)}),define(le[40],he([0,1,19,4,3,5,30,116,37]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ConfigurationScope=e.$zo=e.EditPresentationTypes=void 0,e.$Ko=k,e.$Lo=b,e.$Mo=d,e.$No=R,e.$Oo=y,e.$Po=i,e.$Qo=a,v=be(v),I=be(I);var l;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$zo={Configuration:"base.contributions.configuration"};var h;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go="vscode://schemas/settings/resourceLanguage",e.$Ho="vscode://schemas/settings/configurationDefaults";const u=w.$uo.as(O.$vo.JSONContribution);class p{constructor(){this.a=[],this.i=new Set,this.j=new S.$oe,this.onDidSchemaChange=this.j.event,this.k=new S.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:I.localize(1660,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},u.registerSchema(e.$Go,this.h),this.z()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const s=new Set;this.r(r,t,s),u.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(r){const t=new Set;this.s(r,t),u.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:r,remove:t}){const s=new Set;this.s(t,s),this.r(r,!1,s),u.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(r){const t=new Set;this.l(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(r,t){this.a.push(...r);const s=[];for(const{overrides:o,source:c}of r)for(const g in o){t.add(g);const N=this.b.get(g)??this.b.set(g,{configurationDefaultOverrides:[]}).get(g),T=o[g];if(N.configurationDefaultOverrides.push({value:T,source:c}),e.$Jo.test(g)){const A=this.o(g,T,c,N.configurationDefaultOverrideValue);if(!A)continue;N.configurationDefaultOverrideValue=A,this.n(g,A,c),s.push(...k(g))}else{const A=this.p(g,T,c,N.configurationDefaultOverrideValue);if(!A)continue;N.configurationDefaultOverrideValue=A;const D=this.e[g];D&&(this.A(g,D),this.w(g,D))}}this.q(s)}deregisterDefaultConfigurations(r){const t=new Set;this.m(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(r,t){for(const s of r){const o=this.a.indexOf(s);o!==-1&&this.a.splice(o,1)}for(const{overrides:s,source:o}of r)for(const c in s){const g=this.b.get(c);if(!g)continue;const N=g.configurationDefaultOverrides.findIndex(T=>o?T.source?.id===o.id:T.value===s[c]);if(N!==-1){if(g.configurationDefaultOverrides.splice(N,1),g.configurationDefaultOverrides.length===0&&this.b.delete(c),e.$Jo.test(c)){let T;for(const A of g.configurationDefaultOverrides)T=this.o(c,A.value,A.source,T);T&&!v.$ug(T.value)?(g.configurationDefaultOverrideValue=T,this.n(c,T,o)):(this.b.delete(c),delete this.e[c],delete this.c.properties[c])}else{let T;for(const D of g.configurationDefaultOverrides)T=this.p(c,D.value,D.source,T);g.configurationDefaultOverrideValue=T;const A=this.e[c];A&&(this.A(c,A),this.w(c,A))}t.add(c)}}this.y()}n(r,t,s){const o={type:"object",default:t.value,description:I.localize(1661,null,(0,C.$mj)(r)),$ref:e.$Go,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[r]=o,this.c.properties[r]=o}o(r,t,s,o){const c=o?.value||{},g=o?.source??new Map;if(!(g instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const N of Object.keys(t)){const T=t[N];if(v.$jg(T)&&(v.$og(c[N])||v.$jg(c[N]))){if(c[N]={...c[N]??{},...T},s)for(const D in T)g.set(`${N}.${D}`,s)}else c[N]=T,s?g.set(N,s):g.delete(N)}return{value:c,source:g}}p(r,t,s,o){const c=this.e[r],g=o?.value??c?.defaultDefaultValue;let N=s;if(v.$jg(t)&&(c!==void 0&&c.type==="object"||c===void 0&&(v.$og(g)||v.$jg(g)))){if(N=o?.source??new Map,!(N instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in t)s&&N.set(`${r}.${A}`,s);t={...v.$jg(g)?g:{},...t}}return{value:t,source:N}}deltaConfiguration(r){let t=!1;const s=new Set;r.removedDefaults&&(this.m(r.removedDefaults,s),t=!0),r.addedDefaults&&(this.l(r.addedDefaults,s),t=!0),r.removedConfigurations&&this.s(r.removedConfigurations,s),r.addedConfigurations&&this.r(r.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this.j.fire()}registerOverrideIdentifiers(r){this.q(r),this.j.fire()}q(r){for(const t of r)this.i.add(t);this.y()}r(r,t,s){r.forEach(o=>{this.u(o,t,o.extensionInfo,o.restrictedProperties,void 0,s),this.d.push(o),this.v(o)})}s(r,t){const s=o=>{if(o.properties)for(const c in o.properties){t.add(c);const g=this.e[c];g?.policy?.name&&this.f.delete(g.policy.name),delete this.e[c],this.x(c,o.properties[c])}o.allOf?.forEach(c=>s(c))};for(const o of r){s(o);const c=this.d.indexOf(o);c!==-1&&this.d.splice(c,1)}}u(r,t=!0,s,o,c=h.WINDOW,g){c=v.$qg(r.scope)?c:r.scope;const N=r.properties;if(N)for(const A in N){const D=N[A];if(t&&R(A,D)){delete N[A];continue}if(D.source=s,D.defaultDefaultValue=N[A].default,this.A(A,D),e.$Jo.test(A)?D.scope=void 0:(D.scope=v.$qg(D.scope)?c:D.scope,D.restricted=v.$qg(D.restricted)?!!o?.includes(A):D.restricted),N[A].hasOwnProperty("included")&&!N[A].included){this.g[A]=N[A],delete N[A];continue}else this.e[A]=N[A],N[A].policy?.name&&this.f.set(N[A].policy.name,A);!N[A].deprecationMessage&&N[A].markdownDeprecationMessage&&(N[A].deprecationMessage=N[A].markdownDeprecationMessage),g.add(A)}const T=r.allOf;if(T)for(const A of T)this.u(A,t,s,o,c,g)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const r=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&r.set(t,s.configurationDefaultOverrideValue);return r}v(r){const t=s=>{const o=s.properties;if(o)for(const g in o)this.w(g,o[g]);s.allOf?.forEach(t)};t(r)}w(r,t){switch(e.$Ao.properties[r]=t,t.scope){case h.APPLICATION:e.$Bo.properties[r]=t;break;case h.MACHINE:e.$Co.properties[r]=t;break;case h.MACHINE_OVERRIDABLE:e.$Do.properties[r]=t;break;case h.WINDOW:e.$Eo.properties[r]=t;break;case h.RESOURCE:e.$Fo.properties[r]=t;break;case h.LANGUAGE_OVERRIDABLE:e.$Fo.properties[r]=t,this.h.properties[r]=t;break}}x(r,t){switch(delete e.$Ao.properties[r],t.scope){case h.APPLICATION:delete e.$Bo.properties[r];break;case h.MACHINE:delete e.$Co.properties[r];break;case h.MACHINE_OVERRIDABLE:delete e.$Do.properties[r];break;case h.WINDOW:delete e.$Eo.properties[r];break;case h.RESOURCE:case h.LANGUAGE_OVERRIDABLE:delete e.$Fo.properties[r],delete this.h.properties[r];break}}y(){for(const r of this.i.values()){const t=`[${r}]`,s={type:"object",description:I.localize(1662,null),errorMessage:I.localize(1663,null),$ref:e.$Go};this.A(t,s),e.$Ao.properties[t]=s,e.$Bo.properties[t]=s,e.$Co.properties[t]=s,e.$Do.properties[t]=s,e.$Eo.properties[t]=s,e.$Fo.properties[t]=s}}z(){const r={type:"object",description:I.localize(1664,null),errorMessage:I.localize(1665,null),$ref:e.$Go};e.$Ao.patternProperties[e.$Io]=r,e.$Bo.patternProperties[e.$Io]=r,e.$Co.patternProperties[e.$Io]=r,e.$Do.patternProperties[e.$Io]=r,e.$Eo.patternProperties[e.$Io]=r,e.$Fo.patternProperties[e.$Io]=r,this.j.fire()}A(r,t){const s=this.b.get(r)?.configurationDefaultOverrideValue;let o,c;s&&(!t.disallowConfigurationDefault||!s.source)&&(o=s.value,c=s.source),v.$og(o)&&(o=t.defaultDefaultValue,c=void 0),v.$og(o)&&(o=d(t.type)),t.default=o,t.defaultValueSource=c}}const f="\\[([^\\]]+)\\]",m=new RegExp(f,"g");e.$Io=`^(${f})+$`,e.$Jo=new RegExp(e.$Io);function k(n){const r=[];if(e.$Jo.test(n)){let t=m.exec(n);for(;t?.length;){const s=t[1].trim();s&&r.push(s),t=m.exec(n)}}return(0,P.$Ob)(r)}function b(n){return n.reduce((r,t)=>`${r}[${t}]`,"")}function d(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new p;w.$uo.add(e.$zo.Configuration,$);function R(n,r){return n.trim()?e.$Jo.test(n)?I.localize(1667,null,n):$.getConfigurationProperties()[n]!==void 0?I.localize(1668,null,n):r.policy?.name&&$.getPolicyConfigurations().get(r.policy?.name)!==void 0?I.localize(1669,null,n,r.policy?.name,$.getPolicyConfigurations().get(r.policy?.name)):null:I.localize(1666,null)}function y(){const n=[],r=$.getConfigurationProperties();for(const t of Object.keys(r))n.push([t,r[t].scope]);return n.push(["launch",h.RESOURCE]),n.push(["task",h.RESOURCE]),n}function i(n){const r={};for(const t of n){const s=t.properties;if(v.$jg(s))for(const o in s)r[o]=s[o];t.allOf&&Object.assign(r,i(t.allOf))}return r}function a(n){switch(n){case"application":return h.APPLICATION;case"machine":return h.MACHINE;case"resource":return h.RESOURCE;case"machine-overridable":return h.MACHINE_OVERRIDABLE;case"language-overridable":return h.LANGUAGE_OVERRIDABLE;default:return h.WINDOW}}}),define(le[67],he([0,1,19,4,34,2,25,27,3,11,30,40,9,37]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Uo=e.$To=e.$So=e.$Ro=void 0,e.$Vo=y,P=be(P),v=be(v),O=be(O),w=be(w);function m(r){return Object.isFrozen(r)?r:O.$io(r)}class k{static createEmptyModel(t){return new k({},[],[],void 0,t)}constructor(t,s,o,c,g){this.b=t,this.c=s,this.d=o,this.raw=c,this.f=g,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof k)return s;const o=new b("",this.f);return o.parseRaw(s),o.configurationModel});this.g=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,h.$kj)(this.contents,t):this.contents}inspect(t,s){const o=this;return{get value(){return m(o.rawConfiguration.getValue(t))},get override(){return s?m(o.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return m(s?o.rawConfiguration.override(s).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const c=[];for(const{contents:g,identifiers:N,keys:T}of o.rawConfiguration.overrides){const A=new k(g,T,[],void 0,o.f).getValue(t);A!==void 0&&c.push({identifiers:N,value:A})}return c.length?m(c):void 0}}}getOverrideValue(t,s){const o=this.j(s);return o?t?(0,h.$kj)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return P.$Ob(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return P.$Ob(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=O.$ho(this.contents),o=O.$ho(this.overrides),c=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const N of t)if(g.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(s,N.contents);for(const T of N.overrides){const[A]=o.filter(D=>P.$wb(D.identifiers,T.identifiers));A?(this.i(A.contents,T.contents),A.keys.push(...T.keys),A.keys=P.$Ob(A.keys)):o.push(O.$ho(T))}for(const T of N.keys)c.indexOf(T)===-1&&c.push(T)}return new k(s,c,o,g.every(N=>N instanceof k)?void 0:g,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const c of P.$Ob([...Object.keys(this.contents),...Object.keys(s)])){let g=this.contents[c];const N=s[c];N&&(typeof g=="object"&&typeof N=="object"?(g=O.$ho(g),this.i(g,N)):g=N),o[c]=g}return new k(o,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const o of Object.keys(s)){if(o in t&&w.$jg(t[o])&&w.$jg(s[o])){this.i(t[o],s[o]);continue}t[o]=O.$ho(s[o])}}j(t){let s=null,o=null;const c=g=>{g&&(o?this.i(o,g):o=O.$ho(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===t?s=g.contents:g.identifiers.includes(t)&&c(g.contents);return c(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,h.$jj)(this.contents,t),u.$Jo.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>P.$wb(o.identifiers,(0,u.$Ko)(t))),1))}k(t,s,o){if((0,h.$ij)(this.contents,t,s,c=>this.f.error(c)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),u.$Jo.test(t)){const c=(0,u.$Ko)(t),g={identifiers:c,keys:Object.keys(this.contents[t]),contents:(0,h.$hj)(this.contents[t],T=>this.f.error(T))},N=this.overrides.findIndex(T=>P.$wb(T.identifiers,c));N!==-1?this.overrides[N]=g:this.overrides.push(g)}}}e.$Ro=k;class b{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||k.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!w.$qg(t)){const o=this.h(t);this.parseRaw(o,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:o,keys:c,overrides:g,restricted:N,hasExcludedProperties:T}=this.i(t,s);this.b=new k(o,c,g,T?[t]:void 0,this.g),this.c=N||[]}h(t){let s={},o=null,c=[];const g=[],N=[];function T(D){Array.isArray(c)?c.push(D):o!==null&&(c[o]=D)}const A={onObjectBegin:()=>{const D={};T(D),g.push(c),c=D,o=null},onObjectProperty:D=>{o=D},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const D=[];T(D),g.push(c),c=D,o=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:T,onError:(D,F,x)=>{N.push({error:D,offset:F,length:x})}};if(t)try{v.$9n(t,A),s=c[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return s}i(t,s){const o=f.$uo.as(u.$zo.Configuration).getConfigurationProperties(),c=this.j(t,o,!0,s);t=c.raw;const g=(0,h.$hj)(t,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),N=Object.keys(t),T=this.l(t,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:g,keys:N,overrides:T,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(t,s,o,c){let g=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:g};const N={},T=[];for(const A in t)if(u.$Jo.test(A)&&o){const D=this.j(t[A],s,!1,c);N[A]=D.raw,g=g||D.hasExcludedProperties,T.push(...D.restricted)}else{const D=s[A],F=D?typeof D.scope<"u"?D.scope:u.ConfigurationScope.WINDOW:void 0;D?.restricted&&T.push(A),!c.exclude?.includes(A)&&(c.include?.includes(A)||(F===void 0||c.scopes===void 0||c.scopes.includes(F))&&!(c.skipRestricted&&D?.restricted))?N[A]=t[A]:g=!0}return{raw:N,restricted:T,hasExcludedProperties:g}}l(t,s){const o=[];for(const c of Object.keys(t))if(u.$Jo.test(c)){const g={};for(const N in t[c])g[N]=t[c][N];o.push({identifiers:(0,u.$Ko)(c),keys:Object.keys(g),contents:(0,h.$hj)(g,s)})}return o}}e.$So=b;class d extends I.$Xc{constructor(t,s,o,c,g){super(),this.c=t,this.f=s,this.g=c,this.h=g,this.b=this.B(new S.$oe),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),g),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(S.Event.any(S.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),S.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(p.FileOperation.CREATE)||N.isOperation(p.FileOperation.COPY)||N.isOperation(p.FileOperation.DELETE)||N.isOperation(p.FileOperation.WRITE))&&o.isEqual(N.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return k.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$To=d;class ${constructor(t,s,o,c,g,N,T,A,D,F,x,Y,ne){this.a=t,this.b=s,this.c=o,this.overrideIdentifiers=c,this.d=g,this.f=N,this.g=T,this.h=A,this.i=D,this.j=F,this.k=x,this.l=Y,this.m=ne}get value(){return m(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class R{constructor(t,s,o,c,g,N,T,A,D,F){this.j=t,this.l=s,this.m=o,this.n=c,this.p=g,this.q=N,this.r=T,this.s=A,this.t=D,this.u=F,this.h=null,this.i=new C.$Dc,this.v=null}getValue(t,s,o){return this.w(t,s,o).getValue(t)}updateValue(t,s,o={}){let c;o.resource?(c=this.t.get(o.resource),c||(c=k.createEmptyModel(this.u),this.t.set(o.resource,c))):c=this.s,s===void 0?c.removeValue(t):c.setValue(t,s),o.resource||(this.h=null)}inspect(t,s,o){const c=this.w(t,s,o),g=this.A(s.resource,o),N=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const A of c.overrides)for(const D of A.identifiers)c.getOverrideValue(t,D)!==void 0&&T.add(D);return new $(t,s,c.getValue(t),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,g||void 0,N)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:c,updated:g,removed:N}=a(this.j,t);s=[...c,...g,...N]}for(const c of s)for(const g of(0,u.$Ko)(c)){const N=this.j.getKeysForOverrideIdentifier(g),T=t.getKeysForOverrideIdentifier(g),A=[...T.filter(D=>N.indexOf(D)===-1),...N.filter(D=>T.indexOf(D)===-1),...N.filter(D=>!O.$lo(this.j.override(g).getValue(D),t.override(g).getValue(D)))];o.push([g,A])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:c}=a(this.l,t),g=[...s,...o,...c];return g.length&&this.updatePolicyConfiguration(t),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:c,overrides:g}=a(this.applicationConfiguration,t),N=[...s,...o,...c];return N.length&&this.updateApplicationConfiguration(t),{keys:N,overrides:g}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:c,overrides:g}=a(this.localUserConfiguration,t),N=[...s,...o,...c];return N.length&&this.updateLocalUserConfiguration(t),{keys:N,overrides:g}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:c,overrides:g}=a(this.remoteUserConfiguration,t),N=[...s,...o,...c];return N.length&&this.updateRemoteUserConfiguration(t),{keys:N,overrides:g}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:c,overrides:g}=a(this.workspaceConfiguration,t),N=[...s,...o,...c];return N.length&&this.updateWorkspaceConfiguration(t),{keys:N,overrides:g}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:c,updated:g,removed:N,overrides:T}=a(o,s),A=[...c,...g,...N];return(A.length||!o)&&this.updateFolderConfiguration(t,s),{keys:A,overrides:T}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:c,removed:g,overrides:N}=a(s,void 0);return{keys:[...o,...c,...g],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,o){let c=this.x(s,o);return s.overrideIdentifier&&(c=c.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(c=c.merge(this.l)),c}x({resource:t},s){let o=this.y();if(s&&t){const c=s.getFolder(t);c&&(o=this.z(c.uri)||o);const g=this.t.get(t);g&&(o=o.merge(g))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const o=this.y(),c=this.r.get(t);c?(s=o.merge(c),this.i.set(t,s)):s=o}return s}A(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:o,overrides:c,keys:g}=this.r.get(s);return t.push([s,{contents:o,overrides:c,keys:g}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(c=>s.add(c))),[...s.values()]}static parse(t,s){const o=this.E(t.defaults,s),c=this.E(t.policy,s),g=this.E(t.application,s),N=this.E(t.user,s),T=this.E(t.workspace,s),A=t.folders.reduce((D,F)=>(D.set(l.URI.revive(F[0]),this.E(F[1],s)),D),new C.$Dc);return new R(o,c,g,N,k.createEmptyModel(s),T,A,k.createEmptyModel(s),new C.$Dc,s)}static E(t,s){return new k(t.contents,t.keys,t.overrides,void 0,s)}}e.$Uo=R;function y(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,s=new Map;for(const c of r)c.keys.forEach(g=>t.add(g)),c.overrides.forEach(([g,N])=>{const T=(0,C.$Ac)(s,g,new Set);N.forEach(A=>T.add(A))});const o=[];return s.forEach((c,g)=>o.push([g,[...c.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,s,o,c,g){this.change=t,this.f=s,this.g=o,this.h=c,this.i=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of t.keys)this.affectedKeys.add(N);for(const[,N]of t.overrides)for(const T of N)this.affectedKeys.add(T);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=R.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const o=this.a+t,c=this.d.indexOf(o);if(c<0)return!1;const g=c+o.length;if(g>=this.d.length)return!1;const N=this.d.charCodeAt(g);if(N!==this.b&&N!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,A=this.g.getValue(t,s,this.h);return!O.$lo(T,A)}return!0}}e.$Wo=i;function a(r,t){const{added:s,removed:o,updated:c}=n(t?.rawConfiguration,r?.rawConfiguration),g=[],N=r?.getAllOverrideIdentifiers()||[],T=t?.getAllOverrideIdentifiers()||[];if(t){const A=T.filter(D=>!N.includes(D));for(const D of A)g.push([D,t.getKeysForOverrideIdentifier(D)])}if(r){const A=N.filter(D=>!T.includes(D));for(const D of A)g.push([D,r.getKeysForOverrideIdentifier(D)])}if(t&&r){for(const A of N)if(T.includes(A)){const D=n({contents:r.getOverrideValue(void 0,A)||{},keys:r.getKeysForOverrideIdentifier(A)},{contents:t.getOverrideValue(void 0,A)||{},keys:t.getKeysForOverrideIdentifier(A)});g.push([A,[...D.added,...D.removed,...D.updated]])}}return{added:s,removed:o,updated:c,overrides:g}}function n(r,t){const s=r?t?r.keys.filter(g=>t.keys.indexOf(g)===-1):[...r.keys]:[],o=t?r?t.keys.filter(g=>r.keys.indexOf(g)===-1):[...t.keys]:[],c=[];if(r&&t){for(const g of t.keys)if(r.keys.indexOf(g)!==-1){const N=(0,h.$kj)(t.contents,g),T=(0,h.$kj)(r.contents,g);O.$lo(N,T)||c.push(g)}}return{added:s,removed:o,updated:c}}}),define(le[117],he([0,1,19,4,2,27,3,67,40,6,39,37]),function(Z,e,P,S,v,I,C,O,w,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=void 0;class p extends v.$Xc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new S.$oe),this.onDidChangeConfiguration=this.a.event,this.b=O.$Ro.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$uo.as(w.$zo.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:d})=>this.f(Array.from(b),d))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,d){this.j(b,u.$uo.as(w.$zo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=O.$Ro.createEmptyModel(this.c);const b=u.$uo.as(w.$zo.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,d){const $=this.g();for(const R of b){const y=$[R],i=d[R];y!==void 0?this.b.setValue(R,y):i?this.b.setValue(R,i.default):this.b.removeValue(R)}}}e.$Xo=p;class f{constructor(){this.onDidChangeConfiguration=S.Event.None,this.configurationModel=O.$Ro.createEmptyModel(new l.$qk)}async initialize(){return this.configurationModel}}e.$Yo=f;let m=class extends v.$Xc{get configurationModel(){return this.b}constructor(b,d,$){super(),this.c=b,this.f=d,this.g=$,this.a=this.B(new S.$oe),this.onDidChangeConfiguration=this.a.event,this.b=O.$Ro.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const d={},$=[],R=u.$uo.as(w.$zo.Configuration).getConfigurationProperties();for(const y of b){const i=R[y];if(!i){$.push(y);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}$.push(y),d[i.policy.name]={type:i.type}}}return(0,C.$ug)(d)||await this.f.updatePolicyDefinitions(d),$}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const d=u.$uo.as(w.$zo.Configuration).getPolicyConfigurations(),$=(0,P.$Jb)(b.map(R=>d.get(R)));this.m($,!0)}m(b,d){this.g.trace("PolicyConfiguration#update",b);const $=u.$uo.as(w.$zo.Configuration).getConfigurationProperties(),R=[],y=this.b.isEmpty();for(const i of b){const a=$[i]?.policy?.name;if(a){const n=this.f.getPolicyValue(a);(y?n!==void 0:!(0,I.$lo)(this.b.getValue(i),n))&&R.push([i,n])}else this.b.getValue(i)!==void 0&&R.push([i,void 0])}if(R.length){this.g.trace("PolicyConfiguration#changed",R);const i=this.b;this.b=O.$Ro.createEmptyModel(this.g);for(const a of i.keys)this.b.setValue(a,i.getValue(a));for(const[a,n]of R)n===void 0?this.b.removeValue(a):this.b.setValue(a,n);d&&this.a.fire(this.b)}}};e.$Zo=m,e.$Zo=m=Ee([oe(1,h.$wo),oe(2,l.$dk)],m)}),define(le[118],he([0,1,19,8,13,4,34,78,2,25,27,12,16,30,67,40,117,9,39]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0;class R extends w.$Xc{constructor(a,n,r,t){super(),this.m=a,this.n=t,this.h=this.B(new I.$oe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$Xo(t)),this.c=r instanceof $.$yo?new b.$Yo:this.B(new b.$Zo(this.b,r,t)),this.f=this.B(new m.$To(this.m,{},p.$ah,n,t)),this.a=new m.$Uo(this.b.configurationModel,this.c.configurationModel,m.$Ro.createEmptyModel(t),m.$Ro.createEmptyModel(t),m.$Ro.createEmptyModel(t),m.$Ro.createEmptyModel(t),new l.$Dc,m.$Ro.createEmptyModel(t),new l.$Dc,t),this.j=new y(a,n,this),this.g=this.B(new S.$Uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$Uo(a,n,m.$Ro.createEmptyModel(this.n),r,m.$Ro.createEmptyModel(this.n),m.$Ro.createEmptyModel(this.n),new l.$Dc,m.$Ro.createEmptyModel(this.n),new l.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,n){const r=typeof a=="string"?a:void 0,t=(0,f.$dj)(a)?a:(0,f.$dj)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(a,n,r,t,s){const o=(0,f.$ej)(r)?r:(0,f.$dj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,c=o?t:r;if(c!==void 0&&c!==f.ConfigurationTarget.USER_LOCAL&&c!==f.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${c}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.$Ob)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const g=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(g.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,h.$lo)(n,g.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(D=>(0,P.$wb)([...D.identifiers].sort(),T));A&&(o.overrideIdentifiers=A.identifiers)}const N=o?.overrideIdentifiers?.length?[(0,k.$Lo)(o.overrideIdentifiers),a]:[a];await this.j.write(N,n),await this.reloadConfiguration()}inspect(a,n={}){return this.a.inspect(a,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,n,f.ConfigurationTarget.USER)}s(a,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(a,n);this.u(t,r,f.ConfigurationTarget.DEFAULT)}t(a){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,n,f.ConfigurationTarget.DEFAULT)}u(a,n,r){const t=new m.$Wo(a,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$1o=R;class y{constructor(a,n,r){this.b=a,this.c=n,this.d=r,this.a=new S.$Ph}write(a,n){return this.a.queue(()=>this.e(a,n))}async e(a,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const t=[];if((0,C.$2n)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,a,n);r=(0,O.$go)(r,s),await this.c.writeFile(this.b,v.$Qe.fromString(r))}f(a,n,r){const{tabSize:t,insertSpaces:s,eol:o}=this.h;if(!n.length){const c=JSON.stringify(r,null,s?" ".repeat(t):"	");return[{content:c,length:c.length,offset:0}]}return(0,O.$do)(a,n,r,{tabSize:t,insertSpaces:s,eol:o})}get h(){if(!this.g){let a=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(a=n),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[68],he([0,1,14]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=S,e.$ln=v,e.$mn=I,e.$nn=C;function S(w){return w.scheme===P.Schemas.vscodeRemote?w.authority:void 0}function v(w){if(!w)return;const l=w.indexOf("+");return l<0?w:w.substr(0,l)}function I(w){const{host:l,port:h}=O(w);if(typeof h>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:h}}function C(w,l){let{host:h,port:u}=O(w);return typeof u>"u"&&(u=l),{host:h,port:u}}function O(w){const l=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const h=w.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const u=w.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:w,port:void 0}}}),define(le[22],he([0,1,31,10,68]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$wn=e.$vn=e.$un=e.TargetPlatform=e.ExtensionType=e.$tn=e.$rn=e.$qn=e.$pn=e.$on=void 0,e.$sn=I,e.$xn=u,e.$yn=p,e.$zn=f,e.$An=m,e.$Bn=k,e.$Cn=b,P=be(P),e.$on="extensions.user.cache",e.$pn="extensions.builtin.cache",e.$qn="undefined_publisher",e.$rn=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$tn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(C||(e.ExtensionType=C={}));var O;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class w{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,R){if(typeof $>"u"||$===null)return typeof R>"u"||R===null;if(typeof R>"u"||R===null)return!1;if(typeof $=="string"||typeof R=="string"){const y=typeof $=="string"?$:$.value,i=typeof R=="string"?R:R.value;return P.$If(y,i)}return $._lower===R._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$un=w;class l{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const R of $)this.add(R)}add($){this.c.add(w.toKey($))}delete($){return this.c.delete(w.toKey($))}has($){return this.c.has(w.toKey($))}}e.$vn=l;class h{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(w.toKey($))}get($){return this.c.get(w.toKey($))}has($){return this.c.has(w.toKey($))}set($,R){this.c.set(w.toKey($),R)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$wn=h;function u(d){return p(d)}function p(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function f(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function m(d,$){if($){const R=`onResolveRemoteAuthority:${(0,v.$ln)($)}`;return!!d.activationEvents?.includes(R)}return!1}function k(d){return d.map($=>{const[R,y]=$.split("@");return{proposalName:R,version:y?parseInt(y):void 0}})}function b(d){return d.map($=>$.split("@")[0])}e.$Dn=(0,S.$Ii)("IBuiltinExtensionsScannerService")}),define(le[20],he([0,1,12,5,22,10]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.ExtensionManagementErrorCode=e.$pp=e.ExtensionGalleryErrorCode=e.$op=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=void 0,e.$ip=O,e.$jp=w,e.$kp=l,e.$lp=h,e.$mp=u,e.$np=p,e.$bp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$cp=new RegExp(e.$bp),e.$dp="__web_extension",e.$ep="skipWalkthrough",e.$fp="extensionInstallSource",e.$gp="dependecyOrPackExtensionInstall",e.$hp="clientTargetPlatform";var C;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(C||(e.ExtensionInstallSource=C={}));function O(i){switch(i){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function w(i){switch(i){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function l(i,a){switch(i){case P.Platform.Windows:return a==="x64"?v.TargetPlatform.WIN32_X64:a==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Linux:return a==="x64"?v.TargetPlatform.LINUX_X64:a==="arm64"?v.TargetPlatform.LINUX_ARM64:a==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?v.TargetPlatform.ALPINE_X64:a==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Mac:return a==="x64"?v.TargetPlatform.DARWIN_X64:a==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Web:return v.TargetPlatform.WEB}}function h(i,a){return a===v.TargetPlatform.WEB&&!i.includes(v.TargetPlatform.WEB)}function u(i,a,n){return h(a,n)?!1:i===v.TargetPlatform.UNDEFINED||i===v.TargetPlatform.UNIVERSAL?!0:i===v.TargetPlatform.UNKNOWN?!1:i===n}function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var f;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var m;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var k;(function(i){i.Install="install",i.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$op=(0,I.$Ii)("extensionGalleryService");var d;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting",i.Offline="Offline"})(d||(e.ExtensionGalleryErrorCode=d={}));class $ extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}e.$pp=$;var R;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(R||(e.ExtensionManagementErrorCode=R={}));class y extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}e.$qp=y,e.$rp=(0,I.$Ii)("extensionManagementService"),e.$sp="extensionsIdentifiers/disabled",e.$tp="extensionsIdentifiers/enabled",e.$up=(0,I.$Ii)("IGlobalExtensionEnablementService"),e.$vp=(0,I.$Ii)("IExtensionTipsService"),e.$wp=(0,S.localize2)(1778,"Extensions"),e.$xp=(0,S.localize2)(1779,"Preferences")}),define(le[119],he([0,1,2,22,9]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class I extends P.$Xc{constructor(O,w,l,h,u){super(),this.a=O,this.b=w,this.c=l,this.f=u,this.B(h.onDidInstallExtensions(p=>this.g(p))),this.B(h.onDidUninstallExtension(p=>this.h(p)))}g(O){for(const w of O)w.local&&this.invalidate(w.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,O)&&await this.j(w);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,S.$on))}catch(w){(0,v.$ul)(w)!==v.FileOperationResult.FILE_NOT_FOUND&&this.f.error(w)}}}e.$2q=I});var ze=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[44],he([0,1,16,57,5,45,22,98]),function(Z,e,P,S,v,I,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=h,e.$4p=u,e.$5p=p,e.$6p=f,e.$7p=m,e.$8p=k,e.$9p=b,e.$0p=d,S=ze(S),v=be(v),I=be(I);const w=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function h(y){return y=y.trim(),y==="*"||w.test(y)}function u(y){if(!h(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=y.match(w);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function p(y){if(!y)return null;const i=y.majorBase,a=y.majorMustEqual,n=y.minorBase;let r=y.minorMustEqual;const t=y.patchBase;let s=y.patchMustEqual;y.hasCaret&&(i===0||(r=!1),s=!1);let o=0;if(y.preRelease){const c=l.exec(y.preRelease);if(c){const[,g,N,T]=c;o=Date.UTC(Number(g),Number(N)-1,Number(T))}}return{majorBase:i,majorMustEqual:a,minorBase:n,minorMustEqual:r,patchBase:t,patchMustEqual:s,isMinimum:y.hasGreaterEquals,notBefore:o}}function f(y,i,a){let n;typeof y=="string"?n=p(u(y)):n=y;let r;i instanceof Date?r=i.getTime():typeof i=="string"&&(r=new Date(i).getTime());let t;if(typeof a=="string"?t=p(u(a)):t=a,!n||!t)return!1;const s=n.majorBase,o=n.minorBase,c=n.patchBase;let g=t.majorBase,N=t.minorBase,T=t.patchBase;const A=t.notBefore;let D=t.majorMustEqual,F=t.minorMustEqual,x=t.patchMustEqual;return t.isMinimum?s>g?!0:s<g?!1:o>N?!0:o<N||r&&r<A?!1:c>=T:(s===1&&g===0&&(!D||!F||!x)&&(g=1,N=0,T=0,D=!0,F=!1,x=!1),s<g?!1:s>g?!D:o<N?!1:o>N?!F:c<T?!1:c>T?!x:!(r&&r<A))}function m(y,i,a,n,r,t){const s=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return s.push([S.default.Error,v.localize(1830,null)]),s;if(typeof n.name!="string")return s.push([S.default.Error,v.localize(1831,null,"name")]),s;if(typeof n.version!="string")return s.push([S.default.Error,v.localize(1832,null,"version")]),s;if(!n.engines)return s.push([S.default.Error,v.localize(1833,null,"engines")]),s;if(typeof n.engines.vscode!="string")return s.push([S.default.Error,v.localize(1834,null,"engines.vscode")]),s;if(typeof n.extensionDependencies<"u"&&!R(n.extensionDependencies))return s.push([S.default.Error,v.localize(1835,null,"extensionDependencies")]),s;if(typeof n.activationEvents<"u"){if(!R(n.activationEvents))return s.push([S.default.Error,v.localize(1836,null,"activationEvents")]),s;if(typeof n.main>"u"&&typeof n.browser>"u")return s.push([S.default.Error,v.localize(1837,null,"activationEvents","main","browser")]),s}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&s.push([S.default.Warning,v.localize(1838,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return s.push([S.default.Error,v.localize(1839,null,"main")]),s;{const g=(0,P.$jh)(a,n.main);(0,P.$dh)(g,a)||s.push([S.default.Warning,v.localize(1840,null,g.path,a.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return s.push([S.default.Error,v.localize(1841,null,"browser")]),s;{const g=(0,P.$jh)(a,n.browser);(0,P.$dh)(g,a)||s.push([S.default.Warning,v.localize(1842,null,g.path,a.path)])}}if(!I.valid(n.version))return s.push([S.default.Error,v.localize(1843,null)]),s;const o=[];if(!k(y,i,n,r,o))for(const g of o)s.push([S.default.Error,g]);if(t&&n.enabledApiProposals?.length){const g=[];if(!d([...n.enabledApiProposals],g))for(const N of g)s.push([S.default.Error,N])}return s}function k(y,i,a,n,r){return n||typeof a.main>"u"&&typeof a.browser>"u"?!0:$(y,i,a.engines.vscode,r)}function b(y,i,a){return y==="*"||$(i,a,y)}function d(y,i){if(y.length===0)return!0;const a=Array.isArray(i)?i:void 0,n=(a?void 0:i)??O.allApiProposals,r=[],t=(0,C.$Bn)(y);for(const{proposalName:s,version:o}of t){const c=n[s];c&&o&&c.version!==o&&r.push(v.localize(1844,null,s))}return a?.push(...r),r.length===0}function $(y,i,a,n=[]){const r=p(u(a));if(!r)return n.push(v.localize(1845,null,a)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(v.localize(1846,null,a)),!1}else if(!r.majorMustEqual)return n.push(v.localize(1847,null,a)),!1;return f(y,i,r)?!0:(n.push(v.localize(1848,null,y,a)),!1)}function R(y){if(!Array.isArray(y))return!1;for(let i=0,a=y.length;i<a;i++)if(typeof y[i]!="string")return!1;return!0}}),define(le[69],he([0,1,21,2,12,5,20,10]),function(Z,e,P,S,v,I,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=e.$es=void 0,e.$ds=w;function w(h){return h.tags.find(u=>u.startsWith("lp-"))?.split("lp-")[1]}e.$es=(0,O.$Ii)("languagePackService");let l=class extends S.$Xc{constructor(u){super(),this.c=u}async getAvailableLanguages(){const u=new P.$ze;setTimeout(()=>u.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},u.token)}catch{return[]}const m=p.firstPage.filter(k=>k.properties.localizedLanguages?.length&&k.tags.some(b=>b.startsWith("lp-"))).map(k=>{const b=k.properties.localizedLanguages?.[0],d=w(k);return{...this.f(d,b,k),extensionId:k.identifier.id,galleryExtension:k}});return m.push(this.f("en","English")),m}f(u,p,f){const m=p??u;let k;if(m!==u&&(k=`(${u})`),u.toLowerCase()===v.$x.toLowerCase()&&(k??="",k+=(0,I.localize)(1926,null)),f?.installCount){k??="";const b=f.installCount;let d;b>1e6?d=`${Math.floor(b/1e5)/10}M`:b>1e3?d=`${Math.floor(b/1e3)}K`:d=String(b),k+=` $(cloud-download) ${d}`}return{id:u,label:m,description:k}}};e.$fs=l,e.$fs=l=Ee([oe(0,C.$op)],l)}),define(le[46],he([0,1,13,7,2,5,40,10,6,37]),function(Z,e,P,S,v,I,C,O,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0,e.$aq=p,e.$bq=f,e.$cq=m,e.$dq=k,e.$eq=b,e.$fq=d,e.$$p=(0,O.$Ii)("requestService");class h{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?i[a]="*****":i[a]=this.b[a];this.a=i}return this.a}}class u extends v.$Xc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,I.localize)(2048,null),when:w.$vk.isEqualTo((0,w.$sk)(w.LogLevel.Trace)).serialize()})}async c(i,a,n){const r=`${i} #${++this.b}: ${a.url}`;this.a.trace(`${r} - begin`,a.type,new h(a.headers??{}));try{const t=await n();return this.a.trace(`${r} - end`,a.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,a.type,(0,S.$_)(t)),t}}}e.$_p=u;function p(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function f(y){return y.res.statusCode===204}async function m(y){return f(y)?null:(await(0,P.$3e)(y.stream)).toString()}async function k(y){if(!p(y))throw new Error("Server returned "+y.res.statusCode);return m(y)}async function b(y){if(!p(y))throw new Error("Server returned "+y.res.statusCode);if(f(y))return null;const a=(await(0,P.$3e)(y.stream)).toString();try{return JSON.parse(a)}catch(n){throw n.message+=`:
`+a,n}}function d(y){R(y)}let $;function R(y){const i=l.$uo.as(C.$zo.Configuration),a=$;$={id:"http",order:15,title:(0,I.localize)(2049,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(2050,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2051,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,I.localize)(2052,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,I.localize)(2053,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(2054,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(2055,null),(0,I.localize)(2056,null),(0,I.localize)(2057,null),(0,I.localize)(2058,null)],default:"override",description:(0,I.localize)(2059,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(2060,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,I.localize)(2061,null),restricted:!0}}},i.updateConfigurations({add:[$],remove:a?[a]:[]})}R(C.ConfigurationScope.APPLICATION)}),define(le[120],he([0,1,21,14,9,46]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iS=void 0;let C=class{constructor(w,l){this.a=w,this.b=l}async download(w,l,h=P.CancellationToken.None){if(w.scheme===S.Schemas.file||w.scheme===S.Schemas.vscodeRemote){await this.b.copy(w,l);return}const u={type:"GET",url:w.toString(!0)},p=await this.a.request(u,h);if(p.res.statusCode===200)await this.b.writeFile(l,p.stream);else{const f=await(0,I.$dq)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${f}`)}}};e.$iS=C,e.$iS=C=Ee([oe(0,I.$$p),oe(1,v.$dl)],C)}),define(le[121],he([0,1,122,3]),function(Z,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=I;function v(C,O){return C.protocol==="http:"?O.HTTP_PROXY||O.http_proxy||null:C.protocol==="https:"&&(O.HTTPS_PROXY||O.https_proxy||O.HTTP_PROXY||O.http_proxy)||null}async function I(C,O,w={}){const l=(0,P.parse)(C),h=w.proxyUrl||v(l,O);if(!h)return null;const u=(0,P.parse)(h);if(!/^https?:$/.test(u.protocol||""))return null;const p={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,S.$ng)(w.strictSSL)?w.strictSSL:!0};if(l.protocol==="http:"){const f=await new Promise((m,k)=>{Z(["http-proxy-agent"],m,k)}).then(be);return new f.HttpProxyAgent(h,p)}else{const f=await new Promise((m,k)=>{Z(["https-proxy-agent"],m,k)}).then(be);return new f.HttpsProxyAgent(h,p)}}}),define(le[123],he([0,1,61,15,5,21,38,7,12,28,86,153,8,80]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=k;let m;async function k(d,$,R,y){return R["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Nm)(y)&&!R["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Nm)(y)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=p.Promises.withAsyncBody(async(i,a)=>{const n=new I.$ze;let r=1e4;const t=d.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,f.$Om)(t,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),a(new Error((0,v.localize)(2062,null)))},r);try{i(await b($,n.token))}catch(o){!(0,O.$6)(o)&&!n.token.isCancellationRequested?a(new Error((0,v.localize)(2063,null,(0,C.$tj)(o)))):i({})}finally{clearTimeout(s),n.dispose()}})),m)}async function b(d,$){const R=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",R);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",y);const i=(0,l.$5g)().replace(/-/g,"").substr(0,12),a=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",n);const r=await(0,h.$Dm)(w.OS,n);return d.trace("getUnixShellEnvironment#shell",r),new Promise((t,s)=>{if($.isCancellationRequested)return s(new O.$7);const o=(0,S.$qc)(r);let c,g;const N="";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${N} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,g=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,g=["-i","-l","-c"]):o==="xonsh"?(c=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,g=["-i","-l","-c"]):(c=`'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?g=["-ic"]:g=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),c);const T=(0,P.spawn)(r,[...g,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});$.onCancellationRequested(()=>(T.kill(),s(new O.$7))),T.on("error",F=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,C.$tj)(F)),s(F)});const A=[];T.stdout.on("data",F=>A.push(F));const D=[];T.stderr.on("data",F=>D.push(F)),T.on("close",(F,x)=>{const Y=Buffer.concat(A).toString("utf8");d.trace("getUnixShellEnvironment#raw",Y);const ne=Buffer.concat(D).toString("utf8");if(ne.trim()&&d.trace("getUnixShellEnvironment#stderr",ne),F||x)return s(new Error((0,v.localize)(2064,null,F,x)));const ae=a.exec(Y),ue=ae?ae[1]:"{}";try{const me=JSON.parse(ue);R?me.ELECTRON_RUN_AS_NODE=R:delete me.ELECTRON_RUN_AS_NODE,y?me.ELECTRON_NO_ATTACH_CONSOLE=y:delete me.ELECTRON_NO_ATTACH_CONSOLE,delete me.VSCODE_RESOLVING_ENVIRONMENT,delete me.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",me),t(me)}catch(me){d.error("getUnixShellEnvironment#errorCaught",(0,C.$tj)(me)),s(me)}})})}}),define(le[124],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VR=e.$UR=void 0,e.$UR=(0,P.$Ii)("stateReadService"),e.$VR=(0,P.$Ii)("stateService")}),define(le[70],he([0,1,8,13,2,3,17,9,6]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=e.$XR=e.$WR=e.SaveStrategy=void 0;var l;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class h extends v.$Xc{constructor(m,k,b,d){super(),this.h=m,this.j=k,this.m=b,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new P.$Gh(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.m.error(m)}}getItem(m,k){const b=this.a[m];return(0,I.$qg)(b)?k:b}setItem(m,k){this.setItems([{key:m,data:k}])}setItems(m){let k=!1;for(const{key:b,data:d}of m)this.a[b]!==d&&((0,I.$qg)(d)?(0,I.$og)(this.a[b])||(this.a[b]=void 0,k=!0):(this.a[b]=d,k=!0));k&&this.s()}removeItem(m){(0,I.$og)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,S.$Qe.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(k){this.m.error(k)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$WR=h;let u=class extends v.$Xc{constructor(m,k,b,d){super(),this.a=this.B(new h(k.stateResource,m,b,d))}async init(){await this.a.init()}getItem(m,k){return this.a.getItem(m,k)}};e.$XR=u,e.$XR=u=Ee([oe(1,C.$Pi),oe(2,w.$dk),oe(3,O.$dl)],u);class p extends u{setItem(m,k){this.a.setItem(m,k)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$YR=p}),define(le[71],he([0,1,12,36,28]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=C,e.$zp=O;function I(w){if(P.$v===P.Platform.Linux&&/^penguin(\.|$)/i.test(w))return"chromebook"}function C(w,l,h,u,p,f,m,k,b,d){const $=Object.create(null);$["common.machineId"]=f,$["common.sqmId"]=m,$["common.devDeviceId"]=k,$.sessionID=(0,v.$5g)()+Date.now(),$.commitHash=u,$.version=p,$["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,P.$i)(P.$v),$["common.nodePlatform"]=S.$gc,$["common.nodeArch"]=h,$["common.product"]=d||"desktop",b&&($["common.msftInternal"]=b);let R=0;const y=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),P.$m&&($["common.snap"]="true");const i=I(l);return i&&($["common.platformDetail"]=i),$}function O(w){const l=S.env.USERDNSDOMAIN;if(!l)return!1;const h=l.toLowerCase();return w.some(u=>h===u)}}),define(le[18],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,P.$Ii)("telemetryService"),e.$dm=(0,P.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var S;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(S||(e.TelemetryLevel=S={}));var v;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(v||(e.TelemetryConfiguration=v={}))}),define(le[72],he([0,1,58,7,10,6,18]),function(Z,e,P,S,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.ExtensionSignatureVerificationCode=e.$yq=void 0,e.$yq=(0,v.$Ii)("IExtensionSignatureVerificationService");var O;(function(h){h.Success="Success",h.RequiredArgumentMissing="RequiredArgumentMissing",h.InvalidArgument="InvalidArgument",h.PackageIsUnreadable="PackageIsUnreadable",h.UnhandledException="UnhandledException",h.SignatureManifestIsMissing="SignatureManifestIsMissing",h.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",h.SignatureIsMissing="SignatureIsMissing",h.SignatureIsUnreadable="SignatureIsUnreadable",h.CertificateIsUnreadable="CertificateIsUnreadable",h.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",h.FileAlreadyExists="FileAlreadyExists",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",h.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",h.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",h.SignatureIsInvalid="SignatureIsInvalid",h.SignatureManifestIsInvalid="SignatureManifestIsInvalid",h.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",h.EntryIsMissing="EntryIsMissing",h.EntryIsTampered="EntryIsTampered",h.Untrusted="Untrusted",h.CertificateRevoked="CertificateRevoked",h.SignatureIsNotValid="SignatureIsNotValid",h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(O||(e.ExtensionSignatureVerificationCode=O={}));class w extends Error{constructor(u){super(u),this.code=u}}e.$zq=w;let l=class{constructor(u,p){this.b=u,this.c=p}d(){return this.a||(this.a=this.f()),this.a}async f(){return(0,P.$wq)("@vscode/vsce-sign","src/main.js")}async verify(u,p,f,m){let k;const b=u.identifier.id;try{k=await this.d()}catch(y){return this.b.error("Could not load vsce-sign module",(0,S.$_)(y)),this.b.info(`Extension signature verification is not done: ${b}`),!1}const d=new Date().getTime();let $;try{this.b.trace(`Verifying extension signature for ${b}...`),$=await k.verify(p,f,this.b.getLevel()===I.LogLevel.Trace)}catch(y){$={code:O.UnknownError,didExecute:!1,output:(0,S.$_)(y)}}const R=new Date().getTime()-d;if(this.b.info(`Extension signature verification result for ${b}: ${$.code}. Executed: ${$.didExecute}. Duration: ${R}ms.`),this.b.trace(`Extension signature verification output for ${b}:
${$.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:b,extensionVersion:u.version,code:$.code,internalCode:$.internalCode,duration:R,didExecute:$.didExecute,clientTargetPlatform:m}),$.code===O.Success)return!0;throw new w($.code)}};e.$Aq=l,e.$Aq=l=Ee([oe(0,I.$dk),oe(1,C.$cm)],l)}),define(le[41],he([0,1,27,3,68,71,18]),function(Z,e,P,S,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=void 0,e.$Hp=h,e.$Ip=u,e.$Jp=p,e.$Kp=f,e.$Lp=k,e.$Mp=d,e.$Np=$,e.$Op=i;class O{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Ap=O;class w{constructor(){this.telemetryLevel=C.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Bp=w,e.$Cp=new w;class l{async publicLog(n,r,t){}async publicLogError(n,r,t){}}e.$Dp=l,e.$Ep="telemetry",e.$Fp="extensionTelemetryLog",e.$Gp={log:()=>null,flush:()=>Promise.resolve(null)};function h(a,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!a.enableTelemetry)}function u(a,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function p(a){const n=a.getValue(C.$lm),r=a.getValue(C.$mm);if(a.getValue(C.$nm)===!1||r===!1)return C.TelemetryLevel.NONE;switch(n??C.TelemetryConfiguration.ON){case C.TelemetryConfiguration.ON:return C.TelemetryLevel.USAGE;case C.TelemetryConfiguration.ERROR:return C.TelemetryLevel.ERROR;case C.TelemetryConfiguration.CRASH:return C.TelemetryLevel.CRASH;case C.TelemetryConfiguration.OFF:return C.TelemetryLevel.NONE}}function f(a){const n={},r={},t={};b(a,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function k(a){if(!a)return"none";const n=(0,v.$ln)(a);return m.has(n)?n:"other"}function b(a,n,r=0,t){if(a)for(const s of Object.getOwnPropertyNames(a)){const o=a[s],c=t?t+s:s;Array.isArray(o)?n[c]=(0,P.$mo)(o):o instanceof Date?n[c]=o.toISOString():(0,S.$jg)(o)?r<2?b(o,n,r+1,c+"."):n[c]=(0,P.$mo)(o):n[c]=o}}function d(a,n){const r=a.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,I.$zp)(r)||t}function $(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function R(a,n){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let r=a;const t=[];for(const g of n)for(;;){const N=g.exec(a);if(!N)break;t.push([N.index,g.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(r="";;){const g=o.exec(a);if(!g)break;const N=t.some(([T,A])=>g.index<A&&T<o.lastIndex);!s.test(g[0])&&!N&&(r+=a.substring(c,g.index)+"<REDACTED: user-file-path>",c=o.lastIndex)}return c<a.length&&(r+=a.substr(c)),r}function y(a){if(!a)return a;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(a))return`<REDACTED: ${r.label}>`;return a}function i(a,n){return(0,P.$jo)(a,r=>{if(r instanceof O||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let t=r.replaceAll("%20"," ");t=R(t,n);for(const s of n)t=t.replace(s,"");return t=y(t),t}})}}),define(le[26],he([0,1,31,20,22,12,11,7,36,41]),function(Z,e,P,S,v,I,C,O,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Qp=void 0,e.$Pp=h,e.$Rp=m,e.$Sp=k,e.$Tp=b,e.$Up=d,e.$Vp=$,e.$Wp=R,e.$Xp=y,e.$Zp=i,e.$1p=n;function h(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,P.$Df)(r.id,t.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new p(t.identifier,s,o)}static parse(t){const s=u.exec(t);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o=v.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof p?h(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Qp=p;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const t=f.exec(r);return t&&t[1]?[b(t[1]),t[2]]:[b(r),void 0]}function k(r,t){return`${r}.${t}`}function b(r){return r.toLowerCase()}function d(r,t){return b(k(r??v.$qn,t))}function $(r,t){const s=[],o=c=>{for(const g of s)if(g.some(N=>h(t(N),t(c))))return g;return null};for(const c of r){const g=o(c);g?g.push(c):s.push([c])}return s}function R(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function y(r){return{id:new l.$Ap(r.identifier.id),name:new l.$Ap(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Yp=new v.$un("pprice.better-merge");function i(r,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&s.every(g=>!h(g.identifier,{id:c}))){const g=r.filter(N=>h(N.identifier,{id:c}));g.length===1&&(s.push(g[0]),o.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function a(r,t){if(!I.$l)return!1;let s;try{s=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,O.$_)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,t){const s=await a(r,t),o=(0,S.$kp)(s?"alpine":I.$v,w.$hc);return t.debug("ComputeTargetPlatform:",o),o}}),define(le[125],he([0,1,21,7,14,16,45,11,5,20,26,22]),function(Z,e,P,S,v,I,C,O,w,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;const p=k=>(0,w.localize)(1780,null,k),f=(0,w.localize)(1781,null,"ms-dotnettools.csharp");let m=class{constructor(b,d,$){this.a=b,this.b=d,this.d=$}get f(){}async listExtensions(b,d,$){let R=await this.b.getInstalled(u.ExtensionType.User,$);const y=u.$tn.map(a=>a.toLowerCase());if(d&&d!==""){if(y.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}R=R.filter(a=>a.manifest.categories?a.manifest.categories.map(r=>r.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),y.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,w.localize)(1782,null,this.f)),R=R.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let i;for(const a of R)i!==a.identifier.id&&(i=a.identifier.id,this.a.info(b?`${i}@${a.manifest.version}`:i))}async installExtensions(b,d,$,R){const y=[];try{b.length&&this.a.info(this.f?(0,w.localize)(1783,null,this.f):(0,w.localize)(1784,null));const i=[],a=[],n=(t,s,o)=>{a.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...$,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||$.installPreReleaseVersion}})};for(const t of b)if(t instanceof O.URI)i.push({vsix:t,installOptions:$});else{const[s,o]=(0,h.$Rp)(t);n(s,o,!1)}for(const t of d)if(t instanceof O.URI)i.push({vsix:t,installOptions:{...$,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,h.$Rp)(t);n(s,o,!0)}const r=await this.b.getInstalled(void 0,$.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:s})=>{try{await this.h(t,s,R,r)}catch(o){this.a.error(o),y.push(t.toString())}})),a.length){const t=await this.g(a,r,R);y.push(...t)}}catch(i){throw this.a.error((0,w.localize)(1785,null,(0,S.$_)(i))),i}if(y.length)throw new Error((0,w.localize)(1786,null,y.join(", ")))}async updateExtensions(b){const d=await this.b.getInstalled(u.ExtensionType.User,b),$=[];for(const a of d)a.identifier.uuid&&$.push({...a.identifier,preRelease:a.preRelease});this.a.trace((0,w.localize)(1787,null,$.length));const R=await this.d.getExtensions($,{compatible:!0},P.CancellationToken.None),y=[];for(const a of R)for(const n of d)(0,h.$Pp)(n.identifier,a.identifier)&&(0,C.gt)(a.version,n.manifest.version)&&y.push({extension:a,options:{operation:l.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:b,isApplicationScoped:n.isApplicationScoped}});if(!y.length){this.a.info((0,w.localize)(1788,null));return}this.a.info((0,w.localize)(1789,null,y.map(a=>a.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(y);for(const a of i)a.error?this.a.error((0,w.localize)(1790,null,a.identifier.id,(0,S.$_)(a.error))):this.a.info((0,w.localize)(1791,null,a.identifier.id,a.local?.manifest.version))}async g(b,d,$){if(b=b.filter(({id:a,version:n})=>{const r=d.find(t=>(0,h.$Pp)(t.identifier,{id:a}));if(r){if(!$&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,w.localize)(1792,null,a,r.manifest.version,a)),!1;if(n&&r.manifest.version===n)return this.a.info((0,w.localize)(1793,null,`${a}@${n}`)),!1}return!0}),!b.length)return[];const R=[],y=[],i=await this.j(b);if(await Promise.all(b.map(async({id:a,version:n,installOptions:r})=>{const t=i.get(a.toLowerCase());if(!t){this.a.error(`${p(n?`${a}@${n}`:a)}
${f}`),R.push(a);return}try{const o=await this.d.getManifest(t,P.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),R.push(a);return}const s=d.find(o=>(0,h.$Pp)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.a.info((0,w.localize)(1794,null,n?`${a}@${n}`:a));return}this.a.info((0,w.localize)(1795,null,a,t.version))}r.isBuiltin?this.a.info(n?(0,w.localize)(1796,null,a,n):(0,w.localize)(1797,null,a)):this.a.info(n?(0,w.localize)(1798,null,a,n):(0,w.localize)(1799,null,a)),y.push({extension:t,options:{...r,installGivenVersion:!!n,isApplicationScoped:r.isApplicationScoped||s?.isApplicationScoped}})})),y.length){const a=await this.b.installGalleryExtensions(y);for(const n of a)n.error?(this.a.error((0,w.localize)(1800,null,n.identifier.id,(0,S.$_)(n.error))),R.push(n.identifier.id)):this.a.info((0,w.localize)(1801,null,n.identifier.id,n.local?.manifest.version))}return R}async h(b,d,$,R){const y=await this.b.getManifest(b);if(!y)throw new Error("Invalid vsix");if(await this.l(y,$,d.profileLocation,R))try{await this.b.install(b,{...d,installGivenVersion:!0}),this.a.info((0,w.localize)(1802,null,(0,I.$gh)(b)))}catch(a){if((0,S.$6)(a))this.a.info((0,w.localize)(1803,null,(0,I.$gh)(b)));else throw a}}async j(b){const d=new Map,$=b.some(i=>i.installOptions.installPreReleaseVersion),R=await this.b.getTargetPlatform(),y=[];for(const i of b)l.$cp.test(i.id)&&y.push({...i,preRelease:$});if(y.length){const i=await this.d.getExtensions(y,{targetPlatform:R},P.CancellationToken.None);for(const a of i)d.set(a.identifier.id.toLowerCase(),a)}return d}k(b){return!0}async l(b,d,$,R){if(!d){const y={id:(0,h.$Up)(b.publisher,b.name)},i=R.find(a=>(0,h.$Pp)(y,a.identifier)&&(0,C.gt)(a.manifest.version,b.version));if(i)return this.a.info((0,w.localize)(1804,null,i.identifier.id,i.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,d,$){const R=async i=>{if(i instanceof O.URI){const a=await this.b.getManifest(i);return(0,h.$Sp)(a.publisher,a.name)}return i},y=[];for(const i of b){const a=await R(i),r=(await this.b.getInstalled(void 0,$)).filter(t=>(0,h.$Pp)(t.identifier,{id:a}));if(!r.length)throw new Error(`${this.m(a)}
${f}`);if(r.some(t=>t.type===u.ExtensionType.System)){this.a.info((0,w.localize)(1805,null,a));return}if(!d&&r.some(t=>t.isBuiltin)){this.a.info((0,w.localize)(1806,null,a));return}this.a.info((0,w.localize)(1807,null,a));for(const t of r)await this.b.uninstall(t,{profileLocation:$}),y.push(t);this.f?this.a.info((0,w.localize)(1808,null,a,this.f)):this.a.info((0,w.localize)(1809,null,a))}}async locateExtension(b){const d=await this.b.getInstalled();b.forEach($=>{d.forEach(R=>{if(R.identifier.id===$&&R.location.scheme===v.Schemas.file){this.a.info(R.location.fsPath);return}})})}m(b){return this.f?(0,w.localize)(1810,null,b,this.f):(0,w.localize)(1811,null,b)}};e.$Bq=m,e.$Bq=m=Ee([oe(1,l.$rp),oe(2,l.$op)],m)}),define(le[126],he([0,1,7,4,2,25,26,22,9]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class l extends v.$Xc{constructor(u,p,f,m,k,b,d){super(),this.f=u,this.g=p,this.h=f,this.j=m,this.m=k,this.n=b,this.r=d,this.a=this.B(new S.$oe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new v.$7c),this.s().then(null,$=>d.error("Error while initializing Extensions Watcher",(0,P.$_)($)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(u=>this.u(u.added))),this.B(this.j.onAddExtensions(u=>this.w(u))),this.B(this.j.onDidAddExtensions(u=>this.y(u))),this.B(this.j.onRemoveExtensions(u=>this.z(u))),this.B(this.j.onDidRemoveExtensions(u=>this.C(u))),this.B(this.n.onDidFilesChange(u=>this.D(u)))}async u(u){try{u.length&&await Promise.all(u.map(p=>(this.c.set(p.id,(0,v.$Uc)(this.n.watch(this.m.extUri.dirname(p.extensionsResource)),this.n.watch(p.extensionsResource))),this.G(p.extensionsResource))))}catch(p){throw this.r.error(p),p}}async w(u){for(const p of u.extensions)this.I(this.L(p.identifier,p.version),u.profileLocation)}async y(u){for(const p of u.extensions){const f=this.L(p.identifier,p.version);u.error?this.J(f,u.profileLocation):this.I(f,u.profileLocation)}}async z(u){for(const p of u.extensions)this.J(this.L(p.identifier,p.version),u.profileLocation)}async C(u){const p=[],f=[];for(const m of u.extensions){const k=this.L(m.identifier,m.version);u.error?this.I(k,u.profileLocation):(this.J(k,u.profileLocation),this.b.has(k)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),f.push(this.f.scanInstalledExtensionAtLocation(m.location).then(b=>{b?p.push(b):this.r.info("Extension not found at the location",m.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(f),p.length&&await this.H(p)}catch(m){this.r.error(m)}}D(u){for(const p of this.h.profiles)u.contains(p.extensionsResource,w.FileChangeType.UPDATED,w.FileChangeType.ADDED)&&this.F(p.extensionsResource)}async F(u){const p=[],f=[],m=await this.j.scanProfileExtensions(u),k=new Set,b=new Set;for(const[d,$]of this.b)$.has(u)&&b.add(d);for(const d of m){const $=this.L(d.identifier,d.version);k.add($),b.has($)||(p.push(d.identifier),this.I($,u))}for(const d of b)if(!k.has(d)){const $=this.M(d);$&&(f.push($.identifier),this.J(d,u))}(p.length||f.length)&&this.a.fire({added:p.length?{extensions:p,profileLocation:u}:void 0,removed:f.length?{extensions:f,profileLocation:u}:void 0})}async G(u){const p=await this.j.scanProfileExtensions(u);for(const f of p)this.I(this.L(f.identifier,f.version),u)}async H(u){u||(u=(await this.f.scanAllUserInstalledExtensions()).filter(f=>!this.b.has(this.L(f.identifier,f.manifest.version)))),u.length&&await this.f.markAsUninstalled(...u)}I(u,p){let f=this.b.get(u);f||this.b.set(u,f=new I.$Ec(m=>this.m.extUri.getComparisonKey(m))),f.add(p)}J(u,p){const f=this.b.get(u);f&&f.delete(p),f?.size||this.b.delete(u)}L(u,p){return`${O.$un.toKey(u.id)}@${p}`}M(u){const[p,f]=(0,C.$Rp)(u);return f?{identifier:{id:p},version:f}:void 0}}e.$3q=l}),define(le[127],he([0,1,32,154,19,8,2,14,15,29,17,20,26,6,69,11]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0,P=be(P);let b=class extends m.$fs{constructor(y,i,a,n){super(a),this.h=y,this.j=n,this.g=this.B(new d(i,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(y,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const r=n.translations[y];return r?k.URI.file(r):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),i=Object.keys(y).map(a=>{const n=y[a];return{...this.f(a,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((a,n)=>a.label.localeCompare(n.label)),i}async m(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",y.identifier.id),await this.update())}async n(y){const i=await this.g.getLanguagePacks();Object.keys(i).some(a=>i[a]&&i[a].extensions.some(n=>(0,p.$Pp)(n.extensionIdentifier,y.identifier)))&&(this.j.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),a=await this.g.update(i);return!(0,v.$wb)(Object.keys(y),Object.keys(a))}};e.$gs=b,e.$gs=b=Ee([oe(0,u.$rp),oe(1,h.$Qi),oe(2,u.$op),oe(3,f.$dk)],b);let d=class extends C.$Xc{constructor(y,i){super(),this.j=i,this.c={},this.f=(0,w.$mc)(y.userDataPath,"languagepacks.json"),this.g=new I.$Ph}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.s(i=>{Object.keys(i).forEach(a=>delete i[a]),this.m(i,...y)}).then(()=>this.c)}m(y,...i){for(const a of i)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.n(y,a);Object.keys(y).forEach(a=>this.r(y[a]))}n(y,i){const a=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const r of n)if(i.location.scheme===O.Schemas.file&&$(r)){let t=y[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},y[r.languageId]=t);const s=t.extensions.filter(o=>(0,p.$Pp)(o.extensionIdentifier,a))[0];s?s.version=i.manifest.version:t.extensions.push({extensionIdentifier:a,version:i.manifest.version});for(const o of r.translations)t.translations[o.id]=(0,w.$mc)(i.location.fsPath,o.path)}}r(y){if(y){const i=(0,S.createHash)("md5");for(const a of y.extensions)i.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);y.hash=i.digest("hex")}}s(y=()=>null){return this.g.queue(()=>{let i=null;return P.promises.readFile(this.f,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(i=y(a),a)).then(a=>{for(const r of Object.keys(a))a[r]||delete a[r];this.c=a,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),l.Promises.writeFile(this.f,n)}).then(()=>i,a=>this.j.error(a))})}};d=Ee([oe(0,h.$Qi),oe(1,f.$dk)],d);function $(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const y of R.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}}),define(le[128],he([0,1,58,7,27,41]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QR=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function w(h,u,p){const f=await(0,P.$wq)("@microsoft/1ds-core-js","dist/ms.core.js"),m=await(0,P.$wq)("@microsoft/1ds-post-js","dist/ms.post.js"),k=new f.AppInsightsCore,b=new m.PostChannel,d={instrumentationKey:h,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(p){d.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:p};d.extensionConfig[b.identifier]=$}return k.initialize(d,[]),k.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',u&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),k}class l{constructor(u,p,f,m,k){this.e=u,this.f=p,this.g=f,this.h=k,this.c=C,this.d=O,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(u){if(this.a){if(typeof this.a!="string"){u(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(p=>{u(p)},p=>{(0,S.$2)(p),console.error(p)})}}log(u,p){if(!this.a)return;p=(0,v.$ko)(p,this.g),p=(0,I.$Kp)(p);const f=this.f+"/"+u;try{this.i(m=>{m.pluginVersionString=p?.properties.version??"Unknown",m.track({name:f,baseData:{name:f,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(u=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,u(void 0)})})}):Promise.resolve(void 0)}}e.$QR=l});var ze=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[129],he([0,1,2,27,12,31,5,30,40,130,33,37,18,41]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0,l=ze(l);let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,$,R){this.k=$,this.l=R,this.d={},this.i=new P.$Wc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=p.TelemetryLevel.USAGE,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,I.$kf)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$kf)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(p.$lm)||y.affectsConfiguration(p.$nm)||y.affectsConfiguration(p.$mm))&&this.m()}))}setExperimentProperty(d,$){this.d[d]=$}m(){let d=(0,f.$Jp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const R=$.usage?p.TelemetryLevel.USAGE:$.error?p.TelemetryLevel.ERROR:p.TelemetryLevel.NONE;d=Math.min(d,R)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,$,R){this.g<$||(R=(0,S.$ko)(R,this.d),R=(0,f.$Op)(R,this.j),R=(0,S.$ko)(R,this.c),this.b.forEach(y=>y.log(d,R)))}publicLog(d,$){this.n(d,p.TelemetryLevel.USAGE,$)}publicLog2(d,$){this.publicLog(d,$)}publicLogError(d,$){this.h&&this.n(d,p.TelemetryLevel.ERROR,$)}publicLogError2(d,$){this.publicLogError(d,$)}};e.$ms=m,e.$ms=m=Ee([oe(1,O.$cj),oe(2,h.$wk)],m);function k(){const b=(0,C.localize)(2066,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,C.localize)(2068,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,C.localize)(2067,null,"https://aka.ms/vscode-telemetry"),$=v.$p?"":(0,C.localize)(2069,null),R=(0,C.localize)(2070,null),y=(0,C.localize)(2071,null),i=(0,C.localize)(2072,null),a=(0,C.localize)(2073,null),n=`
|       | ${R} | ${y} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(2074,null);return`
${b} ${d} ${$}

&nbsp;

${a}
${n}

&nbsp;

${r}
`}u.$uo.as(w.$zo.Configuration).registerConfiguration({id:p.$km,order:1,type:"object",title:(0,C.localize)(2075,null),properties:{[p.$lm]:{type:"string",enum:[p.TelemetryConfiguration.ON,p.TelemetryConfiguration.ERROR,p.TelemetryConfiguration.CRASH,p.TelemetryConfiguration.OFF],enumDescriptions:[(0,C.localize)(2076,null),(0,C.localize)(2077,null),(0,C.localize)(2078,null),(0,C.localize)(2079,null)],markdownDescription:k(),default:p.TelemetryConfiguration.ON,restricted:!0,scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$uo.as(w.$zo.Configuration).registerConfiguration({id:p.$km,order:110,type:"object",title:(0,C.localize)(2080,null),properties:{[p.$nm]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,C.localize)(2082,null,l.default.nameLong,l.default.privacyStatementUrl):(0,C.localize)(2081,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(2083,null,`\`#${p.$lm}#\``),scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[131],he([0,1,13,21,155,128]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RR=void 0,v=be(v);async function C(h,u){const p=await u.request(h,S.CancellationToken.None),f=(await(0,P.$3e)(p.stream)).toString(),m=p.res.statusCode??200;return{headers:p.res.headers,statusCode:m,responseData:f}}async function O(h){const u={method:h.type,headers:h.headers};return new Promise((f,m)=>{const k=v.request(h.url??"",u,b=>{b.on("data",function(d){f({headers:b.headers,statusCode:b.statusCode??200,responseData:d.toString()})}),b.on("error",function(d){m(d)})});k.write(h.data,b=>{b&&m(b)}),k.end()})}async function w(h,u,p){const f=typeof u.data=="string"?u.data:new TextDecoder().decode(u.data),m={type:"POST",headers:{...u.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(u.data).toString()},url:u.urlString,data:f};try{const k=h?await C(m,h):await O(m);p(k.statusCode,k.headers,k.responseData)}catch{p(0,{})}}class l extends I.$QR{constructor(u,p,f,m,k){const b={sendPOST:(d,$)=>{w(u,d,$)}};super(p,f,m,k,b)}}e.$RR=l}),define(le[132],he([0,1,32,15,29]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=I,P=be(P);async function I(C,O){const w=Object.create(null),l=(u,p)=>{const f=JSON.parse(u);w[p]=f};if(O){const u=[],p=await v.Promises.readdir(O);for(const m of p)try{(await P.promises.stat((0,S.$mc)(O,m))).isDirectory()&&u.push(m)}catch{}const f=[];for(const m of u)(await v.Promises.readdir((0,S.$mc)(O,m))).filter(b=>b==="telemetry.json").length===1&&f.push(m);for(const m of f){const k=(await P.promises.readFile((0,S.$mc)(O,m,"telemetry.json"))).toString();l(k,m)}}let h=(await P.promises.readFile((0,S.$mc)(C,"telemetry-core.json"))).toString();return l(h,"vscode-core"),h=(await P.promises.readFile((0,S.$mc)(C,"telemetry-extensions.json"))).toString(),l(h,"vscode-extensions"),JSON.stringify(w,null,4)}}),define(le[133],he([0,1,12,84,18]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=I,e.$sic=C,e.$tic=O;async function I(w,l){let h=w.getItem(v.$hm);return(typeof h!="string"||P.$k&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,S.$Wn)(l.error.bind(l))),h}async function C(w,l){let h=w.getItem(v.$im);return typeof h!="string"&&(h=await(0,S.$Xn)(l.error.bind(l))),h}async function O(w,l){let h=w.getItem(v.$jm);return typeof h!="string"&&(h=await(0,S.$Yn)(l.error.bind(l))),h}}),define(le[23],he([0,1,10]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,P.$Ii)("IUriIdentityService")}),define(le[134],he([0,1,23,99,9,16,81,4,2]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class l{static{this._clock=0}constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let h=class{constructor(p){this.g=p,this.c=new w.$Wc,this.f=2**16;const f=new Map,m=k=>{let b=f.get(k.scheme);return b===void 0&&(b=p.hasProvider(k)&&!this.g.hasCapability(k,v.FileSystemProviderCapabilities.PathCaseSensitive),f.set(k.scheme,b)),b};this.c.add(O.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(k=>{f.delete(k.scheme)})),this.extUri=new I.$$g(m),this.d=new C.$Ys((k,b)=>this.extUri.compare(k,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,I.$kh)(p));const f=this.d.get(p);return f?f.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((m,k)=>m[1].time<k[1].time?1:m[1].time>k[1].time?-1:0);l._clock=0,this.d.clear();const f=this.f*.5;for(let m=0;m<f;m++)this.d.set(p[m][0],p[m][1].touch())}};e.$Zs=h,e.$Zs=h=Ee([oe(0,v.$dl)],h),(0,S.$Ws)(P.$Nl,h,S.InstantiationType.Delayed)}),define(le[135],he([0,1,4,2,9,49,25]),function(Z,e,P,S,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=void 0;class O extends S.$Xc{constructor(l,h,u,p,f,m){super(),this.f=l,this.g=h,this.h=u,this.j=p,this.m=f,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$oe),this.onDidChangeFile=this.a.event,this.b=I.$Oi.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new C.$Ec(k=>this.m.extUri.getComparisonKey(this.t(k))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(k=>this.s(k)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,h){return this.g.open(this.t(l),h)}close(l){return this.g.close(l)}read(l,h,u,p,f){return this.g.read(l,h,u,p,f)}write(l,h,u,p,f){return this.g.write(l,h,u,p,f)}watch(l,h){this.b.set(l,l);const u=this.g.watch(this.t(l),h);return(0,S.$Vc)(()=>{this.b.delete(l),u.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,h,u){return this.g.rename(this.t(l),this.t(h),u)}readFile(l,h){return this.g.readFile(this.t(l),h)}readFileStream(l,h,u){return this.g.readFileStream(this.t(l),h,u)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,h,u){return this.g.writeFile(this.t(l),h,u)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,h){return this.g.delete(this.t(l),h)}copy(l,h,u){if((0,v.$hl)(this.g))return this.g.copy(this.t(l),this.t(h),u);throw new Error("copy not supported")}cloneFile(l,h){if((0,v.$il)(this.g))return this.g.cloneFile(this.t(l),this.t(h));throw new Error("clone not supported")}s(l){const h=[];for(const u of l){if(u.resource.scheme!==this.f)continue;const p=this.u(u.resource);this.b.findSubstr(p)&&h.push({resource:p,type:u.type,cId:u.cId})}h.length&&(this.n.debug("User data changed"),this.a.fire(h))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$Ric=O}),define(le[136],he([0,1,5,15,49,16,11,10,14]),function(Z,e,P,S,v,I,C,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=l,e.$Ti=h,e.$Wi=u,e.$Xi=p,e.$Yi=f,e.$Zi=k,e.$1i=b,e.$4i=R,e.$9i=y,e.$0i=i,e.$_i=a,e.$aj=n,e.$bj=r,e.$Ri=(0,O.$Ii)("contextService");function l(t){const s=t;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}function h(t){return typeof t?.id=="string"&&!l(t)&&!p(t)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function u(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,S.$qc)(t)}:s?e.$Ui:e.$Vi;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function p(t){const s=t;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}function f(t){const s=t;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var m;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function k(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function b(t){const s=t;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class d{constructor(s,o,c,g,N){this.h=s,this.j=c,this.k=g,this.l=N,this.c=v.$Oi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=v.$Oi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=d;class ${constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,I.$jh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=$;function R(t){return new $({uri:t,index:0,name:(0,I.$fh)(t)},{uri:t.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,P.localize)(2487,null),extensions:[e.$5i]}],e.$8i="workspace.json";function y(t,s){return I.$ah.isEqualOrParent(t,s.untitledWorkspacesHome)}function i(t){let s;return C.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===w.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(t){return t.id===e.$$i}function n(t,s){return!y(t,s)&&!i(t)}function r(t){return(typeof t=="string"?(0,S.$rc)(t):(0,I.$hh)(t))===e.$6i}}),define(le[24],he([0,1,43,4,2,16,11,5,17,9,10,6,136,25,23,8,28,31,3]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=y,e.$Ql=i,e.$Rl=a;var R;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(R||(e.ProfileResourceType=R={}));function y(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&C.URI.isUri(s.extensionsResource))}e.$Pl=(0,h.$Ii)("IUserDataProfilesService");function i(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:s}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function a(t,s,o,c,g,N){return{id:t,name:s,location:o,isDefault:!1,shortName:g?.shortName,icon:g?.icon,globalStorageHome:N&&g?.useDefaultFlags?.globalState?N.globalStorageHome:(0,I.$jh)(o,"globalStorage"),settingsResource:N&&g?.useDefaultFlags?.settings?N.settingsResource:(0,I.$jh)(o,"settings.json"),keybindingsResource:N&&g?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,I.$jh)(o,"keybindings.json"),tasksResource:N&&g?.useDefaultFlags?.tasks?N.tasksResource:(0,I.$jh)(o,"tasks.json"),snippetsHome:N&&g?.useDefaultFlags?.snippets?N.snippetsHome:(0,I.$jh)(o,"snippets"),extensionsResource:N&&g?.useDefaultFlags?.extensions?N.extensionsResource:(0,I.$jh)(o,"extensions.json"),cacheHome:(0,I.$jh)(c,t),useDefaultFlags:g?.useDefaultFlags,isTransient:g?.transient}}let n=class extends v.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,c,g){super(),this.t=s,this.u=o,this.w=c,this.y=g,this.f=!0,this.h=this.B(new S.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new S.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new S.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new S.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new f.$Dc,workspaces:new f.$Dc,emptyWindows:new Map},this.profilesHome=(0,I.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,$.$hg)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}o.push(a((0,I.$gh)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},s))}}catch(N){this.y.error(N)}const c=new f.$Dc,g=new Map;if(o.length)try{const N=this.Q();if(N.workspaces)for(const[T,A]of Object.entries(N.workspaces)){const D=C.URI.parse(T),F=o.find(x=>x.id===A);F&&c.set(D,F)}if(N.emptyWindows)for(const[T,A]of Object.entries(N.emptyWindows)){const D=o.find(F=>F.id===A);D&&g.set(T,D)}}catch(N){this.y.error(N)}this.z={profiles:o,workspaces:c,emptyWindows:g}}return this.z}D(){const s=a("__default__profile__",(0,O.localize)(2440,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",c=new RegExp(`${(0,d.$kf)(o)}\\s(\\d+)`);let g=0;for(const T of this.profiles){const A=c.exec(T.name),D=A?parseInt(A[1]):0;g=D>g?D:g}const N=`${o} ${g+1}`;return this.createProfile((0,P.$wj)((0,b.$5g)()).toString(16),N,{transient:!0},s)}async createNamedProfile(s,o,c){return this.createProfile((0,P.$wj)((0,b.$5g)()).toString(16),s,o,c)}async createProfile(s,o,c,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(s,o,c);return g&&await this.setProfileForWorkspace(g,N),N}async F(s,o,c){if(!(0,$.$hg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let g=this.r.get(o);return g||(g=(async()=>{try{if(this.profiles.find(D=>D.name===o||D.id===s))throw new Error(`Profile with ${o} name already exists`);const T=a(s,o,(0,I.$jh)(this.profilesHome,s),this.g,c,this.defaultProfile);await this.u.createFolder(T.location);const A=[];return this.j.fire({profile:T,join(D){A.push(D)}}),await k.Promises.settled(A),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,g)),g}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(g=>g.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);return c=a(c.id,o.name??c.name,c.location,this.g,{shortName:o.shortName??c.shortName,icon:o.icon===null?void 0:o.icon??c.icon,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.I([],[],[c]),c}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(g=>g.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const c=[];this.m.fire({profile:o,join(g){c.push(g)}});try{await Promise.allSettled(c)}catch(g){this.y.error(g)}for(const g of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(g)?.id&&this.C.emptyWindows.delete(g);for(const g of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(g)?.id&&this.C.workspaces.delete(g);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(g){(0,l.$ul)(g)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(g)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(g=>g.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,c)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.w.extUri.isEqual(c.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),c=C.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return c||((0,p.$Si)(s)?this.s.folders.get(s.uri):(0,p.$Xi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,p.$Si)(s)?s.uri:(0,p.$Xi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,c){const g=[...this.profiles,...s],N=[],T=this.s.profiles;this.s.profiles=[];for(let A of g){if(A.isDefault||o.some(F=>A.id===F.id))continue;A=c.find(F=>A.id===F.id)??A;const D=T.find(F=>A.id===F.id);if(A.isTransient)this.s.profiles.push(A);else{if(D){for(const[F,x]of this.s.emptyWindows.entries())if(A.id===x.id){this.L({id:F},A);break}for(const[F,x]of this.s.workspaces.entries())if(A.id===x.id){this.L({id:"",configPath:F},A);break}for(const[F,x]of this.s.folders.entries())if(A.id===x.id){this.L({id:"",uri:F},A);break}}N.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(N),this.z=void 0,this.J(s,o,c)}J(s,o,c){this.h.fire({added:s,removed:o,updated:c,all:this.profiles})}L(s,o,c){if(c=o?.isTransient?!0:c,c)(0,p.$Si)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,p.$Xi)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const g=this.G(s);C.URI.isUri(g)?(this.C.workspaces.delete(g),o&&this.C.workspaces.set(g,o)):(this.C.emptyWindows.delete(g),o&&this.C.emptyWindows.set(g,o)),this.M()}}M(){const s={};for(const[c,g]of this.C.workspaces.entries())s[c.toString()]=g.id;const o={};for(const[c,g]of this.C.emptyWindows.entries())o[c.toString()]=g.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},c=this.D();if(s.workspaces)for(const[N,T]of Object.entries(s.workspaces)){const A=C.URI.parse(T);o[N]=this.w.extUri.isEqual(A,c.location)?c.id:this.w.extUri.basename(A)}const g={};if(s.emptyWindows)for(const[N,T]of Object.entries(s.emptyWindows)){const A=C.URI.parse(T);g[N]=this.w.extUri.isEqual(A,c.location)?c.id:this.w.extUri.basename(A)}return{workspaces:o,emptyWindows:g}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Sl=n,e.$Sl=n=Ee([oe(0,w.$Pi),oe(1,l.$dl),oe(2,m.$Nl),oe(3,u.$dk)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Tl=r}),define(le[53],he([0,1,19,8,21,7,4,2,25,12,3,11,5,20,26,22,44,6,33,18,23,24]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$,R,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Kq=void 0,e.$Lq=n,p=be(p);let a=class extends O.$Xc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(o,c,g,N,T,A){super(),this.z=o,this.C=c,this.D=g,this.F=N,this.G=T,this.H=A,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new C.$oe),this.s=this.B(new C.$oe),this.t=this.B(new C.$oe),this.u=this.B(new C.$oe),this.w=this.B(new C.$oe),this.y=[],this.B((0,O.$Vc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(o){const c=await this.getTargetPlatform();return o.allTargetPlatforms.some(g=>(0,f.$mp)(g,o.allTargetPlatforms,c))}async installFromGallery(o,c={}){try{const N=(await this.installGalleryExtensions([{extension:o,options:c}])).find(({identifier:T})=>(0,m.$Pp)(T,o.identifier));if(N?.local)return N?.local;throw N?.error?N.error:new f.$qp(`Unknown error while installing extension ${o.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(g){throw n(g)}}async installGalleryExtensions(o){if(!this.z.isEnabled())throw new f.$qp(p.localize(1765,null),f.ExtensionManagementErrorCode.NotAllowed);const c=[],g=[];return await Promise.allSettled(o.map(async({extension:N,options:T})=>{try{const A=await this.N(N,!!T?.installGivenVersion,!!T?.installPreReleaseVersion,T.productVersion??{version:this.G.version,date:this.G.date});g.push({...A,options:T})}catch(A){c.push({identifier:N.identifier,operation:f.InstallOperation.Install,source:N,error:A,profileLocation:T.profileLocation??this.W()})}})),g.length&&c.push(...await this.I(g)),c}async uninstall(o,c){return this.F.trace("ExtensionManagementService#uninstall",o.identifier.id),this.uninstallExtensions([{extension:o,options:c}])}async toggleAppliationScope(o,c){if((0,k.$xn)(o.manifest)||o.isBuiltin)return o;if(o.isApplicationScoped){let g=await this.updateMetadata(o,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(c,this.H.defaultProfile.extensionsResource)||(g=await this.Z(o,this.H.defaultProfile.extensionsResource,c));for(const N of this.H.profiles){const T=(await this.getInstalled(k.ExtensionType.User,N.extensionsResource)).find(A=>(0,m.$Pp)(A.identifier,o.identifier));T?this.w.fire({local:T,profileLocation:N.extensionsResource}):this.u.fire({identifier:o.identifier,profileLocation:N.extensionsResource})}return g}else{const g=this.D.extUri.isEqual(c,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(o,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(o,c,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:g.identifier,operation:f.InstallOperation.Install,local:g,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),g}}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.g||o-this.h>1e3*60*5)&&(this.g=this.U(),this.h=o),this.g}registerParticipant(o){this.y.push(o)}async resetPinnedStateForAllUserExtensions(o){try{await this.L(this.H.profiles.map(async c=>{const g=await this.getInstalled(k.ExtensionType.User,c.extensionsResource);await this.L(g.map(async N=>{N.pinned!==o&&await this.updateMetadata(N,{pinned:o},c.extensionsResource)}))}))}catch(c){throw this.F.error("Error while resetting pinned state for all user extensions",(0,I.$_)(c)),c}}async I(o){const c=new Map,g=new Map,N=[],T=(D,F)=>`${m.$Qp.create(D).toString()}-${F.toString()}`,A=(D,F,x,Y)=>{const ne=this.X(D,F,x),ae=`${(0,m.$Up)(D.publisher,D.name)}-${x.profileLocation.toString()}`;g.set(ae,{task:ne,root:Y}),this.n.fire({identifier:ne.identifier,source:F,profileLocation:x.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,x),u.URI.isUri(F)||this.j.set(T(F,x.profileLocation),{task:ne,waitingTasks:[]})};try{for(const{manifest:D,extension:F,options:x}of o){const Y=x.isApplicationScoped||x.isBuiltin||(0,k.$xn)(D),ne={...x,installOnlyNewlyAddedFromExtensionPack:x.installOnlyNewlyAddedFromExtensionPack??!u.URI.isUri(F),isApplicationScoped:Y,profileLocation:Y?this.H.defaultProfile.extensionsResource:x.profileLocation??this.W(),productVersion:x.productVersion??{version:this.G.version,date:this.G.date}},ae=u.URI.isUri(F)?void 0:this.j.get(T(F,ne.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,ne.profileLocation.toString()),N.push(ae.task.waitUntilTaskIsFinished())):A(D,F,ne,void 0)}return await Promise.all([...g.values()].map(async({task:D})=>{if(D.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",D.identifier.id);else try{const F=await this.M(D.identifier,D.manifest,!!D.options.installOnlyNewlyAddedFromExtensionPack,!!D.options.installPreReleaseVersion,D.options.profileLocation,D.options.productVersion),x=await this.getInstalled(void 0,D.options.profileLocation,D.options.productVersion),Y={...D.options,context:{...D.options.context,[f.$gp]:!0}};for(const{gallery:ne,manifest:ae}of(0,P.$Ob)(F,({gallery:ue})=>ue.identifier.id)){if(g.has(`${ne.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const ue=this.j.get(T(ne,Y.profileLocation));if(ue){if(this.J(D,ue.task)){const me=ue.task.identifier;this.F.info("Waiting for already requested installing extension",me.id,D.identifier.id,Y.profileLocation.toString()),ue.waitingTasks.push(D),N.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,W=>W.some(_=>(0,m.$Pp)(_.identifier,me)))).then(W=>{if(this.F.info("Finished waiting for already requested installing extension",me.id,D.identifier.id,Y.profileLocation.toString()),!W.find(M=>(0,m.$Pp)(M.identifier,me))?.local)throw new Error(`Extension ${me.id} is not installed`)}))}}else x.some(({identifier:me})=>(0,m.$Pp)(me,ne.identifier))||A(ae,ne,Y,D)}}catch(F){if(u.URI.isUri(D.source))(0,P.$Nb)(D.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",D.identifier.id,F.message),(0,P.$Nb)(D.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",D.identifier.id,F.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",D.identifier.id),F}})),await this.L([...g.entries()].map(async([D,{task:F}])=>{const x=new Date().getTime();let Y;try{Y=await F.run(),await this.L(this.y.map(ne=>ne.postInstall(Y,F.source,F.options,v.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(ne){const ae=n(ne);throw u.URI.isUri(F.source)||r(this.C,F.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Xp)(F.source),error:ae,source:F.options.context?.[f.$fp]}),c.set(D,{error:ae,identifier:F.identifier,operation:F.operation,source:F.source,context:F.options.context,profileLocation:F.options.profileLocation,applicationScoped:F.options.isApplicationScoped}),this.F.error("Error while installing the extension",F.identifier.id,(0,I.$_)(ae),F.options.profileLocation.toString()),ae}if(!u.URI.isUri(F.source)){const ne=F.operation===f.InstallOperation.Update,ae=ne?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(r(this.C,ne?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Xp)(F.source),verificationStatus:F.verificationStatus,duration:new Date().getTime()-x,durationSinceUpdate:ae,source:F.options.context?.[f.$fp]}),l.$p&&F.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,f.StatisticType.Install)}catch{}}c.set(D,{local:Y,identifier:F.identifier,operation:F.operation,source:F.source,context:F.options.context,profileLocation:F.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),N.length&&await this.L(N),[...c.values()]}catch(D){const F=(ne,ae,ue)=>{const me=[];ne.manifest.extensionDependencies?.length&&me.push(...ne.manifest.extensionDependencies),ne.manifest.extensionPack?.length&&me.push(...ne.manifest.extensionPack);for(const W of me){if(ue.includes(W.toLowerCase()))continue;ue.push(W.toLowerCase());const _=c.get(`${W.toLowerCase()}-${ae.toString()}`);_?.local&&(ue=F(_.local,ae,ue))}return ue},x=ne=>({identifier:ne.identifier,operation:f.InstallOperation.Install,source:ne.source,context:ne.options.context,profileLocation:ne.options.profileLocation,error:D}),Y=[];for(const[ne,{task:ae,root:ue}]of g){const me=c.get(ne);me?me.local&&ue&&!c.get(`${ue.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(Y.push(this.Y(me.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),c.set(ne,x(ae))):(ae.cancel(),c.set(ne,x(ae)))}for(const[ne,{task:ae}]of g){const ue=c.get(ne);if(!ue?.local||ae.options.donotIncludePackAndDependencies)continue;F(ue.local,ae.options.profileLocation,[ue.local.identifier.id.toLowerCase()]).slice(1).some(W=>g.has(`${W.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!c.get(`${W.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(Y.push(this.Y(ue.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),c.set(ne,x(ae)))}throw Y.length&&await Promise.allSettled(Y.map(async ne=>{try{await ne.run(),this.F.info("Rollback: Uninstalled extension",ne.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",ne.extension.identifier.id,(0,I.$_)(ae))}})),D}finally{for(const{task:D}of g.values())D.source&&!u.URI.isUri(D.source)&&this.j.delete(T(D.source,D.options.profileLocation));if(c.size){const D=[...c.values()];for(const F of D)F.local&&this.F.info("Extension installed successfully:",F.identifier.id,F.profileLocation.toString());this.s.fire(D)}}}J(o,c){for(const[,{task:g,waitingTasks:N}]of this.j.entries())if(g===o&&(N.includes(c)||N.some(T=>this.J(T,c)))||g===c&&N[0]&&!this.J(o,N[0]))return!1;return!0}async L(o,c){const g=[],N=[],T=await Promise.allSettled(o);for(const D of T)D.status==="fulfilled"?g.push(D.value):N.push(n(D.reason,c));if(!N.length)return g;if(N.length===1)throw N[0];let A=new f.$qp("",f.ExtensionManagementErrorCode.Unknown);for(const D of N)A=new f.$qp(A.message?`${A.message}, ${D.message}`:D.message,D.code!==f.ExtensionManagementErrorCode.Unknown&&D.code!==f.ExtensionManagementErrorCode.Internal?D.code:A.code);throw A}async M(o,c,g,N,T,A){if(!this.z.isEnabled())return[];const D=await this.getInstalled(void 0,T,A),F=[],x=[],Y=async(ne,ae)=>{F.push(ne);const ue=ae.extensionDependencies||[],me=[...ue];if(ae.extensionPack){const W=g?D.find(_=>(0,m.$Pp)(_.identifier,ne)):void 0;for(const _ of ae.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(M=>(0,m.$Pp)({id:M},{id:_}))||me.every(M=>!(0,m.$Pp)({id:M},{id:_}))&&me.push(_)}if(me.length){const W=me.filter(_=>F.every(M=>!(0,m.$Pp)(M,{id:_})));if(W.length){const _=await this.z.getExtensions(W.map(M=>({id:M,preRelease:N})),v.CancellationToken.None);for(const M of _){if(F.find(X=>(0,m.$Pp)(X,M.identifier)))continue;const q=ue.some(X=>(0,m.$Pp)({id:X},M.identifier));let H;try{H=await this.N(M,!1,N,A)}catch(X){if(q)throw X;this.F.info("Skipping the packed extension as it cannot be installed",M.identifier.id,(0,I.$_)(X));continue}x.push({gallery:H.extension,manifest:H.manifest}),await Y(H.extension.identifier,H.manifest)}}}};return await Y(o,c),x}async N(o,c,g,N){let T;const A=await this.getExtensionsControlManifest();if(A.malicious.some(x=>(0,m.$Pp)(o.identifier,x)))throw new f.$qp(p.localize(1766,null,o.identifier.id),f.ExtensionManagementErrorCode.Malicious);const D=A.deprecated[o.identifier.id.toLowerCase()];if(D?.extension?.autoMigrate){if(this.F.info(`The '${o.identifier.id}' extension is deprecated, fetching the compatible '${D.extension.id}' extension instead.`),T=(await this.z.getExtensions([{id:D.extension.id,preRelease:D.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:N},v.CancellationToken.None))[0],!T)throw new f.$qp(p.localize(1767,null,o.identifier.id,D.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(o)){const x=await this.getTargetPlatform();throw new f.$qp(p.localize(1768,null,o.identifier.id,this.G.nameLong,(0,f.$ip)(x)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(T=await this.O(o,c,g,N),!T){const x=[];throw(0,b.$0p)(o.properties.enabledApiProposals??[],x)?!g&&o.properties.isPreReleaseVersion&&(await this.z.getExtensions([o.identifier],v.CancellationToken.None))[0]?new f.$qp(p.localize(1770,null,o.displayName??o.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$qp(p.localize(1771,null,o.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible):new f.$qp(p.localize(1769,null,o.displayName??o.identifier.id,x[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",T.identifier.id);const F=await this.z.getManifest(T,v.CancellationToken.None);if(F===null)throw new f.$qp(`Missing manifest for extension ${T.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(F.version!==T.version)throw new f.$qp(`Cannot install '${T.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:T,manifest:F}}async O(o,c,g,N){const T=await this.getTargetPlatform();let A=null;return!c&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==g&&(A=(await this.z.getExtensions([{...o.identifier,preRelease:g}],{targetPlatform:T,compatible:!0,productVersion:N},v.CancellationToken.None))[0]||null),!A&&await this.z.isExtensionCompatible(o,g,T,N)&&(A=o),A||(c?A=(await this.z.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:T,compatible:!0,productVersion:N},v.CancellationToken.None))[0]||null:A=await this.z.getCompatibleExtension(o,g,T,N)),A}async uninstallExtensions(o){const c=(x,Y)=>`${x.identifier.id.toLowerCase()}${Y.versionOnly?`-${x.manifest.version}`:""}@${Y.profileLocation.toString()}`,g=(x,Y)=>{const ne=this.Y(x,Y);return this.m.set(c(ne.extension,Y),ne),this.F.info("Uninstalling extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,Y.profileLocation.toString()),this.t.fire({identifier:x.identifier,profileLocation:Y.profileLocation,applicationScoped:x.isApplicationScoped}),ne},N=(x,Y,ne)=>{ne?this.F.error("Failed to uninstall extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,Y.profileLocation.toString(),ne.message):this.F.info("Successfully uninstalled extension from the profile",`${x.identifier.id}@${x.manifest.version}`,Y.profileLocation.toString()),r(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$Wp)(x),error:ne}),this.u.fire({identifier:x.identifier,error:ne?.code,profileLocation:Y.profileLocation,applicationScoped:x.isApplicationScoped})},T=[],A=[],D=[],F=new w.$Dc;for(const{extension:x,options:Y}of o){const ne={...Y,profileLocation:x.isApplicationScoped?this.H.defaultProfile.extensionsResource:Y?.profileLocation??this.W()},ae=this.m.get(c(x,ne));ae?(this.F.info("Extensions is already requested to uninstall",x.identifier.id),D.push(ae.waitUntilTaskIsFinished())):T.push(g(x,ne))}try{for(const x of T.slice(0)){let Y=F.get(x.options.profileLocation);if(Y||F.set(x.options.profileLocation,Y=await this.getInstalled(k.ExtensionType.User,x.options.profileLocation)),x.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${x.extension.identifier.id}@${x.extension.manifest.version}`);else{const ne=this.R(x.extension,Y);for(const ae of ne)this.m.has(c(ae,x.options))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):T.push(g(ae,x.options))}x.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${x.extension.identifier.id}@${x.extension.manifest.version}`):this.P(T.map(ne=>ne.extension),Y,x.extension)}await this.L(T.map(async x=>{try{if(await x.run(),await this.L(this.y.map(Y=>Y.postUninstall(x.extension,x.options,v.CancellationToken.None))),x.extension.identifier.uuid)try{await this.z.reportStatistic(x.extension.manifest.publisher,x.extension.manifest.name,x.extension.manifest.version,f.StatisticType.Uninstall)}catch{}}catch(Y){const ne=n(Y);throw N(x.extension,x.options,ne),ne}finally{A.push(x)}})),D.length&&await this.L(D);for(const x of T)N(x.extension,x.options)}catch(x){const Y=n(x);for(const ne of T){try{ne.cancel()}catch{}A.includes(ne)||N(ne.extension,ne.options,Y)}throw Y}finally{for(const x of T)this.m.delete(c(x.extension,x.options))||this.F.warn("Uninstallation task is not found in the cache",x.extension.identifier.id)}}P(o,c,g){for(const N of o){const T=this.S(N,c);if(T.length){const A=T.filter(D=>!o.some(F=>(0,m.$Pp)(F.identifier,D.identifier)));if(A.length)throw new Error(this.Q(N,A,g))}}}Q(o,c,g){return g===o?c.length===1?p.localize(1772,null,g.manifest.displayName||g.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?p.localize(1773,null,g.manifest.displayName||g.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):p.localize(1774,null,g.manifest.displayName||g.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?p.localize(1775,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?p.localize(1776,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):p.localize(1777,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}R(o,c,g=[]){if(g.indexOf(o)!==-1)return[];g.push(o);const N=o.manifest.extensionPack?o.manifest.extensionPack:[];if(N.length){const T=c.filter(D=>!D.isBuiltin&&N.some(F=>(0,m.$Pp)({id:F},D.identifier))),A=[];for(const D of T)A.push(...this.R(D,c,g));return[...T,...A]}return[]}S(o,c){return c.filter(g=>g.manifest.extensionDependencies&&g.manifest.extensionDependencies.some(N=>(0,m.$Pp)({id:N},o.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(o){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,I.$_)(o)),{malicious:[],deprecated:{},search:[]}}}};e.$Kq=a,e.$Kq=a=Ee([oe(0,f.$op),oe(1,R.$cm),oe(2,y.$Nl),oe(3,d.$dk),oe(4,$.$wk),oe(5,i.$Pl)],a);function n(s,o){if(s instanceof f.$qp)return s;let c;return s instanceof f.$pp?c=new f.$qp(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):c=new f.$qp(s.message,(0,I.$6)(s)?f.ExtensionManagementErrorCode.Cancelled:o??f.ExtensionManagementErrorCode.Internal),c.stack=s.stack,c}function r(s,o,{extensionData:c,verificationStatus:g,duration:N,error:T,source:A,durationSinceUpdate:D}){let F,x;(0,h.$pg)(g)&&(g===!0?g="Verified":(g===!1||(F=f.ExtensionManagementErrorCode.Signature,x=g),g="Unverified")),T&&(F=T.code,T.code===f.ExtensionManagementErrorCode.Signature&&(x=T.message)),s.publicLog(o,{...c,verificationStatus:g,success:!T,duration:N,errorcode:F,errorcodeDetail:x,durationSinceUpdate:D,source:A})}class t{constructor(){this.d=new S.$Hh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,S.$vh)(o=>this.h(o))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,S.$vh)(o=>new Promise((c,g)=>{const N=o.onCancellationRequested(()=>{N.dispose(),g(new I.$7)})})),this.d.open()),this.g.cancel()}}e.$Mq=t}),define(le[42],he([0,1,8,13,2,4,25,11,20,26,9,10,6,24,23,3,7,18]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=e.$Nq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class R extends Error{constructor(r,t){super(r),this.code=t}}e.$Nq=R,e.$Oq=(0,u.$Ii)("IExtensionsProfileScannerService");let y=class extends v.$Xc{constructor(r,t,s,o,c,g){super(),this.j=r,this.m=t,this.n=s,this.r=o,this.s=c,this.t=g,this.b=this.B(new I.$oe),this.onAddExtensions=this.b.event,this.c=this.B(new I.$oe),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$oe),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$oe),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Dc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t,s){const o=[],c=[];try{return await this.u(t,g=>{const N=[];if(s)N.push(...g);else for(const T of g)r.some(([A])=>(0,l.$Pp)(A.identifier,T.identifier)&&A.manifest.version!==T.version)?o.push(T):N.push(T);for(const[T,A]of r){const D=N.findIndex(x=>(0,l.$Pp)(x.identifier,T.identifier)&&x.version===T.manifest.version),F={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:A};D===-1?(c.push(F),N.push(F)):N.splice(D,1,F)}return c.length&&this.b.fire({extensions:c,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),N}),c.length&&this.c.fire({extensions:c,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),c}catch(g){throw c.length&&this.c.fire({extensions:c,error:g,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:g,profileLocation:t}),g}}async updateMetadata(r,t){const s=[];return await this.u(t,o=>{const c=[];for(const g of o){const N=r.find(([T])=>(0,l.$Pp)(T.identifier,g.identifier)&&T.manifest.version===g.version);N&&(g.metadata={...g.metadata,...N[1]},s.push(g)),c.push(g)}return c}),s}async removeExtensionFromProfile(r,t){const s=[];try{await this.u(t,o=>{const c=[];for(const g of o)(0,l.$Pp)(g.identifier,r.identifier)?s.push(g):c.push(g);return s.length&&this.f.fire({extensions:s,profileLocation:t}),c}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:t}),o}}async u(r,t,s){return this.F(r).queue(async()=>{let o=[],c;try{const g=await this.m.readFile(r);c=JSON.parse(g.value.toString().trim()||"[]")}catch(g){if((0,h.$ul)(g)!==h.FileOperationResult.FILE_NOT_FOUND)throw g;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(c=await this.D()),!c&&s?.bailOutWhenFileNotFound)throw new R((0,b.$_)(g),$.ERROR_PROFILE_NOT_FOUND)}if(c){Array.isArray(c)||this.w(r);let g=!1;for(const N of c){i(N)||this.w(r);let T;if((0,k.$hg)(N.relativeLocation)&&N.relativeLocation)T=this.z(N.relativeLocation);else if((0,k.$hg)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{T=O.URI.revive(N.location);const A=this.y(T);A&&(g=!0,N.relativeLocation=A)}(0,k.$og)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&(g=!0,N.metadata.hasPreReleaseVersion=!0),o.push({identifier:N.identifier,location:T,version:N.version,metadata:N.metadata})}g&&await this.m.writeFile(r,S.$Qe.fromString(JSON.stringify(c)))}if(t){o=t(o);const g=o.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(r,S.$Qe.fromString(JSON.stringify(g)))}return o})}w(r){const t=new R(`Invalid extensions content in ${r.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(c){if((0,h.$ul)(c)===h.FileOperationResult.FILE_NOT_FOUND)return;throw c}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(g=>i(g))?o=c:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.t.error(c)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,S.$Qe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(c){if((0,h.$ul)(c)===h.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw c}try{await this.m.del(r)}catch(c){(0,h.$ul)(c)!==h.FileOperationResult.FILE_NOT_FOUND&&this.t.error(c)}try{await this.m.del(t)}catch(c){(0,h.$ul)(c)!==h.FileOperationResult.FILE_NOT_FOUND&&this.t.error(c)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new P.$Ph,this.h.set(r,t)),t}};e.$Pq=y,e.$Pq=y=Ee([oe(1,h.$dl),oe(2,f.$Pl),oe(3,m.$Nl),oe(4,d.$cm),oe(5,p.$dk)],y);function i(n){return(0,k.$jg)(n)&&(0,w.$np)(n.identifier)&&(a(n.location)||(0,k.$hg)(n.location)&&n.location)&&((0,k.$og)(n.relativeLocation)||(0,k.$hg)(n.relativeLocation))&&n.version&&(0,k.$hg)(n.version)}function a(n){return n?(0,k.$hg)(n.path)&&(0,k.$hg)(n.scheme):!1}});var ze=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[54],he([0,1,19,8,27,13,7,34,91,2,14,15,12,16,45,57,3,11,5,17,26,22,44,9,10,6,33,4,48,42,24,23,97]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$,R,y,i,a,n,r,t,s,o,c,g,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Uq=e.$Tq=e.$Sq=e.Translations=void 0,e.$Vq=ae,v=be(v),u=be(u),p=be(p),m=be(m),k=ze(k);var D;(function(me){function W(_,M){if(_===M)return!0;const q=Object.keys(_),H=new Set;for(const X of Object.keys(M))H.add(X);if(q.length!==H.size)return!1;for(const X of q){if(_[X]!==M[X])return!1;H.delete(X)}return H.size===0}me.equals=W})(D||(e.Translations=D={})),e.$Sq=(0,r.$Ii)("IExtensionsScannerService");let F=class extends l.$Xc{constructor(W,_,M,q,H,X,ie,se,L,V,z,E){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=_,this.r=M,this.s=q,this.t=H,this.u=X,this.w=ie,this.y=se,this.z=L,this.C=V,this.D=z,this.F=E,this.g=this.B(new o.$oe),this.onDidChangeCache=this.g.event,this.h=(0,f.$jh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(Y,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,y.$1p)(this.w,this.y)),this.G}async scanAllExtensions(W,_,M){const[q,H]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(_)]),X=M?await this.scanExtensionsUnderDevelopment(W,[...q,...H]):[];return this.L(q,H,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const _=[];_.push(this.M(!!W.useCache,W.language)),_.push(this.N(W.language,!!W.checkControlFile));const[M,q]=await Promise.all(_);return this.J([...M,...q],i.ExtensionType.System,W,!1)}async scanUserExtensions(W){const _=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const M=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(_,!!W.profileLocation,i.ExtensionType.User,!W.includeUninstalled,W.language,!0,M,W.productVersion??this.R()),H=W.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let X;try{X=await H.scanExtensions(q)}catch(ie){if(ie instanceof g.$Nq&&ie.code===g.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await H.scanExtensions(q);else throw ie}return X=await this.J(X,i.ExtensionType.User,W,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(W,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===h.Schemas.file).map(async q=>{const H=await this.P(q,!1,i.ExtensionType.User,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(H)).map(ie=>(ie.type=_.find(se=>(0,y.$Pp)(se.identifier,ie.identifier))?.type??ie.type,this.n.validate(ie,H)))}))).flat();return this.J(M,"development",W,!0)}return[]}async scanExistingExtension(W,_,M){const q=await this.P(W,!1,_,!0,M.language,!0,void 0,M.productVersion??this.R()),H=await this.n.scanExtension(q);return!H||!M.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(W,_,M){const q=await this.P(W,!1,_,!0,M.language,!0,void 0,M.productVersion??this.R()),H=await this.n.scanOneOrMultipleExtensions(q);return this.J(H,_,M,!0)}async scanMultipleExtensions(W,_,M){const q=[];return await Promise.all(W.map(async H=>{const X=await this.scanOneOrMultipleExtensions(H,_,M);q.push(...X)})),this.J(q,_,M,!0)}async scanMetadata(W){const _=(0,f.$jh)(W,"package.json"),M=(await this.w.readFile(_)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(W,_){const M=(0,f.$jh)(W,"package.json"),q=(await this.w.readFile(M)).value.toString(),H=JSON.parse(q);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,H.__metadata={...H.__metadata,..._},await this.w.writeFile((0,f.$jh)(W,"package.json"),I.$Qe.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof g.$Nq&&W.code===g.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,I.$Qe.fromString(JSON.stringify([])))}catch(_){(0,n.$ul)(_)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$_)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,_,M,q){return M.includeAllVersions||(W=this.L(_===i.ExtensionType.System?W:void 0,_===i.ExtensionType.User?W:void 0,_==="development"?W:void 0,await this.getTargetPlatform(),q)),M.includeInvalid||(W=W.filter(H=>H.isValid)),W.sort((H,X)=>{const ie=u.$qc(H.location.fsPath),se=u.$qc(X.location.fsPath);return ie<se?-1:ie>se?1:0})}L(W,_,M,q,H){const X=(se,L,V)=>{if(se.isValid&&!L.isValid)return!1;if(se.isValid===L.isValid){if(H&&m.gt(se.manifest.version,L.manifest.version))return this.y.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(m.eq(se.manifest.version,L.manifest.version)){if(se.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${L.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===q)return this.y.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return V?this.y.warn(`Overwriting user extension ${se.location.path} with ${L.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${L.location.path}.`),!0},ie=new i.$wn;return W?.forEach(se=>{const L=ie.get(se.identifier.id);(!L||X(L,se,!1))&&ie.set(se.identifier.id,se)}),_?.forEach(se=>{const L=ie.get(se.identifier.id);if(!L&&W&&se.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!L||X(L,se,!1))&&ie.set(se.identifier.id,se)}),M?.forEach(se=>{const L=ie.get(se.identifier.id);(!L||X(L,se,!0))&&ie.set(se.identifier.id,se),ie.set(se.identifier.id,se)}),[...ie.values()]}async M(W,_){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,_,!0,void 0,this.R()),H=await(W&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",H.length),H}async N(W,_){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const q=_?await this.O():{},H=[],X=d.URI.file(u.$kc(u.$mc(h.$3g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of M){const L=q[se.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":H.push((0,f.$jh)(X,se.name));break;default:H.push(d.URI.file(L));break}}const ie=await Promise.all(H.map(async se=>this.n.scanExtension(await this.P(se,!1,i.ExtensionType.System,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ie.length),(0,P.$Jb)(ie)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,_,M,q,H,X,ie,se){const L=await this.f(H??p.$x),V=await this.Q(W),z=_&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=z?await this.Q(z):void 0;return new x(W,V,z,E,_,ie,M,q,X,se.version,se.date,this.C.commit,!this.z.isBuilt,H,L)}async Q(W){try{const _=await this.w.stat(W);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Tq=F,e.$Tq=F=Ee([oe(4,N.$Pl),oe(5,g.$Oq),oe(6,n.$dl),oe(7,t.$dk),oe(8,R.$Pi),oe(9,s.$wk),oe(10,T.$Nl),oe(11,r.$Hi)],F);class x{constructor(W,_,M,q,H,X,ie,se,L,V,z,E,j,Q,J){this.location=W,this.mtime=_,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=q,this.profile=H,this.profileScanOptions=X,this.type=ie,this.excludeObsolete=se,this.validate=L,this.productVersion=V,this.productDate=z,this.productCommit=E,this.devMode=j,this.language=Q,this.translations=J}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,_){return(0,f.$ch)(W.location,_.location)&&W.mtime===_.mtime&&(0,f.$ch)(W.applicationExtensionslocation,_.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&W.profile===_.profile&&v.$lo(W.profileScanOptions,_.profileScanOptions)&&W.type===_.type&&W.excludeObsolete===_.excludeObsolete&&W.validate===_.validate&&W.productVersion===_.productVersion&&W.productDate===_.productDate&&W.productCommit===_.productCommit&&W.devMode===_.devMode&&W.language===_.language&&D.equals(W.translations,_.translations)}}e.$Uq=x;let Y=class extends l.$Xc{constructor(W,_,M,q,H,X,ie){super(),this.g=W,this.h=_,this.j=M,this.m=q,this.n=X,this.r=ie,this.f=H.extensionsEnabledWithApiProposalVersion?.map(se=>se.toLowerCase())??[]}async scanExtensions(W){const _=W.profile?await this.t(W):await this.s(W);let M={};if(W.excludeObsolete&&W.type===i.ExtensionType.User)try{const q=(await this.m.readFile(this.g)).value.toString();M=JSON.parse(q)}catch{}return(0,b.$ug)(M)?_:_.filter(q=>!M[y.$Qp.create(q).toString()])}async s(W){const _=await this.m.resolve(W.location);if(!_.children?.length)return[];const M=await Promise.all(_.children.map(async q=>{if(!q.isDirectory||W.type===i.ExtensionType.User&&(0,f.$gh)(q.resource).indexOf(".")===0)return null;const H=new x(q.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(H)}));return(0,P.$Jb)(M).sort((q,H)=>q.location.path<H.location.path?-1:1)}async t(W){let _=await this.u(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.j.extUri.isEqual(W.location,W.applicationExtensionslocation)){_=_.filter(q=>!q.metadata?.isApplicationScoped);const M=await this.u(W.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,W);_.push(...M)}return _}async u(W,_,M){const q=await this.h.scanProfileExtensions(W,M.profileScanOptions);if(!q.length)return[];const H=await Promise.all(q.map(async X=>{if(_(X)){const ie=new x(X.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(ie,X.metadata)}return null}));return(0,P.$Jb)(H)}async scanOneOrMultipleExtensions(W){try{if(await this.m.exists((0,f.$jh)(W.location,"package.json"))){const _=await this.scanExtension(W);return _?[_]:[]}else return await this.scanExtensions(W)}catch(_){return this.r.error(`Error scanning extensions at ${W.location.path}:`,(0,C.$_)(_)),[]}}async scanExtension(W,_){try{let M=await this.w(W.location);if(M){M.publisher||(M.publisher=i.$qn),_=_??M.__metadata,delete M.__metadata;const q=(0,y.$Up)(M.publisher,M.name),H=_?.id?{id:q,uuid:_.id}:{id:q},X=_?.isSystem?i.ExtensionType.System:W.type,ie=X===i.ExtensionType.System||!!_?.isBuiltin;M=await this.y(W.location,M,x.createNlsConfiguration(W));let se={type:X,identifier:H,manifest:M,location:W.location,isBuiltin:ie,targetPlatform:_?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return W.validate&&(se=this.validate(se,W)),M.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(q.toLowerCase()))&&(M.originalEnabledApiProposals=M.enabledApiProposals,M.enabledApiProposals=(0,i.$Cn)([...M.enabledApiProposals])),se}}catch(M){W.type!==i.ExtensionType.System&&this.r.error(M)}return null}validate(W,_){let M=!0;const q=this.n.isBuilt&&this.f.includes(W.identifier.id.toLowerCase()),H=(0,a.$7p)(_.productVersion,_.productDate,_.location,W.manifest,W.isBuiltin,q);for(const[X,ie]of H)X===k.default.Error&&(M=!1,this.r.error(this.F(_.location,ie)));return W.isValid=M,W.validations=H,W}async w(W){const _=(0,f.$jh)(W,"package.json");let M;try{M=(await this.m.readFile(_)).value.toString()}catch(H){return(0,n.$ul)(H)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(W,(0,$.localize)(1813,null,_.path,H.message))),null}let q;try{q=JSON.parse(M)}catch{const X=[];(0,O.$2n)(M,X);for(const ie of X)this.r.error(this.F(W,(0,$.localize)(1814,null,_.path,ie.offset,ie.length,(0,w.$Qq)(ie.error))));return null}return(0,O.$0n)(q)!=="object"?(this.r.error(this.F(W,(0,$.localize)(1815,null,_.path))),null):q}async y(W,_,M){const q=await this.z(W,_,M);if(q)try{const H=[],X=await this.C(q.default,H);if(H.length>0)return H.forEach(se=>{this.r.error(this.F(W,(0,$.localize)(1816,null,q.default?.path,(0,w.$Qq)(se.error))))}),_;if((0,O.$0n)(q)!=="object")return this.r.error(this.F(W,(0,$.localize)(1817,null,q.default?.path))),_;const ie=q.values||Object.create(null);return(0,A.$Rq)(this.r,_,ie,X)}catch{}return _}async z(W,_,M){const q=(0,f.$jh)(W,"package.nls.json"),H=(L,V)=>{V.forEach(z=>{this.r.error(this.F(W,(0,$.localize)(1818,null,L?.path,(0,w.$Qq)(z.error))))})},X=L=>{this.r.error(this.F(W,(0,$.localize)(1819,null,L?.path)))},ie=`${_.publisher}.${_.name}`,se=M.translations[ie];if(se)try{const L=d.URI.file(se),V=(await this.m.readFile(L)).value.toString(),z=[],E=(0,O.$2n)(V,z);return z.length>0?(H(L,z),{values:void 0,default:q}):(0,O.$0n)(E)!=="object"?(X(L),{values:void 0,default:q}):{values:E.contents?E.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.m.exists(q))return;let V;try{V=await this.D(W,M)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const z=(await this.m.readFile(V.localized)).value.toString(),E=[],j=(0,O.$2n)(z,E);return E.length>0?(H(V.localized,E),{values:void 0,default:V.original}):(0,O.$0n)(j)!=="object"?(X(V.localized),{values:void 0,default:V.original}):{values:j,default:V.original}}catch{return{values:void 0,default:V.original}}}}async C(W,_){if(W)try{const M=(await this.m.readFile(W)).value.toString();return(0,O.$2n)(M,_)}catch{}}D(W,_){return new Promise((M,q)=>{const H=X=>{const ie=(0,f.$jh)(W,`package.nls.${X}.json`);this.m.exists(ie).then(se=>{se&&M({localized:ie,original:(0,f.$jh)(W,"package.nls.json")});const L=X.lastIndexOf("-");L===-1?M({localized:(0,f.$jh)(W,"package.nls.json"),original:null}):(X=X.substring(0,L),H(X))})};if(_.devMode||_.pseudo||!_.language)return M({localized:(0,f.$jh)(W,"package.nls.json"),original:null});H(_.language)})}F(W,_){return`[${W.path}]: ${_}`}};Y=Ee([oe(1,g.$Oq),oe(2,T.$Nl),oe(3,n.$dl),oe(4,s.$wk),oe(5,R.$Pi),oe(6,t.$dk)],Y);let ne=class extends Y{constructor(W,_,M,q,H,X,ie,se,L){super(_,q,H,X,ie,se,L),this.J=W,this.L=M,this.H=this.B(new S.$Gh(3e3)),this.I=this.B(new o.$oe),this.onDidChangeCache=this.I.event}async scanExtensions(W){const _=this.P(W),M=await this.M(_);if(this.G=W,M&&M.input&&x.equals(M.input,this.G))return this.r.debug("Using cached extensions scan result",W.type===i.ExtensionType.System?"system":"user",W.location.toString()),this.H.trigger(()=>this.O()),M.result.map(H=>(H.location=d.URI.revive(H.location),H));const q=await super.scanExtensions(W);return await this.N(_,{input:W,result:q}),q}async M(W){try{const _=await this.m.readFile(W),M=JSON.parse(_.value.toString());return{result:M.result,input:(0,c.$fi)(M.input)}}catch(_){this.r.debug("Error while reading the extension cache file:",W.path,(0,C.$_)(_))}return null}async N(W,_){try{await this.m.writeFile(W,I.$Qe.fromString(JSON.stringify(_)))}catch(M){this.r.debug("Error while writing the extension cache file:",W.path,(0,C.$_)(M))}}async O(){if(!this.G)return;const W=this.P(this.G),_=await this.M(W);if(!_)return;const M=_.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!v.$lo(q,M))try{this.r.info("Invalidating Cache",M,q),await this.m.del(W),this.I.fire()}catch(H){this.r.error(H)}}P(W){const _=this.Q(W);return this.j.extUri.joinPath(_.cacheHome,W.type===i.ExtensionType.System?i.$pn:i.$on)}Q(W){return W.type===i.ExtensionType.System?this.L.defaultProfile:W.profile?this.j.extUri.isEqual(W.location,this.J.extensionsResource)?this.J:this.L.profiles.find(_=>this.j.extUri.isEqual(W.location,_.extensionsResource))??this.J:this.L.defaultProfile}};ne=Ee([oe(2,N.$Pl),oe(3,g.$Oq),oe(4,T.$Nl),oe(5,n.$dl),oe(6,s.$wk),oe(7,R.$Pi),oe(8,t.$dk)],ne);function ae(me,W){const _=(0,y.$Sp)(me.manifest.publisher,me.manifest.name);return{id:_,identifier:new i.$un(_),isBuiltin:me.type===i.ExtensionType.System,isUserBuiltin:me.type===i.ExtensionType.User&&me.isBuiltin,isUnderDevelopment:W,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,publisherDisplayName:me.publisherDisplayName,...me.manifest}}class ue extends F{constructor(W,_,M,q,H,X,ie,se,L,V,z,E){super(W,_,(0,f.$jh)(M,".vscode-oss-dev","extensions","control.json"),q,H,X,ie,se,L,V,z,E),this.S=(async()=>{if(p.$A)try{const j=await this.w.readFile(d.URI.file(p.$A));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$Wq=ue}),define(le[137],he([0,1,61,8,38,4,2,14,15,29,6,24]),function(Z,e,P,S,v,I,C,O,w,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let p=class extends C.$Xc{constructor(m,k){super(),this.b=m,this.f=k,this.a=new S.$Oh(5)}async postUninstall(m){const k=this.g(m,"uninstall");k&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(k.script,"uninstall",k.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(b)}}));try{await l.Promises.rm(this.m(m))}catch(b){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(b)}}g(m,k){const b=`vscode:${k}`;if(m.location.scheme===O.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[b]=="string"){const d=m.manifest.scripts[b].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${b} should be a node script`),null):{script:(0,w.$mc)(m.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(m,k,b,d,$){return new Promise((R,y)=>{const i=this.j(m,k,b,$);let a;const n=r=>{a&&(clearTimeout(a),a=null),r?y(r):R(void 0)};i.on("error",r=>{n((0,v.$tj)(r)||"Unknown")}),i.on("exit",(r,t)=>{n(r?`post-${k} process exited with code ${r}`:void 0)}),d&&(a=setTimeout(()=>{a=null,i.kill(),y("timed out")},5e3))})}j(m,k,b,d){const $={silent:!0,execArgv:void 0},R=(0,P.fork)(m,[`--type=extension-post-${k}`,...b],$);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const y=I.Event.fromNodeEventEmitter(R.stdout,"data"),i=I.Event.fromNodeEventEmitter(R.stderr,"data");this.B(y(r=>this.f.info(d.identifier.id,d.manifest.version,`post-${k}`,r))),this.B(i(r=>this.f.error(d.identifier.id,d.manifest.version,`post-${k}`,r)));const a=I.Event.any(I.Event.map(y,r=>({data:`%c${r}`,format:[""]}),this.q),I.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return I.Event.debounce(a,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),R}m(m){return(0,w.$mc)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};e.$1q=p,e.$1q=p=Ee([oe(0,u.$Pl),oe(1,h.$dk)],p)}),define(le[73],he([0,1,50,5,53,20]),function(Z,e,P,S,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=C,e.$Yq=O;function C(w){let l=I.ExtensionManagementErrorCode.Extract;return w instanceof P.$Gq&&(w.type==="CorruptZip"?l=I.ExtensionManagementErrorCode.CorruptZip:w.type==="Incomplete"&&(l=I.ExtensionManagementErrorCode.IncompleteZip)),(0,v.$Lq)(w,l)}async function O(w){let l;try{l=await(0,P.$Jq)(w,"extension/package.json")}catch(h){throw C(h)}try{return JSON.parse(l.toString("utf8"))}catch{throw new I.$qp((0,S.localize)(1829,null),I.ExtensionManagementErrorCode.Invalid)}}}),define(le[138],he([0,1,8,7,2,14,16,45,3,28,29,50,30,17,53,20,26,73,72,9,6,18]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$,R,y,i){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0,O=be(O);let n=class extends v.$Xc{static{a=this}static{this.c=".sigzip"}constructor(t,s,o,c,g,N,T){super(),this.h=s,this.j=o,this.m=c,this.n=g,this.r=N,this.t=T,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,o,c){await this.g;const g=await this.w(t,s);let N=!1;if(o&&this.u(t)){let T;try{T=await this.y(t)}catch(A){try{await this.delete(g)}catch(D){this.t.error(D)}throw A}try{N=await this.n.verify(t,g.fsPath,T.fsPath,c)}catch(A){if(N=A.code,N===$.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===$.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(g)}catch(D){this.t.error(D)}throw new k.$qp(u.$Fq,k.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(A){this.t.error(A)}}}return{location:g,verificationStatus:N}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,w.$ng)(s)?s:!0}async w(t,s){try{const o=(0,C.$jh)(this.extensionsDownloadDir,this.G(t)),c=await this.C(t,"vsix",async()=>{await this.z(t,o,g=>this.j.download(t,g,s));try{await this.D(o.fsPath,"extension/package.json")}catch(g){try{await this.h.del(o)}catch(N){this.t.warn(`Error while deleting: ${o.path}`,(0,S.$_)(N))}throw g}},2);return c>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:c}),o}catch(o){throw(0,m.$Lq)(o,k.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,C.$jh)(this.extensionsDownloadDir,`.${(0,l.$5g)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(c){try{await this.h.del(s)}catch(g){this.t.warn(`Error while deleting: ${s.path}`,(0,S.$_)(g))}throw c}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),s}catch(s){throw(0,m.$Lq)(s,k.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==I.Schemas.file){await o(s);return}const c=(0,C.$jh)(this.extensionsDownloadDir,`.${(0,l.$5g)()}`);try{await o(c)}catch(g){try{await this.h.del(c)}catch{}throw g}try{await h.Promises.rename(c.fsPath,s.fsPath,2*60*1e3)}catch(g){try{await this.h.del(c)}catch{}let N=!1;try{N=await this.h.exists(s)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,S.$_)(g)}. Deleted the file from downloaded location`,c.path),g}}async C(t,s,o,c){let g=1;for(;;)try{return await o(),g}catch(N){if(g++>c)throw N;this.t.warn(`Failed downloading ${s}. ${(0,S.$_)(N)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,u.$Jq)(t,s)}catch(o){throw(0,d.$Xq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],c=[];for(const T of t.children)if(T.name.endsWith(a.c))c.push(T.resource);else{const A=b.$Qp.parse(T.name);A&&o.push([A,T])}const g=(0,b.$Vp)(o,([T])=>T),N=[];for(const T of g)T.sort((A,D)=>O.rcompare(A[0].version,D[0].version)),s.push(...T.slice(1).map(A=>A[1].resource)),N.push(T[0][1]);N.sort((T,A)=>T.mtime-A.mtime),s.push(...N.slice(0,Math.max(0,N.length-this.f)).map(T=>T.resource)),s.push(...c),await P.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(t){this.t.error(t)}}G(t){return this.f?b.$Qp.create(t).toString().toLowerCase():(0,l.$5g)()}};e.$Zq=n,e.$Zq=n=a=Ee([oe(0,f.$Qi),oe(1,R.$dl),oe(2,k.$op),oe(3,p.$cj),oe(4,$.$yq),oe(5,i.$cm),oe(6,y.$dk)],n)}),define(le[139],he([0,1,32,8,13,21,38,7,4,43,2,25,14,15,16,45,3,11,28,29,50,5,62,17,53,20,26,42,54,138,137,73,119,126,22,44,9,10,6,33,18,23,24]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$,R,y,i,a,n,r,t,s,o,c,g,N,T,A,D,F,x,Y,ne,ae,ue,me,W,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0,P=be(P),f=be(f),k=be(k),R=be(R),i=be(i),e.$4q=(0,ne.$Ji)(t.$rp);const M=".vsctmp";let q=class extends r.$Kq{constructor(L,V,z,E,j,Q,J,G,U,K,re,ce){super(L,V,re,z,K,ce),this.db=j,this.eb=Q,this.fb=J,this.gb=G,this.hb=U,this.cb=new Map,this.sb=new u.$Ec;const fe=this.B(G.createInstance(N.$1q));this.$=this.B(G.createInstance(H,de=>fe.postUninstall(de))),this.ab=this.B(new A.$2q(ce,U,re,this,this.F)),this.bb=this.B(G.createInstance(g.$Zq));const we=this.B(new D.$3q(this,this.db,ce,Q,re,U,z));this.B(we.onDidChangeExtensionsByAnotherSource(de=>this.rb(de))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$1p)(this.hb,this.F)),this.ib}async zip(L){this.F.trace("ExtensionManagementService#zip",L.identifier.id);const V=await this.qb(L),z=await(0,y.zip)((0,m.$jh)(this.bb.extensionsDownloadDir,(0,$.$5g)()).fsPath,V);return d.URI.file(z)}async getManifest(L){const{location:V,cleanup:z}=await this.kb(L),E=f.$nc(V.fsPath);try{return await(0,T.$Yq)(E)}finally{await z()}}getInstalled(L,V=this.H.defaultProfile.extensionsResource,z={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(L??null,V,z)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(L){return this.$.scanUserExtensionAtLocation(L)}async install(L,V={}){this.F.trace("ExtensionManagementService#install",L.toString());const{location:z,cleanup:E}=await this.kb(L);try{const j=await(0,T.$Yq)(f.$nc(z.fsPath)),Q=(0,s.$Up)(j.publisher,j.name);if(j.engines&&j.engines.vscode&&!(0,x.$9p)(j.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(1820,null,Q,this.G.version));const G=(await this.I([{manifest:j,extension:z,options:V}])).find(({identifier:U})=>(0,s.$Pp)(U,{id:Q}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Lq)(new Error(`Unknown error while installing extension ${Q}`))}finally{await E()}}async installFromLocation(L,V){this.F.trace("ExtensionManagementService#installFromLocation",L.toString());const z=await this.$.scanUserExtensionAtLocation(L);if(!z||!z.manifest.name||!z.manifest.version)throw new Error(`Cannot find a valid extension from the location ${L.toString()}`);return await this.vb([[z,{source:"resource"}]],V),this.F.info("Successfully installed extension",z.identifier.id,V.toString()),z}async installExtensionsFromProfile(L,V,z){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",L,V.toString(),z.toString());const E=(await this.getInstalled(F.ExtensionType.User,V)).filter(j=>L.some(Q=>(0,s.$Pp)(Q,j.identifier)));if(E.length){const j=await Promise.all(E.map(Q=>this.$.scanMetadata(Q,V)));await this.vb(E.map((Q,J)=>[Q,j[J]]),z),this.F.info("Successfully installed extensions",E.map(Q=>Q.identifier.id),z.toString())}return E}async updateMetadata(L,V,z){return this.F.trace("ExtensionManagementService#updateMetadata",L.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0,V.hasPreReleaseVersion=!0),V.isMachineScoped===!1&&(V.isMachineScoped=void 0),V.isBuiltin===!1&&(V.isBuiltin=void 0),V.pinned===!1&&(V.pinned=void 0),L=await this.$.updateMetadata(L,V,z),this.ab.invalidate(z),this.w.fire({local:L,profileLocation:z}),L}async reinstallFromGallery(L){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",L.identifier.id),!this.z.isEnabled())throw new Error(i.localize(1821,null));const V=await this.getTargetPlatform(),[z]=await this.z.getExtensions([{...L.identifier,preRelease:L.preRelease}],{targetPlatform:V,compatible:!0},I.CancellationToken.None);if(!z)throw new Error(i.localize(1822,null));await this.$.setUninstalled(L);try{await this.$.removeUninstalledExtension(L)}catch(E){throw new Error(i.localize(1823,null,(0,C.$tj)(E)))}return this.installFromGallery(z)}Z(L,V,z,E){return this.$.copyExtension(L,V,z,E)}copyExtensions(L,V){return this.$.copyExtensions(L,V,{version:this.G.version,date:this.G.date})}markAsUninstalled(...L){return this.$.setUninstalled(...L)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(L){this.F.error(L)}}async download(L,V,z){const{location:E}=await this.bb.download(L,V,!z);return E}async kb(L){if(L.scheme===p.Schemas.file)return{location:L,async cleanup(){}};this.F.trace("Downloading extension from",L.toString());const V=(0,m.$jh)(this.bb.extensionsDownloadDir,(0,$.$5g)());return await this.fb.download(L,V),this.F.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.hb.del(V)}catch(E){this.F.error(E)}}}}W(){return this.H.defaultProfile.extensionsResource}X(L,V,z){const E=V instanceof d.URI?new s.$Qp({id:(0,s.$Up)(L.publisher,L.name)},L.version):s.$Qp.create(V);return this.gb.createInstance(X,E,L,V,z,(j,Q)=>{if(V instanceof d.URI)return this.pb(E,V,z,Q);let J=this.cb.get(E.toString());return J||(this.cb.set(E.toString(),J=this.ob(E,V,j,z,Q)),J.finally(()=>this.cb.delete(E.toString()))),J},this.$)}Y(L,V){return new ie(L,V,this.eb)}async ob(L,V,z,E,j){const{verificationStatus:Q,location:J}=await this.bb.download(V,z,!E.donotVerifySignature,E.context?.[t.$hp]);try{if(j.isCancellationRequested)throw new O.$7;const G=await(0,T.$Yq)(J.fsPath);if(!new s.$Qp(V.identifier,V.version).equals(new s.$Qp({id:(0,s.$Up)(G.publisher,G.name)},G.version)))throw new t.$qp(i.localize(1824,null,V.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(L,J.fsPath,{id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName,targetPlatform:V.properties.targetPlatform,isApplicationScoped:E.isApplicationScoped,isMachineScoped:E.isMachineScoped,isBuiltin:E.isBuiltin,isPreReleaseVersion:V.properties.isPreReleaseVersion,hasPreReleaseVersion:V.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:E.installGivenVersion?!0:!!E.pinned,preRelease:(0,b.$ng)(E.preRelease)?E.preRelease:E.installPreReleaseVersion||V.properties.isPreReleaseVersion,source:"gallery"},!1,j),verificationStatus:Q}}catch(G){try{await this.bb.delete(J)}catch(U){this.F.warn("Error while deleting the downloaded file",J.toString(),(0,O.$_)(U))}throw(0,r.$Lq)(G)}}async pb(L,V,z,E){return{local:await this.$.extractUserExtension(L,f.$nc(V.fsPath),{isApplicationScoped:z.isApplicationScoped,isMachineScoped:z.isMachineScoped,isBuiltin:z.isBuiltin,installedTimestamp:Date.now(),pinned:z.installGivenVersion?!0:!!z.pinned,source:"vsix"},z.keepExisting??!0,E)}}async qb(L){const V=async E=>{let j=await R.Promises.readdir(E);j=j.map(G=>f.$mc(E,G));const Q=await Promise.all(j.map(G=>P.promises.stat(G)));let J=Promise.resolve([]);return Q.forEach((G,U)=>{const K=j[U];G.isFile()&&(J=J.then(re=>[...re,K])),G.isDirectory()&&(J=J.then(re=>V(K).then(ce=>[...re,...ce])))}),J};return(await V(L.location.fsPath)).map(E=>({path:`extension/${f.$oc(L.location.fsPath,E)}`,localPath:E}))}async rb({added:L,removed:V}){if(V){const z=L&&this.D.extUri.isEqual(V.profileLocation,L.profileLocation)?V.extensions.filter(E=>L.extensions.every(j=>!(0,s.$Pp)(j,E))):V.extensions;for(const E of z)this.F.info("Extensions removed from another source",E.id,V.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:V.profileLocation})}if(L){const E=(await this.getInstalled(F.ExtensionType.User,L.profileLocation)).filter(j=>L.extensions.some(Q=>(0,s.$Pp)(Q,j.identifier)));this.s.fire(E.map(j=>(this.F.info("Extensions added from another source",j.identifier.id,L.profileLocation.toString()),{identifier:j.identifier,local:j,profileLocation:L.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(V=>this.sb.add(V)));const L=await this.hb.resolve(this.db.userExtensionsLocation);for(const V of L.children??[])V.isDirectory&&this.sb.add(V.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(V=>this.ub(V)))}async ub(L){if(!L.affects(this.db.userExtensionsLocation,Y.FileChangeType.ADDED))return;const V=[];for(const z of L.rawAdded){if(this.sb.has(z)||!this.D.extUri.isEqual(this.D.extUri.dirname(z),this.db.userExtensionsLocation)||this.D.extUri.isEqual(z,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(z).startsWith(".")||!(await this.hb.stat(z)).isDirectory)continue;const E=await this.$.scanUserExtensionAtLocation(z);E&&E.installedTimestamp===void 0&&(this.sb.add(z),V.push(E))}V.length&&(await this.vb(V.map(z=>[z,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",V.map(z=>z.identifier.id)))}async vb(L,V){const z=L.map(E=>E[0]);await this.wb(z),await this.eb.addExtensionsToProfile(L,V),this.s.fire(z.map(E=>({local:E,identifier:E.identifier,operation:t.InstallOperation.None,profileLocation:V})))}async wb(L){const V=await this.$.getUninstalledExtensions();for(const z of L){const E=s.$Qp.create(z);V[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.$.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$5q=q,e.$5q=q=Ee([oe(0,t.$op),oe(1,me.$cm),oe(2,ae.$dk),oe(3,n.$Qi),oe(4,c.$Sq),oe(5,o.$Oq),oe(6,a.$5o),oe(7,ne.$Hi),oe(8,Y.$dl),oe(9,ue.$wk),oe(10,W.$Nl),oe(11,_.$Pl)],q);let H=class extends h.$Xc{constructor(L,V,z,E,j,Q,J){super(),this.n=L,this.s=V,this.t=z,this.u=E,this.w=j,this.y=Q,this.z=J,this.h=this.B(new w.$oe),this.onExtract=this.h.event,this.j=new u.$Dc,this.m=new u.$Dc,this.c=(0,m.$jh)(this.t.userExtensionsLocation,".obsolete"),this.g=new S.$Ph}async cleanUp(){await this.J(),await this.I()}async scanExtensions(L,V,z){try{const E={includeInvalid:!0,profileLocation:V,productVersion:z};let j=[];if(L===null||L===F.ExtensionType.System){let Q=this.j.get(V);Q||(Q=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},E,!1).finally(()=>this.j.delete(V)),this.j.set(V,Q)),j.push(...await Q)}else if(L===F.ExtensionType.User){let Q=this.m.get(V);Q||(Q=this.t.scanUserExtensions(E).finally(()=>this.m.delete(V)),this.m.set(V,Q)),j.push(...await Q)}return j=L!==null?j.filter(Q=>Q.type===L):j,await Promise.all(j.map(Q=>this.H(Q)))}catch(E){throw(0,r.$Lq)(E,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(L){try{const V=await this.t.scanUserExtensions({includeAllVersions:!L,includeInvalid:!0});return await Promise.all(V.map(z=>this.H(z)))}catch(V){throw(0,r.$Lq)(V,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(L){try{const V=await this.t.scanExistingExtension(L,F.ExtensionType.User,{includeInvalid:!0});if(V)return await this.H(V)}catch(V){this.z.error(V)}return null}async extractUserExtension(L,V,z,E,j){const Q=L.toString(),J=d.URI.file(f.$mc(this.t.userExtensionsLocation.fsPath,`.${(0,$.$5g)()}`)),G=d.URI.file(f.$mc(this.t.userExtensionsLocation.fsPath,Q));if(await this.s.exists(G)){if(!E)try{return await this.scanLocalExtension(G,F.ExtensionType.User)}catch(U){this.z.warn(`Error while scanning the existing extension at ${G.path}. Deleting the existing extension and extracting it.`,(0,O.$_)(U))}try{await this.D(L.id,G,"removeExisting")}catch{throw new t.$qp(i.localize(1825,null,G.fsPath,L.id),t.ExtensionManagementErrorCode.Delete)}}try{if(j.isCancellationRequested)throw new O.$7;try{this.z.trace(`Started extracting the extension from ${V} to ${G.fsPath}`),await(0,y.$Iq)(V,J.fsPath,{sourcePath:"extension",overwrite:!0},j),this.z.info(`Extracted extension to ${G}:`,L.id)}catch(U){throw(0,T.$Xq)(U)}try{await this.t.updateMetadata(J,z)}catch(U){throw this.y.publicLog2("extension:extract",{extensionId:L.id,code:`${(0,Y.$ul)(U)}`}),(0,r.$Lq)(U,t.ExtensionManagementErrorCode.UpdateMetadata)}if(j.isCancellationRequested)throw new O.$7;try{this.z.trace(`Started renaming the extension from ${J.fsPath} to ${G.fsPath}`),await this.G(J.fsPath,G.fsPath),this.z.info("Renamed to",G.fsPath)}catch(U){if(U.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",L.id);try{await this.s.del(J,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$_)(U)}. Deleted from extracted location`,J),U}this.h.fire(G)}catch(U){try{await this.s.del(J,{recursive:!0})}catch{}throw U}return this.scanLocalExtension(G,F.ExtensionType.User)}async scanMetadata(L,V){return V?(await this.C(L,V))?.metadata:this.t.scanMetadata(L.location)}async C(L,V){return(await this.u.scanProfileExtensions(V)).find(E=>(0,s.$Pp)(E.identifier,L.identifier))}async updateMetadata(L,V,z){try{z?await this.u.updateMetadata([[L,V]],z):await this.t.updateMetadata(L.location,V)}catch(E){throw this.y.publicLog2("extension:extract",{extensionId:L.identifier.id,code:`${(0,Y.$ul)(E)}`,isProfile:!!z}),(0,r.$Lq)(E,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(L.location,L.type,z)}async getUninstalledExtensions(){try{return await this.F()}catch(L){throw(0,r.$Lq)(L,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...L){const V=L.map(z=>s.$Qp.create(z));await this.F(z=>V.forEach(E=>{z[E.toString()]=!0,this.z.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(L){try{await this.F(V=>delete V[L.toString()])}catch(V){throw(0,r.$Lq)(V,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(L,V){if(this.w.extUri.isEqualOrParent(L.location,this.t.userExtensionsLocation))return this.D(L.identifier.id,L.location,V)}async removeUninstalledExtension(L){await this.removeExtension(L,"uninstalled"),await this.F(V=>delete V[s.$Qp.create(L).toString()])}async copyExtension(L,V,z,E){const j=await this.C(L,V),Q=await this.C(L,z);if(E={...j?.metadata,...E},Q)if(this.w.extUri.isEqual(Q.location,L.location))await this.u.updateMetadata([[L,{...Q.metadata,...E}]],z);else{const J=await this.scanLocalExtension(Q.location,L.type,z);await this.u.removeExtensionFromProfile(J,z),await this.u.addExtensionsToProfile([[L,{...Q.metadata,...E}]],z)}else await this.u.addExtensionsToProfile([[L,E]],z);return this.scanLocalExtension(L.location,L.type,z)}async copyExtensions(L,V,z){const E=await this.scanExtensions(F.ExtensionType.User,L,z),j=await Promise.all(E.filter(Q=>!Q.isApplicationScoped).map(async Q=>[Q,await this.scanMetadata(Q,L)]));await this.u.addExtensionsToProfile(j,V)}async D(L,V,z){this.z.trace(`Deleting ${z} extension from disk`,L,V.fsPath);const E=this.w.extUri.joinPath(this.w.extUri.dirname(V),`${this.w.extUri.basename(V)}.${(0,l.$wj)((0,$.$5g)()).toString(16)}${M}`);await this.G(V.fsPath,E.fsPath),await this.s.del(E,{recursive:!0}),this.z.info(`Deleted ${z} extension from disk`,L,V.fsPath)}F(L){return this.g.queue(async()=>{let V;try{V=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,Y.$ul)(E)!==Y.FileOperationResult.FILE_NOT_FOUND)throw E}let z={};if(V)try{z=JSON.parse(V)}catch{}return L&&(L(z),Object.keys(z).length?await this.s.writeFile(this.c,v.$Qe.fromString(JSON.stringify(z))):await this.s.del(this.c)),z})}async G(L,V){try{await R.Promises.rename(L,V,2*60*1e3)}catch(z){throw(0,r.$Lq)(z,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(L,V,z){try{if(z){const j=(await this.t.scanUserExtensions({profileLocation:z})).find(Q=>this.w.extUri.isEqual(Q.location,L));if(j)return await this.H(j)}else{const E=await this.t.scanExistingExtension(L,V,{includeInvalid:!0});if(E)return await this.H(E)}throw new t.$qp(i.localize(1826,null,L.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(E){throw(0,r.$Lq)(E,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(L){const V=await this.s.resolve(L.location);let z,E;return V.children&&(z=V.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,E=V.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:L.identifier,type:L.type,isBuiltin:L.isBuiltin||!!L.metadata?.isBuiltin,location:L.location,manifest:L.manifest,targetPlatform:L.targetPlatform,validations:L.validations,isValid:L.isValid,readmeUrl:z,changelogUrl:E,publisherDisplayName:L.metadata?.publisherDisplayName,publisherId:L.metadata?.publisherId||null,isApplicationScoped:!!L.metadata?.isApplicationScoped,isMachineScoped:!!L.metadata?.isMachineScoped,isPreReleaseVersion:!!L.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!L.metadata?.hasPreReleaseVersion,preRelease:!!L.metadata?.preRelease,installedTimestamp:L.metadata?.installedTimestamp,updated:!!L.metadata?.updated,pinned:!!L.metadata?.pinned,isWorkspaceScoped:!1,source:L.metadata?.source??(L.identifier.uuid?"gallery":"vsix")}}async I(){const L=await this.getUninstalledExtensions();if(Object.keys(L).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(L));const V=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),z=new Set;for(const j of V)L[s.$Qp.create(j).toString()]||z.add(j.identifier.id.toLowerCase());try{const j=(0,s.$Vp)(V,Q=>Q.identifier);await S.Promises.settled(j.map(async Q=>{const J=Q.sort((G,U)=>k.rcompare(G.manifest.version,U.manifest.version))[0];z.has(J.identifier.id.toLowerCase())||await this.n(await this.H(J))}))}catch(j){this.z.error(j)}const E=V.filter(j=>j.metadata&&L[s.$Qp.create(j).toString()]);await Promise.allSettled(E.map(j=>this.removeUninstalledExtension(j)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let L;try{L=await this.s.resolve(this.t.userExtensionsLocation)}catch(V){(0,Y.$ul)(V)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(V);return}if(L?.children)try{await Promise.allSettled(L.children.map(async V=>{if(!(!V.isDirectory||!V.name.endsWith(M))){this.z.trace("Deleting the temporarily deleted folder",V.resource.toString());try{await this.s.del(V.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",V.resource.toString())}catch(z){(0,Y.$ul)(z)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(z)}}}))}catch{}}};e.$6q=H,e.$6q=H=Ee([oe(1,Y.$dl),oe(2,c.$Sq),oe(3,o.$Oq),oe(4,W.$Nl),oe(5,me.$cm),oe(6,ae.$dk)],H);let X=class extends r.$Mq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(L,V,z,E,j,Q,J,G,U,K,re,ce){super(),this.l=L,this.manifest=V,this.source=z,this.options=E,this.m=j,this.n=Q,this.o=J,this.p=G,this.q=U,this.s=K,this.t=re,this.u=ce,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(L){const z=(await this.n.scanExtensions(F.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(J=>(0,s.$Pp)(J.identifier,this.identifier));z&&(this.j=t.InstallOperation.Update);const E={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===F.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof d.URI?"vsix":"gallery"};let j;if(this.source instanceof d.URI){if(z&&this.l.equals(new s.$Qp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(i.localize(1827,null,this.manifest.displayName||this.manifest.name))}const J=await this.w(this.l);if(J)try{await this.n.removeExtension(J,"existing")}catch{throw new Error(i.localize(1828,null,this.manifest.displayName||this.manifest.name))}}else{if(E.id=this.source.identifier.uuid,E.publisherId=this.source.publisherId,E.publisherDisplayName=this.source.publisherDisplayName,E.targetPlatform=this.source.properties.targetPlatform,E.updated=!!z,E.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,E.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,E.preRelease=(0,b.$ng)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==F.ExtensionType.System&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,E,this.options.profileLocation);j=await this.w(this.l)}if(L.isCancellationRequested)throw(0,r.$Lq)(new O.$7);if(!j){const J=await this.m(this.operation,L);j=J.local,this.k=J.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(J){throw(0,r.$Lq)(J,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(L.isCancellationRequested)throw(0,r.$Lq)(new O.$7);try{await this.t.addExtensionsToProfile([[j,E]],this.options.profileLocation,!j.isValid)}catch(J){throw(0,r.$Lq)(J,t.ExtensionManagementErrorCode.AddToProfile)}const Q=await this.n.scanLocalExtension(j.location,F.ExtensionType.User,this.options.profileLocation);if(!Q)throw new t.$qp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof d.URI&&this.x(j,L),Q}async w(L){return(await this.n.getUninstalledExtensions())[L.toString()]?(this.u.trace("Removing the extension from uninstalled list:",L.id),await this.n.setInstalled(L),this.u.info("Removed the extension from uninstalled list:",L.id),(await this.n.scanAllUserExtensions(!0)).find(E=>s.$Qp.create(E).equals(L))):void 0}async x(L,V){try{let[z]=await this.p.getExtensions([{id:L.identifier.id,version:L.manifest.version}],V);if(z||([z]=await this.p.getExtensions([{id:L.identifier.id}],V)),z){const E={id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:L.hasPreReleaseVersion||z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(L,E,this.options.profileLocation)}}catch{}}};X=Ee([oe(6,W.$Nl),oe(7,t.$op),oe(8,_.$Pl),oe(9,c.$Sq),oe(10,o.$Oq),oe(11,ae.$dk)],X);class ie extends r.$Mq{constructor(L,V,z){super(),this.extension=L,this.options=V,this.j=z}async h(L){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(le[140],he([0,1,6,24,23,18,42,9,17,11]),function(Z,e,P,S,v,I,C,O,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=void 0;let h=class extends C.$Pq{constructor(p,f,m,k,b,d){super(l.URI.file(p.extensionsPath),f,m,k,b,d)}};e.$3R=h,e.$3R=h=Ee([oe(0,w.$Qi),oe(1,O.$dl),oe(2,S.$Pl),oe(3,v.$Nl),oe(4,I.$cm),oe(5,P.$dk)],h)}),define(le[141],he([0,1,11,17,42,54,9,10,6,33,23,24]),function(Z,e,P,S,v,I,C,O,w,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;let p=class extends I.$Wq{constructor(m,k,b,d,$,R,y,i){super(P.URI.file($.builtinExtensionsPath),P.URI.file($.extensionsPath),$.userHome,m.defaultProfile,m,k,b,d,$,R,y,i)}};e.$oic=p,e.$oic=p=Ee([oe(0,u.$Pl),oe(1,v.$Oq),oe(2,C.$dl),oe(3,w.$dk),oe(4,S.$Qi),oe(5,l.$wk),oe(6,h.$Nl),oe(7,O.$Hi)],p)}),define(le[74],he([0,1,8,4,2,109,3,89,10,24]),function(Z,e,P,S,v,I,C,O,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$nq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$lq=e.$kq=e.$jq=void 0,e.$mq=f,e.$oq=k,e.$qq=d,e.$jq="__$__isNewStorageMarker",e.$kq="__$__targetStorageMarker",e.$lq=(0,w.$Ii)("storageService");var h;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var u;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var p;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function f($){const R=$.get(e.$kq);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class m extends v.$Xc{static{this.a=60*1e3}constructor(R={flushInterval:m.a}){super(),this.m=R,this.b=this.B(new S.$re),this.c=this.B(new S.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new S.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(R,y,i){return S.Event.filter(this.b.event,a=>a.scope===R&&(y===void 0||a.key===y),i)}n(){this.j.value=(0,P.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(R,y){const{key:i,external:a}=y;if(i===e.$kq){switch(R){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:R})}else this.b.fire({scope:R,key:i,target:this.J(R)[i],external:a})}w(R){this.f.fire({reason:R})}get(R,y,i){return this.P(y)?.get(R,i)}getBoolean(R,y,i){return this.P(y)?.getBoolean(R,i)}getNumber(R,y,i){return this.P(y)?.getNumber(R,i)}getObject(R,y,i){return this.P(y)?.getObject(R,i)}storeAll(R,y){this.y(()=>{for(const i of R)this.store(i.key,i.value,i.scope,i.target,y)})}store(R,y,i,a,n=!1){if((0,C.$qg)(y)){this.remove(R,i,n);return}this.y(()=>{this.z(R,i,a),this.P(i)?.set(R,y,n)})}remove(R,y,i=!1){this.y(()=>{this.z(R,y,void 0),this.P(y)?.delete(R,i)})}y(R){this.b.pause(),this.c.pause();try{R()}finally{this.b.resume(),this.c.resume()}}keys(R,y){const i=[],a=this.J(R);for(const n of Object.keys(a))a[n]===y&&i.push(n);return i}z(R,y,i,a=!1){const n=this.J(y);typeof i=="number"?n[R]!==i&&(n[R]=i,this.P(y)?.set(e.$kq,JSON.stringify(n),a)):typeof n[R]=="number"&&(delete n[R],this.P(y)?.set(e.$kq,JSON.stringify(n),a))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(R){switch(R){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(R){const y=this.P(R);return y?f(y):Object.create(null)}isNew(R){return this.getBoolean(e.$jq,R)===!0}async flush(R=h.NONE){this.f.fire({reason:R});const y=this.P(u.APPLICATION),i=this.P(u.PROFILE),a=this.P(u.WORKSPACE);switch(R){case h.NONE:await P.Promises.settled([y?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await P.Promises.settled([y?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.P(u.APPLICATION)?.items??new Map,y=this.P(u.PROFILE)?.items??new Map,i=this.P(u.WORKSPACE)?.items??new Map;return d(R,y,i,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.P(R)?.optimize()}async switch(R,y){return this.w(h.NONE),(0,l.$Ol)(R)?this.R(R,y):this.S(R,y)}M(R,y){return!(R.id===y.id||k(y)&&k(R))}N(R,y,i){this.y(()=>{const a=new Set;for(const[n,r]of R)a.add(n),y.get(n)!==r&&this.u(i,{key:n,external:!0});for(const[n]of y.items)a.has(n)||this.u(i,{key:n,external:!0})})}}e.$nq=m;function k($){return $.isDefault||!!$.useDefaultFlags?.globalState}class b extends m{constructor(){super(),this.U=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(R=>this.u(u.WORKSPACE,R))),this.B(this.W.onDidChangeStorage(R=>this.u(u.PROFILE,R))),this.B(this.U.onDidChangeStorage(R=>this.u(u.APPLICATION,R)))}P(R){switch(R){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(R){switch(R){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(R){return!1}}e.$pq=b;async function d($,R,y,i,a,n){const r=D=>{try{return JSON.parse(D)}catch{return D}},t=new Map,s=new Map;$.forEach((D,F)=>{t.set(F,D),s.set(F,r(D))});const o=new Map,c=new Map;R.forEach((D,F)=>{o.set(F,D),c.set(F,r(D))});const g=new Map,N=new Map;y.forEach((D,F)=>{g.set(F,D),N.set(F,r(D))}),console.group(i!==a?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(t.forEach((D,F)=>{T.push({key:F,value:D})}),console.table(T),console.groupEnd(),console.log(s),i!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const D=[];o.forEach((F,x)=>{D.push({key:x,value:F})}),console.table(D),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${n})`);const A=[];g.forEach((D,F)=>{A.push({key:F,value:D})}),console.table(A),console.groupEnd(),console.log(N)}}),define(le[142],he([0,1,13,28,74]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=I;async function I(C,O,w){let l=w&&w.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(l)return l;try{const u=(await O.readFile(C.serviceMachineIdResource)).value.toString();l=(0,S.$4g)(u)?u:null}catch{l=null}if(!l){l=(0,S.$5g)();try{await O.writeFile(C.serviceMachineIdResource,P.$Qe.fromString(l))}catch{}}return w?.store("storage.serviceMachineId",l,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),l}}),define(le[143],he([0,1,142,18,41]),function(Z,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=I;async function I(C,O,w,l,h,u,p){const f={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${O.nameShort})`};if((0,v.$Hp)(O,w)&&(0,v.$Jp)(l)===S.TelemetryLevel.USAGE){const m=await(0,P.$rq)(w,h,u);f["X-Market-User-Id"]=m,f["VSCode-SessionId"]=p.machineId||m}return f}}),define(le[144],he([0,1,19,21,7,12,36,3,11,88,30,17,20,26,22,44,9,6,33,46,143,74,18,156]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$,R,y,i,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=void 0,e.$tq=V;const r=I.$p?m.TargetPlatform.WEB:(0,p.$kp)(I.$v,C.$hc),t="X-Market-Search-Activity-Id";var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished",G[G.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function o(...G){return String(G.reduce((U,K)=>U|K,0))}var c;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const g={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},N={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},A={pageNumber:1,pageSize:10,sortBy:p.SortBy.NoneOrRelevance,sortOrder:p.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class D{constructor(U=A){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,K=this.d.pageSize){return new D({...this.d,pageNumber:U,pageSize:K})}withFilter(U,...K){const re=[...this.d.criteria,...K.length?K.map(ce=>({filterType:U,value:ce})):[{filterType:U}]];return new D({...this.d,criteria:re})}withSortBy(U){return new D({...this.d,sortBy:U})}withSortOrder(U){return new D({...this.d,sortOrder:U})}withFlags(...U){return new D({...this.d,flags:U.reduce((K,re)=>K|re,0)})}withAssetTypes(...U){return new D({...this.d,assetTypes:U})}withSource(U){return new D({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:K,pageSize:re,sortBy:ce,sortOrder:fe,flags:we,assetTypes:de}=this.d;return{filters:[{criteria:U,pageNumber:K,pageSize:re,sortBy:ce,sortOrder:fe}],assetTypes:de,flags:we}}get searchText(){const U=this.d.criteria.filter(K=>K.filterType===c.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function F(G,U){const K=(G||[]).filter(re=>re.statisticName===U)[0];return K?K.value:0}function x(G){const U="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(re=>re.assetType.indexOf(U)===0).reduce((re,ce)=>{const fe=ae(G,ce.assetType);return fe&&re.push([ce.assetType.substring(U.length),fe]),re},[])}function Y(G){if(G.properties){const U=G.properties.filter(ce=>ce.key===g.Repository),K=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=U.filter(ce=>K.test(ce.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return ae(G,g.Repository)}function ne(G){return{uri:`${G.fallbackAssetUri}/${g.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${g.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function ae(G,U){return G.files.filter(re=>re.assetType===U)[0]?{uri:`${G.assetUri}/${U}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${U}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}:null}function ue(G,U){const K=G.properties?G.properties.filter(ce=>ce.key===U):[],re=K.length>0&&K[0].value;return re?re.split(",").map(ce=>(0,f.$Tp)(ce)):[]}function me(G){const U=G.properties?G.properties.filter(K=>K.key===N.Engine):[];return U.length>0&&U[0].value||""}function W(G){const U=G.properties?G.properties.filter(K=>K.key===N.PreRelease):[];return U.length>0&&U[0].value==="true"}function _(G){const U=G.properties?G.properties.filter(K=>K.key===N.ExecutesCode):[];return U.length>0?U[0].value==="true":void 0}function M(G){const U=G.properties?G.properties.filter(re=>re.key===N.EnabledApiProposals):[],K=U.length>0&&U[0].value||"";return K?K.split(","):[]}function q(G){const U=G.properties?G.properties.filter(re=>re.key===N.LocalizedLanguages):[],K=U.length>0&&U[0].value||"";return K?K.split(","):[]}function H(G){return G.properties?.find(U=>U.key===N.SponsorLink)?.value}function X(G){return G.properties?.find(U=>U.key===N.SupportLink)?.value}function ie(G){return G.indexOf("preview")!==-1}function se(G){return G.targetPlatform?(0,p.$jp)(G.targetPlatform):m.TargetPlatform.UNDEFINED}function L(G){const U=(0,P.$Ob)(G.versions.map(se)),K=!!G.tags?.includes(p.$dp),re=U.indexOf(m.TargetPlatform.WEB);return K?re===-1&&U.push(m.TargetPlatform.WEB):re!==-1&&U.splice(re,1),U}function V(G,U){for(let K=0;K<G.length;K++){const re=G[K];if(re.version===G[K-1]?.version){let ce=K;if(se(re)===U)for(;ce>0&&G[ce-1].version===re.version;)ce--;ce!==K&&(G.splice(K,1),G.splice(ce,0,re))}}return G}function z(G,U,K){G.telemetryData={index:U,querySource:K,queryActivityId:G.queryContext?.[t]}}function E(G,U,K,re){const ce=G.versions[0],fe={manifest:ae(U,g.Manifest),readme:ae(U,g.Details),changelog:ae(U,g.Changelog),license:ae(U,g.License),repository:Y(U),download:ne(U),icon:ae(U,g.Icon),signature:ae(U,g.Signature),coreTranslations:x(U)};return{type:"gallery",identifier:{id:(0,f.$Up)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:U.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(ce),description:G.shortDescription??"",installCount:F(G.statistics,"install"),rating:F(G.statistics,"averagerating"),ratingCount:F(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:K,assets:fe,properties:{dependencies:ue(U,N.Dependency),extensionPack:ue(U,N.ExtensionPack),engine:me(U),enabledApiProposals:M(U),localizedLanguages:q(U),targetPlatform:se(U),isPreReleaseVersion:W(U),executesCode:_(U)},hasPreReleaseVersion:W(ce),hasReleaseVersion:!0,preview:ie(G.flags),isSigned:!!fe.signature,queryContext:re,supportLink:X(ce)}}let j=class{constructor(U,K,re,ce,fe,we,de,pe){this.l=K,this.n=re,this.o=ce,this.q=fe,this.u=we,this.w=de,this.x=pe;const ye=de.extensionsGallery,$e=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=$e?ye.servicePPEUrl:ye?.serviceUrl,this.g=$e?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.k=de.extensionsEnabledWithApiProposalVersion?.map(ve=>ve.toLowerCase())??[],this.j=(0,y.$sq)(de.version,de,this.o,this.x,this.u,U,this.q)}y(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,K,re){const ce=S.CancellationToken.isCancellationToken(K)?{}:K,fe=S.CancellationToken.isCancellationToken(K)?K:re,we=[],de=[],pe=[],ye=[];let $e=!0;for(const ee of U){ee.uuid?de.push(ee.uuid):we.push(ee.id);const te=!!(ee.version||ee.preRelease);pe.push({id:ee.id,uuid:ee.uuid,includePreRelease:te}),ee.version&&ye.push({id:ee.id,uuid:ee.uuid,version:ee.version}),$e=$e&&!!ee.hasPreRelease&&!te}if(!de.length&&!we.length)return[];let ve=new D().withPage(1,U.length);de.length&&(ve=ve.withFilter(c.ExtensionId,...de)),we.length&&(ve=ve.withFilter(c.ExtensionName,...we)),(ce.queryAllVersions||$e)&&(ve=ve.withFlags(ve.flags,s.IncludeVersions)),ce.source&&(ve=ve.withSource(ce.source));const{extensions:B}=await this.B(ve,{targetPlatform:ce.targetPlatform??r,includePreRelease:pe,versions:ye,compatible:!!ce.compatible,productVersion:ce.productVersion??{version:this.w.version,date:this.w.date}},fe);return ce.source&&B.forEach((ee,te)=>z(ee,te,ce.source)),B}async getCompatibleExtension(U,K,re,ce={version:this.w.version,date:this.w.date}){if((0,p.$lp)(U.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(U,K,re))return U;const fe=new D().withFlags(s.IncludeVersions).withPage(1,1).withFilter(c.ExtensionId,U.identifier.uuid),{extensions:we}=await this.B(fe,{targetPlatform:re,compatible:!0,includePreRelease:K,productVersion:ce},S.CancellationToken.None);return we[0]||null}async isExtensionCompatible(U,K,re,ce={version:this.w.version,date:this.w.date}){if(!(0,p.$mp)(U.properties.targetPlatform,U.allTargetPlatforms,re)||!K&&U.properties.isPreReleaseVersion)return!1;let fe=U.properties.engine;if(!fe){const we=await this.getManifest(U,S.CancellationToken.None);if(!we)throw new Error("Manifest was not found");fe=we.engines.vscode}return!(!(0,k.$9p)(fe,ce.version,ce.date)||!this.z(U.identifier,U.properties.enabledApiProposals))}z(U,K){return!K||!this.k.includes(U.id.toLowerCase())?!0:(0,k.$0p)(K)}async A(U,K,re,ce,fe,we,de={version:this.w.version,date:this.w.date}){if(!(0,p.$mp)(se(K),fe,we)||re!=="any"&&W(K)!==(re==="prerelease"))return!1;if(ce)try{const pe=await this.G(U,K);if(!(0,k.$9p)(pe,de.version,de.date))return!1}catch(pe){return this.n.error(`Error while getting the engine for the version ${K.version}.`,(0,v.$_)(pe)),!1}return!0}async query(U,K){let re=U.text||"";const ce=U.pageSize??50;let fe=new D().withPage(1,ce);re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,ve,B)=>(fe=fe.withFilter(c.Category,B||ve),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,ve,B)=>(fe=fe.withFilter(c.Tag,B||ve),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(c.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),fe=fe.withFilter(c.SearchText,re)),fe=fe.withSortBy(p.SortBy.NoneOrRelevance)):U.ids?fe=fe.withFilter(c.ExtensionId,...U.ids):U.names?fe=fe.withFilter(c.ExtensionName,...U.names):fe=fe.withSortBy(p.SortBy.InstallCount),typeof U.sortBy=="number"&&(fe=fe.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(fe=fe.withSortOrder(U.sortOrder)),U.source&&(fe=fe.withSource(U.source));const we=async($e,ve)=>{const{extensions:B,total:ee}=await this.B($e,{targetPlatform:r,compatible:!1,includePreRelease:!!U.includePreRelease,productVersion:U.productVersion??{version:this.w.version,date:this.w.date}},ve);return B.forEach((te,ge)=>z(te,($e.pageNumber-1)*$e.pageSize+ge,U.source)),{extensions:B,total:ee}},{extensions:de,total:pe}=await we(fe,K),ye=async($e,ve)=>{if(ve.isCancellationRequested)throw new v.$7;const{extensions:B}=await we(fe.withPage($e+1),ve);return B};return{firstPage:de,total:pe,pageSize:fe.pageSize,getPage:ye}}async B(U,K,re){const ce=U.flags;U.flags&s.IncludeLatestVersionOnly&&U.flags&s.IncludeVersions&&(U=U.withFlags(U.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(U.flags&s.IncludeLatestVersionOnly)&&!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags,s.IncludeLatestVersionOnly)),K.versions?.length&&(U=U.withFlags(U.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),U=U.withFlags(U.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:fe,total:we,context:de}=await this.D(U,re);if(!(U.flags&s.IncludeLatestVersionOnly)){const ve=[];for(const B of fe){const ee=await this.C(B,K,de);ee&&ve.push(ee)}return{extensions:ve,total:we}}const ye=[],$e=new Map;for(let ve=0;ve<fe.length;ve++){const B=fe[ve],ee={id:(0,f.$Up)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},te=(0,O.$ng)(K.includePreRelease)?K.includePreRelease:!!K.includePreRelease.find(Pe=>(0,f.$Pp)(Pe,ee))?.includePreRelease;if(K.compatible&&(0,p.$lp)(L(B),K.targetPlatform))continue;const ge=await this.C(B,K,de);!ge||ge.properties.isPreReleaseVersion&&(!te||!ge.hasReleaseVersion)||!ge.properties.isPreReleaseVersion&&ge.properties.targetPlatform!==K.targetPlatform&&ge.hasPreReleaseVersion?$e.set(B.extensionId,ve):ye.push([ve,ge])}if($e.size){const ve=new n.$ie,B=new D().withFlags(ce&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,$e.size).withFilter(c.ExtensionId,...$e.keys()),{extensions:ee}=await this.B(B,K,re);this.q.publicLog2("galleryService:additionalQuery",{duration:ve.elapsed(),count:$e.size});for(const te of ee){const ge=$e.get(te.identifier.uuid);ye.push([ge,te])}}return{extensions:ye.sort((ve,B)=>ve[0]-B[0]).map(([,ve])=>ve),total:we}}async C(U,K,re){const ce={id:(0,f.$Up)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},fe=K.versions?.find(ye=>(0,f.$Pp)(ye,ce))?.version,we=(0,O.$ng)(K.includePreRelease)?K.includePreRelease:!!K.includePreRelease.find(ye=>(0,f.$Pp)(ye,ce))?.includePreRelease,de=L(U),pe=V(U.versions,K.targetPlatform);if(K.compatible&&(0,p.$lp)(de,K.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const $e=pe[ye];if(!(fe&&$e.version!==fe)){if(await this.A(ce.id,$e,we?"any":"release",K.compatible,de,K.targetPlatform,K.productVersion))return K.compatible&&!this.z(ce,M($e))?null:E(U,$e,de,re);if(fe&&$e.version===fe)return null}}return fe||K.compatible?null:E(U,U.versions[0],de)}async D(U,K){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(c.Target,"Microsoft.VisualStudio.Code").withFilter(c.ExcludeWithFlags,o(s.Unpublished));const re=await this.j,ce=JSON.stringify(U.raw),fe={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},we=new n.$ie;let de,pe,ye=0;try{if(de=await this.l.request({type:"POST",url:this.g&&U.criteria.some(ve=>ve.filterType===c.SearchText)?this.g:this.y("/extensionquery"),data:ce,headers:fe},K),de.res.statusCode&&de.res.statusCode>=400&&de.res.statusCode<500)return{galleryExtensions:[],total:ye};const $e=await(0,R.$eq)(de);if($e){const ve=$e.results[0],B=ve.extensions,ee=ve.resultMetadata&&ve.resultMetadata.filter(te=>te.metadataType==="ResultCount")[0];return ye=ee&&ee.metadataItems.filter(te=>te.name==="TotalCount")[0].count||0,{galleryExtensions:B,total:ye,context:de.res.headers.activityid?{[t]:de.res.headers.activityid}:{}}}return{galleryExtensions:[],total:ye}}catch($e){if((0,v.$6)($e))throw pe=p.ExtensionGalleryErrorCode.Cancelled,$e;{const ve=(0,v.$_)($e);throw pe=(0,l.$_o)($e)?p.ExtensionGalleryErrorCode.Offline:ve.startsWith("XHR timeout")?p.ExtensionGalleryErrorCode.Timeout:p.ExtensionGalleryErrorCode.Failed,new p.$pp(ve,pe)}}finally{this.q.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ce.length),duration:we.elapsed(),success:!!de&&(0,R.$aq)(de),responseBodySize:de?.res.headers["Content-Length"],statusCode:de?String(de.res.statusCode):void 0,errorCode:pe,count:String(ye)})}}async reportStatistic(U,K,re,ce){if(!this.isEnabled())return;const fe=I.$p?this.y(`/itemName/${U}.${K}/version/${re}/statType/${ce===p.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${U}/extensions/${K}/${re}/stats?statType=${ce}`),we=I.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:we};try{await this.l.request({type:"POST",url:fe,headers:pe},S.CancellationToken.None)}catch{}}async download(U,K,re){this.n.trace("ExtensionGalleryService#download",U.identifier.id);const ce=(0,f.$Xp)(U),fe=new Date().getTime(),we=re===p.InstallOperation.Install?"install":re===p.InstallOperation.Update?"update":"",de=we?{uri:`${U.assets.download.uri}${w.URI.parse(U.assets.download.uri).query?"&":"?"}${we}=true`,fallbackUri:`${U.assets.download.fallbackUri}${w.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${we}=true`}:U.assets.download,pe=U.queryContext?.[t]?{[t]:U.queryContext[t]}:void 0,ye=await this.F(U.identifier.id,de,g.VSIX,pe?{headers:pe}:void 0);try{await this.u.writeFile(K,ye.stream)}catch($e){try{await this.u.del(K)}catch(ve){this.n.warn(`Error while deleting the file ${K.toString()}`,(0,v.$_)(ve))}throw new p.$pp((0,v.$_)($e),p.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ce,duration:new Date().getTime()-fe})}async downloadSignatureArchive(U,K){if(!U.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const re=await this.F(U.identifier.id,U.assets.signature,g.Signature);try{await this.u.writeFile(K,re.stream)}catch(ce){try{await this.u.del(K)}catch(fe){this.n.warn(`Error while deleting the file ${K.toString()}`,(0,v.$_)(fe))}throw new p.$pp((0,v.$_)(ce),p.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(U,K){if(U.assets.readme){const re=await this.F(U.identifier.id,U.assets.readme,g.Details,{},K);return await(0,R.$dq)(re)||""}return""}async getManifest(U,K){if(U.assets.manifest){const re=await this.F(U.identifier.id,U.assets.manifest,g.Manifest,{},K),ce=await(0,R.$dq)(re);return ce?JSON.parse(ce):null}return null}async E(U,K,re){const ce=ae(K,g.Manifest);if(!ce)throw new Error("Manifest was not found");const fe={"Accept-Encoding":"gzip"},we=await this.F(U,ce,g.Manifest,{headers:fe});return await(0,R.$eq)(we)}async getCoreTranslation(U,K){const re=U.assets.coreTranslations.filter(ce=>ce[0]===K.toUpperCase())[0];if(re){const ce=await this.F(U.identifier.id,re[1],re[0]),fe=await(0,R.$dq)(ce);return fe?JSON.parse(fe):null}return null}async getChangelog(U,K){if(U.assets.changelog){const re=await this.F(U.identifier.id,U.assets.changelog,g.Changelog,{},K);return await(0,R.$dq)(re)||""}return""}async getAllCompatibleVersions(U,K,re){let ce=new D().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.uuid?ce=ce.withFilter(c.ExtensionId,U.uuid):ce=ce.withFilter(c.ExtensionName,U.id);const{galleryExtensions:fe}=await this.D(ce,S.CancellationToken.None);if(!fe.length)return[];const we=L(fe[0]);if((0,p.$lp)(we,re))return[];const de=[];await Promise.all(fe[0].versions.map(async $e=>{try{await this.A(U.id,$e,K?"any":"release",!0,we,re)&&this.z(U,M($e))&&de.push($e)}catch{}}));const pe=[],ye=new Set;for(const $e of V(de,re))ye.has($e.version)||(ye.add($e.version),pe.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:W($e)}));return pe}async F(U,K,re,ce={},fe=S.CancellationToken.None){const we=await this.j,de={type:"GET"},pe={...we,...ce.headers||{}};ce={...ce,...de,headers:pe};const ye=K.uri,$e=K.fallbackUri,ve={...ce,url:ye};try{const B=await this.l.request(ve,fe);if(B.res.statusCode===200)return B;const ee=await(0,R.$dq)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${ee}`)}catch(B){if((0,v.$6)(B))throw B;const ee=(0,v.$_)(B);this.q.publicLog2("galleryService:cdnFallback",{extension:U,assetType:re,message:ee});const te={...ce,url:$e};return this.l.request(te,fe)}}async G(U,K){let re=me(K);if(!re){this.q.publicLog2("galleryService:engineFallback",{extension:U,version:K.version});const ce=await this.E(U,K,S.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");re=ce.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const U=await this.l.request({type:"GET",url:this.h},S.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const K=await(0,R.$eq)(U),re=[],ce={},fe=[],we=[];if(K){for(const de of K.malicious)re.push({id:de});if(K.migrateToPreRelease)for(const[de,pe]of Object.entries(K.migrateToPreRelease))(!pe.engine||(0,k.$9p)(pe.engine,this.w.version,this.w.date))&&(ce[de.toLowerCase()]={disallowInstall:!0,extension:{id:pe.id,displayName:pe.displayName,autoMigrate:{storage:!!pe.migrateStorage},preRelease:!0}});if(K.deprecated)for(const[de,pe]of Object.entries(K.deprecated))pe&&(ce[de.toLowerCase()]=(0,O.$ng)(pe)?{}:pe);if(K.search)for(const de of K.search)fe.push(de);if(Array.isArray(K.extensionsEnabledWithPreRelease))for(const de of K.extensionsEnabledWithPreRelease)we.push(de.toLowerCase())}return{malicious:re,deprecated:ce,search:fe,extensionsEnabledWithPreRelease:we}}};j=Ee([oe(1,R.$$p),oe(2,d.$dk),oe(3,u.$Pi),oe(4,a.$cm),oe(5,b.$dl),oe(6,$.$wk),oe(7,h.$cj)],j);let Q=class extends j{constructor(U,K,re,ce,fe,we,de,pe){super(U,K,re,ce,fe,we,de,pe)}};e.$uq=Q,e.$uq=Q=Ee([oe(0,i.$lq),oe(1,R.$$p),oe(2,d.$dk),oe(3,u.$Pi),oe(4,a.$cm),oe(5,b.$dl),oe(6,$.$wk),oe(7,h.$cj)],Q);let J=class extends j{constructor(U,K,re,ce,fe,we,de){super(void 0,U,K,re,ce,fe,we,de)}};e.$vq=J,e.$vq=J=Ee([oe(0,R.$$p),oe(1,d.$dk),oe(2,u.$Pi),oe(3,a.$cm),oe(4,b.$dl),oe(5,$.$wk),oe(6,h.$cj)],J)}),define(le[145],he([0,1,11,17,9,6,124,23,24,3,70]),function(Z,e,P,S,v,I,C,O,w,l,h){"use strict";var u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=e.$1R=e.$ZR=void 0;let f=class extends w.$Sl{static{u=this}static{this.a="profileAssociationsMigration"}constructor(d,$,R,y,i){super(R,y,$,i),this.U=d,this.W=R}O(){return this.U.getItem(u.b,[]).map($=>({...$,location:(0,l.$hg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):P.URI.revive($.location)}))}Q(){const d=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$ZR=f,e.$ZR=f=u=Ee([oe(0,C.$UR),oe(1,O.$Nl),oe(2,S.$Qi),oe(3,v.$dl),oe(4,I.$dk)],f);let m=p=class extends f{constructor(d,$,R,y,i){super(d,$,R,y,i),this.$=d}P(d){d.length?this.$.setItem(p.b,d.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(p.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(p.c,d):this.$.removeItem(p.c)}Q(){const d="workspaceAndProfileInfo",$=this.$.getItem(d,void 0);if($){this.$.removeItem(d);const y=$.reduce((i,{workspace:a,profile:n})=>(i[P.URI.revive(a).toString()]=P.URI.revive(n).toString(),i),{});this.$.setItem(p.c,{workspaces:y})}const R=super.Q();return this.$.getItem(p.a,!1)||(this.R(R),this.$.setItem(p.a,!0)),R}};e.$1R=m,e.$1R=m=p=Ee([oe(0,C.$VR),oe(1,O.$Nl),oe(2,S.$Qi),oe(3,v.$dl),oe(4,I.$dk)],m);let k=class extends m{constructor(d,$,R,y){super(new h.$YR(h.SaveStrategy.IMMEDIATE,$,y,R),d,$,R,y)}async init(){return await this.$.init(),super.init()}};e.$2R=k,e.$2R=k=Ee([oe(0,O.$Nl),oe(1,S.$Qi),oe(2,v.$dl),oe(3,I.$dk)],k)}),define(le[146],he([0,1,122,8,13,7,3,30,17,123,6,46,121,157]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0,e.$ls=b;let m=class extends u.$_p{constructor($,R,y,i){super(i),this.m=$,this.n=R,this.r=y,this.s(),this.B($.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,R){const{f:y,g:i}=this;let a;try{a=await(0,l.$Um)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,I.$_)(t)))}const n={...process.env,...a},r=$.agent?$.agent:await(0,p.$js)($.url||"",n,{proxyUrl:y,strictSSL:i});return $.agent=r,$.strictSSL=i,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>b($,R))}async resolveProxy($){}async lookupAuthorization($){}async lookupKerberosAuthorization($){try{const R=await new Promise((r,t)=>{Z(["kerberos"],r,t)}).then(be),y=new URL($),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${y.hostname}`:`HTTP@${y.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${y}`,`spn:${i}`),"Negotiate "+await(await R.initializeClient(i)).step("")}catch(R){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",R);return}}async loadCertificates(){return(await new Promise((R,y)=>{Z(["@vscode/proxy-agent"],R,y)}).then(be)).loadSystemCertificates({log:this.r})}};e.$ks=m,e.$ks=m=Ee([oe(0,O.$cj),oe(1,w.$Qi),oe(2,h.$dk),oe(3,h.$ek)],m);async function k(d){return((0,P.parse)(d.url).protocol==="https:"?await new Promise((y,i)=>{Z(["https"],y,i)}).then(be):await new Promise((y,i)=>{Z(["http"],y,i)}).then(be)).request}async function b(d,$){return S.Promises.withAsyncBody(async(R,y)=>{const i=(0,P.parse)(d.url),a=d.getRawRequest?d.getRawRequest(d):await k(d),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,C.$ng)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(n.auth=d.user+":"+d.password);const r=a(n,t=>{const s=(0,C.$lg)(d.followRedirects)?d.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)b({...d,url:t.headers.location,followRedirects:s-1},$).then(R,y);else{let o=t;!d.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,f.createGunzip)())),R({res:t,stream:(0,v.$6e)(o)})}});r.on("error",y),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),$.onCancellationRequested(()=>{r.abort(),y(new I.$7)})})}});var ze=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[158],he([0,1,32,35,8,38,7,2,14,15,12,36,11,30,118,62,120,17,96,144,20,72,125,42,54,139,141,9,108,110,51,106,65,69,127,6,114,39,115,130,33,46,146,70,71,18,129,41,131,132,23,134,24,145,133,140,111,113,5,135,159]),function(Z,e,P,S,v,I,C,O,w,l,h,u,p,f,m,k,b,d,$,R,y,i,a,n,r,t,s,o,c,g,N,T,A,D,F,x,Y,ne,ae,ue,me,W,_,M,q,H,X,ie,se,L,V,z,E,j,Q,J,G,U,K,re,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=we,P=be(P),ue=ze(ue);class fe extends O.$Xc{constructor(pe){super(),this.b=pe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[pe,ye]=await this.f();return pe.invokeFunction(async $e=>{const ve=$e.get(x.$dk),B=$e.get(o.$dl),ee=$e.get(d.$Qi),te=$e.get(E.$Pl);ve.info("CLI main",this.b),this.h(ve),await this.j(ee,B,te,pe),await Promise.all(ye.map(ge=>{(0,v.$zh)(ge.flush(),1e3)}))})}async f(){const pe=new A.$Gi,ye={_serviceBrand:void 0,...ue.default};pe.set(me.$wk,ye);const $e=new $.$_m(this.b,ye);pe.set(d.$Qi,$e),await Promise.all([this.g($e.appSettingsHome.with({scheme:w.Schemas.file}).fsPath),this.g($e.extensionsPath)].map(Ie=>Ie?P.promises.mkdir(Ie,{recursive:!0}):void 0));const ve=new U.$TR((0,x.$rk)($e),$e.logsHome);pe.set(x.$ek,ve);const B=this.B(ve.createLogger("cli",{name:(0,K.localize)(169,null)})),ee=[];ve.getLogLevel()===x.LogLevel.Trace&&ee.push(new x.$lk(ve.getLogLevel()));const te=this.B(new G.$4R(B,ee));pe.set(x.$dk,te);const ge=this.B(new c.$8q(te));pe.set(o.$dl,ge);const Pe=this.B(new g.$yr(te));ge.registerProvider(w.Schemas.file,Pe);const Ae=new z.$Zs(ge);pe.set(V.$Nl,Ae);const ke=new M.$XR(M.SaveStrategy.DELAYED,$e,te,ge),Te=new j.$ZR(ke,Ae,$e,ge,te);pe.set(E.$Pl,Te),ge.registerProvider(w.Schemas.vscodeUserData,new re.$Ric(w.Schemas.file,Pe,w.Schemas.vscodeUserData,Te,Ae,te));const Re=h.$j&&ye.win32RegValueName?this.B(new ae.$Pic(te,ye.win32RegValueName)):$e.policyFile?this.B(new Y.$Qic($e.policyFile,ge,te)):new ne.$yo;pe.set(ne.$wo,Re);const Ce=this.B(new m.$1o(Te.defaultProfile.settingsResource,ge,Re,te));pe.set(f.$cj,Ce),await Promise.all([ke.init(),Ce.initialize()]);let qe;try{qe=await(0,Q.$ric)(ke,te)}catch(Ie){Ie.code!=="ENOENT"&&te.error(Ie)}const De=await(0,Q.$sic)(ke,te),Le=await(0,Q.$tic)(ke,te);Te.init(),pe.set(V.$Nl,new z.$Zs(ge));const je=new _.$ks(Ce,$e,te,ve);pe.set(W.$$p,je),pe.set(k.$5o,new N.$Fi(b.$iS,void 0,!0)),pe.set(n.$Oq,new N.$Fi(J.$3R,void 0,!0)),pe.set(r.$Sq,new N.$Fi(s.$oic,void 0,!0)),pe.set(i.$yq,new N.$Fi(i.$Aq,void 0,!0)),pe.set(t.$4q,new N.$Fi(t.$5q,void 0,!0)),pe.set(y.$op,new N.$Fi(R.$vq,void 0,!0)),pe.set(D.$es,new N.$Fi(F.$gs,void 0,!1));const Ue=[],Se=(0,ie.$Mp)(ye,Ce);if((0,ie.$Hp)(ye,$e)){ye.aiConfig&&ye.aiConfig.ariaKey&&Ue.push(new se.$RR(je,Se,"monacoworkbench",null,ye.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,q.$yp)((0,S.release)(),(0,S.hostname)(),process.arch,ye.commit,ye.version,qe,De,Le,Se),piiPaths:(0,ie.$Np)($e)};pe.set(H.$cm,new N.$Fi(X.$ms,[Ie],!1))}else pe.set(H.$cm,ie.$Cp);return[new T.$Br(pe),Ue]}g(pe){if(h.$j){const ye=(0,ce.getUNCHost)(pe);ye&&(0,ce.addUNCHostToAllowlist)(ye)}return pe}h(pe){(0,C.setUnexpectedErrorHandler)(ye=>{const $e=(0,I.$tj)(ye,!0);$e&&pe.error(`[uncaught exception in CLI]: ${$e}`)}),process.on("uncaughtException",ye=>{(0,C.$1)(ye)||(0,C.$2)(ye)}),process.on("unhandledRejection",ye=>(0,C.$2)(ye))}async j(pe,ye,$e,ve){let B;if(pe.args.profile&&(B=$e.profiles.find(te=>te.name===pe.args.profile),!B))throw new Error(`Profile '${pe.args.profile}' not found.`);const ee=(B??$e.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ve.createInstance(a.$Bq,new x.$lk(x.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return ve.createInstance(a.$Bq,new x.$lk(x.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return ve.createInstance(a.$Bq,new x.$lk(x.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return ve.createInstance(a.$Bq,new x.$lk(x.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return ve.createInstance(a.$Bq,new x.$lk(x.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,L.$8ic)(pe.appRoot,pe.extensionsPath))}}m(pe){return pe.map(ye=>/\.vsix$/i.test(ye)?p.URI.file((0,l.$lc)(ye)?ye:(0,l.$mc)((0,u.cwd)(),ye)):ye)}}async function we(de){const pe=new fe(de);try{await pe.run()}finally{pe.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e2b54301a5745870f6b95d81c91fb3e9557d4f08/core/vs/code/node/cliProcessMain.js.map
