/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","fs","vs/base/common/lazy","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/common/network","vs/base/node/extpath","vs/base/parts/sandbox/node/electronTypes","vs/nls","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/base/common/errorMessage","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],_e=function(fe){for(var e=[],_=0,t=fe.length;_<t;_++)e[_]=be[fe[_]];return e};define(be[37],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=_,e.$ib=t,e.$jb=q,e.$kb=j,e.$lb=X,e.$mb=k,e.$nb=L,e.$pb=F,e.$qb=w,e.$rb=v,e.$sb=p,e.$tb=c;function _(r,h){const E=t(r,h);if(E!==-1)return r[E]}function t(r,h,E=r.length-1){for(let l=E;l>=0;l--){const D=r[l];if(h(D))return l}return-1}function q(r,h){const E=j(r,h);return E===-1?void 0:r[E]}function j(r,h,E=0,l=r.length){let D=E,A=l;for(;D<A;){const u=Math.floor((D+A)/2);h(r[u])?D=u+1:A=u}return D-1}function X(r,h){const E=k(r,h);return E===r.length?void 0:r[E]}function k(r,h,E=0,l=r.length){let D=E,A=l;for(;D<A;){const u=Math.floor((D+A)/2);h(r[u])?A=u:D=u+1}return D}function L(r,h,E=0,l=r.length){const D=k(r,h,E,l);return D===r.length?-1:D}class O{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(O.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!h(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const E=j(this.e,h,this.c);return this.c=E+1,E===-1?void 0:this.e[E]}}e.$ob=O;function F(r,h){if(r.length===0)return;let E=r[0];for(let l=1;l<r.length;l++){const D=r[l];h(D,E)>0&&(E=D)}return E}function w(r,h){if(r.length===0)return;let E=r[0];for(let l=1;l<r.length;l++){const D=r[l];h(D,E)>=0&&(E=D)}return E}function v(r,h){return F(r,(E,l)=>-h(E,l))}function p(r,h){if(r.length===0)return-1;let E=0;for(let l=1;l<r.length;l++){const D=r[l];h(D,r[E])>0&&(E=l)}return E}function c(r,h){for(const E of r){const l=h(E);if(l!==void 0)return l}}}),define(be[11],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var _;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(_||(e.CharCode=_={}))}),define(be[38],_e([0,1]),function(fe,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=t,e.$d=q,e.$e=j,e.$f=X;function t(L,O){const F=Object.create(null);for(const w of L){const v=O(w);let p=F[v];p||(p=F[v]=[]),p.push(w)}return F}function q(L,O){const F=[],w=[];for(const v of L)O.has(v)||F.push(v);for(const v of O)L.has(v)||w.push(v);return{removed:F,added:w}}function j(L,O){const F=[],w=[];for(const[v,p]of L)O.has(v)||F.push(p);for(const[v,p]of O)L.has(v)||w.push(p);return{removed:F,added:w}}function X(L,O){const F=new Set;for(const w of O)L.has(w)&&F.add(w);return F}class k{static{_=Symbol.toStringTag}constructor(O,F){this.b=F,this.a=new Map,this[_]="SetWithKey";for(const w of O)this.add(w)}get size(){return this.a.size}add(O){const F=this.b(O);return this.a.set(F,O),this}delete(O){return this.a.delete(this.b(O))}has(O){return this.a.has(this.b(O))}*entries(){for(const O of this.a.values())yield[O,O]}keys(){return this.values()}*values(){for(const O of this.a.values())yield O}clear(){this.a.clear()}forEach(O,F){this.a.forEach(w=>O.call(F,w,w,this))}[Symbol.iterator](){return this.values()}}e.$g=k}),define(be[39],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=t,e.$bi=q,e.$ci=j;function _(X){return(k,L,O)=>{let F=null,w=null;if(typeof O.value=="function"?(F="value",w=O.value):typeof O.get=="function"&&(F="get",w=O.get),!w)throw new Error("not supported");O[F]=X(w,L)}}function t(X,k,L){let O=null,F=null;if(typeof L.value=="function"?(O="value",F=L.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof L.get=="function"&&(O="get",F=L.get),!F)throw new Error("not supported");const w=`$memoize$${k}`;L[O]=function(...v){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,v)}),this[w]}}function q(X,k,L){return _((O,F)=>{const w=`$debounce$${F}`,v=`$debounce$result$${F}`;return function(...p){this[v]||(this[v]=L?L():void 0),clearTimeout(this[w]),k&&(this[v]=k(this[v],...p),p=[this[v]]),this[w]=setTimeout(()=>{O.apply(this,p),this[v]=L?L():void 0},X)}})}function j(X,k,L){return _((O,F)=>{const w=`$throttle$timer$${F}`,v=`$throttle$result$${F}`,p=`$throttle$lastRun$${F}`,c=`$throttle$pending$${F}`;return function(...r){if(this[v]||(this[v]=L?L():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[v]=k(this[v],...r)),this[c])return;const h=this[p]+X;h<=Date.now()?(this[p]=Date.now(),O.apply(this,[this[v]]),this[v]=L?L():void 0):(this[c]=!0,this[w]=setTimeout(()=>{this[c]=!1,this[p]=Date.now(),O.apply(this,[this[v]]),this[v]=L?L():void 0},h-Date.now()))}})}}),define(be[9],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=t,e.$1=q,e.$2=j,e.$3=X,e.$4=k,e.$5=L,e.$6=F,e.$8=v,e.$9=p,e.$0=c,e.$_=h;class _{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?A.isErrorNoTelemetry(n)?new A(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$X=_,e.$Y=new _;function t(i){e.$Y.setUnexpectedErrorHandler(i)}function q(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function j(i){F(i)||e.$Y.onUnexpectedError(i)}function X(i){F(i)||e.$Y.onUnexpectedExternalError(i)}function k(i){if(i instanceof Error){const{name:n,message:s}=i,o=i.stacktrace||i.stack;return{$isError:!0,name:n,message:s,stack:o,noTelemetry:A.isErrorNoTelemetry(i)}}return i}function L(i){let n;return i.noTelemetry?n=new A:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const O="Canceled";function F(i){return i instanceof w?!0:i instanceof Error&&i.name===O&&i.message===O}class w extends Error{constructor(){super(O),this.name=this.message}}e.$7=w;function v(){const i=new Error(O);return i.name=i.message,i}function p(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function c(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class r extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=r;function h(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class E extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$ab=E;class l extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$bb=l;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=D;class A extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof A)return n;const s=new A;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$db=A;class u extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$eb=u}),define(be[12],_e([0,1,9,37]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=q,e.$vb=j,e.$wb=X,e.$xb=k,e.$yb=L,e.$zb=O,e.$Ab=F,e.$Bb=w,e.$Cb=v,e.$Db=p,e.$Eb=c,e.$Fb=r,e.$Gb=h,e.top=E,e.$Ib=l,e.$Jb=A,e.$Kb=u,e.$Lb=i,e.$Mb=n,e.$Nb=s,e.$Ob=o,e.$Pb=S,e.$Qb=m,e.$Rb=b,e.$Sb=a,e.$Tb=d,e.$Ub=N,e.$Vb=f,e.$Wb=y,e.$Xb=z,e.$Yb=x,e.$Zb=J,e.$1b=K,e.$2b=se,e.$3b=V,e.$4b=ne,e.$5b=re,e.$6b=oe,e.$7b=I,e.$8b=W,e.$9b=Q,e.$_b=ee,e.$dc=we;function q(B,G=0){return B[B.length-(1+G)]}function j(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function X(B,G,T=(g,M)=>g===M){if(B===G)return!0;if(!B||!G||B.length!==G.length)return!1;for(let g=0,M=B.length;g<M;g++)if(!T(B[g],G[g]))return!1;return!0}function k(B,G){const T=B.length-1;G<T&&(B[G]=B[T]),B.pop()}function L(B,G,T){return O(B.length,g=>T(B[g],G))}function O(B,G){let T=0,g=B-1;for(;T<=g;){const M=(T+g)/2|0,Y=G(M);if(Y<0)T=M+1;else if(Y>0)g=M-1;else return M}return-(T+1)}function F(B,G,T){if(B=B|0,B>=G.length)throw new TypeError("invalid index");const g=G[Math.floor(G.length*Math.random())],M=[],Y=[],te=[];for(const de of G){const De=T(de,g);De<0?M.push(de):De>0?Y.push(de):te.push(de)}return B<M.length?F(B,M,T):B<M.length+te.length?te[0]:F(B-(M.length+te.length),Y,T)}function w(B,G){const T=[];let g;for(const M of B.slice(0).sort(G))!g||G(g[0],M)!==0?(g=[M],T.push(g)):g.push(M);return T}function*v(B,G){let T,g;for(const M of B)g!==void 0&&G(g,M)?T.push(M):(T&&(yield T),T=[M]),g=M;T&&(yield T)}function p(B,G){for(let T=0;T<=B.length;T++)G(T===0?void 0:B[T-1],T===B.length?void 0:B[T])}function c(B,G){for(let T=0;T<B.length;T++)G(T===0?void 0:B[T-1],B[T],T+1===B.length?void 0:B[T+1])}function r(B,G,T){const g=[];function M(de,De,Re){if(De===0&&Re.length===0)return;const Ie=g[g.length-1];Ie&&Ie.start+Ie.deleteCount===de?(Ie.deleteCount+=De,Ie.toInsert.push(...Re)):g.push({start:de,deleteCount:De,toInsert:Re})}let Y=0,te=0;for(;;){if(Y===B.length){M(Y,0,G.slice(te));break}if(te===G.length){M(Y,B.length-Y,[]);break}const de=B[Y],De=G[te],Re=T(de,De);Re===0?(Y+=1,te+=1):Re<0?(M(Y,1,[]),Y+=1):Re>0&&(M(Y,0,[De]),te+=1)}return g}function h(B,G,T){const g=r(B,G,T),M=[],Y=[];for(const te of g)M.push(...B.slice(te.start,te.start+te.deleteCount)),Y.push(...te.toInsert);return{removed:M,added:Y}}function E(B,G,T){if(T===0)return[];const g=B.slice(0,T).sort(G);return D(B,G,g,T,B.length),g}function l(B,G,T,g,M){return T===0?Promise.resolve([]):new Promise((Y,te)=>{(async()=>{const de=B.length,De=B.slice(0,T).sort(G);for(let Re=T,Ie=Math.min(T+g,de);Re<de;Re=Ie,Ie=Math.min(Ie+g,de)){if(Re>T&&await new Promise(ge=>setTimeout(ge)),M&&M.isCancellationRequested)throw new _.$7;D(B,G,De,Re,Ie)}return De})().then(Y,te)})}function D(B,G,T,g,M){for(const Y=T.length;g<M;g++){const te=B[g];if(G(te,T[Y-1])<0){T.pop();const de=(0,t.$mb)(T,De=>G(te,De)<0);T.splice(de,0,te)}}}function A(B){return B.filter(G=>!!G)}function u(B){let G=0;for(let T=0;T<B.length;T++)B[T]&&(B[G]=B[T],G+=1);B.length=G}function i(B,G,T){B.splice(T,0,B.splice(G,1)[0])}function n(B){return!Array.isArray(B)||B.length===0}function s(B){return Array.isArray(B)&&B.length>0}function o(B,G=T=>T){const T=new Set;return B.filter(g=>{const M=G(g);return T.has(M)?!1:(T.add(M),!0)})}function S(B){const G=new Set;return T=>{const g=B(T);return G.has(g)?!1:(G.add(g),!0)}}function m(B,G){return B.length>0?B[0]:G}function b(B,G){return B.length>0?B[B.length-1]:G}function a(B,G,T=(g,M)=>g===M){let g=0;for(let M=0,Y=Math.min(B.length,G.length);M<Y&&T(B[M],G[M]);M++)g++;return g}function d(B,G){let T=typeof G=="number"?B:0;typeof G=="number"?T=B:(T=0,G=B);const g=[];if(T<=G)for(let M=T;M<G;M++)g.push(M);else for(let M=T;M>G;M--)g.push(M);return g}function N(B,G,T){return B.reduce((g,M)=>(g[G(M)]=T?T(M):M,g),Object.create(null))}function f(B,G){return B.push(G),()=>y(B,G)}function y(B,G){const T=B.indexOf(G);if(T>-1)return B.splice(T,1),G}function z(B,G,T){const g=B.slice(0,G),M=B.slice(G);return g.concat(T,M)}function x(B,G){let T;if(typeof G=="number"){let g=G;T=()=>{const M=Math.sin(g++)*179426549;return M-Math.floor(M)}}else T=Math.random;for(let g=B.length-1;g>0;g-=1){const M=Math.floor(T()*(g+1)),Y=B[g];B[g]=B[M],B[M]=Y}}function J(B,G){const T=B.indexOf(G);T>-1&&(B.splice(T,1),B.unshift(G))}function K(B,G){const T=B.indexOf(G);T>-1&&(B.splice(T,1),B.push(G))}function se(B,G){for(const T of G)B.push(T)}function V(B,G){return Array.isArray(B)?B.map(G):G(B)}function ne(B){return Array.isArray(B)?B:[B]}function re(B){return B[Math.floor(Math.random()*B.length)]}function oe(B,G,T){const g=$(B,G),M=B.length,Y=T.length;B.length=M+Y;for(let te=M-1;te>=g;te--)B[te+Y]=B[te];for(let te=0;te<Y;te++)B[te+g]=T[te]}function I(B,G,T,g){const M=$(B,G);let Y=B.splice(M,T);return Y===void 0&&(Y=[]),oe(B,M,g),Y}function $(B,G){return G<0?Math.max(G+B.length,0):Math.min(G,B.length)}var P;(function(B){function G(Y){return Y<0}B.isLessThan=G;function T(Y){return Y<=0}B.isLessThanOrEqual=T;function g(Y){return Y>0}B.isGreaterThan=g;function M(Y){return Y===0}B.isNeitherLessOrGreaterThan=M,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(P||(e.CompareResult=P={}));function W(B,G){return(T,g)=>G(B(T),B(g))}function Q(...B){return(G,T)=>{for(const g of B){const M=g(G,T);if(!P.isNeitherLessOrGreaterThan(M))return M}return P.neitherLessOrGreaterThan}}const R=(B,G)=>B-G;e.$0b=R;const Z=(B,G)=>(0,e.$0b)(B?1:0,G?1:0);e.$$b=Z;function ee(B){return(G,T)=>-B(G,T)}class ie{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let T=this.c;for(;T<this.g.length&&G(this.g[T]);)T++;const g=T===this.c?null:this.g.slice(this.c,T);return this.c=T,g}takeFromEndWhile(G){let T=this.d;for(;T>=0&&G(this.g[T]);)T--;const g=T===this.d?null:this.g.slice(T+1,this.d+1);return this.d=T,g}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const T=this.g.slice(this.c,this.c+G);return this.c+=G,T}}e.$ac=ie;class ue{static{this.empty=new ue(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(T=>(G(T),!0))}toArray(){const G=[];return this.iterate(T=>(G.push(T),!0)),G}filter(G){return new ue(T=>this.iterate(g=>G(g)?T(g):!0))}map(G){return new ue(T=>this.iterate(g=>T(G(g))))}some(G){let T=!1;return this.iterate(g=>(T=G(g),!T)),T}findFirst(G){let T;return this.iterate(g=>G(g)?(T=g,!1):!0),T}findLast(G){let T;return this.iterate(g=>(G(g)&&(T=g),!0)),T}findLastMaxBy(G){let T,g=!0;return this.iterate(M=>((g||P.isGreaterThan(G(M,T)))&&(g=!1,T=M),!0)),T}}e.$bc=ue;class he{constructor(G){this.c=G}static createSortPermutation(G,T){const g=Array.from(G.keys()).sort((M,Y)=>T(G[M],G[Y]));return new he(g)}apply(G){return G.map((T,g)=>G[this.c[g]])}inverse(){const G=this.c.slice();for(let T=0;T<this.c.length;T++)G[this.c[T]]=T;return new he(G)}}e.$cc=he;async function we(B,G){return(await Promise.all(B.map(async(g,M)=>({element:g,ok:await G(g,M)})))).find(g=>g.ok)?.element}}),define(be[26],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=_;function _(t,q){const j=this;let X=!1,k;return function(){if(X)return k;if(X=!0,q)try{k=t.apply(j,arguments)}finally{q()}else k=t.apply(j,arguments);return k}}}),define(be[40],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(t){function q(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=q;const j=Object.freeze([]);function X(){return j}t.empty=X;function*k(n){yield n}t.single=k;function L(n){return q(n)?n:k(n)}t.wrap=L;function O(n){return n||j}t.from=O;function*F(n){for(let s=n.length-1;s>=0;s--)yield n[s]}t.reverse=F;function w(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=w;function v(n){return n[Symbol.iterator]().next().value}t.first=v;function p(n,s){let o=0;for(const S of n)if(s(S,o++))return!0;return!1}t.some=p;function c(n,s){for(const o of n)if(s(o))return o}t.find=c;function*r(n,s){for(const o of n)s(o)&&(yield o)}t.filter=r;function*h(n,s){let o=0;for(const S of n)yield s(S,o++)}t.map=h;function*E(n,s){let o=0;for(const S of n)yield*s(S,o++)}t.flatMap=E;function*l(...n){for(const s of n)yield*s}t.concat=l;function D(n,s,o){let S=o;for(const m of n)S=s(S,m);return S}t.reduce=D;function*A(n,s,o=n.length){for(s<0&&(s+=n.length),o<0?o+=n.length:o>n.length&&(o=n.length);s<o;s++)yield n[s]}t.slice=A;function u(n,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,n];const S=n[Symbol.iterator]();for(let m=0;m<s;m++){const b=S.next();if(b.done)return[o,t.empty()];o.push(b.value)}return[o,{[Symbol.iterator](){return S}}]}t.consume=u;async function i(n){const s=[];for await(const o of n)s.push(o);return Promise.resolve(s)}t.asyncToArray=i})(_||(e.Iterable=_={}))}),define(be[16],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class _{constructor(q){this.d=q,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(q){this.c=q}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=_}),define(be[41],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class _{static{this.Undefined=new _(void 0)}constructor(j){this.element=j,this.next=_.Undefined,this.prev=_.Undefined}}class t{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let j=this.a;for(;j!==_.Undefined;){const X=j.next;j.prev=_.Undefined,j.next=_.Undefined,j=X}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,X){const k=new _(j);if(this.a===_.Undefined)this.a=k,this.b=k;else if(X){const O=this.b;this.b=k,k.prev=O,O.next=k}else{const O=this.a;this.a=k,k.next=O,O.prev=k}this.c+=1;let L=!1;return()=>{L||(L=!0,this.e(k))}}shift(){if(this.a!==_.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==_.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==_.Undefined&&j.next!==_.Undefined){const X=j.prev;X.next=j.next,j.next.prev=X}else j.prev===_.Undefined&&j.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):j.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):j.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==_.Undefined;)yield j.element,j=j.next}}e.$8c=t}),define(be[20],_e([0,1]),function(fe,e){"use strict";var _,t,q;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=j,e.$Bc=X,e.$Cc=k,e.$Lc=A;function j(u,i,n){let s=u.get(i);return s===void 0&&(s=n,u.set(i,s)),s}function X(u){const i=[];return u.forEach((n,s)=>{i.push(`${s} => ${n}`)}),`Map(${u.size}) {${i.join(", ")}}`}function k(u){const i=[];return u.forEach(n=>{i.push(n)}),`Set(${u.size}) {${i.join(", ")}}`}class L{constructor(i,n){this.uri=i,this.value=n}}function O(u){return Array.isArray(u)}class F{static{this.c=i=>i.toString()}constructor(i,n){if(this[_]="ResourceMap",i instanceof F)this.d=new Map(i.d),this.e=n??F.c;else if(O(i)){this.d=new Map,this.e=n??F.c;for(const[s,o]of i)this.set(s,o)}else this.d=new Map,this.e=i??F.c}set(i,n){return this.d.set(this.e(i),new L(i,n)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[s,o]of this.d)i(o.value,o.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Dc=F;class w{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this.c=new F(i):(this.c=new F(n),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,n){this.c.forEach((s,o)=>i.call(n,o,o,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=w;var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class p{constructor(){this[q]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,n=v.None){const s=this.c.get(i);if(s)return n!==v.None&&this.m(s,n),s.value}set(i,n,s=v.None){let o=this.c.get(i);if(o)o.value=n,s!==v.None&&this.m(o,s);else{switch(o={key:i,value:n,next:void 0,previous:void 0},s){case v.None:this.k(o);break;case v.AsOld:this.j(o);break;case v.AsNew:this.k(o);break;default:this.k(o);break}this.c.set(i,o),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this.c.get(i);if(n)return this.c.delete(i),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,n){const s=this.g;let o=this.d;for(;o;){if(n?i.bind(n)(o.value,o.key,this):i(o.value,o.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,n=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const S={value:s.key,done:!1};return s=s.next,S}else return{value:void 0,done:!0}}};return o}values(){const i=this,n=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const S={value:s.value,done:!1};return s=s.next,S}else return{value:void 0,done:!0}}};return o}entries(){const i=this,n=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const S={value:[s.key,s.value],done:!1};return s=s.next,S}else return{value:void 0,done:!0}}};return o}[(q=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.d,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.next,s--;this.d=n,this.f=s,n&&(n.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.e,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.previous,s--;this.e=n,this.f=s,n&&(n.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const n=i.next,s=i.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}i.next=void 0,i.previous=void 0,this.g++}m(i,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==v.AsOld&&n!==v.AsNew)){if(n===v.AsOld){if(i===this.d)return;const s=i.next,o=i.previous;i===this.e?(o.next=void 0,this.e=o):(s.previous=o,o.next=s),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(n===v.AsNew){if(i===this.e)return;const s=i.next,o=i.previous;i===this.d?(s.previous=void 0,this.d=s):(s.previous=o,o.next=s),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((n,s)=>{i.push([s,n])}),i}fromJSON(i){this.clear();for(const[n,s]of i)this.set(n,s)}}e.$Fc=p;class c extends p{constructor(i,n=1){super(),this.n=i,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,n=v.AsNew){return super.get(i,n)}peek(i){return super.get(i,v.None)}set(i,n){return super.set(i,n,v.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class r extends c{constructor(i,n=1){super(i,n)}q(i){this.h(i)}set(i,n){return super.set(i,n),this.p(),this}}e.$Gc=r;class h extends c{constructor(i,n=1){super(i,n)}q(i){this.i(i)}set(i,n){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,n),this}}e.$Hc=h;class E{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let n=this.c.get(i)||0;return n===0?!1:(n--,n===0?this.c.delete(i):this.c.set(i,n),!0)}has(i){return this.c.has(i)}}e.$Ic=E;class l{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[n,s]of i)this.set(n,s)}clear(){this.c.clear(),this.d.clear()}set(i,n){this.c.set(i,n),this.d.set(n,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const n=this.c.get(i);return n===void 0?!1:(this.c.delete(i),this.d.delete(n),!0)}forEach(i,n){this.c.forEach((s,o)=>{i.call(n,s,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=l;class D{constructor(){this.c=new Map}add(i,n){let s=this.c.get(i);s||(s=new Set,this.c.set(i,s)),s.add(n)}delete(i,n){const s=this.c.get(i);s&&(s.delete(n),s.size===0&&this.c.delete(i))}forEach(i,n){const s=this.c.get(i);s&&s.forEach(n)}get(i){const n=this.c.get(i);return n||new Set}}e.$Kc=D;function A(u,i){if(u===i)return!0;if(u.size!==i.size)return!1;for(const[n,s]of u)if(!i.has(n)||i.get(n)!==s)return!1;for(const[n]of i)if(!u.has(n))return!1;return!0}}),define(be[4],_e([0,1,12,38,20,26,40]),function(fe,e,_,t,q,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=F,e.$Oc=w,e.$Pc=v,e.$Qc=r,e.$Rc=h,e.$Sc=E,e.$Tc=l,e.$Uc=D,e.$Vc=A,e.$6c=d;const k=!1;let L=null;class O{constructor(){this.b=new Map}static{this.a=0}c(y){let z=this.b.get(y);return z||(z={parent:null,source:null,isSingleton:!1,value:y,idx:O.a++},this.b.set(y,z)),z}trackDisposable(y){const z=this.c(y);z.source||(z.source=new Error().stack)}setParent(y,z){const x=this.c(y);x.parent=z}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,z){const x=z.get(y);if(x)return x;const J=y.parent?this.f(this.c(y.parent),z):y;return z.set(y,J),J}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,y).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(y=10,z){let x;if(z)x=z;else{const ne=new Map,re=[...this.b.values()].filter(I=>I.source!==null&&!this.f(I,ne).isSingleton);if(re.length===0)return;const oe=new Set(re.map(I=>I.value));if(x=re.filter(I=>!(I.parent&&oe.has(I.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function J(ne){function re(I,$){for(;I.length>0&&$.some(P=>typeof P=="string"?P===I[0]:I[0].match(P));)I.shift()}const oe=ne.source.split(`
`).map(I=>I.trim().replace("at ","")).filter(I=>I!=="");return re(oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),oe.reverse()}const K=new q.$Kc;for(const ne of x){const re=J(ne);for(let oe=0;oe<=re.length;oe++)K.add(re.slice(0,oe).join(`
`),ne)}x.sort((0,_.$8b)(ne=>ne.idx,_.$0b));let se="",V=0;for(const ne of x.slice(0,y)){V++;const re=J(ne),oe=[];for(let I=0;I<re.length;I++){let $=re[I];$=`(shared with ${K.get(re.slice(0,I+1).join(`
`)).size}/${x.length} leaks) at ${$}`;const W=K.get(re.slice(0,I).join(`
`)),Q=(0,t.$c)([...W].map(R=>J(R)[I]),R=>R);delete Q[re[I]];for(const[R,Z]of Object.entries(Q))oe.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${R}`);oe.unshift($)}se+=`


==================== Leaking disposable ${V}/${x.length}: ${ne.value.constructor.name} ====================
${oe.join(`
`)}
============================================================

`}return x.length>y&&(se+=`


... and ${x.length-y} more leaking disposables

`),{leaks:x,details:se}}}e.$Mc=O;function F(f){L=f}if(k){const f="__is_disposable_tracked__";F(new class{trackDisposable(y){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[f]||console.log(z)},3e3)}setParent(y,z){if(y&&y!==i.None)try{y[f]=!0}catch{}}markAsDisposed(y){if(y&&y!==i.None)try{y[f]=!0}catch{}}markAsSingleton(y){}})}function w(f){return L?.trackDisposable(f),f}function v(f){L?.markAsDisposed(f)}function p(f,y){L?.setParent(f,y)}function c(f,y){if(L)for(const z of f)L.setParent(z,y)}function r(f){return L?.markAsSingleton(f),f}function h(f){return typeof f=="object"&&f!==null&&typeof f.dispose=="function"&&f.dispose.length===0}function E(f){if(X.Iterable.is(f)){const y=[];for(const z of f)if(z)try{z.dispose()}catch(x){y.push(x)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}function l(f){for(const y of f)h(y)&&y.dispose();return[]}function D(...f){const y=A(()=>E(f));return c(f,y),y}function A(f){const y=w({dispose:(0,j.$fb)(()=>{v(y),f()})});return y}class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{E(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return p(y,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),p(y,null))}}e.$Wc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,w(this),p(this.q,this)}dispose(){v(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Xc=i;class n{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&p(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&p(y,null),y}}e.$Yc=n;class s{constructor(y){this.a=new n,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=s;class o{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=o;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(y){let z=y;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,v(this))},this}}e.$2c=S;class m{constructor(){this.a=new Map}acquire(y,...z){let x=this.a.get(y);x||(x={counter:0,object:this.b(y,...z)},this.a.set(y,x));const{object:J}=x,K=(0,j.$fb)(()=>{--x.counter===0&&(this.c(y,x.object),this.a.delete(y))});return x.counter++,{object:J,dispose:K}}}e.$3c=m;class b{constructor(y){this.a=y}async acquire(y,...z){const x=this.a.acquire(y,...z);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(J){throw x.dispose(),J}}}e.$4c=b;class a{constructor(y){this.object=y}dispose(){}}e.$5c=a;function d(f){const y=new u;try{f(y)}finally{y.dispose()}}class N{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{E(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,z,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(y)?.dispose(),this.a.set(y,z)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const z=this.a.get(y);return this.a.delete(y),z}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=N}),define(be[27],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var _;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(_||(e.MarshalledId=_={}))}),define(be[21],_e([0,1,20]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0,e.$qm=q,e.$rm=X;const t=new _.$Gc(1e4);function q(O){return L(O,"NFC",t)}const j=new _.$Gc(1e4);function X(O){return L(O,"NFD",j)}const k=/[^\u0000-\u0080]/;function L(O,F,w){if(!O)return O;const v=w.get(O);if(v)return v;let p;return k.test(O)?p=O.normalize(F):p=O,w.set(O,p),p}e.$sm=function(){const O=/[\u0300-\u036f]/g;return function(F){return X(F).replace(O,"")}}()}),define(be[2],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=i,e.$E=b,e.$K=a,e.$h="en";let _=!1,t=!1,q=!1,j=!1,X=!1,k=!1,L=!1,O=!1,F=!1,w=!1,v,p=e.$h,c=e.$h,r,h;const E=globalThis;let l;typeof E.vscode<"u"&&typeof E.vscode.process<"u"?l=E.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const D=typeof l?.versions?.electron=="string",A=D&&l?.type==="renderer";if(typeof l=="object"){_=l.platform==="win32",t=l.platform==="darwin",q=l.platform==="linux",j=q&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,L=D,F=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$h,p=e.$h;const d=l.env.VSCODE_NLS_CONFIG;if(d)try{const N=JSON.parse(d);v=N.userLocale,c=N.osLocale,p=N.resolvedLanguage||e.$h,r=N.languagePack?.translationsConfigFile}catch{}X=!0}else typeof navigator=="object"&&!A?(h=navigator.userAgent,_=h.indexOf("Windows")>=0,t=h.indexOf("Macintosh")>=0,O=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,q=h.indexOf("Linux")>=0,w=h?.indexOf("Mobi")>=0,k=!0,p=globalThis._VSCODE_NLS_LANGUAGE||e.$h,v=navigator.language.toLowerCase(),c=v):console.error("Unable to resolve platform.");var u;(function(d){d[d.Web=0]="Web",d[d.Mac=1]="Mac",d[d.Linux=2]="Linux",d[d.Windows=3]="Windows"})(u||(e.Platform=u={}));function i(d){switch(d){case u.Web:return"Web";case u.Mac:return"Mac";case u.Linux:return"Linux";case u.Windows:return"Windows"}}let n=u.Web;t?n=u.Mac:_?n=u.Windows:q&&(n=u.Linux),e.$j=_,e.$k=t,e.$l=q,e.$m=j,e.$n=X,e.$o=L,e.$p=k,e.$q=k&&typeof E.importScripts=="function",e.$r=e.$q?E.origin:void 0,e.$s=O,e.$t=w,e.$u=F,e.$v=n,e.$w=h,e.$x=p;var s;(function(d){function N(){return e.$x}d.value=N;function f(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}d.isDefaultVariant=f;function y(){return e.$x==="en"}d.isDefault=y})(s||(e.Language=s={})),e.$y=v,e.$z=c,e.$A=r,e.$B=typeof E.postMessage=="function"&&!E.importScripts,e.$C=(()=>{if(e.$B){const d=[];E.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let y=0,z=d.length;y<z;y++){const x=d[y];if(x.id===f.data.vscodeScheduleAsyncWork){d.splice(y,1),x.callback();return}}});let N=0;return f=>{const y=++N;d.push({id:y,callback:f}),E.postMessage({vscodeScheduleAsyncWork:y},"*")}}return d=>setTimeout(d)})();var o;(function(d){d[d.Windows=1]="Windows",d[d.Macintosh=2]="Macintosh",d[d.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=t||O?o.Macintosh:_?o.Windows:o.Linux;let S=!0,m=!1;function b(){if(!m){m=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,S=new Uint16Array(d.buffer)[0]===513}return S}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function a(d){return parseFloat(d)>=20}}),define(be[28],_e([0,1,2]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let t;const q=globalThis.vscode;if(typeof q<"u"&&typeof q.process<"u"){const j=q.process;t={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return _.$j?"win32":_.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$gc=t.platform,e.$hc=t.arch});var Ye=this&&this.__createBinding||(Object.create?function(fe,e,_,t){t===void 0&&(t=_);var q=Object.getOwnPropertyDescriptor(e,_);(!q||("get"in q?!e.__esModule:q.writable||q.configurable))&&(q={enumerable:!0,get:function(){return e[_]}}),Object.defineProperty(fe,t,q)}:function(fe,e,_,t){t===void 0&&(t=_),fe[t]=e[_]}),Qe=this&&this.__setModuleDefault||(Object.create?function(fe,e){Object.defineProperty(fe,"default",{enumerable:!0,value:e})}:function(fe,e){fe.default=e}),Ue=this&&this.__importStar||function(fe){if(fe&&fe.__esModule)return fe;var e={};if(fe!=null)for(var _ in fe)_!=="default"&&Object.prototype.hasOwnProperty.call(fe,_)&&Ye(e,fe,_);return Qe(e,fe),e};define(be[3],_e([0,1,28]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,_=Ue(_);const t=65,q=97,j=90,X=122,k=46,L=47,O=92,F=58,w=63;class v extends Error{constructor(s,o,S){let m;typeof o=="string"&&o.indexOf("not ")===0?(m="must not be",o=o.replace(/^not /,"")):m="must be";const b=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${b} ${m} of type ${o}`;a+=`. Received type ${typeof S}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function p(n,s){if(n===null||typeof n!="object")throw new v(s,"Object",n)}function c(n,s){if(typeof n!="string")throw new v(s,"string",n)}const r=_.$gc==="win32";function h(n){return n===L||n===O}function E(n){return n===L}function l(n){return n>=t&&n<=j||n>=q&&n<=X}function D(n,s,o,S){let m="",b=0,a=-1,d=0,N=0;for(let f=0;f<=n.length;++f){if(f<n.length)N=n.charCodeAt(f);else{if(S(N))break;N=L}if(S(N)){if(!(a===f-1||d===1))if(d===2){if(m.length<2||b!==2||m.charCodeAt(m.length-1)!==k||m.charCodeAt(m.length-2)!==k){if(m.length>2){const y=m.lastIndexOf(o);y===-1?(m="",b=0):(m=m.slice(0,y),b=m.length-1-m.lastIndexOf(o)),a=f,d=0;continue}else if(m.length!==0){m="",b=0,a=f,d=0;continue}}s&&(m+=m.length>0?`${o}..`:"..",b=2)}else m.length>0?m+=`${o}${n.slice(a+1,f)}`:m=n.slice(a+1,f),b=f-a-1;a=f,d=0}else N===k&&d!==-1?++d:d=-1}return m}function A(n){return n?`${n[0]==="."?"":"."}${n}`:""}function u(n,s){p(s,"pathObject");const o=s.dir||s.root,S=s.base||`${s.name||""}${A(s.ext)}`;return o?o===s.root?`${o}${S}`:`${o}${n}${S}`:S}e.$ic={resolve(...n){let s="",o="",S=!1;for(let m=n.length-1;m>=-1;m--){let b;if(m>=0){if(b=n[m],c(b,`paths[${m}]`),b.length===0)continue}else s.length===0?b=_.cwd():(b=_.env[`=${s}`]||_.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==s.toLowerCase()&&b.charCodeAt(2)===O)&&(b=`${s}\\`));const a=b.length;let d=0,N="",f=!1;const y=b.charCodeAt(0);if(a===1)h(y)&&(d=1,f=!0);else if(h(y))if(f=!0,h(b.charCodeAt(1))){let z=2,x=z;for(;z<a&&!h(b.charCodeAt(z));)z++;if(z<a&&z!==x){const J=b.slice(x,z);for(x=z;z<a&&h(b.charCodeAt(z));)z++;if(z<a&&z!==x){for(x=z;z<a&&!h(b.charCodeAt(z));)z++;(z===a||z!==x)&&(N=`\\\\${J}\\${b.slice(x,z)}`,d=z)}}}else d=1;else l(y)&&b.charCodeAt(1)===F&&(N=b.slice(0,2),d=2,a>2&&h(b.charCodeAt(2))&&(f=!0,d=3));if(N.length>0)if(s.length>0){if(N.toLowerCase()!==s.toLowerCase())continue}else s=N;if(S){if(s.length>0)break}else if(o=`${b.slice(d)}\\${o}`,S=f,f&&s.length>0)break}return o=D(o,!S,"\\",h),S?`${s}\\${o}`:`${s}${o}`||"."},normalize(n){c(n,"path");const s=n.length;if(s===0)return".";let o=0,S,m=!1;const b=n.charCodeAt(0);if(s===1)return E(b)?"\\":n;if(h(b))if(m=!0,h(n.charCodeAt(1))){let d=2,N=d;for(;d<s&&!h(n.charCodeAt(d));)d++;if(d<s&&d!==N){const f=n.slice(N,d);for(N=d;d<s&&h(n.charCodeAt(d));)d++;if(d<s&&d!==N){for(N=d;d<s&&!h(n.charCodeAt(d));)d++;if(d===s)return`\\\\${f}\\${n.slice(N)}\\`;d!==N&&(S=`\\\\${f}\\${n.slice(N,d)}`,o=d)}}}else o=1;else l(b)&&n.charCodeAt(1)===F&&(S=n.slice(0,2),o=2,s>2&&h(n.charCodeAt(2))&&(m=!0,o=3));let a=o<s?D(n.slice(o),!m,"\\",h):"";return a.length===0&&!m&&(a="."),a.length>0&&h(n.charCodeAt(s-1))&&(a+="\\"),S===void 0?m?`\\${a}`:a:m?`${S}\\${a}`:`${S}${a}`},isAbsolute(n){c(n,"path");const s=n.length;if(s===0)return!1;const o=n.charCodeAt(0);return h(o)||s>2&&l(o)&&n.charCodeAt(1)===F&&h(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,o;for(let b=0;b<n.length;++b){const a=n[b];c(a,"path"),a.length>0&&(s===void 0?s=o=a:s+=`\\${a}`)}if(s===void 0)return".";let S=!0,m=0;if(typeof o=="string"&&h(o.charCodeAt(0))){++m;const b=o.length;b>1&&h(o.charCodeAt(1))&&(++m,b>2&&(h(o.charCodeAt(2))?++m:S=!1))}if(S){for(;m<s.length&&h(s.charCodeAt(m));)m++;m>=2&&(s=`\\${s.slice(m)}`)}return e.$ic.normalize(s)},relative(n,s){if(c(n,"from"),c(s,"to"),n===s)return"";const o=e.$ic.resolve(n),S=e.$ic.resolve(s);if(o===S||(n=o.toLowerCase(),s=S.toLowerCase(),n===s))return"";let m=0;for(;m<n.length&&n.charCodeAt(m)===O;)m++;let b=n.length;for(;b-1>m&&n.charCodeAt(b-1)===O;)b--;const a=b-m;let d=0;for(;d<s.length&&s.charCodeAt(d)===O;)d++;let N=s.length;for(;N-1>d&&s.charCodeAt(N-1)===O;)N--;const f=N-d,y=a<f?a:f;let z=-1,x=0;for(;x<y;x++){const K=n.charCodeAt(m+x);if(K!==s.charCodeAt(d+x))break;K===O&&(z=x)}if(x!==y){if(z===-1)return S}else{if(f>y){if(s.charCodeAt(d+x)===O)return S.slice(d+x+1);if(x===2)return S.slice(d+x)}a>y&&(n.charCodeAt(m+x)===O?z=x:x===2&&(z=3)),z===-1&&(z=0)}let J="";for(x=m+z+1;x<=b;++x)(x===b||n.charCodeAt(x)===O)&&(J+=J.length===0?"..":"\\..");return d+=z,J.length>0?`${J}${S.slice(d,N)}`:(S.charCodeAt(d)===O&&++d,S.slice(d,N))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.$ic.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===O){if(s.charCodeAt(1)===O){const o=s.charCodeAt(2);if(o!==w&&o!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(l(s.charCodeAt(0))&&s.charCodeAt(1)===F&&s.charCodeAt(2)===O)return`\\\\?\\${s}`;return n},dirname(n){c(n,"path");const s=n.length;if(s===0)return".";let o=-1,S=0;const m=n.charCodeAt(0);if(s===1)return h(m)?n:".";if(h(m)){if(o=S=1,h(n.charCodeAt(1))){let d=2,N=d;for(;d<s&&!h(n.charCodeAt(d));)d++;if(d<s&&d!==N){for(N=d;d<s&&h(n.charCodeAt(d));)d++;if(d<s&&d!==N){for(N=d;d<s&&!h(n.charCodeAt(d));)d++;if(d===s)return n;d!==N&&(o=S=d+1)}}}}else l(m)&&n.charCodeAt(1)===F&&(o=s>2&&h(n.charCodeAt(2))?3:2,S=o);let b=-1,a=!0;for(let d=s-1;d>=S;--d)if(h(n.charCodeAt(d))){if(!a){b=d;break}}else a=!1;if(b===-1){if(o===-1)return".";b=o}return n.slice(0,b)},basename(n,s){s!==void 0&&c(s,"suffix"),c(n,"path");let o=0,S=-1,m=!0,b;if(n.length>=2&&l(n.charCodeAt(0))&&n.charCodeAt(1)===F&&(o=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let a=s.length-1,d=-1;for(b=n.length-1;b>=o;--b){const N=n.charCodeAt(b);if(h(N)){if(!m){o=b+1;break}}else d===-1&&(m=!1,d=b+1),a>=0&&(N===s.charCodeAt(a)?--a===-1&&(S=b):(a=-1,S=d))}return o===S?S=d:S===-1&&(S=n.length),n.slice(o,S)}for(b=n.length-1;b>=o;--b)if(h(n.charCodeAt(b))){if(!m){o=b+1;break}}else S===-1&&(m=!1,S=b+1);return S===-1?"":n.slice(o,S)},extname(n){c(n,"path");let s=0,o=-1,S=0,m=-1,b=!0,a=0;n.length>=2&&n.charCodeAt(1)===F&&l(n.charCodeAt(0))&&(s=S=2);for(let d=n.length-1;d>=s;--d){const N=n.charCodeAt(d);if(h(N)){if(!b){S=d+1;break}continue}m===-1&&(b=!1,m=d+1),N===k?o===-1?o=d:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||m===-1||a===0||a===1&&o===m-1&&o===S+1?"":n.slice(o,m)},format:u.bind(null,"\\"),parse(n){c(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const o=n.length;let S=0,m=n.charCodeAt(0);if(o===1)return h(m)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(h(m)){if(S=1,h(n.charCodeAt(1))){let z=2,x=z;for(;z<o&&!h(n.charCodeAt(z));)z++;if(z<o&&z!==x){for(x=z;z<o&&h(n.charCodeAt(z));)z++;if(z<o&&z!==x){for(x=z;z<o&&!h(n.charCodeAt(z));)z++;z===o?S=z:z!==x&&(S=z+1)}}}}else if(l(m)&&n.charCodeAt(1)===F){if(o<=2)return s.root=s.dir=n,s;if(S=2,h(n.charCodeAt(2))){if(o===3)return s.root=s.dir=n,s;S=3}}S>0&&(s.root=n.slice(0,S));let b=-1,a=S,d=-1,N=!0,f=n.length-1,y=0;for(;f>=S;--f){if(m=n.charCodeAt(f),h(m)){if(!N){a=f+1;break}continue}d===-1&&(N=!1,d=f+1),m===k?b===-1?b=f:y!==1&&(y=1):b!==-1&&(y=-1)}return d!==-1&&(b===-1||y===0||y===1&&b===d-1&&b===a+1?s.base=s.name=n.slice(a,d):(s.name=n.slice(a,b),s.base=n.slice(a,d),s.ext=n.slice(b,d))),a>0&&a!==S?s.dir=n.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(r){const n=/\\/g;return()=>{const s=_.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>_.cwd()})();e.$jc={resolve(...n){let s="",o=!1;for(let S=n.length-1;S>=-1&&!o;S--){const m=S>=0?n[S]:i();c(m,`paths[${S}]`),m.length!==0&&(s=`${m}/${s}`,o=m.charCodeAt(0)===L)}return s=D(s,!o,"/",E),o?`/${s}`:s.length>0?s:"."},normalize(n){if(c(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===L,o=n.charCodeAt(n.length-1)===L;return n=D(n,!s,"/",E),n.length===0?s?"/":o?"./":".":(o&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return c(n,"path"),n.length>0&&n.charCodeAt(0)===L},join(...n){if(n.length===0)return".";let s;for(let o=0;o<n.length;++o){const S=n[o];c(S,"path"),S.length>0&&(s===void 0?s=S:s+=`/${S}`)}return s===void 0?".":e.$jc.normalize(s)},relative(n,s){if(c(n,"from"),c(s,"to"),n===s||(n=e.$jc.resolve(n),s=e.$jc.resolve(s),n===s))return"";const o=1,S=n.length,m=S-o,b=1,a=s.length-b,d=m<a?m:a;let N=-1,f=0;for(;f<d;f++){const z=n.charCodeAt(o+f);if(z!==s.charCodeAt(b+f))break;z===L&&(N=f)}if(f===d)if(a>d){if(s.charCodeAt(b+f)===L)return s.slice(b+f+1);if(f===0)return s.slice(b+f)}else m>d&&(n.charCodeAt(o+f)===L?N=f:f===0&&(N=0));let y="";for(f=o+N+1;f<=S;++f)(f===S||n.charCodeAt(f)===L)&&(y+=y.length===0?"..":"/..");return`${y}${s.slice(b+N)}`},toNamespacedPath(n){return n},dirname(n){if(c(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===L;let o=-1,S=!0;for(let m=n.length-1;m>=1;--m)if(n.charCodeAt(m)===L){if(!S){o=m;break}}else S=!1;return o===-1?s?"/":".":s&&o===1?"//":n.slice(0,o)},basename(n,s){s!==void 0&&c(s,"ext"),c(n,"path");let o=0,S=-1,m=!0,b;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let a=s.length-1,d=-1;for(b=n.length-1;b>=0;--b){const N=n.charCodeAt(b);if(N===L){if(!m){o=b+1;break}}else d===-1&&(m=!1,d=b+1),a>=0&&(N===s.charCodeAt(a)?--a===-1&&(S=b):(a=-1,S=d))}return o===S?S=d:S===-1&&(S=n.length),n.slice(o,S)}for(b=n.length-1;b>=0;--b)if(n.charCodeAt(b)===L){if(!m){o=b+1;break}}else S===-1&&(m=!1,S=b+1);return S===-1?"":n.slice(o,S)},extname(n){c(n,"path");let s=-1,o=0,S=-1,m=!0,b=0;for(let a=n.length-1;a>=0;--a){const d=n.charCodeAt(a);if(d===L){if(!m){o=a+1;break}continue}S===-1&&(m=!1,S=a+1),d===k?s===-1?s=a:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||S===-1||b===0||b===1&&s===S-1&&s===o+1?"":n.slice(s,S)},format:u.bind(null,"/"),parse(n){c(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const o=n.charCodeAt(0)===L;let S;o?(s.root="/",S=1):S=0;let m=-1,b=0,a=-1,d=!0,N=n.length-1,f=0;for(;N>=S;--N){const y=n.charCodeAt(N);if(y===L){if(!d){b=N+1;break}continue}a===-1&&(d=!1,a=N+1),y===k?m===-1?m=N:f!==1&&(f=1):m!==-1&&(f=-1)}if(a!==-1){const y=b===0&&o?1:b;m===-1||f===0||f===1&&m===a-1&&m===b+1?s.base=s.name=n.slice(y,a):(s.name=n.slice(y,m),s.base=n.slice(y,a),s.ext=n.slice(m,a))}return b>0?s.dir=n.slice(0,b-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=r?e.$ic.normalize:e.$jc.normalize,e.$lc=r?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=r?e.$ic.join:e.$jc.join,e.$nc=r?e.$ic.resolve:e.$jc.resolve,e.$oc=r?e.$ic.relative:e.$jc.relative,e.$pc=r?e.$ic.dirname:e.$jc.dirname,e.$qc=r?e.$ic.basename:e.$jc.basename,e.$rc=r?e.$ic.extname:e.$jc.extname,e.$sc=r?e.$ic.format:e.$jc.format,e.$tc=r?e.$ic.parse:e.$jc.parse,e.$uc=r?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=r?e.$ic.sep:e.$jc.sep,e.$wc=r?e.$ic.delimiter:e.$jc.delimiter}),define(be[29],_e([0,1,2]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=j,e.$pm=X;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t||(e.Source=t={}));var q;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(q||(e.TerminateResponseCode=q={}));function j(k,...L){const O=L.reduce((v,p)=>(v[p]=!0,v),{}),F=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(v=>!O[v]).forEach(v=>{for(let p=0;p<F.length;p++)if(v.search(F[p])!==-1){delete k[v];break}})}function X(k){k&&(delete k.DEBUG,_.$l&&delete k.LD_PRELOAD)}}),define(be[42],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(j){return new t(j)}constructor(j){this.c=_&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ie=t}),define(be[6],_e([0,1,9,26,4,41,42]),function(fe,e,_,t,q,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$ke=e.Event=void 0,e.$le=p;const k=!1,L=!1,O=!1;var F;(function(J){J.None=()=>q.$Xc.None;function K(ge){if(O){const{onDidAddListener:le}=ge,$e=r.create();let ae=0;ge.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function se(ge,le){return Z(ge,()=>{},0,void 0,!0,void 0,le)}J.defer=se;function V(ge){return(le,$e=null,ae)=>{let Ee=!1,ye;return ye=ge(Le=>{if(!Ee)return ye?ye.dispose():Ee=!0,le.call($e,Le)},null,ae),Ee&&ye.dispose(),ye}}J.once=V;function ne(ge,le){return J.once(J.filter(ge,le))}J.onceIf=ne;function re(ge,le,$e){return Q((ae,Ee=null,ye)=>ge(Le=>ae.call(Ee,le(Le)),null,ye),$e)}J.map=re;function oe(ge,le,$e){return Q((ae,Ee=null,ye)=>ge(Le=>{le(Le),ae.call(Ee,Le)},null,ye),$e)}J.forEach=oe;function I(ge,le,$e){return Q((ae,Ee=null,ye)=>ge(Le=>le(Le)&&ae.call(Ee,Le),null,ye),$e)}J.filter=I;function $(ge){return ge}J.signal=$;function P(...ge){return(le,$e=null,ae)=>{const Ee=(0,q.$Uc)(...ge.map(ye=>ye(Le=>le.call($e,Le))));return R(Ee,ae)}}J.any=P;function W(ge,le,$e,ae){let Ee=$e;return re(ge,ye=>(Ee=le(Ee,ye),Ee),ae)}J.reduce=W;function Q(ge,le){let $e;const ae={onWillAddFirstListener(){$e=ge(Ee.fire,Ee)},onDidRemoveLastListener(){$e?.dispose()}};le||K(ae);const Ee=new n(ae);return le?.add(Ee),Ee.event}function R(ge,le){return le instanceof Array?le.push(ge):le&&le.add(ge),ge}function Z(ge,le,$e=100,ae=!1,Ee=!1,ye,Le){let Oe,Te,Ae,Ne=0,Be;const He={leakWarningThreshold:ye,onWillAddFirstListener(){Oe=ge(Ve=>{Ne++,Te=le(Te,Ve),ae&&!Ae&&(We.fire(Te),Te=void 0),Be=()=>{const qe=Te;Te=void 0,Ae=void 0,(!ae||Ne>1)&&We.fire(qe),Ne=0},typeof $e=="number"?(clearTimeout(Ae),Ae=setTimeout(Be,$e)):Ae===void 0&&(Ae=0,queueMicrotask(Be))})},onWillRemoveListener(){Ee&&Ne>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,Oe.dispose()}};Le||K(He);const We=new n(He);return Le?.add(We),We.event}J.debounce=Z;function ee(ge,le=0,$e){return J.debounce(ge,(ae,Ee)=>ae?(ae.push(Ee),ae):[Ee],le,void 0,!0,void 0,$e)}J.accumulate=ee;function ie(ge,le=(ae,Ee)=>ae===Ee,$e){let ae=!0,Ee;return I(ge,ye=>{const Le=ae||!le(ye,Ee);return ae=!1,Ee=ye,Le},$e)}J.latch=ie;function ue(ge,le,$e){return[J.filter(ge,le,$e),J.filter(ge,ae=>!le(ae),$e)]}J.split=ue;function he(ge,le=!1,$e=[],ae){let Ee=$e.slice(),ye=ge(Te=>{Ee?Ee.push(Te):Oe.fire(Te)});ae&&ae.add(ye);const Le=()=>{Ee?.forEach(Te=>Oe.fire(Te)),Ee=null},Oe=new n({onWillAddFirstListener(){ye||(ye=ge(Te=>Oe.fire(Te)),ae&&ae.add(ye))},onDidAddFirstListener(){Ee&&(le?setTimeout(Le):Le())},onDidRemoveLastListener(){ye&&ye.dispose(),ye=null}});return ae&&ae.add(Oe),Oe.event}J.buffer=he;function we(ge,le){return(ae,Ee,ye)=>{const Le=le(new G);return ge(function(Oe){const Te=Le.evaluate(Oe);Te!==B&&ae.call(Ee,Te)},void 0,ye)}}J.chain=we;const B=Symbol("HaltChainable");class G{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:B),this}reduce(le,$e){let ae=$e;return this.f.push(Ee=>(ae=le(ae,Ee),ae)),this}latch(le=($e,ae)=>$e===ae){let $e=!0,ae;return this.f.push(Ee=>{const ye=$e||!le(Ee,ae);return $e=!1,ae=Ee,ye?Ee:B}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===B)break;return le}}function T(ge,le,$e=ae=>ae){const ae=(...Oe)=>Le.fire($e(...Oe)),Ee=()=>ge.on(le,ae),ye=()=>ge.removeListener(le,ae),Le=new n({onWillAddFirstListener:Ee,onDidRemoveLastListener:ye});return Le.event}J.fromNodeEventEmitter=T;function g(ge,le,$e=ae=>ae){const ae=(...Oe)=>Le.fire($e(...Oe)),Ee=()=>ge.addEventListener(le,ae),ye=()=>ge.removeEventListener(le,ae),Le=new n({onWillAddFirstListener:Ee,onDidRemoveLastListener:ye});return Le.event}J.fromDOMEventEmitter=g;function M(ge){return new Promise(le=>V(ge)(le))}J.toPromise=M;function Y(ge){const le=new n;return ge.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}J.fromPromise=Y;function te(ge,le){return ge($e=>le.fire($e))}J.forward=te;function de(ge,le,$e){return le($e),ge(ae=>le(ae))}J.runAndSubscribe=de;class De{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const ae={onWillAddFirstListener:()=>{le.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||K(ae),this.emitter=new n(ae),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Re(ge,le){return new De(ge,le).emitter.event}J.fromObservable=Re;function Ie(ge){return(le,$e,ae)=>{let Ee=0,ye=!1;const Le={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(ge.reportChanges(),ye&&(ye=!1,le.call($e)))},handlePossibleChange(){},handleChange(){ye=!0}};ge.addObserver(Le),ge.reportChanges();const Oe={dispose(){ge.removeObserver(Le)}};return ae instanceof q.$Wc?ae.add(Oe):Array.isArray(ae)&&ae.push(Oe),Oe}}J.fromObservableLight=Ie})(F||(e.Event=F={}));class w{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${w.f++}`,w.all.add(this)}start(K){this.g=new X.$ie,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}e.$ke=w;let v=-1;function p(J){const K=v;return v=J,{dispose(){v=K}}}class c{static{this.f=1}constructor(K,se,V=(c.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=se,this.name=V,this.h=0}dispose(){this.g?.clear()}check(K,se){const V=this.threshold;if(V<=0||se<V)return;this.g||(this.g=new Map);const ne=this.g.get(K.value)||0;if(this.g.set(K.value,ne+1),this.h-=1,this.h<=0){this.h=V*.5;const[re,oe]=this.getMostFrequentStack(),I=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${oe}):`;console.warn(I),console.warn(re);const $=new h(I,re);this.j($)}return()=>{const re=this.g.get(K.value)||0;this.g.set(K.value,re-1)}}getMostFrequentStack(){if(!this.g)return;let K,se=0;for(const[V,ne]of this.g)(!K||se<ne)&&(K=[V,ne],se=ne);return K}}class r{static create(){const K=new Error;return new r(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h extends Error{constructor(K,se){super(K),this.name="ListenerLeakError",this.stack=se}}e.$me=h;class E extends Error{constructor(K,se){super(K),this.name="ListenerRefusalError",this.stack=se}}e.$ne=E;let l=0;class D{constructor(K){this.value=K,this.id=l++}}const A=2,u=(J,K)=>{if(J instanceof D)K(J);else for(let se=0;se<J.length;se++){const V=J[se];V&&K(V)}};let i;if(k){const J=[];setInterval(()=>{J.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(J.join(`
`)),J.length=0)},3e3),i=new FinalizationRegistry(K=>{typeof K=="string"&&J.push(K)})}class n{constructor(K){this.z=0,this.f=K,this.g=v>0||this.f?.leakWarningThreshold?new c(K?.onListenerError??_.$2,this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(L){const K=this.u;queueMicrotask(()=>{u(K,se=>se.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,se,V)=>{if(this.g&&this.z>this.g.threshold**2){const $=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn($);const P=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],W=new E(`${$}. HINT: Stack shows most frequent listener (${P[1]}-times)`,P[0]);return(this.f?.onListenerError||_.$2)(W),q.$Xc.None}if(this.m)return q.$Xc.None;se&&(K=K.bind(se));const ne=new D(K);let re,oe;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(ne.stack=r.create(),re=this.g.check(ne.stack,this.z+1)),L&&(ne.stack=oe??r.create()),this.u?this.u instanceof D?(this.w??=new o,this.u=[this.u,ne]):this.u.push(ne):(this.f?.onWillAddFirstListener?.(this),this.u=ne,this.f?.onDidAddFirstListener?.(this)),this.z++;const I=(0,q.$Vc)(()=>{i?.unregister(I),re?.(),this.A(ne)});if(V instanceof q.$Wc?V.add(I):Array.isArray(V)&&V.push(I),i){const $=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),P=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec($);i.register(I,P?.[2]??$,I)}return I},this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const se=this.u,V=se.indexOf(K);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,se[V]=void 0;const ne=this.w.current===this;if(this.z*A<=se.length){let re=0;for(let oe=0;oe<se.length;oe++)se[oe]?se[re++]=se[oe]:ne&&(this.w.end--,re<this.w.i&&this.w.i--);se.length=re}}B(K,se){if(!K)return;const V=this.f?.onListenerError||_.$2;if(!V){K.value(se);return}try{K.value(se)}catch(ne){V(ne)}}C(K){const se=K.current.u;for(;K.i<K.end;)this.B(se[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof D)this.B(this.u,K);else{const se=this.w;se.enqueue(this,K,this.u.length),this.C(se)}this.j?.stop()}hasListeners(){return this.z>0}}e.$oe=n;const s=()=>new o;e.$pe=s;class o{constructor(){this.i=-1,this.end=0}enqueue(K,se,V){this.i=0,this.end=V,this.current=K,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends n{async fireAsync(K,se,V){if(this.u)for(this.h||(this.h=new j.$8c),u(this.u,ne=>this.h.push([ne.value,K]));this.h.size>0&&!se.isCancellationRequested;){const[ne,re]=this.h.shift(),oe=[],I={...re,token:se,waitUntil:$=>{if(Object.isFrozen(oe))throw new Error("waitUntil can NOT be called asynchronous");V&&($=V($,ne)),oe.push($)}};try{ne(I)}catch($){(0,_.$2)($);continue}Object.freeze(oe),await Promise.allSettled(oe).then($=>{for(const P of $)P.status==="rejected"&&(0,_.$2)(P.reason)})}}}e.$qe=S;class m extends n{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new j.$8c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}e.$re=m;class b extends m{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}e.$se=b;class a extends n{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(se=>super.fire(se)),this.h=[]}))}}e.$te=a;class d{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const se={event:K,listener:null};this.h.push(se),this.g&&this.m(se);const V=()=>{this.g&&this.o(se);const ne=this.h.indexOf(se);this.h.splice(ne,1)};return(0,q.$Vc)((0,t.$fb)(V))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(se=>this.f.fire(se))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}e.$ue=d;class N{constructor(K,se,V,ne){this.f=new q.$Wc;const re=this.f.add(new d),oe=this.f.add(new q.$7c);function I($){oe.set($,re.add(ne($)))}for(const $ of K)I($);this.f.add(se($=>{I($)})),this.f.add(V($=>{oe.deleteAndDispose($)})),this.event=re.event}dispose(){this.f.dispose()}}e.$ve=N;class f{constructor(){this.f=[]}wrapEvent(K,se,V){return(ne,re,oe)=>K(I=>{const $=this.f[this.f.length-1];if(!se){$?$.buffers.push(()=>ne.call(re,I)):ne.call(re,I);return}const P=$;if(!P){ne.call(re,se(V,I));return}P.items??=[],P.items.push(I),P.buffers.length===0&&$.buffers.push(()=>{P.reducedResult??=V?P.items.reduce(se,V):P.items.reduce(se),ne.call(re,P.reducedResult)})},void 0,oe)}bufferEvents(K){const se={buffers:new Array};this.f.push(se);const V=K();return this.f.pop(),se.buffers.forEach(ne=>ne()),V}}e.$we=f;class y{constructor(){this.f=!1,this.g=F.None,this.h=q.$Xc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$xe=y;class z{static const(K){return new x(K)}constructor(K){this.g=K,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}e.$ye=z;class x{constructor(K){this.value=K,this.onDidChange=F.None}}}),define(be[13],_e([0,1,6]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.CancellationToken=void 0,e.$Ae=k;const t=Object.freeze(function(L,O){const F=setTimeout(L.bind(O),0);return{dispose(){clearTimeout(F)}}});var q;(function(L){function O(F){return F===L.None||F===L.Cancelled||F instanceof j?!0:!F||typeof F!="object"?!1:typeof F.isCancellationRequested=="boolean"&&typeof F.onCancellationRequested=="function"}L.isCancellationToken=O,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(q||(e.CancellationToken=q={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new _.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class X{constructor(O){this.f=void 0,this.g=void 0,this.g=O&&O.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=q.Cancelled}dispose(O=!1){O&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=q.None}}e.$ze=X;function k(L){const O=new X;return L.add({dispose(){O.cancel()}}),O.token}}),define(be[43],_e([0,1,13]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cf=e.$bf=e.$_e=void 0,e.$af=q;class t{constructor(L){this.b=L,this.a=null}get(){if(this.a)return this.a;const L=new _.$ze,O=this.b(L.token);return this.a={promise:O,dispose:()=>{this.a=null,L.cancel(),L.dispose()}},this.a}}e.$_e=t;function q(k){return k}class j{constructor(L,O){this.a=void 0,this.b=void 0,typeof L=="function"?(this.c=L,this.d=q):(this.c=O,this.d=L.getCacheKey)}get(L){const O=this.d(L);return this.b!==O&&(this.b=O,this.a=this.c(L)),this.a}}e.$bf=j;class X{get cachedValues(){return this.a}constructor(L,O){this.a=new Map,this.b=new Map,typeof L=="function"?(this.c=L,this.d=q):(this.c=O,this.d=L.getCacheKey)}get(L){const O=this.d(L);if(this.b.has(O))return this.b.get(O);const F=this.c(L);return this.a.set(L,F),this.b.set(O,F),F}}e.$cf=X}),define(be[44],_e([0,1,9,4]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=q,e.$Ce=j,e.$De=X,e.$Ee=k,e.$Fe=O,e.$Ge=F,e.$He=w,e.$Ie=v,e.$Je=p,e.$Ke=c,e.$Le=r,e.$Me=h,e.$Ne=E,e.$Oe=l,e.$Pe=D;function q(A){const u=A;return u?typeof u.read=="function":!1}function j(A){const u=A;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}function X(A){const u=A;return u?j(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function k(A,u){return new L(A,u)}class L{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,_.$2)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let n;switch(u){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const s=n.indexOf(i);s>=0&&n.splice(s,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function O(A,u){const i=[];let n;for(;(n=A.read())!==null;)i.push(n);return u(i)}function F(A,u,i){const n=[];let s;for(;(s=A.read())!==null&&n.length<i;)n.push(s);return s===null&&n.length>0?u(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return A.read()}}}function w(A,u){return new Promise((i,n)=>{const s=[];v(A,{onData:o=>{u&&s.push(o)},onError:o=>{u?n(o):i(void 0)},onEnd:()=>{i(u?u(s):void 0)}})})}function v(A,u,i){A.on("error",n=>{i?.isCancellationRequested||u.onError(n)}),A.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),A.on("data",n=>{i?.isCancellationRequested||u.onData(n)})}function p(A,u){return new Promise((i,n)=>{const s=new t.$Wc,o=[],S=a=>{if(o.push(a),o.length>u)return s.dispose(),A.pause(),i({stream:A,buffer:o,ended:!1})},m=a=>(s.dispose(),n(a)),b=()=>(s.dispose(),i({stream:A,buffer:o,ended:!0}));s.add((0,t.$Vc)(()=>A.removeListener("error",m))),A.on("error",m),s.add((0,t.$Vc)(()=>A.removeListener("end",b))),A.on("end",b),s.add((0,t.$Vc)(()=>A.removeListener("data",S))),A.on("data",S)})}function c(A,u){const i=k(u);return i.end(A),i}function r(){const A=k(()=>{throw new Error("not supported")});return A.end(),A}function h(A){let u=!1;return{read:()=>u?null:(u=!0,A)}}function E(A,u,i){const n=k(i);return v(A,{onData:s=>n.write(u.data(s)),onError:s=>n.error(u.error?u.error(s):s),onEnd:()=>n.end()}),n}function l(A,u,i){let n=!1;return{read:()=>{const s=u.read();return n?s:(n=!0,s!==null?i([A,s]):A)}}}function D(A,u,i){let n=!1;const s=k(i);return v(u,{onData:o=>n?s.write(o):(n=!0,s.write(i([A,o]))),onError:o=>s.error(o),onEnd:()=>{n||(n=!0,s.write(A)),s.end()}}),s}}),define(be[17],_e([0,1,16,44]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=O,e.$Se=F,e.$Te=w,e.$Ue=v,e.$Ve=p,e.$We=c,e.$Xe=r,e.$Ye=h,e.$Ze=E,e.$1e=l,e.$2e=D,e.$3e=A,e.$4e=u,e.$5e=i,e.$6e=n,e.$7e=s,e.$8e=o,e.$9e=S,e.$0e=m,e.$$e=d,t=Ue(t);const q=typeof Buffer<"u",j=new _.$W(()=>new Uint8Array(256));let X,k;class L{static alloc(f){return q?new L(Buffer.allocUnsafe(f)):new L(new Uint8Array(f))}static wrap(f){return q&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new L(f)}static fromString(f,y){return!(y?.dontUseNodeBuffer||!1)&&q?new L(Buffer.from(f)):(X||(X=new TextEncoder),new L(X.encode(f)))}static fromByteArray(f){const y=L.alloc(f.length);for(let z=0,x=f.length;z<x;z++)y.buffer[z]=f[z];return y}static concat(f,y){if(typeof y>"u"){y=0;for(let J=0,K=f.length;J<K;J++)y+=f[J].byteLength}const z=L.alloc(y);let x=0;for(let J=0,K=f.length;J<K;J++){const se=f[J];z.set(se,x),x+=se.byteLength}return z}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=L.alloc(this.byteLength);return f.set(this),f}toString(){return q?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(f,y){return new L(this.buffer.subarray(f,y))}set(f,y){if(f instanceof L)this.buffer.set(f.buffer,y);else if(f instanceof Uint8Array)this.buffer.set(f,y);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),y);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return v(this.buffer,f)}writeUInt32BE(f,y){p(this.buffer,f,y)}readUInt32LE(f){return c(this.buffer,f)}writeUInt32LE(f,y){r(this.buffer,f,y)}readUInt8(f){return h(this.buffer,f)}writeUInt8(f,y){E(this.buffer,f,y)}indexOf(f,y=0){return O(this.buffer,f instanceof L?f.buffer:f,y)}}e.$Qe=L;function O(N,f,y=0){const z=f.byteLength,x=N.byteLength;if(z===0)return 0;if(z===1)return N.indexOf(f[0]);if(z>x-y)return-1;const J=j.value;J.fill(f.length);for(let ne=0;ne<f.length;ne++)J[f[ne]]=f.length-ne-1;let K=y+f.length-1,se=K,V=-1;for(;K<x;)if(N[K]===f[se]){if(se===0){V=K;break}K--,se--}else K+=Math.max(f.length-se,J[N[K]]),se=f.length-1;return V}function F(N,f){return N[f+0]<<0>>>0|N[f+1]<<8>>>0}function w(N,f,y){N[y+0]=f&255,f=f>>>8,N[y+1]=f&255}function v(N,f){return N[f]*2**24+N[f+1]*2**16+N[f+2]*2**8+N[f+3]}function p(N,f,y){N[y+3]=f,f=f>>>8,N[y+2]=f,f=f>>>8,N[y+1]=f,f=f>>>8,N[y]=f}function c(N,f){return N[f+0]<<0>>>0|N[f+1]<<8>>>0|N[f+2]<<16>>>0|N[f+3]<<24>>>0}function r(N,f,y){N[y+0]=f&255,f=f>>>8,N[y+1]=f&255,f=f>>>8,N[y+2]=f&255,f=f>>>8,N[y+3]=f&255}function h(N,f){return N[f]}function E(N,f,y){N[y]=f}function l(N){return t.$Fe(N,f=>L.concat(f))}function D(N){return t.$Me(N)}function A(N){return t.$He(N,f=>L.concat(f))}async function u(N){return N.ended?L.concat(N.buffer):L.concat([...N.buffer,await A(N.stream)])}function i(N){return t.$Ke(N,f=>L.concat(f))}function n(N){return t.$Ne(N,{data:f=>typeof f=="string"?L.fromString(f):L.wrap(f)},f=>L.concat(f))}function s(N){return t.$Ee(f=>L.concat(f),N)}function o(N,f){return t.$Oe(N,f,y=>L.concat(y))}function S(N,f){return t.$Pe(N,f,y=>L.concat(y))}function m(N){let f=0,y=0,z=0;const x=new Uint8Array(Math.floor(N.length/4*3)),J=se=>{switch(y){case 3:x[z++]=f|se,y=0;break;case 2:x[z++]=f|se>>>2,f=se<<6,y=3;break;case 1:x[z++]=f|se>>>4,f=se<<4,y=2;break;default:f=se<<2,y=1}};for(let se=0;se<N.length;se++){const V=N.charCodeAt(se);if(V>=65&&V<=90)J(V-65);else if(V>=97&&V<=122)J(V-97+26);else if(V>=48&&V<=57)J(V-48+52);else if(V===43||V===45)J(62);else if(V===47||V===95)J(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${N[se]}`)}}const K=z;for(;y>0;)J(0);return L.wrap(x).slice(0,K)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:N},f=!0,y=!1){const z=y?a:b;let x="";const J=N.byteLength%3;let K=0;for(;K<N.byteLength-J;K+=3){const se=N[K+0],V=N[K+1],ne=N[K+2];x+=z[se>>>2],x+=z[(se<<4|V>>>4)&63],x+=z[(V<<2|ne>>>6)&63],x+=z[ne&63]}if(J===1){const se=N[K+0];x+=z[se>>>2],x+=z[se<<4&63],f&&(x+="==")}else if(J===2){const se=N[K+0],V=N[K+1];x+=z[se>>>2],x+=z[(se<<4|V>>>4)&63],x+=z[V<<2&63],f&&(x+="=")}return x}}),define(be[45],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=void 0,e.$je=Symbol("MicrotaskDelay")}),define(be[10],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=_,e.$ig=t,e.$jg=q,e.$kg=j,e.$lg=X,e.$mg=k,e.$ng=L,e.$og=O,e.$pg=F,e.$qg=w,e.$rg=v,e.$sg=p,e.$tg=c,e.$ug=h,e.$vg=E,e.$wg=l,e.$xg=D,e.$yg=A,e.$zg=u;function _(i){return typeof i=="string"}function t(i){return Array.isArray(i)&&i.every(n=>_(n))}function q(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function j(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function X(i){return typeof i=="number"&&!isNaN(i)}function k(i){return!!i&&typeof i[Symbol.iterator]=="function"}function L(i){return i===!0||i===!1}function O(i){return typeof i>"u"}function F(i){return!w(i)}function w(i){return O(i)||i===null}function v(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function p(i){if(w(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function c(...i){const n=[];for(let s=0;s<i.length;s++){const o=i[s];if(w(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(o)}return n}const r=Object.prototype.hasOwnProperty;function h(i){if(!q(i))return!1;for(const n in i)if(r.call(i,n))return!1;return!0}function E(i){return typeof i=="function"}function l(...i){return i.length>0&&i.every(E)}function D(i,n){const s=Math.min(i.length,n.length);for(let o=0;o<s;o++)A(i[o],n[o])}function A(i,n){if(_(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(E(n)){try{if(i instanceof n)return}catch{}if(!w(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function u(i){return i}}),define(be[46],_e([0,1,10]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=t,e.$io=q,e.$jo=X,e.$ko=L,e.$lo=O,e.$mo=F,e.$no=w,e.$oo=v,e.$po=p,e.$qo=c,e.$ro=r,e.$so=h,e.$to=E;function t(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const D=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([A,u])=>{D[A]=u&&typeof u=="object"?t(u):u}),D}function q(l){if(!l||typeof l!="object")return l;const D=[l];for(;D.length>0;){const A=D.shift();Object.freeze(A);for(const u in A)if(j.call(A,u)){const i=A[u];typeof i=="object"&&!Object.isFrozen(i)&&!(0,_.$kg)(i)&&D.push(i)}}return l}const j=Object.prototype.hasOwnProperty;function X(l,D){return k(l,D,new Set)}function k(l,D,A){if((0,_.$qg)(l))return l;const u=D(l);if(typeof u<"u")return u;if(Array.isArray(l)){const i=[];for(const n of l)i.push(k(n,D,A));return i}if((0,_.$jg)(l)){if(A.has(l))throw new Error("Cannot clone recursive data-structure");A.add(l);const i={};for(const n in l)j.call(l,n)&&(i[n]=k(l[n],D,A));return A.delete(l),i}return l}function L(l,D,A=!0){return(0,_.$jg)(l)?((0,_.$jg)(D)&&Object.keys(D).forEach(u=>{u in l?A&&((0,_.$jg)(l[u])&&(0,_.$jg)(D[u])?L(l[u],D[u],A):l[u]=D[u]):l[u]=D[u]}),l):D}function O(l,D){if(l===D)return!0;if(l==null||D===null||D===void 0||typeof l!=typeof D||typeof l!="object"||Array.isArray(l)!==Array.isArray(D))return!1;let A,u;if(Array.isArray(l)){if(l.length!==D.length)return!1;for(A=0;A<l.length;A++)if(!O(l[A],D[A]))return!1}else{const i=[];for(u in l)i.push(u);i.sort();const n=[];for(u in D)n.push(u);if(n.sort(),!O(i,n))return!1;for(A=0;A<i.length;A++)if(!O(l[i[A]],D[i[A]]))return!1}return!0}function F(l){const D=new Set;return JSON.stringify(l,(A,u)=>{if((0,_.$jg)(u)||Array.isArray(u)){if(D.has(u))return"[Circular]";D.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function w(l,D){const A=Object.create(null);return!l||!D||Object.keys(D).forEach(i=>{const n=l[i],s=D[i];O(n,s)||(A[i]=s)}),A}function v(l,D){const A=D.toLowerCase(),u=Object.keys(l).find(i=>i.toLowerCase()===A);return u?l[u]:l[D]}function p(l,D){const A=Object.create(null);for(const[u,i]of Object.entries(l))D(u,i)&&(A[u]=i);return A}function c(l){let D=[];for(;Object.prototype!==l;)D=D.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return D}function r(l){const D=[];for(const A of c(l))typeof l[A]=="function"&&D.push(A);return D}function h(l,D){const A=i=>function(){const n=Array.prototype.slice.call(arguments,0);return D(i,n)},u={};for(const i of l)u[i]=A(i);return u}function E(l,D){const A={};for(const[u,i]of Object.entries(l))A[u]=D(i,u);return A}}),define(be[47],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$df=t,e.$ef=q;var _;(function(j){j[j.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",j[j.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",j[j.MAX_UINT_8=255]="MAX_UINT_8",j[j.MAX_UINT_16=65535]="MAX_UINT_16",j[j.MAX_UINT_32=4294967295]="MAX_UINT_32",j[j.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(e.Constants=_={}));function t(j){return j<0?0:j>_.MAX_UINT_8?_.MAX_UINT_8:j|0}function q(j){return j<0?0:j>_.MAX_UINT_32?_.MAX_UINT_32:j|0}}),define(be[7],_e([0,1,43,11,16,47]),function(fe,e,_,t,q,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.$fg=e.$eg=e.GraphemeBreakType=e.$7f=e.$Yf=e.$Rf=e.$Qf=void 0,e.$ff=X,e.$gf=L,e.$hf=F,e.$if=w,e.$jf=v,e.$kf=p,e.$lf=c,e.$mf=r,e.$nf=h,e.$of=E,e.$pf=l,e.$qf=D,e.$rf=A,e.$sf=u,e.$tf=i,e.$uf=n,e.$vf=s,e.$wf=o,e.$xf=S,e.$yf=m,e.$zf=b,e.$Af=a,e.$Bf=d,e.$Cf=N,e.$Df=f,e.$Ef=y,e.$Ff=z,e.$Gf=x,e.$Hf=J,e.$If=K,e.$Jf=se,e.$Kf=V,e.$Lf=ne,e.$Mf=re,e.$Nf=oe,e.$Of=I,e.$Pf=$,e.$Sf=R,e.$Tf=Z,e.$Uf=ee,e.$Vf=ie,e.$Wf=we,e.$Xf=G,e.$Zf=T,e.$1f=g,e.$2f=M,e.$3f=Y,e.$4f=de,e.$5f=De,e.$6f=Ie,e.$8f=ge,e.$9f=le,e.$0f=$e,e.$$f=ae,e.$_f=Ee,e.$ag=ye,e.$bg=Le,e.$cg=Oe,e.$dg=He;function X(U){return!U||typeof U!="string"?!0:U.trim().length===0}const k=/{(\d+)}/g;function L(U,...H){return H.length===0?U:U.replace(k,function(C,ce){const me=parseInt(ce,10);return isNaN(me)||me<0||me>=H.length?C:H[me]})}const O=/{([^}]+)}/g;function F(U,H){return Object.keys(H).length===0?U:U.replace(O,(C,ce)=>H[ce]??C)}function w(U){return U.replace(/[<>"'&]/g,H=>{switch(H){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return H})}function v(U){return U.replace(/[<>&]/g,function(H){switch(H){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return H}})}function p(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(U,H){let C=0,ce=U.indexOf(H);for(;ce!==-1;)C++,ce=U.indexOf(H,ce+H.length);return C}function r(U,H,C="\u2026"){return U.length<=H?U:`${U.substr(0,H)}${C}`}function h(U,H,C="\u2026"){if(U.length<=H)return U;const ce=Math.ceil(H/2)-C.length/2,me=Math.floor(H/2)-C.length/2;return`${U.substr(0,ce)}${C}${U.substr(U.length-me)}`}function E(U,H=" "){const C=l(U,H);return D(C,H)}function l(U,H){if(!U||!H)return U;const C=H.length;if(C===0||U.length===0)return U;let ce=0;for(;U.indexOf(H,ce)===ce;)ce=ce+C;return U.substring(ce)}function D(U,H){if(!U||!H)return U;const C=H.length,ce=U.length;if(C===0||ce===0)return U;let me=ce,ve=-1;for(;ve=U.lastIndexOf(H,me-1),!(ve===-1||ve+C!==me);){if(ve===0)return"";me=ve}return U.substring(0,me)}function A(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(U){return U.replace(/\*/g,"")}function i(U,H,C={}){if(!U)throw new Error("Cannot create regex from empty string");H||(U=p(U)),C.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let ce="";return C.global&&(ce+="g"),C.matchCase||(ce+="i"),C.multiline&&(ce+="m"),C.unicode&&(ce+="u"),new RegExp(U,ce)}function n(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}function s(U){return U.split(/\r\n|\r|\n/)}function o(U){const H=[],C=U.split(/(\r\n|\r|\n)/);for(let ce=0;ce<Math.ceil(C.length/2);ce++)H.push(C[2*ce]+(C[2*ce+1]??""));return H}function S(U){for(let H=0,C=U.length;H<C;H++){const ce=U.charCodeAt(H);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return H}return-1}function m(U,H=0,C=U.length){for(let ce=H;ce<C;ce++){const me=U.charCodeAt(ce);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return U.substring(H,ce)}return U.substring(H,C)}function b(U,H=U.length-1){for(let C=H;C>=0;C--){const ce=U.charCodeAt(C);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return C}return-1}function a(U,H,C){const ce=[];let me=0;for(const ve of U.matchAll(H)){if(ce.push(U.slice(me,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");me=ve.index+ve[0].length,ce.push(C(ve[0],...ve.slice(1),ve.index,U,ve.groups))}return ce.push(U.slice(me)),Promise.all(ce).then(ve=>ve.join(""))}function d(U,H){return U<H?-1:U>H?1:0}function N(U,H,C=0,ce=U.length,me=0,ve=H.length){for(;C<ce&&me<ve;C++,me++){const ke=U.charCodeAt(C),Fe=H.charCodeAt(me);if(ke<Fe)return-1;if(ke>Fe)return 1}const Pe=ce-C,Me=ve-me;return Pe<Me?-1:Pe>Me?1:0}function f(U,H){return y(U,H,0,U.length,0,H.length)}function y(U,H,C=0,ce=U.length,me=0,ve=H.length){for(;C<ce&&me<ve;C++,me++){let ke=U.charCodeAt(C),Fe=H.charCodeAt(me);if(ke===Fe)continue;if(ke>=128||Fe>=128)return N(U.toLowerCase(),H.toLowerCase(),C,ce,me,ve);x(ke)&&(ke-=32),x(Fe)&&(Fe-=32);const Se=ke-Fe;if(Se!==0)return Se}const Pe=ce-C,Me=ve-me;return Pe<Me?-1:Pe>Me?1:0}function z(U){return U>=t.CharCode.Digit0&&U<=t.CharCode.Digit9}function x(U){return U>=t.CharCode.a&&U<=t.CharCode.z}function J(U){return U>=t.CharCode.A&&U<=t.CharCode.Z}function K(U,H){return U.length===H.length&&y(U,H)===0}function se(U,H){const C=H.length;return H.length>U.length?!1:y(U,H,0,C)===0}function V(U,H){const C=Math.min(U.length,H.length);let ce;for(ce=0;ce<C;ce++)if(U.charCodeAt(ce)!==H.charCodeAt(ce))return ce;return C}function ne(U,H){const C=Math.min(U.length,H.length);let ce;const me=U.length-1,ve=H.length-1;for(ce=0;ce<C;ce++)if(U.charCodeAt(me-ce)!==H.charCodeAt(ve-ce))return ce;return C}function re(U){return 55296<=U&&U<=56319}function oe(U){return 56320<=U&&U<=57343}function I(U,H){return(U-55296<<10)+(H-56320)+65536}function $(U,H,C){const ce=U.charCodeAt(C);if(re(ce)&&C+1<H){const me=U.charCodeAt(C+1);if(oe(me))return I(ce,me)}return ce}function P(U,H){const C=U.charCodeAt(H-1);if(oe(C)&&H>1){const ce=U.charCodeAt(H-2);if(re(ce))return I(ce,C)}return C}class W{get offset(){return this.e}constructor(H,C=0){this.c=H,this.d=H.length,this.e=C}setOffset(H){this.e=H}prevCodePoint(){const H=P(this.c,this.e);return this.e-=H>=j.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,H}nextCodePoint(){const H=$(this.c,this.d,this.e);return this.e+=H>=j.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,H}eol(){return this.e>=this.d}}e.$Qf=W;class Q{get offset(){return this.c.offset}constructor(H,C=0){this.c=new W(H,C)}nextGraphemeLength(){const H=Ne.getInstance(),C=this.c,ce=C.offset;let me=H.getGraphemeBreakType(C.nextCodePoint());for(;!C.eol();){const ve=C.offset,Pe=H.getGraphemeBreakType(C.nextCodePoint());if(Te(me,Pe)){C.setOffset(ve);break}me=Pe}return C.offset-ce}prevGraphemeLength(){const H=Ne.getInstance(),C=this.c,ce=C.offset;let me=H.getGraphemeBreakType(C.prevCodePoint());for(;C.offset>0;){const ve=C.offset,Pe=H.getGraphemeBreakType(C.prevCodePoint());if(Te(Pe,me)){C.setOffset(ve);break}me=Pe}return ce-C.offset}eol(){return this.c.eol()}}e.$Rf=Q;function R(U,H){return new Q(U,H).nextGraphemeLength()}function Z(U,H){return new Q(U,H).prevGraphemeLength()}function ee(U,H){H>0&&oe(U.charCodeAt(H))&&H--;const C=H+R(U,H);return[C-Z(U,C),C]}function ie(U){const H=new Q(U);let C=0;for(;!H.eol();)C++,H.nextGraphemeLength();return C}let ue;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(U){return ue||(ue=he()),ue.test(U)}const B=/^[\t\n\r\x20-\x7E]*$/;function G(U){return B.test(U)}e.$Yf=/[\u2028\u2029]/;function T(U){return e.$Yf.test(U)}function g(U){return U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}function M(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129008||U>=129280&&U<=129535||U>=129648&&U<=129782}function Y(U,H,C=""){const ce=U.trimStart();if(ce.length<H)return ce;const me=/\b/g;let ve=0;for(;me.test(ce)&&!(ce.length-me.lastIndex<H);)ve=me.lastIndex,me.lastIndex+=1;return ve===0?ce:C+ce.substring(ve).trimStart()}const te=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*de(U){let H=0;for(const C of U.matchAll(te))H!==C.index&&(yield{isCode:!1,str:U.substring(H,C.index)}),yield{isCode:!0,str:C[0]},H=C.index+C[0].length;H!==U.length&&(yield{isCode:!1,str:U.substring(H)})}function De(U){return U&&(U=U.replace(te,"")),U}const Re=/\\\[.*?\\\]/g;function Ie(U){return De(U).replace(Re,"")}e.$7f=String.fromCharCode(t.CharCode.UTF8_BOM);function ge(U){return!!(U&&U.length>0&&U.charCodeAt(0)===t.CharCode.UTF8_BOM)}function le(U){return ge(U)?U.substr(1):U}function $e(U,H){if(!U||!H||U.length<H.length)return!1;const C=H.length,ce=U.toLowerCase();let me=0,ve=-1;for(;me<C;){const Pe=ce.indexOf(H[me],ve+1);if(Pe<0)return!1;ve=Pe,me++}return!0}function ae(U,H=!1){return U?(H&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}function Ee(U){return U.charAt(0).toUpperCase()+U.slice(1)}function ye(U,H=1){if(H===0)return"";let C=-1;do C=U.indexOf(`
`,C+1),H--;while(H>0&&C>=0);return C===-1?U:(U[C-1]==="\r"&&C--,U.substr(0,C))}function Le(U){const H=t.CharCode.Z-t.CharCode.A+1;return U=U%(2*H),U<H?String.fromCharCode(t.CharCode.a+U):String.fromCharCode(t.CharCode.A+U-H)}function Oe(U){return Ne.getInstance().getGraphemeBreakType(U)}function Te(U,H){return U===Ae.Other?H!==Ae.Extend&&H!==Ae.SpacingMark:U===Ae.CR&&H===Ae.LF?!1:U===Ae.Control||U===Ae.CR||U===Ae.LF||H===Ae.Control||H===Ae.CR||H===Ae.LF?!0:!(U===Ae.L&&(H===Ae.L||H===Ae.V||H===Ae.LV||H===Ae.LVT)||(U===Ae.LV||U===Ae.V)&&(H===Ae.V||H===Ae.T)||(U===Ae.LVT||U===Ae.T)&&H===Ae.T||H===Ae.Extend||H===Ae.ZWJ||H===Ae.SpacingMark||U===Ae.Prepend||U===Ae.ZWJ&&H===Ae.Extended_Pictographic||U===Ae.Regional_Indicator&&H===Ae.Regional_Indicator)}var Ae;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Ne{static{this.c=null}static getInstance(){return Ne.c||(Ne.c=new Ne),Ne.c}constructor(){this.d=Be()}getGraphemeBreakType(H){if(H<32)return H===t.CharCode.LineFeed?Ae.LF:H===t.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(H<127)return Ae.Other;const C=this.d,ce=C.length/3;let me=1;for(;me<=ce;)if(H<C[3*me])me=2*me;else if(H>C[3*me+1])me=2*me+1;else return C[3*me+2];return Ae.Other}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(U,H){if(U===0)return 0;const C=We(U,H);if(C!==void 0)return C;const ce=new W(H,U);return ce.prevCodePoint(),ce.offset}function We(U,H){const C=new W(H,U);let ce=C.prevCodePoint();for(;Ve(ce)||ce===qe.emojiVariantSelector||ce===qe.enclosingKeyCap;){if(C.offset===0)return;ce=C.prevCodePoint()}if(!M(ce))return;let me=C.offset;return me>0&&C.prevCodePoint()===qe.zwj&&(me=C.offset),me}function Ve(U){return 127995<=U&&U<=127999}var qe;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$eg="\xA0";class ze{static{this.c=new q.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new _.$bf({getCacheKey:JSON.stringify},H=>{function C(Se){const je=new Map;for(let pe=0;pe<Se.length;pe+=2)je.set(Se[pe],Se[pe+1]);return je}function ce(Se,je){const pe=new Map(Se);for(const[Ke,Xe]of je)pe.set(Ke,Xe);return pe}function me(Se,je){if(!Se)return je;const pe=new Map;for(const[Ke,Xe]of Se)je.has(Ke)&&pe.set(Ke,Xe);return pe}const ve=this.c.value;let Pe=H.filter(Se=>!Se.startsWith("_")&&Se in ve);Pe.length===0&&(Pe=["_default"]);let Me;for(const Se of Pe){const je=C(ve[Se]);Me=me(Me,je)}const ke=C(ve._common),Fe=ce(ke,Me);return new ze(Fe)})}static getInstance(H){return ze.d.get(Array.from(H))}static{this.e=new q.$W(()=>Object.keys(ze.c.value).filter(H=>!H.startsWith("_")))}static getLocales(){return ze.e.value}constructor(H){this.f=H}isAmbiguous(H){return this.f.has(H)}containsAmbiguousCharacter(H){for(let C=0;C<H.length;C++){const ce=H.codePointAt(C);if(typeof ce=="number"&&this.isAmbiguous(ce))return!0}return!1}getPrimaryConfusable(H){return this.f.get(H)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$fg=ze;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(H){return Ge.e().has(H)}static containsInvisibleCharacter(H){for(let C=0;C<H.length;C++){const ce=H.codePointAt(C);if(typeof ce=="number"&&Ge.isInvisibleCharacter(ce))return!0}return!1}static get codePoints(){return Ge.e()}}e.$gg=Ge}),define(be[14],_e([0,1,11,3,2,7,10]),function(fe,e,_,t,q,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=k,e.$Bg=L,e.$Cg=O,e.$Dg=F,e.$Eg=w,e.$Fg=r,e.$Gg=h,e.$Hg=E,e.$Ig=l,e.$Jg=D,e.$Kg=A,e.$Lg=u,e.$Mg=i,e.$Ng=n,e.$Og=s,e.$Pg=o,e.$Qg=b;function k(a){return a===_.CharCode.Slash||a===_.CharCode.Backslash}function L(a){return a.replace(/[\\/]/g,t.$jc.sep)}function O(a){return a.indexOf("/")===-1&&(a=L(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function F(a,d=t.$jc.sep){if(!a)return"";const N=a.length,f=a.charCodeAt(0);if(k(f)){if(k(a.charCodeAt(1))&&!k(a.charCodeAt(2))){let z=3;const x=z;for(;z<N&&!k(a.charCodeAt(z));z++);if(x!==z&&!k(a.charCodeAt(z+1))){for(z+=1;z<N;z++)if(k(a.charCodeAt(z)))return a.slice(0,z+1).replace(/[\\/]/g,d)}}return d}else if(l(f)&&a.charCodeAt(1)===_.CharCode.Colon)return k(a.charCodeAt(2))?a.slice(0,2)+d:a.slice(0,2);let y=a.indexOf("://");if(y!==-1){for(y+=3;y<N;y++)if(k(a.charCodeAt(y)))return a.slice(0,y+1)}return""}function w(a){if(!q.$j||!a||a.length<5)return!1;let d=a.charCodeAt(0);if(d!==_.CharCode.Backslash||(d=a.charCodeAt(1),d!==_.CharCode.Backslash))return!1;let N=2;const f=N;for(;N<a.length&&(d=a.charCodeAt(N),d!==_.CharCode.Backslash);N++);return!(f===N||(d=a.charCodeAt(N+1),isNaN(d)||d===_.CharCode.Backslash))}const v=/[\\/:\*\?"<>\|]/g,p=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(a,d=q.$j){const N=d?v:p;return!(!a||a.length===0||/^\s+$/.test(a)||(N.lastIndex=0,N.test(a))||d&&c.test(a)||a==="."||a===".."||d&&a[a.length-1]==="."||d&&a.length!==a.trim().length||a.length>255)}function h(a,d,N){const f=a===d;return!N||f?f:!a||!d?!1:(0,j.$If)(a,d)}function E(a,d,N,f=t.sep){if(a===d)return!0;if(!a||!d||d.length>a.length)return!1;if(N){if(!(0,j.$Jf)(a,d))return!1;if(d.length===a.length)return!0;let z=d.length;return d.charAt(d.length-1)===f&&z--,a.charAt(z)===f}return d.charAt(d.length-1)!==f&&(d+=f),a.indexOf(d)===0}function l(a){return a>=_.CharCode.A&&a<=_.CharCode.Z||a>=_.CharCode.a&&a<=_.CharCode.z}function D(a,d){return q.$j&&a.endsWith(":")&&(a+=t.sep),(0,t.$lc)(a)||(a=(0,t.$mc)(d,a)),a=(0,t.$kc)(a),A(a)}function A(a){return q.$j?(a=(0,j.$qf)(a,t.sep),a.endsWith(":")&&(a+=t.sep)):(a=(0,j.$qf)(a,t.sep),a||(a=t.sep)),a}function u(a){const d=(0,t.$kc)(a);return q.$j?a.length>3?!1:i(d)&&(a.length===2||d.charCodeAt(2)===_.CharCode.Backslash):d===t.$jc.sep}function i(a,d=q.$j){return d?l(a.charCodeAt(0))&&a.charCodeAt(1)===_.CharCode.Colon:!1}function n(a,d=q.$j){return i(a,d)?a[0]:void 0}function s(a,d,N){return d.length>a.length?-1:a===d?0:(N&&(a=a.toLowerCase(),d=d.toLowerCase()),a.indexOf(d))}function o(a){const d=a.split(":");let N,f,y;for(const z of d){const x=Number(z);(0,X.$lg)(x)?f===void 0?f=x:y===void 0&&(y=x):N=N?[N,z].join(":"):z}if(!N)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:N,line:f!==void 0?f:void 0,column:y!==void 0?y:f!==void 0?1:void 0}}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",m="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(a,d,N=8){let f="";for(let z=0;z<N;z++){let x;z===0&&q.$j&&!d&&(N===3||N===4)?x=m:x=S,f+=x.charAt(Math.floor(Math.random()*x.length))}let y;return d?y=`${d}-${f}`:y=f,a?(0,t.$mc)(a,y):y}}),define(be[30],_e([0,1,12,11,7]),function(fe,e,_,t,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class j{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const r=c.charCodeAt(0),h=this.b.charCodeAt(this.c);return r-h}value(){return this.b[this.c]}}e.$Ki=j;class X{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,q.$Cf)(c,this.b,0,c.length,this.c,this.d):(0,q.$Ef)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=X;class k{constructor(c=!0,r=!0){this.f=c,this.g=r}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let r=c.length-1;r>=0;r--,this.c--){const h=this.b.charCodeAt(r);if(!(h===t.CharCode.Slash||this.f&&h===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===t.CharCode.Slash||this.f&&r===t.CharCode.Backslash)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,q.$Cf)(c,this.b,0,c.length,this.d,this.e):(0,q.$Ef)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=k;var L;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(L||(L={}));class O{constructor(c,r){this.f=c,this.g=r,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(L.Scheme),this.c.authority&&this.d.push(L.Authority),this.c.path&&(this.b=new k(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(L.Path)),this.g(c)||(this.c.query&&this.d.push(L.Query),this.c.fragment&&this.d.push(L.Fragment)),this.e=0,this}next(){return this.d[this.e]===L.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===L.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===L.Scheme)return(0,q.$Df)(c,this.c.scheme);if(this.d[this.e]===L.Authority)return(0,q.$Df)(c,this.c.authority);if(this.d[this.e]===L.Path)return this.b.cmp(c);if(this.d[this.e]===L.Query)return(0,q.$Bf)(c,this.c.query);if(this.d[this.e]===L.Fragment)return(0,q.$Bf)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===L.Scheme)return this.c.scheme;if(this.d[this.e]===L.Authority)return this.c.authority;if(this.d[this.e]===L.Path)return this.b.value();if(this.d[this.e]===L.Query)return this.c.query;if(this.d[this.e]===L.Fragment)return this.c.fragment;throw new Error}}e.$Ni=O;class F{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(w||(w={}));class v{static forUris(c=()=>!1,r=()=>!1){return new v(new O(c,r))}static forPaths(c=!1){return new v(new k(void 0,!c))}static forStrings(){return new v(new j)}static forConfigKeys(){return new v(new X)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,r){if(r){const h=r.slice(0);(0,_.$Yb)(h);for(const E of h)this.set(E,c)}else{const h=c.slice(0);(0,_.$Yb)(h);for(const E of h)this.set(E[0],E[1])}}set(c,r){const h=this.b.reset(c);let E;this.c||(this.c=new F,this.c.segment=h.value());const l=[];for(E=this.c;;){const A=h.cmp(E.segment);if(A>0)E.left||(E.left=new F,E.left.segment=h.value()),l.push([w.Left,E]),E=E.left;else if(A<0)E.right||(E.right=new F,E.right.segment=h.value()),l.push([w.Right,E]),E=E.right;else if(h.hasNext())h.next(),E.mid||(E.mid=new F,E.mid.segment=h.value()),l.push([w.Mid,E]),E=E.mid;else break}const D=E.value;E.value=r,E.key=c;for(let A=l.length-1;A>=0;A--){const u=l[A][1];u.updateHeight();const i=u.balanceFactor();if(i<-1||i>1){const n=l[A][0],s=l[A+1][0];if(n===w.Right&&s===w.Right)l[A][1]=u.rotateLeft();else if(n===w.Left&&s===w.Left)l[A][1]=u.rotateRight();else if(n===w.Right&&s===w.Left)u.right=l[A+1][1]=l[A+1][1].rotateRight(),l[A][1]=u.rotateLeft();else if(n===w.Left&&s===w.Right)u.left=l[A+1][1]=l[A+1][1].rotateLeft(),l[A][1]=u.rotateRight();else throw new Error;if(A>0)switch(l[A-1][0]){case w.Left:l[A-1][1].left=l[A][1];break;case w.Right:l[A-1][1].right=l[A][1];break;case w.Mid:l[A-1][1].mid=l[A][1];break}else this.c=l[0][1]}}return D}get(c){return this.d(c)?.value}d(c){const r=this.b.reset(c);let h=this.c;for(;h;){const E=r.cmp(h.segment);if(E>0)h=h.left;else if(E<0)h=h.right;else if(r.hasNext())r.next(),h=h.mid;else break}return h}has(c){const r=this.d(c);return!(r?.value===void 0&&r?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,r){const h=this.b.reset(c),E=[];let l=this.c;for(;l;){const D=h.cmp(l.segment);if(D>0)E.push([w.Left,l]),l=l.left;else if(D<0)E.push([w.Right,l]),l=l.right;else if(h.hasNext())h.next(),E.push([w.Mid,l]),l=l.mid;else break}if(l){if(r?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const D=this.f(l.right);if(D.key){const{key:A,value:u,segment:i}=D;this.e(D.key,!1),l.key=A,l.value=u,l.segment=i}}else{const D=l.left??l.right;if(E.length>0){const[A,u]=E[E.length-1];switch(A){case w.Left:u.left=D;break;case w.Mid:u.mid=D;break;case w.Right:u.right=D;break}}else this.c=D}for(let D=E.length-1;D>=0;D--){const A=E[D][1];A.updateHeight();const u=A.balanceFactor();if(u>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),E[D][1]=A.rotateLeft()):u<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),E[D][1]=A.rotateRight()),D>0)switch(E[D-1][0]){case w.Left:E[D-1][1].left=E[D][1];break;case w.Right:E[D-1][1].right=E[D][1];break;case w.Mid:E[D-1][1].mid=E[D][1];break}else this.c=E[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const r=this.b.reset(c);let h=this.c,E;for(;h;){const l=r.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(r.hasNext())r.next(),E=h.value||E,h=h.mid;else break}return h&&h.value||E}findSuperstr(c){return this.g(c,!1)}g(c,r){const h=this.b.reset(c);let E=this.c;for(;E;){const l=h.cmp(E.segment);if(l>0)E=E.left;else if(l<0)E=E.right;else if(h.hasNext())h.next(),E=E.mid;else return E.mid?this.h(E.mid):r?E.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[r,h]of this)c(h,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const r=[];return this.j(c,r),r[Symbol.iterator]()}j(c,r){c&&(c.left&&this.j(c.left,r),c.value&&r.push([c.key,c.value]),c.mid&&this.j(c.mid,r),c.right&&this.j(c.right,r))}_isBalanced(){const c=r=>{if(!r)return!0;const h=r.balanceFactor();return h<-1||h>1?!1:c(r.left)&&c(r.right)};return c(this.c)}}e.$Oi=v}),define(be[5],_e([0,1,11,27,3,2]),function(fe,e,_,t,q,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=h,e.$zc=i,q=Ue(q);const X=/^\w[\w\d+.-]*$/,k=/^\//,L=/^\/\//;function O(m,b){if(!m.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!X.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!k.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function F(m,b){return!m&&!b?"file":m}function w(m,b){switch(m){case"https":case"http":case"file":b?b[0]!==p&&(b=p+b):b=p;break}return b}const v="",p="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(b){return b instanceof r?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,a,d,N,f,y=!1){typeof b=="object"?(this.scheme=b.scheme||v,this.authority=b.authority||v,this.path=b.path||v,this.query=b.query||v,this.fragment=b.fragment||v):(this.scheme=F(b,y),this.authority=a||v,this.path=w(this.scheme,d||v),this.query=N||v,this.fragment=f||v,O(this,y))}get fsPath(){return i(this,!1)}with(b){if(!b)return this;let{scheme:a,authority:d,path:N,query:f,fragment:y}=b;return a===void 0?a=this.scheme:a===null&&(a=v),d===void 0?d=this.authority:d===null&&(d=v),N===void 0?N=this.path:N===null&&(N=v),f===void 0?f=this.query:f===null&&(f=v),y===void 0?y=this.fragment:y===null&&(y=v),a===this.scheme&&d===this.authority&&N===this.path&&f===this.query&&y===this.fragment?this:new l(a,d,N,f,y)}static parse(b,a=!1){const d=c.exec(b);return d?new l(d[2]||v,S(d[4]||v),S(d[5]||v),S(d[7]||v),S(d[9]||v),a):new l(v,v,v,v,v)}static file(b){let a=v;if(j.$j&&(b=b.replace(/\\/g,p)),b[0]===p&&b[1]===p){const d=b.indexOf(p,2);d===-1?(a=b.substring(2),b=p):(a=b.substring(2,d),b=b.substring(d)||p)}return new l("file",a,b,v,v)}static from(b,a){return new l(b.scheme,b.authority,b.path,b.query,b.fragment,a)}static joinPath(b,...a){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return j.$j&&b.scheme==="file"?d=r.file(q.$ic.join(i(b,!0),...a)).path:d=q.$jc.join(b.path,...a),b.with({path:d})}toString(b=!1){return n(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof r)return b;{const a=new l(b);return a._formatted=b.external??null,a._fsPath=b._sep===E?b.fsPath??null:null,a}}else return b}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=r;function h(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}const E=j.$j?1:void 0;class l extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(b=!1){return b?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const b={$mid:t.MarshalledId.Uri};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=E),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const D={[_.CharCode.Colon]:"%3A",[_.CharCode.Slash]:"%2F",[_.CharCode.QuestionMark]:"%3F",[_.CharCode.Hash]:"%23",[_.CharCode.OpenSquareBracket]:"%5B",[_.CharCode.CloseSquareBracket]:"%5D",[_.CharCode.AtSign]:"%40",[_.CharCode.ExclamationMark]:"%21",[_.CharCode.DollarSign]:"%24",[_.CharCode.Ampersand]:"%26",[_.CharCode.SingleQuote]:"%27",[_.CharCode.OpenParen]:"%28",[_.CharCode.CloseParen]:"%29",[_.CharCode.Asterisk]:"%2A",[_.CharCode.Plus]:"%2B",[_.CharCode.Comma]:"%2C",[_.CharCode.Semicolon]:"%3B",[_.CharCode.Equals]:"%3D",[_.CharCode.Space]:"%20"};function A(m,b,a){let d,N=-1;for(let f=0;f<m.length;f++){const y=m.charCodeAt(f);if(y>=_.CharCode.a&&y<=_.CharCode.z||y>=_.CharCode.A&&y<=_.CharCode.Z||y>=_.CharCode.Digit0&&y<=_.CharCode.Digit9||y===_.CharCode.Dash||y===_.CharCode.Period||y===_.CharCode.Underline||y===_.CharCode.Tilde||b&&y===_.CharCode.Slash||a&&y===_.CharCode.OpenSquareBracket||a&&y===_.CharCode.CloseSquareBracket||a&&y===_.CharCode.Colon)N!==-1&&(d+=encodeURIComponent(m.substring(N,f)),N=-1),d!==void 0&&(d+=m.charAt(f));else{d===void 0&&(d=m.substr(0,f));const z=D[y];z!==void 0?(N!==-1&&(d+=encodeURIComponent(m.substring(N,f)),N=-1),d+=z):N===-1&&(N=f)}}return N!==-1&&(d+=encodeURIComponent(m.substring(N))),d!==void 0?d:m}function u(m){let b;for(let a=0;a<m.length;a++){const d=m.charCodeAt(a);d===_.CharCode.Hash||d===_.CharCode.QuestionMark?(b===void 0&&(b=m.substr(0,a)),b+=D[d]):b!==void 0&&(b+=m[a])}return b!==void 0?b:m}function i(m,b){let a;return m.authority&&m.path.length>1&&m.scheme==="file"?a=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===_.CharCode.Slash&&(m.path.charCodeAt(1)>=_.CharCode.A&&m.path.charCodeAt(1)<=_.CharCode.Z||m.path.charCodeAt(1)>=_.CharCode.a&&m.path.charCodeAt(1)<=_.CharCode.z)&&m.path.charCodeAt(2)===_.CharCode.Colon?b?a=m.path.substr(1):a=m.path[1].toLowerCase()+m.path.substr(2):a=m.path,j.$j&&(a=a.replace(/\//g,"\\")),a}function n(m,b){const a=b?u:A;let d="",{scheme:N,authority:f,path:y,query:z,fragment:x}=m;if(N&&(d+=N,d+=":"),(f||N==="file")&&(d+=p,d+=p),f){let J=f.indexOf("@");if(J!==-1){const K=f.substr(0,J);f=f.substr(J+1),J=K.lastIndexOf(":"),J===-1?d+=a(K,!1,!1):(d+=a(K.substr(0,J),!1,!1),d+=":",d+=a(K.substr(J+1),!1,!0)),d+="@"}f=f.toLowerCase(),J=f.lastIndexOf(":"),J===-1?d+=a(f,!1,!0):(d+=a(f.substr(0,J),!1,!0),d+=f.substr(J))}if(y){if(y.length>=3&&y.charCodeAt(0)===_.CharCode.Slash&&y.charCodeAt(2)===_.CharCode.Colon){const J=y.charCodeAt(1);J>=_.CharCode.A&&J<=_.CharCode.Z&&(y=`/${String.fromCharCode(J+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===_.CharCode.Colon){const J=y.charCodeAt(0);J>=_.CharCode.A&&J<=_.CharCode.Z&&(y=`${String.fromCharCode(J+32)}:${y.substr(2)}`)}d+=a(y,!0,!1)}return z&&(d+="?",d+=a(z,!1,!1)),x&&(d+="#",d+=b?x:A(x,!1,!1)),d}function s(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+s(m.substr(3)):m}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(m){return m.match(o)?m.replace(o,b=>s(b)):m}}),define(be[48],_e([0,1,5]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=t,e.$jr=q,e.$kr=j,e.log=k;function t(O){const F=O;return F&&typeof F.type=="string"&&typeof F.severity=="string"}function q(O){const F=[];let w;try{const v=JSON.parse(O.arguments),p=v[v.length-1];p&&p.__$stack&&(v.pop(),w=p.__$stack),F.push(...v)}catch{F.push("Unable to log remote console arguments",O.arguments)}return{args:F,stack:w}}function j(O){if(typeof O!="string")return j(q(O).stack);const F=O;if(F){const w=X(F),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(v&&v.length===4)return{uri:_.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function X(O){if(!O)return O;const F=O.indexOf(`
`);return F===-1?O:O.substring(0,F)}function k(O,F){const{args:w,stack:v}=q(O),p=typeof w[0]=="string"&&w.length===1;let c=X(v);c&&(c=`(${c.trim()})`);let r=[];if(typeof w[0]=="string"?c&&p?r=[`%c[${F}] %c${w[0]} %c${c}`,L("blue"),L(""),L("grey")]:r=[`%c[${F}] %c${w[0]}`,L("blue"),L(""),...w.slice(1)]:r=[`%c[${F}]%`,L("blue"),...w],c&&!p&&r.push(c),typeof console[O.severity]!="function")throw new Error("Unknown console method");console[O.severity].apply(console,r)}function L(O){return`color: ${O}`}}),define(be[49],_e([0,1,17,5,27]),function(fe,e,_,t,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=j,e.$ei=X,e.$fi=L;function j(O){return JSON.stringify(O,k)}function X(O){let F=JSON.parse(O);return F=L(F),F}function k(O,F){return F instanceof RegExp?{$mid:q.MarshalledId.Regexp,source:F.source,flags:F.flags}:F}function L(O,F=0){if(!O||F>200)return O;if(typeof O=="object"){switch(O.$mid){case q.MarshalledId.Uri:return t.URI.revive(O);case q.MarshalledId.Regexp:return new RegExp(O.source,O.flags);case q.MarshalledId.Date:return new Date(O.source)}if(O instanceof _.$Qe||O instanceof Uint8Array)return O;if(Array.isArray(O))for(let w=0;w<O.length;++w)O[w]=L(O[w],F+1);else for(const w in O)Object.hasOwnProperty.call(O,w)&&(O[w]=L(O[w],F+1))}return O}}),define(be[31],_e([0,1,9,2,7,5,3]),function(fe,e,_,t,q,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Vg=e.$Ug=e.$Tg=e.Schemas=void 0,e.$Rg=L,e.$Sg=O,e.$Wg=w,_=Ue(_),t=Ue(t),X=Ue(X);var k;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting",c.outputChannel="output"})(k||(e.Schemas=k={}));function L(c,r){return j.URI.isUri(c)?(0,q.$If)(c.scheme,r):(0,q.$Jf)(c,r+":")}function O(c,...r){return r.some(h=>L(c,h))}e.$Tg="vscode-tkn",e.$Ug="tkn";class F{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,h){this.f=w(r,h)}getServerRootPath(){return this.f}get g(){return X.$jc.join(this.f,k.vscodeRemoteResource)}set(r,h,E){this.a[r]=h,this.b[r]=E}setConnectionToken(r,h){this.c[r]=h}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(u){return _.$2(u),r}const h=r.authority;let E=this.a[h];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const l=this.b[h],D=this.c[h];let A=`path=${encodeURIComponent(r.path)}`;return typeof D=="string"&&(A+=`&${e.$Ug}=${encodeURIComponent(D)}`),j.URI.from({scheme:t.$p?this.d:k.vscodeRemoteResource,authority:`${E}:${l}`,path:this.g,query:A})}}e.$Vg=new F;function w(c,r){return X.$jc.join(r??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Xg="vs/../../extensions",e.$Yg="vs/../../node_modules",e.$Zg="vs/../../node_modules.asar",e.$1g="vs/../../node_modules.asar.unpacked",e.$2g="vscode-app";class v{static{this.a=e.$2g}asBrowserUri(r){const h=this.b(r,fe);return this.uriToBrowserUri(h)}uriToBrowserUri(r){return r.scheme===k.vscodeRemote?e.$Vg.rewrite(r):r.scheme===k.file&&(t.$n||t.$r===`${k.vscodeFileResource}://${v.a}`)?r.with({scheme:k.vscodeFileResource,authority:r.authority||v.a,query:null,fragment:null}):r}asFileUri(r){const h=this.b(r,fe);return this.uriToFileUri(h)}uriToFileUri(r){return r.scheme===k.vscodeFileResource?r.with({scheme:k.file,authority:r.authority!==v.a?r.authority:null,query:null,fragment:null}):r}b(r,h){if(j.URI.isUri(r))return r;if(globalThis._VSCODE_FILE_ROOT){const E=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(E))return j.URI.joinPath(j.URI.parse(E,!0),r);const l=X.$mc(E,r);return j.URI.file(l)}return j.URI.parse(h.toUrl(r))}}e.$3g=new v;var p;(function(c){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(r.get("3"));const h="vscode-coi";function E(D){let A;typeof D=="string"?A=new URL(D).searchParams:D instanceof URL?A=D.searchParams:j.URI.isUri(D)&&(A=new URL(D.toString(!0)).searchParams);const u=A?.get(h);if(u)return r.get(u)}c.getHeadersFromQuery=E;function l(D,A,u){if(!globalThis.crossOriginIsolated)return;const i=A&&u?"3":u?"2":"1";D instanceof URLSearchParams?D.set(h,i):D[h]=i}c.addSearchParam=l})(p||(e.COI=p={}))}),define(be[22],_e([0,1,11,14,31,3,2,7,5]),function(fe,e,_,t,q,j,X,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0,e.$0g=O,e.$sh=w,e.$th=p,t=Ue(t),j=Ue(j);function O(c){return(0,L.$zc)(c,!0)}class F{constructor(r){this.a=r}compare(r,h,E=!1){return r===h?0:(0,k.$Bf)(this.getComparisonKey(r,E),this.getComparisonKey(h,E))}isEqual(r,h,E=!1){return r===h?!0:!r||!h?!1:this.getComparisonKey(r,E)===this.getComparisonKey(h,E)}getComparisonKey(r,h=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,h,E=!1){if(r.scheme===h.scheme){if(r.scheme===q.Schemas.file)return t.$Hg(O(r),O(h),this.a(r))&&r.query===h.query&&(E||r.fragment===h.fragment);if((0,e.$oh)(r.authority,h.authority))return t.$Hg(r.path,h.path,this.a(r),"/")&&r.query===h.query&&(E||r.fragment===h.fragment)}return!1}joinPath(r,...h){return L.URI.joinPath(r,...h)}basenameOrAuthority(r){return(0,e.$gh)(r)||r.authority}basename(r){return j.$jc.basename(r.path)}extname(r){return j.$jc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let h;return r.scheme===q.Schemas.file?h=L.URI.file(j.$pc(O(r))).path:(h=j.$jc.dirname(r.path),r.authority&&h.length&&h.charCodeAt(0)!==_.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),h="/")),r.with({path:h})}normalizePath(r){if(!r.path.length)return r;let h;return r.scheme===q.Schemas.file?h=L.URI.file(j.$kc(O(r))).path:h=j.$jc.normalize(r.path),r.with({path:h})}relativePath(r,h){if(r.scheme!==h.scheme||!(0,e.$oh)(r.authority,h.authority))return;if(r.scheme===q.Schemas.file){const D=j.$oc(O(r),O(h));return X.$j?t.$Bg(D):D}let E=r.path||"/";const l=h.path||"/";if(this.a(r)){let D=0;for(const A=Math.min(E.length,l.length);D<A&&!(E.charCodeAt(D)!==l.charCodeAt(D)&&E.charAt(D).toLowerCase()!==l.charAt(D).toLowerCase());D++);E=l.substr(0,D)+E.substr(D)}return j.$jc.relative(E,l)}resolvePath(r,h){if(r.scheme===q.Schemas.file){const E=L.URI.file(j.$nc(O(r),h));return r.with({authority:E.authority,path:E.path})}return h=t.$Cg(h),r.with({path:j.$jc.resolve(r.path,h)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,h){return r===h||r!==void 0&&h!==void 0&&(0,k.$If)(r,h)}hasTrailingPathSeparator(r,h=j.sep){if(r.scheme===q.Schemas.file){const E=O(r);return E.length>t.$Dg(E).length&&E[E.length-1]===h}else{const E=r.path;return E.length>1&&E.charCodeAt(E.length-1)===_.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,h=j.sep){return(0,e.$ph)(r,h)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,h=j.sep){let E=!1;if(r.scheme===q.Schemas.file){const l=O(r);E=l!==void 0&&l.length===t.$Dg(l).length&&l[l.length-1]===h}else{h="/";const l=r.path;E=l.length===1&&l.charCodeAt(l.length-1)===_.CharCode.Slash}return!E&&!(0,e.$ph)(r,h)?r.with({path:r.path+"/"}):r}}e.$$g=F,e.$_g=new F(()=>!1),e.$ah=new F(c=>c.scheme===q.Schemas.file?!X.$l:!0),e.$bh=new F(c=>!0),e.$ch=e.$_g.isEqual.bind(e.$_g),e.$dh=e.$_g.isEqualOrParent.bind(e.$_g),e.$eh=e.$_g.getComparisonKey.bind(e.$_g),e.$fh=e.$_g.basenameOrAuthority.bind(e.$_g),e.$gh=e.$_g.basename.bind(e.$_g),e.$hh=e.$_g.extname.bind(e.$_g),e.$ih=e.$_g.dirname.bind(e.$_g),e.$jh=e.$_g.joinPath.bind(e.$_g),e.$kh=e.$_g.normalizePath.bind(e.$_g),e.$lh=e.$_g.relativePath.bind(e.$_g),e.$mh=e.$_g.resolvePath.bind(e.$_g),e.$nh=e.$_g.isAbsolutePath.bind(e.$_g),e.$oh=e.$_g.isEqualAuthority.bind(e.$_g),e.$ph=e.$_g.hasTrailingPathSeparator.bind(e.$_g),e.$qh=e.$_g.removeTrailingPathSeparator.bind(e.$_g),e.$rh=e.$_g.addTrailingPathSeparator.bind(e.$_g);function w(c,r){const h=[];for(let E=0;E<c.length;E++){const l=r(c[E]);c.some((D,A)=>A===E?!1:(0,e.$dh)(l,r(D)))||h.push(c[E])}return h}var v;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function r(h){const E=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(A=>{const[u,i]=A.split(":");u&&i&&E.set(u,i)});const D=h.path.substring(0,h.path.indexOf(";"));return D&&E.set(c.META_DATA_MIME,D),E}c.parseMetaData=r})(v||(e.DataUri=v={}));function p(c,r,h){if(r){let E=c.path;return E&&E[0]!==j.$jc.sep&&(E=j.$jc.sep+E),c.with({scheme:h,authority:r,path:E})}return c.with({scheme:h})}}),define(be[8],_e([0,1,13,9,6,4,22,2,45,16]),function(fe,e,_,t,q,j,X,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$0h=e.$9h=e.$8h=e.$7h=e.Promises=e.$6h=e.$5h=e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0,e.$uh=F,e.$vh=w,e.$wh=v,e.$xh=p,e.$yh=c,e.$zh=r,e.$Ah=h,e.$Bh=E,e.$Jh=m,e.$Kh=b,e.$Lh=a,e.$Mh=d,e.$Nh=N,e.$3h=$,e.$$h=B;function F(T){return!!T&&typeof T.then=="function"}function w(T){const g=new _.$ze,M=T(g.token),Y=new Promise((te,de)=>{const De=g.token.onCancellationRequested(()=>{De.dispose(),de(new t.$7)});Promise.resolve(M).then(Re=>{De.dispose(),g.dispose(),te(Re)},Re=>{De.dispose(),g.dispose(),de(Re)})});return new class{cancel(){g.cancel(),g.dispose()}then(te,de){return Y.then(te,de)}catch(te){return this.then(void 0,te)}finally(te){return Y.finally(te)}}}function v(T,g,M){return new Promise((Y,te)=>{const de=g.onCancellationRequested(()=>{de.dispose(),Y(M)});T.then(Y,te).finally(()=>de.dispose())})}function p(T,g){return new Promise((M,Y)=>{const te=g.onCancellationRequested(()=>{te.dispose(),Y(new t.$7)});T.then(M,Y).finally(()=>te.dispose())})}async function c(T){let g=-1;const M=T.map((Y,te)=>Y.then(de=>(g=te,de)));try{return await Promise.race(M)}finally{T.forEach((Y,te)=>{te!==g&&Y.cancel()})}}function r(T,g,M){let Y;const te=setTimeout(()=>{Y?.(void 0),M?.()},g);return Promise.race([T.finally(()=>clearTimeout(te)),new Promise(de=>Y=de)])}function h(T){return new Promise((g,M)=>{const Y=T();F(Y)?Y.then(g,M):g(Y)})}function E(){let T,g;return{promise:new Promise((Y,te)=>{T=Y,g=te}),resolve:T,reject:g}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(g){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=g,!this.b){const M=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(M,M).then(Y)})}return new Promise((M,Y)=>{this.b.then(M,Y)})}return this.a=g(),new Promise((M,Y)=>{this.a.then(te=>{this.a=null,M(te)},te=>{this.a=null,Y(te)})})}dispose(){this.f=!0}}e.$Ch=l;class D{constructor(){this.a=Promise.resolve(null)}queue(g){return this.a=this.a.then(()=>g(),()=>g())}}e.$Dh=D;class A{constructor(){this.a=new Map}queue(g,M){const te=(this.a.get(g)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(g)===te&&this.a.delete(g)});return this.a.set(g,te),te}}e.$Eh=A;const u=(T,g)=>{let M=!0;const Y=setTimeout(()=>{M=!1,g()},T);return{isTriggered:()=>M,dispose:()=>{clearTimeout(Y),M=!1}}},i=T=>{let g=!0;return queueMicrotask(()=>{g&&(g=!1,T())}),{isTriggered:()=>g,dispose:()=>{g=!1}}};class n{constructor(g){this.defaultDelay=g,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(g,M=this.defaultDelay){this.g=g,this.h(),this.b||(this.b=new Promise((te,de)=>{this.d=te,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=M===L.$je?i(Y):u(M,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Fh=n;class s{constructor(g){this.a=new n(g),this.b=new l}trigger(g,M){return this.a.trigger(()=>this.b.queue(g),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Gh=s;class o{constructor(){this.a=!1,this.b=new Promise((g,M)=>{this.d=g})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Hh=o;class S extends o{constructor(g){super(),this.f=setTimeout(()=>this.open(),g)}open(){clearTimeout(this.f),super.open()}}e.$Ih=S;function m(T,g){return g?new Promise((M,Y)=>{const te=setTimeout(()=>{de.dispose(),M()},T),de=g.onCancellationRequested(()=>{clearTimeout(te),de.dispose(),Y(new t.$7)})}):w(M=>m(T,M))}function b(T,g=0,M){const Y=setTimeout(()=>{T(),M&&te.dispose()},g),te=(0,j.$Vc)(()=>{clearTimeout(Y),M?.deleteAndLeak(te)});return M?.add(te),te}function a(T){const g=[];let M=0;const Y=T.length;function te(){return M<Y?T[M++]():null}function de(De){De!=null&&g.push(De);const Re=te();return Re?Re.then(de):Promise.resolve(g)}return Promise.resolve(null).then(de)}function d(T,g=Y=>!!Y,M=null){let Y=0;const te=T.length,de=()=>{if(Y>=te)return Promise.resolve(M);const De=T[Y++];return Promise.resolve(De()).then(Ie=>g(Ie)?Promise.resolve(Ie):de())};return de()}function N(T,g=Y=>!!Y,M=null){if(T.length===0)return Promise.resolve(M);let Y=T.length;const te=()=>{Y=-1;for(const de of T)de.cancel?.()};return new Promise((de,De)=>{for(const Re of T)Re.then(Ie=>{--Y>=0&&g(Ie)?(te(),de(Ie)):Y===0&&de(M)}).catch(Ie=>{--Y>=0&&(te(),De(Ie))})})}class f{constructor(g){this.a=0,this.b=!1,this.f=g,this.g=[],this.d=0,this.h=new q.$oe}whenIdle(){return this.size>0?q.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(g){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((M,Y)=>{this.g.push({factory:g,c:M,e:Y}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const g=this.g.shift();this.d++;const M=g.factory();M.then(g.c,g.e),M.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Oh=f;class y extends f{constructor(){super(1)}}e.$Ph=y;class z{constructor(){this.a=new P,this.b=0}queue(g){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,g())):this.a.run(this.b++,g())}}e.$Qh=z;class x{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const g=new R;return this.b.add(g),g.p}g(){for(const[,g]of this.a)if(g.size>0)return!1;return!0}queueSize(g,M=X.$_g){const Y=M.getComparisonKey(g);return this.a.get(Y)?.size??0}queueFor(g,M,Y=X.$_g){const te=Y.getComparisonKey(g);let de=this.a.get(te);if(!de){de=new y;const De=this.f++,Re=q.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$7c),this.d.set(De,Re),this.a.set(te,de)}return de.queue(M)}h(){this.g()&&this.j()}j(){for(const g of this.b)g.complete();this.b.clear()}dispose(){for(const[,g]of this.a)g.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Rh=x;class J{constructor(g,M){this.b=!1,this.a=-1,typeof g=="function"&&typeof M=="number"&&this.setIfNotSet(g,M)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(g,M){if(this.b)throw new t.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,g()},M)}setIfNotSet(g,M){if(this.b)throw new t.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,g()},M))}}e.$Sh=J;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(g,M,Y=globalThis){if(this.f)throw new t.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const te=Y.setInterval(()=>{g()},M);this.d=(0,j.$Vc)(()=>{Y.clearInterval(te),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Th=K;class se{constructor(g,M){this.b=-1,this.a=g,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(g=this.d){this.cancel(),this.b=setTimeout(this.f,g)}get delay(){return this.d}set delay(g){this.d=g}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Uh=se;class V{constructor(g,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=g,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(g=this.b){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(g/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Vh=V;class ne extends se{constructor(g,M){super(g,M),this.j=[]}work(g){this.j.push(g),this.isScheduled()||this.schedule()}h(){const g=this.j;this.j=[],this.a?.(g)}dispose(){this.j=[],super.dispose()}}e.$Wh=ne;class re extends j.$Xc{constructor(g,M){super(),this.g=g,this.h=M,this.a=[],this.b=this.B(new j.$Yc),this.f=!1}get pending(){return this.a.length}work(g){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+g.length>this.g.maxBufferedWork)return!1}else if(this.pending+g.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of g)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Xh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Zh=(T,g)=>{(0,k.$C)(()=>{if(M)return;const Y=Date.now()+15;g(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.$Zh=(T,g,M)=>{const Y=T.requestIdleCallback(g,typeof M=="number"?{timeout:M}:void 0);let te=!1;return{dispose(){te||(te=!0,T.cancelIdleCallback(Y))}}},e.$Yh=T=>(0,e.$Zh)(globalThis,T)}();class oe{constructor(g,M){this.g=!1,this.d=()=>{try{this.j=M()}catch(Y){this.l=Y}finally{this.g=!0}},this.f=(0,e.$Zh)(g,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$1h=oe;class I extends oe{constructor(g){super(globalThis,g)}}e.$2h=I;async function $(T,g,M){let Y;for(let te=0;te<M;te++)try{return await T()}catch(de){Y=de,await m(g)}throw Y}class P{isRunning(g){return typeof g=="number"?this.a?.taskId===g:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(g,M,Y){return this.a={taskId:g,cancel:()=>Y?.(),promise:M},M.then(()=>this.d(g),()=>this.d(g)),M}d(g){this.a&&g===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const g=this.b;this.b=void 0,g.run().then(g.promiseResolve,g.promiseReject)}}queue(g){if(this.b)this.b.run=g;else{const{promise:M,resolve:Y,reject:te}=E();this.b={run:g,promise:M,promiseResolve:Y,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$4h=P;class W{constructor(g,M=()=>Date.now()){this.d=g,this.f=M,this.a=0,this.b=0}increment(){const g=this.f();return g-this.a>this.d&&(this.a=g,this.b=0),this.b++,this.b}}e.$5h=W;var Q;(function(T){T[T.Resolved=0]="Resolved",T[T.Rejected=1]="Rejected"})(Q||(Q={}));class R{get isRejected(){return this.d?.outcome===Q.Rejected}get isResolved(){return this.d?.outcome===Q.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Q.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((g,M)=>{this.a=g,this.b=M})}complete(g){return new Promise(M=>{this.a(g),this.d={outcome:Q.Resolved,value:g},M()})}error(g){return new Promise(M=>{this.b(g),this.d={outcome:Q.Rejected,value:g},M()})}cancel(){return this.error(new t.$7)}}e.$6h=R;var Z;(function(T){async function g(Y){let te;const de=await Promise.all(Y.map(De=>De.then(Re=>Re,Re=>{te||(te=Re)})));if(typeof te<"u")throw te;return de}T.settled=g;function M(Y){return new Promise(async(te,de)=>{try{await Y(te,de)}catch(De){de(De)}})}T.withAsyncBody=M})(Z||(e.Promises=Z={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(g){this.a=void 0,this.b=void 0,this.d=!1,this.promise=g.then(M=>(this.a=M,this.d=!0,M),M=>{throw this.b=M,this.d=!0,M})}requireValue(){if(!this.d)throw new t.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$7h=ee;class ie{constructor(g){this.b=g,this.a=new O.$W(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$8h=ie;var ue;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(ue||(ue={}));class he{static fromArray(g){return new he(M=>{M.emitMany(g)})}static fromPromise(g){return new he(async M=>{M.emitMany(await g)})}static fromPromises(g){return new he(async M=>{await Promise.all(g.map(async Y=>M.emitOne(await Y)))})}static merge(g){return new he(async M=>{await Promise.all(g.map(async Y=>{for await(const te of Y)M.emitOne(te)}))})}static{this.EMPTY=he.fromArray([])}constructor(g,M){this.a=ue.Initial,this.b=[],this.d=null,this.f=M,this.g=new q.$oe,queueMicrotask(async()=>{const Y={emitOne:te=>this.h(te),emitMany:te=>this.j(te),reject:te=>this.l(te)};try{await Promise.resolve(g(Y)),this.k()}catch(te){this.l(te)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let g=0;return{next:async()=>{do{if(this.a===ue.DoneError)throw this.d;if(g<this.b.length)return{done:!1,value:this.b[g++]};if(this.a===ue.DoneOK)return{done:!0,value:void 0};await q.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(g,M){return new he(async Y=>{for await(const te of g)Y.emitOne(M(te))})}map(g){return he.map(this,g)}static filter(g,M){return new he(async Y=>{for await(const te of g)M(te)&&Y.emitOne(te)})}filter(g){return he.filter(this,g)}static coalesce(g){return he.filter(g,M=>!!M)}coalesce(){return he.coalesce(this)}static async toPromise(g){const M=[];for await(const Y of g)M.push(Y);return M}toPromise(){return he.toPromise(this)}h(g){this.a===ue.Initial&&(this.b.push(g),this.g.fire())}j(g){this.a===ue.Initial&&(this.b=this.b.concat(g),this.g.fire())}k(){this.a===ue.Initial&&(this.a=ue.DoneOK,this.g.fire())}l(g){this.a===ue.Initial&&(this.a=ue.DoneError,this.d=g,this.g.fire())}}e.$9h=he;class we extends he{constructor(g,M){super(M),this.m=g}cancel(){this.m.cancel()}}e.$0h=we;function B(T){const g=new _.$ze,M=T(g.token);return new we(g,async Y=>{const te=g.token.onCancellationRequested(()=>{te.dispose(),g.dispose(),Y.reject(new t.$7)});try{for await(const de of M){if(g.token.isCancellationRequested)return;Y.emitOne(de)}te.dispose(),g.dispose()}catch(de){te.dispose(),g.dispose(),Y.reject(de)}})}class G{constructor(g){this.a=new R,this.b=new he(te=>{if(M){te.reject(M);return}return Y&&te.emitMany(Y),this.d=de=>te.reject(de),this.f=de=>te.emitOne(de),this.a.p},g);let M,Y;this.f=te=>{Y||(Y=[]),Y.push(te)},this.d=te=>{M||(M=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(g){this.d(g),this.a.complete()}emitOne(g){this.f(g)}}e.$_h=G}),define(be[23],_e([0,1,12,8,11,14,20,3,2,7]),function(fe,e,_,t,q,j,X,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=void 0,e.$yk=F,e.$Bk=r,e.$Ck=z,e.$Dk=x,e.$Ek=J,e.$Fk=K,e.$Gk=se,e.$Hk=oe;function F(){return Object.create(null)}e.$zk="**",e.$Ak="/";const w="[/\\\\]",v="[^/\\\\]",p=/\//g;function c(I,$){switch(I){case 0:return"";case 1:return`${v}*?`;default:return`(?:${w}|${v}+${w}${$?`|${w}${v}+`:""})*?`}}function r(I,$){if(!I)return[];const P=[];let W=!1,Q=!1,R="";for(const Z of I){switch(Z){case $:if(!W&&!Q){P.push(R),R="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}R+=Z}return R&&P.push(R),P}function h(I){if(!I)return"";let $="";const P=r(I,e.$Ak);if(P.every(W=>W===e.$zk))$=".*";else{let W=!1;P.forEach((Q,R)=>{if(Q===e.$zk){if(W)return;$+=c(2,R===P.length-1)}else{let Z=!1,ee="",ie=!1,ue="";for(const he of Q){if(he!=="}"&&Z){ee+=he;continue}if(ie&&(he!=="]"||!ue)){let we;he==="-"?we=he:(he==="^"||he==="!")&&!ue?we="^":he===e.$Ak?we="":we=(0,O.$kf)(he),ue+=we;continue}switch(he){case"{":Z=!0;continue;case"[":ie=!0;continue;case"}":{const B=`(?:${r(ee,",").map(G=>h(G)).join("|")})`;$+=B,Z=!1,ee="";break}case"]":{$+="["+ue+"]",ie=!1,ue="";break}case"?":$+=v;continue;case"*":$+=c(1);continue;default:$+=(0,O.$kf)(he)}}R<P.length-1&&(P[R+1]!==e.$zk||R+2<P.length)&&($+=w)}W=Q===e.$zk})}return $}const E=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,A=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new X.$Gc(1e4),s=function(){return!1},o=function(){return null};function S(I,$){if(!I)return o;let P;typeof I!="string"?P=I.pattern:P=I,P=P.trim();const W=`${P}_${!!$.trimForExclusions}`;let Q=n.get(W);if(Q)return m(Q,I);let R;return E.test(P)?Q=a(P.substr(4),P):(R=l.exec(b(P,$)))?Q=d(R[1],P):($.trimForExclusions?A:D).test(P)?Q=N(P,$):(R=u.exec(b(P,$)))?Q=f(R[1].substr(1),P,!0):(R=i.exec(b(P,$)))?Q=f(R[1],P,!1):Q=y(P),n.set(W,Q),m(Q,I)}function m(I,$){if(typeof $=="string")return I;const P=function(W,Q){return(0,j.$Hg)(W,$.base,!L.$l)?I((0,O.$pf)(W.substr($.base.length),k.sep),Q):null};return P.allBasenames=I.allBasenames,P.allPaths=I.allPaths,P.basenames=I.basenames,P.patterns=I.patterns,P}function b(I,$){return $.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function a(I,$){return function(P,W){return typeof P=="string"&&P.endsWith(I)?$:null}}function d(I,$){const P=`/${I}`,W=`\\${I}`,Q=function(Z,ee){return typeof Z!="string"?null:ee?ee===I?$:null:Z===I||Z.endsWith(P)||Z.endsWith(W)?$:null},R=[I];return Q.basenames=R,Q.patterns=[$],Q.allBasenames=R,Q}function N(I,$){const P=re(I.slice(1,-1).split(",").map(ee=>S(ee,$)).filter(ee=>ee!==o),I),W=P.length;if(!W)return o;if(W===1)return P[0];const Q=function(ee,ie){for(let ue=0,he=P.length;ue<he;ue++)if(P[ue](ee,ie))return I;return null},R=P.find(ee=>!!ee.allBasenames);R&&(Q.allBasenames=R.allBasenames);const Z=P.reduce((ee,ie)=>ie.allPaths?ee.concat(ie.allPaths):ee,[]);return Z.length&&(Q.allPaths=Z),Q}function f(I,$,P){const W=k.sep===k.$jc.sep,Q=W?I:I.replace(p,k.sep),R=k.sep+Q,Z=k.$jc.sep+I;let ee;return P?ee=function(ie,ue){return typeof ie=="string"&&(ie===Q||ie.endsWith(R)||!W&&(ie===I||ie.endsWith(Z)))?$:null}:ee=function(ie,ue){return typeof ie=="string"&&(ie===Q||!W&&ie===I)?$:null},ee.allPaths=[(P?"*/":"./")+I],ee}function y(I){try{const $=new RegExp(`^${h(I)}$`);return function(P){return $.lastIndex=0,typeof P=="string"&&$.test(P)?I:null}}catch{return o}}function z(I,$,P){return!I||typeof $!="string"?!1:x(I)($,void 0,P)}function x(I,$={}){if(!I)return s;if(typeof I=="string"||J(I)){const P=S(I,$);if(P===o)return s;const W=function(Q,R){return!!P(Q,R)};return P.allBasenames&&(W.allBasenames=P.allBasenames),P.allPaths&&(W.allPaths=P.allPaths),W}return V(I,$)}function J(I){const $=I;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}function K(I){return I.allBasenames||[]}function se(I){return I.allPaths||[]}function V(I,$){const P=re(Object.getOwnPropertyNames(I).map(ee=>ne(ee,I[ee],$)).filter(ee=>ee!==o)),W=P.length;if(!W)return o;if(!P.some(ee=>!!ee.requiresSiblings)){if(W===1)return P[0];const ee=function(he,we){let B;for(let G=0,T=P.length;G<T;G++){const g=P[G](he,we);if(typeof g=="string")return g;(0,t.$uh)(g)&&(B||(B=[]),B.push(g))}return B?(async()=>{for(const G of B){const T=await G;if(typeof T=="string")return T}return null})():null},ie=P.find(he=>!!he.allBasenames);ie&&(ee.allBasenames=ie.allBasenames);const ue=P.reduce((he,we)=>we.allPaths?he.concat(we.allPaths):he,[]);return ue.length&&(ee.allPaths=ue),ee}const Q=function(ee,ie,ue){let he,we;for(let B=0,G=P.length;B<G;B++){const T=P[B];T.requiresSiblings&&ue&&(ie||(ie=(0,k.$qc)(ee)),he||(he=ie.substr(0,ie.length-(0,k.$rc)(ee).length)));const g=T(ee,ie,he,ue);if(typeof g=="string")return g;(0,t.$uh)(g)&&(we||(we=[]),we.push(g))}return we?(async()=>{for(const B of we){const G=await B;if(typeof G=="string")return G}return null})():null},R=P.find(ee=>!!ee.allBasenames);R&&(Q.allBasenames=R.allBasenames);const Z=P.reduce((ee,ie)=>ie.allPaths?ee.concat(ie.allPaths):ee,[]);return Z.length&&(Q.allPaths=Z),Q}function ne(I,$,P){if($===!1)return o;const W=S(I,P);if(W===o)return o;if(typeof $=="boolean")return W;if($){const Q=$.when;if(typeof Q=="string"){const R=(Z,ee,ie,ue)=>{if(!ue||!W(Z,ee))return null;const he=Q.replace("$(basename)",()=>ie),we=ue(he);return(0,t.$uh)(we)?we.then(B=>B?I:null):we?I:null};return R.requiresSiblings=!0,R}}return W}function re(I,$){const P=I.filter(ee=>!!ee.basenames);if(P.length<2)return I;const W=P.reduce((ee,ie)=>{const ue=ie.basenames;return ue?ee.concat(ue):ee},[]);let Q;if($){Q=[];for(let ee=0,ie=W.length;ee<ie;ee++)Q.push($)}else Q=P.reduce((ee,ie)=>{const ue=ie.patterns;return ue?ee.concat(ue):ee},[]);const R=function(ee,ie){if(typeof ee!="string")return null;if(!ie){let he;for(he=ee.length;he>0;he--){const we=ee.charCodeAt(he-1);if(we===q.CharCode.Slash||we===q.CharCode.Backslash)break}ie=ee.substr(he)}const ue=W.indexOf(ie);return ue!==-1?Q[ue]:null};R.basenames=W,R.patterns=Q,R.allBasenames=W;const Z=I.filter(ee=>!ee.basenames);return Z.push(R),Z}function oe(I,$){return(0,_.$wb)(I,$,(P,W)=>typeof P=="string"&&typeof W=="string"?P===W:typeof P!="string"&&typeof W!="string"?P.base===W.base&&P.pattern===W.pattern:!1)}}),define(be[24],_e([0,1,15,50,60,8,14,21,3,2,22,5]),function(fe,e,_,t,q,j,X,k,L,O,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=h,e.readdirSync=D,e.whenDeleted=i,e.configureFlushOnWrite=m,e.writeFileSync=a,_=Ue(_);var v;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function p(V,ne=v.UNLINK,re){if((0,X.$Lg)(V))throw new Error("rimraf - will refuse to recursively delete root");return ne===v.UNLINK?r(V):c(V,re)}async function c(V,ne=(0,X.$Qg)((0,t.tmpdir)())){try{try{await _.promises.rename(V,ne)}catch(re){return re.code==="ENOENT"?void 0:r(V)}r(ne).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function r(V){return _.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function h(V){if((0,X.$Lg)(V))throw new Error("rimraf - will refuse to recursively delete root");_.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function E(V,ne){return A(await(ne?l(V):_.promises.readdir(V)))}async function l(V){try{return await _.promises.readdir(V,{withFileTypes:!0})}catch(oe){console.warn("[node.js fs] readdir with filetypes failed with error: ",oe)}const ne=[],re=await E(V);for(const oe of re){let I=!1,$=!1,P=!1;try{const W=await _.promises.lstat((0,L.$mc)(V,oe));I=W.isFile(),$=W.isDirectory(),P=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}ne.push({name:oe,isFile:()=>I,isDirectory:()=>$,isSymbolicLink:()=>P})}return ne}function D(V){return A(_.readdirSync(V))}function A(V){return V.map(ne=>typeof ne=="string"?O.$k?(0,k.$qm)(ne):ne:(ne.name=O.$k?(0,k.$qm)(ne.name):ne.name,ne))}async function u(V){const ne=await E(V),re=[];for(const oe of ne)await n.existsDirectory((0,L.$mc)(V,oe))&&re.push(oe);return re}function i(V,ne=1e3){return new Promise(re=>{let oe=!1;const I=setInterval(()=>{oe||(oe=!0,_.access(V,$=>{oe=!1,$&&(clearInterval(I),re(void 0))}))},ne)})}var n;(function(V){async function ne(I){let $;try{if($=await _.promises.lstat(I),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await _.promises.stat(I),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(P){if(P.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(O.$j&&P.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(I)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw W}throw P}}V.stat=ne;async function re(I){try{const{stat:$,symbolicLink:P}=await V.stat(I);return $.isFile()&&P?.dangling!==!0}catch{}return!1}V.existsFile=re;async function oe(I){try{const{stat:$,symbolicLink:P}=await V.stat(I);return $.isDirectory()&&P?.dangling!==!0}catch{}return!1}V.existsDirectory=oe})(n||(e.SymlinkSupport=n={}));const s=new j.$Rh;function o(V,ne,re){return s.queueFor(w.URI.file(V),()=>{const oe=d(re);return new Promise((I,$)=>b(V,ne,oe,P=>P?$(P):I()))},F.$ah)}let S=!0;function m(V){S=V}function b(V,ne,re,oe){if(!S)return _.writeFile(V,ne,{mode:re.mode,flag:re.flag},oe);_.open(V,re.flag,re.mode,(I,$)=>{if(I)return oe(I);_.writeFile($,ne,P=>{if(P)return _.close($,()=>oe(P));_.fdatasync($,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),m(!1)),_.close($,Q=>oe(Q))))})})}function a(V,ne,re){const oe=d(re);if(!S)return _.writeFileSync(V,ne,{mode:oe.mode,flag:oe.flag});const I=_.openSync(V,oe.flag,oe.mode);try{_.writeFileSync(I,ne);try{_.fdatasyncSync(I)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),m(!1)}}finally{_.closeSync(I)}}function d(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function N(V,ne,re=6e4){if(V!==ne)try{O.$j&&typeof re=="number"?await f(V,ne,Date.now(),re):await _.promises.rename(V,ne)}catch(oe){if(V.toLowerCase()!==ne.toLowerCase()&&oe.code==="EXDEV"||V.endsWith("."))await y(V,ne,{preserveSymlinks:!1}),await p(V,v.MOVE);else throw oe}}async function f(V,ne,re,oe,I=0){try{return await _.promises.rename(V,ne)}catch($){if($.code!=="EACCES"&&$.code!=="EPERM"&&$.code!=="EBUSY")throw $;if(Date.now()-re>=oe)throw console.error(`[node.js fs] rename failed after ${I} retries with error: ${$}`),$;if(I===0){let P=!1;try{const{stat:W}=await n.stat(ne);W.isFile()||(P=!0)}catch{}if(P)throw $}return await(0,j.$Jh)(Math.min(100,I*10)),f(V,ne,re,oe,I+1)}}async function y(V,ne,re){return x(V,ne,{root:{source:V,target:ne},options:re,handledSourcePaths:new Set})}const z=511;async function x(V,ne,re){if(re.handledSourcePaths.has(V))return;re.handledSourcePaths.add(V);const{stat:oe,symbolicLink:I}=await n.stat(V);if(I){if(re.options.preserveSymlinks)try{return await se(V,ne,re)}catch{}if(I.dangling)return}return oe.isDirectory()?J(V,ne,oe.mode&z,re):K(V,ne,oe.mode&z)}async function J(V,ne,re,oe){await _.promises.mkdir(ne,{recursive:!0,mode:re});const I=await E(V);for(const $ of I)await x((0,L.$mc)(V,$),(0,L.$mc)(ne,$),oe)}async function K(V,ne,re){await _.promises.copyFile(V,ne),await _.promises.chmod(ne,re)}async function se(V,ne,re){let oe=await _.promises.readlink(V);(0,X.$Hg)(oe,re.root.source,!O.$l)&&(oe=(0,L.$mc)(re.root.target,oe.substr(re.root.source.length+1))),await _.promises.symlink(oe,ne)}e.Promises=new class{get read(){return(V,ne,re,oe,I)=>new Promise(($,P)=>{_.read(V,ne,re,oe,I,(W,Q,R)=>W?P(W):$({bytesRead:Q,buffer:R}))})}get write(){return(V,ne,re,oe,I)=>new Promise(($,P)=>{_.write(V,ne,re,oe,I,(W,Q,R)=>W?P(W):$({bytesWritten:Q,buffer:R}))})}get fdatasync(){return(0,q.promisify)(_.fdatasync)}get open(){return(0,q.promisify)(_.open)}get close(){return(0,q.promisify)(_.close)}get realpath(){return(0,q.promisify)(_.realpath)}async exists(V){try{return await _.promises.access(V),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return u}get writeFile(){return o}get rm(){return p}get rename(){return N}get copy(){return y}}}),define(be[32],_e([0,1,15,3,2,7,24]),function(fe,e,_,t,q,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=k,e.$rr=L,e.$sr=O,e.$tr=F,_=Ue(_);function k(v){if(q.$l)return v;const p=(0,t.$pc)(v);if(v===p)return v;const c=((0,t.$qc)(v)||v).toLowerCase();try{const h=(0,X.readdirSync)(p).filter(E=>E.toLowerCase()===c);if(h.length===1){const E=k(p);if(E)return(0,t.$mc)(E,h[0])}else if(h.length>1){const E=h.indexOf(c);if(E>=0){const l=k(p);if(l)return(0,t.$mc)(l,h[E])}}}catch{}return null}async function L(v,p){if(q.$l)return v;const c=(0,t.$pc)(v);if(v===c)return v;const r=((0,t.$qc)(v)||v).toLowerCase();try{if(p?.isCancellationRequested)return null;const E=(await X.Promises.readdir(c)).filter(l=>l.toLowerCase()===r);if(E.length===1){const l=await L(c,p);if(l)return(0,t.$mc)(l,E[0])}else if(E.length>1){const l=E.indexOf(r);if(l>=0){const D=await L(c,p);if(D)return(0,t.$mc)(D,E[l])}}}catch{}return null}async function O(v){try{return await X.Promises.realpath(v)}catch{const c=w(v);return await _.promises.access(c,_.constants.R_OK),c}}function F(v){try{return _.realpathSync(v)}catch{const c=w(v);return _.accessSync(c,_.constants.R_OK),c}}function w(v){return(0,j.$qf)((0,t.$kc)(v),t.sep)}}),define(be[51],_e([0,1,15,3,2,28,29,10,24]),function(fe,e,_,t,q,j,X,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Bm=O,e.$Cm=F,t=Ue(t),q=Ue(q),j=Ue(j),k=Ue(k),L=Ue(L),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return X.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return X.TerminateResponseCode}});function O(v=j.env){return v.comspec||"cmd.exe"}function F(v){let p=[],c=!1;const r=function(h){if(c){p.push(h);return}(!v.send(h,l=>{if(l&&console.error(l),c=!1,p.length>0){const D=p.slice(0);p=[],D.forEach(A=>r(A))}})||q.$j)&&(c=!0)};return{send:r}}var w;(function(v){async function p(c,r,h){if(t.$lc(c))return c;if(r===void 0&&(r=j.cwd()),t.$pc(c)!=="."||(h===void 0&&k.$hg(j.env.PATH)&&(h=j.env.PATH.split(t.$wc)),h===void 0||h.length===0))return t.$mc(r,c);async function l(D){if(await L.Promises.exists(D)){let A;try{A=await _.promises.stat(D)}catch(u){u.message.startsWith("EACCES")&&(A=await _.promises.lstat(D))}return A?!A.isDirectory():!1}return!1}for(const D of h){let A;if(t.$lc(D)?A=t.$mc(D,c):A=t.$mc(r,D,c),await l(A))return A;let u=A+".com";if(await l(u)||(u=A+".exe",await l(u)))return u}return t.$mc(r,c)}v.findExecutable=p})(w||(e.win32=w={}))});var Je=this&&this.__decorate||function(fe,e,_,t){var q=arguments.length,j=q<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,_):t,X;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(fe,e,_,t);else for(var k=fe.length-1;k>=0;k--)(X=fe[k])&&(j=(q<3?X(j):q>3?X(e,_,j):X(e,_))||j);return q>3&&j&&Object.defineProperty(e,_,j),j};define(be[25],_e([0,1,12,8,17,13,39,9,6,4,49,7,10]),function(fe,e,_,t,q,j,X,k,L,O,F,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.ProxyChannel=e.$qi=e.$ni=e.$mi=e.$li=e.RequestInitiator=e.$ki=e.$hi=e.$gi=void 0,e.$ii=m,e.$ji=b,e.$oi=z,e.$pi=x,w=Ue(w);var p;(function(I){I[I.Promise=100]="Promise",I[I.PromiseCancel=101]="PromiseCancel",I[I.EventListen=102]="EventListen",I[I.EventDispose=103]="EventDispose"})(p||(p={}));function c(I){switch(I){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var r;(function(I){I[I.Initialize=200]="Initialize",I[I.PromiseSuccess=201]="PromiseSuccess",I[I.PromiseError=202]="PromiseError",I[I.PromiseErrorObj=203]="PromiseErrorObj",I[I.EventFire=204]="EventFire"})(r||(r={}));function h(I){switch(I){case r.Initialize:return"init";case r.PromiseSuccess:return"reply:";case r.PromiseError:case r.PromiseErrorObj:return"replyErr:";case r.EventFire:return"event:"}}var E;(function(I){I[I.Uninitialized=0]="Uninitialized",I[I.Idle=1]="Idle"})(E||(E={}));function l(I){let $=0;for(let P=0;;P+=7){const W=I.read(1);if($|=(W.buffer[0]&127)<<P,!(W.buffer[0]&128))return $}}const D=s(0);function A(I,$){if($===0){I.write(D);return}let P=0;for(let Q=$;Q!==0;Q=Q>>>7)P++;const W=q.$Qe.alloc(P);for(let Q=0;$!==0;Q++)W.buffer[Q]=$&127,$=$>>>7,$>0&&(W.buffer[Q]|=128);I.write(W)}class u{constructor($){this.b=$,this.a=0}read($){const P=this.b.slice(this.a,this.a+$);return this.a+=P.byteLength,P}}e.$gi=u;class i{constructor(){this.a=[]}get buffer(){return q.$Qe.concat(this.a)}write($){this.a.push($)}}e.$hi=i;var n;(function(I){I[I.Undefined=0]="Undefined",I[I.String=1]="String",I[I.Buffer=2]="Buffer",I[I.VSBuffer=3]="VSBuffer",I[I.Array=4]="Array",I[I.Object=5]="Object",I[I.Int=6]="Int"})(n||(n={}));function s(I){const $=q.$Qe.alloc(1);return $.writeUInt8(I,0),$}const o={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},S=typeof Buffer<"u";function m(I,$){if(typeof $>"u")I.write(o.Undefined);else if(typeof $=="string"){const P=q.$Qe.fromString($);I.write(o.String),A(I,P.byteLength),I.write(P)}else if(S&&Buffer.isBuffer($)){const P=q.$Qe.wrap($);I.write(o.Buffer),A(I,P.byteLength),I.write(P)}else if($ instanceof q.$Qe)I.write(o.VSBuffer),A(I,$.byteLength),I.write($);else if(Array.isArray($)){I.write(o.Array),A(I,$.length);for(const P of $)m(I,P)}else if(typeof $=="number"&&($|0)===$)I.write(o.Uint),A(I,$);else{const P=q.$Qe.fromString(JSON.stringify($));I.write(o.Object),A(I,P.byteLength),I.write(P)}}function b(I){switch(I.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return I.read(l(I)).toString();case n.Buffer:return I.read(l(I)).buffer;case n.VSBuffer:return I.read(l(I));case n.Array:{const P=l(I),W=[];for(let Q=0;Q<P;Q++)W.push(b(I));return W}case n.Object:return JSON.parse(I.read(l(I)).toString());case n.Int:return l(I)}}class a{constructor($,P,W=null,Q=1e3){this.h=$,this.j=P,this.k=W,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(R=>this.q(R)),this.m({type:r.Initialize})}registerChannel($,P){this.b.set($,P),setTimeout(()=>this.w($),0)}m($){switch($.type){case r.Initialize:{const P=this.o([$.type]);this.k?.logOutgoing(P,0,d.OtherSide,h($.type));return}case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:{const P=this.o([$.type,$.id],$.data);this.k?.logOutgoing(P,$.id,d.OtherSide,h($.type),$.data);return}}}o($,P=void 0){const W=new i;return m(W,$),m(W,P),this.p(W.buffer)}p($){try{return this.h.send($),$.byteLength}catch{return 0}}q($){const P=new u($),W=b(P),Q=b(P),R=W[0];switch(R){case p.Promise:return this.k?.logIncoming($.byteLength,W[1],d.OtherSide,`${c(R)}: ${W[2]}.${W[3]}`,Q),this.s({type:R,id:W[1],channelName:W[2],name:W[3],arg:Q});case p.EventListen:return this.k?.logIncoming($.byteLength,W[1],d.OtherSide,`${c(R)}: ${W[2]}.${W[3]}`,Q),this.t({type:R,id:W[1],channelName:W[2],name:W[3],arg:Q});case p.PromiseCancel:return this.k?.logIncoming($.byteLength,W[1],d.OtherSide,`${c(R)}`),this.u({type:R,id:W[1]});case p.EventDispose:return this.k?.logIncoming($.byteLength,W[1],d.OtherSide,`${c(R)}`),this.u({type:R,id:W[1]})}}s($){const P=this.b.get($.channelName);if(!P){this.v($);return}const W=new j.$ze;let Q;try{Q=P.call(this.j,$.name,$.arg,W.token)}catch(ee){Q=Promise.reject(ee)}const R=$.id;Q.then(ee=>{this.m({id:R,data:ee,type:r.PromiseSuccess})},ee=>{ee instanceof Error?this.m({id:R,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split(`
`):void 0},type:r.PromiseError}):this.m({id:R,data:ee,type:r.PromiseErrorObj})}).finally(()=>{Z.dispose(),this.d.delete($.id)});const Z=(0,O.$Vc)(()=>W.cancel());this.d.set($.id,Z)}t($){const P=this.b.get($.channelName);if(!P){this.v($);return}const W=$.id,R=P.listen(this.j,$.name,$.arg)(Z=>this.m({id:W,data:Z,type:r.EventFire}));this.d.set($.id,R)}u($){const P=this.d.get($.id);P&&(P.dispose(),this.d.delete($.id))}v($){let P=this.g.get($.channelName);P||(P=[],this.g.set($.channelName,P));const W=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===p.Promise&&this.m({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.l}ms`,stack:void 0},type:r.PromiseError})},this.l);P.push({request:$,timeoutTimer:W})}w($){const P=this.g.get($);if(P){for(const W of P)switch(clearTimeout(W.timeoutTimer),W.request.type){case p.Promise:this.s(W.request);break;case p.EventListen:this.t(W.request);break}this.g.delete($)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,O.$Sc)(this.d.values()),this.d.clear()}}e.$ki=a;var d;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(d||(e.RequestInitiator=d={}));class N{constructor($,P=null){this.l=$,this.a=!1,this.b=E.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new L.$oe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=P}getChannel($){const P=this;return{call(W,Q,R){return P.a?Promise.reject(new k.$7):P.m($,W,Q,R)},listen(W,Q){return P.a?L.Event.None:P.o($,W,Q)}}}m($,P,W,Q=j.CancellationToken.None){const R=this.g++,Z=p.Promise,ee={id:R,type:Z,channelName:$,name:P,arg:W};if(Q.isCancellationRequested)return Promise.reject(new k.$7);let ie;return new Promise((he,we)=>{if(Q.isCancellationRequested)return we(new k.$7);const B=()=>{const M=Y=>{switch(Y.type){case r.PromiseSuccess:this.f.delete(R),he(Y.data);break;case r.PromiseError:{this.f.delete(R);const te=new Error(Y.data.message);te.stack=Array.isArray(Y.data.stack)?Y.data.stack.join(`
`):Y.data.stack,te.name=Y.data.name,we(te);break}case r.PromiseErrorObj:this.f.delete(R),we(Y.data);break}};this.f.set(R,M),this.p(ee)};let G=null;this.b===E.Idle?B():(G=(0,t.$vh)(M=>this.u()),G.then(()=>{G=null,B()}));const T=()=>{G?(G.cancel(),G=null):this.p({id:R,type:p.PromiseCancel}),we(new k.$7)},g=Q.onCancellationRequested(T);ie=(0,O.$Uc)((0,O.$Vc)(T),g),this.d.add(ie)}).finally(()=>{ie.dispose(),this.d.delete(ie)})}o($,P,W){const Q=this.g++,R=p.EventListen,Z={id:Q,type:R,channelName:$,name:P,arg:W};let ee=null;const ie=new L.$oe({onWillAddFirstListener:()=>{ee=(0,t.$vh)(he=>this.u()),ee.then(()=>{ee=null,this.d.add(ie),this.p(Z)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(ie),this.p({id:Q,type:p.EventDispose}))}}),ue=he=>ie.fire(he.data);return this.f.set(Q,ue),ie.event}p($){switch($.type){case p.Promise:case p.EventListen:{const P=this.q([$.type,$.id,$.channelName,$.name],$.arg);this.j?.logOutgoing(P,$.id,d.LocalSide,`${c($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case p.PromiseCancel:case p.EventDispose:{const P=this.q([$.type,$.id]);this.j?.logOutgoing(P,$.id,d.LocalSide,c($.type));return}}}q($,P=void 0){const W=new i;return m(W,$),m(W,P),this.r(W.buffer)}r($){try{return this.l.send($),$.byteLength}catch{return 0}}s($){const P=new u($),W=b(P),Q=b(P),R=W[0];switch(R){case r.Initialize:return this.j?.logIncoming($.byteLength,0,d.LocalSide,h(R)),this.t({type:W[0]});case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:return this.j?.logIncoming($.byteLength,W[1],d.LocalSide,h(R),Q),this.t({type:W[0],id:W[1],data:Q})}}t($){if($.type===r.Initialize){this.b=E.Idle,this.k.fire();return}this.f.get($.id)?.($)}get onDidInitializePromise(){return L.Event.toPromise(this.onDidInitialize)}u(){return this.b===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,O.$Sc)(this.d.values()),this.d.clear()}}e.$li=N,Je([X.$ai],N.prototype,"onDidInitializePromise",null);class f{get connections(){const $=[];return this.f.forEach(P=>$.push(P)),$}constructor($,P,W){this.a=new Map,this.f=new Set,this.g=new L.$oe,this.onDidAddConnection=this.g.event,this.h=new L.$oe,this.onDidRemoveConnection=this.h.event,this.j=new O.$Wc,this.j.add($(({protocol:Q,onDidClientDisconnect:R})=>{const Z=L.Event.once(Q.onMessage);this.j.add(Z(ee=>{const ie=new u(ee),ue=b(ie),he=new a(Q,ue,P,W),we=new N(Q,P);this.a.forEach((G,T)=>he.registerChannel(T,G));const B={channelServer:he,channelClient:we,ctx:ue};this.f.add(B),this.g.fire(B),this.j.add(R(()=>{he.dispose(),we.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel($,P){const W=this;return{call(Q,R,Z){let ee;if((0,v.$vg)(P)){const ue=(0,_.$5b)(W.connections.filter(P));ee=ue?Promise.resolve(ue):L.Event.toPromise(L.Event.filter(W.onDidAddConnection,P))}else ee=P.routeCall(W,Q,R);const ie=ee.then(ue=>ue.channelClient.getChannel($));return z(ie).call(Q,R,Z)},listen(Q,R){if((0,v.$vg)(P))return W.k($,P,Q,R);const Z=P.routeEvent(W,Q,R).then(ee=>ee.channelClient.getChannel($));return z(Z).listen(Q,R)}}}k($,P,W,Q){const R=this;let Z;const ee=new L.$oe({onWillAddFirstListener:()=>{Z=new O.$Wc;const ie=new L.$ue,ue=new Map,he=B=>{const T=B.channelClient.getChannel($).listen(W,Q),g=ie.add(T);ue.set(B,g)},we=B=>{const G=ue.get(B);G&&(G.dispose(),ue.delete(B))};R.connections.filter(P).forEach(he),L.Event.filter(R.onDidAddConnection,P)(he,void 0,Z),R.onDidRemoveConnection(we,void 0,Z),ie.event(ee.fire,ee,Z),Z.add(ie)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return ee.event}registerChannel($,P){this.a.set($,P);for(const W of this.f)W.channelServer.registerChannel($,P)}dispose(){this.j.dispose();for(const $ of this.f)$.channelClient.dispose(),$.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$mi=f;class y{constructor($,P,W=null){const Q=new i;m(Q,P),$.send(Q.buffer),this.a=new N($,W),this.d=new a($,P,W)}getChannel($){return this.a.getChannel($)}registerChannel($,P){this.d.registerChannel($,P)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ni=y;function z(I){return{call($,P,W){return I.then(Q=>Q.call($,P,W))},listen($,P){const W=new L.$xe;return I.then(Q=>W.input=Q.listen($,P)),W.event}}}function x(I){let $=!1;return{call(P,W,Q){return $?I.call(P,W,Q):(0,t.$Jh)(0).then(()=>$=!0).then(()=>I.call(P,W,Q))},listen(P,W){if($)return I.listen(P,W);const Q=new L.$xe;return(0,t.$Jh)(0).then(()=>$=!0).then(()=>Q.input=I.listen(P,W)),Q.event}}}class J{constructor($){this.a=$}routeCall($){return this.b($)}routeEvent($){return this.b($)}async b($){for(const P of $.connections)if(await Promise.resolve(this.a(P.ctx)))return Promise.resolve(P);return await L.Event.toPromise($.onDidAddConnection),await this.b($)}}e.$qi=J;var K;(function(I){function $(R,Z,ee){const ie=R,ue=ee&&ee.disableMarshalling,he=new Map;for(const we in ie)W(we)&&he.set(we,L.Event.buffer(ie[we],!0,void 0,Z));return new class{listen(we,B,G){const T=he.get(B);if(T)return T;const g=ie[B];if(typeof g=="function"){if(Q(B))return g.call(ie,G);if(W(B))return he.set(B,L.Event.buffer(ie[B],!0,void 0,Z)),he.get(B)}throw new k.$db(`Event not found: ${B}`)}call(we,B,G){const T=ie[B];if(typeof T=="function"){if(!ue&&Array.isArray(G))for(let M=0;M<G.length;M++)G[M]=(0,F.$fi)(G[M]);let g=T.apply(ie,G);return g instanceof Promise||(g=Promise.resolve(g)),g}throw new k.$db(`Method not found: ${B}`)}}}I.fromService=$;function P(R,Z){const ee=Z&&Z.disableMarshalling;return new Proxy({},{get(ie,ue){if(typeof ue=="string")return Z?.properties?.has(ue)?Z.properties.get(ue):Q(ue)?function(he){return R.listen(ue,he)}:W(ue)?R.listen(ue):async function(...he){let we;Z&&!(0,v.$qg)(Z.context)?we=[Z.context,...he]:we=he;const B=await R.call(ue,we);return ee?B:(0,F.$fi)(B)};throw new k.$db(`Property not found: ${String(ue)}`)}})}I.toService=P;function W(R){return R[0]==="o"&&R[1]==="n"&&w.$Hf(R.charCodeAt(2))}function Q(R){return/^onDynamic/.test(R)&&w.$Hf(R.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(I){if(Array.isArray(I))return I;if(I&&typeof I=="object"&&typeof I.toString=="function"){const $=I.toString();if($!=="[object Object]")return $}return I}function ne(I){return Array.isArray(I)?I.map(V):V(I)}function re(I,$,P,W,Q,R,Z){Z=ne(Z);const ee=se[Q],ie=ee[W%ee.length];let ue=[`%c[${I}]%c[${String($).padStart(7," ")}]%c[len: ${String(P).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${R}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(R)?(ue=ue.concat(Z),ue.push(")")):ue.push(Z),console.log.apply(console,ue)}class oe{constructor($,P){this.d=$,this.f=P,this.a=0,this.b=0}logOutgoing($,P,W,Q,R){this.b+=$,re(this.d,this.b,$,P,W,Q,R)}logIncoming($,P,W,Q,R){this.a+=$,re(this.f,this.a,$,P,W,Q,R)}}e.$ri=oe}),define(be[52],_e([0,1,61,8,17,13,48,9,6,4,46,51,29,25]),function(fe,e,_,t,q,j,X,k,L,O,F,w,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0,k=Ue(k);class c extends p.$ki{constructor(E){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:L.Event.fromNodeEventEmitter(process,"message",l=>q.$Qe.wrap(Buffer.from(l,"base64")))},E),process.once("disconnect",()=>this.dispose())}}e.$mr=c;class r{constructor(E,l){this.i=E,this.j=l,this.c=new Set,this.g=new Map,this.h=new L.$oe,this.onDidProcessExit=this.h.event;const D=l&&l.timeout?l.timeout:6e4;this.b=new t.$Fh(D),this.d=null,this.f=null}getChannel(E){const l=this;return{call(D,A,u){return l.k(E,D,A,u)},listen(D,A){return l.l(E,D,A)}}}k(E,l,D,A=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(A.isCancellationRequested)return Promise.reject(k.$8());this.b.cancel();const u=this.n(E),i=(0,t.$vh)(o=>u.call(l,D,o)),n=A.onCancellationRequested(()=>i.cancel()),s=(0,O.$Vc)(()=>i.cancel());return this.c.add(s),i.finally(()=>{n.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(E,l,D){if(!this.b)return L.Event.None;this.b.cancel();let A;const u=new L.$oe({onWillAddFirstListener:()=>{A=this.n(E).listen(l,D)(u.fire,u),this.c.add(A)},onDidRemoveLastListener:()=>{this.c.delete(A),A.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const E=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,F.$ho)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(m=>!/^--inspect(-brk)?=/.test(m)).filter(m=>!m.startsWith("--vscode-"))),(0,v.$pm)(l.env),this.d=(0,_.fork)(this.i,E,l);const D=new L.$oe,u=L.Event.fromNodeEventEmitter(this.d,"message",m=>m)(m=>{if((0,X.$ir)(m)){(0,X.log)(m,`IPC Library: ${this.j.serverName}`);return}D.fire(q.$Qe.wrap(Buffer.from(m,"base64")))}),i=this.j.useQueue?(0,w.$Cm)(this.d):this.d,n=m=>this.d&&this.d.connected&&i.send(m.buffer.toString("base64")),s=D.event,o={send:n,onMessage:s};this.f=new p.$li(o);const S=()=>this.o();process.once("exit",S),this.d.on("error",m=>console.warn('IPC "'+this.j.serverName+'" errored with '+m)),this.d.on("exit",(m,b)=>{process.removeListener("exit",S),u.dispose(),this.c.forEach(a=>(0,O.$Sc)(a)),this.c.clear(),m!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+m+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:m,signal:b})})}return this.f}n(E){let l=this.g.get(E);return l||(l=this.m.getChannel(E),this.g.set(E,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$nr=r}),define(be[33],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rY=_;function _(t){return!!t.parentPort}}),define(be[53],_e([0,1,33,17,25,6,10,12]),function(fe,e,_,t,q,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sY=void 0,e.$tY=F;class L{constructor(v){this.a=v,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",p=>p.data?t.$Qe.wrap(p.data):t.$Qe.alloc(0)),v.start()}send(v){this.a.postMessage(v.buffer)}disconnect(){this.a.close()}}class O extends q.$mi{static b(v){(0,X.$rg)((0,_.$rY)(process),"Electron Utility Process");const p=new j.$oe;return process.parentPort.on("message",c=>{if(v?.handledClientConnection(c))return;const r=(0,k.$Qb)(c.ports);r&&p.fire(r)}),j.Event.map(p.event,c=>({protocol:new L(c),onDidClientDisconnect:j.Event.fromNodeEventEmitter(c,"close")}))}constructor(v){super(O.b(v))}}e.$sY=O;function F(w,v,p){const c=r=>{r.data===v&&(w.removeListener("message",c),p())};w.on("message",c)}}),define(be[34],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=q,e.localize2=X;const _=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(k,L){let O;return L.length===0?O=k:O=k.replace(/\{(\d+)\}/g,(F,w)=>{const v=w[0],p=L[v];let c=F;return typeof p=="string"?c=p:(typeof p=="number"||typeof p=="boolean"||p===void 0||p===null)&&(c=String(p)),c}),_&&(O="\uFF3B"+O.replace(/[aouei]/g,"$&$&")+"\uFF3D"),O}function q(k,L,...O){return t(typeof k=="number"?j(k,L):L,O)}function j(k,L){const O=globalThis._VSCODE_NLS_MESSAGES?.[k];if(typeof O!="string"){if(typeof L=="string")return L;throw new Error(`!!! NLS MISSING: ${k} !!!`)}return O}function X(k,L,...O){let F;typeof k=="number"?F=j(k,L):F=L;const w=t(F,O);return{value:w,original:L===F?w:t(L,O)}}}),define(be[54],_e([0,1,12,10,34]),function(fe,e,_,t,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=L,e.$uj=O,e.$vj=F,_=Ue(_),t=Ue(t),q=Ue(q);function j(w,v){return v&&(w.stack||w.stacktrace)?q.localize(105,null,k(w),X(w.stack)||X(w.stacktrace)):k(w)}function X(w){return Array.isArray(w)?w.join(`
`):w}function k(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?q.localize(106,null,w.message):w.message||q.localize(107,null)}function L(w=null,v=!1){if(!w)return q.localize(108,null);if(Array.isArray(w)){const p=_.$Jb(w),c=L(p[0],v);return p.length>1?q.localize(109,null,c,p.length):c}if(t.$hg(w))return w;if(w.detail){const p=w.detail;if(p.error)return j(p.error,v);if(p.exception)return j(p.exception,v)}return w.stack?j(w,v):w.message?w.message:q.localize(110,null)}function O(w){const v=w;return v instanceof Error&&Array.isArray(v.actions)}function F(w,v){let p;return typeof w=="string"?p=new Error(w):p=w,p.actions=v,p}}),define(be[55],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=q,e.$Ji=j;var _;(function(X){X.serviceIds=new Map,X.DI_TARGET="$di$target",X.DI_DEPENDENCIES="$di$dependencies";function k(L){return L[X.DI_DEPENDENCIES]||[]}X.getServiceDependencies=k})(_||(e._util=_={})),e.$Hi=q("instantiationService");function t(X,k,L){k[_.DI_TARGET]===k?k[_.DI_DEPENDENCIES].push({id:X,index:L}):(k[_.DI_DEPENDENCIES]=[{id:X,index:L}],k[_.DI_TARGET]=k)}function q(X){if(_.serviceIds.has(X))return _.serviceIds.get(X);const k=function(L,O,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,L,F)};return k.toString=()=>X,_.serviceIds.set(X,k),k}function j(X){return X}}),define(be[18],_e([0,1,30,3,7,10,5,34,55,2,31,16]),function(fe,e,_,t,q,j,X,k,L,O,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=v,e.$fl=h,e.$gl=l,e.$hl=D,e.$il=A,e.$jl=u,e.$kl=i,e.$ll=n,e.$ml=s,e.$nl=o,e.$ol=S,e.$ql=a,e.$rl=d,e.$sl=N,e.$tl=f,e.$ul=y,e.$xl=se,e.$Jl=$,e.$Kl=P,e.$Ml=Q,e.$dl=(0,L.$Ii)("fileService");function v(R){return R.create===!0}var p;(function(R){R[R.Unknown=0]="Unknown",R[R.File=1]="File",R[R.Directory=2]="Directory",R[R.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var c;(function(R){R[R.Readonly=1]="Readonly",R[R.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var r;(function(R){R[R.UPDATED=2]="UPDATED",R[R.ADDED=4]="ADDED",R[R.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function h(R){const Z=R;return!!Z&&typeof Z.onDidChange=="function"}var E;(function(R){R[R.None=0]="None",R[R.FileReadWrite=2]="FileReadWrite",R[R.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",R[R.FileReadStream=16]="FileReadStream",R[R.FileFolderCopy=8]="FileFolderCopy",R[R.PathCaseSensitive=1024]="PathCaseSensitive",R[R.Readonly=2048]="Readonly",R[R.Trash=4096]="Trash",R[R.FileWriteUnlock=8192]="FileWriteUnlock",R[R.FileAtomicRead=16384]="FileAtomicRead",R[R.FileAtomicWrite=32768]="FileAtomicWrite",R[R.FileAtomicDelete=65536]="FileAtomicDelete",R[R.FileClone=131072]="FileClone"})(E||(e.FileSystemProviderCapabilities=E={}));function l(R){return!!(R.capabilities&E.FileReadWrite)}function D(R){return!!(R.capabilities&E.FileFolderCopy)}function A(R){return!!(R.capabilities&E.FileClone)}function u(R){return!!(R.capabilities&E.FileOpenReadWriteClose)}function i(R){return!!(R.capabilities&E.FileReadStream)}function n(R){return l(R)?!!(R.capabilities&E.FileAtomicRead):!1}function s(R){return l(R)?!!(R.capabilities&E.FileAtomicWrite):!1}function o(R){return!!(R.capabilities&E.FileAtomicDelete)}function S(R){return!!(R.capabilities&E.Readonly)}var m;(function(R){R.FileExists="EntryExists",R.FileNotFound="EntryNotFound",R.FileNotADirectory="EntryNotADirectory",R.FileIsADirectory="EntryIsADirectory",R.FileExceedsStorageQuota="EntryExceedsStorageQuota",R.FileTooLarge="EntryTooLarge",R.FileWriteLocked="EntryWriteLocked",R.NoPermissions="NoPermissions",R.Unavailable="Unavailable",R.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class b extends Error{static create(Z,ee){const ie=new b(Z.toString(),ee);return N(ie,ee),ie}constructor(Z,ee){super(Z),this.code=ee}}e.$pl=b;function a(R,Z){return b.create(R,Z)}function d(R){return R||a((0,k.localize)(1863,null),m.Unknown)}function N(R,Z){return R.name=Z?`${Z} (FileSystemError)`:"FileSystemError",R}function f(R){if(!R)return m.Unknown;if(R instanceof b)return R.code;const Z=/^(.+) \(FileSystemError\)$/.exec(R.name);if(!Z)return m.Unknown;switch(Z[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}function y(R){if(R instanceof V)return R.fileOperationResult;switch(f(R)){case m.FileNotFound:return oe.FILE_NOT_FOUND;case m.FileIsADirectory:return oe.FILE_IS_DIRECTORY;case m.FileNotADirectory:return oe.FILE_NOT_DIRECTORY;case m.FileWriteLocked:return oe.FILE_WRITE_LOCKED;case m.NoPermissions:return oe.FILE_PERMISSION_DENIED;case m.FileExists:return oe.FILE_MOVE_CONFLICT;case m.FileTooLarge:return oe.FILE_TOO_LARGE;default:return oe.FILE_OTHER_ERROR}}var z;(function(R){R[R.CREATE=0]="CREATE",R[R.DELETE=1]="DELETE",R[R.MOVE=2]="MOVE",R[R.COPY=3]="COPY",R[R.WRITE=4]="WRITE"})(z||(e.FileOperation=z={}));class x{constructor(Z,ee,ie){this.resource=Z,this.operation=ee,this.target=ie}isOperation(Z){return this.operation===Z}}e.$vl=x;var J;(function(R){R[R.UPDATED=0]="UPDATED",R[R.ADDED=1]="ADDED",R[R.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class K{static{this.a=null}constructor(Z,ee){this.c=ee,this.b=void 0,this.d=new w.$W(()=>{const ie=_.$Oi.forUris(()=>this.c);return ie.fill(this.rawAdded.map(ue=>[ue,!0])),ie}),this.f=new w.$W(()=>{const ie=_.$Oi.forUris(()=>this.c);return ie.fill(this.rawUpdated.map(ue=>[ue,!0])),ie}),this.g=new w.$W(()=>{const ie=_.$Oi.forUris(()=>this.c);return ie.fill(this.rawDeleted.map(ue=>[ue,!0])),ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ie of Z){switch(ie.type){case J.ADDED:this.rawAdded.push(ie.resource);break;case J.UPDATED:this.rawUpdated.push(ie.resource);break;case J.DELETED:this.rawDeleted.push(ie.resource);break}this.b!==K.a&&(typeof ie.cId=="number"?this.b===void 0?this.b=ie.cId:this.b!==ie.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(Z,...ee){return this.h(Z,{includeChildren:!1},...ee)}affects(Z,...ee){return this.h(Z,{includeChildren:!0},...ee)}h(Z,ee,...ie){if(!Z)return!1;const ue=ie.length>0;return!!((!ue||ie.includes(J.ADDED))&&(this.d.value.get(Z)||ee.includeChildren&&this.d.value.findSuperstr(Z))||(!ue||ie.includes(J.UPDATED))&&(this.f.value.get(Z)||ee.includeChildren&&this.f.value.findSuperstr(Z))||(!ue||ie.includes(J.DELETED))&&(this.g.value.findSubstr(Z)||ee.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}e.$wl=K;function se(R,Z,ee){return!R||!Z||R===Z||Z.length>R.length?!1:(Z.charAt(Z.length-1)!==t.sep&&(Z+=t.sep),ee?(0,q.$Jf)(R,Z):R.indexOf(Z)===0)}class V extends Error{constructor(Z,ee,ie){super(Z),this.fileOperationResult=ee,this.options=ie}}e.$yl=V;class ne extends V{constructor(Z,ee,ie,ue){super(Z,ee,ue),this.fileOperationResult=ee,this.size=ie}}e.$zl=ne;class re extends V{constructor(Z,ee,ie){super(Z,oe.FILE_NOT_MODIFIED_SINCE,ie),this.stat=ee}}e.$Al=re;var oe;(function(R){R[R.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",R[R.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",R[R.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",R[R.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",R[R.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",R[R.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",R[R.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",R[R.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",R[R.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",R[R.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",R[R.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(oe||(e.FileOperationResult=oe={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var I;(function(R){R[R.FILE=0]="FILE",R[R.FOLDER=1]="FOLDER",R[R.ROOT_FOLDER=2]="ROOT_FOLDER"})(I||(e.FileKind=I={})),e.$Il="";function $(R){if(!(typeof R.size!="number"||typeof R.mtime!="number"))return R.mtime.toString(29)+R.size.toString(31)}async function P(R,Z){if(!Z.hasProvider(X.URI.from({scheme:R.scheme})))return new Promise(ee=>{const ie=Z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===R.scheme&&ue.added&&(ie.dispose(),ee())})})}class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(Z){return(0,j.$lg)(Z)||(Z=0),Z<W.KB?(0,k.localize)(1864,null,Z.toFixed(0)):Z<W.MB?(0,k.localize)(1865,null,(Z/W.KB).toFixed(2)):Z<W.GB?(0,k.localize)(1866,null,(Z/W.MB).toFixed(2)):Z<W.TB?(0,k.localize)(1867,null,(Z/W.GB).toFixed(2)):(0,k.localize)(1868,null,(Z/W.TB).toFixed(2))}}e.$Ll=W;function Q(R){const Z=typeof R=="string"||R?.scheme===F.Schemas.vscodeRemote;return typeof R!="string"&&R?.scheme===F.Schemas.file?1024*W.MB:Z?10*W.MB:O.$p?50*W.MB:1024*W.MB}}),define(be[19],_e([0,1,23,4,3,2,5,18]),function(fe,e,_,t,q,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=void 0,e.$9q=L,e.$0q=O,e.$br=p,e.$cr=c,e.$dr=r,e.$er=h,e.$fr=l,e.$gr=D;function L(A){return typeof A.correlationId=="number"}function O(A){return A.recursive===!0}class F extends t.$Xc{static{this.a=5}constructor(u,i,n,s){super(),this.h=u,this.j=i,this.m=n,this.n=s,this.c=this.B(new t.$Yc),this.f=void 0,this.g=0}s(){const u=new t.$Wc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(i=>this.h(i))),u.add(this.b.onDidLogMessage(i=>this.j(i))),u.add(this.b.onDidError(i=>this.t(i.error,i.request)))}t(u,i){this.u(u,i)?this.g<F.a&&this.f?(this.y(`restarting watcher after unexpected error: ${u}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${u}`):this.y(u)}u(u,i){return!(!this.n.restartOnError||i||u.indexOf("No space left on device")!==-1||u.indexOf("EMFILE")!==-1)}w(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}y(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}z(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$$q=F;class w extends F{constructor(u,i,n){super(u,i,n,{type:"node.js",restartOnError:!1})}}e.$_q=w;class v extends F{constructor(u,i,n){super(u,i,n,{type:"universal",restartOnError:!0})}}e.$ar=v;function p(A){return A.map(u=>({type:u.type,resource:X.URI.revive(u.resource),cId:u.cId}))}function c(A){const u=new E;for(const i of A)u.processEvent(i);return u.coalesce()}function r(A,u){return typeof u=="string"&&!u.startsWith(_.$zk)&&!(0,q.$lc)(u)?{base:A,pattern:u}:u}function h(A,u){const i=[];for(const n of u)i.push((0,_.$Dk)(r(A,n)));return i}class E{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$l?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const i=this.b.get(this.c(u));let n=!1;if(i){const s=i.type,o=u.type;i.resource.fsPath!==u.resource.fsPath&&(u.type===k.FileChangeType.DELETED||u.type===k.FileChangeType.ADDED)?n=!0:s===k.FileChangeType.ADDED&&o===k.FileChangeType.DELETED?(this.b.delete(this.c(u)),this.a.delete(i)):s===k.FileChangeType.DELETED&&o===k.FileChangeType.ADDED?i.type=k.FileChangeType.UPDATED:s===k.FileChangeType.ADDED&&o===k.FileChangeType.UPDATED||(i.type=o)}else n=!0;n&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],i=[];return Array.from(this.a).filter(n=>n.type!==k.FileChangeType.DELETED?(u.push(n),!1):!0).sort((n,s)=>n.resource.fsPath.length-s.resource.fsPath.length).filter(n=>i.some(s=>(0,k.$xl)(n.resource.fsPath,s,!j.$l))?!1:(i.push(n.resource.fsPath),!0)).concat(u)}}function l(A,u){if(typeof u=="number")switch(A.type){case k.FileChangeType.ADDED:return(u&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(u&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(u&k.FileChangeFilter.UPDATED)===0}return!1}function D(A){if(typeof A=="number"){const u=[];return A&k.FileChangeFilter.ADDED&&u.push("Added"),A&k.FileChangeFilter.DELETED&&u.push("Deleted"),A&k.FileChangeFilter.UPDATED&&u.push("Updated"),u.length===0?"<all>":`[${u.join(", ")}]`}return"<none>"}}),define(be[35],_e([0,1,15,4,19,6,18,5,8]),function(fe,e,_,t,q,j,X,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class O extends t.$Xc{constructor(){super(),this.a=this.B(new j.$oe),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$oe),this.onDidLogMessage=this.b.event,this.c=this.B(new j.$oe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new t.$7c),this.m=new Set,this.n=this.B(new L.$Gh(this.y())),this.r=5007,this.s=new L.$6h,this.R=!1,this.B(this.f(w=>this.t(w)))}t(w){this.u(w)&&this.z(w)}u(w){return(0,q.$9q)(w)}async watch(w){this.s.isSettled||this.s.complete(),this.s=new L.$6h;try{this.h.clear(),this.g.clear();for(const v of w)this.u(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.w(!1)}finally{this.s.complete()}}w(w){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(v=>!this.j.has(v.correlationId))]),w?this.y():0)}y(){return 800}isSuspended(w){return typeof w.correlationId!="number"?!1:this.m.has(w.correlationId)?"polling":this.j.has(w.correlationId)}async z(w){if(this.j.has(w.correlationId))return;const v=new t.$Wc;this.j.set(w.correlationId,v),await this.s.p,!v.isDisposed&&(this.D(w,v),this.w(!0))}C(w){this.j.deleteAndDispose(w.correlationId),this.m.delete(w.correlationId),this.w(!1)}D(w,v){this.F(w,v)?(this.P(`reusing an existing recursive watcher to monitor ${w.path}`),this.m.delete(w.correlationId)):(this.G(w,v),this.m.add(w.correlationId))}F(w,v){const p=this.O?.subscribe(w.path,(c,r)=>{v.isDisposed||(c?this.D(w,v):r?.type===X.FileChangeType.ADDED&&this.H(w))});return p?(v.add(p),!0):!1}G(w,v){let p=!1;const c=(r,h)=>{if(v.isDisposed)return;const E=this.I(r),l=this.I(h),D=p;p=E,!E&&(l||D)&&this.H(w)};this.P(`starting fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,_.watchFile)(w.path,{persistent:!1,interval:this.r},c)}catch(r){this.Q(`fs.watchFile() failed with error ${r} on path ${w.path} (correlationId: ${w.correlationId})`)}v.add((0,t.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,_.unwatchFile)(w.path,c)}catch(r){this.Q(`fs.unwatchFile() failed with error ${r} on path ${w.path} (correlationId: ${w.correlationId})`)}}))}H(w){this.P(`detected ${w.path} exists again, resuming watcher (correlationId: ${w.correlationId})`);const v={resource:k.URI.file(w.path),type:X.FileChangeType.ADDED,cId:w.correlationId};this.a.fire([v]),this.J(v,w),this.C(w)}I(w){return w.ctimeMs===0&&w.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(w,v){if(this.R){const p=` >> normalized ${w.type===X.FileChangeType.ADDED?"[ADDED]":w.type===X.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`;this.L(p,v)}}L(w,v){this.R&&this.P(`${w}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}M(w){return`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, filter: ${(0,q.$gr)(w.filter)}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`}async setVerboseLogging(w){this.R=w}}e.$pr=O}),define(be[36],_e([0,1,15,8,13,14,4,21,3,2,22,5,32,24,18,19]),function(fe,e,_,t,q,j,X,k,L,O,F,w,v,p,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0,e.$vr=E;class h extends X.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(D,A,u,i,n,s){super(),this.s=D,this.t=A,this.u=u,this.w=i,this.y=n,this.z=s,this.c=this.B(new t.$Xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.u(o))),this.f=this.B(new t.$Wh(o=>this.M(o),h.b)),this.g=(0,r.$er)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,r.$er)(this.s.path,this.s.includes):void 0,this.j=(0,r.$9q)(this.s)?this.s.filter:void 0,this.m=new q.$ze,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const D=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const A=await _.promises.stat(D);if(this.m.token.isCancellationRequested)return;this.B(await this.G(D,A.isDirectory()))}catch(D){D.code!=="ENOENT"?this.O(D):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${D})`),this.D()}}D(){this.r=!0,this.w?.()}async F(D){let A=D.path;try{A=await p.Promises.realpath(D.path),D.path===A&&(A=await(0,v.$rr)(D.path,this.m.token)??D.path),D.path!==A&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${D.path}, real: ${A})`)}catch{}return A}async G(D,A){const u=new X.$Wc;return this.H(D,A,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(D,A,u)),u}H(D,A,u){if(A)return!1;const i=w.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(s,o)=>{if(!u.isDisposed)if(s){const S=await this.G(D,A);u.isDisposed?S.dispose():u.add(S)}else o&&(typeof o.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:i,type:o.type,cId:this.s.correlationId},!0)});return n?(u.add(n),!0):!1}async I(D,A,u){if(O.$k&&(0,j.$Hg)(D,"/Volumes/",!0)){this.O(`Refusing to watch ${D} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new q.$ze(this.m.token);u.add((0,X.$Vc)(()=>i.dispose(!0)));const n=new X.$Wc;u.add(n);try{const s=w.URI.file(this.s.path),o=(0,L.$qc)(D),S=(0,_.watch)(D);n.add((0,X.$Vc)(()=>{S.removeAllListeners(),S.close()})),this.Q(`Started watching: '${D}'`);const m=new Set;if(A)try{for(const a of await p.Promises.readdir(D))m.add(a)}catch(a){this.O(a)}if(i.token.isCancellationRequested)return;const b=new Map;n.add((0,X.$Vc)(()=>{for(const[,a]of b)a.dispose();b.clear()})),S.on("error",(a,d)=>{i.token.isCancellationRequested||(this.O(`Failed to watch ${D} for changes using fs.watch() (${a}, ${d})`),this.D())}),S.on("change",(a,d)=>{if(i.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${a}"] ${d}`);let N="";if(d&&(N=d.toString(),O.$k&&(N=(0,k.$qm)(N))),!(!N||a!=="change"&&a!=="rename"))if(A)if(a==="rename"){b.get(N)?.dispose();const f=setTimeout(async()=>{if(b.delete(N),N===o&&!await p.Promises.exists(D)){this.J(s);return}if(i.token.isCancellationRequested)return;const y=await this.N((0,L.$mc)(D,N));if(i.token.isCancellationRequested)return;let z;y?m.has(N)?z=c.FileChangeType.UPDATED:(z=c.FileChangeType.ADDED,m.add(N)):(m.delete(N),z=c.FileChangeType.DELETED),this.L({resource:(0,F.$jh)(s,N),type:z,cId:this.s.correlationId})},h.a);b.set(N,(0,X.$Vc)(()=>clearTimeout(f)))}else{let f;m.has(N)?f=c.FileChangeType.UPDATED:(f=c.FileChangeType.ADDED,m.add(N)),this.L({resource:(0,F.$jh)(s,N),type:f,cId:this.s.correlationId})}else if(a==="rename"||N!==o){const f=setTimeout(async()=>{const y=await p.Promises.exists(D);i.token.isCancellationRequested||(y?(this.L({resource:s,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(D,!1))):this.J(s))},h.a);n.clear(),n.add((0,X.$Vc)(()=>clearTimeout(f)))}else this.L({resource:s,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(s){i.token.isCancellationRequested||this.O(`Failed to watch ${D} for changes using fs.watch() (${s.toString()})`),this.D()}}J(D){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:D,type:c.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(D,A=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${D.type===c.FileChangeType.ADDED?"[ADDED]":D.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${D.resource.fsPath}`),!A&&this.g.some(u=>u(D.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${D.resource.fsPath}`):!A&&this.h&&this.h.length>0&&!this.h.some(u=>u(D.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${D.resource.fsPath}`):this.f.work(D))}M(D){const A=(0,r.$cr)(D),u=[];for(const n of A){if((0,r.$fr)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}u.push(n)}if(u.length===0)return;if(this.z)for(const n of u)this.R(` >> normalized ${n.type===c.FileChangeType.ADDED?"[ADDED]":n.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(D){if(O.$l)return p.Promises.exists(D);try{const A=(0,L.$qc)(D);return(await p.Promises.readdir((0,L.$pc)(D))).some(i=>i===A)}catch(A){return this.Q(A),!1}}setVerboseLogging(D){this.z=D}O(D){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${D}`})}P(D){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${D}`})}Q(D){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${D}`})}R(D){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${D}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ur=h;async function E(l,D,A,u,i=512){const n=await p.Promises.open(l,"r"),s=Buffer.allocUnsafe(i),o=new q.$ze(u);let S,m=!1;const b={path:l,excludes:[],recursive:!1},a=new h(b,void 0,d=>{(async()=>{for(const{type:N}of d)if(N===c.FileChangeType.UPDATED){if(m)return;m=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:f}=await p.Promises.read(n,s,0,i,null);if(!f||o.token.isCancellationRequested)break;D(s.slice(0,f))}}catch(f){S=new Error(f),o.dispose(!0)}finally{m=!1}}})()});return await a.ready,A(),new Promise((d,N)=>{o.token.onCancellationRequested(async()=>{a.dispose();try{await p.Promises.close(n)}catch(f){S=new Error(f)}S?N(S):d()})})}}),define(be[56],_e([0,1,6,23,35,2,36,14]),function(fe,e,_,t,q,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class L extends q.$pr{constructor(F){super(),this.O=F,this.onDidError=_.Event.None,this.watchers=new Set}async N(F){F=this.Z(F);const w=[],v=new Set(Array.from(this.watchers));for(const p of F){const c=this.W(p);c&&(0,t.$Hk)(c.request.excludes,p.excludes)&&(0,t.$Hk)(c.request.includes,p.includes)?v.delete(c):w.push(p)}w.length&&this.P(`Request to start watching: ${w.map(p=>this.M(p)).join(",")}`),v.size&&this.P(`Request to stop watching: ${Array.from(v).map(p=>this.M(p.request)).join(",")}`);for(const p of v)this.Y(p);for(const p of w)this.X(p)}W(F){for(const w of this.watchers)if(typeof F.correlationId=="number"||typeof w.request.correlationId=="number"){if(w.request.correlationId===F.correlationId)return w}else if((0,k.$Gg)(w.request.path,F.path,!j.$l))return w}X(F){const w=new X.$ur(F,this.O,p=>this.a.fire(p),()=>this.c.fire(F),p=>this.b.fire(p),this.R),v={request:F,instance:w};this.watchers.add(v)}async stop(){await super.stop();for(const F of this.watchers)this.Y(F)}Y(F){this.P("stopping file watcher",F),this.watchers.delete(F),F.instance.dispose()}Z(F){const w=new Map;for(const v of F){const p=j.$l?v.path:v.path.toLowerCase();let c=w.get(v.correlationId);c||(c=new Map,w.set(v.correlationId,c)),c.has(p)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(v)}`),c.set(p,v)}return Array.from(w.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(F){super.setVerboseLogging(F);for(const w of this.watchers)w.instance.setVerboseLogging(F)}P(F,w){this.R&&this.b.fire({type:"trace",message:this.bb(F,w)})}Q(F){this.b.fire({type:"warn",message:this.bb(F)})}bb(F,w){return w?`[File Watcher (node.js)] ${F} (${this.M(w.request)})`:`[File Watcher (node.js)] ${F}`}}e.$wr=L}),define(be[57],_e([0,1,62,15,50,5,8,13,54,6,14,23,35,30,21,3,2,32,36,18,19,4]),function(fe,e,_,t,q,j,X,k,L,O,F,w,v,p,c,r,h,E,l,D,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=e.$pnc=void 0,_=Ue(_);class i extends u.$Xc{get failed(){return this.c}get stopped(){return this.f}constructor(o,S,m,b,a,d){super(),this.ready=o,this.request=S,this.restarts=m,this.token=b,this.worker=a,this.m=d,this.a=this.B(new O.$oe),this.onDidStop=this.a.event,this.b=this.B(new O.$oe),this.onDidFail=this.b.event,this.c=!1,this.f=!1,this.g=this.request.includes?(0,A.$er)(this.request.path,this.request.includes):void 0,this.h=this.request.excludes?(0,A.$er)(this.request.path,this.request.excludes):void 0,this.j=new Map,this.B((0,u.$Vc)(()=>this.j.clear()))}subscribe(o,S){o=j.URI.file(o).fsPath;let m=this.j.get(o);return m||(m=new Set,this.j.set(o,m)),m.add(S),(0,u.$Vc)(()=>{const b=this.j.get(o);b&&(b.delete(S),b.size===0&&this.j.delete(o))})}get subscriptionsCount(){return this.j.size}notifyFileChange(o,S){const m=this.j.get(o);if(m)for(const b of m)b(S)}notifyWatchFailed(){this.c=!0,this.b.fire()}include(o){return!this.g||this.g.length===0?!0:this.g.some(S=>S(o))}exclude(o){return!!this.h?.some(S=>S(o))}async stop(o){this.f=!0;try{await this.m()}finally{this.a.fire({joinRestart:o}),this.dispose()}}}e.$pnc=i;class n extends v.$pr{static{this.S=new Map([["create",D.FileChangeType.ADDED],["update",D.FileChangeType.UPDATED],["delete",D.FileChangeType.DELETED]])}static{this.U=h.$j?"windows":h.$l?"inotify":"fs-events"}static{this.X=75}constructor(){super(),this.W=this.B(new O.$oe),this.onDidError=this.W.event,this.watchers=new Set,this.Y=this.B(new X.$Xh({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},o=>this.a.fire(o))),this.Z=!1,this.$()}$(){process.on("uncaughtException",o=>this.nb(o)),process.on("unhandledRejection",o=>this.nb(o))}async N(o){o=this.qb(o);const S=[],m=new Set(Array.from(this.watchers));for(const b of o){const a=this.bb(b);a&&(0,w.$Hk)(a.request.excludes,b.excludes)&&(0,w.$Hk)(a.request.includes,b.includes)&&a.request.pollingInterval===b.pollingInterval?m.delete(a):S.push(b)}S.length&&this.P(`Request to start watching: ${S.map(b=>this.M(b)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(b=>this.M(b.request)).join(",")}`);for(const b of m)await this.pb(b);for(const b of S)b.pollingInterval?this.cb(b,b.pollingInterval):await this.db(b)}bb(o){for(const S of this.watchers)if(this.u(o)||this.u(S.request)){if(S.request.correlationId===o.correlationId)return S}else if((0,F.$Gg)(S.request.path,o.path,!h.$l))return S}cb(o,S,m=0){const b=new k.$ze,a=new X.$6h,d=(0,F.$Qg)((0,q.tmpdir)(),"vscode-watcher-snapshot"),N=new i(a.p,o,m,b.token,new X.$Wh(K=>this.gb(K,N),n.X),async()=>{b.dispose(!0),N.worker.flush(),N.worker.dispose(),J.dispose(),(0,t.unlinkSync)(d)});this.watchers.add(N);const{realPath:f,realPathDiffers:y,realPathLength:z}=this.ib(o);this.P(`Started watching: '${f}' with polling interval '${S}'`);let x=0;const J=new X.$Uh(async()=>{if(x++,!b.token.isCancellationRequested){if(x>1){const K=await _.getEventsSince(f,d,{ignore:o.excludes,backend:n.U});if(b.token.isCancellationRequested)return;this.eb(K,N,y,z)}await _.writeSnapshot(f,d,{ignore:o.excludes,backend:n.U}),x===1&&a.complete(),!b.token.isCancellationRequested&&J.schedule()}},S);J.schedule(0)}async db(o,S=0){const m=new k.$ze,b=new X.$6h,a=new i(b.p,o,S,m.token,new X.$Wh(y=>this.gb(y,a),n.X),async()=>{m.dispose(!0),a.worker.flush(),a.worker.dispose(),await(await b.p)?.unsubscribe()});this.watchers.add(a);const{realPath:d,realPathDiffers:N,realPathLength:f}=this.ib(o);try{const y=await _.subscribe(d,(z,x)=>{a.token.isCancellationRequested||(z&&this.nb(z,o),this.eb(x,a,N,f))},{backend:n.U,ignore:a.request.excludes});this.P(`Started watching: '${d}' with backend '${n.U}'`),b.complete(y)}catch(y){this.nb(y,o),b.complete(void 0),a.notifyWatchFailed(),this.c.fire(o)}}eb(o,S,m,b){if(o.length===0)return;this.jb(o,S.request,m,b);const a=this.fb(S,o);for(const d of a)S.worker.work(d)}fb(o,S){const m=[];for(const{path:b,type:a}of S){const d=n.S.get(a);this.R&&this.L(`${d===D.FileChangeType.ADDED?"[ADDED]":d===D.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${b}`,o.request),o.include(b)?m.push({type:d,resource:j.URI.file(b),cId:o.request.correlationId}):this.R&&this.L(` >> ignored (not included) ${b}`,o.request)}return m}gb(o,S){const m=(0,A.$cr)(o),{events:b,rootDeleted:a}=this.kb(m,S);this.hb(b,S),a&&this.lb(S)}hb(o,S){if(o.length===0)return;this.Y.work(o)?this.Y.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.Y.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,S):this.Q(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}ib(o){let S=o.path,m=!1,b=o.path.length;try{S=(0,E.$tr)(o.path),o.path===S&&(S=(0,E.$qr)(o.path)??o.path),o.path!==S&&(b=S.length,m=!0,this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${S})`))}catch{}return{realPath:S,realPathDiffers:m,realPathLength:b}}jb(o,S,m,b){for(const a of o)h.$k&&(a.path=(0,c.$qm)(a.path)),h.$j&&S.path.length<=3&&(a.path=(0,r.$kc)(a.path)),m&&(a.path=S.path+a.path.substr(b))}kb(o,S){const m=[];let b=!1;const a=this.u(S.request)?S.request.filter:void 0;for(const d of o){if(S.subscriptionsCount>0&&S.notifyFileChange(d.resource.fsPath,d),b=d.type===D.FileChangeType.DELETED&&(0,F.$Gg)(d.resource.fsPath,S.request.path,!h.$l),(0,A.$fr)(d,a)||b&&!this.u(S.request)){this.R&&this.L(` >> ignored (filtered) ${d.resource.fsPath}`,S.request);continue}this.J(d,S.request),m.push(d)}return{events:m,rootDeleted:b}}lb(o){this.Q("Watcher shutdown because watched path got deleted",o);let S=!1;this.u(o.request)||(S=this.mb(o)),S||(o.notifyWatchFailed(),this.c.fire(o.request))}mb(o){const S=(0,r.$pc)(o.request.path);if((0,t.existsSync)(S)){this.P("Trying to watch on the parent path to restart the watcher...",o);const m=new l.$ur({path:S,excludes:[],recursive:!1,correlationId:o.request.correlationId},void 0,b=>{if(!o.token.isCancellationRequested){for(const{resource:a,type:d}of b)if((0,F.$Gg)(a.fsPath,o.request.path,!h.$l)&&(d===D.FileChangeType.ADDED||d===D.FileChangeType.UPDATED)&&this.rb(o.request.path)){this.Q("Watcher restarts because watched path got created again",o),m.dispose(),this.ob(o);break}}},void 0,b=>this.b.fire(b),this.R);return o.token.onCancellationRequested(()=>m.dispose()),!0}return!1}nb(o,S){const m=(0,L.$tj)(o);m.indexOf("No space left on device")!==-1?this.Z||(this.ub("Inotify limit reached (ENOSPC)",S),this.Z=!0):(this.ub(`Unexpected error: ${m} (EUNKNOWN)`,S),this.W.fire({request:S,error:m}))}async stop(){await super.stop();for(const o of this.watchers)await this.pb(o)}ob(o,S=800){const m=new X.$Uh(async()=>{if(o.token.isCancellationRequested)return;const b=new X.$6h;try{await this.pb(o,b.p),o.request.pollingInterval?this.cb(o.request,o.request.pollingInterval,o.restarts+1):await this.db(o.request,o.restarts+1)}finally{b.complete()}},S);m.schedule(),o.token.onCancellationRequested(()=>m.dispose())}async pb(o,S){this.P("stopping file watcher",o),this.watchers.delete(o);try{await o.stop(S)}catch(m){this.ub(`Unexpected error stopping watcher: ${(0,L.$tj)(m)}`,o.request)}}qb(o,S=!0){o.sort((a,d)=>a.path.length-d.path.length);const m=new Map;for(const a of o){if(a.excludes.includes(w.$zk))continue;const d=h.$l?a.path:a.path.toLowerCase();let N=m.get(a.correlationId);N||(N=new Map,m.set(a.correlationId,N)),N.has(d)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(a)}`),N.set(d,a)}const b=[];for(const a of m.values()){const d=p.$Oi.forPaths(!h.$l);for(const N of a.values()){if(d.findSubstr(N.path))try{if((0,E.$tr)(N.path)===N.path){this.P(`ignoring a request for watching who's parent is already watched: ${this.M(N)}`);continue}}catch(f){this.P(`ignoring a request for watching who's realpath failed to resolve: ${this.M(N)} (error: ${f})`),this.c.fire(N);continue}if(S&&!this.rb(N.path)){this.c.fire(N);continue}d.set(N.path,N)}b.push(...Array.from(d).map(([,N])=>N))}return b}rb(o){try{if(!(0,t.statSync)(o).isDirectory())return this.P(`ignoring a path for watching that is a file and not a folder: ${o}`),!1}catch(S){return this.P(`ignoring a path for watching who's stat info failed to resolve: ${o} (error: ${S})`),!1}return!0}subscribe(o,S){for(const m of this.watchers){if(m.failed||!(0,F.$Hg)(o,m.request.path,!h.$l)||m.exclude(o)||!m.include(o))continue;const b=new u.$Wc;return b.add(O.Event.once(m.onDidStop)(async a=>{await a.joinRestart,!b.isDisposed&&S(!0)})),b.add(O.Event.once(m.onDidFail)(()=>S(!0))),b.add(m.subscribe(o,a=>S(null,a))),b}}P(o,S){this.R&&this.b.fire({type:"trace",message:this.vb(o,S?.request)})}Q(o,S){this.b.fire({type:"warn",message:this.vb(o,S?.request)})}ub(o,S){this.b.fire({type:"error",message:this.vb(o,S)})}vb(o,S){return S?`[File Watcher (parcel)] ${o} (path: ${S.path})`:`[File Watcher (parcel)] ${o}`}get O(){return this}}e.$qnc=n}),define(be[58],_e([0,1,19]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=t;function t(c,r,h){const E=[],l=L(c.filter(z=>z.recursive)),D=l.filter(z=>r.isSuspended(z)===!1),A=l.filter(z=>r.isSuspended(z)==="polling"),u=l.filter(z=>r.isSuspended(z)===!0),i=j(l,r),n=X(r),s=L(c.filter(z=>!z.recursive)),o=s.filter(z=>h.isSuspended(z)===!1),S=s.filter(z=>h.isSuspended(z)==="polling"),m=s.filter(z=>h.isSuspended(z)===!0),b=j(s,h),a=k(h);E.push("[Summary]"),E.push(`- Recursive Requests:     total: ${l.length}, suspended: ${i.suspended}, polling: ${i.polling}`),E.push(`- Non-Recursive Requests: total: ${s.length}, suspended: ${b.suspended}, polling: ${b.polling}`),E.push(`- Recursive Watchers:     total: ${r.watchers.size}, active: ${n.active}, failed: ${n.failed}, stopped: ${n.stopped}`),E.push(`- Non-Recursive Watchers: total: ${h.watchers.size}, active: ${a.active}, failed: ${a.failed}, reusing: ${a.reusing}`),E.push(`- I/O Handles Impact:     total: ${i.polling+b.polling+n.active+a.active}`),E.push(`
[Recursive Requests (${l.length}, suspended: ${i.suspended}, polling: ${i.polling})]:`);const d=[];for(const z of[D,A,u].flat())F(d,z,r);E.push(...q(d));const N=[];v(N,r),E.push(...q(N)),E.push(`
[Non-Recursive Requests (${s.length}, suspended: ${b.suspended}, polling: ${b.polling})]:`);const f=[];for(const z of[o,S,m].flat())F(f,z,h);E.push(...q(f));const y=[];return p(y,h),E.push(...q(y)),`

[File Watcher] request stats:

${E.join(`
`)}

`}function q(c){let r=0;for(const h of c)r=Math.max(r,h.split("	")[0].length);for(let h=0;h<c.length;h++){const l=c[h].split("	");if(l.length===2){const D=" ".repeat(r-l[0].length);c[h]=`${l[0]}${D}	${l[1]}`}}return c}function j(c,r){let h=0,E=0;for(const l of c){const D=r.isSuspended(l);D!==!1&&(E++,D==="polling"&&h++)}return{suspended:E,polling:h}}function X(c){let r=0,h=0,E=0;for(const l of c.watchers.values())!l.failed&&!l.stopped&&r++,l.failed&&h++,l.stopped&&E++;return{active:r,failed:h,stopped:E}}function k(c){let r=0,h=0,E=0;for(const l of c.watchers)!l.instance.failed&&!l.instance.isReusingRecursiveWatcher&&r++,l.instance.failed&&h++,l.instance.isReusingRecursiveWatcher&&E++;return{active:r,failed:h,reusing:E}}function L(c){return c.sort((r,h)=>{const E=O(r)?r.path:r.request.path,l=O(h)?h.path:h.request.path,D=Math.min(E.length,l.length);for(let A=0;A<D;A++)if(E[A]!==l[A])return E[A]<l[A]?-1:1;return E.length-l.length}),c}function O(c){return typeof c?.path=="string"}function F(c,r,h){const E=[],l=h.isSuspended(r);l!==!1&&(l==="polling"?E.push("[SUSPENDED <polling>]"):E.push("[SUSPENDED <non-polling>]")),c.push(` ${r.path}	${E.length>0?E.join(" ")+" ":""}(${w(r)})`)}function w(c){return`excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,_.$gr)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"}`}function v(c,r){const h=L(Array.from(r.watchers.values())),{active:E,failed:l,stopped:D}=X(r);c.push(`
[Recursive Watchers (${h.length}, active: ${E}, failed: ${l}, stopped: ${D})]:`);for(const A of h){const u=[];A.failed&&u.push("[FAILED]"),A.stopped&&u.push("[STOPPED]"),A.subscriptionsCount>0&&u.push(`[SUBSCRIBED:${A.subscriptionsCount}]`),A.restarts>0&&u.push(`[RESTARTED:${A.restarts}]`),c.push(` ${A.request.path}	${u.length>0?u.join(" ")+" ":""}(${w(A.request)})`)}}function p(c,r){const h=L(Array.from(r.watchers.values())),E=h.filter(n=>!n.instance.failed&&!n.instance.isReusingRecursiveWatcher),l=h.filter(n=>n.instance.failed),D=h.filter(n=>n.instance.isReusingRecursiveWatcher),{active:A,failed:u,reusing:i}=k(r);c.push(`
[Non-Recursive Watchers (${h.length}, active: ${A}, failed: ${u}, reusing: ${i})]:`);for(const n of[E,l,D].flat()){const s=[];n.instance.failed&&s.push("[FAILED]"),n.instance.isReusingRecursiveWatcher&&s.push("[REUSING]"),c.push(` ${n.request.path}	${s.length>0?s.join(" ")+" ":""}(${w(n.request)})`)}}}),define(be[59],_e([0,1,4,6,57,56,8,58]),function(fe,e,_,t,q,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;class L extends _.$Xc{constructor(){super(...arguments),this.a=this.B(new q.$qnc),this.b=this.B(new j.$wr(this.a)),this.onDidChangeFile=t.Event.any(this.a.onDidChangeFile,this.b.onDidChangeFile),this.onDidError=t.Event.any(this.a.onDidError,this.b.onDidError),this.c=this.B(new t.$oe),this.onDidLogMessage=t.Event.any(this.c.event,this.a.onDidLogMessage,this.b.onDidLogMessage),this.f=[]}async watch(F){this.f=F;let w;try{await this.a.watch(F.filter(v=>v.recursive))}catch(v){w=v}try{await this.b.watch(F.filter(v=>!v.recursive))}catch(v){w||(w=v)}if(w)throw w}async setVerboseLogging(F){F&&this.f.length>0&&this.c.fire({type:"trace",message:(0,k.$rnc)(this.f,this.a,this.b)}),await X.Promises.settled([this.a.setVerboseLogging(F),this.b.setVerboseLogging(F)])}async stop(){await X.Promises.settled([this.a.stop(),this.b.stop()])}}e.$snc=L}),define(be[63],_e([0,1,4,25,52,53,33,59]),function(fe,e,_,t,q,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;(0,X.$rY)(process)?L=new j.$sY:L=new q.$mr("watcher");const O=new k.$snc;L.registerChannel("watcher",t.ProxyChannel.fromService(O,new _.$Wc))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e2b54301a5745870f6b95d81c91fb3e9557d4f08/core/vs/platform/files/node/watcher/watcherMain.js.map
