/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls","vs/base/common/charCode","vs/base/common/decorators","vs/base/common/process","vs/platform/terminal/common/terminal","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/platform/terminal/common/capabilities/capabilities","vs/base/common/lazy","vs/base/common/resources","vs/base/common/map","vs/base/common/marshallingIds","vs/base/node/pfs","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/processes","vs/base/common/objects","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/sandbox/node/electronTypes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uint","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/uuid","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/base/common/date","vs/base/common/errorMessage","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","util","minimist","node-pty","vs/base/common/performance","@xterm/headless","vs/platform/terminal/node/ptyHostMain"],fe=function(ie){for(var e=[],o=0,t=ie.length;o<t;o++)e[o]=he[ie[o]];return e};define(he[43],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=o,e.$ib=t,e.$jb=A,e.$kb=m,e.$lb=j,e.$mb=_,e.$nb=$,e.$pb=v,e.$qb=b,e.$rb=f,e.$sb=l,e.$tb=c;function o(u,h){const a=t(u,h);if(a!==-1)return u[a]}function t(u,h,a=u.length-1){for(let s=a;s>=0;s--){const p=u[s];if(h(p))return s}return-1}function A(u,h){const a=m(u,h);return a===-1?void 0:u[a]}function m(u,h,a=0,s=u.length){let p=a,E=s;for(;p<E;){const S=Math.floor((p+E)/2);h(u[S])?p=S+1:E=S}return p-1}function j(u,h){const a=_(u,h);return a===u.length?void 0:u[a]}function _(u,h,a=0,s=u.length){let p=a,E=s;for(;p<E;){const S=Math.floor((p+E)/2);h(u[S])?E=S:p=S+1}return p}function $(u,h,a=0,s=u.length){const p=_(u,h,a,s);return p===u.length?-1:p}class r{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(r.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!h(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const a=m(this.e,h,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$ob=r;function v(u,h){if(u.length===0)return;let a=u[0];for(let s=1;s<u.length;s++){const p=u[s];h(p,a)>0&&(a=p)}return a}function b(u,h){if(u.length===0)return;let a=u[0];for(let s=1;s<u.length;s++){const p=u[s];h(p,a)>=0&&(a=p)}return a}function f(u,h){return v(u,(a,s)=>-h(a,s))}function l(u,h){if(u.length===0)return-1;let a=0;for(let s=1;s<u.length;s++){const p=u[s];h(p,u[a])>0&&(a=s)}return a}function c(u,h){for(const a of u){const s=h(a);if(s!==void 0)return s}}}),define(he[13],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var o;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(o||(e.CharCode=o={}))}),define(he[44],fe([0,1]),function(ie,e){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=t,e.$d=A,e.$e=m,e.$f=j;function t($,r){const v=Object.create(null);for(const b of $){const f=r(b);let l=v[f];l||(l=v[f]=[]),l.push(b)}return v}function A($,r){const v=[],b=[];for(const f of $)r.has(f)||v.push(f);for(const f of r)$.has(f)||b.push(f);return{removed:v,added:b}}function m($,r){const v=[],b=[];for(const[f,l]of $)r.has(f)||v.push(l);for(const[f,l]of r)$.has(f)||b.push(l);return{removed:v,added:b}}function j($,r){const v=new Set;for(const b of r)$.has(b)&&v.add(b);return v}class _{static{o=Symbol.toStringTag}constructor(r,v){this.b=v,this.a=new Map,this[o]="SetWithKey";for(const b of r)this.add(b)}get size(){return this.a.size}add(r){const v=this.b(r);return this.a.set(v,r),this}delete(r){return this.a.delete(this.b(r))}has(r){return this.a.has(this.b(r))}*entries(){for(const r of this.a.values())yield[r,r]}keys(){return this.values()}*values(){for(const r of this.a.values())yield r}clear(){this.a.clear()}forEach(r,v){this.a.forEach(b=>r.call(v,b,b,this))}[Symbol.iterator](){return this.values()}}e.$g=_}),define(he[14],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=t,e.$bi=A,e.$ci=m;function o(j){return(_,$,r)=>{let v=null,b=null;if(typeof r.value=="function"?(v="value",b=r.value):typeof r.get=="function"&&(v="get",b=r.get),!b)throw new Error("not supported");r[v]=j(b,$)}}function t(j,_,$){let r=null,v=null;if(typeof $.value=="function"?(r="value",v=$.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(r="get",v=$.get),!v)throw new Error("not supported");const b=`$memoize$${_}`;$[r]=function(...f){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,f)}),this[b]}}function A(j,_,$){return o((r,v)=>{const b=`$debounce$${v}`,f=`$debounce$result$${v}`;return function(...l){this[f]||(this[f]=$?$():void 0),clearTimeout(this[b]),_&&(this[f]=_(this[f],...l),l=[this[f]]),this[b]=setTimeout(()=>{r.apply(this,l),this[f]=$?$():void 0},j)}})}function m(j,_,$){return o((r,v)=>{const b=`$throttle$timer$${v}`,f=`$throttle$result$${v}`,l=`$throttle$lastRun$${v}`,c=`$throttle$pending$${v}`;return function(...u){if(this[f]||(this[f]=$?$():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),_&&(this[f]=_(this[f],...u)),this[c])return;const h=this[l]+j;h<=Date.now()?(this[l]=Date.now(),r.apply(this,[this[f]]),this[f]=$?$():void 0):(this[c]=!0,this[b]=setTimeout(()=>{this[c]=!1,this[l]=Date.now(),r.apply(this,[this[f]]),this[f]=$?$():void 0},h-Date.now()))}})}}),define(he[7],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=t,e.$1=A,e.$2=m,e.$3=j,e.$4=_,e.$5=$,e.$6=v,e.$8=f,e.$9=l,e.$0=c,e.$_=h;class o{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?E.isErrorNoTelemetry(n)?new E(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(g=>{g(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$X=o,e.$Y=new o;function t(i){e.$Y.setUnexpectedErrorHandler(i)}function A(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function m(i){v(i)||e.$Y.onUnexpectedError(i)}function j(i){v(i)||e.$Y.onUnexpectedExternalError(i)}function _(i){if(i instanceof Error){const{name:n,message:g}=i,R=i.stacktrace||i.stack;return{$isError:!0,name:n,message:g,stack:R,noTelemetry:E.isErrorNoTelemetry(i)}}return i}function $(i){let n;return i.noTelemetry?n=new E:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const r="Canceled";function v(i){return i instanceof b?!0:i instanceof Error&&i.name===r&&i.message===r}class b extends Error{constructor(){super(r),this.name=this.message}}e.$7=b;function f(){const i=new Error(r);return i.name=i.message,i}function l(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function c(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class u extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=u;function h(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class a extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$ab=a;class s extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$bb=s;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=p;class E extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof E)return n;const g=new E;return g.message=n.message,g.stack=n.stack,g}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$db=E;class S extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}e.$eb=S}),define(he[17],fe([0,1,7,43]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=A,e.$vb=m,e.$wb=j,e.$xb=_,e.$yb=$,e.$zb=r,e.$Ab=v,e.$Bb=b,e.$Cb=f,e.$Db=l,e.$Eb=c,e.$Fb=u,e.$Gb=h,e.top=a,e.$Ib=s,e.$Jb=E,e.$Kb=S,e.$Lb=i,e.$Mb=n,e.$Nb=g,e.$Ob=R,e.$Pb=q,e.$Qb=w,e.$Rb=L,e.$Sb=k,e.$Tb=O,e.$Ub=z,e.$Vb=D,e.$Wb=y,e.$Xb=N,e.$Yb=I,e.$Zb=P,e.$1b=C,e.$2b=Q,e.$3b=V,e.$4b=Z,e.$5b=re,e.$6b=ae,e.$7b=X,e.$8b=ee,e.$9b=le,e.$_b=de,e.$dc=oe;function A(U,K=0){return U[U.length-(1+K)]}function m(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function j(U,K,T=(M,G)=>M===G){if(U===K)return!0;if(!U||!K||U.length!==K.length)return!1;for(let M=0,G=U.length;M<G;M++)if(!T(U[M],K[M]))return!1;return!0}function _(U,K){const T=U.length-1;K<T&&(U[K]=U[T]),U.pop()}function $(U,K,T){return r(U.length,M=>T(U[M],K))}function r(U,K){let T=0,M=U-1;for(;T<=M;){const G=(T+M)/2|0,x=K(G);if(x<0)T=G+1;else if(x>0)M=G-1;else return G}return-(T+1)}function v(U,K,T){if(U=U|0,U>=K.length)throw new TypeError("invalid index");const M=K[Math.floor(K.length*Math.random())],G=[],x=[],ne=[];for(const $e of K){const ve=T($e,M);ve<0?G.push($e):ve>0?x.push($e):ne.push($e)}return U<G.length?v(U,G,T):U<G.length+ne.length?ne[0]:v(U-(G.length+ne.length),x,T)}function b(U,K){const T=[];let M;for(const G of U.slice(0).sort(K))!M||K(M[0],G)!==0?(M=[G],T.push(M)):M.push(G);return T}function*f(U,K){let T,M;for(const G of U)M!==void 0&&K(M,G)?T.push(G):(T&&(yield T),T=[G]),M=G;T&&(yield T)}function l(U,K){for(let T=0;T<=U.length;T++)K(T===0?void 0:U[T-1],T===U.length?void 0:U[T])}function c(U,K){for(let T=0;T<U.length;T++)K(T===0?void 0:U[T-1],U[T],T+1===U.length?void 0:U[T+1])}function u(U,K,T){const M=[];function G($e,ve,De){if(ve===0&&De.length===0)return;const Ie=M[M.length-1];Ie&&Ie.start+Ie.deleteCount===$e?(Ie.deleteCount+=ve,Ie.toInsert.push(...De)):M.push({start:$e,deleteCount:ve,toInsert:De})}let x=0,ne=0;for(;;){if(x===U.length){G(x,0,K.slice(ne));break}if(ne===K.length){G(x,U.length-x,[]);break}const $e=U[x],ve=K[ne],De=T($e,ve);De===0?(x+=1,ne+=1):De<0?(G(x,1,[]),x+=1):De>0&&(G(x,0,[ve]),ne+=1)}return M}function h(U,K,T){const M=u(U,K,T),G=[],x=[];for(const ne of M)G.push(...U.slice(ne.start,ne.start+ne.deleteCount)),x.push(...ne.toInsert);return{removed:G,added:x}}function a(U,K,T){if(T===0)return[];const M=U.slice(0,T).sort(K);return p(U,K,M,T,U.length),M}function s(U,K,T,M,G){return T===0?Promise.resolve([]):new Promise((x,ne)=>{(async()=>{const $e=U.length,ve=U.slice(0,T).sort(K);for(let De=T,Ie=Math.min(T+M,$e);De<$e;De=Ie,Ie=Math.min(Ie+M,$e)){if(De>T&&await new Promise(we=>setTimeout(we)),G&&G.isCancellationRequested)throw new o.$7;p(U,K,ve,De,Ie)}return ve})().then(x,ne)})}function p(U,K,T,M,G){for(const x=T.length;M<G;M++){const ne=U[M];if(K(ne,T[x-1])<0){T.pop();const $e=(0,t.$mb)(T,ve=>K(ne,ve)<0);T.splice($e,0,ne)}}}function E(U){return U.filter(K=>!!K)}function S(U){let K=0;for(let T=0;T<U.length;T++)U[T]&&(U[K]=U[T],K+=1);U.length=K}function i(U,K,T){U.splice(T,0,U.splice(K,1)[0])}function n(U){return!Array.isArray(U)||U.length===0}function g(U){return Array.isArray(U)&&U.length>0}function R(U,K=T=>T){const T=new Set;return U.filter(M=>{const G=K(M);return T.has(G)?!1:(T.add(G),!0)})}function q(U){const K=new Set;return T=>{const M=U(T);return K.has(M)?!1:(K.add(M),!0)}}function w(U,K){return U.length>0?U[0]:K}function L(U,K){return U.length>0?U[U.length-1]:K}function k(U,K,T=(M,G)=>M===G){let M=0;for(let G=0,x=Math.min(U.length,K.length);G<x&&T(U[G],K[G]);G++)M++;return M}function O(U,K){let T=typeof K=="number"?U:0;typeof K=="number"?T=U:(T=0,K=U);const M=[];if(T<=K)for(let G=T;G<K;G++)M.push(G);else for(let G=T;G>K;G--)M.push(G);return M}function z(U,K,T){return U.reduce((M,G)=>(M[K(G)]=T?T(G):G,M),Object.create(null))}function D(U,K){return U.push(K),()=>y(U,K)}function y(U,K){const T=U.indexOf(K);if(T>-1)return U.splice(T,1),K}function N(U,K,T){const M=U.slice(0,K),G=U.slice(K);return M.concat(T,G)}function I(U,K){let T;if(typeof K=="number"){let M=K;T=()=>{const G=Math.sin(M++)*179426549;return G-Math.floor(G)}}else T=Math.random;for(let M=U.length-1;M>0;M-=1){const G=Math.floor(T()*(M+1)),x=U[M];U[M]=U[G],U[G]=x}}function P(U,K){const T=U.indexOf(K);T>-1&&(U.splice(T,1),U.unshift(K))}function C(U,K){const T=U.indexOf(K);T>-1&&(U.splice(T,1),U.push(K))}function Q(U,K){for(const T of K)U.push(T)}function V(U,K){return Array.isArray(U)?U.map(K):K(U)}function Z(U){return Array.isArray(U)?U:[U]}function re(U){return U[Math.floor(Math.random()*U.length)]}function ae(U,K,T){const M=F(U,K),G=U.length,x=T.length;U.length=G+x;for(let ne=G-1;ne>=M;ne--)U[ne+x]=U[ne];for(let ne=0;ne<x;ne++)U[ne+M]=T[ne]}function X(U,K,T,M){const G=F(U,K);let x=U.splice(G,T);return x===void 0&&(x=[]),ae(U,G,M),x}function F(U,K){return K<0?Math.max(K+U.length,0):Math.min(K,U.length)}var J;(function(U){function K(x){return x<0}U.isLessThan=K;function T(x){return x<=0}U.isLessThanOrEqual=T;function M(x){return x>0}U.isGreaterThan=M;function G(x){return x===0}U.isNeitherLessOrGreaterThan=G,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function ee(U,K){return(T,M)=>K(U(T),U(M))}function le(...U){return(K,T)=>{for(const M of U){const G=M(K,T);if(!J.isNeitherLessOrGreaterThan(G))return G}return J.neitherLessOrGreaterThan}}const W=(U,K)=>U-K;e.$0b=W;const ce=(U,K)=>(0,e.$0b)(U?1:0,K?1:0);e.$$b=ce;function de(U){return(K,T)=>-U(K,T)}class te{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let T=this.c;for(;T<this.g.length&&K(this.g[T]);)T++;const M=T===this.c?null:this.g.slice(this.c,T);return this.c=T,M}takeFromEndWhile(K){let T=this.d;for(;T>=0&&K(this.g[T]);)T--;const M=T===this.d?null:this.g.slice(T+1,this.d+1);return this.d=T,M}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const T=this.g.slice(this.c,this.c+K);return this.c+=K,T}}e.$ac=te;class d{static{this.empty=new d(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(T=>(K(T),!0))}toArray(){const K=[];return this.iterate(T=>(K.push(T),!0)),K}filter(K){return new d(T=>this.iterate(M=>K(M)?T(M):!0))}map(K){return new d(T=>this.iterate(M=>T(K(M))))}some(K){let T=!1;return this.iterate(M=>(T=K(M),!T)),T}findFirst(K){let T;return this.iterate(M=>K(M)?(T=M,!1):!0),T}findLast(K){let T;return this.iterate(M=>(K(M)&&(T=M),!0)),T}findLastMaxBy(K){let T,M=!0;return this.iterate(G=>((M||J.isGreaterThan(K(G,T)))&&(M=!1,T=G),!0)),T}}e.$bc=d;class H{constructor(K){this.c=K}static createSortPermutation(K,T){const M=Array.from(K.keys()).sort((G,x)=>T(K[G],K[x]));return new H(M)}apply(K){return K.map((T,M)=>K[this.c[M]])}inverse(){const K=this.c.slice();for(let T=0;T<this.c.length;T++)K[this.c[T]]=T;return new H(K)}}e.$cc=H;async function oe(U,K){return(await Promise.all(U.map(async(M,G)=>({element:M,ok:await K(M,G)})))).find(M=>M.ok)?.element}}),define(he[45],fe([0,1,7]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=t,e.$hd=A,e.$id=m,e.$jd=j,e.$kd=_,e.$ld=$;function t(r,v){if(!r)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}function A(r,v="Unreachable"){throw new Error(v)}function m(r,v="unexpected state"){if(!r)throw new o.$eb(`Assertion Failed: ${v}`)}function j(r){r||(0,o.$2)(new o.$eb("Soft Assertion Failed"))}function _(r){if(!r()){debugger;r(),(0,o.$2)(new o.$eb("Assertion Failed"))}}function $(r,v){let b=0;for(;b<r.length-1;){const f=r[b],l=r[b+1];if(!v(f,l))return!1;b++}return!0}}),define(he[31],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=o;function o(t,A){const m=this;let j=!1,_;return function(){if(j)return _;if(j=!0,A)try{_=t.apply(m,arguments)}finally{A()}else _=t.apply(m,arguments);return _}}}),define(he[46],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(t){function A(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=A;const m=Object.freeze([]);function j(){return m}t.empty=j;function*_(n){yield n}t.single=_;function $(n){return A(n)?n:_(n)}t.wrap=$;function r(n){return n||m}t.from=r;function*v(n){for(let g=n.length-1;g>=0;g--)yield n[g]}t.reverse=v;function b(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=b;function f(n){return n[Symbol.iterator]().next().value}t.first=f;function l(n,g){let R=0;for(const q of n)if(g(q,R++))return!0;return!1}t.some=l;function c(n,g){for(const R of n)if(g(R))return R}t.find=c;function*u(n,g){for(const R of n)g(R)&&(yield R)}t.filter=u;function*h(n,g){let R=0;for(const q of n)yield g(q,R++)}t.map=h;function*a(n,g){let R=0;for(const q of n)yield*g(q,R++)}t.flatMap=a;function*s(...n){for(const g of n)yield*g}t.concat=s;function p(n,g,R){let q=R;for(const w of n)q=g(q,w);return q}t.reduce=p;function*E(n,g,R=n.length){for(g<0&&(g+=n.length),R<0?R+=n.length:R>n.length&&(R=n.length);g<R;g++)yield n[g]}t.slice=E;function S(n,g=Number.POSITIVE_INFINITY){const R=[];if(g===0)return[R,n];const q=n[Symbol.iterator]();for(let w=0;w<g;w++){const L=q.next();if(L.done)return[R,t.empty()];R.push(L.value)}return[R,{[Symbol.iterator](){return q}}]}t.consume=S;async function i(n){const g=[];for await(const R of n)g.push(R);return Promise.resolve(g)}t.asyncToArray=i})(o||(e.Iterable=o={}))}),define(he[24],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class o{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=o}),define(he[47],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class o{static{this.Undefined=new o(void 0)}constructor(m){this.element=m,this.next=o.Undefined,this.prev=o.Undefined}}class t{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let m=this.a;for(;m!==o.Undefined;){const j=m.next;m.prev=o.Undefined,m.next=o.Undefined,m=j}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(m){return this.d(m,!1)}push(m){return this.d(m,!0)}d(m,j){const _=new o(m);if(this.a===o.Undefined)this.a=_,this.b=_;else if(j){const r=this.b;this.b=_,_.prev=r,r.next=_}else{const r=this.a;this.a=_,_.next=r,r.prev=_}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(_))}}shift(){if(this.a!==o.Undefined){const m=this.a.element;return this.e(this.a),m}}pop(){if(this.b!==o.Undefined){const m=this.b.element;return this.e(this.b),m}}e(m){if(m.prev!==o.Undefined&&m.next!==o.Undefined){const j=m.prev;j.next=m.next,m.next.prev=j}else m.prev===o.Undefined&&m.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):m.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):m.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let m=this.a;for(;m!==o.Undefined;)yield m.element,m=m.next}}e.$8c=t}),define(he[26],fe([0,1]),function(ie,e){"use strict";var o,t,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=m,e.$Bc=j,e.$Cc=_,e.$Lc=E;function m(S,i,n){let g=S.get(i);return g===void 0&&(g=n,S.set(i,g)),g}function j(S){const i=[];return S.forEach((n,g)=>{i.push(`${g} => ${n}`)}),`Map(${S.size}) {${i.join(", ")}}`}function _(S){const i=[];return S.forEach(n=>{i.push(n)}),`Set(${S.size}) {${i.join(", ")}}`}class ${constructor(i,n){this.uri=i,this.value=n}}function r(S){return Array.isArray(S)}class v{static{this.c=i=>i.toString()}constructor(i,n){if(this[o]="ResourceMap",i instanceof v)this.d=new Map(i.d),this.e=n??v.c;else if(r(i)){this.d=new Map,this.e=n??v.c;for(const[g,R]of i)this.set(g,R)}else this.d=new Map,this.e=i??v.c}set(i,n){return this.d.set(this.e(i),new $(i,n)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[g,R]of this.d)i(R.value,R.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Dc=v;class b{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this.c=new v(i):(this.c=new v(n),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,n){this.c.forEach((g,R)=>i.call(n,R,R,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=b;var f;(function(S){S[S.None=0]="None",S[S.AsOld=1]="AsOld",S[S.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class l{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,n=f.None){const g=this.c.get(i);if(g)return n!==f.None&&this.m(g,n),g.value}set(i,n,g=f.None){let R=this.c.get(i);if(R)R.value=n,g!==f.None&&this.m(R,g);else{switch(R={key:i,value:n,next:void 0,previous:void 0},g){case f.None:this.k(R);break;case f.AsOld:this.j(R);break;case f.AsNew:this.k(R);break;default:this.k(R);break}this.c.set(i,R),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this.c.get(i);if(n)return this.c.delete(i),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,n){const g=this.g;let R=this.d;for(;R;){if(n?i.bind(n)(R.value,R.key,this):i(R.value,R.key,this),this.g!==g)throw new Error("LinkedMap got modified during iteration.");R=R.next}}keys(){const i=this,n=this.g;let g=this.d;const R={[Symbol.iterator](){return R},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const q={value:g.key,done:!1};return g=g.next,q}else return{value:void 0,done:!0}}};return R}values(){const i=this,n=this.g;let g=this.d;const R={[Symbol.iterator](){return R},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const q={value:g.value,done:!1};return g=g.next,q}else return{value:void 0,done:!0}}};return R}entries(){const i=this,n=this.g;let g=this.d;const R={[Symbol.iterator](){return R},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const q={value:[g.key,g.value],done:!1};return g=g.next,q}else return{value:void 0,done:!0}}};return R}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.d,g=this.size;for(;n&&g>i;)this.c.delete(n.key),n=n.next,g--;this.d=n,this.f=g,n&&(n.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.e,g=this.size;for(;n&&g>i;)this.c.delete(n.key),n=n.previous,g--;this.e=n,this.f=g,n&&(n.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const n=i.next,g=i.previous;if(!n||!g)throw new Error("Invalid list");n.previous=g,g.next=n}i.next=void 0,i.previous=void 0,this.g++}m(i,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==f.AsOld&&n!==f.AsNew)){if(n===f.AsOld){if(i===this.d)return;const g=i.next,R=i.previous;i===this.e?(R.next=void 0,this.e=R):(g.previous=R,R.next=g),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(n===f.AsNew){if(i===this.e)return;const g=i.next,R=i.previous;i===this.d?(g.previous=void 0,this.d=g):(g.previous=R,R.next=g),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((n,g)=>{i.push([g,n])}),i}fromJSON(i){this.clear();for(const[n,g]of i)this.set(n,g)}}e.$Fc=l;class c extends l{constructor(i,n=1){super(),this.n=i,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,n=f.AsNew){return super.get(i,n)}peek(i){return super.get(i,f.None)}set(i,n){return super.set(i,n,f.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class u extends c{constructor(i,n=1){super(i,n)}q(i){this.h(i)}set(i,n){return super.set(i,n),this.p(),this}}e.$Gc=u;class h extends c{constructor(i,n=1){super(i,n)}q(i){this.i(i)}set(i,n){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,n),this}}e.$Hc=h;class a{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let n=this.c.get(i)||0;return n===0?!1:(n--,n===0?this.c.delete(i):this.c.set(i,n),!0)}has(i){return this.c.has(i)}}e.$Ic=a;class s{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[n,g]of i)this.set(n,g)}clear(){this.c.clear(),this.d.clear()}set(i,n){this.c.set(i,n),this.d.set(n,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const n=this.c.get(i);return n===void 0?!1:(this.c.delete(i),this.d.delete(n),!0)}forEach(i,n){this.c.forEach((g,R)=>{i.call(n,g,R,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=s;class p{constructor(){this.c=new Map}add(i,n){let g=this.c.get(i);g||(g=new Set,this.c.set(i,g)),g.add(n)}delete(i,n){const g=this.c.get(i);g&&(g.delete(n),g.size===0&&this.c.delete(i))}forEach(i,n){const g=this.c.get(i);g&&g.forEach(n)}get(i){const n=this.c.get(i);return n||new Set}}e.$Kc=p;function E(S,i){if(S===i)return!0;if(S.size!==i.size)return!1;for(const[n,g]of S)if(!i.has(n)||i.get(n)!==g)return!1;for(const[n]of i)if(!S.has(n))return!1;return!0}}),define(he[2],fe([0,1,17,44,26,31,46]),function(ie,e,o,t,A,m,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=v,e.$Oc=b,e.$Pc=f,e.$Qc=u,e.$Rc=h,e.$Sc=a,e.$Tc=s,e.$Uc=p,e.$Vc=E,e.$6c=O;const _=!1;let $=null;class r{constructor(){this.b=new Map}static{this.a=0}c(y){let N=this.b.get(y);return N||(N={parent:null,source:null,isSingleton:!1,value:y,idx:r.a++},this.b.set(y,N)),N}trackDisposable(y){const N=this.c(y);N.source||(N.source=new Error().stack)}setParent(y,N){const I=this.c(y);I.parent=N}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,N){const I=N.get(y);if(I)return I;const P=y.parent?this.f(this.c(y.parent),N):y;return N.set(y,P),P}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,I])=>I.source!==null&&!this.f(I,y).isSingleton).flatMap(([I])=>I)}computeLeakingDisposables(y=10,N){let I;if(N)I=N;else{const Z=new Map,re=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,Z).isSingleton);if(re.length===0)return;const ae=new Set(re.map(X=>X.value));if(I=re.filter(X=>!(X.parent&&ae.has(X.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function P(Z){function re(X,F){for(;X.length>0&&F.some(J=>typeof J=="string"?J===X[0]:X[0].match(J));)X.shift()}const ae=Z.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return re(ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ae.reverse()}const C=new A.$Kc;for(const Z of I){const re=P(Z);for(let ae=0;ae<=re.length;ae++)C.add(re.slice(0,ae).join(`
`),Z)}I.sort((0,o.$8b)(Z=>Z.idx,o.$0b));let Q="",V=0;for(const Z of I.slice(0,y)){V++;const re=P(Z),ae=[];for(let X=0;X<re.length;X++){let F=re[X];F=`(shared with ${C.get(re.slice(0,X+1).join(`
`)).size}/${I.length} leaks) at ${F}`;const ee=C.get(re.slice(0,X).join(`
`)),le=(0,t.$c)([...ee].map(W=>P(W)[X]),W=>W);delete le[re[X]];for(const[W,ce]of Object.entries(le))ae.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${W}`);ae.unshift(F)}Q+=`


==================== Leaking disposable ${V}/${I.length}: ${Z.value.constructor.name} ====================
${ae.join(`
`)}
============================================================

`}return I.length>y&&(Q+=`


... and ${I.length-y} more leaking disposables

`),{leaks:I,details:Q}}}e.$Mc=r;function v(D){$=D}if(_){const D="__is_disposable_tracked__";v(new class{trackDisposable(y){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[D]||console.log(N)},3e3)}setParent(y,N){if(y&&y!==i.None)try{y[D]=!0}catch{}}markAsDisposed(y){if(y&&y!==i.None)try{y[D]=!0}catch{}}markAsSingleton(y){}})}function b(D){return $?.trackDisposable(D),D}function f(D){$?.markAsDisposed(D)}function l(D,y){$?.setParent(D,y)}function c(D,y){if($)for(const N of D)$.setParent(N,y)}function u(D){return $?.markAsSingleton(D),D}function h(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function a(D){if(j.Iterable.is(D)){const y=[];for(const N of D)if(N)try{N.dispose()}catch(I){y.push(I)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function s(D){for(const y of D)h(y)&&y.dispose();return[]}function p(...D){const y=E(()=>a(D));return c(D,y),y}function E(D){const y=b({dispose:(0,m.$fb)(()=>{f(y),D()})});return y}class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return l(y,this),this.g?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),l(y,null))}}e.$Wc=S;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new S,b(this),l(this.q,this)}dispose(){f(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Xc=i;class n{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&l(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&l(y,null),y}}e.$Yc=n;class g{constructor(y){this.a=new n,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=g;class R{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=R;class q{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(y){let N=y;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,f(this))},this}}e.$2c=q;class w{constructor(){this.a=new Map}acquire(y,...N){let I=this.a.get(y);I||(I={counter:0,object:this.b(y,...N)},this.a.set(y,I));const{object:P}=I,C=(0,m.$fb)(()=>{--I.counter===0&&(this.c(y,I.object),this.a.delete(y))});return I.counter++,{object:P,dispose:C}}}e.$3c=w;class L{constructor(y){this.a=y}async acquire(y,...N){const I=this.a.acquire(y,...N);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(P){throw I.dispose(),P}}}e.$4c=L;class k{constructor(y){this.object=y}dispose(){}}e.$5c=k;function O(D){const y=new S;try{D(y)}finally{y.dispose()}}class z{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,N,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(y)?.dispose(),this.a.set(y,N)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const N=this.a.get(y);return this.a.delete(y),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=z}),define(he[27],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var o;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(o||(e.MarshalledId=o={}))}),define(he[48],fe([0,1,26]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0,e.$qm=A,e.$rm=j;const t=new o.$Gc(1e4);function A(r){return $(r,"NFC",t)}const m=new o.$Gc(1e4);function j(r){return $(r,"NFD",m)}const _=/[^\u0000-\u0080]/;function $(r,v,b){if(!r)return r;const f=b.get(r);if(f)return f;let l;return _.test(r)?l=r.normalize(v):l=r,b.set(r,l),l}e.$sm=function(){const r=/[\u0300-\u036f]/g;return function(v){return j(v).replace(r,"")}}()}),function(){function ie(A){const m=[];typeof A=="number"&&m.push("code/timeOrigin",A);function j($){m.push($,Date.now())}function _(){const $=[];for(let r=0;r<m.length;r+=2)$.push({name:m[r],startTime:m[r+1]});return $}return{mark:j,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const m=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const j of performance.getEntriesByType("mark"))m.push({name:j.name,startTime:Math.round(A+j.startTime)});return m}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function o(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=o(t))}(),define(he[3],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=i,e.$E=L,e.$K=k,e.$h="en";let o=!1,t=!1,A=!1,m=!1,j=!1,_=!1,$=!1,r=!1,v=!1,b=!1,f,l=e.$h,c=e.$h,u,h;const a=globalThis;let s;typeof a.vscode<"u"&&typeof a.vscode.process<"u"?s=a.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(s=process);const p=typeof s?.versions?.electron=="string",E=p&&s?.type==="renderer";if(typeof s=="object"){o=s.platform==="win32",t=s.platform==="darwin",A=s.platform==="linux",m=A&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,$=p,v=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$h,l=e.$h;const O=s.env.VSCODE_NLS_CONFIG;if(O)try{const z=JSON.parse(O);f=z.userLocale,c=z.osLocale,l=z.resolvedLanguage||e.$h,u=z.languagePack?.translationsConfigFile}catch{}j=!0}else typeof navigator=="object"&&!E?(h=navigator.userAgent,o=h.indexOf("Windows")>=0,t=h.indexOf("Macintosh")>=0,r=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,b=h?.indexOf("Mobi")>=0,_=!0,l=globalThis._VSCODE_NLS_LANGUAGE||e.$h,f=navigator.language.toLowerCase(),c=f):console.error("Unable to resolve platform.");var S;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(S||(e.Platform=S={}));function i(O){switch(O){case S.Web:return"Web";case S.Mac:return"Mac";case S.Linux:return"Linux";case S.Windows:return"Windows"}}let n=S.Web;t?n=S.Mac:o?n=S.Windows:A&&(n=S.Linux),e.$j=o,e.$k=t,e.$l=A,e.$m=m,e.$n=j,e.$o=$,e.$p=_,e.$q=_&&typeof a.importScripts=="function",e.$r=e.$q?a.origin:void 0,e.$s=r,e.$t=b,e.$u=v,e.$v=n,e.$w=h,e.$x=l;var g;(function(O){function z(){return e.$x}O.value=z;function D(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}O.isDefaultVariant=D;function y(){return e.$x==="en"}O.isDefault=y})(g||(e.Language=g={})),e.$y=f,e.$z=c,e.$A=u,e.$B=typeof a.postMessage=="function"&&!a.importScripts,e.$C=(()=>{if(e.$B){const O=[];a.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let y=0,N=O.length;y<N;y++){const I=O[y];if(I.id===D.data.vscodeScheduleAsyncWork){O.splice(y,1),I.callback();return}}});let z=0;return D=>{const y=++z;O.push({id:y,callback:D}),a.postMessage({vscodeScheduleAsyncWork:y},"*")}}return O=>setTimeout(O)})();var R;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(R||(e.OperatingSystem=R={})),e.OS=t||r?R.Macintosh:o?R.Windows:R.Linux;let q=!0,w=!1;function L(){if(!w){w=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,q=new Uint16Array(O.buffer)[0]===513}return q}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function k(O){return parseFloat(O)>=20}}),define(he[15],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let t;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const m=A.process;t={get platform(){return m.platform},get arch(){return m.arch},get env(){return m.env},cwd(){return m.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return o.$j?"win32":o.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$gc=t.platform,e.$hc=t.arch});var Qe=this&&this.__createBinding||(Object.create?function(ie,e,o,t){t===void 0&&(t=o);var A=Object.getOwnPropertyDescriptor(e,o);(!A||("get"in A?!e.__esModule:A.writable||A.configurable))&&(A={enumerable:!0,get:function(){return e[o]}}),Object.defineProperty(ie,t,A)}:function(ie,e,o,t){t===void 0&&(t=o),ie[t]=e[o]}),Ze=this&&this.__setModuleDefault||(Object.create?function(ie,e){Object.defineProperty(ie,"default",{enumerable:!0,value:e})}:function(ie,e){ie.default=e}),Se=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var e={};if(ie!=null)for(var o in ie)o!=="default"&&Object.prototype.hasOwnProperty.call(ie,o)&&Qe(e,ie,o);return Ze(e,ie),e};define(he[5],fe([0,1,15]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,o=Se(o);const t=65,A=97,m=90,j=122,_=46,$=47,r=92,v=58,b=63;class f extends Error{constructor(g,R,q){let w;typeof R=="string"&&R.indexOf("not ")===0?(w="must not be",R=R.replace(/^not /,"")):w="must be";const L=g.indexOf(".")!==-1?"property":"argument";let k=`The "${g}" ${L} ${w} of type ${R}`;k+=`. Received type ${typeof q}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function l(n,g){if(n===null||typeof n!="object")throw new f(g,"Object",n)}function c(n,g){if(typeof n!="string")throw new f(g,"string",n)}const u=o.$gc==="win32";function h(n){return n===$||n===r}function a(n){return n===$}function s(n){return n>=t&&n<=m||n>=A&&n<=j}function p(n,g,R,q){let w="",L=0,k=-1,O=0,z=0;for(let D=0;D<=n.length;++D){if(D<n.length)z=n.charCodeAt(D);else{if(q(z))break;z=$}if(q(z)){if(!(k===D-1||O===1))if(O===2){if(w.length<2||L!==2||w.charCodeAt(w.length-1)!==_||w.charCodeAt(w.length-2)!==_){if(w.length>2){const y=w.lastIndexOf(R);y===-1?(w="",L=0):(w=w.slice(0,y),L=w.length-1-w.lastIndexOf(R)),k=D,O=0;continue}else if(w.length!==0){w="",L=0,k=D,O=0;continue}}g&&(w+=w.length>0?`${R}..`:"..",L=2)}else w.length>0?w+=`${R}${n.slice(k+1,D)}`:w=n.slice(k+1,D),L=D-k-1;k=D,O=0}else z===_&&O!==-1?++O:O=-1}return w}function E(n){return n?`${n[0]==="."?"":"."}${n}`:""}function S(n,g){l(g,"pathObject");const R=g.dir||g.root,q=g.base||`${g.name||""}${E(g.ext)}`;return R?R===g.root?`${R}${q}`:`${R}${n}${q}`:q}e.$ic={resolve(...n){let g="",R="",q=!1;for(let w=n.length-1;w>=-1;w--){let L;if(w>=0){if(L=n[w],c(L,`paths[${w}]`),L.length===0)continue}else g.length===0?L=o.cwd():(L=o.env[`=${g}`]||o.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==g.toLowerCase()&&L.charCodeAt(2)===r)&&(L=`${g}\\`));const k=L.length;let O=0,z="",D=!1;const y=L.charCodeAt(0);if(k===1)h(y)&&(O=1,D=!0);else if(h(y))if(D=!0,h(L.charCodeAt(1))){let N=2,I=N;for(;N<k&&!h(L.charCodeAt(N));)N++;if(N<k&&N!==I){const P=L.slice(I,N);for(I=N;N<k&&h(L.charCodeAt(N));)N++;if(N<k&&N!==I){for(I=N;N<k&&!h(L.charCodeAt(N));)N++;(N===k||N!==I)&&(z=`\\\\${P}\\${L.slice(I,N)}`,O=N)}}}else O=1;else s(y)&&L.charCodeAt(1)===v&&(z=L.slice(0,2),O=2,k>2&&h(L.charCodeAt(2))&&(D=!0,O=3));if(z.length>0)if(g.length>0){if(z.toLowerCase()!==g.toLowerCase())continue}else g=z;if(q){if(g.length>0)break}else if(R=`${L.slice(O)}\\${R}`,q=D,D&&g.length>0)break}return R=p(R,!q,"\\",h),q?`${g}\\${R}`:`${g}${R}`||"."},normalize(n){c(n,"path");const g=n.length;if(g===0)return".";let R=0,q,w=!1;const L=n.charCodeAt(0);if(g===1)return a(L)?"\\":n;if(h(L))if(w=!0,h(n.charCodeAt(1))){let O=2,z=O;for(;O<g&&!h(n.charCodeAt(O));)O++;if(O<g&&O!==z){const D=n.slice(z,O);for(z=O;O<g&&h(n.charCodeAt(O));)O++;if(O<g&&O!==z){for(z=O;O<g&&!h(n.charCodeAt(O));)O++;if(O===g)return`\\\\${D}\\${n.slice(z)}\\`;O!==z&&(q=`\\\\${D}\\${n.slice(z,O)}`,R=O)}}}else R=1;else s(L)&&n.charCodeAt(1)===v&&(q=n.slice(0,2),R=2,g>2&&h(n.charCodeAt(2))&&(w=!0,R=3));let k=R<g?p(n.slice(R),!w,"\\",h):"";return k.length===0&&!w&&(k="."),k.length>0&&h(n.charCodeAt(g-1))&&(k+="\\"),q===void 0?w?`\\${k}`:k:w?`${q}\\${k}`:`${q}${k}`},isAbsolute(n){c(n,"path");const g=n.length;if(g===0)return!1;const R=n.charCodeAt(0);return h(R)||g>2&&s(R)&&n.charCodeAt(1)===v&&h(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let g,R;for(let L=0;L<n.length;++L){const k=n[L];c(k,"path"),k.length>0&&(g===void 0?g=R=k:g+=`\\${k}`)}if(g===void 0)return".";let q=!0,w=0;if(typeof R=="string"&&h(R.charCodeAt(0))){++w;const L=R.length;L>1&&h(R.charCodeAt(1))&&(++w,L>2&&(h(R.charCodeAt(2))?++w:q=!1))}if(q){for(;w<g.length&&h(g.charCodeAt(w));)w++;w>=2&&(g=`\\${g.slice(w)}`)}return e.$ic.normalize(g)},relative(n,g){if(c(n,"from"),c(g,"to"),n===g)return"";const R=e.$ic.resolve(n),q=e.$ic.resolve(g);if(R===q||(n=R.toLowerCase(),g=q.toLowerCase(),n===g))return"";let w=0;for(;w<n.length&&n.charCodeAt(w)===r;)w++;let L=n.length;for(;L-1>w&&n.charCodeAt(L-1)===r;)L--;const k=L-w;let O=0;for(;O<g.length&&g.charCodeAt(O)===r;)O++;let z=g.length;for(;z-1>O&&g.charCodeAt(z-1)===r;)z--;const D=z-O,y=k<D?k:D;let N=-1,I=0;for(;I<y;I++){const C=n.charCodeAt(w+I);if(C!==g.charCodeAt(O+I))break;C===r&&(N=I)}if(I!==y){if(N===-1)return q}else{if(D>y){if(g.charCodeAt(O+I)===r)return q.slice(O+I+1);if(I===2)return q.slice(O+I)}k>y&&(n.charCodeAt(w+I)===r?N=I:I===2&&(N=3)),N===-1&&(N=0)}let P="";for(I=w+N+1;I<=L;++I)(I===L||n.charCodeAt(I)===r)&&(P+=P.length===0?"..":"\\..");return O+=N,P.length>0?`${P}${q.slice(O,z)}`:(q.charCodeAt(O)===r&&++O,q.slice(O,z))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const g=e.$ic.resolve(n);if(g.length<=2)return n;if(g.charCodeAt(0)===r){if(g.charCodeAt(1)===r){const R=g.charCodeAt(2);if(R!==b&&R!==_)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(s(g.charCodeAt(0))&&g.charCodeAt(1)===v&&g.charCodeAt(2)===r)return`\\\\?\\${g}`;return n},dirname(n){c(n,"path");const g=n.length;if(g===0)return".";let R=-1,q=0;const w=n.charCodeAt(0);if(g===1)return h(w)?n:".";if(h(w)){if(R=q=1,h(n.charCodeAt(1))){let O=2,z=O;for(;O<g&&!h(n.charCodeAt(O));)O++;if(O<g&&O!==z){for(z=O;O<g&&h(n.charCodeAt(O));)O++;if(O<g&&O!==z){for(z=O;O<g&&!h(n.charCodeAt(O));)O++;if(O===g)return n;O!==z&&(R=q=O+1)}}}}else s(w)&&n.charCodeAt(1)===v&&(R=g>2&&h(n.charCodeAt(2))?3:2,q=R);let L=-1,k=!0;for(let O=g-1;O>=q;--O)if(h(n.charCodeAt(O))){if(!k){L=O;break}}else k=!1;if(L===-1){if(R===-1)return".";L=R}return n.slice(0,L)},basename(n,g){g!==void 0&&c(g,"suffix"),c(n,"path");let R=0,q=-1,w=!0,L;if(n.length>=2&&s(n.charCodeAt(0))&&n.charCodeAt(1)===v&&(R=2),g!==void 0&&g.length>0&&g.length<=n.length){if(g===n)return"";let k=g.length-1,O=-1;for(L=n.length-1;L>=R;--L){const z=n.charCodeAt(L);if(h(z)){if(!w){R=L+1;break}}else O===-1&&(w=!1,O=L+1),k>=0&&(z===g.charCodeAt(k)?--k===-1&&(q=L):(k=-1,q=O))}return R===q?q=O:q===-1&&(q=n.length),n.slice(R,q)}for(L=n.length-1;L>=R;--L)if(h(n.charCodeAt(L))){if(!w){R=L+1;break}}else q===-1&&(w=!1,q=L+1);return q===-1?"":n.slice(R,q)},extname(n){c(n,"path");let g=0,R=-1,q=0,w=-1,L=!0,k=0;n.length>=2&&n.charCodeAt(1)===v&&s(n.charCodeAt(0))&&(g=q=2);for(let O=n.length-1;O>=g;--O){const z=n.charCodeAt(O);if(h(z)){if(!L){q=O+1;break}continue}w===-1&&(L=!1,w=O+1),z===_?R===-1?R=O:k!==1&&(k=1):R!==-1&&(k=-1)}return R===-1||w===-1||k===0||k===1&&R===w-1&&R===q+1?"":n.slice(R,w)},format:S.bind(null,"\\"),parse(n){c(n,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return g;const R=n.length;let q=0,w=n.charCodeAt(0);if(R===1)return h(w)?(g.root=g.dir=n,g):(g.base=g.name=n,g);if(h(w)){if(q=1,h(n.charCodeAt(1))){let N=2,I=N;for(;N<R&&!h(n.charCodeAt(N));)N++;if(N<R&&N!==I){for(I=N;N<R&&h(n.charCodeAt(N));)N++;if(N<R&&N!==I){for(I=N;N<R&&!h(n.charCodeAt(N));)N++;N===R?q=N:N!==I&&(q=N+1)}}}}else if(s(w)&&n.charCodeAt(1)===v){if(R<=2)return g.root=g.dir=n,g;if(q=2,h(n.charCodeAt(2))){if(R===3)return g.root=g.dir=n,g;q=3}}q>0&&(g.root=n.slice(0,q));let L=-1,k=q,O=-1,z=!0,D=n.length-1,y=0;for(;D>=q;--D){if(w=n.charCodeAt(D),h(w)){if(!z){k=D+1;break}continue}O===-1&&(z=!1,O=D+1),w===_?L===-1?L=D:y!==1&&(y=1):L!==-1&&(y=-1)}return O!==-1&&(L===-1||y===0||y===1&&L===O-1&&L===k+1?g.base=g.name=n.slice(k,O):(g.name=n.slice(k,L),g.base=n.slice(k,O),g.ext=n.slice(L,O))),k>0&&k!==q?g.dir=n.slice(0,k-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(u){const n=/\\/g;return()=>{const g=o.cwd().replace(n,"/");return g.slice(g.indexOf("/"))}}return()=>o.cwd()})();e.$jc={resolve(...n){let g="",R=!1;for(let q=n.length-1;q>=-1&&!R;q--){const w=q>=0?n[q]:i();c(w,`paths[${q}]`),w.length!==0&&(g=`${w}/${g}`,R=w.charCodeAt(0)===$)}return g=p(g,!R,"/",a),R?`/${g}`:g.length>0?g:"."},normalize(n){if(c(n,"path"),n.length===0)return".";const g=n.charCodeAt(0)===$,R=n.charCodeAt(n.length-1)===$;return n=p(n,!g,"/",a),n.length===0?g?"/":R?"./":".":(R&&(n+="/"),g?`/${n}`:n)},isAbsolute(n){return c(n,"path"),n.length>0&&n.charCodeAt(0)===$},join(...n){if(n.length===0)return".";let g;for(let R=0;R<n.length;++R){const q=n[R];c(q,"path"),q.length>0&&(g===void 0?g=q:g+=`/${q}`)}return g===void 0?".":e.$jc.normalize(g)},relative(n,g){if(c(n,"from"),c(g,"to"),n===g||(n=e.$jc.resolve(n),g=e.$jc.resolve(g),n===g))return"";const R=1,q=n.length,w=q-R,L=1,k=g.length-L,O=w<k?w:k;let z=-1,D=0;for(;D<O;D++){const N=n.charCodeAt(R+D);if(N!==g.charCodeAt(L+D))break;N===$&&(z=D)}if(D===O)if(k>O){if(g.charCodeAt(L+D)===$)return g.slice(L+D+1);if(D===0)return g.slice(L+D)}else w>O&&(n.charCodeAt(R+D)===$?z=D:D===0&&(z=0));let y="";for(D=R+z+1;D<=q;++D)(D===q||n.charCodeAt(D)===$)&&(y+=y.length===0?"..":"/..");return`${y}${g.slice(L+z)}`},toNamespacedPath(n){return n},dirname(n){if(c(n,"path"),n.length===0)return".";const g=n.charCodeAt(0)===$;let R=-1,q=!0;for(let w=n.length-1;w>=1;--w)if(n.charCodeAt(w)===$){if(!q){R=w;break}}else q=!1;return R===-1?g?"/":".":g&&R===1?"//":n.slice(0,R)},basename(n,g){g!==void 0&&c(g,"ext"),c(n,"path");let R=0,q=-1,w=!0,L;if(g!==void 0&&g.length>0&&g.length<=n.length){if(g===n)return"";let k=g.length-1,O=-1;for(L=n.length-1;L>=0;--L){const z=n.charCodeAt(L);if(z===$){if(!w){R=L+1;break}}else O===-1&&(w=!1,O=L+1),k>=0&&(z===g.charCodeAt(k)?--k===-1&&(q=L):(k=-1,q=O))}return R===q?q=O:q===-1&&(q=n.length),n.slice(R,q)}for(L=n.length-1;L>=0;--L)if(n.charCodeAt(L)===$){if(!w){R=L+1;break}}else q===-1&&(w=!1,q=L+1);return q===-1?"":n.slice(R,q)},extname(n){c(n,"path");let g=-1,R=0,q=-1,w=!0,L=0;for(let k=n.length-1;k>=0;--k){const O=n.charCodeAt(k);if(O===$){if(!w){R=k+1;break}continue}q===-1&&(w=!1,q=k+1),O===_?g===-1?g=k:L!==1&&(L=1):g!==-1&&(L=-1)}return g===-1||q===-1||L===0||L===1&&g===q-1&&g===R+1?"":n.slice(g,q)},format:S.bind(null,"/"),parse(n){c(n,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return g;const R=n.charCodeAt(0)===$;let q;R?(g.root="/",q=1):q=0;let w=-1,L=0,k=-1,O=!0,z=n.length-1,D=0;for(;z>=q;--z){const y=n.charCodeAt(z);if(y===$){if(!O){L=z+1;break}continue}k===-1&&(O=!1,k=z+1),y===_?w===-1?w=z:D!==1&&(D=1):w!==-1&&(D=-1)}if(k!==-1){const y=L===0&&R?1:L;w===-1||D===0||D===1&&w===k-1&&w===L+1?g.base=g.name=n.slice(y,k):(g.name=n.slice(y,w),g.base=n.slice(y,k),g.ext=n.slice(w,k))}return L>0?g.dir=n.slice(0,L-1):R&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=u?e.$ic.normalize:e.$jc.normalize,e.$lc=u?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=u?e.$ic.join:e.$jc.join,e.$nc=u?e.$ic.resolve:e.$jc.resolve,e.$oc=u?e.$ic.relative:e.$jc.relative,e.$pc=u?e.$ic.dirname:e.$jc.dirname,e.$qc=u?e.$ic.basename:e.$jc.basename,e.$rc=u?e.$ic.extname:e.$jc.extname,e.$sc=u?e.$ic.format:e.$jc.format,e.$tc=u?e.$ic.parse:e.$jc.parse,e.$uc=u?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=u?e.$ic.sep:e.$jc.sep,e.$wc=u?e.$ic.delimiter:e.$jc.delimiter}),define(he[32],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=m,e.$pm=j;var t;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(t||(e.Source=t={}));var A;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function m(_,...$){const r=$.reduce((f,l)=>(f[l]=!0,f),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(f=>!r[f]).forEach(f=>{for(let l=0;l<v.length;l++)if(f.search(v[l])!==-1){delete _[f];break}})}function j(_){_&&(delete _.DEBUG,o.$l&&delete _.LD_PRELOAD)}}),define(he[49],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0;const o=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(m){return new t(m)}constructor(m){this.c=o&&m===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ie=t}),define(he[4],fe([0,1,7,31,2,47,49]),function(ie,e,o,t,A,m,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$ke=e.Event=void 0,e.$le=l;const _=!1,$=!1,r=!1;var v;(function(P){P.None=()=>A.$Xc.None;function C(we){if(r){const{onDidAddListener:ge}=we,pe=u.create();let be=0;we.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),ge?.()}}}function Q(we,ge){return ce(we,()=>{},0,void 0,!0,void 0,ge)}P.defer=Q;function V(we){return(ge,pe=null,be)=>{let Ee=!1,_e;return _e=we(Pe=>{if(!Ee)return _e?_e.dispose():Ee=!0,ge.call(pe,Pe)},null,be),Ee&&_e.dispose(),_e}}P.once=V;function Z(we,ge){return P.once(P.filter(we,ge))}P.onceIf=Z;function re(we,ge,pe){return le((be,Ee=null,_e)=>we(Pe=>be.call(Ee,ge(Pe)),null,_e),pe)}P.map=re;function ae(we,ge,pe){return le((be,Ee=null,_e)=>we(Pe=>{ge(Pe),be.call(Ee,Pe)},null,_e),pe)}P.forEach=ae;function X(we,ge,pe){return le((be,Ee=null,_e)=>we(Pe=>ge(Pe)&&be.call(Ee,Pe),null,_e),pe)}P.filter=X;function F(we){return we}P.signal=F;function J(...we){return(ge,pe=null,be)=>{const Ee=(0,A.$Uc)(...we.map(_e=>_e(Pe=>ge.call(pe,Pe))));return W(Ee,be)}}P.any=J;function ee(we,ge,pe,be){let Ee=pe;return re(we,_e=>(Ee=ge(Ee,_e),Ee),be)}P.reduce=ee;function le(we,ge){let pe;const be={onWillAddFirstListener(){pe=we(Ee.fire,Ee)},onDidRemoveLastListener(){pe?.dispose()}};ge||C(be);const Ee=new n(be);return ge?.add(Ee),Ee.event}function W(we,ge){return ge instanceof Array?ge.push(we):ge&&ge.add(we),we}function ce(we,ge,pe=100,be=!1,Ee=!1,_e,Pe){let Re,ke,Le,Te=0,ze;const Ve={leakWarningThreshold:_e,onWillAddFirstListener(){Re=we(Ye=>{Te++,ke=ge(ke,Ye),be&&!Le&&(qe.fire(ke),ke=void 0),ze=()=>{const We=ke;ke=void 0,Le=void 0,(!be||Te>1)&&qe.fire(We),Te=0},typeof pe=="number"?(clearTimeout(Le),Le=setTimeout(ze,pe)):Le===void 0&&(Le=0,queueMicrotask(ze))})},onWillRemoveListener(){Ee&&Te>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,Re.dispose()}};Pe||C(Ve);const qe=new n(Ve);return Pe?.add(qe),qe.event}P.debounce=ce;function de(we,ge=0,pe){return P.debounce(we,(be,Ee)=>be?(be.push(Ee),be):[Ee],ge,void 0,!0,void 0,pe)}P.accumulate=de;function te(we,ge=(be,Ee)=>be===Ee,pe){let be=!0,Ee;return X(we,_e=>{const Pe=be||!ge(_e,Ee);return be=!1,Ee=_e,Pe},pe)}P.latch=te;function d(we,ge,pe){return[P.filter(we,ge,pe),P.filter(we,be=>!ge(be),pe)]}P.split=d;function H(we,ge=!1,pe=[],be){let Ee=pe.slice(),_e=we(ke=>{Ee?Ee.push(ke):Re.fire(ke)});be&&be.add(_e);const Pe=()=>{Ee?.forEach(ke=>Re.fire(ke)),Ee=null},Re=new n({onWillAddFirstListener(){_e||(_e=we(ke=>Re.fire(ke)),be&&be.add(_e))},onDidAddFirstListener(){Ee&&(ge?setTimeout(Pe):Pe())},onDidRemoveLastListener(){_e&&_e.dispose(),_e=null}});return be&&be.add(Re),Re.event}P.buffer=H;function oe(we,ge){return(be,Ee,_e)=>{const Pe=ge(new K);return we(function(Re){const ke=Pe.evaluate(Re);ke!==U&&be.call(Ee,ke)},void 0,_e)}}P.chain=oe;const U=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(pe=>(ge(pe),pe)),this}filter(ge){return this.f.push(pe=>ge(pe)?pe:U),this}reduce(ge,pe){let be=pe;return this.f.push(Ee=>(be=ge(be,Ee),be)),this}latch(ge=(pe,be)=>pe===be){let pe=!0,be;return this.f.push(Ee=>{const _e=pe||!ge(Ee,be);return pe=!1,be=Ee,_e?Ee:U}),this}evaluate(ge){for(const pe of this.f)if(ge=pe(ge),ge===U)break;return ge}}function T(we,ge,pe=be=>be){const be=(...Re)=>Pe.fire(pe(...Re)),Ee=()=>we.on(ge,be),_e=()=>we.removeListener(ge,be),Pe=new n({onWillAddFirstListener:Ee,onDidRemoveLastListener:_e});return Pe.event}P.fromNodeEventEmitter=T;function M(we,ge,pe=be=>be){const be=(...Re)=>Pe.fire(pe(...Re)),Ee=()=>we.addEventListener(ge,be),_e=()=>we.removeEventListener(ge,be),Pe=new n({onWillAddFirstListener:Ee,onDidRemoveLastListener:_e});return Pe.event}P.fromDOMEventEmitter=M;function G(we){return new Promise(ge=>V(we)(ge))}P.toPromise=G;function x(we){const ge=new n;return we.then(pe=>{ge.fire(pe)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}P.fromPromise=x;function ne(we,ge){return we(pe=>ge.fire(pe))}P.forward=ne;function $e(we,ge,pe){return ge(pe),we(be=>ge(be))}P.runAndSubscribe=$e;class ve{constructor(ge,pe){this._observable=ge,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ge.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};pe||C(be),this.emitter=new n(be),pe&&pe.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,pe){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function De(we,ge){return new ve(we,ge).emitter.event}P.fromObservable=De;function Ie(we){return(ge,pe,be)=>{let Ee=0,_e=!1;const Pe={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(we.reportChanges(),_e&&(_e=!1,ge.call(pe)))},handlePossibleChange(){},handleChange(){_e=!0}};we.addObserver(Pe),we.reportChanges();const Re={dispose(){we.removeObserver(Pe)}};return be instanceof A.$Wc?be.add(Re):Array.isArray(be)&&be.push(Re),Re}}P.fromObservableLight=Ie})(v||(e.Event=v={}));class b{static{this.all=new Set}static{this.f=0}constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${b.f++}`,b.all.add(this)}start(C){this.g=new j.$ie,this.listenerCount=C}stop(){if(this.g){const C=this.g.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this.g=void 0}}}e.$ke=b;let f=-1;function l(P){const C=f;return f=P,{dispose(){f=C}}}class c{static{this.f=1}constructor(C,Q,V=(c.f++).toString(16).padStart(3,"0")){this.j=C,this.threshold=Q,this.name=V,this.h=0}dispose(){this.g?.clear()}check(C,Q){const V=this.threshold;if(V<=0||Q<V)return;this.g||(this.g=new Map);const Z=this.g.get(C.value)||0;if(this.g.set(C.value,Z+1),this.h-=1,this.h<=0){this.h=V*.5;const[re,ae]=this.getMostFrequentStack(),X=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${ae}):`;console.warn(X),console.warn(re);const F=new h(X,re);this.j(F)}return()=>{const re=this.g.get(C.value)||0;this.g.set(C.value,re-1)}}getMostFrequentStack(){if(!this.g)return;let C,Q=0;for(const[V,Z]of this.g)(!C||Q<Z)&&(C=[V,Z],Q=Z);return C}}class u{static create(){const C=new Error;return new u(C.stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h extends Error{constructor(C,Q){super(C),this.name="ListenerLeakError",this.stack=Q}}e.$me=h;class a extends Error{constructor(C,Q){super(C),this.name="ListenerRefusalError",this.stack=Q}}e.$ne=a;let s=0;class p{constructor(C){this.value=C,this.id=s++}}const E=2,S=(P,C)=>{if(P instanceof p)C(P);else for(let Q=0;Q<P.length;Q++){const V=P[Q];V&&C(V)}};let i;if(_){const P=[];setInterval(()=>{P.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(P.join(`
`)),P.length=0)},3e3),i=new FinalizationRegistry(C=>{typeof C=="string"&&P.push(C)})}class n{constructor(C){this.z=0,this.f=C,this.g=f>0||this.f?.leakWarningThreshold?new c(C?.onListenerError??o.$2,this.f?.leakWarningThreshold??f):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const C=this.u;queueMicrotask(()=>{S(C,Q=>Q.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(C,Q,V)=>{if(this.g&&this.z>this.g.threshold**2){const F=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(F);const J=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new a(`${F}. HINT: Stack shows most frequent listener (${J[1]}-times)`,J[0]);return(this.f?.onListenerError||o.$2)(ee),A.$Xc.None}if(this.m)return A.$Xc.None;Q&&(C=C.bind(Q));const Z=new p(C);let re,ae;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Z.stack=u.create(),re=this.g.check(Z.stack,this.z+1)),$&&(Z.stack=ae??u.create()),this.u?this.u instanceof p?(this.w??=new R,this.u=[this.u,Z]):this.u.push(Z):(this.f?.onWillAddFirstListener?.(this),this.u=Z,this.f?.onDidAddFirstListener?.(this)),this.z++;const X=(0,A.$Vc)(()=>{i?.unregister(X),re?.(),this.A(Z)});if(V instanceof A.$Wc?V.add(X):Array.isArray(V)&&V.push(X),i){const F=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),J=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(F);i.register(X,J?.[2]??F,X)}return X},this.q}A(C){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Q=this.u,V=Q.indexOf(C);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Q[V]=void 0;const Z=this.w.current===this;if(this.z*E<=Q.length){let re=0;for(let ae=0;ae<Q.length;ae++)Q[ae]?Q[re++]=Q[ae]:Z&&(this.w.end--,re<this.w.i&&this.w.i--);Q.length=re}}B(C,Q){if(!C)return;const V=this.f?.onListenerError||o.$2;if(!V){C.value(Q);return}try{C.value(Q)}catch(Z){V(Z)}}C(C){const Q=C.current.u;for(;C.i<C.end;)this.B(Q[C.i++],C.value);C.reset()}fire(C){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof p)this.B(this.u,C);else{const Q=this.w;Q.enqueue(this,C,this.u.length),this.C(Q)}this.j?.stop()}hasListeners(){return this.z>0}}e.$oe=n;const g=()=>new R;e.$pe=g;class R{constructor(){this.i=-1,this.end=0}enqueue(C,Q,V){this.i=0,this.end=V,this.current=C,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class q extends n{async fireAsync(C,Q,V){if(this.u)for(this.h||(this.h=new m.$8c),S(this.u,Z=>this.h.push([Z.value,C]));this.h.size>0&&!Q.isCancellationRequested;){const[Z,re]=this.h.shift(),ae=[],X={...re,token:Q,waitUntil:F=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");V&&(F=V(F,Z)),ae.push(F)}};try{Z(X)}catch(F){(0,o.$2)(F);continue}Object.freeze(ae),await Promise.allSettled(ae).then(F=>{for(const J of F)J.status==="rejected"&&(0,o.$2)(J.reason)})}}}e.$qe=q;class w extends n{get isPaused(){return this.h!==0}constructor(C){super(C),this.h=0,this.s=new m.$8c,this.t=C?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const C=Array.from(this.s);this.s.clear(),super.fire(this.t(C))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(C){this.z&&(this.h!==0?this.s.push(C):super.fire(C))}}e.$re=w;class L extends w{constructor(C){super(C),this.k=C.delay??100}fire(C){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(C)}}e.$se=L;class k extends n{constructor(C){super(C),this.h=[],this.k=C?.merge}fire(C){this.hasListeners()&&(this.h.push(C),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}e.$te=k;class O{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(C){const Q={event:C,listener:null};this.h.push(Q),this.g&&this.m(Q);const V=()=>{this.g&&this.o(Q);const Z=this.h.indexOf(Q);this.h.splice(Z,1)};return(0,A.$Vc)((0,t.$fb)(V))}j(){this.g=!0,this.h.forEach(C=>this.m(C))}k(){this.g=!1,this.h.forEach(C=>this.o(C))}m(C){C.listener=C.event(Q=>this.f.fire(Q))}o(C){C.listener?.dispose(),C.listener=null}dispose(){this.f.dispose();for(const C of this.h)C.listener?.dispose();this.h=[]}}e.$ue=O;class z{constructor(C,Q,V,Z){this.f=new A.$Wc;const re=this.f.add(new O),ae=this.f.add(new A.$7c);function X(F){ae.set(F,re.add(Z(F)))}for(const F of C)X(F);this.f.add(Q(F=>{X(F)})),this.f.add(V(F=>{ae.deleteAndDispose(F)})),this.event=re.event}dispose(){this.f.dispose()}}e.$ve=z;class D{constructor(){this.f=[]}wrapEvent(C,Q,V){return(Z,re,ae)=>C(X=>{const F=this.f[this.f.length-1];if(!Q){F?F.buffers.push(()=>Z.call(re,X)):Z.call(re,X);return}const J=F;if(!J){Z.call(re,Q(V,X));return}J.items??=[],J.items.push(X),J.buffers.length===0&&F.buffers.push(()=>{J.reducedResult??=V?J.items.reduce(Q,V):J.items.reduce(Q),Z.call(re,J.reducedResult)})},void 0,ae)}bufferEvents(C){const Q={buffers:new Array};this.f.push(Q);const V=C();return this.f.pop(),Q.buffers.forEach(Z=>Z()),V}}e.$we=D;class y{constructor(){this.f=!1,this.g=v.None,this.h=A.$Xc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(C){this.g=C,this.f&&(this.h.dispose(),this.h=C(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$xe=y;class N{static const(C){return new I(C)}constructor(C){this.g=C,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(C){C!==this.g&&(this.g=C,this.f.fire(void 0))}}e.$ye=N;class I{constructor(C){this.value=C,this.onDidChange=v.None}}}),define(he[18],fe([0,1,4]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.CancellationToken=void 0,e.$Ae=_;const t=Object.freeze(function($,r){const v=setTimeout($.bind(r),0);return{dispose(){clearTimeout(v)}}});var A;(function($){function r(v){return v===$.None||v===$.Cancelled||v instanceof m?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}$.isCancellationToken=r,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(A||(e.CancellationToken=A={}));class m{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new o.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new m),this.f}cancel(){this.f?this.f instanceof m&&this.f.cancel():this.f=A.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof m&&this.f.dispose():this.f=A.None}}e.$ze=j;function _($){const r=new j;return $.add({dispose(){r.cancel()}}),r.token}}),define(he[50],fe([0,1,18]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cf=e.$bf=e.$_e=void 0,e.$af=A;class t{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new o.$ze,r=this.b($.token);return this.a={promise:r,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$_e=t;function A(_){return _}class m{constructor($,r){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=A):(this.c=r,this.d=$.getCacheKey)}get($){const r=this.d($);return this.b!==r&&(this.b=r,this.a=this.c($)),this.a}}e.$bf=m;class j{get cachedValues(){return this.a}constructor($,r){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=A):(this.c=r,this.d=$.getCacheKey)}get($){const r=this.d($);if(this.b.has(r))return this.b.get(r);const v=this.c($);return this.a.set($,v),this.b.set(r,v),v}}e.$cf=j}),define(he[51],fe([0,1,7,2]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=A,e.$Ce=m,e.$De=j,e.$Ee=_,e.$Fe=r,e.$Ge=v,e.$He=b,e.$Ie=f,e.$Je=l,e.$Ke=c,e.$Le=u,e.$Me=h,e.$Ne=a,e.$Oe=s,e.$Pe=p;function A(E){const S=E;return S?typeof S.read=="function":!1}function m(E){const S=E;return S?[S.on,S.pause,S.resume,S.destroy].every(i=>typeof i=="function"):!1}function j(E){const S=E;return S?m(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}function _(E,S){return new $(E,S)}class ${constructor(S,i){this.e=S,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(i=>i(S))}h(S){this.c.error.length===0?(0,o.$2)(S):this.c.error.slice(0).forEach(i=>i(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,i){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(S,i){if(this.a.destroyed)return;let n;switch(S){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const g=n.indexOf(i);g>=0&&n.splice(g,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(E,S){const i=[];let n;for(;(n=E.read())!==null;)i.push(n);return S(i)}function v(E,S,i){const n=[];let g;for(;(g=E.read())!==null&&n.length<i;)n.push(g);return g===null&&n.length>0?S(n):{read:()=>{if(n.length>0)return n.shift();if(typeof g<"u"){const R=g;return g=void 0,R}return E.read()}}}function b(E,S){return new Promise((i,n)=>{const g=[];f(E,{onData:R=>{S&&g.push(R)},onError:R=>{S?n(R):i(void 0)},onEnd:()=>{i(S?S(g):void 0)}})})}function f(E,S,i){E.on("error",n=>{i?.isCancellationRequested||S.onError(n)}),E.on("end",()=>{i?.isCancellationRequested||S.onEnd()}),E.on("data",n=>{i?.isCancellationRequested||S.onData(n)})}function l(E,S){return new Promise((i,n)=>{const g=new t.$Wc,R=[],q=k=>{if(R.push(k),R.length>S)return g.dispose(),E.pause(),i({stream:E,buffer:R,ended:!1})},w=k=>(g.dispose(),n(k)),L=()=>(g.dispose(),i({stream:E,buffer:R,ended:!0}));g.add((0,t.$Vc)(()=>E.removeListener("error",w))),E.on("error",w),g.add((0,t.$Vc)(()=>E.removeListener("end",L))),E.on("end",L),g.add((0,t.$Vc)(()=>E.removeListener("data",q))),E.on("data",q)})}function c(E,S){const i=_(S);return i.end(E),i}function u(){const E=_(()=>{throw new Error("not supported")});return E.end(),E}function h(E){let S=!1;return{read:()=>S?null:(S=!0,E)}}function a(E,S,i){const n=_(i);return f(E,{onData:g=>n.write(S.data(g)),onError:g=>n.error(S.error?S.error(g):g),onEnd:()=>n.end()}),n}function s(E,S,i){let n=!1;return{read:()=>{const g=S.read();return n?g:(n=!0,g!==null?i([E,g]):E)}}}function p(E,S,i){let n=!1;const g=_(i);return f(S,{onData:R=>n?g.write(R):(n=!0,g.write(i([E,R]))),onError:R=>g.error(R),onEnd:()=>{n||(n=!0,g.write(E)),g.end()}}),g}}),define(he[19],fe([0,1,24,51]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=r,e.$Se=v,e.$Te=b,e.$Ue=f,e.$Ve=l,e.$We=c,e.$Xe=u,e.$Ye=h,e.$Ze=a,e.$1e=s,e.$2e=p,e.$3e=E,e.$4e=S,e.$5e=i,e.$6e=n,e.$7e=g,e.$8e=R,e.$9e=q,e.$0e=w,e.$$e=O,t=Se(t);const A=typeof Buffer<"u",m=new o.$W(()=>new Uint8Array(256));let j,_;class ${static alloc(D){return A?new $(Buffer.allocUnsafe(D)):new $(new Uint8Array(D))}static wrap(D){return A&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new $(D)}static fromString(D,y){return!(y?.dontUseNodeBuffer||!1)&&A?new $(Buffer.from(D)):(j||(j=new TextEncoder),new $(j.encode(D)))}static fromByteArray(D){const y=$.alloc(D.length);for(let N=0,I=D.length;N<I;N++)y.buffer[N]=D[N];return y}static concat(D,y){if(typeof y>"u"){y=0;for(let P=0,C=D.length;P<C;P++)y+=D[P].byteLength}const N=$.alloc(y);let I=0;for(let P=0,C=D.length;P<C;P++){const Q=D[P];N.set(Q,I),I+=Q.byteLength}return N}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=$.alloc(this.byteLength);return D.set(this),D}toString(){return A?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(D,y){return new $(this.buffer.subarray(D,y))}set(D,y){if(D instanceof $)this.buffer.set(D.buffer,y);else if(D instanceof Uint8Array)this.buffer.set(D,y);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),y);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return f(this.buffer,D)}writeUInt32BE(D,y){l(this.buffer,D,y)}readUInt32LE(D){return c(this.buffer,D)}writeUInt32LE(D,y){u(this.buffer,D,y)}readUInt8(D){return h(this.buffer,D)}writeUInt8(D,y){a(this.buffer,D,y)}indexOf(D,y=0){return r(this.buffer,D instanceof $?D.buffer:D,y)}}e.$Qe=$;function r(z,D,y=0){const N=D.byteLength,I=z.byteLength;if(N===0)return 0;if(N===1)return z.indexOf(D[0]);if(N>I-y)return-1;const P=m.value;P.fill(D.length);for(let Z=0;Z<D.length;Z++)P[D[Z]]=D.length-Z-1;let C=y+D.length-1,Q=C,V=-1;for(;C<I;)if(z[C]===D[Q]){if(Q===0){V=C;break}C--,Q--}else C+=Math.max(D.length-Q,P[z[C]]),Q=D.length-1;return V}function v(z,D){return z[D+0]<<0>>>0|z[D+1]<<8>>>0}function b(z,D,y){z[y+0]=D&255,D=D>>>8,z[y+1]=D&255}function f(z,D){return z[D]*2**24+z[D+1]*2**16+z[D+2]*2**8+z[D+3]}function l(z,D,y){z[y+3]=D,D=D>>>8,z[y+2]=D,D=D>>>8,z[y+1]=D,D=D>>>8,z[y]=D}function c(z,D){return z[D+0]<<0>>>0|z[D+1]<<8>>>0|z[D+2]<<16>>>0|z[D+3]<<24>>>0}function u(z,D,y){z[y+0]=D&255,D=D>>>8,z[y+1]=D&255,D=D>>>8,z[y+2]=D&255,D=D>>>8,z[y+3]=D&255}function h(z,D){return z[D]}function a(z,D,y){z[y]=D}function s(z){return t.$Fe(z,D=>$.concat(D))}function p(z){return t.$Me(z)}function E(z){return t.$He(z,D=>$.concat(D))}async function S(z){return z.ended?$.concat(z.buffer):$.concat([...z.buffer,await E(z.stream)])}function i(z){return t.$Ke(z,D=>$.concat(D))}function n(z){return t.$Ne(z,{data:D=>typeof D=="string"?$.fromString(D):$.wrap(D)},D=>$.concat(D))}function g(z){return t.$Ee(D=>$.concat(D),z)}function R(z,D){return t.$Oe(z,D,y=>$.concat(y))}function q(z,D){return t.$Pe(z,D,y=>$.concat(y))}function w(z){let D=0,y=0,N=0;const I=new Uint8Array(Math.floor(z.length/4*3)),P=Q=>{switch(y){case 3:I[N++]=D|Q,y=0;break;case 2:I[N++]=D|Q>>>2,D=Q<<6,y=3;break;case 1:I[N++]=D|Q>>>4,D=Q<<4,y=2;break;default:D=Q<<2,y=1}};for(let Q=0;Q<z.length;Q++){const V=z.charCodeAt(Q);if(V>=65&&V<=90)P(V-65);else if(V>=97&&V<=122)P(V-97+26);else if(V>=48&&V<=57)P(V-48+52);else if(V===43||V===45)P(62);else if(V===47||V===95)P(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${z[Q]}`)}}const C=N;for(;y>0;)P(0);return $.wrap(I).slice(0,C)}const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:z},D=!0,y=!1){const N=y?k:L;let I="";const P=z.byteLength%3;let C=0;for(;C<z.byteLength-P;C+=3){const Q=z[C+0],V=z[C+1],Z=z[C+2];I+=N[Q>>>2],I+=N[(Q<<4|V>>>4)&63],I+=N[(V<<2|Z>>>6)&63],I+=N[Z&63]}if(P===1){const Q=z[C+0];I+=N[Q>>>2],I+=N[Q<<4&63],D&&(I+="==")}else if(P===2){const Q=z[C+0],V=z[C+1];I+=N[Q>>>2],I+=N[(Q<<4|V>>>4)&63],I+=N[V<<2&63],D&&(I+="=")}return I}}),define(he[52],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=void 0,e.$je=Symbol("MicrotaskDelay")}),define(he[9],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=o,e.$ig=t,e.$jg=A,e.$kg=m,e.$lg=j,e.$mg=_,e.$ng=$,e.$og=r,e.$pg=v,e.$qg=b,e.$rg=f,e.$sg=l,e.$tg=c,e.$ug=h,e.$vg=a,e.$wg=s,e.$xg=p,e.$yg=E,e.$zg=S;function o(i){return typeof i=="string"}function t(i){return Array.isArray(i)&&i.every(n=>o(n))}function A(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function m(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function j(i){return typeof i=="number"&&!isNaN(i)}function _(i){return!!i&&typeof i[Symbol.iterator]=="function"}function $(i){return i===!0||i===!1}function r(i){return typeof i>"u"}function v(i){return!b(i)}function b(i){return r(i)||i===null}function f(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function l(i){if(b(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function c(...i){const n=[];for(let g=0;g<i.length;g++){const R=i[g];if(b(R))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);n.push(R)}return n}const u=Object.prototype.hasOwnProperty;function h(i){if(!A(i))return!1;for(const n in i)if(u.call(i,n))return!1;return!0}function a(i){return typeof i=="function"}function s(...i){return i.length>0&&i.every(a)}function p(i,n){const g=Math.min(i.length,n.length);for(let R=0;R<g;R++)E(i[R],n[R])}function E(i,n){if(o(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(a(n)){try{if(i instanceof n)return}catch{}if(!b(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function S(i){return i}}),define(he[33],fe([0,1,9]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=t,e.$io=A,e.$jo=j,e.$ko=$,e.$lo=r,e.$mo=v,e.$no=b,e.$oo=f,e.$po=l,e.$qo=c,e.$ro=u,e.$so=h,e.$to=a;function t(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const p=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([E,S])=>{p[E]=S&&typeof S=="object"?t(S):S}),p}function A(s){if(!s||typeof s!="object")return s;const p=[s];for(;p.length>0;){const E=p.shift();Object.freeze(E);for(const S in E)if(m.call(E,S)){const i=E[S];typeof i=="object"&&!Object.isFrozen(i)&&!(0,o.$kg)(i)&&p.push(i)}}return s}const m=Object.prototype.hasOwnProperty;function j(s,p){return _(s,p,new Set)}function _(s,p,E){if((0,o.$qg)(s))return s;const S=p(s);if(typeof S<"u")return S;if(Array.isArray(s)){const i=[];for(const n of s)i.push(_(n,p,E));return i}if((0,o.$jg)(s)){if(E.has(s))throw new Error("Cannot clone recursive data-structure");E.add(s);const i={};for(const n in s)m.call(s,n)&&(i[n]=_(s[n],p,E));return E.delete(s),i}return s}function $(s,p,E=!0){return(0,o.$jg)(s)?((0,o.$jg)(p)&&Object.keys(p).forEach(S=>{S in s?E&&((0,o.$jg)(s[S])&&(0,o.$jg)(p[S])?$(s[S],p[S],E):s[S]=p[S]):s[S]=p[S]}),s):p}function r(s,p){if(s===p)return!0;if(s==null||p===null||p===void 0||typeof s!=typeof p||typeof s!="object"||Array.isArray(s)!==Array.isArray(p))return!1;let E,S;if(Array.isArray(s)){if(s.length!==p.length)return!1;for(E=0;E<s.length;E++)if(!r(s[E],p[E]))return!1}else{const i=[];for(S in s)i.push(S);i.sort();const n=[];for(S in p)n.push(S);if(n.sort(),!r(i,n))return!1;for(E=0;E<i.length;E++)if(!r(s[i[E]],p[i[E]]))return!1}return!0}function v(s){const p=new Set;return JSON.stringify(s,(E,S)=>{if((0,o.$jg)(S)||Array.isArray(S)){if(p.has(S))return"[Circular]";p.add(S)}return typeof S=="bigint"?`[BigInt ${S.toString()}]`:S})}function b(s,p){const E=Object.create(null);return!s||!p||Object.keys(p).forEach(i=>{const n=s[i],g=p[i];r(n,g)||(E[i]=g)}),E}function f(s,p){const E=p.toLowerCase(),S=Object.keys(s).find(i=>i.toLowerCase()===E);return S?s[S]:s[p]}function l(s,p){const E=Object.create(null);for(const[S,i]of Object.entries(s))p(S,i)&&(E[S]=i);return E}function c(s){let p=[];for(;Object.prototype!==s;)p=p.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return p}function u(s){const p=[];for(const E of c(s))typeof s[E]=="function"&&p.push(E);return p}function h(s,p){const E=i=>function(){const n=Array.prototype.slice.call(arguments,0);return p(i,n)},S={};for(const i of s)S[i]=E(i);return S}function a(s,p){const E={};for(const[S,i]of Object.entries(s))E[S]=p(i,S);return E}}),define(he[53],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$df=t,e.$ef=A;var o;(function(m){m[m.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",m[m.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",m[m.MAX_UINT_8=255]="MAX_UINT_8",m[m.MAX_UINT_16=65535]="MAX_UINT_16",m[m.MAX_UINT_32=4294967295]="MAX_UINT_32",m[m.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o||(e.Constants=o={}));function t(m){return m<0?0:m>o.MAX_UINT_8?o.MAX_UINT_8:m|0}function A(m){return m<0?0:m>o.MAX_UINT_32?o.MAX_UINT_32:m|0}}),define(he[10],fe([0,1,50,13,24,53]),function(ie,e,o,t,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.$fg=e.$eg=e.GraphemeBreakType=e.$7f=e.$Yf=e.$Rf=e.$Qf=void 0,e.$ff=j,e.$gf=$,e.$hf=v,e.$if=b,e.$jf=f,e.$kf=l,e.$lf=c,e.$mf=u,e.$nf=h,e.$of=a,e.$pf=s,e.$qf=p,e.$rf=E,e.$sf=S,e.$tf=i,e.$uf=n,e.$vf=g,e.$wf=R,e.$xf=q,e.$yf=w,e.$zf=L,e.$Af=k,e.$Bf=O,e.$Cf=z,e.$Df=D,e.$Ef=y,e.$Ff=N,e.$Gf=I,e.$Hf=P,e.$If=C,e.$Jf=Q,e.$Kf=V,e.$Lf=Z,e.$Mf=re,e.$Nf=ae,e.$Of=X,e.$Pf=F,e.$Sf=W,e.$Tf=ce,e.$Uf=de,e.$Vf=te,e.$Wf=oe,e.$Xf=K,e.$Zf=T,e.$1f=M,e.$2f=G,e.$3f=x,e.$4f=$e,e.$5f=ve,e.$6f=Ie,e.$8f=we,e.$9f=ge,e.$0f=pe,e.$$f=be,e.$_f=Ee,e.$ag=_e,e.$bg=Pe,e.$cg=Re,e.$dg=Ve;function j(B){return!B||typeof B!="string"?!0:B.trim().length===0}const _=/{(\d+)}/g;function $(B,...Y){return Y.length===0?B:B.replace(_,function(se,ue){const ye=parseInt(ue,10);return isNaN(ye)||ye<0||ye>=Y.length?se:Y[ye]})}const r=/{([^}]+)}/g;function v(B,Y){return Object.keys(Y).length===0?B:B.replace(r,(se,ue)=>Y[ue]??se)}function b(B){return B.replace(/[<>"'&]/g,Y=>{switch(Y){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Y})}function f(B){return B.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}function l(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(B,Y){let se=0,ue=B.indexOf(Y);for(;ue!==-1;)se++,ue=B.indexOf(Y,ue+Y.length);return se}function u(B,Y,se="\u2026"){return B.length<=Y?B:`${B.substr(0,Y)}${se}`}function h(B,Y,se="\u2026"){if(B.length<=Y)return B;const ue=Math.ceil(Y/2)-se.length/2,ye=Math.floor(Y/2)-se.length/2;return`${B.substr(0,ue)}${se}${B.substr(B.length-ye)}`}function a(B,Y=" "){const se=s(B,Y);return p(se,Y)}function s(B,Y){if(!B||!Y)return B;const se=Y.length;if(se===0||B.length===0)return B;let ue=0;for(;B.indexOf(Y,ue)===ue;)ue=ue+se;return B.substring(ue)}function p(B,Y){if(!B||!Y)return B;const se=Y.length,ue=B.length;if(se===0||ue===0)return B;let ye=ue,Ae=-1;for(;Ae=B.lastIndexOf(Y,ye-1),!(Ae===-1||Ae+se!==ye);){if(Ae===0)return"";ye=Ae}return B.substring(0,ye)}function E(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function S(B){return B.replace(/\*/g,"")}function i(B,Y,se={}){if(!B)throw new Error("Cannot create regex from empty string");Y||(B=l(B)),se.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let ue="";return se.global&&(ue+="g"),se.matchCase||(ue+="i"),se.multiline&&(ue+="m"),se.unicode&&(ue+="u"),new RegExp(B,ue)}function n(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}function g(B){return B.split(/\r\n|\r|\n/)}function R(B){const Y=[],se=B.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(se.length/2);ue++)Y.push(se[2*ue]+(se[2*ue+1]??""));return Y}function q(B){for(let Y=0,se=B.length;Y<se;Y++){const ue=B.charCodeAt(Y);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return Y}return-1}function w(B,Y=0,se=B.length){for(let ue=Y;ue<se;ue++){const ye=B.charCodeAt(ue);if(ye!==t.CharCode.Space&&ye!==t.CharCode.Tab)return B.substring(Y,ue)}return B.substring(Y,se)}function L(B,Y=B.length-1){for(let se=Y;se>=0;se--){const ue=B.charCodeAt(se);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return se}return-1}function k(B,Y,se){const ue=[];let ye=0;for(const Ae of B.matchAll(Y)){if(ue.push(B.slice(ye,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");ye=Ae.index+Ae[0].length,ue.push(se(Ae[0],...Ae.slice(1),Ae.index,B,Ae.groups))}return ue.push(B.slice(ye)),Promise.all(ue).then(Ae=>Ae.join(""))}function O(B,Y){return B<Y?-1:B>Y?1:0}function z(B,Y,se=0,ue=B.length,ye=0,Ae=Y.length){for(;se<ue&&ye<Ae;se++,ye++){const Ue=B.charCodeAt(se),Ne=Y.charCodeAt(ye);if(Ue<Ne)return-1;if(Ue>Ne)return 1}const Oe=ue-se,Fe=Ae-ye;return Oe<Fe?-1:Oe>Fe?1:0}function D(B,Y){return y(B,Y,0,B.length,0,Y.length)}function y(B,Y,se=0,ue=B.length,ye=0,Ae=Y.length){for(;se<ue&&ye<Ae;se++,ye++){let Ue=B.charCodeAt(se),Ne=Y.charCodeAt(ye);if(Ue===Ne)continue;if(Ue>=128||Ne>=128)return z(B.toLowerCase(),Y.toLowerCase(),se,ue,ye,Ae);I(Ue)&&(Ue-=32),I(Ne)&&(Ne-=32);const Me=Ue-Ne;if(Me!==0)return Me}const Oe=ue-se,Fe=Ae-ye;return Oe<Fe?-1:Oe>Fe?1:0}function N(B){return B>=t.CharCode.Digit0&&B<=t.CharCode.Digit9}function I(B){return B>=t.CharCode.a&&B<=t.CharCode.z}function P(B){return B>=t.CharCode.A&&B<=t.CharCode.Z}function C(B,Y){return B.length===Y.length&&y(B,Y)===0}function Q(B,Y){const se=Y.length;return Y.length>B.length?!1:y(B,Y,0,se)===0}function V(B,Y){const se=Math.min(B.length,Y.length);let ue;for(ue=0;ue<se;ue++)if(B.charCodeAt(ue)!==Y.charCodeAt(ue))return ue;return se}function Z(B,Y){const se=Math.min(B.length,Y.length);let ue;const ye=B.length-1,Ae=Y.length-1;for(ue=0;ue<se;ue++)if(B.charCodeAt(ye-ue)!==Y.charCodeAt(Ae-ue))return ue;return se}function re(B){return 55296<=B&&B<=56319}function ae(B){return 56320<=B&&B<=57343}function X(B,Y){return(B-55296<<10)+(Y-56320)+65536}function F(B,Y,se){const ue=B.charCodeAt(se);if(re(ue)&&se+1<Y){const ye=B.charCodeAt(se+1);if(ae(ye))return X(ue,ye)}return ue}function J(B,Y){const se=B.charCodeAt(Y-1);if(ae(se)&&Y>1){const ue=B.charCodeAt(Y-2);if(re(ue))return X(ue,se)}return se}class ee{get offset(){return this.e}constructor(Y,se=0){this.c=Y,this.d=Y.length,this.e=se}setOffset(Y){this.e=Y}prevCodePoint(){const Y=J(this.c,this.e);return this.e-=Y>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Y}nextCodePoint(){const Y=F(this.c,this.d,this.e);return this.e+=Y>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Y}eol(){return this.e>=this.d}}e.$Qf=ee;class le{get offset(){return this.c.offset}constructor(Y,se=0){this.c=new ee(Y,se)}nextGraphemeLength(){const Y=Te.getInstance(),se=this.c,ue=se.offset;let ye=Y.getGraphemeBreakType(se.nextCodePoint());for(;!se.eol();){const Ae=se.offset,Oe=Y.getGraphemeBreakType(se.nextCodePoint());if(ke(ye,Oe)){se.setOffset(Ae);break}ye=Oe}return se.offset-ue}prevGraphemeLength(){const Y=Te.getInstance(),se=this.c,ue=se.offset;let ye=Y.getGraphemeBreakType(se.prevCodePoint());for(;se.offset>0;){const Ae=se.offset,Oe=Y.getGraphemeBreakType(se.prevCodePoint());if(ke(Oe,ye)){se.setOffset(Ae);break}ye=Oe}return ue-se.offset}eol(){return this.c.eol()}}e.$Rf=le;function W(B,Y){return new le(B,Y).nextGraphemeLength()}function ce(B,Y){return new le(B,Y).prevGraphemeLength()}function de(B,Y){Y>0&&ae(B.charCodeAt(Y))&&Y--;const se=Y+W(B,Y);return[se-ce(B,se),se]}function te(B){const Y=new le(B);let se=0;for(;!Y.eol();)se++,Y.nextGraphemeLength();return se}let d;function H(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(B){return d||(d=H()),d.test(B)}const U=/^[\t\n\r\x20-\x7E]*$/;function K(B){return U.test(B)}e.$Yf=/[\u2028\u2029]/;function T(B){return e.$Yf.test(B)}function M(B){return B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}function G(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129008||B>=129280&&B<=129535||B>=129648&&B<=129782}function x(B,Y,se=""){const ue=B.trimStart();if(ue.length<Y)return ue;const ye=/\b/g;let Ae=0;for(;ye.test(ue)&&!(ue.length-ye.lastIndex<Y);)Ae=ye.lastIndex,ye.lastIndex+=1;return Ae===0?ue:se+ue.substring(Ae).trimStart()}const ne=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(B){let Y=0;for(const se of B.matchAll(ne))Y!==se.index&&(yield{isCode:!1,str:B.substring(Y,se.index)}),yield{isCode:!0,str:se[0]},Y=se.index+se[0].length;Y!==B.length&&(yield{isCode:!1,str:B.substring(Y)})}function ve(B){return B&&(B=B.replace(ne,"")),B}const De=/\\\[.*?\\\]/g;function Ie(B){return ve(B).replace(De,"")}e.$7f=String.fromCharCode(t.CharCode.UTF8_BOM);function we(B){return!!(B&&B.length>0&&B.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ge(B){return we(B)?B.substr(1):B}function pe(B,Y){if(!B||!Y||B.length<Y.length)return!1;const se=Y.length,ue=B.toLowerCase();let ye=0,Ae=-1;for(;ye<se;){const Oe=ue.indexOf(Y[ye],Ae+1);if(Oe<0)return!1;Ae=Oe,ye++}return!0}function be(B,Y=!1){return B?(Y&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}function Ee(B){return B.charAt(0).toUpperCase()+B.slice(1)}function _e(B,Y=1){if(Y===0)return"";let se=-1;do se=B.indexOf(`
`,se+1),Y--;while(Y>0&&se>=0);return se===-1?B:(B[se-1]==="\r"&&se--,B.substr(0,se))}function Pe(B){const Y=t.CharCode.Z-t.CharCode.A+1;return B=B%(2*Y),B<Y?String.fromCharCode(t.CharCode.a+B):String.fromCharCode(t.CharCode.A+B-Y)}function Re(B){return Te.getInstance().getGraphemeBreakType(B)}function ke(B,Y){return B===Le.Other?Y!==Le.Extend&&Y!==Le.SpacingMark:B===Le.CR&&Y===Le.LF?!1:B===Le.Control||B===Le.CR||B===Le.LF||Y===Le.Control||Y===Le.CR||Y===Le.LF?!0:!(B===Le.L&&(Y===Le.L||Y===Le.V||Y===Le.LV||Y===Le.LVT)||(B===Le.LV||B===Le.V)&&(Y===Le.V||Y===Le.T)||(B===Le.LVT||B===Le.T)&&Y===Le.T||Y===Le.Extend||Y===Le.ZWJ||Y===Le.SpacingMark||B===Le.Prepend||B===Le.ZWJ&&Y===Le.Extended_Pictographic||B===Le.Regional_Indicator&&Y===Le.Regional_Indicator)}var Le;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Te{static{this.c=null}static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=ze()}getGraphemeBreakType(Y){if(Y<32)return Y===t.CharCode.LineFeed?Le.LF:Y===t.CharCode.CarriageReturn?Le.CR:Le.Control;if(Y<127)return Le.Other;const se=this.d,ue=se.length/3;let ye=1;for(;ye<=ue;)if(Y<se[3*ye])ye=2*ye;else if(Y>se[3*ye+1])ye=2*ye+1;else return se[3*ye+2];return Le.Other}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(B,Y){if(B===0)return 0;const se=qe(B,Y);if(se!==void 0)return se;const ue=new ee(Y,B);return ue.prevCodePoint(),ue.offset}function qe(B,Y){const se=new ee(Y,B);let ue=se.prevCodePoint();for(;Ye(ue)||ue===We.emojiVariantSelector||ue===We.enclosingKeyCap;){if(se.offset===0)return;ue=se.prevCodePoint()}if(!G(ue))return;let ye=se.offset;return ye>0&&se.prevCodePoint()===We.zwj&&(ye=se.offset),ye}function Ye(B){return 127995<=B&&B<=127999}var We;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.$eg="\xA0";class He{static{this.c=new A.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new o.$bf({getCacheKey:JSON.stringify},Y=>{function se(Me){const je=new Map;for(let Ce=0;Ce<Me.length;Ce+=2)je.set(Me[Ce],Me[Ce+1]);return je}function ue(Me,je){const Ce=new Map(Me);for(const[Xe,Je]of je)Ce.set(Xe,Je);return Ce}function ye(Me,je){if(!Me)return je;const Ce=new Map;for(const[Xe,Je]of Me)je.has(Xe)&&Ce.set(Xe,Je);return Ce}const Ae=this.c.value;let Oe=Y.filter(Me=>!Me.startsWith("_")&&Me in Ae);Oe.length===0&&(Oe=["_default"]);let Fe;for(const Me of Oe){const je=se(Ae[Me]);Fe=ye(Fe,je)}const Ue=se(Ae._common),Ne=ue(Ue,Fe);return new He(Ne)})}static getInstance(Y){return He.d.get(Array.from(Y))}static{this.e=new A.$W(()=>Object.keys(He.c.value).filter(Y=>!Y.startsWith("_")))}static getLocales(){return He.e.value}constructor(Y){this.f=Y}isAmbiguous(Y){return this.f.has(Y)}containsAmbiguousCharacter(Y){for(let se=0;se<Y.length;se++){const ue=Y.codePointAt(se);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(Y){return this.f.get(Y)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$fg=He;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(Y){return Ge.e().has(Y)}static containsInvisibleCharacter(Y){for(let se=0;se<Y.length;se++){const ue=Y.codePointAt(se);if(typeof ue=="number"&&Ge.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return Ge.e()}}e.$gg=Ge}),define(he[34],fe([0,1,13,5,3,10,9]),function(ie,e,o,t,A,m,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=_,e.$Bg=$,e.$Cg=r,e.$Dg=v,e.$Eg=b,e.$Fg=u,e.$Gg=h,e.$Hg=a,e.$Ig=s,e.$Jg=p,e.$Kg=E,e.$Lg=S,e.$Mg=i,e.$Ng=n,e.$Og=g,e.$Pg=R,e.$Qg=L;function _(k){return k===o.CharCode.Slash||k===o.CharCode.Backslash}function $(k){return k.replace(/[\\/]/g,t.$jc.sep)}function r(k){return k.indexOf("/")===-1&&(k=$(k)),/^[a-zA-Z]:(\/|$)/.test(k)&&(k="/"+k),k}function v(k,O=t.$jc.sep){if(!k)return"";const z=k.length,D=k.charCodeAt(0);if(_(D)){if(_(k.charCodeAt(1))&&!_(k.charCodeAt(2))){let N=3;const I=N;for(;N<z&&!_(k.charCodeAt(N));N++);if(I!==N&&!_(k.charCodeAt(N+1))){for(N+=1;N<z;N++)if(_(k.charCodeAt(N)))return k.slice(0,N+1).replace(/[\\/]/g,O)}}return O}else if(s(D)&&k.charCodeAt(1)===o.CharCode.Colon)return _(k.charCodeAt(2))?k.slice(0,2)+O:k.slice(0,2);let y=k.indexOf("://");if(y!==-1){for(y+=3;y<z;y++)if(_(k.charCodeAt(y)))return k.slice(0,y+1)}return""}function b(k){if(!A.$j||!k||k.length<5)return!1;let O=k.charCodeAt(0);if(O!==o.CharCode.Backslash||(O=k.charCodeAt(1),O!==o.CharCode.Backslash))return!1;let z=2;const D=z;for(;z<k.length&&(O=k.charCodeAt(z),O!==o.CharCode.Backslash);z++);return!(D===z||(O=k.charCodeAt(z+1),isNaN(O)||O===o.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,l=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(k,O=A.$j){const z=O?f:l;return!(!k||k.length===0||/^\s+$/.test(k)||(z.lastIndex=0,z.test(k))||O&&c.test(k)||k==="."||k===".."||O&&k[k.length-1]==="."||O&&k.length!==k.trim().length||k.length>255)}function h(k,O,z){const D=k===O;return!z||D?D:!k||!O?!1:(0,m.$If)(k,O)}function a(k,O,z,D=t.sep){if(k===O)return!0;if(!k||!O||O.length>k.length)return!1;if(z){if(!(0,m.$Jf)(k,O))return!1;if(O.length===k.length)return!0;let N=O.length;return O.charAt(O.length-1)===D&&N--,k.charAt(N)===D}return O.charAt(O.length-1)!==D&&(O+=D),k.indexOf(O)===0}function s(k){return k>=o.CharCode.A&&k<=o.CharCode.Z||k>=o.CharCode.a&&k<=o.CharCode.z}function p(k,O){return A.$j&&k.endsWith(":")&&(k+=t.sep),(0,t.$lc)(k)||(k=(0,t.$mc)(O,k)),k=(0,t.$kc)(k),E(k)}function E(k){return A.$j?(k=(0,m.$qf)(k,t.sep),k.endsWith(":")&&(k+=t.sep)):(k=(0,m.$qf)(k,t.sep),k||(k=t.sep)),k}function S(k){const O=(0,t.$kc)(k);return A.$j?k.length>3?!1:i(O)&&(k.length===2||O.charCodeAt(2)===o.CharCode.Backslash):O===t.$jc.sep}function i(k,O=A.$j){return O?s(k.charCodeAt(0))&&k.charCodeAt(1)===o.CharCode.Colon:!1}function n(k,O=A.$j){return i(k,O)?k[0]:void 0}function g(k,O,z){return O.length>k.length?-1:k===O?0:(z&&(k=k.toLowerCase(),O=O.toLowerCase()),k.indexOf(O))}function R(k){const O=k.split(":");let z,D,y;for(const N of O){const I=Number(N);(0,j.$lg)(I)?D===void 0?D=I:y===void 0&&(y=I):z=z?[z,N].join(":"):N}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:D!==void 0?D:void 0,column:y!==void 0?y:D!==void 0?1:void 0}}const q="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function L(k,O,z=8){let D="";for(let N=0;N<z;N++){let I;N===0&&A.$j&&!O&&(z===3||z===4)?I=w:I=q,D+=I.charAt(Math.floor(Math.random()*I.length))}let y;return O?y=`${O}-${D}`:y=D,k?(0,t.$mc)(k,y):y}}),define(he[54],fe([0,1,10]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Aj=void 0,e.$wj=t,e.$xj=A,e.$yj=m,e.$zj=_,e.$Bj=u,o=Se(o);function t(a){return A(a,0)}function A(a,s){switch(typeof a){case"object":return a===null?m(349,s):Array.isArray(a)?$(a,s):r(a,s);case"string":return _(a,s);case"boolean":return j(a,s);case"number":return m(a,s);case"undefined":return m(937,s);default:return m(617,s)}}function m(a,s){return(s<<5)-s+a|0}function j(a,s){return m(a?433:863,s)}function _(a,s){s=m(149417,s);for(let p=0,E=a.length;p<E;p++)s=m(a.charCodeAt(p),s);return s}function $(a,s){return s=m(104579,s),a.reduce((p,E)=>A(E,p),s)}function r(a,s){return s=m(181387,s),Object.keys(a).sort().reduce((p,E)=>(p=_(E,p),A(a[E],p)),s)}class v{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=A(s,this.g),this.g}}e.$Aj=v;var b;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function f(a,s,p=32){const E=p-s,S=~((1<<E)-1);return(a<<s|(S&a)>>>E)>>>0}function l(a,s=0,p=a.byteLength,E=0){for(let S=0;S<p;S++)a[s+S]=E}function c(a,s,p="0"){for(;a.length<s;)a=p+a;return a}function u(a,s=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(p=>p.toString(16).padStart(2,"0")).join(""):c((a>>>0).toString(16),s/4)}class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(b.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const p=s.length;if(p===0)return;const E=this.p;let S=this.r,i=this.u,n,g;for(i!==0?(n=i,g=-1,i=0):(n=s.charCodeAt(0),g=0);;){let R=n;if(o.$Mf(n))if(g+1<p){const q=s.charCodeAt(g+1);o.$Nf(q)?(g++,R=o.$Of(n,q)):R=b.UNICODE_REPLACEMENT}else{i=n;break}else o.$Nf(n)&&(R=b.UNICODE_REPLACEMENT);if(S=this.w(E,S,R),g++,g<p)n=s.charCodeAt(g);else break}this.r=S,this.u=i}w(s,p,E){return E<128?s[p++]=E:E<2048?(s[p++]=192|(E&1984)>>>6,s[p++]=128|(E&63)>>>0):E<65536?(s[p++]=224|(E&61440)>>>12,s[p++]=128|(E&4032)>>>6,s[p++]=128|(E&63)>>>0):(s[p++]=240|(E&1835008)>>>18,s[p++]=128|(E&258048)>>>12,s[p++]=128|(E&4032)>>>6,s[p++]=128|(E&63)>>>0),p>=b.BLOCK_SIZE&&(this.y(),p-=b.BLOCK_SIZE,this.t+=b.BLOCK_SIZE,s[0]=s[b.BLOCK_SIZE+0],s[1]=s[b.BLOCK_SIZE+1],s[2]=s[b.BLOCK_SIZE+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,b.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=h.g,p=this.q;for(let L=0;L<64;L+=4)s.setUint32(L,p.getUint32(L,!1),!1);for(let L=64;L<320;L+=4)s.setUint32(L,f(s.getUint32(L-12,!1)^s.getUint32(L-32,!1)^s.getUint32(L-56,!1)^s.getUint32(L-64,!1),1),!1);let E=this.h,S=this.l,i=this.m,n=this.n,g=this.o,R,q,w;for(let L=0;L<80;L++)L<20?(R=S&i|~S&n,q=1518500249):L<40?(R=S^i^n,q=1859775393):L<60?(R=S&i|S&n|i&n,q=2400959708):(R=S^i^n,q=3395469782),w=f(E,5)+R+g+q+s.getUint32(L*4,!1)&4294967295,g=n,n=i,i=f(S,30),S=E,E=w;this.h=this.h+E&4294967295,this.l=this.l+S&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+g&4294967295}}e.$Cj=h}),define(he[55],fe([0,1,17,13,10]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class m{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const u=c.charCodeAt(0),h=this.b.charCodeAt(this.c);return u-h}value(){return this.b[this.c]}}e.$Ki=m;class j{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,A.$Cf)(c,this.b,0,c.length,this.c,this.d):(0,A.$Ef)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=j;class _{constructor(c=!0,u=!0){this.f=c,this.g=u}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let u=c.length-1;u>=0;u--,this.c--){const h=this.b.charCodeAt(u);if(!(h===t.CharCode.Slash||this.f&&h===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const u=this.b.charCodeAt(this.e);if(u===t.CharCode.Slash||this.f&&u===t.CharCode.Backslash)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,A.$Cf)(c,this.b,0,c.length,this.d,this.e):(0,A.$Ef)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=_;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class r{constructor(c,u){this.f=c,this.g=u,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new _(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push($.Path)),this.g(c)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===$.Scheme)return(0,A.$Df)(c,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,A.$Df)(c,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(c);if(this.d[this.e]===$.Query)return(0,A.$Bf)(c,this.c.query);if(this.d[this.e]===$.Fragment)return(0,A.$Bf)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Ni=r;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(b||(b={}));class f{static forUris(c=()=>!1,u=()=>!1){return new f(new r(c,u))}static forPaths(c=!1){return new f(new _(void 0,!c))}static forStrings(){return new f(new m)}static forConfigKeys(){return new f(new j)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,u){if(u){const h=u.slice(0);(0,o.$Yb)(h);for(const a of h)this.set(a,c)}else{const h=c.slice(0);(0,o.$Yb)(h);for(const a of h)this.set(a[0],a[1])}}set(c,u){const h=this.b.reset(c);let a;this.c||(this.c=new v,this.c.segment=h.value());const s=[];for(a=this.c;;){const E=h.cmp(a.segment);if(E>0)a.left||(a.left=new v,a.left.segment=h.value()),s.push([b.Left,a]),a=a.left;else if(E<0)a.right||(a.right=new v,a.right.segment=h.value()),s.push([b.Right,a]),a=a.right;else if(h.hasNext())h.next(),a.mid||(a.mid=new v,a.mid.segment=h.value()),s.push([b.Mid,a]),a=a.mid;else break}const p=a.value;a.value=u,a.key=c;for(let E=s.length-1;E>=0;E--){const S=s[E][1];S.updateHeight();const i=S.balanceFactor();if(i<-1||i>1){const n=s[E][0],g=s[E+1][0];if(n===b.Right&&g===b.Right)s[E][1]=S.rotateLeft();else if(n===b.Left&&g===b.Left)s[E][1]=S.rotateRight();else if(n===b.Right&&g===b.Left)S.right=s[E+1][1]=s[E+1][1].rotateRight(),s[E][1]=S.rotateLeft();else if(n===b.Left&&g===b.Right)S.left=s[E+1][1]=s[E+1][1].rotateLeft(),s[E][1]=S.rotateRight();else throw new Error;if(E>0)switch(s[E-1][0]){case b.Left:s[E-1][1].left=s[E][1];break;case b.Right:s[E-1][1].right=s[E][1];break;case b.Mid:s[E-1][1].mid=s[E][1];break}else this.c=s[0][1]}}return p}get(c){return this.d(c)?.value}d(c){const u=this.b.reset(c);let h=this.c;for(;h;){const a=u.cmp(h.segment);if(a>0)h=h.left;else if(a<0)h=h.right;else if(u.hasNext())u.next(),h=h.mid;else break}return h}has(c){const u=this.d(c);return!(u?.value===void 0&&u?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,u){const h=this.b.reset(c),a=[];let s=this.c;for(;s;){const p=h.cmp(s.segment);if(p>0)a.push([b.Left,s]),s=s.left;else if(p<0)a.push([b.Right,s]),s=s.right;else if(h.hasNext())h.next(),a.push([b.Mid,s]),s=s.mid;else break}if(s){if(u?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const p=this.f(s.right);if(p.key){const{key:E,value:S,segment:i}=p;this.e(p.key,!1),s.key=E,s.value=S,s.segment=i}}else{const p=s.left??s.right;if(a.length>0){const[E,S]=a[a.length-1];switch(E){case b.Left:S.left=p;break;case b.Mid:S.mid=p;break;case b.Right:S.right=p;break}}else this.c=p}for(let p=a.length-1;p>=0;p--){const E=a[p][1];E.updateHeight();const S=E.balanceFactor();if(S>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),a[p][1]=E.rotateLeft()):S<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),a[p][1]=E.rotateRight()),p>0)switch(a[p-1][0]){case b.Left:a[p-1][1].left=a[p][1];break;case b.Right:a[p-1][1].right=a[p][1];break;case b.Mid:a[p-1][1].mid=a[p][1];break}else this.c=a[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const u=this.b.reset(c);let h=this.c,a;for(;h;){const s=u.cmp(h.segment);if(s>0)h=h.left;else if(s<0)h=h.right;else if(u.hasNext())u.next(),a=h.value||a,h=h.mid;else break}return h&&h.value||a}findSuperstr(c){return this.g(c,!1)}g(c,u){const h=this.b.reset(c);let a=this.c;for(;a;){const s=h.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(h.hasNext())h.next(),a=a.mid;else return a.mid?this.h(a.mid):u?a.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[u,h]of this)c(h,u)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const u=[];return this.j(c,u),u[Symbol.iterator]()}j(c,u){c&&(c.left&&this.j(c.left,u),c.value&&u.push([c.key,c.value]),c.mid&&this.j(c.mid,u),c.right&&this.j(c.right,u))}_isBalanced(){const c=u=>{if(!u)return!0;const h=u.balanceFactor();return h<-1||h>1?!1:c(u.left)&&c(u.right)};return c(this.c)}}e.$Oi=f}),define(he[6],fe([0,1,13,27,5,3]),function(ie,e,o,t,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=h,e.$zc=i,A=Se(A);const j=/^\w[\w\d+.-]*$/,_=/^\//,$=/^\/\//;function r(w,L){if(!w.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${w.authority}", path: "${w.path}", query: "${w.query}", fragment: "${w.fragment}"}`);if(w.scheme&&!j.test(w.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(w.path){if(w.authority){if(!_.test(w.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(w.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(w,L){return!w&&!L?"file":w}function b(w,L){switch(w){case"https":case"http":case"file":L?L[0]!==l&&(L=l+L):L=l;break}return L}const f="",l="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(L){return L instanceof u?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,k,O,z,D,y=!1){typeof L=="object"?(this.scheme=L.scheme||f,this.authority=L.authority||f,this.path=L.path||f,this.query=L.query||f,this.fragment=L.fragment||f):(this.scheme=v(L,y),this.authority=k||f,this.path=b(this.scheme,O||f),this.query=z||f,this.fragment=D||f,r(this,y))}get fsPath(){return i(this,!1)}with(L){if(!L)return this;let{scheme:k,authority:O,path:z,query:D,fragment:y}=L;return k===void 0?k=this.scheme:k===null&&(k=f),O===void 0?O=this.authority:O===null&&(O=f),z===void 0?z=this.path:z===null&&(z=f),D===void 0?D=this.query:D===null&&(D=f),y===void 0?y=this.fragment:y===null&&(y=f),k===this.scheme&&O===this.authority&&z===this.path&&D===this.query&&y===this.fragment?this:new s(k,O,z,D,y)}static parse(L,k=!1){const O=c.exec(L);return O?new s(O[2]||f,q(O[4]||f),q(O[5]||f),q(O[7]||f),q(O[9]||f),k):new s(f,f,f,f,f)}static file(L){let k=f;if(m.$j&&(L=L.replace(/\\/g,l)),L[0]===l&&L[1]===l){const O=L.indexOf(l,2);O===-1?(k=L.substring(2),L=l):(k=L.substring(2,O),L=L.substring(O)||l)}return new s("file",k,L,f,f)}static from(L,k){return new s(L.scheme,L.authority,L.path,L.query,L.fragment,k)}static joinPath(L,...k){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return m.$j&&L.scheme==="file"?O=u.file(A.$ic.join(i(L,!0),...k)).path:O=A.$jc.join(L.path,...k),L.with({path:O})}toString(L=!1){return n(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof u)return L;{const k=new s(L);return k._formatted=L.external??null,k._fsPath=L._sep===a?L.fsPath??null:null,k}}else return L}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=u;function h(w){return!w||typeof w!="object"?!1:typeof w.scheme=="string"&&(typeof w.authority=="string"||typeof w.authority>"u")&&(typeof w.path=="string"||typeof w.path>"u")&&(typeof w.query=="string"||typeof w.query>"u")&&(typeof w.fragment=="string"||typeof w.fragment>"u")}const a=m.$j?1:void 0;class s extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(L=!1){return L?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const L={$mid:t.MarshalledId.Uri};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=a),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const p={[o.CharCode.Colon]:"%3A",[o.CharCode.Slash]:"%2F",[o.CharCode.QuestionMark]:"%3F",[o.CharCode.Hash]:"%23",[o.CharCode.OpenSquareBracket]:"%5B",[o.CharCode.CloseSquareBracket]:"%5D",[o.CharCode.AtSign]:"%40",[o.CharCode.ExclamationMark]:"%21",[o.CharCode.DollarSign]:"%24",[o.CharCode.Ampersand]:"%26",[o.CharCode.SingleQuote]:"%27",[o.CharCode.OpenParen]:"%28",[o.CharCode.CloseParen]:"%29",[o.CharCode.Asterisk]:"%2A",[o.CharCode.Plus]:"%2B",[o.CharCode.Comma]:"%2C",[o.CharCode.Semicolon]:"%3B",[o.CharCode.Equals]:"%3D",[o.CharCode.Space]:"%20"};function E(w,L,k){let O,z=-1;for(let D=0;D<w.length;D++){const y=w.charCodeAt(D);if(y>=o.CharCode.a&&y<=o.CharCode.z||y>=o.CharCode.A&&y<=o.CharCode.Z||y>=o.CharCode.Digit0&&y<=o.CharCode.Digit9||y===o.CharCode.Dash||y===o.CharCode.Period||y===o.CharCode.Underline||y===o.CharCode.Tilde||L&&y===o.CharCode.Slash||k&&y===o.CharCode.OpenSquareBracket||k&&y===o.CharCode.CloseSquareBracket||k&&y===o.CharCode.Colon)z!==-1&&(O+=encodeURIComponent(w.substring(z,D)),z=-1),O!==void 0&&(O+=w.charAt(D));else{O===void 0&&(O=w.substr(0,D));const N=p[y];N!==void 0?(z!==-1&&(O+=encodeURIComponent(w.substring(z,D)),z=-1),O+=N):z===-1&&(z=D)}}return z!==-1&&(O+=encodeURIComponent(w.substring(z))),O!==void 0?O:w}function S(w){let L;for(let k=0;k<w.length;k++){const O=w.charCodeAt(k);O===o.CharCode.Hash||O===o.CharCode.QuestionMark?(L===void 0&&(L=w.substr(0,k)),L+=p[O]):L!==void 0&&(L+=w[k])}return L!==void 0?L:w}function i(w,L){let k;return w.authority&&w.path.length>1&&w.scheme==="file"?k=`//${w.authority}${w.path}`:w.path.charCodeAt(0)===o.CharCode.Slash&&(w.path.charCodeAt(1)>=o.CharCode.A&&w.path.charCodeAt(1)<=o.CharCode.Z||w.path.charCodeAt(1)>=o.CharCode.a&&w.path.charCodeAt(1)<=o.CharCode.z)&&w.path.charCodeAt(2)===o.CharCode.Colon?L?k=w.path.substr(1):k=w.path[1].toLowerCase()+w.path.substr(2):k=w.path,m.$j&&(k=k.replace(/\//g,"\\")),k}function n(w,L){const k=L?S:E;let O="",{scheme:z,authority:D,path:y,query:N,fragment:I}=w;if(z&&(O+=z,O+=":"),(D||z==="file")&&(O+=l,O+=l),D){let P=D.indexOf("@");if(P!==-1){const C=D.substr(0,P);D=D.substr(P+1),P=C.lastIndexOf(":"),P===-1?O+=k(C,!1,!1):(O+=k(C.substr(0,P),!1,!1),O+=":",O+=k(C.substr(P+1),!1,!0)),O+="@"}D=D.toLowerCase(),P=D.lastIndexOf(":"),P===-1?O+=k(D,!1,!0):(O+=k(D.substr(0,P),!1,!0),O+=D.substr(P))}if(y){if(y.length>=3&&y.charCodeAt(0)===o.CharCode.Slash&&y.charCodeAt(2)===o.CharCode.Colon){const P=y.charCodeAt(1);P>=o.CharCode.A&&P<=o.CharCode.Z&&(y=`/${String.fromCharCode(P+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===o.CharCode.Colon){const P=y.charCodeAt(0);P>=o.CharCode.A&&P<=o.CharCode.Z&&(y=`${String.fromCharCode(P+32)}:${y.substr(2)}`)}O+=k(y,!0,!1)}return N&&(O+="?",O+=k(N,!1,!1)),I&&(O+="#",O+=L?I:E(I,!1,!1)),O}function g(w){try{return decodeURIComponent(w)}catch{return w.length>3?w.substr(0,3)+g(w.substr(3)):w}}const R=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function q(w){return w.match(R)?w.replace(R,L=>g(L)):w}}),define(he[56],fe([0,1,6]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=t,e.$jr=A,e.$kr=m,e.log=_;function t(r){const v=r;return v&&typeof v.type=="string"&&typeof v.severity=="string"}function A(r){const v=[];let b;try{const f=JSON.parse(r.arguments),l=f[f.length-1];l&&l.__$stack&&(f.pop(),b=l.__$stack),v.push(...f)}catch{v.push("Unable to log remote console arguments",r.arguments)}return{args:v,stack:b}}function m(r){if(typeof r!="string")return m(A(r).stack);const v=r;if(v){const b=j(v),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(f&&f.length===4)return{uri:o.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function j(r){if(!r)return r;const v=r.indexOf(`
`);return v===-1?r:r.substring(0,v)}function _(r,v){const{args:b,stack:f}=A(r),l=typeof b[0]=="string"&&b.length===1;let c=j(f);c&&(c=`(${c.trim()})`);let u=[];if(typeof b[0]=="string"?c&&l?u=[`%c[${v}] %c${b[0]} %c${c}`,$("blue"),$(""),$("grey")]:u=[`%c[${v}] %c${b[0]}`,$("blue"),$(""),...b.slice(1)]:u=[`%c[${v}]%`,$("blue"),...b],c&&!l&&u.push(c),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,u)}function $(r){return`color: ${r}`}}),define(he[57],fe([0,1,19,6,27]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=m,e.$ei=j,e.$fi=$;function m(r){return JSON.stringify(r,_)}function j(r){let v=JSON.parse(r);return v=$(v),v}function _(r,v){return v instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:v.source,flags:v.flags}:v}function $(r,v=0){if(!r||v>200)return r;if(typeof r=="object"){switch(r.$mid){case A.MarshalledId.Uri:return t.URI.revive(r);case A.MarshalledId.Regexp:return new RegExp(r.source,r.flags);case A.MarshalledId.Date:return new Date(r.source)}if(r instanceof o.$Qe||r instanceof Uint8Array)return r;if(Array.isArray(r))for(let b=0;b<r.length;++b)r[b]=$(r[b],v+1);else for(const b in r)Object.hasOwnProperty.call(r,b)&&(r[b]=$(r[b],v+1))}return r}}),define(he[20],fe([0,1,7,3,10,6,5]),function(ie,e,o,t,A,m,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Vg=e.$Ug=e.$Tg=e.Schemas=void 0,e.$Rg=$,e.$Sg=r,e.$Wg=b,o=Se(o),t=Se(t),j=Se(j);var _;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting",c.outputChannel="output"})(_||(e.Schemas=_={}));function $(c,u){return m.URI.isUri(c)?(0,A.$If)(c.scheme,u):(0,A.$Jf)(c,u+":")}function r(c,...u){return u.some(h=>$(c,h))}e.$Tg="vscode-tkn",e.$Ug="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u,h){this.f=b(u,h)}getServerRootPath(){return this.f}get g(){return j.$jc.join(this.f,_.vscodeRemoteResource)}set(u,h,a){this.a[u]=h,this.b[u]=a}setConnectionToken(u,h){this.c[u]=h}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(S){return o.$2(S),u}const h=u.authority;let a=this.a[h];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const s=this.b[h],p=this.c[h];let E=`path=${encodeURIComponent(u.path)}`;return typeof p=="string"&&(E+=`&${e.$Ug}=${encodeURIComponent(p)}`),m.URI.from({scheme:t.$p?this.d:_.vscodeRemoteResource,authority:`${a}:${s}`,path:this.g,query:E})}}e.$Vg=new v;function b(c,u){return j.$jc.join(u??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Xg="vs/../../extensions",e.$Yg="vs/../../node_modules",e.$Zg="vs/../../node_modules.asar",e.$1g="vs/../../node_modules.asar.unpacked",e.$2g="vscode-app";class f{static{this.a=e.$2g}asBrowserUri(u){const h=this.b(u,ie);return this.uriToBrowserUri(h)}uriToBrowserUri(u){return u.scheme===_.vscodeRemote?e.$Vg.rewrite(u):u.scheme===_.file&&(t.$n||t.$r===`${_.vscodeFileResource}://${f.a}`)?u.with({scheme:_.vscodeFileResource,authority:u.authority||f.a,query:null,fragment:null}):u}asFileUri(u){const h=this.b(u,ie);return this.uriToFileUri(h)}uriToFileUri(u){return u.scheme===_.vscodeFileResource?u.with({scheme:_.file,authority:u.authority!==f.a?u.authority:null,query:null,fragment:null}):u}b(u,h){if(m.URI.isUri(u))return u;if(globalThis._VSCODE_FILE_ROOT){const a=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(a))return m.URI.joinPath(m.URI.parse(a,!0),u);const s=j.$mc(a,u);return m.URI.file(s)}return m.URI.parse(h.toUrl(u))}}e.$3g=new f;var l;(function(c){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(u.get("3"));const h="vscode-coi";function a(p){let E;typeof p=="string"?E=new URL(p).searchParams:p instanceof URL?E=p.searchParams:m.URI.isUri(p)&&(E=new URL(p.toString(!0)).searchParams);const S=E?.get(h);if(S)return u.get(S)}c.getHeadersFromQuery=a;function s(p,E,S){if(!globalThis.crossOriginIsolated)return;const i=E&&S?"3":S?"2":"1";p instanceof URLSearchParams?p.set(h,i):p[h]=i}c.addSearchParam=s})(l||(e.COI=l={}))}),define(he[25],fe([0,1,13,34,20,5,3,10,6]),function(ie,e,o,t,A,m,j,_,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0,e.$0g=r,e.$sh=b,e.$th=l,t=Se(t),m=Se(m);function r(c){return(0,$.$zc)(c,!0)}class v{constructor(u){this.a=u}compare(u,h,a=!1){return u===h?0:(0,_.$Bf)(this.getComparisonKey(u,a),this.getComparisonKey(h,a))}isEqual(u,h,a=!1){return u===h?!0:!u||!h?!1:this.getComparisonKey(u,a)===this.getComparisonKey(h,a)}getComparisonKey(u,h=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,h,a=!1){if(u.scheme===h.scheme){if(u.scheme===A.Schemas.file)return t.$Hg(r(u),r(h),this.a(u))&&u.query===h.query&&(a||u.fragment===h.fragment);if((0,e.$oh)(u.authority,h.authority))return t.$Hg(u.path,h.path,this.a(u),"/")&&u.query===h.query&&(a||u.fragment===h.fragment)}return!1}joinPath(u,...h){return $.URI.joinPath(u,...h)}basenameOrAuthority(u){return(0,e.$gh)(u)||u.authority}basename(u){return m.$jc.basename(u.path)}extname(u){return m.$jc.extname(u.path)}dirname(u){if(u.path.length===0)return u;let h;return u.scheme===A.Schemas.file?h=$.URI.file(m.$pc(r(u))).path:(h=m.$jc.dirname(u.path),u.authority&&h.length&&h.charCodeAt(0)!==o.CharCode.Slash&&(console.error(`dirname("${u.toString})) resulted in a relative path`),h="/")),u.with({path:h})}normalizePath(u){if(!u.path.length)return u;let h;return u.scheme===A.Schemas.file?h=$.URI.file(m.$kc(r(u))).path:h=m.$jc.normalize(u.path),u.with({path:h})}relativePath(u,h){if(u.scheme!==h.scheme||!(0,e.$oh)(u.authority,h.authority))return;if(u.scheme===A.Schemas.file){const p=m.$oc(r(u),r(h));return j.$j?t.$Bg(p):p}let a=u.path||"/";const s=h.path||"/";if(this.a(u)){let p=0;for(const E=Math.min(a.length,s.length);p<E&&!(a.charCodeAt(p)!==s.charCodeAt(p)&&a.charAt(p).toLowerCase()!==s.charAt(p).toLowerCase());p++);a=s.substr(0,p)+a.substr(p)}return m.$jc.relative(a,s)}resolvePath(u,h){if(u.scheme===A.Schemas.file){const a=$.URI.file(m.$nc(r(u),h));return u.with({authority:a.authority,path:a.path})}return h=t.$Cg(h),u.with({path:m.$jc.resolve(u.path,h)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,h){return u===h||u!==void 0&&h!==void 0&&(0,_.$If)(u,h)}hasTrailingPathSeparator(u,h=m.sep){if(u.scheme===A.Schemas.file){const a=r(u);return a.length>t.$Dg(a).length&&a[a.length-1]===h}else{const a=u.path;return a.length>1&&a.charCodeAt(a.length-1)===o.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,h=m.sep){return(0,e.$ph)(u,h)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,h=m.sep){let a=!1;if(u.scheme===A.Schemas.file){const s=r(u);a=s!==void 0&&s.length===t.$Dg(s).length&&s[s.length-1]===h}else{h="/";const s=u.path;a=s.length===1&&s.charCodeAt(s.length-1)===o.CharCode.Slash}return!a&&!(0,e.$ph)(u,h)?u.with({path:u.path+"/"}):u}}e.$$g=v,e.$_g=new v(()=>!1),e.$ah=new v(c=>c.scheme===A.Schemas.file?!j.$l:!0),e.$bh=new v(c=>!0),e.$ch=e.$_g.isEqual.bind(e.$_g),e.$dh=e.$_g.isEqualOrParent.bind(e.$_g),e.$eh=e.$_g.getComparisonKey.bind(e.$_g),e.$fh=e.$_g.basenameOrAuthority.bind(e.$_g),e.$gh=e.$_g.basename.bind(e.$_g),e.$hh=e.$_g.extname.bind(e.$_g),e.$ih=e.$_g.dirname.bind(e.$_g),e.$jh=e.$_g.joinPath.bind(e.$_g),e.$kh=e.$_g.normalizePath.bind(e.$_g),e.$lh=e.$_g.relativePath.bind(e.$_g),e.$mh=e.$_g.resolvePath.bind(e.$_g),e.$nh=e.$_g.isAbsolutePath.bind(e.$_g),e.$oh=e.$_g.isEqualAuthority.bind(e.$_g),e.$ph=e.$_g.hasTrailingPathSeparator.bind(e.$_g),e.$qh=e.$_g.removeTrailingPathSeparator.bind(e.$_g),e.$rh=e.$_g.addTrailingPathSeparator.bind(e.$_g);function b(c,u){const h=[];for(let a=0;a<c.length;a++){const s=u(c[a]);c.some((p,E)=>E===a?!1:(0,e.$dh)(s,u(p)))||h.push(c[a])}return h}var f;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function u(h){const a=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(E=>{const[S,i]=E.split(":");S&&i&&a.set(S,i)});const p=h.path.substring(0,h.path.indexOf(";"));return p&&a.set(c.META_DATA_MIME,p),a}c.parseMetaData=u})(f||(e.DataUri=f={}));function l(c,u,h){if(u){let a=c.path;return a&&a[0]!==m.$jc.sep&&(a=m.$jc.sep+a),c.with({scheme:h,authority:u,path:a})}return c.with({scheme:h})}}),define(he[11],fe([0,1,18,7,4,2,25,3,52,24]),function(ie,e,o,t,A,m,j,_,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$0h=e.$9h=e.$8h=e.$7h=e.Promises=e.$6h=e.$5h=e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0,e.$uh=v,e.$vh=b,e.$wh=f,e.$xh=l,e.$yh=c,e.$zh=u,e.$Ah=h,e.$Bh=a,e.$Jh=w,e.$Kh=L,e.$Lh=k,e.$Mh=O,e.$Nh=z,e.$3h=F,e.$$h=U;function v(T){return!!T&&typeof T.then=="function"}function b(T){const M=new o.$ze,G=T(M.token),x=new Promise((ne,$e)=>{const ve=M.token.onCancellationRequested(()=>{ve.dispose(),$e(new t.$7)});Promise.resolve(G).then(De=>{ve.dispose(),M.dispose(),ne(De)},De=>{ve.dispose(),M.dispose(),$e(De)})});return new class{cancel(){M.cancel(),M.dispose()}then(ne,$e){return x.then(ne,$e)}catch(ne){return this.then(void 0,ne)}finally(ne){return x.finally(ne)}}}function f(T,M,G){return new Promise((x,ne)=>{const $e=M.onCancellationRequested(()=>{$e.dispose(),x(G)});T.then(x,ne).finally(()=>$e.dispose())})}function l(T,M){return new Promise((G,x)=>{const ne=M.onCancellationRequested(()=>{ne.dispose(),x(new t.$7)});T.then(G,x).finally(()=>ne.dispose())})}async function c(T){let M=-1;const G=T.map((x,ne)=>x.then($e=>(M=ne,$e)));try{return await Promise.race(G)}finally{T.forEach((x,ne)=>{ne!==M&&x.cancel()})}}function u(T,M,G){let x;const ne=setTimeout(()=>{x?.(void 0),G?.()},M);return Promise.race([T.finally(()=>clearTimeout(ne)),new Promise($e=>x=$e)])}function h(T){return new Promise((M,G)=>{const x=T();v(x)?x.then(M,G):M(x)})}function a(){let T,M;return{promise:new Promise((x,ne)=>{T=x,M=ne}),resolve:T,reject:M}}class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(M){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=M,!this.b){const G=()=>{if(this.b=null,this.f)return;const x=this.queue(this.d);return this.d=null,x};this.b=new Promise(x=>{this.a.then(G,G).then(x)})}return new Promise((G,x)=>{this.b.then(G,x)})}return this.a=M(),new Promise((G,x)=>{this.a.then(ne=>{this.a=null,G(ne)},ne=>{this.a=null,x(ne)})})}dispose(){this.f=!0}}e.$Ch=s;class p{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}e.$Dh=p;class E{constructor(){this.a=new Map}queue(M,G){const ne=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(M)===ne&&this.a.delete(M)});return this.a.set(M,ne),ne}}e.$Eh=E;const S=(T,M)=>{let G=!0;const x=setTimeout(()=>{G=!1,M()},T);return{isTriggered:()=>G,dispose:()=>{clearTimeout(x),G=!1}}},i=T=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,T())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class n{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,G=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((ne,$e)=>{this.d=ne,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const x=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$je?i(x):S(G,x),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Fh=n;class g{constructor(M){this.a=new n(M),this.b=new s}trigger(M,G){return this.a.trigger(()=>this.b.queue(M),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Gh=g;class R{constructor(){this.a=!1,this.b=new Promise((M,G)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Hh=R;class q extends R{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}e.$Ih=q;function w(T,M){return M?new Promise((G,x)=>{const ne=setTimeout(()=>{$e.dispose(),G()},T),$e=M.onCancellationRequested(()=>{clearTimeout(ne),$e.dispose(),x(new t.$7)})}):b(G=>w(T,G))}function L(T,M=0,G){const x=setTimeout(()=>{T(),G&&ne.dispose()},M),ne=(0,m.$Vc)(()=>{clearTimeout(x),G?.deleteAndLeak(ne)});return G?.add(ne),ne}function k(T){const M=[];let G=0;const x=T.length;function ne(){return G<x?T[G++]():null}function $e(ve){ve!=null&&M.push(ve);const De=ne();return De?De.then($e):Promise.resolve(M)}return Promise.resolve(null).then($e)}function O(T,M=x=>!!x,G=null){let x=0;const ne=T.length,$e=()=>{if(x>=ne)return Promise.resolve(G);const ve=T[x++];return Promise.resolve(ve()).then(Ie=>M(Ie)?Promise.resolve(Ie):$e())};return $e()}function z(T,M=x=>!!x,G=null){if(T.length===0)return Promise.resolve(G);let x=T.length;const ne=()=>{x=-1;for(const $e of T)$e.cancel?.()};return new Promise(($e,ve)=>{for(const De of T)De.then(Ie=>{--x>=0&&M(Ie)?(ne(),$e(Ie)):x===0&&$e(G)}).catch(Ie=>{--x>=0&&(ne(),ve(Ie))})})}class D{constructor(M){this.a=0,this.b=!1,this.f=M,this.g=[],this.d=0,this.h=new A.$oe}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(M){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,x)=>{this.g.push({factory:M,c:G,e:x}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const M=this.g.shift();this.d++;const G=M.factory();G.then(M.c,M.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Oh=D;class y extends D{constructor(){super(1)}}e.$Ph=y;class N{constructor(){this.a=new J,this.b=0}queue(M){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,M())):this.a.run(this.b++,M())}}e.$Qh=N;class I{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const M=new W;return this.b.add(M),M.p}g(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueSize(M,G=j.$_g){const x=G.getComparisonKey(M);return this.a.get(x)?.size??0}queueFor(M,G,x=j.$_g){const ne=x.getComparisonKey(M);let $e=this.a.get(ne);if(!$e){$e=new y;const ve=this.f++,De=A.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ne),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new m.$7c),this.d.set(ve,De),this.a.set(ne,$e)}return $e.queue(G)}h(){this.g()&&this.j()}j(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Rh=I;class P{constructor(M,G){this.b=!1,this.a=-1,typeof M=="function"&&typeof G=="number"&&this.setIfNotSet(M,G)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,G){if(this.b)throw new t.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},G)}setIfNotSet(M,G){if(this.b)throw new t.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},G))}}e.$Sh=P;class C{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(M,G,x=globalThis){if(this.f)throw new t.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=x.setInterval(()=>{M()},G);this.d=(0,m.$Vc)(()=>{x.clearInterval(ne),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Th=C;class Q{constructor(M,G){this.b=-1,this.a=M,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Uh=Q;class V{constructor(M,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=M,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Vh=V;class Z extends Q{constructor(M,G){super(M,G),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}e.$Wh=Z;class re extends m.$Xc{constructor(M,G){super(),this.g=M,this.h=G,this.a=[],this.b=this.B(new m.$Yc),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of M)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Xh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Zh=(T,M)=>{(0,_.$C)(()=>{if(G)return;const x=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$Zh=(T,M,G)=>{const x=T.requestIdleCallback(M,typeof G=="number"?{timeout:G}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,T.cancelIdleCallback(x))}}},e.$Yh=T=>(0,e.$Zh)(globalThis,T)}();class ae{constructor(M,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(x){this.l=x}finally{this.g=!0}},this.f=(0,e.$Zh)(M,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$1h=ae;class X extends ae{constructor(M){super(globalThis,M)}}e.$2h=X;async function F(T,M,G){let x;for(let ne=0;ne<G;ne++)try{return await T()}catch($e){x=$e,await w(M)}throw x}class J{isRunning(M){return typeof M=="number"?this.a?.taskId===M:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(M,G,x){return this.a={taskId:M,cancel:()=>x?.(),promise:G},G.then(()=>this.d(M),()=>this.d(M)),G}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}queue(M){if(this.b)this.b.run=M;else{const{promise:G,resolve:x,reject:ne}=a();this.b={run:M,promise:G,promiseResolve:x,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$4h=J;class ee{constructor(M,G=()=>Date.now()){this.d=M,this.f=G,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}e.$5h=ee;var le;(function(T){T[T.Resolved=0]="Resolved",T[T.Rejected=1]="Rejected"})(le||(le={}));class W{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((M,G)=>{this.a=M,this.b=G})}complete(M){return new Promise(G=>{this.a(M),this.d={outcome:le.Resolved,value:M},G()})}error(M){return new Promise(G=>{this.b(M),this.d={outcome:le.Rejected,value:M},G()})}cancel(){return this.error(new t.$7)}}e.$6h=W;var ce;(function(T){async function M(x){let ne;const $e=await Promise.all(x.map(ve=>ve.then(De=>De,De=>{ne||(ne=De)})));if(typeof ne<"u")throw ne;return $e}T.settled=M;function G(x){return new Promise(async(ne,$e)=>{try{await x(ne,$e)}catch(ve){$e(ve)}})}T.withAsyncBody=G})(ce||(e.Promises=ce={}));class de{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(M){this.a=void 0,this.b=void 0,this.d=!1,this.promise=M.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new t.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$7h=de;class te{constructor(M){this.b=M,this.a=new r.$W(()=>new de(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$8h=te;var d;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(d||(d={}));class H{static fromArray(M){return new H(G=>{G.emitMany(M)})}static fromPromise(M){return new H(async G=>{G.emitMany(await M)})}static fromPromises(M){return new H(async G=>{await Promise.all(M.map(async x=>G.emitOne(await x)))})}static merge(M){return new H(async G=>{await Promise.all(M.map(async x=>{for await(const ne of x)G.emitOne(ne)}))})}static{this.EMPTY=H.fromArray([])}constructor(M,G){this.a=d.Initial,this.b=[],this.d=null,this.f=G,this.g=new A.$oe,queueMicrotask(async()=>{const x={emitOne:ne=>this.h(ne),emitMany:ne=>this.j(ne),reject:ne=>this.l(ne)};try{await Promise.resolve(M(x)),this.k()}catch(ne){this.l(ne)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===d.DoneError)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===d.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(M,G){return new H(async x=>{for await(const ne of M)x.emitOne(G(ne))})}map(M){return H.map(this,M)}static filter(M,G){return new H(async x=>{for await(const ne of M)G(ne)&&x.emitOne(ne)})}filter(M){return H.filter(this,M)}static coalesce(M){return H.filter(M,G=>!!G)}coalesce(){return H.coalesce(this)}static async toPromise(M){const G=[];for await(const x of M)G.push(x);return G}toPromise(){return H.toPromise(this)}h(M){this.a===d.Initial&&(this.b.push(M),this.g.fire())}j(M){this.a===d.Initial&&(this.b=this.b.concat(M),this.g.fire())}k(){this.a===d.Initial&&(this.a=d.DoneOK,this.g.fire())}l(M){this.a===d.Initial&&(this.a=d.DoneError,this.d=M,this.g.fire())}}e.$9h=H;class oe extends H{constructor(M,G){super(G),this.m=M}cancel(){this.m.cancel()}}e.$0h=oe;function U(T){const M=new o.$ze,G=T(M.token);return new oe(M,async x=>{const ne=M.token.onCancellationRequested(()=>{ne.dispose(),M.dispose(),x.reject(new t.$7)});try{for await(const $e of G){if(M.token.isCancellationRequested)return;x.emitOne($e)}ne.dispose(),M.dispose()}catch($e){ne.dispose(),M.dispose(),x.reject($e)}})}class K{constructor(M){this.a=new W,this.b=new H(ne=>{if(G){ne.reject(G);return}return x&&ne.emitMany(x),this.d=$e=>ne.reject($e),this.f=$e=>ne.emitOne($e),this.a.p},M);let G,x;this.f=ne=>{x||(x=[]),x.push(ne)},this.d=ne=>{G||(G=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(M){this.d(M),this.a.complete()}emitOne(M){this.f(M)}}e.$_h=K}),define(he[58],fe([0,1,19,27,6]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=void 0,e.$Rn=$,e.$Sn=v,e.$Tn=b;function m(f){return f.toJSON()}class j{constructor(l){this.a=l}transformIncoming(l){const c=this.a.transformIncoming(l);return c===l?l:m(A.URI.from(c))}transformOutgoing(l){const c=this.a.transformOutgoing(l);return c===l?l:m(A.URI.from(c))}transformOutgoingURI(l){const c=this.a.transformOutgoing(l);return c===l?l:A.URI.from(c)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Pn=j,e.$Qn=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function _(f,l,c){if(!f||c>200)return null;if(typeof f=="object"){if(f instanceof A.URI)return l.transformOutgoing(f);for(const u in f)if(Object.hasOwnProperty.call(f,u)){const h=_(f[u],l,c+1);h!==null&&(f[u]=h)}}return null}function $(f,l){const c=_(f,l,0);return c===null?f:c}function r(f,l,c,u){if(!f||u>200)return null;if(typeof f=="object"){if(f.$mid===t.MarshalledId.Uri)return c?A.URI.revive(l.transformIncoming(f)):l.transformIncoming(f);if(f instanceof o.$Qe)return null;for(const h in f)if(Object.hasOwnProperty.call(f,h)){const a=r(f[h],l,c,u+1);a!==null&&(f[h]=a)}}return null}function v(f,l){const c=r(f,l,!1,0);return c===null?f:c}function b(f,l){const c=r(f,l,!0,0);return c===null?f:c}}),define(he[59],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=t;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(A){return o.test(A)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(_){for(let $=0;$<_.length;$++)_[$]=Math.floor(Math.random()*256);return _};const m=new Uint8Array(16),j=[];for(let _=0;_<256;_++)j.push(_.toString(16).padStart(2,"0"));return function(){A(m),m[6]=m[6]&15|64,m[8]=m[8]&63|128;let $=0,r="";return r+=j[m[$++]],r+=j[m[$++]],r+=j[m[$++]],r+=j[m[$++]],r+="-",r+=j[m[$++]],r+=j[m[$++]],r+="-",r+=j[m[$++]],r+=j[m[$++]],r+="-",r+=j[m[$++]],r+=j[m[$++]],r+="-",r+=j[m[$++]],r+=j[m[$++]],r+=j[m[$++]],r+=j[m[$++]],r+=j[m[$++]],r+=j[m[$++]],r}}()}),define(he[28],fe([0,1,35,21,100,11,34,48,5,3,25,6]),function(ie,e,o,t,A,m,j,_,$,r,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=h,e.readdirSync=p,e.whenDeleted=i,e.configureFlushOnWrite=w,e.writeFileSync=k,o=Se(o);var f;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function l(V,Z=f.UNLINK,re){if((0,j.$Lg)(V))throw new Error("rimraf - will refuse to recursively delete root");return Z===f.UNLINK?u(V):c(V,re)}async function c(V,Z=(0,j.$Qg)((0,t.tmpdir)())){try{try{await o.promises.rename(V,Z)}catch(re){return re.code==="ENOENT"?void 0:u(V)}u(Z).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function u(V){return o.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function h(V){if((0,j.$Lg)(V))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function a(V,Z){return E(await(Z?s(V):o.promises.readdir(V)))}async function s(V){try{return await o.promises.readdir(V,{withFileTypes:!0})}catch(ae){console.warn("[node.js fs] readdir with filetypes failed with error: ",ae)}const Z=[],re=await a(V);for(const ae of re){let X=!1,F=!1,J=!1;try{const ee=await o.promises.lstat((0,$.$mc)(V,ae));X=ee.isFile(),F=ee.isDirectory(),J=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Z.push({name:ae,isFile:()=>X,isDirectory:()=>F,isSymbolicLink:()=>J})}return Z}function p(V){return E(o.readdirSync(V))}function E(V){return V.map(Z=>typeof Z=="string"?r.$k?(0,_.$qm)(Z):Z:(Z.name=r.$k?(0,_.$qm)(Z.name):Z.name,Z))}async function S(V){const Z=await a(V),re=[];for(const ae of Z)await n.existsDirectory((0,$.$mc)(V,ae))&&re.push(ae);return re}function i(V,Z=1e3){return new Promise(re=>{let ae=!1;const X=setInterval(()=>{ae||(ae=!0,o.access(V,F=>{ae=!1,F&&(clearInterval(X),re(void 0))}))},Z)})}var n;(function(V){async function Z(X){let F;try{if(F=await o.promises.lstat(X),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await o.promises.stat(X),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(r.$j&&J.code==="EACCES")try{return{stat:await o.promises.stat(await o.promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw ee}throw J}}V.stat=Z;async function re(X){try{const{stat:F,symbolicLink:J}=await V.stat(X);return F.isFile()&&J?.dangling!==!0}catch{}return!1}V.existsFile=re;async function ae(X){try{const{stat:F,symbolicLink:J}=await V.stat(X);return F.isDirectory()&&J?.dangling!==!0}catch{}return!1}V.existsDirectory=ae})(n||(e.SymlinkSupport=n={}));const g=new m.$Rh;function R(V,Z,re){return g.queueFor(b.URI.file(V),()=>{const ae=O(re);return new Promise((X,F)=>L(V,Z,ae,J=>J?F(J):X()))},v.$ah)}let q=!0;function w(V){q=V}function L(V,Z,re,ae){if(!q)return o.writeFile(V,Z,{mode:re.mode,flag:re.flag},ae);o.open(V,re.flag,re.mode,(X,F)=>{if(X)return ae(X);o.writeFile(F,Z,J=>{if(J)return o.close(F,()=>ae(J));o.fdatasync(F,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),w(!1)),o.close(F,le=>ae(le))))})})}function k(V,Z,re){const ae=O(re);if(!q)return o.writeFileSync(V,Z,{mode:ae.mode,flag:ae.flag});const X=o.openSync(V,ae.flag,ae.mode);try{o.writeFileSync(X,Z);try{o.fdatasyncSync(X)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),w(!1)}}finally{o.closeSync(X)}}function O(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function z(V,Z,re=6e4){if(V!==Z)try{r.$j&&typeof re=="number"?await D(V,Z,Date.now(),re):await o.promises.rename(V,Z)}catch(ae){if(V.toLowerCase()!==Z.toLowerCase()&&ae.code==="EXDEV"||V.endsWith("."))await y(V,Z,{preserveSymlinks:!1}),await l(V,f.MOVE);else throw ae}}async function D(V,Z,re,ae,X=0){try{return await o.promises.rename(V,Z)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-re>=ae)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${F}`),F;if(X===0){let J=!1;try{const{stat:ee}=await n.stat(Z);ee.isFile()||(J=!0)}catch{}if(J)throw F}return await(0,m.$Jh)(Math.min(100,X*10)),D(V,Z,re,ae,X+1)}}async function y(V,Z,re){return I(V,Z,{root:{source:V,target:Z},options:re,handledSourcePaths:new Set})}const N=511;async function I(V,Z,re){if(re.handledSourcePaths.has(V))return;re.handledSourcePaths.add(V);const{stat:ae,symbolicLink:X}=await n.stat(V);if(X){if(re.options.preserveSymlinks)try{return await Q(V,Z,re)}catch{}if(X.dangling)return}return ae.isDirectory()?P(V,Z,ae.mode&N,re):C(V,Z,ae.mode&N)}async function P(V,Z,re,ae){await o.promises.mkdir(Z,{recursive:!0,mode:re});const X=await a(V);for(const F of X)await I((0,$.$mc)(V,F),(0,$.$mc)(Z,F),ae)}async function C(V,Z,re){await o.promises.copyFile(V,Z),await o.promises.chmod(Z,re)}async function Q(V,Z,re){let ae=await o.promises.readlink(V);(0,j.$Hg)(ae,re.root.source,!r.$l)&&(ae=(0,$.$mc)(re.root.target,ae.substr(re.root.source.length+1))),await o.promises.symlink(ae,Z)}e.Promises=new class{get read(){return(V,Z,re,ae,X)=>new Promise((F,J)=>{o.read(V,Z,re,ae,X,(ee,le,W)=>ee?J(ee):F({bytesRead:le,buffer:W}))})}get write(){return(V,Z,re,ae,X)=>new Promise((F,J)=>{o.write(V,Z,re,ae,X,(ee,le,W)=>ee?J(ee):F({bytesWritten:le,buffer:W}))})}get fdatasync(){return(0,A.promisify)(o.fdatasync)}get open(){return(0,A.promisify)(o.open)}get close(){return(0,A.promisify)(o.close)}get realpath(){return(0,A.promisify)(o.realpath)}async exists(V){try{return await o.promises.access(V),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return S}get writeFile(){return R}get rm(){return l}get rename(){return z}get copy(){return y}}}),define(he[60],fe([0,1,21,5,28]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=s,e.$Am=p,o=Se(o),t=Se(t),A=Se(A);const m=/^\d+$/,j=/^Microsoft.PowerShell_.*/,_=/^Microsoft.PowerShellPreview_.*/;var $;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})($||($={}));let r;switch(process.arch){case"ia32":r=$.x86;break;case"arm":case"arm64":r=$.ARM;break;default:r=$.x64;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?$.ARM:$.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=$.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=$.x86:v=$.x64;class b{constructor(S,i,n){this.exePath=S,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await A.SymlinkSupport.existsFile(this.exePath)),this.a}}function f({useAlternateBitness:E=!1}={}){return E?r===$.x64?process.env["ProgramFiles(x86)"]||null:v===$.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:E=!1,findPreview:S=!1}={}){const i=f({useAlternateBitness:E});if(!i)return null;const n=t.$mc(i,"PowerShell");if(!await A.SymlinkSupport.existsDirectory(n))return null;let g=-1,R=null;for(const L of await A.Promises.readdir(n)){let k=-1;if(S){const z=L.indexOf("-");if(z<0)continue;const D=L.substring(0,z);if(!m.test(D)||L.substring(z+1)!=="preview")continue;k=parseInt(D,10)}else{if(!m.test(L))continue;k=parseInt(L,10)}if(k<=g)continue;const O=t.$mc(n,L,"pwsh.exe");await A.SymlinkSupport.existsFile(O)&&(R=O,g=k)}if(!R)return null;const q=i.includes("x86")?" (x86)":"",w=S?" Preview":"";return new b(R,`PowerShell${w}${q}`,!0)}async function c({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const S=t.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await A.SymlinkSupport.existsDirectory(S))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=E?{pwshMsixDirRegex:_,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const g of await A.Promises.readdir(S))if(i.test(g)){const R=t.$mc(S,g,"pwsh.exe");return new b(R,n)}return null}function u(){const E=t.$mc(o.homedir(),".dotnet","tools","pwsh.exe");return new b(E,".NET Core PowerShell Global Tool")}function h(){const E=t.$mc(process.env.windir,r===$.x86&&v!==$.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(E,"Windows PowerShell",!0)}async function*a(){let E=await l();E&&(yield E),E=await l({useAlternateBitness:!0}),E&&(yield E),E=await c(),E&&(yield E),E=u(),E&&(yield E),E=await l({findPreview:!0}),E&&(yield E),E=await c({findPreview:!0}),E&&(yield E),E=await l({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=h(),E&&(yield E)}async function*s(){for await(const E of a())await E.exists()&&(yield E)}async function p(){for await(const E of s())return E;return null}}),define(he[36],fe([0,1,35,5,3,15,32,9,28]),function(ie,e,o,t,A,m,j,_,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Bm=r,e.$Cm=v,t=Se(t),A=Se(A),m=Se(m),_=Se(_),$=Se($),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function r(f=m.env){return f.comspec||"cmd.exe"}function v(f){let l=[],c=!1;const u=function(h){if(c){l.push(h);return}(!f.send(h,s=>{if(s&&console.error(s),c=!1,l.length>0){const p=l.slice(0);l=[],p.forEach(E=>u(E))}})||A.$j)&&(c=!0)};return{send:u}}var b;(function(f){async function l(c,u,h){if(t.$lc(c))return c;if(u===void 0&&(u=m.cwd()),t.$pc(c)!=="."||(h===void 0&&_.$hg(m.env.PATH)&&(h=m.env.PATH.split(t.$wc)),h===void 0||h.length===0))return t.$mc(u,c);async function s(p){if(await $.Promises.exists(p)){let E;try{E=await o.promises.stat(p)}catch(S){S.message.startsWith("EACCES")&&(E=await o.promises.lstat(p))}return E?!E.isDirectory():!1}return!1}for(const p of h){let E;if(t.$lc(p)?E=t.$mc(p,c):E=t.$mc(u,p,c),await s(E))return E;let S=E+".com";if(await s(S)||(S=E+".exe",await s(S)))return S}return t.$mc(u,c)}f.findExecutable=l})(b||(e.win32=b={}))}),define(he[61],fe([0,1,29,20]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=A;function A(j){return new Promise((_,$)=>{let r;const v=new Map;function b(l,c,u,h,a){const s=v.get(c);if(l===j||s){const p={name:f(u),cmd:u,pid:l,ppid:c,load:h,mem:a};v.set(l,p),l===j&&(r=p),s&&(s.children||(s.children=[]),s.children.push(p),s.children.length>1&&(s.children=s.children.sort((E,S)=>E.pid-S.pid)))}}function f(l){const c=/--utility-sub-type=network/i,u=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,a=/conhost\.exe.+--headless/i,s=/--type=([a-zA-Z-]+)/;if(u.exec(l))return"electron-crash-reporter";if(h.exec(l))return"winpty-agent";if(a.exec(l))return"conpty-agent";let p=s.exec(l);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?c.exec(l)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const E=/[a-zA-Z-]+\.js/g;let S="";do p=E.exec(l),p&&(S+=p+" ");while(p);return S&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${S})`:l}if(process.platform==="win32"){const l=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,u)=>{ie(["@vscode/windows-process-tree"],c,u)}).then(Se).then(c=>{c.getProcessList(j,u=>{if(!u){$(new Error(`Root process ${j} not found`));return}c.getProcessCpuUsage(u,h=>{const a=new Map;h.forEach(s=>{const p=l(s.commandLine||"");a.set(s.pid,{name:f(p),cmd:p,pid:s.pid,ppid:s.ppid,load:s.cpu||0,mem:s.memory||0})}),r=a.get(j),r?(a.forEach(s=>{const p=a.get(s.ppid);p&&(p.children||(p.children=[]),p.children.push(s))}),a.forEach(s=>{s.children&&(s.children=s.children.sort((p,E)=>p.pid-E.pid))}),_(r)):$(new Error(`Root process ${j} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let l=function(){let c=[r];const u=[];for(;c.length;){const a=c.shift();a&&(u.push(a.pid),a.children&&(c=c.concat(a.children)))}let h=JSON.stringify(t.$3g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+u.join(" "),(0,o.exec)(h,{},(a,s,p)=>{if(a||p)$(a||new Error(p.toString()));else{const E=s.toString().split(`
`);for(let S=0;S<u.length;S++){const i=v.get(u[S]);i.load=parseFloat(E[S])}if(!r){$(new Error(`Root process ${j} not found`));return}_(r)}})};(0,o.exec)("which ps",{},(c,u,h)=>{if(c||h)if(process.platform!=="linux")$(c||new Error(h.toString()));else{const a=JSON.stringify(t.$3g.asFileUri("vs/base/node/ps.sh").fsPath);(0,o.exec)(a,{},(s,p,E)=>{s||E?$(s||new Error(E.toString())):(m(p,b),l())})}else{const a=u.toString().trim();(0,o.exec)(`${a} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,E,S)=>{p||S&&!S.includes("screen size is bogus")?$(p||new Error(S.toString())):(m(E,b),process.platform==="linux"?l():r?_(r):$(new Error(`Root process ${j} not found`)))})}})}})}function m(j,_){const $=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=j.toString().split(`
`);for(const v of r){const b=$.exec(v.trim());b&&b.length===6&&_(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(he[62],fe([0,1,21,3,60,36]),function(ie,e,o,t,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=j,t=Se(t),m=Se(m);async function j(b,f){return b===t.OperatingSystem.Windows?t.$j?v():m.$Bm(f):$(b,f)}let _=null;function $(b,f){if(t.$l&&b===t.OperatingSystem.Macintosh||t.$k&&b===t.OperatingSystem.Linux)return"/bin/bash";if(!_){let l;if(t.$j)l="/bin/bash";else{if(l=f.SHELL,!l)try{l=(0,o.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}_=l}return _}let r=null;async function v(){return r||(r=(await(0,A.$Am)()).exePath),r}});var me=this&&this.__decorate||function(ie,e,o,t){var A=arguments.length,m=A<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,o):t,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")m=Reflect.decorate(ie,e,o,t);else for(var _=ie.length-1;_>=0;_--)(j=ie[_])&&(m=(A<3?j(m):A>3?j(e,o,m):j(e,o))||m);return A>3&&m&&Object.defineProperty(e,o,m),m};define(he[30],fe([0,1,17,11,19,18,14,7,4,2,57,10,9]),function(ie,e,o,t,A,m,j,_,$,r,v,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.ProxyChannel=e.$qi=e.$ni=e.$mi=e.$li=e.RequestInitiator=e.$ki=e.$hi=e.$gi=void 0,e.$ii=w,e.$ji=L,e.$oi=N,e.$pi=I,b=Se(b);var l;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(l||(l={}));function c(X){switch(X){case l.Promise:return"req";case l.PromiseCancel:return"cancel";case l.EventListen:return"subscribe";case l.EventDispose:return"unsubscribe"}}var u;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(u||(u={}));function h(X){switch(X){case u.Initialize:return"init";case u.PromiseSuccess:return"reply:";case u.PromiseError:case u.PromiseErrorObj:return"replyErr:";case u.EventFire:return"event:"}}var a;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(a||(a={}));function s(X){let F=0;for(let J=0;;J+=7){const ee=X.read(1);if(F|=(ee.buffer[0]&127)<<J,!(ee.buffer[0]&128))return F}}const p=g(0);function E(X,F){if(F===0){X.write(p);return}let J=0;for(let le=F;le!==0;le=le>>>7)J++;const ee=A.$Qe.alloc(J);for(let le=0;F!==0;le++)ee.buffer[le]=F&127,F=F>>>7,F>0&&(ee.buffer[le]|=128);X.write(ee)}class S{constructor(F){this.b=F,this.a=0}read(F){const J=this.b.slice(this.a,this.a+F);return this.a+=J.byteLength,J}}e.$gi=S;class i{constructor(){this.a=[]}get buffer(){return A.$Qe.concat(this.a)}write(F){this.a.push(F)}}e.$hi=i;var n;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(n||(n={}));function g(X){const F=A.$Qe.alloc(1);return F.writeUInt8(X,0),F}const R={Undefined:g(n.Undefined),String:g(n.String),Buffer:g(n.Buffer),VSBuffer:g(n.VSBuffer),Array:g(n.Array),Object:g(n.Object),Uint:g(n.Int)},q=typeof Buffer<"u";function w(X,F){if(typeof F>"u")X.write(R.Undefined);else if(typeof F=="string"){const J=A.$Qe.fromString(F);X.write(R.String),E(X,J.byteLength),X.write(J)}else if(q&&Buffer.isBuffer(F)){const J=A.$Qe.wrap(F);X.write(R.Buffer),E(X,J.byteLength),X.write(J)}else if(F instanceof A.$Qe)X.write(R.VSBuffer),E(X,F.byteLength),X.write(F);else if(Array.isArray(F)){X.write(R.Array),E(X,F.length);for(const J of F)w(X,J)}else if(typeof F=="number"&&(F|0)===F)X.write(R.Uint),E(X,F);else{const J=A.$Qe.fromString(JSON.stringify(F));X.write(R.Object),E(X,J.byteLength),X.write(J)}}function L(X){switch(X.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return X.read(s(X)).toString();case n.Buffer:return X.read(s(X)).buffer;case n.VSBuffer:return X.read(s(X));case n.Array:{const J=s(X),ee=[];for(let le=0;le<J;le++)ee.push(L(X));return ee}case n.Object:return JSON.parse(X.read(s(X)).toString());case n.Int:return s(X)}}class k{constructor(F,J,ee=null,le=1e3){this.h=F,this.j=J,this.k=ee,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:u.Initialize})}registerChannel(F,J){this.b.set(F,J),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case u.Initialize:{const J=this.o([F.type]);this.k?.logOutgoing(J,0,O.OtherSide,h(F.type));return}case u.PromiseSuccess:case u.PromiseError:case u.EventFire:case u.PromiseErrorObj:{const J=this.o([F.type,F.id],F.data);this.k?.logOutgoing(J,F.id,O.OtherSide,h(F.type),F.data);return}}}o(F,J=void 0){const ee=new i;return w(ee,F),w(ee,J),this.p(ee.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const J=new S(F),ee=L(J),le=L(J),W=ee[0];switch(W){case l.Promise:return this.k?.logIncoming(F.byteLength,ee[1],O.OtherSide,`${c(W)}: ${ee[2]}.${ee[3]}`,le),this.s({type:W,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case l.EventListen:return this.k?.logIncoming(F.byteLength,ee[1],O.OtherSide,`${c(W)}: ${ee[2]}.${ee[3]}`,le),this.t({type:W,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case l.PromiseCancel:return this.k?.logIncoming(F.byteLength,ee[1],O.OtherSide,`${c(W)}`),this.u({type:W,id:ee[1]});case l.EventDispose:return this.k?.logIncoming(F.byteLength,ee[1],O.OtherSide,`${c(W)}`),this.u({type:W,id:ee[1]})}}s(F){const J=this.b.get(F.channelName);if(!J){this.v(F);return}const ee=new m.$ze;let le;try{le=J.call(this.j,F.name,F.arg,ee.token)}catch(de){le=Promise.reject(de)}const W=F.id;le.then(de=>{this.m({id:W,data:de,type:u.PromiseSuccess})},de=>{de instanceof Error?this.m({id:W,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split(`
`):void 0},type:u.PromiseError}):this.m({id:W,data:de,type:u.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.d.delete(F.id)});const ce=(0,r.$Vc)(()=>ee.cancel());this.d.set(F.id,ce)}t(F){const J=this.b.get(F.channelName);if(!J){this.v(F);return}const ee=F.id,W=J.listen(this.j,F.name,F.arg)(ce=>this.m({id:ee,data:ce,type:u.EventFire}));this.d.set(F.id,W)}u(F){const J=this.d.get(F.id);J&&(J.dispose(),this.d.delete(F.id))}v(F){let J=this.g.get(F.channelName);J||(J=[],this.g.set(F.channelName,J));const ee=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===l.Promise&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:u.PromiseError})},this.l);J.push({request:F,timeoutTimer:ee})}w(F){const J=this.g.get(F);if(J){for(const ee of J)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case l.Promise:this.s(ee.request);break;case l.EventListen:this.t(ee.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Sc)(this.d.values()),this.d.clear()}}e.$ki=k;var O;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class z{constructor(F,J=null){this.l=F,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$oe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=J}getChannel(F){const J=this;return{call(ee,le,W){return J.a?Promise.reject(new _.$7):J.m(F,ee,le,W)},listen(ee,le){return J.a?$.Event.None:J.o(F,ee,le)}}}m(F,J,ee,le=m.CancellationToken.None){const W=this.g++,ce=l.Promise,de={id:W,type:ce,channelName:F,name:J,arg:ee};if(le.isCancellationRequested)return Promise.reject(new _.$7);let te;return new Promise((H,oe)=>{if(le.isCancellationRequested)return oe(new _.$7);const U=()=>{const G=x=>{switch(x.type){case u.PromiseSuccess:this.f.delete(W),H(x.data);break;case u.PromiseError:{this.f.delete(W);const ne=new Error(x.data.message);ne.stack=Array.isArray(x.data.stack)?x.data.stack.join(`
`):x.data.stack,ne.name=x.data.name,oe(ne);break}case u.PromiseErrorObj:this.f.delete(W),oe(x.data);break}};this.f.set(W,G),this.p(de)};let K=null;this.b===a.Idle?U():(K=(0,t.$vh)(G=>this.u()),K.then(()=>{K=null,U()}));const T=()=>{K?(K.cancel(),K=null):this.p({id:W,type:l.PromiseCancel}),oe(new _.$7)},M=le.onCancellationRequested(T);te=(0,r.$Uc)((0,r.$Vc)(T),M),this.d.add(te)}).finally(()=>{te.dispose(),this.d.delete(te)})}o(F,J,ee){const le=this.g++,W=l.EventListen,ce={id:le,type:W,channelName:F,name:J,arg:ee};let de=null;const te=new $.$oe({onWillAddFirstListener:()=>{de=(0,t.$vh)(H=>this.u()),de.then(()=>{de=null,this.d.add(te),this.p(ce)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.d.delete(te),this.p({id:le,type:l.EventDispose}))}}),d=H=>te.fire(H.data);return this.f.set(le,d),te.event}p(F){switch(F.type){case l.Promise:case l.EventListen:{const J=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(J,F.id,O.LocalSide,`${c(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case l.PromiseCancel:case l.EventDispose:{const J=this.q([F.type,F.id]);this.j?.logOutgoing(J,F.id,O.LocalSide,c(F.type));return}}}q(F,J=void 0){const ee=new i;return w(ee,F),w(ee,J),this.r(ee.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const J=new S(F),ee=L(J),le=L(J),W=ee[0];switch(W){case u.Initialize:return this.j?.logIncoming(F.byteLength,0,O.LocalSide,h(W)),this.t({type:ee[0]});case u.PromiseSuccess:case u.PromiseError:case u.EventFire:case u.PromiseErrorObj:return this.j?.logIncoming(F.byteLength,ee[1],O.LocalSide,h(W),le),this.t({type:ee[0],id:ee[1],data:le})}}t(F){if(F.type===u.Initialize){this.b=a.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Sc)(this.d.values()),this.d.clear()}}e.$li=z,me([j.$ai],z.prototype,"onDidInitializePromise",null);class D{get connections(){const F=[];return this.f.forEach(J=>F.push(J)),F}constructor(F,J,ee){this.a=new Map,this.f=new Set,this.g=new $.$oe,this.onDidAddConnection=this.g.event,this.h=new $.$oe,this.onDidRemoveConnection=this.h.event,this.j=new r.$Wc,this.j.add(F(({protocol:le,onDidClientDisconnect:W})=>{const ce=$.Event.once(le.onMessage);this.j.add(ce(de=>{const te=new S(de),d=L(te),H=new k(le,d,J,ee),oe=new z(le,J);this.a.forEach((K,T)=>H.registerChannel(T,K));const U={channelServer:H,channelClient:oe,ctx:d};this.f.add(U),this.g.fire(U),this.j.add(W(()=>{H.dispose(),oe.dispose(),this.f.delete(U),this.h.fire(U)}))}))}))}getChannel(F,J){const ee=this;return{call(le,W,ce){let de;if((0,f.$vg)(J)){const d=(0,o.$5b)(ee.connections.filter(J));de=d?Promise.resolve(d):$.Event.toPromise($.Event.filter(ee.onDidAddConnection,J))}else de=J.routeCall(ee,le,W);const te=de.then(d=>d.channelClient.getChannel(F));return N(te).call(le,W,ce)},listen(le,W){if((0,f.$vg)(J))return ee.k(F,J,le,W);const ce=J.routeEvent(ee,le,W).then(de=>de.channelClient.getChannel(F));return N(ce).listen(le,W)}}}k(F,J,ee,le){const W=this;let ce;const de=new $.$oe({onWillAddFirstListener:()=>{ce=new r.$Wc;const te=new $.$ue,d=new Map,H=U=>{const T=U.channelClient.getChannel(F).listen(ee,le),M=te.add(T);d.set(U,M)},oe=U=>{const K=d.get(U);K&&(K.dispose(),d.delete(U))};W.connections.filter(J).forEach(H),$.Event.filter(W.onDidAddConnection,J)(H,void 0,ce),W.onDidRemoveConnection(oe,void 0,ce),te.event(de.fire,de,ce),ce.add(te)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return de.event}registerChannel(F,J){this.a.set(F,J);for(const ee of this.f)ee.channelServer.registerChannel(F,J)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$mi=D;class y{constructor(F,J,ee=null){const le=new i;w(le,J),F.send(le.buffer),this.a=new z(F,ee),this.d=new k(F,J,ee)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,J){this.d.registerChannel(F,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ni=y;function N(X){return{call(F,J,ee){return X.then(le=>le.call(F,J,ee))},listen(F,J){const ee=new $.$xe;return X.then(le=>ee.input=le.listen(F,J)),ee.event}}}function I(X){let F=!1;return{call(J,ee,le){return F?X.call(J,ee,le):(0,t.$Jh)(0).then(()=>F=!0).then(()=>X.call(J,ee,le))},listen(J,ee){if(F)return X.listen(J,ee);const le=new $.$xe;return(0,t.$Jh)(0).then(()=>F=!0).then(()=>le.input=X.listen(J,ee)),le.event}}}class P{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const J of F.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await $.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$qi=P;var C;(function(X){function F(W,ce,de){const te=W,d=de&&de.disableMarshalling,H=new Map;for(const oe in te)ee(oe)&&H.set(oe,$.Event.buffer(te[oe],!0,void 0,ce));return new class{listen(oe,U,K){const T=H.get(U);if(T)return T;const M=te[U];if(typeof M=="function"){if(le(U))return M.call(te,K);if(ee(U))return H.set(U,$.Event.buffer(te[U],!0,void 0,ce)),H.get(U)}throw new _.$db(`Event not found: ${U}`)}call(oe,U,K){const T=te[U];if(typeof T=="function"){if(!d&&Array.isArray(K))for(let G=0;G<K.length;G++)K[G]=(0,v.$fi)(K[G]);let M=T.apply(te,K);return M instanceof Promise||(M=Promise.resolve(M)),M}throw new _.$db(`Method not found: ${U}`)}}}X.fromService=F;function J(W,ce){const de=ce&&ce.disableMarshalling;return new Proxy({},{get(te,d){if(typeof d=="string")return ce?.properties?.has(d)?ce.properties.get(d):le(d)?function(H){return W.listen(d,H)}:ee(d)?W.listen(d):async function(...H){let oe;ce&&!(0,f.$qg)(ce.context)?oe=[ce.context,...H]:oe=H;const U=await W.call(d,oe);return de?U:(0,v.$fi)(U)};throw new _.$db(`Property not found: ${String(d)}`)}})}X.toService=J;function ee(W){return W[0]==="o"&&W[1]==="n"&&b.$Hf(W.charCodeAt(2))}function le(W){return/^onDynamic/.test(W)&&b.$Hf(W.charCodeAt(9))}})(C||(e.ProxyChannel=C={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const F=X.toString();if(F!=="[object Object]")return F}return X}function Z(X){return Array.isArray(X)?X.map(V):V(X)}function re(X,F,J,ee,le,W,ce){ce=Z(ce);const de=Q[le],te=de[ee%de.length];let d=[`%c[${X}]%c[${String(F).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test(W)?(d=d.concat(ce),d.push(")")):d.push(ce),console.log.apply(console,d)}class ae{constructor(F,J){this.d=F,this.f=J,this.a=0,this.b=0}logOutgoing(F,J,ee,le,W){this.b+=F,re(this.d,this.b,F,J,ee,le,W)}logIncoming(F,J,ee,le,W){this.a+=F,re(this.f,this.a,F,J,ee,le,W)}}e.$ri=ae}),define(he[63],fe([0,1,29,11,19,18,56,7,4,2,33,36,32,30]),function(ie,e,o,t,A,m,j,_,$,r,v,b,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0,_=Se(_);class c extends l.$ki{constructor(a){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",s=>A.$Qe.wrap(Buffer.from(s,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$mr=c;class u{constructor(a,s){this.i=a,this.j=s,this.c=new Set,this.g=new Map,this.h=new $.$oe,this.onDidProcessExit=this.h.event;const p=s&&s.timeout?s.timeout:6e4;this.b=new t.$Fh(p),this.d=null,this.f=null}getChannel(a){const s=this;return{call(p,E,S){return s.k(a,p,E,S)},listen(p,E){return s.l(a,p,E)}}}k(a,s,p,E=m.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(_.$8());this.b.cancel();const S=this.n(a),i=(0,t.$vh)(R=>S.call(s,p,R)),n=E.onCancellationRequested(()=>i.cancel()),g=(0,r.$Vc)(()=>i.cancel());return this.c.add(g),i.finally(()=>{n.dispose(),this.c.delete(g),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(a,s,p){if(!this.b)return $.Event.None;this.b.cancel();let E;const S=new $.$oe({onWillAddFirstListener:()=>{E=this.n(a).listen(s,p)(S.fire,S),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,v.$ho)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(w=>!/^--inspect(-brk)?=/.test(w)).filter(w=>!w.startsWith("--vscode-"))),(0,f.$pm)(s.env),this.d=(0,o.fork)(this.i,a,s);const p=new $.$oe,S=$.Event.fromNodeEventEmitter(this.d,"message",w=>w)(w=>{if((0,j.$ir)(w)){(0,j.log)(w,`IPC Library: ${this.j.serverName}`);return}p.fire(A.$Qe.wrap(Buffer.from(w,"base64")))}),i=this.j.useQueue?(0,b.$Cm)(this.d):this.d,n=w=>this.d&&this.d.connected&&i.send(w.buffer.toString("base64")),g=p.event,R={send:n,onMessage:g};this.f=new l.$li(R);const q=()=>this.o();process.once("exit",q),this.d.on("error",w=>console.warn('IPC "'+this.j.serverName+'" errored with '+w)),this.d.on("exit",(w,L)=>{process.removeListener("exit",q),S.dispose(),this.c.forEach(k=>(0,r.$Sc)(k)),this.c.clear(),w!==0&&L!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+w+" and signal "+L),this.b?.cancel(),this.o(),this.h.fire({code:w,signal:L})})}return this.f}n(a){let s=this.g.get(a);return s||(s=this.m.getChannel(a),this.g.set(a,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$nr=u}),define(he[37],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rY=o;function o(t){return!!t.parentPort}}),define(he[64],fe([0,1,37,19,30,4,9,17]),function(ie,e,o,t,A,m,j,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sY=void 0,e.$tY=v;class ${constructor(f){this.a=f,this.onMessage=m.Event.fromNodeEventEmitter(this.a,"message",l=>l.data?t.$Qe.wrap(l.data):t.$Qe.alloc(0)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}class r extends A.$mi{static b(f){(0,j.$rg)((0,o.$rY)(process),"Electron Utility Process");const l=new m.$oe;return process.parentPort.on("message",c=>{if(f?.handledClientConnection(c))return;const u=(0,_.$Qb)(c.ports);u&&l.fire(u)}),m.Event.map(l.event,c=>({protocol:new $(c),onDidClientDisconnect:m.Event.fromNodeEventEmitter(c,"close")}))}constructor(f){super(r.b(f))}}e.$sY=r;function v(b,f,l){const c=u=>{u.data===f&&(b.removeListener("message",c),l())};b.on("message",c)}}),define(he[12],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=A,e.localize2=j;const o=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(_,$){let r;return $.length===0?r=_:r=_.replace(/\{(\d+)\}/g,(v,b)=>{const f=b[0],l=$[f];let c=v;return typeof l=="string"?c=l:(typeof l=="number"||typeof l=="boolean"||l===void 0||l===null)&&(c=String(l)),c}),o&&(r="\uFF3B"+r.replace(/[aouei]/g,"$&$&")+"\uFF3D"),r}function A(_,$,...r){return t(typeof _=="number"?m(_,$):$,r)}function m(_,$){const r=globalThis._VSCODE_NLS_MESSAGES?.[_];if(typeof r!="string"){if(typeof $=="string")return $;throw new Error(`!!! NLS MISSING: ${_} !!!`)}return r}function j(_,$,...r){let v;typeof _=="number"?v=m(_,$):v=$;const b=t(v,r);return{value:b,original:$===v?b:t($,r)}}}),define(he[65],fe([0,1,12]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=r,e.$6m=v,e.$7m=b;const t=60,A=t*60,m=A*24,j=m*7,_=m*30,$=m*365;function r(f,l,c,u){typeof f!="number"&&(f=f.getTime());const h=Math.round((new Date().getTime()-f)/1e3);if(h<-30)return(0,o.localize)(42,null,r(new Date().getTime()+h*1e3,!1));if(!u&&h<30)return(0,o.localize)(43,null);let a;return h<t?(a=h,l?a===1?c?(0,o.localize)(44,null,a):(0,o.localize)(45,null,a):c?(0,o.localize)(46,null,a):(0,o.localize)(47,null,a):a===1?c?(0,o.localize)(48,null,a):(0,o.localize)(49,null,a):c?(0,o.localize)(50,null,a):(0,o.localize)(51,null,a)):h<A?(a=Math.floor(h/t),l?a===1?c?(0,o.localize)(52,null,a):(0,o.localize)(53,null,a):c?(0,o.localize)(54,null,a):(0,o.localize)(55,null,a):a===1?c?(0,o.localize)(56,null,a):(0,o.localize)(57,null,a):c?(0,o.localize)(58,null,a):(0,o.localize)(59,null,a)):h<m?(a=Math.floor(h/A),l?a===1?c?(0,o.localize)(60,null,a):(0,o.localize)(61,null,a):c?(0,o.localize)(62,null,a):(0,o.localize)(63,null,a):a===1?c?(0,o.localize)(64,null,a):(0,o.localize)(65,null,a):c?(0,o.localize)(66,null,a):(0,o.localize)(67,null,a)):h<j?(a=Math.floor(h/m),l?a===1?(0,o.localize)(68,null,a):(0,o.localize)(69,null,a):a===1?(0,o.localize)(70,null,a):(0,o.localize)(71,null,a)):h<_?(a=Math.floor(h/j),l?a===1?c?(0,o.localize)(72,null,a):(0,o.localize)(73,null,a):c?(0,o.localize)(74,null,a):(0,o.localize)(75,null,a):a===1?c?(0,o.localize)(76,null,a):(0,o.localize)(77,null,a):c?(0,o.localize)(78,null,a):(0,o.localize)(79,null,a)):h<$?(a=Math.floor(h/_),l?a===1?c?(0,o.localize)(80,null,a):(0,o.localize)(81,null,a):c?(0,o.localize)(82,null,a):(0,o.localize)(83,null,a):a===1?c?(0,o.localize)(84,null,a):(0,o.localize)(85,null,a):c?(0,o.localize)(86,null,a):(0,o.localize)(87,null,a)):(a=Math.floor(h/$),l?a===1?c?(0,o.localize)(88,null,a):(0,o.localize)(89,null,a):c?(0,o.localize)(90,null,a):(0,o.localize)(91,null,a):a===1?c?(0,o.localize)(92,null,a):(0,o.localize)(93,null,a):c?(0,o.localize)(94,null,a):(0,o.localize)(95,null,a))}function v(f,l){const c=Math.abs(f/1e3);return c<1?l?(0,o.localize)(96,null,f):(0,o.localize)(97,null,f):c<t?l?(0,o.localize)(98,null,Math.round(f)/1e3):(0,o.localize)(99,null,Math.round(f)/1e3):c<A?l?(0,o.localize)(100,null,Math.round(f/(1e3*t))):(0,o.localize)(101,null,Math.round(f/(1e3*t))):c<m?l?(0,o.localize)(102,null,Math.round(f/(1e3*A))):(0,o.localize)(103,null,Math.round(f/(1e3*A))):(0,o.localize)(104,null,Math.round(f/(1e3*m)))}function b(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[66],fe([0,1,17,9,12]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=$,e.$uj=r,e.$vj=v,o=Se(o),t=Se(t),A=Se(A);function m(b,f){return f&&(b.stack||b.stacktrace)?A.localize(105,null,_(b),j(b.stack)||j(b.stacktrace)):_(b)}function j(b){return Array.isArray(b)?b.join(`
`):b}function _(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?A.localize(106,null,b.message):b.message||A.localize(107,null)}function $(b=null,f=!1){if(!b)return A.localize(108,null);if(Array.isArray(b)){const l=o.$Jb(b),c=$(l[0],f);return l.length>1?A.localize(109,null,c,l.length):c}if(t.$hg(b))return b;if(b.detail){const l=b.detail;if(l.error)return m(l.error,f);if(l.exception)return m(l.exception,f)}return b.stack?m(b,f):b.message?b.message:A.localize(110,null)}function r(b){const f=b;return f instanceof Error&&Array.isArray(f.actions)}function v(b,f){let l;return typeof b=="string"?l=new Error(b):l=b,l.actions=f,l}}),define(he[67],fe([0,1,13,7,12]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var m;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(m||(e.TokenType=m={}));function j(...v){switch(v.length){case 1:return(0,A.localize)(1691,null,v[0]);case 2:return(0,A.localize)(1692,null,v[0],v[1]);case 3:return(0,A.localize)(1693,null,v[0],v[1],v[2]);default:return}}const _=(0,A.localize)(1694,null),$=(0,A.localize)(1695,null);class r{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case m.LParen:return"(";case m.RParen:return")";case m.Neg:return"!";case m.Eq:return b.isTripleEq?"===":"==";case m.NotEq:return b.isTripleEq?"!==":"!=";case m.Lt:return"<";case m.LtEq:return"<=";case m.Gt:return">=";case m.GtEq:return">=";case m.RegexOp:return"=~";case m.RegexStr:return b.lexeme;case m.True:return"true";case m.False:return"false";case m.In:return"in";case m.Not:return"not";case m.And:return"&&";case m.Or:return"||";case m.Str:return b.lexeme;case m.QuotedStr:return b.lexeme;case m.Error:return b.lexeme;case m.EOF:return"EOF";default:throw(0,t.$0)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",m.Not],["in",m.In],["false",m.False],["true",m.True]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case o.CharCode.OpenParen:this.k(m.LParen);break;case o.CharCode.CloseParen:this.k(m.RParen);break;case o.CharCode.ExclamationMark:if(this.h(o.CharCode.Equals)){const f=this.h(o.CharCode.Equals);this.f.push({type:m.NotEq,offset:this.d,isTripleEq:f})}else this.k(m.Neg);break;case o.CharCode.SingleQuote:this.o();break;case o.CharCode.Slash:this.q();break;case o.CharCode.Equals:if(this.h(o.CharCode.Equals)){const f=this.h(o.CharCode.Equals);this.f.push({type:m.Eq,offset:this.d,isTripleEq:f})}else this.h(o.CharCode.Tilde)?this.k(m.RegexOp):this.l(j("==","=~"));break;case o.CharCode.LessThan:this.k(this.h(o.CharCode.Equals)?m.LtEq:m.Lt);break;case o.CharCode.GreaterThan:this.k(this.h(o.CharCode.Equals)?m.GtEq:m.Gt);break;case o.CharCode.Ampersand:this.h(o.CharCode.Ampersand)?this.k(m.And):this.l(j("&&"));break;case o.CharCode.Pipe:this.h(o.CharCode.Pipe)?this.k(m.Or):this.l(j("||"));break;case o.CharCode.Space:case o.CharCode.CarriageReturn:case o.CharCode.Tab:case o.CharCode.LineFeed:case o.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(m.EOF),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?o.CharCode.Null:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const f=this.d,l=this.c.substring(this.d,this.e),c={type:m.Error,offset:this.d,lexeme:l};this.g.push({offset:f,lexeme:l,additionalInfo:b}),this.f.push(c)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const f=this.c.substring(this.d,this.e),l=r.b.get(f);l?this.k(l):this.f.push({type:m.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==o.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(_);return}this.i(),this.f.push({type:m.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,f=!1,l=!1;for(;;){if(b>=this.c.length){this.e=b,this.l($);return}const u=this.c.charCodeAt(b);if(f)f=!1;else if(u===o.CharCode.Slash&&!l){b++;break}else u===o.CharCode.OpenSquareBracket?l=!0:u===o.CharCode.Backslash?f=!0:u===o.CharCode.CloseSquareBracket&&(l=!1);b++}for(;b<this.c.length&&r.a.has(this.c.charCodeAt(b));)b++;this.e=b;const c=this.c.substring(this.d,this.e);this.f.push({type:m.RegexStr,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=r}),define(he[68],fe([0,1,65,14,20,5,15,25,6]),function(ie,e,o,t,A,m,j,_,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=void 0,e.$0m=v,e.$$m=b,e.$8m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,m.$pc)(A.$3g.asFileUri("").fsPath)}get userHome(){return $.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return $.URI.file((0,m.$mc)(this.userDataPath,"User"))}get tmpDir(){return $.URI.file(this.b.tmpDir)}get cacheHome(){return $.URI.file(this.userDataPath)}get stateResource(){return(0,_.$jh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,_.$jh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,o.$7m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.$mc)(this.userDataPath,"logs",l)}return $.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,_.$jh)($.URI.file((0,m.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,_.$jh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,_.$jh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,_.$jh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=j.env.VSCODE_PORTABLE;return l?$.URI.file((0,m.$mc)(l,"argv.json")):(0,_.$jh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return $.URI.file((0,m.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,m.$nc)(l):(0,m.$kc)((0,m.$mc)(A.$3g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?$.URI.file((0,m.$nc)(l)):$.URI.file((0,m.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,m.$nc)(l);const c=j.env.VSCODE_EXTENSIONS;if(c)return c;const u=j.env.VSCODE_PORTABLE;return u?(0,m.$mc)(u,"extensions"):(0,_.$jh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(c=>/^[^:/?#]+?:\/\//.test(c)?$.URI.parse(c):$.URI.file((0,m.$kc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?$.URI.parse(l):$.URI.file((0,m.$kc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$8m.test(l))}get extensionLogLevel(){const l=[];for(const c of this.args.log||[]){const u=e.$8m.exec(c);u&&u[1]&&u[2]&&l.push([u[1],u[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,_.$jh)($.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=j.env.VSCODE_PORTABLE;return l?$.URI.file((0,m.$mc)(l,"policy.json")):(0,_.$jh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,c,u){this.a=l,this.b=c,this.c=u,this.editSessionId=this.args.editSessionId}}e.$9m=r,me([t.$ai],r.prototype,"appRoot",null),me([t.$ai],r.prototype,"userHome",null),me([t.$ai],r.prototype,"userDataPath",null),me([t.$ai],r.prototype,"appSettingsHome",null),me([t.$ai],r.prototype,"tmpDir",null),me([t.$ai],r.prototype,"cacheHome",null),me([t.$ai],r.prototype,"stateResource",null),me([t.$ai],r.prototype,"userRoamingDataHome",null),me([t.$ai],r.prototype,"userDataSyncHome",null),me([t.$ai],r.prototype,"sync",null),me([t.$ai],r.prototype,"machineSettingsResource",null),me([t.$ai],r.prototype,"workspaceStorageHome",null),me([t.$ai],r.prototype,"localHistoryHome",null),me([t.$ai],r.prototype,"keyboardLayoutResource",null),me([t.$ai],r.prototype,"argvResource",null),me([t.$ai],r.prototype,"isExtensionDevelopment",null),me([t.$ai],r.prototype,"untitledWorkspacesHome",null),me([t.$ai],r.prototype,"builtinExtensionsPath",null),me([t.$ai],r.prototype,"extensionsPath",null),me([t.$ai],r.prototype,"extensionDevelopmentLocationURI",null),me([t.$ai],r.prototype,"extensionDevelopmentKind",null),me([t.$ai],r.prototype,"extensionTestsLocationURI",null),me([t.$ai],r.prototype,"debugExtensionHost",null),me([t.$ai],r.prototype,"logLevel",null),me([t.$ai],r.prototype,"extensionLogLevel",null),me([t.$ai],r.prototype,"serviceMachineIdResource",null),me([t.$ai],r.prototype,"disableTelemetry",null),me([t.$ai],r.prototype,"disableWorkspaceTrust",null),me([t.$ai],r.prototype,"useInMemorySecretStorage",null),me([t.$ai],r.prototype,"policyFile",null);function v(f,l){return b(f["inspect-extensions"],f["inspect-brk-extensions"],5870,l,f.debugId,f.extensionEnvironment)}function b(f,l,c,u,h,a){const p=Number(l||f)||(u?null:c),E=p?!!l:!1;let S;if(a)try{S=JSON.parse(a)}catch{}return{port:p,break:E,debugId:h,env:S}}});var Ke=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[69],fe([0,1,101,3,12]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=void 0,e.$Gm=_,e.$Hm=r,e.$Im=l,e.$Jm=c,o=Ke(o);const m={o:(0,A.localize)(1711,null),e:(0,A.localize)(1712,null),t:(0,A.localize)(1713,null)};e.$Em=["tunnel","serve-web"],e.$Fm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,A.localize)(1714,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,A.localize)(1715,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,A.localize)(1716,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,A.localize)(1717,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,A.localize)(1718,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,A.localize)(1719,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,A.localize)(1720,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,A.localize)(1721,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,A.localize)(1722,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,A.localize)(1723,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,A.localize)(1724,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,A.localize)(1725,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,A.localize)(1726,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,A.localize)(1727,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(1728,null)},"show-versions":{type:"boolean",cat:"e",description:(0,A.localize)(1729,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,A.localize)(1730,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,A.localize)(1731,null)},"pre-release":{type:"boolean",cat:"e",description:(0,A.localize)(1732,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,A.localize)(1733,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(1734,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,A.localize)(1735,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,A.localize)(1736,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,A.localize)(1737,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,A.localize)(1738,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,A.localize)(1739,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,A.localize)(1740,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,A.localize)(1741,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,A.localize)(1742,null)},sync:{type:"string",cat:"t",description:(0,A.localize)(1743,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,A.localize)(1744,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,A.localize)(1745,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,A.localize)(1746,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,A.localize)(1747,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,A.localize)(1748,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,A.localize)(1749,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function _(u,h,a=j){const s=u.find(w=>w.length>0&&w[0]!=="-"),p={},E=["_"],S=[],i={};let n;for(const w in h){const L=h[w];L.type==="subcommand"?w===s&&(n=L):(L.alias&&(p[w]=L.alias),L.type==="string"||L.type==="string[]"?(E.push(w),L.deprecates&&E.push(...L.deprecates)):L.type==="boolean"&&(S.push(w),L.deprecates&&S.push(...L.deprecates)),L.global&&(i[w]=L))}if(n&&s){const w=i;for(const z in n.options)w[z]=n.options[z];const L=u.filter(z=>z!==s),k=a.getSubcommandReporter?a.getSubcommandReporter(s):void 0,O=_(L,w,k);return{[s]:O,_:[]}}const g=(0,o.default)(u,{string:E,boolean:S,alias:p}),R={},q=g;R._=g._.map(w=>String(w)).filter(w=>w.length>0),delete q._;for(const w in h){const L=h[w];if(L.type==="subcommand")continue;L.alias&&delete q[L.alias];let k=q[w];if(L.deprecates)for(const O of L.deprecates)q.hasOwnProperty(O)&&(k||(k=q[O],k&&a.onDeprecatedOption(O,L.deprecationMessage||(0,A.localize)(1750,null,w))),delete q[O]);if(typeof k<"u"){if(L.type==="string[]"){if(Array.isArray(k)||(k=[k]),!L.allowEmptyValue){const O=k.filter(z=>z.length>0);O.length!==k.length&&(a.onEmptyValue(w),k=O.length>0?O:void 0)}}else L.type==="string"&&(Array.isArray(k)?(k=k.pop(),a.onMultipleValues(w,k)):!k&&!L.allowEmptyValue&&(a.onEmptyValue(w),k=void 0));R[w]=k,L.deprecationMessage&&a.onDeprecatedOption(w,L.deprecationMessage)}delete q[w]}for(const w in q)a.onUnknownOption(w);return R}function $(u,h){let a="";return h.args&&(Array.isArray(h.args)?a=` <${h.args.join("> <")}>`:a=` <${h.args}>`),h.alias?`-${h.alias} --${u}${a}`:`--${u}${a}`}function r(u,h){const a=[];for(const s in u){const p=u[s],E=$(s,p);a.push([E,p.description])}return v(a,h)}function v(u,h){const s=u.reduce((S,i)=>Math.max(S,i[0].length),12)+2+1;if(h-s<25)return u.reduce((S,i)=>S.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const p=h-s-1,E=[];for(const S of u){const i=S[0],n=f(S[1],p),g=b(s-i.length-2);E.push("  "+i+g+n[0]);for(let R=1;R<n.length;R++)E.push(b(s)+n[R])}return E}function b(u){return" ".repeat(u)}function f(u,h){const a=[];for(;u.length;){const s=u.length<h?u.length:u.lastIndexOf(" ",h),p=u.slice(0,s).trim();u=u.slice(s),a.push(p)}return a}function l(u,h,a,s,p){const E=process.stdout.isTTY&&process.stdout.columns||80,S=p?.noInputFiles!==!0?`[${(0,A.localize)(1751,null)}...]`:"",i=[`${u} ${a}`];i.push(""),i.push(`${(0,A.localize)(1752,null)}: ${h} [${(0,A.localize)(1753,null)}]${S}`),i.push(""),p?.noPipe!==!0&&(t.$j?i.push((0,A.localize)(1754,null,h)):i.push((0,A.localize)(1755,null,h)),i.push(""));const n={},g=[];for(const R in s){const q=s[R];if(q.type==="subcommand")q.description&&g.push({command:R,description:q.description});else if(q.description&&q.cat){let w=n[q.cat];w||(n[q.cat]=w={}),w[R]=q}}for(const R in n){const q=R,w=n[q];w&&(i.push(m[q]),i.push(...r(w,E)),i.push(""))}return g.length&&(i.push((0,A.localize)(1756,null)),i.push(...v(g.map(R=>[R.command,R.description]),E)),i.push("")),i.join(`
`)}function c(u,h){return`${u||(0,A.localize)(1757,null)}
${h||(0,A.localize)(1758,null)}
${process.arch}`}}),function(){function ie(e,o,t){function A(j,_){const $=m(j,_),r=[$];return e.isAbsolute($)||r.unshift(t),e.resolve(...r)}function m(j,_){process.env.VSCODE_DEV&&(_="code-oss-dev");const $=process.env.VSCODE_PORTABLE;if($)return e.join($,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,_);const v=j["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(b,"AppData","Roaming")}break;case"darwin":r=e.join(o.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(o.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,_)}return{getUserDataPath:A}}if(typeof define=="function")define(he[70],fe([71,21,15]),function(e,o,t){return ie(e,o,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),o=require("os");module.exports=ie(e,o,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[72],fe([0,1,21,68,70]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0,e.$an=j,e.$bn=_;class m extends t.$9m{constructor(r,v){super(r,{homeDir:(0,o.homedir)(),tmpDir:(0,o.tmpdir)(),userDataDir:(0,A.getUserDataPath)(r,v.nameShort)},v)}}e.$_m=m;function j($,r){return(0,t.$$m)($["inspect-ptyhost"],$["inspect-brk-ptyhost"],5877,r,$.extensionEnvironment)}function _($,r){return(0,t.$$m)($["inspect-sharedprocess"],$["inspect-brk-sharedprocess"],5879,r,$.extensionEnvironment)}}),define(he[22],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=A,e.$Ji=m;var o;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function _($){return $[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=_})(o||(e._util=o={})),e.$Hi=A("instantiationService");function t(j,_,$){_[o.DI_TARGET]===_?_[o.DI_DEPENDENCIES].push({id:j,index:$}):(_[o.DI_DEPENDENCIES]=[{id:j,index:$}],_[o.DI_TARGET]=_)}function A(j){if(o.serviceIds.has(j))return o.serviceIds.get(j);const _=function($,r,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(_,$,v)};return _.toString=()=>j,o.serviceIds.set(j,_),_}function m(j){return j}}),define(he[38],fe([0,1,13,3,10,67,22,12,7]),function(ie,e,o,t,A,m,j,_,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=v,e.$Hj=g,e.$Ij=R,e.$2j=W;const r=new Map;r.set("false",!1),r.set("true",!0),r.set("isMac",t.$k),r.set("isLinux",t.$l),r.set("isWindows",t.$j),r.set("isWeb",t.$p),r.set("isMacNative",t.$k&&!t.$p),r.set("isEdge",t.$I),r.set("isFirefox",t.$G),r.set("isChrome",t.$F),r.set("isSafari",t.$H);function v(te,d){if(r.get(te)!==void 0)throw(0,$.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");r.set(te,d)}const b=Object.prototype.hasOwnProperty;var f;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const l={regexParsingWithErrorRecovery:!0},c=(0,_.localize)(1671,null),u=(0,_.localize)(1672,null),h=(0,_.localize)(1673,null),a=(0,_.localize)(1674,null),s=(0,_.localize)(1675,null),p=(0,_.localize)(1676,null),E=(0,_.localize)(1677,null),S=(0,_.localize)(1678,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=l){this.k=d,this.d=new m.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:u});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const H=this.l();if(!this.E()){const oe=this.D(),U=oe.type===m.TokenType.Str?p:void 0;throw this.h.push({message:s,offset:oe.offset,lexeme:m.$Dj.getLexeme(oe),additionalInfo:U}),i.c}return H}catch(H){if(H!==i.c)throw H;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(m.TokenType.Or);){const H=this.o();d.push(H)}return d.length===1?d[0]:n.or(...d)}o(){const d=[this.s()];for(;this.y(m.TokenType.And);){const H=this.s();d.push(H)}return d.length===1?d[0]:n.and(...d)}s(){if(this.y(m.TokenType.Neg)){const d=this.D();switch(d.type){case m.TokenType.True:return this.z(),w.INSTANCE;case m.TokenType.False:return this.z(),L.INSTANCE;case m.TokenType.LParen:{this.z();const H=this.l();return this.A(m.TokenType.RParen,a),H?.negate()}case m.TokenType.Str:return this.z(),N.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case m.TokenType.True:return this.z(),n.true();case m.TokenType.False:return this.z(),n.false();case m.TokenType.LParen:{this.z();const H=this.l();return this.A(m.TokenType.RParen,a),H}case m.TokenType.Str:{const H=d.lexeme;if(this.z(),this.y(m.TokenType.RegexOp)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==m.TokenType.RegexStr)throw this.B("REGEX",U);const K=U.lexeme,T=K.lastIndexOf("/"),M=T===K.length-1?void 0:this.w(K.substring(T+1));let G;try{G=new RegExp(K.substring(1,T),M)}catch{throw this.B("REGEX",U)}return Z.create(H,G)}switch(U.type){case m.TokenType.RegexStr:case m.TokenType.Error:{const K=[U.lexeme];this.z();let T=this.D(),M=0;for(let ve=0;ve<U.lexeme.length;ve++)U.lexeme.charCodeAt(ve)===o.CharCode.OpenParen?M++:U.lexeme.charCodeAt(ve)===o.CharCode.CloseParen&&M--;for(;!this.E()&&T.type!==m.TokenType.And&&T.type!==m.TokenType.Or;){switch(T.type){case m.TokenType.LParen:M++;break;case m.TokenType.RParen:M--;break;case m.TokenType.RegexStr:case m.TokenType.QuotedStr:for(let ve=0;ve<T.lexeme.length;ve++)T.lexeme.charCodeAt(ve)===o.CharCode.OpenParen?M++:U.lexeme.charCodeAt(ve)===o.CharCode.CloseParen&&M--}if(M<0)break;K.push(m.$Dj.getLexeme(T)),this.z(),T=this.D()}const G=K.join(""),x=G.lastIndexOf("/"),ne=x===G.length-1?void 0:this.w(G.substring(x+1));let $e;try{$e=new RegExp(G.substring(1,x),ne)}catch{throw this.B("REGEX",U)}return n.regex(H,$e)}case m.TokenType.QuotedStr:{const K=U.lexeme;this.z();let T=null;if(!(0,A.$ff)(K)){const M=K.indexOf("/"),G=K.lastIndexOf("/");if(M!==G&&M>=0){const x=K.slice(M+1,G),ne=K[G+1]==="i"?"i":"";try{T=new RegExp(x,ne)}catch{throw this.B("REGEX",U)}}}if(T===null)throw this.B("REGEX",U);return Z.create(H,T)}default:throw this.B("REGEX",this.D())}}if(this.y(m.TokenType.Not)){this.A(m.TokenType.In,h);const U=this.u();return n.notIn(H,U)}switch(this.D().type){case m.TokenType.Eq:{this.z();const U=this.u();if(this.x().type===m.TokenType.QuotedStr)return n.equals(H,U);switch(U){case"true":return n.has(H);case"false":return n.not(H);default:return n.equals(H,U)}}case m.TokenType.NotEq:{this.z();const U=this.u();if(this.x().type===m.TokenType.QuotedStr)return n.notEquals(H,U);switch(U){case"true":return n.not(H);case"false":return n.has(H);default:return n.notEquals(H,U)}}case m.TokenType.Lt:return this.z(),Q.create(H,this.u());case m.TokenType.LtEq:return this.z(),V.create(H,this.u());case m.TokenType.Gt:return this.z(),P.create(H,this.u());case m.TokenType.GtEq:return this.z(),C.create(H,this.u());case m.TokenType.In:return this.z(),n.in(H,this.u());default:return n.has(H)}}case m.TokenType.EOF:throw this.h.push({message:E,offset:d.offset,lexeme:"",additionalInfo:S}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case m.TokenType.Str:case m.TokenType.QuotedStr:return this.z(),d.lexeme;case m.TokenType.True:return this.z(),"true";case m.TokenType.False:return this.z(),"false";case m.TokenType.In:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,H){if(this.C(d))return this.z();throw this.B(H,this.D())}B(d,H,oe){const U=(0,_.localize)(1679,null,d,m.$Dj.getLexeme(H)),K=H.offset,T=m.$Dj.getLexeme(H);return this.h.push({message:U,offset:K,lexeme:T,additionalInfo:oe}),i.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===m.TokenType.EOF}}e.$Fj=i;class n{static false(){return w.INSTANCE}static true(){return L.INSTANCE}static has(d){return k.create(d)}static equals(d,H){return O.create(d,H)}static notEquals(d,H){return y.create(d,H)}static regex(d,H){return Z.create(d,H)}static in(d,H){return z.create(d,H)}static notIn(d,H){return D.create(d,H)}static not(d){return N.create(d)}static and(...d){return X.create(d,null,!0)}static or(...d){return F.create(d,null,!0)}static greater(d,H){return P.create(d,H)}static greaterEquals(d,H){return C.create(d,H)}static smaller(d,H){return Q.create(d,H)}static smallerEquals(d,H){return V.create(d,H)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$Gj=n;function g(te){const d=new i({regexParsingWithErrorRecovery:!1});return te.map(H=>(d.parse(H),d.lexingErrors.length>0?d.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,_.localize)(1680,null,oe.additionalInfo):(0,_.localize)(1681,null),offset:oe.offset,length:oe.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function R(te,d){const H=te?te.substituteConstants():void 0,oe=d?d.substituteConstants():void 0;return!H&&!oe?!0:!H||!oe?!1:H.equals(oe)}function q(te,d){return te.cmp(d)}class w{static{this.INSTANCE=new w}constructor(){this.type=f.False}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return L.INSTANCE}}e.$Jj=w;class L{static{this.INSTANCE=new L}constructor(){this.type=f.True}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return w.INSTANCE}}e.$Kj=L;class k{static create(d,H=null){const oe=r.get(d);return typeof oe=="boolean"?oe?L.INSTANCE:w.INSTANCE:new k(d,H)}constructor(d,H){this.key=d,this.c=H,this.type=f.Defined}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=r.get(this.key);return typeof d=="boolean"?d?L.INSTANCE:w.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Lj=k;class O{static create(d,H,oe=null){if(typeof H=="boolean")return H?k.create(d,oe):N.create(d,oe);const U=r.get(d);return typeof U=="boolean"?H===(U?"true":"false")?L.INSTANCE:w.INSTANCE:new O(d,H,oe)}constructor(d,H,oe){this.c=d,this.d=H,this.f=oe,this.type=f.Equals}cmp(d){return d.type!==this.type?this.type-d.type:le(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=r.get(this.c);if(typeof d=="boolean"){const H=d?"true":"false";return this.d===H?L.INSTANCE:w.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Mj=O;class z{static create(d,H){return new z(d,H)}constructor(d,H){this.d=d,this.f=H,this.type=f.In,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:le(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const H=d.getValue(this.f),oe=d.getValue(this.d);return Array.isArray(H)?H.includes(oe):typeof oe=="string"&&typeof H=="object"&&H!==null?b.call(H,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Nj=z;class D{static create(d,H){return new D(d,H)}constructor(d,H){this.d=d,this.f=H,this.type=f.NotIn,this.c=z.create(d,H)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=D;class y{static create(d,H,oe=null){if(typeof H=="boolean")return H?N.create(d,oe):k.create(d,oe);const U=r.get(d);return typeof U=="boolean"?H===(U?"true":"false")?w.INSTANCE:L.INSTANCE:new y(d,H,oe)}constructor(d,H,oe){this.c=d,this.d=H,this.f=oe,this.type=f.NotEquals}cmp(d){return d.type!==this.type?this.type-d.type:le(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=r.get(this.c);if(typeof d=="boolean"){const H=d?"true":"false";return this.d===H?w.INSTANCE:L.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Pj=y;class N{static create(d,H=null){const oe=r.get(d);return typeof oe=="boolean"?oe?w.INSTANCE:L.INSTANCE:new N(d,H)}constructor(d,H){this.c=d,this.d=H,this.type=f.Not}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=r.get(this.c);return typeof d=="boolean"?d?w.INSTANCE:L.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Qj=N;function I(te,d){if(typeof te=="string"){const H=parseFloat(te);isNaN(H)||(te=H)}return typeof te=="string"||typeof te=="number"?d(te):w.INSTANCE}class P{static create(d,H,oe=null){return I(H,U=>new P(d,U,oe))}constructor(d,H,oe){this.c=d,this.d=H,this.f=oe,this.type=f.Greater}cmp(d){return d.type!==this.type?this.type-d.type:le(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Rj=P;class C{static create(d,H,oe=null){return I(H,U=>new C(d,U,oe))}constructor(d,H,oe){this.c=d,this.d=H,this.f=oe,this.type=f.GreaterEquals}cmp(d){return d.type!==this.type?this.type-d.type:le(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Sj=C;class Q{static create(d,H,oe=null){return I(H,U=>new Q(d,U,oe))}constructor(d,H,oe){this.c=d,this.d=H,this.f=oe,this.type=f.Smaller}cmp(d){return d.type!==this.type?this.type-d.type:le(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Tj=Q;class V{static create(d,H,oe=null){return I(H,U=>new V(d,U,oe))}constructor(d,H,oe){this.c=d,this.d=H,this.f=oe,this.type=f.SmallerEquals}cmp(d){return d.type!==this.type?this.type-d.type:le(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Uj=V;class Z{static create(d,H){return new Z(d,H)}constructor(d,H){this.d=d,this.f=H,this.type=f.Regex,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const H=this.f?this.f.source:"",oe=d.f?d.f.source:"";return H<oe?-1:H>oe?1:0}equals(d){if(d.type===this.type){const H=this.f?this.f.source:"",oe=d.f?d.f.source:"";return this.d===d.d&&H===oe}return!1}substituteConstants(){return this}evaluate(d){const H=d.getValue(this.d);return this.f?this.f.test(H):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$Vj=Z;class re{static create(d){return new re(d)}constructor(d){this.c=d,this.type=f.NotRegex}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new re(this.c.map(d))}negate(){return this.c}}e.$Wj=re;function ae(te){let d=null;for(let H=0,oe=te.length;H<oe;H++){const U=te[H].substituteConstants();if(te[H]!==U&&d===null){d=[];for(let K=0;K<H;K++)d[K]=te[K]}d!==null&&(d[H]=U)}return d===null?te:d}class X{static create(d,H,oe){return X.d(d,H,oe)}constructor(d,H){this.expr=d,this.c=H,this.type=f.And}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let H=0,oe=this.expr.length;H<oe;H++){const U=q(this.expr[H],d.expr[H]);if(U!==0)return U}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let H=0,oe=this.expr.length;H<oe;H++)if(!this.expr[H].equals(d.expr[H]))return!1;return!0}return!1}substituteConstants(){const d=ae(this.expr);return d===this.expr?this:X.create(d,this.c,!1)}evaluate(d){for(let H=0,oe=this.expr.length;H<oe;H++)if(!this.expr[H].evaluate(d))return!1;return!0}static d(d,H,oe){const U=[];let K=!1;for(const T of d)if(T){if(T.type===f.True){K=!0;continue}if(T.type===f.False)return w.INSTANCE;if(T.type===f.And){U.push(...T.expr);continue}U.push(T)}if(U.length===0&&K)return L.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(q);for(let T=1;T<U.length;T++)U[T-1].equals(U[T])&&(U.splice(T,1),T--);if(U.length===1)return U[0];for(;U.length>1;){const T=U[U.length-1];if(T.type!==f.Or)break;U.pop();const M=U.pop(),G=U.length===0,x=F.create(T.expr.map(ne=>X.create([ne,M],null,oe)),null,G);x&&(U.push(x),U.sort(q))}if(U.length===1)return U[0];if(oe){for(let T=0;T<U.length;T++)for(let M=T+1;M<U.length;M++)if(U[T].negate().equals(U[M]))return w.INSTANCE;if(U.length===1)return U[0]}return new X(U,H)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const H of this.expr)d.push(...H.keys());return d}map(d){return new X(this.expr.map(H=>H.map(d)),null)}negate(){if(!this.c){const d=[];for(const H of this.expr)d.push(H.negate());this.c=F.create(d,this,!0)}return this.c}}e.$Xj=X;class F{static create(d,H,oe){return F.d(d,H,oe)}constructor(d,H){this.expr=d,this.c=H,this.type=f.Or}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let H=0,oe=this.expr.length;H<oe;H++){const U=q(this.expr[H],d.expr[H]);if(U!==0)return U}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let H=0,oe=this.expr.length;H<oe;H++)if(!this.expr[H].equals(d.expr[H]))return!1;return!0}return!1}substituteConstants(){const d=ae(this.expr);return d===this.expr?this:F.create(d,this.c,!1)}evaluate(d){for(let H=0,oe=this.expr.length;H<oe;H++)if(this.expr[H].evaluate(d))return!0;return!1}static d(d,H,oe){let U=[],K=!1;if(d){for(let T=0,M=d.length;T<M;T++){const G=d[T];if(G){if(G.type===f.False){K=!0;continue}if(G.type===f.True)return L.INSTANCE;if(G.type===f.Or){U=U.concat(G.expr);continue}U.push(G)}}if(U.length===0&&K)return w.INSTANCE;U.sort(q)}if(U.length!==0){if(U.length===1)return U[0];for(let T=1;T<U.length;T++)U[T-1].equals(U[T])&&(U.splice(T,1),T--);if(U.length===1)return U[0];if(oe){for(let T=0;T<U.length;T++)for(let M=T+1;M<U.length;M++)if(U[T].negate().equals(U[M]))return L.INSTANCE;if(U.length===1)return U[0]}return new F(U,H)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const H of this.expr)d.push(...H.keys());return d}map(d){return new F(this.expr.map(H=>H.map(d)),null)}negate(){if(!this.c){const d=[];for(const H of this.expr)d.push(H.negate());for(;d.length>1;){const H=d.shift(),oe=d.shift(),U=[];for(const K of de(H))for(const T of de(oe))U.push(X.create([K,T],null,!1));d.unshift(F.create(U,null,!1))}this.c=F.create(d,this,!0)}return this.c}}e.$Yj=F;class J extends k{static{this.d=[]}static all(){return J.d.values()}constructor(d,H,oe){super(d,null),this.f=H,typeof oe=="object"?J.d.push({...oe,key:d}):oe!==!0&&J.d.push({key:d,description:oe,type:H!=null?typeof H:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return O.create(this.key,d)}notEqualsTo(d){return y.create(this.key,d)}}e.$Zj=J,e.$1j=(0,j.$Ii)("contextKeyService");function ee(te,d){return te<d?-1:te>d?1:0}function le(te,d,H,oe){return te<H?-1:te>H?1:d<oe?-1:d>oe?1:0}function W(te,d){if(te.type===f.False||d.type===f.True)return!0;if(te.type===f.Or)return d.type===f.Or?ce(te.expr,d.expr):!1;if(d.type===f.Or){for(const H of d.expr)if(W(te,H))return!0;return!1}if(te.type===f.And){if(d.type===f.And)return ce(d.expr,te.expr);for(const H of te.expr)if(W(H,d))return!0;return!1}return te.equals(d)}function ce(te,d){let H=0,oe=0;for(;H<te.length&&oe<d.length;){const U=te[H].cmp(d[oe]);if(U<0)return!1;U===0&&H++,oe++}return H===te.length}function de(te){return te.type===f.Or?te.expr:[te]}}),define(he[73],fe([0,1,55,5,10,9,6,12,22,3,20,24]),function(ie,e,o,t,A,m,j,_,$,r,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=f,e.$fl=h,e.$gl=s,e.$hl=p,e.$il=E,e.$jl=S,e.$kl=i,e.$ll=n,e.$ml=g,e.$nl=R,e.$ol=q,e.$ql=k,e.$rl=O,e.$sl=z,e.$tl=D,e.$ul=y,e.$xl=Q,e.$Jl=F,e.$Kl=J,e.$Ml=le,e.$dl=(0,$.$Ii)("fileService");function f(W){return W.create===!0}var l;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var c;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var u;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(u||(e.FileChangeFilter=u={}));function h(W){const ce=W;return!!ce&&typeof ce.onDidChange=="function"}var a;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function s(W){return!!(W.capabilities&a.FileReadWrite)}function p(W){return!!(W.capabilities&a.FileFolderCopy)}function E(W){return!!(W.capabilities&a.FileClone)}function S(W){return!!(W.capabilities&a.FileOpenReadWriteClose)}function i(W){return!!(W.capabilities&a.FileReadStream)}function n(W){return s(W)?!!(W.capabilities&a.FileAtomicRead):!1}function g(W){return s(W)?!!(W.capabilities&a.FileAtomicWrite):!1}function R(W){return!!(W.capabilities&a.FileAtomicDelete)}function q(W){return!!(W.capabilities&a.Readonly)}var w;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class L extends Error{static create(ce,de){const te=new L(ce.toString(),de);return z(te,de),te}constructor(ce,de){super(ce),this.code=de}}e.$pl=L;function k(W,ce){return L.create(W,ce)}function O(W){return W||k((0,_.localize)(1863,null),w.Unknown)}function z(W,ce){return W.name=ce?`${ce} (FileSystemError)`:"FileSystemError",W}function D(W){if(!W)return w.Unknown;if(W instanceof L)return W.code;const ce=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ce)return w.Unknown;switch(ce[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}function y(W){if(W instanceof V)return W.fileOperationResult;switch(D(W)){case w.FileNotFound:return ae.FILE_NOT_FOUND;case w.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case w.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case w.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case w.NoPermissions:return ae.FILE_PERMISSION_DENIED;case w.FileExists:return ae.FILE_MOVE_CONFLICT;case w.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var N;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class I{constructor(ce,de,te){this.resource=ce,this.operation=de,this.target=te}isOperation(ce){return this.operation===ce}}e.$vl=I;var P;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class C{static{this.a=null}constructor(ce,de){this.c=de,this.b=void 0,this.d=new b.$W(()=>{const te=o.$Oi.forUris(()=>this.c);return te.fill(this.rawAdded.map(d=>[d,!0])),te}),this.f=new b.$W(()=>{const te=o.$Oi.forUris(()=>this.c);return te.fill(this.rawUpdated.map(d=>[d,!0])),te}),this.g=new b.$W(()=>{const te=o.$Oi.forUris(()=>this.c);return te.fill(this.rawDeleted.map(d=>[d,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ce){switch(te.type){case P.ADDED:this.rawAdded.push(te.resource);break;case P.UPDATED:this.rawUpdated.push(te.resource);break;case P.DELETED:this.rawDeleted.push(te.resource);break}this.b!==C.a&&(typeof te.cId=="number"?this.b===void 0?this.b=te.cId:this.b!==te.cId&&(this.b=C.a):this.b!==void 0&&(this.b=C.a))}}contains(ce,...de){return this.h(ce,{includeChildren:!1},...de)}affects(ce,...de){return this.h(ce,{includeChildren:!0},...de)}h(ce,de,...te){if(!ce)return!1;const d=te.length>0;return!!((!d||te.includes(P.ADDED))&&(this.d.value.get(ce)||de.includeChildren&&this.d.value.findSuperstr(ce))||(!d||te.includes(P.UPDATED))&&(this.f.value.get(ce)||de.includeChildren&&this.f.value.findSuperstr(ce))||(!d||te.includes(P.DELETED))&&(this.g.value.findSubstr(ce)||de.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$wl=C;function Q(W,ce,de){return!W||!ce||W===ce||ce.length>W.length?!1:(ce.charAt(ce.length-1)!==t.sep&&(ce+=t.sep),de?(0,A.$Jf)(W,ce):W.indexOf(ce)===0)}class V extends Error{constructor(ce,de,te){super(ce),this.fileOperationResult=de,this.options=te}}e.$yl=V;class Z extends V{constructor(ce,de,te,d){super(ce,de,d),this.fileOperationResult=de,this.size=te}}e.$zl=Z;class re extends V{constructor(ce,de,te){super(ce,ae.FILE_NOT_MODIFIED_SINCE,te),this.stat=de}}e.$Al=re;var ae;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var X;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$Il="";function F(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function J(W,ce){if(!ce.hasProvider(j.URI.from({scheme:W.scheme})))return new Promise(de=>{const te=ce.onDidChangeFileSystemProviderRegistrations(d=>{d.scheme===W.scheme&&d.added&&(te.dispose(),de())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ce){return(0,m.$lg)(ce)||(ce=0),ce<ee.KB?(0,_.localize)(1864,null,ce.toFixed(0)):ce<ee.MB?(0,_.localize)(1865,null,(ce/ee.KB).toFixed(2)):ce<ee.GB?(0,_.localize)(1866,null,(ce/ee.MB).toFixed(2)):ce<ee.TB?(0,_.localize)(1867,null,(ce/ee.GB).toFixed(2)):(0,_.localize)(1868,null,(ce/ee.TB).toFixed(2))}}e.$Ll=ee;function le(W){const ce=typeof W=="string"||W?.scheme===v.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===v.Schemas.file?1024*ee.MB:ce?10*ee.MB:r.$p?50*ee.MB:1024*ee.MB}}),define(he[8],fe([0,1,12,66,4,54,2,26,3,25,9,6,38,22]),function(ie,e,o,t,A,m,j,_,$,r,v,b,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=u,e.log=a,e.$rk=L,e.$sk=k,e.$tk=O,e.$uk=z,o=Se(o),e.$dk=(0,l.$Ii)("logService"),e.$ek=(0,l.$Ii)("loggerService");function c(){return new Date().toISOString()}function u(D){return(0,v.$lg)(D)}var h;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$gk=h.Info;function a(D,y,N){switch(y){case h.Trace:D.trace(N);break;case h.Debug:D.debug(N);break;case h.Info:D.info(N);break;case h.Warning:D.warn(N);break;case h.Error:D.error(N);break;case h.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function s(D,y=!1){let N="";for(let I=0;I<D.length;I++){let P=D[I];if(P instanceof Error&&(P=(0,t.$tj)(P,y)),typeof P=="object")try{P=JSON.stringify(P)}catch{}N+=(I>0?" ":"")+P}return N}class p extends j.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new A.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==h.Off&&this.b<=y}}e.$ik=p;class E extends p{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...N){this.f(h.Trace)&&this.g(h.Trace,s([y,...N],!0))}debug(y,...N){this.f(h.Debug)&&this.g(h.Debug,s([y,...N]))}info(y,...N){this.f(h.Info)&&this.g(h.Info,s([y,...N]))}warn(y,...N){this.f(h.Warning)&&this.g(h.Warning,s([y,...N]))}error(y,...N){if(this.f(h.Error))if(y instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=y.stack,this.g(h.Error,s(I))}else this.g(h.Error,s([y,...N]))}flush(){}}e.$jk=E;class S extends p{constructor(y=e.$gk){super(),this.setLevel(y),this.g=!$.$j}trace(y,...N){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,y,...N):console.log(`[main ${c()}]`,y,...N))}debug(y,...N){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,y,...N):console.log(`[main ${c()}]`,y,...N))}info(y,...N){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,y,...N):console.log(`[main ${c()}]`,y,...N))}warn(y,...N){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,y,...N):console.warn(`[main ${c()}]`,y,...N))}error(y,...N){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,y,...N):console.error(`[main ${c()}]`,y,...N))}flush(){}}e.$kk=S;class i extends p{constructor(y=e.$gk,N=!0){super(),this.g=N,this.setLevel(y)}trace(y,...N){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...N):console.log(y,...N))}debug(y,...N){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...N):console.log(y,...N))}info(y,...N){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...N):console.log(y,...N))}warn(y,...N){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...N):console.log(y,...N))}error(y,...N){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...N):console.error(y,...N))}flush(){}}e.$lk=i;class n extends p{constructor(y,N=e.$gk){super(),this.g=y,this.setLevel(N)}trace(y,...N){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(y),...N])}debug(y,...N){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(y),...N])}info(y,...N){this.f(h.Info)&&this.g.log(h.Info,[this.h(y),...N])}warn(y,...N){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(y),...N])}error(y,...N){this.f(h.Error)&&this.g.log(h.Error,[this.h(y),...N])}h(y){return typeof y=="string"?y:(0,t.$tj)(y,this.f(h.Trace))}flush(){}}e.$mk=n;class g extends p{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const N of this.g)N.setLevel(y);super.setLevel(y)}trace(y,...N){for(const I of this.g)I.trace(y,...N)}debug(y,...N){for(const I of this.g)I.debug(y,...N)}info(y,...N){for(const I of this.g)I.info(y,...N)}warn(y,...N){for(const I of this.g)I.warn(y,...N)}error(y,...N){for(const I of this.g)I.error(y,...N)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$nk=g;class R extends j.$Xc{constructor(y,N,I){if(super(),this.h=y,this.j=N,this.b=new _.$Dc,this.c=this.B(new A.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$oe),this.onDidChangeVisibility=this.g.event,I)for(const P of I)this.b.set(P.resource,{logger:void 0,info:P})}m(y){return(0,v.$hg)(y)?[...this.b.values()].find(N=>N.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,N){const I=this.n(y),P=(0,v.$hg)(y)?y:N?.id??(0,m.$wj)(I.toString()).toString(16);let C=this.b.get(I)?.logger;const Q=N?.logLevel==="always"?h.Trace:N?.logLevel;C||(C=this.s(I,Q??this.getLogLevel(I)??this.h,{...N,id:P}));const V={logger:C,info:{resource:I,id:P,logLevel:Q,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(V.info),this.b.set(I,V),C}n(y){return(0,v.$hg)(y)?(0,r.$jh)(this.j,`${y}.log`):y}setLogLevel(y,N){if(b.URI.isUri(y)){const I=y,P=N,C=this.b.get(I);C&&P!==C.info.logLevel&&(C.info.logLevel=P===this.h?void 0:P,C.logger?.setLevel(P),this.b.set(C.info.resource,C),this.f.fire([I,P]))}else{this.h=y;for(const[I,P]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&P.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,N){const I=this.m(y);I&&N!==!I.info.hidden&&(I.info.hidden=!N,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,N]))}getLogLevel(y){let N;return y&&(N=this.b.get(y)?.info.logLevel),N??this.h}registerLogger(y){const N=this.b.get(y.resource);N?N.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const N=this.b.get(y);N&&(N.logger&&N.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=R;class q{constructor(){this.onDidChangeLogLevel=new A.$oe().event}setLevel(y){}getLevel(){return h.Info}trace(y,...N){}debug(y,...N){}info(y,...N){}warn(y,...N){}error(y,...N){}critical(y,...N){}dispose(){}flush(){}}e.$pk=q;class w extends q{}e.$qk=w;function L(D){if(D.verbose)return h.Trace;if(typeof D.logLevel=="string"){const y=z(D.logLevel.toLowerCase());if(y!==void 0)return y}return e.$gk}function k(D){switch(D){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}function O(D){switch(D){case h.Trace:return{original:"Trace",value:o.localize(1957,null)};case h.Debug:return{original:"Debug",value:o.localize(1958,null)};case h.Info:return{original:"Info",value:o.localize(1959,null)};case h.Warning:return{original:"Warning",value:o.localize(1960,null)};case h.Error:return{original:"Error",value:o.localize(1961,null)};case h.Off:return{original:"Off",value:o.localize(1962,null)}}}function z(D){switch(D){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$vk=new f.$Zj("logLevel",k(h.Info))}),define(he[74],fe([0,1,6,4,8,2]),function(ie,e,o,t,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.$ys=void 0;class j extends A.$ok{constructor(b,f,l,c,u){super(f,l,c),this.r=b,this.t=u,this.B(u.listen("onDidChangeLogLevel",b)(h=>{(0,A.$fk)(h)?super.setLogLevel(h):super.setLogLevel(o.URI.revive(h[0]),h[1])})),this.B(u.listen("onDidChangeVisibility",b)(([h,a])=>super.setVisibility(o.URI.revive(h),a))),this.B(u.listen("onDidChangeLoggers",b)(({added:h,removed:a})=>{for(const s of h)super.registerLogger({...s,resource:o.URI.revive(s.resource)});for(const s of a)super.deregisterLogger(s.resource)}))}createConsoleMainLogger(){return new A.$mk({log:(b,f)=>{this.t.call("consoleLog",[b,f])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,f){super.setLogLevel(b,f),this.t.call("setLogLevel",[b,f])}setVisibility(b,f){super.setVisibility(b,f),this.t.call("setVisibility",[this.n(b),f])}s(b,f,l){return new _(this.t,b,f,l,this.r)}static setLogLevel(b,f,l){return b.call("setLogLevel",[f,l])}}e.$ys=j;class _ extends A.$jk{constructor(b,f,l,c,u){super(c?.logLevel==="always"),this.r=b,this.s=f,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[f,c,u]).then(()=>{this.u(this.n),this.m=!0})}g(b,f){const l=[[b,f]];this.m?this.u(l):this.n.push(...l)}u(b){this.r.call("log",[this.s,b])}}class ${constructor(b,f){this.a=b,this.b=f}listen(b,f){const l=this.b(b);switch(f){case"onDidChangeLoggers":return t.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(u=>this.c(u,l)),removed:[...c.removed].map(u=>this.c(u,l))}));case"onDidChangeVisibility":return t.Event.map(this.a.onDidChangeVisibility,c=>[l.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return t.Event.map(this.a.onDidChangeLogLevel,c=>(0,A.$fk)(c)?c:[l.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${f}`)}async call(b,f,l){const c=this.b(b);switch(f){case"setLogLevel":return(0,A.$fk)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(o.URI.revive(c.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(u=>this.c(u,c)))}throw new Error(`Call not found: ${f}`)}c(b,f){return{...b,resource:f.transformOutgoingURI(b.resource)}}}e.$zs=$;class r extends m.$Xc{constructor(b,f){super(),f.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(l=>f.call("setLogLevel",[l]))),f.call("getRegisteredLoggers").then(l=>{for(const c of l)b.registerLogger({...c,resource:o.URI.revive(c.resource)})}),this.B(f.listen("onDidChangeVisibility")(([l,c])=>b.setVisibility(o.URI.revive(l),c))),this.B(f.listen("onDidChangeLoggers")(({added:l,removed:c})=>{for(const u of l)b.registerLogger({...u,resource:o.URI.revive(u.resource)});for(const u of c)b.deregisterLogger(u.resource)}))}}e.$As=r}),define(he[75],fe([0,1,2,8]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class A extends o.$Xc{constructor(j,_=[]){super(),this.a=new t.$nk([j,..._]),this.B(j.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,..._){this.a.trace(j,..._)}debug(j,..._){this.a.debug(j,..._)}info(j,..._){this.a.info(j,..._)}warn(j,..._){this.a.warn(j,..._)}error(j,..._){this.a.error(j,..._)}flush(){this.a.flush()}}e.$4R=A}),define(he[76],fe([0,1,73,8]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0;var A;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(A||(A={}));async function m(r,v,b,f,l){try{const c=await new Promise((h,a)=>{ie(["@vscode/spdlog"],h,a)}).then(Se);c.setFlushOn(A.Trace);const u=await c.createAsyncRotatingLogger(r,v,b,f);return l?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(c){console.error(c)}return null}function j(r,v,b){switch(v){case t.LogLevel.Trace:r.trace(b);break;case t.LogLevel.Debug:r.debug(b);break;case t.LogLevel.Info:r.info(b);break;case t.LogLevel.Warning:r.warn(b);break;case t.LogLevel.Error:r.error(b);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function _(r,v){switch(v){case t.LogLevel.Trace:r.setLevel(A.Trace);break;case t.LogLevel.Debug:r.setLevel(A.Debug);break;case t.LogLevel.Info:r.setLevel(A.Info);break;case t.LogLevel.Warning:r.setLevel(A.Warning);break;case t.LogLevel.Error:r.setLevel(A.Error);break;case t.LogLevel.Off:r.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class $ extends t.$jk{constructor(v,b,f,l,c){super(),this.m=[],this.setLevel(c),this.n=this.s(v,b,f,l),this.B(this.onDidChangeLogLevel(u=>{this.r&&_(this.r,u)}))}async s(v,b,f,l){const c=f?6:1,u=30/c*o.$Ll.MB,h=await m(v,b,u,c,l);if(h){this.r=h,_(this.r,this.getLevel());for(const{level:a,message:s}of this.m)j(this.r,a,s);this.m=[]}}g(v,b){this.r?j(this.r,v,b):this.getLevel()<=v&&this.m.push({level:v,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$SR=$}),define(he[77],fe([0,1,59,8,76]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0;class m extends t.$ok{s(_,$,r){return new A.$SR((0,o.$5g)(),_.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,$)}}e.$TR=m}),define(he[78],fe([0,1,15]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const m=A.context.configuration();if(m)t=m.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(t=globalThis._VSCODE_PRODUCT_JSON,o.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const m=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:m.version})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(he[79],fe([0,1,22]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,o.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"}),define(he[80],fe([0,1,45,9]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=void 0,o=Se(o),t=Se(t);class A{constructor(){this.a=new Map}add(j,_){o.ok(t.$hg(j)),o.ok(t.$jg(_)),o.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,_)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$uo=new A}),define(he[23],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandInvalidationReason=e.TerminalCapability=void 0;var o;(function(A){A[A.CwdDetection=0]="CwdDetection",A[A.NaiveCwdDetection=1]="NaiveCwdDetection",A[A.CommandDetection=2]="CommandDetection",A[A.PartialCommandDetection=3]="PartialCommandDetection",A[A.BufferMarkDetection=4]="BufferMarkDetection"})(o||(e.TerminalCapability=o={}));var t;(function(A){A.Windows="windows",A.NoProblemsReported="noProblemsReported"})(t||(e.CommandInvalidationReason=t={}))}),define(he[81],fe([0,1,4,2,23]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cxb=void 0;class m extends t.$Xc{constructor(_){super(),this.f=_,this.type=A.TerminalCapability.BufferMarkDetection,this.a=new Map,this.b=new Map,this.c=this.B(new o.$oe),this.onMarkAdded=this.c.event}*markers(){for(const _ of this.a.values())yield _;for(const _ of this.b.values())yield _}addMark(_){const $=_?.marker||this.f.registerMarker(),r=_?.id;$&&(r?(this.a.set(r,$),$.onDispose(()=>this.a.delete(r))):(this.b.set($.id,$),$.onDispose(()=>this.b.delete($.id))),this.c.fire({marker:$,id:r,hidden:_?.hidden,hoverMessage:_?.hoverMessage}))}getMark(_){return this.a.get(_)}}e.$cxb=m});var Be=this&&this.__param||function(ie,e){return function(o,t){e(o,t,ie)}};define(he[82],fe([0,1,4,2,8,14]),function(ie,e,o,t,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0;var j;(function($){$[$.Unknown=0]="Unknown",$[$.Input=1]="Input",$[$.Execute=2]="Execute"})(j||(j={}));let _=class extends t.$Xc{get value(){return this.j}get prefix(){return this.j.substring(0,this.m)}get suffix(){return this.j.substring(this.m,this.n===-1?void 0:this.n)}get cursorIndex(){return this.m}get ghostTextIndex(){return this.n}constructor(r,v,b,f){super(),this.w=r,this.z=f,this.a=j.Unknown,this.c=0,this.h="",this.j="",this.m=0,this.n=-1,this.r=this.B(new o.$oe),this.onDidStartInput=this.r.event,this.s=this.B(new o.$oe),this.onDidChangeInput=this.s.event,this.t=this.B(new o.$oe),this.onDidFinishInput=this.t.event,this.u=this.B(new o.$oe),this.onDidInterrupt=this.u.event,this.B(o.Event.any(this.w.onCursorMove,this.w.onData,this.w.onWriteParsed)(()=>this.G())),this.B(this.w.onData(l=>this.I(l))),this.B(v(l=>this.D(l))),this.B(b(()=>this.F())),this.B(this.onDidStartInput(()=>this.C("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.C("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.C("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.C("PromptInputModel#onDidInterrupt")))}C(r){this.z.getLevel()===A.LogLevel.Trace&&this.z.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.g=r,this.G()}setLastPromptLine(r){this.f=r,this.G()}setConfidentCommandLine(r){this.j!==r&&(this.j=r,this.m=-1,this.n=-1,this.s.fire(this.Q()))}getCombinedString(){const r=this.j.replaceAll(`
`,"\u23CE");if(this.m===-1)return r;let v=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(v+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,v+=`${r.substring(this.ghostTextIndex)}]`):v+=r.substring(this.cursorIndex),v}serialize(){return{modelState:this.Q(),commandStartX:this.c,lastPromptLine:this.f,continuationPrompt:this.g,lastUserInput:this.h}}deserialize(r){this.j=r.modelState.value,this.m=r.modelState.cursorIndex,this.n=r.modelState.ghostTextIndex,this.c=r.commandStartX,this.f=r.lastPromptLine,this.g=r.continuationPrompt,this.h=r.lastUserInput}D(r){this.a!==j.Input&&(this.a=j.Input,this.b=r.marker,this.c=this.w.buffer.active.cursorX,this.j="",this.m=0,this.r.fire(this.Q()),this.s.fire(this.Q()),this.f&&this.c!==this.f.length&&this.w.buffer.active.getLine(this.b.line)?.translateToString(!0).startsWith(this.f)&&(this.c=this.f.length,this.G()))}F(){if(this.a===j.Execute)return;this.m=-1,this.n!==-1&&(this.j=this.j.substring(0,this.n),this.n=-1);const r=this.Q();this.h===""&&(this.h="",this.u.fire(r)),this.a=j.Execute,this.t.fire(r),this.s.fire(r)}G(){try{this.H()}catch(r){this.z.error("Error while syncing prompt input model",r)}}H(){if(this.a!==j.Input)return;const r=this.b?.line;if(r===void 0)return;const v=this.w.buffer.active;let b=v.getLine(r);const f=b?.translateToString(!0,this.c);if(!b||f===void 0){this.z.trace("PromptInputModel#_sync: no line");return}const l=v.baseY+v.cursorY;let c=f,u=-1,h;l===r?h=this.O(this.c,v,b):h=f.trimEnd().length,l===r&&v.cursorX>1&&(u=this.J(v,b,h));for(let a=r+1;a<=l;a++){b=v.getLine(a);const s=b?.translateToString(!0);if(s&&b)if(b.isWrapped){c+=s;const p=this.O(0,v,b);l===a?h+=p:h+=s.length}else if(this.g===void 0||this.M(s)){const p=this.L(s);if(c+=`
${p}`,l===a){const E=this.N(b,s),S=this.O(E,v,b);h+=S+1}else h+=p.length+1}else break}for(let a=l+1;a<v.baseY+this.w.rows;a++){b=v.getLine(a);const s=b?.translateToString(!0);if(s&&b)if(this.g===void 0||this.M(s))c+=`
${this.L(s)}`;else break;else break}this.z.getLevel()===A.LogLevel.Trace&&this.z.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let a=this.j.length-this.j.trimEnd().length;this.h==="\x7F"&&(this.h="",h===this.m-1&&(this.j.trimEnd().length>c.trimEnd().length&&c.trimEnd().length<=h?a=Math.max(this.j.length-1-c.trimEnd().length,0):a=Math.max(a-1,0))),this.h==="\x1B[3~"&&(this.h="",h===this.m&&(a=Math.max(a-1,0)));const s=c.split(`
`),p=s.length>1,E=c.trimEnd();if(!p){E.length<c.length&&(this.h===" "&&(this.h="",h>E.length&&h>this.m&&a++),a=Math.max(h-E.length,a,0));const S=h===0?"":c[h-1];a>0&&h===this.m+1&&this.h!==""&&S!==" "&&(a=this.j.length-this.m)}if(p){s[s.length-1]=s.at(-1)?.trimEnd()??"";const S=(s.length-1)*(this.g?.length??0);a=Math.max(0,h-c.length-S)}c=s.map(S=>S.trimEnd()).join(`
`)+" ".repeat(a)}(this.j!==c||this.m!==h||this.n!==u)&&(this.j=c,this.m=h,this.n=u,this.s.fire(this.Q()))}I(r){this.h=r}J(r,v,b){let f=-1,l=!1,c=r.cursorX;for(;c>0;){const u=v.getCell(--c);if(!u)break;if(u.getChars().trim().length>0){l=!this.P(u);break}}if(l){let u=0,h=r.cursorX;for(;h<v.length;){const a=v.getCell(h++);if(!a||a.getCode()===0)break;if(this.P(a)){f=b+u;break}u+=a.getChars().length}}return f}L(r){return this.M(r)&&(r=r.substring(this.g.length)),r}M(r){return!!(this.g&&r.startsWith(this.g))}N(r,v){if(!this.g||!v.startsWith(this.g))return 0;let b="",f=0;for(;b!==this.g;)b+=r.getCell(f++).getChars();return f}O(r,v,b){return b?.translateToString(!0,r,v.cursorX).length??0}P(r){return!!(r.isItalic()||r.isDim())}Q(){return Object.freeze({value:this.j,prefix:this.prefix,suffix:this.suffix,cursorIndex:this.m,ghostTextIndex:this.n})}};e.$ps=_,me([(0,m.$ci)(0)],_.prototype,"G",null),e.$ps=_=me([Be(3,A.$dk)],_)}),define(he[83],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=void 0;class o{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(v){this.b.endMarker=v}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(v,b){this.a=v,this.b=b}static deserialize(v,b,f){const l=v.buffer.normal,c=b.startLine!==void 0?v.registerMarker(b.startLine-(l.baseY+l.cursorY)):void 0;if(!c)return;const u=b.promptStartLine!==void 0?v.registerMarker(b.promptStartLine-(l.baseY+l.cursorY)):void 0,h=b.endLine!==void 0?v.registerMarker(b.endLine-(l.baseY+l.cursorY)):void 0,a=b.executedLine!==void 0?v.registerMarker(b.executedLine-(l.baseY+l.cursorY)):void 0;return new o(v,{command:f?"":b.command,commandLineConfidence:b.commandLineConfidence??"low",isTrusted:b.isTrusted,promptStartMarker:u,marker:c,startX:b.startX,endMarker:h,executedMarker:a,executedX:b.executedX,timestamp:b.timestamp,duration:b.duration,cwd:b.cwd,commandStartLineContent:b.commandStartLineContent,exitCode:b.exitCode,markProperties:b.markProperties,aliases:void 0,wasReplayed:!0})}serialize(v){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:v?"":this.command,commandLineConfidence:v?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return A(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const v=this.executedMarker.line,b=this.endMarker.line;if(v===b)return;let f="",l;for(let c=v;c<b;c++)l=this.a.buffer.active.getLine(c),l&&(f+=l.translateToString(!l.isWrapped)+(l.isWrapped?"":`
`));return f===""?void 0:f}getOutputMatch(v){if(!this.executedMarker||!this.endMarker)return;const b=this.endMarker.line;if(b===-1)return;const f=this.a.buffer.active,l=Math.max(this.executedMarker.line,0),c=v.lineMatcher,u=typeof c=="string"?1:v.length||j(c),h=[];let a;if(v.anchor==="bottom")for(let s=b-(v.offset||0);s>=l;s--){let p=s;const E=s;for(;p>=l&&f.getLine(p)?.isWrapped;)p--;if(s=p,h.unshift(m(f,p,E,this.a.cols)),a||(a=h[0].match(c)),h.length>=u)break}else for(let s=l+(v.offset||0);s<b;s++){const p=s;let E=s;for(;E+1<b&&f.getLine(E+1)?.isWrapped;)E++;if(s=E,h.push(m(f,p,E,this.a.cols)),a||(a=h[h.length-1].match(c)),h.length>=u)break}return a?{regexMatch:a,outputLines:h}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return _(this,this.a.buffer.active)}getCommandRowCount(){return $(this)}}e.$qs=o;class t{constructor(v){this.c=v}serialize(v){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:v,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(v,b,f,l){if(b===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||f)return new o(this.c,{command:f?"":this.command||"",commandLineConfidence:f?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:v,exitCode:b,commandStartLineContent:this.commandStartLineContent,markProperties:l})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return A(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return _(this,this.c.buffer.active)}getCommandRowCount(){return $(this)}}e.$rs=t;function A(r,v,b,f,l,c){if(!b||!l||f===void 0||c===void 0)return"";let u="";for(let h=b.line;h<=l.line;h++){const a=r.getLine(h);a&&(u+=a.translateToString(!0,h===b.line?f:0,h===l.line?c:v))}return u}function m(r,v,b,f){const l=Math.max(2048/f*2);b=Math.min(b,v+l);let c="";for(let u=v;u<=b;u++){const h=r.getLine(u);h&&(c+=h.translateToString(!0,0,f))}return c}function j(r){if(!r.multiline)return 1;const v=r.source;let b=1,f=v.indexOf("\\n");for(;f!==-1;)b++,f=v.indexOf("\\n",f+1);return b}function _(r,v){const b="hasOutput"in r?r.marker:r.commandStartMarker;if(!b||!r.promptStartMarker)return 1;let f=1,l=r.promptStartMarker.line;for(;l<b.line&&(v.getLine(l)?.translateToString(!0)??"").length===0;)l++;return f=b.line-l+1,f}function $(r){const v="hasOutput"in r?r.marker:r.commandStartMarker,b="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!v||!b)return 1;let l=Math.max(b.line,v.line)-v.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&l--,l}}),define(he[84],fe([0,1,11,14,4,2,8,23,83,82]),function(ie,e,o,t,A,m,j,_,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$wb=void 0,e.$_wb=c;let v=class extends m.$Xc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.n.command}get executingCommandObject(){if(this.n.commandStartMarker)return{marker:this.n.commandStartMarker}}get currentCommand(){return this.n}get cwd(){return this.g}get promptTerminator(){return this.h}constructor(s,p){super(),this.L=s,this.M=p,this.type=_.TerminalCapability.CommandDetection,this.f=[],this.n=new $.$rs(this.L),this.r=[],this.t=!1,this.D=this.B(new A.$oe),this.onCommandStarted=this.D.event,this.F=this.B(new A.$oe),this.onBeforeCommandFinished=this.F.event,this.G=this.B(new A.$oe),this.onCommandFinished=this.G.event,this.H=this.B(new A.$oe),this.onCommandExecuted=this.H.event,this.I=this.B(new A.$oe),this.onCommandInvalidated=this.I.event,this.J=this.B(new A.$oe),this.onCurrentCommandInvalidated=this.J.event,this.c=this.B(new r.$ps(this.L,this.onCommandStarted,this.onCommandExecuted,this.M)),this.B(this.onCommandExecuted(S=>{if(S.commandLineConfidence!=="high"){const i=S;S.command=i.extractCommandLine(),S.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&S.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(S.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&S.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(S.commandLineConfidence="medium")}}));const E=this;this.z=new class{get onCurrentCommandInvalidatedEmitter(){return E.J}get onCommandStartedEmitter(){return E.D}get onCommandExecutedEmitter(){return E.H}get dimensions(){return E.s}get isCommandStorageDisabled(){return E.t}get commandMarkers(){return E.r}set commandMarkers(S){E.r=S}get clearCommandsInViewport(){return E.P.bind(E)}commitCommandFinished(){E.w?.flush(),E.w=void 0}},this.C=this.B(new m.$Zc(new b(this.L,this,this.z,this.M))),this.s={cols:this.L.cols,rows:this.L.rows},this.B(this.L.onResize(S=>this.N(S))),this.B(this.L.onCursorMove(()=>this.O()))}N(s){this.C.value.preHandleResize?.(s),this.s.cols=s.cols,this.s.rows=s.rows}O(){this.q.isDisposed||this.L.buffer.active===this.L.buffer.normal&&this.n.commandStartMarker&&this.L.buffer.active.baseY+this.L.buffer.active.cursorY<this.n.commandStartMarker.line&&(this.P(),this.n.isInvalid=!0,this.J.fire({reason:_.CommandInvalidationReason.Windows}))}P(){let s=0;for(let p=this.f.length-1;p>=0;p--){const E=this.f[p].marker?.line;if(E&&E<this.L.buffer.active.baseY)break;s++}s>0&&this.I.fire(this.f.splice(this.f.length-s,s))}setContinuationPrompt(s){this.c.setContinuationPrompt(s)}setPromptTerminator(s,p){this.M.debug("CommandDetectionCapability#setPromptTerminator",s),this.h=s,this.c.setLastPromptLine(p)}setCwd(s){this.g=s}setIsWindowsPty(s){if(s&&!(this.C.value instanceof l)){const p=this;this.C.value=new l(this.L,this,new class{get onCurrentCommandInvalidatedEmitter(){return p.J}get onCommandStartedEmitter(){return p.D}get onCommandExecutedEmitter(){return p.H}get dimensions(){return p.s}get isCommandStorageDisabled(){return p.t}get commandMarkers(){return p.r}set commandMarkers(E){p.r=E}get clearCommandsInViewport(){return p.P.bind(p)}commitCommandFinished(){p.w?.flush(),p.w=void 0}},this.M)}else!s&&!(this.C.value instanceof b)&&(this.C.value=new b(this.L,this,this.z,this.M))}setIsCommandStorageDisabled(){this.t=!0}getCommandForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.n;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>s)){for(let p=this.commands.length-1;p>=0;p--)if((this.commands[p].promptStartMarker??this.commands[p].marker).line<=s)return this.commands[p]}}getCwdForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.g;const p=this.getCommandForLine(s);if(p&&"cwd"in p)return p.cwd}handlePromptStart(s){const p=this.commands.at(-1);p?.endMarker&&p?.executedMarker&&p.endMarker.line===p.executedMarker.line&&(this.M.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${p.endMarker.line} -> ${p.executedMarker.line+1}`),p.endMarker=h(this.L,p.executedMarker,1)),this.n.promptStartMarker=s?.marker||(p?.endMarker?h(this.L,p.endMarker):this.L.registerMarker(0)),this.M.debug("CommandDetectionCapability#handlePromptStart",this.L.buffer.active.cursorX,this.n.promptStartMarker?.line)}handleContinuationStart(){this.n.currentContinuationMarker=this.L.registerMarker(0),this.M.debug("CommandDetectionCapability#handleContinuationStart",this.n.currentContinuationMarker)}handleContinuationEnd(){if(!this.n.currentContinuationMarker){this.M.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.n.continuations||(this.n.continuations=[]),this.n.continuations.push({marker:this.n.currentContinuationMarker,end:this.L.buffer.active.cursorX}),this.n.currentContinuationMarker=void 0,this.M.debug("CommandDetectionCapability#handleContinuationEnd",this.n.continuations[this.n.continuations.length-1])}handleRightPromptStart(){this.n.commandRightPromptStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptStart",this.n.commandRightPromptStartX)}handleRightPromptEnd(){this.n.commandRightPromptEndX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptEnd",this.n.commandRightPromptEndX)}handleCommandStart(s){if(this.u=s,this.n.cwd=this.g,this.n.commandStartMarker=s?.marker||this.n.commandStartMarker,this.n.commandStartMarker?.line===this.L.buffer.active.cursorY){this.n.commandStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleCommandStart",this.n.commandStartX,this.n.commandStartMarker?.line);return}this.C.value.handleCommandStart(s)}handleGenericCommand(s){s?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(s),this.handleCommandStart(s),this.handleCommandExecuted(s),this.handleCommandFinished(void 0,s)}handleCommandExecuted(s){this.C.value.handleCommandExecuted(s),this.n.markExecutedTime()}handleCommandFinished(s,p){if(this.n.markFinishedTime(),this.C.value.preHandleCommandFinished?.(),this.M.debug("CommandDetectionCapability#handleCommandFinished",this.L.buffer.active.cursorX,p?.marker?.line,this.n.command,this.n),s===void 0){const S=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.n.command&&this.n.command.length>0&&S?.command===this.n.command&&(s=S.exitCode)}if(this.n.commandStartMarker===void 0||!this.L.buffer.active)return;this.n.commandFinishedMarker=p?.marker||this.L.registerMarker(0),this.C.value.postHandleCommandFinished?.();const E=this.n.promoteToFullCommand(this.g,s,this.u?.ignoreCommandLine??!1,p?.markProperties);E&&(this.f.push(E),this.w=new o.$Uh(()=>{this.F.fire(E),this.n.isInvalid||(this.M.debug("CommandDetectionCapability#onCommandFinished",E),this.G.fire(E))},50),this.w.schedule()),this.n=new $.$rs(this.L),this.u=void 0}setCommandLine(s,p){this.M.debug("CommandDetectionCapability#setCommandLine",s,p),this.n.command=s,this.n.commandLineConfidence="high",this.n.isTrusted=p,p&&this.c.setConfidentCommandLine(s)}serialize(){const s=this.commands.map(E=>E.serialize(this.t)),p=this.n.serialize(this.g);return p&&s.push(p),{isWindowsPty:this.C.value instanceof l,commands:s,promptInputModel:this.c.serialize()}}deserialize(s){s.isWindowsPty&&this.setIsWindowsPty(s.isWindowsPty);const p=this.L.buffer.normal;for(const E of s.commands){if(!E.endLine){const i=E.startLine!==void 0?this.L.registerMarker(E.startLine-(p.baseY+p.cursorY)):void 0;if(!i)continue;this.n.commandStartMarker=E.startLine!==void 0?this.L.registerMarker(E.startLine-(p.baseY+p.cursorY)):void 0,this.n.commandStartX=E.startX,this.n.promptStartMarker=E.promptStartLine!==void 0?this.L.registerMarker(E.promptStartLine-(p.baseY+p.cursorY)):void 0,this.g=E.cwd,this.D.fire({marker:i});continue}const S=$.$qs.deserialize(this.L,E,this.t);S&&(this.f.push(S),this.M.debug("CommandDetectionCapability#onCommandFinished",S),this.G.fire(S))}s.promptInputModel&&this.c.deserialize(s.promptInputModel)}};e.$$wb=v,me([(0,t.$bi)(500)],v.prototype,"O",null),e.$$wb=v=me([Be(1,j.$dk)],v);class b extends m.$Xc{constructor(s,p,E,S){super(),this.c=s,this.f=p,this.g=E,this.h=S,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&E.clearCommandsInViewport(),!1)))}handleCommandStart(s){this.g.commitCommandFinished();const p=this.f.currentCommand;p.commandStartX=this.c.buffer.active.cursorX,p.commandStartMarker=s?.marker||this.c.registerMarker(0),p.commandExecutedMarker?.dispose(),p.commandExecutedMarker=void 0,p.commandExecutedX=void 0;for(const E of this.g.commandMarkers)E.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:s?.marker||p.commandStartMarker,markProperties:s?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",p.commandStartX,p.commandStartMarker?.line)}handleCommandExecuted(s){const p=this.f.currentCommand;if(p.commandExecutedMarker=s?.marker||this.c.registerMarker(0),p.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",p.commandExecutedX,p.commandExecutedMarker?.line),!p.commandStartMarker||!p.commandExecutedMarker||p.commandStartX===void 0)return;p.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(p.commandStartMarker.line)?.translateToString(!0,p.commandStartX,p.commandRightPromptStartX).trim();let E=p.commandStartMarker.line+1;const S=p.commandExecutedMarker.line;for(;E<S;E++){const i=this.c.buffer.active.getLine(E);if(i){const n=p.continuations?.find(R=>R.marker.line===E);n&&(p.command+=`
`);const g=n?.end??0;p.command+=i.translateToString(!0,g)}}E===S&&(p.command+=this.c.buffer.active.getLine(S)?.translateToString(!0,void 0,p.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(p)}}var f;(function(a){a[a.MaxCheckLineCount=10]="MaxCheckLineCount",a[a.Interval=20]="Interval",a[a.MaximumPollCount=10]="MaximumPollCount"})(f||(f={}));let l=class extends m.$Xc{constructor(s,p,E,S){super(),this.n=s,this.r=p,this.s=E,this.t=S,this.c=this.B(new m.$Yc),this.g=0,this.h=0,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:_.CommandInvalidationReason.Windows}))}))}preHandleResize(s){const p=this.n.buffer.active.baseY,E=s.rows-this.s.dimensions.rows;E>0&&this.D().then(()=>{const S=Math.min(E,p);for(let i=this.r.commands.length-1;i>=0;i--){const n=this.r.commands[i];if(!n.marker||n.marker.line<p||n.commandStartLineContent===void 0)break;const g=this.n.buffer.active.getLine(n.marker.line);if(!g||g.translateToString(!0)===n.commandStartLineContent)continue;const R=n.marker.line-S;this.n.buffer.active.getLine(R)?.translateToString(!0)===n.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:S})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const s=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?h(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new o.$Uh(()=>this.u(s),f.Interval),this.f.schedule()}u(s){if(this.q.isDisposed)return;const p=this.n.buffer.active;let E=this.g;for(;E<f.MaxCheckLineCount&&s.line+E<p.baseY+this.n.rows;){if(this.C()){const S=this.F(s.line+E);if(S){const i=typeof S=="string"?S:S.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof S=="object"&&S.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=h(this.n,this.r.currentCommand.commandStartMarker);const n=this.r.commands.at(-1);n&&this.r.currentCommand.commandStartMarker.line!==n.endMarker?.line&&(n.endMarker?.dispose(),n.endMarker=h(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=i.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${s.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}E++}E<f.MaxCheckLineCount?(this.g=E,++this.h<f.MaximumPollCount?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=f.MaximumPollCount,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const s=this.n.registerMarker(0);s&&this.s.commandMarkers.push(s)}})),this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(s){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const s=this.r.currentCommand,p=s.command,E=s.commandStartMarker?.line,S=s.commandExecutedMarker?.line;if(!p||p.length===0||E===void 0||E===-1||S===void 0||S===-1)return;let i=0,n=!1;for(let g=E;g<=S;g++){const R=this.n.buffer.active.getLine(g);if(!R)break;const q=R.translateToString(!0);for(let w=0;w<q.length;w++){for(;p.length<i&&p[i]===" ";)i++;if(q[w]===p[i]&&i++,i===p.length){const L=w>=this.n.cols-1;s.commandExecutedMarker=this.n.registerMarker(g-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(L?1:0)),s.commandExecutedX=L?0:w+1,n=!0;break}}if(n)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((s,p)=>s.line-p.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const s=this.r.commands.at(-1);if(!s)return!0;const p=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,E=(s.endMarker?s.endMarker.line:s.marker?.line)??-1;return p>E}D(){const s=this.n.buffer.active.cursorX,p=this.n.buffer.active.cursorY;let E=0;return new Promise((S,i)=>{const n=setInterval(()=>{if(s!==this.n.buffer.active.cursorX||p!==this.n.buffer.active.cursorY){S(),clearInterval(n);return}E+=10,E>1e3&&(clearInterval(n),S())},10)})}F(s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const p=this.n.buffer.active.getLine(s);if(!p)return;const E=p.translateToString(!0);if(!E)return;const S=E.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(S){const q=this.G(S,E,">");if(q)return{prompt:q,likelySingleLine:!0}}const i=E.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const q=this.G(i,E,"\u276F");if(q)return q}const n=E.match(/^(?<prompt>\$)/)?.groups?.prompt;if(n){const q=this.G(n,E,"$");if(q)return q}const g=E.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(g)return{prompt:g,likelySingleLine:!0};if(this.r.promptTerminator&&E.trim().endsWith(this.r.promptTerminator)){const q=this.G(E,E,this.r.promptTerminator);if(q)return q}const R=E.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return R?.groups?.prompt?{prompt:R.groups.prompt,likelySingleLine:!0}:void 0}G(s,p,E){if(s)return p===s&&s.endsWith(E)&&(s+=" "),s}};l=me([Be(3,j.$dk)],l);function c(a,s,p,E){if(!E)return;const S=s.executedMarker,i=s.endMarker;if(!S||!i)return;const n=S.line,g=i.line,R=E.length,q=[];if(E.anchor==="bottom")for(let w=g-(E.offset||0);w>=n;w--){let L=w;const k=w;for(;L>=n&&a.getLine(L)?.isWrapped;)L--;w=L,q.unshift(u(a,L,k,p)),q.length>R&&q.pop()}else for(let w=n+(E.offset||0);w<g;w++){const L=w;let k=w;for(;k+1<g&&a.getLine(k+1)?.isWrapped;)k++;w=k,q.push(u(a,L,k,p)),q.length===R&&q.shift()}return q}function u(a,s,p,E){const S=Math.max(2048/E*2);p=Math.min(p,s+S);let i="";for(let n=s;n<=p;n++){const g=a.getLine(n);g&&(i+=g.translateToString(!0,0,E))}return i}function h(a,s,p=0){return a.registerMarker(s.line-(a.buffer.active.baseY+a.buffer.active.cursorY)+p)}}),define(he[85],fe([0,1,4,2,23]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$axb=void 0;class m extends t.$Xc{constructor(){super(...arguments),this.type=A.TerminalCapability.CwdDetection,this.a="",this.b=new Map,this.c=this.B(new o.$oe),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(_){const $=this.a!==_;this.a=_;const r=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,r+1),$&&this.c.fire(_)}}e.$axb=m}),define(he[86],fe([0,1,4,2,23]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bxb=void 0;var m;(function(_){_[_.MinimumPromptLength=2]="MinimumPromptLength"})(m||(m={}));class j extends t.$Wc{get commands(){return this.a}constructor($){super(),this.c=$,this.type=A.TerminalCapability.PartialCommandDetection,this.a=[],this.b=this.add(new o.$oe),this.onCommandFinished=this.b.event,this.add(this.c.onData(r=>this.h(r))),this.add(this.c.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&this.m(),!1)))}h($){$==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=m.MinimumPromptLength){const $=this.c.registerMarker(0);$&&(this.a.push($),this.b.fire($))}}m(){let $=0;for(let r=this.a.length-1;r>=0&&!(this.a[r].line<this.c.buffer.active.baseY);r--)$++;this.a.splice(this.a.length-$,$)}}e.$bxb=j}),define(he[87],fe([0,1,4,2]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0wb=e.$9wb=void 0;class A extends t.$Xc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new o.$oe),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new o.$oe),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new o.$oe),this.onDidRemoveCapability=this.g.event,this.h=this.B(new o.$oe),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(_,$){this.a.set(_,$),this.f.fire(_),this.h.fire({id:_,capability:$})}get(_){return this.a.get(_)}remove(_){const $=this.a.get(_);$&&(this.a.delete(_),this.b.fire(_),this.h.fire({id:_,capability:$}))}has(_){return this.a.has(_)}}e.$9wb=A;class m extends t.$Xc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new o.$oe),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new o.$oe),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new o.$oe),this.onDidRemoveCapability=this.f.event,this.g=this.B(new o.$oe),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const _ of this._stores)for(const $ of _.items)yield $}has(_){for(const $ of this._stores)for(const r of $.items)if(r===_)return!0;return!1}get(_){for(const $ of this._stores){const r=$.get(_);if(r)return r}}add(_){this._stores.push(_);for(const $ of _.items)this.b.fire($),this.g.fire({id:$,capability:_.get($)});this.B(_.onDidAddCapabilityType($=>this.b.fire($))),this.B(_.onDidAddCapability($=>this.g.fire($))),this.B(_.onDidRemoveCapabilityType($=>this.a.fire($))),this.B(_.onDidRemoveCapability($=>this.f.fire($)))}}e.$0wb=m}),define(he[39],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var o;(function(t){t[t.Replace=1]="Replace",t[t.Append=2]="Append",t[t.Prepend=3]="Prepend"})(o||(e.EnvironmentVariableMutatorType=o={}))}),define(he[88],fe([0,1,3,39]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;const A=new Map([[t.EnvironmentVariableMutatorType.Append,"APPEND"],[t.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[t.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class m{constructor(v){this.collections=v,this.a=new Map,this.b=new Map,v.forEach((b,f)=>{this.d(b,f);const l=b.map.entries();let c=l.next();for(;!c.done;){const u=c.value[1],h=c.value[0];let a=this.a.get(h);if(a||(a=[],this.a.set(h,a)),a.length>0&&a[0].type===t.EnvironmentVariableMutatorType.Replace){c=l.next();continue}const s={extensionIdentifier:f,value:u.value,type:u.type,scope:u.scope,variable:u.variable,options:u.options};s.scope||delete s.scope,a.unshift(s),c=l.next()}})}async applyToProcessEnvironment(v,b,f){let l;o.$j&&(l={},Object.keys(v).forEach(c=>l[c.toLowerCase()]=c));for(const[c,u]of this.getVariableMap(b)){const h=o.$j&&l[c.toLowerCase()]||c;for(const a of u){const s=f?await f(a.value):a.value;if(a.options?.applyAtProcessCreation??!0)switch(a.type){case t.EnvironmentVariableMutatorType.Append:v[h]=(v[h]||"")+s;break;case t.EnvironmentVariableMutatorType.Prepend:v[h]=s+(v[h]||"");break;case t.EnvironmentVariableMutatorType.Replace:v[h]=s;break}if(a.options?.applyAtShellIntegration??!1){const p=`VSCODE_ENV_${A.get(a.type)}`;v[p]=(v[p]?v[p]+":":"")+c+"="+this.c(s)}}}}c(v){return v.replaceAll(":","\\x3a")}diff(v,b){const f=new Map,l=new Map,c=new Map;if(v.getVariableMap(b).forEach((u,h)=>{const a=this.getVariableMap(b).get(h),s=_(u,a);s&&f.set(h,s)}),this.getVariableMap(b).forEach((u,h)=>{const a=v.getVariableMap(b).get(h),s=_(u,a);s&&c.set(h,s)}),this.getVariableMap(b).forEach((u,h)=>{const a=v.getVariableMap(b).get(h),s=$(u,a);s&&l.set(h,s)}),!(f.size===0&&l.size===0&&c.size===0))return{added:f,changed:l,removed:c}}getVariableMap(v){const b=new Map;for(const f of this.a.values()){const l=f.filter(c=>j(c,v));l.length>0&&b.set(l[0].variable,l)}return b}getDescriptionMap(v){const b=new Map;for(const f of this.b.values()){const l=f.filter(c=>j(c,v,!0));for(const c of l)b.set(c.extensionIdentifier,c.description)}return b}d(v,b){if(!v.descriptionMap)return;const f=v.descriptionMap.entries();let l=f.next();for(;!l.done;){const c=l.value[1],u=l.value[0];let h=this.b.get(u);h||(h=[],this.b.set(u,h));const a={extensionIdentifier:b,scope:c.scope,description:c.description};a.scope||delete a.scope,h.push(a),l=f.next()}}}e.$Qs=m;function j(r,v,b=!1){return r.scope?!!(r.scope.workspaceFolder&&v?.workspaceFolder&&r.scope.workspaceFolder.index===v.workspaceFolder.index):b?v===r.scope:!0}function _(r,v){if(!v)return r;const b=new Set;v.forEach(l=>b.add(l.extensionIdentifier));const f=[];return r.forEach(l=>{b.has(l.extensionIdentifier)||f.push(l)}),f.length===0?void 0:f}function $(r,v){if(!v)return;const b=new Map;v.forEach(l=>b.set(l.extensionIdentifier,l));const f=[];return r.forEach(l=>{const c=b.get(l.extensionIdentifier);c&&(l.type!==c.type||l.value!==c.value||l.scope?.workspaceFolder?.index!==c.scope?.workspaceFolder?.index)&&f.push(c)}),f.length===0?void 0:f}}),define(he[89],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=o,e.$Ls=t,e.$Ms=A,e.$Ns=m,e.$Os=j,e.$Ps=_;function o($){return[...$.entries()]}function t($){return $?[...$.entries()]:[]}function A($){return new Map($)}function m($){return new Map($??[])}function j($){return Array.from($.entries()).map(r=>[r[0],o(r[1].map),t(r[1].descriptionMap)])}function _($){return new Map($.map(r=>[r[0],{map:A(r[1]),descriptionMap:m(r[2])}]))}}),define(he[90],fe([0,1,11,18,4,2,8]),function(ie,e,o,t,A,m,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=void 0;let _=class extends m.$Xc{constructor(r,v){super(),this.h=v,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new A.$oe),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,m.$Vc)(()=>{for(const b of this.f.values())(0,m.$Sc)(b)}))}createRequest(r){return new Promise((v,b)=>{const f=++this.a;this.c.set(f,v),this.g.fire({requestId:f,...r});const l=new t.$ze;(0,o.$Jh)(this.b,l.token).then(()=>b(`Request ${f} timed out (${this.b}ms)`)),this.f.set(f,[(0,m.$Vc)(()=>l.cancel())])})}acceptReply(r,v){const b=this.c.get(r);b?(this.c.delete(r),(0,m.$Sc)(this.f.get(r)||[]),this.f.delete(r),b(v)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$Bs=_,e.$Bs=_=me([Be(1,j.$dk)],_)}),define(he[16],fe([0,1,22,38,80]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$us=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ts=void 0,e.$ts=new t.$Zj("terminalTabFocusMode",!1,!0);var m;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(m||(e.TerminalSettingPrefix=m={}));var j;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var _;(function(i){i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh"})(_||(e.PosixShellType=_={}));var $;(function(i){i.CommandPrompt="cmd",i.Wsl="wsl",i.GitBash="gitbash"})($||(e.WindowsShellType=$={}));var r;(function(i){i.PowerShell="pwsh",i.Python="python",i.Julia="julia",i.NuShell="nu"})(r||(e.GeneralShellType=r={}));var v;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(v||(e.TitleEventSource=v={}));var b;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var f;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={})),e.$us=(0,o.$Ii)("ptyService");var l;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(l||(e.HeartbeatConstants=l={}));var c;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(c||(e.TerminalLocation=c={}));var u;(function(i){i.TerminalView="view",i.Editor="editor"})(u||(e.TerminalLocationString=u={}));var h;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(h||(e.LocalReconnectConstants=h={}));var a;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(a||(e.FlowControlConstants=a={}));var s;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var p;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(p||(e.ShellIntegrationStatus=p={}));var E;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(E||(e.TerminalExitReason=E={})),e.$vs={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const g=this.b(n.remoteAuthority);if(this.a.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this.a.set(g,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}A.$uo.add(e.$vs.Backend,new S),e.$ws=(0,o.$Ii)("localPtyService"),e.$xs=(0,o.$Ii)("terminalLogService")}),define(he[91],fe([0,1,11,2,3]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0;class m extends t.$Xc{constructor(_,$,r,v){super(),this.a=0,this.b=!1,this.c=!1,this.B(_.onProcessData(b=>{if(this.b||this.c)return;const f=typeof b=="string"?b:b.data;for(let l=0;l<f.length;l++)f[l]===$[this.a]?this.a++:this.f(),this.a===$.length&&(v.debug(`Auto reply match: "${$}", response: "${r}"`),_.input(r),this.c=!0,(0,o.$Jh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){A.$j&&(this.b=!0)}handleInput(){this.b=!1}}e.$Jnc=m}),define(he[92],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$myb=void 0;class o{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,m,j=5){const _=m($=>{const r=typeof $=="string"?$:$.data;let v=this.a.get(A);if(v){v.data.push(r);return}const b=setTimeout(()=>this.flushBuffer(A),j);v={data:[r],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(A),_.dispose()}},this.a.set(A,v)});return _}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const m=this.a.get(A);m&&(this.a.delete(A),this.b(A,m.data.join("")))}}e.$myb=o}),define(he[40],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=t,e.$uR=A,e.$vR=m,e.$wR=j;function t(_){let $=_;$.includes("\\")&&($=$.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return $=$.replace(r,""),`'${$}'`}function A(_,$,r){if(!_)return"";if(!$)return _;$.match(/[\/\\]$/)&&($=$.slice(0,$.length-1));const v=_.replace(/\\/g,"/").toLowerCase(),b=$.replace(/\\/g,"/").toLowerCase();return v.includes(b)?`~${r}${_.slice($.length+1)}`:_}function m(_){return _.match(/^['"].*['"]$/)&&(_=_.substring(1,_.length-1)),o.OS===o.OperatingSystem.Windows&&_&&_[1]===":"?_[0].toUpperCase()+_.substring(1):_}function j(_){return!_.strictEnv}}),define(he[93],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=t;var o;(function(A){A[A.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(o||(o={}));function t(A){const m=[];let j=0;for(let _=0;_<A.length-1;_++)(_-j+1>=o.WriteMaxChunkSize||A[_+1]==="\x1B")&&(m.push(A.substring(j,_+1)),j=_+1,_++);return j!==A.length&&m.push(A.substring(j)),m}}),define(he[94],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SYb=o;function o(t,A={}){let m="";return A.excludeLeadingNewLine||(m+=`\r
`),m+="\x1B[0m\x1B[7m * ",A.loudFormatting?m+="\x1B[0;104m":m+="\x1B[0m",m+=` ${t} \x1B[0m
\r`,m}}),define(he[95],fe([0,1,16,2,87,84,85,23,86,4,81,6,40,10]),function(ie,e,o,t,A,m,j,_,$,r,v,b,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dxb=e.ShellIntegrationOscPs=void 0,e.$exb=p,e.$fxb=E,e.$gxb=S;var c;(function(i){i[i.FinalTerm=133]="FinalTerm",i[i.VSCode=633]="VSCode",i[i.ITerm=1337]="ITerm",i[i.SetCwd=7]="SetCwd",i[i.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(c||(e.ShellIntegrationOscPs=c={}));var u;(function(i){i.PromptStart="A",i.CommandStart="B",i.CommandExecuted="C",i.CommandFinished="D"})(u||(u={}));var h;(function(i){i.PromptStart="A",i.CommandStart="B",i.CommandExecuted="C",i.CommandFinished="D",i.CommandLine="E",i.ContinuationStart="F",i.ContinuationEnd="G",i.RightPromptStart="H",i.RightPromptEnd="I",i.Property="P",i.SetMark="SetMark"})(h||(h={}));var a;(function(i){i.SetMark="SetMark",i.CurrentDir="CurrentDir"})(a||(a={}));class s extends t.$Xc{get status(){return this.g}constructor(n,g,R,q){super(),this.j=n,this.m=g,this.n=R,this.r=q,this.capabilities=this.B(new A.$9wb),this.b=!1,this.f=[],this.g=o.ShellIntegrationStatus.Off,this.h=new r.$oe,this.onDidChangeStatus=this.h.event,this.B((0,t.$Vc)(()=>{this.z(),this.s()}))}s(){(0,t.$Sc)(this.f),this.f.length=0}activate(n){this.a=n,this.capabilities.add(_.TerminalCapability.PartialCommandDetection,this.B(new $.$bxb(this.a))),this.B(n.parser.registerOscHandler(c.VSCode,g=>this.w(g))),this.B(n.parser.registerOscHandler(c.ITerm,g=>this.H(g))),this.f.push(n.parser.registerOscHandler(c.FinalTerm,g=>this.t(g))),this.B(n.parser.registerOscHandler(c.SetCwd,g=>this.J(g))),this.B(n.parser.registerOscHandler(c.SetWindowsFriendlyCwd,g=>this.I(g))),this.y()}getMarkerId(n,g){this.N(n).getMark(g)}t(n){const g=this.u(n);return this.g===o.ShellIntegrationStatus.Off&&(this.g=o.ShellIntegrationStatus.FinalTerm,this.h.fire(this.g)),g}u(n){if(!this.a)return!1;const[g,...R]=n.split(";");switch(g){case u.PromptStart:return this.M(this.a).handlePromptStart(),!0;case u.CommandStart:return this.M(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case u.CommandExecuted:return this.M(this.a).handleCommandExecuted(),!0;case u.CommandFinished:{const q=R.length===1?parseInt(R[0]):void 0;return this.M(this.a).handleCommandFinished(q),!0}}return!1}w(n){const g=this.C(n);return!this.b&&g&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==o.ShellIntegrationStatus.VSCode&&(this.g=o.ShellIntegrationStatus.VSCode,this.h.fire(this.g)),g}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(_.TerminalCapability.CommandDetection)&&!this.capabilities.get(_.TerminalCapability.CwdDetection)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(n){if(!this.a)return!1;const g=n.indexOf(";"),R=g===-1?n:n.substring(0,g),q=g===-1?[]:n.substring(g+1).split(";");switch(R){case h.PromptStart:return this.M(this.a).handlePromptStart(),!0;case h.CommandStart:return this.M(this.a).handleCommandStart(),!0;case h.CommandExecuted:return this.M(this.a).handleCommandExecuted(),!0;case h.CommandFinished:{const w=q[0],L=w!==void 0?parseInt(w):void 0;return this.M(this.a).handleCommandFinished(L),!0}case h.CommandLine:{const w=q[0],L=q[1];let k;return w!==void 0?k=p(w):k="",this.M(this.a).setCommandLine(k,L===this.j),!0}case h.ContinuationStart:return this.M(this.a).handleContinuationStart(),!0;case h.ContinuationEnd:return this.M(this.a).handleContinuationEnd(),!0;case h.RightPromptStart:return this.M(this.a).handleRightPromptStart(),!0;case h.RightPromptEnd:return this.M(this.a).handleRightPromptEnd(),!0;case h.Property:{const w=q[0],L=w!==void 0?p(w):"",{key:k,value:O}=E(L);if(O===void 0)return!0;switch(k){case"ContinuationPrompt":return this.D((0,l.$6f)(O)),!0;case"Cwd":return this.G(O),!0;case"IsWindows":return this.M(this.a).setIsWindowsPty(O==="True"),!0;case"Prompt":{const z=O.replace(/\x1b\[[0-9;]*m/g,"");return this.F(z),!0}case"Task":return this.N(this.a),this.capabilities.get(_.TerminalCapability.CommandDetection)?.setIsCommandStorageDisabled(),!0}}case h.SetMark:return this.N(this.a).addMark(S(q)),!0}return!1}D(n){this.a&&this.M(this.a).setContinuationPrompt(n)}F(n){if(!this.a)return;const g=n.substring(n.lastIndexOf(`
`)+1),R=g.substring(g.lastIndexOf(" "));R&&this.M(this.a).setPromptTerminator(R,g)}G(n){n=(0,f.$vR)(n),this.L().updateCwd(n),this.capabilities.get(_.TerminalCapability.CommandDetection)?.setCwd(n)}H(n){if(!this.a)return!1;const[g]=n.split(";");switch(g){case a.SetMark:this.N(this.a).addMark();default:{const{key:R,value:q}=E(g);if(q===void 0)return!0;switch(R){case a.CurrentDir:return this.G(q),!0}}}return!1}I(n){if(!this.a)return!1;const[g,...R]=n.split(";");switch(g){case"9":return R.length&&this.G(R[0]),!0}return!1}J(n){if(!this.a)return!1;const[g]=n.split(";");if(g.match(/^file:\/\/.*\//)){const R=b.URI.parse(g);if(R.path&&R.path.length>0)return this.G(R.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(_.TerminalCapability.CommandDetection)?{isWindowsPty:!1,commands:[],promptInputModel:void 0}:this.M(this.a).serialize()}deserialize(n){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.M(this.a).deserialize(n)}L(){let n=this.capabilities.get(_.TerminalCapability.CwdDetection);return n||(n=this.B(new j.$axb),this.capabilities.add(_.TerminalCapability.CwdDetection,n)),n}M(n){let g=this.capabilities.get(_.TerminalCapability.CommandDetection);return g||(g=this.B(new m.$$wb(n,this.r)),this.capabilities.add(_.TerminalCapability.CommandDetection,g)),g}N(n){let g=this.capabilities.get(_.TerminalCapability.BufferMarkDetection);return g||(g=this.B(new v.$cxb(n)),this.capabilities.add(_.TerminalCapability.BufferMarkDetection,g)),g}}e.$dxb=s;function p(i){return i.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(n,g,R)=>R?String.fromCharCode(parseInt(R,16)):g)}function E(i){const n=i.indexOf("=");return n===-1?{key:i,value:void 0}:{key:i.substring(0,n),value:i.substring(1+n)}}function S(i){let n,g=!1;for(const R of i)R!==void 0&&(R==="Hidden"&&(g=!0),R.startsWith("Id=")&&(n=R.substring(3)));return{id:n,hidden:g}}}),define(he[41],fe([0,1,5,14,4,2,61,8]),function(ie,e,o,t,A,m,j,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=e.$Knc=void 0;var $;(function(v){v[v.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",v[v.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})($||($={})),e.$Knc=[];let r=class extends m.$Xc{set hasChildProcesses(b){this.a!==b&&(this.a=b,this.f.debug("ChildProcessMonitor: Has child processes changed",b),this.b.fire(b))}get hasChildProcesses(){return this.a}constructor(b,f){super(),this.c=b,this.f=f,this.a=!1,this.b=this.B(new A.$oe),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const b=await(0,j.$3s)(this.c);this.hasChildProcesses=this.j(b)}catch(b){this.f.debug("ChildProcessMonitor: Fetching process tree failed",b)}}h(){this.g()}j(b){if(!b.children)return!1;if(b.children.length===1){const f=b.children[0];let l;if(f.cmd.startsWith('"'))l=f.cmd.substring(1,f.cmd.indexOf('"',1));else{const c=f.cmd.indexOf(" ");c===-1?l=f.cmd:l=f.cmd.substring(0,c)}return e.$Knc.indexOf((0,o.$tc)(l).name)===-1}return b.children.length>0}};e.$Lnc=r,me([(0,t.$bi)($.ActiveDebounceDuration)],r.prototype,"g",null),me([(0,t.$ci)($.InactiveThrottleDuration)],r.prototype,"h",null),e.$Lnc=r=me([Be(1,_.$dk)],r)}),define(he[96],fe([0,1,4,2,16]),function(ie,e,o,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;class m extends t.$Xc{constructor(){super(),this.a=this.B(new o.$oe),this.onBeat=this.a.event;const _=setInterval(()=>{this.a.fire()},A.HeartbeatConstants.BeatInterval);this.B((0,t.$Vc)(()=>clearInterval(_)))}}e.$Mnc=m}),define(he[42],fe([0,1,21,20,33,5,3,15,10,9,28,39,89,88]),function(ie,e,o,t,A,m,j,_,$,r,v,b,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=c,e.$Ss=u,e.$Ts=h,o=Se(o),m=Se(m),_=Se(_),v=Se(v);function c(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(o.release());let L=0;return w&&w.length===4&&(L=parseInt(w[3])),L}async function u(w,L,k,O=_.env,z=v.Promises.exists){if(m.$lc(w))return await z(w)?w:void 0;if(L===void 0&&(L=_.cwd()),m.$pc(w)!=="."){const I=m.$mc(L,w);return await z(I)?I:void 0}const y=(0,A.$oo)(O,"PATH");if(k===void 0&&(0,r.$hg)(y)&&(k=y.split(m.$wc)),k===void 0||k.length===0){const I=m.$mc(L,w);return await z(I)?I:void 0}for(const I of k){let P;if(m.$lc(I)?P=m.$mc(I,w):P=m.$mc(L,I,w),await z(P))return P;if(j.$j){let C=P+".com";if(await z(C)||(C=P+".exe",await z(C)))return C}}const N=m.$mc(L,w);return await z(N)?N:void 0}function h(w,L,k,O,z){const D=j.$j&&(!L.windowsEnableConpty||c()<18309);if(!L.shellIntegration.enabled||!w.executable||w.isFeatureTerminal&&!w.forceShellIntegration||w.ignoreShellIntegration||D)return;const y=w.args,N=_.$gc==="win32"?m.$qc(w.executable).toLowerCase():m.$qc(w.executable),I=m.$pc(t.$3g.asFileUri("").fsPath);let P;const C={VSCODE_INJECTION:"1"};if(L.shellIntegration.nonce&&(C.VSCODE_NONCE=L.shellIntegration.nonce),j.$j){if(N==="pwsh.exe"||N==="powershell.exe")return!y||R(y)?P=p.get(s.WindowsPwsh):g(y)&&(P=p.get(s.WindowsPwshLogin)),P?(P=[...P],P[P.length-1]=(0,$.$gf)(P[P.length-1],I,""),C.VSCODE_STABLE=z.quality==="stable"?"1":"0",L.shellIntegration.suggestEnabled&&(C.VSCODE_SUGGEST="1"),{newArgs:P,envMixin:C}):void 0;if(N==="bash.exe")return!y||y.length===0?P=p.get(s.Bash):q(y)&&(C.VSCODE_SHELL_LOGIN="1",a(L,C),P=p.get(s.Bash)),P?(P=[...P],P[P.length-1]=(0,$.$gf)(P[P.length-1],I),C.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:P,envMixin:C}):void 0;O.warn(`Shell integration cannot be enabled for executable "${w.executable}" and args`,w.args);return}switch(N){case"bash":return!y||y.length===0?P=p.get(s.Bash):q(y)&&(C.VSCODE_SHELL_LOGIN="1",a(L,C),P=p.get(s.Bash)),P?(P=[...P],P[P.length-1]=(0,$.$gf)(P[P.length-1],I),C.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:P,envMixin:C}):void 0;case"fish":{const Q=k?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=m.$mc(I,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return C.XDG_DATA_DIRS=`${Q}:${V}`,a(L,C),{newArgs:void 0,envMixin:C}}case"pwsh":return!y||R(y)?P=p.get(s.Pwsh):g(y)&&(P=p.get(s.PwshLogin)),P?(L.shellIntegration.suggestEnabled&&(C.VSCODE_SUGGEST="1"),P=[...P],P[P.length-1]=(0,$.$gf)(P[P.length-1],I,""),C.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:P,envMixin:C}):void 0;case"zsh":{if(!y||y.length===0?P=p.get(s.Zsh):q(y)?(P=p.get(s.ZshLogin),a(L,C)):(y===p.get(s.Zsh)||y===p.get(s.ZshLogin))&&(P=y),!P)return;P=[...P],P[P.length-1]=(0,$.$gf)(P[P.length-1],I);let Q;try{Q=o.userInfo().username}catch{Q="unknown"}const V=m.$mc(o.tmpdir(),`${Q}-${z.applicationName}-zsh`);C.ZDOTDIR=V;const Z=k?.ZDOTDIR??o.homedir()??"~";C.USER_ZDOTDIR=Z;const re=[];return re.push({source:m.$mc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:m.$mc(V,".zshrc")}),re.push({source:m.$mc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:m.$mc(V,".zprofile")}),re.push({source:m.$mc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:m.$mc(V,".zshenv")}),re.push({source:m.$mc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:m.$mc(V,".zlogin")}),{newArgs:P,envMixin:C,filesToCopy:re}}}O.warn(`Shell integration cannot be enabled for executable "${w.executable}" and args`,w.args)}function a(w,L){if(j.$k&&w.environmentVariableCollections){const k=(0,f.$Ps)(w.environmentVariableCollections),z=new l.$Qs(k).getVariableMap({workspaceFolder:w.workspaceFolder}).get("PATH"),D=[];if(z)for(const y of z)y.type===b.EnvironmentVariableMutatorType.Prepend&&D.push(y.value);D.length>0&&(L.VSCODE_PATH_PREFIX=D.join(""))}}var s;(function(w){w.WindowsPwsh="windows-pwsh",w.WindowsPwshLogin="windows-pwsh-login",w.Pwsh="pwsh",w.PwshLogin="pwsh-login",w.Zsh="zsh",w.ZshLogin="zsh-login",w.Bash="bash"})(s||(s={}));const p=new Map;p.set(s.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(s.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(s.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(s.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(s.Zsh,["-i"]),p.set(s.ZshLogin,["-il"]),p.set(s.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],S=["--login","-l"],i=["-i","--interactive"],n=["-nol","-nologo"];function g(w){return typeof w=="string"?E.includes(w.toLowerCase()):w.length===1&&E.includes(w[0].toLowerCase())||w.length===2&&(E.includes(w[0].toLowerCase())||E.includes(w[1].toLowerCase()))&&(n.includes(w[0].toLowerCase())||n.includes(w[1].toLowerCase()))}function R(w){return typeof w=="string"?n.includes(w.toLowerCase()):w.length===0||w?.length===1&&n.includes(w[0].toLowerCase())}function q(w){return typeof w!="string"&&(w=w.filter(L=>!i.includes(L.toLowerCase()))),w==="string"&&S.includes(w.toLowerCase())||typeof w!="string"&&w.length===1&&S.includes(w[0].toLowerCase())}}),define(he[97],fe([0,1,11,14,4,2,3,16]),function(ie,e,o,t,A,m,j,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0;const $=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let r;class v extends m.$Xc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(f){if(super(),this.h=f,this.c="",this.f=new A.$oe,this.g=new A.$oe,!j.$j)throw new Error(`WindowsShellHelper cannot be instantiated on ${j.$v}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){j.$j&&(await(0,o.$Jh)(300),this.getShellName().then(f=>{const l=this.getShellType(f);l!==this.b&&(this.g.fire(l),this.f.fire(f),this.b=l,this.c=f)}))}m(f){if(!f)return"";if($.indexOf(f.name)===-1||!f.children||f.children.length===0)return f.name;let l=0;for(;l<f.children.length;l++){const c=f.children[l];if(!c.children||c.children.length===0||c.children[0].name!=="conhost.exe")break}return l>=f.children.length?f.name:this.m(f.children[l])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(r||(r=await new Promise((f,l)=>{ie(["@vscode/windows-process-tree"],f,l)}).then(Se)),this.a=new Promise(f=>{r.getProcessTree(this.h,l=>{const c=this.m(l);this.a=void 0,f(c)})}),this.a)}getShellType(f){switch(f.toLowerCase()){case"cmd.exe":return _.WindowsShellType.CommandPrompt;case"powershell.exe":case"pwsh.exe":return _.GeneralShellType.PowerShell;case"bash.exe":case"git-cmd.exe":return _.WindowsShellType.GitBash;case"julia.exe:":return _.GeneralShellType.Julia;case"nu.exe":return _.GeneralShellType.NuShell;case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return _.WindowsShellType.Wsl;default:return f.match(/python(\d(\.\d{0,2})?)?\.exe/)?_.GeneralShellType.Python:void 0}}}e.$Nnc=v,me([(0,t.$bi)(500)],v.prototype,"checkShell",null)}),define(he[98],fe([0,1,35,29,11,4,2,5,3,6,12,8,79,16,41,42,97,102,93]),function(ie,e,o,t,A,m,j,_,$,r,v,b,f,l,c,u,h,a,s){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0,o=Se(o),_=Se(_);var E;(function(q){q[q.DataFlushTimeout=250]="DataFlushTimeout",q[q.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(E||(E={}));var S;(function(q){q[q.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",q[q.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",q[q.WriteInterval=5]="WriteInterval"})(S||(S={}));const i=new Map([["bash",l.PosixShellType.Bash],["csh",l.PosixShellType.Csh],["fish",l.PosixShellType.Fish],["ksh",l.PosixShellType.Ksh],["sh",l.PosixShellType.Sh],["zsh",l.PosixShellType.Zsh]]),n=new Map([["pwsh",l.GeneralShellType.PowerShell],["python",l.GeneralShellType.Python],["julia",l.GeneralShellType.Julia],["nu",l.GeneralShellType.NuShell]]);let g=class extends j.$Xc{static{p=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return $.$j?this.t?.shellType:i.get(this.n)||n.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(w,L,k,O,z,D,y,N,I){super(),this.shellLaunchConfig=w,this.N=D,this.O=y,this.P=N,this.Q=I,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new m.$oe),this.onProcessData=this.I.event,this.J=this.B(new m.$oe),this.onProcessReady=this.J.event,this.L=this.B(new m.$oe),this.onDidChangeProperty=this.L.event,this.M=this.B(new m.$oe),this.onProcessExit=this.M.event;let P;$.$j?P=_.$qc(this.shellLaunchConfig.executable||""):P="xterm-256color",this.D=L,this.a[l.ProcessPropertyType.InitialCwd]=this.D,this.a[l.ProcessPropertyType.Cwd]=this.D;const C=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,u.$Rs)()>=18309,Q=C&&this.O.windowsUseConptyDll;this.F={name:P,cwd:L,env:z,cols:k,rows:O,useConpty:C,useConptyDll:Q,conptyInheritCursor:C&&!!w.initialText},$.$j&&(C&&k===0&&O===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new R,this.B(this.C.onTrigger(V=>{this.C?.dispose(),this.C=void 0,V.cols&&V.rows&&this.resize(V.cols,V.rows)}))),this.onProcessReady(V=>{this.t=this.B(new h.$Nnc(V.pid)),this.B(this.t.onShellTypeChanged(Z=>this.L.fire({type:l.ProcessPropertyType.ShellType,value:Z}))),this.B(this.t.onShellNameChanged(Z=>this.L.fire({type:l.ProcessPropertyType.Title,value:Z})))})),this.B((0,j.$Vc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const L=(await Promise.all([this.R(),this.S()])).find(O=>O!==void 0);if(L)return L;let k;if(this.O.shellIntegration.enabled)if(k=(0,u.$Ts)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),k){if(this.L.fire({type:l.ProcessPropertyType.UsedShellIntegrationInjection,value:!0}),k.envMixin)for(const[O,z]of Object.entries(k.envMixin))this.F.env||={},this.F.env[O]=z;if(k.filesToCopy)for(const O of k.filesToCopy)try{await o.promises.mkdir(_.$pc(O.dest),{recursive:!0}),await o.promises.copyFile(O.source,O.dest)}catch{}}else this.L.fire({type:l.ProcessPropertyType.FailedShellIntegrationActivation,value:!0});try{return await this.U(this.shellLaunchConfig,this.F,k),k?.newArgs?{injectedArgs:k.newArgs}:void 0}catch(O){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",O),{message:`A native exception occurred during launch (${O.message})`}}}async R(){try{if(!(await o.promises.stat(this.D)).isDirectory())return{message:(0,v.localize)(2119,null,this.D.toString())}}catch(w){if(w?.code==="ENOENT")return{message:(0,v.localize)(2120,null,this.D.toString())}}this.L.fire({type:l.ProcessPropertyType.InitialCwd,value:this.D})}async S(){const w=this.shellLaunchConfig;if(!w.executable)throw new Error("IShellLaunchConfig.executable not set");const L=w.cwd instanceof r.URI?w.cwd.path:w.cwd,k=w.env&&w.env.PATH?w.env.PATH.split(_.$wc):void 0,O=await(0,u.$Ss)(w.executable,L,k,this.N);if(!O)return{message:(0,v.localize)(2121,null,w.executable)};try{const z=await o.promises.stat(O);if(!z.isFile()&&!z.isSymbolicLink())return{message:(0,v.localize)(2122,null,w.executable)};w.executable=O}catch(z){if(z?.code!=="EACCES")throw z}}async U(w,L,k){const O=k?.newArgs||w.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",w.executable,O,L);const z=(0,a.spawn)(w.executable,O,L);this.m=z,this.u=this.B(new c.$Lnc(z.pid,this.P)),this.u.onDidChangeHasChildProcesses(D=>this.L.fire({type:l.ProcessPropertyType.HasChildProcesses,value:D})),this.s=new Promise(D=>{this.onProcessReady(()=>D())}),z.onData(D=>{this.H+=D.length,!this.G&&this.H>l.FlowControlConstants.HighWatermarkChars&&(this.P.trace(`Flow control: Pause (${this.H} > ${l.FlowControlConstants.HighWatermarkChars})`),this.G=!0,z.pause()),this.P.trace("node-pty.IPty#onData",D),this.I.fire(D),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),z.onExit(D=>{this.g=D.exitCode,this.X()}),this.$(z.pid),this.W(z)}W(w){setTimeout(()=>this.ab(w)),$.$j||(this.w=setInterval(()=>{this.n!==w.process&&this.ab(w)},200))}X(){this.P.getLevel()===b.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},E.DataFlushTimeout)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!$.$j||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-p.b<S.KillSpawnThrottleInterval;)this.P.trace("Throttling kill/spawn call"),await(0,A.$Jh)(S.KillSpawnThrottleInterval-(Date.now()-p.b)+S.KillSpawnSpacingDuration);p.b=Date.now()}}$(w){this.J.fire({pid:w,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(w){if(this.q.isDisposed)return;this.n=w.process??"",this.L.fire({type:l.ProcessPropertyType.Title,value:this.n});const L=this.currentTitle.replace(/ \(figterm\)$/g,"");if(L.toLowerCase().startsWith("python"))this.L.fire({type:l.ProcessPropertyType.ShellType,value:l.GeneralShellType.Python});else if(L.toLowerCase().startsWith("julia"))this.L.fire({type:l.ProcessPropertyType.ShellType,value:l.GeneralShellType.Julia});else{const k=i.get(L)||n.get(L);this.L.fire({type:l.ProcessPropertyType.ShellType,value:k})}}shutdown(w){this.P.getLevel()===b.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),w&&!$.$j?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},E.MaximumShutdownTime))}input(w,L=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,s.$ss)(w).map(k=>({isBinary:L,data:k}))),this.bb())}async processBinary(w){this.input(w,!0)}async refreshProperty(w){switch(w){case l.ProcessPropertyType.Cwd:{const L=await this.getCwd();return L!==this.a.cwd&&(this.a.cwd=L,this.L.fire({type:l.ProcessPropertyType.Cwd,value:this.a.cwd})),L}case l.ProcessPropertyType.InitialCwd:{const L=await this.getInitialCwd();return L!==this.a.initialCwd&&(this.a.initialCwd=L,this.L.fire({type:l.ProcessPropertyType.InitialCwd,value:this.a.initialCwd})),L}case l.ProcessPropertyType.Title:return this.currentTitle;default:return this.shellType}}async updateProperty(w,L){w===l.ProcessPropertyType.FixedDimensions&&(this.a.fixedDimensions=L)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},S.WriteInterval)}}cb(){const w=this.y.shift();this.P.trace("node-pty.IPty#write",w.data),w.isBinary?this.m.write(Buffer.from(w.data,"binary")):this.m.write(w.data),this.u?.handleInput()}resize(w,L){if(!this.q.isDisposed&&!(typeof w!="number"||typeof L!="number"||isNaN(w)||isNaN(L))&&this.m){if(w=Math.max(w,1),L=Math.max(L,1),this.C){this.C.cols=w,this.C.rows=L;return}this.P.trace("node-pty.IPty#resize",w,L);try{this.m.resize(w,L)}catch(k){if(this.P.trace("node-pty.IPty#resize exception "+k.message),this.g!==void 0&&k.message!=="ioctl(2) failed, EBADF"&&k.message!=="Cannot resize a pty that has already exited")throw k}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(w){this.H=Math.max(this.H-w,0),this.P.trace(`Flow control: Ack ${w} chars (unacknowledged: ${this.H})`),this.G&&this.H<l.FlowControlConstants.LowWatermarkChars&&(this.P.trace(`Flow control: Resume (${this.H} < ${l.FlowControlConstants.LowWatermarkChars})`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if($.$k)return new Promise(w=>{if(!this.m){w(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,t.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(L,k,O)=>{!L&&k!==""?w(k.substring(k.indexOf("/"),k.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",L,k,O),w(this.D))})});if($.$l){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await o.promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return $.$j?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,u.$Rs)()}:void 0}};e.$Onc=g,e.$Onc=g=p=me([Be(7,b.$dk),Be(8,f.$wk)],g);class R extends j.$Xc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new m.$oe),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,j.$Vc)(()=>clearTimeout(this.a)))}}}),define(he[99],fe([0,1,29,11,4,2,3,62,8,90,16,92,40,42,98,12,41,91,7,95,94,71,14,103,104]),function(ie,e,o,t,A,m,j,_,$,r,v,b,f,l,c,u,h,a,s,p,E,S,i,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0,e.$Pnc=R,n=Se(n);function R(N,I,P){if(typeof P.value!="function")throw new Error("not supported");const C="value",Q=P.value;P[C]=async function(...V){this.traceRpcArgs.logService.getLevel()===$.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${Q.name}(${V.map(re=>JSON.stringify(re)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,t.$Jh)(this.traceRpcArgs.simulatedLatency);let Z;try{Z=await Q.apply(this,V)}catch(re){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${Q.name}`,re),re}return this.traceRpcArgs.logService.getLevel()===$.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${Q.name}`,Z),Z}}let q,w;class L extends m.$Xc{H(I,P){return P(C=>{this.I.getLevel()===$.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${I}.fire(${JSON.stringify(C)})`)}),P}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(I,P,C,Q){super(),this.I=I,this.J=P,this.L=C,this.M=Q,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new A.$oe),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new A.$oe),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new A.$oe),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new A.$oe),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new A.$oe),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new A.$oe),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new A.$oe),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new A.$oe),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,m.$Vc)(()=>{for(const V of this.a.values())V.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$Bs(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(I){h.$Knc.length=0,h.$Knc.push(...I)}async requestDetachInstance(I,P){return this.f.createRequest({workspaceId:I,instanceId:P})}async acceptDetachInstanceReply(I,P){let C;const Q=this.a.get(P);Q&&(C=await this.S(P,Q)),this.f.acceptReply(I,C)}async freePortKillProcess(I){const C=(await new Promise((Q,V)=>{(0,o.exec)(j.$j?`netstat -ano | findstr "${I}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${I}`,{},(Z,re)=>{if(Z)return V("Problem occurred when listing active processes");Q(re)})})).split(/\r?\n/).filter(Q=>!!Q.trim());if(C.length>=1){const Q=/\s+(\d+)(?:\s+|$)/,V=C[0].match(Q)?.[1];if(V)try{process.kill(Number.parseInt(V))}catch{}else throw new Error(`Processes for port ${I} were not found`);return{port:I,processId:V}}throw new Error(`Could not kill process with port ${I}`)}async serializeTerminalState(I){const P=[];for(const[Q,V]of this.a.entries())V.hasWrittenData&&I.indexOf(Q)!==-1&&P.push(t.Promises.withAsyncBody(async Z=>{Z({id:Q,shellLaunchConfig:V.shellLaunchConfig,processDetails:await this.S(Q,V),processLaunchConfig:V.processLaunchOptions,unicodeVersion:V.unicodeVersion,replayEvent:await V.serializeNormalBuffer(),timestamp:Date.now()})}));const C={version:1,state:await Promise.all(P)};return JSON.stringify(C)}async reviveTerminalProcesses(I,P,C){const Q=[];for(const V of P)Q.push(this.N(I,V));await Promise.all(Q)}async N(I,P){const C=(0,u.localize)(2118,null),Q=await this.createProcess({...P.shellLaunchConfig,cwd:P.processDetails.cwd,color:P.processDetails.color,icon:P.processDetails.icon,name:P.processDetails.titleSource===v.TitleEventSource.Api?P.processDetails.title:void 0,initialText:P.replayEvent.events[0].data+(0,E.$SYb)(C,{loudFormatting:!0})},P.processDetails.cwd,P.replayEvent.events[0].cols,P.replayEvent.events[0].rows,P.unicodeVersion,P.processLaunchConfig.env,P.processLaunchConfig.executableEnv,P.processLaunchConfig.options,!0,P.processDetails.workspaceId,P.processDetails.workspaceName,!0,P.replayEvent.events[0].data),V=this.R(I,P.id);this.g.set(V,{newId:Q,state:P}),this.I.info(`Revived process, old id ${V} -> new id ${Q}`)}async shutdownAll(){this.dispose()}async createProcess(I,P,C,Q,V,Z,re,ae,X,F,J,ee,le){if(I.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const W=++this.n,ce=new c.$Onc(I,P,C,Q,Z,re,ae,this.I,this.J),de={env:Z,executableEnv:re,options:ae},te=new O(W,ce,F,J,X,C,Q,de,V,this.L,this.I,ee&&typeof I.initialText=="string"?I.initialText:void 0,le,I.icon,I.color,I.name,I.fixedDimensions);return ce.onProcessExit(d=>{te.dispose(),this.a.delete(W),this.C.fire({id:W,event:d})}),te.onProcessData(d=>this.w.fire({id:W,event:d})),te.onProcessReplay(d=>this.y.fire({id:W,event:d})),te.onProcessReady(d=>this.z.fire({id:W,event:d})),te.onProcessOrphanQuestion(()=>this.D.fire({id:W})),te.onDidChangeProperty(d=>this.G.fire({id:W,property:d})),te.onPersistentProcessReady(()=>{for(const d of this.j.entries())te.installAutoReply(d[0],d[1])}),this.a.set(W,te),W}async attachToProcess(I){try{await this.U(I).attach(),this.I.info(`Persistent process reconnection "${I}"`)}catch(P){throw this.I.warn(`Persistent process reconnection "${I}" failed`,P.message),P}}async updateTitle(I,P,C){this.U(I).setTitle(P,C)}async updateIcon(I,P,C,Q){this.U(I).setIcon(P,C,Q)}async clearBuffer(I){this.U(I).clearBuffer()}async refreshProperty(I,P){return this.U(I).refreshProperty(P)}async updateProperty(I,P,C){return this.U(I).updateProperty(P,C)}async detachFromProcess(I,P){return this.U(I).detach(P)}async reduceConnectionGraceTime(){for(const I of this.a.values())I.reduceGraceTime()}async listProcesses(){const I=Array.from(this.a.entries()).filter(([Q,V])=>V.shouldPersistTerminal);this.I.info(`Listing ${I.length} persistent terminals, ${this.a.size} total terminals`);const P=I.map(async([Q,V])=>this.S(Q,V));return(await Promise.all(P)).filter(Q=>Q.isOrphan)}async getPerformanceMarks(){return n.getMarks()}async start(I){const P=this.a.get(I);return P?P.start():{message:`Could not find pty with id "${I}"`}}async shutdown(I,P){return this.a.get(I)?.shutdown(P)}async input(I,P){return this.U(I).input(P)}async processBinary(I,P){return this.U(I).writeBinary(P)}async resize(I,P,C){return this.U(I).resize(P,C)}async getInitialCwd(I){return this.U(I).getInitialCwd()}async getCwd(I){return this.U(I).getCwd()}async acknowledgeDataEvent(I,P){return this.U(I).acknowledgeDataEvent(P)}async setUnicodeVersion(I,P){return this.U(I).setUnicodeVersion(P)}async getLatency(){return[]}async orphanQuestionReply(I){return this.U(I).orphanQuestionReply()}async installAutoReply(I,P){this.j.set(I,P);for(const C of this.a.values())C.installAutoReply(I,P)}async uninstallAllAutoReplies(){for(const I of this.j.keys())for(const P of this.a.values())P.uninstallAutoReply(I)}async uninstallAutoReply(I){for(const P of this.a.values())P.uninstallAutoReply(I)}async getDefaultSystemShell(I=j.OS){return(0,_.$Dm)(I,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(I,P){if(P==="win-to-unix"){if(!j.$j)return I;if((0,l.$Rs)()<17063)return I.replace(/\\/g,"/");const C=this.O();return C?new Promise(Q=>{(0,o.execFile)(C,["-e","wslpath",I],{},(Z,re,ae)=>{Q(Z?I:(0,f.$tR)(re.trim()))}).stdin.end()}):I}if(P==="unix-to-win"&&j.$j){if((0,l.$Rs)()<17063)return I;const C=this.O();return C?new Promise(Q=>{(0,o.execFile)(C,["-e","wslpath","-w",I],{},(Z,re,ae)=>{Q(Z?I:re.trim())}).stdin.end()}):I}return I}O(){const I=(0,l.$Rs)()>=16299,P=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=process.env.SystemRoot;if(C)return(0,S.join)(C,P?"Sysnative":"System32",I?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(I,P){try{return this.g.get(this.R(I,P))?.newId}catch(C){this.I.warn(`Couldn't find terminal ID ${I}-${P}`,C.message)}}async setTerminalLayoutInfo(I){this.b.set(I.workspaceId,I)}async getTerminalLayoutInfo(I){n.mark("code/willGetTerminalLayoutInfo");const P=this.b.get(I.workspaceId);if(P){const C=new Set,V=(await Promise.all(P.tabs.map(async Z=>this.P(I.workspaceId,Z,C)))).filter(Z=>Z.terminals.length>0);return n.mark("code/didGetTerminalLayoutInfo"),{tabs:V}}n.mark("code/didGetTerminalLayoutInfo")}async P(I,P,C){const V=(await Promise.all(P.terminals.map(Z=>this.Q(I,Z,C)))).filter(Z=>Z.terminal!==null);return{isActive:P.isActive,activePersistentProcessId:P.activePersistentProcessId,terminals:V}}async Q(I,P,C){try{const Q=this.R(I,P.terminal),V=this.g.get(Q)?.newId;this.I.info(`Expanding terminal instance, old id ${Q} -> new id ${V}`),this.g.delete(Q);const Z=V??P.terminal;if(C.has(Z))throw new Error(`Terminal ${Z} has already been expanded`);C.add(Z);const re=this.U(Z);return{terminal:{...re&&await this.S(P.terminal,re,V!==void 0),id:Z},relativeSize:P.relativeSize}}catch(Q){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",Q.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",P),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:P.relativeSize}}}R(I,P){return`${I}-${P}`}async S(I,P,C=!1){n.mark(`code/willBuildProcessDetails/${I}`);const[Q,V]=await Promise.all([P.getCwd(),C?!0:P.isOrphaned()]),Z={id:I,title:P.title,titleSource:P.titleSource,pid:P.pid,workspaceId:P.workspaceId,workspaceName:P.workspaceName,cwd:Q,isOrphan:V,icon:P.icon,color:P.color,fixedDimensions:P.fixedDimensions,environmentVariableCollections:P.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:P.shellLaunchConfig.reconnectionProperties,waitOnExit:P.shellLaunchConfig.waitOnExit,hideFromUser:P.shellLaunchConfig.hideFromUser,isFeatureTerminal:P.shellLaunchConfig.isFeatureTerminal,type:P.shellLaunchConfig.type,hasChildProcesses:P.hasChildProcesses,shellIntegrationNonce:P.processLaunchOptions.options.shellIntegration.nonce};return n.mark(`code/didBuildProcessDetails/${I}`),Z}U(I){const P=this.a.get(I);if(!P)throw new s.$db("Could not find pty on pty host");return P}}e.$Qnc=L,me([i.$ai],L.prototype,"traceRpcArgs",null),me([R],L.prototype,"refreshIgnoreProcessNames",null),me([R],L.prototype,"requestDetachInstance",null),me([R],L.prototype,"acceptDetachInstanceReply",null),me([R],L.prototype,"freePortKillProcess",null),me([R],L.prototype,"serializeTerminalState",null),me([R],L.prototype,"reviveTerminalProcesses",null),me([R],L.prototype,"shutdownAll",null),me([R],L.prototype,"createProcess",null),me([R],L.prototype,"attachToProcess",null),me([R],L.prototype,"updateTitle",null),me([R],L.prototype,"updateIcon",null),me([R],L.prototype,"clearBuffer",null),me([R],L.prototype,"refreshProperty",null),me([R],L.prototype,"updateProperty",null),me([R],L.prototype,"detachFromProcess",null),me([R],L.prototype,"reduceConnectionGraceTime",null),me([R],L.prototype,"listProcesses",null),me([R],L.prototype,"getPerformanceMarks",null),me([R],L.prototype,"start",null),me([R],L.prototype,"shutdown",null),me([R],L.prototype,"input",null),me([R],L.prototype,"processBinary",null),me([R],L.prototype,"resize",null),me([R],L.prototype,"getInitialCwd",null),me([R],L.prototype,"getCwd",null),me([R],L.prototype,"acknowledgeDataEvent",null),me([R],L.prototype,"setUnicodeVersion",null),me([R],L.prototype,"getLatency",null),me([R],L.prototype,"orphanQuestionReply",null),me([R],L.prototype,"installAutoReply",null),me([R],L.prototype,"uninstallAllAutoReplies",null),me([R],L.prototype,"uninstallAutoReply",null),me([R],L.prototype,"getDefaultSystemShell",null),me([R],L.prototype,"getEnvironment",null),me([R],L.prototype,"getWslPath",null),me([R],L.prototype,"getRevivedPtyNewId",null),me([R],L.prototype,"setTerminalLayoutInfo",null),me([R],L.prototype,"getTerminalLayoutInfo",null);var k;(function(N){N.None="None",N.ReplayOnly="ReplayOnly",N.Session="Session"})(k||(k={}));class O extends m.$Xc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!==k.None}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(I,P){P===v.TitleEventSource.Api&&(this.j.setValue(k.Session,"setTitle"),this.P.freeRawReviveBuffer()),this.N=I,this.O=P}setIcon(I,P,C){(!this.Y||"id"in P&&"id"in this.Y&&P.id!==this.Y.id||!this.color||C!==this.Z)&&(this.P.freeRawReviveBuffer(),I&&this.j.setValue(k.Session,"setIcon")),this.Y=P,this.Z=C}S(I){this.R=I}constructor(I,P,C,Q,V,Z,re,ae,X,F,J,ee,le,W,ce,de,te){super(),this.U=I,this.W=P,this.workspaceId=C,this.workspaceName=Q,this.shouldPersistTerminal=V,this.processLaunchOptions=ae,this.unicodeVersion=X,this.X=J,this.Y=W,this.Z=ce,this.b=new Map,this.f=new Map,this.g=!1,this.w=new t.$Ph,this.C=this.B(new A.$oe),this.onProcessReplay=this.C.event,this.D=this.B(new A.$oe),this.onProcessReady=this.D.event,this.F=this.B(new A.$oe),this.onPersistentProcessReady=this.F.event,this.G=this.B(new A.$oe),this.onProcessData=this.G.event,this.H=this.B(new A.$oe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new A.$oe),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=v.TitleEventSource.Process,this.j=new z(`Persistent process "${this.U}" interaction state`,k.None,this.X),this.Q=ee!==void 0,this.P=new D(Z,re,F.scrollback,X,ee,ae.options.shellIntegration.nonce,V?le:void 0,this.X),de&&this.setTitle(de,v.TitleEventSource.Api),this.R=te,this.n=null,this.u=0,this.y=this.B(new t.$Vh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${y(F.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},F.graceTime)),this.z=this.B(new t.$Vh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${y(F.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},F.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(d=>{this.L=d.pid,this.M=d.cwd,this.D.fire(d)})),this.B(this.W.onDidChangeProperty(d=>{this.I.fire(d)})),this.a=new b.$myb((d,H)=>this.G.fire(H)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(d=>this.P.handleData(d))),this.B((0,m.$Vc)(()=>{for(const d of this.b.values())d.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(I){this.shouldPersistTerminal&&(this.j.value!==k.None||I)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!==k.Session)}async refreshProperty(I){return this.W.refreshProperty(I)}async updateProperty(I,P){if(I===v.ProcessPropertyType.FixedDimensions)return this.S(P)}async start(){if(!this.g){const I=await this.W.start();return I&&"message"in I||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),I}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:v.ProcessPropertyType.Title,value:this.W.currentTitle}),this.I.fire({type:v.ProcessPropertyType.ShellType,value:this.W.shellType}),this.triggerReplay()}shutdown(I){return this.W.shutdown(I)}input(I){if(this.j.setValue(k.Session,"input"),this.P.freeRawReviveBuffer(),!this.J){for(const P of this.b.values())P.handleInput();return this.W.input(I)}}writeBinary(I){return this.W.processBinary(I)}resize(I,P){if(!this.J){this.P.handleResize(I,P),this.a.flushBuffer(this.U);for(const C of this.b.values())C.handleResize();return this.W.resize(I,P)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(I){this.unicodeVersion=I,this.P.setUnicodeVersion?.(I)}acknowledgeDataEvent(I){if(!this.J)return this.W.acknowledgeDataEvent(I)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value===k.None&&this.j.setValue(k.ReplayOnly,"triggerReplay");const I=await this.P.generateReplayEvent();let P=0;for(const C of I.events)P+=C.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${P} chars and ${I.events.length} size events`),this.C.fire(I),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(I,P){this.b.get(I)?.dispose(),this.b.set(I,new a.$Jnc(this.W,I,P,this.X))}uninstallAutoReply(I){this.b.get(I)?.dispose(),this.b.delete(I)}sendCommandResult(I,P,C){this.f.get(I)&&this.f.delete(I)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const I=this.n;this.n=null,I.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new t.$Ih(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class z{get value(){return this.b}setValue(I,P){this.b!==I&&(this.b=I,this.f(P))}constructor(I,P,C){this.a=I,this.b=P,this.d=C,this.f("initialized")}f(I){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${I}`)}}class D{constructor(I,P,C,Q,V,Z,re,ae){this.f=re,this.a=new g.Terminal({cols:I,rows:P,scrollback:C,allowProposedApi:!0}),V&&this.a.writeln(V),this.setUnicodeVersion(Q),this.b=new p.$dxb(Z,!0,void 0,ae),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(I){this.a.write(I)}handleResize(I,P){this.a.resize(I,P)}clearBuffer(){this.a.clear()}async generateReplayEvent(I,P){const C=new(await this._getSerializeConstructor());this.a.loadAddon(C);const Q={scrollback:this.a.options.scrollback};I&&(Q.excludeAltBuffer=!0,Q.excludeModes=!0);let V;return P&&this.f?V=this.f:V=C.serialize(Q),{events:[{cols:this.a.cols,rows:this.a.rows,data:V}],commands:this.b.serialize()}}async setUnicodeVersion(I){this.a.unicode.activeVersion!==I&&(I==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=I)}async _getUnicode11Constructor(){return w||(w=(await new Promise((I,P)=>{ie(["@xterm/addon-unicode11"],I,P)}).then(Se)).Unicode11Addon),w}async _getSerializeConstructor(){return q||(q=(await new Promise((I,P)=>{ie(["@xterm/addon-serialize"],I,P)}).then(Se)).SerializeAddon),q}}function y(N){let I=0,P=0,C=0;N>=1e3&&(C=Math.floor(N/1e3),N-=C*1e3),C>=60&&(P=Math.floor(C/60),C-=P*60),P>=60&&(I=Math.floor(P/60),P-=I*60);const Q=I?`${I}h`:"",V=P?`${P}m`:"",Z=C?`${C}s`:"",re=N?`${N}ms`:"";return`${Q}${V}${Z}${re}`}});var Ke=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[105],fe([0,1,58,30,63,64,12,69,72,8,74,75,77,78,16,96,99,37,11,2]),function(ie,e,o,t,A,m,j,_,$,r,v,b,f,l,c,u,h,a,s,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),l=Ke(l),E();async function E(){const S=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),i=parseInt(process.env.VSCODE_LATENCY??"0"),n={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,S&&await(0,s.$Jh)(S);const g=(0,a.$rY)(process);let R;g?R=new m.$sY:R=new A.$mr(c.TerminalIpcChannels.PtyHost);const q={_serviceBrand:void 0,...l.default},w=new $.$_m((0,_.$Gm)(process.argv,_.$Fm),q),L=new f.$TR((0,r.$rk)(w),w.logsHome);R.registerChannel(c.TerminalIpcChannels.Logger,new v.$zs(L,()=>o.$Qn));const k=L.createLogger("ptyhost",{name:(0,j.localize)(2117,null)}),O=new b.$4R(k);S&&O.warn(`Pty Host startup is delayed ${S}ms`),i&&O.warn(`Pty host is simulating ${i}ms latency`);const z=new p.$Wc,D=new u.$Mnc;R.registerChannel(c.TerminalIpcChannels.Heartbeat,t.ProxyChannel.fromService(D,z));const y=new h.$Qnc(O,q,n,i),N=t.ProxyChannel.fromService(y,z);R.registerChannel(c.TerminalIpcChannels.PtyHost,N),g&&R.registerChannel(c.TerminalIpcChannels.PtyHostWindow,N),process.once("exit",()=>{O.trace("Pty host exiting"),O.dispose(),D.dispose(),y.dispose()})}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e2b54301a5745870f6b95d81c91fb3e9557d4f08/core/vs/platform/terminal/node/ptyHostMain.js.map
