/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Oe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/path","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/marshalling","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/ternarySearchTree","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/services/search/common/searchExtTypes","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function($e){for(var e=[],y=0,D=$e.length;y<D;y++)e[y]=Oe[$e[y]];return e};define(Oe[72],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=D,e.$bi=C,e.$ci=N;function y(T){return(O,p,s)=>{let I=null,v=null;if(typeof s.value=="function"?(I="value",v=s.value):typeof s.get=="function"&&(I="get",v=s.get),!v)throw new Error("not supported");s[I]=T(v,p)}}function D(T,O,p){let s=null,I=null;if(typeof p.value=="function"?(s="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(s="get",I=p.get),!I)throw new Error("not supported");const v=`$memoize$${O}`;p[s]=function(...h){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,h)}),this[v]}}function C(T,O,p){return y((s,I)=>{const v=`$debounce$${I}`,h=`$debounce$result$${I}`;return function(...E){this[h]||(this[h]=p?p():void 0),clearTimeout(this[v]),O&&(this[h]=O(this[h],...E),E=[this[h]]),this[v]=setTimeout(()=>{s.apply(this,E),this[h]=p?p():void 0},T)}})}function N(T,O,p){return y((s,I)=>{const v=`$throttle$timer$${I}`,h=`$throttle$result$${I}`,E=`$throttle$lastRun$${I}`,f=`$throttle$pending$${I}`;return function(...r){if(this[h]||(this[h]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),O&&(this[h]=O(this[h],...r)),this[f])return;const a=this[E]+T;a<=Date.now()?(this[E]=Date.now(),s.apply(this,[this[h]]),this[h]=p?p():void 0):(this[f]=!0,this[v]=setTimeout(()=>{this[f]=!1,this[E]=Date.now(),s.apply(this,[this[h]]),this[h]=p?p():void 0},a-Date.now()))}})}});var Hn=this&&this.__createBinding||(Object.create?function($e,e,y,D){D===void 0&&(D=y);var C=Object.getOwnPropertyDescriptor(e,y);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[y]}}),Object.defineProperty($e,D,C)}:function($e,e,y,D){D===void 0&&(D=y),$e[D]=e[y]}),Kn=this&&this.__setModuleDefault||(Object.create?function($e,e){Object.defineProperty($e,"default",{enumerable:!0,value:e})}:function($e,e){$e.default=e}),He=this&&this.__importStar||function($e){if($e&&$e.__esModule)return $e;var e={};if($e!=null)for(var y in $e)y!=="default"&&Object.prototype.hasOwnProperty.call($e,y)&&Hn(e,$e,y);return Kn(e,$e),e};define(Oe[136],Ae([1,0,17]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=C,e.$$c=N,e.$_c=T,e.$ad=O,e.$bd=p,e.$cd=s,y=He(y);const D=(E,f)=>E===f;e.$9c=D;function C(E=e.$9c){return(f,r)=>y.$wb(f,r,E)}function N(){return(E,f)=>JSON.stringify(E)===JSON.stringify(f)}function T(){return(E,f)=>E.equals(f)}function O(E,f,r){if(r!==void 0){const a=E;return a==null||f===void 0||f===null?f===a:r(a,f)}else{const a=E;return(c,u)=>c==null||u===void 0||u===null?u===c:a(c,u)}}function p(E,f){if(E===f)return!0;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let r=0;r<E.length;r++)if(!p(E[r],f[r]))return!1;return!0}if(E&&typeof E=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const r=E,a=f,c=Object.keys(r),u=Object.keys(a),i=new Set(u);if(c.length!==u.length)return!1;for(const n of c)if(!i.has(n)||!p(r[n],a[n]))return!1;return!0}return!1}function s(E){return JSON.stringify(h(E))}let I=0;const v=new WeakMap;function h(E){if(Array.isArray(E))return E.map(h);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const f=E,r=Object.create(null);for(const a of Object.keys(f).sort())r[a]=h(f[a]);return r}else{let f=v.get(E);return f===void 0&&(f=I++,v.set(E,f)),f+"----2b76a038c20c4bcc"}return E}}),define(Oe[97],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=e.$IQ=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$IQ=y,e.$JQ=new y("id#")}),define(Oe[137],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Zn=T,e.$1n=v,e.$2n=h,e.$3n=E,e.$4n=f,e.$5n=r,e.$6n=a,e.$7n=c,e.$8n=u,e.$9n=i,e.$0n=n;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function T(t,o=!1){let l=0;const m=t.length;let g="",d=0,S=D.Unknown,k=y.None;function w(M){let Z=0,G=0;for(;Z<M;){const U=t.charCodeAt(l);if(U>=I._0&&U<=I._9)G=G*16+U-I._0;else if(U>=I.A&&U<=I.F)G=G*16+U-I.A+10;else if(U>=I.a&&U<=I.f)G=G*16+U-I.a+10;else break;l++,Z++}return Z<M&&(G=-1),G}function P(M){l=M,g="",d=0,S=D.Unknown,k=y.None}function R(){const M=l;if(t.charCodeAt(l)===I._0)l++;else for(l++;l<t.length&&s(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===I.dot)if(l++,l<t.length&&s(t.charCodeAt(l)))for(l++;l<t.length&&s(t.charCodeAt(l));)l++;else return k=y.UnexpectedEndOfNumber,t.substring(M,l);let Z=l;if(l<t.length&&(t.charCodeAt(l)===I.E||t.charCodeAt(l)===I.e))if(l++,(l<t.length&&t.charCodeAt(l)===I.plus||t.charCodeAt(l)===I.minus)&&l++,l<t.length&&s(t.charCodeAt(l))){for(l++;l<t.length&&s(t.charCodeAt(l));)l++;Z=l}else k=y.UnexpectedEndOfNumber;return t.substring(M,Z)}function $(){let M="",Z=l;for(;;){if(l>=m){M+=t.substring(Z,l),k=y.UnexpectedEndOfString;break}const G=t.charCodeAt(l);if(G===I.doubleQuote){M+=t.substring(Z,l),l++;break}if(G===I.backslash){if(M+=t.substring(Z,l),l++,l>=m){k=y.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case I.doubleQuote:M+='"';break;case I.backslash:M+="\\";break;case I.slash:M+="/";break;case I.b:M+="\b";break;case I.f:M+="\f";break;case I.n:M+=`
`;break;case I.r:M+="\r";break;case I.t:M+="	";break;case I.u:{const V=w(4);V>=0?M+=String.fromCharCode(V):k=y.InvalidUnicode;break}default:k=y.InvalidEscapeCharacter}Z=l;continue}if(G>=0&&G<=31)if(p(G)){M+=t.substring(Z,l),k=y.UnexpectedEndOfString;break}else k=y.InvalidCharacter;l++}return M}function b(){if(g="",k=y.None,d=l,l>=m)return d=m,S=D.EOF;let M=t.charCodeAt(l);if(O(M)){do l++,g+=String.fromCharCode(M),M=t.charCodeAt(l);while(O(M));return S=D.Trivia}if(p(M))return l++,g+=String.fromCharCode(M),M===I.carriageReturn&&t.charCodeAt(l)===I.lineFeed&&(l++,g+=`
`),S=D.LineBreakTrivia;switch(M){case I.openBrace:return l++,S=D.OpenBraceToken;case I.closeBrace:return l++,S=D.CloseBraceToken;case I.openBracket:return l++,S=D.OpenBracketToken;case I.closeBracket:return l++,S=D.CloseBracketToken;case I.colon:return l++,S=D.ColonToken;case I.comma:return l++,S=D.CommaToken;case I.doubleQuote:return l++,g=$(),S=D.StringLiteral;case I.slash:{const Z=l-1;if(t.charCodeAt(l+1)===I.slash){for(l+=2;l<m&&!p(t.charCodeAt(l));)l++;return g=t.substring(Z,l),S=D.LineCommentTrivia}if(t.charCodeAt(l+1)===I.asterisk){l+=2;const G=m-1;let U=!1;for(;l<G;){if(t.charCodeAt(l)===I.asterisk&&t.charCodeAt(l+1)===I.slash){l+=2,U=!0;break}l++}return U||(l++,k=y.UnexpectedEndOfComment),g=t.substring(Z,l),S=D.BlockCommentTrivia}return g+=String.fromCharCode(M),l++,S=D.Unknown}case I.minus:if(g+=String.fromCharCode(M),l++,l===m||!s(t.charCodeAt(l)))return S=D.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return g+=R(),S=D.NumericLiteral;default:for(;l<m&&L(M);)l++,M=t.charCodeAt(l);if(d!==l){switch(g=t.substring(d,l),g){case"true":return S=D.TrueKeyword;case"false":return S=D.FalseKeyword;case"null":return S=D.NullKeyword}return S=D.Unknown}return g+=String.fromCharCode(M),l++,S=D.Unknown}}function L(M){if(O(M)||p(M))return!1;switch(M){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function A(){let M;do M=b();while(M>=D.LineCommentTrivia&&M<=D.Trivia);return M}return{setPosition:P,getPosition:()=>l,scan:o?A:b,getToken:()=>S,getTokenValue:()=>g,getTokenOffset:()=>d,getTokenLength:()=>l-d,getTokenError:()=>k}}function O(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function s(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function v(t,o){const l=[],m=new Object;let g;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k(w,P,R,$){d.value=w,d.offset=P,d.length=R,d.type=$,d.colonOffset=void 0,g=d}try{i(t,{onObjectBegin:(w,P)=>{if(o<=w)throw m;g=void 0,S=o>w,l.push("")},onObjectProperty:(w,P,R)=>{if(o<P||(k(w,P,R,"property"),l[l.length-1]=w,o<=P+R))throw m},onObjectEnd:(w,P)=>{if(o<=w)throw m;g=void 0,l.pop()},onArrayBegin:(w,P)=>{if(o<=w)throw m;g=void 0,l.push(0)},onArrayEnd:(w,P)=>{if(o<=w)throw m;g=void 0,l.pop()},onLiteralValue:(w,P,R)=>{if(o<P||(k(w,P,R,n(w)),o<=P+R))throw m},onSeparator:(w,P,R)=>{if(o<=P)throw m;if(w===":"&&g&&g.type==="property")g.colonOffset=P,S=!1,g=void 0;else if(w===","){const $=l[l.length-1];typeof $=="number"?l[l.length-1]=$+1:(S=!0,l[l.length-1]=""),g=void 0}}})}catch(w){if(w!==m)throw w}return{path:l,previousNode:g,isAtPropertyKey:S,matches:w=>{let P=0;for(let R=0;P<w.length&&R<l.length;R++)if(w[P]===l[R]||w[P]==="*")P++;else if(w[P]!=="**")return!1;return P===w.length}}}function h(t,o=[],l=N.DEFAULT){let m=null,g=[];const d=[];function S(w){Array.isArray(g)?g.push(w):m!==null&&(g[m]=w)}return i(t,{onObjectBegin:()=>{const w={};S(w),d.push(g),g=w,m=null},onObjectProperty:w=>{m=w},onObjectEnd:()=>{g=d.pop()},onArrayBegin:()=>{const w=[];S(w),d.push(g),g=w,m=null},onArrayEnd:()=>{g=d.pop()},onLiteralValue:S,onError:(w,P,R)=>{o.push({error:w,offset:P,length:R})}},l),g[0]}function E(t,o=[],l=N.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(w){m.type==="property"&&(m.length=w-m.offset,m=m.parent)}function d(w){return m.children.push(w),w}i(t,{onObjectBegin:w=>{m=d({type:"object",offset:w,length:-1,parent:m,children:[]})},onObjectProperty:(w,P,R)=>{m=d({type:"property",offset:P,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:w,offset:P,length:R,parent:m})},onObjectEnd:(w,P)=>{m.length=w+P-m.offset,m=m.parent,g(w+P)},onArrayBegin:(w,P)=>{m=d({type:"array",offset:w,length:-1,parent:m,children:[]})},onArrayEnd:(w,P)=>{m.length=w+P-m.offset,m=m.parent,g(w+P)},onLiteralValue:(w,P,R)=>{d({type:n(w),offset:P,length:R,parent:m,value:w}),g(P+R)},onSeparator:(w,P,R)=>{m.type==="property"&&(w===":"?m.colonOffset=P:w===","&&g(P))},onError:(w,P,R)=>{o.push({error:w,offset:P,length:R})}},l);const k=m.children[0];return k&&delete k.parent,k}function f(t,o){if(!t)return;let l=t;for(const m of o)if(typeof m=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let g=!1;for(const d of l.children)if(Array.isArray(d.children)&&d.children[0].value===m){l=d.children[1],g=!0;break}if(!g)return}else{const g=m;if(l.type!=="array"||g<0||!Array.isArray(l.children)||g>=l.children.length)return;l=l.children[g]}return l}function r(t){if(!t.parent||!t.parent.children)return[];const o=r(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;o.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&o.push(l)}return o}function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const o=Object.create(null);for(const l of t.children){const m=l.children[1];m&&(o[l.children[0].value]=a(m))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,o,l=!1){return o>=t.offset&&o<t.offset+t.length||l&&o===t.offset+t.length}function u(t,o,l=!1){if(c(t,o,l)){const m=t.children;if(Array.isArray(m))for(let g=0;g<m.length&&m[g].offset<=o;g++){const d=u(m[g],o,l);if(d)return d}return t}}function i(t,o,l=N.DEFAULT){const m=T(t,!1);function g(se){return se?()=>se(m.getTokenOffset(),m.getTokenLength()):()=>!0}function d(se){return se?ce=>se(ce,m.getTokenOffset(),m.getTokenLength()):()=>!0}const S=g(o.onObjectBegin),k=d(o.onObjectProperty),w=g(o.onObjectEnd),P=g(o.onArrayBegin),R=g(o.onArrayEnd),$=d(o.onLiteralValue),b=d(o.onSeparator),L=g(o.onComment),A=d(o.onError),M=l&&l.disallowComments,Z=l&&l.allowTrailingComma;function G(){for(;;){const se=m.scan();switch(m.getTokenError()){case y.InvalidUnicode:U(C.InvalidUnicode);break;case y.InvalidEscapeCharacter:U(C.InvalidEscapeCharacter);break;case y.UnexpectedEndOfNumber:U(C.UnexpectedEndOfNumber);break;case y.UnexpectedEndOfComment:M||U(C.UnexpectedEndOfComment);break;case y.UnexpectedEndOfString:U(C.UnexpectedEndOfString);break;case y.InvalidCharacter:U(C.InvalidCharacter);break}switch(se){case D.LineCommentTrivia:case D.BlockCommentTrivia:M?U(C.InvalidCommentToken):L();break;case D.Unknown:U(C.InvalidSymbol);break;case D.Trivia:case D.LineBreakTrivia:break;default:return se}}}function U(se,ce=[],te=[]){if(A(se),ce.length+te.length>0){let we=m.getToken();for(;we!==D.EOF;){if(ce.indexOf(we)!==-1){G();break}else if(te.indexOf(we)!==-1)break;we=G()}}}function V(se){const ce=m.getTokenValue();return se?$(ce):k(ce),G(),!0}function Q(){switch(m.getToken()){case D.NumericLiteral:{let se=0;try{se=JSON.parse(m.getTokenValue()),typeof se!="number"&&(U(C.InvalidNumberFormat),se=0)}catch{U(C.InvalidNumberFormat)}$(se);break}case D.NullKeyword:$(null);break;case D.TrueKeyword:$(!0);break;case D.FalseKeyword:$(!1);break;default:return!1}return G(),!0}function ne(){return m.getToken()!==D.StringLiteral?(U(C.PropertyNameExpected,[],[D.CloseBraceToken,D.CommaToken]),!1):(V(!1),m.getToken()===D.ColonToken?(b(":"),G(),oe()||U(C.ValueExpected,[],[D.CloseBraceToken,D.CommaToken])):U(C.ColonExpected,[],[D.CloseBraceToken,D.CommaToken]),!0)}function ue(){S(),G();let se=!1;for(;m.getToken()!==D.CloseBraceToken&&m.getToken()!==D.EOF;){if(m.getToken()===D.CommaToken){if(se||U(C.ValueExpected,[],[]),b(","),G(),m.getToken()===D.CloseBraceToken&&Z)break}else se&&U(C.CommaExpected,[],[]);ne()||U(C.ValueExpected,[],[D.CloseBraceToken,D.CommaToken]),se=!0}return w(),m.getToken()!==D.CloseBraceToken?U(C.CloseBraceExpected,[D.CloseBraceToken],[]):G(),!0}function x(){P(),G();let se=!1;for(;m.getToken()!==D.CloseBracketToken&&m.getToken()!==D.EOF;){if(m.getToken()===D.CommaToken){if(se||U(C.ValueExpected,[],[]),b(","),G(),m.getToken()===D.CloseBracketToken&&Z)break}else se&&U(C.CommaExpected,[],[]);oe()||U(C.ValueExpected,[],[D.CloseBracketToken,D.CommaToken]),se=!0}return R(),m.getToken()!==D.CloseBracketToken?U(C.CloseBracketExpected,[D.CloseBracketToken],[]):G(),!0}function oe(){switch(m.getToken()){case D.OpenBracketToken:return x();case D.OpenBraceToken:return ue();case D.StringLiteral:return V(!0);default:return Q()}}return G(),m.getToken()===D.EOF?l.allowEmptyContent?!0:(U(C.ValueExpected,[],[]),!1):oe()?(m.getToken()!==D.EOF&&U(C.EndOfFileExpected,[],[]),!0):(U(C.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Oe[138],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=y;function y(N){let T=!1;const O=new Map,p=new Map;if(C(N,r=>{if(N===r)return!0;const a=JSON.stringify(r);if(a.length<30)return!0;const c=O.get(a);if(!c){const u={schemas:[r]};return O.set(a,u),p.set(r,u),!0}return c.schemas.push(r),p.set(r,c),T=!0,!1}),O.clear(),!T)return JSON.stringify(N);let I="$defs";for(;N.hasOwnProperty(I);)I+="_";const v=[];function h(r){return JSON.stringify(r,(a,c)=>{if(c!==r){const u=p.get(c);if(u&&u.schemas.length>1)return u.id||(u.id=`_${v.length}`,v.push(u.schemas[0])),{$ref:`#/${I}/${u.id}`}}return c})}const E=h(N),f=[];for(let r=0;r<v.length;r++)f.push(`"_${r}":${h(v[r])}`);return f.length?`${E.substring(0,E.length-1)},"${I}":{${f.join(",")}}}`:E}function D(N){return typeof N=="object"&&N!==null}function C(N,T){if(!N||typeof N!="object")return;const O=(...E)=>{for(const f of E)D(f)&&v.push(f)},p=(...E)=>{for(const f of E)if(D(f))for(const r in f){const a=f[r];D(a)&&v.push(a)}},s=(...E)=>{for(const f of E)if(Array.isArray(f))for(const r of f)D(r)&&v.push(r)},I=E=>{if(Array.isArray(E))for(const f of E)D(f)&&v.push(f);else D(E)&&v.push(E)},v=[N];let h=v.pop();for(;h;)T(h)&&(O(h.additionalItems,h.additionalProperties,h.not,h.contains,h.propertyNames,h.if,h.then,h.else,h.unevaluatedItems,h.unevaluatedProperties),p(h.definitions,h.$defs,h.properties,h.patternProperties,h.dependencies,h.dependentSchemas),s(h.anyOf,h.allOf,h.oneOf,h.prefixItems),I(h.items)),h=v.pop()}}),function($e,e){typeof define=="function"&&define.amd?define(Oe[139],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}$e.defaults=e();function y(nt){$e.defaults=nt}const D=/[&<>"']/,C=new RegExp(D.source,"g"),N=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,T=new RegExp(N.source,"g"),O={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=nt=>O[nt];function s(nt,he){if(he){if(D.test(nt))return nt.replace(C,p)}else if(N.test(nt))return nt.replace(T,p);return nt}const I=/(^|[^\[])\^/g;function v(nt,he){let pe=typeof nt=="string"?nt:nt.source;he=he||"";const ye={replace:(Re,fe)=>{let ve=typeof fe=="string"?fe:fe.source;return ve=ve.replace(I,"$1"),pe=pe.replace(Re,ve),ye},getRegex:()=>new RegExp(pe,he)};return ye}function h(nt){try{nt=encodeURI(nt).replace(/%25/g,"%")}catch{return null}return nt}const E={exec:()=>null};function f(nt,he){const pe=nt.replace(/\|/g,(fe,ve,X)=>{let q=!1,de=ve;for(;--de>=0&&X[de]==="\\";)q=!q;return q?"|":" |"}),ye=pe.split(/ \|/);let Re=0;if(ye[0].trim()||ye.shift(),ye.length>0&&!ye[ye.length-1].trim()&&ye.pop(),he)if(ye.length>he)ye.splice(he);else for(;ye.length<he;)ye.push("");for(;Re<ye.length;Re++)ye[Re]=ye[Re].trim().replace(/\\\|/g,"|");return ye}function r(nt,he,pe){const ye=nt.length;if(ye===0)return"";let Re=0;for(;Re<ye;){const fe=nt.charAt(ye-Re-1);if(fe===he&&!pe)Re++;else if(fe!==he&&pe)Re++;else break}return nt.slice(0,ye-Re)}function a(nt,he){if(nt.indexOf(he[1])===-1)return-1;let pe=0;for(let ye=0;ye<nt.length;ye++)if(nt[ye]==="\\")ye++;else if(nt[ye]===he[0])pe++;else if(nt[ye]===he[1]&&(pe--,pe<0))return ye;return-1}function c(nt,he,pe,ye){const Re=he.href,fe=he.title?s(he.title):null,ve=nt[1].replace(/\\([\[\]])/g,"$1");if(nt[0].charAt(0)!=="!"){ye.state.inLink=!0;const X={type:"link",raw:pe,href:Re,title:fe,text:ve,tokens:ye.inlineTokens(ve)};return ye.state.inLink=!1,X}return{type:"image",raw:pe,href:Re,title:fe,text:s(ve)}}function u(nt,he){const pe=nt.match(/^(\s+)(?:```)/);if(pe===null)return he;const ye=pe[1];return he.split(`
`).map(Re=>{const fe=Re.match(/^\s+/);if(fe===null)return Re;const[ve]=fe;return ve.length>=ye.length?Re.slice(ye.length):Re}).join(`
`)}class i{options;rules;lexer;constructor(he){this.options=he||$e.defaults}space(he){const pe=this.rules.block.newline.exec(he);if(pe&&pe[0].length>0)return{type:"space",raw:pe[0]}}code(he){const pe=this.rules.block.code.exec(he);if(pe){const ye=pe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:pe[0],codeBlockStyle:"indented",text:this.options.pedantic?ye:r(ye,`
`)}}}fences(he){const pe=this.rules.block.fences.exec(he);if(pe){const ye=pe[0],Re=u(ye,pe[3]||"");return{type:"code",raw:ye,lang:pe[2]?pe[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):pe[2],text:Re}}}heading(he){const pe=this.rules.block.heading.exec(he);if(pe){let ye=pe[2].trim();if(/#$/.test(ye)){const Re=r(ye,"#");(this.options.pedantic||!Re||/ $/.test(Re))&&(ye=Re.trim())}return{type:"heading",raw:pe[0],depth:pe[1].length,text:ye,tokens:this.lexer.inline(ye)}}}hr(he){const pe=this.rules.block.hr.exec(he);if(pe)return{type:"hr",raw:r(pe[0],`
`)}}blockquote(he){const pe=this.rules.block.blockquote.exec(he);if(pe){let ye=r(pe[0],`
`).split(`
`),Re="",fe="";const ve=[];for(;ye.length>0;){let X=!1;const q=[];let de;for(de=0;de<ye.length;de++)if(/^ {0,3}>/.test(ye[de]))q.push(ye[de]),X=!0;else if(!X)q.push(ye[de]);else break;ye=ye.slice(de);const We=q.join(`
`),Je=We.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Re=Re?`${Re}
${We}`:We,fe=fe?`${fe}
${Je}`:Je;const ct=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Je,ve,!0),this.lexer.state.top=ct,ye.length===0)break;const dt=ve[ve.length-1];if(dt?.type==="code")break;if(dt?.type==="blockquote"){const mt=dt,Rt=mt.raw+`
`+ye.join(`
`),At=this.blockquote(Rt);ve[ve.length-1]=At,Re=Re.substring(0,Re.length-mt.raw.length)+At.raw,fe=fe.substring(0,fe.length-mt.text.length)+At.text;break}else if(dt?.type==="list"){const mt=dt,Rt=mt.raw+`
`+ye.join(`
`),At=this.list(Rt);ve[ve.length-1]=At,Re=Re.substring(0,Re.length-dt.raw.length)+At.raw,fe=fe.substring(0,fe.length-mt.raw.length)+At.raw,ye=Rt.substring(ve[ve.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Re,tokens:ve,text:fe}}}list(he){let pe=this.rules.block.list.exec(he);if(pe){let ye=pe[1].trim();const Re=ye.length>1,fe={type:"list",raw:"",ordered:Re,start:Re?+ye.slice(0,-1):"",loose:!1,items:[]};ye=Re?`\\d{1,9}\\${ye.slice(-1)}`:`\\${ye}`,this.options.pedantic&&(ye=Re?ye:"[*+-]");const ve=new RegExp(`^( {0,3}${ye})((?:[	 ][^\\n]*)?(?:\\n|$))`);let X=!1;for(;he;){let q=!1,de="",We="";if(!(pe=ve.exec(he))||this.rules.block.hr.test(he))break;de=pe[0],he=he.substring(de.length);let Je=pe[2].split(`
`,1)[0].replace(/^\t+/,Qt=>" ".repeat(3*Qt.length)),ct=he.split(`
`,1)[0],dt=!Je.trim(),mt=0;if(this.options.pedantic?(mt=2,We=Je.trimStart()):dt?mt=pe[1].length+1:(mt=pe[2].search(/[^ ]/),mt=mt>4?1:mt,We=Je.slice(mt),mt+=pe[1].length),dt&&/^ *$/.test(ct)&&(de+=ct+`
`,he=he.substring(ct.length+1),q=!0),!q){const Qt=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),_t=new RegExp(`^ {0,${Math.min(3,mt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),_e=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:\`\`\`|~~~)`),Ot=new RegExp(`^ {0,${Math.min(3,mt-1)}}#`);for(;he;){const Ut=he.split(`
`,1)[0];if(ct=Ut,this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),_e.test(ct)||Ot.test(ct)||Qt.test(ct)||_t.test(he))break;if(ct.search(/[^ ]/)>=mt||!ct.trim())We+=`
`+ct.slice(mt);else{if(dt||Je.search(/[^ ]/)>=4||_e.test(Je)||Ot.test(Je)||_t.test(Je))break;We+=`
`+ct}!dt&&!ct.trim()&&(dt=!0),de+=Ut+`
`,he=he.substring(Ut.length+1),Je=ct.slice(mt)}}fe.loose||(X?fe.loose=!0:/\n *\n *$/.test(de)&&(X=!0));let Rt=null,At;this.options.gfm&&(Rt=/^\[[ xX]\] /.exec(We),Rt&&(At=Rt[0]!=="[ ] ",We=We.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:de,task:!!Rt,checked:At,loose:!1,text:We,tokens:[]}),fe.raw+=de}fe.items[fe.items.length-1].raw=fe.items[fe.items.length-1].raw.trimEnd(),fe.items[fe.items.length-1].text=fe.items[fe.items.length-1].text.trimEnd(),fe.raw=fe.raw.trimEnd();for(let q=0;q<fe.items.length;q++)if(this.lexer.state.top=!1,fe.items[q].tokens=this.lexer.blockTokens(fe.items[q].text,[]),!fe.loose){const de=fe.items[q].tokens.filter(Je=>Je.type==="space"),We=de.length>0&&de.some(Je=>/\n.*\n/.test(Je.raw));fe.loose=We}if(fe.loose)for(let q=0;q<fe.items.length;q++)fe.items[q].loose=!0;return fe}}html(he){const pe=this.rules.block.html.exec(he);if(pe)return{type:"html",block:!0,raw:pe[0],pre:pe[1]==="pre"||pe[1]==="script"||pe[1]==="style",text:pe[0]}}def(he){const pe=this.rules.block.def.exec(he);if(pe){const ye=pe[1].toLowerCase().replace(/\s+/g," "),Re=pe[2]?pe[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",fe=pe[3]?pe[3].substring(1,pe[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):pe[3];return{type:"def",tag:ye,raw:pe[0],href:Re,title:fe}}}table(he){const pe=this.rules.block.table.exec(he);if(!pe||!/[:|]/.test(pe[2]))return;const ye=f(pe[1]),Re=pe[2].replace(/^\||\| *$/g,"").split("|"),fe=pe[3]&&pe[3].trim()?pe[3].replace(/\n[ \t]*$/,"").split(`
`):[],ve={type:"table",raw:pe[0],header:[],align:[],rows:[]};if(ye.length===Re.length){for(const X of Re)/^ *-+: *$/.test(X)?ve.align.push("right"):/^ *:-+: *$/.test(X)?ve.align.push("center"):/^ *:-+ *$/.test(X)?ve.align.push("left"):ve.align.push(null);for(let X=0;X<ye.length;X++)ve.header.push({text:ye[X],tokens:this.lexer.inline(ye[X]),header:!0,align:ve.align[X]});for(const X of fe)ve.rows.push(f(X,ve.header.length).map((q,de)=>({text:q,tokens:this.lexer.inline(q),header:!1,align:ve.align[de]})));return ve}}lheading(he){const pe=this.rules.block.lheading.exec(he);if(pe)return{type:"heading",raw:pe[0],depth:pe[2].charAt(0)==="="?1:2,text:pe[1],tokens:this.lexer.inline(pe[1])}}paragraph(he){const pe=this.rules.block.paragraph.exec(he);if(pe){const ye=pe[1].charAt(pe[1].length-1)===`
`?pe[1].slice(0,-1):pe[1];return{type:"paragraph",raw:pe[0],text:ye,tokens:this.lexer.inline(ye)}}}text(he){const pe=this.rules.block.text.exec(he);if(pe)return{type:"text",raw:pe[0],text:pe[0],tokens:this.lexer.inline(pe[0])}}escape(he){const pe=this.rules.inline.escape.exec(he);if(pe)return{type:"escape",raw:pe[0],text:s(pe[1])}}tag(he){const pe=this.rules.inline.tag.exec(he);if(pe)return!this.lexer.state.inLink&&/^<a /i.test(pe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(pe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:pe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:pe[0]}}link(he){const pe=this.rules.inline.link.exec(he);if(pe){const ye=pe[2].trim();if(!this.options.pedantic&&/^</.test(ye)){if(!/>$/.test(ye))return;const ve=r(ye.slice(0,-1),"\\");if((ye.length-ve.length)%2===0)return}else{const ve=a(pe[2],"()");if(ve>-1){const q=(pe[0].indexOf("!")===0?5:4)+pe[1].length+ve;pe[2]=pe[2].substring(0,ve),pe[0]=pe[0].substring(0,q).trim(),pe[3]=""}}let Re=pe[2],fe="";if(this.options.pedantic){const ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);ve&&(Re=ve[1],fe=ve[3])}else fe=pe[3]?pe[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(ye)?Re=Re.slice(1):Re=Re.slice(1,-1)),c(pe,{href:Re&&Re.replace(this.rules.inline.anyPunctuation,"$1"),title:fe&&fe.replace(this.rules.inline.anyPunctuation,"$1")},pe[0],this.lexer)}}reflink(he,pe){let ye;if((ye=this.rules.inline.reflink.exec(he))||(ye=this.rules.inline.nolink.exec(he))){const Re=(ye[2]||ye[1]).replace(/\s+/g," "),fe=pe[Re.toLowerCase()];if(!fe){const ve=ye[0].charAt(0);return{type:"text",raw:ve,text:ve}}return c(ye,fe,ye[0],this.lexer)}}emStrong(he,pe,ye=""){let Re=this.rules.inline.emStrongLDelim.exec(he);if(!Re||Re[3]&&ye.match(/[\p{L}\p{N}]/u))return;if(!(Re[1]||Re[2]||"")||!ye||this.rules.inline.punctuation.exec(ye)){const ve=[...Re[0]].length-1;let X,q,de=ve,We=0;const Je=Re[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Je.lastIndex=0,pe=pe.slice(-1*he.length+ve);(Re=Je.exec(pe))!=null;){if(X=Re[1]||Re[2]||Re[3]||Re[4]||Re[5]||Re[6],!X)continue;if(q=[...X].length,Re[3]||Re[4]){de+=q;continue}else if((Re[5]||Re[6])&&ve%3&&!((ve+q)%3)){We+=q;continue}if(de-=q,de>0)continue;q=Math.min(q,q+de+We);const ct=[...Re[0]][0].length,dt=he.slice(0,ve+Re.index+ct+q);if(Math.min(ve,q)%2){const Rt=dt.slice(1,-1);return{type:"em",raw:dt,text:Rt,tokens:this.lexer.inlineTokens(Rt)}}const mt=dt.slice(2,-2);return{type:"strong",raw:dt,text:mt,tokens:this.lexer.inlineTokens(mt)}}}}codespan(he){const pe=this.rules.inline.code.exec(he);if(pe){let ye=pe[2].replace(/\n/g," ");const Re=/[^ ]/.test(ye),fe=/^ /.test(ye)&&/ $/.test(ye);return Re&&fe&&(ye=ye.substring(1,ye.length-1)),ye=s(ye,!0),{type:"codespan",raw:pe[0],text:ye}}}br(he){const pe=this.rules.inline.br.exec(he);if(pe)return{type:"br",raw:pe[0]}}del(he){const pe=this.rules.inline.del.exec(he);if(pe)return{type:"del",raw:pe[0],text:pe[2],tokens:this.lexer.inlineTokens(pe[2])}}autolink(he){const pe=this.rules.inline.autolink.exec(he);if(pe){let ye,Re;return pe[2]==="@"?(ye=s(pe[1]),Re="mailto:"+ye):(ye=s(pe[1]),Re=ye),{type:"link",raw:pe[0],text:ye,href:Re,tokens:[{type:"text",raw:ye,text:ye}]}}}url(he){let pe;if(pe=this.rules.inline.url.exec(he)){let ye,Re;if(pe[2]==="@")ye=s(pe[0]),Re="mailto:"+ye;else{let fe;do fe=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])?.[0]??"";while(fe!==pe[0]);ye=s(pe[0]),pe[1]==="www."?Re="http://"+pe[0]:Re=pe[0]}return{type:"link",raw:pe[0],text:ye,href:Re,tokens:[{type:"text",raw:ye,text:ye}]}}}inlineText(he){const pe=this.rules.inline.text.exec(he);if(pe){let ye;return this.lexer.state.inRawBlock?ye=pe[0]:ye=s(pe[0]),{type:"text",raw:pe[0],text:ye}}}}const n=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,o=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,l=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,m=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,g=/(?:[*+-]|\d{1,9}[.)])/,d=v(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,g).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),S=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,k=/^[^\n]+/,w=/(?!\s*\])(?:\\.|[^\[\]\\])+/,P=v(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",w).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),R=v(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,g).getRegex(),$="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",b=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,L=v("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",b).replace("tag",$).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A=v(S).replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex(),Z={blockquote:v(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",A).getRegex(),code:t,def:P,fences:o,heading:m,hr:l,html:L,lheading:d,list:R,newline:n,paragraph:A,table:E,text:k},G=v("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex(),U={...Z,table:G,paragraph:v(S).replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",G).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex()},V={...Z,html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",b).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:v(S).replace("hr",l).replace("heading",` *#{1,6} *[^
]`).replace("lheading",d).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},Q=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,ne=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,ue=/^( {2,}|\\)\n(?!\s*$)/,x=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,oe="\\p{P}\\p{S}",se=v(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,oe).getRegex(),ce=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,te=v(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,oe).getRegex(),we=v("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,oe).getRegex(),Ce=v("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,oe).getRegex(),Y=v(/\\([punct])/,"gu").replace(/punct/g,oe).getRegex(),W=v(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),ee=v(b).replace("(?:-->|$)","-->").getRegex(),be=v("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",ee).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),Pe=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,je=v(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",Pe).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),Te=v(/^!?\[(label)\]\[(ref)\]/).replace("label",Pe).replace("ref",w).getRegex(),Ee=v(/^!?\[(ref)\](?:\[\])?/).replace("ref",w).getRegex(),Fe=v("reflink|nolink(?!\\()","g").replace("reflink",Te).replace("nolink",Ee).getRegex(),Ve={_backpedal:E,anyPunctuation:Y,autolink:W,blockSkip:ce,br:ue,code:ne,del:E,emStrongLDelim:te,emStrongRDelimAst:we,emStrongRDelimUnd:Ce,escape:Q,link:je,nolink:Ee,punctuation:se,reflink:Te,reflinkSearch:Fe,tag:be,text:x,url:E},Ge={...Ve,link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",Pe).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Pe).getRegex()},et={...Ve,escape:v(Q).replace("])","~|])").getRegex(),url:v(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},it={...et,br:v(ue).replace("{2,}","*").getRegex(),text:v(et.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Me={normal:Z,gfm:U,pedantic:V},Ue={normal:Ve,gfm:et,breaks:it,pedantic:Ge};class ze{tokens;options;state;tokenizer;inlineQueue;constructor(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||$e.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const pe={block:Me.normal,inline:Ue.normal};this.options.pedantic?(pe.block=Me.pedantic,pe.inline=Ue.pedantic):this.options.gfm&&(pe.block=Me.gfm,this.options.breaks?pe.inline=Ue.breaks:pe.inline=Ue.gfm),this.tokenizer.rules=pe}static get rules(){return{block:Me,inline:Ue}}static lex(he,pe){return new ze(pe).lex(he)}static lexInline(he,pe){return new ze(pe).inlineTokens(he)}lex(he){he=he.replace(/\r\n|\r/g,`
`),this.blockTokens(he,this.tokens);for(let pe=0;pe<this.inlineQueue.length;pe++){const ye=this.inlineQueue[pe];this.inlineTokens(ye.src,ye.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(he,pe=[],ye=!1){this.options.pedantic?he=he.replace(/\t/g,"    ").replace(/^ +$/gm,""):he=he.replace(/^( *)(\t+)/gm,(X,q,de)=>q+"    ".repeat(de.length));let Re,fe,ve;for(;he;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(X=>(Re=X.call({lexer:this},he,pe))?(he=he.substring(Re.raw.length),pe.push(Re),!0):!1))){if(Re=this.tokenizer.space(he)){he=he.substring(Re.raw.length),Re.raw.length===1&&pe.length>0?pe[pe.length-1].raw+=`
`:pe.push(Re);continue}if(Re=this.tokenizer.code(he)){he=he.substring(Re.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Re.raw,fe.text+=`
`+Re.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Re);continue}if(Re=this.tokenizer.fences(he)){he=he.substring(Re.raw.length),pe.push(Re);continue}if(Re=this.tokenizer.heading(he)){he=he.substring(Re.raw.length),pe.push(Re);continue}if(Re=this.tokenizer.hr(he)){he=he.substring(Re.raw.length),pe.push(Re);continue}if(Re=this.tokenizer.blockquote(he)){he=he.substring(Re.raw.length),pe.push(Re);continue}if(Re=this.tokenizer.list(he)){he=he.substring(Re.raw.length),pe.push(Re);continue}if(Re=this.tokenizer.html(he)){he=he.substring(Re.raw.length),pe.push(Re);continue}if(Re=this.tokenizer.def(he)){he=he.substring(Re.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Re.raw,fe.text+=`
`+Re.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[Re.tag]||(this.tokens.links[Re.tag]={href:Re.href,title:Re.title});continue}if(Re=this.tokenizer.table(he)){he=he.substring(Re.raw.length),pe.push(Re);continue}if(Re=this.tokenizer.lheading(he)){he=he.substring(Re.raw.length),pe.push(Re);continue}if(ve=he,this.options.extensions&&this.options.extensions.startBlock){let X=1/0;const q=he.slice(1);let de;this.options.extensions.startBlock.forEach(We=>{de=We.call({lexer:this},q),typeof de=="number"&&de>=0&&(X=Math.min(X,de))}),X<1/0&&X>=0&&(ve=he.substring(0,X+1))}if(this.state.top&&(Re=this.tokenizer.paragraph(ve))){fe=pe[pe.length-1],ye&&fe?.type==="paragraph"?(fe.raw+=`
`+Re.raw,fe.text+=`
`+Re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Re),ye=ve.length!==he.length,he=he.substring(Re.raw.length);continue}if(Re=this.tokenizer.text(he)){he=he.substring(Re.raw.length),fe=pe[pe.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+Re.raw,fe.text+=`
`+Re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Re);continue}if(he){const X="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,pe}inline(he,pe=[]){return this.inlineQueue.push({src:he,tokens:pe}),pe}inlineTokens(he,pe=[]){let ye,Re,fe,ve=he,X,q,de;if(this.tokens.links){const We=Object.keys(this.tokens.links);if(We.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(ve))!=null;)We.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(ve=ve.slice(0,X.index)+"["+"a".repeat(X[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(ve))!=null;)ve=ve.slice(0,X.index)+"["+"a".repeat(X[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.anyPunctuation.exec(ve))!=null;)ve=ve.slice(0,X.index)+"++"+ve.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;he;)if(q||(de=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(We=>(ye=We.call({lexer:this},he,pe))?(he=he.substring(ye.raw.length),pe.push(ye),!0):!1))){if(ye=this.tokenizer.escape(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.tag(he)){he=he.substring(ye.raw.length),Re=pe[pe.length-1],Re&&ye.type==="text"&&Re.type==="text"?(Re.raw+=ye.raw,Re.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.link(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.reflink(he,this.tokens.links)){he=he.substring(ye.raw.length),Re=pe[pe.length-1],Re&&ye.type==="text"&&Re.type==="text"?(Re.raw+=ye.raw,Re.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.emStrong(he,ve,de)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.codespan(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.br(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.del(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.autolink(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(he))){he=he.substring(ye.raw.length),pe.push(ye);continue}if(fe=he,this.options.extensions&&this.options.extensions.startInline){let We=1/0;const Je=he.slice(1);let ct;this.options.extensions.startInline.forEach(dt=>{ct=dt.call({lexer:this},Je),typeof ct=="number"&&ct>=0&&(We=Math.min(We,ct))}),We<1/0&&We>=0&&(fe=he.substring(0,We+1))}if(ye=this.tokenizer.inlineText(fe)){he=he.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(de=ye.raw.slice(-1)),q=!0,Re=pe[pe.length-1],Re&&Re.type==="text"?(Re.raw+=ye.raw,Re.text+=ye.text):pe.push(ye);continue}if(he){const We="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return pe}}class B{options;parser;constructor(he){this.options=he||$e.defaults}space(he){return""}code({text:he,lang:pe,escaped:ye}){const Re=(pe||"").match(/^\S*/)?.[0],fe=he.replace(/\n$/,"")+`
`;return Re?'<pre><code class="language-'+s(Re)+'">'+(ye?fe:s(fe,!0))+`</code></pre>
`:"<pre><code>"+(ye?fe:s(fe,!0))+`</code></pre>
`}blockquote({tokens:he}){return`<blockquote>
${this.parser.parse(he)}</blockquote>
`}html({text:he}){return he}heading({tokens:he,depth:pe}){return`<h${pe}>${this.parser.parseInline(he)}</h${pe}>
`}hr(he){return`<hr>
`}list(he){const pe=he.ordered,ye=he.start;let Re="";for(let X=0;X<he.items.length;X++){const q=he.items[X];Re+=this.listitem(q)}const fe=pe?"ol":"ul",ve=pe&&ye!==1?' start="'+ye+'"':"";return"<"+fe+ve+`>
`+Re+"</"+fe+`>
`}listitem(he){let pe="";if(he.task){const ye=this.checkbox({checked:!!he.checked});he.loose?he.tokens.length>0&&he.tokens[0].type==="paragraph"?(he.tokens[0].text=ye+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=ye+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",raw:ye+" ",text:ye+" "}):pe+=ye+" "}return pe+=this.parser.parse(he.tokens,!!he.loose),`<li>${pe}</li>
`}checkbox({checked:he}){return"<input "+(he?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:he}){return`<p>${this.parser.parseInline(he)}</p>
`}table(he){let pe="",ye="";for(let fe=0;fe<he.header.length;fe++)ye+=this.tablecell(he.header[fe]);pe+=this.tablerow({text:ye});let Re="";for(let fe=0;fe<he.rows.length;fe++){const ve=he.rows[fe];ye="";for(let X=0;X<ve.length;X++)ye+=this.tablecell(ve[X]);Re+=this.tablerow({text:ye})}return Re&&(Re=`<tbody>${Re}</tbody>`),`<table>
<thead>
`+pe+`</thead>
`+Re+`</table>
`}tablerow({text:he}){return`<tr>
${he}</tr>
`}tablecell(he){const pe=this.parser.parseInline(he.tokens),ye=he.header?"th":"td";return(he.align?`<${ye} align="${he.align}">`:`<${ye}>`)+pe+`</${ye}>
`}strong({tokens:he}){return`<strong>${this.parser.parseInline(he)}</strong>`}em({tokens:he}){return`<em>${this.parser.parseInline(he)}</em>`}codespan({text:he}){return`<code>${he}</code>`}br(he){return"<br>"}del({tokens:he}){return`<del>${this.parser.parseInline(he)}</del>`}link({href:he,title:pe,tokens:ye}){const Re=this.parser.parseInline(ye),fe=h(he);if(fe===null)return Re;he=fe;let ve='<a href="'+he+'"';return pe&&(ve+=' title="'+pe+'"'),ve+=">"+Re+"</a>",ve}image({href:he,title:pe,text:ye}){const Re=h(he);if(Re===null)return ye;he=Re;let fe=`<img src="${he}" alt="${ye}"`;return pe&&(fe+=` title="${pe}"`),fe+=">",fe}text(he){return"tokens"in he&&he.tokens?this.parser.parseInline(he.tokens):he.text}}class j{strong({text:he}){return he}em({text:he}){return he}codespan({text:he}){return he}del({text:he}){return he}html({text:he}){return he}text({text:he}){return he}link({text:he}){return""+he}image({text:he}){return""+he}br(){return""}}class H{options;renderer;textRenderer;constructor(he){this.options=he||$e.defaults,this.options.renderer=this.options.renderer||new B,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new j}static parse(he,pe){return new H(pe).parse(he)}static parseInline(he,pe){return new H(pe).parseInline(he)}parse(he,pe=!0){let ye="";for(let Re=0;Re<he.length;Re++){const fe=he[Re];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const X=fe,q=this.options.extensions.renderers[X.type].call({parser:this},X);if(q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type)){ye+=q||"";continue}}const ve=fe;switch(ve.type){case"space":{ye+=this.renderer.space(ve);continue}case"hr":{ye+=this.renderer.hr(ve);continue}case"heading":{ye+=this.renderer.heading(ve);continue}case"code":{ye+=this.renderer.code(ve);continue}case"table":{ye+=this.renderer.table(ve);continue}case"blockquote":{ye+=this.renderer.blockquote(ve);continue}case"list":{ye+=this.renderer.list(ve);continue}case"html":{ye+=this.renderer.html(ve);continue}case"paragraph":{ye+=this.renderer.paragraph(ve);continue}case"text":{let X=ve,q=this.renderer.text(X);for(;Re+1<he.length&&he[Re+1].type==="text";)X=he[++Re],q+=`
`+this.renderer.text(X);pe?ye+=this.renderer.paragraph({type:"paragraph",raw:q,text:q,tokens:[{type:"text",raw:q,text:q}]}):ye+=q;continue}default:{const X='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(X),"";throw new Error(X)}}}return ye}parseInline(he,pe){pe=pe||this.renderer;let ye="";for(let Re=0;Re<he.length;Re++){const fe=he[Re];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const X=this.options.extensions.renderers[fe.type].call({parser:this},fe);if(X!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type)){ye+=X||"";continue}}const ve=fe;switch(ve.type){case"escape":{ye+=pe.text(ve);break}case"html":{ye+=pe.html(ve);break}case"link":{ye+=pe.link(ve);break}case"image":{ye+=pe.image(ve);break}case"strong":{ye+=pe.strong(ve);break}case"em":{ye+=pe.em(ve);break}case"codespan":{ye+=pe.codespan(ve);break}case"br":{ye+=pe.br(ve);break}case"del":{ye+=pe.del(ve);break}case"text":{ye+=pe.text(ve);break}default:{const X='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(X),"";throw new Error(X)}}}return ye}}class J{options;constructor(he){this.options=he||$e.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(he){return he}postprocess(he){return he}processAllTokens(he){return he}}class re{defaults=e();options=this.setOptions;parse=this.parseMarkdown(ze.lex,H.parse);parseInline=this.parseMarkdown(ze.lexInline,H.parseInline);Parser=H;Renderer=B;TextRenderer=j;Lexer=ze;Tokenizer=i;Hooks=J;constructor(...he){this.use(...he)}walkTokens(he,pe){let ye=[];for(const Re of he)switch(ye=ye.concat(pe.call(this,Re)),Re.type){case"table":{const fe=Re;for(const ve of fe.header)ye=ye.concat(this.walkTokens(ve.tokens,pe));for(const ve of fe.rows)for(const X of ve)ye=ye.concat(this.walkTokens(X.tokens,pe));break}case"list":{const fe=Re;ye=ye.concat(this.walkTokens(fe.items,pe));break}default:{const fe=Re;this.defaults.extensions?.childTokens?.[fe.type]?this.defaults.extensions.childTokens[fe.type].forEach(ve=>{const X=fe[ve].flat(1/0);ye=ye.concat(this.walkTokens(X,pe))}):fe.tokens&&(ye=ye.concat(this.walkTokens(fe.tokens,pe)))}}return ye}use(...he){const pe=this.defaults.extensions||{renderers:{},childTokens:{}};return he.forEach(ye=>{const Re={...ye};if(Re.async=this.defaults.async||Re.async||!1,ye.extensions&&(ye.extensions.forEach(fe=>{if(!fe.name)throw new Error("extension name required");if("renderer"in fe){const ve=pe.renderers[fe.name];ve?pe.renderers[fe.name]=function(...X){let q=fe.renderer.apply(this,X);return q===!1&&(q=ve.apply(this,X)),q}:pe.renderers[fe.name]=fe.renderer}if("tokenizer"in fe){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const ve=pe[fe.level];ve?ve.unshift(fe.tokenizer):pe[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?pe.startBlock?pe.startBlock.push(fe.start):pe.startBlock=[fe.start]:fe.level==="inline"&&(pe.startInline?pe.startInline.push(fe.start):pe.startInline=[fe.start]))}"childTokens"in fe&&fe.childTokens&&(pe.childTokens[fe.name]=fe.childTokens)}),Re.extensions=pe),ye.renderer){const fe=this.defaults.renderer||new B(this.defaults);for(const ve in ye.renderer){if(!(ve in fe))throw new Error(`renderer '${ve}' does not exist`);if(["options","parser"].includes(ve))continue;const X=ve,q=ye.renderer[X],de=fe[X];fe[X]=(...We)=>{let Je=q.apply(fe,We);return Je===!1&&(Je=de.apply(fe,We)),Je||""}}Re.renderer=fe}if(ye.tokenizer){const fe=this.defaults.tokenizer||new i(this.defaults);for(const ve in ye.tokenizer){if(!(ve in fe))throw new Error(`tokenizer '${ve}' does not exist`);if(["options","rules","lexer"].includes(ve))continue;const X=ve,q=ye.tokenizer[X],de=fe[X];fe[X]=(...We)=>{let Je=q.apply(fe,We);return Je===!1&&(Je=de.apply(fe,We)),Je}}Re.tokenizer=fe}if(ye.hooks){const fe=this.defaults.hooks||new J;for(const ve in ye.hooks){if(!(ve in fe))throw new Error(`hook '${ve}' does not exist`);if(ve==="options")continue;const X=ve,q=ye.hooks[X],de=fe[X];J.passThroughHooks.has(ve)?fe[X]=We=>{if(this.defaults.async)return Promise.resolve(q.call(fe,We)).then(ct=>de.call(fe,ct));const Je=q.call(fe,We);return de.call(fe,Je)}:fe[X]=(...We)=>{let Je=q.apply(fe,We);return Je===!1&&(Je=de.apply(fe,We)),Je}}Re.hooks=fe}if(ye.walkTokens){const fe=this.defaults.walkTokens,ve=ye.walkTokens;Re.walkTokens=function(X){let q=[];return q.push(ve.call(this,X)),fe&&(q=q.concat(fe.call(this,X))),q}}this.defaults={...this.defaults,...Re}}),this}setOptions(he){return this.defaults={...this.defaults,...he},this}lexer(he,pe){return ze.lex(he,pe??this.defaults)}parser(he,pe){return H.parse(he,pe??this.defaults)}parseMarkdown(he,pe){return(Re,fe)=>{const ve={...fe},X={...this.defaults,...ve},q=this.onError(!!X.silent,!!X.async);if(this.defaults.async===!0&&ve.async===!1)return q(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Re>"u"||Re===null)return q(new Error("marked(): input parameter is undefined or null"));if(typeof Re!="string")return q(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected"));if(X.hooks&&(X.hooks.options=X),X.async)return Promise.resolve(X.hooks?X.hooks.preprocess(Re):Re).then(de=>he(de,X)).then(de=>X.hooks?X.hooks.processAllTokens(de):de).then(de=>X.walkTokens?Promise.all(this.walkTokens(de,X.walkTokens)).then(()=>de):de).then(de=>pe(de,X)).then(de=>X.hooks?X.hooks.postprocess(de):de).catch(q);try{X.hooks&&(Re=X.hooks.preprocess(Re));let de=he(Re,X);X.hooks&&(de=X.hooks.processAllTokens(de)),X.walkTokens&&this.walkTokens(de,X.walkTokens);let We=pe(de,X);return X.hooks&&(We=X.hooks.postprocess(We)),We}catch(de){return q(de)}}}onError(he,pe){return ye=>{if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,he){const Re="<p>An error occurred:</p><pre>"+s(ye.message+"",!0)+"</pre>";return pe?Promise.resolve(Re):Re}if(pe)return Promise.reject(ye);throw ye}}}const ge=new re;function ke(nt,he){return ge.parse(nt,he)}ke.options=ke.setOptions=function(nt){return ge.setOptions(nt),ke.defaults=ge.defaults,y(ke.defaults),ke},ke.getDefaults=e,ke.defaults=$e.defaults,ke.use=function(...nt){return ge.use(...nt),ke.defaults=ge.defaults,y(ke.defaults),ke},ke.walkTokens=function(nt,he){return ge.walkTokens(nt,he)},ke.parseInline=ge.parseInline,ke.Parser=H,ke.parser=H.parse,ke.Renderer=B,ke.TextRenderer=j,ke.Lexer=ze,ke.lexer=ze.lex,ke.Tokenizer=i,ke.Hooks=J,ke.parse=ke;const qe=ke.options,xe=ke.setOptions,rt=ke.use,st=ke.walkTokens,ut=ke.parseInline,ot=ke,lt=H.parse,vt=ze.lex;$e.Hooks=J,$e.Lexer=ze,$e.Marked=re,$e.Parser=H,$e.Renderer=B,$e.TextRenderer=j,$e.Tokenizer=i,$e.getDefaults=e,$e.lexer=vt,$e.marked=ke,$e.options=qe,$e.parse=ot,$e.parseInline=ut,$e.parser=lt,$e.setOptions=xe,$e.use=rt,$e.walkTokens=st}),define(Oe[140],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=y;function y(r){const a=N(r);if(a&&a.length>0)return new Uint32Array(a)}let D=0;const C=new Uint32Array(10);function N(r){if(D=0,T(r,v,p.InitialConsonant),D>0||(T(r,h,p.Vowel),D>0)||(T(r,E,p.FinalConsonant),D>0)||(T(r,f,p.CompatibilityJamo),D))return C.subarray(0,D);if(r>=44032&&r<=55203){const a=r-44032,c=a%588,u=Math.floor(a/588),i=Math.floor(c/28),n=c%28-1;if(u<v.length?T(u,v,0):p.InitialConsonant+u-p.CompatibilityJamo<f.length&&T(p.InitialConsonant+u,f,p.CompatibilityJamo),i<h.length?T(i,h,0):p.Vowel+i-p.CompatibilityJamo<f.length&&T(p.Vowel+i-p.CompatibilityJamo,f,p.CompatibilityJamo),n>=0&&(n<E.length?T(n,E,0):p.FinalConsonant+n-p.CompatibilityJamo<f.length&&T(p.FinalConsonant+n-p.CompatibilityJamo,f,p.CompatibilityJamo)),D>0)return C.subarray(0,D)}}function T(r,a,c){r>=c&&r<c+a.length&&O(a[r-c])}function O(r){r!==s.NUL&&(C[D++]=r&255,r>>8&&(C[D++]=r>>8&255),r>>16&&(C[D++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var s;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(s||(s={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const v=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),h=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l]),E=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,I.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),f=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.E,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,s.Q,I.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l])}),define(Oe[141],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0,e.$Om=y,e.rot=D,e.$Tm=O;function y(p,s,I){return Math.min(Math.max(p,s),I)}function D(p,s){return(s+p%s)%s}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Qm=C;class N{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rm=N;class T{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const I=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sm=T;function O(p,s,I,v,h,E,f,r){const a=f-I,c=r-v,u=h-I,i=E-v,n=p-I,t=s-v,o=a*a+c*c,l=a*u+c*i,m=a*n+c*t,g=u*u+i*i,d=u*n+i*t,S=1/(o*g-l*l),k=(g*m-l*d)*S,w=(o*d-l*m)*S;return k>=0&&w>=0&&k+w<1}}),define(Oe[142],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=N,e.$fd=h;class y{constructor(f,r,a){this.owner=f,this.debugNameSource=r,this.referenceFn=a}getDebugName(f){return N(f,this)}}e.$dd=y;const D=new Map,C=new WeakMap;function N(E,f){const r=C.get(E);if(r)return r;const a=T(E,f);if(a){let c=D.get(a)??0;c++,D.set(a,c);const u=c===1?a:`${a}#${c}`;return C.set(E,u),u}}function T(E,f){const r=C.get(E);if(r)return r;const a=f.owner?I(f.owner)+".":"";let c;const u=f.debugNameSource;if(u!==void 0)if(typeof u=="function"){if(c=u(),c!==void 0)return a+c}else return a+u;const i=f.referenceFn;if(i!==void 0&&(c=h(i),c!==void 0))return a+c;if(f.owner!==void 0){const n=O(f.owner,E);if(n!==void 0)return a+n}}function O(E,f){for(const r in E)if(E[r]===f)return r}const p=new Map,s=new WeakMap;function I(E){const f=s.get(E);if(f)return f;const r=v(E);let a=p.get(r)??0;a++,p.set(r,a);const c=a===1?r:`${r}#${a}`;return s.set(E,c),c}function v(E){const f=E.constructor;return f?f.name:"Object"}function h(E){const f=E.toString(),a=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(a?a[1]:void 0)?.trim()}}),define(Oe[143],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Nd=D,e.$Od=C;let y;function D(r){y=r}function C(){return y}class N{constructor(){this.a=0,this.d=new WeakMap}b(a){return T([O(E("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[O(" "),s(I(a.oldValue,70),{color:"red",strikeThrough:!0}),O(" "),s(I(a.newValue,60),{color:"green"})]:[O(" (unchanged)")]:[O(" "),s(I(a.newValue,60),{color:"green"}),O(" (initial)")]}handleObservableChanged(a,c){console.log(...this.b([p("observable value changed"),s(a.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(a){if(a.size!==0)return s(" (changed deps: "+[...a].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const c=a.handleChange;this.d.set(a,new Set),a.handleChange=(u,i)=>(this.d.get(a).add(u),c.apply(a,[u,i]))}handleDerivedRecomputed(a,c){const u=this.d.get(a);console.log(...this.b([p("derived recomputed"),s(a.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(u),{data:[{fn:a._debugNameData.referenceFn??a._computeFn}]}])),u.clear()}handleFromEventObservableTriggered(a,c){console.log(...this.b([p("observable from event triggered"),s(a.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const c=a.handleChange;this.d.set(a,new Set),a.handleChange=(u,i)=>(this.d.get(a).add(u),c.apply(a,[u,i]))}handleAutorunTriggered(a){const c=this.d.get(a);console.log(...this.b([p("autorun"),s(a.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:a._debugNameData.referenceFn??a._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let c=a.getDebugName();c===void 0&&(c=""),console.log(...this.b([p("transaction"),s(c,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Pd=N;function T(r){const a=new Array,c=[];let u="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(u+=`%c${t.text}`,a.push(t.style),t.data&&c.push(...t.data)):"data"in t&&c.push(...t.data)}i(r);const n=[u,...a];return n.push(...c),n}function O(r){return s(r,{color:"black"})}function p(r){return s(f(`${r}: `,10),{color:"black",bold:!0})}function s(r,a={color:"black"}){function c(i){return Object.entries(i).reduce((n,[t,o])=>`${n}${t}:${o};`,"")}const u={color:a.color};return a.strikeThrough&&(u["text-decoration"]="line-through"),a.bold&&(u["font-weight"]="bold"),{text:r,style:c(u)}}function I(r,a){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=a?`"${r}"`:`"${r.substr(0,a-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?v(r,a):h(r,a);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function v(r,a){let c="[ ",u=!0;for(const i of r){if(u||(c+=", "),c.length-5>a){c+="...";break}u=!1,c+=`${I(i,a-c.length)}`}return c+=" ]",c}function h(r,a){let c="{ ",u=!0;for(const[i,n]of Object.entries(r)){if(u||(c+=", "),c.length-5>a){c+="...";break}u=!1,c+=`${i}: ${I(n,a-c.length)}`}return c+=" }",c}function E(r,a){let c="";for(let u=1;u<=a;u++)c+=r;return c}function f(r,a){for(;r.length<a;)r+=" ";return r}}),define(Oe[144],Ae([1,0,136,142,143]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$0d=e.$8d=e.$3d=e.$2d=void 0,e.$Yd=T,e.$Zd=p,e.$1d=I,e.$4d=E,e.$5d=r,e.$6d=a,e.$7d=c,e.$9d=i,e.$$d=t;let N;function T(l){N=l}let O;function p(l){O=l}let s;function I(l){s=l}class v{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,g){const d=g===void 0?void 0:m,S=g===void 0?m:g;return s({owner:d,debugName:()=>{const k=(0,D.$fd)(S);if(k!==void 0)return k;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(P)return`${this.debugName}.${P[2]}`;if(!d)return`${this.debugName} (mapped)`},debugReferenceFn:S},k=>S(this.read(k),k))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},m=>this.read(m).read(m))}recomputeInitiallyAndOnChange(m,g){return m.add(N(this,g)),this}keepObserved(m){return m.add(O(this)),this}get a(){return this.get()}}e.$2d=v;class h extends v{constructor(){super(...arguments),this.b=new Set}addObserver(m){const g=this.b.size;this.b.add(m),g===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$3d=h;function E(l,m){const g=new u(l,m);try{l(g)}finally{g.finish()}}let f;function r(l){if(f)l(f);else{const m=new u(l,void 0);f=m;try{l(m)}finally{m.finish(),f=void 0}}}async function a(l,m){const g=new u(l,m);try{await l(g)}finally{g.finish()}}function c(l,m,g){l?m(l):E(m,g)}class u{constructor(m,g){this._fn=m,this.b=g,this.a=[],(0,C.$Od)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,D.$fd)(this._fn)}updateObserver(m,g){this.a.push({observer:m,observable:g}),m.beginUpdate(g)}finish(){const m=this.a;for(let g=0;g<m.length;g++){const{observer:d,observable:S}=m[g];d.endUpdate(S)}this.a=null,(0,C.$Od)()?.handleEndTransaction()}}e.$8d=u;function i(l,m){let g;return typeof l=="string"?g=new D.$dd(void 0,l,void 0):g=new D.$dd(l,void 0,void 0),new n(g,m,y.$9c)}class n extends h{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,g,d){super(),this.e=m,this.g=d,this.d=g}get(){return this.d}set(m,g,d){if(d===void 0&&this.g(this.d,m))return;let S;g||(g=S=new u(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(m),(0,C.$Od)()?.handleObservableChanged(this,{oldValue:k,newValue:m,change:d,didChange:!0,hadValue:!0});for(const w of this.b)g.updateObserver(w,this),w.handleChange(this,d)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$0d=n;function t(l,m){let g;return typeof l=="string"?g=new D.$dd(void 0,l,void 0):g=new D.$dd(l,void 0,void 0),new o(g,m,y.$9c)}class o extends n{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$_d=o}),function(){function $e(C){const N=[];typeof C=="number"&&N.push("code/timeOrigin",C);function T(p){N.push(p,Date.now())}function O(){const p=[];for(let s=0;s<N.length;s+=2)p.push({name:N[s],startTime:N[s+1]});return p}return{mark:T,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const T of performance.getEntriesByType("mark"))N.push({name:T.name,startTime:Math.round(C+T.startTime)});return N}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=y(D))}(),define(Oe[145],Ae([1,0,40]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=void 0;const D=Symbol("unset");class C{constructor(){this.a=new T,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||y.Iterable.empty()}get entries(){return this.a.children?.entries()||y.Iterable.empty()}insert(p,s,I){this.d(p,v=>v._value=s,I)}mutate(p,s){this.d(p,I=>I._value=s(I._value===D?void 0:I._value))}mutatePath(p,s){this.d(p,()=>{},I=>s(I))}delete(p){const s=this.c(p);if(!s)return;let I=s.length-1;const v=s[I].node._value;if(v!==D){for(this.b--,s[I].node._value=D;I>0;I--){const{node:h,part:E}=s[I];if(h.children?.size||h._value!==D)break;s[I-1].node.children.delete(E)}return v}}*deleteRecursive(p){const s=this.c(p);if(!s)return;const I=s[s.length-1].node;for(let v=s.length-1;v>0;v--){const h=s[v-1];if(h.node.children.delete(s[v].part),h.node.children.size>0||h.node._value!==D)break}for(const v of N(I))v._value!==D&&(this.b--,yield v._value)}find(p){let s=this.a;for(const I of p){const v=s.children?.get(I);if(!v)return;s=v}return s._value===D?void 0:s._value}hasKeyOrParent(p){let s=this.a;for(const I of p){const v=s.children?.get(I);if(!v)return!1;if(v._value!==D)return!0;s=v}return!1}hasKeyOrChildren(p){let s=this.a;for(const I of p){const v=s.children?.get(I);if(!v)return!1;s=v}return!0}hasKey(p){let s=this.a;for(const I of p){const v=s.children?.get(I);if(!v)return!1;s=v}return s._value!==D}c(p){const s=[{part:"",node:this.a}];let I=0;for(const v of p){const h=s[I].node.children?.get(v);if(!h)return;s.push({part:v,node:h}),I++}return s}d(p,s,I){let v=this.a;for(const f of p){if(v.children)if(v.children.has(f))v=v.children.get(f);else{const r=new T;v.children.set(f,r),v=r}else{const r=new T;v.children=new Map([[f,r]]),v=r}I?.(v)}const h=v._value===D?0:1;s(v);const E=v._value===D?0:1;this.b+=E-h}*values(){for(const{_value:p}of N(this.a))p!==D&&(yield p)}}e.$kJ=C;function*N(O){const p=[O];for(;p.length>0;){const s=p.pop();if(yield s,s.children)for(const I of s.children.values())p.push(I)}}class T{constructor(){this._value=D}get value(){return this._value===D?void 0:this._value}set value(p){this._value=p===void 0?D:p}}}),define(Oe[146],Ae([1,0,48,20]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=O,e.$Gr=p,e.$Hr=s,e.$Ir=I,e.$Jr=v,e.$Kr=h,e.$Lr=E,e.$Mr=f,e.$Nr=r,e.$Or=a,e.$Pr=d,e.$Qr=S,e.$Rr=k;const C=new y.$W(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),N=new y.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new y.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(w,P,R=!1){const $=w||"",b=P||"",L=C.value.collator.compare($,b);return C.value.collatorIsNumeric&&L===0&&$!==b?$<b?-1:1:L}function p(w,P){const R=N.value.collator;return w=w||"",P=P||"",n(R,w,P)}function s(w,P){const R=N.value.collator;return w=w||"",P=P||"",m(w,P)||n(R,w,P)}function I(w,P){const R=N.value.collator;return w=w||"",P=P||"",l(w,P)||n(R,w,P)}function v(w,P){return w=w||"",P=P||"",w===P?0:w<P?-1:1}function h(w,P){const[R,$]=u(w),[b,L]=u(P);let A=C.value.collator.compare($,L);if(A===0){if(C.value.collatorIsNumeric&&$!==L)return $<L?-1:1;if(A=C.value.collator.compare(R,b),C.value.collatorIsNumeric&&A===0&&R!==b)return R<b?-1:1}return A}function E(w,P){w=w||"",P=P||"";const R=i(w),$=i(P),b=N.value.collator,L=T.value.collator;return n(L,R,$)||n(b,w,P)}function f(w,P){w=w||"",P=P||"";const R=i(w),$=i(P),b=N.value.collator,L=T.value.collator;return n(L,R,$)||m(w,P)||n(b,w,P)}function r(w,P){w=w||"",P=P||"";const R=i(w),$=i(P),b=N.value.collator,L=T.value.collator;return n(L,R,$)||l(w,P)||n(b,w,P)}function a(w,P){w=w||"",P=P||"";const R=i(w).toLowerCase(),$=i(P).toLowerCase();return R!==$?R<$?-1:1:w!==P?w<P?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function u(w,P=!1){const R=w?c.exec(w):[];let $=[R&&R[1]||"",R&&R[3]||""];return P&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function i(w){const P=w?c.exec(w):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function n(w,P,R){const $=w.compare(P,R);return $!==0?$:P.length!==R.length?P.length<R.length?-1:1:0}function t(w){const P=w.charAt(0);return P.toLocaleUpperCase()!==P}function o(w){const P=w.charAt(0);return P.toLocaleLowerCase()!==P}function l(w,P){return t(w)&&o(P)?-1:o(w)&&t(P)?1:0}function m(w,P){return o(w)&&t(P)?-1:t(w)&&o(P)?1:0}function g(w,P,R=!1){return R||(w=w&&w.toLowerCase(),P=P&&P.toLowerCase()),w===P?0:w<P?-1:1}function d(w,P,R=!1){const $=w.split(D.sep),b=P.split(D.sep),L=$.length-1,A=b.length-1;let M,Z;for(let G=0;;G++){if(M=L===G,Z=A===G,M&&Z)return O($[G],b[G],R);if(M)return-1;if(Z)return 1;const U=g($[G],b[G],R);if(U!==0)return U}}function S(w,P,R){const $=w.toLowerCase(),b=P.toLowerCase(),L=k(w,P,R);if(L)return L;const A=$.endsWith(R),M=b.endsWith(R);if(A!==M)return A?-1:1;const Z=O($,b);return Z!==0?Z:$.localeCompare(b)}function k(w,P,R){const $=w.toLowerCase(),b=P.toLowerCase(),L=$.startsWith(R),A=b.startsWith(R);if(L!==A)return L?-1:1;if(L&&A){if($.length<b.length)return-1;if($.length>b.length)return 1}return 0}}),define(Oe[73],Ae([1,0,20]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0,e.$et=N,e.$ft=T,e.$gt=O,e.$ht=s,e.$dt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(I){const v=(0,y.$rc)(I),h=D[v.toLowerCase()];return h!==void 0?h:T(I)}function T(I){const v=(0,y.$rc)(I);return C[v.toLowerCase()]}function O(I){for(const v in C)if(C[v]===I)return v}const p=/^(.+)\/(.+?)(;.+)?$/;function s(I,v){const h=p.exec(I);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:v?void 0:I}}),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var D in y)(typeof exports=="object"?exports:$e)[D]=y[D]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function y(D){if(e[D])return e[D].exports;var C=e[D]={i:D,l:!1,exports:{}};return $e[D].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=$e,y.c=e,y.d=function(D,C,N){y.o(D,C)||Object.defineProperty(D,C,{enumerable:!0,get:N})},y.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},y.t=function(D,C){if(1&C&&(D=y(D)),8&C||4&C&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(y.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&C&&typeof D!="string")for(var T in D)y.d(N,T,function(O){return D[O]}.bind(null,T));return N},y.n=function(D){var C=D&&D.__esModule?function(){return D.default}:function(){return D};return y.d(C,"a",C),C},y.o=function(D,C){return Object.prototype.hasOwnProperty.call(D,C)},y.p="",y(y.s=0)}([function($e,e,y){(function(D){var C;e=$e.exports=we,C=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],p=e.src=[],s=0,I=s++;p[I]="0|[1-9]\\d*";var v=s++;p[v]="[0-9]+";var h=s++;p[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=s++;p[E]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var f=s++;p[f]="("+p[v]+")\\.("+p[v]+")\\.("+p[v]+")";var r=s++;p[r]="(?:"+p[I]+"|"+p[h]+")";var a=s++;p[a]="(?:"+p[v]+"|"+p[h]+")";var c=s++;p[c]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var u=s++;p[u]="(?:-?("+p[a]+"(?:\\."+p[a]+")*))";var i=s++;p[i]="[0-9A-Za-z-]+";var n=s++;p[n]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=s++,o="v?"+p[E]+p[c]+"?"+p[n]+"?";p[t]="^"+o+"$";var l="[v=\\s]*"+p[f]+p[u]+"?"+p[n]+"?",m=s++;p[m]="^"+l+"$";var g=s++;p[g]="((?:<|>)?=?)";var d=s++;p[d]=p[v]+"|x|X|\\*";var S=s++;p[S]=p[I]+"|x|X|\\*";var k=s++;p[k]="[v=\\s]*("+p[S]+")(?:\\.("+p[S]+")(?:\\.("+p[S]+")(?:"+p[c]+")?"+p[n]+"?)?)?";var w=s++;p[w]="[v=\\s]*("+p[d]+")(?:\\.("+p[d]+")(?:\\.("+p[d]+")(?:"+p[u]+")?"+p[n]+"?)?)?";var P=s++;p[P]="^"+p[g]+"\\s*"+p[k]+"$";var R=s++;p[R]="^"+p[g]+"\\s*"+p[w]+"$";var $=s++;p[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=s++;p[b]="(?:~>?)";var L=s++;p[L]="(\\s*)"+p[b]+"\\s+",O[L]=new RegExp(p[L],"g");var A=s++;p[A]="^"+p[b]+p[k]+"$";var M=s++;p[M]="^"+p[b]+p[w]+"$";var Z=s++;p[Z]="(?:\\^)";var G=s++;p[G]="(\\s*)"+p[Z]+"\\s+",O[G]=new RegExp(p[G],"g");var U=s++;p[U]="^"+p[Z]+p[k]+"$";var V=s++;p[V]="^"+p[Z]+p[w]+"$";var Q=s++;p[Q]="^"+p[g]+"\\s*("+l+")$|^$";var ne=s++;p[ne]="^"+p[g]+"\\s*("+o+")$|^$";var ue=s++;p[ue]="(\\s*)"+p[g]+"\\s*("+l+"|"+p[k]+")",O[ue]=new RegExp(p[ue],"g");var x=s++;p[x]="^\\s*("+p[k]+")\\s+-\\s+("+p[k]+")\\s*$";var oe=s++;p[oe]="^\\s*("+p[w]+")\\s+-\\s+("+p[w]+")\\s*$";var se=s++;p[se]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)C(ce,p[ce]),O[ce]||(O[ce]=new RegExp(p[ce]));function te(j,H){if(j instanceof we)return j;if(typeof j!="string"||j.length>N||!(H?O[m]:O[t]).test(j))return null;try{return new we(j,H)}catch{return null}}function we(j,H){if(j instanceof we){if(j.loose===H)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof we))return new we(j,H);C("SemVer",j,H),this.loose=H;var J=j.trim().match(H?O[m]:O[t]);if(!J)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(re){if(/^[0-9]+$/.test(re)){var ge=+re;if(ge>=0&&ge<T)return ge}return re}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=te,e.valid=function(j,H){var J=te(j,H);return J?J.version:null},e.clean=function(j,H){var J=te(j.trim().replace(/^[=v]+/,""),H);return J?J.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(j){return C("SemVer.compare",this.version,this.loose,j),j instanceof we||(j=new we(j,this.loose)),this.compareMain(j)||this.comparePre(j)},we.prototype.compareMain=function(j){return j instanceof we||(j=new we(j,this.loose)),Y(this.major,j.major)||Y(this.minor,j.minor)||Y(this.patch,j.patch)},we.prototype.comparePre=function(j){if(j instanceof we||(j=new we(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],re=j.prerelease[H];if(C("prerelease compare",H,J,re),J===void 0&&re===void 0)return 0;if(re===void 0)return 1;if(J===void 0)return-1;if(J!==re)return Y(J,re)}while(++H)},we.prototype.inc=function(j,H){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,H,J,re){typeof J=="string"&&(re=J,J=void 0);try{return new we(j,J).inc(H,re).version}catch{return null}},e.diff=function(j,H){if(Pe(j,H))return null;var J=te(j),re=te(H);if(J.prerelease.length||re.prerelease.length){for(var ge in J)if((ge==="major"||ge==="minor"||ge==="patch")&&J[ge]!==re[ge])return"pre"+ge;return"prerelease"}for(var ge in J)if((ge==="major"||ge==="minor"||ge==="patch")&&J[ge]!==re[ge])return ge},e.compareIdentifiers=Y;var Ce=/^[0-9]+$/;function Y(j,H){var J=Ce.test(j),re=Ce.test(H);return J&&re&&(j=+j,H=+H),J&&!re?-1:re&&!J?1:j<H?-1:j>H?1:0}function W(j,H,J){return new we(j,J).compare(new we(H,J))}function ee(j,H,J){return W(j,H,J)>0}function be(j,H,J){return W(j,H,J)<0}function Pe(j,H,J){return W(j,H,J)===0}function je(j,H,J){return W(j,H,J)!==0}function Te(j,H,J){return W(j,H,J)>=0}function Ee(j,H,J){return W(j,H,J)<=0}function Fe(j,H,J,re){var ge;switch(H){case"===":typeof j=="object"&&(j=j.version),typeof J=="object"&&(J=J.version),ge=j===J;break;case"!==":typeof j=="object"&&(j=j.version),typeof J=="object"&&(J=J.version),ge=j!==J;break;case"":case"=":case"==":ge=Pe(j,J,re);break;case"!=":ge=je(j,J,re);break;case">":ge=ee(j,J,re);break;case">=":ge=Te(j,J,re);break;case"<":ge=be(j,J,re);break;case"<=":ge=Ee(j,J,re);break;default:throw new TypeError("Invalid operator: "+H)}return ge}function Ve(j,H){if(j instanceof Ve){if(j.loose===H)return j;j=j.value}if(!(this instanceof Ve))return new Ve(j,H);C("comparator",j,H),this.loose=H,this.parse(j),this.semver===Ge?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(j,H){return Y(H,j)},e.major=function(j,H){return new we(j,H).major},e.minor=function(j,H){return new we(j,H).minor},e.patch=function(j,H){return new we(j,H).patch},e.compare=W,e.compareLoose=function(j,H){return W(j,H,!0)},e.rcompare=function(j,H,J){return W(H,j,J)},e.sort=function(j,H){return j.sort(function(J,re){return e.compare(J,re,H)})},e.rsort=function(j,H){return j.sort(function(J,re){return e.rcompare(J,re,H)})},e.gt=ee,e.lt=be,e.eq=Pe,e.neq=je,e.gte=Te,e.lte=Ee,e.cmp=Fe,e.Comparator=Ve;var Ge={};function et(j,H){if(j instanceof et)return j.loose===H?j:new et(j.raw,H);if(j instanceof Ve)return new et(j.value,H);if(!(this instanceof et))return new et(j,H);if(this.loose=H,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function it(j){return!j||j.toLowerCase()==="x"||j==="*"}function Me(j,H,J,re,ge,ke,qe,xe,rt,st,ut,ot,lt){return((H=it(J)?"":it(re)?">="+J+".0.0":it(ge)?">="+J+"."+re+".0":">="+H)+" "+(xe=it(rt)?"":it(st)?"<"+(+rt+1)+".0.0":it(ut)?"<"+rt+"."+(+st+1)+".0":ot?"<="+rt+"."+st+"."+ut+"-"+ot:"<="+xe)).trim()}function Ue(j,H){for(var J=0;J<j.length;J++)if(!j[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<j.length;J++)if(C(j[J].semver),j[J].semver!==Ge&&j[J].semver.prerelease.length>0){var re=j[J].semver;if(re.major===H.major&&re.minor===H.minor&&re.patch===H.patch)return!0}return!1}return!0}function ze(j,H,J){try{H=new et(H,J)}catch{return!1}return H.test(j)}function B(j,H,J,re){var ge,ke,qe,xe,rt;switch(j=new we(j,re),H=new et(H,re),J){case">":ge=ee,ke=Ee,qe=be,xe=">",rt=">=";break;case"<":ge=be,ke=Te,qe=ee,xe="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(j,H,re))return!1;for(var st=0;st<H.set.length;++st){var ut=H.set[st],ot=null,lt=null;if(ut.forEach(function(vt){vt.semver===Ge&&(vt=new Ve(">=0.0.0")),ot=ot||vt,lt=lt||vt,ge(vt.semver,ot.semver,re)?ot=vt:qe(vt.semver,lt.semver,re)&&(lt=vt)}),ot.operator===xe||ot.operator===rt||(!lt.operator||lt.operator===xe)&&ke(j,lt.semver)||lt.operator===rt&&qe(j,lt.semver))return!1}return!0}Ve.prototype.parse=function(j){var H=this.loose?O[Q]:O[ne],J=j.match(H);if(!J)throw new TypeError("Invalid comparator: "+j);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new we(J[2],this.loose):this.semver=Ge},Ve.prototype.toString=function(){return this.value},Ve.prototype.test=function(j){return C("Comparator.test",j,this.loose),this.semver===Ge||(typeof j=="string"&&(j=new we(j,this.loose)),Fe(j,this.operator,this.semver,this.loose))},Ve.prototype.intersects=function(j,H){if(!(j instanceof Ve))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new et(j.value,H),ze(this.value,J,H);if(j.operator==="")return J=new et(this.value,H),ze(j.semver,J,H);var re=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),ke=this.semver.version===j.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),xe=Fe(this.semver,"<",j.semver,H)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),rt=Fe(this.semver,">",j.semver,H)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return re||ge||ke&&qe||xe||rt},e.Range=et,et.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},et.prototype.toString=function(){return this.range},et.prototype.parseRange=function(j){var H=this.loose;j=j.trim(),C("range",j,H);var J=H?O[oe]:O[x];j=j.replace(J,Me),C("hyphen replace",j),j=j.replace(O[ue],"$1$2$3"),C("comparator trim",j,O[ue]),j=(j=(j=j.replace(O[L],"$1~")).replace(O[G],"$1^")).split(/\s+/).join(" ");var re=H?O[Q]:O[ne],ge=j.split(" ").map(function(ke){return function(qe,xe){return C("comp",qe),qe=function(rt,st){return rt.trim().split(/\s+/).map(function(ut){return function(ot,lt){C("caret",ot,lt);var vt=lt?O[V]:O[U];return ot.replace(vt,function(nt,he,pe,ye,Re){var fe;return C("caret",ot,nt,he,pe,ye,Re),it(he)?fe="":it(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":it(ye)?fe=he==="0"?">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+".0 <"+(+he+1)+".0.0":Re?(C("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+Re+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+Re+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+Re+" <"+(+he+1)+".0.0"):(C("no pr"),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+" <"+(+he+1)+".0.0"),C("caret return",fe),fe})}(ut,st)}).join(" ")}(qe,xe),C("caret",qe),qe=function(rt,st){return rt.trim().split(/\s+/).map(function(ut){return function(ot,lt){var vt=lt?O[M]:O[A];return ot.replace(vt,function(nt,he,pe,ye,Re){var fe;return C("tilde",ot,nt,he,pe,ye,Re),it(he)?fe="":it(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":it(ye)?fe=">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":Re?(C("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),fe=">="+he+"."+pe+"."+ye+Re+" <"+he+"."+(+pe+1)+".0"):fe=">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0",C("tilde return",fe),fe})}(ut,st)}).join(" ")}(qe,xe),C("tildes",qe),qe=function(rt,st){return C("replaceXRanges",rt,st),rt.split(/\s+/).map(function(ut){return function(ot,lt){ot=ot.trim();var vt=lt?O[R]:O[P];return ot.replace(vt,function(nt,he,pe,ye,Re,fe){C("xRange",ot,nt,he,pe,ye,Re,fe);var ve=it(pe),X=ve||it(ye),q=X||it(Re);return he==="="&&q&&(he=""),ve?nt=he===">"||he==="<"?"<0.0.0":"*":he&&q?(X&&(ye=0),q&&(Re=0),he===">"?(he=">=",X?(pe=+pe+1,ye=0,Re=0):q&&(ye=+ye+1,Re=0)):he==="<="&&(he="<",X?pe=+pe+1:ye=+ye+1),nt=he+pe+"."+ye+"."+Re):X?nt=">="+pe+".0.0 <"+(+pe+1)+".0.0":q&&(nt=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),C("xRange return",nt),nt})}(ut,st)}).join(" ")}(qe,xe),C("xrange",qe),qe=function(rt,st){return C("replaceStars",rt,st),rt.trim().replace(O[se],"")}(qe,xe),C("stars",qe),qe}(ke,H)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(ke){return!!ke.match(re)})),ge=ge.map(function(ke){return new Ve(ke,H)})},et.prototype.intersects=function(j,H){if(!(j instanceof et))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(re){return j.set.some(function(ge){return ge.every(function(ke){return re.intersects(ke,H)})})})})},e.toComparators=function(j,H){return new et(j,H).set.map(function(J){return J.map(function(re){return re.value}).join(" ").trim().split(" ")})},et.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new we(j,this.loose));for(var H=0;H<this.set.length;H++)if(Ue(this.set[H],j))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(j,H,J){var re=null,ge=null;try{var ke=new et(H,J)}catch{return null}return j.forEach(function(qe){ke.test(qe)&&(re&&ge.compare(qe)!==-1||(ge=new we(re=qe,J)))}),re},e.minSatisfying=function(j,H,J){var re=null,ge=null;try{var ke=new et(H,J)}catch{return null}return j.forEach(function(qe){ke.test(qe)&&(re&&ge.compare(qe)!==1||(ge=new we(re=qe,J)))}),re},e.validRange=function(j,H){try{return new et(j,H).range||"*"}catch{return null}},e.ltr=function(j,H,J){return B(j,H,"<",J)},e.gtr=function(j,H,J){return B(j,H,">",J)},e.outside=B,e.prerelease=function(j,H){var J=te(j,H);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(j,H,J){return j=new et(j,J),H=new et(H,J),j.intersects(H)},e.coerce=function(j){if(j instanceof we)return j;if(typeof j!="string")return null;var H=j.match(O[$]);return H==null?null:te((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,y(1))},function($e,e){var y,D,C=$e.exports={};function N(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function O(a){if(y===setTimeout)return setTimeout(a,0);if((y===N||!y)&&setTimeout)return y=setTimeout,setTimeout(a,0);try{return y(a,0)}catch{try{return y.call(null,a,0)}catch{return y.call(this,a,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:N}catch{y=N}try{D=typeof clearTimeout=="function"?clearTimeout:T}catch{D=T}})();var p,s=[],I=!1,v=-1;function h(){I&&p&&(I=!1,p.length?s=p.concat(s):v=-1,s.length&&E())}function E(){if(!I){var a=O(h);I=!0;for(var c=s.length;c;){for(p=s,s=[];++v<c;)p&&p[v].run();v=-1,c=s.length}p=null,I=!1,function(u){if(D===clearTimeout)return clearTimeout(u);if((D===T||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(u);try{D(u)}catch{try{return D.call(null,u)}catch{return D.call(this,u)}}}(a)}}function f(a,c){this.fun=a,this.array=c}function r(){}C.nextTick=function(a){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];s.push(new f(a,c)),s.length!==1||I||O(E)},f.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=r,C.addListener=r,C.once=r,C.off=r,C.removeListener=r,C.removeAllListeners=r,C.emit=r,C.prependListener=r,C.prependOnceListener=r,C.listeners=function(a){return[]},C.binding=function(a){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(a){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Oe[147],Ae([1,0,6,4]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.$jt=e.$it=e.ScrollbarVisibility=void 0;var C;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class N{constructor(f,r,a,c,u,i,n){this.c=f,this._scrollStateBrand=void 0,this.c&&(r=r|0,a=a|0,c=c|0,u=u|0,i=i|0,n=n|0),this.rawScrollLeft=c,this.rawScrollTop=n,r<0&&(r=0),c+r>a&&(c=a-r),c<0&&(c=0),u<0&&(u=0),n+u>i&&(n=i-u),n<0&&(n=0),this.width=r,this.scrollWidth=a,this.scrollLeft=c,this.height=u,this.scrollHeight=i,this.scrollTop=n}equals(f){return this.rawScrollLeft===f.rawScrollLeft&&this.rawScrollTop===f.rawScrollTop&&this.width===f.width&&this.scrollWidth===f.scrollWidth&&this.scrollLeft===f.scrollLeft&&this.height===f.height&&this.scrollHeight===f.scrollHeight&&this.scrollTop===f.scrollTop}withScrollDimensions(f,r){return new N(this.c,typeof f.width<"u"?f.width:this.width,typeof f.scrollWidth<"u"?f.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof f.height<"u"?f.height:this.height,typeof f.scrollHeight<"u"?f.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(f){return new N(this.c,this.width,this.scrollWidth,typeof f.scrollLeft<"u"?f.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof f.scrollTop<"u"?f.scrollTop:this.rawScrollTop)}createScrollEvent(f,r){const a=this.width!==f.width,c=this.scrollWidth!==f.scrollWidth,u=this.scrollLeft!==f.scrollLeft,i=this.height!==f.height,n=this.scrollHeight!==f.scrollHeight,t=this.scrollTop!==f.scrollTop;return{inSmoothScrolling:r,oldWidth:f.width,oldScrollWidth:f.scrollWidth,oldScrollLeft:f.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:f.height,oldScrollHeight:f.scrollHeight,oldScrollTop:f.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:c,scrollLeftChanged:u,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$it=N;class T extends D.$Xc{constructor(f){super(),this._scrollableBrand=void 0,this.j=this.B(new y.$oe),this.onScroll=this.j.event,this.c=f.smoothScrollDuration,this.f=f.scheduleAtNextAnimationFrame,this.g=new N(f.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(f){this.c=f}validateScrollPosition(f){return this.g.withScrollPosition(f)}getScrollDimensions(){return this.g}setScrollDimensions(f,r){const a=this.g.withScrollDimensions(f,r);this.n(a,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(f){const r=this.g.withScrollPosition(f);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(f,r){if(this.c===0)return this.setScrollPositionNow(f);if(this.h){f={scrollLeft:typeof f.scrollLeft>"u"?this.h.to.scrollLeft:f.scrollLeft,scrollTop:typeof f.scrollTop>"u"?this.h.to.scrollTop:f.scrollTop};const a=this.g.withScrollPosition(f);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let c;r?c=new I(this.h.from,a,this.h.startTime,this.h.duration):c=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=c}else{const a=this.g.withScrollPosition(f);this.h=I.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const f=this.h.tick(),r=this.g.withScrollPosition(f);if(this.n(r,!0),!!this.h){if(f.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(f,r){const a=this.g;a.equals(f)||(this.g=f,this.j.fire(this.g.createScrollEvent(a,r)))}}e.$jt=T;class O{constructor(f,r,a){this.scrollLeft=f,this.scrollTop=r,this.isDone=a}}e.$kt=O;function p(E,f){const r=f-E;return function(a){return E+r*h(a)}}function s(E,f,r){return function(a){return a<r?E(a/r):f((a-r)/(1-r))}}class I{constructor(f,r,a,c){this.from=f,this.to=r,this.duration=c,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(f,r,a){if(Math.abs(f-r)>2.5*a){let u,i;return f<r?(u=f+.75*a,i=r-.75*a):(u=f-.75*a,i=r+.75*a),s(p(f,u),p(i,r),.33)}return p(f,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(f){this.to=f.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(f){const r=(f-this.startTime)/this.duration;if(r<1){const a=this.c(r),c=this.d(r);return new O(a,c,!1)}return new O(this.to.scrollLeft,this.to.scrollTop,!0)}combine(f,r,a){return I.start(f,r,a)}static start(f,r,a){a=a+10;const c=Date.now()-10;return new I(f,r,c,a)}}e.$lt=I;function v(E){return Math.pow(E,3)}function h(E){return 1-v(1-E)}}),define(Oe[148],Ae([1,0,13,4]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=C,e.$Ce=N,e.$De=T,e.$Ee=O,e.$Fe=s,e.$Ge=I,e.$He=v,e.$Ie=h,e.$Je=E,e.$Ke=f,e.$Le=r,e.$Me=a,e.$Ne=c,e.$Oe=u,e.$Pe=i;function C(n){const t=n;return t?typeof t.read=="function":!1}function N(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function T(n){const t=n;return t?N(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function O(n,t){return new p(n,t)}class p{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,y.$2)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const m=l.indexOf(o);m>=0&&l.splice(m,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(n,t){const o=[];let l;for(;(l=n.read())!==null;)o.push(l);return t(o)}function I(n,t,o){const l=[];let m;for(;(m=n.read())!==null&&l.length<o;)l.push(m);return m===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof m<"u"){const g=m;return m=void 0,g}return n.read()}}}function v(n,t){return new Promise((o,l)=>{const m=[];h(n,{onData:g=>{t&&m.push(g)},onError:g=>{t?l(g):o(void 0)},onEnd:()=>{o(t?t(m):void 0)}})})}function h(n,t,o){n.on("error",l=>{o?.isCancellationRequested||t.onError(l)}),n.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),n.on("data",l=>{o?.isCancellationRequested||t.onData(l)})}function E(n,t){return new Promise((o,l)=>{const m=new D.$Wc,g=[],d=w=>{if(g.push(w),g.length>t)return m.dispose(),n.pause(),o({stream:n,buffer:g,ended:!1})},S=w=>(m.dispose(),l(w)),k=()=>(m.dispose(),o({stream:n,buffer:g,ended:!0}));m.add((0,D.$Vc)(()=>n.removeListener("error",S))),n.on("error",S),m.add((0,D.$Vc)(()=>n.removeListener("end",k))),n.on("end",k),m.add((0,D.$Vc)(()=>n.removeListener("data",d))),n.on("data",d)})}function f(n,t){const o=O(t);return o.end(n),o}function r(){const n=O(()=>{throw new Error("not supported")});return n.end(),n}function a(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function c(n,t,o){const l=O(o);return h(n,{onData:m=>l.write(t.data(m)),onError:m=>l.error(t.error?t.error(m):m),onEnd:()=>l.end()}),l}function u(n,t,o){let l=!1;return{read:()=>{const m=t.read();return l?m:(l=!0,m!==null?o([n,m]):n)}}}function i(n,t,o){let l=!1;const m=O(o);return h(t,{onData:g=>l?m.write(g):(l=!0,m.write(o([n,g]))),onError:g=>m.error(g),onEnd:()=>{l||(l=!0,m.write(n)),m.end()}}),m}}),define(Oe[22],Ae([1,0,48,148]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=s,e.$Se=I,e.$Te=v,e.$Ue=h,e.$Ve=E,e.$We=f,e.$Xe=r,e.$Ye=a,e.$Ze=c,e.$1e=u,e.$2e=i,e.$3e=n,e.$4e=t,e.$5e=o,e.$6e=l,e.$7e=m,e.$8e=g,e.$9e=d,e.$0e=S,e.$$e=P,D=He(D);const C=typeof Buffer<"u",N=new y.$W(()=>new Uint8Array(256));let T,O;class p{static alloc($){return C?new p(Buffer.allocUnsafe($)):new p(new Uint8Array($))}static wrap($){return C&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new p($)}static fromString($,b){return!(b?.dontUseNodeBuffer||!1)&&C?new p(Buffer.from($)):(T||(T=new TextEncoder),new p(T.encode($)))}static fromByteArray($){const b=p.alloc($.length);for(let L=0,A=$.length;L<A;L++)b.buffer[L]=$[L];return b}static concat($,b){if(typeof b>"u"){b=0;for(let M=0,Z=$.length;M<Z;M++)b+=$[M].byteLength}const L=p.alloc(b);let A=0;for(let M=0,Z=$.length;M<Z;M++){const G=$[M];L.set(G,A),A+=G.byteLength}return L}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=p.alloc(this.byteLength);return $.set(this),$}toString(){return C?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice($,b){return new p(this.buffer.subarray($,b))}set($,b){if($ instanceof p)this.buffer.set($.buffer,b);else if($ instanceof Uint8Array)this.buffer.set($,b);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),b);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return h(this.buffer,$)}writeUInt32BE($,b){E(this.buffer,$,b)}readUInt32LE($){return f(this.buffer,$)}writeUInt32LE($,b){r(this.buffer,$,b)}readUInt8($){return a(this.buffer,$)}writeUInt8($,b){c(this.buffer,$,b)}indexOf($,b=0){return s(this.buffer,$ instanceof p?$.buffer:$,b)}}e.$Qe=p;function s(R,$,b=0){const L=$.byteLength,A=R.byteLength;if(L===0)return 0;if(L===1)return R.indexOf($[0]);if(L>A-b)return-1;const M=N.value;M.fill($.length);for(let V=0;V<$.length;V++)M[$[V]]=$.length-V-1;let Z=b+$.length-1,G=Z,U=-1;for(;Z<A;)if(R[Z]===$[G]){if(G===0){U=Z;break}Z--,G--}else Z+=Math.max($.length-G,M[R[Z]]),G=$.length-1;return U}function I(R,$){return R[$+0]<<0>>>0|R[$+1]<<8>>>0}function v(R,$,b){R[b+0]=$&255,$=$>>>8,R[b+1]=$&255}function h(R,$){return R[$]*2**24+R[$+1]*2**16+R[$+2]*2**8+R[$+3]}function E(R,$,b){R[b+3]=$,$=$>>>8,R[b+2]=$,$=$>>>8,R[b+1]=$,$=$>>>8,R[b]=$}function f(R,$){return R[$+0]<<0>>>0|R[$+1]<<8>>>0|R[$+2]<<16>>>0|R[$+3]<<24>>>0}function r(R,$,b){R[b+0]=$&255,$=$>>>8,R[b+1]=$&255,$=$>>>8,R[b+2]=$&255,$=$>>>8,R[b+3]=$&255}function a(R,$){return R[$]}function c(R,$,b){R[b]=$}function u(R){return D.$Fe(R,$=>p.concat($))}function i(R){return D.$Me(R)}function n(R){return D.$He(R,$=>p.concat($))}async function t(R){return R.ended?p.concat(R.buffer):p.concat([...R.buffer,await n(R.stream)])}function o(R){return D.$Ke(R,$=>p.concat($))}function l(R){return D.$Ne(R,{data:$=>typeof $=="string"?p.fromString($):p.wrap($)},$=>p.concat($))}function m(R){return D.$Ee($=>p.concat($),R)}function g(R,$){return D.$Oe(R,$,b=>p.concat(b))}function d(R,$){return D.$Pe(R,$,b=>p.concat(b))}function S(R){let $=0,b=0,L=0;const A=new Uint8Array(Math.floor(R.length/4*3)),M=G=>{switch(b){case 3:A[L++]=$|G,b=0;break;case 2:A[L++]=$|G>>>2,$=G<<6,b=3;break;case 1:A[L++]=$|G>>>4,$=G<<4,b=2;break;default:$=G<<2,b=1}};for(let G=0;G<R.length;G++){const U=R.charCodeAt(G);if(U>=65&&U<=90)M(U-65);else if(U>=97&&U<=122)M(U-97+26);else if(U>=48&&U<=57)M(U-48+52);else if(U===43||U===45)M(62);else if(U===47||U===95)M(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${R[G]}`)}}const Z=L;for(;b>0;)M(0);return p.wrap(A).slice(0,Z)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:R},$=!0,b=!1){const L=b?w:k;let A="";const M=R.byteLength%3;let Z=0;for(;Z<R.byteLength-M;Z+=3){const G=R[Z+0],U=R[Z+1],V=R[Z+2];A+=L[G>>>2],A+=L[(G<<4|U>>>4)&63],A+=L[(U<<2|V>>>6)&63],A+=L[V&63]}if(M===1){const G=R[Z+0];A+=L[G>>>2],A+=L[G<<4&63],$&&(A+="==")}else if(M===2){const G=R[Z+0],U=R[Z+1];A+=L[G>>>2],A+=L[(G<<4|U>>>4)&63],A+=L[U<<2&63],$&&(A+="=")}return A}}),define(Oe[149],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=void 0,e.$je=Symbol("MicrotaskDelay")}),define(Oe[35],Ae([1,0,98]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$9j=C;var D;(function(T){function O(p){return p&&typeof p=="object"&&typeof p.id=="string"}T.isThemeColor=O})(D||(e.ThemeColor=D={}));function C(T){return{id:T}}var N;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p(u){const i=O.exec(u.id);if(!i)return p(y.$8j.error);const[,n,t]=i,o=["codicon","codicon-"+n];return t&&o.push("codicon-modifier-"+t.substring(1)),o}T.asClassNameArray=p;function s(u){return p(u).join(" ")}T.asClassName=s;function I(u){return"."+p(u).join(".")}T.asCSSSelector=I;function v(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||D.isThemeColor(u.color))}T.isThemeIcon=v;const h=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function E(u){const i=h.exec(u);if(!i)return;const[,n]=i;return{id:n}}T.fromString=E;function f(u){return{id:u}}T.fromId=f;function r(u,i){let n=u.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}T.modify=r;function a(u){const i=u.id.lastIndexOf("~");if(i!==-1)return u.id.substring(i+1)}T.getModifier=a;function c(u,i){return u.id===i.id&&u.color?.id===i.color?.id}T.isEqual=c})(N||(e.ThemeIcon=N={}))}),define(Oe[52],Ae([1,0,27,20,21,12,14]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=O,e.$Bg=p,e.$Cg=s,e.$Dg=I,e.$Eg=v,e.$Fg=r,e.$Gg=a,e.$Hg=c,e.$Ig=u,e.$Jg=i,e.$Kg=n,e.$Lg=t,e.$Mg=o,e.$Ng=l,e.$Og=m,e.$Pg=g,e.$Qg=k;function O(w){return w===y.CharCode.Slash||w===y.CharCode.Backslash}function p(w){return w.replace(/[\\/]/g,D.$jc.sep)}function s(w){return w.indexOf("/")===-1&&(w=p(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function I(w,P=D.$jc.sep){if(!w)return"";const R=w.length,$=w.charCodeAt(0);if(O($)){if(O(w.charCodeAt(1))&&!O(w.charCodeAt(2))){let L=3;const A=L;for(;L<R&&!O(w.charCodeAt(L));L++);if(A!==L&&!O(w.charCodeAt(L+1))){for(L+=1;L<R;L++)if(O(w.charCodeAt(L)))return w.slice(0,L+1).replace(/[\\/]/g,P)}}return P}else if(u($)&&w.charCodeAt(1)===y.CharCode.Colon)return O(w.charCodeAt(2))?w.slice(0,2)+P:w.slice(0,2);let b=w.indexOf("://");if(b!==-1){for(b+=3;b<R;b++)if(O(w.charCodeAt(b)))return w.slice(0,b+1)}return""}function v(w){if(!C.$j||!w||w.length<5)return!1;let P=w.charCodeAt(0);if(P!==y.CharCode.Backslash||(P=w.charCodeAt(1),P!==y.CharCode.Backslash))return!1;let R=2;const $=R;for(;R<w.length&&(P=w.charCodeAt(R),P!==y.CharCode.Backslash);R++);return!($===R||(P=w.charCodeAt(R+1),isNaN(P)||P===y.CharCode.Backslash))}const h=/[\\/:\*\?"<>\|]/g,E=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(w,P=C.$j){const R=P?h:E;return!(!w||w.length===0||/^\s+$/.test(w)||(R.lastIndex=0,R.test(w))||P&&f.test(w)||w==="."||w===".."||P&&w[w.length-1]==="."||P&&w.length!==w.trim().length||w.length>255)}function a(w,P,R){const $=w===P;return!R||$?$:!w||!P?!1:(0,N.$If)(w,P)}function c(w,P,R,$=D.sep){if(w===P)return!0;if(!w||!P||P.length>w.length)return!1;if(R){if(!(0,N.$Jf)(w,P))return!1;if(P.length===w.length)return!0;let L=P.length;return P.charAt(P.length-1)===$&&L--,w.charAt(L)===$}return P.charAt(P.length-1)!==$&&(P+=$),w.indexOf(P)===0}function u(w){return w>=y.CharCode.A&&w<=y.CharCode.Z||w>=y.CharCode.a&&w<=y.CharCode.z}function i(w,P){return C.$j&&w.endsWith(":")&&(w+=D.sep),(0,D.$lc)(w)||(w=(0,D.$mc)(P,w)),w=(0,D.$kc)(w),n(w)}function n(w){return C.$j?(w=(0,N.$qf)(w,D.sep),w.endsWith(":")&&(w+=D.sep)):(w=(0,N.$qf)(w,D.sep),w||(w=D.sep)),w}function t(w){const P=(0,D.$kc)(w);return C.$j?w.length>3?!1:o(P)&&(w.length===2||P.charCodeAt(2)===y.CharCode.Backslash):P===D.$jc.sep}function o(w,P=C.$j){return P?u(w.charCodeAt(0))&&w.charCodeAt(1)===y.CharCode.Colon:!1}function l(w,P=C.$j){return o(w,P)?w[0]:void 0}function m(w,P,R){return P.length>w.length?-1:w===P?0:(R&&(w=w.toLowerCase(),P=P.toLowerCase()),w.indexOf(P))}function g(w){const P=w.split(":");let R,$,b;for(const L of P){const A=Number(L);(0,T.$lg)(A)?$===void 0?$=A:b===void 0&&(b=A):R=R?[R,L].join(":"):L}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:$!==void 0?$:void 0,column:b!==void 0?b:$!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",S="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(w,P,R=8){let $="";for(let L=0;L<R;L++){let A;L===0&&C.$j&&!P&&(R===3||R===4)?A=S:A=d,$+=A.charAt(Math.floor(Math.random()*A.length))}let b;return P?b=`${P}-${$}`:b=$,w?(0,D.$mc)(w,b):b}}),define(Oe[150],Ae([1,0,27,28,140,12]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.FuzzyScore=e.$Lk=e.$Kk=void 0,e.or=T,e.$Mk=p,e.$Nk=s,e.$Ok=h,e.$Pk=k,e.$Qk=w,e.$Rk=A,e.$Sk=M,e.$Tk=Z,e.$Uk=G,e.$Vk=ee,e.$Xk=Te,e.$Yk=Ve,e.$Zk=Ge,N=He(N);function T(...Me){return function(Ue,ze){for(let B=0,j=Me.length;B<j;B++){const H=Me[B](Ue,ze);if(H)return H}return null}}e.$Kk=O.bind(void 0,!1),e.$Lk=O.bind(void 0,!0);function O(Me,Ue,ze){if(!ze||ze.length<Ue.length)return null;let B;return Me?B=N.$Jf(ze,Ue):B=ze.indexOf(Ue)===0,B?Ue.length>0?[{start:0,end:Ue.length}]:[]:null}function p(Me,Ue){const ze=Ue.toLowerCase().indexOf(Me.toLowerCase());return ze===-1?null:[{start:ze,end:ze+Me.length}]}function s(Me,Ue){return I(Me.toLowerCase(),Ue.toLowerCase(),0,0)}function I(Me,Ue,ze,B){if(ze===Me.length)return[];if(B===Ue.length)return null;if(Me[ze]===Ue[B]){let j=null;return(j=I(Me,Ue,ze+1,B+1))?t({start:B,end:B+1},j):null}return I(Me,Ue,ze,B+1)}function v(Me){return y.CharCode.a<=Me&&Me<=y.CharCode.z}function h(Me){return y.CharCode.A<=Me&&Me<=y.CharCode.Z}function E(Me){return y.CharCode.Digit0<=Me&&Me<=y.CharCode.Digit9}function f(Me){return Me===y.CharCode.Space||Me===y.CharCode.Tab||Me===y.CharCode.LineFeed||Me===y.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Me=>r.add(Me.charCodeAt(0)));function a(Me){return f(Me)||r.has(Me)}function c(Me,Ue){return Me===Ue||a(Me)&&a(Ue)}const u=new Map;function i(Me){if(u.has(Me))return u.get(Me);let Ue;const ze=(0,C.$Ik)(Me);return ze&&(Ue=ze),u.set(Me,Ue),Ue}function n(Me){return v(Me)||h(Me)||E(Me)}function t(Me,Ue){return Ue.length===0?Ue=[Me]:Me.end===Ue[0].start?Ue[0].start=Me.start:Ue.unshift(Me),Ue}function o(Me,Ue){for(let ze=Ue;ze<Me.length;ze++){const B=Me.charCodeAt(ze);if(h(B)||E(B)||ze>0&&!n(Me.charCodeAt(ze-1)))return ze}return Me.length}function l(Me,Ue,ze,B){if(ze===Me.length)return[];if(B===Ue.length)return null;if(Me[ze]!==Ue[B].toLowerCase())return null;{let j=null,H=B+1;for(j=l(Me,Ue,ze+1,B+1);!j&&(H=o(Ue,H))<Ue.length;)j=l(Me,Ue,ze+1,H),H++;return j===null?null:t({start:B,end:B+1},j)}}function m(Me){let Ue=0,ze=0,B=0,j=0,H=0;for(let qe=0;qe<Me.length;qe++)H=Me.charCodeAt(qe),h(H)&&Ue++,v(H)&&ze++,n(H)&&B++,E(H)&&j++;const J=Ue/Me.length,re=ze/Me.length,ge=B/Me.length,ke=j/Me.length;return{upperPercent:J,lowerPercent:re,alphaPercent:ge,numericPercent:ke}}function g(Me){const{upperPercent:Ue,lowerPercent:ze}=Me;return ze===0&&Ue>.6}function d(Me){const{upperPercent:Ue,lowerPercent:ze,alphaPercent:B,numericPercent:j}=Me;return ze>.2&&Ue<.8&&B>.6&&j<.2}function S(Me){let Ue=0,ze=0,B=0,j=0;for(let H=0;H<Me.length;H++)B=Me.charCodeAt(H),h(B)&&Ue++,v(B)&&ze++,f(B)&&j++;return(Ue===0||ze===0)&&j===0?Me.length<=30:Ue<=5}function k(Me,Ue){if(!Ue||(Ue=Ue.trim(),Ue.length===0)||!S(Me))return null;Ue.length>60&&(Ue=Ue.substring(0,60));const ze=m(Ue);if(!d(ze)){if(!g(ze))return null;Ue=Ue.toLowerCase()}let B=null,j=0;for(Me=Me.toLowerCase();j<Ue.length&&(B=l(Me,Ue,0,j))===null;)j=o(Ue,j+1);return B}function w(Me,Ue,ze=!1){if(!Ue||Ue.length===0)return null;let B=null,j=0;for(Me=Me.toLowerCase(),Ue=Ue.toLowerCase();j<Ue.length&&(B=P(Me,Ue,0,j,ze),B===null);)j=R(Ue,j+1);return B}function P(Me,Ue,ze,B,j){let H=0;if(ze===Me.length)return[];if(B===Ue.length)return null;if(!c(Me.charCodeAt(ze),Ue.charCodeAt(B))){const ge=i(Me.charCodeAt(ze));if(!ge)return null;for(let ke=0;ke<ge.length;ke++)if(!c(ge[ke],Ue.charCodeAt(B+ke)))return null;H+=ge.length-1}let J=null,re=B+H+1;if(J=P(Me,Ue,ze+1,re,j),!j)for(;!J&&(re=R(Ue,re))<Ue.length;)J=P(Me,Ue,ze+1,re,j),re++;if(!J)return null;if(Me.charCodeAt(ze)!==Ue.charCodeAt(B)){const ge=i(Me.charCodeAt(ze));if(!ge)return J;for(let ke=0;ke<ge.length;ke++)if(ge[ke]!==Ue.charCodeAt(B+ke))return J}return t({start:B,end:B+H+1},J)}function R(Me,Ue){for(let ze=Ue;ze<Me.length;ze++)if(a(Me.charCodeAt(ze))||ze>0&&a(Me.charCodeAt(ze-1)))return ze;return Me.length}const $=T(e.$Lk,k,p),b=T(e.$Lk,k,s),L=new D.$Gc(1e4);function A(Me,Ue,ze=!1){if(typeof Me!="string"||typeof Ue!="string")return null;let B=L.get(Me);B||(B=new RegExp(N.$rf(Me),"i"),L.set(Me,B));const j=B.exec(Ue);return j?[{start:j.index,end:j.index+j[0].length}]:ze?b(Me,Ue):$(Me,Ue)}function M(Me,Ue){const ze=Te(Me,Me.toLowerCase(),0,Ue,Ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ze?G(ze):null}function Z(Me,Ue,ze,B,j,H){const J=Math.min(13,Me.length);for(;ze<J;ze++){const re=Te(Me,Ue,ze,B,j,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,H]}function G(Me){if(typeof Me>"u")return[];const Ue=[],ze=Me[1];for(let B=Me.length-1;B>1;B--){const j=Me[B]+ze,H=Ue[Ue.length-1];H&&H.end===j?H.end=j+1:Ue.push({start:j,end:j+1})}return Ue}const U=128;function V(){const Me=[],Ue=[];for(let ze=0;ze<=U;ze++)Ue[ze]=0;for(let ze=0;ze<=U;ze++)Me.push(Ue.slice(0));return Me}function Q(Me){const Ue=[];for(let ze=0;ze<=Me;ze++)Ue[ze]=0;return Ue}const ne=Q(2*U),ue=Q(2*U),x=V(),oe=V(),se=V(),ce=!1;function te(Me,Ue,ze,B,j){function H(re,ge,ke=" "){for(;re.length<ge;)re=ke+re;return re}let J=` |   |${B.split("").map(re=>H(re,3)).join("|")}
`;for(let re=0;re<=ze;re++)re===0?J+=" |":J+=`${Ue[re-1]}|`,J+=Me[re].slice(0,j+1).map(ge=>H(ge.toString(),3)).join("|")+`
`;return J}function we(Me,Ue,ze,B){Me=Me.substr(Ue),ze=ze.substr(B),console.log(te(oe,Me,Me.length,ze,ze.length)),console.log(te(se,Me,Me.length,ze,ze.length)),console.log(te(x,Me,Me.length,ze,ze.length))}function Ce(Me,Ue){if(Ue<0||Ue>=Me.length)return!1;const ze=Me.codePointAt(Ue);switch(ze){case y.CharCode.Underline:case y.CharCode.Dash:case y.CharCode.Period:case y.CharCode.Space:case y.CharCode.Slash:case y.CharCode.Backslash:case y.CharCode.SingleQuote:case y.CharCode.DoubleQuote:case y.CharCode.Colon:case y.CharCode.DollarSign:case y.CharCode.LessThan:case y.CharCode.GreaterThan:case y.CharCode.OpenParen:case y.CharCode.CloseParen:case y.CharCode.OpenSquareBracket:case y.CharCode.CloseSquareBracket:case y.CharCode.OpenCurlyBrace:case y.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!N.$2f(ze)}}function Y(Me,Ue){if(Ue<0||Ue>=Me.length)return!1;switch(Me.charCodeAt(Ue)){case y.CharCode.Space:case y.CharCode.Tab:return!0;default:return!1}}function W(Me,Ue,ze){return Ue[Me]!==ze[Me]}function ee(Me,Ue,ze,B,j,H,J=!1){for(;Ue<ze&&j<H;)Me[Ue]===B[j]&&(J&&(ne[Ue]=j),Ue+=1),j+=1;return Ue===ze}var be;(function(Me){Me[Me.Diag=1]="Diag",Me[Me.Left=2]="Left",Me[Me.LeftLeft=3]="LeftLeft"})(be||(be={}));var Pe;(function(Me){Me.Default=[-100,0];function Ue(ze){return!ze||ze.length===2&&ze[0]===-100&&ze[1]===0}Me.isDefault=Ue})(Pe||(e.FuzzyScore=Pe={}));class je{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ue,ze){this.firstMatchCanBeWeak=Ue,this.boostFullMatch=ze}}e.$Wk=je;function Te(Me,Ue,ze,B,j,H,J=je.default){const re=Me.length>U?U:Me.length,ge=B.length>U?U:B.length;if(ze>=re||H>=ge||re-ze>ge-H||!ee(Ue,ze,re,j,H,ge,!0))return;Ee(re,ge,ze,H,Ue,j);let ke=1,qe=1,xe=ze,rt=H;const st=[!1];for(ke=1,xe=ze;xe<re;ke++,xe++){const nt=ne[xe],he=ue[xe],pe=xe+1<re?ue[xe+1]:ge;for(qe=nt-H+1,rt=nt;rt<pe;qe++,rt++){let ye=Number.MIN_SAFE_INTEGER,Re=!1;rt<=he&&(ye=Fe(Me,Ue,xe,ze,B,j,rt,ge,H,x[ke-1][qe-1]===0,st));let fe=0;ye!==Number.MAX_SAFE_INTEGER&&(Re=!0,fe=ye+oe[ke-1][qe-1]);const ve=rt>nt,X=ve?oe[ke][qe-1]+(x[ke][qe-1]>0?-5:0):0,q=rt>nt+1&&x[ke][qe-1]>0,de=q?oe[ke][qe-2]+(x[ke][qe-2]>0?-5:0):0;if(q&&(!ve||de>=X)&&(!Re||de>=fe))oe[ke][qe]=de,se[ke][qe]=be.LeftLeft,x[ke][qe]=0;else if(ve&&(!Re||X>=fe))oe[ke][qe]=X,se[ke][qe]=be.Left,x[ke][qe]=0;else if(Re)oe[ke][qe]=fe,se[ke][qe]=be.Diag,x[ke][qe]=x[ke-1][qe-1]+1;else throw new Error("not possible")}}if(ce&&we(Me,ze,B,H),!st[0]&&!J.firstMatchCanBeWeak)return;ke--,qe--;const ut=[oe[ke][qe],H];let ot=0,lt=0;for(;ke>=1;){let nt=qe;do{const he=se[ke][nt];if(he===be.LeftLeft)nt=nt-2;else if(he===be.Left)nt=nt-1;else break}while(nt>=1);ot>1&&Ue[ze+ke-1]===j[H+qe-1]&&!W(nt+H-1,B,j)&&ot+1>x[ke][nt]&&(nt=qe),nt===qe?ot++:ot=1,lt||(lt=nt),ke--,qe=nt-1,ut.push(qe)}ge-H===re&&J.boostFullMatch&&(ut[0]+=2);const vt=lt-re;return ut[0]-=vt,ut}function Ee(Me,Ue,ze,B,j,H){let J=Me-1,re=Ue-1;for(;J>=ze&&re>=B;)j[J]===H[re]&&(ue[J]=re,J--),re--}function Fe(Me,Ue,ze,B,j,H,J,re,ge,ke,qe){if(Ue[ze]!==H[J])return Number.MIN_SAFE_INTEGER;let xe=1,rt=!1;return J===ze-B?xe=Me[ze]===j[J]?7:5:W(J,j,H)&&(J===0||!W(J-1,j,H))?(xe=Me[ze]===j[J]?7:5,rt=!0):Ce(H,J)&&(J===0||!Ce(H,J-1))?xe=5:(Ce(H,J-1)||Y(H,J-1))&&(xe=5,rt=!0),xe>1&&ze===B&&(qe[0]=!0),rt||(rt=W(J,j,H)||Ce(H,J-1)||Y(H,J-1)),ze===B?J>ge&&(xe-=rt?3:5):ke?xe+=rt?2:0:xe+=rt?0:1,J+1===re&&(xe-=rt?3:5),xe}function Ve(Me,Ue,ze,B,j,H,J){return et(Me,Ue,ze,B,j,H,!0,J)}function Ge(Me,Ue,ze,B,j,H,J){return et(Me,Ue,ze,B,j,H,!1,J)}function et(Me,Ue,ze,B,j,H,J,re){let ge=Te(Me,Ue,ze,B,j,H,re);if(ge&&!J)return ge;if(Me.length>=3){const ke=Math.min(7,Me.length-1);for(let qe=ze+1;qe<ke;qe++){const xe=it(Me,qe);if(xe){const rt=Te(xe,xe.toLowerCase(),ze,B,j,H,re);rt&&(rt[0]-=3,(!ge||rt[0]>ge[0])&&(ge=rt))}}}return ge}function it(Me,Ue){if(Ue+1>=Me.length)return;const ze=Me[Ue],B=Me[Ue+1];if(ze!==B)return Me.slice(0,Ue)+B+ze+Me.slice(Ue+2)}}),define(Oe[99],Ae([1,0,150,12,35]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=p,e.$2k=I,e.$3k=h,e.$4k=E,e.$5k=r,e.$6k=a;const N="$(",T=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${T.source}`,"g");function p(c){return c.replace(O,(u,i)=>i?u:`\\${u}`)}const s=new RegExp(`\\\\${T.source}`,"g");function I(c){return c.replace(s,u=>`\\${u}`)}const v=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function h(c){return c.indexOf(N)===-1?c:c.replace(v,(u,i,n,t)=>n?u:i||t||"")}function E(c){return c?c.replace(/\$\((.*?)\)/g,(u,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(c){f.lastIndex=0;let u="";const i=[];let n=0;for(;;){const t=f.lastIndex,o=f.exec(c),l=c.substring(t,o?.index);if(l.length>0){u+=l;for(let m=0;m<l.length;m++)i.push(n)}if(!o)break;n+=o[0].length}return{text:u,iconOffsets:i}}function a(c,u,i=!1){const{text:n,iconOffsets:t}=u;if(!t||t.length===0)return(0,y.$Rk)(c,n,i);const o=(0,D.$pf)(n," "),l=n.length-o.length,m=(0,y.$Rk)(c,o,i);if(m)for(const g of m){const d=t[g.start+l]+l;g.start+=d,g.end+=d}return m}}),define(Oe[36],Ae([1,0,12]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),y=He(y);var D;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(D||(D={})),function(C){const N="error",T="warning",O="warn",p="info",s="ignore";function I(h){return h?y.$If(N,h)?C.Error:y.$If(T,h)||y.$If(O,h)?C.Warning:y.$If(p,h)?C.Info:C.Ignore:C.Ignore}C.fromValue=I;function v(h){switch(h){case C.Error:return N;case C.Warning:return T;case C.Info:return p;default:return s}}C.toString=v}(D||(D={})),e.default=D}),define(Oe[49],Ae([1,0,17,27,12]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class N{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const r=f.charCodeAt(0),a=this.b.charCodeAt(this.c);return r-a}value(){return this.b[this.c]}}e.$Ki=N;class T{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===D.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,C.$Cf)(f,this.b,0,f.length,this.c,this.d):(0,C.$Ef)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=T;class O{constructor(f=!0,r=!0){this.f=f,this.g=r}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let r=f.length-1;r>=0;r--,this.c--){const a=this.b.charCodeAt(r);if(!(a===D.CharCode.Slash||this.f&&a===D.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===D.CharCode.Slash||this.f&&r===D.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,C.$Cf)(f,this.b,0,f.length,this.d,this.e):(0,C.$Ef)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=O;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class s{constructor(f,r){this.f=f,this.g=r,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new O(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,C.$Df)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,C.$Df)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,C.$Bf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,C.$Bf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ni=s;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(v||(v={}));class h{static forUris(f=()=>!1,r=()=>!1){return new h(new s(f,r))}static forPaths(f=!1){return new h(new O(void 0,!f))}static forStrings(){return new h(new N)}static forConfigKeys(){return new h(new T)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,r){if(r){const a=r.slice(0);(0,y.$Yb)(a);for(const c of a)this.set(c,f)}else{const a=f.slice(0);(0,y.$Yb)(a);for(const c of a)this.set(c[0],c[1])}}set(f,r){const a=this.b.reset(f);let c;this.c||(this.c=new I,this.c.segment=a.value());const u=[];for(c=this.c;;){const n=a.cmp(c.segment);if(n>0)c.left||(c.left=new I,c.left.segment=a.value()),u.push([v.Left,c]),c=c.left;else if(n<0)c.right||(c.right=new I,c.right.segment=a.value()),u.push([v.Right,c]),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new I,c.mid.segment=a.value()),u.push([v.Mid,c]),c=c.mid;else break}const i=c.value;c.value=r,c.key=f;for(let n=u.length-1;n>=0;n--){const t=u[n][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const l=u[n][0],m=u[n+1][0];if(l===v.Right&&m===v.Right)u[n][1]=t.rotateLeft();else if(l===v.Left&&m===v.Left)u[n][1]=t.rotateRight();else if(l===v.Right&&m===v.Left)t.right=u[n+1][1]=u[n+1][1].rotateRight(),u[n][1]=t.rotateLeft();else if(l===v.Left&&m===v.Right)t.left=u[n+1][1]=u[n+1][1].rotateLeft(),u[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(u[n-1][0]){case v.Left:u[n-1][1].left=u[n][1];break;case v.Right:u[n-1][1].right=u[n][1];break;case v.Mid:u[n-1][1].mid=u[n][1];break}else this.c=u[0][1]}}return i}get(f){return this.d(f)?.value}d(f){const r=this.b.reset(f);let a=this.c;for(;a;){const c=r.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(f){const r=this.d(f);return!(r?.value===void 0&&r?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,r){const a=this.b.reset(f),c=[];let u=this.c;for(;u;){const i=a.cmp(u.segment);if(i>0)c.push([v.Left,u]),u=u.left;else if(i<0)c.push([v.Right,u]),u=u.right;else if(a.hasNext())a.next(),c.push([v.Mid,u]),u=u.mid;else break}if(u){if(r?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const i=this.f(u.right);if(i.key){const{key:n,value:t,segment:o}=i;this.e(i.key,!1),u.key=n,u.value=t,u.segment=o}}else{const i=u.left??u.right;if(c.length>0){const[n,t]=c[c.length-1];switch(n){case v.Left:t.left=i;break;case v.Mid:t.mid=i;break;case v.Right:t.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const n=c[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),c[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),c[i][1]=n.rotateRight()),i>0)switch(c[i-1][0]){case v.Left:c[i-1][1].left=c[i][1];break;case v.Right:c[i-1][1].right=c[i][1];break;case v.Mid:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const r=this.b.reset(f);let a=this.c,c;for(;a;){const u=r.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(r.hasNext())r.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(f){return this.g(f,!1)}g(f,r){const a=this.b.reset(f);let c=this.c;for(;c;){const u=a.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(a.hasNext())a.next(),c=c.mid;else return c.mid?this.h(c.mid):r?c.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[r,a]of this)f(a,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const r=[];return this.j(f,r),r[Symbol.iterator]()}j(f,r){f&&(f.left&&this.j(f.left,r),f.value&&r.push([f.key,f.value]),f.mid&&this.j(f.mid,r),f.right&&this.j(f.right,r))}_isBalanced(){const f=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:f(r.left)&&f(r.right)};return f(this.c)}}e.$Oi=h}),define(Oe[33],Ae([1,0,22,2,37]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=N,e.$ei=T,e.$fi=p;function N(s){return JSON.stringify(s,O)}function T(s){let I=JSON.parse(s);return I=p(I),I}function O(s,I){return I instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(s,I=0){if(!s||I>200)return s;if(typeof s=="object"){switch(s.$mid){case C.MarshalledId.Uri:return D.URI.revive(s);case C.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case C.MarshalledId.Date:return new Date(s.source)}if(s instanceof y.$Qe||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let v=0;v<s.length;++v)s[v]=p(s[v],I+1);else for(const v in s)Object.hasOwnProperty.call(s,v)&&(s[v]=p(s[v],I+1))}return s}}),define(Oe[23],Ae([1,0,27,52,15,20,21,12,2]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0,e.$0g=s,e.$sh=v,e.$th=E,D=He(D),N=He(N);function s(f){return(0,p.$zc)(f,!0)}class I{constructor(r){this.a=r}compare(r,a,c=!1){return r===a?0:(0,O.$Bf)(this.getComparisonKey(r,c),this.getComparisonKey(a,c))}isEqual(r,a,c=!1){return r===a?!0:!r||!a?!1:this.getComparisonKey(r,c)===this.getComparisonKey(a,c)}getComparisonKey(r,a=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,a,c=!1){if(r.scheme===a.scheme){if(r.scheme===C.Schemas.file)return D.$Hg(s(r),s(a),this.a(r))&&r.query===a.query&&(c||r.fragment===a.fragment);if((0,e.$oh)(r.authority,a.authority))return D.$Hg(r.path,a.path,this.a(r),"/")&&r.query===a.query&&(c||r.fragment===a.fragment)}return!1}joinPath(r,...a){return p.URI.joinPath(r,...a)}basenameOrAuthority(r){return(0,e.$gh)(r)||r.authority}basename(r){return N.$jc.basename(r.path)}extname(r){return N.$jc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let a;return r.scheme===C.Schemas.file?a=p.URI.file(N.$pc(s(r))).path:(a=N.$jc.dirname(r.path),r.authority&&a.length&&a.charCodeAt(0)!==y.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),a="/")),r.with({path:a})}normalizePath(r){if(!r.path.length)return r;let a;return r.scheme===C.Schemas.file?a=p.URI.file(N.$kc(s(r))).path:a=N.$jc.normalize(r.path),r.with({path:a})}relativePath(r,a){if(r.scheme!==a.scheme||!(0,e.$oh)(r.authority,a.authority))return;if(r.scheme===C.Schemas.file){const i=N.$oc(s(r),s(a));return T.$j?D.$Bg(i):i}let c=r.path||"/";const u=a.path||"/";if(this.a(r)){let i=0;for(const n=Math.min(c.length,u.length);i<n&&!(c.charCodeAt(i)!==u.charCodeAt(i)&&c.charAt(i).toLowerCase()!==u.charAt(i).toLowerCase());i++);c=u.substr(0,i)+c.substr(i)}return N.$jc.relative(c,u)}resolvePath(r,a){if(r.scheme===C.Schemas.file){const c=p.URI.file(N.$nc(s(r),a));return r.with({authority:c.authority,path:c.path})}return a=D.$Cg(a),r.with({path:N.$jc.resolve(r.path,a)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,a){return r===a||r!==void 0&&a!==void 0&&(0,O.$If)(r,a)}hasTrailingPathSeparator(r,a=N.sep){if(r.scheme===C.Schemas.file){const c=s(r);return c.length>D.$Dg(c).length&&c[c.length-1]===a}else{const c=r.path;return c.length>1&&c.charCodeAt(c.length-1)===y.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,a=N.sep){return(0,e.$ph)(r,a)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,a=N.sep){let c=!1;if(r.scheme===C.Schemas.file){const u=s(r);c=u!==void 0&&u.length===D.$Dg(u).length&&u[u.length-1]===a}else{a="/";const u=r.path;c=u.length===1&&u.charCodeAt(u.length-1)===y.CharCode.Slash}return!c&&!(0,e.$ph)(r,a)?r.with({path:r.path+"/"}):r}}e.$$g=I,e.$_g=new I(()=>!1),e.$ah=new I(f=>f.scheme===C.Schemas.file?!T.$l:!0),e.$bh=new I(f=>!0),e.$ch=e.$_g.isEqual.bind(e.$_g),e.$dh=e.$_g.isEqualOrParent.bind(e.$_g),e.$eh=e.$_g.getComparisonKey.bind(e.$_g),e.$fh=e.$_g.basenameOrAuthority.bind(e.$_g),e.$gh=e.$_g.basename.bind(e.$_g),e.$hh=e.$_g.extname.bind(e.$_g),e.$ih=e.$_g.dirname.bind(e.$_g),e.$jh=e.$_g.joinPath.bind(e.$_g),e.$kh=e.$_g.normalizePath.bind(e.$_g),e.$lh=e.$_g.relativePath.bind(e.$_g),e.$mh=e.$_g.resolvePath.bind(e.$_g),e.$nh=e.$_g.isAbsolutePath.bind(e.$_g),e.$oh=e.$_g.isEqualAuthority.bind(e.$_g),e.$ph=e.$_g.hasTrailingPathSeparator.bind(e.$_g),e.$qh=e.$_g.removeTrailingPathSeparator.bind(e.$_g),e.$rh=e.$_g.addTrailingPathSeparator.bind(e.$_g);function v(f,r){const a=[];for(let c=0;c<f.length;c++){const u=r(f[c]);f.some((i,n)=>n===c?!1:(0,e.$dh)(u,r(i)))||a.push(f[c])}return a}var h;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function r(a){const c=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(n=>{const[t,o]=n.split(":");t&&o&&c.set(t,o)});const i=a.path.substring(0,a.path.indexOf(";"));return i&&c.set(f.META_DATA_MIME,i),c}f.parseMetaData=r})(h||(e.DataUri=h={}));function E(f,r,a){if(r){let c=f.path;return c&&c[0]!==N.$jc.sep&&(c=N.$jc.sep+c),f.with({scheme:a,authority:r,path:c})}return f.with({scheme:a})}}),define(Oe[10],Ae([1,0,19,13,6,4,23,21,149,48]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$0h=e.$9h=e.$8h=e.$7h=e.Promises=e.$6h=e.$5h=e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0,e.$uh=I,e.$vh=v,e.$wh=h,e.$xh=E,e.$yh=f,e.$zh=r,e.$Ah=a,e.$Bh=c,e.$Jh=S,e.$Kh=k,e.$Lh=w,e.$Mh=P,e.$Nh=R,e.$3h=x,e.$$h=Pe;function I(Te){return!!Te&&typeof Te.then=="function"}function v(Te){const Ee=new y.$ze,Fe=Te(Ee.token),Ve=new Promise((Ge,et)=>{const it=Ee.token.onCancellationRequested(()=>{it.dispose(),et(new D.$7)});Promise.resolve(Fe).then(Me=>{it.dispose(),Ee.dispose(),Ge(Me)},Me=>{it.dispose(),Ee.dispose(),et(Me)})});return new class{cancel(){Ee.cancel(),Ee.dispose()}then(Ge,et){return Ve.then(Ge,et)}catch(Ge){return this.then(void 0,Ge)}finally(Ge){return Ve.finally(Ge)}}}function h(Te,Ee,Fe){return new Promise((Ve,Ge)=>{const et=Ee.onCancellationRequested(()=>{et.dispose(),Ve(Fe)});Te.then(Ve,Ge).finally(()=>et.dispose())})}function E(Te,Ee){return new Promise((Fe,Ve)=>{const Ge=Ee.onCancellationRequested(()=>{Ge.dispose(),Ve(new D.$7)});Te.then(Fe,Ve).finally(()=>Ge.dispose())})}async function f(Te){let Ee=-1;const Fe=Te.map((Ve,Ge)=>Ve.then(et=>(Ee=Ge,et)));try{return await Promise.race(Fe)}finally{Te.forEach((Ve,Ge)=>{Ge!==Ee&&Ve.cancel()})}}function r(Te,Ee,Fe){let Ve;const Ge=setTimeout(()=>{Ve?.(void 0),Fe?.()},Ee);return Promise.race([Te.finally(()=>clearTimeout(Ge)),new Promise(et=>Ve=et)])}function a(Te){return new Promise((Ee,Fe)=>{const Ve=Te();I(Ve)?Ve.then(Ee,Fe):Ee(Ve)})}function c(){let Te,Ee;return{promise:new Promise((Ve,Ge)=>{Te=Ve,Ee=Ge}),resolve:Te,reject:Ee}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Ee){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Ee,!this.b){const Fe=()=>{if(this.b=null,this.f)return;const Ve=this.queue(this.d);return this.d=null,Ve};this.b=new Promise(Ve=>{this.a.then(Fe,Fe).then(Ve)})}return new Promise((Fe,Ve)=>{this.b.then(Fe,Ve)})}return this.a=Ee(),new Promise((Fe,Ve)=>{this.a.then(Ge=>{this.a=null,Fe(Ge)},Ge=>{this.a=null,Ve(Ge)})})}dispose(){this.f=!0}}e.$Ch=u;class i{constructor(){this.a=Promise.resolve(null)}queue(Ee){return this.a=this.a.then(()=>Ee(),()=>Ee())}}e.$Dh=i;class n{constructor(){this.a=new Map}queue(Ee,Fe){const Ge=(this.a.get(Ee)??Promise.resolve()).catch(()=>{}).then(Fe).finally(()=>{this.a.get(Ee)===Ge&&this.a.delete(Ee)});return this.a.set(Ee,Ge),Ge}}e.$Eh=n;const t=(Te,Ee)=>{let Fe=!0;const Ve=setTimeout(()=>{Fe=!1,Ee()},Te);return{isTriggered:()=>Fe,dispose:()=>{clearTimeout(Ve),Fe=!1}}},o=Te=>{let Ee=!0;return queueMicrotask(()=>{Ee&&(Ee=!1,Te())}),{isTriggered:()=>Ee,dispose:()=>{Ee=!1}}};class l{constructor(Ee){this.defaultDelay=Ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Ee,Fe=this.defaultDelay){this.g=Ee,this.h(),this.b||(this.b=new Promise((Ge,et)=>{this.d=Ge,this.f=et}).then(()=>{if(this.b=null,this.d=null,this.g){const Ge=this.g;return this.g=null,Ge()}}));const Ve=()=>{this.a=null,this.d?.(null)};return this.a=Fe===p.$je?o(Ve):t(Fe,Ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Fh=l;class m{constructor(Ee){this.a=new l(Ee),this.b=new u}trigger(Ee,Fe){return this.a.trigger(()=>this.b.queue(Ee),Fe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Gh=m;class g{constructor(){this.a=!1,this.b=new Promise((Ee,Fe)=>{this.d=Ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Hh=g;class d extends g{constructor(Ee){super(),this.f=setTimeout(()=>this.open(),Ee)}open(){clearTimeout(this.f),super.open()}}e.$Ih=d;function S(Te,Ee){return Ee?new Promise((Fe,Ve)=>{const Ge=setTimeout(()=>{et.dispose(),Fe()},Te),et=Ee.onCancellationRequested(()=>{clearTimeout(Ge),et.dispose(),Ve(new D.$7)})}):v(Fe=>S(Te,Fe))}function k(Te,Ee=0,Fe){const Ve=setTimeout(()=>{Te(),Fe&&Ge.dispose()},Ee),Ge=(0,N.$Vc)(()=>{clearTimeout(Ve),Fe?.deleteAndLeak(Ge)});return Fe?.add(Ge),Ge}function w(Te){const Ee=[];let Fe=0;const Ve=Te.length;function Ge(){return Fe<Ve?Te[Fe++]():null}function et(it){it!=null&&Ee.push(it);const Me=Ge();return Me?Me.then(et):Promise.resolve(Ee)}return Promise.resolve(null).then(et)}function P(Te,Ee=Ve=>!!Ve,Fe=null){let Ve=0;const Ge=Te.length,et=()=>{if(Ve>=Ge)return Promise.resolve(Fe);const it=Te[Ve++];return Promise.resolve(it()).then(Ue=>Ee(Ue)?Promise.resolve(Ue):et())};return et()}function R(Te,Ee=Ve=>!!Ve,Fe=null){if(Te.length===0)return Promise.resolve(Fe);let Ve=Te.length;const Ge=()=>{Ve=-1;for(const et of Te)et.cancel?.()};return new Promise((et,it)=>{for(const Me of Te)Me.then(Ue=>{--Ve>=0&&Ee(Ue)?(Ge(),et(Ue)):Ve===0&&et(Fe)}).catch(Ue=>{--Ve>=0&&(Ge(),it(Ue))})})}class ${constructor(Ee){this.a=0,this.b=!1,this.f=Ee,this.g=[],this.d=0,this.h=new C.$oe}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Ee){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Fe,Ve)=>{this.g.push({factory:Ee,c:Fe,e:Ve}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Ee=this.g.shift();this.d++;const Fe=Ee.factory();Fe.then(Ee.c,Ee.e),Fe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Oh=$;class b extends ${constructor(){super(1)}}e.$Ph=b;class L{constructor(){this.a=new oe,this.b=0}queue(Ee){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Ee())):this.a.run(this.b++,Ee())}}e.$Qh=L;class A{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Ee=new te;return this.b.add(Ee),Ee.p}g(){for(const[,Ee]of this.a)if(Ee.size>0)return!1;return!0}queueSize(Ee,Fe=T.$_g){const Ve=Fe.getComparisonKey(Ee);return this.a.get(Ve)?.size??0}queueFor(Ee,Fe,Ve=T.$_g){const Ge=Ve.getComparisonKey(Ee);let et=this.a.get(Ge);if(!et){et=new b;const it=this.f++,Me=C.Event.once(et.onDrained)(()=>{et?.dispose(),this.a.delete(Ge),this.h(),this.d?.deleteAndDispose(it),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$7c),this.d.set(it,Me),this.a.set(Ge,et)}return et.queue(Fe)}h(){this.g()&&this.j()}j(){for(const Ee of this.b)Ee.complete();this.b.clear()}dispose(){for(const[,Ee]of this.a)Ee.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Rh=A;class M{constructor(Ee,Fe){this.b=!1,this.a=-1,typeof Ee=="function"&&typeof Fe=="number"&&this.setIfNotSet(Ee,Fe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Ee,Fe){if(this.b)throw new D.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Ee()},Fe)}setIfNotSet(Ee,Fe){if(this.b)throw new D.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Ee()},Fe))}}e.$Sh=M;class Z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Ee,Fe,Ve=globalThis){if(this.f)throw new D.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Ge=Ve.setInterval(()=>{Ee()},Fe);this.d=(0,N.$Vc)(()=>{Ve.clearInterval(Ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Th=Z;class G{constructor(Ee,Fe){this.b=-1,this.a=Ee,this.d=Fe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Ee=this.d){this.cancel(),this.b=setTimeout(this.f,Ee)}get delay(){return this.d}set delay(Ee){this.d=Ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Uh=G;class U{constructor(Ee,Fe){Fe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Fe}ms is not a multiple of 1000ms.`),this.a=Ee,this.b=Fe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Ee=this.b){Ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Vh=U;class V extends G{constructor(Ee,Fe){super(Ee,Fe),this.j=[]}work(Ee){this.j.push(Ee),this.isScheduled()||this.schedule()}h(){const Ee=this.j;this.j=[],this.a?.(Ee)}dispose(){this.j=[],super.dispose()}}e.$Wh=V;class Q extends N.$Xc{constructor(Ee,Fe){super(),this.g=Ee,this.h=Fe,this.a=[],this.b=this.B(new N.$Yc),this.f=!1}get pending(){return this.a.length}work(Ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+Ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Fe of Ee)this.a.push(Fe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Xh=Q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Zh=(Te,Ee)=>{(0,O.$C)(()=>{if(Fe)return;const Ve=Date.now()+15;Ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ve-Date.now())}}))});let Fe=!1;return{dispose(){Fe||(Fe=!0)}}}:e.$Zh=(Te,Ee,Fe)=>{const Ve=Te.requestIdleCallback(Ee,typeof Fe=="number"?{timeout:Fe}:void 0);let Ge=!1;return{dispose(){Ge||(Ge=!0,Te.cancelIdleCallback(Ve))}}},e.$Yh=Te=>(0,e.$Zh)(globalThis,Te)}();class ne{constructor(Ee,Fe){this.g=!1,this.d=()=>{try{this.j=Fe()}catch(Ve){this.l=Ve}finally{this.g=!0}},this.f=(0,e.$Zh)(Ee,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$1h=ne;class ue extends ne{constructor(Ee){super(globalThis,Ee)}}e.$2h=ue;async function x(Te,Ee,Fe){let Ve;for(let Ge=0;Ge<Fe;Ge++)try{return await Te()}catch(et){Ve=et,await S(Ee)}throw Ve}class oe{isRunning(Ee){return typeof Ee=="number"?this.a?.taskId===Ee:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Ee,Fe,Ve){return this.a={taskId:Ee,cancel:()=>Ve?.(),promise:Fe},Fe.then(()=>this.d(Ee),()=>this.d(Ee)),Fe}d(Ee){this.a&&Ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Ee=this.b;this.b=void 0,Ee.run().then(Ee.promiseResolve,Ee.promiseReject)}}queue(Ee){if(this.b)this.b.run=Ee;else{const{promise:Fe,resolve:Ve,reject:Ge}=c();this.b={run:Ee,promise:Fe,promiseResolve:Ve,promiseReject:Ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$4h=oe;class se{constructor(Ee,Fe=()=>Date.now()){this.d=Ee,this.f=Fe,this.a=0,this.b=0}increment(){const Ee=this.f();return Ee-this.a>this.d&&(this.a=Ee,this.b=0),this.b++,this.b}}e.$5h=se;var ce;(function(Te){Te[Te.Resolved=0]="Resolved",Te[Te.Rejected=1]="Rejected"})(ce||(ce={}));class te{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Ee,Fe)=>{this.a=Ee,this.b=Fe})}complete(Ee){return new Promise(Fe=>{this.a(Ee),this.d={outcome:ce.Resolved,value:Ee},Fe()})}error(Ee){return new Promise(Fe=>{this.b(Ee),this.d={outcome:ce.Rejected,value:Ee},Fe()})}cancel(){return this.error(new D.$7)}}e.$6h=te;var we;(function(Te){async function Ee(Ve){let Ge;const et=await Promise.all(Ve.map(it=>it.then(Me=>Me,Me=>{Ge||(Ge=Me)})));if(typeof Ge<"u")throw Ge;return et}Te.settled=Ee;function Fe(Ve){return new Promise(async(Ge,et)=>{try{await Ve(Ge,et)}catch(it){et(it)}})}Te.withAsyncBody=Fe})(we||(e.Promises=we={}));class Ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Ee){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Ee.then(Fe=>(this.a=Fe,this.d=!0,Fe),Fe=>{throw this.b=Fe,this.d=!0,Fe})}requireValue(){if(!this.d)throw new D.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$7h=Ce;class Y{constructor(Ee){this.b=Ee,this.a=new s.$W(()=>new Ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$8h=Y;var W;(function(Te){Te[Te.Initial=0]="Initial",Te[Te.DoneOK=1]="DoneOK",Te[Te.DoneError=2]="DoneError"})(W||(W={}));class ee{static fromArray(Ee){return new ee(Fe=>{Fe.emitMany(Ee)})}static fromPromise(Ee){return new ee(async Fe=>{Fe.emitMany(await Ee)})}static fromPromises(Ee){return new ee(async Fe=>{await Promise.all(Ee.map(async Ve=>Fe.emitOne(await Ve)))})}static merge(Ee){return new ee(async Fe=>{await Promise.all(Ee.map(async Ve=>{for await(const Ge of Ve)Fe.emitOne(Ge)}))})}static{this.EMPTY=ee.fromArray([])}constructor(Ee,Fe){this.a=W.Initial,this.b=[],this.d=null,this.f=Fe,this.g=new C.$oe,queueMicrotask(async()=>{const Ve={emitOne:Ge=>this.h(Ge),emitMany:Ge=>this.j(Ge),reject:Ge=>this.l(Ge)};try{await Promise.resolve(Ee(Ve)),this.k()}catch(Ge){this.l(Ge)}finally{Ve.emitOne=void 0,Ve.emitMany=void 0,Ve.reject=void 0}})}[Symbol.asyncIterator](){let Ee=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(Ee<this.b.length)return{done:!1,value:this.b[Ee++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Ee,Fe){return new ee(async Ve=>{for await(const Ge of Ee)Ve.emitOne(Fe(Ge))})}map(Ee){return ee.map(this,Ee)}static filter(Ee,Fe){return new ee(async Ve=>{for await(const Ge of Ee)Fe(Ge)&&Ve.emitOne(Ge)})}filter(Ee){return ee.filter(this,Ee)}static coalesce(Ee){return ee.filter(Ee,Fe=>!!Fe)}coalesce(){return ee.coalesce(this)}static async toPromise(Ee){const Fe=[];for await(const Ve of Ee)Fe.push(Ve);return Fe}toPromise(){return ee.toPromise(this)}h(Ee){this.a===W.Initial&&(this.b.push(Ee),this.g.fire())}j(Ee){this.a===W.Initial&&(this.b=this.b.concat(Ee),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(Ee){this.a===W.Initial&&(this.a=W.DoneError,this.d=Ee,this.g.fire())}}e.$9h=ee;class be extends ee{constructor(Ee,Fe){super(Fe),this.m=Ee}cancel(){this.m.cancel()}}e.$0h=be;function Pe(Te){const Ee=new y.$ze,Fe=Te(Ee.token);return new be(Ee,async Ve=>{const Ge=Ee.token.onCancellationRequested(()=>{Ge.dispose(),Ee.dispose(),Ve.reject(new D.$7)});try{for await(const et of Fe){if(Ee.token.isCancellationRequested)return;Ve.emitOne(et)}Ge.dispose(),Ee.dispose()}catch(et){Ge.dispose(),Ee.dispose(),Ve.reject(et)}})}class je{constructor(Ee){this.a=new te,this.b=new ee(Ge=>{if(Fe){Ge.reject(Fe);return}return Ve&&Ge.emitMany(Ve),this.d=et=>Ge.reject(et),this.f=et=>Ge.emitOne(et),this.a.p},Ee);let Fe,Ve;this.f=Ge=>{Ve||(Ve=[]),Ve.push(Ge)},this.d=Ge=>{Fe||(Fe=Ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Ee){this.d(Ee),this.a.complete()}emitOne(Ee){this.f(Ee)}}e.$_h=je}),define(Oe[41],Ae([1,0,17,10,27,52,28,20,21,12]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=void 0,e.$yk=I,e.$Bk=r,e.$Ck=L,e.$Dk=A,e.$Ek=M,e.$Fk=Z,e.$Gk=G,e.$Hk=ne;function I(){return Object.create(null)}e.$zk="**",e.$Ak="/";const v="[/\\\\]",h="[^/\\\\]",E=/\//g;function f(ue,x){switch(ue){case 0:return"";case 1:return`${h}*?`;default:return`(?:${v}|${h}+${v}${x?`|${v}${h}+`:""})*?`}}function r(ue,x){if(!ue)return[];const oe=[];let se=!1,ce=!1,te="";for(const we of ue){switch(we){case x:if(!se&&!ce){oe.push(te),te="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}te+=we}return te&&oe.push(te),oe}function a(ue){if(!ue)return"";let x="";const oe=r(ue,e.$Ak);if(oe.every(se=>se===e.$zk))x=".*";else{let se=!1;oe.forEach((ce,te)=>{if(ce===e.$zk){if(se)return;x+=f(2,te===oe.length-1)}else{let we=!1,Ce="",Y=!1,W="";for(const ee of ce){if(ee!=="}"&&we){Ce+=ee;continue}if(Y&&(ee!=="]"||!W)){let be;ee==="-"?be=ee:(ee==="^"||ee==="!")&&!W?be="^":ee===e.$Ak?be="":be=(0,s.$kf)(ee),W+=be;continue}switch(ee){case"{":we=!0;continue;case"[":Y=!0;continue;case"}":{const Pe=`(?:${r(Ce,",").map(je=>a(je)).join("|")})`;x+=Pe,we=!1,Ce="";break}case"]":{x+="["+W+"]",Y=!1,W="";break}case"?":x+=h;continue;case"*":x+=f(1);continue;default:x+=(0,s.$kf)(ee)}}te<oe.length-1&&(oe[te+1]!==e.$zk||te+2<oe.length)&&(x+=v)}se=ce===e.$zk})}return x}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new T.$Gc(1e4),m=function(){return!1},g=function(){return null};function d(ue,x){if(!ue)return g;let oe;typeof ue!="string"?oe=ue.pattern:oe=ue,oe=oe.trim();const se=`${oe}_${!!x.trimForExclusions}`;let ce=l.get(se);if(ce)return S(ce,ue);let te;return c.test(oe)?ce=w(oe.substr(4),oe):(te=u.exec(k(oe,x)))?ce=P(te[1],oe):(x.trimForExclusions?n:i).test(oe)?ce=R(oe,x):(te=t.exec(k(oe,x)))?ce=$(te[1].substr(1),oe,!0):(te=o.exec(k(oe,x)))?ce=$(te[1],oe,!1):ce=b(oe),l.set(se,ce),S(ce,ue)}function S(ue,x){if(typeof x=="string")return ue;const oe=function(se,ce){return(0,N.$Hg)(se,x.base,!p.$l)?ue((0,s.$pf)(se.substr(x.base.length),O.sep),ce):null};return oe.allBasenames=ue.allBasenames,oe.allPaths=ue.allPaths,oe.basenames=ue.basenames,oe.patterns=ue.patterns,oe}function k(ue,x){return x.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function w(ue,x){return function(oe,se){return typeof oe=="string"&&oe.endsWith(ue)?x:null}}function P(ue,x){const oe=`/${ue}`,se=`\\${ue}`,ce=function(we,Ce){return typeof we!="string"?null:Ce?Ce===ue?x:null:we===ue||we.endsWith(oe)||we.endsWith(se)?x:null},te=[ue];return ce.basenames=te,ce.patterns=[x],ce.allBasenames=te,ce}function R(ue,x){const oe=Q(ue.slice(1,-1).split(",").map(Ce=>d(Ce,x)).filter(Ce=>Ce!==g),ue),se=oe.length;if(!se)return g;if(se===1)return oe[0];const ce=function(Ce,Y){for(let W=0,ee=oe.length;W<ee;W++)if(oe[W](Ce,Y))return ue;return null},te=oe.find(Ce=>!!Ce.allBasenames);te&&(ce.allBasenames=te.allBasenames);const we=oe.reduce((Ce,Y)=>Y.allPaths?Ce.concat(Y.allPaths):Ce,[]);return we.length&&(ce.allPaths=we),ce}function $(ue,x,oe){const se=O.sep===O.$jc.sep,ce=se?ue:ue.replace(E,O.sep),te=O.sep+ce,we=O.$jc.sep+ue;let Ce;return oe?Ce=function(Y,W){return typeof Y=="string"&&(Y===ce||Y.endsWith(te)||!se&&(Y===ue||Y.endsWith(we)))?x:null}:Ce=function(Y,W){return typeof Y=="string"&&(Y===ce||!se&&Y===ue)?x:null},Ce.allPaths=[(oe?"*/":"./")+ue],Ce}function b(ue){try{const x=new RegExp(`^${a(ue)}$`);return function(oe){return x.lastIndex=0,typeof oe=="string"&&x.test(oe)?ue:null}}catch{return g}}function L(ue,x,oe){return!ue||typeof x!="string"?!1:A(ue)(x,void 0,oe)}function A(ue,x={}){if(!ue)return m;if(typeof ue=="string"||M(ue)){const oe=d(ue,x);if(oe===g)return m;const se=function(ce,te){return!!oe(ce,te)};return oe.allBasenames&&(se.allBasenames=oe.allBasenames),oe.allPaths&&(se.allPaths=oe.allPaths),se}return U(ue,x)}function M(ue){const x=ue;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}function Z(ue){return ue.allBasenames||[]}function G(ue){return ue.allPaths||[]}function U(ue,x){const oe=Q(Object.getOwnPropertyNames(ue).map(Ce=>V(Ce,ue[Ce],x)).filter(Ce=>Ce!==g)),se=oe.length;if(!se)return g;if(!oe.some(Ce=>!!Ce.requiresSiblings)){if(se===1)return oe[0];const Ce=function(ee,be){let Pe;for(let je=0,Te=oe.length;je<Te;je++){const Ee=oe[je](ee,be);if(typeof Ee=="string")return Ee;(0,D.$uh)(Ee)&&(Pe||(Pe=[]),Pe.push(Ee))}return Pe?(async()=>{for(const je of Pe){const Te=await je;if(typeof Te=="string")return Te}return null})():null},Y=oe.find(ee=>!!ee.allBasenames);Y&&(Ce.allBasenames=Y.allBasenames);const W=oe.reduce((ee,be)=>be.allPaths?ee.concat(be.allPaths):ee,[]);return W.length&&(Ce.allPaths=W),Ce}const ce=function(Ce,Y,W){let ee,be;for(let Pe=0,je=oe.length;Pe<je;Pe++){const Te=oe[Pe];Te.requiresSiblings&&W&&(Y||(Y=(0,O.$qc)(Ce)),ee||(ee=Y.substr(0,Y.length-(0,O.$rc)(Ce).length)));const Ee=Te(Ce,Y,ee,W);if(typeof Ee=="string")return Ee;(0,D.$uh)(Ee)&&(be||(be=[]),be.push(Ee))}return be?(async()=>{for(const Pe of be){const je=await Pe;if(typeof je=="string")return je}return null})():null},te=oe.find(Ce=>!!Ce.allBasenames);te&&(ce.allBasenames=te.allBasenames);const we=oe.reduce((Ce,Y)=>Y.allPaths?Ce.concat(Y.allPaths):Ce,[]);return we.length&&(ce.allPaths=we),ce}function V(ue,x,oe){if(x===!1)return g;const se=d(ue,oe);if(se===g)return g;if(typeof x=="boolean")return se;if(x){const ce=x.when;if(typeof ce=="string"){const te=(we,Ce,Y,W)=>{if(!W||!se(we,Ce))return null;const ee=ce.replace("$(basename)",()=>Y),be=W(ee);return(0,D.$uh)(be)?be.then(Pe=>Pe?ue:null):be?ue:null};return te.requiresSiblings=!0,te}}return se}function Q(ue,x){const oe=ue.filter(Ce=>!!Ce.basenames);if(oe.length<2)return ue;const se=oe.reduce((Ce,Y)=>{const W=Y.basenames;return W?Ce.concat(W):Ce},[]);let ce;if(x){ce=[];for(let Ce=0,Y=se.length;Ce<Y;Ce++)ce.push(x)}else ce=oe.reduce((Ce,Y)=>{const W=Y.patterns;return W?Ce.concat(W):Ce},[]);const te=function(Ce,Y){if(typeof Ce!="string")return null;if(!Y){let ee;for(ee=Ce.length;ee>0;ee--){const be=Ce.charCodeAt(ee-1);if(be===C.CharCode.Slash||be===C.CharCode.Backslash)break}Y=Ce.substr(ee)}const W=se.indexOf(Y);return W!==-1?ce[W]:null};te.basenames=se,te.patterns=ce,te.allBasenames=se;const we=ue.filter(Ce=>!Ce.basenames);return we.push(te),we}function ne(ue,x){return(0,y.$wb)(ue,x,(oe,se)=>typeof oe=="string"&&typeof se=="string"?oe===se:typeof oe!="string"&&typeof se!="string"?oe.base===se.base&&oe.pattern===se.pattern:!1)}}),define(Oe[60],Ae([1,0,13,99,23,12,2]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.MarkdownStringTextNewlineStyle=void 0,e.$8k=s,e.$9k=I,e.$0k=v,e.$$k=h,e.$_k=E,e.$al=f,e.$bl=r,e.$cl=a;var O;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(O||(e.MarkdownStringTextNewlineStyle=O={}));class p{constructor(u="",i=!1){if(this.value=u,typeof this.value!="string")throw(0,y.$9)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(u,i=O.Paragraph){return this.value+=h(this.supportThemeIcons?(0,D.$1k)(u):u).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===O.Break?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,i){return this.value+=`
${E(i,u)}
`,this}appendLink(u,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(u),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(u,i){const n=new RegExp((0,N.$kf)(i),"g");return u.replace(n,(t,o)=>u.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$7k=p;function s(c){return I(c)?!c.value:Array.isArray(c)?c.every(s):!0}function I(c){return c instanceof p?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function v(c,u){return c===u?!0:!c||!u?!1:c.value===u.value&&c.isTrusted===u.isTrusted&&c.supportThemeIcons===u.supportThemeIcons&&c.supportHtml===u.supportHtml&&(c.baseUri===u.baseUri||!!c.baseUri&&!!u.baseUri&&(0,C.$ch)(T.URI.from(c.baseUri),T.URI.from(u.baseUri)))}function h(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(c,u){const i=c.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${u}`,c,`${"`".repeat(n)}`].join(`
`)}function f(c){return c.replace(/"/g,"&quot;")}function r(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function a(c){const u=[],i=c.split("|").map(t=>t.trim());c=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),o=/width=(\d+)/.exec(n),l=t?t[1]:"",m=o?o[1]:"",g=isFinite(parseInt(m)),d=isFinite(parseInt(l));g&&u.push(`width="${m}"`),d&&u.push(`height="${l}"`)}return{href:c,dimensions:u}}}),define(Oe[100],Ae([1,0,17,52,20,21,23,12]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6w=p,e.$7w=I,e.$8w=h,e.$9w=E,e.$0w=c,e.$$w=i,e.$_w=n,e.$ax=t,e.$bx=o,e.$cx=l;function p(g,d){const{os:S,tildify:k,relative:w}=d;if(w){const $=s(g,w,S);if(typeof $=="string")return $}let P=g.fsPath;if(S===N.OperatingSystem.Windows&&!N.$j?P=P.replace(/\//g,"\\"):S!==N.OperatingSystem.Windows&&N.$j&&(P=P.replace(/\\/g,"/")),S!==N.OperatingSystem.Windows&&k?.userHome){const $=k.userHome.fsPath;let b;g.scheme!==k.userHome.scheme&&g.path[0]===C.$jc.sep&&g.path[1]!==C.$jc.sep?b=k.userHome.with({path:g.path}).fsPath:b=P,P=h(b,$,S)}return(S===N.OperatingSystem.Windows?C.$ic:C.$jc).normalize(I(P,S===N.OperatingSystem.Windows))}function s(g,d,S){const k=S===N.OperatingSystem.Windows?C.$ic:C.$jc,w=S===N.OperatingSystem.Linux?T.$_g:T.$bh,P=d.getWorkspace(),R=(0,y.$Qb)(P.folders);if(!R)return;g.scheme!==R.uri.scheme&&g.path[0]===C.$jc.sep&&g.path[1]!==C.$jc.sep&&(g=R.uri.with({path:g.path}));const $=d.getWorkspaceFolder(g);if(!$)return;let b;if(w.isEqual($.uri,g)?b="":b=w.relativePath($.uri,g)??"",b&&(b=k.normalize(b)),P.folders.length>1&&!d.noPrefix){const L=$.name?$.name:w.basenameOrAuthority($.uri);b=b?`${L} \u2022 ${b}`:L}return b}function I(g,d=N.$j){return(0,D.$Mg)(g,d)?g.charAt(0).toUpperCase()+g.slice(1):g}let v=Object.create(null);function h(g,d,S=N.OS){if(S===N.OperatingSystem.Windows||!g||!d)return g;let k=v.original===d?v.normalized:void 0;k||(k=d,N.$j&&(k=(0,D.$Bg)(k)),k=`${(0,O.$qf)(k,C.$jc.sep)}${C.$jc.sep}`,v={original:d,normalized:k});let w=g;return N.$j&&(w=(0,D.$Bg)(w)),(S===N.OperatingSystem.Linux?w.startsWith(k):(0,O.$Jf)(w,k))?`~/${w.substr(k.length)}`:g}function E(g,d){return g.replace(/^~($|\/|\\)/,`${d}$1`)}const f="\u2026",r="\\\\",a="~";function c(g,d=C.sep){const S=new Array(g.length);let k=!1;for(let w=0;w<g.length;w++){const P=g[w];if(P===""){S[w]=`.${d}`;continue}if(!P){S[w]=P;continue}k=!0;let R="",$=P;$.indexOf(r)===0?(R=$.substr(0,$.indexOf(r)+r.length),$=$.substr($.indexOf(r)+r.length)):$.indexOf(d)===0?(R=$.substr(0,$.indexOf(d)+d.length),$=$.substr($.indexOf(d)+d.length)):$.indexOf(a)===0&&(R=$.substr(0,$.indexOf(a)+a.length),$=$.substr($.indexOf(a)+a.length));const b=$.split(d);for(let L=1;k&&L<=b.length;L++)for(let A=b.length-L;k&&A>=0;A--){k=!1;let M=b.slice(A,A+L).join(d);for(let Z=0;!k&&Z<g.length;Z++)if(Z!==w&&g[Z]&&g[Z].indexOf(M)>-1){const G=A+L===b.length,U=A>0&&g[Z].indexOf(d)>-1?d+M:M,V=g[Z].endsWith(U);k=!G||V}if(!k){let Z="";(b[0].endsWith(":")||R!=="")&&(A===1&&(A=0,L++,M=b[0]+d+M),A>0&&(Z=b[0]+d),Z=R+Z),A>0&&(Z=Z+f+d),Z=Z+M,A+L<b.length&&(Z=Z+d+f),S[w]=Z}}k&&(S[w]=P)}return S}var u;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function i(g,d=Object.create(null)){const S=[];let k=!1,w="";for(const P of g)if(P==="$"||k&&P==="{")w&&S.push({value:w,type:u.TEXT}),w="",k=!0;else if(P==="}"&&k){const R=d[w];if(typeof R=="string")R.length&&S.push({value:R,type:u.VARIABLE});else if(R){const $=S[S.length-1];(!$||$.type!==u.SEPARATOR)&&S.push({value:R.label,type:u.SEPARATOR})}w="",k=!1}else w+=P;return w&&!k&&S.push({value:w,type:u.TEXT}),S.filter((P,R)=>{if(P.type===u.SEPARATOR){const $=S[R-1],b=S[R+1];return[$,b].every(L=>L&&(L.type===u.VARIABLE||L.type===u.TEXT)&&L.value.length>0)}return!0}).map(P=>P.value).join("")}function n(g,d){return N.$k||d?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$k?"&":"&&"):g.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(g,d){return N.$k||d?g.replace(/\(&&\w\)|&&/g,""):N.$j?g.replace(/&&|&/g,S=>S==="&"?"&&":"&"):g.replace(/&&/g,"_")}function o(g){return g.replace(/&/g,"&&")}function l(g){if(g.endsWith("]")){const d=g.lastIndexOf(" [",g.length-2);if(d!==-1){const S=m(g.substring(0,d)),k=g.substring(d);return{name:S.name+k,parentPath:S.parentPath}}}return m(g)}function m(g){const d=g.indexOf("/")!==-1?C.$jc:C.$ic,S=d.basename(g),k=d.dirname(g);return S.length?{name:S,parentPath:k}:{name:k,parentPath:""}}}),define(Oe[151],Ae([1,0,22,37,2]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=void 0,e.$Rn=p,e.$Sn=I,e.$Tn=v;function N(h){return h.toJSON()}class T{constructor(E){this.a=E}transformIncoming(E){const f=this.a.transformIncoming(E);return f===E?E:N(C.URI.from(f))}transformOutgoing(E){const f=this.a.transformOutgoing(E);return f===E?E:N(C.URI.from(f))}transformOutgoingURI(E){const f=this.a.transformOutgoing(E);return f===E?E:C.URI.from(f)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Pn=T,e.$Qn=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function O(h,E,f){if(!h||f>200)return null;if(typeof h=="object"){if(h instanceof C.URI)return E.transformOutgoing(h);for(const r in h)if(Object.hasOwnProperty.call(h,r)){const a=O(h[r],E,f+1);a!==null&&(h[r]=a)}}return null}function p(h,E){const f=O(h,E,0);return f===null?h:f}function s(h,E,f,r){if(!h||r>200)return null;if(typeof h=="object"){if(h.$mid===D.MarshalledId.Uri)return f?C.URI.revive(E.transformIncoming(h)):E.transformIncoming(h);if(h instanceof y.$Qe)return null;for(const a in h)if(Object.hasOwnProperty.call(h,a)){const c=s(h[a],E,f,r+1);c!==null&&(h[a]=c)}}return null}function I(h,E){const f=s(h,E,!1,0);return f===null?h:f}function v(h,E){const f=s(h,E,!0,0);return f===null?h:f}}),define(Oe[38],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=D;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(C){return y.test(C)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(O){for(let p=0;p<O.length;p++)O[p]=Math.floor(Math.random()*256);return O};const N=new Uint8Array(16),T=[];for(let O=0;O<256;O++)T.push(O.toString(16).padStart(2,"0"));return function(){C(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let p=0,s="";return s+=T[N[p++]],s+=T[N[p++]],s+=T[N[p++]],s+=T[N[p++]],s+="-",s+=T[N[p++]],s+=T[N[p++]],s+="-",s+=T[N[p++]],s+=T[N[p++]],s+="-",s+=T[N[p++]],s+=T[N[p++]],s+="-",s+=T[N[p++]],s+=T[N[p++]],s+=T[N[p++]],s+=T[N[p++]],s+=T[N[p++]],s+=T[N[p++]],s}}()}),define(Oe[152],Ae([1,0,17,40,38]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=e.$wu=void 0,e.$uu=N,e.$vu=T,e.$xu=s;function N(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function T(v,h,E){const f={id:(0,C.$5g)(),name:v,uri:h,data:E};return{asString:async()=>"",asFile:()=>f,value:void 0}}class O{constructor(){this.a=new Map}get size(){let h=0;for(const E of this.a)h++;return h}has(h){return this.a.has(this.b(h))}matches(h){const E=[...this.a.keys()];return D.Iterable.some(this,([f,r])=>r.asFile())&&E.push("files"),I(p(h),E)}get(h){return this.a.get(this.b(h))?.[0]}append(h,E){const f=this.a.get(h);f?f.push(E):this.a.set(this.b(h),[E])}replace(h,E){this.a.set(this.b(h),[E])}delete(h){this.a.delete(this.b(h))}*[Symbol.iterator](){for(const[h,E]of this.a)for(const f of E)yield[h,f]}b(h){return p(h)}}e.$wu=O;function p(v){return v.toLowerCase()}function s(v,h){return I(p(v),h.map(p))}function I(v,h){if(v==="*/*")return h.length>0;if(h.includes(v))return!0;const E=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[f,r,a]=E;return a==="*"?h.some(c=>c.startsWith(r+"/")):!1}e.$yu=Object.freeze({create:v=>(0,y.$Ob)(v.map(h=>h.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$yu.split(v).filter(h=>!h.startsWith("#"))})}),define(Oe[153],Ae([1,0,10,6,4,33,14]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=e.StorageState=e.StorageHint=void 0,e.$gq=p;var O;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function p(h){const E=h;return E?.changed instanceof Map||E?.deleted instanceof Set}var s;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(s||(e.StorageState=s={}));class I extends C.$Xc{static{this.a=100}constructor(E,f=Object.create(null)){super(),this.r=E,this.s=f,this.b=this.B(new D.$re),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new y.$Gh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((f,r)=>this.w(r,f)),E.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(E,f){if(this.c===s.Closed)return;let r=!1;(0,T.$qg)(f)?r=this.f.delete(E):this.f.get(E)!==f&&(this.f.set(E,f),r=!0),r&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,f){const r=this.f.get(E);return(0,T.$qg)(r)?f:r}getBoolean(E,f){const r=this.get(E);return(0,T.$qg)(r)?f:r==="true"}getNumber(E,f){const r=this.get(E);return(0,T.$qg)(r)?f:parseInt(r,10)}getObject(E,f){const r=this.get(E);return(0,T.$qg)(r)?f:(0,N.$ei)(r)}async set(E,f,r=!1){if(this.c===s.Closed)return;if((0,T.$qg)(f))return this.delete(E,r);const a=(0,T.$jg)(f)||Array.isArray(f)?(0,N.$di)(f):String(f);if(this.f.get(E)!==a)return this.f.set(E,a),this.j.set(E,a),this.h.delete(E),this.b.fire({key:E,external:r}),this.D()}async delete(E,f=!1){if(!(this.c===s.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:f}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===s.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$hq=I;class v{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((f,r)=>this.a.set(r,f)),E.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$iq=v}),define(Oe[154],Ae([1,0,27]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Eu=C;var D;(function(N){N[N.Unknown=0]="Unknown",N[N.Invalid=3]="Invalid",N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function C(N){let T=0,O=0,p=0,s=D.Unknown;for(let I=0,v=N.length;I<v;I++){const h=N.charCodeAt(I);h===y.CharCode.CarriageReturn?(T===0&&(O=I),T++,I+1<v&&N.charCodeAt(I+1)===y.CharCode.LineFeed?(s|=D.CRLF,I++):s|=D.Invalid,p=I+1):h===y.CharCode.LineFeed&&(s|=D.LF,T===0&&(O=I),T++,p=I+1)}return T===0&&(O=N.length),[T,O,N.length-p,s]}}),define(Oe[155],Ae([1,0,12,21,22]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=void 0,e.$hu=I,e.$iu=v,y=He(y),D=He(D),C=He(C);let N;function T(){return N||(N=new TextDecoder("UTF-16LE")),N}let O;function p(){return O||(O=new TextDecoder("UTF-16BE")),O}let s;function I(){return s||(s=D.$E()?T():p()),s}function v(f,r,a){const c=new Uint16Array(f.buffer,r,a);return a>0&&(c[0]===65279||c[0]===65534)?h(f,r,a):T().decode(c)}function h(f,r,a){const c=[];let u=0;for(let i=0;i<a;i++){const n=C.$Se(f,r);r+=2,c[u++]=String.fromCharCode(n)}return c.join("")}class E{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return I().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const a=this.a-this.d;a<=1&&(a===0||y.$Mf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const a=r.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=r;return}for(let c=0;c<a;c++)this.b[this.d++]=r.charCodeAt(c)}}e.$ju=E}),define(Oe[156],Ae([1,0,22,155]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=void 0,e.$lu=T,y=He(y);function C(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,I,v,h){this.oldPosition=s,this.oldText=I,this.newPosition=v,this.newText=h}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,I,v){const h=I.length;y.$Ve(s,h,v),v+=4;for(let E=0;E<h;E++)y.$Te(s,I.charCodeAt(E),v),v+=2;return v}static d(s,I){const v=y.$Ue(s,I);return I+=4,(0,D.$iu)(s,I,v)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(s,I){return y.$Ve(s,this.oldPosition,I),I+=4,y.$Ve(s,this.newPosition,I),I+=4,I=N.c(s,this.oldText,I),I=N.c(s,this.newText,I),I}static read(s,I,v){const h=y.$Ue(s,I);I+=4;const E=y.$Ue(s,I);I+=4;const f=N.d(s,I);I+=N.a(f);const r=N.d(s,I);return I+=N.a(r),v.push(new N(h,f,E,r)),I}}e.$ku=N;function T(p,s){return p===null||p.length===0?s:new O(p,s).compress()}class O{constructor(s,I){this.a=s,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,I=0,v=this.n(s),h=this.l(I);for(;s<this.f||I<this.h;){if(v===null){this.k(h),h=this.l(++I);continue}if(h===null){this.m(v),v=this.n(++s);continue}if(h.oldEnd<=v.newPosition){this.k(h),h=this.l(++I);continue}if(v.newEnd<=h.oldPosition){this.m(v),v=this.n(++s);continue}if(h.oldPosition<v.newPosition){const[c,u]=O.r(h,v.newPosition-h.oldPosition);this.k(c),h=u;continue}if(v.newPosition<h.oldPosition){const[c,u]=O.q(v,h.oldPosition-v.newPosition);this.m(c),v=u;continue}let r,a;if(h.oldEnd===v.newEnd)r=v,a=h,v=this.n(++s),h=this.l(++I);else if(h.oldEnd<v.newEnd){const[c,u]=O.q(v,h.oldLength);r=c,a=h,v=u,h=this.l(++I)}else{const[c,u]=O.r(h,v.newLength);r=v,a=c,v=this.n(++s),h=u}this.d[this.e++]=new N(r.oldPosition,r.oldText,a.newPosition,a.newText),this.g+=r.newLength-r.oldLength,this.j+=a.newLength-a.oldLength}const E=O.s(this.d);return O.t(E)}k(s){this.d[this.e++]=O.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=O.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,I){return new N(I.oldPosition-s,I.oldText,I.newPosition,I.newText)}static p(s,I){return new N(I.oldPosition,I.oldText,I.newPosition+s,I.newText)}static q(s,I){const v=s.newText.substr(0,I),h=s.newText.substr(I);return[new N(s.oldPosition,s.oldText,s.newPosition,v),new N(s.oldEnd,"",s.newPosition+I,h)]}static r(s,I){const v=s.oldText.substr(0,I),h=s.oldText.substr(I);return[new N(s.oldPosition,v,s.newPosition,s.newText),new N(s.oldPosition+I,h,s.newEnd,"")]}static s(s){if(s.length===0)return s;const I=[];let v=0,h=s[0];for(let E=1;E<s.length;E++){const f=s[E];h.oldEnd===f.oldPosition?h=new N(h.oldPosition,h.oldText+f.oldText,h.newPosition,h.newText+f.newText):(I[v++]=h,h=f)}return I[v++]=h,I}static t(s){if(s.length===0)return s;const I=[];let v=0;for(let h=0;h<s.length;h++){const E=s[h];E.oldText!==E.newText&&(I[v++]=E)}return I}}}),define(Oe[157],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=void 0,e.$qt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Oe[158],Ae([1,0,41,20]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=C,e.$Cu=N;function C(T,O,p,s,I,v){if(Array.isArray(T)){let h=0;for(const E of T){const f=C(E,O,p,s,I,v);if(f===10)return f;f>h&&(h=f)}return h}else{if(typeof T=="string")return s?T==="*"?5:T===p?10:0:0;if(T){const{language:h,pattern:E,scheme:f,hasAccessToAllModels:r,notebookType:a}=T;if(!s&&!r)return 0;a&&I&&(O=I);let c=0;if(f)if(f===O.scheme)c=10;else if(f==="*")c=5;else return 0;if(h)if(h===p)c=10;else if(h==="*")c=Math.max(c,5);else return 0;if(a)if(a===v)c=10;else if(a==="*"&&v!==void 0)c=Math.max(c,5);else return 0;if(E){let u;if(typeof E=="string"?u=E:u={...E,base:(0,D.$kc)(E.base)},u===O.fsPath||(0,y.$Ck)(u,O.fsPath))c=10;else return 0}return c}else return 0}}function N(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(N):!!T.notebookType}}),define(Oe[159],Ae([1,0,27,160]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.IndentAction=void 0;var C;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class N{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let I=0,v=s.notIn.length;I<v;I++)switch(s.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case D.StandardTokenType.Other:return!0;case D.StandardTokenType.Comment:return this.c;case D.StandardTokenType.String:return this.b;case D.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,I){if(s.getTokenCount()===0)return!0;const v=s.findTokenIndexAtOffset(I-2),h=s.getStandardTokenType(v);return this.isOK(h)}g(s,I){for(let v=s;v<=I;v++){const h=String.fromCharCode(v);if(!this.open.includes(h)&&!this.close.includes(h))return h}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(y.CharCode.Digit0,y.CharCode.Digit9)),this.e||(this.e=this.g(y.CharCode.a,y.CharCode.z)),this.e||(this.e=this.g(y.CharCode.A,y.CharCode.Z))),this.e}}e.$3u=N;class T{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of s)O(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),O(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),O(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),O(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&O(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$4u=T;function O(p,s,I){p.has(s)?p.get(s).push(I):p.set(s,[I])}}),define(Oe[161],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=e.NodeColor=e.$kD=void 0,e.$mD=C,e.$nD=N,e.$oD=s,e.$pD=I,e.$qD=v,e.$rD=h,e.$sD=E,e.$tD=f;class y{constructor(a,c){this.piece=a,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$lD)return C(this.right);let a=this;for(;a.parent!==e.$lD&&a.parent.left!==a;)a=a.parent;return a.parent===e.$lD?e.$lD:a.parent}prev(){if(this.left!==e.$lD)return N(this.left);let a=this;for(;a.parent!==e.$lD&&a.parent.right!==a;)a=a.parent;return a.parent===e.$lD?e.$lD:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$kD=y;var D;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(D||(e.NodeColor=D={})),e.$lD=new y(null,D.Black),e.$lD.parent=e.$lD,e.$lD.left=e.$lD,e.$lD.right=e.$lD,e.$lD.color=D.Black;function C(r){for(;r.left!==e.$lD;)r=r.left;return r}function N(r){for(;r.right!==e.$lD;)r=r.right;return r}function T(r){return r===e.$lD?0:r.size_left+r.piece.length+T(r.right)}function O(r){return r===e.$lD?0:r.lf_left+r.piece.lineFeedCnt+O(r.right)}function p(){e.$lD.parent=e.$lD}function s(r,a){const c=a.right;c.size_left+=a.size_left+(a.piece?a.piece.length:0),c.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=c.left,c.left!==e.$lD&&(c.left.parent=a),c.parent=a.parent,a.parent===e.$lD?r.root=c:a.parent.left===a?a.parent.left=c:a.parent.right=c,c.left=a,a.parent=c}function I(r,a){const c=a.left;a.left=c.right,c.right!==e.$lD&&(c.right.parent=a),c.parent=a.parent,a.size_left-=c.size_left+(c.piece?c.piece.length:0),a.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),a.parent===e.$lD?r.root=c:a===a.parent.right?a.parent.right=c:a.parent.left=c,c.right=a,a.parent=c}function v(r,a){let c,u;if(a.left===e.$lD?(u=a,c=u.right):a.right===e.$lD?(u=a,c=u.left):(u=C(a.right),c=u.right),u===r.root){r.root=c,c.color=D.Black,a.detach(),p(),r.root.parent=e.$lD;return}const i=u.color===D.Red;if(u===u.parent.left?u.parent.left=c:u.parent.right=c,u===a?(c.parent=u.parent,f(r,c)):(u.parent===a?c.parent=u:c.parent=u.parent,f(r,c),u.left=a.left,u.right=a.right,u.parent=a.parent,u.color=a.color,a===r.root?r.root=u:a===a.parent.left?a.parent.left=u:a.parent.right=u,u.left!==e.$lD&&(u.left.parent=u),u.right!==e.$lD&&(u.right.parent=u),u.size_left=a.size_left,u.lf_left=a.lf_left,f(r,u)),a.detach(),c.parent.left===c){const t=T(c),o=O(c);if(t!==c.parent.size_left||o!==c.parent.lf_left){const l=t-c.parent.size_left,m=o-c.parent.lf_left;c.parent.size_left=t,c.parent.lf_left=o,E(r,c.parent,l,m)}}if(f(r,c.parent),i){p();return}let n;for(;c!==r.root&&c.color===D.Black;)c===c.parent.left?(n=c.parent.right,n.color===D.Red&&(n.color=D.Black,c.parent.color=D.Red,s(r,c.parent),n=c.parent.right),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,c=c.parent):(n.right.color===D.Black&&(n.left.color=D.Black,n.color=D.Red,I(r,n),n=c.parent.right),n.color=c.parent.color,c.parent.color=D.Black,n.right.color=D.Black,s(r,c.parent),c=r.root)):(n=c.parent.left,n.color===D.Red&&(n.color=D.Black,c.parent.color=D.Red,I(r,c.parent),n=c.parent.left),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,c=c.parent):(n.left.color===D.Black&&(n.right.color=D.Black,n.color=D.Red,s(r,n),n=c.parent.left),n.color=c.parent.color,c.parent.color=D.Black,n.left.color=D.Black,I(r,c.parent),c=r.root));c.color=D.Black,p()}function h(r,a){for(f(r,a);a!==r.root&&a.parent.color===D.Red;)if(a.parent===a.parent.parent.left){const c=a.parent.parent.right;c.color===D.Red?(a.parent.color=D.Black,c.color=D.Black,a.parent.parent.color=D.Red,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,s(r,a)),a.parent.color=D.Black,a.parent.parent.color=D.Red,I(r,a.parent.parent))}else{const c=a.parent.parent.left;c.color===D.Red?(a.parent.color=D.Black,c.color=D.Black,a.parent.parent.color=D.Red,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,I(r,a)),a.parent.color=D.Black,a.parent.parent.color=D.Red,s(r,a.parent.parent))}r.root.color=D.Black}function E(r,a,c,u){for(;a!==r.root&&a!==e.$lD;)a.parent.left===a&&(a.parent.size_left+=c,a.parent.lf_left+=u),a=a.parent}function f(r,a){let c=0,u=0;if(a!==r.root){for(;a!==r.root&&a===a.parent.right;)a=a.parent;if(a!==r.root)for(a=a.parent,c=T(a.left)-a.size_left,u=O(a.left)-a.lf_left,a.size_left+=c,a.lf_left+=u;a!==r.root&&(c!==0||u!==0);)a.parent.left===a&&(a.parent.size_left+=c,a.parent.lf_left+=u),a=a.parent}}}),define(Oe[101],Ae([1,0,27,102,32,53,161,103]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ED=e.$DD=e.$CD=void 0,e.$AD=v,e.$BD=h;const p=65535;function s(u){let i;return u[u.length-1]<65536?i=new Uint16Array(u.length):i=new Uint32Array(u.length),i.set(u,0),i}class I{constructor(i,n,t,o,l){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=o,this.isBasicASCII=l}}function v(u,i=!0){const n=[0];let t=1;for(let o=0,l=u.length;o<l;o++){const m=u.charCodeAt(o);m===y.CharCode.CarriageReturn?o+1<l&&u.charCodeAt(o+1)===y.CharCode.LineFeed?(n[t++]=o+2,o++):n[t++]=o+1:m===y.CharCode.LineFeed&&(n[t++]=o+1)}return i?s(n):n}function h(u,i){u.length=0,u[0]=0;let n=1,t=0,o=0,l=0,m=!0;for(let d=0,S=i.length;d<S;d++){const k=i.charCodeAt(d);k===y.CharCode.CarriageReturn?d+1<S&&i.charCodeAt(d+1)===y.CharCode.LineFeed?(l++,u[n++]=d+2,d++):(t++,u[n++]=d+1):k===y.CharCode.LineFeed?(o++,u[n++]=d+1):m&&k!==y.CharCode.Tab&&(k<32||k>126)&&(m=!1)}const g=new I(s(u),t,o,l,m);return u.length=0,g}class E{constructor(i,n,t,o,l){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=o,this.length=l}}e.$CD=E;class f{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$DD=f;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==T.$lD&&i.iterate(i.root,t=>(t!==T.$lD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let o=0;o<t.length;o++){const l=t[o];if(l.node.parent===null||l.nodeStartOffset>=i){t[o]=null,n=!0;continue}}if(n){const o=[];for(const l of t)l!==null&&o.push(l);this.b=o}}}class c{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new f("",[0])],this.g={line:0,column:0},this.root=T.$lD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let o=null;for(let l=0,m=i.length;l<m;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=v(i[l].buffer));const g=new E(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),o=this.S(o,g)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,t=n-Math.floor(n/3),o=t*2;let l="",m=0;const g=[];if(this.iterate(this.root,d=>{const S=this.R(d),k=S.length;if(m<=t||m+k<o)return l+=S,m+=k,!0;const w=l.replace(/\r\n|\r|\n/g,i);return g.push(new f(w,v(w))),l=S,m=k,!0}),m>0){const d=l.replace(/\r\n|\r|\n/g,i);g.push(new f(d,v(d)))}this.create(g,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===T.$lD)return!0;const l=this.R(o),m=l.length,g=i.G(n),d=i.G(n+m),S=i.getValueInRange2(g,d);return n+=m,l===S})}getOffsetAt(i,n){let t=0,o=this.root;for(;o!==T.$lD;)if(o.left!==T.$lD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const l=this.B(o,i-o.lf_left-2);return t+=l+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const o=i;for(;n!==T.$lD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const l=this.A(n,i-n.size_left);if(t+=n.lf_left+l.index,l.index===0){const m=this.getOffsetAt(t+1,1),g=o-m;return new D.$St(t+1,g+1)}return new D.$St(t+1,l.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===T.$lD){const l=this.getOffsetAt(t+1,1),m=o-i-l;return new D.$St(t+1,m+1)}else n=n.right;return new D.$St(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,o);return n?n!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,n):l}getValueInRange2(i,n){if(i.node===n.node){const g=i.node,d=this.a[g.piece.bufferIndex].buffer,S=this.u(g.piece.bufferIndex,g.piece.start);return d.substring(S+i.remainder,S+n.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let m=o.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==T.$lD;){const g=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){m+=g.substring(d,d+n.remainder);break}else m+=g.substr(d,t.piece.length);t=t.next()}return m}getLinesContent(){const i=[];let n=0,t="",o=!1;return this.iterate(this.root,l=>{if(l===T.$lD)return!0;const m=l.piece;let g=m.length;if(g===0)return!0;const d=this.a[m.bufferIndex].buffer,S=this.a[m.bufferIndex].lineStarts,k=m.start.line,w=m.end.line;let P=S[k]+m.start.column;if(o&&(d.charCodeAt(P)===y.CharCode.LineFeed&&(P++,g--),i[n++]=t,t="",o=!1,g===0))return!0;if(k===w)return!this.f&&d.charCodeAt(P+g-1)===y.CharCode.CarriageReturn?(o=!0,t+=d.substr(P,g-1)):t+=d.substr(P,g),!0;t+=this.f?d.substring(P,Math.max(P,S[k+1]-this.e)):d.substring(P,S[k+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let R=k+1;R<w;R++)t=this.f?d.substring(S[R],S[R+1]-this.e):d.substring(S[R],S[R+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&d.charCodeAt(S[w]+m.end.column-1)===y.CharCode.CarriageReturn?(o=!0,m.end.column===0?n--:t=d.substr(S[w],m.end.column-1)):t=d.substr(S[w],m.end.column),!0}),o&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(o)}else{const n=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===T.$lD)return"";const o=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(l,l+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start),l=o+n.remainder,m=o+n.node.piece.length;return t.buffer.substring(l,m)}}findMatchesInNode(i,n,t,o,l,m,g,d,S,k,w){const P=this.a[i.piece.bufferIndex],R=this.u(i.piece.bufferIndex,i.piece.start),$=this.u(i.piece.bufferIndex,l),b=this.u(i.piece.bufferIndex,m);let L;const A={line:0,column:0};let M,Z;n._wordSeparators?(M=P.buffer.substring($,b),Z=G=>G+$,n.reset(0)):(M=P.buffer,Z=G=>G,n.reset($));do if(L=n.next(M),L){if(Z(L.index)>=b)return k;this.s(i,Z(L.index)-R,A);const G=this.t(i.piece.bufferIndex,l,A),U=A.line===l.line?A.column-l.column+o:A.column+1,V=U+L[0].length;if(w[k++]=(0,O.$wD)(new C.$Tt(t+G,U,t+G,V),L,d),Z(L.index)+L[0].length>=b||k>=S)return k}while(L);return k}findMatchesLineByLine(i,n,t,o){const l=[];let m=0;const g=new O.$zD(n.wordSeparators,n.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const S=this.H(i.endLineNumber,i.endColumn);if(S===null)return[];let k=this.s(d.node,d.remainder);const w=this.s(S.node,S.remainder);if(d.node===S.node)return this.findMatchesInNode(d.node,g,i.startLineNumber,i.startColumn,k,w,n,t,o,m,l),l;let P=i.startLineNumber,R=d.node;for(;R!==S.node;){const b=this.t(R.piece.bufferIndex,k,R.piece.end);if(b>=1){const A=this.a[R.piece.bufferIndex].lineStarts,M=this.u(R.piece.bufferIndex,R.piece.start),Z=A[k.line+b],G=P===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(R,g,P,G,k,this.s(R,Z-M),n,t,o,m,l),m>=o)return l;P+=b}const L=P===i.startLineNumber?i.startColumn-1:0;if(P===i.endLineNumber){const A=this.getLineContent(P).substring(L,i.endColumn-1);return m=this.n(n,g,A,i.endLineNumber,L,m,l,t,o),l}if(m=this.n(n,g,this.getLineContent(P).substr(L),P,L,m,l,t,o),m>=o)return l;P++,d=this.H(P,1),R=d.node,k=this.s(d.node,d.remainder)}if(P===i.endLineNumber){const b=P===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(P).substring(b,i.endColumn-1);return m=this.n(n,g,L,i.endLineNumber,b,m,l,t,o),l}const $=P===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(S.node,g,P,$,k,w,n,t,o,m,l),l}n(i,n,t,o,l,m,g,d,S){const k=i.wordSeparators;if(!d&&i.simpleSearch){const P=i.simpleSearch,R=P.length,$=t.length;let b=-R;for(;(b=t.indexOf(P,b+R))!==-1;)if((!k||(0,O.$yD)(k,t,$,b,R))&&(g[m++]=new N.$kw(new C.$Tt(o,b+1+l,o,b+1+R+l),null),m>=S))return m;return m}let w;n.reset(0);do if(w=n.next(t),w&&(g[m++]=(0,O.$wD)(new C.$Tt(o,w.index+1+l,o,w.index+1+w[0].length+l),w,d),m>=S))return m;while(w);return m}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==T.$lD){const{node:o,remainder:l,nodeStartOffset:m}=this.G(i),g=o.piece,d=g.bufferIndex,S=this.s(o,l);if(o.piece.bufferIndex===0&&g.end.line===this.g.line&&g.end.column===this.g.column&&m+g.length===i&&n.length<p){this.F(o,n),this.y();return}if(m===i)this.o(n,o),this.h.validate(i);else if(m+o.piece.length>i){const k=[];let w=new E(g.bufferIndex,S,g.end,this.t(g.bufferIndex,S,g.end),this.u(d,g.end)-this.u(d,S));if(this.K()&&this.M(n)&&this.I(o,l)===10){const b={line:w.start.line+1,column:0};w=new E(w.bufferIndex,b,w.end,this.t(w.bufferIndex,b,w.end),w.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(o,l-1)===13){const b=this.s(o,l-1);this.C(o,b),n="\r"+n,o.piece.length===0&&k.push(o)}else this.C(o,S);else this.C(o,S);const P=this.w(n);w.length>0&&this.S(o,w);let R=o;for(let $=0;$<P.length;$++)R=this.S(R,P[$]);this.v(k)}else this.q(n,o)}else{const o=this.w(n);let l=this.T(null,o[0]);for(let m=1;m<o.length;m++)l=this.S(l,o[m])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===T.$lD)return;const t=this.G(i),o=this.G(i+n),l=t.node,m=o.node;if(l===m){const P=this.s(l,t.remainder),R=this.s(l,o.remainder);if(t.nodeStartOffset===i){if(n===l.piece.length){const $=l.next();(0,T.$qD)(this,l),this.N($),this.y();return}this.D(l,R),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+n){this.C(l,P),this.O(l),this.y();return}this.E(l,P,R),this.y();return}const g=[],d=this.s(l,t.remainder);this.C(l,d),this.h.validate(i),l.piece.length===0&&g.push(l);const S=this.s(m,o.remainder);this.D(m,S),m.piece.length===0&&g.push(m);const k=l.next();for(let P=k;P!==T.$lD&&P!==m;P=P.next())g.push(P);const w=l.piece.length===0?l.prev():l;this.v(g),this.O(w),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const m=n.piece,g={line:m.start.line+1,column:0},d=new E(m.bufferIndex,g,m.end,this.t(m.bufferIndex,g,m.end),m.length-1);n.piece=d,i+=`
`,(0,T.$sD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const o=this.w(i);let l=this.T(n,o[o.length-1]);for(let m=o.length-2;m>=0;m--)l=this.T(l,o[m]);this.N(l),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),o=this.S(n,t[0]);let l=o;for(let m=1;m<t.length;m++)l=this.S(l,t[m]);this.N(o)}s(i,n,t){const o=i.piece,l=i.piece.bufferIndex,m=this.a[l].lineStarts,d=m[o.start.line]+o.start.column+n;let S=o.start.line,k=o.end.line,w=0,P=0,R=0;for(;S<=k&&(w=S+(k-S)/2|0,R=m[w],w!==k);)if(P=m[w+1],d<R)k=w-1;else if(d>=P)S=w+1;else break;return t?(t.line=w,t.column=d-R,null):{line:w,column:d-R}}t(i,n,t){if(t.column===0)return t.line-n.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-n.line;const l=o[t.line+1],m=o[t.line]+t.column;if(l>m+1)return t.line-n.line;const g=m-1;return this.a[i].buffer.charCodeAt(g)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,T.$qD)(this,i[n])}w(i){if(i.length>p){const k=[];for(;i.length>p;){const P=i.charCodeAt(p-1);let R;P===y.CharCode.CarriageReturn||P>=55296&&P<=56319?(R=i.substring(0,p-1),i=i.substring(p-1)):(R=i.substring(0,p),i=i.substring(p));const $=v(R);k.push(new E(this.a.length,{line:0,column:0},{line:$.length-1,column:R.length-$[$.length-1]},$.length-1,R.length)),this.a.push(new f(R,$))}const w=v(i);return k.push(new E(this.a.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this.a.push(new f(i,w)),k}let n=this.a[0].buffer.length;const t=v(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let k=0;k<t.length;k++)t[k]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let k=0;k<t.length;k++)t[k]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,g=l-this.a[0].lineStarts[m],d={line:m,column:g},S=new E(0,o,d,this.t(0,o,d),l-n);return this.g=d,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,o="";const l=this.h.get2(i);if(l){t=l.node;const m=this.B(t,i-l.nodeStartLineNumber-1),g=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=g.substring(d+m,d+t.piece.length);else{const S=this.B(t,i-l.nodeStartLineNumber);return g.substring(d+m,d+S-n)}}else{let m=0;const g=i;for(;t!==T.$lD;)if(t.left!==T.$lD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const d=this.B(t,i-t.lf_left-2),S=this.B(t,i-t.lf_left-1),k=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);return m+=t.size_left,this.h.set({node:t,nodeStartOffset:m,nodeStartLineNumber:g-(i-1-t.lf_left)}),k.substring(w+d,w+S-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const d=this.B(t,i-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,k=this.u(t.piece.bufferIndex,t.piece.start);o=S.substring(k+d,k+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,m+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==T.$lD;){const m=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const g=this.B(t,0),d=this.u(t.piece.bufferIndex,t.piece.start);return o+=m.substring(d,d+g-n),o}else{const g=this.u(t.piece.bufferIndex,t.piece.start);o+=m.substr(g,t.piece.length)}t=t.next()}return o}y(){let i=this.root,n=1,t=0;for(;i!==T.$lD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,o=this.s(i,n),l=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const m=this.t(i.piece.bufferIndex,t.start,o);if(m!==l)return{index:m,remainder:0}}return{index:l,remainder:o.column}}B(i,n){if(n<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,l=t.start.line+n+1;return l>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[l]-o[t.start.line]-t.start.column}C(i,n){const t=i.piece,o=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),m=n,g=this.u(t.bufferIndex,m),d=this.t(t.bufferIndex,t.start,m),S=d-o,k=g-l,w=t.length+k;i.piece=new E(t.bufferIndex,t.start,m,d,w),(0,T.$sD)(this,i,k,S)}D(i,n){const t=i.piece,o=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),m=n,g=this.t(t.bufferIndex,m,t.end),d=this.u(t.bufferIndex,m),S=g-o,k=l-d,w=t.length+k;i.piece=new E(t.bufferIndex,m,t.end,g,w),(0,T.$sD)(this,i,k,S)}E(i,n,t){const o=i.piece,l=o.start,m=o.end,g=o.length,d=o.lineFeedCnt,S=n,k=this.t(o.bufferIndex,o.start,S),w=this.u(o.bufferIndex,n)-this.u(o.bufferIndex,l);i.piece=new E(o.bufferIndex,o.start,S,k,w),(0,T.$sD)(this,i,w-g,k-d);const P=new E(o.bufferIndex,t,m,this.t(o.bufferIndex,t,m),this.u(o.bufferIndex,m)-this.u(o.bufferIndex,t)),R=this.S(i,P);this.N(R)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=n;const l=v(n,!1);for(let R=0;R<l.length;R++)l[R]+=o;if(t){const R=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-R}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const m=this.a[0].lineStarts.length-1,g=this.a[0].buffer.length-this.a[0].lineStarts[m],d={line:m,column:g},S=i.piece.length+n.length,k=i.piece.lineFeedCnt,w=this.t(0,i.piece.start,d),P=w-k;i.piece=new E(i.piece.bufferIndex,i.piece.start,d,w,S),this.g=d,(0,T.$sD)(this,i,n.length,P)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;n!==T.$lD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const l={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this.h.set(l),l}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,o=0;for(;t!==T.$lD;)if(t.left!==T.$lD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),m=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(l+n-1,m),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+n-1<=t.piece.length)return{node:t,remainder:l+n-1,nodeStartOffset:o};n-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==T.$lD;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),m=this.J(t);return{node:t,remainder:Math.min(n-1,l),nodeStartOffset:m}}else if(t.piece.length>=n-1){const l=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:l}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===T.$lD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,o=n.start.line,l=t[o]+n.start.column;return o===t.length-1||t[o+1]>l+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===T.$lD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,g=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,l,g,m),(0,T.$sD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const d={line:n.piece.start.line+1,column:0},S=n.piece.length-1,k=this.t(n.piece.bufferIndex,d,n.piece.end);n.piece=new E(n.piece.bufferIndex,d,n.piece.end,k,S),(0,T.$sD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const w=this.w(`\r
`);this.S(i,w[0]);for(let P=0;P<t.length;P++)(0,T.$qD)(this,t[P])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,T.$qD)(this,t);else{const o=t.piece,l={line:o.start.line+1,column:0},m=o.length-1,g=this.t(o.bufferIndex,l,o.end);t.piece=new E(o.bufferIndex,l,o.end,g,m),(0,T.$sD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===T.$lD)return n(T.$lD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===T.$lD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return n.buffer.substring(o,l)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,o)}S(i,n){const t=new T.$kD(n,T.NodeColor.Red);if(t.left=T.$lD,t.right=T.$lD,t.parent=T.$lD,t.size_left=0,t.lf_left=0,this.root===T.$lD)this.root=t,t.color=T.NodeColor.Black;else if(i.right===T.$lD)i.right=t,t.parent=i;else{const l=(0,T.$mD)(i.right);l.left=t,t.parent=l}return(0,T.$rD)(this,t),t}T(i,n){const t=new T.$kD(n,T.NodeColor.Red);if(t.left=T.$lD,t.right=T.$lD,t.parent=T.$lD,t.size_left=0,t.lf_left=0,this.root===T.$lD)this.root=t,t.color=T.NodeColor.Black;else if(i.left===T.$lD)i.left=t,t.parent=i;else{const o=(0,T.$nD)(i.left);o.right=t,t.parent=o}return(0,T.$rD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$ED=c}),define(Oe[162],Ae([1,0,6,12,32,53,101,154,156,4]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FD=void 0,D=He(D);class I extends s.$Xc{constructor(h,E,f,r,a,c,u){super(),this.m=this.B(new y.$oe),this.onDidChangeContent=this.m.event,this.f=E,this.j=!c,this.g=r,this.h=a,this.c=new T.$ED(h,f,u)}equals(h){return!(h instanceof I)||this.f!==h.f||this.getEOL()!==h.getEOL()?!1:this.c.equal(h.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(h){return this.c.createSnapshot(h?this.f:"")}getOffsetAt(h,E){return this.c.getOffsetAt(h,E)}getPositionAt(h){return this.c.getPositionAt(h)}getRangeAt(h,E){const f=h+E,r=this.getPositionAt(h),a=this.getPositionAt(f);return new C.$Tt(r.lineNumber,r.column,a.lineNumber,a.column)}getValueInRange(h,E=N.EndOfLinePreference.TextDefined){if(h.isEmpty())return"";const f=this.n(E);return this.c.getValueInRange(h,f)}getValueLengthInRange(h,E=N.EndOfLinePreference.TextDefined){if(h.isEmpty())return 0;if(h.startLineNumber===h.endLineNumber)return h.endColumn-h.startColumn;const f=this.getOffsetAt(h.startLineNumber,h.startColumn),r=this.getOffsetAt(h.endLineNumber,h.endColumn);let a=0;const c=this.n(E),u=this.getEOL();if(c.length!==u.length){const i=c.length-u.length,n=h.endLineNumber-h.startLineNumber;a=i*n}return r-f+a}getCharacterCountInRange(h,E=N.EndOfLinePreference.TextDefined){if(this.j){let f=0;const r=h.startLineNumber,a=h.endLineNumber;for(let c=r;c<=a;c++){const u=this.getLineContent(c),i=c===r?h.startColumn-1:0,n=c===a?h.endColumn-1:u.length;for(let t=i;t<n;t++)D.$Mf(u.charCodeAt(t))?(f=f+1,t=t+1):f=f+1}return f+=this.n(E).length*(a-r),f}return this.getValueLengthInRange(h,E)}getNearestChunk(h){return this.c.getNearestChunk(h)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(h){return this.c.getLineContent(h)}getLineCharCode(h,E){return this.c.getLineCharCode(h,E)}getCharCode(h){return this.c.getCharCode(h)}getLineLength(h){return this.c.getLineLength(h)}getLineMinColumn(h){return 1}getLineMaxColumn(h){return this.getLineLength(h)+1}getLineFirstNonWhitespaceColumn(h){const E=D.$xf(this.getLineContent(h));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(h){const E=D.$zf(this.getLineContent(h));return E===-1?0:E+2}n(h){switch(h){case N.EndOfLinePreference.LF:return`
`;case N.EndOfLinePreference.CRLF:return`\r
`;case N.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(h){this.c.setEOL(h)}applyEdits(h,E,f){let r=this.g,a=this.h,c=this.j,u=!0,i=[];for(let d=0;d<h.length;d++){const S=h[d];u&&S._isTracked&&(u=!1);const k=S.range;if(S.text){let b=!0;c||(b=!D.$Xf(S.text),c=b),!r&&b&&(r=D.$Wf(S.text)),!a&&b&&(a=D.$Zf(S.text))}let w="",P=0,R=0,$=0;if(S.text){let b;[P,R,$,b]=(0,O.$Eu)(S.text);const L=this.getEOL(),A=L===`\r
`?O.StringEOL.CRLF:O.StringEOL.LF;b===O.StringEOL.Unknown||b===A?w=S.text:w=S.text.replace(/\r\n|\r|\n/g,L)}i[d]={sortIndex:d,identifier:S.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:w,eolCount:P,firstLineLength:R,lastLineLength:$,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}i.sort(I.u);let n=!1;for(let d=0,S=i.length-1;d<S;d++){const k=i[d].range.getEndPosition(),w=i[d+1].range.getStartPosition();if(w.isBeforeOrEqual(k)){if(w.isBefore(k))throw new Error("Overlapping ranges are not allowed!");n=!0}}u&&(i=this.s(i));const t=f||E?I._getInverseEditRanges(i):[],o=[];if(E)for(let d=0;d<i.length;d++){const S=i[d],k=t[d];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let w=k.startLineNumber;w<=k.endLineNumber;w++){let P="";w===k.startLineNumber&&(P=this.getLineContent(S.range.startLineNumber),D.$xf(P)!==-1)||o.push({lineNumber:w,oldContent:P})}}let l=null;if(f){let d=0;l=[];for(let S=0;S<i.length;S++){const k=i[S],w=t[S],P=this.getValueInRange(k.range),R=k.rangeOffset+d;d+=k.text.length-P.length,l[S]={sortIndex:k.sortIndex,identifier:k.identifier,range:w,text:P,textChange:new p.$ku(k.rangeOffset,P,R,k.text)}}n||l.sort((S,k)=>S.sortIndex-k.sortIndex)}this.g=r,this.h=a,this.j=c;const m=this.t(i);let g=null;if(E&&o.length>0){o.sort((d,S)=>S.lineNumber-d.lineNumber),g=[];for(let d=0,S=o.length;d<S;d++){const k=o[d].lineNumber;if(d>0&&o[d-1].lineNumber===k)continue;const w=o[d].oldContent,P=this.getLineContent(k);P.length===0||P===w||D.$xf(P)!==-1||g.push(k)}}return this.m.fire(),new N.$ow(l,m,g)}s(h){return h.length<1e3?h:[this._toSingleEditOperation(h)]}_toSingleEditOperation(h){let E=!1;const f=h[0].range,r=h[h.length-1].range,a=new C.$Tt(f.startLineNumber,f.startColumn,r.endLineNumber,r.endColumn);let c=f.startLineNumber,u=f.startColumn;const i=[];for(let m=0,g=h.length;m<g;m++){const d=h[m],S=d.range;E=E||d.forceMoveMarkers,i.push(this.getValueInRange(new C.$Tt(c,u,S.startLineNumber,S.startColumn))),d.text.length>0&&i.push(d.text),c=S.endLineNumber,u=S.endColumn}const n=i.join(""),[t,o,l]=(0,O.$Eu)(n);return{sortIndex:0,identifier:h[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,N.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:o,lastLineLength:l,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(h){h.sort(I.w);const E=[];for(let f=0;f<h.length;f++){const r=h[f],a=r.range.startLineNumber,c=r.range.startColumn,u=r.range.endLineNumber,i=r.range.endColumn;if(a===u&&c===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new C.$Tt(a,c,u,i);E.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return E}findMatchesLineByLine(h,E,f,r){return this.c.findMatchesLineByLine(h,E,f,r)}getPieceTree(){return this.c}static _getInverseEditRange(h,E){const f=h.startLineNumber,r=h.startColumn,[a,c,u]=(0,O.$Eu)(E);let i;if(E.length>0){const n=a+1;n===1?i=new C.$Tt(f,r,f,r+c):i=new C.$Tt(f,r,f+n-1,u+1)}else i=new C.$Tt(f,r,f,r);return i}static _getInverseEditRanges(h){const E=[];let f=0,r=0,a=null;for(let c=0,u=h.length;c<u;c++){const i=h[c];let n,t;a?a.range.endLineNumber===i.range.startLineNumber?(n=f,t=r+(i.range.startColumn-a.range.endColumn)):(n=f+(i.range.startLineNumber-a.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const l=i.eolCount+1;l===1?o=new C.$Tt(n,t,n,t+i.firstLineLength):o=new C.$Tt(n,t,n+l-1,i.lastLineLength+1)}else o=new C.$Tt(n,t,n,t);f=o.endLineNumber,r=o.endColumn,E.push(o),a=i}return E}static u(h,E){const f=C.$Tt.compareRangesUsingEnds(h.range,E.range);return f===0?h.sortIndex-E.sortIndex:f}static w(h,E){const f=C.$Tt.compareRangesUsingEnds(h.range,E.range);return f===0?E.sortIndex-h.sortIndex:-f}}e.$FD=I}),define(Oe[163],Ae([1,0,27,12,53,101,162]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GD=void 0,D=He(D);class O{constructor(I,v,h,E,f,r,a,c,u){this.a=I,this.b=v,this.c=h,this.d=E,this.e=f,this.f=r,this.g=a,this.h=c,this.j=u}k(I){const v=this.c+this.d+this.e,h=this.c+this.e;return v===0?I===C.DefaultEndOfLine.LF?`
`:`\r
`:h>v/2?`\r
`:`
`}create(I){const v=this.k(I),h=this.a;if(this.j&&(v===`\r
`&&(this.c>0||this.d>0)||v===`
`&&(this.c>0||this.e>0)))for(let f=0,r=h.length;f<r;f++){const a=h[f].buffer.replace(/\r\n|\r|\n/g,v),c=(0,N.$AD)(a);h[f]=new N.$DD(a,c)}const E=new T.$FD(h,this.b,v,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&D.$8f(I)&&(this.b=D.$7f,I=I.substr(1));const v=I.charCodeAt(I.length-1);v===y.CharCode.CarriageReturn||v>=55296&&v<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=v):(this.m(I,!1),this.c=!1,this.d=v)}m(I,v){!v&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const v=(0,N.$BD)(this.e,I);this.a.push(new N.$DD(I,v.lineStarts)),this.f+=v.cr,this.g+=v.lf,this.h+=v.crlf,v.isBasicASCII||(this.l=!1,this.j||(this.j=D.$Wf(I)),this.k||(this.k=D.$Zf(I)))}finish(I=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const v=(0,N.$AD)(I.buffer);I.lineStarts=v,this.d===y.CharCode.CarriageReturn&&this.f++}}}e.$GD=p}),define(Oe[104],Ae([1,0,22,21]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jeb=p,e.$keb=I,D=He(D);var C;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(C||(C={}));function N(v){for(let h=0,E=v.length;h<E;h+=4){const f=v[h+0],r=v[h+1],a=v[h+2],c=v[h+3];v[h+0]=c,v[h+1]=a,v[h+2]=r,v[h+3]=f}}function T(v){const h=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return D.$E()||N(h),y.$Qe.wrap(h)}function O(v){const h=v.buffer;if(D.$E()||N(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const E=new Uint8Array(h.byteLength);return E.set(h),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(v){const h=new Uint32Array(s(v));let E=0;if(h[E++]=v.id,v.type==="full")h[E++]=C.Full,h[E++]=v.data.length,h.set(v.data,E),E+=v.data.length;else{h[E++]=C.Delta,h[E++]=v.deltas.length;for(const f of v.deltas)h[E++]=f.start,h[E++]=f.deleteCount,f.data?(h[E++]=f.data.length,h.set(f.data,E),E+=f.data.length):h[E++]=0}return T(h)}function s(v){let h=0;if(h+=2,v.type==="full")h+=1+v.data.length;else{h+=1,h+=3*v.deltas.length;for(const E of v.deltas)E.data&&(h+=E.data.length)}return h}function I(v){const h=O(v);let E=0;const f=h[E++];if(h[E++]===C.Full){const u=h[E++],i=h.subarray(E,E+u);return E+=u,{id:f,type:"full",data:i}}const a=h[E++],c=[];for(let u=0;u<a;u++){const i=h[E++],n=h[E++],t=h[E++];let o;t>0&&(o=h.subarray(E,E+t),E+=t),c[u]={start:i,deleteCount:n,data:o}}return{id:f,type:"delta",deltas:c}}}),define(Oe[164],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$_=e.$0_=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const T=this.a.get(N);return this.a.delete(N),T}}addDragOperationTransfer(N,T){this.a.set(N,T)}}e.$0_=y;class D{constructor(N){this.identifier=N}}e.$$_=D}),define(Oe[165],Ae([1,0,6,4,9]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0,e.$sj=I,C=He(C);class N extends D.$Xc{constructor(h,E="",f="",r=!0,a){super(),this.j=this.B(new y.$oe),this.onDidChange=this.j.event,this.z=!0,this.m=h,this.n=E,this.w=f,this.z=r,this.D=a}get id(){return this.m}get label(){return this.n}set label(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.j.fire({label:h}))}get tooltip(){return this.u||""}set tooltip(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.j.fire({tooltip:h}))}get class(){return this.w}set class(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.j.fire({class:h}))}get enabled(){return this.z}set enabled(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.j.fire({enabled:h}))}get checked(){return this.C}set checked(h){this.J(h)}J(h){this.C!==h&&(this.C=h,this.j.fire({checked:h}))}async run(h,E){this.D&&await this.D(h)}}e.$nj=N;class T extends D.$Xc{constructor(){super(...arguments),this.f=this.B(new y.$oe),this.onWillRun=this.f.event,this.m=this.B(new y.$oe),this.onDidRun=this.m.event}async run(h,E){if(!h.enabled)return;this.f.fire({action:h});let f;try{await this.u(h,E)}catch(r){f=r}this.m.fire({action:h,error:f})}async u(h,E){await h.run(E)}}e.$oj=T;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let E=[];for(const f of h)f.length&&(E.length?E=[...E,new O,...f]:E=f);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$pj=O;class p{get actions(){return this.a}constructor(h,E,f,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=E,this.class=r,this.a=f}async run(){}}e.$qj=p;class s extends N{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,C.localize(41,null),void 0,!1)}}e.$rj=s;function I(v){return{id:v.id,label:v.label,tooltip:v.tooltip??v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...h)=>v.run(...h)}}}),define(Oe[166],Ae([1,0,9]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=s,e.$6m=I,e.$7m=v;const D=60,C=D*60,N=C*24,T=N*7,O=N*30,p=N*365;function s(h,E,f,r){typeof h!="number"&&(h=h.getTime());const a=Math.round((new Date().getTime()-h)/1e3);if(a<-30)return(0,y.localize)(42,null,s(new Date().getTime()+a*1e3,!1));if(!r&&a<30)return(0,y.localize)(43,null);let c;return a<D?(c=a,E?c===1?f?(0,y.localize)(44,null,c):(0,y.localize)(45,null,c):f?(0,y.localize)(46,null,c):(0,y.localize)(47,null,c):c===1?f?(0,y.localize)(48,null,c):(0,y.localize)(49,null,c):f?(0,y.localize)(50,null,c):(0,y.localize)(51,null,c)):a<C?(c=Math.floor(a/D),E?c===1?f?(0,y.localize)(52,null,c):(0,y.localize)(53,null,c):f?(0,y.localize)(54,null,c):(0,y.localize)(55,null,c):c===1?f?(0,y.localize)(56,null,c):(0,y.localize)(57,null,c):f?(0,y.localize)(58,null,c):(0,y.localize)(59,null,c)):a<N?(c=Math.floor(a/C),E?c===1?f?(0,y.localize)(60,null,c):(0,y.localize)(61,null,c):f?(0,y.localize)(62,null,c):(0,y.localize)(63,null,c):c===1?f?(0,y.localize)(64,null,c):(0,y.localize)(65,null,c):f?(0,y.localize)(66,null,c):(0,y.localize)(67,null,c)):a<T?(c=Math.floor(a/N),E?c===1?(0,y.localize)(68,null,c):(0,y.localize)(69,null,c):c===1?(0,y.localize)(70,null,c):(0,y.localize)(71,null,c)):a<O?(c=Math.floor(a/T),E?c===1?f?(0,y.localize)(72,null,c):(0,y.localize)(73,null,c):f?(0,y.localize)(74,null,c):(0,y.localize)(75,null,c):c===1?f?(0,y.localize)(76,null,c):(0,y.localize)(77,null,c):f?(0,y.localize)(78,null,c):(0,y.localize)(79,null,c)):a<p?(c=Math.floor(a/O),E?c===1?f?(0,y.localize)(80,null,c):(0,y.localize)(81,null,c):f?(0,y.localize)(82,null,c):(0,y.localize)(83,null,c):c===1?f?(0,y.localize)(84,null,c):(0,y.localize)(85,null,c):f?(0,y.localize)(86,null,c):(0,y.localize)(87,null,c)):(c=Math.floor(a/p),E?c===1?f?(0,y.localize)(88,null,c):(0,y.localize)(89,null,c):f?(0,y.localize)(90,null,c):(0,y.localize)(91,null,c):c===1?f?(0,y.localize)(92,null,c):(0,y.localize)(93,null,c):f?(0,y.localize)(94,null,c):(0,y.localize)(95,null,c))}function I(h,E){const f=Math.abs(h/1e3);return f<1?E?(0,y.localize)(96,null,h):(0,y.localize)(97,null,h):f<D?E?(0,y.localize)(98,null,Math.round(h)/1e3):(0,y.localize)(99,null,Math.round(h)/1e3):f<C?E?(0,y.localize)(100,null,Math.round(h/(1e3*D))):(0,y.localize)(101,null,Math.round(h/(1e3*D))):f<N?E?(0,y.localize)(102,null,Math.round(h/(1e3*C))):(0,y.localize)(103,null,Math.round(h/(1e3*C))):(0,y.localize)(104,null,Math.round(h/(1e3*N)))}function v(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Oe[42],Ae([1,0,17,14,9]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=p,e.$uj=s,e.$vj=I,y=He(y),D=He(D),C=He(C);function N(v,h){return h&&(v.stack||v.stacktrace)?C.localize(105,null,O(v),T(v.stack)||T(v.stacktrace)):O(v)}function T(v){return Array.isArray(v)?v.join(`
`):v}function O(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?C.localize(106,null,v.message):v.message||C.localize(107,null)}function p(v=null,h=!1){if(!v)return C.localize(108,null);if(Array.isArray(v)){const E=y.$Jb(v),f=p(E[0],h);return E.length>1?C.localize(109,null,f,E.length):f}if(D.$hg(v))return v;if(v.detail){const E=v.detail;if(E.error)return N(E.error,h);if(E.exception)return N(E.exception,h)}return v.stack?N(v,h):v.message?v.message:C.localize(110,null)}function s(v){const h=v;return h instanceof Error&&Array.isArray(h.actions)}function I(v,h){let E;return typeof v=="string"?E=new Error(v):E=v,E.actions=h,E}}),define(Oe[167],Ae([1,0,27,13,9]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var N;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(N||(e.TokenType=N={}));function T(...I){switch(I.length){case 1:return(0,C.localize)(1691,null,I[0]);case 2:return(0,C.localize)(1692,null,I[0],I[1]);case 3:return(0,C.localize)(1693,null,I[0],I[1],I[2]);default:return}}const O=(0,C.localize)(1694,null),p=(0,C.localize)(1695,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case N.LParen:return"(";case N.RParen:return")";case N.Neg:return"!";case N.Eq:return v.isTripleEq?"===":"==";case N.NotEq:return v.isTripleEq?"!==":"!=";case N.Lt:return"<";case N.LtEq:return"<=";case N.Gt:return">=";case N.GtEq:return">=";case N.RegexOp:return"=~";case N.RegexStr:return v.lexeme;case N.True:return"true";case N.False:return"false";case N.In:return"in";case N.Not:return"not";case N.And:return"&&";case N.Or:return"||";case N.Str:return v.lexeme;case N.QuotedStr:return v.lexeme;case N.Error:return v.lexeme;case N.EOF:return"EOF";default:throw(0,D.$0)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",N.Not],["in",N.In],["false",N.False],["true",N.True]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case y.CharCode.OpenParen:this.k(N.LParen);break;case y.CharCode.CloseParen:this.k(N.RParen);break;case y.CharCode.ExclamationMark:if(this.h(y.CharCode.Equals)){const h=this.h(y.CharCode.Equals);this.f.push({type:N.NotEq,offset:this.d,isTripleEq:h})}else this.k(N.Neg);break;case y.CharCode.SingleQuote:this.o();break;case y.CharCode.Slash:this.q();break;case y.CharCode.Equals:if(this.h(y.CharCode.Equals)){const h=this.h(y.CharCode.Equals);this.f.push({type:N.Eq,offset:this.d,isTripleEq:h})}else this.h(y.CharCode.Tilde)?this.k(N.RegexOp):this.l(T("==","=~"));break;case y.CharCode.LessThan:this.k(this.h(y.CharCode.Equals)?N.LtEq:N.Lt);break;case y.CharCode.GreaterThan:this.k(this.h(y.CharCode.Equals)?N.GtEq:N.Gt);break;case y.CharCode.Ampersand:this.h(y.CharCode.Ampersand)?this.k(N.And):this.l(T("&&"));break;case y.CharCode.Pipe:this.h(y.CharCode.Pipe)?this.k(N.Or):this.l(T("||"));break;case y.CharCode.Space:case y.CharCode.CarriageReturn:case y.CharCode.Tab:case y.CharCode.LineFeed:case y.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(N.EOF),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?y.CharCode.Null:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const h=this.d,E=this.c.substring(this.d,this.e),f={type:N.Error,offset:this.d,lexeme:E};this.g.push({offset:h,lexeme:E,additionalInfo:v}),this.f.push(f)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const h=this.c.substring(this.d,this.e),E=s.b.get(h);E?this.k(E):this.f.push({type:N.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==y.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:N.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,h=!1,E=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(p);return}const r=this.c.charCodeAt(v);if(h)h=!1;else if(r===y.CharCode.Slash&&!E){v++;break}else r===y.CharCode.OpenSquareBracket?E=!0:r===y.CharCode.Backslash?h=!0:r===y.CharCode.CloseSquareBracket&&(E=!1);v++}for(;v<this.c.length&&s.a.has(this.c.charCodeAt(v));)v++;this.e=v;const f=this.c.substring(this.d,this.e);this.f.push({type:N.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=s}),define(Oe[105],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const y={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(y)}),define(Oe[74],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class y{constructor(C,N=[],T=!1){this.ctor=C,this.staticArguments=N,this.supportsDelayedInstantiation=T}}e.$Fi=y}),define(Oe[61],Ae([1,0,74]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ws=N,e.$Xs=T;const D=[];var C;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function N(O,p,s){p instanceof y.$Fi||(p=new y.$Fi(p,[],!!s)),D.push([O,p])}function T(){return D}}),define(Oe[168],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;class y{constructor(N,T){this.key=N,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$zr=y;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const T of this.a.values())T.outgoing.size===0&&N.push(T);return N}insertEdge(N,T){const O=this.lookupOrInsertNode(N),p=this.lookupOrInsertNode(T);O.outgoing.set(p.key,p),p.incoming.set(O.key,O)}removeNode(N){const T=this.b(N);this.a.delete(T);for(const O of this.a.values())O.outgoing.delete(T),O.incoming.delete(T)}lookupOrInsertNode(N){const T=this.b(N);let O=this.a.get(T);return O||(O=new y(T,N),this.a.set(T,O)),O}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[T,O]of this.a)N.push(`${T}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,T]of this.a){const O=new Set([N]),p=this.c(T,O);if(p)return p}}c(N,T){for(const[O,p]of N.outgoing){if(T.has(O))return[...T,O].join(" -> ");T.add(O);const s=this.c(p,T);if(s)return s;T.delete(O)}}}e.$Ar=D}),define(Oe[3],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=C,e.$Ji=N;var y;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function O(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=O})(y||(e._util=y={})),e.$Hi=C("instantiationService");function D(T,O,p){O[y.DI_TARGET]===O?O[y.DI_DEPENDENCIES].push({id:T,index:p}):(O[y.DI_DEPENDENCIES]=[{id:T,index:p}],O[y.DI_TARGET]=O)}function C(T){if(y.serviceIds.has(T))return y.serviceIds.get(T);const O=function(p,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(O,p,I)};return O.toString=()=>T,y.serviceIds.set(T,O),O}function N(T){return T}}),define(Oe[43],Ae([1,0,14,2,3]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=N,e.$ej=T,e.$fj=p,e.$gj=s,e.$hj=I,e.$ij=v,e.$jj=h,e.$kj=f,e.$lj=r,e.$mj=a,y=He(y),e.$cj=(0,C.$Ii)("configurationService");function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}var O;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function p(c){switch(c){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function s(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function I(c,u){const i=Object.create(null);for(const n in c)v(i,n,c[n],u);return i}function v(c,u,i,n){const t=u.split("."),o=t.pop();let l=c;for(let m=0;m<t.length;m++){const g=t[m];let d=l[g];switch(typeof d){case"undefined":d=l[g]=Object.create(null);break;case"object":if(d===null){n(`Ignoring ${u} as ${t.slice(0,m+1).join(".")} is null`);return}break;default:n(`Ignoring ${u} as ${t.slice(0,m+1).join(".")} is ${JSON.stringify(d)}`);return}l=d}if(typeof l=="object"&&l!==null)try{l[o]=i}catch{n(`Ignoring ${u} as ${t.join(".")} is ${JSON.stringify(l)}`)}else n(`Ignoring ${u} as ${t.join(".")} is ${JSON.stringify(l)}`)}function h(c,u){const i=u.split(".");E(c,i)}function E(c,u){const i=u.shift();if(u.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const n=c[i];typeof n=="object"&&!Array.isArray(n)&&(E(n,u),Object.keys(n).length===0&&delete c[i])}}function f(c,u,i){function n(l,m){let g=l;for(const d of m){if(typeof g!="object"||g===null)return;g=g[d]}return g}const t=u.split("."),o=n(c,t);return typeof o>"u"?i:o}function r(c,u,i){Object.keys(u).forEach(n=>{n!=="__proto__"&&(n in c?y.$jg(c[n])&&y.$jg(u[n])?r(c[n],u[n],i):i&&(c[n]=u[n]):c[n]=u[n])})}function a(c){return c.replace(/[\[\]]/g,"")}}),define(Oe[31],Ae([1,0,27,21,12,167,3,9,13]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=I,e.$Hj=m,e.$Ij=g,e.$2j=te;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",D.$k),s.set("isLinux",D.$l),s.set("isWindows",D.$j),s.set("isWeb",D.$p),s.set("isMacNative",D.$k&&!D.$p),s.set("isEdge",D.$I),s.set("isFirefox",D.$G),s.set("isChrome",D.$F),s.set("isSafari",D.$H);function I(Y,W){if(s.get(Y)!==void 0)throw(0,p.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(Y,W)}const v=Object.prototype.hasOwnProperty;var h;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const E={regexParsingWithErrorRecovery:!0},f=(0,O.localize)(1671,null),r=(0,O.localize)(1672,null),a=(0,O.localize)(1673,null),c=(0,O.localize)(1674,null),u=(0,O.localize)(1675,null),i=(0,O.localize)(1676,null),n=(0,O.localize)(1677,null),t=(0,O.localize)(1678,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=E){this.k=W,this.d=new N.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ee=this.l();if(!this.E()){const be=this.D(),Pe=be.type===N.TokenType.Str?i:void 0;throw this.h.push({message:u,offset:be.offset,lexeme:N.$Dj.getLexeme(be),additionalInfo:Pe}),o.c}return ee}catch(ee){if(ee!==o.c)throw ee;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(N.TokenType.Or);){const ee=this.o();W.push(ee)}return W.length===1?W[0]:l.or(...W)}o(){const W=[this.s()];for(;this.y(N.TokenType.And);){const ee=this.s();W.push(ee)}return W.length===1?W[0]:l.and(...W)}s(){if(this.y(N.TokenType.Neg)){const W=this.D();switch(W.type){case N.TokenType.True:return this.z(),S.INSTANCE;case N.TokenType.False:return this.z(),k.INSTANCE;case N.TokenType.LParen:{this.z();const ee=this.l();return this.A(N.TokenType.RParen,c),ee?.negate()}case N.TokenType.Str:return this.z(),L.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case N.TokenType.True:return this.z(),l.true();case N.TokenType.False:return this.z(),l.false();case N.TokenType.LParen:{this.z();const ee=this.l();return this.A(N.TokenType.RParen,c),ee}case N.TokenType.Str:{const ee=W.lexeme;if(this.z(),this.y(N.TokenType.RegexOp)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==N.TokenType.RegexStr)throw this.B("REGEX",Pe);const je=Pe.lexeme,Te=je.lastIndexOf("/"),Ee=Te===je.length-1?void 0:this.w(je.substring(Te+1));let Fe;try{Fe=new RegExp(je.substring(1,Te),Ee)}catch{throw this.B("REGEX",Pe)}return V.create(ee,Fe)}switch(Pe.type){case N.TokenType.RegexStr:case N.TokenType.Error:{const je=[Pe.lexeme];this.z();let Te=this.D(),Ee=0;for(let it=0;it<Pe.lexeme.length;it++)Pe.lexeme.charCodeAt(it)===y.CharCode.OpenParen?Ee++:Pe.lexeme.charCodeAt(it)===y.CharCode.CloseParen&&Ee--;for(;!this.E()&&Te.type!==N.TokenType.And&&Te.type!==N.TokenType.Or;){switch(Te.type){case N.TokenType.LParen:Ee++;break;case N.TokenType.RParen:Ee--;break;case N.TokenType.RegexStr:case N.TokenType.QuotedStr:for(let it=0;it<Te.lexeme.length;it++)Te.lexeme.charCodeAt(it)===y.CharCode.OpenParen?Ee++:Pe.lexeme.charCodeAt(it)===y.CharCode.CloseParen&&Ee--}if(Ee<0)break;je.push(N.$Dj.getLexeme(Te)),this.z(),Te=this.D()}const Fe=je.join(""),Ve=Fe.lastIndexOf("/"),Ge=Ve===Fe.length-1?void 0:this.w(Fe.substring(Ve+1));let et;try{et=new RegExp(Fe.substring(1,Ve),Ge)}catch{throw this.B("REGEX",Pe)}return l.regex(ee,et)}case N.TokenType.QuotedStr:{const je=Pe.lexeme;this.z();let Te=null;if(!(0,C.$ff)(je)){const Ee=je.indexOf("/"),Fe=je.lastIndexOf("/");if(Ee!==Fe&&Ee>=0){const Ve=je.slice(Ee+1,Fe),Ge=je[Fe+1]==="i"?"i":"";try{Te=new RegExp(Ve,Ge)}catch{throw this.B("REGEX",Pe)}}}if(Te===null)throw this.B("REGEX",Pe);return V.create(ee,Te)}default:throw this.B("REGEX",this.D())}}if(this.y(N.TokenType.Not)){this.A(N.TokenType.In,a);const Pe=this.u();return l.notIn(ee,Pe)}switch(this.D().type){case N.TokenType.Eq:{this.z();const Pe=this.u();if(this.x().type===N.TokenType.QuotedStr)return l.equals(ee,Pe);switch(Pe){case"true":return l.has(ee);case"false":return l.not(ee);default:return l.equals(ee,Pe)}}case N.TokenType.NotEq:{this.z();const Pe=this.u();if(this.x().type===N.TokenType.QuotedStr)return l.notEquals(ee,Pe);switch(Pe){case"true":return l.not(ee);case"false":return l.has(ee);default:return l.notEquals(ee,Pe)}}case N.TokenType.Lt:return this.z(),G.create(ee,this.u());case N.TokenType.LtEq:return this.z(),U.create(ee,this.u());case N.TokenType.Gt:return this.z(),M.create(ee,this.u());case N.TokenType.GtEq:return this.z(),Z.create(ee,this.u());case N.TokenType.In:return this.z(),l.in(ee,this.u());default:return l.has(ee)}}case N.TokenType.EOF:throw this.h.push({message:n,offset:W.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case N.TokenType.Str:case N.TokenType.QuotedStr:return this.z(),W.lexeme;case N.TokenType.True:return this.z(),"true";case N.TokenType.False:return this.z(),"false";case N.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ee){if(this.C(W))return this.z();throw this.B(ee,this.D())}B(W,ee,be){const Pe=(0,O.localize)(1679,null,W,N.$Dj.getLexeme(ee)),je=ee.offset,Te=N.$Dj.getLexeme(ee);return this.h.push({message:Pe,offset:je,lexeme:Te,additionalInfo:be}),o.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===N.TokenType.EOF}}e.$Fj=o;class l{static false(){return S.INSTANCE}static true(){return k.INSTANCE}static has(W){return w.create(W)}static equals(W,ee){return P.create(W,ee)}static notEquals(W,ee){return b.create(W,ee)}static regex(W,ee){return V.create(W,ee)}static in(W,ee){return R.create(W,ee)}static notIn(W,ee){return $.create(W,ee)}static not(W){return L.create(W)}static and(...W){return ue.create(W,null,!0)}static or(...W){return x.create(W,null,!0)}static greater(W,ee){return M.create(W,ee)}static greaterEquals(W,ee){return Z.create(W,ee)}static smaller(W,ee){return G.create(W,ee)}static smallerEquals(W,ee){return U.create(W,ee)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Gj=l;function m(Y){const W=new o({regexParsingWithErrorRecovery:!1});return Y.map(ee=>(W.parse(ee),W.lexingErrors.length>0?W.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,O.localize)(1680,null,be.additionalInfo):(0,O.localize)(1681,null),offset:be.offset,length:be.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function g(Y,W){const ee=Y?Y.substituteConstants():void 0,be=W?W.substituteConstants():void 0;return!ee&&!be?!0:!ee||!be?!1:ee.equals(be)}function d(Y,W){return Y.cmp(W)}class S{static{this.INSTANCE=new S}constructor(){this.type=h.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return k.INSTANCE}}e.$Jj=S;class k{static{this.INSTANCE=new k}constructor(){this.type=h.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return S.INSTANCE}}e.$Kj=k;class w{static create(W,ee=null){const be=s.get(W);return typeof be=="boolean"?be?k.INSTANCE:S.INSTANCE:new w(W,ee)}constructor(W,ee){this.key=W,this.c=ee,this.type=h.Defined}cmp(W){return W.type!==this.type?this.type-W.type:se(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=s.get(this.key);return typeof W=="boolean"?W?k.INSTANCE:S.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Lj=w;class P{static create(W,ee,be=null){if(typeof ee=="boolean")return ee?w.create(W,be):L.create(W,be);const Pe=s.get(W);return typeof Pe=="boolean"?ee===(Pe?"true":"false")?k.INSTANCE:S.INSTANCE:new P(W,ee,be)}constructor(W,ee,be){this.c=W,this.d=ee,this.f=be,this.type=h.Equals}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=s.get(this.c);if(typeof W=="boolean"){const ee=W?"true":"false";return this.d===ee?k.INSTANCE:S.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Mj=P;class R{static create(W,ee){return new R(W,ee)}constructor(W,ee){this.d=W,this.f=ee,this.type=h.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ee=W.getValue(this.f),be=W.getValue(this.d);return Array.isArray(ee)?ee.includes(be):typeof be=="string"&&typeof ee=="object"&&ee!==null?v.call(ee,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=$.create(this.d,this.f)),this.c}}e.$Nj=R;class ${static create(W,ee){return new $(W,ee)}constructor(W,ee){this.d=W,this.f=ee,this.type=h.NotIn,this.c=R.create(W,ee)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=$;class b{static create(W,ee,be=null){if(typeof ee=="boolean")return ee?L.create(W,be):w.create(W,be);const Pe=s.get(W);return typeof Pe=="boolean"?ee===(Pe?"true":"false")?S.INSTANCE:k.INSTANCE:new b(W,ee,be)}constructor(W,ee,be){this.c=W,this.d=ee,this.f=be,this.type=h.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=s.get(this.c);if(typeof W=="boolean"){const ee=W?"true":"false";return this.d===ee?S.INSTANCE:k.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Pj=b;class L{static create(W,ee=null){const be=s.get(W);return typeof be=="boolean"?be?S.INSTANCE:k.INSTANCE:new L(W,ee)}constructor(W,ee){this.c=W,this.d=ee,this.type=h.Not}cmp(W){return W.type!==this.type?this.type-W.type:se(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=s.get(this.c);return typeof W=="boolean"?W?S.INSTANCE:k.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Qj=L;function A(Y,W){if(typeof Y=="string"){const ee=parseFloat(Y);isNaN(ee)||(Y=ee)}return typeof Y=="string"||typeof Y=="number"?W(Y):S.INSTANCE}class M{static create(W,ee,be=null){return A(ee,Pe=>new M(W,Pe,be))}constructor(W,ee,be){this.c=W,this.d=ee,this.f=be,this.type=h.Greater}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Rj=M;class Z{static create(W,ee,be=null){return A(ee,Pe=>new Z(W,Pe,be))}constructor(W,ee,be){this.c=W,this.d=ee,this.f=be,this.type=h.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Sj=Z;class G{static create(W,ee,be=null){return A(ee,Pe=>new G(W,Pe,be))}constructor(W,ee,be){this.c=W,this.d=ee,this.f=be,this.type=h.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Tj=G;class U{static create(W,ee,be=null){return A(ee,Pe=>new U(W,Pe,be))}constructor(W,ee,be){this.c=W,this.d=ee,this.f=be,this.type=h.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Uj=U;class V{static create(W,ee){return new V(W,ee)}constructor(W,ee){this.d=W,this.f=ee,this.type=h.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ee=this.f?this.f.source:"",be=W.f?W.f.source:"";return ee<be?-1:ee>be?1:0}equals(W){if(W.type===this.type){const ee=this.f?this.f.source:"",be=W.f?W.f.source:"";return this.d===W.d&&ee===be}return!1}substituteConstants(){return this}evaluate(W){const ee=W.getValue(this.d);return this.f?this.f.test(ee):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Vj=V;class Q{static create(W){return new Q(W)}constructor(W){this.c=W,this.type=h.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new Q(this.c.map(W))}negate(){return this.c}}e.$Wj=Q;function ne(Y){let W=null;for(let ee=0,be=Y.length;ee<be;ee++){const Pe=Y[ee].substituteConstants();if(Y[ee]!==Pe&&W===null){W=[];for(let je=0;je<ee;je++)W[je]=Y[je]}W!==null&&(W[ee]=Pe)}return W===null?Y:W}class ue{static create(W,ee,be){return ue.d(W,ee,be)}constructor(W,ee){this.expr=W,this.c=ee,this.type=h.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ee=0,be=this.expr.length;ee<be;ee++){const Pe=d(this.expr[ee],W.expr[ee]);if(Pe!==0)return Pe}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ee=0,be=this.expr.length;ee<be;ee++)if(!this.expr[ee].equals(W.expr[ee]))return!1;return!0}return!1}substituteConstants(){const W=ne(this.expr);return W===this.expr?this:ue.create(W,this.c,!1)}evaluate(W){for(let ee=0,be=this.expr.length;ee<be;ee++)if(!this.expr[ee].evaluate(W))return!1;return!0}static d(W,ee,be){const Pe=[];let je=!1;for(const Te of W)if(Te){if(Te.type===h.True){je=!0;continue}if(Te.type===h.False)return S.INSTANCE;if(Te.type===h.And){Pe.push(...Te.expr);continue}Pe.push(Te)}if(Pe.length===0&&je)return k.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(d);for(let Te=1;Te<Pe.length;Te++)Pe[Te-1].equals(Pe[Te])&&(Pe.splice(Te,1),Te--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const Te=Pe[Pe.length-1];if(Te.type!==h.Or)break;Pe.pop();const Ee=Pe.pop(),Fe=Pe.length===0,Ve=x.create(Te.expr.map(Ge=>ue.create([Ge,Ee],null,be)),null,Fe);Ve&&(Pe.push(Ve),Pe.sort(d))}if(Pe.length===1)return Pe[0];if(be){for(let Te=0;Te<Pe.length;Te++)for(let Ee=Te+1;Ee<Pe.length;Ee++)if(Pe[Te].negate().equals(Pe[Ee]))return S.INSTANCE;if(Pe.length===1)return Pe[0]}return new ue(Pe,ee)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ee of this.expr)W.push(...ee.keys());return W}map(W){return new ue(this.expr.map(ee=>ee.map(W)),null)}negate(){if(!this.c){const W=[];for(const ee of this.expr)W.push(ee.negate());this.c=x.create(W,this,!0)}return this.c}}e.$Xj=ue;class x{static create(W,ee,be){return x.d(W,ee,be)}constructor(W,ee){this.expr=W,this.c=ee,this.type=h.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ee=0,be=this.expr.length;ee<be;ee++){const Pe=d(this.expr[ee],W.expr[ee]);if(Pe!==0)return Pe}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ee=0,be=this.expr.length;ee<be;ee++)if(!this.expr[ee].equals(W.expr[ee]))return!1;return!0}return!1}substituteConstants(){const W=ne(this.expr);return W===this.expr?this:x.create(W,this.c,!1)}evaluate(W){for(let ee=0,be=this.expr.length;ee<be;ee++)if(this.expr[ee].evaluate(W))return!0;return!1}static d(W,ee,be){let Pe=[],je=!1;if(W){for(let Te=0,Ee=W.length;Te<Ee;Te++){const Fe=W[Te];if(Fe){if(Fe.type===h.False){je=!0;continue}if(Fe.type===h.True)return k.INSTANCE;if(Fe.type===h.Or){Pe=Pe.concat(Fe.expr);continue}Pe.push(Fe)}}if(Pe.length===0&&je)return S.INSTANCE;Pe.sort(d)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let Te=1;Te<Pe.length;Te++)Pe[Te-1].equals(Pe[Te])&&(Pe.splice(Te,1),Te--);if(Pe.length===1)return Pe[0];if(be){for(let Te=0;Te<Pe.length;Te++)for(let Ee=Te+1;Ee<Pe.length;Ee++)if(Pe[Te].negate().equals(Pe[Ee]))return k.INSTANCE;if(Pe.length===1)return Pe[0]}return new x(Pe,ee)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ee of this.expr)W.push(...ee.keys());return W}map(W){return new x(this.expr.map(ee=>ee.map(W)),null)}negate(){if(!this.c){const W=[];for(const ee of this.expr)W.push(ee.negate());for(;W.length>1;){const ee=W.shift(),be=W.shift(),Pe=[];for(const je of Ce(ee))for(const Te of Ce(be))Pe.push(ue.create([je,Te],null,!1));W.unshift(x.create(Pe,null,!1))}this.c=x.create(W,this,!0)}return this.c}}e.$Yj=x;class oe extends w{static{this.d=[]}static all(){return oe.d.values()}constructor(W,ee,be){super(W,null),this.f=ee,typeof be=="object"?oe.d.push({...be,key:W}):be!==!0&&oe.d.push({key:W,description:be,type:ee!=null?typeof ee:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return P.create(this.key,W)}notEqualsTo(W){return b.create(this.key,W)}}e.$Zj=oe,e.$1j=(0,T.$Ii)("contextKeyService");function se(Y,W){return Y<W?-1:Y>W?1:0}function ce(Y,W,ee,be){return Y<ee?-1:Y>ee?1:W<be?-1:W>be?1:0}function te(Y,W){if(Y.type===h.False||W.type===h.True)return!0;if(Y.type===h.Or)return W.type===h.Or?we(Y.expr,W.expr):!1;if(W.type===h.Or){for(const ee of W.expr)if(te(Y,ee))return!0;return!1}if(Y.type===h.And){if(W.type===h.And)return we(W.expr,Y.expr);for(const ee of Y.expr)if(te(ee,W))return!0;return!1}return Y.equals(W)}function we(Y,W){let ee=0,be=0;for(;ee<Y.length&&be<W.length;){const Pe=Y[ee].cmp(W[be]);if(Pe<0)return!1;Pe===0&&ee++,be++}return ee===Y.length}function Ce(Y){return Y.type===h.Or?Y.expr:[Y]}}),define(Oe[169],Ae([1,0,31,3]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.$xt=e.AccessibilitySupport=e.$wt=void 0,e.$yt=N,e.$wt=(0,D.$Ii)("accessibilityService");var C;(function(T){T[T.Unknown=0]="Unknown",T[T.Disabled=1]="Disabled",T[T.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$xt=new y.$Zj("accessibilityModeEnabled",!1);function N(T){return T&&typeof T=="object"&&typeof T.label=="string"&&(typeof T.role>"u"||typeof T.role=="string")}e.$zt="ACCESSIBLE_VIEW_SHOWN_"}),define(Oe[106],Ae([1,0,17,25,21,147,281,157,170,9,169]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=d,e.cursorStyleToString=A,e.filterValidationDecorations=Ue,y=He(y),D=He(D),C=He(C),s=He(s);var v;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(q){this.c=q}hasChanged(q){return this.c[q]}}e.ConfigurationChangedEvent=h;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class f{constructor(q,de,We,Je){this.id=q,this.name=de,this.defaultValue=We,this.schema=Je}applyUpdate(q,de){return a(q,de)}compute(q,de,We){return We}}class r{constructor(q,de){this.newValue=q,this.didChange=de}}e.ApplyUpdateResult=r;function a(X,q){if(typeof X!="object"||typeof q!="object"||!X||!q)return new r(q,X!==q);if(Array.isArray(X)||Array.isArray(q)){const We=Array.isArray(X)&&Array.isArray(q)&&y.$wb(X,q);return new r(q,!We)}let de=!1;for(const We in q)if(q.hasOwnProperty(We)){const Je=a(X[We],q[We]);Je.didChange&&(X[We]=Je.newValue,de=!0)}return new r(X,de)}class c{constructor(q){this.schema=void 0,this.id=q,this.name="_never_",this.defaultValue=void 0}applyUpdate(q,de){return a(q,de)}validate(q){return this.defaultValue}}class u{constructor(q,de,We,Je){this.id=q,this.name=de,this.defaultValue=We,this.schema=Je}applyUpdate(q,de){return a(q,de)}validate(q){return typeof q>"u"?this.defaultValue:q}compute(q,de,We){return We}}function i(X,q){return typeof X>"u"?q:X==="false"?!1:!!X}class n extends u{constructor(q,de,We,Je=void 0){typeof Je<"u"&&(Je.type="boolean",Je.default=We),super(q,de,We,Je)}validate(q){return i(q,this.defaultValue)}}function t(X,q,de,We){if(typeof X>"u")return q;let Je=parseInt(X,10);return isNaN(Je)?q:(Je=Math.max(de,Je),Je=Math.min(We,Je),Je|0)}class o extends u{static clampedInt(q,de,We,Je){return t(q,de,We,Je)}constructor(q,de,We,Je,ct,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=We,dt.minimum=Je,dt.maximum=ct),super(q,de,We,dt),this.minimum=Je,this.maximum=ct}validate(q){return o.clampedInt(q,this.defaultValue,this.minimum,this.maximum)}}function l(X,q,de,We){if(typeof X>"u")return q;const Je=m.float(X,q);return m.clamp(Je,de,We)}class m extends u{static clamp(q,de,We){return q<de?de:q>We?We:q}static float(q,de){if(typeof q=="number")return q;if(typeof q>"u")return de;const We=parseFloat(q);return isNaN(We)?de:We}constructor(q,de,We,Je,ct){typeof ct<"u"&&(ct.type="number",ct.default=We),super(q,de,We,ct),this.validationFn=Je}validate(q){return this.validationFn(m.float(q,this.defaultValue))}}class g extends u{static string(q,de){return typeof q!="string"?de:q}constructor(q,de,We,Je=void 0){typeof Je<"u"&&(Je.type="string",Je.default=We),super(q,de,We,Je)}validate(q){return g.string(q,this.defaultValue)}}function d(X,q,de,We){return typeof X!="string"?q:We&&X in We?We[X]:de.indexOf(X)===-1?q:X}class S extends u{constructor(q,de,We,Je,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=Je,ct.default=We),super(q,de,We,ct),this.c=Je}validate(q){return d(q,this.defaultValue,this.c)}}class k extends f{constructor(q,de,We,Je,ct,dt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=ct,mt.default=Je),super(q,de,We,mt),this.c=ct,this.d=dt}validate(q){return typeof q!="string"?this.defaultValue:this.c.indexOf(q)===-1?this.defaultValue:this.d(q)}}function w(X){switch(X){case"none":return v.None;case"keep":return v.Keep;case"brackets":return v.Brackets;case"advanced":return v.Advanced;case"full":return v.Full}}class P extends f{constructor(){super(ve.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(300,null),s.localize(301,null),s.localize(302,null)],default:"auto",tags:["accessibility"],description:s.localize(303,null)})}validate(q){switch(q){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(q,de,We){return We===I.AccessibilitySupport.Unknown?q.accessibilitySupport:We}}class R extends f{constructor(){const q={insertSpace:!0,ignoreEmptyLines:!0};super(ve.comments,"comments",q,{"editor.comments.insertSpace":{type:"boolean",default:q.insertSpace,description:s.localize(304,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:q.ignoreEmptyLines,description:s.localize(305,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{insertSpace:i(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var $;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})($||(e.TextEditorCursorBlinkingStyle=$={}));function b(X){switch(X){case"blink":return $.Blink;case"smooth":return $.Smooth;case"phase":return $.Phase;case"expand":return $.Expand;case"solid":return $.Solid}}var L;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(L||(e.TextEditorCursorStyle=L={}));function A(X){switch(X){case L.Line:return"line";case L.Block:return"block";case L.Underline:return"underline";case L.LineThin:return"line-thin";case L.BlockOutline:return"block-outline";case L.UnderlineThin:return"underline-thin"}}function M(X){switch(X){case"line":return L.Line;case"block":return L.Block;case"underline":return L.Underline;case"line-thin":return L.LineThin;case"block-outline":return L.BlockOutline;case"underline-thin":return L.UnderlineThin}}class Z extends c{constructor(){super(ve.editorClassName)}compute(q,de,We){const Je=["monaco-editor"];return de.get(ve.extraEditorClassName)&&Je.push(de.get(ve.extraEditorClassName)),q.extraEditorClassName&&Je.push(q.extraEditorClassName),de.get(ve.mouseStyle)==="default"?Je.push("mouse-default"):de.get(ve.mouseStyle)==="copy"&&Je.push("mouse-copy"),de.get(ve.showUnused)&&Je.push("showUnused"),de.get(ve.showDeprecated)&&Je.push("showDeprecated"),Je.join(" ")}}class G extends n{constructor(){super(ve.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(306,null)})}compute(q,de,We){return We&&q.emptySelectionClipboard}}class U extends f{constructor(){const q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ve.find,"find",q,{"editor.find.cursorMoveOnType":{type:"boolean",default:q.cursorMoveOnType,description:s.localize(307,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:q.seedSearchStringFromSelection,enumDescriptions:[s.localize(308,null),s.localize(309,null),s.localize(310,null)],description:s.localize(311,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:q.autoFindInSelection,enumDescriptions:[s.localize(312,null),s.localize(313,null),s.localize(314,null)],description:s.localize(315,null)},"editor.find.globalFindClipboard":{type:"boolean",default:q.globalFindClipboard,description:s.localize(316,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:q.addExtraSpaceOnTop,description:s.localize(317,null)},"editor.find.loop":{type:"boolean",default:q.loop,description:s.localize(318,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{cursorMoveOnType:i(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof q.seedSearchStringFromSelection=="boolean"?q.seedSearchStringFromSelection?"always":"never":d(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof q.autoFindInSelection=="boolean"?q.autoFindInSelection?"always":"never":d(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(de.loop,this.defaultValue.loop)}}}class V extends f{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ve.fontLigatures,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:s.localize(319,null)},{type:"string",description:s.localize(320,null)}],description:s.localize(321,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"||q.length===0?V.OFF:q==="true"?V.ON:q:q?V.ON:V.OFF}}e.EditorFontLigatures=V;class Q extends f{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ve.fontVariations,"fontVariations",Q.OFF,{anyOf:[{type:"boolean",description:s.localize(322,null)},{type:"string",description:s.localize(323,null)}],description:s.localize(324,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"?Q.OFF:q==="true"?Q.TRANSLATE:q:q?Q.TRANSLATE:Q.OFF}compute(q,de,We){return q.fontInfo.fontVariationSettings}}e.EditorFontVariations=Q;class ne extends c{constructor(){super(ve.fontInfo)}compute(q,de,We){return q.fontInfo}}class ue extends u{constructor(){super(ve.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(325,null)})}validate(q){const de=m.float(q,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(de,6,100)}compute(q,de,We){return q.fontInfo.fontSize}}class x extends f{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ve.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.d,maximum:x.e,errorMessage:s.localize(326,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(327,null)})}validate(q){return q==="normal"||q==="bold"?q:String(o.clampedInt(q,e.EDITOR_FONT_DEFAULTS.fontWeight,x.d,x.e))}}class oe extends f{constructor(){const q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:q.multiple,enumDescriptions:[s.localize(328,null),s.localize(329,null),s.localize(330,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ve.gotoLocation,"gotoLocation",q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(331,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(332,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(333,null),...de},"editor.gotoLocation.multipleDeclarations":{description:s.localize(334,null),...de},"editor.gotoLocation.multipleImplementations":{description:s.localize(335,null),...de},"editor.gotoLocation.multipleReferences":{description:s.localize(336,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:q.alternativeDefinitionCommand,enum:We,description:s.localize(337,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:q.alternativeTypeDefinitionCommand,enum:We,description:s.localize(338,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:q.alternativeDeclarationCommand,enum:We,description:s.localize(339,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:q.alternativeImplementationCommand,enum:We,description:s.localize(340,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:q.alternativeReferenceCommand,enum:We,description:s.localize(341,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{multiple:d(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??d(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??d(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??d(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??d(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??d(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:de.multipleTests??d(de.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:g.string(de.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class se extends f{constructor(){const q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ve.hover,"hover",q,{"editor.hover.enabled":{type:"boolean",default:q.enabled,description:s.localize(342,null)},"editor.hover.delay":{type:"number",default:q.delay,minimum:0,maximum:1e4,description:s.localize(343,null)},"editor.hover.sticky":{type:"boolean",default:q.sticky,description:s.localize(344,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:q.hidingDelay,description:s.localize(345,null)},"editor.hover.above":{type:"boolean",default:q.above,description:s.localize(346,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),delay:o.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:i(de.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(de.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(de.above,this.defaultValue.above)}}}var ce;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ce||(e.RenderMinimap=ce={}));class te extends c{constructor(){super(ve.layoutInfo)}compute(q,de,We){return te.computeLayout(de,{memory:q.memory,outerWidth:q.outerWidth,outerHeight:q.outerHeight,isDominatedByLongLines:q.isDominatedByLongLines,lineHeight:q.fontInfo.lineHeight,viewLineCount:q.viewLineCount,lineNumbersDigitCount:q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:q.fontInfo.maxDigitWidth,pixelRatio:q.pixelRatio,glyphMarginDecorationLaneCount:q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(q){const de=q.height/q.lineHeight,We=Math.floor(q.paddingTop/q.lineHeight);let Je=Math.floor(q.paddingBottom/q.lineHeight);q.scrollBeyondLastLine&&(Je=Math.max(Je,de-1));const ct=(We+q.viewLineCount+Je)/(q.pixelRatio*q.height),dt=Math.floor(q.viewLineCount/ct);return{typicalViewportLineCount:de,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Je,desiredRatio:ct,minimapLineCount:dt}}static c(q,de){const We=q.outerWidth,Je=q.outerHeight,ct=q.pixelRatio;if(!q.minimap.enabled)return{renderMinimap:ce.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ct*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const dt=de.stableMinimapLayoutInput,mt=dt&&q.outerHeight===dt.outerHeight&&q.lineHeight===dt.lineHeight&&q.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&q.pixelRatio===dt.pixelRatio&&q.scrollBeyondLastLine===dt.scrollBeyondLastLine&&q.paddingTop===dt.paddingTop&&q.paddingBottom===dt.paddingBottom&&q.minimap.enabled===dt.minimap.enabled&&q.minimap.side===dt.minimap.side&&q.minimap.size===dt.minimap.size&&q.minimap.showSlider===dt.minimap.showSlider&&q.minimap.renderCharacters===dt.minimap.renderCharacters&&q.minimap.maxColumn===dt.minimap.maxColumn&&q.minimap.scale===dt.minimap.scale&&q.verticalScrollbarWidth===dt.verticalScrollbarWidth&&q.isViewportWrapping===dt.isViewportWrapping,Rt=q.lineHeight,At=q.typicalHalfwidthCharacterWidth,Qt=q.scrollBeyondLastLine,_t=q.minimap.renderCharacters;let _e=ct>=2?Math.round(q.minimap.scale*2):q.minimap.scale;const Ot=q.minimap.maxColumn,Ut=q.minimap.size,$t=q.minimap.side,Pt=q.verticalScrollbarWidth,ei=q.viewLineCount,ti=q.remainingWidth,Ht=q.isViewportWrapping,wt=_t?2:3;let Nt=Math.floor(ct*Je);const ai=Nt/ct;let Zt=!1,Ye=!1,ii=wt*_e,ci=_e/ct,ui=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Kt,extraLinesBeyondLastLine:Gt,desiredRatio:li,minimapLineCount:Mt}=te.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Qt,paddingTop:q.paddingTop,paddingBottom:q.paddingBottom,height:Je,lineHeight:Rt,pixelRatio:ct});if(ei/Mt>1)Zt=!0,Ye=!0,_e=1,ii=1,ci=_e/ct;else{let bt=!1,Jt=_e+1;if(Ut==="fit"){const St=Math.ceil((Kt+ei+Gt)*ii);Ht&&mt&&ti<=de.stableFitRemainingWidth?(bt=!0,Jt=de.stableFitMaxMinimapScale):bt=St>Nt}if(Ut==="fill"||bt){Zt=!0;const St=_e;ii=Math.min(Rt*ct,Math.max(1,Math.floor(1/li))),Ht&&mt&&ti<=de.stableFitRemainingWidth&&(Jt=de.stableFitMaxMinimapScale),_e=Math.min(Jt,Math.max(1,Math.floor(ii/wt))),_e>St&&(ui=Math.min(2,_e/St)),ci=_e/ct/ui,Nt=Math.ceil(Math.max(ri,Kt+ei+Gt)*ii),Ht?(de.stableMinimapLayoutInput=q,de.stableFitRemainingWidth=ti,de.stableFitMaxMinimapScale=_e):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const Et=Math.floor(Ot*ci),jt=Math.min(Et,Math.max(0,Math.floor((ti-Pt-2)*ci/(At+ci)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(ct*jt);const Bt=Lt/ct;Lt=Math.floor(Lt*ui);const oi=_t?ce.Text:ce.Blocks,ni=$t==="left"?0:We-jt-Pt;return{renderMinimap:oi,minimapLeft:ni,minimapWidth:jt,minimapHeightIsEditorHeight:Zt,minimapIsSampling:Ye,minimapScale:_e,minimapLineHeight:ii,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ai}}static computeLayout(q,de){const We=de.outerWidth|0,Je=de.outerHeight|0,ct=de.lineHeight|0,dt=de.lineNumbersDigitCount|0,mt=de.typicalHalfwidthCharacterWidth,Rt=de.maxDigitWidth,At=de.pixelRatio,Qt=de.viewLineCount,_t=q.get(ve.wordWrapOverride2),_e=_t==="inherit"?q.get(ve.wordWrapOverride1):_t,Ot=_e==="inherit"?q.get(ve.wordWrap):_e,Ut=q.get(ve.wordWrapColumn),$t=de.isDominatedByLongLines,Pt=q.get(ve.glyphMargin),ei=q.get(ve.lineNumbers).renderType!==it.Off,ti=q.get(ve.lineNumbersMinChars),Ht=q.get(ve.scrollBeyondLastLine),wt=q.get(ve.padding),Nt=q.get(ve.minimap),ai=q.get(ve.scrollbar),Zt=ai.verticalScrollbarSize,Ye=ai.verticalHasArrows,ii=ai.arrowSize,ci=ai.horizontalScrollbarSize,ui=q.get(ve.folding),Et=q.get(ve.showFoldingControls)!=="never";let jt=q.get(ve.lineDecorationsWidth);ui&&Et&&(jt+=16);let Lt=0;if(ei){const Xt=Math.max(dt,ti);Lt=Math.round(Xt*Rt)}let Bt=0;Pt&&(Bt=ct*de.glyphMarginDecorationLaneCount);let oi=0,ni=oi+Bt,ri=ni+Lt,Kt=ri+jt;const Gt=We-Bt-Lt-jt;let li=!1,Mt=!1,Dt=-1;_e==="inherit"&&$t?(li=!0,Mt=!0):Ot==="on"||Ot==="bounded"?Mt=!0:Ot==="wordWrapColumn"&&(Dt=Ut);const bt=te.c({outerWidth:We,outerHeight:Je,lineHeight:ct,typicalHalfwidthCharacterWidth:mt,pixelRatio:At,scrollBeyondLastLine:Ht,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Nt,verticalScrollbarWidth:Zt,viewLineCount:Qt,remainingWidth:Gt,isViewportWrapping:Mt},de.memory||new E);bt.renderMinimap!==ce.None&&bt.minimapLeft===0&&(oi+=bt.minimapWidth,ni+=bt.minimapWidth,ri+=bt.minimapWidth,Kt+=bt.minimapWidth);const Jt=Gt-bt.minimapWidth,St=Math.max(1,Math.floor((Jt-Zt-2)/mt)),hi=Ye?ii:0;return Mt&&(Dt=Math.max(1,St),Ot==="bounded"&&(Dt=Math.min(Dt,Ut))),{width:We,height:Je,glyphMarginLeft:oi,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:Lt,decorationsLeft:ri,decorationsWidth:jt,contentLeft:Kt,contentWidth:Jt,minimap:bt,viewportColumn:St,isWordWrapMinified:li,isViewportWrapping:Mt,wrappingColumn:Dt,verticalScrollbarWidth:Zt,horizontalScrollbarHeight:ci,overviewRuler:{top:hi,width:Zt,height:Je-2*hi,right:0}}}}e.EditorLayoutInfoComputer=te;class we extends f{constructor(){super(ve.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(347,null),s.localize(348,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(349,null)}})}validate(q){return d(q,"simple",["simple","advanced"])}compute(q,de,We){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":We}}var Ce;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(Ce||(e.ShowLightbulbIconMode=Ce={}));class Y extends f{constructor(){const q={enabled:Ce.OnCode};super(ve.lightbulb,"lightbulb",q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ce.Off,Ce.OnCode,Ce.On],default:q.enabled,enumDescriptions:[s.localize(350,null),s.localize(351,null),s.localize(352,null)],description:s.localize(353,null)}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{enabled:d(q.enabled,this.defaultValue.enabled,[Ce.Off,Ce.OnCode,Ce.On])}}}class W extends f{constructor(){const q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ve.stickyScroll,"stickyScroll",q,{"editor.stickyScroll.enabled":{type:"boolean",default:q.enabled,description:s.localize(354,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:q.maxLineCount,minimum:1,maximum:20,description:s.localize(355,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:q.defaultModel,description:s.localize(356,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:q.scrollWithEditor,description:s.localize(357,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(de.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(de.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(de.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends f{constructor(){const q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ve.inlayHints,"inlayHints",q,{"editor.inlayHints.enabled":{type:"string",default:q.enabled,description:s.localize(358,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(359,null),s.localize(360,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(361,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(362,null)]},"editor.inlayHints.fontSize":{type:"number",default:q.fontSize,markdownDescription:s.localize(363,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:q.fontFamily,markdownDescription:s.localize(364,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:q.padding,description:s.localize(365,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return typeof de.enabled=="boolean"&&(de.enabled=de.enabled?"on":"off"),{enabled:d(de.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily),padding:i(de.padding,this.defaultValue.padding)}}}class be extends f{constructor(){super(ve.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(q){return typeof q=="string"&&/^\d+(\.\d+)?ch$/.test(q)?-parseFloat(q.substring(0,q.length-2)):o.clampedInt(q,this.defaultValue,0,1e3)}compute(q,de,We){return We<0?o.clampedInt(-We*q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class Pe extends m{constructor(){super(ve.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,q=>m.clamp(q,0,150),{markdownDescription:s.localize(366,null)})}compute(q,de,We){return q.fontInfo.lineHeight}}class je extends f{constructor(){const q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ve.minimap,"minimap",q,{"editor.minimap.enabled":{type:"boolean",default:q.enabled,description:s.localize(367,null)},"editor.minimap.autohide":{type:"boolean",default:q.autohide,description:s.localize(368,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(369,null),s.localize(370,null),s.localize(371,null)],default:q.size,description:s.localize(372,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:q.side,description:s.localize(373,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:q.showSlider,description:s.localize(374,null)},"editor.minimap.scale":{type:"number",default:q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(375,null)},"editor.minimap.renderCharacters":{type:"boolean",default:q.renderCharacters,description:s.localize(376,null)},"editor.minimap.maxColumn":{type:"number",default:q.maxColumn,description:s.localize(377,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:q.showRegionSectionHeaders,description:s.localize(378,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:q.showMarkSectionHeaders,description:s.localize(379,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:q.sectionHeaderFontSize,description:s.localize(380,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:q.sectionHeaderLetterSpacing,description:s.localize(381,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),autohide:i(de.autohide,this.defaultValue.autohide),size:d(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(de.side,this.defaultValue.side,["right","left"]),showSlider:d(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(de.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(de.scale,1,1,3),maxColumn:o.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(de.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(de.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:m.clamp(de.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:m.clamp(de.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function Te(X){return X==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class Ee extends f{constructor(){super(ve.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(382,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(383,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{top:o.clampedInt(de.top,0,0,1e3),bottom:o.clampedInt(de.bottom,0,0,1e3)}}}class Fe extends f{constructor(){const q={enabled:!0,cycle:!0};super(ve.parameterHints,"parameterHints",q,{"editor.parameterHints.enabled":{type:"boolean",default:q.enabled,description:s.localize(384,null)},"editor.parameterHints.cycle":{type:"boolean",default:q.cycle,description:s.localize(385,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),cycle:i(de.cycle,this.defaultValue.cycle)}}}class Ve extends c{constructor(){super(ve.pixelRatio)}compute(q,de,We){return q.pixelRatio}}class Ge extends f{constructor(){super(ve.placeholder,"placeholder",void 0)}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q:this.defaultValue}}class et extends f{constructor(){const q={other:"on",comments:"off",strings:"off"},de=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(386,null),s.localize(387,null),s.localize(388,null)]}];super(ve.quickSuggestions,"quickSuggestions",q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:de,default:q.strings,description:s.localize(389,null)},comments:{anyOf:de,default:q.comments,description:s.localize(390,null)},other:{anyOf:de,default:q.other,description:s.localize(391,null)}},default:q,markdownDescription:s.localize(392,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=q}validate(q){if(typeof q=="boolean"){const At=q?"on":"off";return{comments:At,strings:At,other:At}}if(!q||typeof q!="object")return this.defaultValue;const{other:de,comments:We,strings:Je}=q,ct=["on","inline","off"];let dt,mt,Rt;return typeof de=="boolean"?dt=de?"on":"off":dt=d(de,this.defaultValue.other,ct),typeof We=="boolean"?mt=We?"on":"off":mt=d(We,this.defaultValue.comments,ct),typeof Je=="boolean"?Rt=Je?"on":"off":Rt=d(Je,this.defaultValue.strings,ct),{other:dt,comments:mt,strings:Rt}}}var it;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(it||(e.RenderLineNumbersType=it={}));class Me extends f{constructor(){super(ve.lineNumbers,"lineNumbers",{renderType:it.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(393,null),s.localize(394,null),s.localize(395,null),s.localize(396,null)],default:"on",description:s.localize(397,null)})}validate(q){let de=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof q<"u"&&(typeof q=="function"?(de=it.Custom,We=q):q==="interval"?de=it.Interval:q==="relative"?de=it.Relative:q==="on"?de=it.On:de=it.Off),{renderType:de,renderFn:We}}}function Ue(X){const q=X.get(ve.renderValidationDecorations);return q==="editable"?X.get(ve.readOnly):q!=="on"}class ze extends f{constructor(){const q=[],de={type:"number",description:s.localize(398,null)};super(ve.rulers,"rulers",q,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:s.localize(399,null),format:"color-hex"}}}]},default:q,description:s.localize(400,null)})}validate(q){if(Array.isArray(q)){const de=[];for(const We of q)if(typeof We=="number")de.push({column:o.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Je=We;de.push({column:o.clampedInt(Je.column,0,0,1e4),color:Je.color})}return de.sort((We,Je)=>We.column-Je.column),de}return this.defaultValue}}class B extends f{constructor(){super(ve.readOnlyMessage,"readOnlyMessage",void 0)}validate(q){return!q||typeof q!="object"?this.defaultValue:q}}function j(X,q){if(typeof X!="string")return q;switch(X){case"hidden":return N.ScrollbarVisibility.Hidden;case"visible":return N.ScrollbarVisibility.Visible;default:return N.ScrollbarVisibility.Auto}}class H extends f{constructor(){const q={vertical:N.ScrollbarVisibility.Auto,horizontal:N.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ve.scrollbar,"scrollbar",q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(401,null),s.localize(402,null),s.localize(403,null)],default:"auto",description:s.localize(404,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(405,null),s.localize(406,null),s.localize(407,null)],default:"auto",description:s.localize(408,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:q.verticalScrollbarSize,description:s.localize(409,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:q.horizontalScrollbarSize,description:s.localize(410,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:q.scrollByPage,description:s.localize(411,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:q.ignoreHorizontalScrollbarInContentHeight,description:s.localize(412,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q,We=o.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=o.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(de.vertical,this.defaultValue.vertical),horizontal:j(de.horizontal,this.defaultValue.horizontal),useShadows:i(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:o.clampedInt(de.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:o.clampedInt(de.verticalSliderSize,Je,0,1e3),scrollByPage:i(de.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(de.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends f{constructor(){const q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ve.unicodeHighlighting,"unicodeHighlight",q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.nonBasicASCII,description:s.localize(413,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:q.invisibleCharacters,description:s.localize(414,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:q.ambiguousCharacters,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeComments,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeStrings,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:q.allowedCharacters,description:s.localize(418,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:q.allowedLocales,description:s.localize(419,null)}})}applyUpdate(q,de){let We=!1;de.allowedCharacters&&q&&(D.$lo(q.allowedCharacters,de.allowedCharacters)||(q={...q,allowedCharacters:de.allowedCharacters},We=!0)),de.allowedLocales&&q&&(D.$lo(q.allowedLocales,de.allowedLocales)||(q={...q,allowedLocales:de.allowedLocales},We=!0));const Je=super.applyUpdate(q,de);return We?new r(Je.newValue,!0):Je}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{nonBasicASCII:xe(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:xe(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:xe(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(q.allowedLocales,this.defaultValue.allowedLocales)}}c(q,de){if(typeof q!="object"||!q)return de;const We={};for(const[Je,ct]of Object.entries(q))ct===!0&&(We[Je]=!0);return We}}class re extends f{constructor(){const q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ve.inlineSuggest,"inlineSuggest",q,{"editor.inlineSuggest.enabled":{type:"boolean",default:q.enabled,description:s.localize(420,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(421,null),s.localize(422,null),s.localize(423,null)],description:s.localize(424,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:q.suppressSuggestions,description:s.localize(425,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:q.fontFamily,description:s.localize(426,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),mode:d(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(de.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily)}}}class ge extends f{constructor(){const q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(ve.inlineEdit,"experimentalInlineEdit",q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:q.enabled,description:s.localize(427,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(428,null),s.localize(429,null),s.localize(430,null)],description:s.localize(431,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:q.fontFamily,description:s.localize(432,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showToolbar:d(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ke extends f{constructor(){const q={enabled:O.$qt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$qt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ve.bracketPairColorization,"bracketPairColorization",q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(433,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:q.independentColorPoolPerBracketType,description:s.localize(434,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(de.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class qe extends f{constructor(){const q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ve.guides,"guides",q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(435,null),s.localize(436,null),s.localize(437,null)],default:q.bracketPairs,description:s.localize(438,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(439,null),s.localize(440,null),s.localize(441,null)],default:q.bracketPairsHorizontal,description:s.localize(442,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:q.highlightActiveBracketPair,description:s.localize(443,null)},"editor.guides.indentation":{type:"boolean",default:q.indentation,description:s.localize(444,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(445,null),s.localize(446,null),s.localize(447,null)],default:q.highlightActiveIndentation,description:s.localize(448,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{bracketPairs:xe(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:xe(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:xe(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function xe(X,q,de){const We=de.indexOf(X);return We===-1?q:de[We]}class rt extends f{constructor(){const q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ve.suggest,"suggest",q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(449,null),s.localize(450,null)],default:q.insertMode,description:s.localize(451,null)},"editor.suggest.filterGraceful":{type:"boolean",default:q.filterGraceful,description:s.localize(452,null)},"editor.suggest.localityBonus":{type:"boolean",default:q.localityBonus,description:s.localize(453,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:q.shareSuggestSelections,markdownDescription:s.localize(454,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(455,null),s.localize(456,null),s.localize(457,null),s.localize(458,null)],default:q.selectionMode,markdownDescription:s.localize(459,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:q.snippetsPreventQuickSuggestions,description:s.localize(460,null)},"editor.suggest.showIcons":{type:"boolean",default:q.showIcons,description:s.localize(461,null)},"editor.suggest.showStatusBar":{type:"boolean",default:q.showStatusBar,description:s.localize(462,null)},"editor.suggest.preview":{type:"boolean",default:q.preview,description:s.localize(463,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:q.showInlineDetails,description:s.localize(464,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(465,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(466,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(467,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(468,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{insertMode:d(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(de.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(de.showIcons,this.defaultValue.showIcons),showStatusBar:i(de.showStatusBar,this.defaultValue.showStatusBar),preview:i(de.preview,this.defaultValue.preview),previewMode:d(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(de.showMethods,this.defaultValue.showMethods),showFunctions:i(de.showFunctions,this.defaultValue.showFunctions),showConstructors:i(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(de.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(de.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(de.showFields,this.defaultValue.showFields),showVariables:i(de.showVariables,this.defaultValue.showVariables),showClasses:i(de.showClasses,this.defaultValue.showClasses),showStructs:i(de.showStructs,this.defaultValue.showStructs),showInterfaces:i(de.showInterfaces,this.defaultValue.showInterfaces),showModules:i(de.showModules,this.defaultValue.showModules),showProperties:i(de.showProperties,this.defaultValue.showProperties),showEvents:i(de.showEvents,this.defaultValue.showEvents),showOperators:i(de.showOperators,this.defaultValue.showOperators),showUnits:i(de.showUnits,this.defaultValue.showUnits),showValues:i(de.showValues,this.defaultValue.showValues),showConstants:i(de.showConstants,this.defaultValue.showConstants),showEnums:i(de.showEnums,this.defaultValue.showEnums),showEnumMembers:i(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(de.showKeywords,this.defaultValue.showKeywords),showWords:i(de.showWords,this.defaultValue.showWords),showColors:i(de.showColors,this.defaultValue.showColors),showFiles:i(de.showFiles,this.defaultValue.showFiles),showReferences:i(de.showReferences,this.defaultValue.showReferences),showFolders:i(de.showFolders,this.defaultValue.showFolders),showTypeParameters:i(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(de.showSnippets,this.defaultValue.showSnippets),showUsers:i(de.showUsers,this.defaultValue.showUsers),showIssues:i(de.showIssues,this.defaultValue.showIssues)}}}class st extends f{constructor(){super(ve.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(497,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(498,null),default:!0,type:"boolean"}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(q.selectSubwords,this.defaultValue.selectSubwords)}}}class ut extends f{constructor(){const q=[];super(ve.wordSegmenterLocales,"wordSegmenterLocales",q,{anyOf:[{description:s.localize(499,null),type:"string"},{description:s.localize(500,null),type:"array",items:{type:"string"}}]})}validate(q){if(typeof q=="string"&&(q=[q]),Array.isArray(q)){const de=[];for(const We of q)if(typeof We=="string")try{Intl.Segmenter.supportedLocalesOf(We).length>0&&de.push(We)}catch{}return de}return this.defaultValue}}var ot;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(ot||(e.WrappingIndent=ot={}));class lt extends f{constructor(){super(ve.wrappingIndent,"wrappingIndent",ot.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(501,null),s.localize(502,null),s.localize(503,null),s.localize(504,null)],description:s.localize(505,null),default:"same"}})}validate(q){switch(q){case"none":return ot.None;case"same":return ot.Same;case"indent":return ot.Indent;case"deepIndent":return ot.DeepIndent}return ot.Same}compute(q,de,We){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?ot.None:We}}class vt extends c{constructor(){super(ve.wrappingInfo)}compute(q,de,We){const Je=de.get(ve.layoutInfo);return{isDominatedByLongLines:q.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}class nt extends f{constructor(){const q={enabled:!0,showDropSelector:"afterDrop"};super(ve.dropIntoEditor,"dropIntoEditor",q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(506,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(507,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(508,null),s.localize(509,null)],default:"afterDrop"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showDropSelector:d(de.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class he extends f{constructor(){const q={enabled:!0,showPasteSelector:"afterPaste"};super(ve.pasteAs,"pasteAs",q,{"editor.pasteAs.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(510,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(511,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(512,null),s.localize(513,null)],default:"afterPaste"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showPasteSelector:d(de.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const pe="Consolas, 'Courier New', monospace",ye="Menlo, Monaco, 'Courier New', monospace",Re="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?ye:C.$l?Re:pe,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function fe(X){return e.editorOptionsRegistry[X.id]=X,X}var ve;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.placeholder=88]="placeholder",X[X.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",X[X.quickSuggestions=90]="quickSuggestions",X[X.quickSuggestionsDelay=91]="quickSuggestionsDelay",X[X.readOnly=92]="readOnly",X[X.readOnlyMessage=93]="readOnlyMessage",X[X.renameOnType=94]="renameOnType",X[X.renderControlCharacters=95]="renderControlCharacters",X[X.renderFinalNewline=96]="renderFinalNewline",X[X.renderLineHighlight=97]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=99]="renderValidationDecorations",X[X.renderWhitespace=100]="renderWhitespace",X[X.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",X[X.roundedSelection=102]="roundedSelection",X[X.rulers=103]="rulers",X[X.scrollbar=104]="scrollbar",X[X.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=106]="scrollBeyondLastLine",X[X.scrollPredominantAxis=107]="scrollPredominantAxis",X[X.selectionClipboard=108]="selectionClipboard",X[X.selectionHighlight=109]="selectionHighlight",X[X.selectOnLineNumbers=110]="selectOnLineNumbers",X[X.showFoldingControls=111]="showFoldingControls",X[X.showUnused=112]="showUnused",X[X.snippetSuggestions=113]="snippetSuggestions",X[X.smartSelect=114]="smartSelect",X[X.smoothScrolling=115]="smoothScrolling",X[X.stickyScroll=116]="stickyScroll",X[X.stickyTabStops=117]="stickyTabStops",X[X.stopRenderingLineAfter=118]="stopRenderingLineAfter",X[X.suggest=119]="suggest",X[X.suggestFontSize=120]="suggestFontSize",X[X.suggestLineHeight=121]="suggestLineHeight",X[X.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",X[X.suggestSelection=123]="suggestSelection",X[X.tabCompletion=124]="tabCompletion",X[X.tabIndex=125]="tabIndex",X[X.unicodeHighlighting=126]="unicodeHighlighting",X[X.unusualLineTerminators=127]="unusualLineTerminators",X[X.useShadowDOM=128]="useShadowDOM",X[X.useTabStops=129]="useTabStops",X[X.wordBreak=130]="wordBreak",X[X.wordSegmenterLocales=131]="wordSegmenterLocales",X[X.wordSeparators=132]="wordSeparators",X[X.wordWrap=133]="wordWrap",X[X.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=136]="wordWrapColumn",X[X.wordWrapOverride1=137]="wordWrapOverride1",X[X.wordWrapOverride2=138]="wordWrapOverride2",X[X.wrappingIndent=139]="wrappingIndent",X[X.wrappingStrategy=140]="wrappingStrategy",X[X.showDeprecated=141]="showDeprecated",X[X.inlayHints=142]="inlayHints",X[X.editorClassName=143]="editorClassName",X[X.pixelRatio=144]="pixelRatio",X[X.tabFocusMode=145]="tabFocusMode",X[X.layoutInfo=146]="layoutInfo",X[X.wrappingInfo=147]="wrappingInfo",X[X.defaultColorDecorators=148]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(ve||(e.EditorOption=ve={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:fe(new n(ve.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(514,null)})),acceptSuggestionOnEnter:fe(new S(ve.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(515,null),""],markdownDescription:s.localize(516,null)})),accessibilitySupport:fe(new P),accessibilityPageSize:fe(new o(ve.accessibilityPageSize,"accessibilityPageSize",10,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(517,null),tags:["accessibility"]})),ariaLabel:fe(new g(ve.ariaLabel,"ariaLabel",s.localize(518,null))),ariaRequired:fe(new n(ve.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:fe(new n(ve.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(519,null),tags:["accessibility"]})),autoClosingBrackets:fe(new S(ve.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(520,null),s.localize(521,null),""],description:s.localize(522,null)})),autoClosingComments:fe(new S(ve.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(523,null),s.localize(524,null),""],description:s.localize(525,null)})),autoClosingDelete:fe(new S(ve.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(526,null),""],description:s.localize(527,null)})),autoClosingOvertype:fe(new S(ve.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingQuotes:fe(new S(ve.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(530,null),s.localize(531,null),""],description:s.localize(532,null)})),autoIndent:fe(new k(ve.autoIndent,"autoIndent",v.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[s.localize(533,null),s.localize(534,null),s.localize(535,null),s.localize(536,null),s.localize(537,null)],description:s.localize(538,null)})),automaticLayout:fe(new n(ve.automaticLayout,"automaticLayout",!1)),autoSurround:fe(new S(ve.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(539,null),s.localize(540,null),s.localize(541,null),""],description:s.localize(542,null)})),bracketPairColorization:fe(new ke),bracketPairGuides:fe(new qe),stickyTabStops:fe(new n(ve.stickyTabStops,"stickyTabStops",!1,{description:s.localize(543,null)})),codeLens:fe(new n(ve.codeLens,"codeLens",!0,{description:s.localize(544,null)})),codeLensFontFamily:fe(new g(ve.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(545,null)})),codeLensFontSize:fe(new o(ve.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(546,null)})),colorDecorators:fe(new n(ve.colorDecorators,"colorDecorators",!0,{description:s.localize(547,null)})),colorDecoratorActivatedOn:fe(new S(ve.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(548,null),s.localize(549,null),s.localize(550,null)],description:s.localize(551,null)})),colorDecoratorsLimit:fe(new o(ve.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(552,null)})),columnSelection:fe(new n(ve.columnSelection,"columnSelection",!1,{description:s.localize(553,null)})),comments:fe(new R),contextmenu:fe(new n(ve.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:fe(new n(ve.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(554,null)})),cursorBlinking:fe(new k(ve.cursorBlinking,"cursorBlinking",$.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:s.localize(555,null)})),cursorSmoothCaretAnimation:fe(new S(ve.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(556,null),s.localize(557,null),s.localize(558,null)],description:s.localize(559,null)})),cursorStyle:fe(new k(ve.cursorStyle,"cursorStyle",L.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:s.localize(560,null)})),cursorSurroundingLines:fe(new o(ve.cursorSurroundingLines,"cursorSurroundingLines",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(561,null)})),cursorSurroundingLinesStyle:fe(new S(ve.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(562,null),s.localize(563,null)],markdownDescription:s.localize(564,null)})),cursorWidth:fe(new o(ve.cursorWidth,"cursorWidth",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(565,null)})),disableLayerHinting:fe(new n(ve.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:fe(new n(ve.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:fe(new n(ve.domReadOnly,"domReadOnly",!1)),dragAndDrop:fe(new n(ve.dragAndDrop,"dragAndDrop",!0,{description:s.localize(566,null)})),emptySelectionClipboard:fe(new G),dropIntoEditor:fe(new nt),stickyScroll:fe(new W),experimentalWhitespaceRendering:fe(new S(ve.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(567,null),s.localize(568,null),s.localize(569,null)],description:s.localize(570,null)})),extraEditorClassName:fe(new g(ve.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:fe(new m(ve.fastScrollSensitivity,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:s.localize(571,null)})),find:fe(new U),fixedOverflowWidgets:fe(new n(ve.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:fe(new n(ve.folding,"folding",!0,{description:s.localize(572,null)})),foldingStrategy:fe(new S(ve.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(573,null),s.localize(574,null)],description:s.localize(575,null)})),foldingHighlight:fe(new n(ve.foldingHighlight,"foldingHighlight",!0,{description:s.localize(576,null)})),foldingImportsByDefault:fe(new n(ve.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(577,null)})),foldingMaximumRegions:fe(new o(ve.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(578,null)})),unfoldOnClickAfterEndOfLine:fe(new n(ve.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(579,null)})),fontFamily:fe(new g(ve.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(580,null)})),fontInfo:fe(new ne),fontLigatures2:fe(new V),fontSize:fe(new ue),fontWeight:fe(new x),fontVariations:fe(new Q),formatOnPaste:fe(new n(ve.formatOnPaste,"formatOnPaste",!1,{description:s.localize(581,null)})),formatOnType:fe(new n(ve.formatOnType,"formatOnType",!1,{description:s.localize(582,null)})),glyphMargin:fe(new n(ve.glyphMargin,"glyphMargin",!0,{description:s.localize(583,null)})),gotoLocation:fe(new oe),hideCursorInOverviewRuler:fe(new n(ve.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(584,null)})),hover:fe(new se),inDiffEditor:fe(new n(ve.inDiffEditor,"inDiffEditor",!1)),letterSpacing:fe(new m(ve.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>m.clamp(X,-5,20),{description:s.localize(585,null)})),lightbulb:fe(new Y),lineDecorationsWidth:fe(new be),lineHeight:fe(new Pe),lineNumbers:fe(new Me),lineNumbersMinChars:fe(new o(ve.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:fe(new n(ve.linkedEditing,"linkedEditing",!1,{description:s.localize(586,null)})),links:fe(new n(ve.links,"links",!0,{description:s.localize(587,null)})),matchBrackets:fe(new S(ve.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(588,null)})),minimap:fe(new je),mouseStyle:fe(new S(ve.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:fe(new m(ve.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:s.localize(589,null)})),mouseWheelZoom:fe(new n(ve.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$k?s.localize(590,null):s.localize(591,null)})),multiCursorMergeOverlapping:fe(new n(ve.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(592,null)})),multiCursorModifier:fe(new k(ve.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[s.localize(593,null),s.localize(594,null)],markdownDescription:s.localize(595,null)})),multiCursorPaste:fe(new S(ve.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(596,null),s.localize(597,null)],markdownDescription:s.localize(598,null)})),multiCursorLimit:fe(new o(ve.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(599,null)})),occurrencesHighlight:fe(new S(ve.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(600,null),s.localize(601,null),s.localize(602,null)],markdownDescription:s.localize(603,null)})),overviewRulerBorder:fe(new n(ve.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(604,null)})),overviewRulerLanes:fe(new o(ve.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:fe(new Ee),pasteAs:fe(new he),parameterHints:fe(new Fe),peekWidgetDefaultFocus:fe(new S(ve.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(605,null),s.localize(606,null)],description:s.localize(607,null)})),placeholder:fe(new Ge),definitionLinkOpensInPeek:fe(new n(ve.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(608,null)})),quickSuggestions:fe(new et),quickSuggestionsDelay:fe(new o(ve.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(609,null)})),readOnly:fe(new n(ve.readOnly,"readOnly",!1)),readOnlyMessage:fe(new B),renameOnType:fe(new n(ve.renameOnType,"renameOnType",!1,{description:s.localize(610,null),markdownDeprecationMessage:s.localize(611,null)})),renderControlCharacters:fe(new n(ve.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(612,null),restricted:!0})),renderFinalNewline:fe(new S(ve.renderFinalNewline,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:s.localize(613,null)})),renderLineHighlight:fe(new S(ve.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(614,null)],description:s.localize(615,null)})),renderLineHighlightOnlyWhenFocus:fe(new n(ve.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(616,null)})),renderValidationDecorations:fe(new S(ve.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:fe(new S(ve.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(617,null),s.localize(618,null),s.localize(619,null),""],description:s.localize(620,null)})),revealHorizontalRightPadding:fe(new o(ve.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:fe(new n(ve.roundedSelection,"roundedSelection",!0,{description:s.localize(621,null)})),rulers:fe(new ze),scrollbar:fe(new H),scrollBeyondLastColumn:fe(new o(ve.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(622,null)})),scrollBeyondLastLine:fe(new n(ve.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(623,null)})),scrollPredominantAxis:fe(new n(ve.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(624,null)})),selectionClipboard:fe(new n(ve.selectionClipboard,"selectionClipboard",!0,{description:s.localize(625,null),included:C.$l})),selectionHighlight:fe(new n(ve.selectionHighlight,"selectionHighlight",!0,{description:s.localize(626,null)})),selectOnLineNumbers:fe(new n(ve.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:fe(new S(ve.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(627,null),s.localize(628,null),s.localize(629,null)],description:s.localize(630,null)})),showUnused:fe(new n(ve.showUnused,"showUnused",!0,{description:s.localize(631,null)})),showDeprecated:fe(new n(ve.showDeprecated,"showDeprecated",!0,{description:s.localize(632,null)})),inlayHints:fe(new ee),snippetSuggestions:fe(new S(ve.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(633,null),s.localize(634,null),s.localize(635,null),s.localize(636,null)],description:s.localize(637,null)})),smartSelect:fe(new st),smoothScrolling:fe(new n(ve.smoothScrolling,"smoothScrolling",!1,{description:s.localize(638,null)})),stopRenderingLineAfter:fe(new o(ve.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:fe(new rt),inlineSuggest:fe(new re),inlineEdit:fe(new ge),inlineCompletionsAccessibilityVerbose:fe(new n(ve.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(639,null)})),suggestFontSize:fe(new o(ve.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(640,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:fe(new o(ve.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(641,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:fe(new n(ve.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(642,null)})),suggestSelection:fe(new S(ve.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(643,null),s.localize(644,null),s.localize(645,null)],description:s.localize(646,null)})),tabCompletion:fe(new S(ve.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(647,null),s.localize(648,null),s.localize(649,null)],description:s.localize(650,null)})),tabIndex:fe(new o(ve.tabIndex,"tabIndex",0,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:fe(new J),unusualLineTerminators:fe(new S(ve.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(651,null),s.localize(652,null),s.localize(653,null)],description:s.localize(654,null)})),useShadowDOM:fe(new n(ve.useShadowDOM,"useShadowDOM",!0)),useTabStops:fe(new n(ve.useTabStops,"useTabStops",!0,{description:s.localize(655,null)})),wordBreak:fe(new S(ve.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(656,null),s.localize(657,null)],description:s.localize(658,null)})),wordSegmenterLocales:fe(new ut),wordSeparators:fe(new g(ve.wordSeparators,"wordSeparators",p.$rt,{description:s.localize(659,null)})),wordWrap:fe(new S(ve.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(660,null),s.localize(661,null),s.localize(662,null),s.localize(663,null)],description:s.localize(664,null)})),wordWrapBreakAfterCharacters:fe(new g(ve.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:fe(new g(ve.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:fe(new o(ve.wordWrapColumn,"wordWrapColumn",80,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(665,null)})),wordWrapOverride1:fe(new S(ve.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:fe(new S(ve.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:fe(new Z),defaultColorDecorators:fe(new n(ve.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(666,null)})),pixelRatio:fe(new Ve),tabFocusMode:fe(new n(ve.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(667,null)})),layoutInfo:fe(new te),wrappingInfo:fe(new vt),wrappingIndent:fe(new lt),wrappingStrategy:fe(new we)}}),define(Oe[107],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,y.$Ii)("environmentService"),e.$Qi=(0,y.$Ji)(e.$Pi)}),define(Oe[29],Ae([1,0,49,20,12,14,2,9,3,21,15,48]),function($e,e,y,D,C,N,T,O,p,s,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=h,e.$fl=a,e.$gl=u,e.$hl=i,e.$il=n,e.$jl=t,e.$kl=o,e.$ll=l,e.$ml=m,e.$nl=g,e.$ol=d,e.$ql=w,e.$rl=P,e.$sl=R,e.$tl=$,e.$ul=b,e.$xl=G,e.$Jl=x,e.$Kl=oe,e.$Ml=ce,e.$dl=(0,p.$Ii)("fileService");function h(te){return te.create===!0}var E;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var f;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var r;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function a(te){const we=te;return!!we&&typeof we.onDidChange=="function"}var c;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function u(te){return!!(te.capabilities&c.FileReadWrite)}function i(te){return!!(te.capabilities&c.FileFolderCopy)}function n(te){return!!(te.capabilities&c.FileClone)}function t(te){return!!(te.capabilities&c.FileOpenReadWriteClose)}function o(te){return!!(te.capabilities&c.FileReadStream)}function l(te){return u(te)?!!(te.capabilities&c.FileAtomicRead):!1}function m(te){return u(te)?!!(te.capabilities&c.FileAtomicWrite):!1}function g(te){return!!(te.capabilities&c.FileAtomicDelete)}function d(te){return!!(te.capabilities&c.Readonly)}var S;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class k extends Error{static create(we,Ce){const Y=new k(we.toString(),Ce);return R(Y,Ce),Y}constructor(we,Ce){super(we),this.code=Ce}}e.$pl=k;function w(te,we){return k.create(te,we)}function P(te){return te||w((0,O.localize)(1863,null),S.Unknown)}function R(te,we){return te.name=we?`${we} (FileSystemError)`:"FileSystemError",te}function $(te){if(!te)return S.Unknown;if(te instanceof k)return te.code;const we=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!we)return S.Unknown;switch(we[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function b(te){if(te instanceof U)return te.fileOperationResult;switch($(te)){case S.FileNotFound:return ne.FILE_NOT_FOUND;case S.FileIsADirectory:return ne.FILE_IS_DIRECTORY;case S.FileNotADirectory:return ne.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return ne.FILE_WRITE_LOCKED;case S.NoPermissions:return ne.FILE_PERMISSION_DENIED;case S.FileExists:return ne.FILE_MOVE_CONFLICT;case S.FileTooLarge:return ne.FILE_TOO_LARGE;default:return ne.FILE_OTHER_ERROR}}var L;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class A{constructor(we,Ce,Y){this.resource=we,this.operation=Ce,this.target=Y}isOperation(we){return this.operation===we}}e.$vl=A;var M;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class Z{static{this.a=null}constructor(we,Ce){this.c=Ce,this.b=void 0,this.d=new v.$W(()=>{const Y=y.$Oi.forUris(()=>this.c);return Y.fill(this.rawAdded.map(W=>[W,!0])),Y}),this.f=new v.$W(()=>{const Y=y.$Oi.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(W=>[W,!0])),Y}),this.g=new v.$W(()=>{const Y=y.$Oi.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(W=>[W,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of we){switch(Y.type){case M.ADDED:this.rawAdded.push(Y.resource);break;case M.UPDATED:this.rawUpdated.push(Y.resource);break;case M.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==Z.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=Z.a):this.b!==void 0&&(this.b=Z.a))}}contains(we,...Ce){return this.h(we,{includeChildren:!1},...Ce)}affects(we,...Ce){return this.h(we,{includeChildren:!0},...Ce)}h(we,Ce,...Y){if(!we)return!1;const W=Y.length>0;return!!((!W||Y.includes(M.ADDED))&&(this.d.value.get(we)||Ce.includeChildren&&this.d.value.findSuperstr(we))||(!W||Y.includes(M.UPDATED))&&(this.f.value.get(we)||Ce.includeChildren&&this.f.value.findSuperstr(we))||(!W||Y.includes(M.DELETED))&&(this.g.value.findSubstr(we)||Ce.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$wl=Z;function G(te,we,Ce){return!te||!we||te===we||we.length>te.length?!1:(we.charAt(we.length-1)!==D.sep&&(we+=D.sep),Ce?(0,C.$Jf)(te,we):te.indexOf(we)===0)}class U extends Error{constructor(we,Ce,Y){super(we),this.fileOperationResult=Ce,this.options=Y}}e.$yl=U;class V extends U{constructor(we,Ce,Y,W){super(we,Ce,W),this.fileOperationResult=Ce,this.size=Y}}e.$zl=V;class Q extends U{constructor(we,Ce,Y){super(we,ne.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Ce}}e.$Al=Q;var ne;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var ue;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Il="";function x(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function oe(te,we){if(!we.hasProvider(T.URI.from({scheme:te.scheme})))return new Promise(Ce=>{const Y=we.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===te.scheme&&W.added&&(Y.dispose(),Ce())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(we){return(0,N.$lg)(we)||(we=0),we<se.KB?(0,O.localize)(1864,null,we.toFixed(0)):we<se.MB?(0,O.localize)(1865,null,(we/se.KB).toFixed(2)):we<se.GB?(0,O.localize)(1866,null,(we/se.MB).toFixed(2)):we<se.TB?(0,O.localize)(1867,null,(we/se.GB).toFixed(2)):(0,O.localize)(1868,null,(we/se.TB).toFixed(2))}}e.$Ll=se;function ce(te){const we=typeof te=="string"||te?.scheme===I.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===I.Schemas.file?1024*se.MB:we?10*se.MB:s.$p?50*se.MB:1024*se.MB}}),define(Oe[75],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class y{constructor(...C){this.a=new Map;for(const[N,T]of C)this.set(N,T)}set(C,N){const T=this.a.get(C);return this.a.set(C,N),T}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Gi=y}),define(Oe[171],Ae([1,0,10,13,4,74,168,3,75,172]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0;const I=!1;class v extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class h{constructor(a=new p.$Gi,c=!1,u,i=I){this.i=a,this.j=c,this.k=u,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Hi,this),this._globalGraph=i?u?._globalGraph??new T.$Ar(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Sc)(this.h),this.h.clear();for(const a of this.g)(0,C.$Rc)(a)&&a.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(a,c){this.m();const u=this,i=new class extends h{dispose(){u.h.delete(i),super.dispose()}}(a,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(a,...c){this.m();const u=f.traceInvocation(this.l,a);let i=!1;try{return a({get:t=>{if(i)throw(0,D.$0)("service accessor is only valid during the invocation of its target method");const o=this.s(t,u);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...c)}finally{i=!0,u.stop()}}createInstance(a,...c){this.m();let u,i;return a instanceof N.$Fi?(u=f.traceCreation(this.l,a.ctor),i=this.o(a.ctor,a.staticArguments.concat(c),u)):(u=f.traceCreation(this.l,a),i=this.o(a,c,u)),u.stop(),i}o(a,c=[],u){const i=O._util.getServiceDependencies(a).sort((o,l)=>o.index-l.index),n=[];for(const o of i){const l=this.s(o.id,u);l||this.y(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`,!1),n.push(l)}const t=i.length>0?i[0].index:c.length;if(c.length!==t){console.trace(`[createInstance] First service dependency of ${a.name} at position ${t+1} conflicts with ${c.length} static arguments`);const o=t-c.length;o>0?c=c.concat(new Array(o)):c=c.slice(0,t)}return Reflect.construct(a,c.concat(n))}q(a,c){if(this.i.get(a)instanceof N.$Fi)this.i.set(a,c);else if(this.k)this.k.q(a,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(a){const c=this.i.get(a);return!c&&this.k?this.k.r(a):c}s(a,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const u=this.r(a);return u instanceof N.$Fi?this.u(a,u,c.branch(a,!0)):(c.branch(a,!1),u)}u(a,c,u){if(this.t.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.t.add(a);try{return this.v(a,c,u)}finally{this.t.delete(a)}}v(a,c,u){const i=new T.$Ar(l=>l.id.toString());let n=0;const t=[{id:a,desc:c,_trace:u}],o=new Set;for(;t.length;){const l=t.pop();if(!o.has(String(l.id))){if(o.add(String(l.id)),i.lookupOrInsertNode(l),n++>1e3)throw new v(i);for(const m of O._util.getServiceDependencies(l.desc.ctor)){const g=this.r(m.id);if(g||this.y(`[createInstance] ${a} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(m.id)),g instanceof N.$Fi){const d={id:m.id,desc:g,_trace:l._trace.branch(m.id,!0)};i.insertEdge(l,d),t.push(d)}}}}for(;;){const l=i.roots();if(l.length===0){if(!i.isEmpty())throw new v(i);break}for(const{data:m}of l){if(this.r(m.id)instanceof N.$Fi){const d=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,d)}i.removeNode(m)}}return this.r(a)}w(a,c,u=[],i,n){if(this.i.get(a)instanceof N.$Fi)return this.x(a,c,u,i,n,this.g);if(this.k)return this.k.w(a,c,u,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(a,c,u=[],i,n,t){if(i){const o=new h(void 0,this.j,this,this.l);o.c=String(a);const l=new Map,m=new y.$2h(()=>{const g=o.o(c,u,n);for(const[d,S]of l){const k=g[d];if(typeof k=="function")for(const w of S)w.disposable=k.apply(g,w.listener)}return l.clear(),t.add(g),g});return new Proxy(Object.create(null),{get(g,d){if(!m.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let w=l.get(d);return w||(w=new s.$8c,l.set(d,w)),(R,$,b)=>{if(m.isInitialized)return m.value[d](R,$,b);{const L={listener:[R,$,b],disposable:void 0},A=w.push(L);return(0,C.$Vc)(()=>{A(),L.disposable?.dispose()})}}}if(d in g)return g[d];const S=m.value;let k=S[d];return typeof k!="function"||(k=k.bind(S),g[d]=k),k},set(g,d,S){return m.value[d]=S,!0},getPrototypeOf(g){return c.prototype}})}else{const o=this.o(c,u,n);return t.add(o),o}}y(a,c){if(c&&console.warn(a),this.j)throw new Error(a)}}e.$Br=h;var E;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(E||(E={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(a,c){return a?new f(E.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(a,c){return a?new f(E.Creation,c.name):f.c}static{this.f=0}constructor(a,c){this.type=a,this.name=c,this.g=Date.now(),this.h=[]}branch(a,c){const u=new f(E.Branch,a.toString());return this.h.push([a,c,u]),u}stop(){const a=Date.now()-this.g;f.f+=a;let c=!1;function u(n,t){const o=[],l=new Array(n+1).join("	");for(const[m,g,d]of t.h)if(g&&d){c=!0,o.push(`${l}CREATES -> ${m}`);const S=u(n+1,d);S&&o.push(S)}else o.push(`${l}uses -> ${m}`);return o.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(a>2||c)&&f.all.add(i.join(`
`))}}e.$Cr=f}),define(Oe[11],Ae([1,0,9,42,6,76,4,28,21,23,14,2,31,3]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=r,e.log=c,e.$rk=k,e.$sk=w,e.$tk=P,e.$uk=R,y=He(y),e.$dk=(0,E.$Ii)("logService"),e.$ek=(0,E.$Ii)("loggerService");function f(){return new Date().toISOString()}function r($){return(0,I.$lg)($)}var a;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$gk=a.Info;function c($,b,L){switch(b){case a.Trace:$.trace(L);break;case a.Debug:$.debug(L);break;case a.Info:$.info(L);break;case a.Warning:$.warn(L);break;case a.Error:$.error(L);break;case a.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function u($,b=!1){let L="";for(let A=0;A<$.length;A++){let M=$[A];if(M instanceof Error&&(M=(0,D.$tj)(M,b)),typeof M=="object")try{M=JSON.stringify(M)}catch{}L+=(A>0?" ":"")+M}return L}class i extends T.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new C.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==a.Off&&this.b<=b}}e.$ik=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...L){this.f(a.Trace)&&this.g(a.Trace,u([b,...L],!0))}debug(b,...L){this.f(a.Debug)&&this.g(a.Debug,u([b,...L]))}info(b,...L){this.f(a.Info)&&this.g(a.Info,u([b,...L]))}warn(b,...L){this.f(a.Warning)&&this.g(a.Warning,u([b,...L]))}error(b,...L){if(this.f(a.Error))if(b instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=b.stack,this.g(a.Error,u(A))}else this.g(a.Error,u([b,...L]))}flush(){}}e.$jk=n;class t extends i{constructor(b=e.$gk){super(),this.setLevel(b),this.g=!p.$j}trace(b,...L){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...L):console.log(`[main ${f()}]`,b,...L))}debug(b,...L){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...L):console.log(`[main ${f()}]`,b,...L))}info(b,...L){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...L):console.log(`[main ${f()}]`,b,...L))}warn(b,...L){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,b,...L):console.warn(`[main ${f()}]`,b,...L))}error(b,...L){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,b,...L):console.error(`[main ${f()}]`,b,...L))}flush(){}}e.$kk=t;class o extends i{constructor(b=e.$gk,L=!0){super(),this.g=L,this.setLevel(b)}trace(b,...L){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...L):console.log(b,...L))}debug(b,...L){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...L):console.log(b,...L))}info(b,...L){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...L):console.log(b,...L))}warn(b,...L){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...L):console.log(b,...L))}error(b,...L){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...L):console.error(b,...L))}flush(){}}e.$lk=o;class l extends i{constructor(b,L=e.$gk){super(),this.g=b,this.setLevel(L)}trace(b,...L){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(b),...L])}debug(b,...L){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(b),...L])}info(b,...L){this.f(a.Info)&&this.g.log(a.Info,[this.h(b),...L])}warn(b,...L){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(b),...L])}error(b,...L){this.f(a.Error)&&this.g.log(a.Error,[this.h(b),...L])}h(b){return typeof b=="string"?b:(0,D.$tj)(b,this.f(a.Trace))}flush(){}}e.$mk=l;class m extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const L of this.g)L.setLevel(b);super.setLevel(b)}trace(b,...L){for(const A of this.g)A.trace(b,...L)}debug(b,...L){for(const A of this.g)A.debug(b,...L)}info(b,...L){for(const A of this.g)A.info(b,...L)}warn(b,...L){for(const A of this.g)A.warn(b,...L)}error(b,...L){for(const A of this.g)A.error(b,...L)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$nk=m;class g extends T.$Xc{constructor(b,L,A){if(super(),this.h=b,this.j=L,this.b=new O.$Dc,this.c=this.B(new C.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$oe),this.onDidChangeVisibility=this.g.event,A)for(const M of A)this.b.set(M.resource,{logger:void 0,info:M})}m(b){return(0,I.$hg)(b)?[...this.b.values()].find(L=>L.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,L){const A=this.n(b),M=(0,I.$hg)(b)?b:L?.id??(0,N.$wj)(A.toString()).toString(16);let Z=this.b.get(A)?.logger;const G=L?.logLevel==="always"?a.Trace:L?.logLevel;Z||(Z=this.s(A,G??this.getLogLevel(A)??this.h,{...L,id:M}));const U={logger:Z,info:{resource:A,id:M,logLevel:G,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(U.info),this.b.set(A,U),Z}n(b){return(0,I.$hg)(b)?(0,s.$jh)(this.j,`${b}.log`):b}setLogLevel(b,L){if(v.URI.isUri(b)){const A=b,M=L,Z=this.b.get(A);Z&&M!==Z.info.logLevel&&(Z.info.logLevel=M===this.h?void 0:M,Z.logger?.setLevel(M),this.b.set(Z.info.resource,Z),this.f.fire([A,M]))}else{this.h=b;for(const[A,M]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,L){const A=this.m(b);A&&L!==!A.info.hidden&&(A.info.hidden=!L,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,L]))}getLogLevel(b){let L;return b&&(L=this.b.get(b)?.info.logLevel),L??this.h}registerLogger(b){const L=this.b.get(b.resource);L?L.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const L=this.b.get(b);L&&(L.logger&&L.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=g;class d{constructor(){this.onDidChangeLogLevel=new C.$oe().event}setLevel(b){}getLevel(){return a.Info}trace(b,...L){}debug(b,...L){}info(b,...L){}warn(b,...L){}error(b,...L){}critical(b,...L){}dispose(){}flush(){}}e.$pk=d;class S extends d{}e.$qk=S;function k($){if($.verbose)return a.Trace;if(typeof $.logLevel=="string"){const b=R($.logLevel.toLowerCase());if(b!==void 0)return b}return e.$gk}function w($){switch($){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}function P($){switch($){case a.Trace:return{original:"Trace",value:y.localize(1957,null)};case a.Debug:return{original:"Debug",value:y.localize(1958,null)};case a.Info:return{original:"Info",value:y.localize(1959,null)};case a.Warning:return{original:"Warning",value:y.localize(1960,null)};case a.Error:return{original:"Error",value:y.localize(1961,null)};case a.Off:return{original:"Off",value:y.localize(1962,null)}}}function R($){switch($){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$vk=new h.$Zj("logLevel",w(a.Info))}),define(Oe[173],Ae([1,0,4,11]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class C extends y.$Xc{constructor(T,O=[]){super(),this.a=new D.$nk([T,...O]),this.B(T.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...O){this.a.trace(T,...O)}debug(T,...O){this.a.debug(T,...O)}info(T,...O){this.a.info(T,...O)}warn(T,...O){this.a.warn(T,...O)}error(T,...O){this.a.error(T,...O)}flush(){this.a.flush()}}e.$4R=C});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Oe[108],Ae([1,0,36,9,3]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,y=si(y);var N;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var T;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(p){function s(f,r){return r-f}p.compare=s;const I=Object.create(null);I[p.Error]=(0,D.localize)(1963,null),I[p.Warning]=(0,D.localize)(1964,null),I[p.Info]=(0,D.localize)(1965,null);function v(f){return I[f]||""}p.toString=v;function h(f){switch(f){case y.default.Error:return p.Error;case y.default.Warning:return p.Warning;case y.default.Info:return p.Info;case y.default.Ignore:return p.Hint}}p.fromSeverity=h;function E(f){switch(f){case p.Error:return y.default.Error;case p.Warning:return y.default.Warning;case p.Info:return y.default.Info;case p.Hint:return y.default.Ignore}}p.toSeverity=E}(T||(e.MarkerSeverity=T={}));var O;(function(p){const s="";function I(h){return v(h,!0)}p.makeKey=I;function v(h,E){const f=[s];return h.source?f.push(h.source.replace("\xA6","\\\xA6")):f.push(s),h.code?typeof h.code=="string"?f.push(h.code.replace("\xA6","\\\xA6")):f.push(h.code.value.replace("\xA6","\\\xA6")):f.push(s),h.severity!==void 0&&h.severity!==null?f.push(T.toString(h.severity)):f.push(s),h.message&&E?f.push(h.message.replace("\xA6","\\\xA6")):f.push(s),h.startLineNumber!==void 0&&h.startLineNumber!==null?f.push(h.startLineNumber.toString()):f.push(s),h.startColumn!==void 0&&h.startColumn!==null?f.push(h.startColumn.toString()):f.push(s),h.endLineNumber!==void 0&&h.endLineNumber!==null?f.push(h.endLineNumber.toString()):f.push(s),h.endColumn!==void 0&&h.endColumn!==null?f.push(h.endColumn.toString()):f.push(s),f.push(s),f.join("\xA6")}p.makeKeyOptionalMessage=v})(O||(e.IMarkerData=O={})),e.$Lu=(0,C.$Ii)("markerService")});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Oe[174],Ae([1,0,6,36,3]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$zw=e.Severity=void 0,e.$Aw=O,D=si(D),e.Severity=D.default,e.$zw=(0,C.$Ii)("notificationService");var N;(function(v){v[v.DEFAULT=0]="DEFAULT",v[v.SILENT=1]="SILENT",v[v.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var T;(function(v){v[v.WORKSPACE=0]="WORKSPACE",v[v.PROFILE=1]="PROFILE",v[v.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function O(v){if(v){const h=v;return typeof h.id=="string"&&typeof h.label=="string"}return!1}var p;(function(v){v[v.OFF=0]="OFF",v[v.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class s{constructor(){this.progress=new I,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(h){}updateMessage(h){}updateActions(h){}close(){}}e.$Bw=s;class I{infinite(){}done(){}total(h){}worked(h){}}e.$Cw=I}),define(Oe[109],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,y.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"});var Xe=this&&this.__decorate||function($e,e,y,D){var C=arguments.length,N=C<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,y):D,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate($e,e,y,D);else for(var O=$e.length-1;O>=0;O--)(T=$e[O])&&(N=(C<3?T(N):C>3?T(e,y,N):T(e,y))||N);return C>3&&N&&Object.defineProperty(e,y,N),N},Qe=this&&this.__param||function($e,e){return function(y,D){e(y,D,$e)}};define(Oe[77],Ae([1,0,10,19,4,3]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jw=e.$Iw=e.$Hw=e.$Gw=e.$Fw=e.$Ew=e.ProgressLocation=e.$Dw=void 0,e.$Dw=(0,N.$Ii)("progressService");var T;(function(v){v[v.Explorer=1]="Explorer",v[v.Scm=3]="Scm",v[v.Extensions=5]="Extensions",v[v.Window=10]="Window",v[v.Notification=15]="Notification",v[v.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$Ew=Object.freeze({total(){},worked(){},done(){}});class O{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(h){this.b=h}report(h){this.a=h,this.b(this.a)}}e.$Fw=O;class p{get value(){return this.a}constructor(h){this.e=h}report(h){this.b?this.b.push(h):this.b=[h],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const h=this.b.shift();this.a=h,await this.e(this.a)}}finally{this.c=!1;const h=this.d;this.d=void 0,h?.()}}drain(){return this.c?new Promise(h=>{const E=this.d;this.d=()=>{E?.(),h()}}):Promise.resolve()}}e.$Gw=p;let s=class extends C.$Xc{constructor(h,E){super(),this.a=new y.$6h,E.withProgress(h,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,C.$Vc)(()=>this.a.complete()))}report(h){this.b?this.b.report(h):this.c=h}};e.$Hw=s,e.$Hw=s=Xe([Qe(1,e.$Dw)],s);class I extends C.$Xc{constructor(h){super(),this.g=h,this.a=0,this.b=this.B(new C.$Wc)}start(h){this.stop();const E=++this.a,f=new D.$ze;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},h),this.b.add((0,C.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Vc)(()=>f.cancel())),this.b.add((0,C.$Vc)(()=>this.c?this.c.done():void 0)),{id:E,token:f.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(h){this.a===h&&this.b.clear()}}e.$Iw=I,e.$Jw=(0,N.$Ii)("editorProgressService")}),define(Oe[30],Ae([1,0,62,14]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=void 0,y=He(y),D=He(D);class C{constructor(){this.a=new Map}add(T,O){y.ok(D.$hg(T)),y.ok(D.$jg(O)),y.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,O)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$uo=new C}),define(Oe[78],Ae([1,0,6,138,30]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,C=He(C),e.$vo={JSONContribution:"base.contributions.json"};function N(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this.b=new y.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,I){this.a[N(s)]=I,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const I=this.a[s];return I?(0,D.$$j)(I):void 0}hasSchemaContent(s){return!!this.a[s]}}const O=new T;C.$uo.add(e.$vo.JSONContribution,O)}),define(Oe[54],Ae([1,0,17,6,14,9,43,78,30]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ConfigurationScope=e.$zo=e.EditPresentationTypes=void 0,e.$Ko=r,e.$Lo=a,e.$Mo=c,e.$No=i,e.$Oo=n,e.$Po=t,e.$Qo=o,C=He(C),N=He(N);var s;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$zo={Configuration:"base.contributions.configuration"};var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go="vscode://schemas/settings/resourceLanguage",e.$Ho="vscode://schemas/settings/configurationDefaults";const v=p.$uo.as(O.$vo.JSONContribution);class h{constructor(){this.a=[],this.i=new Set,this.j=new D.$oe,this.onDidSchemaChange=this.j.event,this.k=new D.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:N.localize(1660,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},v.registerSchema(e.$Go,this.h),this.z()}registerConfiguration(m,g=!0){this.registerConfigurations([m],g)}registerConfigurations(m,g=!0){const d=new Set;this.r(m,g,d),v.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:d})}deregisterConfigurations(m){const g=new Set;this.s(m,g),v.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:g})}updateConfigurations({add:m,remove:g}){const d=new Set;this.s(g,d),this.r(m,!1,d),v.registerSchema(e.$Go,this.h),this.j.fire(),this.k.fire({properties:d})}registerDefaultConfigurations(m){const g=new Set;this.l(m,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:!0})}l(m,g){this.a.push(...m);const d=[];for(const{overrides:S,source:k}of m)for(const w in S){g.add(w);const P=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),R=S[w];if(P.configurationDefaultOverrides.push({value:R,source:k}),e.$Jo.test(w)){const $=this.o(w,R,k,P.configurationDefaultOverrideValue);if(!$)continue;P.configurationDefaultOverrideValue=$,this.n(w,$,k),d.push(...r(w))}else{const $=this.p(w,R,k,P.configurationDefaultOverrideValue);if(!$)continue;P.configurationDefaultOverrideValue=$;const b=this.e[w];b&&(this.A(w,b),this.w(w,b))}}this.q(d)}deregisterDefaultConfigurations(m){const g=new Set;this.m(m,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:!0})}m(m,g){for(const d of m){const S=this.a.indexOf(d);S!==-1&&this.a.splice(S,1)}for(const{overrides:d,source:S}of m)for(const k in d){const w=this.b.get(k);if(!w)continue;const P=w.configurationDefaultOverrides.findIndex(R=>S?R.source?.id===S.id:R.value===d[k]);if(P!==-1){if(w.configurationDefaultOverrides.splice(P,1),w.configurationDefaultOverrides.length===0&&this.b.delete(k),e.$Jo.test(k)){let R;for(const $ of w.configurationDefaultOverrides)R=this.o(k,$.value,$.source,R);R&&!C.$ug(R.value)?(w.configurationDefaultOverrideValue=R,this.n(k,R,S)):(this.b.delete(k),delete this.e[k],delete this.c.properties[k])}else{let R;for(const b of w.configurationDefaultOverrides)R=this.p(k,b.value,b.source,R);w.configurationDefaultOverrideValue=R;const $=this.e[k];$&&(this.A(k,$),this.w(k,$))}g.add(k)}}this.y()}n(m,g,d){const S={type:"object",default:g.value,description:N.localize(1661,null,(0,T.$mj)(m)),$ref:e.$Go,defaultDefaultValue:g.value,source:d,defaultValueSource:d};this.e[m]=S,this.c.properties[m]=S}o(m,g,d,S){const k=S?.value||{},w=S?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const P of Object.keys(g)){const R=g[P];if(C.$jg(R)&&(C.$og(k[P])||C.$jg(k[P]))){if(k[P]={...k[P]??{},...R},d)for(const b in R)w.set(`${P}.${b}`,d)}else k[P]=R,d?w.set(P,d):w.delete(P)}return{value:k,source:w}}p(m,g,d,S){const k=this.e[m],w=S?.value??k?.defaultDefaultValue;let P=d;if(C.$jg(g)&&(k!==void 0&&k.type==="object"||k===void 0&&(C.$og(w)||C.$jg(w)))){if(P=S?.source??new Map,!(P instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const $ in g)d&&P.set(`${m}.${$}`,d);g={...C.$jg(w)?w:{},...g}}return{value:g,source:P}}deltaConfiguration(m){let g=!1;const d=new Set;m.removedDefaults&&(this.m(m.removedDefaults,d),g=!0),m.addedDefaults&&(this.l(m.addedDefaults,d),g=!0),m.removedConfigurations&&this.s(m.removedConfigurations,d),m.addedConfigurations&&this.r(m.addedConfigurations,!1,d),this.j.fire(),this.k.fire({properties:d,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...m){this.j.fire()}registerOverrideIdentifiers(m){this.q(m),this.j.fire()}q(m){for(const g of m)this.i.add(g);this.y()}r(m,g,d){m.forEach(S=>{this.u(S,g,S.extensionInfo,S.restrictedProperties,void 0,d),this.d.push(S),this.v(S)})}s(m,g){const d=S=>{if(S.properties)for(const k in S.properties){g.add(k);const w=this.e[k];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[k],this.x(k,S.properties[k])}S.allOf?.forEach(k=>d(k))};for(const S of m){d(S);const k=this.d.indexOf(S);k!==-1&&this.d.splice(k,1)}}u(m,g=!0,d,S,k=I.WINDOW,w){k=C.$qg(m.scope)?k:m.scope;const P=m.properties;if(P)for(const $ in P){const b=P[$];if(g&&i($,b)){delete P[$];continue}if(b.source=d,b.defaultDefaultValue=P[$].default,this.A($,b),e.$Jo.test($)?b.scope=void 0:(b.scope=C.$qg(b.scope)?k:b.scope,b.restricted=C.$qg(b.restricted)?!!S?.includes($):b.restricted),P[$].hasOwnProperty("included")&&!P[$].included){this.g[$]=P[$],delete P[$];continue}else this.e[$]=P[$],P[$].policy?.name&&this.f.set(P[$].policy.name,$);!P[$].deprecationMessage&&P[$].markdownDeprecationMessage&&(P[$].deprecationMessage=P[$].markdownDeprecationMessage),w.add($)}const R=m.allOf;if(R)for(const $ of R)this.u($,g,d,S,k,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const m=new Map;for(const[g,d]of this.b)d.configurationDefaultOverrideValue&&m.set(g,d.configurationDefaultOverrideValue);return m}v(m){const g=d=>{const S=d.properties;if(S)for(const w in S)this.w(w,S[w]);d.allOf?.forEach(g)};g(m)}w(m,g){switch(e.$Ao.properties[m]=g,g.scope){case I.APPLICATION:e.$Bo.properties[m]=g;break;case I.MACHINE:e.$Co.properties[m]=g;break;case I.MACHINE_OVERRIDABLE:e.$Do.properties[m]=g;break;case I.WINDOW:e.$Eo.properties[m]=g;break;case I.RESOURCE:e.$Fo.properties[m]=g;break;case I.LANGUAGE_OVERRIDABLE:e.$Fo.properties[m]=g,this.h.properties[m]=g;break}}x(m,g){switch(delete e.$Ao.properties[m],g.scope){case I.APPLICATION:delete e.$Bo.properties[m];break;case I.MACHINE:delete e.$Co.properties[m];break;case I.MACHINE_OVERRIDABLE:delete e.$Do.properties[m];break;case I.WINDOW:delete e.$Eo.properties[m];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Fo.properties[m],delete this.h.properties[m];break}}y(){for(const m of this.i.values()){const g=`[${m}]`,d={type:"object",description:N.localize(1662,null),errorMessage:N.localize(1663,null),$ref:e.$Go};this.A(g,d),e.$Ao.properties[g]=d,e.$Bo.properties[g]=d,e.$Co.properties[g]=d,e.$Do.properties[g]=d,e.$Eo.properties[g]=d,e.$Fo.properties[g]=d}}z(){const m={type:"object",description:N.localize(1664,null),errorMessage:N.localize(1665,null),$ref:e.$Go};e.$Ao.patternProperties[e.$Io]=m,e.$Bo.patternProperties[e.$Io]=m,e.$Co.patternProperties[e.$Io]=m,e.$Do.patternProperties[e.$Io]=m,e.$Eo.patternProperties[e.$Io]=m,e.$Fo.patternProperties[e.$Io]=m,this.j.fire()}A(m,g){const d=this.b.get(m)?.configurationDefaultOverrideValue;let S,k;d&&(!g.disallowConfigurationDefault||!d.source)&&(S=d.value,k=d.source),C.$og(S)&&(S=g.defaultDefaultValue,k=void 0),C.$og(S)&&(S=c(g.type)),g.default=S,g.defaultValueSource=k}}const E="\\[([^\\]]+)\\]",f=new RegExp(E,"g");e.$Io=`^(${E})+$`,e.$Jo=new RegExp(e.$Io);function r(l){const m=[];if(e.$Jo.test(l)){let g=f.exec(l);for(;g?.length;){const d=g[1].trim();d&&m.push(d),g=f.exec(l)}}return(0,y.$Ob)(m)}function a(l){return l.reduce((m,g)=>`${m}[${g}]`,"")}function c(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new h;p.$uo.add(e.$zo.Configuration,u);function i(l,m){return l.trim()?e.$Jo.test(l)?N.localize(1667,null,l):u.getConfigurationProperties()[l]!==void 0?N.localize(1668,null,l):m.policy?.name&&u.getPolicyConfigurations().get(m.policy?.name)!==void 0?N.localize(1669,null,l,m.policy?.name,u.getPolicyConfigurations().get(m.policy?.name)):null:N.localize(1666,null)}function n(){const l=[],m=u.getConfigurationProperties();for(const g of Object.keys(m))l.push([g,m[g].scope]);return l.push(["launch",I.RESOURCE]),l.push(["task",I.RESOURCE]),l}function t(l){const m={};for(const g of l){const d=g.properties;if(C.$jg(d))for(const S in d)m[S]=d[S];g.allOf&&Object.assign(m,t(g.allOf))}return m}function o(l){switch(l){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Oe[175],Ae([1,0,17,6,137,4,28,25,14,2,43,54,29,30]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Uo=e.$To=e.$So=e.$Ro=void 0,e.$Vo=n,y=He(y),C=He(C),O=He(O),p=He(p);function f(m){return Object.isFrozen(m)?m:O.$io(m)}class r{static createEmptyModel(g){return new r({},[],[],void 0,g)}constructor(g,d,S,k,w){this.b=g,this.c=d,this.d=S,this.raw=k,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const g=this.raw.map(d=>{if(d instanceof r)return d;const S=new a("",this.f);return S.parseRaw(d),S.configurationModel});this.g=g.reduce((d,S)=>S===d?S:d.merge(S),g[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(g){return g?(0,I.$kj)(this.contents,g):this.contents}inspect(g,d){const S=this;return{get value(){return f(S.rawConfiguration.getValue(g))},get override(){return d?f(S.rawConfiguration.getOverrideValue(g,d)):void 0},get merged(){return f(d?S.rawConfiguration.override(d).getValue(g):S.rawConfiguration.getValue(g))},get overrides(){const k=[];for(const{contents:w,identifiers:P,keys:R}of S.rawConfiguration.overrides){const $=new r(w,R,[],void 0,S.f).getValue(g);$!==void 0&&k.push({identifiers:P,value:$})}return k.length?f(k):void 0}}}getOverrideValue(g,d){const S=this.j(d);return S?g?(0,I.$kj)(S,g):S:void 0}getKeysForOverrideIdentifier(g){const d=[];for(const S of this.overrides)S.identifiers.includes(g)&&d.push(...S.keys);return y.$Ob(d)}getAllOverrideIdentifiers(){const g=[];for(const d of this.overrides)g.push(...d.identifiers);return y.$Ob(g)}override(g){let d=this.a.get(g);return d||(d=this.h(g),this.a.set(g,d)),d}merge(...g){const d=O.$ho(this.contents),S=O.$ho(this.overrides),k=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const P of g)if(w.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(d,P.contents);for(const R of P.overrides){const[$]=S.filter(b=>y.$wb(b.identifiers,R.identifiers));$?(this.i($.contents,R.contents),$.keys.push(...R.keys),$.keys=y.$Ob($.keys)):S.push(O.$ho(R))}for(const R of P.keys)k.indexOf(R)===-1&&k.push(R)}return new r(d,k,S,w.every(P=>P instanceof r)?void 0:w,this.f)}h(g){const d=this.j(g);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const S={};for(const k of y.$Ob([...Object.keys(this.contents),...Object.keys(d)])){let w=this.contents[k];const P=d[k];P&&(typeof w=="object"&&typeof P=="object"?(w=O.$ho(w),this.i(w,P)):w=P),S[k]=w}return new r(S,this.keys,this.overrides,void 0,this.f)}i(g,d){for(const S of Object.keys(d)){if(S in g&&p.$jg(g[S])&&p.$jg(d[S])){this.i(g[S],d[S]);continue}g[S]=O.$ho(d[S])}}j(g){let d=null,S=null;const k=w=>{w&&(S?this.i(S,w):S=O.$ho(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===g?d=w.contents:w.identifiers.includes(g)&&k(w.contents);return k(d),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(g,d){this.k(g,d,!0)}setValue(g,d){this.k(g,d,!1)}removeValue(g){const d=this.keys.indexOf(g);d!==-1&&(this.keys.splice(d,1),(0,I.$jj)(this.contents,g),v.$Jo.test(g)&&this.overrides.splice(this.overrides.findIndex(S=>y.$wb(S.identifiers,(0,v.$Ko)(g))),1))}k(g,d,S){if((0,I.$ij)(this.contents,g,d,k=>this.f.error(k)),S=S||this.keys.indexOf(g)===-1,S&&this.keys.push(g),v.$Jo.test(g)){const k=(0,v.$Ko)(g),w={identifiers:k,keys:Object.keys(this.contents[g]),contents:(0,I.$hj)(this.contents[g],R=>this.f.error(R))},P=this.overrides.findIndex(R=>y.$wb(R.identifiers,k));P!==-1?this.overrides[P]=w:this.overrides.push(w)}}}e.$Ro=r;class a{constructor(g,d){this.f=g,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(g,d){if(!p.$qg(g)){const S=this.h(g);this.parseRaw(S,d)}}reparse(g){this.a&&this.parseRaw(this.a,g)}parseRaw(g,d){this.a=g;const{contents:S,keys:k,overrides:w,restricted:P,hasExcludedProperties:R}=this.i(g,d);this.b=new r(S,k,w,R?[g]:void 0,this.g),this.c=P||[]}h(g){let d={},S=null,k=[];const w=[],P=[];function R(b){Array.isArray(k)?k.push(b):S!==null&&(k[S]=b)}const $={onObjectBegin:()=>{const b={};R(b),w.push(k),k=b,S=null},onObjectProperty:b=>{S=b},onObjectEnd:()=>{k=w.pop()},onArrayBegin:()=>{const b=[];R(b),w.push(k),k=b,S=null},onArrayEnd:()=>{k=w.pop()},onLiteralValue:R,onError:(b,L,A)=>{P.push({error:b,offset:L,length:A})}};if(g)try{C.$9n(g,$),d=k[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return d}i(g,d){const S=E.$uo.as(v.$zo.Configuration).getConfigurationProperties(),k=this.j(g,S,!0,d);g=k.raw;const w=(0,I.$hj)(g,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`)),P=Object.keys(g),R=this.l(g,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`));return{contents:w,keys:P,overrides:R,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(g,d,S,k){let w=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:g,restricted:[],hasExcludedProperties:w};const P={},R=[];for(const $ in g)if(v.$Jo.test($)&&S){const b=this.j(g[$],d,!1,k);P[$]=b.raw,w=w||b.hasExcludedProperties,R.push(...b.restricted)}else{const b=d[$],L=b?typeof b.scope<"u"?b.scope:v.ConfigurationScope.WINDOW:void 0;b?.restricted&&R.push($),!k.exclude?.includes($)&&(k.include?.includes($)||(L===void 0||k.scopes===void 0||k.scopes.includes(L))&&!(k.skipRestricted&&b?.restricted))?P[$]=g[$]:w=!0}return{raw:P,restricted:R,hasExcludedProperties:w}}l(g,d){const S=[];for(const k of Object.keys(g))if(v.$Jo.test(k)){const w={};for(const P in g[k])w[P]=g[k][P];S.push({identifiers:(0,v.$Ko)(k),keys:Object.keys(w),contents:(0,I.$hj)(w,d)})}return S}}e.$So=a;class c extends N.$Xc{constructor(g,d,S,k,w){super(),this.c=g,this.f=d,this.g=k,this.h=w,this.b=this.B(new D.$oe),this.onDidChange=this.b.event,this.a=new a(this.c.toString(),w),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(h.FileOperation.CREATE)||P.isOperation(h.FileOperation.COPY)||P.isOperation(h.FileOperation.DELETE)||P.isOperation(h.FileOperation.WRITE))&&S.isEqual(P.resource,g)))(()=>this.b.fire()))}async loadConfiguration(){try{const g=await this.g.readFile(this.c);return this.a.parse(g.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(g){return g&&(this.f=g),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$To=c;class u{constructor(g,d,S,k,w,P,R,$,b,L,A,M,Z){this.a=g,this.b=d,this.c=S,this.overrideIdentifiers=k,this.d=w,this.f=P,this.g=R,this.h=$,this.i=b,this.j=L,this.k=A,this.l=M,this.m=Z}get value(){return f(this.c)}n(g){return g?.value!==void 0||g?.override!==void 0||g?.overrides!==void 0?g:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(g,d,S,k,w,P,R,$,b,L){this.j=g,this.l=d,this.m=S,this.n=k,this.p=w,this.q=P,this.r=R,this.s=$,this.t=b,this.u=L,this.h=null,this.i=new T.$Dc,this.v=null}getValue(g,d,S){return this.w(g,d,S).getValue(g)}updateValue(g,d,S={}){let k;S.resource?(k=this.t.get(S.resource),k||(k=r.createEmptyModel(this.u),this.t.set(S.resource,k))):k=this.s,d===void 0?k.removeValue(g):k.setValue(g,d),S.resource||(this.h=null)}inspect(g,d,S){const k=this.w(g,d,S),w=this.A(d.resource,S),P=d.resource?this.t.get(d.resource)||this.s:this.s,R=new Set;for(const $ of k.overrides)for(const b of $.identifiers)k.getOverrideValue(g,b)!==void 0&&R.add(b);return new u(g,d,k.getValue(g),R.size?[...R]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,w||void 0,P)}keys(g){const d=this.A(void 0,g);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(g){this.j=g,this.h=null,this.i.clear()}updatePolicyConfiguration(g){this.l=g}updateApplicationConfiguration(g){this.m=g,this.h=null,this.i.clear()}updateLocalUserConfiguration(g){this.n=g,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(g){this.p=g,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(g){this.q=g,this.h=null,this.i.clear()}updateFolderConfiguration(g,d){this.r.set(g,d),this.i.delete(g)}deleteFolderConfiguration(g){this.folderConfigurations.delete(g),this.i.delete(g)}compareAndUpdateDefaultConfiguration(g,d){const S=[];if(!d){const{added:k,updated:w,removed:P}=o(this.j,g);d=[...k,...w,...P]}for(const k of d)for(const w of(0,v.$Ko)(k)){const P=this.j.getKeysForOverrideIdentifier(w),R=g.getKeysForOverrideIdentifier(w),$=[...R.filter(b=>P.indexOf(b)===-1),...P.filter(b=>R.indexOf(b)===-1),...P.filter(b=>!O.$lo(this.j.override(w).getValue(b),g.override(w).getValue(b)))];S.push([w,$])}return this.updateDefaultConfiguration(g),{keys:d,overrides:S}}compareAndUpdatePolicyConfiguration(g){const{added:d,updated:S,removed:k}=o(this.l,g),w=[...d,...S,...k];return w.length&&this.updatePolicyConfiguration(g),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(g){const{added:d,updated:S,removed:k,overrides:w}=o(this.applicationConfiguration,g),P=[...d,...S,...k];return P.length&&this.updateApplicationConfiguration(g),{keys:P,overrides:w}}compareAndUpdateLocalUserConfiguration(g){const{added:d,updated:S,removed:k,overrides:w}=o(this.localUserConfiguration,g),P=[...d,...S,...k];return P.length&&this.updateLocalUserConfiguration(g),{keys:P,overrides:w}}compareAndUpdateRemoteUserConfiguration(g){const{added:d,updated:S,removed:k,overrides:w}=o(this.remoteUserConfiguration,g),P=[...d,...S,...k];return P.length&&this.updateRemoteUserConfiguration(g),{keys:P,overrides:w}}compareAndUpdateWorkspaceConfiguration(g){const{added:d,updated:S,removed:k,overrides:w}=o(this.workspaceConfiguration,g),P=[...d,...S,...k];return P.length&&this.updateWorkspaceConfiguration(g),{keys:P,overrides:w}}compareAndUpdateFolderConfiguration(g,d){const S=this.folderConfigurations.get(g),{added:k,updated:w,removed:P,overrides:R}=o(S,d),$=[...k,...w,...P];return($.length||!S)&&this.updateFolderConfiguration(g,d),{keys:$,overrides:R}}compareAndDeleteFolderConfiguration(g){const d=this.folderConfigurations.get(g);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(g);const{added:S,updated:k,removed:w,overrides:P}=o(d,void 0);return{keys:[...S,...k,...w],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(g,d,S){let k=this.x(d,S);return d.overrideIdentifier&&(k=k.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(g)!==void 0&&(k=k.merge(this.l)),k}x({resource:g},d){let S=this.y();if(d&&g){const k=d.getFolder(g);k&&(S=this.z(k.uri)||S);const w=this.t.get(g);w&&(S=S.merge(w))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(g){let d=this.i.get(g);if(!d){const S=this.y(),k=this.r.get(g);k?(d=S.merge(k),this.i.set(g,d)):d=S}return d}A(g,d){if(d&&g){const S=d.getFolder(g);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((g,d)=>{const{contents:S,overrides:k,keys:w}=this.r.get(d);return g.push([d,{contents:S,overrides:k,keys:w}]),g},[])}}allKeys(){const g=new Set;return this.j.keys.forEach(d=>g.add(d)),this.userConfiguration.keys.forEach(d=>g.add(d)),this.q.keys.forEach(d=>g.add(d)),this.r.forEach(d=>d.keys.forEach(S=>g.add(S))),[...g.values()]}B(){const g=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>g.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>g.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>g.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach(S=>g.add(S))),[...g.values()]}D(g){const d=new Set;return this.j.getKeysForOverrideIdentifier(g).forEach(S=>d.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(g).forEach(S=>d.add(S)),this.q.getKeysForOverrideIdentifier(g).forEach(S=>d.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(g).forEach(k=>d.add(k))),[...d.values()]}static parse(g,d){const S=this.E(g.defaults,d),k=this.E(g.policy,d),w=this.E(g.application,d),P=this.E(g.user,d),R=this.E(g.workspace,d),$=g.folders.reduce((b,L)=>(b.set(s.URI.revive(L[0]),this.E(L[1],d)),b),new T.$Dc);return new i(S,k,w,P,r.createEmptyModel(d),R,$,r.createEmptyModel(d),new T.$Dc,d)}static E(g,d){return new r(g.contents,g.keys,g.overrides,void 0,d)}}e.$Uo=i;function n(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const g=new Set,d=new Map;for(const k of m)k.keys.forEach(w=>g.add(w)),k.overrides.forEach(([w,P])=>{const R=(0,T.$Ac)(d,w,new Set);P.forEach($=>R.add($))});const S=[];return d.forEach((k,w)=>S.push([w,[...k.values()]])),{keys:[...g.values()],overrides:S}}class t{constructor(g,d,S,k,w){this.change=g,this.f=d,this.g=S,this.h=k,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of g.keys)this.affectedKeys.add(P);for(const[,P]of g.overrides)for(const R of P)this.affectedKeys.add(R);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(g,d){const S=this.a+g,k=this.d.indexOf(S);if(k<0)return!1;const w=k+S.length;if(w>=this.d.length)return!1;const P=this.d.charCodeAt(w);if(P!==this.b&&P!==this.c)return!1;if(d){const R=this.previousConfiguration?this.previousConfiguration.getValue(g,d,this.f?.workspace):void 0,$=this.g.getValue(g,d,this.h);return!O.$lo(R,$)}return!0}}e.$Wo=t;function o(m,g){const{added:d,removed:S,updated:k}=l(g?.rawConfiguration,m?.rawConfiguration),w=[],P=m?.getAllOverrideIdentifiers()||[],R=g?.getAllOverrideIdentifiers()||[];if(g){const $=R.filter(b=>!P.includes(b));for(const b of $)w.push([b,g.getKeysForOverrideIdentifier(b)])}if(m){const $=P.filter(b=>!R.includes(b));for(const b of $)w.push([b,m.getKeysForOverrideIdentifier(b)])}if(g&&m){for(const $ of P)if(R.includes($)){const b=l({contents:m.getOverrideValue(void 0,$)||{},keys:m.getKeysForOverrideIdentifier($)},{contents:g.getOverrideValue(void 0,$)||{},keys:g.getKeysForOverrideIdentifier($)});w.push([$,[...b.added,...b.removed,...b.updated]])}}return{added:d,removed:S,updated:k,overrides:w}}function l(m,g){const d=m?g?m.keys.filter(w=>g.keys.indexOf(w)===-1):[...m.keys]:[],S=g?m?g.keys.filter(w=>m.keys.indexOf(w)===-1):[...g.keys]:[],k=[];if(m&&g){for(const w of g.keys)if(m.keys.indexOf(w)!==-1){const P=(0,I.$kj)(g.contents,w),R=(0,I.$kj)(m.contents,w);O.$lo(P,R)||k.push(w)}}return{added:d,removed:S,updated:k}}}),define(Oe[110],Ae([1,0,13,3]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.RemoteAuthorityResolverErrorCode=e.$Wl=e.$Vl=e.RemoteConnectionType=e.$Ul=void 0,e.$Yl=s,e.$Ul=(0,D.$Ii)("remoteAuthorityResolverService");var C;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class N{constructor(v){this.id=v,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Vl=N;class T{constructor(v,h){this.host=v,this.port=h,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wl=T;var O;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class p extends y.$db{static isNotAvailable(v){return v instanceof p&&v._code===O.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof p&&v._code===O.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof p&&v._code===O.NoResolverFound}static isInvalidAuthority(v){return v instanceof p&&v._code===O.InvalidAuthority}static isHandled(v){return v instanceof p&&v.isHandled}constructor(v,h=O.Unknown,E){super(v),this._message=v,this._code=h,this._detail=E,this.isHandled=h===O.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Xl=p;function s(I){const v=I.indexOf("+");return v===-1?I:I.substring(0,v)}}),define(Oe[63],Ae([1,0,15]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=D,e.$ln=C,e.$mn=N,e.$nn=T;function D(p){return p.scheme===y.Schemas.vscodeRemote?p.authority:void 0}function C(p){if(!p)return;const s=p.indexOf("+");return s<0?p:p.substr(0,s)}function N(p){const{host:s,port:I}=O(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:I}}function T(p,s){let{host:I,port:v}=O(p);return typeof v>"u"&&(v=s),{host:I,port:v}}function O(p){const s=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=p.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:p,port:void 0}}}),define(Oe[18],Ae([1,0,12,3,63]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$wn=e.$vn=e.$un=e.TargetPlatform=e.ExtensionType=e.$tn=e.$rn=e.$qn=e.$pn=e.$on=void 0,e.$sn=N,e.$xn=v,e.$yn=h,e.$zn=E,e.$An=f,e.$Bn=r,e.$Cn=a,y=He(y),e.$on="extensions.user.cache",e.$pn="extensions.builtin.cache",e.$qn="undefined_publisher",e.$rn=["ui","workspace","web"];function N(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$tn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(T||(e.ExtensionType=T={}));var O;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class p{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,i){if(typeof u>"u"||u===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof u=="string"||typeof i=="string"){const n=typeof u=="string"?u:u.value,t=typeof i=="string"?i:i.value;return y.$If(n,t)}return u._lower===i._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$un=p;class s{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const i of u)this.add(i)}add(u){this.c.add(p.toKey(u))}delete(u){return this.c.delete(p.toKey(u))}has(u){return this.c.has(p.toKey(u))}}e.$vn=s;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(p.toKey(u))}get(u){return this.c.get(p.toKey(u))}has(u){return this.c.has(p.toKey(u))}set(u,i){this.c.set(p.toKey(u),i)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$wn=I;function v(c){return h(c)}function h(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function E(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function f(c,u){if(u){const i=`onResolveRemoteAuthority:${(0,C.$ln)(u)}`;return!!c.activationEvents?.includes(i)}return!1}function r(c){return c.map(u=>{const[i,n]=u.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function a(c){return c.map(u=>u.split("@")[0])}e.$Dn=(0,D.$Ii)("IBuiltinExtensionsScannerService")}),define(Oe[111],Ae([1,0,21,9,18,3]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.ExtensionManagementErrorCode=e.$pp=e.ExtensionGalleryErrorCode=e.$op=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=void 0,e.$ip=O,e.$jp=p,e.$kp=s,e.$lp=I,e.$mp=v,e.$np=h,e.$bp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$cp=new RegExp(e.$bp),e.$dp="__web_extension",e.$ep="skipWalkthrough",e.$fp="extensionInstallSource",e.$gp="dependecyOrPackExtensionInstall",e.$hp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function O(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function p(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function s(t,o){switch(t){case y.Platform.Windows:return o==="x64"?C.TargetPlatform.WIN32_X64:o==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case y.Platform.Linux:return o==="x64"?C.TargetPlatform.LINUX_X64:o==="arm64"?C.TargetPlatform.LINUX_ARM64:o==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?C.TargetPlatform.ALPINE_X64:o==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case y.Platform.Mac:return o==="x64"?C.TargetPlatform.DARWIN_X64:o==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case y.Platform.Web:return C.TargetPlatform.WEB}}function I(t,o){return o===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function v(t,o,l){return I(o,l)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===l}function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var a;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(a||(e.InstallOperation=a={})),e.$op=(0,N.$Ii)("extensionGalleryService");var c;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(c||(e.ExtensionGalleryErrorCode=c={}));class u extends Error{constructor(o,l){super(o),this.code=l,this.name=l}}e.$pp=u;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(o,l){super(o),this.code=l,this.name=l}}e.$qp=n,e.$rp=(0,N.$Ii)("extensionManagementService"),e.$sp="extensionsIdentifiers/disabled",e.$tp="extensionsIdentifiers/enabled",e.$up=(0,N.$Ii)("IGlobalExtensionEnablementService"),e.$vp=(0,N.$Ii)("IExtensionTipsService"),e.$wp=(0,D.localize2)(1778,"Extensions"),e.$xp=(0,D.localize2)(1779,"Preferences")}),define(Oe[112],Ae([1,0,13,18]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bH=e.$aH=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(T,O){this.a.set(T,O)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const O=Object.create(null);for(const p of T){const s=this.readActivationEvents(p);s.length>0&&(O[D.$un.toKey(p.identifier)]=s)}return O}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const O=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let p=0;p<O.length;p++)O[p]==="onUri"&&(O[p]=`onUri:${D.$un.toKey(T.identifier)}`);if(!T.contributes)return O;for(const p in T.contributes){const s=this.a.get(p);if(!s)continue;const I=T.contributes[p],v=Array.isArray(I)?I:[I];try{s(v,O)}catch(h){(0,y.$2)(h)}}return O}}e.$aH=C,e.$bH=new C});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Oe[176],Ae([1,0,23,36,9,282,18,105]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=I,e.$4p=v,e.$5p=h,e.$6p=E,e.$7p=f,e.$8p=r,e.$9p=a,e.$0p=c,D=si(D),C=He(C),N=He(N);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||p.test(n)}function v(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function h(n){if(!n)return null;const t=n.majorBase,o=n.majorMustEqual,l=n.minorBase;let m=n.minorMustEqual;const g=n.patchBase;let d=n.patchMustEqual;n.hasCaret&&(t===0||(m=!1),d=!1);let S=0;if(n.preRelease){const k=s.exec(n.preRelease);if(k){const[,w,P,R]=k;S=Date.UTC(Number(w),Number(P)-1,Number(R))}}return{majorBase:t,majorMustEqual:o,minorBase:l,minorMustEqual:m,patchBase:g,patchMustEqual:d,isMinimum:n.hasGreaterEquals,notBefore:S}}function E(n,t,o){let l;typeof n=="string"?l=h(v(n)):l=n;let m;t instanceof Date?m=t.getTime():typeof t=="string"&&(m=new Date(t).getTime());let g;if(typeof o=="string"?g=h(v(o)):g=o,!l||!g)return!1;const d=l.majorBase,S=l.minorBase,k=l.patchBase;let w=g.majorBase,P=g.minorBase,R=g.patchBase;const $=g.notBefore;let b=g.majorMustEqual,L=g.minorMustEqual,A=g.patchMustEqual;return g.isMinimum?d>w?!0:d<w?!1:S>P?!0:S<P||m&&m<$?!1:k>=R:(d===1&&w===0&&(!b||!L||!A)&&(w=1,P=0,R=0,b=!0,L=!1,A=!1),d<w?!1:d>w?!b:S<P?!1:S>P?!L:k<R?!1:k>R?!A:!(m&&m<$))}function f(n,t,o,l,m,g){const d=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return d.push([D.default.Error,C.localize(1830,null)]),d;if(typeof l.name!="string")return d.push([D.default.Error,C.localize(1831,null,"name")]),d;if(typeof l.version!="string")return d.push([D.default.Error,C.localize(1832,null,"version")]),d;if(!l.engines)return d.push([D.default.Error,C.localize(1833,null,"engines")]),d;if(typeof l.engines.vscode!="string")return d.push([D.default.Error,C.localize(1834,null,"engines.vscode")]),d;if(typeof l.extensionDependencies<"u"&&!i(l.extensionDependencies))return d.push([D.default.Error,C.localize(1835,null,"extensionDependencies")]),d;if(typeof l.activationEvents<"u"){if(!i(l.activationEvents))return d.push([D.default.Error,C.localize(1836,null,"activationEvents")]),d;if(typeof l.main>"u"&&typeof l.browser>"u")return d.push([D.default.Error,C.localize(1837,null,"activationEvents","main","browser")]),d}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&d.push([D.default.Warning,C.localize(1838,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return d.push([D.default.Error,C.localize(1839,null,"main")]),d;{const w=(0,y.$jh)(o,l.main);(0,y.$dh)(w,o)||d.push([D.default.Warning,C.localize(1840,null,w.path,o.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return d.push([D.default.Error,C.localize(1841,null,"browser")]),d;{const w=(0,y.$jh)(o,l.browser);(0,y.$dh)(w,o)||d.push([D.default.Warning,C.localize(1842,null,w.path,o.path)])}}if(!N.valid(l.version))return d.push([D.default.Error,C.localize(1843,null)]),d;const S=[];if(!r(n,t,l,m,S))for(const w of S)d.push([D.default.Error,w]);if(g&&l.enabledApiProposals?.length){const w=[];if(!c([...l.enabledApiProposals],w))for(const P of w)d.push([D.default.Error,P])}return d}function r(n,t,o,l,m){return l||typeof o.main>"u"&&typeof o.browser>"u"?!0:u(n,t,o.engines.vscode,m)}function a(n,t,o){return n==="*"||u(t,o,n)}function c(n,t){if(n.length===0)return!0;const o=Array.isArray(t)?t:void 0,l=(o?void 0:t)??O.allApiProposals,m=[],g=(0,T.$Bn)(n);for(const{proposalName:d,version:S}of g){const k=l[d];k&&S&&k.version!==S&&m.push(C.localize(1844,null,d))}return o?.push(...m),m.length===0}function u(n,t,o,l=[]){const m=h(v(o));if(!m)return l.push(C.localize(1845,null,o)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return l.push(C.localize(1846,null,o)),!1}else if(!m.majorMustEqual)return l.push(C.localize(1847,null,o)),!1;return E(n,t,m)?!0:(l.push(C.localize(1848,null,n,o)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,o=n.length;t<o;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Oe[177],Ae([1,0,22,13,4,9,54,3,11,30]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0,e.$aq=h,e.$bq=E,e.$cq=f,e.$dq=r,e.$eq=a,e.$fq=c,e.$$p=(0,O.$Ii)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class v extends C.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,N.localize)(2048,null),when:p.$vk.isEqualTo((0,p.$sk)(p.LogLevel.Trace)).serialize()})}async c(t,o,l){const m=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${m} - begin`,o.type,new I(o.headers??{}));try{const g=await l();return this.a.trace(`${m} - end`,o.type,g.res.statusCode,g.res.headers),g}catch(g){throw this.a.error(`${m} - error`,o.type,(0,D.$_)(g)),g}}}e.$_p=v;function h(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function E(n){return n.res.statusCode===204}async function f(n){return E(n)?null:(await(0,y.$3e)(n.stream)).toString()}async function r(n){if(!h(n))throw new Error("Server returned "+n.res.statusCode);return f(n)}async function a(n){if(!h(n))throw new Error("Server returned "+n.res.statusCode);if(E(n))return null;const o=(await(0,y.$3e)(n.stream)).toString();try{return JSON.parse(o)}catch(l){throw l.message+=`:
`+o,l}}function c(n){i(n)}let u;function i(n){const t=s.$uo.as(T.$zo.Configuration),o=u;u={id:"http",order:15,title:(0,N.localize)(2049,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2050,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(2051,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(2052,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,N.localize)(2053,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(2054,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(2055,null),(0,N.localize)(2056,null),(0,N.localize)(2057,null),(0,N.localize)(2058,null)],default:"override",description:(0,N.localize)(2059,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(2060,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(2061,null),restricted:!0}}},t.updateConfigurations({add:[u],remove:o?[o]:[]})}i(T.ConfigurationScope.APPLICATION)}),define(Oe[178],Ae([1,0,21,79,38]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=T,e.$zp=O;function N(p){if(y.$v===y.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function T(p,s,I,v,h,E,f,r,a,c){const u=Object.create(null);u["common.machineId"]=E,u["common.sqmId"]=f,u["common.devDeviceId"]=r,u.sessionID=(0,C.$5g)()+Date.now(),u.commitHash=v,u.version=h,u["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,y.$i)(y.$v),u["common.nodePlatform"]=D.$gc,u["common.nodeArch"]=I,u["common.product"]=c||"desktop",a&&(u["common.msftInternal"]=a);let i=0;const n=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),y.$m&&(u["common.snap"]="true");const t=N(s);return t&&(u["common.platformDetail"]=t),u}function O(p){const s=D.env.USERDNSDOMAIN;if(!s)return!1;const I=s.toLowerCase();return p.some(v=>I===v)}}),define(Oe[113],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,y.$Ii)("telemetryService"),e.$dm=(0,y.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var C;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Oe[64],Ae([1,0,25,14,63,178,113]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=void 0,e.$Hp=I,e.$Ip=v,e.$Jp=h,e.$Kp=E,e.$Lp=r,e.$Mp=c,e.$Np=u,e.$Op=t;class O{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$Ap=O;class p{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Bp=p,e.$Cp=new p;class s{async publicLog(l,m,g){}async publicLogError(l,m,g){}}e.$Dp=s,e.$Ep="telemetry",e.$Fp="extensionTelemetryLog",e.$Gp={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!o.enableTelemetry)}function v(o,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function h(o){const l=o.getValue(T.$lm),m=o.getValue(T.$mm);if(o.getValue(T.$nm)===!1||m===!1)return T.TelemetryLevel.NONE;switch(l??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function E(o){const l={},m={},g={};a(o,g);for(let d in g){d=d.length>150?d.substr(d.length-149):d;const S=g[d];typeof S=="number"?m[d]=S:typeof S=="boolean"?m[d]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${S.length}`),l[d]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(l[d]=S)}return{properties:l,measurements:m}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(o){if(!o)return"none";const l=(0,C.$ln)(o);return f.has(l)?l:"other"}function a(o,l,m=0,g){if(o)for(const d of Object.getOwnPropertyNames(o)){const S=o[d],k=g?g+d:d;Array.isArray(S)?l[k]=(0,y.$mo)(S):S instanceof Date?l[k]=S.toISOString():(0,D.$jg)(S)?m<2?a(S,l,m+1,k+"."):l[k]=(0,y.$mo)(S):l[k]=S}}function c(o,l){const m=o.msftInternalDomains||[],g=l.getValue("telemetry.internalTesting");return(0,N.$zp)(m)||g}function u(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,l){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let m=o;const g=[];for(const w of l)for(;;){const P=w.exec(o);if(!P)break;g.push([P.index,w.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(m="";;){const w=S.exec(o);if(!w)break;const P=g.some(([R,$])=>w.index<$&&R<S.lastIndex);!d.test(w[0])&&!P&&(m+=o.substring(k,w.index)+"<REDACTED: user-file-path>",k=S.lastIndex)}return k<o.length&&(m+=o.substr(k)),m}function n(o){if(!o)return o;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of l)if(m.regex.test(o))return`<REDACTED: ${m.label}>`;return o}function t(o,l){return(0,y.$jo)(o,m=>{if(m instanceof O||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let g=m.replaceAll("%20"," ");g=i(g,l);for(const d of l)g=g.replace(d,"");return g=n(g),g}})}}),define(Oe[179],Ae([1,0,12,111,18,21,2,13,79,64]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Qp=void 0,e.$Pp=I,e.$Rp=f,e.$Sp=r,e.$Tp=a,e.$Up=c,e.$Vp=u,e.$Wp=i,e.$Xp=n,e.$Zp=t,e.$1p=l;function I(m,g){return m.uuid&&g.uuid?m.uuid===g.uuid:m.id===g.id?!0:(0,y.$Df)(m.id,g.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(g){const d=g.manifest?g.manifest.version:g.version,S=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new h(g.identifier,d,S)}static parse(g){const d=v.exec(g);return d&&d[1]&&d[2]?new h({id:d[1]},d[2],d[4]||void 0):null}constructor(g,d,S=C.TargetPlatform.UNDEFINED){this.identifier=g,this.version=d,this.targetPlatform=S,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof h?I(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$Qp=h;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(m){const g=E.exec(m);return g&&g[1]?[a(g[1]),g[2]]:[a(m),void 0]}function r(m,g){return`${m}.${g}`}function a(m){return m.toLowerCase()}function c(m,g){return a(r(m??C.$qn,g))}function u(m,g){const d=[],S=k=>{for(const w of d)if(w.some(P=>I(g(P),g(k))))return w;return null};for(const k of m){const w=S(k);w?w.push(k):d.push([k])}return d}function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}function n(m){return{id:new s.$Ap(m.identifier.id),name:new s.$Ap(m.name),version:m.version,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,isPreReleaseVersion:m.properties.isPreReleaseVersion,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0),isSigned:m.isSigned,...m.telemetryData}}e.$Yp=new C.$un("pprice.better-merge");function t(m,g){const d=[],S=g.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const k=S.shift();if(k&&d.every(w=>!I(w.identifier,{id:k}))){const w=m.filter(P=>I(P.identifier,{id:k}));w.length===1&&(d.push(w[0]),S.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}async function o(m,g){if(!N.$l)return!1;let d;try{d=(await m.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await m.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){g.debug("Error while getting the os-release file.",(0,O.$_)(k))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(m,g){const d=await o(m,g),S=(0,D.$kp)(d?"alpine":N.$v,p.$hc);return g.debug("ComputeTargetPlatform:",S),S}}),define(Oe[180],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=y,e.$Ls=D,e.$Ms=C,e.$Ns=N,e.$Os=T,e.$Ps=O;function y(p){return[...p.entries()]}function D(p){return p?[...p.entries()]:[]}function C(p){return new Map(p)}function N(p){return new Map(p??[])}function T(p){return Array.from(p.entries()).map(s=>[s[0],y(s[1].map),D(s[1].descriptionMap)])}function O(p){return new Map(p.map(s=>[s[0],{map:C(s[1]),descriptionMap:N(s[2])}]))}}),define(Oe[181],Ae([1,0,3,31,30]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$us=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ts=void 0,e.$ts=new D.$Zj("terminalTabFocusMode",!1,!0);var N;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(N||(e.TerminalSettingPrefix=N={}));var T;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var O;(function(o){o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh"})(O||(e.PosixShellType=O={}));var p;(function(o){o.CommandPrompt="cmd",o.Wsl="wsl",o.GitBash="gitbash"})(p||(e.WindowsShellType=p={}));var s;(function(o){o.PowerShell="pwsh",o.Python="python",o.Julia="julia",o.NuShell="nu"})(s||(e.GeneralShellType=s={}));var I;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var v;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(v||(e.TerminalIpcChannels=v={}));var h;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(h||(e.ProcessPropertyType=h={})),e.$us=(0,y.$Ii)("ptyService");var E;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var f;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var r;(function(o){o.TerminalView="view",o.Editor="editor"})(r||(e.TerminalLocationString=r={}));var a;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var c;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(c||(e.FlowControlConstants=c={}));var u;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var i;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var n;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$vs={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(l){const m=this.b(l.remoteAuthority);if(this.a.has(m))throw new Error(`A terminal backend with remote authority '${m}' was already registered.`);this.a.set(m,l)}getTerminalBackend(l){return this.a.get(this.b(l))}b(l){return l?.toLowerCase()??""}}C.$uo.add(e.$vs.Backend,new t),e.$ws=(0,y.$Ii)("localPtyService"),e.$xs=(0,y.$Ii)("terminalLogService")}),define(Oe[182],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$myb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,N,T=5){const O=N(p=>{const s=typeof p=="string"?p:p.data;let I=this.a.get(C);if(I){I.data.push(s);return}const v=setTimeout(()=>this.flushBuffer(C),T);I={data:[s],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(C),O.dispose()}},this.a.set(C,I)});return O}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const N=this.a.get(C);N&&(this.a.delete(C),this.b(C,N.data.join("")))}}e.$myb=y}),define(Oe[183],Ae([1,0,10,98,283,35,6,14,2,9,78,30]),function($e,e,y,D,C,N,T,O,p,s,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ox=e.$Nx=e.$Mx=e.$Lx=e.$Kx=e.$Jx=e.IconFontDefinition=e.IconContribution=e.$Gx=void 0,e.$Hx=a,e.$Ix=c,v=He(v),e.$Gx={IconContribution:"base.contributions.icons"};var h;(function(t){function o(l,m){let g=l.defaults;for(;N.ThemeIcon.isThemeIcon(g);){const d=r.getIcon(g.id);if(!d)return;g=d.defaults}return g}t.getDefinition=o})(h||(e.IconContribution=h={}));var E;(function(t){function o(m){return{weight:m.weight,style:m.style,src:m.src.map(g=>({format:g.format,location:g.location.toString()}))}}t.toJSONObject=o;function l(m){const g=d=>(0,O.$hg)(d)?d:void 0;if(m&&Array.isArray(m.src)&&m.src.every(d=>(0,O.$hg)(d.format)&&(0,O.$hg)(d.location)))return{weight:g(m.weight),style:g(m.style),src:m.src.map(d=>({format:d.format,location:p.URI.parse(d.location)}))}}t.fromJSONObject=l})(E||(e.IconFontDefinition=E={}));class f{constructor(){this.a=new T.$oe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(2362,null)},fontCharacter:{type:"string",description:(0,s.localize)(2363,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,l,m,g){const d=this.b[o];if(d){if(m&&!d.description){d.description=m,this.d.properties[o].markdownDescription=`${m} $(${o})`;const w=this.e.enum.indexOf(o);w!==-1&&(this.e.enumDescriptions[w]=m),this.a.fire()}return d}const S={id:o,description:m,defaults:l,deprecationMessage:g};this.b[o]=S;const k={$ref:"#/definitions/icons"};return g&&(k.deprecationMessage=g),m&&(k.markdownDescription=`${m}: $(${o})`),this.d.properties[o]=k,this.e.enum.push(o),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const l=this.e.enum.indexOf(o);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,l){const m=this.f[o];return m||(this.f[o]=l,this.a.fire(),l)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(d,S)=>d.id.localeCompare(S.id),l=d=>{for(;N.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.b).map(d=>this.b[d]);for(const d of g.filter(S=>!!S.description).sort(o))m.push(`|<i class="${l(d)}"></i>|${d.id}|${N.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const d of g.filter(S=>!N.ThemeIcon.isThemeIcon(S.defaults)).sort(o))m.push(`|<i class="${l(d)}"></i>|${d.id}|`);return m.join(`
`)}}const r=new f;v.$uo.add(e.$Gx.IconContribution,r);function a(t,o,l,m){return r.registerIcon(t,o,l,m)}function c(){return r}function u(){const t=(0,C.$4j)();for(const o in t){const l="\\"+t[o].toString(16);r.registerIcon(o,{fontCharacter:l})}}u(),e.$Jx="vscode://schemas/icons";const i=v.$uo.as(I.$vo.JSONContribution);i.registerSchema(e.$Jx,r.getIconSchema());const n=new y.$Uh(()=>i.notifySchemaChanged(e.$Jx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Kx=a("widget-close",D.$8j.close,(0,s.localize)(2364,null)),e.$Lx=a("goto-previous-location",D.$8j.arrowUp,(0,s.localize)(2365,null)),e.$Mx=a("goto-next-location",D.$8j.arrowDown,(0,s.localize)(2366,null)),e.$Nx=N.ThemeIcon.modify(D.$8j.sync,"spin"),e.$Ox=N.ThemeIcon.modify(D.$8j.loading,"spin")}),define(Oe[184],Ae([1,0,6,4,21,2,43,3,11]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=e.$Uw=e.$Rw=e.$Pw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Lw=e.$Kw=void 0,e.$Mw=v,e.$Nw=E,e.$Ow=f,e.$Qw=r,e.$Sw=a,e.$Tw=c,e.$Kw=(0,O.$Ii)("tunnelService"),e.$Lw=(0,O.$Ii)("sharedTunnelsService");var s;(function(n){n.Http="http",n.Https="https"})(s||(e.TunnelProtocol=s={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function v(n){return!!n.forwardPort}var h;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function E(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function f(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const o of t){const l=o.split("=")[1];if(/^https?:/.exec(l)){const m=E(N.URI.parse(l));if(m)return m}}}e.$Pw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Pw.indexOf(n)>=0}e.$Rw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(n){return e.$Rw.indexOf(n)>=0}function c(n,t,o,l){if(o===C.OperatingSystem.Windows)return!1;if(o===C.OperatingSystem.Macintosh&&a(t)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(m?.length===4&&parseInt(m[1])>=18)return!1}return n<1024}class u{constructor(t,o,l){this.remoteAddress=t,this.localAddress=o,this.b=l,this.a=new y.$oe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Uw=u;let i=class extends D.$Xc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new y.$oe,this.onTunnelOpened=this.a.event,this.b=new y.$oe,this.onTunnelClosed=this.b.event,this.c=new y.$oe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const l of o){const m=Array.from(l.values());for(const g of m){const d=await g.value;d&&typeof d!="string"&&t.push(d)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,l,m,g){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:l,privacy:m,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(a(t)||r(t))&&(t=e.$Pw[0]);const l=this.D(t,o);if(l)return++l.refcount,l.value}openTunnel(t,o,l,m,g,d=!1,S,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${l} on local port ${g}.`);const w=this.g??t;if(!w)return;if(o||(o="localhost"),m||(m=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const P=this.F(w,o,l,m,g,d,S,k);return P?P.then(R=>{if(R){if(typeof R=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,l),R}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.w(R);return(R.tunnelRemoteHost!==o||R.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&R.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),P)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const l=o.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,o,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const m=l.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),m}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const l=this.f.get(t);if(l&&l.has(o)){const m=l.get(o);m.refcount=0,await this.y(t,o,m)}}z(t,o,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:l})}async C(t,o){const l=this.f.get(t);if(l){const m=l.get(o),g=m?await m.value:void 0;(!g||typeof g=="string")&&l.delete(o),l.size===0&&this.f.delete(t)}}D(t,o){const l=[t];r(t)?(l.push(...e.$Pw),l.push(...e.$Rw)):a(t)&&l.push(...e.$Rw);const m=l.map(g=>this.f.get(g));for(const g of m){const d=g?.get(o);if(d)return d}}canTunnel(t){return!!E(t)}G(t,o,l,m,g,d,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${l} on local port ${m}.`);const k=l;this.n.add(k);const w=m===void 0?l:m,P={elevationRequired:g?this.isPortPrivileged(w):!1},R={remoteAddress:{host:o,port:l},localAddressPort:m,privacy:d,public:d?d!==I.Private:void 0,protocol:S},$=t.forwardPort(R,P);return $?(this.z(o,l,$),$.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),$}};e.$Vw=i,e.$Vw=i=Xe([Qe(0,p.$dk),Qe(1,T.$cj)],i)}),define(Oe[114],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,y.$Ii)("IUriIdentityService")}),define(Oe[185],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ww=void 0,e.$Ww=(0,y.$Ii)("editSessionIdentityService");var D;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(D||(e.EditSessionIdentityMatch=D={}))}),define(Oe[186],Ae([1,0,15]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=D,e.$yN=C,e.$zN=N,e.$AN=T,e.$BN=O;function D(p){return p.scheme!==y.Schemas.file&&p.scheme!==y.Schemas.vscodeRemote}function C(p){if(p.folders.length)return p.folders.every(s=>D(s.uri))?p.folders[0].uri:void 0;if(p.configuration&&D(p.configuration))return p.configuration}function N(p){return C(p)?.scheme}function T(p){return C(p)?.authority}function O(p){return C(p)!==void 0}}),define(Oe[50],Ae([1,0,9,20,49,23,2,3,15]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=s,e.$Ti=I,e.$Wi=v,e.$Xi=h,e.$Yi=E,e.$Zi=r,e.$1i=a,e.$4i=i,e.$9i=n,e.$0i=t,e.$_i=o,e.$aj=l,e.$bj=m,e.$Ri=(0,O.$Ii)("contextService");function s(g){const d=g;return typeof d?.id=="string"&&T.URI.isUri(d.uri)}function I(g){return typeof g?.id=="string"&&!s(g)&&!h(g)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function v(g,d){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,D.$qc)(g)}:d?e.$Ui:e.$Vi;const S=g;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function h(g){const d=g;return typeof d?.id=="string"&&T.URI.isUri(d.configPath)}function E(g){const d=g;if(d?.uri)return{id:d.id,uri:T.URI.revive(d.uri)};const S=g;if(S?.configPath)return{id:S.id,configPath:T.URI.revive(S.configPath)};if(g?.id)return{id:g.id}}var f;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function r(g){const d=g;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}function a(g){const d=g;return!!(d&&typeof d=="object"&&T.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}class c{constructor(d,S,k,w,P){this.h=d,this.j=k,this.k=w,this.l=P,this.c=C.$Oi.forUris(this.l,()=>!0),this.folders=S}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=C.$Oi.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=c;class u{constructor(d,S){this.raw=S,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,N.$jh)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=u;function i(g){return new u({uri:g,index:0,name:(0,N.$fh)(g)},{uri:g.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,y.localize)(2487,null),extensions:[e.$5i]}],e.$8i="workspace.json";function n(g,d){return N.$ah.isEqualOrParent(g,d.untitledWorkspacesHome)}function t(g){let d;return T.URI.isUri(g)?d=g:d=g.configuration,d?.scheme===p.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(g){return g.id===e.$$i}function l(g,d){return!n(g,d)&&!t(g)}function m(g){return(typeof g=="string"?(0,D.$rc)(g):(0,N.$hh)(g))===e.$6i}}),define(Oe[115],Ae([1,0,76,6,4,23,2,9,107,29,3,11,50,28,114,10,38,12,14]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=n,e.$Ql=t,e.$Rl=o;var i;(function(g){g.Settings="settings",g.Keybindings="keybindings",g.Snippets="snippets",g.Tasks="tasks",g.Extensions="extensions",g.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(g){const d=g;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&typeof d.isDefault=="boolean"&&typeof d.name=="string"&&T.URI.isUri(d.location)&&T.URI.isUri(d.globalStorageHome)&&T.URI.isUri(d.settingsResource)&&T.URI.isUri(d.keybindingsResource)&&T.URI.isUri(d.tasksResource)&&T.URI.isUri(d.snippetsHome)&&T.URI.isUri(d.extensionsResource))}e.$Pl=(0,I.$Ii)("IUserDataProfilesService");function t(g,d){return{id:g.id,isDefault:g.isDefault,name:g.name,shortName:g.shortName,icon:g.icon,location:T.URI.revive(g.location).with({scheme:d}),globalStorageHome:T.URI.revive(g.globalStorageHome).with({scheme:d}),settingsResource:T.URI.revive(g.settingsResource).with({scheme:d}),keybindingsResource:T.URI.revive(g.keybindingsResource).with({scheme:d}),tasksResource:T.URI.revive(g.tasksResource).with({scheme:d}),snippetsHome:T.URI.revive(g.snippetsHome).with({scheme:d}),extensionsResource:T.URI.revive(g.extensionsResource).with({scheme:d}),cacheHome:T.URI.revive(g.cacheHome).with({scheme:d}),useDefaultFlags:g.useDefaultFlags,isTransient:g.isTransient}}function o(g,d,S,k,w,P){return{id:g,name:d,location:S,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:P&&w?.useDefaultFlags?.globalState?P.globalStorageHome:(0,N.$jh)(S,"globalStorage"),settingsResource:P&&w?.useDefaultFlags?.settings?P.settingsResource:(0,N.$jh)(S,"settings.json"),keybindingsResource:P&&w?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,N.$jh)(S,"keybindings.json"),tasksResource:P&&w?.useDefaultFlags?.tasks?P.tasksResource:(0,N.$jh)(S,"tasks.json"),snippetsHome:P&&w?.useDefaultFlags?.snippets?P.snippetsHome:(0,N.$jh)(S,"snippets"),extensionsResource:P&&w?.useDefaultFlags?.extensions?P.extensionsResource:(0,N.$jh)(S,"extensions.json"),cacheHome:(0,N.$jh)(k,g),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let l=class extends C.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(d,S,k,w){super(),this.t=d,this.u=S,this.w=k,this.y=w,this.f=!0,this.h=this.B(new D.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Dc,workspaces:new E.$Dc,emptyWindows:new Map},this.profilesHome=(0,N.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(d){this.f!==d&&(this.z=void 0,this.f=d)}isEnabled(){return this.f}get C(){if(!this.z){const d=this.D(),S=[d];if(this.f)try{for(const P of this.O()){if(!P.name||!(0,u.$hg)(P.name)||!P.location){this.y.warn("Skipping the invalid stored profile",P.location||P.name);continue}S.push(o((0,N.$gh)(P.location),P.name,P.location,this.g,{shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags},d))}}catch(P){this.y.error(P)}const k=new E.$Dc,w=new Map;if(S.length)try{const P=this.Q();if(P.workspaces)for(const[R,$]of Object.entries(P.workspaces)){const b=T.URI.parse(R),L=S.find(A=>A.id===$);L&&k.set(b,L)}if(P.emptyWindows)for(const[R,$]of Object.entries(P.emptyWindows)){const b=S.find(L=>L.id===$);b&&w.set(R,b)}}catch(P){this.y.error(P)}this.z={profiles:S,workspaces:k,emptyWindows:w}}return this.z}D(){const d=o("__default__profile__",(0,O.localize)(2440,null),this.t.userRoamingDataHome,this.g);return{...d,extensionsResource:this.S()??d.extensionsResource,isDefault:!0}}async createTransientProfile(d){const S="Temp",k=new RegExp(`${(0,c.$kf)(S)}\\s(\\d+)`);let w=0;for(const R of this.profiles){const $=k.exec(R.name),b=$?parseInt($[1]):0;w=b>w?b:w}const P=`${S} ${w+1}`;return this.createProfile((0,y.$wj)((0,a.$5g)()).toString(16),P,{transient:!0},d)}async createNamedProfile(d,S,k){return this.createProfile((0,y.$wj)((0,a.$5g)()).toString(16),d,S,k)}async createProfile(d,S,k,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=await this.F(d,S,k);return w&&await this.setProfileForWorkspace(w,P),P}async F(d,S,k){if(!(0,u.$hg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(S);return w||(w=(async()=>{try{if(this.profiles.find(b=>b.name===S||b.id===d))throw new Error(`Profile with ${S} name already exists`);const R=o(d,S,(0,N.$jh)(this.profilesHome,d),this.g,k,this.defaultProfile);await this.u.createFolder(R.location);const $=[];return this.j.fire({profile:R,join(b){$.push(b)}}),await r.Promises.settled($),this.I([R],[],[]),R}finally{this.r.delete(S)}})(),this.r.set(S,w)),w}async updateProfile(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(w=>w.id===d.id);if(!k)throw new Error(`Profile '${d.name}' does not exist`);return k=o(k.id,S.name??k.name,k.location,this.g,{shortName:S.shortName??k.shortName,icon:S.icon===null?void 0:S.icon??k.icon,transient:S.transient??k.isTransient,useDefaultFlags:S.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(d.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(w=>w.id===d.id);if(!S)throw new Error(`Profile '${d.name}' does not exist`);const k=[];this.m.fire({profile:S,join(w){k.push(w)}});try{await Promise.allSettled(k)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(w){(0,s.$ul)(w)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(w=>w.id===S.id);if(!k)throw new Error(`Profile '${S.name}' does not exist`);this.L(d,k)}unsetWorkspace(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(d,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const d=await this.u.resolve(this.profilesHome);await Promise.all((d.children||[]).filter(S=>S.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const d=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(d.map(S=>this.removeProfile(S)))}getProfileForWorkspace(d){const S=this.G(d),k=T.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return k||((0,h.$Si)(d)?this.s.folders.get(d.uri):(0,h.$Xi)(d)?this.s.workspaces.get(d.configPath):this.s.emptyWindows.get(d.id))}G(d){return(0,h.$Si)(d)?d.uri:(0,h.$Xi)(d)?d.configPath:d.id}H(d){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,d.location)))}I(d,S,k){const w=[...this.profiles,...d],P=[],R=this.s.profiles;this.s.profiles=[];for(let $ of w){if($.isDefault||S.some(L=>$.id===L.id))continue;$=k.find(L=>$.id===L.id)??$;const b=R.find(L=>$.id===L.id);if($.isTransient)this.s.profiles.push($);else{if(b){for(const[L,A]of this.s.emptyWindows.entries())if($.id===A.id){this.L({id:L},$);break}for(const[L,A]of this.s.workspaces.entries())if($.id===A.id){this.L({id:"",configPath:L},$);break}for(const[L,A]of this.s.folders.entries())if($.id===A.id){this.L({id:"",uri:L},$);break}}P.push({location:$.location,name:$.name,shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags})}}this.P(P),this.z=void 0,this.J(d,S,k)}J(d,S,k){this.h.fire({added:d,removed:S,updated:k,all:this.profiles})}L(d,S,k){if(k=S?.isTransient?!0:k,k)(0,h.$Si)(d)?(this.s.folders.delete(d.uri),S&&this.s.folders.set(d.uri,S)):(0,h.$Xi)(d)?(this.s.workspaces.delete(d.configPath),S&&this.s.workspaces.set(d.configPath,S)):(this.s.emptyWindows.delete(d.id),S&&this.s.emptyWindows.set(d.id,S));else{this.L(d,void 0,!0);const w=this.G(d);T.URI.isUri(w)?(this.C.workspaces.delete(w),S&&this.C.workspaces.set(w,S)):(this.C.emptyWindows.delete(w),S&&this.C.emptyWindows.set(w,S)),this.M()}}M(){const d={};for(const[k,w]of this.C.workspaces.entries())d[k.toString()]=w.id;const S={};for(const[k,w]of this.C.emptyWindows.entries())S[k.toString()]=w.id;this.R({workspaces:d,emptyWindows:S}),this.z=void 0}N(d){const S={},k=this.D();if(d.workspaces)for(const[P,R]of Object.entries(d.workspaces)){const $=T.URI.parse(R);S[P]=this.w.extUri.isEqual($,k.location)?k.id:this.w.extUri.basename($)}const w={};if(d.emptyWindows)for(const[P,R]of Object.entries(d.emptyWindows)){const $=T.URI.parse(R);w[P]=this.w.extUri.isEqual($,k.location)?k.id:this.w.extUri.basename($)}return{workspaces:S,emptyWindows:w}}O(){return[]}P(d){throw new Error("not implemented")}Q(){return{}}R(d){throw new Error("not implemented")}S(){}};e.$Sl=l,e.$Sl=l=Xe([Qe(0,p.$Pi),Qe(1,s.$dl),Qe(2,f.$Nl),Qe(3,v.$dk)],l);class m extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(d){this.a=d}Q(){return this.X}R(d){this.X=d}}e.$Tl=m}),define(Oe[187],Ae([1,0,10,6,4,65,14,153,3,115]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$nq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$lq=e.$kq=e.$jq=void 0,e.$mq=E,e.$oq=r,e.$qq=c,e.$jq="__$__isNewStorageMarker",e.$kq="__$__targetStorageMarker",e.$lq=(0,p.$Ii)("storageService");var I;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var v;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var h;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function E(u){const i=u.get(e.$kq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class f extends C.$Xc{static{this.a=60*1e3}constructor(i={flushInterval:f.a}){super(),this.m=i,this.b=this.B(new D.$re),this.c=this.B(new D.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new y.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return D.Event.filter(this.b.event,o=>o.scope===i&&(n===void 0||o.key===n),t)}n(){this.j.value=(0,y.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:o}=n;if(t===e.$kq){switch(i){case v.APPLICATION:this.H=void 0;break;case v.PROFILE:this.F=void 0;break;case v.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,o,l=!1){if((0,T.$qg)(n)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,n,l)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],o=this.J(i);for(const l of Object.keys(o))o[l]===n&&t.push(l);return t}z(i,n,t,o=!1){const l=this.J(n);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(n)?.set(e.$kq,JSON.stringify(l),o)):typeof l[i]=="number"&&(delete l[i],this.P(n)?.set(e.$kq,JSON.stringify(l),o))}get D(){return this.C||(this.C=this.L(v.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(v.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(v.APPLICATION)),this.H}J(i){switch(i){case v.APPLICATION:return this.I;case v.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?E(n):Object.create(null)}isNew(i){return this.getBoolean(e.$jq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const n=this.P(v.APPLICATION),t=this.P(v.PROFILE),o=this.P(v.WORKSPACE);switch(i){case I.NONE:await y.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await y.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(v.APPLICATION)?.items??new Map,n=this.P(v.PROFILE)?.items??new Map,t=this.P(v.WORKSPACE)?.items??new Map;return c(i,n,t,this.Q(v.APPLICATION)??"",this.Q(v.PROFILE)??"",this.Q(v.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(I.NONE),(0,s.$Ol)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const o=new Set;for(const[l,m]of i)o.add(l),n.get(l)!==m&&this.u(t,{key:l,external:!0});for(const[l]of n.items)o.has(l)||this.u(t,{key:l,external:!0})})}}e.$nq=f;function r(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class a extends f{constructor(){super(),this.U=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$hq(new O.$iq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(v.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(v.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(v.APPLICATION,i)))}P(i){switch(i){case v.APPLICATION:return this.U;case v.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case v.APPLICATION:return"inMemory (application)";case v.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$pq=a;async function c(u,i,n,t,o,l){const m=b=>{try{return JSON.parse(b)}catch{return b}},g=new Map,d=new Map;u.forEach((b,L)=>{g.set(L,b),d.set(L,m(b))});const S=new Map,k=new Map;i.forEach((b,L)=>{S.set(L,b),k.set(L,m(b))});const w=new Map,P=new Map;n.forEach((b,L)=>{w.set(L,b),P.set(L,m(b))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const R=[];if(g.forEach((b,L)=>{R.push({key:L,value:b})}),console.table(R),console.groupEnd(),console.log(d),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const b=[];S.forEach((L,A)=>{b.push({key:A,value:L})}),console.table(b),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${l})`);const $=[];w.forEach((b,L)=>{$.push({key:L,value:b})}),console.table($),console.groupEnd(),console.log(P)}}),define(Oe[80],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const N=this.c++;return this.b.set(N,C),this.e(),N}get(C,N){return this.b.has(C)?this.b.get(C)[N]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$nqc=y}),define(Oe[51],Ae([1,0,15,23,29,3]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=e.$sqc=void 0;class T{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new D.$$g(p=>{const s=this.b.get(p.scheme);return!(s===void 0||s&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,s){s===null?this.b.delete(p.scheme):this.b.set(p.scheme,s)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$sqc=T,e.$tqc=(0,N.$Ii)("IExtHostFileSystemInfo")}),define(Oe[26],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=void 0,e.$TQ=(0,y.$Ii)("IExtHostInitDataService")}),define(Oe[188],Ae([1,0,9,11,173,26]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=void 0;let T=class extends C.$4R{constructor(p,s,I){const v=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",h=I.remote.isRemote?(0,y.localize)(2704,null):p?(0,y.localize)(2705,null):(0,y.localize)(2706,null);super(s.createLogger(v,{name:h}))}};e.$Gsc=T,e.$Gsc=T=Xe([Qe(1,D.$ek),Qe(2,N.$TQ)],T)}),define(Oe[189],Ae([1,0,10]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=e.$$qc=void 0;class D{constructor(T,O,p){this.h=new Map,this.a=T,this.b=O,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new y.$Uh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of s.values())I.complete()}catch(I){for(const v of s.values())v.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,O){let p=this.f[T];return typeof p>"u"&&(p=O),p}update(T,O){this.f[T]=O;const p=this.h.get(T);if(p!==void 0)return p.p;const s=new y.$6h;return this.h.set(T,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$$qc=D;class C extends D{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,O){super(T.identifier.value,!0,O),this.j=T}}e.$_qc=C}),define(Oe[190],Ae([1,0,6,2]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rc=void 0;class C{constructor(T){this.c=T,this.a=new y.$oe,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$oe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,O,p,s){const v=this.c.getNotebookDocument(D.URI.revive(T)).acceptModelChanged(O.value,p,s);this.b.fire(v)}$acceptDirtyStateChanged(T,O){this.c.getNotebookDocument(D.URI.revive(T)).acceptDirty(O)}$acceptModelSaved(T){const O=this.c.getNotebookDocument(D.URI.revive(T));this.a.fire(O.apiNotebook)}}e.$$rc=C}),define(Oe[16],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=void 0,e.$DQ=(0,y.$Ii)("IExtHostRpcService");class D{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$EQ=D}),define(Oe[191],Ae([1,0,18,6,4]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0;class N{#e;constructor(O,p){this.disposables=new C.$Wc,this.a=y.$un.toKey(O.identifier),this.#e=p,this.onDidChange=D.Event.map(D.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(O){return this.#e.get(this.a,O)}store(O,p){return this.#e.store(this.a,O,p)}delete(O){return this.#e.delete(this.a,O)}}e.$irc=N}),define(Oe[66],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=e.$Iqc=void 0,e.$Iqc=(0,y.$Ii)("IURITransformerService");class D{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$Jqc=D});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Oe[116],Ae([1,0,9,14,2,4,3,30,29,15,42,165,36]),function($e,e,y,D,C,N,T,O,p,s,I,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$DG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$tG=e.EditorInputCapabilities=e.$sG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=void 0,e.$jG=r,e.$kG=a,e.$lG=c,e.$mG=u,e.$nG=i,e.$oG=n,e.$pG=t,e.$qG=o,e.$rG=l,e.$uG=w,e.$vG=R,e.$wG=$,e.$xG=b,e.$yG=L,e.$zG=A,e.$AG=M,e.$BG=Z,e.$CG=ue,e.$EG=se,e.$FG=te,e.$GG=we,e.$HG=Ce,h=si(h),e.$eG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$fG={id:"default",displayName:(0,y.localize)(4053,null),providerDisplayName:(0,y.localize)(4054,null)},e.$gG="workbench.editor.sidebysideEditor",e.$hG="workbench.editors.textDiffEditor",e.$iG="workbench.editors.binaryResourceDiffEditor";var E;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var f;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function r(Y){const W=Y;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function a(Y){const W=Y;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function c(Y,W,ee){for(const be of ee.visibleEditorPanes)if(be.group.id===W&&Y.matches(be.input))return be.getViewState()}function u(Y){if(w(Y))return!1;const W=Y;return C.URI.isUri(W?.resource)}function i(Y){if(w(Y))return!1;const W=Y;return W?.original!==void 0&&W.modified!==void 0}function n(Y){if(w(Y))return!1;const W=Y;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function t(Y){if(w(Y)||i(Y))return!1;const W=Y;return W?.primary!==void 0&&W.secondary!==void 0}function o(Y){if(w(Y))return!1;const W=Y;return W?W.resource===void 0||W.resource.scheme===s.Schemas.untitled||W.forceUntitled===!0:!1}function l(Y){if(w(Y))return!1;const W=Y;return C.URI.isUri(W?.base?.resource)&&C.URI.isUri(W?.input1?.resource)&&C.URI.isUri(W?.input2?.resource)&&C.URI.isUri(W?.result?.resource)}var m;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var g;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g||(e.SaveReason=g={}));class d{constructor(){this.a=new Map}registerSource(W,ee){let be=this.a.get(W);return be||(be={source:W,label:ee},this.a.set(W,be)),be.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$sG=new d;var S;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class k extends N.$Xc{}e.$tG=k;function w(Y){return Y instanceof k}function P(Y){const W=Y;return C.URI.isUri(W?.preferredResource)}function R(Y){const W=Y;return w(W?.primary)&&w(W?.secondary)}function $(Y){const W=Y;return w(W?.modified)&&w(W?.original)}function b(Y,W,ee,be,Pe){return Ce(be,[(0,v.$sj)({id:"workbench.action.openLargeFile",label:(0,y.localize)(4055,null),run:()=>{const je={...ee,limits:{size:Number.MAX_VALUE}};Y.openEditor(W,je)}}),(0,v.$sj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(4056,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}function L(Y){return w(Y?.editor)}function A(Y){const W=Y;return L(Y)&&W?.group!==void 0}function M(Y){const W=Y;return typeof W?.groupId=="number"&&w(W.editor)}function Z(Y){return typeof Y?.groupId=="number"}var G;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(G||(e.EditorCloseContext=G={}));var U;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var V;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class Q{getOriginalUri(W,ee){if(!W)return;if(l(W))return e.$DG.getOriginalUri(W.result,ee);if(ee?.supportSideBySide){const{primary:Pe,secondary:je}=this.a(W);if(Pe&&je){if(ee?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(je,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===V.ANY)return this.getOriginalUri(Pe,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(je,{filterByScheme:ee.filterByScheme});W=ee.supportSideBySide===V.PRIMARY?Pe:je}}if(i(W)||n(W)||t(W)||l(W))return;const be=P(W)?W.preferredResource:W.resource;return!be||!ee||!ee.filterByScheme?be:this.b(be,ee.filterByScheme)}a(W){return R(W)||t(W)?{primary:W.primary,secondary:W.secondary}:$(W)||i(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,ee){if(!W)return;if(l(W))return e.$DG.getCanonicalUri(W.result,ee);if(ee?.supportSideBySide){const{primary:Pe,secondary:je}=this.a(W);if(Pe&&je){if(ee?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(je,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===V.ANY)return this.getCanonicalUri(Pe,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(je,{filterByScheme:ee.filterByScheme});W=ee.supportSideBySide===V.PRIMARY?Pe:je}}if(i(W)||n(W)||t(W)||l(W))return;const be=W.resource;return!be||!ee||!ee.filterByScheme?be:this.b(be,ee.filterByScheme)}b(W,ee){if(Array.isArray(ee)){if(ee.some(be=>W.scheme===be))return W}else if(ee===W.scheme)return W}}var ne;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ne||(e.EditorCloseMethod=ne={}));function ue(Y,W,ee,be){if(!Y.isSticky(W))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ee===ne.MOUSE||ee===ne.KEYBOARD;case"mouse":return ee===ne.MOUSE;case"keyboard":return ee===ne.KEYBOARD}return!1}e.$DG=new Q;var x;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(x||(e.CloseDirection=x={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(W){const ee=this.a=W.get(T.$Hi);for(const[be,Pe]of this.c)this.e(be,Pe,ee);this.c.clear()}e(W,ee,be){const Pe=be.createInstance(ee);this.d.set(W,Pe)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,D.$sg)(this.b)}registerEditorSerializer(W,ee){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,ee,this.a):this.c.set(W,ee),(0,N.$Vc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}O.$uo.add(e.$eG.EditorFactory,new oe);async function se(Y,W,ee){return!Y||!Y.length?[]:await Promise.all(Y.map(async be=>{const Pe=C.URI.revive(be.fileUri);if(!Pe){ee.info("Cannot resolve the path because it is not valid.",be);return}if(!await W.canHandleResource(Pe)){ee.info("Cannot resolve the path because it cannot be handled",be);return}let Te=be.exists,Ee=be.type;if(typeof Te!="boolean"||typeof Ee!="number")try{Ee=(await W.stat(Pe)).isDirectory?p.FileType.Directory:p.FileType.Unknown,Te=!0}catch(Ve){ee.error(Ve),Te=!1}if(!Te&&be.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",be);return}if(Ee===p.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",be);return}const Fe={...be.options,pinned:!0};return Te?{resource:Pe,options:Fe}:{resource:Pe,options:Fe,forceUntitled:!0}}))}var ce;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function te(Y){const W=Y;if(!W)return!1;const ee=W;if(ee.modified)return te(ee.modified);const be=W;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function we(Y){return(0,I.$uj)(Y)}function Ce(Y,W,ee){const be=(0,I.$vj)(Y,W);return be.forceMessage=ee?.forceMessage,be.forceSeverity=ee?.forceSeverity,be.allowDialog=ee?.allowDialog,be}}),define(Oe[192],Ae([1,0,6,9,3,4,28,30,25,98,183]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PG=e.$OG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$NG=e.ViewContentGroups=e.$LG=e.ViewContainerLocation=e.Extensions=e.$KG=e.$JG=e.$IG=void 0,e.$MG=E,e.$IG="views",e.$JG=(0,D.localize)(4216,null),e.$KG=(0,I.$Hx)("default-view-icon",s.$8j.window,(0,D.localize)(4217,null));var v;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var h;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(h||(e.ViewContainerLocation=h={})),e.$LG=[h.Sidebar,h.Panel,h.AuxiliaryBar];function E(o){switch(o){case h.Sidebar:return"sidebar";case h.Panel:return"panel";case h.AuxiliaryBar:return"auxiliarybar"}}class f extends N.$Xc{constructor(){super(...arguments),this.c=this.B(new y.$oe),this.onDidRegister=this.c.event,this.f=this.B(new y.$oe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,m,g){const d=this.get(l.id);if(d)return d;const S=l;return S.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,T.$Ac)(this.g,m,[]).push(S),g?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:m}),S}deregisterViewContainer(l){for(const m of this.g.keys()){const g=this.g.get(m),d=g?.indexOf(l);if(d!==-1){g?.splice(d,1),g.length===0&&this.g.delete(m),this.f.fire({viewContainer:l,viewContainerLocation:m});return}}}get(l){return this.all.filter(m=>m.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(g=>g?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(m=>this.getViewContainerLocation(m)===l)}}O.$uo.add(v.ViewContainersRegistry,new f);var r;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(r||(e.ViewContentGroups=r={}));function a(o,l){const m=o.group??r.More,g=l.group??r.More;return m!==g?m.localeCompare(g):(o.order??5)-(l.order??5)}class c extends N.$Xc{constructor(){super(...arguments),this.c=this.B(new y.$oe),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$oe),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$oe),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$oe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new T.$Kc}registerViews(l,m){this.registerViews2([{views:l,viewContainer:m}])}registerViews2(l){l.forEach(({views:m,viewContainer:g})=>this.r(m,g)),this.c.fire(l)}deregisterViews(l,m){const g=this.s(l,m);g.length&&this.f.fire({views:g,viewContainer:m})}moveViews(l,m){for(const g of this.m.keys())if(g!==m){const d=this.s(l,g);d.length&&(this.r(d,m),this.g.fire({views:d,from:g,to:m}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const m of this.j){const g=(this.m.get(m)||[]).filter(d=>d.id===l)[0];if(g)return g}return null}getViewContainer(l){for(const m of this.j)if((this.m.get(m)||[]).filter(d=>d.id===l)[0])return m;return null}registerViewWelcomeContent(l,m){return this.n.add(l,m),this.h.fire(l),(0,N.$Vc)(()=>{this.n.delete(l,m),this.h.fire(l)})}registerViewWelcomeContent2(l,m){const g=new Map;for(const[d,S]of m)this.n.add(l,S),g.set(d,(0,N.$Vc)(()=>{this.n.delete(l,S),this.h.fire(l)}));return this.h.fire(l),g}getViewWelcomeContent(l){const m=[];return this.n.forEach(l,g=>m.push(g)),m.sort(a)}r(l,m){let g=this.m.get(m);g||(g=[],this.m.set(m,g),this.j.push(m));for(const d of l){if(this.getView(d.id)!==null)throw new Error((0,D.localize)(4218,null,d.id));g.push(d)}}s(l,m){const g=this.m.get(m);if(!g)return[];const d=[],S=[];for(const k of g)l.includes(k)?d.push(k):S.push(k);return d.length&&(S.length?this.m.set(m,S):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),d}}O.$uo.add(v.ViewsRegistry,new c),e.$NG=(0,C.$Ii)("viewDescriptorService");var u;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(l,m){this.c=!1,this.d=!1,(0,p.$ko)(this,l),this.d=!!m,this.resolve=async g=>{if(m&&!this.c){const d=await m(g);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$OG=n;class t extends Error{constructor(l){super((0,D.localize)(4219,null,l)),this.name="NoTreeViewError"}static is(l){return!!l&&l.name==="NoTreeViewError"}}e.$PG=t}),define(Oe[193],Ae([1,0,9,31]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=void 0,e.$TG=new D.$Zj("chatSessionResponseVote","",{type:"string",description:(0,y.localize)(4702,null)}),e.$UG=new D.$Zj("chatVoteUpEnabled",!1,{type:"boolean",description:(0,y.localize)(4703,null)}),e.$VG=new D.$Zj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,y.localize)(4704,null)}),e.$WG=new D.$Zj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,y.localize)(4705,null)}),e.$XG=new D.$Zj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,y.localize)(4706,null)}),e.$YG=new D.$Zj("chatSessionResponseError",!1,{type:"boolean",description:(0,y.localize)(4707,null)}),e.$ZG=new D.$Zj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,y.localize)(4708,null)}),e.$1G=new D.$Zj("chatResponse",!1,{type:"boolean",description:(0,y.localize)(4709,null)}),e.$2G=new D.$Zj("chatRequest",!1,{type:"boolean",description:(0,y.localize)(4710,null)}),e.$3G=new D.$Zj("chatEditApplied",!1,{type:"boolean",description:(0,y.localize)(4711,null)}),e.$4G=new D.$Zj("chatInputHasText",!1,{type:"boolean",description:(0,y.localize)(4712,null)}),e.$5G=new D.$Zj("chatInputHasFocus",!1,{type:"boolean",description:(0,y.localize)(4713,null)}),e.$6G=new D.$Zj("inChatInput",!1,{type:"boolean",description:(0,y.localize)(4714,null)}),e.$7G=new D.$Zj("inChat",!1,{type:"boolean",description:(0,y.localize)(4715,null)}),e.$8G=new D.$Zj("chatIsEnabled",!1,{type:"boolean",description:(0,y.localize)(4716,null)}),e.$9G=new D.$Zj("chatCursorAtTop",!1),e.$0G=new D.$Zj("chatInputHasAgent",!1),e.$$G=new D.$Zj("chatLocation",void 0),e.$_G=new D.$Zj("quickChatHasFocus",!1,{type:"boolean",description:(0,y.localize)(4717,null)})}),define(Oe[117],Ae([1,0,284,10,19,6,40,4,33,144,12,31,18,3,11,109,177,187,193]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.ChatAgentLocation=void 0,e.$iI=m,e.$jI=g;var n;(function(d){d.Panel="panel",d.Terminal="terminal",d.Notebook="notebook",d.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(d){function S(k){switch(k){case"panel":return d.Panel;case"terminal":return d.Terminal;case"notebook":return d.Notebook;case"editor":return d.Editor}return d.Panel}d.fromRaw=S}(n||(e.ChatAgentLocation=n={})),e.$dI=(0,E.$Ii)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.f=S,this.b=new Map,this.d=new N.$oe,this.onDidChangeAgents=this.d.event,this.g=new Map,this.i=new Map,this.e=u.$8G.bindTo(this.f)}registerAgent(S,k){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const P=this,R=k.slashCommands;k={...k,get slashCommands(){return R.filter(b=>!b.when||P.f.contextMatchesRules(v.$Gj.deserialize(b.when)))}};const $={data:k};return this.b.set(S,$),(0,O.$Vc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,k){const w=this.b.get(S);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return w.data.isDefault&&this.e.set(!0),w.impl=k,this.d.fire(new o(w.data,k)),(0,O.$Vc)(()=>{w.impl=void 0,this.d.fire(void 0),w.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,k){S.isDynamic=!0;const w={data:S,impl:k};return this.b.set(S.id,w),this.d.fire(new o(S,k)),(0,O.$Vc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,k){return this.g.set(S,k),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,k,w){return await this.g.get(S)?.(k,w)??[]}updateAgent(S,k){const w=this.b.get(S);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);w.data.metadata={...w.data.metadata,...k},this.d.fire(new o(w.data,w.impl))}getDefaultAgent(S){return(0,y.$hb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(S))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const k=this.b.get(S);return!k?.data.when||this.f.contextMatchesRules(v.$Gj.deserialize(k.data.when))}getAgentByFullyQualifiedId(S){const k=T.Iterable.find(this.b.values(),w=>m(w.data)===S)?.data;if(!(k&&!this.h(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new o(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(k=>k.name===S)}agentHasDupeName(S){const k=this.getAgent(S);return k?this.getAgentsByName(k.name).filter(w=>w.extensionId.value!==k.extensionId.value).length>0:!1}async invokeAgent(S,k,w,P,R){const $=this.b.get(S);if(!$?.impl)throw new Error(`No activated agent with id "${S}"`);return await $.impl.invoke(k,w,P,R)}async getFollowups(S,k,w,P,R){const $=this.b.get(S);if(!$?.impl)throw new Error(`No activated agent with id "${S}"`);return $.impl?.provideFollowups?$.impl.provideFollowups(k,w,P,R):[]}async getChatTitle(S,k,w){const P=this.b.get(S);if(!P?.impl)throw new Error(`No activated agent with id "${S}"`);if(P.impl?.provideChatTitle)return P.impl.provideChatTitle(k,w)}registerChatParticipantDetectionProvider(S,k){return this.i.set(S,k),(0,O.$Vc)(()=>{this.i.delete(S)})}hasChatParticipantDetectionProviders(){return this.i.size>0}async detectAgentOrCommand(S,k,w,P){const R=T.Iterable.first(this.i.values());if(!R)return;const $=this.getAgents().reduce((M,Z)=>{M.push({participant:Z.id,disambiguation:Z.disambiguation??[]});for(const G of Z.slashCommands)M.push({participant:Z.id,command:G.name,disambiguation:[]});return M},[]),b=await R.provideParticipantDetection(S,k,{...w,participants:$},P);if(!b)return;const L=this.getAgent(b.participant);if(!L)return;if(!b.command)return{agent:L};const A=L?.slashCommands.find(M=>M.name===b.command);if(A)return{agent:L,command:A}}};e.$eI=t,e.$eI=t=Xe([Qe(0,v.$1j)],t);class o{constructor(S,k){this.b=S,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(S,k,w,P){return this.d.invoke(S,k,w,P)}async provideFollowups(S,k,w,P){return this.d.provideFollowups?this.d.provideFollowups(S,k,w,P):[]}provideWelcomeMessage(S,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,k)}provideSampleQuestions(S,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,k)}toJSON(){return this.b}}e.$fI=o,e.$gI=(0,E.$Ii)("chatAgentNameService");let l=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(S,k,w,P){if(this.g=k,this.h=w,this.i=P,this.e=(0,s.$9d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const R=P.get(i.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(R??"{}"),void 0)}catch{P.remove(i.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,D.$Jh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,a.$eq)(S);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const w=k.restrictedChatParticipants;this.e.set(w,void 0),this.i.store(i.b,JSON.stringify(w),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(S){const k=this.l(S.name,S).get(),w=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return k&&w}l(S,k){return this.e.map(P=>P[S.toLowerCase()]).map(P=>P?P.some(R=>(0,I.$If)(R,R.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$hI=l,e.$hI=l=i=Xe([Qe(0,r.$wk),Qe(1,a.$$p),Qe(2,f.$dk),Qe(3,c.$lq)],l);function m(d){return`${d.extensionId.value}.${d.id}`}function g(d){const S="name"in d?d:{...d,name:d.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new h.$un("")),(0,p.$fi)(S)}}),define(Oe[194],Ae([1,0,2,32,3]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$IH=N,e.$JH=T;function N(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof y.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(D.$Tt.isIRange)}function T(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(N)}var O;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(O||(e.ChatResponseReferencePartStatusKind=O={}));var p;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var s;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(s||(e.ChatCopyKind=s={})),e.$KH=(0,C.$Ii)("IChatService"),e.$LH="accessibility.voice.keywordActivation"}),define(Oe[195],Ae([1,0,6,10,9]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yub=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new y.$oe,this.o=new y.$oe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(O){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=O}onEvent(O){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=O}onRequest(O){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.u("response",O)}sendRequest(O,p,s,I){const v={command:O};if(p&&Object.keys(p).length>0&&(v.arguments=p),this.u("request",v),typeof I=="number"){const h=setTimeout(()=>{clearTimeout(h);const E=this.f.get(v.seq);if(E){this.f.delete(v.seq);const f={type:"response",seq:0,request_seq:v.seq,success:!1,command:O,message:(0,C.localize)(5715,null,I,O)};E(f)}},I)}return s&&this.f.set(v.seq,s),v.seq}acceptMessage(O){this.k?this.k(O):(this.m.push(O),this.m.length===1&&this.s())}q(O,p){return O.type!=="event"||p.type!=="event"}async s(){let O;for(;this.m.length;){if((!O||this.q(this.m[0],O))&&await(0,D.$Jh)(0),O=this.m.shift(),!O)return;switch(O.type){case"event":this.j?.(O);break;case"request":this.g?.(O);break;case"response":{const p=O,s=this.f.get(p.request_seq);s&&(this.f.delete(p.request_seq),s(p));break}}}}u(O,p){p.type=O,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((p,s)=>O.set(s,p)),await(0,D.$Jh)(500),O.forEach((p,s)=>{p({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$yub=N}),define(Oe[81],Ae([1,0,2,9,31,3]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$7K=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$5K=e.MemoryRangeType=e.State=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=void 0,e.$4K=p,e.$6K=I,D=He(D),e.$RJ="workbench.view.debug",e.$SJ="workbench.debug.variablesView",e.$TJ="workbench.debug.watchExpressionsView",e.$UJ="workbench.debug.callStackView",e.$VJ="workbench.debug.loadedScriptsView",e.$WJ="workbench.debug.breakPointsView",e.$XJ="workbench.debug.disassemblyView",e.$YJ="workbench.panel.repl",e.$ZJ="workbench.panel.repl.view",e.$1J=new C.$Zj("debugType",void 0,{type:"string",description:D.localize(5716,null)}),e.$2J=new C.$Zj("debugConfigurationType",void 0,{type:"string",description:D.localize(5717,null)}),e.$3J=new C.$Zj("debugState","inactive",{type:"string",description:D.localize(5718,null)}),e.$4J="debugUx",e.$5J=new C.$Zj(e.$4J,"default",{type:"string",description:D.localize(5719,null)}),e.$6J=new C.$Zj("hasDebugged",!1,{type:"boolean",description:D.localize(5720,null)}),e.$7J=new C.$Zj("inDebugMode",!1,{type:"boolean",description:D.localize(5721,null)}),e.$8J=new C.$Zj("inDebugRepl",!1,{type:"boolean",description:D.localize(5722,null)}),e.$9J=new C.$Zj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(5723,null)}),e.$0J=new C.$Zj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(5724,null)}),e.$$J=new C.$Zj("breakpointsFocused",!0,{type:"boolean",description:D.localize(5725,null)}),e.$_J=new C.$Zj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(5726,null)}),e.$aK=new C.$Zj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(5727,null)}),e.$bK=new C.$Zj("variablesFocused",!0,{type:"boolean",description:D.localize(5728,null)}),e.$cK=new C.$Zj("expressionSelected",!1,{type:"boolean",description:D.localize(5729,null)}),e.$dK=new C.$Zj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(5730,null)}),e.$eK=new C.$Zj("callStackItemType",void 0,{type:"string",description:D.localize(5731,null)}),e.$fK=new C.$Zj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(5732,null)}),e.$gK=new C.$Zj("callStackItemStopped",!1,{type:"boolean",description:D.localize(5733,null)}),e.$hK=new C.$Zj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(5734,null)}),e.$iK=new C.$Zj("watchItemType",void 0,{type:"string",description:D.localize(5735,null)}),e.$jK=new C.$Zj("canViewMemory",void 0,{type:"boolean",description:D.localize(5736,null)}),e.$kK=new C.$Zj("breakpointItemType",void 0,{type:"string",description:D.localize(5737,null)}),e.$lK=new C.$Zj("breakpointItemBytes",void 0,{type:"boolean",description:D.localize(5738,null)}),e.$mK=new C.$Zj("breakpointHasModes",!1,{type:"boolean",description:D.localize(5739,null)}),e.$nK=new C.$Zj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(5740,null)}),e.$oK=new C.$Zj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(5741,null)}),e.$pK=new C.$Zj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(5742,null)}),e.$qK=new C.$Zj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(5743,null)}),e.$rK=new C.$Zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(5744,null)}),e.$sK=new C.$Zj("stepBackSupported",!1,{type:"boolean",description:D.localize(5745,null)}),e.$tK=new C.$Zj("restartFrameSupported",!1,{type:"boolean",description:D.localize(5746,null)}),e.$uK=new C.$Zj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(5747,null)}),e.$vK=new C.$Zj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(5748,null)}),e.$wK=new C.$Zj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(5749,null)}),e.$xK=new C.$Zj("breakpointsExist",!1,{type:"boolean",description:D.localize(5750,null)}),e.$yK=new C.$Zj("debuggersAvailable",!1,{type:"boolean",description:D.localize(5751,null)}),e.$zK=new C.$Zj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(5752,null)}),e.$AK=new C.$Zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(5753,null)}),e.$BK=new C.$Zj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(5754,null)}),e.$CK=new C.$Zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:D.localize(5755,null)}),e.$DK=new C.$Zj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(5756,null)}),e.$EK=new C.$Zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(5757,null)}),e.$FK=new C.$Zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(5758,null)}),e.$GK=new C.$Zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(5759,null)}),e.$HK=new C.$Zj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(5760,null)}),e.$IK=new C.$Zj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(5761,null)}),e.$JK=new C.$Zj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(5762,null)}),e.$KK=new C.$Zj("variableIsReadonly",!1,{type:"boolean",description:D.localize(5763,null)}),e.$LK=new C.$Zj("variableValue",!1,{type:"string",description:D.localize(5764,null)}),e.$MK=new C.$Zj("variableType",!1,{type:"string",description:D.localize(5765,null)}),e.$NK=new C.$Zj("variableInterfaces",!1,{type:"array",description:D.localize(5766,null)}),e.$OK=new C.$Zj("variableName",!1,{type:"string",description:D.localize(5767,null)}),e.$PK=new C.$Zj("variableLanguage",!1,{type:"string",description:D.localize(5768,null)}),e.$QK=new C.$Zj("variableExtensionId",!1,{type:"string",description:D.localize(5769,null)}),e.$RK=new C.$Zj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(5770,null)}),e.$SK=new C.$Zj("multiSessionRepl",!1,{type:"boolean",description:D.localize(5771,null)}),e.$TK=new C.$Zj("multiSessionDebug",!1,{type:"boolean",description:D.localize(5772,null)}),e.$UK=new C.$Zj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(5773,null)}),e.$VK=new C.$Zj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(5774,null)}),e.$WK=new C.$Zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(5775,null)}),e.$XK=new C.$Zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(5776,null)});const T=i=>D.localize(5777,null,i);e.$YK=T,e.$ZK="editor.contrib.debug",e.$1K="editor.contrib.breakpoint",e.$2K="debug",e.$3K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(5778,null)};var O;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(O||(e.State=O={}));function p(i){switch(i){case O.Initializing:return"initializing";case O.Stopped:return"stopped";case O.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$5K="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var v;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(v||(e.DataBreakpointSetType=v={}));var h;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(h||(e.DebugConfigurationProviderTriggerKind=h={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$7K=(0,N.$Ii)("debugService");var f;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var a;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var c;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(c||(e.IDebugVisualizationTreeItem=c={}));var u;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:y.URI.revive(n.iconPath.light),dark:y.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(u||(e.IDebugVisualization=u={}))}),define(Oe[196],Ae([1,0,12,2,20,25,15,32,19,17]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yI=void 0,e.$mI=v,e.$nI=h,e.$oI=E,e.$pI=f,e.$qI=r,e.$rI=a,e.$sI=c,e.$tI=i,e.$uI=o,e.$vI=l,e.$wI=g,e.$xI=S;const I=/{([^}]+)}/g;function v(w,P,R){return w.replace(I,function($,b){return P&&b.length>0&&b[0]!=="_"?$:R&&R.hasOwnProperty(b)?R[b]:$})}function h(w){const P={};for(const R of Object.keys(w))R.startsWith("!")||(P[R]=w[R]);return P}function E(w){return w.configuration.request==="attach"&&!f(w)&&(!w.parentSession||E(w.parentSession))}function f(w){let P=w.configuration.type;if(P)return P==="vslsShare"&&(P=w.configuration.adapterProxy.configuration.type),(0,y.$If)(P,"extensionhost")||(0,y.$If)(P,"pwa-extensionhost")?w:w.parentSession?f(w.parentSession):void 0}function r(w){return w.type&&(w.label||w.program||w.runtime)}function a(w,P,R){let $,b=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let A=null;for(;A=L.exec(w);){const M=A.index+1,Z=M+A[0].length;if(M<=P&&Z>=R){$=A[0],b=M;break}}if($){const M=/(\w|\p{L})+/gu;let Z=null;for(;(Z=M.exec($))&&!(Z.index+1+b+Z[0].length>=R););Z&&($=$.substring(0,M.lastIndex))}return $?{start:b,end:b+$.length-1}:{start:0,end:0}}async function c(w,P,R,$){if(w.evaluatableExpressionProvider.has(P)){const b=w.evaluatableExpressionProvider.ordered(P),L=(0,s.$Jb)(await Promise.all(b.map(async A=>{try{return await A.provideEvaluatableExpression(P,R,$??p.CancellationToken.None)}catch{return}})));if(L.length>0){let A=L[0].expression;const M=L[0].range;return A||(A=P.getLineContent(R.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:A}}}else{const b=P.getLineContent(R.lineNumber),{start:L,end:A}=a(b,R.column,R.column),M=b.substring(L-1,A);return{matchingExpression:M,range:new O.$Tt(R.lineNumber,L,R.lineNumber,L+M.length)}}return null}const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(w){return!!(w&&w.match(u))}function n(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(i(w.path))return D.URI.parse(w.path);if((0,C.$lc)(w.path))return D.URI.file(w.path)}return w.path}function t(w){if(typeof w.path=="object"){const P=D.URI.revive(w.path);if(P)return P.scheme===T.Schemas.file?P.fsPath:P.toString()}return w.path}function o(w,P){const R=P?n:t,$=(0,N.$ho)(w);return m($,(b,L)=>{b&&L&&(L.path=R(L))}),$}function l(w,P){const R=P?n:t,$=(0,N.$ho)(w);return m($,(b,L)=>{!b&&L&&(L.path=R(L))}),$}function m(w,P){switch(w.type){case"event":{const R=w;switch(R.event){case"output":P(!1,R.body.source);break;case"loadedSource":P(!1,R.body.source);break;case"breakpoint":P(!1,R.body.breakpoint.source);break;default:break}break}case"request":{const R=w;switch(R.command){case"setBreakpoints":P(!0,R.arguments.source);break;case"breakpointLocations":P(!0,R.arguments.source);break;case"source":P(!0,R.arguments.source);break;case"gotoTargets":P(!0,R.arguments.source);break;case"launchVSCode":R.arguments.args.forEach($=>P(!1,$));break;default:break}break}case"response":{const R=w;if(R.success&&R.body)switch(R.command){case"stackTrace":R.body.stackFrames.forEach($=>P(!1,$.source));break;case"loadedSources":R.body.sources.forEach($=>P(!1,$));break;case"scopes":R.body.scopes.forEach($=>P(!1,$.source));break;case"setFunctionBreakpoints":R.body.breakpoints.forEach($=>P(!1,$.source));break;case"setBreakpoints":R.body.breakpoints.forEach($=>P(!1,$.source));break;case"disassemble":R.body?.instructions.forEach(b=>P(!1,b.location));break;default:break}break}}}function g(w){return w.filter(P=>!P.presentation?.hidden).sort((P,R)=>P.presentation?R.presentation?P.presentation.group?R.presentation.group?P.presentation.group!==R.presentation.group?P.presentation.group.localeCompare(R.presentation.group):d(P.presentation.order,R.presentation.order):-1:R.presentation.group?1:d(P.presentation.order,R.presentation.order):-1:R.presentation?1:0)}function d(w,P){return typeof w!="number"?typeof P!="number"?0:1:typeof P!="number"?-1:w-P}async function S(w,P){const R=w.getValue("debug.saveBeforeStart",{overrideIdentifier:P.activeTextEditorLanguageId});if(R!=="none"&&(await P.saveAll(),R==="allEditorsInActiveGroup")){const $=P.activeEditorPane;$&&$.input.resource?.scheme===T.Schemas.untitled&&await P.save({editor:$.input,groupId:$.group.id})}await w.reloadConfiguration()}const k=(w,P)=>!w||!P?w===P:w.name===P.name&&w.path===P.path&&w.sourceReference===P.sourceReference;e.$yI=k}),define(Oe[197],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cL=e.CellExecutionUpdateType=void 0;var D;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(D||(e.CellExecutionUpdateType=D={})),e.$cL=(0,y.$Ii)("INotebookExecutionService")}),define(Oe[198],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.$fL=e.ProxyKernelState=e.$eL=void 0,e.$eL=100;var D;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(D||(e.ProxyKernelState=D={})),e.$fL=(0,y.$Ii)("INotebookKernelService"),e.$gL=(0,y.$Ii)("INotebookKernelHistoryService")}),define(Oe[199],Ae([1,0,4,32,53,163,103]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m2b=void 0;class O extends y.$Xc{constructor(s,I,v){super(),this._source=s,this.b=I,this.c=v,this.a=void 0}f(s){const I=s.getLineCount();return new D.$Tt(1,1,I,this.g(s,I))}g(s,I){if(I<1||I>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const s=new N.$GD;s.acceptChunk(this._source);const I=s.finish(!0),{textBuffer:v,disposable:h}=I.create(C.DefaultEndOfLine.LF);this.b=v,this.B(h)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const I=new N.$GD;I.acceptChunk(s);const v=I.finish(!0),{textBuffer:h,disposable:E}=v.create(C.DefaultEndOfLine.LF);return this.B(E),h})),this.a}findInInputs(s){const v=new T.$uD(s,!1,!1,null).parseSearchRequest();if(!v)return[];const h=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(h,v,!0,5e3)}findInOutputs(s){const v=new T.$uD(s,!1,!1,null).parseSearchRequest();return v?this.outputTextBuffers.map(h=>{const E=h.findMatchesLineByLine(this.f(h),v,!0,5e3);if(E.length!==0)return{textBuffer:h,matches:E}}).filter(h=>!!h):[]}}e.$m2b=O}),define(Oe[55],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(N){N.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var D;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(D||(e.TestPosition=D={}));class C{static fromExtHostTestItem(T,O,p=T.parent){if(T._isRoot)return new C([O]);const s=[T.id];for(let I=p;I&&I.id!==O;I=I.parent)s.push(I.id);return s.push(O),new C(s.reverse())}static isRoot(T){return!T.includes(y.Delimiter)}static root(T){const O=T.indexOf(y.Delimiter);return O===-1?T:T.slice(0,O)}static fromString(T){return new C(T.split(y.Delimiter))}static join(T,O){return new C([...T.path,O])}static joinToString(T,O){return T.toString()+y.Delimiter+O}static parentId(T){const O=T.lastIndexOf(y.Delimiter);return O===-1?void 0:T.slice(0,O)}static localId(T){const O=T.lastIndexOf(y.Delimiter);return O===-1?T:T.slice(O+y.Delimiter.length)}static isChild(T,O){return O[T.length]===y.Delimiter&&O.startsWith(T)}static compare(T,O){return T===O?D.IsSame:C.isChild(T,O)?D.IsChild:C.isChild(O,T)?D.IsParent:D.Disconnected}static getLengthOfCommonPrefix(T,O){if(T===0)return 0;let p=0;for(;p<T-1;){for(let s=1;s<T;s++){const I=O(s-1),v=O(s);if(I.path[p]!==v.path[p])return p}p++}return p}constructor(T,O=T.length){if(this.path=T,this.d=O,T.length===0||O<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new C(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new C(this.path,T)}compare(T){if(typeof T=="string")return C.compare(this.toString(),T);for(let O=0;O<T.d&&O<this.d;O++)if(T.path[O]!==this.path[O])return D.Disconnected;return T.d>this.d?D.IsChild:T.d<this.d?D.IsParent:D.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+=y.Delimiter,this.c+=this.path[T]}return this.c}}e.$lJ=C}),define(Oe[56],Ae([1,0,2,102,32,55]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$tJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$sJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$rJ=e.$qJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$pJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$oJ=e.$nJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$mJ=e.TestResultState=void 0;var T;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(T||(e.TestResultState=T={})),e.$mJ={[T.Unset]:"unset",[T.Queued]:"queued",[T.Running]:"running",[T.Passed]:"passed",[T.Failed]:"failed",[T.Skipped]:"skipped",[T.Errored]:"errored"};var O;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var p;(function(V){V[V.Refresh=2]="Refresh",V[V.CodeRelatedToTest=4]="CodeRelatedToTest",V[V.TestRelatedToCode=8]="TestRelatedToCode"})(p||(e.TestControllerCapability=p={}));var s;(function(V){V[V.Run=2]="Run",V[V.Debug=4]="Debug",V[V.Coverage=8]="Coverage",V[V.HasNonDefaultProfile=16]="HasNonDefaultProfile",V[V.HasConfigurable=32]="HasConfigurable",V[V.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.$nJ=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const I=V=>"runId"in V;e.$oJ=I;var v;(function(V){V.serialize=Q=>({range:Q.range.toJSON(),uri:Q.uri.toJSON()}),V.deserialize=(Q,ne)=>({range:C.$Tt.lift(ne.range),uri:Q.asCanonicalUri(y.URI.revive(ne.uri))})})(v||(e.IRichLocation=v={}));var h;(function(V){V[V.Error=0]="Error",V[V.Output=1]="Output"})(h||(e.TestMessageType=h={}));var E;(function(V){V.serialize=Q=>({label:Q.label,uri:Q.uri?.toJSON(),position:Q.position?.toJSON()}),V.deserialize=(Q,ne)=>({label:ne.label,uri:ne.uri?Q.asCanonicalUri(y.URI.revive(ne.uri)):void 0,position:ne.position?D.$St.lift(ne.position):void 0})})(E||(e.ITestMessageStackFrame=E={}));var f;(function(V){V.serialize=Q=>({message:Q.message,type:h.Error,expected:Q.expected,actual:Q.actual,contextValue:Q.contextValue,location:Q.location&&v.serialize(Q.location),stackTrace:Q.stackTrace?.map(E.serialize)}),V.deserialize=(Q,ne)=>({message:ne.message,type:h.Error,expected:ne.expected,actual:ne.actual,contextValue:ne.contextValue,location:ne.location&&v.deserialize(Q,ne.location),stackTrace:ne.stackTrace&&ne.stackTrace.map(ue=>E.deserialize(Q,ue))})})(f||(e.ITestErrorMessage=f={}));const r=(V,Q)=>`${Q?"s":"e"}${V}`;e.$pJ=r;var a;(function(V){V.serialize=Q=>({message:Q.message,type:h.Output,offset:Q.offset,length:Q.length,location:Q.location&&v.serialize(Q.location)}),V.deserialize=(Q,ne)=>({message:ne.message,type:h.Output,offset:ne.offset,length:ne.length,location:ne.location&&v.deserialize(Q,ne.location)})})(a||(e.ITestOutputMessage=a={}));var c;(function(V){V.serialize=Q=>Q.type===h.Error?f.serialize(Q):a.serialize(Q),V.deserialize=(Q,ne)=>ne.type===h.Error?f.deserialize(Q,ne):a.deserialize(Q,ne),V.isDiffable=Q=>Q.type===h.Error&&Q.actual!==void 0&&Q.expected!==void 0})(c||(e.ITestMessage=c={}));var u;(function(V){V.serializeWithoutMessages=Q=>({state:Q.state,duration:Q.duration,messages:[]}),V.serialize=Q=>({state:Q.state,duration:Q.duration,messages:Q.messages.map(c.serialize)}),V.deserialize=(Q,ne)=>({state:ne.state,duration:ne.duration,messages:ne.messages.map(ue=>c.deserialize(Q,ue))})})(u||(e.ITestTaskState=u={}));const i="\0",n=(V,Q)=>V+i+Q;e.$qJ=n;const t=V=>{const Q=V.indexOf(i);return{ctrlId:V.slice(0,Q),tagId:V.slice(Q+1)}};e.$rJ=t;var o;(function(V){V.serialize=Q=>({extId:Q.extId,label:Q.label,tags:Q.tags,busy:Q.busy,children:void 0,uri:Q.uri?.toJSON(),range:Q.range?.toJSON()||null,description:Q.description,error:Q.error,sortText:Q.sortText}),V.deserialize=(Q,ne)=>({extId:ne.extId,label:ne.label,tags:ne.tags,busy:ne.busy,children:void 0,uri:ne.uri?Q.asCanonicalUri(y.URI.revive(ne.uri)):void 0,range:ne.range?C.$Tt.lift(ne.range):null,description:ne.description,error:ne.error,sortText:ne.sortText})})(o||(e.ITestItem=o={}));var l;(function(V){V[V.NotExpandable=0]="NotExpandable",V[V.Expandable=1]="Expandable",V[V.BusyExpanding=2]="BusyExpanding",V[V.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var m;(function(V){V.serialize=Q=>({expand:Q.expand,item:o.serialize(Q.item)}),V.deserialize=(Q,ne)=>({controllerId:N.$lJ.root(ne.item.extId),expand:ne.expand,item:o.deserialize(Q,ne.item)})})(m||(e.InternalTestItem=m={}));var g;(function(V){V.serialize=Q=>{let ne;return Q.item&&(ne={},Q.item.label!==void 0&&(ne.label=Q.item.label),Q.item.tags!==void 0&&(ne.tags=Q.item.tags),Q.item.busy!==void 0&&(ne.busy=Q.item.busy),Q.item.uri!==void 0&&(ne.uri=Q.item.uri?.toJSON()),Q.item.range!==void 0&&(ne.range=Q.item.range?.toJSON()),Q.item.description!==void 0&&(ne.description=Q.item.description),Q.item.error!==void 0&&(ne.error=Q.item.error),Q.item.sortText!==void 0&&(ne.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:ne}},V.deserialize=Q=>{let ne;return Q.item&&(ne={},Q.item.label!==void 0&&(ne.label=Q.item.label),Q.item.tags!==void 0&&(ne.tags=Q.item.tags),Q.item.busy!==void 0&&(ne.busy=Q.item.busy),Q.item.range!==void 0&&(ne.range=Q.item.range?C.$Tt.lift(Q.item.range):null),Q.item.description!==void 0&&(ne.description=Q.item.description),Q.item.error!==void 0&&(ne.error=Q.item.error),Q.item.sortText!==void 0&&(ne.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:ne}}})(g||(e.ITestItemUpdate=g={}));const d=(V,Q)=>{Q.expand!==void 0&&(V.expand=Q.expand),Q.item!==void 0&&(V.item=V.item?Object.assign(V.item,Q.item):Q.item)};e.$sJ=d;var S;(function(V){V.serializeWithoutMessages=Q=>({...m.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(u.serializeWithoutMessages)}),V.serialize=Q=>({...m.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(u.serialize)}),V.deserialize=(Q,ne)=>({...m.deserialize(Q,ne),ownComputedState:ne.ownComputedState,computedState:ne.computedState,tasks:ne.tasks.map(ue=>u.deserialize(Q,ue)),retired:!0})})(S||(e.TestResultItem=S={}));var k;(function(V){V.empty=()=>({covered:0,total:0}),V.sum=(Q,ne)=>{Q.covered+=ne.covered,Q.total+=ne.total}})(k||(e.ICoverageCount=k={}));var w;(function(V){V.serialize=Q=>({id:Q.id,statement:Q.statement,branch:Q.branch,declaration:Q.declaration,testIds:Q.testIds,uri:Q.uri.toJSON()}),V.deserialize=(Q,ne)=>({id:ne.id,statement:ne.statement,branch:ne.branch,declaration:ne.declaration,testIds:ne.testIds,uri:Q.asCanonicalUri(y.URI.revive(ne.uri))}),V.empty=(Q,ne)=>({id:Q,uri:ne,statement:k.empty()})})(w||(e.IFileCoverage=w={}));function P(V){return{...V,location:V.location?.toJSON()}}function R(V){return V.location=V.location?D.$St.isIPosition(V.location)?D.$St.lift(V.location):C.$Tt.lift(V.location):void 0,V}e.$tJ=3;var $;(function(V){V[V.Declaration=0]="Declaration",V[V.Statement=1]="Statement",V[V.Branch=2]="Branch"})($||(e.DetailType=$={}));var b;(function(V){V.serialize=Q=>Q.type===$.Declaration?A.serialize(Q):M.serialize(Q),V.deserialize=Q=>Q.type===$.Declaration?A.deserialize(Q):M.deserialize(Q)})(b||(e.CoverageDetails=b={}));var L;(function(V){V.serialize=P,V.deserialize=R})(L||(e.IBranchCoverage=L={}));var A;(function(V){V.serialize=P,V.deserialize=R})(A||(e.IDeclarationCoverage=A={}));var M;(function(V){V.serialize=Q=>({...P(Q),branches:Q.branches?.map(L.serialize)}),V.deserialize=Q=>({...R(Q),branches:Q.branches?.map(L.deserialize)})})(M||(e.IStatementCoverage=M={}));var Z;(function(V){V[V.Add=0]="Add",V[V.Update=1]="Update",V[V.DocumentSynced=2]="DocumentSynced",V[V.Remove=3]="Remove",V[V.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",V[V.Retire=5]="Retire",V[V.AddTag=6]="AddTag",V[V.RemoveTag=7]="RemoveTag"})(Z||(e.TestDiffOpType=Z={}));var G;(function(V){V.deserialize=(Q,ne)=>ne.op===Z.Add?{op:ne.op,item:m.deserialize(Q,ne.item)}:ne.op===Z.Update?{op:ne.op,item:g.deserialize(ne.item)}:ne.op===Z.DocumentSynced?{op:ne.op,uri:Q.asCanonicalUri(y.URI.revive(ne.uri)),docv:ne.docv}:ne,V.serialize=Q=>Q.op===Z.Add?{op:Q.op,item:m.serialize(Q.item)}:Q.op===Z.Update?{op:Q.op,item:g.serialize(Q.item)}:Q})(G||(e.TestsDiffOp=G={}));class U{constructor(Q){this.l=Q,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(Q){const ne=this.x();for(const ue of Q)switch(ue.op){case Z.Add:this.p(m.deserialize(this.l,ue.item),ne);break;case Z.Update:this.q(g.deserialize(ue.item),ne);break;case Z.Remove:this.v(ue.itemId,ne);break;case Z.Retire:this.w(ue.itemId);break;case Z.IncrementPendingExtHosts:this.updatePendingRoots(ue.amount);break;case Z.AddTag:this.f.set(ue.tag.id,ue.tag);break;case Z.RemoveTag:this.f.delete(ue.id);break}ne.complete?.()}p(Q,ne){const ue=N.$lJ.parentId(Q.item.extId)?.toString();let x;if(!ue)x=this.y(Q),this.h.add(x),this.g.set(Q.item.extId,x);else if(this.g.has(ue)){const oe=this.g.get(ue);oe.children.add(Q.item.extId),x=this.y(Q,oe),this.g.set(Q.item.extId,x)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(Q)}`);return}return ne.add?.(x),Q.expand===l.BusyExpanding&&this.j++,x}q(Q,ne){const ue=this.g.get(Q.extId);if(ue)return Q.expand!==void 0&&(ue.expand===l.BusyExpanding&&this.j--,Q.expand===l.BusyExpanding&&this.j++),(0,e.$sJ)(ue,Q),ne.update?.(ue),ue}v(Q,ne){const ue=this.g.get(Q);if(!ue)return;const x=N.$lJ.parentId(ue.item.extId)?.toString();x?this.g.get(x).children.delete(ue.item.extId):this.h.delete(ue);const oe=[[Q]];for(;oe.length;)for(const se of oe.pop()){const ce=this.g.get(se);ce&&(oe.push(ce.children),this.g.delete(se),ne.remove?.(ce,ce!==ue),ce.expand===l.BusyExpanding&&this.j--)}}w(Q){}updatePendingRoots(Q){this.k+=Q}x(){return{}}}e.$uJ=U}),define(Oe[200],Ae([1,0,99,9,56]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$eHb=e.$dHb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var N;(function(v){v.ViewletId="workbench.view.extension.test",v.ExplorerViewId="workbench.view.testing",v.OutputPeekContributionId="editor.contrib.testingOutputPeek",v.DecorationsContributionId="editor.contrib.testingDecorations",v.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",v.CoverageViewId="workbench.view.testCoverage",v.ResultsPanelId="workbench.panel.testResults",v.ResultsViewId="workbench.panel.testResults.view",v.MessageLanguageId="vscodeInternalTestMessage"})(N||(e.Testing=N={}));var T;(function(v){v.List="list",v.Tree="true"})(T||(e.TestExplorerViewMode=T={}));var O;(function(v){v.ByLocation="location",v.ByStatus="status",v.ByDuration="duration"})(O||(e.TestExplorerViewSorting=O={}));const p={[C.TestResultState.Errored]:(0,D.localize)(10835,null),[C.TestResultState.Failed]:(0,D.localize)(10836,null),[C.TestResultState.Passed]:(0,D.localize)(10837,null),[C.TestResultState.Queued]:(0,D.localize)(10838,null),[C.TestResultState.Running]:(0,D.localize)(10839,null),[C.TestResultState.Skipped]:(0,D.localize)(10840,null),[C.TestResultState.Unset]:(0,D.localize)(10841,null)},s=(v,h)=>(0,D.localize)(10842,null,(0,y.$3k)(v),p[h]);e.$dHb=s,e.$eHb={[C.TestRunProfileBitset.Debug]:(0,D.localize)(10843,null),[C.TestRunProfileBitset.Run]:(0,D.localize)(10844,null),[C.TestRunProfileBitset.Coverage]:(0,D.localize)(10845,null)};var I;(function(v){v.CancelTestRefreshAction="testing.cancelTestRefresh",v.CancelTestRunAction="testing.cancelRun",v.ClearTestResultsAction="testing.clearTestResults",v.CollapseAllAction="testing.collapseAll",v.ConfigureTestProfilesAction="testing.configureProfile",v.ContinousRunUsingForTest="testing.continuousRunUsingForTest",v.CoverageAtCursor="testing.coverageAtCursor",v.CoverageByUri="testing.coverage.uri",v.CoverageClear="testing.coverage.close",v.CoverageCurrentFile="testing.coverageCurrentFile",v.CoverageFilterToTest="testing.coverageFilterToTest",v.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",v.CoverageLastRun="testing.coverageLastRun",v.CoverageSelectedAction="testing.coverageSelected",v.CoverageToggleToolbar="testing.coverageToggleToolbar",v.CoverageViewChangeSorting="testing.coverageViewChangeSorting",v.DebugAction="testing.debug",v.DebugAllAction="testing.debugAll",v.DebugAtCursor="testing.debugAtCursor",v.DebugByUri="testing.debug.uri",v.DebugCurrentFile="testing.debugCurrentFile",v.DebugFailedTests="testing.debugFailTests",v.DebugLastRun="testing.debugLastRun",v.DebugSelectedAction="testing.debugSelected",v.FilterAction="workbench.actions.treeView.testExplorer.filter",v.GetExplorerSelection="_testing.getExplorerSelection",v.GetSelectedProfiles="testing.getSelectedProfiles",v.GoToTest="testing.editFocusedTest",v.GoToRelatedTest="testing.goToRelatedTest",v.PeekRelatedTest="testing.peekRelatedTest",v.GoToRelatedCode="testing.goToRelatedCode",v.PeekRelatedCode="testing.peekRelatedCode",v.HideTestAction="testing.hideTest",v.OpenCoverage="testing.openCoverage",v.OpenOutputPeek="testing.openOutputPeek",v.RefreshTestsAction="testing.refreshTests",v.ReRunFailedTests="testing.reRunFailTests",v.ReRunLastRun="testing.reRunLastRun",v.RunAction="testing.run",v.RunAllAction="testing.runAll",v.RunAllWithCoverageAction="testing.coverageAll",v.RunAtCursor="testing.runAtCursor",v.RunByUri="testing.run.uri",v.RunCurrentFile="testing.runCurrentFile",v.RunSelectedAction="testing.runSelected",v.RunUsingProfileAction="testing.runUsing",v.RunWithCoverageAction="testing.coverage",v.SearchForTestExtension="testing.searchForTestExtension",v.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",v.ShowMostRecentOutputAction="testing.showMostRecentOutput",v.StartContinousRun="testing.startContinuousRun",v.StopContinousRun="testing.stopContinuousRun",v.TestingSortByDurationAction="testing.sortByDuration",v.TestingSortByLocationAction="testing.sortByLocation",v.TestingSortByStatusAction="testing.sortByStatus",v.TestingViewAsListAction="testing.viewAsList",v.TestingViewAsTreeAction="testing.viewAsTree",v.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",v.ToggleInlineTestOutput="testing.toggleInlineTestOutput",v.UnhideAllTestsAction="testing.unhideAllTests",v.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Oe[82],Ae([1,0,10,6,4,62,56,55]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.TestItemEventOp=void 0;var p;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const s=(u,i)=>u===i,v=Object.entries({range:(u,i)=>u===i?!0:!u||!i?!1:u.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(u,i)=>!(u.length!==i.length||u.some(n=>!i.includes(n)))}),h=(u,i)=>{let n;for(const[t,o]of v)o(u[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class E extends C.$Xc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new y.$Uh(()=>this.flushDiff(),200)),this.g=this.B(new D.$oe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case T.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===T.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case T.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===T.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,T.$sJ)(n.item,i.item);return}if(n.op===T.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,T.$sJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===T.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,n-1):o.wait().then(()=>this.L(t,n-1))}else if(t.expand===T.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case p.RemoveChild:this.O(O.$lJ.joinToString(i.fullId,n.id));break;case p.Upsert:this.z(n.item,i);break;case p.Bulk:for(const t of n.ops)this.w(i,t);break;case p.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,N.$hd)(n)}}y(i){i&&this.pushDiff({op:T.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=O.$lJ.fromExtHostTestItem(i,this.root.id,n?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==n?.actual&&this.s.getChildren(o.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:T.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,n),this.pushDiff({op:T.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,n);return}if(l.actual===i){this.H(i,l,n);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const m=this.s.getChildren(l.actual),g=l.actual,d=h(this.s.toITestItem(g),this.s.toITestItem(i));this.s.getApiFor(g).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=T.TestItemExpandState.NotExpandable,d&&(d.hasOwnProperty("tags")&&(this.C(i.tags,g.tags,t.toString()),delete d.tags),this.w(l,{op:p.SetProp,update:d})),this.I(i,l,n);for(const[k,w]of m)this.s.getChildren(i).get(w.id)||this.O(O.$lJ.joinToString(t,w.id));const S=l.expandLevels;S!==void 0&&queueMicrotask(()=>{l.expand===T.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(l.actual.uri)}C(i,n,t){const o=new Set(n.map(l=>l.id));for(const l of i)o.delete(l.id)||this.D(l);this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,T.$qJ)(this.s.controllerId,l.id))}}}),o.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:T.TestDiffOpType.AddTag,tag:{id:(0,T.$qJ)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:T.TestDiffOpType.RemoveTag,id:(0,T.$qJ)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=l=>this.w(n,l),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[o,l]of this.s.getChildren(i))this.z(l,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?T.TestItemExpandState.Expanded:T.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?T.TestItemExpandState.Expandable:T.TestItemExpandState.NotExpandable:n=T.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===T.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[o,l]of this.s.getChildren(i.actual)){const m=this.expand(O.$lJ.joinToString(i.fullId,l.id),n);(0,y.$uh)(m)&&t.push(m)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new y.$Hh;return l.open(),l}i.expand=T.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new y.$Hh,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,y.$uh)(o)?o.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:T.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const l of o.actual.tags)this.F(l.id);this.tree.delete(o.fullId.toString());for(const[l,m]of this.s.getChildren(o.actual))t.push(this.tree.get(O.$lJ.joinToString(o.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$tQ=E;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$uQ=f;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$vQ=r;class a extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$wQ=a;const c=(u,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(o,l){for(const m of t.values())o.call(l,m,this)},[Symbol.iterator](){return t.entries()},replace(o){const l=new Map,m=new Set(t.keys()),g={op:p.Bulk,ops:[]};for(const d of o){if(!(d instanceof n))throw new r(d.id);const S=i(d).controllerId;if(S!==u.controllerId)throw new a(d.id,S,u.controllerId);if(l.has(d.id))throw new f(d.id);l.set(d.id,d),m.delete(d.id),g.ops.push({op:p.Upsert,item:d})}for(const d of m.keys())g.ops.push({op:p.RemoveChild,id:d});u.listener?.(g),t=l},add(o){if(!(o instanceof n))throw new r(o.id);t.set(o.id,o),u.listener?.({op:p.Upsert,item:o})},delete(o){t.delete(o)&&u.listener?.({op:p.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$xQ=c}),define(Oe[118],Ae([1,0,82]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=void 0;const D=new WeakMap,C=(T,O)=>{const p={controllerId:O};return D.set(T,p),p};e.$yQ=C;const N=T=>{const O=D.get(T);if(!O)throw new y.$vQ(T?.id||"<unknown>");return O};e.$zQ=N}),define(Oe[83],Ae([1,0,27,15,2]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Db=e.$8Db=e.$7Db=void 0,e.$0Db=N,e.$$Db=O,e.$7Db="vscode-cdn.net",e.$8Db=`vscode-resource.${e.$7Db}`,e.$9Db=`'self' https://*.${e.$7Db}`;function N(p,s){return p.scheme===D.Schemas.http||p.scheme===D.Schemas.https?p:(s&&s.authority&&s.isRemote&&p.scheme===D.Schemas.file&&(p=C.URI.from({scheme:D.Schemas.vscodeRemote,authority:s.authority,path:p.path})),C.URI.from({scheme:D.Schemas.https,authority:`${p.scheme}+${T(p.authority)}.${e.$8Db}`,path:p.path,fragment:p.fragment,query:p.query}))}function T(p){return p.replace(/./g,s=>{const I=s.charCodeAt(0);return I>=y.CharCode.a&&I<=y.CharCode.z||I>=y.CharCode.A&&I<=y.CharCode.Z||I>=y.CharCode.Digit0&&I<=y.CharCode.Digit9?s:"-"+I.toString(16).padStart(4,"0")})}function O(p){return p.replace(/-([0-9a-f]{4})/g,(s,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Oe[201],Ae([1,0,6,4,83]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0;class N{constructor(O,p,s){this.d=O,this.e=p,this.f=s,this.a=0,this.b=new D.$Wc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const v of this.c.values())I.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,p,s,I,v){let h;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===O){h=i;break}if(!h)throw new Error("not a visible editor");const E=this,f=this.a++,r=new y.$oe,a=new y.$oe,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$0Db)(i,E.f)}get cspSource(){return C.$9Db}set options(i){this.b=i,E.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return E.d.$postMessage(f,i)}},u=new class{constructor(){this.editor=O,this.line=p,this.height=s,this.webview=c,this.onDidDispose=a.event}dispose(){E.c.has(f)&&(E.c.delete(f),E.d.$disposeEditorInset(f),a.fire(),a.dispose(),r.dispose())}};return this.d.$createEditorInset(f,h.id,h.value.document.uri,p+1,s,I||{},v.identifier,v.extensionLocation),this.c.set(f,{editor:O,inset:u,onDidReceiveMessage:r}),u}$onDidDispose(O){const p=this.c.get(O);p&&p.inset.dispose()}$onDidReceiveMessage(O,p){this.c.get(O)?.onDidReceiveMessage.fire(p)}}e.$Gqc=N}),define(Oe[119],Ae([1,0,3]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=e.$4M=void 0,e.$4M="__",e.$5M=(0,y.$Ii)("IAuthenticationService"),e.$6M=(0,y.$Ii)("IAuthenticationExtensionsService")}),define(Oe[202],Ae([1,0,3,13]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=e.VariableKind=e.$rR=void 0,e.$rR=(0,y.$Ii)("configurationResolverService");var C;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(C||(e.VariableKind=C={}));class N extends D.$db{constructor(O,p){super(p),this.variable=O}}e.$sR=N}),define(Oe[203],Ae([1,0,20,79,14,25,21,100,9,202,12]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=void 0,y=He(y),D=He(D),C=He(C),N=He(N);class v{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,f,r,a){this.h=new Map,this.a=E,this.b=f,this.g=r,a&&(this.c=a.then(c=>this.i(c)))}i(E){if(T.$j){const f=Object.create(null);return Object.keys(E).forEach(r=>{f[r.toLowerCase()]=E[r]}),f}return E}resolveWithEnvironment(E,f,r){return this.l({env:this.i(E),userHome:void 0},f?f.uri:void 0,r)}async resolveAsync(E,f){const r={env:await this.c,userHome:await this.g};return this.l(r,E?E.uri:void 0,f)}async j(E,f,r,a){const c=N.$ho(f);T.$j&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):T.$k&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):T.$l&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,E?E.uri:void 0,c,r,a)}async resolveAnyAsync(E,f,r){return this.j(E,f,r)}async resolveAnyMap(E,f,r){const a=new Map;return{newConfig:await this.j(E,f,r,a),resolvedVariables:a}}resolveWithInteractionReplace(E,f,r,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,f,r,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,f){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,f)}async l(E,f,r,a,c){if(C.$hg(r))return this.m(E,f,r,a,c);if(Array.isArray(r))return Promise.all(r.map(u=>this.l(E,f,u,a,c)));if(C.$jg(r)){const u=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(E,f,n,a,c),await this.l(E,f,r[n],a,c)]));for(const[n,t]of i)u[n]=t;return u}return r}m(E,f,r,a,c){return(0,I.$Af)(r,v.VARIABLE_REGEXP,async(u,i)=>{if(i.includes(v.VARIABLE_LHS))return u;let n=await this.o(E,u,i,f,a);return c?.set(i,n),n!==u&&C.$hg(n)&&n.match(v.VARIABLE_REGEXP)&&(n=await this.m(E,f,n,a,c)),n})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,f,r,a,c){let u;const i=r.split(":");i.length>1&&(r=i[0],u=i[1]);const n=l=>{const m=this.a.getFilePath();if(m)return(0,O.$7w)(m);throw new s.$sR(l,(0,p.localize)(12143,null,f))},t=l=>{const m=n(l);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,O.$7w)(g)}throw new s.$sR(l,(0,p.localize)(12144,null,f,y.$qc(m)))},o=l=>{if(u){const m=this.a.getFolderUri(u);if(m)return m;throw new s.$sR(l,(0,p.localize)(12145,null,f,u))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new s.$sR(l,(0,p.localize)(12146,null,f)):new s.$sR(l,(0,p.localize)(12147,null,f))};switch(r){case"env":if(u){if(E.env){const l=E.env[T.$j?u.toLowerCase():u];if(C.$hg(l))return l}return""}throw new s.$sR(s.VariableKind.Env,(0,p.localize)(12148,null,f));case"config":if(u){const l=this.a.getConfigurationValue(a,u);if(C.$qg(l))throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12149,null,f,u));if(C.$jg(l))throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12150,null,f,u));return l}throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12151,null,f));case"command":return this.p(s.VariableKind.Command,f,u,c,"command");case"input":return this.p(s.VariableKind.Input,f,u,c,"input");case"extensionInstallFolder":if(u){const l=await this.a.getExtension(u);if(!l)throw new s.$sR(s.VariableKind.ExtensionInstallFolder,(0,p.localize)(12152,null,f,u));return this.n(l.extensionLocation)}throw new s.$sR(s.VariableKind.ExtensionInstallFolder,(0,p.localize)(12153,null,f));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,O.$7w)(this.n(o(s.VariableKind.WorkspaceFolder)));case"cwd":return a||u?(0,O.$7w)(this.n(o(s.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.$7w)(y.$qc(this.n(o(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new s.$sR(s.VariableKind.UserHome,(0,p.localize)(12154,null,f))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new s.$sR(s.VariableKind.LineNumber,(0,p.localize)(12155,null,f))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new s.$sR(s.VariableKind.SelectedText,(0,p.localize)(12156,null,f))}case"file":return n(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$qc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||u?y.$oc(this.n(o(s.VariableKind.RelativeFile)),n(s.VariableKind.RelativeFile)):n(s.VariableKind.RelativeFile);case"relativeFileDirname":{const l=y.$pc(n(s.VariableKind.RelativeFileDirname));if(a||u){const m=y.$oc(this.n(o(s.VariableKind.RelativeFileDirname)),l);return m.length===0?".":m}return l}case"fileDirname":return y.$pc(n(s.VariableKind.FileDirname));case"fileExtname":return y.$rc(n(s.VariableKind.FileExtname));case"fileBasename":return y.$qc(n(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=y.$qc(n(s.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-y.$rc(l).length)}case"fileDirnameBasename":return y.$qc(y.$pc(n(s.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||f}case"execInstallFolder":{const l=this.a.getAppRoot();return l||f}case"pathSeparator":case"/":return y.sep;default:try{const l=u?`${r}:${u}`:r;return this.p(s.VariableKind.Unknown,f,l,c,void 0)}catch{return f}}}}p(E,f,r,a,c){if(r&&a){const u=c===void 0?a[r]:a[c+":"+r];if(typeof u=="string")return u;throw new s.$sR(E,(0,p.localize)(12157,null,f))}return f}}e.$HR=v}),define(Oe[120],Ae([1,0,3,116]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$IE=void 0,e.$JE=s,e.$KE=h,e.$LE=E,e.$IE=(0,y.$Ii)("editorGroupsService");var C;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var T;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var O;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(O||(e.GroupsArrangement=O={}));var p;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function s(f){const r=f;return(0,D.$uG)(r?.editor)&&(0,D.$uG)(r?.replacement)}var I;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var v;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function h(f){const r=f;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function E(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(Oe[204],Ae([1,0,3,120]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PE=e.$OE=e.$NE=e.$ME=void 0,e.$QE=C,e.$ME=(0,y.$Ii)("editorService"),e.$NE=-1,e.$OE=-2,e.$PE=-3;function C(N){const T=N;return typeof N=="number"||(0,D.$KE)(T)}}),define(Oe[205],Ae([1,0,3,107]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0,e.$lN=(0,y.$Ji)(D.$Pi)}),define(Oe[121],Ae([1,0,18,6,20,4,10]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=e.$Iec=e.$Hec=e.$Gec=e.$Fec=void 0,C=He(C);class O{constructor(u,i){this.versionId=u,this.removedDueToLooping=i}}e.$Fec=O;class p{static isHostExtension(u,i,n){if(i.getExtensionDescription(u))return!1;const t=n.getExtensionDescription(u);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(u,i){this.j=u,this.c=new D.$oe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new y.$wn,this.g=[],this.h=new Map;for(const u of this.e){if(this.f.has(u.identifier)){console.error("Extension `"+u.identifier.value+"` is already registered");continue}this.f.set(u.identifier,u),this.g.push(u);const i=this.j.readActivationEvents(u);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(u)}}set(u){return this.e=u,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(u,i){this.e=a(this.e,i),this.e=this.e.concat(u);const n=p.l(this.e);return this.e=a(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new O(this.d,n)}static l(u){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,g){this.addNode(m),this.addNode(g),this.c.has(m)?this.c.get(m).push(g):this.c.set(m,[g])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,g){const d=i.getArcs(m);for(let S=0;S<d.length;S++)if(!g.has(d[S]))return!1;return!0}getNodes(){return this.e}},n=new y.$wn;for(const m of u)if(n.set(m.identifier,m),m.extensionDependencies)for(const g of m.extensionDependencies)i.addArc(y.$un.toKey(m.identifier),y.$un.toKey(g));const t=new Set;i.getNodes().filter(m=>i.getArcs(m).length===0).forEach(m=>t.add(m));const o=i.getNodes().filter(m=>!t.has(m));let l;do{l=!1;for(let m=0;m<o.length;m++){const g=o[m];i.hasOnlyGoodArcs(g,t)&&(o.splice(m,1),m--,t.add(g),l=!0)}}while(l);return o.map(m=>n.get(m))}containsActivationEvent(u){return this.h.has(u)}containsExtension(u){return this.f.has(u)}getExtensionDescriptionsForActivationEvent(u){const i=this.h.get(u);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(u){const i=this.f.get(u);return i||void 0}getExtensionDescriptionByUUID(u){for(const i of this.g)if(i.uuid===u)return i}getExtensionDescriptionByIdOrUUID(u,i){return this.getExtensionDescription(u)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Gec=p;class s{constructor(u,i){this.versionId=u,this.extensions=i}}e.$Hec=s;class I{constructor(u){this.d=new E,this.c=new p(u,[])}async acquireLock(u){const i=await this.d.acquire(u);return new v(this,i)}deltaExtensions(u,i,n){if(!u.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(u){return this.c.containsActivationEvent(u)}containsExtension(u){return this.c.containsExtension(u)}getExtensionDescriptionsForActivationEvent(u){return this.c.getExtensionDescriptionsForActivationEvent(u)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(u){return this.c.getExtensionDescription(u)}getExtensionDescriptionByUUID(u){return this.c.getExtensionDescriptionByUUID(u)}getExtensionDescriptionByIdOrUUID(u,i){return this.c.getExtensionDescriptionByIdOrUUID(u,i)}}e.$Iec=I;class v extends N.$Xc{constructor(u,i){super(),this.f=u,this.c=!1,this.B(i)}isAcquiredFor(u){return!this.c&&this.f===u}}e.$Jec=v;class h{constructor(u){this.name=u;const i=(0,T.$Bh)();this.promise=i.promise,this.c=i.resolve}resolve(u){this.c(u)}}class E{constructor(){this.c=[],this.d=!1}async acquire(u){const i=new h(u);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const u=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${u.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};u.resolve((0,N.$Vc)(t))}}var f;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(f||(f={}));function r(c,u){const i=c.isBuiltin?f.Builtin:c.isUnderDevelopment?f.Dev:f.User,n=u.isBuiltin?f.Builtin:u.isUnderDevelopment?f.Dev:f.User;if(i!==n)return i-n;const t=C.$jc.basename(c.extensionLocation.path),o=C.$jc.basename(u.extensionLocation.path);return t<o?-1:t>o?1:0}function a(c,u){const i=new y.$vn(u);return c.filter(n=>!i.has(n.identifier))}}),define(Oe[84],Ae([1,0,22]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$En=T,e.$Fn=O;var D;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(D||(e.UIKind=D={}));var C;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var N;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function T(s){const I=y.$Qe.alloc(1);switch(s){case N.Initialized:I.writeUInt8(1,0);break;case N.Ready:I.writeUInt8(2,0);break;case N.Terminate:I.writeUInt8(3,0);break}return I}function O(s,I){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return I===N.Initialized;case 2:return I===N.Ready;case 3:return I===N.Terminate;default:return!1}}var p;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Oe[67],Ae([1,0,3,6,113,11,26,84,63,64,25,2,4,9]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$VQ=e.$UQ=void 0,e.$WQ=a;let f=class extends h.$Xc{constructor(u,i){super(),this.s=u,this.t=i,this.a=this.B(new D.$oe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new D.$oe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=v.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Fp,name:(0,E.localize)(2711,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,N.$fk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===N.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(u,i,n){const t=this.getTelemetryDetails(),o=new r(i,n,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...l,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(u,i,n){this.f=u,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const i=Object.create(null);switch(i["common.extname"]=`${u.publisher}.${u.name}`,i["common.extversion"]=u.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:i["common.uikind"]="web";break;case O.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$ln)((0,s.$Lp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const o=n.filter(l=>!l.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,i){const t=this.r.get(u.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(u.value),!1;let o=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),o=!0);return o}};e.$UQ=f,e.$UQ=f=Xe([Qe(0,T.$TQ),Qe(1,N.$ek)],f);class r{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,i,n,t,o,l,m){this.g=n,this.h=t,this.i=o,this.j=l,this.a=new D.$oe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(u,i){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let i="properties"in u?u.properties??{}:u;return i=(0,s.$Op)(i,[]),this.c&&(i=(0,I.$ko)(i,this.c)),this.b||(i=(0,I.$ko)(i,this.j)),"properties"in u?u.properties=i:u=i,u}k(u,i){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(u,i),this.h.trace(u,i))}logUsage(u,i){this.d.isUsageEnabled&&this.k(u,i)}logError(u,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,i);else{const n={name:u.name,message:u.message,stack:u.stack,cause:u.cause},t=(0,s.$Op)(n,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const u=this,i={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$VQ=r;function a(c){const u=Date.now()-new Date(c).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$XQ=(0,y.$Ii)("IExtHostTelemetry")}),define(Oe[24],Ae([1,0,6,2,179,112,18,3]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AH=e.ActivationKind=e.$xH=e.$wH=e.$tH=e.ExtensionHostStartup=e.$sH=e.$rH=e.$qH=e.$pH=void 0,e.$uH=h,e.$vH=E,e.$yH=c,e.$zH=u,e.$pH=Object.freeze({identifier:new T.$un("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:T.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$qH="extensions.webWorker",e.$rH=(0,O.$Ii)("extensionService");class p{constructor(t){this.dependency=t}}e.$sH=p;var s;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,l){this.c=t,this.d=o.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$bH.createActivationEventsMap(this.d)}}set(t,o,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const m=[],g=[],d=[],S=[],k=v(this.d),w=v(o),P=(A,M)=>A.extensionLocation.toString()===M.extensionLocation.toString()||A.isBuiltin===M.isBuiltin||A.isUserBuiltin===M.isUserBuiltin||A.isUnderDevelopment===M.isUnderDevelopment;for(const A of this.d){const M=w.get(A.identifier);if(!M){m.push(A.identifier),k.delete(A.identifier);continue}if(!P(A,M)){m.push(A.identifier),k.delete(A.identifier);continue}}for(const A of o){const M=k.get(A.identifier);if(!M){g.push(A);continue}if(!P(M,A)){m.push(M.identifier),k.delete(M.identifier);continue}}const R=new T.$vn(this.e),$=new T.$vn(l);for(const A of this.e)$.has(A)||d.push(A);for(const A of l)R.has(A)||S.push(A);const b=N.$bH.createActivationEventsMap(g),L={versionId:t,toRemove:m,toAdd:g,addActivationEvents:b,myToRemove:d,myToAdd:S};return this.delta(L),L}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:l,myToRemove:m,myToAdd:g}=t,d=new T.$vn(o),S=new T.$vn(m);for(let k=0;k<this.d.length;k++)d.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)S.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of l)this.d.push(k);for(const k of g)this.e.push(k);return this.f=null,t}containsExtension(t){for(const o of this.e)if(T.$un.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const l=N.$bH.readActivationEvents(o);for(const m of l)t.add(m)}return t}}e.$tH=I;function v(n){const t=new T.$wn;for(const o of n)t.set(o.identifier,o);return t}function h(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function E(n,t){if(!h(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class f{constructor(t,o,l,m){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=l,this.activationReason=m}}e.$wH=f;class r{constructor(t,o){this.description=t,this.value=o}}e.$xH=r;var a;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function c(n){return{type:n.isBuiltin?T.ExtensionType.System:T.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,C.$Up)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function u(n,t){const o=(0,C.$Sp)(n.manifest.publisher,n.manifest.name);return{id:o,identifier:new T.$un(o),isBuiltin:n.type===T.ExtensionType.System,isUserBuiltin:n.type===T.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$AH=i}),define(Oe[206],Ae([1,0,13,4,121,18,24,11,10]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=e.$7qc=e.$6qc=e.$5qc=e.$4qc=e.$3qc=void 0,y=He(y);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(u,i,n,t){this.startup=u,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$3qc=s;class I{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,i){return u===-1||i===-1?-1:i-u}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$4qc=I;class v{constructor(u,i,n,t,o,l){this.activationFailed=u,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=o,this.disposable=l}}e.$5qc=v;class h extends v{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}e.$6qc=h;class E extends v{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}e.$7qc=E;class f extends v{constructor(u){super(!0,u,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}let r=class{constructor(u,i,n,t){this.g=t,this.a=u,this.b=i,this.c=n,this.d=new N.$wn,this.f=Object.create(null)}dispose(){for(const[u,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const u=[];for(const[i,n]of this.d)u.push(n.wait());await Promise.all(u)}isActivated(u){const i=this.d.get(u);return!!(i&&i.value)}getActivatedExtension(u){const i=this.d.get(u);if(!i||!i.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return i.value}async activateByEvent(u,i){if(this.f[u])return;const n=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,i){const n=this.a.getExtensionDescription(u);if(!n)throw new Error(`Extension '${u.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(u){const i=u.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(u){if(this.d.has(u.id))return this.d.get(u.id);if(this.l(u.id))return this.k(u,null,[],null);const i=this.a.getExtensionDescription(u.id);if(!i){const o=new Error(`Cannot activate unknown extension '${u.id.value}'`),l=this.k(u,null,[],new f(o));return this.c.onExtensionActivationError(u.id,o,new T.$sH(u.id.value)),l}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const l=this.d.get(o);if(l){n.push(l);continue}if(this.l(o)){n.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:u.reason}));continue}const m=this.a.getExtensionDescription(o);if(m){if(!m.main&&!m.browser)continue;n.push(this.j({id:m.identifier,reason:u.reason}));continue}const g=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${o}'`),S=this.k(u,i.displayName,[],new f(d));return this.c.onExtensionActivationError(i.identifier,d,new T.$sH(o)),S}return this.k(u,i.displayName,n,null)}k(u,i,n,t){const o=new a(u.id,i,u.reason,n,t,this.c,this.g);return this.d.set(u.id,o),o}l(u){return C.$Gec.isHostExtension(u,this.a,this.b)}m(u){const i=this.b.getExtensionDescription(u);return i?!i.main&&!i.browser:!1}};e.$8qc=r,e.$8qc=r=Xe([Qe(3,O.$dk)],r);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,i,n,t,o,l,m){this.c=u,this.d=i,this.f=n,this.g=t,this.h=o,this.j=l,this.k=m,this.a=new p.$Hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const i=this.g[u];if(i.value&&!i.value.activationFailed){this.g.splice(u,1),u--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new f(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const i=new Error;if(u&&u.name&&(i.name=u.name),u&&u.message?i.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(i.stack=u.stack),this.h=new f(i),this.b&&y.$6(u))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};a=Xe([Qe(6,O.$dk)],a)});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Oe[122],Ae([1,0,9,13,36,111,78,30,18,109,112,105]),function($e,e,y,D,C,N,T,O,p,s,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=void 0,y=He(y),C=si(C);const h=O.$uo.as(T.$vo.JSONContribution);class E{constructor(t,o,l){this.a=t,this.b=o,this.c=l}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$jH=E;class f{static a(t){const o=new p.$vn;for(let l=0,m=t.length;l<m;l++)o.add(t[l].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new f(o,[]);if(!o||!o.length)return new f([],t);const l=this.a(t),m=this.a(o),g=o.filter(S=>!l.has(S.description.identifier)),d=t.filter(S=>!m.has(S.description.identifier));return new f(g,d)}constructor(t,o){this.added=t,this.removed=o}}e.$kH=f;class r{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=f.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,D.$2)(t)}}}e.$lH=r;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(12312,null),y.localize(12313,null)]},c="vscode://schemas/vscode-extensions";e.$mH={properties:{engines:{type:"object",description:y.localize(12314,null),properties:{vscode:{type:"string",description:y.localize(12315,null),default:"^1.22.0"}}},publisher:{description:y.localize(12316,null),type:"string"},displayName:{description:y.localize(12317,null),type:"string"},categories:{description:y.localize(12318,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$tn},{type:"string",const:"Languages",deprecationMessage:y.localize(12319,null)}]}},galleryBanner:{type:"object",description:y.localize(12320,null),properties:{color:{description:y.localize(12321,null),type:"string"},theme:{description:y.localize(12322,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(12323,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12324,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(12325,null)},enabledApiProposals:{markdownDescription:y.localize(12326,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(v.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:y.localize(12327,null),type:"string",enum:["none"],enumDescriptions:[y.localize(12328,null)]},activationEvents:{description:y.localize(12329,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(12330,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(12331,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(12332,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(12333,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(12334,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(12335,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(12336,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(12337,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(12338,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(12339,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(12340,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(12341,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(12342,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(12343,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(12344,null)},{label:"onUri",body:"onUri",description:y.localize(12345,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(12346,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(12347,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(12348,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(12349,null)},{label:"onRenderer",description:y.localize(12350,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(12351,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(12352,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(12353,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(12354,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:y.localize(12355,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:y.localize(12356,null)},{label:"*",description:y.localize(12357,null),body:"*"}]}},badges:{type:"array",description:y.localize(12358,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(12359,null)},href:{type:"string",description:y.localize(12360,null)},description:{type:"string",description:y.localize(12361,null)}}}},markdown:{type:"string",description:y.localize(12362,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(12363,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(12364,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$bp}},extensionPack:{description:y.localize(12365,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$bp}},extensionKind:{description:y.localize(12366,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(12367,null)},{body:["workspace"],description:y.localize(12368,null)},{body:["ui","workspace"],description:y.localize(12369,null)},{body:["workspace","ui"],description:y.localize(12370,null)},{body:[],description:y.localize(12371,null)}]},capabilities:{description:y.localize(12372,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(12373,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(12374,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(12375,null),y.localize(12376,null),y.localize(12377,null)]},description:{type:"string",markdownDescription:y.localize(12378,null)}}},untrustedWorkspaces:{description:y.localize(12379,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(12380,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(12381,null),y.localize(12382,null),y.localize(12383,null)]},restrictedConfigurations:{description:y.localize(12384,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(12385,null)}}}}},sponsor:{description:y.localize(12386,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(12387,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(12388,null),type:"string"},"vscode:uninstall":{description:y.localize(12389,null),type:"string"}}},icon:{type:"string",description:y.localize(12390,null)},l10n:{type:"string",description:y.localize(12391,null)},pricing:{type:"string",markdownDescription:y.localize(12392,null),enum:["Free","Trial"],default:"Free"}}};class u{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$bH.register(t.extensionPoint,t.activationEventsGenerator),e.$mH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,h.registerSchema(c,e.$mH),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$nH=u;const i={ExtensionsRegistry:"ExtensionsRegistry"};O.$uo.add(i.ExtensionsRegistry,new u),e.$oH=O.$uo.as(i.ExtensionsRegistry),h.registerSchema(c,e.$mH),h.registerSchema(s.$xk,{properties:{extensionEnabledApiProposals:{description:y.localize(12393,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Oe[207],Ae([1,0,6,40,4,12,9,18,3,11,24,122]),function($e,e,y,D,C,N,T,O,p,s,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DH=e.$CH=e.$BH=e.ChatMessageRole=void 0;var h;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(h||(e.ChatMessageRole=h={})),e.$BH=(0,p.$Ii)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,T.localize)(4723,null)}}};e.$CH=v.$oH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,T.localize)(4724,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(r,a)=>{for(const c of r)a.push(`onLanguageModelChat:${c.vendor}`)}});let f=class{constructor(a,c){this.e=a,this.f=c,this.a=new C.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new y.$oe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$CH.setHandler(u=>{this.c.clear();for(const n of u){if(!(0,I.$uH)(n.description,"chatProvider")){n.collector.error((0,T.localize)(4725,null));continue}for(const t of D.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,T.localize)(4726,null,t.vendor));continue}if((0,N.$ff)(t.vendor)){n.collector.error((0,T.localize)(4727,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,T.localize)(4728,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(a){return this.b.get(a)?.metadata}async selectLanguageModels(a){if(a.vendor)await this.e.activateByEvent(`onLanguageModelChat:${a.vendor}}`);else{const u=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(u)}const c=[];for(const[u,i]of this.b)(a.vendor===void 0||i.metadata.vendor===a.vendor)&&(a.family===void 0||i.metadata.family===a.family)&&(a.version===void 0||i.metadata.version===a.version)&&(a.identifier===void 0||i.metadata.id===a.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>O.$un.equals(n,a.extension)))&&c.push(u);return this.f.trace("[LM] selected language models",a,c),c}registerLanguageModelChat(a,c){if(this.f.trace("[LM] registering language model chat",a,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(a))throw new Error(`Chat response provider with identifier ${a} is already registered.`);return this.b.set(a,c),this.d.fire({added:[{identifier:a,metadata:c.metadata}]}),(0,C.$Vc)(()=>{this.b.delete(a)&&(this.d.fire({removed:[a]}),this.f.trace("[LM] UNregistered language model chat",a,c.metadata))})}async sendChatRequest(a,c,u,i,n){const t=this.b.get(a);if(!t)throw new Error(`Chat response provider with identifier ${a} is not registered.`);return t.sendChatRequest(u,c,i,n)}computeTokenLength(a,c,u){const i=this.b.get(a);if(!i)throw new Error(`Chat response provider with identifier ${a} is not registered.`);return i.provideTokenCount(c,u)}};e.$DH=f,e.$DH=f=Xe([Qe(0,I.$rH),Qe(1,s.$dk)],f)}),define(Oe[208],Ae([1,0,9,14,25,122,31,6]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=void 0,y=He(y),D=He(D),C=He(C);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(9873,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(9874,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(9875,null),default:""}}};var s;(function(h){function E(f,r,a){if(!f)return;const c=D.$hg(f.type)?f.type:void 0;if(!c||c.length===0){a.error(y.localize(9876,null));return}const u=[];if(Array.isArray(f.required))for(const i of f.required)D.$hg(i)&&u.push(i);return{extensionId:r.value,taskType:c,required:u,properties:f.properties?C.$ho(f.properties):{},when:f.when?T.$Gj.deserialize(f.when):void 0}}h.from=E})(s||(s={}));const I=N.$oH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,E)=>{for(const f of h)f.type&&E.push(`onTaskType:${f.type}`)},jsonSchema:{description:y.localize(9877,null),type:"array",items:p}});class v{constructor(){this.d=new O.$oe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,f)=>{I.setHandler((r,a)=>{this.c=void 0;try{for(const c of a.removed){const u=c.value;for(const i of u)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of a.added){const u=c.value;for(const i of u){const n=s.from(i,c.description.identifier,c.collector);n&&(this.a[n.taskType]=n)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const f of this.all()){const r={type:"object",additionalProperties:!1};f.required.length>0&&(r.required=f.required.slice(0)),f.properties!==void 0?r.properties=C.$ho(f.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[f.taskType]},E.push(r)}this.c={oneOf:E}}return this.c}}e.$_I=new v}),define(Oe[209],Ae([1,0,9,14,23,25,31,208,43]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$jJ=e.JsonSchemaVersion=e.ExecutionEngine=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$dJ=e.ShellQuoting=e.$cJ=e.$bJ=e.$aJ=void 0,y=He(y),D=He(D),C=He(C),N=He(N),e.$aJ="settings",e.$bJ=new T.$Zj("taskRunning",!1,y.localize(9878,null)),e.$cJ=y.localize2(9880,"Tasks");var s;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$dJ="$customized",function(U){function V(Q){if(!Q)return U.Strong;switch(Q.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=V}(s||(e.ShellQuoting=s={}));var I;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var v;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(v||(e.RevealKind=v={})),function(U){function V(Q){switch(Q.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=V}(v||(e.RevealKind=v={}));var h;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(h||(e.RevealProblemKind=h={})),function(U){function V(Q){switch(Q.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=V}(h||(e.RevealProblemKind=h={}));var E;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(E||(e.PanelKind=E={})),function(U){function V(Q){switch(Q.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=V}(E||(e.PanelKind=E={}));var f;(function(U){U.defaults={echo:!0,reveal:v.Always,revealProblems:h.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(f||(e.PresentationOptions=f={}));var r;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(U){function V(ne){switch(ne.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=V;function Q(ne){switch(ne){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=Q}(r||(e.RuntimeType=r={}));var a;(function(U){function V(Q){return D.$hg(Q)?Q:Q.value}U.value=V})(a||(e.CommandString=a={}));var c;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function V(ne){return ne===U.Clean._id||ne===U.Build._id||ne===U.Rebuild._id||ne===U.Test._id}U.is=V;function Q(ne){if(ne!==void 0)return D.$hg(ne)?V(ne)?{_id:ne,isDefault:!1}:void 0:ne}U.from=Q})(c||(e.TaskGroup=c={}));var u;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(u||(e.TaskScope=u={}));var i;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function V(Q){switch(Q){case U.User:return p.ConfigurationTarget.USER;case U.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}U.toConfigurationTarget=V})(i||(e.TaskSourceKind=i={}));var n;(function(U){U.parallel="parallel",U.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class l{constructor(V,Q,ne,ue,x,oe){this._label="",this._id=V,Q&&(this._label=Q),ne&&(this.type=ne),this.runOptions=ue,this.configurationProperties=x,this._source=oe}getDefinition(V){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const V={folder:this.d(),id:this._id};return JSON.stringify(V)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,Q=!1){if(V===void 0)return!1;if(D.$hg(V))return V===this._label||V===this.configurationProperties.identifier||Q&&V===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this.c===void 0&&(this.c=[]),V&&(this.c=this.c.concat(V))}get taskLoadMessages(){return this.c}}e.$eJ=l;class m extends l{constructor(V,Q,ne,ue,x,oe,se,ce){super(V,ne,void 0,se,ce,Q),this.command={},this._source=Q,this.hasDefinedMatchers=oe,x&&(this.command=x)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let Q;switch(this.command?this.command.runtime:void 0){case r.Shell:Q="shell";break;case r.Process:Q="process";break;case r.CustomExecution:Q="customExecution";break;case void 0:Q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Q,_key:this._id,id:this._id}}}static is(V){return V instanceof m}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$aJ:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const V=this.d();if(!V)return;let Q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Q+=this._source.kind);const ne={type:e.$dJ,folder:V,id:Q};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$gh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(V){return new m(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$fJ=m;class g extends l{constructor(V,Q,ne,ue,x,oe,se){super(V,ne,ue,oe,se,Q),this._source=Q,this.configures=x}static is(V){return V instanceof g}f(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$gh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$aJ:this._source.config.workspaceFolder?.uri.toString()}getKey(){const V=this.d();if(!V)return;let Q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Q+=this._source.kind);const ne={type:e.$dJ,folder:V,id:Q};return JSON.stringify(ne)}}e.$gJ=g;class d extends l{constructor(V,Q,ne,ue,x,oe,se,ce,te){super(V,ne,ue,ce,te,Q),this.defines=x,this.hasDefinedMatchers=se,this.command=oe,this.icon=te.icon,this.hide=te.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof d}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===u.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.d(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(V){return new d(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$hJ=d;class S extends l{constructor(V,Q,ne,ue,x,oe){super(V,ne,ue,x,oe,Q),this._source=Q}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(V){return new S(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.$iJ=S;var k;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(U){U._default=U.Terminal}(k||(e.ExecutionEngine=k={}));var w;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class P{constructor(V){this.c=new Map;for(let Q=0;Q<V.length;Q++)this.c.set(V[Q].uri.toString(),Q)}compare(V,Q){const ne=V.getWorkspaceFolder(),ue=Q.getWorkspaceFolder();if(ne&&ue){let x=this.c.get(ne.uri.toString());x=x===void 0?0:x+1;let oe=this.c.get(ue.uri.toString());return oe=oe===void 0?0:oe+1,x===oe?V._label.localeCompare(Q._label):x-oe}else return!ne&&ue?-1:ne&&!ue?1:0}}e.$jJ=P;var R;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(R||(e.TaskEventKind=R={}));var $;(function(U){U.SingleRun="singleRun",U.Background="background"})($||(e.TaskRunType=$={}));var b;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var L;(function(U){function V(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?$.Background:$.SingleRun,group:ce.configurationProperties.group,__task:ce}}function Q(ce,te,we){return{...V(ce),kind:R.Start,terminalId:te,resolvedVariables:we}}U.start=Q;function ne(ce,te,we){return{...V(ce),kind:R.ProcessStarted,terminalId:te,processId:we}}U.processStarted=ne;function ue(ce,te,we){return{...V(ce),kind:R.ProcessEnded,terminalId:te,exitCode:we}}U.processEnded=ue;function x(ce,te,we){return{...V(ce),kind:R.Terminated,exitReason:we,terminalId:te}}U.terminated=x;function oe(ce,te,we){return{...V(te),kind:ce,terminalId:we}}U.general=oe;function se(){return{kind:R.Changed}}U.changed=se})(L||(e.TaskEvent=L={}));var A;(function(U){function V(ne){const ue=Object.keys(ne).sort();let x="";for(const oe of ue){let se=ne[oe];se instanceof Object?se=V(se):typeof se=="string"&&(se=se.replace(/,/g,",,")),x+=oe+","+se+","}return x}function Q(ne){const x={_key:V(ne),type:ne.taskType};return Object.assign(x,ne),x}U.create=Q})(A||(e.KeyedTaskIdentifier=A={}));var M;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection",U.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var Z;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(Z||(e.TasksSchemaProperties=Z={}));var G;(function(U){function V(Q,ne){const ue=O.$_I.get(Q.type);if(ue===void 0){const ce=N.$ho(Q);return delete ce._key,A.create(ce)}const x=Object.create(null);x.type=ue.taskType;const oe=new Set;ue.required.forEach(ce=>oe.add(ce));const se=ue.properties;for(const ce of Object.keys(se)){const te=Q[ce];if(te!=null)x[ce]=te;else if(oe.has(ce)){const we=se[ce];if(we.default!==void 0)x[ce]=N.$ho(we.default);else switch(we.type){case"boolean":x[ce]=!1;break;case"number":case"integer":x[ce]=0;break;case"string":x[ce]="";break;default:ne.error(y.localize(9879,null,JSON.stringify(Q,void 0,0),ce));return}}}return A.create(x)}U.createTaskIdentifier=V})(G||(e.TaskDefinition=G={}))}),define(Oe[210],Ae([1,0,13]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=e.$Kec=void 0;class D{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,O)=>{this.b=T,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,y.$2)(T))}then(T,O){return this.j().then(T,O)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$Kec=D;class C extends D{constructor(){super(),this.h=!0,this.i=new y.$7}}e.$Lec=C}),define(Oe[39],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4w=e.$1w=void 0,e.$2w=C,e.$3w=N;class y{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++y.count}}e.$1w=y;const D=[];function C(O){const p=new y(O);return D[p.nid]=p,p}function N(O){return D[O].sid}class T{constructor(p){this.value=p}}e.$4w=T}),define(Oe[5],Ae([1,0,39]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$2N=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.TextEditorRevealType=D={}));var C;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var T;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var O;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(O||(e.WebviewMessageArrayBufferViewType=O={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var s;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class v{static{this.a=0}static mixin(a){return a._id=v.a++,a}}e.$2N=v;var h;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var E;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var f;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$3N={MainThreadAuthentication:(0,y.$2w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$2w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,y.$2w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,y.$2w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,y.$2w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$2w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,y.$2w)("MainThreadChatSkills"),MainThreadClipboard:(0,y.$2w)("MainThreadClipboard"),MainThreadCommands:(0,y.$2w)("MainThreadCommands"),MainThreadComments:(0,y.$2w)("MainThreadComments"),MainThreadConfiguration:(0,y.$2w)("MainThreadConfiguration"),MainThreadConsole:(0,y.$2w)("MainThreadConsole"),MainThreadDebugService:(0,y.$2w)("MainThreadDebugService"),MainThreadDecorations:(0,y.$2w)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$2w)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$2w)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$2w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$2w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$2w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$2w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$2w)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$2w)("MainThreadErrors"),MainThreadTreeViews:(0,y.$2w)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$2w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$2w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$2w)("MainThreadLanguages"),MainThreadLogger:(0,y.$2w)("MainThreadLogger"),MainThreadMessageService:(0,y.$2w)("MainThreadMessageService"),MainThreadOutputService:(0,y.$2w)("MainThreadOutputService"),MainThreadProgress:(0,y.$2w)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$2w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$2w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$2w)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$2w)("MainThreadSecretState"),MainThreadStorage:(0,y.$2w)("MainThreadStorage"),MainThreadSpeech:(0,y.$2w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$2w)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$2w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,y.$2w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,y.$2w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$2w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$2w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$2w)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$2w)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$2w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$2w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$2w)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$2w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$2w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$2w)("MainThreadExtensionService"),MainThreadSCM:(0,y.$2w)("MainThreadSCM"),MainThreadSearch:(0,y.$2w)("MainThreadSearch"),MainThreadShare:(0,y.$2w)("MainThreadShare"),MainThreadTask:(0,y.$2w)("MainThreadTask"),MainThreadWindow:(0,y.$2w)("MainThreadWindow"),MainThreadLabelService:(0,y.$2w)("MainThreadLabelService"),MainThreadNotebook:(0,y.$2w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$2w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$2w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$2w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$2w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$2w)("MainThreadInteractive"),MainThreadTheming:(0,y.$2w)("MainThreadTheming"),MainThreadTunnelService:(0,y.$2w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$2w)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$2w)("MainThreadTimeline"),MainThreadTesting:(0,y.$2w)("MainThreadTesting"),MainThreadLocalization:(0,y.$2w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$2w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$2w)("MainThreadAiEmbeddingVector")},e.$4N={ExtHostCommands:(0,y.$2w)("ExtHostCommands"),ExtHostConfiguration:(0,y.$2w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$2w)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$2w)("ExtHostDebugService"),ExtHostDecorations:(0,y.$2w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$2w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$2w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$2w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$2w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$2w)("ExtHostEditors"),ExtHostTreeViews:(0,y.$2w)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$2w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$2w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$2w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$2w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$2w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$2w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$2w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$2w)("ExtHostStatusBar"),ExtHostShare:(0,y.$2w)("ExtHostShare"),ExtHostExtensionService:(0,y.$2w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$2w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$2w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,y.$2w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,y.$2w)("ExtHostSCM"),ExtHostSearch:(0,y.$2w)("ExtHostSearch"),ExtHostTask:(0,y.$2w)("ExtHostTask"),ExtHostWorkspace:(0,y.$2w)("ExtHostWorkspace"),ExtHostWindow:(0,y.$2w)("ExtHostWindow"),ExtHostWebviews:(0,y.$2w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$2w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$2w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$2w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$2w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$2w)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$2w)("ExtHostProgress"),ExtHostComments:(0,y.$2w)("ExtHostComments"),ExtHostSecretState:(0,y.$2w)("ExtHostSecretState"),ExtHostStorage:(0,y.$2w)("ExtHostStorage"),ExtHostUrls:(0,y.$2w)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$2w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$2w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$2w)("ExtHostOutputService"),ExtHostLabelService:(0,y.$2w)("ExtHostLabelService"),ExtHostNotebook:(0,y.$2w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$2w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$2w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$2w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$2w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$2w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$2w)("ExtHostInteractive"),ExtHostChatAgents2:(0,y.$2w)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$2w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,y.$2w)("ExtHostChatSkills"),ExtHostChatProvider:(0,y.$2w)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$2w)("ExtHostSpeech"),ExtHostEmbeddings:(0,y.$2w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,y.$2w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$2w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$2w)("ExtHostTheming"),ExtHostTunnelService:(0,y.$2w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$2w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$2w)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$2w)("ExtHostTimeline"),ExtHostTesting:(0,y.$2w)("ExtHostTesting"),ExtHostTelemetry:(0,y.$2w)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$2w)("ExtHostLocalization")}}),define(Oe[85],Ae([1,0,3,11,5,16]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=e.$pqc=void 0,C=He(C),e.$pqc=(0,y.$Ii)("IExtHostApiDeprecationService");let T=class{constructor(p,s){this.c=s,this.a=new Set,this.b=p.getProxy(C.$3N.MainThreadTelemetry)}report(p,s,I){const v=this.d(p,s);this.a.has(v)||(this.a.add(v),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:p}))}d(p,s){return`${p}-${s.identifier.value}`}};e.$qqc=T,e.$qqc=T=Xe([Qe(0,N.$DQ),Qe(1,D.$dk)],T),e.$rqc=Object.freeze(new class{report(O,p,s){}})}),define(Oe[211],Ae([1,0,5]),function($e,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=void 0;class D{constructor(N){const T=N.getProxy(y.$3N.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(O){return T.$writeText(O)}})}}e.$Eqc=D}),define(Oe[212],Ae([1,0,25,5,26,16]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsc=void 0;let T=class{constructor(I,v){this.a=I.getProxy(D.$3N.MainThreadConsole),this.b=v.consoleForward.includeStack,this.c=v.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,v){const h=this,E=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){h.e(I,v,E,arguments)}})}e(I,v,h,E){this.a.$logExtensionHostMessage({type:"__$console",severity:v,arguments:p(E,this.b)}),this.c&&this.f(I,h,E)}};e.$Fsc=T,e.$Fsc=T=Xe([Qe(0,N.$DQ),Qe(1,C.$TQ)],T);const O=1e5;function p(s,I){const v=[];if(s.length)for(let h=0;h<s.length;h++){let E=s[h];if(typeof E>"u")E="undefined";else if(E instanceof Error){const f=E;f.stack?E=f.stack:E=f.toString()}v.push(E)}if(I){const h=new Error().stack;h&&v.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,y.$mo)(v);return h.length>O?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Oe[213],Ae([1,0,2,5,24]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grc=void 0;class N{constructor(O){this.a=O.getProxy(D.$3N.MainThreadDialogs)}showOpenDialog(O,p){return p?.allowUIResources&&(0,C.$vH)(O,"showLocal"),this.a.$showOpenDialog(p).then(s=>s?s.map(I=>y.URI.revive(I)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then(p=>p?y.URI.revive(p):void 0)}}e.$Grc=N}),define(Oe[214],Ae([1,0,19,6,4,5]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jrc=void 0;class T{constructor(p){this.b=new Map,this.c=new D.$oe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(N.$3N.MainThreadEmbeddings)}registerEmbeddingsProvider(p,s,I){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const v=this.e++;return this.a.$registerEmbeddingProvider(v,s),this.b.set(v,{id:s,provider:I}),(0,C.$Vc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(v),this.b.delete(v)})}async computeEmbeddings(p,s,I){I??=y.CancellationToken.None;let v=!1;typeof s=="string"&&(s=[s],v=!0);const h=await this.a.$computeEmbeddings(p,s,I);if(h.length!==s.length)throw new Error;if(v){if(h.length!==1)throw new Error;return h[0]}return h}async $provideEmbeddings(p,s,I){const v=this.b.get(p);if(!v)return[];const h=await v.provider.provideEmbeddings(s,I);return h||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Jrc=T}),define(Oe[215],Ae([1,0,4,5]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6rc=void 0;class C{constructor(T){this.b=0,this.a=T.getProxy(D.$3N.MainThreadLabelService)}$registerResourceLabelFormatter(T){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,T),(0,y.$Vc)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.$6rc=C}),define(Oe[86],Ae([1,0,21,12,2,3,11,5,26,16]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=e.$jrc=void 0;let I=class{constructor(h,E,f){this.f=f,this.d=new Map,this.a=E.getProxy(O.$3N.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===y.$h}getMessage(h,E){const{message:f,args:r,comment:a}=E;if(this.c)return(0,D.$hf)(f,r??{});let c=f;a&&a.length>0&&(c+=`/${Array.isArray(a)?a.join(""):a}`);const u=this.d.get(h)?.contents[c];return u||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,D.$hf)(u??f,r??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let E;const f=await this.g(h);if(!f){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(f),a=JSON.parse(r);E=h.isBuiltin?a.contents?.bundle:a}catch(r){this.f.error(`Failed to load translations for ${h.identifier.value} from ${f}: ${r.message}`);return}E&&this.d.set(h.identifier.value,{contents:E,uri:f})}async g(h){if(h.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return C.URI.revive(E)}return h.l10n?C.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$jrc=I,e.$jrc=I=Xe([Qe(0,p.$TQ),Qe(1,s.$DQ),Qe(2,T.$dk)],I),e.$krc=(0,N.$Ii)("IExtHostLocalizationService")}),define(Oe[216],Ae([1,0,11,5,26,16,2,33]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=void 0;let p=class extends y.$ok{constructor(v,h){super(h.logLevel,h.logsLocation,h.loggers.map(E=>(0,O.$fi)(E))),this.r=v.getProxy(D.$3N.MainThreadLogger)}$setLogLevel(v,h){h?this.setLogLevel(T.URI.revive(h),v):this.setLogLevel(v)}setVisibility(v,h){super.setVisibility(v,h),this.r.$setVisibility(v,h)}s(v,h,E){return new s(this.r,v,h,E)}};e.$Esc=p,e.$Esc=p=Xe([Qe(0,N.$DQ),Qe(1,C.$TQ)],p);class s extends y.$jk{constructor(v,h,E,f){super(f?.logLevel==="always"),this.r=v,this.s=h,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(h,f).then(()=>{this.u(this.n),this.m=!0})}g(v,h){const E=[[v,h]];this.m?this.u(E):this.n.push(...E)}u(v){this.r.$log(this.s,v)}flush(){this.r.$flush(this.s)}}}),define(Oe[87],Ae([1,0,5,3,4,16,22]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=e.$lrc=void 0,e.$lrc=(0,D.$Ii)("IExtHostManagedSockets");let O=class{constructor(v){this.b=0,this.c=null,this.d=new Map,this.a=v.getProxy(y.$3N.MainThreadManagedSockets)}setFactory(v,h){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(v,h),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(v){if(!this.c||this.c.socketFactoryId!==v)throw new Error(`No socket factory with id ${v}`);const h=++this.b,E=await this.c.makeConnection(),f=new C.$Wc;return this.d.set(h,new s(h,E,f)),f.add((0,C.$Vc)(()=>this.d.delete(h))),f.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(h),f.dispose()})),f.add(E.onDidClose(r=>{this.a.$onDidManagedSocketClose(h,r?.stack??r?.message),f.dispose()})),f.add(E.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(h,T.$Qe.wrap(r)))),h}$remoteSocketWrite(v,h){this.d.get(v)?.actual.send(h.buffer)}$remoteSocketEnd(v){const h=this.d.get(v);h&&(h.actual.end(),h.dispose())}async $remoteSocketDrain(v){await this.d.get(v)?.actual.drain?.()}};e.$mrc=O,e.$mrc=O=Xe([Qe(0,N.$DQ)],O);class p{constructor(v,h){this.socketFactoryId=v,this.makeConnection=h}}class s extends C.$Xc{constructor(v,h,E){super(),this.socketId=v,this.actual=h,this.B(E)}}}),define(Oe[217],Ae([1,0,5,11,24]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=void 0;function N(O){return O&&O.title}let T=class{constructor(p,s){this.b=s,this.a=p.getProxy(y.$3N.MainThreadMessageService)}showMessage(p,s,I,v,h){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let f;typeof v=="string"||N(v)?f=[v,...h]:(E.modal=v?.modal,E.useCustom=v?.useCustom,E.detail=v?.detail,f=h),E.useCustom&&(0,C.$vH)(p,"resolvers");const r=[];let a=!1;for(let c=0;c<f.length;c++){const u=f[c];if(typeof u=="string")r.push({title:u,handle:c,isCloseAffordance:!1});else if(typeof u=="object"){const{title:i,isCloseAffordance:n}=u;r.push({title:i,isCloseAffordance:!!n,handle:c}),n&&(a?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,u):a=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,u)}return this.a.$showMessage(s,I,E,r).then(c=>{if(typeof c=="number")return f[c]})}};e.$9rc=T,e.$9rc=T=Xe([Qe(1,D.$dk)],T)}),define(Oe[218],Ae([1,0,4,14,2,24,5]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsc=void 0;class O{constructor(s){this.b=new Map,this.a=s.getProxy(T.$3N.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,I,v){if((0,N.$vH)(s,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,v),this.a.$registerProfileContentHandler(I,v.name,v.description,s.identifier.value),(0,y.$Vc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(s,I,v,h){const E=this.b.get(s);if(!E)throw new Error(`Unknown handler with id: ${s}`);return E.saveProfile(I,v,h)}async $readProfile(s,I,v){const h=this.b.get(s);if(!h)throw new Error(`Unknown handler with id: ${s}`);return h.readProfile((0,D.$hg)(I)?I:C.URI.revive(I),v)}}e.$fsc=O}),define(Oe[88],Ae([1,0,5,6,3]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=e.$grc=void 0;class N{constructor(O){this.b=new D.$oe,this.onDidChangePassword=this.b.event,this.a=O.getProxy(y.$3N.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,p){return this.a.$getPassword(O,p)}store(O,p,s){return this.a.$setPassword(O,p,s)}delete(O,p){return this.a.$deletePassword(O,p)}}e.$grc=N,e.$hrc=(0,C.$Ii)("IExtHostSecretState")}),define(Oe[219],Ae([1,0,19,4,5]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=void 0;class N{static{this.a=1}constructor(O){this.c=new Map,this.d=new Map,this.f=new Map,this.b=O.getProxy(C.$3N.MainThreadSpeech)}async $createSpeechToTextSession(O,p,s){const I=this.c.get(O);if(!I)return;const v=new D.$Wc,h=new y.$ze;this.d.set(p,h);const E=await I.provideSpeechToTextSession(h.token,s?{language:s}:void 0);E&&(v.add(E.onDidChange(f=>{h.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,f)})),v.add(h.token.onCancellationRequested(()=>v.dispose())))}async $cancelSpeechToTextSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}async $createTextToSpeechSession(O,p,s){const I=this.c.get(O);if(!I)return;const v=new D.$Wc,h=new y.$ze;this.d.set(p,h);const E=await I.provideTextToSpeechSession(h.token,s?{language:s}:void 0);E&&(this.f.set(p,E),v.add(E.onDidChange(f=>{h.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,f)})),v.add(h.token.onCancellationRequested(()=>v.dispose())))}async $synthesizeSpeech(O,p){this.f.get(O)?.synthesize(p)}async $cancelTextToSpeechSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O),this.f.delete(O)}async $createKeywordRecognitionSession(O,p){const s=this.c.get(O);if(!s)return;const I=new D.$Wc,v=new y.$ze;this.d.set(p,v);const h=await s.provideKeywordRecognitionSession(v.token);h&&(I.add(h.onDidChange(E=>{v.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),I.add(v.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}registerProvider(O,p,s){const I=N.a++;return this.c.set(I,s),this.b.$registerProvider(I,p,{extension:O,displayName:O.value}),(0,D.$Vc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$msc=N}),define(Oe[89],Ae([1,0,5,6,3]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=e.$9qc=void 0;class N{constructor(O,p){this.c=p,this.b=new D.$oe,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(y.$3N.MainThreadStorage)}registerExtensionStorageKeysToSync(O,p){this.a.$registerExtensionStorageKeysToSync(O,p)}async initializeExtensionStorage(O,p,s){const I=await this.a.$initializeExtensionStorage(O,p);let v;return I&&(v=this.d(O,p,I)),v||s}setValue(O,p,s){return this.a.$setValue(O,p,s)}$acceptValue(O,p,s){const I=this.d(O,p,s);I&&this.b.fire({shared:O,key:p,value:I})}d(O,p,s){try{return JSON.parse(s)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${O}): ${I}`)}}}e.$9qc=N,e.$0qc=(0,C.$Ii)("IExtHostStorage")}),define(Oe[220],Ae([1,0,4,15,2,5]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ysc=void 0;class T{static{this.a=new Set([D.Schemas.http,D.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(N.$3N.MainThreadUriOpeners)}registerExternalUriOpener(p,s,I,v){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const h=v.schemes.find(E=>!T.a.has(E));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(s,I),this.b.$registerUriOpener(s,v.schemes,p,v.label),(0,y.$Vc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri(p,s,I){const v=this.c.get(p);if(!v)throw new Error(`Unknown opener with id: ${p}`);const h=C.URI.revive(s);return v.canOpenExternalUri(h,I)}async $openUri(p,s,I){const v=this.c.get(p);if(!v)throw new Error(`Unknown opener id: '${p}'`);return v.openExternalUri(C.URI.revive(s.resolvedUri),{sourceUri:C.URI.revive(s.sourceUri)},I)}}e.$ysc=T}),define(Oe[221],Ae([1,0,5,2,4,13,18]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsc=void 0;class O{static{this.a=0}constructor(s){this.c=new T.$vn,this.d=new Map,this.b=s.getProxy(y.$3N.MainThreadUrls)}registerUriHandler(s,I){const v=s.identifier;if(this.c.has(v))throw new Error(`Protocol handler already registered for extension ${v}`);const h=O.a++;return this.c.add(v),this.d.set(h,I),this.b.$registerUriHandler(h,v,s.displayName||s.name),(0,C.$Vc)(()=>{this.c.delete(v),this.d.delete(h),this.b.$unregisterUriHandler(h)})}$handleExternalUri(s,I){const v=this.d.get(s);if(!v)return Promise.resolve(void 0);try{v.handleUri(D.URI.revive(I))}catch(h){(0,N.$2)(h)}return Promise.resolve(void 0)}async createAppUri(s){return D.URI.revive(await this.b.$createAppUri(s))}}e.$zsc=O}),define(Oe[222],Ae([1,0,22,5]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lub=N,e.$mub=O,D=He(D);class C{constructor(){this.buffers=[]}add(s){let I=this.buffers.indexOf(s);return I<0&&(I=this.buffers.length,this.buffers.push(s)),I}}function N(p,s){if(s.serializeBuffersForPostMessage){const I=new C,h=JSON.stringify(p,(f,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const a=T(r);if(a)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),E=I.buffers.map(f=>{const r=new Uint8Array(f);return y.$Qe.wrap(r)});return{message:h,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function T(p){switch(p.constructor.name){case"Int8Array":return D.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return D.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return D.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return D.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return D.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return D.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return D.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return D.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return D.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return D.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return D.WebviewMessageArrayBufferViewType.BigUint64Array}}function O(p,s){const I=s.map(E=>{const f=new ArrayBuffer(E.byteLength);return new Uint8Array(f).set(E.buffer),f}),v=s.length?(E,f)=>{if(f&&typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const r=f,{index:a}=r,c=I[a];if(r.view)switch(r.view.type){case D.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return f}:void 0;return{message:JSON.parse(p,v),arrayBuffers:I}}}),define(Oe[68],Ae([1,0,6,4,15,25,2,176,222,83,5]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=e.$Tqc=void 0,e.$Uqc=h,e.$Wqc=r,e.$Xqc=a,N=He(N),I=He(I);class v{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,o,l,m,g,d){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new y.$oe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$oe,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=o,this.#n=l,this.#s=m,this.#r=g,this.#u=h(g),this.#d=E(g),this.#i=d}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,s.$0Db)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===C.Schemas.https||n.scheme===C.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$9Db}return s.$9Db}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),N.$lo(this.#o,n)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,p.$lub)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,m,g,d,S,k)=>{const w=T.URI.from({scheme:d||"file",path:decodeURIComponent(S)}),P=(0,s.$0Db)(w,{isRemote:t,authority:o}).toString();return`${m}${P}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,m,g,d,S,k)=>{const w=T.URI.from({scheme:d||"file",path:decodeURIComponent(S)}),P=(0,s.$0Db)(w,{isRemote:t,authority:o}).toString();return`${m}${P}${k}`})}}e.$Tqc=v;function h(i){try{const n=(0,O.$5p)((0,O.$4p)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function E(i){try{const n=(0,O.$5p)((0,O.$4p)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class f extends D.$Xc{constructor(n,t,o,l,m){super(),this.c=t,this.f=o,this.g=l,this.h=m,this.b=new Map,this.a=n.getProxy(I.$3N.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,o){const l=this.j(n);if(l){const{message:m}=(0,p.$mub)(t,o.value);l._onMessageEmitter.fire(m)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,o){const l=new v(n,this.a,c(t),this.c,this.f,o,this.h);this.b.set(n,l);const m=l._onDidDispose(()=>{m.dispose(),this.deleteWebview(n)});return l}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$Vqc=f;function r(i){return{id:i.identifier,location:i.extensionLocation}}function a(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||u(i,n)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>T.URI.from(n))}}function u(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Oe[123],Ae([1,0,6,15,12,2,3,16,5]),function($e,e,y,D,C,N,T,O,p){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Csc=e.$Bsc=void 0;let I=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const h=this.d;return{get focused(){return h.focused},get active(){return h.active}}}constructor(h){this.c=new y.$oe,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=h.getProxy(p.$3N.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:f})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(h){this.onDidChangeWindowProperty("focused",h)}$onDidChangeWindowActive(h){this.onDidChangeWindowProperty("active",h)}onDidChangeWindowProperty(h,E){E!==this.d[h]&&(this.d={...this.d,[h]:E},this.c.fire(this.d))}openUri(h,E){let f;if(typeof h=="string"){f=h;try{h=N.URI.parse(h)}catch{return Promise.reject(`Invalid uri - '${h}'`)}}return(0,C.$ff)(h.scheme)?Promise.reject("Invalid scheme - cannot be empty"):h.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${h.scheme}'`):this.b.$openUri(h,f,E)}async asExternalUri(h,E){if((0,C.$ff)(h.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(h,E);return N.URI.from(f)}};e.$Bsc=I,e.$Bsc=I=s=Xe([Qe(0,O.$DQ)],I),e.$Csc=(0,T.$Ii)("IExtHostWindow")}),define(Oe[223],Ae([1,0,212,26,16]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ruc=void 0;let N=class extends y.$Fsc{constructor(O,p){super(O,p)}f(O,p,s){p.apply(console,s)}};e.$Ruc=N,e.$Ruc=N=Xe([Qe(0,C.$DQ),Qe(1,D.$TQ)],N)}),define(Oe[224],Ae([1,0,10,22,19,27,13,6,4,37,151,210,39]),function($e,e,y,D,C,N,T,O,p,s,I,v,h){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=e.ResponsiveState=e.RequestInitiator=void 0,e.$Mec=u,e.$Nec=i,T=He(T);function f(L,A){try{return JSON.stringify(L,A)}catch{return"null"}}const r="$$ref$$",a={[r]:-1};class c{constructor(A,M){this.jsonString=A,this.referencedBuffers=M}}function u(L,A=null,M=!1){const Z=[];return{jsonString:(M?f:JSON.stringify)(L,(U,V)=>{if(typeof V>"u")return a;if(typeof V=="object"){if(V instanceof D.$Qe){const Q=Z.push(V)-1;return{[r]:Q}}if(A)return A(U,V)}return V}),referencedBuffers:Z}}function i(L,A,M){return JSON.parse(L,(Z,G)=>{if(G){const U=G[r];if(typeof U=="number")return A[U];if(M&&G.$mid===s.MarshalledId.Uri)return M.transformIncoming(G)}return G})}function n(L,A){return JSON.stringify(L,A)}function t(L){return L?(A,M)=>M&&M.$mid===s.MarshalledId.Uri?L.transformOutgoing(M):M:null}var o;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(L){L[L.Responsive=0]="Responsive",L[L.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const m=()=>{},g=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class S extends p.$Xc{static{E=g}static{this.a=3*1e3}constructor(A,M=null,Z=null){super(),this[E]=!0,this.b=this.B(new O.$oe),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=M,this.g=Z,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let G=0,U=h.$1w.count;G<U;G++)this.m[G]=null,this.s[G]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new y.$Uh(()=>this.H(),1e3)),this.B(this.c.onMessage(G=>this.L(G)))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const M=this.w[A];delete this.w[A],M.resolveErr(T.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,I.$Sn)(A,this.g):A}getProxy(A){const{nid:M,sid:Z}=A;return this.s[M]||(this.s[M]=this.J(M,Z)),this.s[M]}J(A,M){const Z={get:(G,U)=>(typeof U=="string"&&!G[U]&&U.charCodeAt(0)===N.CharCode.DollarSign&&(G[U]=(...V)=>this.U(A,U,V)),U===d?M:G[U])};return new Proxy(Object.create(null),Z)}set(A,M){return this.m[A.nid]=M,M}assertRegistered(A){for(let M=0,Z=A.length;M<Z;M++){const G=A[M];if(!this.m[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}L(A){if(this.j)return;const M=A.byteLength,Z=w.read(A,0),G=Z.readUInt8(),U=Z.readUInt32();switch(G){case $.RequestJSONArgs:case $.RequestJSONArgsWithCancellation:{let{rpcId:V,method:Q,args:ne}=R.deserializeRequestJSONArgs(Z);this.g&&(ne=(0,I.$Sn)(ne,this.g)),this.M(M,U,V,Q,ne,G===$.RequestJSONArgsWithCancellation);break}case $.RequestMixedArgs:case $.RequestMixedArgsWithCancellation:{let{rpcId:V,method:Q,args:ne}=R.deserializeRequestMixedArgs(Z);this.g&&(ne=(0,I.$Sn)(ne,this.g)),this.M(M,U,V,Q,ne,G===$.RequestMixedArgsWithCancellation);break}case $.Acknowledged:{this.f?.logIncoming(M,U,o.LocalSide,"ack"),this.G(U);break}case $.Cancel:{this.N(M,U);break}case $.ReplyOKEmpty:{this.O(M,U,void 0);break}case $.ReplyOKJSON:{let V=R.deserializeReplyOKJSON(Z);this.g&&(V=(0,I.$Sn)(V,this.g)),this.O(M,U,V);break}case $.ReplyOKJSONWithBuffers:{const V=R.deserializeReplyOKJSONWithBuffers(Z,this.g);this.O(M,U,V);break}case $.ReplyOKVSBuffer:{const V=R.deserializeReplyOKVSBuffer(Z);this.O(M,U,V);break}case $.ReplyErrError:{let V=R.deserializeReplyErrError(Z);this.g&&(V=(0,I.$Sn)(V,this.g)),this.P(M,U,V);break}case $.ReplyErrEmpty:{this.P(M,U,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,M,Z,G,U,V){this.f?.logIncoming(A,M,o.OtherSide,`receiveRequest ${(0,h.$3w)(Z)}.${G}(`,U);const Q=String(M);let ne,ue;if(V){const oe=new C.$ze;U.push(oe.token),ne=this.Q(Z,G,U),ue=()=>oe.cancel()}else ne=this.Q(Z,G,U),ue=m;this.u[Q]=ue;const x=R.serializeAcknowledged(M);this.f?.logOutgoing(x.byteLength,M,o.OtherSide,"ack"),this.c.send(x),ne.then(oe=>{delete this.u[Q];const se=R.serializeReplyOK(M,oe,this.h);this.f?.logOutgoing(se.byteLength,M,o.OtherSide,"reply:",oe),this.c.send(se)},oe=>{delete this.u[Q];const se=R.serializeReplyErr(M,oe);this.f?.logOutgoing(se.byteLength,M,o.OtherSide,"replyErr:",oe),this.c.send(se)})}N(A,M){this.f?.logIncoming(A,M,o.OtherSide,"receiveCancel");const Z=String(M);this.u[Z]?.()}O(A,M,Z){this.f?.logIncoming(A,M,o.LocalSide,"receiveReply:",Z);const G=String(M);if(!this.w.hasOwnProperty(G))return;const U=this.w[G];delete this.w[G],U.resolveOk(Z)}P(A,M,Z){this.f?.logIncoming(A,M,o.LocalSide,"receiveReplyErr:",Z);const G=String(M);if(!this.w.hasOwnProperty(G))return;const U=this.w[G];delete this.w[G];let V;Z&&(Z.$isError?(V=new Error,V.name=Z.name,V.message=Z.message,V.stack=Z.stack):V=Z),U.resolveErr(V)}Q(A,M,Z){try{return Promise.resolve(this.S(A,M,Z))}catch(G){return Promise.reject(G)}}S(A,M,Z){const G=this.m[A];if(!G)throw new Error("Unknown actor "+(0,h.$3w)(A));const U=G[M];if(typeof U!="function")throw new Error("Unknown method "+M+" on actor "+(0,h.$3w)(A));return U.apply(G,Z)}U(A,M,Z){if(this.j)return new v.$Lec;let G=null;if(Z.length>0&&C.CancellationToken.isCancellationToken(Z[Z.length-1])&&(G=Z.pop()),G&&G.isCancellationRequested)return Promise.reject(T.$8());const U=R.serializeRequestArguments(Z,this.h),V=++this.t,Q=String(V),ne=new v.$Kec,ue=new p.$Wc;G&&ue.add(G.onCancellationRequested(()=>{const oe=R.serializeCancel(V);this.f?.logOutgoing(oe.byteLength,V,o.LocalSide,"cancel"),this.c.send(R.serializeCancel(V))})),this.w[Q]=new k(ne,ue),this.F(V);const x=R.serializeRequest(V,A,M,U,!!G);return this.f?.logOutgoing(x.byteLength,V,o.LocalSide,`request: ${(0,h.$3w)(A)}.${M}(`,Z),this.c.send(x),ne}}e.$Oec=S;class k{constructor(A,M){this.a=A,this.b=M}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class w{static alloc(A,M,Z){const G=new w(D.$Qe.alloc(Z+1+4),0);return G.writeUInt8(A),G.writeUInt32(M),G}static read(A,M){return new w(A,M)}get buffer(){return this.a}constructor(A,M){this.a=A,this.b=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+A).toString();return this.b+=A,Z}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+A).toString();return this.b+=A,Z}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+A);return this.b+=A,M}static sizeMixedArray(A){let M=0;M+=1;for(let Z=0,G=A.length;Z<G;Z++){const U=A[Z];switch(M+=1,U.type){case b.String:M+=this.sizeLongString(U.value);break;case b.VSBuffer:M+=this.sizeVSBuffer(U.value);break;case b.SerializedObjectWithBuffers:M+=this.sizeUInt32,M+=this.sizeLongString(U.value);for(let V=0;V<U.buffers.length;++V)M+=this.sizeVSBuffer(U.buffers[V]);break;case b.Undefined:break}}return M}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let M=0,Z=A.length;M<Z;M++){const G=A[M];switch(G.type){case b.String:this.writeUInt8(b.String),this.writeLongString(G.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(G.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let U=0;U<G.buffers.length;++U)this.writeBuffer(G.buffers[U]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const M=new Array(A);for(let Z=0;Z<A;Z++)switch(this.readUInt8()){case b.String:M[Z]=this.readLongString();break;case b.VSBuffer:M[Z]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const U=this.readUInt32(),V=this.readLongString(),Q=[];for(let ne=0;ne<U;++ne)Q.push(this.readVSBuffer());M[Z]=new h.$4w(i(V,Q,null));break}case b.Undefined:M[Z]=void 0;break}return M}}var P;(function(L){L[L.Simple=0]="Simple",L[L.Mixed=1]="Mixed"})(P||(P={}));class R{static a(A){for(let M=0,Z=A.length;M<Z;M++)if(A[M]instanceof D.$Qe||A[M]instanceof h.$4w||typeof A[M]>"u")return!0;return!1}static serializeRequestArguments(A,M){if(this.a(A)){const Z=[];for(let G=0,U=A.length;G<U;G++){const V=A[G];if(V instanceof D.$Qe)Z[G]={type:b.VSBuffer,value:V};else if(typeof V>"u")Z[G]={type:b.Undefined};else if(V instanceof h.$4w){const{jsonString:Q,referencedBuffers:ne}=u(V.value,M);Z[G]={type:b.SerializedObjectWithBuffers,value:D.$Qe.fromString(Q),buffers:ne}}else Z[G]={type:b.String,value:D.$Qe.fromString(n(V,M))}}return{type:P.Mixed,args:Z}}return{type:P.Simple,args:n(A,M)}}static serializeRequest(A,M,Z,G,U){switch(G.type){case P.Simple:return this.b(A,M,Z,G.args,U);case P.Mixed:return this.c(A,M,Z,G.args,U)}}static b(A,M,Z,G,U){const V=D.$Qe.fromString(Z),Q=D.$Qe.fromString(G);let ne=0;ne+=w.sizeUInt8(),ne+=w.sizeShortString(V),ne+=w.sizeLongString(Q);const ue=w.alloc(U?$.RequestJSONArgsWithCancellation:$.RequestJSONArgs,A,ne);return ue.writeUInt8(M),ue.writeShortString(V),ue.writeLongString(Q),ue.buffer}static deserializeRequestJSONArgs(A){const M=A.readUInt8(),Z=A.readShortString(),G=A.readLongString();return{rpcId:M,method:Z,args:JSON.parse(G)}}static c(A,M,Z,G,U){const V=D.$Qe.fromString(Z);let Q=0;Q+=w.sizeUInt8(),Q+=w.sizeShortString(V),Q+=w.sizeMixedArray(G);const ne=w.alloc(U?$.RequestMixedArgsWithCancellation:$.RequestMixedArgs,A,Q);return ne.writeUInt8(M),ne.writeShortString(V),ne.writeMixedArray(G),ne.buffer}static deserializeRequestMixedArgs(A){const M=A.readUInt8(),Z=A.readShortString(),G=A.readMixedArray(),U=new Array(G.length);for(let V=0,Q=G.length;V<Q;V++){const ne=G[V];typeof ne=="string"?U[V]=JSON.parse(ne):U[V]=ne}return{rpcId:M,method:Z,args:U}}static serializeAcknowledged(A){return w.alloc($.Acknowledged,A,0).buffer}static serializeCancel(A){return w.alloc($.Cancel,A,0).buffer}static serializeReplyOK(A,M,Z){if(typeof M>"u")return this.d(A);if(M instanceof D.$Qe)return this.e(A,M);if(M instanceof h.$4w){const{jsonString:G,referencedBuffers:U}=u(M.value,Z,!0);return this.g(A,G,U)}else return this.f(A,f(M,Z))}static d(A){return w.alloc($.ReplyOKEmpty,A,0).buffer}static e(A,M){let Z=0;Z+=w.sizeVSBuffer(M);const G=w.alloc($.ReplyOKVSBuffer,A,Z);return G.writeVSBuffer(M),G.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,M){const Z=D.$Qe.fromString(M);let G=0;G+=w.sizeLongString(Z);const U=w.alloc($.ReplyOKJSON,A,G);return U.writeLongString(Z),U.buffer}static g(A,M,Z){const G=D.$Qe.fromString(M);let U=0;U+=w.sizeUInt32,U+=w.sizeLongString(G);for(const Q of Z)U+=w.sizeVSBuffer(Q);const V=w.alloc($.ReplyOKJSONWithBuffers,A,U);V.writeUInt32(Z.length),V.writeLongString(G);for(const Q of Z)V.writeBuffer(Q);return V.buffer}static deserializeReplyOKJSON(A){const M=A.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(A,M){const Z=A.readUInt32(),G=A.readLongString(),U=[];for(let V=0;V<Z;++V)U.push(A.readVSBuffer());return new h.$4w(i(G,U,M))}static serializeReplyErr(A,M){const Z=M?f(T.$4(M),null):void 0;if(typeof Z!="string")return this.h(A);const G=D.$Qe.fromString(Z);let U=0;U+=w.sizeLongString(G);const V=w.alloc($.ReplyErrError,A,U);return V.writeLongString(G),V.buffer}static deserializeReplyErrError(A){const M=A.readLongString();return JSON.parse(M)}static h(A){return w.alloc($.ReplyErrEmpty,A,0).buffer}}var $;(function(L){L[L.RequestJSONArgs=1]="RequestJSONArgs",L[L.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",L[L.RequestMixedArgs=3]="RequestMixedArgs",L[L.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",L[L.Acknowledged=5]="Acknowledged",L[L.Cancel=6]="Cancel",L[L.ReplyOKEmpty=7]="ReplyOKEmpty",L[L.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",L[L.ReplyOKJSON=9]="ReplyOKJSON",L[L.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",L[L.ReplyErrError=11]="ReplyErrError",L[L.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var b;(function(L){L[L.String=1]="String",L[L.VSBuffer=2]="VSBuffer",L[L.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",L[L.Undefined=4]="Undefined"})(b||(b={}))}),define(Oe[225],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tuc=void 0;const y=function(N){const T=O=>{globalThis.removeEventListener("message",T);const p=O.data;Object.defineProperties(globalThis,{postMessage:{value(s,I){p.postMessage(s,I)}},onmessage:{get(){return p.onmessage},set(s){p.onmessage=s}}}),p.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",T)}.toString();class D extends EventTarget{constructor(N,T,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${y})('${T}'))`,s=new Blob([p],{type:"application/javascript"}),I=URL.createObjectURL(s),v=new MessageChannel,h=I,E={type:"_newWorker",id:h,port:v.port2,url:I,options:O};N(E,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{N({type:"_terminateWorker",id:h}),URL.revokeObjectURL(I),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(f){v.port1.onmessage=f}},onmessageerror:{get(){return v.port1.onmessageerror},set(f){v.port1.onmessageerror=f}}}),v.port1.addEventListener("messageerror",f=>{const r=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(r)}),v.port1.addEventListener("message",f=>{const r=new MessageEvent("message",{data:f.data});this.dispatchEvent(r)}),v.port1.start()}}e.$Tuc=D}),define(Oe[226],Ae([1,0,22,28,15,61,3]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=e.$IL=void 0,e.$JL=I,e.$KL=v,e.$IL=(0,T.$Ii)("notebookDocumentService");const O=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${O.join("")}]+`),s=7;function I(E){if(E.scheme!==C.Schemas.vscodeNotebookCell)return;const f=E.fragment.indexOf("s");if(f<0)return;const r=parseInt(E.fragment.substring(0,f).replace(p,""),s),a=(0,y.$0e)(E.fragment.substring(f+1)).toString();if(!isNaN(r))return{handle:r,notebook:E.with({scheme:a,fragment:null})}}function v(E,f){const r=f.toString(s),c=`${r.length<O.length?O[r.length-1]:"z"}${r}s${(0,y.$$e)(y.$Qe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:C.Schemas.vscodeNotebookCell,fragment:c})}class h{constructor(){this.a=new D.$Dc}getNotebook(f){if(f.scheme===C.Schemas.vscodeNotebookCell){const r=I(f);if(r){const a=this.a.get(r.notebook);if(a)return a}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$LL=h,(0,N.$Ws)(e.$IL,h,N.InstantiationType.Delayed)}),define(Oe[90],Ae([1,0,22,41,40,73,15,20,21,31,226]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$3L=e.CellStatusbarAlignment=e.$2L=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$YL=e.$XL=e.$VL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$UL=e.$TL=e.$SL=e.$RL=e.CellKind=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=void 0,e.$WL=l,e.$ZL=d,e.$1L=S,e.$4L=P,e.$5L=$,D=He(D),e.$ML="workbench.editor.notebook",e.$NL="workbench.editor.notebookTextDiffEditor",e.$OL="workbench.editor.interactive",e.$PL="workbench.editor.repl",e.$QL="replNotebook.input.execute";var v;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(v||(e.CellKind=v={})),e.$RL=["application/json","application/javascript","text/html","image/svg+xml",N.$dt.latex,N.$dt.markdown,"image/png","image/jpeg",N.$dt.text],e.$SL=[N.$dt.latex,N.$dt.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$dt.text],e.$TL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$UL="_notAvailable";var h;(function(Q){Q[Q.Running=1]="Running",Q[Q.Idle=2]="Idle"})(h||(e.NotebookRunState=h={}));var E;(function(Q){Q[Q.Unconfirmed=1]="Unconfirmed",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var f;(function(Q){Q[Q.Unconfirmed=1]="Unconfirmed",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var r;(function(Q){Q[Q.WithHardKernelDependency=0]="WithHardKernelDependency",Q[Q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Q[Q.Pure=2]="Pure",Q[Q.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var a;(function(Q){Q.Always="always",Q.Never="never",Q.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var c;(function(Q){Q[Q.ModelChange=1]="ModelChange",Q[Q.Move=2]="Move",Q[Q.ChangeCellLanguage=5]="ChangeCellLanguage",Q[Q.Initialize=6]="Initialize",Q[Q.ChangeCellMetadata=7]="ChangeCellMetadata",Q[Q.Output=8]="Output",Q[Q.OutputItem=9]="OutputItem",Q[Q.ChangeCellContent=10]="ChangeCellContent",Q[Q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Q[Q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Q[Q.ChangeCellMime=13]="ChangeCellMime",Q[Q.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var u;(function(Q){Q[Q.Handle=0]="Handle",Q[Q.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var i;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Output=2]="Output",Q[Q.Metadata=3]="Metadata",Q[Q.CellLanguage=4]="CellLanguage",Q[Q.DocumentMetadata=5]="DocumentMetadata",Q[Q.Move=6]="Move",Q[Q.OutputItems=7]="OutputItems",Q[Q.PartialMetadata=8]="PartialMetadata",Q[Q.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(Q){Q.scheme=T.Schemas.vscodeNotebookCell;function ne(te,we){return(0,I.$KL)(te,we)}Q.generate=ne;function ue(te){return(0,I.$JL)(te)}Q.parse=ue;function x(te,we){return te.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${we??""},${te.scheme!==T.Schemas.file?te.scheme:""}`})}Q.generateCellOutputUri=x;function oe(te){if(te.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const we=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!we)return;const Ce=we[1]&&we[1]!==""?we[1]:void 0,Y=we[2];return{outputId:Ce,notebook:te.with({scheme:Y||T.Schemas.file,fragment:null})}}Q.parseCellOutputUri=oe;function se(te,we,Ce){return Q.generate(te,we).with({scheme:Ce})}Q.generateCellPropertyUri=se;function ce(te,we){if(te.scheme===we)return Q.parse(te.with({scheme:Q.scheme}))}Q.parseCellPropertyUri=ce})(n||(e.CellUri=n={}));const t=Q=>p.$j?Q.replace(/\//g,"\\"):Q;class o{constructor(ne=[],ue=e.$RL){this.e=ue,this.d=[...new Set(ne)].map(x=>({pattern:x,matches:D.$Dk(t(x))}))}sort(ne){const ue=new Map(C.Iterable.map(ne,oe=>[oe,t(oe)]));let x=[];for(const{matches:oe}of this.d)for(const[se,ce]of ue)if(oe(ce)){x.push(se),ue.delete(se);break}return ue.size&&(x=x.concat([...ue.keys()].sort((oe,se)=>this.e.indexOf(oe)-this.e.indexOf(se)))),x}prioritize(ne,ue){const x=this.f(ne);if(x===-1){this.d.unshift({pattern:ne,matches:D.$Dk(t(ne))});return}const oe=new Set(ue.map(ce=>this.f(ce,x)));oe.delete(-1);const se=Array.from(oe).sort();this.d.splice(x+1,0,...se.map(ce=>this.d[ce]));for(let ce=se.length-1;ce>=0;ce--)this.d.splice(se[ce],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,ue=this.d.length){const x=t(ne);for(let oe=0;oe<ue;oe++)if(this.d[oe].matches(x))return oe;return-1}}e.$VL=o;function l(Q,ne,ue,x=(oe,se)=>oe===se){const oe=[];function se(we,Ce,Y){if(Ce===0&&Y.length===0)return;const W=oe[oe.length-1];W&&W.start+W.deleteCount===we?(W.deleteCount+=Ce,W.toInsert.push(...Y)):oe.push({start:we,deleteCount:Ce,toInsert:Y})}let ce=0,te=0;for(;;){if(ce===Q.length){se(ce,0,ne.slice(te));break}if(te===ne.length){se(ce,Q.length-ce,[]);break}const we=Q[ce],Ce=ne[te];if(x(we,Ce)){ce+=1,te+=1;continue}ue(Ce)?(se(ce,1,[]),ce+=1):(se(ce,0,[Ce]),te+=1)}return oe}e.$XL=new s.$Zj("notebookEditorCursorAtBoundary","none"),e.$YL=new s.$Zj("notebookEditorCursorAtLineBoundary","none");var m;(function(Q){Q.default="default",Q.option="option"})(m||(e.NotebookEditorPriority=m={}));var g;(function(Q){Q.Cells="cells",Q.Text="text",Q.None="none"})(g||(e.NotebookFindScopeType=g={}));function d(Q){const ne=Q;return!!((typeof ne.include=="string"||D.$Ek(ne.include))&&(typeof ne.exclude=="string"||D.$Ek(ne.exclude)))}function S(Q,ne,ue){if(Array.isArray(Q.viewType)&&Q.viewType.indexOf(ne)>=0||Q.viewType===ne)return!0;if(Q.filenamePattern){const x=d(Q.filenamePattern)?Q.filenamePattern.include:Q.filenamePattern,oe=d(Q.filenamePattern)?Q.filenamePattern.exclude:void 0;if(D.$Ck(x,(0,O.$qc)(ue.fsPath).toLowerCase()))return!(oe&&D.$Ck(oe,(0,O.$qc)(ue.fsPath).toLowerCase()))}return!1}e.$2L={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var k;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(k||(e.CellStatusbarAlignment=k={}));class w{static{this.d="notebook/"}static create(ne){return`${w.d}${ne}`}static parse(ne){if(ne.startsWith(w.d))return ne.substring(w.d.length)}}e.$3L=w;function P(Q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Q)}const R=new TextDecoder;function $(Q){const ne=[];let ue=!1;for(const ce of Q)(ne.length===0||ue)&&(ne.push(ce),ue=!0);let x=A(ne);const oe=y.$Qe.concat(ne.map(ce=>y.$Qe.wrap(ce))),se=V(oe);return x=x||se.byteLength!==oe.byteLength,{data:se,didCompression:x}}e.$6L="\x1B[A";const b=e.$6L.split("").map(Q=>Q.charCodeAt(0)),L=10;function A(Q){let ne=!1;return Q.forEach((ue,x)=>{if(x===0||ue.length<e.$6L.length)return;const oe=Q[x-1],se=ue.subarray(0,e.$6L.length);if(se[0]===b[0]&&se[1]===b[1]&&se[2]===b[2]){const ce=oe.lastIndexOf(L);if(ce===-1)return;ne=!0,Q[x-1]=oe.subarray(0,ce),Q[x]=ue.subarray(e.$6L.length)}}),ne}function M(Q){let ne=Q;do Q=ne,ne=Q.replace(/[^\n]\x08/gm,"");while(ne.length<Q.length);return Q}function Z(Q){for(Q=Q.replace(/\r+\n/gm,`
`);Q.search(/\r[^$]/g)>-1;){const ne=Q.match(/^(.*)\r+/m)[1];let ue=Q.match(/\r+(.*)$/m)[1];ue=ue+ne.slice(ue.length,ne.length),Q=Q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return Q}const G=8,U=13;function V(Q){return!Q.buffer.includes(G)&&!Q.buffer.includes(U)?Q:y.$Qe.fromString(Z(M(R.decode(Q.buffer))))}}),define(Oe[7],Ae([1,0,17,13,60,28,73,12,14,2,38,18,29,110,90]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f){"use strict";var r,a,c,u,i,n,t,o,l,m,g,d,S,k,w,P,R;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$sQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.LanguageModelChatMessageRole=e.$jQ=e.$iQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$4P=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$QP=e.$PP=e.$OP=e.$NP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.TestRunProfileKind=e.TestResultState=e.$GP=e.$FP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$EP=e.NotebookVariablesRequestKind=e.$DP=e.$CP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$BP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.ColorThemeKind=e.$vP=e.$uP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$tP=e.QuickInputButtonLocation=e.$sP=e.DebugConsoleMode=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mP=e.$lP=e.FileChangeType=e.$kP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$jP=e.$iP=e.$hP=e.$gP=e.InlineCompletionTriggerKind=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$6O=e.ConfigurationTarget=e.$5O=e.$4O=e.$3O=e.$2O=e.DocumentPasteTriggerKind=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UO=e.ViewBadge=e.ProgressLocation=e.$TO=e.$SO=e.TaskScope=e.ShellQuoting=e.$RO=e.$QO=e.$PO=e.TaskPanelKind=e.TaskRevealKind=e.$OO=e.TerminalLocation=e.$NO=e.$MO=e.$LO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KO=e.$JO=e.$IO=e.$HO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$FO=e.$EO=e.$DO=e.$CO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BO=e.$AO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.LanguageStatusSeverity=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.CodeActionTriggerKind=e.$oO=e.$nO=e.SymbolTag=e.SymbolKind=e.$mO=e.$lO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.DiagnosticSeverity=e.DiagnosticTag=e.$fO=e.$eO=e.FileEditType=e.$dO=e.$cO=e.$bO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$aO=e.$_N=e.$$N=e.$8N=e.$7N=e.$6N=e.$5N=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=U,e.$0N=V,e.$GO=dt,e.$7O=ji,e.$MP=Cn;function $(z){return Object.assign(z,{apply:function(...ie){if(ie.length===0)return Reflect.construct(z,[]);{const Se=ie.length===1?[]:ie[1];return Reflect.construct(z,Se,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(z,[]);{const[Se,...Ze]=ie;return Reflect.construct(z,Ze,Se.constructor)}}})}var b;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var L;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let A=r=class{static from(...F){let ie=F;return new r(function(){if(ie){for(const Se of ie)Se&&typeof Se.dispose=="function"&&Se.dispose();ie=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$5N=A,e.$5N=A=r=Xe([$],A);let M=a=class{static Min(...F){if(F.length===0)throw new TypeError;let ie=F[0];for(let Se=1;Se<F.length;Se++){const Ze=F[Se];Ze.isBefore(ie)&&(ie=Ze)}return ie}static Max(...F){if(F.length===0)throw new TypeError;let ie=F[0];for(let Se=1;Se<F.length;Se++){const Ze=F[Se];Ze.isAfter(ie)&&(ie=Ze)}return ie}static isPosition(F){if(!F)return!1;if(F instanceof a)return!0;const{line:ie,character:Se}=F;return typeof ie=="number"&&typeof Se=="number"}static of(F){if(F instanceof a)return F;if(this.isPosition(F))return new a(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,ie){if(F<0)throw(0,D.$9)("line must be non-negative");if(ie<0)throw(0,D.$9)("character must be non-negative");this.c=F,this.e=ie}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,ie=0){if(F===null||ie===null)throw(0,D.$9)();let Se;return typeof F>"u"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,ie=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&ie===0?this:new a(this.line+Se,this.character+ie)}with(F,ie=this.character){if(F===null||ie===null)throw(0,D.$9)();let Se;return typeof F>"u"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,ie=typeof F.character=="number"?F.character:this.character),Se===this.line&&ie===this.character?this:new a(Se,ie)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$6N=M,e.$6N=M=a=Xe([$],M);let Z=c=class{static isRange(F){return F instanceof c?!0:F?M.isPosition(F.start)&&M.isPosition(F.end):!1}static of(F){if(F instanceof c)return F;if(this.isRange(F))return new c(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,ie,Se,Ze){let at,pt;if(typeof F=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ze=="number"?(at=new M(F,ie),pt=new M(Se,Ze)):M.isPosition(F)&&M.isPosition(ie)&&(at=M.of(F),pt=M.of(ie)),!at||!pt)throw new Error("Invalid arguments");at.isBefore(pt)?(this.c=at,this.e=pt):(this.c=pt,this.e=at)}contains(F){return c.isRange(F)?this.contains(F.start)&&this.contains(F.end):M.isPosition(F)?!(M.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const ie=M.Max(F.start,this.c),Se=M.Min(F.end,this.e);if(!ie.isAfter(Se))return new c(ie,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ie=M.Min(F.start,this.c),Se=M.Max(F.end,this.end);return new c(ie,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,ie=this.end){if(F===null||ie===null)throw(0,D.$9)();let Se;return F?M.isPosition(F)?Se=F:(Se=F.start||this.start,ie=F.end||this.end):Se=this.start,Se.isEqual(this.c)&&ie.isEqual(this.end)?this:new c(Se,ie)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return U(this)}};e.$7N=Z,e.$7N=Z=c=Xe([$],Z);let G=u=class extends Z{static isSelection(F){return F instanceof u?!0:F?Z.isRange(F)&&M.isPosition(F.anchor)&&M.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,ie,Se,Ze){let at,pt;if(typeof F=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ze=="number"?(at=new M(F,ie),pt=new M(Se,Ze)):M.isPosition(F)&&M.isPosition(ie)&&(at=M.of(F),pt=M.of(ie)),!at||!pt)throw new Error("Invalid arguments");super(at,pt),this.f=at,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return V(this)}};e.$8N=G,e.$8N=G=u=Xe([$],G);function U(z){return z.isEmpty?`[${z.start.line}:${z.start.character})`:`[${z.start.line}:${z.start.character} -> ${z.end.line}:${z.end.character})`}function V(z){let F=U(z);return z.isEmpty||(z.active.isEqual(z.start)?F=`|${F}`:F=`${F}|`),F}const Q=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,D.$9)("connectionToken")};class ne{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ie,Se){if(typeof F!="string"||F.length===0)throw(0,D.$9)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,D.$9)("port");typeof Se<"u"&&Q(Se),this.host=F,this.port=Math.round(ie),this.connectionToken=Se}}e.$$N=ne;class ue{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ie){this.makeConnection=F,this.connectionToken=ie,typeof ie<"u"&&Q(ie)}}e.$_N=ue;class x extends Error{static NotAvailable(F,ie){return new x(F,E.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(F){return new x(F,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,ie=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F),this._message=F,this._code=ie,this._detail=Se,Object.setPrototypeOf(this,x.prototype)}}e.$aO=x;var oe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(oe||(e.EndOfLine=oe={}));var se;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(se||(e.EnvironmentVariableMutatorType=se={}));let ce=i=class{static isTextEdit(F){return F instanceof i?!0:F?Z.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ie){return new i(F,ie)}static insert(F,ie){return i.replace(new Z(F,F),ie)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const ie=new i(new Z(new M(0,0),new M(0,0)),"");return ie.newEol=F,ie}get range(){return this.c}set range(F){if(F&&!Z.isRange(F))throw(0,D.$9)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,D.$9)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,D.$9)("newEol");this.f=F}constructor(F,ie){this.c=F,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$bO=ce,e.$bO=ce=i=Xe([$],ce);let te=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?ki.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ie){return new n(F,ie)}static insertCells(F,ie){return new n(new ki(F,F),ie)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,ie){const Se=new n(new ki(F,F),[]);return Se.newCellMetadata=ie,Se}static updateNotebookMetadata(F){const ie=new n(new ki(0,0),[]);return ie.newNotebookMetadata=F,ie}constructor(F,ie){this.range=F,this.newCells=ie}};e.$cO=te,e.$cO=te=n=Xe([$],te);class we{static isSnippetTextEdit(F){return F instanceof we?!0:F?Z.isRange(F.range)&&W.isSnippetString(F.snippet):!1}static replace(F,ie){return new we(F,ie)}static insert(F,ie){return we.replace(new Z(F,F),ie)}constructor(F,ie){this.range=F,this.snippet=ie}}e.$dO=we;var Ce;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ce||(e.FileEditType=Ce={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,ie,Se,Ze){this.c.push({_type:Ce.File,from:F,to:ie,options:Se,metadata:Ze})}createFile(F,ie,Se){this.c.push({_type:Ce.File,from:void 0,to:F,options:ie,metadata:Se})}deleteFile(F,ie,Se){this.c.push({_type:Ce.File,from:F,to:void 0,options:ie,metadata:Se})}e(F,ie,Se){this.c.push({_type:Ce.Cell,metadata:Se,uri:F,edit:{editType:f.CellEditType.DocumentMetadata,metadata:ie},notebookMetadata:ie})}f(F,ie,Se,Ze){const at=ie.start,pt=ie.end;(at!==pt||Se.length>0)&&this.c.push({_type:Ce.CellReplace,uri:F,index:at,count:pt-at,cells:Se,metadata:Ze})}g(F,ie,Se,Ze){this.c.push({_type:Ce.Cell,metadata:Ze,uri:F,edit:{editType:f.CellEditType.Metadata,index:ie,metadata:Se}})}replace(F,ie,Se,Ze){this.c.push({_type:Ce.Text,uri:F,edit:new ce(ie,Se),metadata:Ze})}insert(F,ie,Se,Ze){this.replace(F,new Z(ie,ie),Se,Ze)}delete(F,ie,Se){this.replace(F,ie,"",Se)}has(F){return this.c.some(ie=>ie._type===Ce.Text&&ie.uri.toString()===F.toString())}set(F,ie){if(ie)for(const Se of ie){if(!Se)continue;let Ze,at;Array.isArray(Se)?(Ze=Se[0],at=Se[1]):Ze=Se,te.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(F,Ze.range.start,Ze.newCellMetadata,at):Ze.newNotebookMetadata?this.e(F,Ze.newNotebookMetadata,at):this.f(F,Ze.range,Ze.newCells,at):we.isSnippetTextEdit(Ze)?this.c.push({_type:Ce.Snippet,uri:F,range:Ze.range,edit:Ze.snippet,metadata:at}):this.c.push({_type:Ce.Text,uri:F,edit:Ze,metadata:at})}else{for(let Se=0;Se<this.c.length;Se++){const Ze=this.c[Se];switch(Ze._type){case Ce.Text:case Ce.Snippet:case Ce.Cell:case Ce.CellReplace:Ze.uri.toString()===F.toString()&&(this.c[Se]=void 0);break}}(0,y.$Kb)(this.c)}}get(F){const ie=[];for(const Se of this.c)Se._type===Ce.Text&&Se.uri.toString()===F.toString()&&ie.push(Se.edit);return ie}entries(){const F=new N.$Dc;for(const ie of this.c)if(ie._type===Ce.Text){let Se=F.get(ie.uri);Se||(Se=[ie.uri,[]],F.set(ie.uri,Se)),Se[1].push(ie.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$eO=Y,e.$eO=Y=Xe([$],Y);let W=t=class{static isSnippetString(F){return F instanceof t?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=t.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ie=this.e++){if(typeof F=="function"){const Se=new t;Se.e=this.e,F(Se),this.e=Se.e,F=Se.value}else F=t.c(F);return this.value+="${",this.value+=ie,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ie=this.e++){const Se=F.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,ie){if(typeof ie=="function"){const Se=new t;Se.e=this.e,ie(Se),this.e=Se.e,ie=Se.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$fO=W,e.$fO=W=t=Xe([$],W);var ee;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(ee||(e.DiagnosticTag=ee={}));var be;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let Pe=o=class{static isLocation(F){return F instanceof o?!0:F?Z.isRange(F.range)&&s.URI.isUri(F.uri):!1}constructor(F,ie){if(this.uri=F,ie)if(Z.isRange(ie))this.range=Z.of(ie);else if(M.isPosition(ie))this.range=new Z(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$gO=Pe,e.$gO=Pe=o=Xe([$],Pe);let je=class{static is(F){return F?typeof F.message=="string"&&F.location&&Z.isRange(F.location.range)&&s.URI.isUri(F.location.uri):!1}constructor(F,ie){this.location=F,this.message=ie}static isEqual(F,ie){return F===ie?!0:!F||!ie?!1:F.message===ie.message&&F.location.range.isEqual(ie.location.range)&&F.location.uri.toString()===ie.location.uri.toString()}};e.$hO=je,e.$hO=je=Xe([$],je);let Te=class{constructor(F,ie,Se=be.Error){if(!Z.isRange(F))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=F,this.message=ie,this.severity=Se}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ie){return F===ie?!0:!F||!ie?!1:F.message===ie.message&&F.severity===ie.severity&&F.code===ie.code&&F.severity===ie.severity&&F.source===ie.source&&F.range.isEqual(ie.range)&&(0,y.$wb)(F.tags,ie.tags)&&(0,y.$wb)(F.relatedInformation,ie.relatedInformation,je.isEqual)}};e.$iO=Te,e.$iO=Te=Xe([$],Te);let Ee=class{constructor(F,ie){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ie}};e.$jO=Ee,e.$jO=Ee=Xe([$],Ee);let Fe=class extends Ee{constructor(F,ie,Se,Ze){super(F,ie),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=Ze}};e.$kO=Fe,e.$kO=Fe=Xe([$],Fe);var Ve;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(Ve||(e.HoverVerbosityAction=Ve={}));var Ge;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(Ge||(e.DocumentHighlightKind=Ge={}));let et=class{constructor(F,ie=Ge.Text){this.range=F,this.kind=ie}toJSON(){return{range:this.range,kind:Ge[this.kind]}}};e.$lO=et,e.$lO=et=Xe([$],et);let it=class{constructor(F,ie){this.uri=F,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$mO=it,e.$mO=it=Xe([$],it);var Me;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var Ue;(function(z){z[z.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let ze=l=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,ie,Se,Ze,at){this.name=F,this.kind=ie,this.containerName=at,typeof Se=="string"&&(this.containerName=Se),Ze instanceof Pe?this.location=Ze:Se instanceof Z&&(this.location=new Pe(Ze,Se)),l.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$nO=ze,e.$nO=ze=l=Xe([$],ze);let B=m=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(m.validate)}constructor(F,ie,Se,Ze,at){this.name=F,this.detail=ie,this.kind=Se,this.range=Ze,this.selectionRange=at,this.children=[],m.validate(this)}};e.$oO=B,e.$oO=B=m=Xe([$],B);var j;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(j||(e.CodeActionTriggerKind=j={}));let H=class{constructor(F,ie){this.title=F,this.kind=ie}};e.$pO=H,e.$pO=H=Xe([$],H);let J=class{static{g=this}static{this.c="."}constructor(F){this.value=F}append(F){return new g(this.value?this.value+g.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+g.c)}};e.$qO=J,e.$qO=J=g=Xe([$],J),J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorMove=J.Refactor.append("move"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll"),J.Notebook=J.Empty.append("notebook");let re=class{constructor(F,ie){if(this.range=F,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rO=re,e.$rO=re=Xe([$],re);class ge{constructor(F,ie,Se,Ze,at,pt){this.kind=F,this.name=ie,this.detail=Se,this.uri=Ze,this.range=at,this.selectionRange=pt}}e.$sO=ge;class ke{constructor(F,ie){this.fromRanges=ie,this.from=F}}e.$tO=ke;class qe{constructor(F,ie){this.fromRanges=ie,this.to=F}}e.$uO=qe;var xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(xe||(e.LanguageStatusSeverity=xe={}));let rt=class{constructor(F,ie){this.range=F,this.command=ie}get isResolved(){return!!this.command}};e.$vO=rt,e.$vO=rt=Xe([$],rt);let st=d=class{#e;static isMarkdownString(F){return F instanceof d?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,ie=!1){this.#e=new C.$7k(F,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,ie){return this.#e.appendCodeblock(ie??"",F),this}};e.$wO=st,e.$wO=st=d=Xe([$],st);let ut=class{constructor(F,ie){this.label=F,this.documentation=ie}};e.$xO=ut,e.$xO=ut=Xe([$],ut);let ot=class{constructor(F,ie){this.label=F,this.documentation=ie,this.parameters=[]}};e.$yO=ot,e.$yO=ot=Xe([$],ot);let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zO=lt,e.$zO=lt=Xe([$],lt);var vt;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(vt||(e.SignatureHelpTriggerKind=vt={}));var nt;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let he=class{constructor(F){this.value=F}};e.$AO=he,e.$AO=he=Xe([$],he);let pe=class{constructor(F,ie,Se){this.position=F,this.label=ie,this.kind=Se}};e.$BO=pe,e.$BO=pe=Xe([$],pe);var ye;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var Re;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Re||(e.CompletionItemKind=Re={}));var fe;(function(z){z[z.Deprecated=1]="Deprecated"})(fe||(e.CompletionItemTag=fe={}));let ve=class{constructor(F,ie){this.label=F,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Re[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CO=ve,e.$CO=ve=Xe([$],ve);let X=class{constructor(F=[],ie=!1){this.items=F,this.isIncomplete=ie}};e.$DO=X,e.$DO=X=Xe([$],X);let q=class{constructor(F,ie,Se){this.insertText=F,this.range=ie,this.command=Se}};e.$EO=q,e.$EO=q=Xe([$],q);let de=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$FO=de,e.$FO=de=Xe([$],de);var We;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(We||(e.PartialAcceptTriggerKind=We={}));var Je;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Je||(e.ViewColumn=Je={}));var ct;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));function dt(z,F){return`${v.$un.toKey(z)}.${F}`}var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(mt||(e.TextEditorLineNumbersStyle=mt={}));var Rt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Rt||(e.TextDocumentSaveReason=Rt={}));var At;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var Qt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var _t;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var _e;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(_e||(e.DecorationRangeBehavior=_e={})),function(z){function F(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=F}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Ot;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(z){function F(ie){switch(ie){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=F}(Ot||(e.SyntaxTokenType=Ot={}));let Ut=class{constructor(F,ie){if(ie&&!s.URI.isUri(ie))throw(0,D.$9)("target");if(!Z.isRange(F)||F.isEmpty)throw(0,D.$9)("range");this.range=F,this.target=ie}};e.$HO=Ut,e.$HO=Ut=Xe([$],Ut);let $t=class{constructor(F,ie,Se,Ze){this.red=F,this.green=ie,this.blue=Se,this.alpha=Ze}};e.$IO=$t,e.$IO=$t=Xe([$],$t);let Pt=class{constructor(F,ie){if(ie&&!(ie instanceof $t))throw(0,D.$9)("color");if(!Z.isRange(F)||F.isEmpty)throw(0,D.$9)("range");this.range=F,this.color=ie}};e.$JO=Pt,e.$JO=Pt=Xe([$],Pt);let ei=class{constructor(F){if(!F||typeof F!="string")throw(0,D.$9)("label");this.label=F}};e.$KO=ei,e.$KO=ei=Xe([$],ei);var ti;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var Ht;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var wt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(wt||(e.TerminalExitReason=wt={}));var Nt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(Nt||(e.TerminalShellExecutionCommandLineConfidence=Nt={}));class ai{constructor(F,ie,Se){if(this.startIndex=F,this.length=ie,this.tooltip=Se,typeof F!="number"||F<0)throw(0,D.$9)("startIndex");if(typeof ie!="number"||ie<1)throw(0,D.$9)("length");if(Se!==void 0&&typeof Se!="string")throw(0,D.$9)("tooltip")}}e.$LO=ai;class Zt{constructor(F){this.uri=F}}e.$MO=Zt;class Ye{constructor(F){this.terminalCommand=F}}e.$NO=Ye;var ii;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(ii||(e.TerminalLocation=ii={}));class ci{constructor(F){if(this.options=F,typeof F!="object")throw(0,D.$9)("options")}}e.$OO=ci;var ui;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(ui||(e.TaskRevealKind=ui={}));var Et;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Et||(e.TaskPanelKind=Et={}));let jt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(F){switch(F){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(F,ie){if(this.label=ie,typeof F!="string"||typeof ie!="string")throw(0,D.$9)("name");this.c=F}get id(){return this.c}};e.$PO=jt,e.$PO=jt=S=Xe([$],jt);function Lt(z){let F="";for(let ie=0;ie<z.length;ie++)F+=z[ie].replace(/,/g,",,")+",";return F}let Bt=class{constructor(F,ie,Se){if(typeof F!="string")throw(0,D.$9)("process");this.e=[],this.c=F,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Se):this.f=ie)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,D.$9)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)F.push(ie);return Lt(F)}};e.$QO=Bt,e.$QO=Bt=Xe([$],Bt);let oi=class{constructor(F,ie,Se){if(this.f=[],Array.isArray(ie)){if(!F)throw(0,D.$9)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,D.$9)("command");this.e=F,this.f=ie,this.g=Se}else{if(typeof F!="string")throw(0,D.$9)("commandLine");this.c=F,this.g=ie}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,D.$9)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,D.$9)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)F.push(typeof ie=="string"?ie:ie.value);return Lt(F)}};e.$RO=oi,e.$RO=oi=Xe([$],oi);var ni;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var ri;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Kt{constructor(F){this.c=F}computeId(){return"customExecution"+(0,I.$5g)()}set callback(F){this.c=F}get callback(){return this.c}}e.$SO=Kt;let Gt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,ie,Se,Ze,at,pt){this.k=!1,this.l=this.definition=F;let yt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=Se,this.execution=Ze,yt=at,this.k=!0):ie===ri.Global||ie===ri.Workspace?(this.target=ie,this.o=this.name=Se,this.w=this.source=Ze,this.execution=at,yt=pt):(this.target=ie,this.o=this.name=Se,this.w=this.source=Ze,this.execution=at,yt=pt),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof oi?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Kt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,I.$5g)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,D.$9)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,D.$9)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const ie=this.l.type;(k.g===ie||k.e===ie||k.f===ie||k.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,D.$9)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$TO=Gt,e.$TO=Gt=k=Xe([$],Gt);var li;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(li||(e.ProgressLocation=li={}));var Mt;(function(z){function F(ie){const Se=ie;return(0,p.$lg)(Se.value)?Se.tooltip&&!(0,p.$hg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}z.isViewBadge=F})(Mt||(e.ViewBadge=Mt={}));let Dt=w=class{static isTreeItem(F,ie){const Se=F;if(Se.checkboxState!==void 0){const Ze=(0,p.$lg)(Se.checkboxState)?Se.checkboxState:(0,p.$jg)(Se.checkboxState)&&(0,p.$lg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,at=!(0,p.$lg)(Se.checkboxState)&&(0,p.$jg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Jt.Checked&&Ze!==Jt.Unchecked||at!==void 0&&!(0,p.$hg)(at))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(F instanceof w)return!0;if(Se.label!==void 0&&!(0,p.$hg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$hg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$hg)(Se.iconPath)&&!s.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$hg)(Se.iconPath.id))){const Ze=Se.iconPath;if(!Ze||!(0,p.$hg)(Ze.light)&&!s.URI.isUri(Ze.light)&&!(0,p.$hg)(Ze.dark)&&!s.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$hg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!s.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$hg)(Se.tooltip)&&!(Se.tooltip instanceof st)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<bt.None&&Se.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$hg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(F,ie=bt.None){this.collapsibleState=ie,s.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$UO=Dt,e.$UO=Dt=w=Xe([$],Dt);var bt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Jt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Jt||(e.TreeItemCheckboxState=Jt={}));let St=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$VO=St,e.$VO=St=Xe([$],St);class hi extends St{}e.$WO=hi;class Xt extends hi{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$XO=Xt;class Mi{constructor(F,ie,Se,Ze){this.name=F,this.uri=ie,this._itemId=Se,this.c=Ze}data(){return this.c()}}e.$YO=Mi;let di=class{#e=new Map;constructor(F){for(const[ie,Se]of F??[]){const Ze=this.#e.get(this.#t(ie));Ze?Ze.push(Se):this.#e.set(this.#t(ie),[Se])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,ie){this.#e.set(this.#t(F),[ie])}forEach(F,ie){for(const[Se,Ze]of this.#e)for(const at of Ze)F.call(ie,at,Se,this)}*[Symbol.iterator](){for(const[F,ie]of this.#e)for(const Se of ie)yield[F,Se]}#t(F){return F.toLowerCase()}};e.$ZO=di,e.$ZO=di=Xe([$],di);let yi=class{constructor(F,ie,Se){this.insertText=F,this.title=ie,this.kind=Se}};e.$1O=yi,e.$1O=yi=Xe([$],yi);var Wt;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(Wt||(e.DocumentPasteTriggerKind=Wt={}));class fi{static{this.c="."}constructor(F){this.value=F}append(...F){return new fi((this.value?[this.value,...F]:F).join(fi.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+fi.c)}}e.$2O=fi,fi.Empty=new fi("");class Fi{constructor(F,ie,Se){this.title=ie,this.insertText=F,this.kind=Se}}e.$3O=Fi;let Ct=class{constructor(F,ie){this.id=F,this.color=ie}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$4O=Ct,e.$4O=Ct=Xe([$],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Si=class{constructor(F){this.id=F}};e.$5O=Si,e.$5O=Si=Xe([$],Si);var Ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ai||(e.ConfigurationTarget=Ai={}));let gi=class{get base(){return this.c}set base(F){this.c=F,this.e=s.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,ie){if(typeof F!="string"&&(!F||!s.URI.isUri(F)&&!s.URI.isUri(F.uri)))throw(0,D.$9)("base");if(typeof ie!="string")throw(0,D.$9)("pattern");typeof F=="string"?this.baseUri=s.URI.file(F):s.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$6O=gi,e.$6O=gi=Xe([$],gi);const zi=new WeakMap;function ji(z,F){zi.set(z,F)}let zt=class{constructor(F,ie,Se,Ze,at){this.enabled=typeof F=="boolean"?F:!0,typeof ie=="string"&&(this.condition=ie),typeof Se=="string"&&(this.hitCondition=Se),typeof Ze=="string"&&(this.logMessage=Ze),typeof at=="string"&&(this.mode=at)}get id(){return this.c||(this.c=zi.get(this)??(0,I.$5g)()),this.c}};e.$8O=zt,e.$8O=zt=Xe([$],zt);let Pi=class extends zt{constructor(F,ie,Se,Ze,at,pt){if(super(ie,Se,Ze,at,pt),F===null)throw(0,D.$9)("location");this.location=F}};e.$9O=Pi,e.$9O=Pi=Xe([$],Pi);let Di=class extends zt{constructor(F,ie,Se,Ze,at,pt){super(ie,Se,Ze,at,pt),this.functionName=F}};e.$0O=Di,e.$0O=Di=Xe([$],Di);let wi=class extends zt{constructor(F,ie,Se,Ze,at,pt,yt,xt){if(super(Ze,at,pt,yt,xt),!ie)throw(0,D.$9)("dataId");this.label=F,this.dataId=ie,this.canPersist=Se}};e.$$O=wi,e.$$O=wi=Xe([$],wi);let bi=class{constructor(F,ie,Se){this.command=F,this.args=ie||[],this.options=Se}};e.$_O=bi,e.$_O=bi=Xe([$],bi);let me=class{constructor(F,ie){this.port=F,this.host=ie}};e.$aP=me,e.$aP=me=Xe([$],me);let De=class{constructor(F){this.path=F}};e.$bP=De,e.$bP=De=Xe([$],De);let ae=class{constructor(F){this.implementation=F}};e.$cP=ae,e.$cP=ae=Xe([$],ae);class K{constructor(F,ie,Se){this.session=F,this.threadId=ie,this.frameId=Se}}e.$dP=K;class Ie{constructor(F,ie){this.session=F,this.threadId=ie}}e.$eP=Ie;let Be=class{constructor(F,ie){this.range=F,this.expression=ie}};e.$fP=Be,e.$fP=Be=Xe([$],Be);var tt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(tt||(e.InlineCompletionTriggerKind=tt={}));let Ke=class{constructor(F,ie){this.range=F,this.text=ie}};e.$gP=Ke,e.$gP=Ke=Xe([$],Ke);let gt=class{constructor(F,ie,Se=!0){this.range=F,this.variableName=ie,this.caseSensitiveLookup=Se}};e.$hP=gt,e.$hP=gt=Xe([$],gt);let Tt=class{constructor(F,ie){this.range=F,this.expression=ie}};e.$iP=Tt,e.$iP=Tt=Xe([$],Tt);let Yt=class{constructor(F,ie){this.frameId=F,this.stoppedLocation=ie}};e.$jP=Yt,e.$jP=Yt=Xe([$],Yt);var Vt;(function(z){z[z.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var qt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(qt||(e.NewSymbolNameTriggerKind=qt={}));class Ni{constructor(F,ie){this.newSymbolName=F,this.tags=ie}}e.$kP=Ni;var en;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=P=class extends Error{static FileExists(F){return new P(F,h.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(F){return new P(F,h.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(F){return new P(F,h.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(F){return new P(F,h.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(F){return new P(F,h.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(F){return new P(F,h.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}constructor(F,ie=h.FileSystemProviderErrorCode.Unknown,Se){super(s.URI.isUri(F)?F.toString(!0):F),this.code=Se?.name??"Unknown",(0,h.$sl)(this,ie),Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$lP=Vi,e.$lP=Vi=P=Xe([$],Vi);let Ei=class{constructor(F,ie,Se){this.start=F,this.end=ie,this.kind=Se}};e.$mP=Ei,e.$mP=Ei=Xe([$],Ei);var tn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var Ui;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var rn;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Qi;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));var sn;(function(z){z[z.Reply=1]="Reply",z[z.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(F,ie=[]){this.tokenTypes=F,this.tokenModifiers=ie}}e.$nP=on;function wn(z){return typeof z>"u"||(0,p.$ig)(z)}class Ci{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let ie=0,Se=F.tokenTypes.length;ie<Se;ie++)this.k.set(F.tokenTypes[ie],ie);for(let ie=0,Se=F.tokenModifiers.length;ie<Se;ie++)this.l.set(F.tokenModifiers[ie],ie)}}push(F,ie,Se,Ze,at){if(typeof F=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ze=="number"&&(typeof at=="number"||typeof at>"u"))return typeof at>"u"&&(at=0),this.q(F,ie,Se,Ze,at);if(Z.isRange(F)&&typeof ie=="string"&&wn(Se))return this.o(F,ie,Se);throw(0,D.$9)()}o(F,ie,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ze=F.start.line,at=F.start.character,pt=F.end.character-F.start.character,yt=this.k.get(ie);let xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const vi=this.l.get($i);xt|=1<<vi>>>0}this.q(Ze,at,pt,yt,xt)}q(F,ie,Se,Ze,at){if(this.f&&(F<this.c||F===this.c&&ie<this.e)){this.f=!1;const xt=this.g.length/5|0;let $i=0,vi=0;for(let Ii=0;Ii<xt;Ii++){let Oi=this.g[5*Ii],xi=this.g[5*Ii+1];Oi===0?(Oi=$i,xi+=vi):Oi+=$i,this.g[5*Ii]=Oi,this.g[5*Ii+1]=xi,$i=Oi,vi=xi}}let pt=F,yt=ie;this.f&&this.j>0&&(pt-=this.c,pt===0&&(yt-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=yt,this.g[this.j++]=Se,this.g[this.j++]=Ze,this.g[this.j++]=at,this.c=F,this.e=ie}static r(F){const ie=[],Se=F.length/5|0;for(let yt=0;yt<Se;yt++)ie[yt]=yt;ie.sort((yt,xt)=>{const $i=F[5*yt],vi=F[5*xt];if($i===vi){const Ii=F[5*yt+1],Oi=F[5*xt+1];return Ii-Oi}return $i-vi});const Ze=new Uint32Array(F.length);let at=0,pt=0;for(let yt=0;yt<Se;yt++){const xt=5*ie[yt],$i=F[xt+0],vi=F[xt+1],Ii=F[xt+2],Oi=F[xt+3],xi=F[xt+4],Qn=$i-at,Mr=Qn===0?vi-pt:vi,_i=5*yt;Ze[_i+0]=Qn,Ze[_i+1]=Mr,Ze[_i+2]=Ii,Ze[_i+3]=Oi,Ze[_i+4]=xi,at=$i,pt=vi}return Ze}build(F){return this.f?new Hi(new Uint32Array(this.g),F):new Hi(Ci.r(this.g),F)}}e.$oP=Ci;class Hi{constructor(F,ie){this.resultId=ie,this.data=F}}e.$pP=Hi;class bn{constructor(F,ie,Se){this.start=F,this.deleteCount=ie,this.data=Se}}e.$qP=bn;class vn{constructor(F,ie){this.resultId=ie,this.edits=F}}e.$rP=vn;var qi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(qi||(e.DebugConsoleMode=qi={}));class an{constructor(F){this.name=F}}e.$sP=an;var Le;(function(z){z[z.Title=1]="Title",z[z.Inline=2]="Inline"})(Le||(e.QuickInputButtonLocation=Le={}));let mi=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$tP=mi,e.$tP=mi=Xe([$],mi);var Ki;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ki||(e.QuickPickItemKind=Ki={}));var ht;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ht||(e.InputBoxValidationSeverity=ht={}));var kt;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(kt||(e.ExtensionKind=kt={}));class yn{static validate(F){if(typeof F.badge=="string"){let ie=(0,O.$Sf)(F.badge,0);if(ie<F.badge.length&&(ie+=(0,O.$Sf)(F.badge,ie)),F.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Ct.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,ie,Se){this.badge=F,this.tooltip=ie,this.color=Se}}e.$uP=yn;let Gi=class{constructor(F){this.kind=F}};e.$vP=Gi,e.$vP=Gi=Xe([$],Gi);var Ji;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class ki{static isNotebookRange(F){return F instanceof ki?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,ie){if(F<0)throw(0,D.$9)("start must be positive");if(ie<0)throw(0,D.$9)("end must be positive");F<=ie?(this.c=F,this.e=ie):(this.c=ie,this.e=F)}with(F){let ie=this.c,Se=this.e;return F.start!==void 0&&(ie=F.start),F.end!==void 0&&(Se=F.end),ie===this.c&&Se===this.e?this:new ki(ie,Se)}}e.$wP=ki;class Ri{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ie=>Ri.isNotebookCellData(ie))}static isNotebookCellData(F){return!0}constructor(F,ie,Se,Ze,at,pt,yt){this.kind=F,this.value=ie,this.languageId=Se,this.mime=Ze,this.outputs=at??[],this.metadata=pt,this.executionSummary=yt,Ri.validate(this)}}e.$xP=Ri;class Sn{constructor(F){this.cells=F}}e.$yP=Sn;class pi{static isNotebookCellOutputItem(F){return F instanceof pi?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ie={name:F.name,message:F.message,stack:F.stack};return pi.json(ie,"application/vnd.code.notebook.error")}static stdout(F){return pi.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return pi.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ie="application/octet-stream"){return new pi(F,ie)}static#e=new TextEncoder;static text(F,ie=T.$dt.text){const Se=pi.#e.encode(String(F));return new pi(Se,ie)}static json(F,ie="text/x-json"){const Se=JSON.stringify(F,void 0,"	");return pi.text(Se,ie)}constructor(F,ie){this.data=F,this.mime=ie;const Se=(0,T.$ht)(ie,!0);if(!Se)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$zP=pi;class Wi{static isNotebookCellOutput(F){return F instanceof Wi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ie=!1){const Se=new Set,Ze=new Set;for(let at=0;at<F.length;at++){const pt=F[at],yt=(0,T.$ht)(pt.mime);if(!Se.has(yt)||(0,f.$4L)(yt)){Se.add(yt);continue}Ze.add(at),ie&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return Ze.size===0?F:F.filter((at,pt)=>!Ze.has(pt))}constructor(F,ie,Se){this.items=Wi.ensureUniqueMimeTypes(F,!0),typeof ie=="string"?(this.id=ie,this.metadata=Se):(this.id=(0,I.$5g)(),this.metadata=ie??Se)}}e.$AP=Wi;var Zi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Zi||(e.NotebookCellKind=Zi={}));var cn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class En{constructor(F,ie){this.text=F,this.alignment=ie}}e.$BP=En;var hn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class kn{constructor(F,ie=[]){this.uri=F,this.provides=(0,y.$4b)(ie)}}e.$CP=kn;class In{constructor(F){this.label=F}}e.$DP=In;var fn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Xi=class{constructor(F,ie){this.label=F,this.timestamp=ie}};e.$EP=Xi,e.$EP=Xi=Xe([$],Xi);var gn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var _;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(_||(e.ExtensionRuntime=_={}));var le;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(le||(e.StandardTokenType=le={}));class Ne{constructor(F,ie){this.ranges=F,this.wordPattern=ie}}e.$FP=Ne;class ft{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$GP=ft;var It;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(It||(e.TestResultState=It={}));var Ft;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Ti=class{constructor(F=void 0,ie=void 0,Se=void 0,Ze=!1,at=!0){this.include=F,this.exclude=ie,this.profile=Se,this.continuous=Ze,this.preserveFocus=at}};e.$HP=Ti,e.$HP=Ti=Xe([$],Ti);let Yi=R=class{static diff(F,ie,Se){const Ze=new R(F);return Ze.expectedOutput=ie,Ze.actualOutput=Se,Ze}constructor(F){this.message=F}};e.$IP=Yi,e.$IP=Yi=R=Xe([$],Yi);let Pn=class{constructor(F){this.id=F}};e.$JP=Pn,e.$JP=Pn=Xe([$],Pn);class Gn{constructor(F,ie,Se){this.label=F,this.uri=ie,this.position=Se}}e.$KP=Gn;class mn{constructor(F,ie){this.covered=F,this.total=ie,Cn(this)}}e.$LP=mn;function Cn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class Dn{static fromDetails(F,ie){const Se=new mn(0,0),Ze=new mn(0,0),at=new mn(0,0);for(const yt of ie)if("branches"in yt){Se.total+=1,Se.covered+=yt.executed?1:0;for(const xt of yt.branches)Ze.total+=1,Ze.covered+=xt.executed?1:0}else at.total+=1,at.covered+=yt.executed?1:0;const pt=new Dn(F,Se,Ze.total>0?Ze:void 0,at.total>0?at:void 0);return pt.detailedCoverage=ie,pt}constructor(F,ie,Se,Ze,at=[]){this.uri=F,this.statementCoverage=ie,this.branchCoverage=Se,this.declarationCoverage=Ze,this.fromTests=at}}e.$NP=Dn;class Jn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,ie,Se=[]){this.executed=F,this.location=ie,this.branches=Se}}e.$OP=Jn;class Zn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,ie,Se){this.executed=F,this.location=ie,this.label=Se}}e.$PP=Zn;class Xn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,ie,Se){this.name=F,this.executed=ie,this.location=Se}}e.$QP=Xn;var Rn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var Tn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Tn||(e.WorkspaceTrustState=Tn={}));var On;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Yn{constructor(F,ie,Se,Ze,at,pt){this.kind=F,this.name=ie,this.detail=Se,this.uri=Ze,this.range=at,this.selectionRange=pt}}e.$RP=Yn;class xn{constructor(F){this.uri=F}}e.$SP=xn;class _n{constructor(F,ie){this.original=F,this.modified=ie}}e.$TP=_n;class er{constructor(F,ie,Se,Ze){this.base=F,this.input1=ie,this.input2=Se,this.result=Ze}}e.$UP=er;class tr{constructor(F,ie){this.uri=F,this.viewType=ie}}e.$VP=tr;class ir{constructor(F){this.viewType=F}}e.$WP=ir;class nr{constructor(F,ie){this.uri=F,this.notebookType=ie}}e.$XP=nr;class rr{constructor(F,ie,Se){this.original=F,this.modified=ie,this.notebookType=Se}}e.$YP=rr;class sr{constructor(){}}e.$ZP=sr;class or{constructor(F,ie){this.uri=F,this.inputBoxUri=ie}}e.$1P=or;class ar{constructor(){}}e.$2P=ar;class cr{constructor(F){this.textDiffs=F}}e.$3P=cr;var An;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(An||(e.InteractiveSessionVoteDirection=An={}));var Nn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Ln;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Ln||(e.ChatVariableLevel=Ln={}));class lr{constructor(F,ie,Se){this.id=F,this.label=ie,this.values=Se}}e.$4P=lr;var Mn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Fn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new st(F):F}}e.$5P=ur;class hr{constructor(F,ie){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new st(F):F,this.vulnerabilities=ie}}e.$6P=hr;class dr{constructor(F,ie){this.participant=F,this.command=ie}}e.$7P=dr;class fr{constructor(F,ie,Se,Ze){this.title=F,this.message=ie,this.data=Se,this.buttons=Ze}}e.$8P=fr;class gr{constructor(F,ie){this.value=F,this.baseUri=ie}}e.$9P=gr;class mr{constructor(F,ie){this.value=F,this.title=ie}}e.$0P=mr;class pr{constructor(F){this.value=F}}e.$$P=pr;class $r{constructor(F,ie){this.value=F,this.task=ie}}e.$_P=$r;class wr{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new st(F):F}}e.$aQ=wr;class br{constructor(F){this.value=F}}e.$bQ=br;class vr{constructor(F,ie,Se){this.value=F,this.iconPath=ie,this.options=Se}}e.$cQ=vr;class yr{constructor(F,ie,Se){this.value=F,this.license=ie,this.snippet=Se}}e.$dQ=yr;class Sr{constructor(F,ie){this.uri=F,this.range=ie}}e.$eQ=Sr;class Er{constructor(F,ie){this.uri=F,this.edits=Array.isArray(ie)?ie:[ie]}}e.$fQ=Er;class kr{constructor(F,ie,Se,Ze){this.prompt=F,this.command=ie,this.references=Se,this.participant=Ze}}e.$gQ=kr;class Ir{constructor(F,ie,Se,Ze){this.response=F,this.result=ie,this.participant=Se,this.command=Ze}}e.$hQ=Ir;var zn;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var Un;(function(z){z[z.Complete=1]="Complete",z[z.Partial=2]="Partial",z[z.Omitted=3]="Omitted"})(Un||(e.ChatResponseReferencePartStatusKind=Un={}));class Pr{constructor(F,ie,Se){this.document=F,this.selection=ie,this.wholeRange=Se}}e.$iQ=Pr;class Dr{constructor(F){this.cell=F}}e.$jQ=Dr;var pn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Cr{constructor(F,ie,Se){this.name=F,this.content=ie,this.isError=Se??!1}}e.$kQ=Cr;class $n{static User(F,ie){const Se=new $n(pn.User,typeof F=="string"?F:"",ie);return Se.content2=F,Se}static Assistant(F,ie){return new $n(pn.Assistant,F,ie)}constructor(F,ie,Se){this.role=F,this.content=ie,this.content2=ie,this.name=Se}}e.$lQ=$n;class Rr{constructor(F,ie){this.name=F,this.parameters=ie}}e.$mQ=Rr;class Tr{constructor(F){this.value=F}}e.$nQ=Tr;class Or{constructor(F){this.content=F}}e.$oQ=Or;class Ar{constructor(F,ie){this.content=F,this.name=ie}}e.$pQ=Ar;class Nr{constructor(F,ie){this.content=F,this.name=ie}}e.$qQ=Nr;class Li extends Error{static NotFound(F){return new Li(F,Li.NotFound.name)}static NoPermissions(F){return new Li(F,Li.NoPermissions.name)}static Blocked(F){return new Li(F,Li.Blocked.name)}constructor(F,ie,Se){super(F,{cause:Se}),this.name="LanguageModelError",this.code=ie??""}}e.$rQ=Li;var jn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(jn||(e.RelatedInformationType=jn={}));var Bn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var qn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(qn||(e.TextToSpeechStatus=qn={}));var Wn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Wn||(e.KeywordRecognitionStatus=Wn={}));class Lr{constructor(F,ie){this.text=F,this.range=ie}}e.$sQ=Lr;var Vn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Oe[227],Ae([1,0,5,7]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=void 0;class C{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(y.$3N.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,O,p){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(T);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(O,p)??[]}getRelatedInformation(T,O,p){return this.c.$getAiRelatedInformation(O,p)}registerRelatedInformationProvider(T,O,p){const s=this.b;return this.b++,this.a.set(s,p),this.c.$registerAiRelatedInformationProvider(s,O),new D.$5N(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$oqc=C}),define(Oe[91],Ae([1,0,6,5,7,18,119,3,16]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=e.$zqc=void 0,e.$zqc=(0,O.$Ii)("IExtHostAuthentication");let s=class{constructor(h){this.b=new Map,this.c=new y.$oe,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=h.getProxy(D.$3N.MainThreadAuthentication)}async getSession(h,E,f,r={}){const a=N.$un.toKey(h.identifier),c=[...f].sort().join(" ");return await this.d.getOrCreate(`${a} ${E} ${c}`,async()=>{await this.a.$ensureProvider(E);const u=h.displayName||h.name;return this.a.$getSession(E,f,a,u,r)})}async getAccounts(h){return await this.a.$ensureProvider(h),await this.a.$getAccounts(h)}async removeSession(h,E){const f=this.b.get(h);return f?f.provider.removeSession(E):this.a.$removeSession(h,E)}registerAuthenticationProvider(h,E,f,r){if(this.b.get(h))throw new Error(`An authentication provider with id '${h}' is already registered.`);this.b.set(h,{label:E,provider:f,options:r??{supportsMultipleAccounts:!1}});const a=f.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(h,c));return this.a.$registerAuthenticationProvider(h,E,r?.supportsMultipleAccounts??!1),new C.$5N(()=>{a.dispose(),this.b.delete(h),this.a.$unregisterAuthenticationProvider(h)})}async $createSession(h,E,f){const r=this.b.get(h);if(r)return await r.provider.createSession(E,f);throw new Error(`Unable to find authentication provider with handle: ${h}`)}async $removeSession(h,E){const f=this.b.get(h);if(f)return await f.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${h}`)}async $getSessions(h,E,f){const r=this.b.get(h);if(r)return await r.provider.getSessions(E,f);throw new Error(`Unable to find authentication provider with handle: ${h}`)}$onDidChangeAuthenticationSessions(h,E){return h.startsWith(T.$4M)||this.c.fire({provider:{id:h,label:E}}),Promise.resolve()}};e.$Aqc=s,e.$Aqc=s=Xe([Qe(0,p.$DQ)],s);class I{constructor(){this.a=new Map}getOrCreate(h,E){const f=this.a.get(h);if(f)return f;const r=E().finally(()=>this.a.delete(h));return this.a.set(h,r),r}}}),define(Oe[124],Ae([1,0,2,5,7,3,16,11,17,12,20,24]),function($e,e,y,D,C,N,T,O,p,s,I,v){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Frc=e.$Erc=void 0;let E=class{static{h=this}static{this.c=0}static{this.d=250}constructor(r,a){this.h=a,this.f=new Map,this.g=r.getProxy(D.$3N.MainThreadDecorations)}registerFileDecorationProvider(r,a){const c=h.c++;this.f.set(c,{provider:r,extensionDescription:a}),this.g.$registerDecorationProvider(c,a.identifier.value);const u=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const n=(0,p.$4b)(i);if(n.length<=h.d){this.g.$onDidChange(c,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,n.length);const t=n.map(m=>({uri:m,rank:(0,s.$lf)(m.path,"/")})),o=(0,p.$Bb)(t,(m,g)=>m.rank-g.rank||(0,s.$Bf)(m.uri.path,g.uri.path)),l=[];e:for(const m of o){let g;for(const d of m){const S=(0,I.$pc)(d.uri.path);if(g!==S&&(g=S,l.push(d.uri)>=h.d))break e}}this.g.$onDidChange(c,l)});return new C.$5N(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(r,a,c){if(!this.f.has(r))return Object.create(null);const u=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(a.map(async t=>{try{const{uri:o,id:l}=t,m=await Promise.resolve(i.provideFileDecoration(y.URI.revive(o),c));if(!m)return;try{C.$uP.validate(m),m.badge&&typeof m.badge!="string"&&(0,v.$vH)(n,"codiconDecoration"),u[l]=[m.propagate,m.tooltip,m.badge,m.color]}catch(g){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${g}`)}}catch(o){this.h.error(o)}})),u}};e.$Erc=E,e.$Erc=E=h=Xe([Qe(0,T.$DQ),Qe(1,O.$dk)],E),e.$Frc=(0,N.$Ii)("IExtHostDecorations")}),define(Oe[228],Ae([1,0,13,2,7,5,15,19,12]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hrc=void 0;class s{static{this.a=0}constructor(v,h,E){this.d=h,this.e=E,this.b=new Map,this.c=v.getProxy(N.$3N.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,h){if(Object.keys(T.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const E=s.a++;this.b.set(E,h),this.c.$registerTextContentProvider(E,v);let f;if(typeof h.onDidChange=="function"){let r;f=h.onDidChange(async a=>{if(a.scheme!==v){this.e.warn(`Provider for scheme '${v}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;r&&await r;const c=this.$provideTextDocumentContent(E,a).then(async u=>{if(!u&&typeof u!="string")return;const i=this.d.getDocument(a);if(!i)return;const n=(0,p.$vf)(u);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(a,u)}).catch(y.$2).finally(()=>{r===c&&(r=void 0)});r=c})}return new C.$5N(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(v,h){const E=this.b.get(v);return E?Promise.resolve(E.provideTextDocumentContent(D.URI.revive(h),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.$Hrc=s}),define(Oe[125],Ae([1,0,62,15,12,285,170,7,17]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=void 0,e.$FQ=I;const s=new Map;function I(f,r){r?s.set(f,r):s.delete(f)}function v(f){return s.get(f)}class h extends N.$vw{constructor(r,a,c,u,i,n,t){super(a,c,u,i),this.c=r,this.m=n,this.q=t,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$wb)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===D.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(a){return a?r.s(a):r.getText()},get eol(){return r.g===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(a){return r.t(a)},offsetAt(a){return r.u(a)},positionAt(a){return r.v(a)},validateRange(a){return r.w(a)},validatePosition(a){return r.x(a)},getWordRangeAtPosition(a,c){return r.y(a,c)},[Symbol.for("debug.description")](){return`TextDocument(${r.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,y.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,y.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const a=this.w(r);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const c=this.g,u=a.start.line,i=a.end.line,n=[];n.push(this.f[u].substring(a.start.character));for(let t=u+1;t<i;t++)n.push(this.f[t]);return n.push(this.f[i].substring(0,a.end.character)),n.join(c)}t(r){let a;if(r instanceof O.$6N?a=r.line:typeof r=="number"&&(a=r),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new E(a,this.f[a],a===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const a=this.j.getIndexOf(r),c=this.f[a.index].length;return new O.$6N(a.index,Math.min(a.remainder,c))}w(r){if(!(r instanceof O.$7N))throw new Error("Invalid argument");const a=this.x(r.start),c=this.x(r.end);return a===r.start&&c===r.end?r:new O.$7N(a.line,a.character,c.line,c.character)}x(r){if(!(r instanceof O.$6N))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:a,character:c}=r,u=!1;if(a<0)a=0,c=0,u=!0;else if(a>=this.f.length)a=this.f.length-1,c=this.f[a].length,u=!0;else{const i=this.f[a].length;c<0?(c=0,u=!0):c>i&&(c=i,u=!0)}return u?new O.$6N(a,c):r}y(r,a){const c=this.x(r);if(!a)a=v(this.m);else if((0,C.$uf)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const u=(0,T.$vt)(c.character+1,(0,T.$tt)(a),this.f[c.line],0);if(u)return new O.$7N(c.line,u.startColumn-1,c.line,u.endColumn-1)}}e.$GQ=h;class E{constructor(r,a,c){this.a=r,this.b=a,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.$7N(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.$7N(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$HQ=E}),define(Oe[229],Ae([1,0,5,7]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Krc=void 0;class C{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(y.$3N.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,O,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(T);if(!s)throw new Error("Embedding vector provider not found");const I=await s.provideEmbeddingVector(O,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(T,O,p){const s=this.b;return this.b++,this.a.set(s,p),this.c.$registerAiEmbeddingVectorProvider(O,s),new D.$5N(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$Krc=C}),define(Oe[69],Ae([1,0,5,29,7,22,3,16,51,4,10,23,15]),function($e,e,y,D,C,N,T,O,p,s,I,v,h){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=e.$Pqc=void 0,D=He(D);let f=E=class{constructor(a,c){this.b=new Map,this.c=new I.$Rh,this.a=a.getProxy(y.$3N.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(i){try{let n;const t=u.b.get(i.scheme);return t?(await u.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await u.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===D.FilePermission.Readonly?1:void 0}}catch(n){E.e(n)}},async readDirectory(i){try{const n=u.b.get(i.scheme);return n?(await u.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await u.a.$readdir(i)}catch(n){return E.e(n)}},async createDirectory(i){try{const n=u.b.get(i.scheme);return n&&!n.isReadonly?(await u.a.$ensureActivation(i.scheme),await u.d(n.impl,n.extUri,i)):await u.a.$mkdir(i)}catch(n){return E.e(n)}},async readFile(i){try{const n=u.b.get(i.scheme);return n?(await u.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await u.a.$readFile(i)).buffer}catch(n){return E.e(n)}},async writeFile(i,n){try{const t=u.b.get(i.scheme);return t&&!t.isReadonly?(await u.a.$ensureActivation(i.scheme),await u.d(t.impl,t.extUri,t.extUri.dirname(i)),await u.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await u.a.$writeFile(i,N.$Qe.wrap(n))}catch(t){return E.e(t)}},async delete(i,n){try{const t=u.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await u.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await u.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return E.e(t)}},async rename(i,n,t){try{return await u.a.$rename(i,n,{overwrite:!1,...t})}catch(o){return E.e(o)}},async copy(i,n,t){try{return await u.a.$copy(i,n,{overwrite:!1,...t})}catch(o){return E.e(o)}},isWritableFileSystem(i){const n=c.getCapabilities(i);if(typeof n=="number")return!(n&D.FileSystemProviderCapabilities.Readonly)}})}async d(a,c,u){const i=[];for(;!c.isEqual(u,c.dirname(u));)try{if(!((await a.stat(u)).type&D.FileType.Directory))throw C.$lP.FileExists(`Unable to create folder '${u.scheme===h.Schemas.file?u.fsPath:u.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(D.$tl(n)!==D.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(c.basename(u)),u=c.dirname(u)}for(let n=i.length-1;n>=0;n--){u=c.joinPath(u,i[n]);try{await a.createDirectory(u)}catch(t){if(D.$tl(t)!==D.FileSystemProviderErrorCode.FileExists)throw t}}}static e(a){if(a instanceof C.$lP)throw a;if(a instanceof D.$pl)switch(a.code){case D.FileSystemProviderErrorCode.FileExists:throw C.$lP.FileExists(a.message);case D.FileSystemProviderErrorCode.FileNotFound:throw C.$lP.FileNotFound(a.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw C.$lP.FileNotADirectory(a.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw C.$lP.FileIsADirectory(a.message);case D.FileSystemProviderErrorCode.NoPermissions:throw C.$lP.NoPermissions(a.message);case D.FileSystemProviderErrorCode.Unavailable:throw C.$lP.Unavailable(a.message);default:throw new C.$lP(a.message,a.name)}if(!(a instanceof Error))throw new C.$lP(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw C.$lP.Unavailable(a.message);switch(a.name){case D.FileSystemProviderErrorCode.FileExists:throw C.$lP.FileExists(a.message);case D.FileSystemProviderErrorCode.FileNotFound:throw C.$lP.FileNotFound(a.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw C.$lP.FileNotADirectory(a.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw C.$lP.FileIsADirectory(a.message);case D.FileSystemProviderErrorCode.NoPermissions:throw C.$lP.NoPermissions(a.message);case D.FileSystemProviderErrorCode.Unavailable:throw C.$lP.Unavailable(a.message);default:throw new C.$lP(a.message,a.name)}}addFileSystemProvider(a,c,u){return this.b.set(a,{impl:c,extUri:u?.isCaseSensitive?v.$_g:v.$bh,isReadonly:!!u?.isReadonly}),(0,s.$Vc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??v.$_g}};e.$Pqc=f,e.$Pqc=f=E=Xe([Qe(0,O.$DQ),Qe(1,p.$tqc)],f),e.$Qqc=(0,T.$Ii)("IExtHostConsumerFileSystem")}),define(Oe[92],Ae([1,0,3,26,11,69,2]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=e.$Rqc=void 0,e.$Rqc=(0,y.$Ii)("IExtensionStoragePaths");let O=class{constructor(s,I,v){this.d=I,this.f=v,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(s){return T.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,I=await this.g(s);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(T.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(v){this.d.error("[ExtHostStorage]",v);return}}workspaceValue(s){if(this.c)return T.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return T.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Sqc=O,e.$Sqc=O=Xe([Qe(0,D.$TQ),Qe(1,C.$dk),Qe(2,N.$Qqc)],O)}),define(Oe[230],Ae([1,0,7,16,6]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usc=void 0;let N=class{constructor(O){this.a=new y.$vP(y.ColorThemeKind.Dark),this.b=new C.$oe}get activeColorTheme(){return this.a}$onColorThemeChange(O){let p;switch(O){case"light":p=y.ColorThemeKind.Light;break;case"hcDark":p=y.ColorThemeKind.HighContrast;break;case"hcLight":p=y.ColorThemeKind.HighContrastLight;break;default:p=y.ColorThemeKind.Dark}this.a=new y.$vP(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$usc=N,e.$usc=N=Xe([Qe(0,D.$DQ)],N)}),define(Oe[93],Ae([1,0,19,6,4,9,3,11,184,5,26,16,7]),function($e,e,y,D,C,N,T,O,p,s,I,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NGb=e.$MGb=e.TunnelDtoConverter=void 0,N=He(N),h=He(h);class E extends p.$Uw{}var f;(function(a){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}a.fromApiTunnel=c;function u(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}a.fromServiceTunnel=u})(f||(e.TunnelDtoConverter=f={})),e.$MGb=(0,T.$Ii)("IExtHostTunnelService");let r=class extends C.$Xc{constructor(c,u,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new D.$oe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(s.$3N.MainThreadTunnelService)}async openTunnel(c,u){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const i=await this.a.$openTunnel(u,c.displayName);if(i){const n=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,u){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:u}),this.a.$registerPortsAttributesProvider(c,i),new h.$5N(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,u,i,n,t){const o=[];for(const m of c){const g=this.r.get(m);if(!g)return[];o.push(...await Promise.all(u.map(async d=>{let S;try{S=await g.provider.providePortAttributes({port:d,pid:i,commandLine:n},t)}catch{S=await g.provider.providePortAttributes(d,i,n,t)}return{providedAttributes:S,port:d}})))}const l=o.filter(m=>!!m.providedAttributes);return l.length>0?l.map(m=>({autoForwardAction:m.providedAttributes.autoForwardAction,port:m.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,u){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await c.provideTunnel(n,t,y.CancellationToken.None)??void 0;const i=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,privacyOptions:u.tunnelFeatures?.privacyOptions,protocol:u.tunnelFeatures.protocol===void 0?!0:u.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Vc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,u){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(u?this.w(u):void 0);if(i){this.b=i;let n=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:N.localize(2714,null),themeIcon:"lock"},{id:"public",label:N.localize(2715,null),themeIcon:"eye"}]);const t=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Vc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,u){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(u&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,u){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,u);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:n,disposeListener:t}),f.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const u=await Promise.all(c.map(n=>this.f(n.host,n.port,n.detail??""))),i=c.filter((n,t)=>u[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$NGb=r,e.$NGb=r=Xe([Qe(0,v.$DQ),Qe(1,I.$TQ),Qe(2,O.$dk)],r)}),define(Oe[8],Ae([1,0,17,22,152,231,60,28,139,33,73,25,145,23,35,14,2,106,32,160,94,53,108,77,118,116,117,207,81,90,55,56,204,7]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l,m,g,d,S,k,w,P,R,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$AQ=se,e.$BQ=te,e.$CQ=we,T=He(T),p=He(p),u=He(u),i=He(i),n=He(n),S=He(S),w=He(w),b=He(b);var L;(function(me){function De(K){const{selectionStartLineNumber:Ie,selectionStartColumn:Be,positionLineNumber:tt,positionColumn:Ke}=K,gt=new b.$6N(Ie-1,Be-1),Tt=new b.$6N(tt-1,Ke-1);return new b.$8N(gt,Tt)}me.to=De;function ae(K){const{anchor:Ie,active:Be}=K;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}me.from=ae})(L||(e.Selection=L={}));var A;(function(me){function De(K){if(!K)return;const{start:Ie,end:Be}=K;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}me.from=De;function ae(K){if(!K)return;const{startLineNumber:Ie,startColumn:Be,endLineNumber:tt,endColumn:Ke}=K;return new b.$7N(Ie-1,Be-1,tt-1,Ke-1)}me.to=ae})(A||(e.Range=A={}));var M;(function(me){function De(K){return{uri:K.uri,range:A.from(K.range)}}me.from=De;function ae(K){return new b.$gO(a.URI.revive(K.uri),A.to(K.range))}me.to=ae})(M||(e.Location=M={}));var Z;(function(me){function De(ae){switch(ae){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}me.to=De})(Z||(e.TokenType=Z={}));var G;(function(me){function De(K){return new b.$6N(K.lineNumber-1,K.column-1)}me.to=De;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}me.from=ae})(G||(e.Position=G={}));var U;(function(me){function De(Ie,Be,tt){return(0,y.$Jb)((0,y.$4b)(Ie).map(Ke=>ae(Ke,Be,tt)))}me.from=De;function ae(Ie,Be,tt){if(typeof Ie=="string")return{$serialized:!0,language:Ie,isBuiltin:tt?.isBuiltin};if(Ie)return{$serialized:!0,language:Ie.language,scheme:K(Ie.scheme,Be),pattern:Je.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType,isBuiltin:tt?.isBuiltin}}function K(Ie,Be){return Be&&typeof Ie=="string"?Be.transformOutgoingScheme(Ie):Ie}})(U||(e.DocumentSelector=U={}));var V;(function(me){function De(K){switch(K){case b.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}me.from=De;function ae(K){switch(K){case o.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}me.to=ae})(V||(e.DiagnosticTag=V={}));var Q;(function(me){function De(K){let Ie;return K.code&&((0,r.$hg)(K.code)||(0,r.$lg)(K.code)?Ie=String(K.code):Ie={value:String(K.code.value),target:K.code.target}),{...A.from(K.range),message:K.message,source:K.source,code:Ie,severity:ue.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(ne.from),tags:Array.isArray(K.tags)?(0,y.$Jb)(K.tags.map(V.from)):void 0}}me.from=De;function ae(K){const Ie=new b.$iO(A.to(K),K.message,ue.to(K.severity));return Ie.source=K.source,Ie.code=(0,r.$hg)(K.code)?K.code:K.code?.value,Ie.relatedInformation=K.relatedInformation&&K.relatedInformation.map(ne.to),Ie.tags=K.tags&&(0,y.$Jb)(K.tags.map(V.to)),Ie}me.to=ae})(Q||(e.Diagnostic=Q={}));var ne;(function(me){function De(K){return{...A.from(K.location.range),message:K.message,resource:K.location.uri}}me.from=De;function ae(K){return new b.$hO(new b.$gO(K.resource,A.to(K)),K.message)}me.to=ae})(ne||(e.DiagnosticRelatedInformation=ne={}));var ue;(function(me){function De(K){switch(K){case b.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}me.from=De;function ae(K){switch(K){case o.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}me.to=ae})(ue||(e.DiagnosticSeverity=ue={}));var x;(function(me){function De(K){return typeof K=="number"&&K>=b.ViewColumn.One?K-1:K===b.ViewColumn.Beside?$.$OE:$.$NE}me.from=De;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ae})(x||(e.ViewColumn=x={}));function oe(me){return typeof me.range<"u"}function se(me){return me.length===0?!0:!!oe(me[0])}var ce;(function(me){function De(Ke){return Ke.map(me.from)}me.fromMany=De;function ae(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function K(Ke){let gt;if(ae(Ke)){const{language:Vt,value:qt}=Ke;gt={value:"```"+Vt+`
`+qt+"\n```\n"}}else b.$wO.isMarkdownString(Ke)?gt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?gt={value:Ke}:gt={value:""};const Tt=Object.create(null);gt.uris=Tt;const Yt=({href:Vt})=>{try{let qt=a.URI.parse(Vt,!0);qt=qt.with({query:Ie(qt.query,Tt)}),Tt[Vt]=qt}catch{}return""};return p.marked.walkTokens(p.marked.lexer(gt.value),Vt=>{Vt.type==="link"?Yt({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&Yt(T.$cl(Vt.href))}),gt}me.from=K;function Ie(Ke,gt){if(!Ke)return Ke;let Tt;try{Tt=(0,s.$ei)(Ke)}catch{}if(!Tt)return Ke;let Yt=!1;return Tt=(0,v.$jo)(Tt,Vt=>{if(a.URI.isUri(Vt)){const qt=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[qt]=Vt,Yt=!0,qt}else return}),Yt?JSON.stringify(Tt):Ke}function Be(Ke){const gt=new b.$wO(Ke.value,Ke.supportThemeIcons);return gt.isTrusted=Ke.isTrusted,gt.supportHtml=Ke.supportHtml,gt.baseUri=Ke.baseUri?a.URI.from(Ke.baseUri):void 0,gt}me.to=Be;function tt(Ke){if(Ke)return typeof Ke=="string"?Ke:me.from(Ke)}me.fromStrict=tt})(ce||(e.MarkdownString=ce={}));function te(me){return se(me)?me.map(De=>({range:A.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ce.fromMany(De.hoverMessage):De.hoverMessage?ce.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):me.map(De=>({range:A.from(De)}))}function we(me){return typeof me>"u"?me:typeof me=="string"?a.URI.file(me):me}var Ce;(function(me){function De(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?we(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}me.from=De})(Ce||(e.ThemableDecorationAttachmentRenderOptions=Ce={}));var Y;(function(me){function De(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?we(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ce.from(ae.before):void 0,after:ae.after?Ce.from(ae.after):void 0}}me.from=De})(Y||(e.ThemableDecorationRenderOptions=Y={}));var W;(function(me){function De(ae){if(typeof ae>"u")return ae;switch(ae){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}me.from=De})(W||(e.DecorationRangeBehavior=W={}));var ee;(function(me){function De(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?W.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?Y.from(ae.light):void 0,dark:ae.dark?Y.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?we(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ce.from(ae.before):void 0,after:ae.after?Ce.from(ae.after):void 0}}me.from=De})(ee||(e.DecorationRenderOptions=ee={}));var be;(function(me){function De(K){return{text:K.newText,eol:K.newEol&&ve.from(K.newEol),range:A.from(K.range)}}me.from=De;function ae(K){const Ie=new b.$bO(A.to(K.range),K.text);return Ie.newEol=typeof K.eol>"u"?void 0:ve.to(K.eol),Ie}me.to=ae})(be||(e.TextEdit=be={}));var Pe;(function(me){function De(K,Ie){const Be={edits:[]};if(K instanceof b.$eO){const tt=new O.$Ec;for(const Ke of K._allEntries())Ke._type===b.FileEditType.File&&a.URI.isUri(Ke.to)&&Ke.from===void 0&&tt.add(Ke.to);for(const Ke of K._allEntries())if(Ke._type===b.FileEditType.File){let gt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?gt={type:"base64",value:(0,D.$$e)(D.$Qe.wrap(Ke.options.contents))}:gt={type:"dataTransferItem",id:Ke.options.contents._itemId}),Be.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:gt},metadata:Ke.metadata})}else Ke._type===b.FileEditType.Text?Be.edits.push({resource:Ke.uri,textEdit:be.from(Ke.edit),versionId:tt.has(Ke.uri)?void 0:Ie?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===b.FileEditType.Snippet?Be.edits.push({resource:Ke.uri,textEdit:{range:A.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:tt.has(Ke.uri)?void 0:Ie?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===b.FileEditType.Cell?Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===b.FileEditType.CellReplace&&Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:w.CellEditType.Replace,index:Ke.index,count:Ke.count,cells:Ke.cells.map(_e.from)}})}return Be}me.from=De;function ae(K){const Ie=new b.$eO,Be=new O.$Dc;for(const tt of K.edits)if(tt.textEdit){const Ke=tt,gt=a.URI.revive(Ke.resource),Tt=A.to(Ke.textEdit.range),Yt=Ke.textEdit.text,Vt=Ke.textEdit.insertAsSnippet;let qt;Vt?qt=b.$dO.replace(Tt,new b.$fO(Yt)):qt=b.$bO.replace(Tt,Yt);const Ni=Be.get(gt);Ni?Ni.push(qt):Be.set(gt,[qt])}else Ie.renameFile(a.URI.revive(tt.oldResource),a.URI.revive(tt.newResource),tt.options);for(const[tt,Ke]of Be)Ie.set(tt,Ke);return Ie}me.to=ae})(Pe||(e.WorkspaceEdit=Pe={}));var je;(function(me){const De=Object.create(null);De[b.SymbolKind.File]=n.SymbolKind.File,De[b.SymbolKind.Module]=n.SymbolKind.Module,De[b.SymbolKind.Namespace]=n.SymbolKind.Namespace,De[b.SymbolKind.Package]=n.SymbolKind.Package,De[b.SymbolKind.Class]=n.SymbolKind.Class,De[b.SymbolKind.Method]=n.SymbolKind.Method,De[b.SymbolKind.Property]=n.SymbolKind.Property,De[b.SymbolKind.Field]=n.SymbolKind.Field,De[b.SymbolKind.Constructor]=n.SymbolKind.Constructor,De[b.SymbolKind.Enum]=n.SymbolKind.Enum,De[b.SymbolKind.Interface]=n.SymbolKind.Interface,De[b.SymbolKind.Function]=n.SymbolKind.Function,De[b.SymbolKind.Variable]=n.SymbolKind.Variable,De[b.SymbolKind.Constant]=n.SymbolKind.Constant,De[b.SymbolKind.String]=n.SymbolKind.String,De[b.SymbolKind.Number]=n.SymbolKind.Number,De[b.SymbolKind.Boolean]=n.SymbolKind.Boolean,De[b.SymbolKind.Array]=n.SymbolKind.Array,De[b.SymbolKind.Object]=n.SymbolKind.Object,De[b.SymbolKind.Key]=n.SymbolKind.Key,De[b.SymbolKind.Null]=n.SymbolKind.Null,De[b.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,De[b.SymbolKind.Struct]=n.SymbolKind.Struct,De[b.SymbolKind.Event]=n.SymbolKind.Event,De[b.SymbolKind.Operator]=n.SymbolKind.Operator,De[b.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function ae(Ie){return typeof De[Ie]=="number"?De[Ie]:n.SymbolKind.Property}me.from=ae;function K(Ie){for(const Be in De)if(De[Be]===Ie)return Number(Be);return b.SymbolKind.Property}me.to=K})(je||(e.SymbolKind=je={}));var Te;(function(me){function De(K){switch(K){case b.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}me.from=De;function ae(K){switch(K){case n.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}me.to=ae})(Te||(e.SymbolTag=Te={}));var Ee;(function(me){function De(K){return{name:K.name,kind:je.from(K.kind),tags:K.tags&&K.tags.map(Te.from),containerName:K.containerName,location:it.from(K.location)}}me.from=De;function ae(K){const Ie=new b.$nO(K.name,je.to(K.kind),K.containerName,it.to(K.location));return Ie.tags=K.tags&&K.tags.map(Te.to),Ie}me.to=ae})(Ee||(e.WorkspaceSymbol=Ee={}));var Fe;(function(me){function De(K){const Ie={name:K.name||"!!MISSING: name!!",detail:K.detail,range:A.from(K.range),selectionRange:A.from(K.selectionRange),kind:je.from(K.kind),tags:K.tags?.map(Te.from)??[]};return K.children&&(Ie.children=K.children.map(De)),Ie}me.from=De;function ae(K){const Ie=new b.$oO(K.name,K.detail,je.to(K.kind),A.to(K.range),A.to(K.selectionRange));return(0,y.$Nb)(K.tags)&&(Ie.tags=K.tags.map(Te.to)),K.children&&(Ie.children=K.children.map(ae)),Ie}me.to=ae})(Fe||(e.DocumentSymbol=Fe={}));var Ve;(function(me){function De(K){const Ie=new b.$sO(je.to(K.kind),K.name,K.detail||"",a.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return Ie._sessionId=K._sessionId,Ie._itemId=K._itemId,Ie}me.to=De;function ae(K,Ie,Be){if(Ie=Ie??K._sessionId,Be=Be??K._itemId,Ie===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Be,name:K.name,detail:K.detail,kind:je.from(K.kind),uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Te.from)}}me.from=ae})(Ve||(e.CallHierarchyItem=Ve={}));var Ge;(function(me){function De(ae){return new b.$tO(Ve.to(ae.from),ae.fromRanges.map(K=>A.to(K)))}me.to=De})(Ge||(e.CallHierarchyIncomingCall=Ge={}));var et;(function(me){function De(ae){return new b.$uO(Ve.to(ae.to),ae.fromRanges.map(K=>A.to(K)))}me.to=De})(et||(e.CallHierarchyOutgoingCall=et={}));var it;(function(me){function De(K){return{range:K.range&&A.from(K.range),uri:K.uri}}me.from=De;function ae(K){return new b.$gO(a.URI.revive(K.uri),A.to(K.range))}me.to=ae})(it||(e.location=it={}));var Me;(function(me){function De(K){const Ie=K,Be=K;return{originSelectionRange:Ie.originSelectionRange?A.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Be.uri,range:A.from(Ie.targetRange?Ie.targetRange:Be.range),targetSelectionRange:Ie.targetSelectionRange?A.from(Ie.targetSelectionRange):void 0}}me.from=De;function ae(K){return{targetUri:a.URI.revive(K.uri),targetRange:A.to(K.range),targetSelectionRange:K.targetSelectionRange?A.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?A.to(K.originSelectionRange):void 0}}me.to=ae})(Me||(e.DefinitionLink=Me={}));var Ue;(function(me){function De(K){return{range:A.from(K.range),contents:ce.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}me.from=De;function ae(K){const Ie=K.contents.map(ce.to),Be=A.to(K.range),tt=K.canIncreaseVerbosity,Ke=K.canDecreaseVerbosity;return new b.$kO(Ie,Be,tt,Ke)}me.to=ae})(Ue||(e.Hover=Ue={}));var ze;(function(me){function De(K){return{range:A.from(K.range),expression:K.expression}}me.from=De;function ae(K){return new b.$fP(A.to(K.range),K.expression)}me.to=ae})(ze||(e.EvaluatableExpression=ze={}));var B;(function(me){function De(K){if(K instanceof b.$gP)return{type:"text",range:A.from(K.range),text:K.text};if(K instanceof b.$hP)return{type:"variable",range:A.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof b.$iP)return{type:"expression",range:A.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}me.from=De;function ae(K){switch(K.type){case"text":return{range:A.to(K.range),text:K.text};case"variable":return{range:A.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:A.to(K.range),expression:K.expression}}}me.to=ae})(B||(e.InlineValue=B={}));var j;(function(me){function De(K){return{frameId:K.frameId,stoppedLocation:A.from(K.stoppedLocation)}}me.from=De;function ae(K){return new b.$jP(K.frameId,A.to(K.stoppedLocation))}me.to=ae})(j||(e.InlineValueContext=j={}));var H;(function(me){function De(K){return{range:A.from(K.range),kind:K.kind}}me.from=De;function ae(K){return new b.$lO(A.to(K.range),K.kind)}me.to=ae})(H||(e.DocumentHighlight=H={}));var J;(function(me){function De(K){return{uri:K.uri,highlights:K.highlights.map(H.from)}}me.from=De;function ae(K){return new b.$mO(a.URI.revive(K.uri),K.highlights.map(H.to))}me.to=ae})(J||(e.MultiDocumentHighlight=J={}));var re;(function(me){function De(ae){switch(ae){case n.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}me.to=De})(re||(e.CompletionTriggerKind=re={}));var ge;(function(me){function De(ae){return{triggerKind:re.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}me.to=De})(ge||(e.CompletionContext=ge={}));var ke;(function(me){function De(K){switch(K){case b.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}me.from=De;function ae(K){switch(K){case n.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}me.to=ae})(ke||(e.CompletionItemTag=ke={}));var qe;(function(me){const De=new Map([[b.CompletionItemKind.Method,n.CompletionItemKind.Method],[b.CompletionItemKind.Function,n.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,n.CompletionItemKind.Field],[b.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[b.CompletionItemKind.Class,n.CompletionItemKind.Class],[b.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[b.CompletionItemKind.Module,n.CompletionItemKind.Module],[b.CompletionItemKind.Property,n.CompletionItemKind.Property],[b.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[b.CompletionItemKind.Value,n.CompletionItemKind.Value],[b.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,n.CompletionItemKind.Text],[b.CompletionItemKind.Color,n.CompletionItemKind.Color],[b.CompletionItemKind.File,n.CompletionItemKind.File],[b.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[b.CompletionItemKind.Event,n.CompletionItemKind.Event],[b.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[b.CompletionItemKind.User,n.CompletionItemKind.User]]);function ae(Be){return De.get(Be)??n.CompletionItemKind.Property}me.from=ae;const K=new Map([[n.CompletionItemKind.Method,b.CompletionItemKind.Method],[n.CompletionItemKind.Function,b.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,b.CompletionItemKind.Field],[n.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[n.CompletionItemKind.Class,b.CompletionItemKind.Class],[n.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[n.CompletionItemKind.Module,b.CompletionItemKind.Module],[n.CompletionItemKind.Property,b.CompletionItemKind.Property],[n.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[n.CompletionItemKind.Value,b.CompletionItemKind.Value],[n.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,b.CompletionItemKind.Text],[n.CompletionItemKind.Color,b.CompletionItemKind.Color],[n.CompletionItemKind.File,b.CompletionItemKind.File],[n.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[n.CompletionItemKind.Event,b.CompletionItemKind.Event],[n.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,b.CompletionItemKind.User],[n.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ie(Be){return K.get(Be)??b.CompletionItemKind.Property}me.to=Ie})(qe||(e.CompletionItemKind=qe={}));var xe;(function(me){function De(ae,K){const Ie=new b.$CO(ae.label);return Ie.insertText=ae.insertText,Ie.kind=qe.to(ae.kind),Ie.tags=ae.tags?.map(ke.to),Ie.detail=ae.detail,Ie.documentation=T.$9k(ae.documentation)?ce.to(ae.documentation):ae.documentation,Ie.sortText=ae.sortText,Ie.filterText=ae.filterText,Ie.preselect=ae.preselect,Ie.commitCharacters=ae.commitCharacters,u.$Tt.isIRange(ae.range)?Ie.range=A.to(ae.range):typeof ae.range=="object"&&(Ie.range={inserting:A.to(ae.range.insert),replacing:A.to(ae.range.replace)}),Ie.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof ae.insertTextRules<"u"&&ae.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?Ie.insertText=new b.$fO(ae.insertText):(Ie.insertText=ae.insertText,Ie.textEdit=Ie.range instanceof b.$7N?new b.$bO(Ie.range,Ie.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ae.additionalTextEdits.map(Be=>be.to(Be))),Ie.command=K&&ae.command?K.fromInternal(ae.command):void 0,Ie}me.to=De})(xe||(e.CompletionItem=xe={}));var rt;(function(me){function De(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ce.fromStrict(K.documentation)}}me.from=De;function ae(K){return{label:K.label,documentation:T.$9k(K.documentation)?ce.to(K.documentation):K.documentation}}me.to=ae})(rt||(e.ParameterInformation=rt={}));var st;(function(me){function De(K){return{label:K.label,documentation:ce.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(rt.from):[],activeParameter:K.activeParameter}}me.from=De;function ae(K){return{label:K.label,documentation:T.$9k(K.documentation)?ce.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(rt.to):[],activeParameter:K.activeParameter}}me.to=ae})(st||(e.SignatureInformation=st={}));var ut;(function(me){function De(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(st.from):[]}}me.from=De;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(st.to):[]}}me.to=ae})(ut||(e.SignatureHelp=ut={}));var ot;(function(me){function De(ae,K){const Ie=new b.$BO(G.to(K.position),typeof K.label=="string"?K.label:K.label.map(lt.to.bind(void 0,ae)),K.kind&&vt.to(K.kind));return Ie.textEdits=K.textEdits&&K.textEdits.map(be.to),Ie.tooltip=T.$9k(K.tooltip)?ce.to(K.tooltip):K.tooltip,Ie.paddingLeft=K.paddingLeft,Ie.paddingRight=K.paddingRight,Ie}me.to=De})(ot||(e.InlayHint=ot={}));var lt;(function(me){function De(ae,K){const Ie=new b.$AO(K.label);return Ie.tooltip=T.$9k(K.tooltip)?ce.to(K.tooltip):K.tooltip,n.Command.is(K.command)&&(Ie.command=ae.fromInternal(K.command)),K.location&&(Ie.location=it.to(K.location)),Ie}me.to=De})(lt||(e.InlayHintLabelPart=lt={}));var vt;(function(me){function De(K){return K}me.from=De;function ae(K){return K}me.to=ae})(vt||(e.InlayHintKind=vt={}));var nt;(function(me){function De(K){return{range:A.from(K.range),url:K.target,tooltip:K.tooltip}}me.from=De;function ae(K){let Ie;if(K.url)try{Ie=typeof K.url=="string"?a.URI.parse(K.url,!0):a.URI.revive(K.url)}catch{}const Be=new b.$HO(A.to(K.range),Ie);return Be.tooltip=K.tooltip,Be}me.to=ae})(nt||(e.DocumentLink=nt={}));var he;(function(me){function De(K){const Ie=new b.$KO(K.label);return K.textEdit&&(Ie.textEdit=be.to(K.textEdit)),K.additionalTextEdits&&(Ie.additionalTextEdits=K.additionalTextEdits.map(Be=>be.to(Be))),Ie}me.to=De;function ae(K){return{label:K.label,textEdit:K.textEdit?be.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ie=>be.from(Ie)):void 0}}me.from=ae})(he||(e.ColorPresentation=he={}));var pe;(function(me){function De(K){return new b.$IO(K[0],K[1],K[2],K[3])}me.to=De;function ae(K){return[K.red,K.green,K.blue,K.alpha]}me.from=ae})(pe||(e.Color=pe={}));var ye;(function(me){function De(K){return{range:A.from(K.range)}}me.from=De;function ae(K){return new b.$rO(A.to(K.range))}me.to=ae})(ye||(e.SelectionRange=ye={}));var Re;(function(me){function De(ae){switch(ae){case g.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case g.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case g.SaveReason.FOCUS_CHANGE:case g.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}me.to=De})(Re||(e.TextDocumentSaveReason=Re={}));var fe;(function(me){function De(K){switch(K){case b.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}me.from=De;function ae(K){switch(K){case c.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}me.to=ae})(fe||(e.TextEditorLineNumbersStyle=fe={}));var ve;(function(me){function De(K){if(K===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(K===b.EndOfLine.LF)return t.EndOfLineSequence.LF}me.from=De;function ae(K){if(K===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(K===t.EndOfLineSequence.LF)return b.EndOfLine.LF}me.to=ae})(ve||(e.EndOfLine=ve={}));var X;(function(me){function De(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case b.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case b.ProgressLocation.Window:return l.ProgressLocation.Window;case b.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}me.from=De})(X||(e.ProgressLocation=X={}));var q;(function(me){function De(K){const Ie={start:K.start+1,end:K.end+1};return K.kind&&(Ie.kind=de.from(K.kind)),Ie}me.from=De;function ae(K){const Ie={start:K.start-1,end:K.end-1};return K.kind&&(Ie.kind=de.to(K.kind)),Ie}me.to=ae})(q||(e.FoldingRange=q={}));var de;(function(me){function De(K){if(K)switch(K){case b.FoldingRangeKind.Comment:return n.$Uu.Comment;case b.FoldingRangeKind.Imports:return n.$Uu.Imports;case b.FoldingRangeKind.Region:return n.$Uu.Region}}me.from=De;function ae(K){if(K)switch(K.value){case n.$Uu.Comment.value:return b.FoldingRangeKind.Comment;case n.$Uu.Imports.value:return b.FoldingRangeKind.Imports;case n.$Uu.Region.value:return b.FoldingRangeKind.Region}}me.to=ae})(de||(e.FoldingRangeKind=de={}));var We;(function(me){function De(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?A.from(ae.selection):void 0,override:typeof ae.override=="boolean"?g.$fG.id:void 0}}me.from=De})(We||(e.TextEditorOpenOptions=We={}));var Je;(function(me){function De(Be){return Be instanceof b.$6O?Be.toJSON():typeof Be=="string"?Be:ae(Be)||K(Be)?new b.$6O(Be.baseUri??Be.base,Be.pattern).toJSON():Be}me.from=De;function ae(Be){const tt=Be;return tt?a.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function K(Be){const tt=Be;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Ie(Be){return typeof Be=="string"?Be:new b.$6O(a.URI.revive(Be.baseUri),Be.pattern)}me.to=Ie})(Je||(e.GlobPattern=Je={}));var ct;(function(me){function De(ae){if(ae){if(Array.isArray(ae))return ae.map(De);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:Je.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}me.from=De})(ct||(e.LanguageSelector=ct={}));var dt;(function(me){function De(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Ie=>Array.isArray(Ie)&&Ie.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&a.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(tt=>tt instanceof b.$7N)))}me.is=De;function ae(K){return{documents:K.documents.map(Ie=>Ie.map(Be=>({uri:a.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(tt=>A.from(tt))})))}}me.from=ae})(dt||(e.MappedEditsContext=dt={}));var mt;(function(me){function De(K){return{start:K.start,end:K.end}}me.from=De;function ae(K){return new b.$wP(K.start,K.end)}me.to=ae})(mt||(e.NotebookRange=mt={}));var Rt;(function(me){function De(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}me.to=De;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}me.from=ae})(Rt||(e.NotebookCellExecutionSummary=Rt={}));var At;(function(me){function De(ae){if(ae===w.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(ae===w.NotebookCellExecutionState.Pending)return;if(ae===w.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}me.to=De})(At||(e.NotebookCellExecutionState=At={}));var Qt;(function(me){function De(K){switch(K){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}me.from=De;function ae(K){switch(K){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}me.to=ae})(Qt||(e.NotebookCellKind=Qt={}));var _t;(function(me){function De(K){const Ie={metadata:K.metadata??Object.create(null),cells:[]};for(const Be of K.cells)b.$xP.validate(Be),Ie.cells.push(_e.from(Be));return Ie}me.from=De;function ae(K){const Ie=new b.$yP(K.cells.map(_e.to));return(0,r.$ug)(K.metadata)||(Ie.metadata=K.metadata),Ie}me.to=ae})(_t||(e.NotebookData=_t={}));var _e;(function(me){function De(K){return{cellKind:Qt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Rt.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ut.from):[]}}me.from=De;function ae(K){return new b.$xP(Qt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ut.to):void 0,K.metadata,K.internalMetadata?Rt.to(K.internalMetadata):void 0)}me.to=ae})(_e||(e.NotebookCellData=_e={}));var Ot;(function(me){function De(K){return{mime:K.mime,valueBytes:D.$Qe.wrap(K.data)}}me.from=De;function ae(K){return new b.$zP(K.valueBytes.buffer,K.mime)}me.to=ae})(Ot||(e.NotebookCellOutputItem=Ot={}));var Ut;(function(me){function De(K){return{outputId:K.id,items:K.items.map(Ot.from),metadata:K.metadata}}me.from=De;function ae(K){const Ie=K.items.map(Ot.to);return new b.$AP(Ie,K.outputId,K.metadata)}me.to=ae})(Ut||(e.NotebookCellOutput=Ut={}));var $t;(function(me){function De(Ie){return K(Ie)?{include:Je.from(Ie.include)??void 0,exclude:Je.from(Ie.exclude)??void 0}:Je.from(Ie)??void 0}me.from=De;function ae(Ie){return K(Ie)?{include:Je.to(Ie.include),exclude:Je.to(Ie.exclude)}:Je.to(Ie)}me.to=ae;function K(Ie){const Be=Ie;return Be?!(0,r.$qg)(Be.include)&&!(0,r.$qg)(Be.exclude):!1}})($t||(e.NotebookExclusiveDocumentPattern=$t={}));var Pt;(function(me){function De(ae,K,Ie){const Be=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===b.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:K.toInternal(Be,Ie),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}me.from=De})(Pt||(e.NotebookStatusBarItem=Pt={}));var ei;(function(me){function De(ae,K,Ie){const Be=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:K.toInternal(Be,Ie),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}me.from=De})(ei||(e.NotebookKernelSourceAction=ei={}));var ti;(function(me){function De(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}me.from=De})(ti||(e.NotebookDocumentContentOptions=ti={}));var Ht;(function(me){function De(K){return{uri:K.uri,provides:K.provides}}me.from=De;function ae(K){return new b.$CP(a.URI.revive(K.uri),K.provides)}me.to=ae})(Ht||(e.NotebookRendererScript=Ht={}));var wt;(function(me){function De(K){return{message:ce.fromStrict(K.message)||"",type:R.TestMessageType.Error,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:A.from(K.location.range),uri:K.location.uri},stackTrace:K.stackTrace?.map(Ie=>({label:Ie.label,position:Ie.position&&G.from(Ie.position),uri:Ie.uri&&a.URI.revive(Ie.uri).toJSON()}))}}me.from=De;function ae(K){const Ie=new b.$IP(typeof K.message=="string"?K.message:ce.to(K.message));return Ie.actualOutput=K.actual,Ie.expectedOutput=K.expected,Ie.contextValue=K.contextValue,Ie.location=K.location?it.to(K.location):void 0,Ie}me.to=ae})(wt||(e.TestMessage=wt={}));var Nt;(function(me){me.namespace=R.$qJ,me.denamespace=R.$rJ})(Nt||(e.TestTag=Nt={}));var ai;(function(me){function De(K){const Ie=(0,m.$zQ)(K).controllerId;return{extId:P.$lJ.fromExtHostTestItem(K,Ie).toString(),label:K.label,uri:a.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Be=>Nt.namespace(Ie,Be.id)),range:u.$Tt.lift(A.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ce.fromStrict(K.error)||null}}me.from=De;function ae(K){return{parent:void 0,error:void 0,id:P.$lJ.fromString(K.extId).localId,label:K.label,uri:a.URI.revive(K.uri),tags:(K.tags||[]).map(Ie=>{const{tagId:Be}=Nt.denamespace(Ie);return new b.$JP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:A.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}me.toPlain=ae})(ai||(e.TestItem=ai={})),function(me){function De(K){return{id:K.id}}me.from=De;function ae(K){return new b.$JP(K.id)}me.to=ae}(Nt||(e.TestTag=Nt={}));var Zt;(function(me){const De=(K,Ie)=>{const Be=K.value;if(!Be)return;const tt={...ai.toPlain(Be.item),parent:Ie,taskStates:Be.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(gt=>gt.type===R.TestMessageType.Error).map(wt.to)})),children:[]};if(K.children)for(const Ke of K.children.values()){const gt=De(Ke,tt);gt&&tt.children.push(gt)}return tt};function ae(K){const Ie=new h.$kJ;for(const Ke of K.items)Ie.insert(P.$lJ.fromString(Ke.item.extId).path,Ke);const Be=[Ie.nodes],tt=[];for(;Be.length;)for(const Ke of Be.pop())Ke.value?tt.push(Ke):Ke.children&&Be.push(Ke.children.values());return{completedAt:K.completedAt,results:tt.map(Ke=>De(Ke)).filter(r.$pg)}}me.to=ae})(Zt||(e.TestResults=Zt={}));var Ye;(function(me){function De(Be){return{covered:Be.covered,total:Be.total}}function ae(Be){return"line"in Be?G.from(Be):A.from(Be)}function K(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:ae(Be.location),type:R.DetailType.Statement,branches:Be.branches.length?Be.branches.map(tt=>({count:tt.executed,location:tt.location&&ae(tt.location),label:tt.label})):void 0}:{type:R.DetailType.Declaration,name:Be.name,count:Be.executed,location:ae(Be.location)}}me.fromDetails=K;function Ie(Be,tt,Ke){return b.$MP(Ke.statementCoverage),b.$MP(Ke.branchCoverage),b.$MP(Ke.declarationCoverage),{id:tt,uri:Ke.uri,statement:De(Ke.statementCoverage),branch:Ke.branchCoverage&&De(Ke.branchCoverage),declaration:Ke.declarationCoverage&&De(Ke.declarationCoverage),testIds:Ke instanceof b.$NP&&Ke.fromTests.length?Ke.fromTests.map(gt=>P.$lJ.fromExtHostTestItem(gt,Be).toString()):void 0}}me.fromFile=Ie})(Ye||(e.TestCoverage=Ye={}));var ii;(function(me){function De(ae){switch(ae){case n.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}me.to=De})(ii||(e.CodeActionTriggerKind=ii={}));var ci;(function(me){function De(K){const Ie=new b.$RP(je.to(K.kind),K.name,K.detail||"",a.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return Ie._sessionId=K._sessionId,Ie._itemId=K._itemId,Ie}me.to=De;function ae(K,Ie,Be){if(Ie=Ie??K._sessionId,Be=Be??K._itemId,Ie===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Be,kind:je.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Te.from)}}me.from=ae})(ci||(e.TypeHierarchyItem=ci={}));var ui;(function(me){function De(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}me.from=De})(ui||(e.ViewBadge=ui={}));var Et;(function(me){function De(Be,tt,Ke){const gt=tt.fileData;return gt?new b.$XO(new b.$YO(gt.name,a.URI.revive(gt.uri),gt.id,(0,N.$fb)(()=>Ke(gt.id)))):Be===I.$dt.uriList&&tt.uriListData?new b.$WO(Ie(tt.uriListData)):new b.$WO(tt.asString)}me.to=De;async function ae(Be,tt){const Ke=await tt.asString();if(Be===I.$dt.uriList)return{asString:Ke,fileData:void 0,uriListData:K(Ke)};const gt=tt.asFile();return{asString:Ke,fileData:gt?{name:gt.name,uri:gt.uri,id:gt._itemId??gt.id}:void 0}}me.from=ae;function K(Be){return C.$yu.split(Be).map(tt=>{if(tt.startsWith("#"))return tt;try{return a.URI.parse(tt)}catch{}return tt})}function Ie(Be){return C.$yu.create(Be.map(tt=>typeof tt=="string"?tt:a.URI.revive(tt)))}})(Et||(e.DataTransferItem=Et={}));var jt;(function(me){function De(K,Ie){const Be=K.items.map(([tt,Ke])=>[tt,Et.to(tt,Ke,Ie)]);return new b.$ZO(Be)}me.toDataTransfer=De;async function ae(K){const Ie={items:[]},Be=[];for(const[tt,Ke]of K)Be.push((async()=>{Ie.items.push([tt,await Et.from(tt,Ke)])})());return await Promise.all(Be),Ie}me.from=ae})(jt||(e.DataTransfer=jt={}));var Lt;(function(me){function De(K,Ie){return{kind:"reply",agentId:K.participant??Ie?.agentId??"",subCommand:K.command??Ie?.command,message:K.prompt,title:K.label}}me.from=De;function ae(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}me.to=ae})(Lt||(e.ChatFollowup=Lt={}));var Bt;(function(me){function De(K){switch(K){case S.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}me.to=De;function ae(K){switch(K){case b.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}me.from=ae})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var oi;(function(me){function De(K){let Ie="",Be;K.content.type==="text"?Ie=K.content.value:Be=new b.$kQ(K.content.name,K.content.value,K.content.isError);const tt=Bt.to(K.role),Ke=new b.$lQ(tt,Ie,K.name);return Be!==void 0&&(Ke.content2=Be),Ke}me.to=De;function ae(K){const Ie=Bt.from(K.role),Be=K.name;let tt;return K.content2 instanceof b.$kQ?tt={type:"function_result",name:K.content2.name,value:K.content2.content,isError:K.content2.isError}:tt={type:"text",value:K.content},{role:Ie,name:Be,content:tt}}me.from=ae})(oi||(e.LanguageModelChatMessage=oi={}));var ni;(function(me){function De(K){return{kind:"markdownContent",content:ce.from(K.value)}}me.from=De;function ae(K){return new b.$5P(ce.to(K.content))}me.to=ae})(ni||(e.ChatResponseMarkdownPart=ni={}));var ri;(function(me){function De(K){return{kind:"markdownVuln",content:ce.from(K.value),vulnerabilities:K.vulnerabilities}}me.from=De;function ae(K){return new b.$6P(ce.to(K.content),K.vulnerabilities)}me.to=ae})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Kt;(function(me){function De(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}me.from=De;function ae(K){return new b.$7P(K.agentId,K.command)}me.to=ae})(Kt||(e.ChatResponseDetectedParticipantPart=Kt={}));var Gt;(function(me){function De(ae){return{kind:"confirmation",title:ae.title,message:ae.message,data:ae.data,buttons:ae.buttons}}me.from=De})(Gt||(e.ChatResponseConfirmationPart=Gt={}));var li;(function(me){function De(K){const{value:Ie,baseUri:Be}=K;function tt(Ke,gt){return Ke.map(Tt=>{const Yt=a.URI.joinPath(gt,Tt.name);return{label:Tt.name,uri:Yt,children:Tt.children&&tt(Tt.children,Yt)}})}return{kind:"treeData",treeData:{label:(0,E.$gh)(Be),uri:Be,children:tt(Ie,Be)}}}me.from=De;function ae(K){const Ie=(0,s.$fi)(K.treeData);function Be(gt){return gt.map(Tt=>({name:Tt.label,children:Tt.children&&Be(Tt.children)}))}const tt=Ie.uri,Ke=Ie.children?Be(Ie.children):[];return new b.$9P(Ke,tt)}me.to=ae})(li||(e.ChatResponseFilesPart=li={}));var Mt;(function(me){function De(K){const Ie=Be=>a.URI.isUri(Be);return{kind:"inlineReference",name:K.title,inlineReference:Ie(K.value)?K.value:M.from(K.value)}}me.from=De;function ae(K){const Ie=(0,s.$fi)(K);return new b.$0P(a.URI.isUri(Ie.inlineReference)?Ie.inlineReference:M.to(Ie.inlineReference),K.name)}me.to=ae})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Dt;(function(me){function De(K){return{kind:"progressMessage",content:ce.from(K.value)}}me.from=De;function ae(K){return new b.$$P(K.content.value)}me.to=ae})(Dt||(e.ChatResponseProgressPart=Dt={}));var bt;(function(me){function De(K){return{kind:"warning",content:ce.from(K.value)}}me.from=De;function ae(K){return new b.$aQ(K.content.value)}me.to=ae})(bt||(e.ChatResponseWarningPart=bt={}));var Jt;(function(me){function De(K){return{kind:"move",uri:K.uri,range:A.from(K.range)}}me.from=De;function ae(K){return new b.$eQ(a.URI.revive(K.uri),A.to(K.range))}me.to=ae})(Jt||(e.ChatResponseMovePart=Jt={}));var St;(function(me){function De(ae){return{kind:"progressTask",content:ce.from(ae.value)}}me.from=De})(St||(e.ChatTask=St={}));var hi;(function(me){function De(ae){return{kind:"progressTaskResult",content:typeof ae=="string"?ce.from(ae):void 0}}me.from=De})(hi||(e.ChatTaskResult=hi={}));var Xt;(function(me){function De(K,Ie,Be){return{kind:"command",command:Ie.toInternal(K.value,Be)??{command:K.value.command,title:K.value.title}}}me.from=De;function ae(K,Ie){return new b.$bQ(Ie.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}me.to=ae})(Xt||(e.ChatResponseCommandButtonPart=Xt={}));var Mi;(function(me){function De(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(Ie=>be.from(Ie))}}me.from=De;function ae(K){return new b.$fQ(a.URI.revive(K.uri),K.edits.map(Ie=>be.to(Ie)))}me.to=ae})(Mi||(e.ChatResponseTextEditPart=Mi={}));var di;(function(me){function De(K){const Ie=f.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:a.URI.isUri(K.iconPath)?{light:a.URI.revive(K.iconPath)}:K.iconPath&&"light"in K.iconPath&&"dark"in K.iconPath&&a.URI.isUri(K.iconPath.light)&&a.URI.isUri(K.iconPath.dark)?{light:a.URI.revive(K.iconPath.light),dark:a.URI.revive(K.iconPath.dark)}:void 0;return typeof K.value=="object"&&"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:a.URI.isUri(K.value.value)||!K.value.value?K.value.value:M.from(K.value.value)},iconPath:Ie,options:K.options}:{kind:"reference",reference:a.URI.isUri(K.value)||typeof K.value=="string"?K.value:M.from(K.value),iconPath:Ie,options:K.options}}me.from=De;function ae(K){const Ie=(0,s.$fi)(K),Be=tt=>a.URI.isUri(tt)?tt:M.to(tt);return new b.$cQ(typeof Ie.reference=="string"?Ie.reference:"variableName"in Ie.reference?{variableName:Ie.reference.variableName,value:Ie.reference.value&&Be(Ie.reference.value)}:Be(Ie.reference))}me.to=ae})(di||(e.ChatResponseReferencePart=di={}));var yi;(function(me){function De(ae){return{kind:"codeCitation",value:ae.value,license:ae.license,snippet:ae.snippet}}me.from=De})(yi||(e.ChatResponseCodeCitationPart=yi={}));var Wt;(function(me){function De(Ie,Be,tt){return Ie instanceof b.$5P?ni.from(Ie):Ie instanceof b.$0P?Mt.from(Ie):Ie instanceof b.$cQ?di.from(Ie):Ie instanceof b.$$P?Dt.from(Ie):Ie instanceof b.$9P?li.from(Ie):Ie instanceof b.$bQ?Xt.from(Ie,Be,tt):Ie instanceof b.$fQ?Mi.from(Ie):Ie instanceof b.$6P?ri.from(Ie):Ie instanceof b.$7P?Kt.from(Ie):Ie instanceof b.$aQ?bt.from(Ie):Ie instanceof b.$8P?Gt.from(Ie):Ie instanceof b.$dQ?yi.from(Ie):Ie instanceof b.$eQ?Jt.from(Ie):{kind:"markdownContent",content:ce.from("")}}me.from=De;function ae(Ie,Be){switch(Ie.kind){case"reference":return di.to(Ie);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(Ie,Be)}}me.to=ae;function K(Ie,Be){switch(Ie.kind){case"markdownContent":return ni.to(Ie);case"inlineReference":return Mt.to(Ie);case"progressMessage":return;case"treeData":return li.to(Ie);case"command":return Xt.to(Ie,Be)}}me.toContent=K})(Wt||(e.ChatResponsePart=Wt={}));var fi;(function(me){function De(ae,K){const Ie=ae.variables.variables.filter(tt=>tt.isTool),Be=ae.variables.variables.filter(tt=>!tt.isTool);return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,references:Be.map(Ct.to),toolReferences:Ie.map(Si.to),location:Fi.to(ae.location),acceptedConfirmationData:ae.acceptedConfirmationData,rejectedConfirmationData:ae.rejectedConfirmationData,location2:K}}me.to=De})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(me){function De(K){switch(K){case d.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case d.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case d.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case d.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}me.to=De;function ae(K){switch(K){case b.ChatLocation.Notebook:return d.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return d.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return d.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return d.ChatAgentLocation.Editor}}me.from=ae})(Fi||(e.ChatLocation=Fi={}));var Ct;(function(me){function De(ae){const K=ae.value;if(!K)throw new Error("Invalid value reference");return{id:ae.id,name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],value:(0,a.$yc)(K)?a.URI.revive(K):K&&typeof K=="object"&&"uri"in K&&"range"in K&&(0,a.$yc)(K.uri)?M.to((0,s.$fi)(K)):K,modelDescription:ae.modelDescription}}me.to=De})(Ct||(e.ChatPromptReference=Ct={}));var Si;(function(me){function De(ae){if(ae.value)throw new Error("Invalid tool reference");return{id:ae.id,range:ae.range&&[ae.range.start,ae.range.endExclusive]}}me.to=De})(Si||(e.ChatLanguageModelToolReference=Si={}));var Ai;(function(me){function De(ae,K,Ie){return{id:ae.id,label:ae.label,fullName:ae.fullName,icon:ae.icon?.id,value:ae.values[0].value,insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation,command:K.toInternal(ae.command,Ie)}}me.from=De})(Ai||(e.ChatAgentCompletionItem=Ai={}));var gi;(function(me){function De(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata,nextQuestion:ae.nextQuestion}}me.to=De})(gi||(e.ChatAgentResult=gi={}));var zi;(function(me){function De(ae,K,Ie){if(K.action.kind==="vote")return;const Be=gi.to(ae);if(K.action.kind==="command"){const tt=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ie.fromInternal(tt)??{command:tt.id,title:tt.title}}},result:Be}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:Lt.to(K.action.followup)},result:Be}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:Be}:{action:K.action,result:Be}}me.to=De})(zi||(e.ChatAgentUserActionEvent=zi={}));var ji;(function(me){function De(K){return{...K,string:K.toString()}}me.from=De;function ae(K){const Ie={...K,toString:()=>K.string};return delete Ie.string,Ie}me.to=ae})(ji||(e.LanguageModelToolResult=ji={}));var zt;(function(me){function De(ae,K,Ie){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:K.toInternal(ae,Ie)}me.from=De})(zt||(e.TerminalQuickFix=zt={}));var Pi;(function(me){function De(ae){return{kind:Di.to(ae.kind)}}me.to=De})(Pi||(e.PartialAcceptInfo=Pi={}));var Di;(function(me){function De(ae){switch(ae){case n.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}me.to=De})(Di||(e.PartialAcceptTriggerKind=Di={}));var wi;(function(me){function De(ae,K){return{id:K,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:ae.contextValue}}me.from=De})(wi||(e.DebugTreeItem=wi={}));var bi;(function(me){function De(ae){return{id:ae.id,modelDescription:ae.modelDescription,parametersSchema:ae.parametersSchema,displayName:ae.displayName}}me.to=De})(bi||(e.LanguageModelToolDescription=bi={}))}),define(Oe[232],Ae([1,0,5,16,8,39]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;let T=class{constructor(p,s){this.a=p.getProxy(y.$3N.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>s.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,s,I){const v=new N.$4w(C.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(v,void 0,I?.isRefactoring??!1)}};e.$Bqc=T,e.$Bqc=T=Xe([Qe(0,D.$DQ)],T)}),define(Oe[233],Ae([1,0,17,10,42,6,40,4,33,70,14,2,18,5,8,7,117,194,24]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0,f=He(f),r=He(r);class i{constructor(l,m,g,d,S){this.j=l,this.k=m,this.l=g,this.m=d,this.n=S,this.b=s.$ie.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let m=function(d){if(l.c){const S=new Error("Response stream has been closed");throw Error.captureStackTrace(S,d),S}};const l=this;this.b.reset();const g=(d,S)=>{if(typeof this.d>"u"&&(d.kind==="markdownContent"||d.kind==="markdownVuln")&&(this.d=this.b.elapsed()),S){const k=this.l.$handleProgressChunk(this.k.requestId,d),w={report:P=>{k?.then(R=>{R&&(r.$wO.isMarkdownString(P.value)?this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseWarningPart.from(P),R):this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseReferencePart.from(P),R))})}};Promise.all([k,S?.(w)]).then(([P,R])=>{P!==void 0&&this.l.$handleProgressChunk(this.k.requestId,f.ChatTaskResult.from(R),P)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){m(this.markdown);const S=new r.$5P(d),k=f.ChatResponseMarkdownPart.from(S);return g(k),this},markdownWithVulnerabilities(d,S){m(this.markdown),S&&(0,u.$vH)(l.j,"chatParticipantAdditions");const k=new r.$6P(d,S),w=f.ChatResponseMarkdownWithVulnerabilitiesPart.from(k);return g(w),this},filetree(d,S){m(this.filetree);const k=new r.$9P(d,S),w=f.ChatResponseFilesPart.from(k);return g(w),this},anchor(d,S){m(this.anchor);const k=new r.$0P(d,S),w=f.ChatResponseAnchorPart.from(k);return g(w),this},button(d){m(this.anchor);const S=new r.$bQ(d),k=f.ChatResponseCommandButtonPart.from(S,l.m,l.n);return g(k),this},progress(d,S){m(this.progress);const k=new r.$_P(d,S),w=S?f.ChatTask.from(k):f.ChatResponseProgressPart.from(k);return g(w,S),this},warning(d){m(this.progress),(0,u.$vH)(l.j,"chatParticipantAdditions");const S=new r.$aQ(d),k=f.ChatResponseWarningPart.from(S);return g(k),this},reference(d,S){return this.reference2(d,S)},reference2(d,S,k){if(m(this.reference),typeof d=="object"&&"variableName"in d&&(0,u.$vH)(l.j,"chatParticipantAdditions"),typeof d=="object"&&"variableName"in d&&!d.value){const w=l.k.variables.variables.find(P=>P.name===d.variableName);if(w){let P;if(w.references?.length)P=w.references.map(R=>({kind:"reference",reference:{variableName:d.variableName,value:R.reference}}));else{const R=new r.$cQ(d,S,k);P=[f.ChatResponseReferencePart.from(R)]}return P.forEach(R=>g(R)),this}}else{const w=new r.$cQ(d,S,k),P=f.ChatResponseReferencePart.from(w);g(P)}return this},codeCitation(d,S,k){m(this.codeCitation),(0,u.$vH)(l.j,"chatParticipantAdditions");const w=new r.$dQ(d,S,k),P=f.ChatResponseCodeCitationPart.from(w);g(P)},textEdit(d,S){m(this.textEdit),(0,u.$vH)(l.j,"chatParticipantAdditions");const k=new r.$fQ(d,S),w=f.ChatResponseTextEditPart.from(k);return g(w),this},detectedParticipant(d,S){m(this.detectedParticipant),(0,u.$vH)(l.j,"chatParticipantAdditions");const k=new r.$7P(d,S),w=f.ChatResponseDetectedParticipantPart.from(k);return g(w),this},confirmation(d,S,k,w){m(this.confirmation),(0,u.$vH)(l.j,"chatParticipantAdditions");const P=new r.$8P(d,S,k,w),R=f.ChatResponseConfirmationPart.from(P);return g(R),this},push(d){if(m(this.push),(d instanceof r.$fQ||d instanceof r.$6P||d instanceof r.$7P||d instanceof r.$aQ||d instanceof r.$8P||d instanceof r.$dQ||d instanceof r.$eQ)&&(0,u.$vH)(l.j,"chatParticipantAdditions"),d instanceof r.$cQ)this.reference2(d.value,d.iconPath,d.options);else{const S=f.ChatResponsePart.from(d,l.m,l.n);g(S)}return this}}}return this.g}}class n extends O.$Xc{static{this.b=0}static{this.j=0}constructor(l,m,g,d){super(),this.t=m,this.u=g,this.w=d,this.c=new Map,this.m=new Map,this.n=this.B(new O.$7c),this.s=this.B(new O.$7c),this.g=l.getProxy(E.$3N.MainThreadChatAgents2)}transferActiveChat(l){this.g.$transferActiveChatSession(l)}createChatAgent(l,m,g){const d=n.b++,S=new t(l,m,this.g,d,g);return this.c.set(d,S),this.g.$registerAgent(d,l.identifier,m,{},void 0),S.apiAgent}createDynamicChatAgent(l,m,g,d){const S=n.b++,k=new t(l,m,this.g,S,d);return this.c.set(S,k),this.g.$registerAgent(S,l.identifier,m,{isSticky:!0},g),k.apiAgent}registerChatParticipantDetectionProvider(l){const m=n.j++;return this.m.set(m,l),this.g.$registerChatParticipantDetectionProvider(m),(0,O.$Vc)(()=>{this.m.delete(m),this.g.$unregisterChatParticipantDetectionProvider(m)})}async $detectChatParticipant(l,m,g,d,S){const{request:k,location:w,history:P}=await this.y(m,g),R=this.m.get(l);if(R)return R.provideParticipantDetection(f.ChatAgentRequest.to(k,w),{history:P},{participants:d.participants,location:f.ChatLocation.to(d.location)},S)}async y(l,m){const g=(0,p.$fi)(l),d=await this.z(g.agentId,m);let S;if(g.locationData?.type===a.ChatAgentLocation.Editor){const k=this.w.getDocument(g.locationData.document);S=new r.$iQ(k,f.Selection.to(g.locationData.selection),f.Range.to(g.locationData.wholeRange))}else if(g.locationData?.type===a.ChatAgentLocation.Notebook){const k=this.w.getDocument(g.locationData.sessionInputUri);S=new r.$jQ(k)}else g.locationData?.type,a.ChatAgentLocation.Terminal;return{request:g,location:S,history:d}}async $invokeAgent(l,m,g,d){const S=this.c.get(l);if(!S)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);let k;try{const{request:w,location:P,history:R}=await this.y(m,g);let $=this.n.get(w.sessionId);$||($=new O.$Wc,this.n.set(w.sessionId,$)),k=new i(S.extension,w,this.g,this.u.converter,$);const b=S.invoke(f.ChatAgentRequest.to(w,P),{history:R},k.apiObject,d);return await(0,D.$wh)(Promise.resolve(b).then(L=>{if(L?.metadata)try{JSON.stringify(L.metadata)}catch(M){const Z=`result.metadata MUST be JSON.stringify-able. Got error: ${M.message}`;return this.t.error(`[${S.extension.identifier.value}] [@${S.id}] ${Z}`,S.extension),{errorDetails:{message:Z},timings:k?.timings,nextQuestion:L.nextQuestion}}let A;return L?.errorDetails&&(A={...L.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,u.$vH)(S.extension,"chatParticipantPrivate"),{errorDetails:A,timings:k?.timings,metadata:L?.metadata,nextQuestion:L?.nextQuestion}}),d)}catch(w){return this.t.error(w,S.extension),w instanceof r.$rQ&&w.cause&&(w=w.cause),{errorDetails:{message:(0,C.$tj)(w),responseIsIncomplete:!0}}}finally{k?.close()}}async z(l,m){const g=[];for(const d of m.history){const S=f.ChatAgentResult.to(d.result),k=l===d.request.agentId?S:{...S,metadata:void 0},w=d.request.variables.variables.filter(b=>!b.isTool).map(f.ChatPromptReference.to),P=d.request.variables.variables.filter(b=>b.isTool).map(f.ChatLanguageModelToolReference.to),R=new r.$gQ(d.request.message,d.request.command,w,d.request.agentId);R.toolReferences=P,g.push(R);const $=(0,y.$Jb)(d.response.map(b=>f.ChatResponsePart.toContent(b,this.u.converter)));g.push(new r.$hQ($,k,d.request.agentId,d.request.command))}return g}$releaseSession(l){this.n.deleteAndDispose(l)}async $provideFollowups(l,m,g,d,S){const k=this.c.get(m);if(!k)return Promise.resolve([]);const w=(0,p.$fi)(l),P=await this.z(k.id,d),R=f.ChatAgentResult.to(g);return(await k.provideFollowups(R,{history:P},S)).filter($=>{const b=!$.participant||T.Iterable.some(this.c.values(),L=>L.id===$.participant&&h.$un.equals(L.extension.identifier,k.extension.identifier));return b||this.t.warn(`[@${k.id}] ChatFollowup refers to an unknown participant: ${$.participant}`),b}).map($=>f.ChatFollowup.from($,w))}$acceptFeedback(l,m,g,d){const S=this.c.get(l);if(!S)return;const k=f.ChatAgentResult.to(m);let w;switch(g){case c.ChatAgentVoteDirection.Down:w=r.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:w=r.ChatResultFeedbackKind.Helpful;break}S.acceptFeedback(Object.freeze(d?{result:k,kind:w,reportIssue:d}:{result:k,kind:w}))}$acceptAction(l,m,g){const d=this.c.get(l);if(!d||g.action.kind==="vote")return;const S=f.ChatAgentUserActionEvent.to(m,g,this.u.converter);S&&d.acceptAction(Object.freeze(S))}async $invokeCompletionProvider(l,m,g){const d=this.c.get(l);if(!d)return[];let S=this.s.get(l);return S?S.clear():(S=new O.$Wc,this.s.set(l,S)),(await d.invokeCompletionProvider(m,g)).map(w=>f.ChatAgentCompletionItem.from(w,this.u.converter,S))}async $provideWelcomeMessage(l,m,g){const d=this.c.get(l);if(d)return await d.provideWelcomeMessage(f.ChatLocation.to(m),g)}async $provideChatTitle(l,m,g){const d=this.c.get(l);if(!d)return;const S=await this.z(d.id,{history:m});return await d.provideTitle({history:S},g)}async $provideSampleQuestions(l,m,g){const d=this.c.get(l);if(d)return(await d.provideSampleQuestions(f.ChatLocation.to(m),g)).map(S=>f.ChatFollowup.from(S,void 0))}}e.$Cqc=n;class t{constructor(l,m,g,d,S){this.extension=l,this.id=m,this.w=g,this.x=d,this.y=S,this.l=new N.$oe,this.m=new N.$oe}acceptFeedback(l){this.l.fire(l)}acceptAction(l){this.m.fire(l)}async invokeCompletionProvider(l,m){return this.o?await this.o.provider.provideCompletionItems(l,m)??[]:[]}async provideFollowups(l,m,g){if(!this.b)return[];const d=await this.b.provideFollowups(l,m,g);return d?d.filter(S=>!(S&&"commandId"in S)).filter(S=>!(S&&"message"in S)):[]}async provideWelcomeMessage(l,m){if(!this.q)return[];const g=await this.q.provideWelcomeMessage(l,m);return g?g.map(d=>typeof d=="string"?d:f.MarkdownString.from(d)):[]}async provideTitle(l,m){if(this.s)return await this.s.provideChatTitle(l,m)??void 0}async provideSampleQuestions(l,m){if(!this.q||!this.q.provideSampleQuestions)return[];const g=await this.q.provideSampleQuestions(l,m);return g||[]}get apiAgent(){let l=!1,m=!1;const g=()=>{l||m||(m=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof v.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$4O?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.k,helpTextPrefix:!this.d||typeof this.d=="string"?this.d:f.MarkdownString.from(this.d),helpTextVariablesPrefix:!this.g||typeof this.g=="string"?this.g:f.MarkdownString.from(this.g),helpTextPostfix:!this.j||typeof this.j=="string"?this.j:f.MarkdownString.from(this.j),supportIssueReporting:this.n,requester:this.t,supportsSlowVariables:this.u}),m=!1}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(S){d.c=S,g()},get requestHandler(){return d.y},set requestHandler(S){(0,I.$rg)(typeof S=="function","Invalid request handler"),d.y=S},get followupProvider(){return d.b},set followupProvider(S){d.b=S,g()},get helpTextPrefix(){return(0,u.$vH)(d.extension,"defaultChatParticipant"),d.d},set helpTextPrefix(S){(0,u.$vH)(d.extension,"defaultChatParticipant"),d.d=S,g()},get helpTextVariablesPrefix(){return(0,u.$vH)(d.extension,"defaultChatParticipant"),d.g},set helpTextVariablesPrefix(S){(0,u.$vH)(d.extension,"defaultChatParticipant"),d.g=S,g()},get helpTextPostfix(){return(0,u.$vH)(d.extension,"defaultChatParticipant"),d.j},set helpTextPostfix(S){(0,u.$vH)(d.extension,"defaultChatParticipant"),d.j=S,g()},get isSecondary(){return(0,u.$vH)(d.extension,"defaultChatParticipant"),d.k},set isSecondary(S){(0,u.$vH)(d.extension,"defaultChatParticipant"),d.k=S,g()},get supportIssueReporting(){return(0,u.$vH)(d.extension,"chatParticipantPrivate"),d.n},set supportIssueReporting(S){(0,u.$vH)(d.extension,"chatParticipantPrivate"),d.n=S,g()},get onDidReceiveFeedback(){return d.l.event},set participantVariableProvider(S){if((0,u.$vH)(d.extension,"chatParticipantAdditions"),d.o=S,S){if(!S.triggerCharacters.length)throw new Error("triggerCharacters are required");d.w.$registerAgentCompletionsProvider(d.x,d.id,S.triggerCharacters)}else d.w.$unregisterAgentCompletionsProvider(d.x,d.id)},get participantVariableProvider(){return(0,u.$vH)(d.extension,"chatParticipantAdditions"),d.o},set welcomeMessageProvider(S){(0,u.$vH)(d.extension,"defaultChatParticipant"),d.q=S,g()},get welcomeMessageProvider(){return(0,u.$vH)(d.extension,"defaultChatParticipant"),d.q},set titleProvider(S){(0,u.$vH)(d.extension,"defaultChatParticipant"),d.s=S,g()},get titleProvider(){return(0,u.$vH)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,u.$uH)(this.extension,"chatParticipantAdditions")?this.m.event:void 0,set requester(S){d.t=S,g()},get requester(){return d.t},set supportsSlowReferences(S){(0,u.$vH)(d.extension,"chatParticipantPrivate"),d.u=S,g()},get supportsSlowReferences(){return(0,u.$vH)(d.extension,"chatParticipantPrivate"),d.u},dispose(){l=!0,d.b=void 0,d.l.dispose(),d.w.$unregisterAgent(d.x)}}}invoke(l,m,g,d){return this.y(l,m,g,d)}}}),define(Oe[234],Ae([1,0,13,4,35,5,8,7,24]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0,T=He(T),O=He(O);class s{static{this.a=0}constructor(h){this.b=new Map,this.c=h.getProxy(N.$3N.MainThreadChatVariables)}async $resolveVariable(h,E,f,r){const a=this.b.get(h);if(a)try{if(a.resolver.resolve2){(0,p.$vH)(a.extension,"chatParticipantAdditions");const c=new I(E,this.c),u=await a.resolver.resolve2(a.data.name,{prompt:f},c.apiObject,r);if(u&&u[0])return u[0].value}else{const c=await a.resolver.resolve(a.data.name,{prompt:f},r);if(c&&c[0])return c[0].value}}catch(c){(0,y.$3)(c)}}registerVariableResolver(h,E,f,r,a,c,u,i,n){const t=s.a++,o=n?C.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:h,data:{id:E,name:f,description:r,modelDescription:a,icon:o},resolver:u}),this.c.$registerVariable(t,{id:E,name:f,description:r,modelDescription:a,isSlow:c,fullName:i,icon:o}),(0,D.$Vc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Dqc=s;class I{constructor(h,E){this.c=h,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(r){if(h.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,r),a}};const h=this,f=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){E(this.progress);const a=new O.$$P(r),c=T.ChatResponseProgressPart.from(a);return f(c),this},reference(r){E(this.reference);const a=new O.$cQ(r),c=T.ChatResponseReferencePart.from(a);return f(c),this},push(r){return E(this.push),r instanceof O.$cQ?f(T.ChatResponseReferencePart.from(r)):r instanceof O.$$P&&f(T.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Oe[235],Ae([1,0,10,72,6,4,37,2,94,18,8,7,5,24]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=f,p=He(p),I=He(I),v=He(v);function f(r,a,c){const u=r.getProxy(h.$3N.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$wn,a.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===T.MarshalledId.CommentController){const P=this.b.get(w.handle);return P?P.value:w}else if(w&&w.$mid===T.MarshalledId.CommentThread){const P=w,R=this.b.get(P.commentControlHandle);if(!R)return P;const $=R.getCommentThread(P.commentThreadHandle);return $?$.value:P}else if(w&&(w.$mid===T.MarshalledId.CommentThreadReply||w.$mid===T.MarshalledId.CommentThreadInstance)){const P=this.b.get(w.thread.commentControlHandle);if(!P)return w;const R=P.getCommentThread(w.thread.commentThreadHandle);return R?w.$mid===T.MarshalledId.CommentThreadInstance?R.value:{thread:R.value,text:w.text}:w}else if(w&&w.$mid===T.MarshalledId.CommentNode){const P=this.b.get(w.thread.commentControlHandle);if(!P)return w;const R=P.getCommentThread(w.thread.commentThreadHandle);if(!R)return w;const $=w.commentUniqueId,b=R.getCommentByUniqueId($);return b||w}else if(w&&w.$mid===T.MarshalledId.CommentThreadNode){const P=this.b.get(w.thread.commentControlHandle);if(!P)return w;const R=P.getCommentThread(w.thread.commentThreadHandle);if(!R)return w;const $=w.text,b=w.commentUniqueId,L=R.getCommentByUniqueId(b);return L?(typeof L.body=="string"?L.body=$:L.body=new v.$wO($),L):w}return w}})}createCommentController(w,P,R){const $=i.a++,b=new t(w,$,P,R);this.b.set(b.handle,b);const L=this.c.get(w.identifier)||[];return L.push(b),this.c.set(w.identifier,L),b.value}async $createCommentThreadTemplate(w,P,R,$){const b=this.b.get(w);b&&b.$createCommentThreadTemplate(P,R,$)}async $setActiveComment(w,P){const R=this.b.get(w);R&&R.$setActiveComment(P??void 0)}async $updateCommentThreadTemplate(w,P,R){const $=this.b.get(w);$&&$.$updateCommentThreadTemplate(P,R)}$deleteCommentThread(w,P){this.b.get(w)?.$deleteCommentThread(P)}async $provideCommentingRanges(w,P,R){const $=this.b.get(w);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const b=await c.ensureDocumentData(O.URI.revive(P));return(0,y.$Ah)(async()=>{const L=await $.commentingRangeProvider.provideCommentingRanges(b.document,R);let A;return Array.isArray(L)?A={ranges:L,fileComments:!1}:L?A={ranges:L.ranges||[],fileComments:L.enableFileComments||!1}:A=L??void 0,A}).then(L=>{let A;return L&&(A={ranges:L.ranges.map(M=>I.Range.from(M)),fileComments:L.fileComments}),A})}$toggleReaction(w,P,R,$,b){const L=this.b.get(w);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,y.$Ah)(()=>{const A=L.getCommentThread(P);if(A){const M=A.getCommentByUniqueId($.uniqueIdInThread);if(L!==void 0&&M&&L.reactionHandler)return L.reactionHandler(M,m(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,E.$vH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,P,R,$,b,L,A,M,Z){this.m=P,this.n=R,this.o=$,this.p=b,this.q=L,this.extensionDescription=A,this.r=M,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$oe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Yc,this.l.value=new N.$Wc,this.n===void 0&&(this.n=`${w}.${this.handle}`),u.$createCommentThread(P,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(U=>o(this,U,this.k,this.extensionDescription)),A.identifier,this.r,Z),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{u.$deleteCommentThread(P,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(U){G.range=U},get comments(){return G.comments},set comments(U){G.comments=U},get collapsibleState(){return G.collapsibleState},set collapsibleState(U){G.collapsibleState=U},get canReply(){return G.canReply},set canReply(U){G.canReply=U},get contextValue(){return G.contextValue},set contextValue(U){G.contextValue=U},get label(){return G.label},set label(U){G.label=U},get state(){return G.state},set state(U){G.state=U},reveal:(U,V)=>G.reveal(U,V),hide:()=>G.hide(),dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Wc);const w=R=>Object.prototype.hasOwnProperty.call(this.b,R),P={};w("range")&&(P.range=I.Range.from(this.p)),w("label")&&(P.label=this.label),w("contextValue")&&(P.contextValue=this.contextValue??null),w("comments")&&(P.comments=this.q.map(R=>o(this,R,this.k,this.extensionDescription))),w("collapsibleState")&&(P.collapseState=g(this.g)),w("canReply")&&(P.canReply=this.canReply),w("state")&&(P.state=d(this.h)),w("applicability")&&(P.applicability=S(this.h)),w("isTemplate")&&(P.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,P)}getCommentByUniqueId(w){for(const P of this.k){const R=P[0],$=P[1];if(w===$)return R}}async reveal(w,P){(0,E.$vH)(this.extensionDescription,"commentReveal");let R;w&&w.body!==void 0?R=w:P=P??w;let $=R?this.k.get(R):void 0;$??=this.k.get(this.q[0]);let b=!0,L=!1;return P?.focus===v.CommentThreadFocus.Reply?(L=!0,b=!1):P?.focus===v.CommentThreadFocus.Comment&&(b=!1),u.$revealCommentThread(this.m,this.handle,$,{preserveFocus:b,focusReply:L})}async hide(){return u.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Xe([(0,D.$bi)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,E.$vH)(this.h,"commentingRangeHint"),u.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$vH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$vH)(this.h,"activeComment"),this.f?.value}constructor(w,P,R,$){this.h=w,this.i=P,this.j=R,this.k=$,this.a=new Map,u.$registerCommentController(this.handle,R,$,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(L){b.options=L},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(L){b.commentingRangeProvider=L},get reactionHandler(){return b.reactionHandler},set reactionHandler(L){b.reactionHandler=L},get activeCommentThread(){return b.activeCommentThread},createCommentThread(L,A,M){return b.createCommentThread(L,A,M).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(w,P,R){P===void 0&&(0,E.$vH)(this.h,"fileComments");const $=new n(this.id,this.handle,void 0,w,P,R,this.h,!1);return this.a.set($.handle,$),$}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const P=this.a.get(w.commentThreadHandle);P&&(this.e=w.uniqueIdInThread?P.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=P)}$createCommentThreadTemplate(w,P,R){const $=new n(this.id,this.handle,void 0,O.URI.revive(w),I.Range.to(P),[],this.h,!0,R);return $.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set($.handle,$),$}$updateCommentThreadTemplate(w,P){const R=this.a.get(w);R&&(R.range=I.Range.to(P))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function o(k,w,P,R){let $=P.get(w);return $||($=++k.commentHandle,P.set(w,$)),w.state!==void 0&&(0,E.$vH)(R,"commentsDraftState"),w.reactions?.some(b=>b.reactors!==void 0)&&(0,E.$vH)(R,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:$,body:typeof w.body=="string"?w.body:I.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(b=>l(b)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function l(k){return{label:k.label,iconPath:k.iconPath?I.$CQ(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted,reactors:k.reactors&&k.reactors.length>0&&typeof k.reactors[0]!="string"?k.reactors.map(w=>w.name):k.reactors}}function m(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?O.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1,reactors:k.reactors?.map(w=>({name:w}))}}function g(k){if(k!==void 0)switch(k){case v.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case v.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function d(k){let w;if(typeof k=="object"?w=k.resolved:w=k,w!==void 0)switch(w){case v.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case v.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function S(k){let w;if(typeof k=="object"&&(w=k.applicability),w!==void 0)switch(w){case v.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case v.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Oe[236],Ae([1,0,19,76,4,15,23,2,8,68,80,5,7]),function($e,e,y,D,C,N,T,O,p,s,I,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=void 0,p=He(p),v=He(v),h=He(h);class E{constructor(l,m){this.document=l,this.b=m,this.a=1,this.c=new I.$nqc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,m){await this.f(l).undo(),m||this.disposeBackup()}async redo(l,m){await this.f(l).redo(),m||this.disposeBackup()}disposeEdits(l){for(const m of l)this.c.delete(m)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,T.$jh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const m=this.c.get(l,0);if(!m)throw new Error("No edit found");return m}}class f{constructor(){this.a=new Map}get(l,m){return this.a.get(this.b(l,m))}add(l,m,g){const d=this.b(l,m.uri);if(this.a.has(d))throw new Error(`Document already exists for viewType:${l} resource:${m.uri}`);const S=new E(m,g);return this.a.set(d,S),S}delete(l,m){const g=this.b(l,m.uri);this.a.delete(g)}b(l,m){return`${l}@@@${m}`}}var r;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(r||(r={}));class a{constructor(){this.a=new Map}addTextProvider(l,m,g){return this.b(l,{type:r.Text,extension:m,provider:g})}addCustomProvider(l,m,g){return this.b(l,{type:r.Custom,extension:m,provider:g})}get(l){return this.a.get(l)}b(l,m){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,m),new h.$5N(()=>this.a.delete(l))}}class c{constructor(l,m,g,d,S){this.d=m,this.f=g,this.g=d,this.h=S,this.b=new a,this.c=new f,this.a=l.getProxy(v.$3N.MainThreadCustomEditors)}registerCustomEditorProvider(l,m,g,d){const S=new C.$Wc;return i(g)?(S.add(this.b.addTextProvider(m,l,g)),this.a.$registerTextEditorProvider((0,s.$Wqc)(l),m,d.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,s.$Uqc)(l))):(S.add(this.b.addCustomProvider(m,l,g)),u(g)&&S.add(g.onDidChangeCustomDocument(k=>{const w=this.i(m,k.document.uri);if(n(k)){const P=w.addEdit(k);this.a.$onDidEdit(k.document.uri,m,P,k.label)}else this.a.$onContentChange(k.document.uri,m)})),this.a.$registerCustomEditorProvider((0,s.$Wqc)(l),m,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,s.$Uqc)(l))),h.$5N.from(S,new h.$5N(()=>{this.a.$unregisterEditorProvider(m)}))}async $createCustomDocument(l,m,g,d,S){const k=this.b.get(m);if(!k)throw new Error(`No provider found for '${m}'`);if(k.type!==r.Custom)throw new Error(`Invalid provide type for '${m}'`);const w=O.URI.revive(l),P=await k.provider.openCustomDocument(w,{backupId:g,untitledDocumentData:d?.buffer},S);let R;return u(k.provider)&&this.f&&(R=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(m,P,R),{editable:u(k.provider)}}async $disposeCustomDocument(l,m){const g=this.b.get(m);if(!g)throw new Error(`No provider found for '${m}'`);if(g.type!==r.Custom)throw new Error(`Invalid provider type for '${m}'`);const d=O.URI.revive(l),{document:S}=this.i(m,d);this.c.delete(m,S),S.dispose()}async $resolveCustomEditor(l,m,g,d,S,k){const w=this.b.get(g);if(!w)throw new Error(`No provider found for '${g}'`);const P=p.ViewColumn.to(S),R=this.g.createNewWebview(m,d.contentOptions,w.extension),$=this.h.createNewWebviewPanel(m,g,d.title,P,d.options,R,d.active),b=O.URI.revive(l);switch(w.type){case r.Custom:{const{document:L}=this.i(g,b);return w.provider.resolveCustomEditor(L,$,k)}case r.Text:{const L=this.d.getDocument(b);return w.provider.resolveCustomTextEditor(L,$,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,m,g){this.i(m,l).disposeEdits(g)}async $onMoveCustomEditor(l,m,g){const d=this.b.get(g);if(!d)throw new Error(`No provider found for '${g}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const S=this.h.getWebviewPanel(l);if(!S)throw new Error("No webview found");const k=O.URI.revive(m),w=this.d.getDocument(k);await d.provider.moveCustomTextEditor(w,S,y.CancellationToken.None)}async $undo(l,m,g,d){return this.i(m,l).undo(g,d)}async $redo(l,m,g,d){return this.i(m,l).redo(g,d)}async $revert(l,m,g){const d=this.i(m,l);await this.j(m).revertCustomDocument(d.document,g),d.disposeBackup()}async $onSave(l,m,g){const d=this.i(m,l);await this.j(m).saveCustomDocument(d.document,g),d.disposeBackup()}async $onSaveAs(l,m,g,d){const S=this.i(m,l);return this.j(m).saveCustomDocumentAs(S.document,O.URI.revive(g),d)}async $backup(l,m,g){const d=this.i(m,l),k=await this.j(m).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},g);return d.updateBackup(k),k.id}i(l,m){const g=this.c.get(l,O.URI.revive(m));if(!g)throw new Error("No custom document found");return g}j(l){const g=this.b.get(l)?.provider;if(!g||!u(g))throw new Error("Custom document is not editable");return g}}e.$Zqc=c;function u(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function n(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const l=o.scheme===N.Schemas.file||o.scheme===N.Schemas.untitled?o.fsPath:o.toString();return(0,D.$wj)(l)+""}}),define(Oe[237],Ae([1,0,9,108,2,5,7,8,6,11,28,51]),function($e,e,y,D,C,N,T,O,p,s,I,v){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=e.$uqc=void 0,O=He(O);class E{#e;#t;#i;constructor(a,c,u,i,n,t,o,l){this.d=a,this.e=c,this.f=u,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,u),this.#i=new I.$Dc(m=>t.getComparisonKey(m)),this.#e=o,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,c){if(!a){this.clear();return}this.j();let u=[];if(C.URI.isUri(a)){if(!c){this.delete(a);return}this.#i.set(a,c.slice()),u=[a]}else if(Array.isArray(a)){u=[];let t;a=[...a].sort(E.k);for(const o of a){const[l,m]=o;if((!t||l.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=l,u.push(l),this.#i.set(l,[])),m)this.#i.get(l)?.push(...m);else{const g=this.#i.get(l);g&&(g.length=0)}}}if(this.#t.fire(u),!this.#e)return;const i=[];let n=0;for(const t of u){let o=[];const l=this.#i.get(t);if(l)if(l.length>this.g){o=[];const m=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const d of l)if(d.severity===m[g]&&o.push({...O.Diagnostic.from(d),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:D.MarkerSeverity.Info,message:(0,y.localize)(2698,null,l.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=l.map(m=>({...O.Diagnostic.from(m),modelVersionId:this.h(t)}));if(i.push([t,o]),n+=o.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,c){this.j();for(const[u,i]of this)a.call(c,u,i,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const c=this.#i.get(a);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,c){return a[0].toString()<c[0].toString()?-1:a[0].toString()>c[0].toString()?1:0}}e.$uqc=E;let f=class{static{h=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(a){const c=new I.$Dc;for(const u of a)c.set(u,u);return{uris:Object.freeze(Array.from(c.values()))}}constructor(a,c,u,i){this.j=c,this.k=u,this.l=i,this.g=new Map,this.h=new p.$se({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,h._mapper),this.f=a.getProxy(N.$3N.MainThreadDiagnostics)}createDiagnosticCollection(a,c){const{g:u,f:i,h:n,j:t,k:o,l}=this,m=new class{$changeMany(S,k){i.$changeMany(S,k),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,S,k.length===0?"CLEARING":k)}$clear(S){i.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,S)}dispose(){i.dispose()}};let g;if(!c)c="_generated_diagnostic_collection_name_#"+h.c++,g=c;else if(!u.has(c))g=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do g=c+h.c++;while(u.has(g))}return new class extends E{constructor(){super(c,g,h.e,h.d,S=>l.getDocument(S)?.version,o.extUri,m,n),u.set(g,this)}dispose(){super.dispose(),u.delete(g)}}}getDiagnostics(a){if(a)return this.m(a);{const c=new Map,u=[];for(const i of this.g.values())i.forEach((n,t)=>{let o=c.get(n.toString());typeof o>"u"&&(o=u.length,c.set(n.toString(),o),u.push([n,[]])),u[o][1]=u[o][1].concat(...t)});return u}}m(a){let c=[];for(const u of this.g.values())u.has(a)&&(c=c.concat(u.get(a)));return c}$acceptMarkersChange(a){if(!this.n){const c="_generated_mirror",u=new E(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,u),this.n=u}for(const[c,u]of a)this.n.set(C.URI.revive(c),u.map(O.Diagnostic.to))}};e.$vqc=f,e.$vqc=f=h=Xe([Qe(1,s.$dk),Qe(2,v.$tqc)],f)}),define(Oe[238],Ae([1,0,2,13,7,8,172,39]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=void 0;class p{constructor(I,v,h,E={timeout:1500,errors:3}){this.c=I,this.d=v,this.f=h,this.g=E,this.a=new T.$8c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(v,h,E)=>{const r={dispose:this.a.push([v,h,I])};return Array.isArray(E)&&E.push(r),r}}async $participateInSave(I,v){const h=y.URI.revive(I);let E=!1;const f=setTimeout(()=>E=!0,this.g.timeout),r=[];try{for(const a of[...this.a]){if(E)break;const c=this.d.getDocument(h),u=await this.h(a,{document:c,reason:N.TextDocumentSaveReason.to(v)});r.push(u)}}finally{clearTimeout(f)}return r}h([I,v,h],E){const f=this.b.get(I);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(h,I,v,E).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this.b.get(I);this.b.set(I,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,v,h,E){const f=[],r=Date.now(),{document:a,reason:c}=E,{version:u}=a,i=Object.freeze({document:a,reason:c,waitUntil(n){if(Object.isFrozen(f))throw(0,D.$0)("waitUntil can not be called async");f.push(Promise.resolve(n))}});try{v.apply(h,[i])}catch(n){return Promise.reject(n)}return Object.freeze(f),new Promise((n,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(f).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),n(l)}).catch(l=>{clearTimeout(o),t(l)})}).then(n=>{const t={edits:[]};for(const o of n)if(Array.isArray(o)&&o.every(l=>l instanceof C.$bO))for(const{newText:l,newEol:m,range:g}of o)t.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:g&&N.Range.from(g),text:l,eol:m&&N.EndOfLine.from(m)}});if(t.edits.length!==0)return u===a.version?this.f.$tryApplyWorkspaceEdit(new O.$4w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Irc=p}),define(Oe[239],Ae([1,0,6,4,2,5,125,8,14,25,7]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0,O=He(O);class v{constructor(E,f){this.a=new y.$oe,this.b=new y.$oe,this.c=new y.$oe,this.d=new y.$oe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new D.$Wc,this.h=new Map,this.f=E.getProxy(N.$3N.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(r=>{for(const a of r)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const a of r)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const f=this.g.getDocument(E);if(f)return f}getDocument(E){const f=this.getDocumentData(E);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return f.document}ensureDocumentData(E){const f=this.g.getDocument(E);if(f)return Promise.resolve(f);let r=this.h.get(E.toString());return r||(r=this.f.$tryOpenDocument(E).then(a=>{this.h.delete(E.toString());const c=C.URI.revive(a);return(0,p.$sg)(this.g.getDocument(c))},a=>(this.h.delete(E.toString()),Promise.reject(a))),this.h.set(E.toString(),r)),r}createDocumentData(E){return this.f.$tryCreateDocument(E).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged(E,f){const r=C.URI.revive(E),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(f),this.a.fire(a.document)}$acceptModelSaved(E){const f=C.URI.revive(E),r=this.g.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(E,f){const r=C.URI.revive(E),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(f),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,f,r){const a=C.URI.revive(E),c=this.g.getDocument(a);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(f);let u;f.isUndoing?u=I.TextDocumentChangeReason.Undo:f.isRedoing&&(u=I.TextDocumentChangeReason.Redo),this.c.fire((0,s.$io)({document:c.document,contentChanges:f.changes.map(i=>({range:O.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:u}))}setWordDefinitionFor(E,f){(0,T.$FQ)(E,f)}}e.$wqc=v}),define(Oe[71],Ae([1,0,240,6,14,2,3,5,16,8,7]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=e.$1qc=void 0,s=He(s),e.$1qc=(0,T.$Ii)("IExtHostEditorTabs");class v{constructor(a,c,u){this.e=u,this.d=c,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,c={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case O.TabInputKind.TextInput:return new I.$SP(N.URI.revive(this.b.input.uri));case O.TabInputKind.TextDiffInput:return new I.$TP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case O.TabInputKind.TextMergeInput:return new I.$UP(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case O.TabInputKind.CustomEditorInput:return new I.$VP(N.URI.revive(this.b.input.uri),this.b.input.viewType);case O.TabInputKind.WebviewEditorInput:return new I.$WP(this.b.input.viewType);case O.TabInputKind.NotebookInput:return new I.$XP(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case O.TabInputKind.NotebookDiffInput:return new I.$YP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case O.TabInputKind.TerminalEditorInput:return new I.$ZP;case O.TabInputKind.InteractiveEditorInput:return new I.$1P(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case O.TabInputKind.ChatEditorInput:return new I.$2P;case O.TabInputKind.MultiDiffEditorInput:return new I.$3P(this.b.input.diffEditors.map(a=>new I.$TP(N.URI.revive(a.original),N.URI.revive(a.modified))));default:return}}}class h{constructor(a,c){this.c=[],this.d="",this.b=a,this.e=c;for(const u of a.tabs)u.isActive&&(this.d=u.id),this.c.push(new v(u,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,c={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return s.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(u=>u.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(u=>u.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===O.TabModelOperationKind.TAB_OPEN){const u=new v(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,u),a.tabDto.isActive&&(this.d=u.tabId),u}else if(a.kind===O.TabModelOperationKind.TAB_CLOSE){const u=this.c.splice(a.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return u.tabId===this.d&&(this.d=""),u}else if(a.kind===O.TabModelOperationKind.TAB_MOVE){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this.c.splice(a.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,u),u}const c=this.c.find(u=>u.tabId===a.tabDto.id);if(!c)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(a.tabDto),c}activeTabId(){return this.d}}let E=class{constructor(a){this.b=new D.$oe,this.c=new D.$oe,this.e=[],this.a=a.getProxy(O.$3N.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,c={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(u=>u.apiObject))},get activeTabGroup(){const u=a.d;return(0,C.$sg)(a.e.find(n=>n.groupId===u)?.apiObject)},close:async(u,i)=>{const n=Array.isArray(u)?u:[u];return n.length?f(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(a){const c=new Set(this.e.map(m=>m.groupId)),u=new Set(a.map(m=>m.groupId)),i=(0,y.$d)(c,u),n=this.e.filter(m=>i.removed.includes(m.groupId)).map(m=>m.apiObject),t=[],o=[];this.e=a.map(m=>{const g=new h(m,()=>this.d);return i.added.includes(g.groupId)?t.push(g.apiObject):o.push(g.apiObject),g});const l=(0,C.$sg)(a.find(m=>m.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:n,changed:o}))}$acceptTabGroupUpdate(a){const c=this.e.find(u=>u.groupId===a.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const c=this.e.find(i=>i.groupId===a.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const u=c.acceptTabOperation(a);switch(a.kind){case O.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case O.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case O.TabModelOperationKind.TAB_MOVE:case O.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}g(a){for(const c of this.e)for(const u of c.tabs)if(u.apiObject===a)return u}h(a){return this.e.find(c=>c.apiObject===a)}async i(a,c){const u=[];for(const i of a){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");u.push(n.tabId)}return this.a.$closeTab(u,c)}async j(a,c){const u=[];for(const i of a){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");u.push(n.groupId)}return this.a.$closeGroup(u,c)}};e.$2qc=E,e.$2qc=E=Xe([Qe(0,p.$DQ)],E);function f(r){return r.tabs!==void 0}}),define(Oe[241],Ae([1,0,2,5,29,4,7,8,286,12,27,22,24,60]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lrc=void 0,C=He(C),O=He(O);class f{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const u=this.a.indexOf(c);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),u=[];let i,n,t=p.State.LastKnownState,o=p.State.LastKnownState;for(const l of c){let m=i?(0,s.$Kf)(i,l):0;for(m===0?n=p.State.Start:n=o;m<l.length;m++)m+1===l.length?(t=o,o=p.State.BeforeColon):o+=1,u.push([n,l.toUpperCase().charCodeAt(m),o]),u.push([n,l.toLowerCase().charCodeAt(m),o]),n=o;i=l,o=t}u.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),u.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$24(u)}}provideDocumentLinks(c){this.c();const u=[],i=p.$34.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of i){const t=O.DocumentLink.to(n);t.target&&u.push(t)}return u}}class r{constructor(c,u){this.i=u,this.b=new f,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(D.$3N.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,u,i,n={}){if(r.j(i),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const t=this.h++;this.b.add(u),this.d.add(u),this.c.set(t,i);let o=C.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(o+=C.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(o+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,h.$vH)(c,"fsChunks"),o+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;n.isReadonly&&(0,E.$9k)(n.isReadonly)&&n.isReadonly.value!==""&&(l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,u,o,l).catch(g=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${u}`),console.error(g)});const m=i.onDidChangeFile(g=>{const d=[];for(const S of g){const{uri:k,type:w}=S;if(k.scheme!==u)continue;let P;switch(w){case T.FileChangeType.Changed:P=C.FileChangeType.UPDATED;break;case T.FileChangeType.Created:P=C.FileChangeType.ADDED;break;case T.FileChangeType.Deleted:P=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:k,type:P})}this.a.$onFileSystemChange(t,d)});return(0,N.$Vc)(()=>{m.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:u,ctime:i,mtime:n,size:t,permissions:o}=c;return{type:u,ctime:i,mtime:n,size:t,permissions:o}}$stat(c,u){return Promise.resolve(this.l(c).stat(y.URI.revive(u))).then(i=>r.k(i))}$readdir(c,u){return Promise.resolve(this.l(c).readDirectory(y.URI.revive(u)))}$readFile(c,u){return Promise.resolve(this.l(c).readFile(y.URI.revive(u))).then(i=>v.$Qe.wrap(i))}$writeFile(c,u,i,n){return Promise.resolve(this.l(c).writeFile(y.URI.revive(u),i.buffer,n))}$delete(c,u,i){return Promise.resolve(this.l(c).delete(y.URI.revive(u),i))}$rename(c,u,i,n){return Promise.resolve(this.l(c).rename(y.URI.revive(u),y.URI.revive(i),n))}$copy(c,u,i,n){const t=this.l(c);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(y.URI.revive(u),y.URI.revive(i),n))}$mkdir(c,u){return Promise.resolve(this.l(c).createDirectory(y.URI.revive(u)))}$watch(c,u,i,n){const t=this.l(c).watch(y.URI.revive(i),n);this.f.set(u,t)}$unwatch(c,u){const i=this.f.get(u);i&&(i.dispose(),this.f.delete(u))}$open(c,u,i){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(y.URI.revive(u),i))}$close(c,u){const i=this.l(c);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(u))}$read(c,u,i,n){const t=this.l(c);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=v.$Qe.alloc(n);return Promise.resolve(t.read(u,i,o.buffer,0,n)).then(l=>o.slice(0,l))}$write(c,u,i,n){const t=this.l(c);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(u,i,n.buffer,0,n.byteLength))}l(c){const u=this.c.get(c);if(!u){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return u}}e.$Lrc=r}),define(Oe[242],Ae([1,0,6,41,2,5,8,7,29,48]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mrc=void 0,T=He(T);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(f,r,a,c,u,i){this.a=Math.random(),this.b=new y.$oe,this.c=new y.$oe,this.d=new y.$oe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,D.$Dk)(u),t=typeof u=="string",o=i?.correlate,l=c(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(o&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const g of m.created){const d=C.URI.revive(g);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const g of m.changed){const d=C.URI.revive(g);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const g of m.deleted){const d=C.URI.revive(g);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=O.$5N.from(this.i(f,a,u,i,i?.correlate),this.b,this.c,this.d,l)}i(f,r,a,c,u){const i=O.$5N.from();if(typeof a=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return i;const n=f.getProxy(N.$3N.MainThreadFileSystemEventService);let t=!1;(a.pattern.includes(D.$zk)||a.pattern.includes(D.$Ak))&&(t=!0);let o;return u&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(o=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(o&=~p.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(o&=~p.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(o&=~p.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,a.baseUri,{recursive:t,excludes:c?.excludes??[],filter:o},!!u),O.$5N.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class v{constructor(f){this.a=f,this.session=this.a.session,this.b=new s.$W(()=>this.a.created.map(C.URI.revive)),this.c=new s.$W(()=>this.a.changed.map(C.URI.revive)),this.d=new s.$W(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class h{constructor(f,r,a){this.j=f,this.k=r,this.l=a,this.a=new y.$oe,this.b=new y.$oe,this.c=new y.$oe,this.d=new y.$oe,this.g=new y.$qe,this.h=new y.$qe,this.i=new y.$qe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(f,r,a,c){return new I(this.j,f,r,this.a.event,T.GlobPattern.from(a),c)}$onFileEvent(f){this.a.fire(new v(f))}$onDidRunFileOperation(f,r){switch(f){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(a=>C.URI.revive(a.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(a=>C.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(f){return this.m(f,this.g)}getOnWillCreateFileEvent(f){return this.m(f,this.h)}getOnWillDeleteFileEvent(f){return this.m(f,this.i)}m(f,r){return(a,c,u)=>{const i=function(t){a.call(c,t)};return i.extension=f,r.event(i,void 0,u)}}async $onWillRunFileOperation(f,r,a,c){switch(f){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(u=>({oldUri:C.URI.revive(u.source),newUri:C.URI.revive(u.target)}))},a,c);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(u=>C.URI.revive(u.target))},a,c);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(u=>C.URI.revive(u.target))},a,c)}}async n(f,r,a,c){const u=new Set,i=[];if(await f.fireAsync(r,c,async(t,o)=>{const l=Date.now(),m=await Promise.resolve(t);m instanceof O.$eO&&(i.push([o.extension,m]),u.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-l>a&&this.k.warn("SLOW file-participant",o.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:o}=T.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(u)}}}e.$Mrc=h}),define(Oe[243],Ae([1,0,17,10,19,13,97,4,25,70,12,14,2,32,287,94,104,9,18,8,7,24,80,5]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0,r=He(r),i=He(i),l=He(l);class m{constructor(B,j){this.d=B,this.e=j}async provideDocumentSymbols(B,j){const H=this.d.getDocument(B),J=await this.e.provideDocumentSymbols(H,j);if(!(0,y.$Mb)(J))return J[0]instanceof n.$oO?J.map(i.DocumentSymbol.from):m.f(J)}static f(B){B=B.slice(0).sort((J,re)=>{let ge=J.location.range.start.compareTo(re.location.range.start);return ge===0&&(ge=re.location.range.end.compareTo(J.location.range.end)),ge});const j=[],H=[];for(const J of B){const re={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(H.length===0){H.push(re),j.push(re);break}const ge=H[H.length-1];if(E.$Tt.containsRange(ge.range,re.range)&&!E.$Tt.equalsRange(ge.range,re.range)){ge.children?.push(re),H.push(re);break}H.pop()}}return j}}class g{constructor(B,j,H,J,re,ge){this.f=B,this.g=j,this.h=H,this.j=J,this.k=re,this.l=ge,this.d=new o.$nqc("CodeLens"),this.e=new Map}async provideCodeLenses(B,j){const H=this.f.getDocument(B),J=await this.h.provideCodeLenses(H,j);if(!J||j.isCancellationRequested)return;const re=this.d.add(J),ge=new O.$Wc;this.e.set(re,ge);const ke={cacheId:re,lenses:[]};for(let qe=0;qe<J.length;qe++)ke.lenses.push({cacheId:[re,qe],range:i.Range.from(J[qe].range),command:this.g.toInternal(J[qe].command,ge)});return ke}async resolveCodeLens(B,j){const H=B.cacheId&&this.d.get(...B.cacheId);if(!H)return;let J;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?J=H:J=await this.h.resolveCodeLens(H,j),J||(J=H),j.isCancellationRequested)return;const re=B.cacheId&&this.e.get(B.cacheId[0]);if(re){if(!J.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return B.command=this.g.toInternal(J.command,re),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function d(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class S{constructor(B,j){this.d=B,this.e=j}async provideDefinition(B,j,H){const J=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideDefinition(J,re,H);return d(ge)}}class k{constructor(B,j){this.d=B,this.e=j}async provideDeclaration(B,j,H){const J=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideDeclaration(J,re,H);return d(ge)}}class w{constructor(B,j){this.d=B,this.e=j}async provideImplementation(B,j,H){const J=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideImplementation(J,re,H);return d(ge)}}class P{constructor(B,j){this.d=B,this.e=j}async provideTypeDefinition(B,j,H){const J=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideTypeDefinition(J,re,H);return d(ge)}}class R{static{this.f=10}constructor(B,j){this.g=B,this.h=j,this.d=0,this.e=new Map}async provideHover(B,j,H,J){const re=this.g.getDocument(B),ge=i.Position.to(j);let ke;if(H&&H.verbosityRequest){const st=H.verbosityRequest.previousHover.id,ut=this.e.get(st);if(!ut)throw new Error(`Hover with id ${st} not found`);const ot={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:ut};ke=await this.h.provideHover(re,ge,J,ot)}else ke=await this.h.provideHover(re,ge,J);if(!ke||(0,y.$Mb)(ke.contents))return;ke.range||(ke.range=re.getWordRangeAtPosition(ge)),ke.range||(ke.range=new n.$7N(ge,ge));const qe=i.Hover.from(ke),xe=this.d;if(this.e.size===R.f){const st=Math.min(...this.e.keys());this.e.delete(st)}return this.e.set(xe,ke),this.d+=1,{...qe,id:xe}}releaseHover(B){this.e.delete(B)}}class ${constructor(B,j){this.d=B,this.e=j}async provideEvaluatableExpression(B,j,H){const J=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideEvaluatableExpression(J,re,H);if(ge)return i.EvaluatableExpression.from(ge)}}class b{constructor(B,j){this.d=B,this.e=j}async provideInlineValues(B,j,H,J){const re=this.d.getDocument(B),ge=await this.e.provideInlineValues(re,i.Range.to(j),i.InlineValueContext.to(H),J);if(Array.isArray(ge))return ge.map(ke=>i.InlineValue.from(ke))}}class L{constructor(B,j){this.d=B,this.e=j}async provideDocumentHighlights(B,j,H){const J=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideDocumentHighlights(J,re,H);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class A{constructor(B,j){this.d=B,this.e=j}async provideMultiDocumentHighlights(B,j,H,J){const re=this.d.getDocument(B),ge=H.map(xe=>this.d.getDocument(xe)),ke=i.Position.to(j),qe=await this.e.provideMultiDocumentHighlights(re,ke,ge,J);if(Array.isArray(qe))return qe.map(i.MultiDocumentHighlight.from)}}class M{constructor(B,j){this.d=B,this.e=j}async provideLinkedEditingRanges(B,j,H){const J=this.d.getDocument(B),re=i.Position.to(j),ge=await this.e.provideLinkedEditingRanges(J,re,H);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,y.$Jb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class Z{constructor(B,j){this.d=B,this.e=j}async provideReferences(B,j,H,J){const re=this.d.getDocument(B),ge=i.Position.to(j),ke=await this.e.provideReferences(re,ge,H,J);if(Array.isArray(ke))return ke.map(i.location.from)}}class G{static{this.d=1e3}constructor(B,j,H,J,re,ge,ke){this.g=B,this.h=j,this.j=H,this.k=J,this.l=re,this.m=ge,this.n=ke,this.e=new o.$nqc("CodeAction"),this.f=new Map}async provideCodeActions(B,j,H,J){const re=this.g.getDocument(B),ge=f.$Vt.isISelection(j)?i.Selection.to(j):i.Range.to(j),ke=[];for(const ot of this.j.getDiagnostics(B))if(ge.intersection(ot.range)&&ke.push(ot)>G.d)break;const qe={diagnostics:ke,only:H.only?new n.$qO(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},xe=await this.k.provideCodeActions(re,ge,qe,J);if(!(0,y.$Nb)(xe)||J.isCancellationRequested)return;const rt=this.e.add(xe),st=new O.$Wc;this.f.set(rt,st);const ut=[];for(let ot=0;ot<xe.length;ot++){const lt=xe[ot];if(lt)if(G.o(lt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ut.push({_isSynthetic:!0,title:lt.title,command:this.h.toInternal(lt,st)});else{qe.only&&(lt.kind?qe.only.contains(lt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value}' requested but returned code action is of kind '${lt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const vt=lt.ranges??[];ut.push({cacheId:[rt,ot],title:lt.title,command:lt.command&&this.h.toInternal(lt.command,st),diagnostics:lt.diagnostics&&lt.diagnostics.map(i.Diagnostic.from),edit:lt.edit&&i.WorkspaceEdit.from(lt.edit,void 0),kind:lt.kind&&lt.kind.value,isPreferred:lt.isPreferred,isAI:(0,t.$uH)(this.m,"codeActionAI")?lt.isAI:!1,ranges:(0,t.$uH)(this.m,"codeActionRanges")?(0,y.$Jb)(vt.map(i.Range.from)):void 0,disabled:lt.disabled?.reason})}}return{cacheId:rt,actions:ut}}async resolveCodeAction(B,j){const[H,J]=B,re=this.e.get(H,J);if(!re||G.o(re))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(re,j)??re;let ke;ge.edit&&(ke=i.WorkspaceEdit.from(ge.edit,void 0));let qe;if(ge.command){const xe=this.f.get(H);xe&&(qe=this.h.toInternal(ge.command,xe))}return{edit:ke,command:qe}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class U{constructor(B,j,H,J,re){this.e=B,this.f=j,this.g=H,this.h=J,this.j=re,this.d=new o.$nqc("DocumentPasteEdit")}async prepareDocumentPaste(B,j,H,J){if(!this.g.prepareDocumentPaste)return;const re=this.f.getDocument(B),ge=j.map(xe=>i.Range.to(xe)),ke=i.DataTransfer.toDataTransfer(H,()=>{throw new N.$ab});if(await this.g.prepareDocumentPaste(re,ge,ke,J),J.isCancellationRequested)return;const qe=Array.from(ke).filter(([,xe])=>!(xe instanceof n.$WO));return i.DataTransfer.from(qe)}async providePasteEdits(B,j,H,J,re,ge){if(!this.g.provideDocumentPasteEdits)return[];const ke=this.f.getDocument(j),qe=H.map(ut=>i.Range.to(ut)),xe=i.DataTransfer.toDataTransfer(J,async ut=>(await this.e.$resolvePasteFileData(this.h,B,ut)).buffer),rt=await this.g.provideDocumentPasteEdits(ke,qe,xe,{only:re.only?new n.$2O(re.only):void 0,triggerKind:re.triggerKind},ge);if(!rt||ge.isCancellationRequested)return[];const st=this.d.add(rt);return rt.map((ut,ot)=>({_cacheId:[st,ot],title:ut.title??(0,c.localize)(2701,null,this.j.displayName||this.j.name),kind:ut.kind,yieldTo:ut.yieldTo?.map(lt=>lt.value),insertText:typeof ut.insertText=="string"?ut.insertText:{snippet:ut.insertText.value},additionalEdit:ut.additionalEdit?i.WorkspaceEdit.from(ut.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,j){const[H,J]=B,re=this.d.get(H,J);if(!re||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(B){this.d.delete(B)}}class V{constructor(B,j){this.d=B,this.e=j}async provideDocumentFormattingEdits(B,j,H){const J=this.d.getDocument(B),re=await this.e.provideDocumentFormattingEdits(J,j,H);if(Array.isArray(re))return re.map(i.TextEdit.from)}}class Q{constructor(B,j){this.d=B,this.e=j}async provideDocumentRangeFormattingEdits(B,j,H,J){const re=this.d.getDocument(B),ge=i.Range.to(j),ke=await this.e.provideDocumentRangeFormattingEdits(re,ge,H,J);if(Array.isArray(ke))return ke.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,j,H,J){(0,v.$rg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this.d.getDocument(B),ge=j.map(i.Range.to),ke=await this.e.provideDocumentRangesFormattingEdits(re,ge,H,J);if(Array.isArray(ke))return ke.map(i.TextEdit.from)}}class ne{constructor(B,j){this.d=B,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,j,H,J,re){const ge=this.d.getDocument(B),ke=i.Position.to(j),qe=await this.e.provideOnTypeFormattingEdits(ge,ke,H,J,re);if(Array.isArray(qe))return qe.map(i.TextEdit.from)}}class ue{constructor(B,j){this.e=B,this.f=j,this.d=new o.$nqc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,j){const H=await this.e.provideWorkspaceSymbols(B,j);if(!(0,y.$Nb)(H))return{symbols:[]};const J=this.d.add(H),re={cacheId:J,symbols:[]};for(let ge=0;ge<H.length;ge++){const ke=H[ge];if(!ke||!ke.name){this.f.warn("INVALID SymbolInformation",ke);continue}re.symbols.push({...i.WorkspaceSymbol.from(ke),cacheId:[J,ge]})}return re}async resolveWorkspaceSymbol(B,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const H=this.d.get(...B.cacheId);if(H){const J=await this.e.resolveWorkspaceSymbol(H,j);return J&&(0,p.$ko)(B,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class x{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,j,H){this.d=B,this.e=j,this.f=H}async provideRenameEdits(B,j,H,J){const re=this.d.getDocument(B),ge=i.Position.to(j);try{const ke=await this.e.provideRenameEdits(re,ge,H,J);return ke?i.WorkspaceEdit.from(ke):void 0}catch(ke){const qe=x.g(ke);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(ke)}}async resolveRenameLocation(B,j,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(B),re=i.Position.to(j);try{const ge=await this.e.prepareRename(J,re,H);let ke,qe;if(n.$7N.isRange(ge)?(ke=ge,qe=J.getText(ge)):(0,v.$jg)(ge)&&(ke=ge.range,qe=ge.placeholder),!ke||!qe)return;if(ke.start.line>re.line||ke.end.line<re.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ke),text:qe}}catch(ge){const ke=x.g(ge);return ke?{rejectReason:ke,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class oe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(B,j,H){this.e=B,this.f=j,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,j,H,J){const re=this.e.getDocument(B),ge=i.Range.to(j);try{const ke=oe.d[H],qe=await this.f.provideNewSymbolNames(re,ge,ke,J);return qe?qe.map(xe=>typeof xe=="string"?{newSymbolName:xe}:{newSymbolName:xe.newSymbolName,tags:xe.tags}):void 0}catch(ke){this.g.error(oe.h(ke)??JSON.stringify(ke,null,"	"));return}}static h(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class se{constructor(B,j){this.resultId=B,this.tokens=j}}class ce{constructor(B,j){this.f=B,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,j,H){const J=this.f.getDocument(B),re=j!==0?this.d.get(j):null;let ge=typeof re?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,re.resultId,H):await this.g.provideDocumentSemanticTokens(J,H);return re&&this.d.delete(j),ge?(ge=ce.h(ge),this.o(ce.n(re,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ce.j(B)?ce.k(B)?B:new n.$pP(new Uint32Array(B.data),B.resultId):ce.l(B)?ce.m(B)?B:new n.$rP(B.edits.map(j=>new n.$qP(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const j of B.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(B,j){if(!ce.j(j)||!B||!B.tokens)return j;const H=B.tokens,J=H.length,re=j.data,ge=re.length;let ke=0;const qe=Math.min(J,ge);for(;ke<qe&&H[ke]===re[ke];)ke++;if(ke===J&&ke===ge)return new n.$rP([],j.resultId);let xe=0;const rt=qe-ke;for(;xe<rt&&H[J-xe-1]===re[ge-xe-1];)xe++;return new n.$rP([{start:ke,deleteCount:J-ke-xe,data:re.subarray(ke,ge-xe)}],j.resultId)}o(B,j){if(ce.j(B)){const H=this.e++;return this.d.set(H,new se(B.resultId,B.data)),(0,a.$jeb)({id:H,type:"full",data:B.data})}if(ce.l(B)){const H=this.e++;return ce.j(j)?this.d.set(H,new se(j.resultId,j.data)):this.d.set(H,new se(B.resultId)),(0,a.$jeb)({id:H,type:"delta",deltas:(B.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class te{constructor(B,j){this.d=B,this.e=j}async provideDocumentRangeSemanticTokens(B,j,H){const J=this.d.getDocument(B),re=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(j),H);return re?this.f(re):null}f(B){return(0,a.$jeb)({id:0,type:"full",data:B.data})}}class we{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,j,H,J,re){this.f=B,this.g=j,this.h=H,this.j=J,this.k=re,this.d=new o.$nqc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,j,H,J){const re=this.f.getDocument(B),ge=i.Position.to(j),ke=re.getWordRangeAtPosition(ge)||new n.$7N(ge,ge),qe=ke.with({end:ge}),xe=new s.$ie,rt=await this.h.provideCompletionItems(re,ge,J,i.CompletionContext.to(H));if(!rt||J.isCancellationRequested)return;const st=Array.isArray(rt)?new n.$DO(rt):rt,ut=we.supportsResolving(this.h)?this.d.add(st.items):this.d.add([]),ot=new O.$Wc;this.e.set(ut,ot);const lt=[],vt={x:ut,[l.ISuggestResultDtoField.completions]:lt,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(ke),insert:i.Range.from(qe)},[l.ISuggestResultDtoField.isIncomplete]:st.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:xe.elapsed()};for(let nt=0;nt<st.items.length;nt++){const he=st.items[nt],pe=this.l(he,[ut,nt],qe,ke);lt.push(pe)}return vt}async resolveCompletionItem(B,j){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...B);if(!H)return;const J=this.l(H,B),re=await this.h.resolveCompletionItem(H,j);if(!re)return;const ge=this.l(re,B);return(J[l.ISuggestDataDtoField.insertText]!==ge[l.ISuggestDataDtoField.insertText]||J[l.ISuggestDataDtoField.insertTextRules]!==ge[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J[l.ISuggestDataDtoField.commandIdent]!==ge[l.ISuggestDataDtoField.commandIdent]||J[l.ISuggestDataDtoField.commandId]!==ge[l.ISuggestDataDtoField.commandId]||!(0,p.$lo)(J[l.ISuggestDataDtoField.commandArguments],ge[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,[l.ISuggestDataDtoField.documentation]:ge[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:ge[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:ge[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:ge[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:ge[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:ge[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:ge[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:ge[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,j,H,J){const re=this.e.get(j[0]);if(!re)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,re),ke={x:j,[l.ISuggestDataDtoField.label]:B.label,[l.ISuggestDataDtoField.kind]:B.kind!==void 0?i.CompletionItemKind.from(B.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:B.tags&&B.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:B.detail,[l.ISuggestDataDtoField.documentation]:typeof B.documentation>"u"?void 0:i.MarkdownString.fromStrict(B.documentation),[l.ISuggestDataDtoField.sortText]:B.sortText!==B.label?B.sortText:void 0,[l.ISuggestDataDtoField.filterText]:B.filterText!==B.label?B.filterText:void 0,[l.ISuggestDataDtoField.preselect]:B.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:B.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:B.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:B.additionalTextEdits&&B.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:ge?.$ident,[l.ISuggestDataDtoField.commandId]:ge?.id,[l.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ke[l.ISuggestDataDtoField.insertText]=B.textEdit.newText):typeof B.insertText=="string"?ke[l.ISuggestDataDtoField.insertText]=B.insertText:B.insertText instanceof n.$fO&&(ke[l.ISuggestDataDtoField.insertText]=B.insertText.value,ke[l.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let qe;return B.textEdit?qe=B.textEdit.range:B.range&&(qe=B.range),n.$7N.isRange(qe)?ke[l.ISuggestDataDtoField.range]=i.Range.from(qe):qe&&(!H?.isEqual(qe.inserting)||!J?.isEqual(qe.replacing))&&(ke[l.ISuggestDataDtoField.range]={insert:i.Range.from(qe.inserting),replace:i.Range.from(qe.replacing)}),ke}}class Ce{async provideInlineCompletions(B,j,H,J){}async provideInlineEdits(B,j,H,J){}disposeCompletions(B){}handleDidShowCompletionItem(B,j,H){}handlePartialAccept(B,j,H,J){}}class Y extends Ce{constructor(B,j,H,J){super(),this.f=B,this.g=j,this.h=H,this.j=J,this.d=new ee,this.e=(0,t.$uH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$uH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,j,H,J){const re=this.g.getDocument(B),ge=i.Position.to(j),ke=await this.h.provideInlineCompletionItems(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},J);if(!ke||J.isCancellationRequested)return;const qe=Array.isArray(ke)?ke:ke.items,xe=this.e?Array.isArray(ke)?[]:ke.commands||[]:[],rt=this.e&&!Array.isArray(ke)?ke.enableForwardStability:void 0;let st;return{pid:this.d.createReferenceId({dispose(){st?.dispose()},items:qe}),items:qe.map((ot,lt)=>{let vt;ot.command&&(st||(st=new O.$Wc),vt=this.j.toInternal(ot.command,st));const nt=ot.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:ot.filterText,range:ot.range?i.Range.from(ot.range):void 0,command:vt,idx:lt,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:xe.map(ot=>(st||(st=new O.$Wc),this.j.toInternal(ot,st))),suppressSuggestions:!1,enableForwardStability:rt}}async provideInlineEdits(B,j,H,J){if(!this.h.provideInlineEdits)return;(0,t.$vH)(this.f,"inlineCompletionsAdditions");const re=this.g.getDocument(B),ge=i.Range.to(j),ke=await this.h.provideInlineEdits(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind],userPrompt:H.userPrompt},J);if(!ke||J.isCancellationRequested)return;const qe=Array.isArray(ke)?ke:ke.items,xe=this.e?Array.isArray(ke)?[]:ke.commands||[]:[],rt=this.e&&!Array.isArray(ke)?ke.enableForwardStability:void 0;let st;return{pid:this.d.createReferenceId({dispose(){st?.dispose()},items:qe}),items:qe.map((ot,lt)=>{let vt;ot.command&&(st||(st=new O.$Wc),vt=this.j.toInternal(ot.command,st));const nt=ot.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:ot.filterText,range:ot.range?i.Range.from(ot.range):void 0,command:vt,idx:lt,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:xe.map(ot=>(st||(st=new O.$Wc),this.j.toInternal(ot,st))),suppressSuggestions:!1,enableForwardStability:rt}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,j,H){const J=this.d.get(B)?.items[j];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,H)}handlePartialAccept(B,j,H,J){const re=this.d.get(B)?.items[j];re&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(re,H),this.h.handleDidPartiallyAcceptCompletionItem(re,i.PartialAcceptInfo.to(J)))}}class W{async provideInlineEdits(B,j,H){const J=this.f.getDocument(B),re=await this.g.provideInlineEdit(J,{triggerKind:this.e[j.triggerKind]},H);if(!re||H.isCancellationRequested)return;let ge;const ke=this.d.createReferenceId({dispose(){ge?.dispose()},item:re});let qe;re.accepted&&(ge||(ge=new O.$Wc),qe=this.h.toInternal(re.accepted,ge));let xe;return re.rejected&&(ge||(ge=new O.$Wc),xe=this.h.toInternal(re.rejected,ge)),{pid:ke,text:re.text,range:i.Range.from(re.range),accepted:qe,rejected:xe}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,j,H,J){this.f=j,this.g=H,this.h=J,this.d=new ee,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class ee{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const j=this.e++;return this.d.set(j,B),j}disposeReferenceId(B){const j=this.d.get(B);return this.d.delete(B),j}get(B){return this.d.get(B)}}class be{constructor(B,j){this.e=B,this.f=j,this.d=new o.$nqc("SignatureHelp")}async provideSignatureHelp(B,j,H,J){const re=this.e.getDocument(B),ge=i.Position.to(j),ke=this.g(H),qe=await this.f.provideSignatureHelp(re,ge,J,ke);if(qe){const xe=this.d.add([qe]);return{...i.SignatureHelp.from(qe),id:xe}}}g(B){let j;if(B.activeSignatureHelp){const H=i.SignatureHelp.to(B.activeSignatureHelp),J=this.d.get(B.activeSignatureHelp.id,0);J?(j=J,j.activeSignature=H.activeSignature,j.activeParameter=H.activeParameter):j=H}return{...B,activeSignatureHelp:j}}releaseSignatureHelp(B){this.d.delete(B)}}class Pe{constructor(B,j,H,J,re){this.f=B,this.g=j,this.h=H,this.j=J,this.k=re,this.d=new o.$nqc("InlayHints"),this.e=new Map}async provideInlayHints(B,j,H){const J=this.f.getDocument(B),re=i.Range.to(j),ge=await this.h.provideInlayHints(J,re,H);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(H.isCancellationRequested)return;const ke=this.d.add(ge);this.e.set(ke,new O.$Wc);const qe={hints:[],cacheId:ke};for(let xe=0;xe<ge.length;xe++)this.l(ge[xe],re)&&qe.hints.push(this.m(ge[xe],[ke,xe]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),qe}async resolveInlayHint(B,j){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...B);if(!H)return;const J=await this.h.resolveInlayHint(H,j);if(J&&this.l(J))return this.m(J,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,j){return B.label.length===0||Array.isArray(B.label)&&B.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(j&&!j.contains(B.position))}m(B,j){const H=this.e.get(j[0]);if(!H)throw Error("DisposableStore is missing...");const J={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(B.tooltip),position:i.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(i.TextEdit.from),kind:B.kind&&i.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")J.label=B.label;else{const re=[];J.label=re;for(const ge of B.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ke={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$gO.isLocation(ge.location)&&(ke.location=i.location.from(ge.location)),ge.command&&(ke.command=this.g.toInternal(ge.command,H)),re.push(ke)}}return J}}class je{constructor(B,j){this.e=B,this.f=j,this.d=new o.$nqc("DocumentLink")}async provideLinks(B,j){const H=this.e.getDocument(B),J=await this.f.provideDocumentLinks(H,j);if(!(!Array.isArray(J)||J.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(je.g).map(i.DocumentLink.from)};{const re=this.d.add(J),ge={links:[],cacheId:re};for(let ke=0;ke<J.length;ke++){if(!je.g(J[ke]))continue;const qe=i.DocumentLink.from(J[ke]);qe.cacheId=[re,ke],ge.links.push(qe)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,j){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...B);if(!H)return;const J=await this.f.resolveDocumentLink(H,j);if(!(!J||!je.g(J)))return i.DocumentLink.from(J)}releaseLinks(B){this.d.delete(B)}}class Te{constructor(B,j){this.d=B,this.e=j}async provideColors(B,j){const H=this.d.getDocument(B),J=await this.e.provideDocumentColors(H,j);return Array.isArray(J)?J.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(B,j,H){const J=this.d.getDocument(B),re=i.Range.to(j.range),ge=i.Color.to(j.color),ke=await this.e.provideColorPresentations(ge,{document:J,range:re},H);if(Array.isArray(ke))return ke.map(i.ColorPresentation.from)}}class Ee{constructor(B,j){this.d=B,this.e=j}async provideFoldingRanges(B,j,H){const J=this.d.getDocument(B),re=await this.e.provideFoldingRanges(J,j,H);if(Array.isArray(re))return re.map(i.FoldingRange.from)}}class Fe{constructor(B,j,H){this.d=B,this.e=j,this.f=H}async provideSelectionRanges(B,j,H){const J=this.d.getDocument(B),re=j.map(i.Position.to),ge=await this.e.provideSelectionRanges(J,re,H);if(!(0,y.$Nb)(ge))return[];if(ge.length!==re.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ke=[];for(let qe=0;qe<re.length;qe++){const xe=[];ke.push(xe);let rt=re[qe],st=ge[qe];for(;;){if(!st.range.contains(rt))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(i.SelectionRange.from(st)),!st.parent)break;rt=st.range,st=st.parent}}return ke}}class Ve{constructor(B,j){this.f=B,this.g=j,this.d=new T.$IQ(""),this.e=new Map}async prepareSession(B,j,H){const J=this.f.getDocument(B),re=i.Position.to(j),ge=await this.g.prepareCallHierarchy(J,re,H);if(!ge)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(ge)?ge.map(qe=>this.h(ke,qe)):[this.h(ke,ge)]}async provideCallsTo(B,j,H){const J=this.j(B,j);if(!J)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyIncomingCalls(J,H);if(re)return re.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ke=>i.Range.from(ke))}))}async provideCallsFrom(B,j,H){const J=this.j(B,j);if(!J)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyOutgoingCalls(J,H);if(re)return re.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ke=>i.Range.from(ke))}))}releaseSession(B){this.e.delete(B)}h(B,j){const H=this.e.get(B),J=i.CallHierarchyItem.from(j,B,H.size.toString(36));return H.set(J._itemId,j),J}j(B,j){return this.e.get(B)?.get(j)}}class Ge{constructor(B,j){this.f=B,this.g=j,this.d=new T.$IQ(""),this.e=new Map}async prepareSession(B,j,H){const J=this.f.getDocument(B),re=i.Position.to(j),ge=await this.g.prepareTypeHierarchy(J,re,H);if(!ge)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(ge)?ge.map(qe=>this.h(ke,qe)):[this.h(ke,ge)]}async provideSupertypes(B,j,H){const J=this.j(B,j);if(!J)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySupertypes(J,H);if(re)return re.map(ge=>this.h(B,ge))}async provideSubtypes(B,j,H){const J=this.j(B,j);if(!J)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySubtypes(J,H);if(re)return re.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,j){const H=this.e.get(B),J=i.TypeHierarchyItem.from(j,B,H.size.toString(36));return H.set(J._itemId,j),J}j(B,j){return this.e.get(B)?.get(j)}}class et{constructor(B,j,H,J,re){this.e=B,this.f=j,this.g=H,this.h=J,this.j=re,this.d=new o.$nqc("DocumentDropEdit")}async provideDocumentOnDropEdits(B,j,H,J,re){const ge=this.f.getDocument(j),ke=i.Position.to(H),qe=i.DataTransfer.toDataTransfer(J,async ut=>(await this.e.$resolveDocumentOnDropFileData(this.h,B,ut)).buffer),xe=await this.g.provideDocumentDropEdits(ge,ke,qe,re);if(!xe)return;const rt=(0,y.$4b)(xe),st=this.d.add(rt);return rt.map((ut,ot)=>({_cacheId:[st,ot],title:ut.title??(0,c.localize)(2702,null,this.j.displayName||this.j.name),kind:ut.kind?.value,yieldTo:ut.yieldTo?.map(lt=>lt.value),insertText:typeof ut.insertText=="string"?ut.insertText:{snippet:ut.insertText.value},additionalEdit:ut.additionalEdit?i.WorkspaceEdit.from(ut.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,j){const[H,J]=B,re=this.d.get(H,J);if(!re||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(B){this.d.delete(B)}}class it{constructor(B,j){this.d=B,this.e=j}async provideMappedEdits(B,j,H,J){const re=h.URI.revive(B),ge=this.d.getDocument(re),ke=H.documents.map(rt=>rt.map(st=>({uri:h.URI.revive(st.uri),version:st.version,ranges:st.ranges.map(ut=>i.Range.to(ut))}))),qe={documents:ke,selections:ke[0]?.[0]?.ranges??[]},xe=await this.e.provideMappedEdits(ge,j,qe,J);return xe?i.WorkspaceEdit.from(xe):null}}class Me{constructor(B,j){this.adapter=B,this.extension=j}}class Ue{static{this.d=0}constructor(B,j,H,J,re,ge,ke,qe){this.g=j,this.h=H,this.j=J,this.k=re,this.l=ge,this.m=ke,this.n=qe,this.f=new Map,this.e=B.getProxy(l.$3N.MainThreadLanguageFeatures)}o(B,j){return i.DocumentSelector.from(B,this.g,j)}p(B){return new n.$5N(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Ue.d++}async s(B,j,H,J,re,ge=!1){const ke=this.f.get(B);if(!ke||!(ke.adapter instanceof j))return J;const qe=Date.now();ge||this.l.trace(`[${ke.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const xe=H(ke.adapter,ke.extension);return Promise.resolve(xe).catch(rt=>{(0,N.$6)(rt)||(this.l.error(`[${ke.extension.identifier.value}] provider FAILED`),this.l.error(rt),this.n.onExtensionError(ke.extension.identifier,rt))}).finally(()=>{ge||this.l.trace(`[${ke.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),C.CancellationToken.isCancellationToken(re)?(0,D.$xh)(xe,re):xe}t(B,j){const H=this.q();return this.f.set(H,new Me(B,j)),H}static u(B){return B.displayName||B.name}static w(B){return B.identifier.value}registerDocumentSymbolProvider(B,j,H,J){const re=this.t(new m(this.h,H),B),ge=J&&J.label||Ue.u(B);return this.e.$registerDocumentSymbolProvider(re,this.o(j,B),ge),this.p(re)}$provideDocumentSymbols(B,j,H){return this.s(B,m,J=>J.provideDocumentSymbols(h.URI.revive(j),H),void 0,H)}registerCodeLensProvider(B,j,H){const J=this.q(),re=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Me(new g(this.h,this.j.converter,H,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(J,this.o(j,B),re);let ge=this.p(J);if(re!==void 0){const ke=H.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(re));ge=n.$5N.from(ge,ke)}return ge}$provideCodeLenses(B,j,H){return this.s(B,g,J=>J.provideCodeLenses(h.URI.revive(j),H),void 0,H)}$resolveCodeLens(B,j,H){return this.s(B,g,J=>J.resolveCodeLens(j,H),void 0,void 0)}$releaseCodeLenses(B,j){this.s(B,g,H=>Promise.resolve(H.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(B,j,H){const J=this.t(new S(this.h,H),B);return this.e.$registerDefinitionSupport(J,this.o(j,B)),this.p(J)}$provideDefinition(B,j,H,J){return this.s(B,S,re=>re.provideDefinition(h.URI.revive(j),H,J),[],J)}registerDeclarationProvider(B,j,H){const J=this.t(new k(this.h,H),B);return this.e.$registerDeclarationSupport(J,this.o(j,B)),this.p(J)}$provideDeclaration(B,j,H,J){return this.s(B,k,re=>re.provideDeclaration(h.URI.revive(j),H,J),[],J)}registerImplementationProvider(B,j,H){const J=this.t(new w(this.h,H),B);return this.e.$registerImplementationSupport(J,this.o(j,B)),this.p(J)}$provideImplementation(B,j,H,J){return this.s(B,w,re=>re.provideImplementation(h.URI.revive(j),H,J),[],J)}registerTypeDefinitionProvider(B,j,H){const J=this.t(new P(this.h,H),B);return this.e.$registerTypeDefinitionSupport(J,this.o(j,B)),this.p(J)}$provideTypeDefinition(B,j,H,J){return this.s(B,P,re=>re.provideTypeDefinition(h.URI.revive(j),H,J),[],J)}registerHoverProvider(B,j,H,J){const re=this.t(new R(this.h,H),B);return this.e.$registerHoverProvider(re,this.o(j,B)),this.p(re)}$provideHover(B,j,H,J,re){return this.s(B,R,ge=>ge.provideHover(h.URI.revive(j),H,J,re),void 0,re)}$releaseHover(B,j){this.s(B,R,H=>Promise.resolve(H.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(B,j,H,J){const re=this.t(new $(this.h,H),B);return this.e.$registerEvaluatableExpressionProvider(re,this.o(j,B)),this.p(re)}$provideEvaluatableExpression(B,j,H,J){return this.s(B,$,re=>re.provideEvaluatableExpression(h.URI.revive(j),H,J),void 0,J)}registerInlineValuesProvider(B,j,H,J){const re=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new b(this.h,H),B);this.e.$registerInlineValuesProvider(ge,this.o(j,B),re);let ke=this.p(ge);if(re!==void 0){const qe=H.onDidChangeInlineValues(xe=>this.e.$emitInlineValuesEvent(re));ke=n.$5N.from(ke,qe)}return ke}$provideInlineValues(B,j,H,J,re){return this.s(B,b,ge=>ge.provideInlineValues(h.URI.revive(j),H,J,re),void 0,re)}registerDocumentHighlightProvider(B,j,H){const J=this.t(new L(this.h,H),B);return this.e.$registerDocumentHighlightProvider(J,this.o(j,B)),this.p(J)}registerMultiDocumentHighlightProvider(B,j,H){const J=this.t(new A(this.h,H),B);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(j,B)),this.p(J)}$provideDocumentHighlights(B,j,H,J){return this.s(B,L,re=>re.provideDocumentHighlights(h.URI.revive(j),H,J),void 0,J)}$provideMultiDocumentHighlights(B,j,H,J,re){return this.s(B,A,ge=>ge.provideMultiDocumentHighlights(h.URI.revive(j),H,J.map(ke=>h.URI.revive(ke)),re),void 0,re)}registerLinkedEditingRangeProvider(B,j,H){const J=this.t(new M(this.h,H),B);return this.e.$registerLinkedEditingRangeProvider(J,this.o(j,B)),this.p(J)}$provideLinkedEditingRanges(B,j,H,J){return this.s(B,M,async re=>{const ge=await re.provideLinkedEditingRanges(h.URI.revive(j),H,J);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Ue.y(ge.wordPattern):void 0}},void 0,J)}registerReferenceProvider(B,j,H){const J=this.t(new Z(this.h,H),B);return this.e.$registerReferenceSupport(J,this.o(j,B)),this.p(J)}$provideReferences(B,j,H,J,re){return this.s(B,Z,ge=>ge.provideReferences(h.URI.revive(j),H,J,re),void 0,re)}registerCodeActionProvider(B,j,H,J){const re=new O.$Wc,ge=this.t(new G(this.h,this.j.converter,this.k,H,this.l,B,this.m),B);return this.e.$registerCodeActionSupport(ge,this.o(j,B),{providedKinds:J?.providedCodeActionKinds?.map(ke=>ke.value),documentation:J?.documentation?.map(ke=>({kind:ke.kind.value,command:this.j.converter.toInternal(ke.command,re)}))},Ue.u(B),Ue.w(B),!!H.resolveCodeAction),re.add(this.p(ge)),re}$provideCodeActions(B,j,H,J,re){return this.s(B,G,ge=>ge.provideCodeActions(h.URI.revive(j),H,J,re),void 0,re)}$resolveCodeAction(B,j,H){return this.s(B,G,J=>J.resolveCodeAction(j,H),{},void 0)}$releaseCodeActions(B,j){this.s(B,G,H=>Promise.resolve(H.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(B,j,H){const J=this.t(new V(this.h,H),B);return this.e.$registerDocumentFormattingSupport(J,this.o(j,B),B.identifier,B.displayName||B.name),this.p(J)}$provideDocumentFormattingEdits(B,j,H,J){return this.s(B,V,re=>re.provideDocumentFormattingEdits(h.URI.revive(j),H,J),void 0,J)}registerDocumentRangeFormattingEditProvider(B,j,H){const J=typeof H.provideDocumentRangesFormattingEdits=="function",re=this.t(new Q(this.h,H),B);return this.e.$registerRangeFormattingSupport(re,this.o(j,B),B.identifier,B.displayName||B.name,J),this.p(re)}$provideDocumentRangeFormattingEdits(B,j,H,J,re){return this.s(B,Q,ge=>ge.provideDocumentRangeFormattingEdits(h.URI.revive(j),H,J,re),void 0,re)}$provideDocumentRangesFormattingEdits(B,j,H,J,re){return this.s(B,Q,ge=>ge.provideDocumentRangesFormattingEdits(h.URI.revive(j),H,J,re),void 0,re)}registerOnTypeFormattingEditProvider(B,j,H,J){const re=this.t(new ne(this.h,H),B);return this.e.$registerOnTypeFormattingSupport(re,this.o(j,B),J,B.identifier),this.p(re)}$provideOnTypeFormattingEdits(B,j,H,J,re,ge){return this.s(B,ne,ke=>ke.provideOnTypeFormattingEdits(h.URI.revive(j),H,J,re,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,j){const H=this.t(new ue(j,this.l),B);return this.e.$registerNavigateTypeSupport(H,typeof j.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(B,j,H){return this.s(B,ue,J=>J.provideWorkspaceSymbols(j,H),{symbols:[]},H)}$resolveWorkspaceSymbol(B,j,H){return this.s(B,ue,J=>J.resolveWorkspaceSymbol(j,H),void 0,void 0)}$releaseWorkspaceSymbols(B,j){this.s(B,ue,H=>H.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(B,j,H){const J=this.t(new x(this.h,H,this.l),B);return this.e.$registerRenameSupport(J,this.o(j,B),x.supportsResolving(H)),this.p(J)}$provideRenameEdits(B,j,H,J,re){return this.s(B,x,ge=>ge.provideRenameEdits(h.URI.revive(j),H,J,re),void 0,re)}$resolveRenameLocation(B,j,H,J){return this.s(B,x,re=>re.resolveRenameLocation(h.URI.revive(j),H,J),void 0,J)}registerNewSymbolNamesProvider(B,j,H){const J=this.t(new oe(this.h,H,this.l),B);return this.e.$registerNewSymbolNamesProvider(J,this.o(j,B)),this.p(J)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this.s(B,oe,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,j,H,J,re){return this.s(B,oe,ge=>ge.provideNewSymbolNames(h.URI.revive(j),H,J,re),void 0,re)}registerDocumentSemanticTokensProvider(B,j,H,J){const re=this.t(new ce(this.h,H),B),ge=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(re,this.o(j,B),J,ge);let ke=this.p(re);if(ge){const qe=H.onDidChangeSemanticTokens(xe=>this.e.$emitDocumentSemanticTokensEvent(ge));ke=n.$5N.from(ke,qe)}return ke}$provideDocumentSemanticTokens(B,j,H,J){return this.s(B,ce,re=>re.provideDocumentSemanticTokens(h.URI.revive(j),H,J),null,J)}$releaseDocumentSemanticTokens(B,j){this.s(B,ce,H=>H.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,j,H,J){const re=this.t(new te(this.h,H),B);return this.e.$registerDocumentRangeSemanticTokensProvider(re,this.o(j,B),J),this.p(re)}$provideDocumentRangeSemanticTokens(B,j,H,J){return this.s(B,te,re=>re.provideDocumentRangeSemanticTokens(h.URI.revive(j),H,J),null,J)}registerCompletionItemProvider(B,j,H,J){const re=this.t(new we(this.h,this.j.converter,H,this.m,B),B);return this.e.$registerCompletionsProvider(re,this.o(j,B),J,we.supportsResolving(H),B.identifier),this.p(re)}$provideCompletionItems(B,j,H,J,re){return this.s(B,we,ge=>ge.provideCompletionItems(h.URI.revive(j),H,J,re),void 0,re)}$resolveCompletionItem(B,j,H){return this.s(B,we,J=>J.resolveCompletionItem(j,H),void 0,H)}$releaseCompletionItems(B,j){this.s(B,we,H=>H.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(B,j,H,J){const re=new Y(B,this.h,H,this.j.converter),ge=this.t(re,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(j,B),re.supportsHandleEvents,u.$un.toKey(B.identifier.value),J?.yieldTo?.map(ke=>u.$un.toKey(ke))||[]),this.p(ge)}$provideInlineCompletions(B,j,H,J,re){return this.s(B,Ce,ge=>ge.provideInlineCompletions(h.URI.revive(j),H,J,re),void 0,re)}$provideInlineEdits(B,j,H,J,re){return this.s(B,Ce,ge=>ge.provideInlineEdits(h.URI.revive(j),H,J,re),void 0,re)}$handleInlineCompletionDidShow(B,j,H,J){this.s(B,Ce,async re=>{re.handleDidShowCompletionItem(j,H,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,j,H,J,re){this.s(B,Ce,async ge=>{ge.handlePartialAccept(j,H,J,re)},void 0,void 0)}$freeInlineCompletionsList(B,j){this.s(B,Ce,async H=>{H.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(B,j,H){const J=new W(B,this.h,H,this.j.converter),re=this.t(J,B);return this.e.$registerInlineEditProvider(re,this.o(j,B),B.identifier),this.p(re)}$provideInlineEdit(B,j,H,J){return this.s(B,W,re=>re.provideInlineEdits(h.URI.revive(j),H,J),void 0,J)}$freeInlineEdit(B,j){this.s(B,W,async H=>{H.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(B,j,H,J){const re=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,ge=this.t(new be(this.h,H),B);return this.e.$registerSignatureHelpProvider(ge,this.o(j,B),re),this.p(ge)}$provideSignatureHelp(B,j,H,J,re){return this.s(B,be,ge=>ge.provideSignatureHelp(h.URI.revive(j),H,J,re),void 0,re)}$releaseSignatureHelp(B,j){this.s(B,be,H=>H.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(B,j,H){const J=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,re=this.t(new Pe(this.h,this.j.converter,H,this.l,B),B);this.e.$registerInlayHintsProvider(re,this.o(j,B),typeof H.resolveInlayHint=="function",J,Ue.u(B));let ge=this.p(re);if(J!==void 0){const ke=H.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(J));ge=n.$5N.from(ge,ke)}return ge}$provideInlayHints(B,j,H,J){return this.s(B,Pe,re=>re.provideInlayHints(h.URI.revive(j),H,J),void 0,J)}$resolveInlayHint(B,j,H){return this.s(B,Pe,J=>J.resolveInlayHint(j,H),void 0,H)}$releaseInlayHints(B,j){this.s(B,Pe,H=>H.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(B,j,H){const J=this.t(new je(this.h,H),B);return this.e.$registerDocumentLinkProvider(J,this.o(j,B),typeof H.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(B,j,H){return this.s(B,je,J=>J.provideLinks(h.URI.revive(j),H),void 0,H,j.scheme==="output")}$resolveDocumentLink(B,j,H){return this.s(B,je,J=>J.resolveLink(j,H),void 0,void 0,!0)}$releaseDocumentLinks(B,j){this.s(B,je,H=>H.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(B,j,H){const J=this.t(new Te(this.h,H),B);return this.e.$registerDocumentColorProvider(J,this.o(j,B)),this.p(J)}$provideDocumentColors(B,j,H){return this.s(B,Te,J=>J.provideColors(h.URI.revive(j),H),[],H)}$provideColorPresentations(B,j,H,J){return this.s(B,Te,re=>re.provideColorPresentations(h.URI.revive(j),H,J),void 0,J)}registerFoldingRangeProvider(B,j,H){const J=this.q(),re=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Me(new Ee(this.h,H),B)),this.e.$registerFoldingRangeProvider(J,this.o(j,B),B.identifier,re);let ge=this.p(J);if(re!==void 0){const ke=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(re));ge=n.$5N.from(ge,ke)}return ge}$provideFoldingRanges(B,j,H,J){return this.s(B,Ee,re=>re.provideFoldingRanges(h.URI.revive(j),H,J),void 0,J)}registerSelectionRangeProvider(B,j,H){const J=this.t(new Fe(this.h,H,this.l),B);return this.e.$registerSelectionRangeProvider(J,this.o(j,B)),this.p(J)}$provideSelectionRanges(B,j,H,J){return this.s(B,Fe,re=>re.provideSelectionRanges(h.URI.revive(j),H,J),[],J)}registerCallHierarchyProvider(B,j,H){const J=this.t(new Ve(this.h,H),B);return this.e.$registerCallHierarchyProvider(J,this.o(j,B)),this.p(J)}$prepareCallHierarchy(B,j,H,J){return this.s(B,Ve,re=>Promise.resolve(re.prepareSession(h.URI.revive(j),H,J)),void 0,J)}$provideCallHierarchyIncomingCalls(B,j,H,J){return this.s(B,Ve,re=>re.provideCallsTo(j,H,J),void 0,J)}$provideCallHierarchyOutgoingCalls(B,j,H,J){return this.s(B,Ve,re=>re.provideCallsFrom(j,H,J),void 0,J)}$releaseCallHierarchy(B,j){this.s(B,Ve,H=>Promise.resolve(H.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(B,j,H){const J=this.t(new Ge(this.h,H),B);return this.e.$registerTypeHierarchyProvider(J,this.o(j,B)),this.p(J)}$prepareTypeHierarchy(B,j,H,J){return this.s(B,Ge,re=>Promise.resolve(re.prepareSession(h.URI.revive(j),H,J)),void 0,J)}$provideTypeHierarchySupertypes(B,j,H,J){return this.s(B,Ge,re=>re.provideSupertypes(j,H,J),void 0,J)}$provideTypeHierarchySubtypes(B,j,H,J){return this.s(B,Ge,re=>re.provideSubtypes(j,H,J),void 0,J)}$releaseTypeHierarchy(B,j){this.s(B,Ge,H=>Promise.resolve(H.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(B,j,H,J){const re=this.q();return this.f.set(re,new Me(new et(this.e,this.h,H,re,B),B)),this.e.$registerDocumentOnDropEditProvider(re,this.o(j,B),(0,t.$uH)(B,"documentPaste")&&J?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(re)}$provideDocumentOnDropEdits(B,j,H,J,re,ge){return this.s(B,et,ke=>Promise.resolve(ke.provideDocumentOnDropEdits(j,h.URI.revive(H),J,re,ge)),void 0,void 0)}$resolveDropEdit(B,j,H){return this.s(B,et,J=>J.resolveDropEdit(j,H),{},void 0)}$releaseDocumentOnDropEdits(B,j){this.s(B,et,H=>Promise.resolve(H.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(B,j,H){const J=this.t(new it(this.h,H),B);return this.e.$registerMappedEditsProvider(J,this.o(j,B),B.displayName??B.name),this.p(J)}$provideMappedEdits(B,j,H,J,re){return this.s(B,it,ge=>Promise.resolve(ge.provideMappedEdits(j,H,J,re)),null,re)}registerDocumentPasteEditProvider(B,j,H,J){const re=this.q();return this.f.set(re,new Me(new U(this.e,this.h,H,re,B),B)),this.e.$registerPasteEditProvider(re,this.o(j,B),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(re)}$prepareDocumentPaste(B,j,H,J,re){return this.s(B,U,ge=>ge.prepareDocumentPaste(h.URI.revive(j),H,J,re),void 0,re)}$providePasteEdits(B,j,H,J,re,ge,ke){return this.s(B,U,qe=>qe.providePasteEdits(j,h.URI.revive(H),J,re,ge,ke),void 0,ke)}$resolvePasteEdit(B,j,H){return this.s(B,U,J=>J.resolvePasteEdit(j,H),{},void 0)}$releasePasteEdits(B,j){this.s(B,U,H=>Promise.resolve(H.releasePasteEdits(j)),void 0,void 0)}static y(B){return{pattern:B.source,flags:B.flags}}static z(B){return{decreaseIndentPattern:Ue.y(B.decreaseIndentPattern),increaseIndentPattern:Ue.y(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Ue.y(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Ue.y(B.unIndentedLinePattern):void 0}}static B(B){return{beforeText:Ue.y(B.beforeText),afterText:B.afterText?Ue.y(B.afterText):void 0,previousLineText:B.previousLineText?Ue.y(B.previousLineText):void 0,action:B.action}}static C(B){return B.map(Ue.B)}static D(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(j=>n.SyntaxTokenType.toString(j)):void 0}}static E(B){return B.map(Ue.D)}setLanguageConfiguration(B,j,H){const{wordPattern:J}=H;if(J&&(0,I.$uf)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(j,J):this.h.setWordDefinitionFor(j,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const re=this.q(),ge={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Ue.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Ue.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Ue.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Ue.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(re,j,ge),this.p(re)}$setWordDefinitions(B){for(const j of B)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$xqc=Ue}),define(Oe[244],Ae([1,0,4,33,5,8]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7rc=void 0,N=He(N);class T{constructor(p){this.a=new Map,this.c=new Map,this.b=p.getProxy(C.$3N.MainThreadLanguageModelTools),this.b.$getTools().then(s=>{for(const I of s)this.c.set(I.id,(0,D.$fi)(I))})}async invokeTool(p,s,I){const v=await this.b.$invokeTool(p,s,I);return N.LanguageModelToolResult.to(v)}async $acceptToolDelta(p){p.added&&this.c.set(p.added.id,p.added),p.removed&&this.c.delete(p.removed)}get tools(){return Array.from(this.c.values()).map(p=>N.LanguageModelToolDescription.to(p))}async $invokeTool(p,s,I){const v=this.a.get(p);if(!v)throw new Error(`Unknown tool ${p}`);const h=await v.tool.invoke(s,I);return N.LanguageModelToolResult.from(h)}registerTool(p,s,I){return this.a.set(s,{extension:p,tool:I}),this.b.$registerTool(s),(0,y.$Vc)(()=>{this.a.delete(s),this.b.$unregisterTool(s)})}}e.$7rc=T}),define(Oe[95],Ae([1,0,10,19,42,13,6,40,4,9,18,3,11,77,5,91,16,8,7,119,24]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=void 0,c=He(c),u=He(u),e.$erc=(0,v.$Ii)("IExtHostLanguageModels");class o{constructor(d,S){this.option=d,this.stream=new y.$_h,this.stream=S??new y.$_h}}class l{constructor(){this.a=new Map,this.b=new y.$_h,this.c=!1;const d=this;this.apiObject={get stream(){return d.b.asyncIterable},get text(){return y.$9h.map(d.b.asyncIterable,S=>{if(S instanceof u.$nQ)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;let S=this.a.get(d.index);S||(this.a.size===0?S=new o(d.index,this.b):S=new o(d.index),this.a.set(d.index,S));let k;d.part.type==="text"?k=new u.$nQ(d.part.value):k=new u.$mQ(d.part.name,d.part.parameters),S.stream.emitOne(k)}reject(d){this.c=!0;for(const S of this.d())S.reject(d)}resolve(){this.c=!0;for(const d of this.d())d.resolve()}}let m=class{static{t=this}static{this.a=1}constructor(d,S,k){this.j=S,this.k=k,this.c=new T.$oe,this.d=new T.$oe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$wn,this.i=new Map,this.s=new Set,this.b=d.getProxy(f.$3N.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,S,k,w){const P=t.a++;this.f.set(P,{extension:d.identifier,provider:k,languageModelId:S});let R;w.auth&&(R={providerLabel:d.displayName||d.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(P,`${I.$un.toKey(d.identifier)}/${P}/${S}`,{extension:d.identifier,id:S,vendor:w.vendor??I.$un.toKey(d.identifier),name:w.name??"",family:w.family??"",version:w.version,maxInputTokens:w.maxInputTokens,maxOutputTokens:w.maxOutputTokens,auth:R,targetExtensions:w.extensions});const $=k.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:L,tokenCount:A})=>{this.b.$whenLanguageModelChatRequestMade(S,new I.$un(b),L,A)});return(0,p.$Vc)(()=>{this.f.delete(P),this.b.$unregisterProvider(P),$?.dispose()})}async $startChatRequest(d,S,k,w,P,R){const $=this.f.get(d);if(!$)throw new Error("Provider not found");const b=new E.$Fw(async A=>{if(R.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let M;if(A.part instanceof u.$mQ?M={type:"function_use",name:A.part.name,parameters:A.part.parameters}:A.part instanceof u.$nQ&&(M={type:"text",value:A.part.value}),!M){this.j.warn(`[CHAT](${$.extension.value}) UNKNOWN part ${JSON.stringify(A)}`);return}this.b.$reportResponsePart(S,{index:A.index,part:M})});let L;if($.provider.provideLanguageModelResponse2)L=Promise.resolve($.provider.provideLanguageModelResponse2(w.map(c.LanguageModelChatMessage.to),P,I.$un.toKey(k),b,R));else{const A=new E.$Fw(async M=>{b.report({index:M.index,part:new u.$nQ(M.part)})});L=Promise.resolve($.provider.provideLanguageModelResponse(w.map(c.LanguageModelChatMessage.to),P?.modelOptions??{},I.$un.toKey(k),A,R))}L.then(()=>{this.b.$reportResponseDone(S,void 0)},A=>{this.b.$reportResponseDone(S,(0,N.$4)(A))})}$provideTokenLength(d,S,k){const w=this.f.get(d);return w?Promise.resolve(w.provider.provideTokenCount(S,k)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:S,metadata:k}of d.added)this.g.set(S,{metadata:k,apiObjects:new I.$wn});if(d.removed)for(const S of d.removed){this.g.delete(S);for(const[k,w]of this.i)w.languageModelId===S&&(w.res.reject(new N.$7),this.i.delete(k))}d.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,S){const k=await this.b.$selectChatModels({...S,extension:d.identifier}),w=[],P=this;for(const R of k){const $=this.g.get(R);if(!$)continue;this.o(d.identifier,$.metadata)&&await this.q($.metadata);let b=$.apiObjects.get(d.identifier);b||(b={id:R,vendor:$.metadata.vendor,family:$.metadata.family,version:$.metadata.version,name:$.metadata.name,maxInputTokens:$.metadata.maxInputTokens,countTokens(L,A){if(!P.g.has(R))throw u.$rQ.NotFound(R);return P.r(R,L,A??D.CancellationToken.None)},sendRequest(L,A,M){if(!P.g.has(R))throw u.$rQ.NotFound(R);return P.l(d,R,L,A??{},M??D.CancellationToken.None)}},Object.freeze(b),$.apiObjects.set(d.identifier,b)),w.push(b)}return w}async l(d,S,k,w,P){const R=this.m(d,k),$=d.identifier,b=this.g.get(S)?.metadata;if(!b||!this.g.has(S))throw u.$rQ.NotFound(`Language model '${S}' is unknown.`);if(this.o($,b)&&(!await this.n(d,{identifier:b.extension,displayName:b.auth.providerLabel},w.justification,!1)||!this.h.get($)?.has(b.extension)))throw u.$rQ.NoPermissions(`Language model '${S}' cannot be used by '${$.value}'.`);try{const L=Math.random()*1e6|0,A=new l;this.i.set(L,{languageModelId:S,res:A});try{await this.b.$tryStartChatRequest($,S,L,R,w,P)}catch(M){throw this.i.delete(L),M}return A.apiObject}catch(L){throw L.name===u.$rQ.name?L:new u.$rQ(`Language model '${S}' errored: ${(0,C.$tj)(L)}`,"Unknown",L)}}m(d,S){const k=[];for(const w of S)w.role===u.LanguageModelChatMessageRole.System&&(0,n.$vH)(d,"languageModelSystem"),w.content2 instanceof u.$kQ&&(0,n.$vH)(d,"lmTools"),k.push(c.LanguageModelChatMessage.from(w));return k}async $acceptResponsePart(d,S){const k=this.i.get(d);k&&k.res.handleFragment(S)}async $acceptResponseDone(d,S){const k=this.i.get(d);k&&(this.i.delete(d),S?k.res.reject((0,N.$5)(S)):k.res.resolve())}async n(d,S,k,w){const P=i.$4M+S.identifier.value;if(await this.k.getSession(d,P,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:S.identifier,enabled:!0}]),!0;if(w)return!1;try{const $=k?(0,s.localize)(2703,null,S.displayName,k):void 0;return await this.k.getSession(d,P,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:d.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o(d,S){return!!S.auth&&!I.$un.equals(S.extension,d)}async q(d){if(d.auth)for(const S of this.s)try{await this.n(S,{identifier:d.extension,displayName:""},void 0,!0)}catch(k){this.j.error("Fake Auth request failed"),this.j.error(k)}}async r(d,S,k){if(!this.g.get(d))throw u.$rQ.NotFound(`Language model '${d}' is unknown.`);const P=O.Iterable.find(this.f.values(),R=>R.languageModelId===d);return P?P.provider.provideTokenCount(S,k):this.b.$countTokens(d,typeof S=="string"?S:c.LanguageModelChatMessage.from(S),k)}$updateModelAccesslist(d){const S=new Array;for(const{from:k,to:w,enabled:P}of d){const R=this.h.get(k)??new I.$vn;if(R.has(w)!==P){P?R.add(w):R.delete(w),this.h.set(k,R);const b={from:k,to:w};S.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(d){this.s.add(d);const S=this,k=T.Event.signal(T.Event.filter(this.c.event,P=>I.$un.equals(P.from,d.identifier))),w=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(k,w)},canSendRequest(P){let R;e:for(const[b,L]of S.g)for(const A of L.apiObjects.values())if(A===P){R=L.metadata;break e}if(!R)return;if(!S.o(d.identifier,R))return!0;const $=S.h.get(d.identifier);if($)return $.has(R.extension)}}}};e.$frc=m,e.$frc=m=t=Xe([Qe(0,a.$DQ),Qe(1,h.$dk),Qe(2,r.$zqc)],m)});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Oe[245],Ae([1,0,5,8,7,36,10,4,24]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8rc=void 0,D=He(D),N=si(N);class s{constructor(v,h,E,f){this.c=h,this.d=E,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=v.getProxy(y.$3N.MainThreadLanguages)}$acceptLanguageIds(v){this.b=v}async getLanguages(){return this.b.slice(0)}async changeLanguage(v,h){await this.a.$changeLanguage(v,h);const E=this.c.getDocumentData(v);if(!E)throw new Error(`document '${v.toString()}' NOT found`);return E.document}async tokenAtPosition(v,h){const E=v.version,f=D.Position.from(h),r=await this.a.$tokensAtPosition(v.uri,f),a={type:C.StandardTokenType.Other,range:v.getWordRangeAtPosition(h)??new C.$7N(h.line,h.character,h.line,h.character)};if(!r)return a;const c={range:D.Range.to(r.range),type:D.TokenType.to(r.type)};return!c.range.contains(h)||E!==v.version?a:c}createLanguageStatusItem(v,h,E){const f=this.f++,r=this.a,a=this.g,c=`${v.identifier.value}/${h}`;if(a.has(c))throw new Error(`LanguageStatusItem with id '${h}' ALREADY exists`);a.add(c);const u={selector:E,id:h,name:v.displayName??v.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new O.$Wc,t=()=>{if(i?.dispose(),!a.has(c)){console.warn(`LanguageStatusItem (${h}) from ${v.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,T.$Kh)(()=>{n.clear(),this.a.$setLanguageStatus(f,{id:c,name:u.name??v.displayName??v.name,source:v.displayName??v.name,selector:D.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===C.LanguageStatusSeverity.Error?N.default.Error:u.severity===C.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:u.command&&this.d.toInternal(u.command,n),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},o={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(f),a.delete(c)},get id(){return u.id},get name(){return u.name},set name(l){u.name=l,t()},get selector(){return u.selector},set selector(l){u.selector=l,t()},get text(){return u.text},set text(l){u.text=l,t()},set text2(l){(0,p.$vH)(v,"languageStatusText"),u.text=l,t()},get text2(){return(0,p.$vH)(v,"languageStatusText"),u.text},get detail(){return u.detail},set detail(l){u.detail=l,t()},get severity(){return u.severity},set severity(l){u.severity=l,t()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(l){u.accessibilityInformation=l,t()},get command(){return u.command},set command(l){u.command=l,t()},get busy(){return u.busy},set busy(l){u.busy=l,t()}};return t(),o}}e.$8rc=s}),define(Oe[246],Ae([1,0,15,2,8,7,90]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orc=e.$Nrc=void 0,C=He(C),T=He(T);class O{constructor(v,h,E,f){this.start=v,this.deletedCount=h,this.deletedItems=E,this.items=f}asApiEvent(){return{range:new N.$wP(this.start,this.start+this.deletedCount),addedCells:this.items.map(v=>v.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1}}constructor(v,h,E){this.notebook=v,this.h=h,this.j=E,this.handle=E.handle,this.uri=D.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(C.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const v=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return v.g},set mime(f){v.g=f},get outputs(){return v.a.slice(0)},get metadata(){return v.b},get executionSummary(){return v.d}};this.f=Object.freeze(E)}return this.f}setOutputs(v){this.a=v.map(C.NotebookCellOutput.to)}setOutputItems(v,h,E){const f=E.map(C.NotebookCellOutputItem.to),r=this.a.find(a=>a.id===v);if(r&&(h||(r.items.length=0),r.items.push(...f),r.items.length>1&&r.items.every(a=>T.$4L(a.mime)))){const a=new Map,c=[];r.items.forEach(u=>{let i;a.has(u.mime)?i=a.get(u.mime):(i=[],a.set(u.mime,i),c.push(u.mime)),i.push(u.data)}),r.items.length=0,c.forEach(u=>{const i=T.$5L(a.get(u));r.items.push({mime:u,data:i.data.buffer})})}}setMetadata(v){this.b=Object.freeze(v)}setInternalMetadata(v){this.e=v,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.$Nrc=p;class s{static{this.a=0}constructor(v,h,E,f,r){this.k=v,this.l=h,this.m=E,this.uri=f,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const v=this,h={get uri(){return v.uri},get version(){return v.g},get notebookType(){return v.d},get isDirty(){return v.h},get isUntitled(){return v.uri.scheme===y.Schemas.untitled},get isClosed(){return v.j},get metadata(){return v.f},get cellCount(){return v.b.length},cellAt(E){return E=v.n(E),v.b[E].apiCell},getCells(E){return(E?v.p(E):v.b).map(r=>r.apiCell)},save(){return v.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(v){v.metadata&&(this.f=Object.freeze({...this.f,...v.metadata}))}acceptDirty(v){this.h=v}acceptModelChanged(v,h,E){this.g=v.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:E});const f={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},r=[];for(const c of v.rawEvents)c.kind===T.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,f.contentChanges):c.kind===T.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,f.contentChanges):c.kind===T.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===T.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===T.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),r.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),r.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const a=new Map;for(let c=0;c<r.length;c++){const u=r[c],i=a.get(u.cell);if(i===void 0){const n=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});a.set(u.cell,n-1)}else f.cellChanges[i]={...f.cellChanges[i],...u}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(v){return v=v|0,v<0?0:v>=this.b.length?this.b.length-1:v}o(v){let h=v.start|0,E=v.end|0;return h<0&&(h=0),E>this.b.length&&(E=this.b.length),v.with({start:h,end:E})}p(v){v=this.o(v);const h=[];for(let E=v.start;E<v.end;E++)h.push(this.b[E]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(v,h,E){if(this.j)return;const f=[],r=[],a=[];if(v.reverse().forEach(c=>{const i=c[2].map(o=>{const l=new p(this,this.l,o);return h||r.push(p.asModelAddData(o)),l}),n=new O(c[0],c[1],[],i),t=this.b.splice(c[0],c[1],...i);for(const o of t)a.push(o.uri),n.deletedItems.push(o.apiCell);f.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:a}),E)for(const c of f)E.push(c.asApiEvent())}s(v,h,E,f){const r=this.b.splice(v,h);this.b.splice(E,0,...r);const a=[new O(v,h,r.map(c=>c.apiCell),[]),new O(E,0,[],r)];for(const c of a)f.push(c.asApiEvent())}t(v,h){this.b[v].setOutputs(h)}u(v,h,E,f){this.b[v].setOutputItems(h,E,f)}v(v,h){const E=this.b[v];E.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(E.uri,h)}w(v,h){const E=this.b[v];E.apiCell.mime=h}x(v,h){this.b[v].setMetadata(h)}y(v,h){this.b[v].setInternalMetadata(h)}getCellFromApiCell(v){return this.b.find(h=>h.apiCell===v)}getCellFromIndex(v){return this.b[v]}getCell(v){return this.b.find(h=>h.handle===v)}getCellIndex(v){return this.b.indexOf(v)}}e.$Orc=s}),define(Oe[247],Ae([1,0,6,2,8,7,39]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0rc=void 0;class O{constructor(s,I,v,h={timeout:1500,errors:3}){this.b=s,this.c=I,this.d=v,this.f=h,this.a=new y.$qe}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(I,v,h)=>{const E=function(r){I.call(v,r)};return E.extension=s,this.a.event(E,void 0,h)}}async $participateInSave(s,I,v){const h=D.URI.revive(s),E=this.c.getNotebookDocument(h);if(!E)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:C.TextDocumentSaveReason.to(I)},v,async(a,c)=>{const u=Date.now(),i=await await Promise.resolve(a);Date.now()-u>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!v.isCancellationRequested&&i&&(i instanceof N.$eO?f.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),v.isCancellationRequested)return!1;if(f.length===0)return!0;const r={edits:[]};for(const a of f){const{edits:c}=C.WorkspaceEdit.from(a);r.edits=r.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new T.$4w(r))}}e.$0rc=O}),define(Oe[126],Ae([1,0,13,8,7]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=void 0,D=He(D),C=He(C);class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(O,p,s,I,v,h){this.id=O,this.f=p,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=v,this.b=I,this.c=h}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(p){this.selections=[p]},get selections(){return O.a},set selections(p){if(!Array.isArray(p)||!p.every(C.$wP.isNotebookRange))throw(0,y.$9)("selections");O.a=p,O.g(p)},get visibleRanges(){return O.b},revealRange(p,s){O.f.$tryRevealRange(O.id,D.NotebookRange.from(p),s??C.NotebookEditorRevealType.Default)},get viewColumn(){return O.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(D.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.$Prc=N}),define(Oe[248],Ae([1,0,6,11,8]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=void 0,C=He(C);let N=class{constructor(O,p){this.c=O,this.d=p,this.a=new y.$oe,this.b=new y.$oe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,p);const s=this.d.getEditorById(O);p.visibleRanges&&s._acceptVisibleRanges(p.visibleRanges.ranges.map(C.NotebookRange.to)),p.selections&&s._acceptSelections(p.selections.selections.map(C.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const p in O)this.d.getEditorById(p)._acceptViewColumn(C.ViewColumn.to(O[p]))}};e.$_rc=N,e.$_rc=N=Xe([Qe(0,D.$dk)],N)}),define(Oe[249],Ae([1,0,6,5,126]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0;class N{constructor(O,p){this.c=p,this.a=new Map,this.b=O.getProxy(D.$3N.MainThreadNotebookRenderers)}$postRendererMessage(O,p,s){const I=this.c.getEditorById(O);this.a.get(p)?.fire({editor:I.apiEditor,message:s})}createRendererMessaging(O,p){if(!O.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,v,h)=>this.d(p).event(I,v,h),postMessage:(I,v)=>{C.$Prc.apiEditorsToExtHost.has(I)&&([I,v]=[v,I]);const h=v&&C.$Prc.apiEditorsToExtHost.get(v);return this.b.$postMessage(h?.id,p,I)}}}d(O){let p=this.a.get(O);return p||(p=new y.$oe({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(O)}}),this.a.set(O,p),p)}}e.$csc=N}),define(Oe[250],Ae([1,0,8,77,19,72,13]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsc=void 0;class O{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,h,E){const f=this.b++,{title:r,location:a,cancellable:c}=h,u={label:v.displayName||v.name,id:v.identifier.value};return this.a.$startProgress(f,{location:y.ProgressLocation.from(a),title:r,source:u,cancellable:c},v.isUnderDevelopment?void 0:v.identifier.value).catch(T.$3),this.d(f,E,!!c)}d(v,h,E){let f;E&&(f=new C.$ze,this.c.set(v,f));const r=c=>{this.a.$progressEnd(c),this.c.delete(c),f?.dispose()};let a;try{a=h(new s(this.a,v),E&&f?f.token:C.CancellationToken.None)}catch(c){throw r(v),c}return a.then(c=>r(v),c=>r(v)),a}$acceptProgressCanceled(v){const h=this.c.get(v);h&&(h.cancel(),this.c.delete(v))}}e.$gsc=O;function p(I,v){return I.message=v.message,typeof v.increment=="number"&&(typeof I.increment=="number"?I.increment+=v.increment:I.increment=v.increment),I}class s extends D.$Fw{constructor(v,h){super(E=>this.throttledReport(E)),this.c=v,this.d=h}throttledReport(v){this.c.$progressReport(this.d,v)}}Xe([(0,N.$ci)(100,(I,v)=>p(I,v),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Oe[251],Ae([1,0,2,5,10,8]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsc=void 0;class T{static{this.a=0}constructor(p,s){this.d=s,this.c=new Map,this.b=p.getProxy(D.$3N.MainThreadQuickDiff)}$provideOriginalResource(p,s,I){const v=y.URI.revive(s),h=this.c.get(p);return h?(0,C.$Ah)(()=>h.provideOriginalResource(v,I)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,s,I,v){const h=T.a++;return this.c.set(h,s),this.b.$registerQuickDiffProvider(h,N.DocumentSelector.from(p,this.d),I,v),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}e.$hsc=T});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Oe[252],Ae([1,0,19,6,4,5,2,7,13,17,36,35,24,8]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isc=f,I=si(I);function f(r,a,c){const u=r.getProxy(N.$3N.MainThreadQuickOpen);class i{constructor(k,w){this.e=new Map,this.f=0,this.a=k,this.b=w}showQuickPick(k,w,P,R=y.CancellationToken.None){this.c=void 0;const $=Promise.resolve(w),b=++this.f,L=u.$show(b,{title:P?.title,placeHolder:P?.placeHolder,matchOnDescription:P?.matchOnDescription,matchOnDetail:P?.matchOnDetail,ignoreFocusLost:P?.ignoreFocusOut,canPickMany:P?.canPickMany},R),A={},M=L.then(()=>A);return Promise.race([M,$]).then(Z=>{if(Z===A)return;const G=(0,h.$uH)(k,"quickPickItemTooltip");return $.then(U=>{const V=[];for(let Q=0;Q<U.length;Q++){const ne=U[Q];if(typeof ne=="string")V.push({label:ne,handle:Q});else if(ne.kind===O.QuickPickItemKind.Separator)V.push({type:"separator",label:ne.label});else{ne.tooltip&&!G&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const ue=ne.iconPath?m(ne.iconPath):void 0;V.push({label:ne.label,iconPath:ue?.iconPath,iconClass:ue?.iconClass,description:ne.description,detail:ne.detail,picked:ne.picked,alwaysShow:ne.alwaysShow,tooltip:G?E.MarkdownString.fromStrict(ne.tooltip):void 0,handle:Q})}}return P&&typeof P.onDidSelectItem=="function"&&(this.c=Q=>{P.onDidSelectItem(U[Q])}),u.$setItems(b,V),L.then(Q=>{if(typeof Q=="number")return U[Q];if(Array.isArray(Q))return Q.map(ne=>U[ne])})})}).then(void 0,Z=>{if(!(0,p.$6)(Z))return u.$setError(b,Z),Promise.reject(Z)})}$onItemSelected(k){this.c?.(k)}showInput(k,w=y.CancellationToken.None){return this.d=k?.validateInput,u.$input(k,typeof this.d=="function",w).then(void 0,P=>{if(!(0,p.$6)(P))return Promise.reject(P)})}async $validateInput(k){if(!this.d)return;const w=await this.d(k);if(!w||typeof w=="string")return w;let P;switch(w.severity){case O.InputBoxValidationSeverity.Info:P=I.default.Info;break;case O.InputBoxValidationSeverity.Warning:P=I.default.Warning;break;case O.InputBoxValidationSeverity.Error:P=I.default.Error;break;default:P=w.message?I.default.Error:I.default.Ignore;break}return{content:w.message,severity:P}}async showWorkspaceFolderPick(k,w=y.CancellationToken.None){const P=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!P)return;const R=await this.a.getWorkspaceFolders2();if(R)return R.find($=>$.uri.toString()===P.uri.toString())}createQuickPick(k){const w=new g(k,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}createInputBox(k){const w=new d(k,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}$onDidChangeValue(k,w){this.e.get(k)?._fireDidChangeValue(w)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,w){const P=this.e.get(k);P instanceof g&&P._fireDidChangeActive(w)}$onDidChangeSelection(k,w){const P=this.e.get(k);P instanceof g&&P._fireDidChangeSelection(w)}$onDidTriggerButton(k,w){this.e.get(k)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(k,w,P){const R=this.e.get(k);R instanceof g&&R._fireDidTriggerItemButton(w,P)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class n{static{this.a=1}constructor(k,w){this.x=k,this.y=w,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new D.$oe,this.q=new D.$oe,this.r=new D.$oe,this.s=new D.$oe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){const w=(0,h.$uH)(this.x,"quickInputButtonLocation");!w&&k.some(P=>P.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=k.slice(),this.o.clear(),k.forEach((P,R)=>{const $=P===O.$tP.Back?-1:R;this.o.set($,P)}),this.z({buttons:k.map((P,R)=>({...m(P.iconPath),tooltip:P.tooltip,handle:P===O.$tP.Back?-1:R,location:w?P.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const w=this.o.get(k);w&&this.r.fire(w)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Sc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),u.$dispose(this._id))}z(k){if(!this.v){for(const w of Object.keys(k)){const P=k[w];this.u[w]=P===void 0?null:P}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){u.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof O.$4O)return{id:S.id};const k=l(S),w=o(S);return{dark:typeof k=="string"?T.URI.file(k):k,light:typeof w=="string"?T.URI.file(w):w}}function o(S){return typeof S=="object"&&"light"in S?S.light:S}function l(S){return typeof S=="object"&&"dark"in S?S.dark:S}function m(S){const k=t(S);let w,P;return"id"in k?P=v.ThemeIcon.asClassName(k):w=k,{iconPath:w,iconClass:P}}class g extends n{constructor(k,w){super(k,w),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new D.$oe,this.L=[],this.M=new D.$oe,this.N=new D.$oe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((R,$)=>{this.C.set($,R),this.D.set(R,$)});const w=(0,h.$uH)(this.x,"quickPickItemTooltip"),P=[];for(let R=0;R<k.length;R++){const $=k[R];if($.kind===O.QuickPickItemKind.Separator)P.push({type:"separator",label:$.label});else{$.tooltip&&!w&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const b=$.iconPath?m($.iconPath):void 0;P.push({handle:R,label:$.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,tooltip:w?E.MarkdownString.fromStrict($.tooltip):void 0,buttons:$.buttons?.map((L,A)=>({...m(L.iconPath),tooltip:L.tooltip,handle:A}))})}}this.z({items:P})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(w=>this.D.has(w)),this.z({activeItems:this.J.map(w=>this.D.get(w))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(w=>this.D.has(w)),this.z({selectedItems:this.L.map(w=>this.D.get(w))})}_fireDidChangeActive(k){const w=(0,s.$Jb)(k.map(P=>this.C.get(P)));this.J=w,this.K.fire(w)}_fireDidChangeSelection(k){const w=(0,s.$Jb)(k.map(P=>this.C.get(P)));this.L=w,this.M.fire(w)}_fireDidTriggerItemButton(k,w){const P=this.C.get(k);if(!P||!P.buttons||!P.buttons.length)return;const R=P.buttons[w];R&&this.N.fire({button:R,item:P})}}class d extends n{constructor(k,w){super(k,w),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:I.default.Error}):this.z({validationMessage:k.message,severity:k.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(a,c)}}),define(Oe[253],Ae([1,0,2,6,72,4,10,5,17,146,11,18,37,35,8,24,15,21]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=e.$jsc=void 0;function i(A){return A instanceof y.URI}function n(A,M){return A.scheme===a.Schemas.file&&M.scheme===a.Schemas.file&&c.$l?A.toString()===M.toString():A.toString().toLowerCase()===M.toString().toLowerCase()}function t(A){if(A)return typeof A.iconPath=="string"?y.URI.file(A.iconPath):y.URI.isUri(A.iconPath)||E.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function o(A){if(A){if(y.URI.isUri(A))return A;if(E.ThemeIcon.isThemeIcon(A))return A;{const M=A;return{light:M.light,dark:M.dark}}}else return}function l(A){const M=o(A.icon),Z=A.labels?.map(G=>({title:G.title,icon:o(G.icon)}));return{...A,icon:M,labels:Z}}function m(A,M){if(!A.iconPath&&!M.iconPath)return 0;if(A.iconPath){if(!M.iconPath)return 1}else return-1;const Z=typeof A.iconPath=="string"?A.iconPath:y.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,G=typeof M.iconPath=="string"?M.iconPath:y.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,s.$Pr)(Z,G)}function g(A,M){let Z=0;if(A.strikeThrough!==M.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==M.faded)return A.faded?1:-1;if(A.tooltip!==M.tooltip)return(A.tooltip||"").localeCompare(M.tooltip||"");if(Z=m(A,M),Z!==0)return Z;if(A.light&&M.light)Z=m(A.light,M.light);else{if(A.light)return 1;if(M.light)return-1}if(Z!==0)return Z;if(A.dark&&M.dark)Z=m(A.dark,M.dark);else{if(A.dark)return 1;if(M.dark)return-1}return Z}function d(A,M){if(A.command!==M.command)return A.command<M.command?-1:1;if(A.title!==M.title)return A.title<M.title?-1:1;if(A.tooltip!==M.tooltip){if(A.tooltip!==void 0&&M.tooltip!==void 0)return A.tooltip<M.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(A.arguments===M.arguments)return 0;if(A.arguments)if(M.arguments){if(A.arguments.length!==M.arguments.length)return A.arguments.length-M.arguments.length}else return 1;else return-1;for(let Z=0;Z<A.arguments.length;Z++){const G=A.arguments[Z],U=M.arguments[Z];if(G!==U&&!(i(G)&&i(U)&&n(G,U)))return G<U?-1:1}return 0}function S(A,M){let Z=(0,s.$Pr)(A.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(Z!==0)return Z;if(A.command&&M.command)Z=d(A.command,M.command);else{if(A.command)return 1;if(M.command)return-1}if(Z!==0)return Z;if(A.decorations&&M.decorations)Z=g(A.decorations,M.decorations);else{if(A.decorations)return 1;if(M.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&M.multiFileDiffEditorModifiedUri)Z=(0,s.$Pr)(A.multiFileDiffEditorModifiedUri.fsPath,M.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(M.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&M.multiDiffEditorOriginalUri)Z=(0,s.$Pr)(A.multiDiffEditorOriginalUri.fsPath,M.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(M.multiDiffEditorOriginalUri)return-1}return Z}function k(A,M){for(let Z=0;Z<A.length;Z++)if(A[Z]!==M[Z])return!1;return!0}function w(A,M){return A.command===M.command&&A.title===M.title&&A.tooltip===M.tooltip&&(A.arguments&&M.arguments?k(A.arguments,M.arguments):A.arguments===M.arguments)}function P(A,M){return(0,p.$wb)(A,M,w)}class R{#e;#t;get value(){return this.d}set value(M){M=M??"",this.#e.$setInputBoxValue(this.m,M),this.o(M)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(M){this.#e.$setInputBoxPlaceholder(this.m,M),this.f=M}get validateInput(){return(0,r.$vH)(this.k,"scmValidation"),this.g}set validateInput(M){if((0,r.$vH)(this.k,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=M,this.#e.$setValidationProviderIsEnabled(this.m,!!M)}get enabled(){return this.h}set enabled(M){M=!!M,this.h!==M&&(this.h=M,this.#e.$setInputBoxEnablement(this.m,M))}get visible(){return this.j}set visible(M){M=!!M,this.j!==M&&(this.j=M,this.#e.$setInputBoxVisibility(this.m,M))}get document(){return(0,r.$vH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(M,Z,G,U,V){this.k=M,this.m=U,this.n=V,this.d="",this.e=new D.$oe,this.f="",this.h=!0,this.j=!0,this.#t=Z,this.#e=G}showValidationMessage(M,Z){(0,r.$vH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,M,Z)}$onInputBoxValueChange(M){this.o(M)}o(M){this.d=M,this.e.fire(M)}}e.$jsc=R;class ${static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(M){this.w=M,this.s.$updateGroupLabel(this.u,this.handle,M)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(M){this.q=M,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(M){this.f=[...M],this.k.fire()}constructor(M,Z,G,U,V,Q,ne){this.s=M,this.t=Z,this.u=G,this.v=U,this.w=V,this.multiDiffEditorEnableViewChanges=Q,this.x=ne,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new D.$oe,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new D.$oe,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=$.d++}getResourceState(M){return this.g.get(M)}$executeResourceCommand(M,Z){const G=this.h.get(M);return G?(0,T.$Ah)(()=>this.t.executeCommand(G.command,...G.arguments||[],Z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this.f].sort(S),G=(0,p.$Fb)(this.p,M,S).map(Q=>{const ne=Q.toInsert.map(ue=>{const x=this.e++;this.g.set(x,ue);const oe=ue.resourceUri;let se;if(ue.command)if(ue.command.command==="vscode.open"||ue.command.command==="vscode.diff"||ue.command.command==="vscode.changes"){const Fe=new N.$Wc;se=this.t.converter.toInternal(ue.command,Fe),this.j.set(x,Fe)}else this.h.set(x,ue.command);const ce=(0,r.$uH)(this.x,"scmMultiDiffEditor"),te=ce?ue.multiDiffEditorOriginalUri:void 0,we=ce?ue.multiFileDiffEditorModifiedUri:void 0,Ce=t(ue.decorations),Y=ue.decorations&&t(ue.decorations.light)||Ce,W=ue.decorations&&t(ue.decorations.dark)||Ce,ee=[Y,W],be=ue.decorations&&ue.decorations.tooltip||"",Pe=ue.decorations&&!!ue.decorations.strikeThrough,je=ue.decorations&&!!ue.decorations.faded,Te=ue.contextValue||"";return{rawResource:[x,oe,ee,be,Pe,je,Te,se,te,we],handle:x}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:ne}}),U=G.map(({start:Q,deleteCount:ne,toInsert:ue})=>[Q,ne,ue.map(x=>x.rawResource)]),V=G.reverse();for(const{start:Q,deleteCount:ne,toInsert:ue}of V){const x=ue.map(se=>se.handle),oe=this.o.splice(Q,ne,...x);for(const se of oe)this.g.delete(se),this.h.delete(se),this.j.get(se)?.dispose(),this.j.delete(se)}return this.p=M,U}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(M){this.g!==M&&(this.g=M,this.#e.$updateSourceControl(this.x,{count:M}))}get quickDiffProvider(){return this.h}set quickDiffProvider(M){this.h=M;let Z;(0,r.$uH)(this.y,"quickDiffProvider")&&(Z=M?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!M,quickDiffLabel:Z})}get historyProvider(){return(0,r.$vH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(M){(0,r.$vH)(this.y,"scmHistoryProvider"),this.j=M,this.k.value=new N.$Wc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!M}),M&&this.k.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this.m=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(M){M!==this.n&&(this.n=M,this.#e.$updateSourceControl(this.x,{commitTemplate:M}))}get acceptInputCommand(){return this.p}set acceptInputCommand(M){this.o.value=new N.$Wc,this.p=M;const Z=this.z.converter.toInternal(M,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:Z})}get actionButton(){return(0,r.$vH)(this.y,"scmActionButton"),this.s}set actionButton(M){(0,r.$vH)(this.y,"scmActionButton"),this.q.value=new N.$Wc,this.s=M;const Z=M!==void 0?{command:this.z.converter.toInternal(M.command,this.q.value),secondaryCommands:M.secondaryCommands?.map(G=>G.map(U=>this.z.converter.toInternal(U,this.q.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:Z??null})}get statusBarCommands(){return this.u}set statusBarCommands(M){if(this.u&&M&&P(this.u,M))return;this.t.value=new N.$Wc,this.u=M;const Z=(M||[]).map(G=>this.z.converter.toInternal(G,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:Z})}get selected(){return this.v}constructor(M,Z,G,U,V,Q,ne){this.y=M,this.z=U,this.A=V,this.B=Q,this.C=ne,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Yc,this.n=void 0,this.o=new N.$Yc,this.p=void 0,this.q=new N.$Yc,this.t=new N.$Yc,this.u=void 0,this.v=!1,this.w=new D.$oe,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=G;const ue=y.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${V}/scm${this.x}/input`,query:ne?`rootUri=${encodeURIComponent(ne.toString())}`:void 0});this.f=new R(M,Z,this.#e,this.x,ue),this.#e.$registerSourceControl(this.x,V,Q,ne,ue)}createResourceGroup(M,Z,G){const U=(0,r.$uH)(this.y,"scmMultiDiffEditor")&&G?.multiDiffEditorEnableViewChanges===!0,V=new $(this.#e,this.z,this.x,M,Z,U,this.y),Q=D.Event.once(V.onDidDispose)(()=>this.D.delete(V));return this.D.set(V,Q),this.eventuallyAddResourceGroups(),V}eventuallyAddResourceGroups(){const M=[],Z=[];for(const[G,U]of this.D){U.dispose();const V=G.onDidUpdateResourceStates(()=>{this.E.add(G),this.eventuallyUpdateResourceStates()});D.Event.once(G.onDidDispose)(()=>{this.E.delete(G),V.dispose(),this.e.delete(G.handle),this.#e.$unregisterGroup(this.x,G.handle)}),M.push([G.handle,G.id,G.label,G.features,G.multiDiffEditorEnableViewChanges]);const Q=G._takeResourceStateSnapshot();Q.length>0&&Z.push([G.handle,Q]),this.e.set(G.handle,G)}this.#e.$registerGroups(this.x,M,Z),this.D.clear()}eventuallyUpdateResourceStates(){const M=[];this.E.forEach(Z=>{const G=Z._takeResourceStateSnapshot();G.length!==0&&M.push([Z.handle,G])}),M.length>0&&this.#e.$spliceResourceStates(this.x,M),this.E.clear()}getResourceGroup(M){return this.e.get(M)}setSelectionState(M){this.v=M,this.w.fire(M)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.x)}}Xe([(0,C.$bi)(100)],b.prototype,"eventuallyAddResourceGroups",null),Xe([(0,C.$bi)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let L=class{static{u=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(M,Z,G,U){this.m=Z,this.n=G,this.o=U,this.g=new Map,this.h=new v.$wn,this.j=new D.$oe,this.e=M.getProxy(O.$3N.MainThreadSCM),this.f=M.getProxy(O.$3N.MainThreadTelemetry),Z.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===h.MarshalledId.ScmResource){const Q=this.g.get(V.sourceControlHandle);if(!Q)return V;const ne=Q.getResourceGroup(V.groupHandle);return ne?ne.getResourceState(V.handle):V}else if(V&&V.$mid===h.MarshalledId.ScmResourceGroup){const Q=this.g.get(V.sourceControlHandle);return Q?Q.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===h.MarshalledId.ScmProvider){const Q=this.g.get(V.handle);return Q||V}return V}})}createSourceControl(M,Z,G,U){this.o.trace("ExtHostSCM#createSourceControl",M.identifier.value,Z,G,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const V=u.d++,Q=new b(M,this.n,this.e,this.m,Z,G,U);this.g.set(V,Q);const ne=this.h.get(M.identifier)||[];return ne.push(Q),this.h.set(M.identifier,ne),Q}getLastInputBox(M){this.o.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const Z=this.h.get(M.identifier),G=Z&&Z[Z.length-1];return G&&G.inputBox}$provideOriginalResource(M,Z,G){const U=y.URI.revive(Z);this.o.trace("ExtHostSCM#$provideOriginalResource",M,U.toString());const V=this.g.get(M);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$Ah)(()=>V.quickDiffProvider.provideOriginalResource(U,G)).then(Q=>Q||null)}$onInputBoxValueChange(M,Z){this.o.trace("ExtHostSCM#$onInputBoxValueChange",M);const G=this.g.get(M);return G&&G.inputBox.$onInputBoxValueChange(Z),Promise.resolve(void 0)}$executeResourceCommand(M,Z,G,U){this.o.trace("ExtHostSCM#$executeResourceCommand",M,Z,G);const V=this.g.get(M);if(!V)return Promise.resolve(void 0);const Q=V.getResourceGroup(Z);return Q?Q.$executeResourceCommand(G,U):Promise.resolve(void 0)}$validateInput(M,Z,G){this.o.trace("ExtHostSCM#$validateInput",M);const U=this.g.get(M);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,T.$Ah)(()=>U.inputBox.validateInput(Z,G)).then(V=>{if(!V)return Promise.resolve(void 0);const Q=f.MarkdownString.fromStrict(V.message);return Q?Promise.resolve([Q,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this.g.get(M)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(M,Z,G,U){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(Z,G,U)??void 0}async $resolveHistoryItemGroupCommonAncestor2(M,Z,G){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(Z,G)??void 0}async $provideHistoryItems(M,Z,G,U){return(await this.g.get(M)?.historyProvider?.provideHistoryItems(Z,G,U))?.map(ne=>l(ne))??void 0}async $provideHistoryItems2(M,Z,G){return(await this.g.get(M)?.historyProvider?.provideHistoryItems2(Z,G))?.map(Q=>l(Q))??void 0}async $provideHistoryItemSummary(M,Z,G,U){const V=this.g.get(M)?.historyProvider;if(typeof V?.provideHistoryItemSummary!="function")return;const Q=await V.provideHistoryItemSummary(Z,G,U);return Q?l(Q):void 0}async $provideHistoryItemChanges(M,Z,G,U){return await this.g.get(M)?.historyProvider?.provideHistoryItemChanges(Z,G,U)??void 0}};e.$ksc=L,e.$ksc=L=u=Xe([Qe(3,I.$dk)],L)}),define(Oe[254],Ae([1,0,5,8,2]),function($e,e,y,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsc=void 0;class N{static{this.a=0}constructor(O,p){this.d=p,this.c=new Map,this.b=O.getProxy(y.$3N.MainThreadShare)}async $provideShare(O,p,s){return await this.c.get(O)?.provideShare({selection:D.Range.to(p.selection),resourceUri:C.URI.revive(p.resourceUri)},s)??void 0}registerShareProvider(O,p){const s=N.a++;return this.c.set(s,p),this.b.$registerShareProvider(s,D.DocumentSelector.from(O,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$lsc=N}),define(Oe[255],Ae([1,0,7,5,9,4,8,14]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=e.$nsc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$5O("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$5O("statusBarItem.warningForeground")]])}#e;#t;constructor(h,E,f,r,a,c=y.StatusBarAlignment.Left,u){if(this.i=!1,this.k="",this.q=new N.$Wc,this.#e=h,this.#t=E,a&&r){this.c=(0,y.$GO)(r.identifier,a);const i=f.get(this.c);i&&(c=i.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,u=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=a,this.g=c,this.h=this.u(u)}u(h){if((0,O.$lg)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(h){this.k=h,this.v()}set name(h){this.m=h,this.v()}set tooltip(h){this.l=h,this.v()}set color(h){this.n=h,this.v()}set backgroundColor(h){h&&!p.b.has(h.id)&&(h=void 0),this.o=h,this.v()}set command(h){this.r?.fromApi!==h&&(this.p&&this.q.add(this.p),this.p=new N.$Wc,typeof h=="string"?this.r={fromApi:h,internal:this.#t.toInternal({title:"",command:h},this.p)}:h?this.r={fromApi:h,internal:this.#t.toInternal(h,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(h){this.t=h,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let E;this.m?E=this.m:E=(0,C.localize)(2709,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=p.b.get(this.o.id));const r=T.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,h,this.e?.identifier.value,E,this.k,r,this.r?.internal,f,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$nsc=p;class s{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(2710,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const E={message:h};return this.b.unshift(E),this.c(),new y.$5N(()=>{const f=this.b.indexOf(E);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(h,E){this.e=new Map,this.a=h.getProxy(D.$3N.MainThreadStatusBar),this.b=E,this.c=new s(this)}$acceptStaticEntries(h){for(const E of h)this.e.set(E.entryId,E)}createStatusBarEntry(h,E,f,r){return new p(this.a,this.b,this.e,h,E,f,r)}setStatusBarMessage(h,E){const f=this.c.setMessage(h);let r;return typeof E=="number"?r=setTimeout(()=>f.dispose(),E):typeof E<"u"&&E.then(()=>f.dispose(),()=>f.dispose()),new y.$5N(()=>{f.dispose(),clearTimeout(r)})}}e.$osc=I}),define(Oe[127],Ae([1,0,32,118,55,82,56,8,2]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=e.$QQ=e.$PQ=void 0,y=He(y),O=He(O);const s=(i,n,t,o)=>{let l=n;return{enumerable:!0,configurable:!1,get(){return l},set(m){if(!t(l,m)){const g=l;l=m,i.listener?.(o(m,g))}}}},I=(i,n)=>i===n,v={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(o=>t.id===o.id)))},h=i=>n=>({op:N.TestItemEventOp.SetProp,update:i(n)}),E=(i,n)=>({range:(()=>{let t;const o=h(l=>({range:y.$Tt.lift(O.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:N.TestItemEventOp.DocumentSynced}),v.range(t,l)||(t=l,i.listener?.(o(l)))}}})(),label:s(i,n,v.label,h(t=>({label:t}))),description:s(i,void 0,v.description,h(t=>({description:t}))),sortText:s(i,void 0,v.sortText,h(t=>({sortText:t}))),canResolveChildren:s(i,!1,v.canResolveChildren,t=>({op:N.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,v.busy,h(t=>({busy:t}))),error:s(i,void 0,v.error,h(t=>({error:O.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],v.tags,(t,o)=>({op:N.TestItemEventOp.SetTags,new:t.map(O.TestTag.from),old:o.map(O.TestTag.from)}))}),f=i=>{const n=C.$lJ.fromString(i.extId),t=new a(n.controllerId,n.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=O.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>O.TestTag.to({id:(0,T.$rJ)(o).tagId})),t},r=i=>{let n;for(const t of i.tests){const o=f(t.item);(0,D.$zQ)(o).parent=n,n=o}return n};e.$PQ=r;class a{constructor(n,t,o,l){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const m=(0,D.$yQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof c?void 0:m.parent}},children:{value:(0,N.$xQ)(m,D.$zQ,a),enumerable:!0,writable:!1},...E(m,o)})}}e.$QQ=a;class c extends a{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$RQ=c;class u extends N.$tQ{constructor(n,t,o){super({controllerId:n,getDocumentVersion:l=>l&&o.getDocument(l)?.version,getApiFor:D.$zQ,getChildren:l=>l.children,root:new c(n,t),toITestItem:O.TestItem.from})}}e.$SQ=u}),define(Oe[34],Ae([1,0,14,7,8,25,5,17,11,33,32,102,2,4,3,16,127,22,39,42,70,64,67,38]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.$3Q=e.$2Q=e.$1Q=e.$ZQ=e.$YQ=void 0,D=He(D),C=He(C);let m=class{#e;#t;#i;constructor(P,R,$){this.b=new Map,this.c=new Map,this.#e=P.getProxy(T.$3N.MainThreadCommands),this.d=R,this.#i=$,this.#t=P.getProxy(T.$3N.MainThreadTelemetry),this.converter=new g(this,b=>{const L=this.c.get(b);return L?.result===S.Void?L:void 0},R),this.f=[{processArgument(b){return(0,s.$fi)(b)}},{processArgument(b){return(0,N.$jo)(b,function(L){if(I.$Tt.isIRange(L))return C.Range.to(L);if(v.$St.isIPosition(L))return C.Position.to(L);if(I.$Tt.isIRange(L.range)&&h.URI.isUri(L.uri))return C.location.to(L);if(L instanceof c.$Qe)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const R=this.registerCommand(!1,P.id,async(...$)=>{const b=P.args.map((A,M)=>{if(!A.validate($[M]))throw new Error(`Invalid argument '${A.name}' when running '${P.id}', received: ${typeof $[M]=="object"?JSON.stringify($[M],null,"	"):$[M]} `);return A.convert($[M])}),L=await this.executeCommand(P.internalId,...b);return P.result.convert(L,$,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new D.$5N(()=>{R.dispose(),this.c.delete(P.id)})}registerCommand(P,R,$,b,L,A){if(this.d.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this.b.has(R))throw new Error(`command '${R}' already exists`);return this.b.set(R,{callback:$,thisArg:b,metadata:L,extension:A}),P&&this.#e.$registerCommand(R),new D.$5N(()=>{this.b.delete(R)&&P&&this.#e.$unregisterCommand(R)})}executeCommand(P,...R){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,R,!0)}async g(P,R,$){if(this.b.has(P))return this.#e.$fireCommandActivationEvent(P),this.h(P,R,!1);{let b=!1;const L=(0,N.$jo)(R,function(A){if(A instanceof D.$6N)return C.Position.from(A);if(A instanceof D.$7N)return C.Range.from(A);if(A instanceof D.$gO)return C.location.from(A);if(D.$wP.isNotebookRange(A))return C.NotebookRange.from(A);if(A instanceof ArrayBuffer)return b=!0,c.$Qe.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return b=!0,c.$Qe.wrap(A);if(A instanceof c.$Qe)return b=!0,A;if(!Array.isArray(A))return A});try{const A=await this.#e.$executeCommand(P,b?new u.$4w(L):L,$);return(0,s.$fi)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this.g(P,R,!1);throw A}}}async h(P,R,$){const b=this.b.get(P);if(!b)throw new Error("Unknown command");const{callback:L,thisArg:A,metadata:M}=b;if(M?.args)for(let G=0;G<M.args.length;G++)try{(0,y.$yg)(R[G],M.args[G].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${M.args[G].name}' - ${M.args[G].description}`)}const Z=n.$ie.create();try{return await L.apply(A,R)}catch(G){if(P===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...R);U&&(P=U.command)}if(this.d.error(G,P,b.extension?.identifier),!$)throw G;if(b.extension?.identifier){const U=this.#i.onExtensionError(b.extension.identifier,G);this.d.trace("forwarded error to extension?",U,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$tj)(G)),this.id=P,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,P,Z.elapsed())}}j(P,R,$){P.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new t.$Ap(R),duration:$})}$executeContributedCommand(P,...R){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const $=this.b.get(P);return $?(R=R.map(b=>this.f.reduce((L,A)=>A.processArgument(L,$.extension?.identifier),b)),this.h(P,R,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),this.#e.$getCommands().then(R=>(P&&(R=R.filter($=>$[0]!=="_")),R))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[R,$]of this.b){const{metadata:b}=$;b&&(P[R]=b)}return Promise.resolve(P)}};e.$YQ=m,e.$YQ=m=Xe([Qe(0,r.$DQ),Qe(1,p.$dk),Qe(2,o.$XQ)],m),e.$ZQ=(0,f.$Ii)("IExtHostCommands");class g{constructor(P,R,$){this.d=P,this.f=R,this.g=$,this.delegatingCommandId=`__vsc${(0,l.$5g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,R){if(!P)return;const $={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return $;const b=this.f(P.command);if(b)$.id=b.internalId,$.arguments=b.args.map((L,A)=>L.convert(P.arguments&&P.arguments[A]));else if((0,O.$Nb)(P.arguments)){const L=`${P.command} /${++this.c}`;this.b.set(L,P),R.add((0,E.$Vc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),$.$ident=L,$.id=this.delegatingCommandId,$.arguments=[L],this.g.trace("CommandsConverter#CREATE",P.command,L)}return $}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const R=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],R?R.command:"MISSING"),R?this.d.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$1Q=g;class d{static{this.Uri=new d("uri","Uri of a text document",P=>h.URI.isUri(P),P=>P)}static{this.Position=new d("position","A position in a text document",P=>D.$6N.isPosition(P),C.Position.from)}static{this.Range=new d("range","A range in a text document",P=>D.$7N.isRange(P),C.Range.from)}static{this.Selection=new d("selection","A selection in a text document",P=>D.$8N.isSelection(P),C.Selection.from)}static{this.Number=new d("number","",P=>typeof P=="number",P=>P)}static{this.String=new d("string","",P=>typeof P=="string",P=>P)}static{this.StringArray=d.Arr(d.String)}static Arr(P){return new d(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,R=>Array.isArray(R)&&R.every($=>P.validate($)),R=>R.map($=>P.convert($)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",P=>P instanceof D.$sO,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",P=>P instanceof D.$RP,C.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",P=>P instanceof a.$QQ,C.TestItem.from)}constructor(P,R,$,b){this.name=P,this.description=R,this.validate=$,this.convert=b}optional(){return new d(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,R){return new d(P??this.name,R??this.description,this.validate,this.convert)}}e.$2Q=d;class S{static{this.Void=new S("no result",P=>P)}constructor(P,R){this.description=P,this.convert=R}}e.$3Q=S;class k{constructor(P,R,$,b,L){this.id=P,this.internalId=R,this.description=$,this.args=b,this.result=L}}e.$4Q=k}),define(Oe[256],Ae([1,0,17,15,2,94,104,31,34,8,7]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0,N=He(N),s=He(s),I=He(I);const v=[new p.$4Q("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of DocumentHighlight-instances.",E(s.DocumentHighlight.to))),new p.$4Q("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if((0,y.$Mb)(r))return;class c extends I.$nO{static to(i){const n=new c(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new I.$gO(a[0],s.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=s.Range.to(i.selectionRange),n.children=i.children?i.children.map(c.to):[],n}}return r.map(c.to)})),new p.$4Q("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$2Q.Uri,new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$2Q.Uri,p.$2Q.Range,new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$2Q.Uri,p.$2Q.Position,new p.$2Q("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location-instances.",E(s.location.to))),new p.$4Q("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location-instances.",E(s.location.to))),new p.$4Q("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Hover-instances.",E(s.Hover.to))),new p.$4Q("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Hover-instances.",E(s.Hover.to))),new p.$4Q("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$2Q.Uri,new p.$2Q("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>I.$6N.isPosition(a)),r=>r.map(s.Position.from))],new p.$3Q("A promise that resolves to an array of ranges.",r=>r.map(a=>{let c;for(const u of a.reverse())c=new I.$rO(s.Range.to(u),c);return c}))),new p.$4Q("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$2Q.String.with("query","Search string")],new p.$3Q("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(s.WorkspaceSymbol.to))),new p.$4Q("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(s.CallHierarchyItem.to))),new p.$4Q("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$2Q.CallHierarchyItem],new p.$3Q("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(s.CallHierarchyIncomingCall.to))),new p.$4Q("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$2Q.CallHierarchyItem],new p.$3Q("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(s.CallHierarchyOutgoingCall.to))),new p.$4Q("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:s.Range.to(r.range),placeholder:r.text}})),new p.$4Q("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("newName","The new symbol name")],new p.$3Q("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return s.WorkspaceEdit.to(r)}})),new p.$4Q("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$2Q.Uri,p.$2Q.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$3Q("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(s.DocumentLink.to))),new p.$4Q("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$2Q.Uri],new p.$3Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$nP(r.tokenTypes,r.tokenModifiers)})),new p.$4Q("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$2Q.Uri],new p.$3Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,T.$keb)(r);if(a.type==="full")return new I.$pP(a.data,void 0)})),new p.$4Q("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$2Q.Uri,p.$2Q.Range.optional()],new p.$3Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$nP(r.tokenTypes,r.tokenModifiers)})),new p.$4Q("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$2Q.Uri,p.$2Q.Range],new p.$3Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,T.$keb)(r);if(a.type==="full")return new I.$pP(a.data,void 0)})),new p.$4Q("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$2Q.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$3Q("A promise that resolves to a CompletionList-instance.",(r,a,c)=>{if(!r)return new I.$DO([]);const u=r.suggestions.map(i=>s.CompletionItem.to(i,c));return new I.$DO(u,r.incomplete)})),new p.$4Q("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$3Q("A promise that resolves to SignatureHelp.",r=>{if(r)return s.SignatureHelp.to(r)})),new p.$4Q("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$2Q.Uri,p.$2Q.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$3Q("A promise that resolves to an array of CodeLens-instances.",(r,a,c)=>E(u=>new I.$vO(s.Range.to(u.range),u.command&&c.fromInternal(u.command)))(r))),new p.$4Q("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$2Q.Uri,new p.$2Q("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$7N.isRange(r),r=>I.$8N.isSelection(r)?s.Selection.from(r):s.Range.from(r)),p.$2Q.String.with("kind","Code action kind to return code actions for").optional(),p.$2Q.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$3Q("A promise that resolves to an array of Command-instances.",(r,a,c)=>E(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(u.command)}else{const i=new I.$pO(u.title,u.kind?new I.$qO(u.kind):void 0);return u.edit&&(i.edit=s.WorkspaceEdit.to(u.edit)),u.command&&(i.command=c.fromInternal(u.command)),i.isPreferred=u.isPreferred,i}})(r))),new p.$4Q("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new I.$JO(s.Range.to(a.range),s.Color.to(a.color))):[])),new p.$4Q("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$2Q("color","The color to show and insert",r=>r instanceof I.$IO,s.Color.from),new p.$2Q("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:s.Range.from(r.range)}))],new p.$3Q("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(s.ColorPresentation.to):[])),new p.$4Q("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$2Q.Uri,p.$2Q.Range],new p.$3Q("A promise that resolves to an array of Inlay objects",(r,a,c)=>r.map(s.InlayHint.to.bind(void 0,c)))),new p.$4Q("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of FoldingRange objects",(r,a)=>{if(r)return r.map(s.FoldingRange.to)})),new p.$4Q("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$3Q("A promise that resolves to an array of NotebookContentProvider static info objects.",E(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>s.NotebookExclusiveDocumentPattern.to(a))})))),new p.$4Q("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$2Q.Uri,p.$2Q.Range,new p.$2Q("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$7N,r=>s.InlineValueContext.from(r))],new p.$3Q("A promise that resolves to an array of InlineValue objects",r=>r.map(s.InlineValue.to))),new p.$4Q("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$2Q("uriOrString","Uri-instance or string (only http/https)",r=>C.URI.isUri(r)||typeof r=="string"&&(0,D.$Sg)(r,D.Schemas.http,D.Schemas.https),r=>r),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional(),p.$2Q.String.with("label","").optional()],p.$3Q.Void),new p.$4Q("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$2Q.Uri.with("resource","Resource to open"),p.$2Q.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional()],p.$3Q.Void),new p.$4Q("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$2Q.Uri.with("left","Left-hand side resource of the diff editor"),p.$2Q.Uri.with("right","Right-hand side resource of the diff editor"),p.$2Q.String.with("title","Human readable title for the diff editor").optional(),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)]).optional()],p.$3Q.Void),new p.$4Q("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$2Q.String.with("title","Human readable title for the changes editor"),new p.$2Q("resourceList","List of resources to compare",r=>{for(const a of r){if(a.length!==3)return!1;const[c,u,i]=a;if(!C.URI.isUri(c)||!C.URI.isUri(u)&&u!==void 0&&u!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],p.$3Q.Void),new p.$4Q("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$2Q.TypeHierarchyItem],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$2Q.TypeHierarchyItem],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$2Q.TestItem],p.$3Q.Void),new p.$4Q("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$2Q.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$3Q.Void),new p.$4Q("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$2Q.String.with("name","The context key name"),new p.$2Q("value","The context key value",()=>!0,r=>r)],p.$3Q.Void),new p.$4Q("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$2Q.Uri,p.$2Q.StringArray,new p.$2Q("MappedEditsContext","Mapped Edits Context",r=>s.MappedEditsContext.is(r),r=>s.MappedEditsContext.from(r))],new p.$3Q("A promise that resolves to a workspace edit or null",r=>r?s.WorkspaceEdit.to(r):null)),new p.$4Q("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$2Q("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?s.Range.from(r.initialRange):void 0,initialSelection:I.$8N.isSelection(r.initialSelection)?s.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?s.Position.from(r.position):void 0}})],p.$3Q.Void)];class h{static register(a){v.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",O.$Hj)}}e.$yqc=h;function E(r){return a=>{if(Array.isArray(a))return a.map(r)}}function f(r){if(!Array.isArray(r))return;const a=[];for(const c of r)N.$Qu(c)?a.push(s.DefinitionLink.to(c)):a.push(s.location.to(c));return a}}),define(Oe[257],Ae([1,0,2,34]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5rc=void 0;class C{constructor(T,O,p,s,I){this.a=O,this.b=p,this.c=s;const v=new D.$4Q("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.$2Q("showOptions","Show Options",h=>!0,h=>h),new D.$2Q("resource","Interactive resource Uri",h=>!0,h=>h),new D.$2Q("controllerId","Notebook controller Id",h=>!0,h=>h),new D.$2Q("title","Interactive editor title",h=>!0,h=>h)],new D.$3Q("Notebook and input URI",h=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const E=this.a.getEditorById(h.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:y.URI.revive(h.notebookUri),inputUri:y.URI.revive(h.inputUri),notebookEditor:E.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:y.URI.revive(h.notebookUri),inputUri:y.URI.revive(h.inputUri)}}));this.c.registerApiCommand(v)}$willAddInteractiveDocument(T,O,p,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:p,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$5rc=C}),define(Oe[258],Ae([1,0,17,10,19,6,4,28,2,18,11,5,34,8,7,83,197,24,39,198]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$asc=void 0,e.$bsc=d,E=He(E);let n=class{constructor(k,w,P,R,$){this.m=w,this.n=P,this.o=R,this.q=$,this.b=new O.$Dc,this.c=new O.$Dc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$oe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=k.getProxy(v.$3N.MainThreadNotebookKernels);const b=new h.$4Q("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new h.$2Q("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const M=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:M}}else if(A&&"notebookEditor"in A){const M=this.n.getIdByEditor(A.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return A})],h.$3Q.Void),L=new h.$4Q("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[h.$2Q.Uri],new h.$3Q("A promise that resolves to an array of variables",(A,M)=>A.map(Z=>({variable:{name:Z.name,value:Z.value,expression:Z.expression,type:Z.type,language:Z.language},hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(L)}createNotebookController(k,w,P,R,$,b){for(const te of this.j.values())if(te.controller.id===w&&s.$un.equals(k.identifier,te.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const L=this.k++,A=this;this.q.trace(`NotebookController[${L}], CREATED by ${k.identifier.value}, ${w}`);const M=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${k.identifier}'`);let Z=!1;const G=new N.$oe,U=new N.$oe,V={id:d(k.identifier,w),notebookType:P,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:R||k.identifier.value,preloads:b?b.map(E.NotebookRendererScript.from):[]};let Q=$??M,ne,ue;this.a.$addKernel(L,V).catch(te=>{console.log(te),Z=!0});let x=0;const oe=()=>{if(Z)return;const te=++x;Promise.resolve().then(()=>{te===x&&this.a.$updateKernel(L,V)})},se=new O.$Dc,ce={get id(){return w},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:G.event,get label(){return V.label},set label(te){V.label=te??k.displayName??k.name,oe()},get detail(){return V.detail??""},set detail(te){V.detail=te,oe()},get description(){return V.description??""},set description(te){V.description=te,oe()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(te){V.supportedLanguages=te,oe()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(te){V.supportsExecutionOrder=te,oe()},get rendererScripts(){return V.preloads?V.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(te){Q=te??M},get interruptHandler(){return ne},set interruptHandler(te){ne=te,V.supportsInterrupt=!!te,oe()},set variableProvider(te){(0,c.$vH)(k,"notebookVariableProvider"),ue=te,V.hasVariableProvider=!!te,te?.onDidChangeVariables(we=>A.a.$variablesUpdated(we.uri)),oe()},get variableProvider(){return ue},createNotebookCellExecution(te){if(Z)throw new Error("notebook controller is DISPOSED");if(!se.has(te.notebook.uri))throw A.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(se.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return A._createNotebookCellExecution(te,d(k.identifier,this.id))},createNotebookExecution(te){if((0,c.$vH)(k,"notebookExecution"),Z)throw new Error("notebook controller is DISPOSED");if(!se.has(te.uri))throw A.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(se.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.uri.toString()}`);return A._createNotebookExecution(te,d(k.identifier,this.id))},dispose:()=>{Z||(this.q.trace(`NotebookController[${L}], DISPOSED`),Z=!0,this.j.delete(L),G.dispose(),U.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(te,we){we===f.NotebookControllerAffinity2.Hidden&&(0,c.$vH)(k,"notebookControllerAffinityHidden"),A.a.$updateNotebookPriority(L,te.uri,we)},onDidReceiveMessage:U.event,postMessage(te,we){return(0,c.$vH)(k,"notebookMessaging"),A.a.$postMessage(L,we&&A.n.getIdByEditor(we),te)},asWebviewUri(te){return(0,c.$vH)(k,"notebookMessaging"),(0,r.$0Db)(te,A.m.remote)}};return this.j.set(L,{extensionId:k.identifier,controller:ce,onDidReceiveMessage:U,onDidChangeSelection:G,associatedNotebooks:se}),ce}getIdByController(k){for(const[w,P]of this.j)if(P.controller===k)return d(P.extensionId,k.id);return null}createNotebookControllerDetectionTask(k,w){const P=this.g++,R=this;this.q.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${k.identifier.value}`),this.a.$addKernelDetectionTask(P,w);const $={dispose:()=>{this.f.delete(P),R.a.$removeKernelDetectionTask(P)}};return this.f.set(P,$),$}registerKernelSourceActionProvider(k,w,P){const R=this.i++,$=typeof P.onDidChangeNotebookKernelSourceActions=="function"?R:void 0,b=this;this.h.set(R,P),this.q.trace(`NotebookKernelSourceActionProvider[${R}], CREATED by ${k.identifier.value}`),this.a.$addKernelSourceActionProvider(R,R,w);let L;return $!==void 0&&(L=P.onDidChangeNotebookKernelSourceActions(A=>this.a.$emitNotebookKernelSourceActionsChangeEvent($))),{dispose:()=>{this.h.delete(R),b.a.$removeKernelSourceActionProvider(R,R),L?.dispose()}}}async $provideKernelSourceActions(k,w){const P=this.h.get(k);if(P){const R=new T.$Wc;return(await P.provideNotebookKernelSourceActions(w)??[]).map(b=>E.NotebookKernelSourceAction.from(b,this.o.converter,R))}return[]}$acceptNotebookAssociation(k,w,P){const R=this.j.get(k);if(R){const $=this.n.getNotebookDocument(p.URI.revive(w));P?R.associatedNotebooks.set($.uri,!0):R.associatedNotebooks.delete($.uri),this.q.trace(`NotebookController[${k}] ASSOCIATE notebook`,$.uri.toString(),P),R.onDidChangeSelection.fire({selected:P,notebook:$.apiNotebook})}}async $executeCells(k,w,P){const R=this.j.get(k);if(!R)return;const $=this.n.getNotebookDocument(p.URI.revive(w)),b=[];for(const L of P){const A=$.getCell(L);A&&b.push(A.apiCell)}try{this.q.trace(`NotebookController[${k}] EXECUTE cells`,$.uri.toString(),b.length),await R.controller.executeHandler.call(R.controller,b,$.apiNotebook,R.controller)}catch(L){this.q.error(`NotebookController[${k}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(k,w,P){const R=this.j.get(k);if(!R)return;const $=this.n.getNotebookDocument(p.URI.revive(w));if(R.controller.interruptHandler)await R.controller.interruptHandler.call(R.controller,$.apiNotebook);else for(const b of P){const L=$.getCell(b);L&&this.b.get(L.uri)?.cancel()}if(R.controller.interruptHandler){const b=this.c.get($.uri);this.c.delete($.uri),P.length&&Array.isArray(b)&&b.length&&b.forEach(L=>L.dispose())}}async $provideVariables(k,w,P,R,$,b,L){const A=this.j.get(k);if(!A)return;const M=this.n.getNotebookDocument(p.URI.revive(P)),Z=A.controller.variableProvider;if(!Z)return;let G;if(R!==void 0){if(G=this.s[R],!G)return}else this.s={};const U=$==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,V=Z.provideVariables(M.apiNotebook,G,U,b,L);let Q=0;for await(const ne of V){if(L.isCancellationRequested)return;const ue={id:this.r++,name:ne.variable.name,value:ne.variable.value,type:ne.variable.type,interfaces:ne.variable.interfaces,language:ne.variable.language,expression:ne.variable.expression,hasNamedChildren:ne.hasNamedChildren,indexedChildrenCount:ne.indexedChildrenCount,extensionId:A.extensionId.value};if(this.s[ue.id]=ne.variable,this.a.$receiveVariable(w,ue),Q++>=i.$eL)return}}$acceptKernelMessageFromRenderer(k,w,P){const R=this.j.get(k);if(!R)return;const $=this.n.getEditorById(w);R.onDidReceiveMessage.fire(Object.freeze({editor:$.apiEditor,message:P}))}$cellExecutionChanged(k,w,P){const $=this.n.getNotebookDocument(p.URI.revive(k)).getCell(w);if($){const b=P?E.NotebookCellExecutionState.to(P):f.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:$.apiCell,state:b})}}_createNotebookCellExecution(k,w){if(k.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const R=this.n.getNotebookDocument(k.notebook.uri).getCellFromApiCell(k);if(!R)throw new Error("invalid cell");if(this.b.has(R.uri))throw new Error(`duplicate execution for ${R.uri}`);const $=new o(w,R,this.a);this.b.set(R.uri,$);const b=$.onDidChangeState(()=>{$.state===t.Resolved&&($.dispose(),b.dispose(),this.b.delete(R.uri))});return $.asApiObject()}_createNotebookExecution(k,w){const P=this.n.getNotebookDocument(k.uri),R=k.getCells().find(L=>{const A=P.getCellFromApiCell(L);return A&&this.b.has(A.uri)});if(R)throw new Error(`duplicate cell execution for ${R.document.uri}`);if(this.c.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const $=new m(w,P,this.a),b=$.onDidChangeState(()=>{$.state===l.Resolved&&($.dispose(),b.dispose(),this.c.delete(P.uri))});return this.c.set(P.uri,[$,b]),$.asApiObject()}};e.$asc=n,e.$asc=n=Xe([Qe(4,I.$dk)],n);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class o extends T.$Xc{static{this.a=0}get state(){return this.f}constructor(k,w,P){super(),this.m=w,this.n=P,this.b=o.a++,this.c=new N.$oe,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$ze),this.h=new g(10,R=>this.s(R)),this.j=w.internalMetadata.executionOrder,this.n.$createExecution(this.b,k,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(k){await this.h.addItem(k)}async s(k){const w=Array.isArray(k)?k:[k];return this.n.$updateExecution(this.b,new u.$4w(w))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(k){let w=this.m;if(k&&(w=this.m.notebook.getCellFromApiCell(k)),!w)throw new Error("INVALID cell");return w.handle}y(k){return k.map(w=>{const P=f.$AP.ensureUniqueMimeTypes(w.items,!0);return P===w.items?E.NotebookCellOutput.from(w):E.NotebookCellOutput.from({items:P,id:w.id,metadata:w.metadata})})}async z(k,w,P){const R=this.w(w),$=this.y((0,y.$4b)(k));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:R,append:P,outputs:$})}async C(k,w,P){return k=f.$AP.ensureUniqueMimeTypes((0,y.$4b)(k),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:k.map(E.NotebookCellOutputItem.from),outputId:w.id,append:P})}asApiObject(){const k=this;return Object.freeze({get token(){return k.g.token},get cell(){return k.m.apiCell},get executionOrder(){return k.j},set executionOrder(P){k.j=P,k.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:k.j}])},start(P){if(k.f===t.Resolved||k.f===t.Started)throw new Error("Cannot call start again");k.f=t.Started,k.c.fire(),k.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,R,$){if(k.f===t.Resolved)throw new Error("Cannot call resolve twice");k.f=t.Resolved,k.c.fire(),k.h.flush();const b=$?{message:$.message,stack:$.stack,location:$?.location?{startLineNumber:$.location.start.line,startColumn:$.location.start.character,endLineNumber:$.location.end.line,endColumn:$.location.end.character}:void 0,uri:$.uri}:void 0;k.n.$completeExecution(k.b,new u.$4w({runEndTime:R,lastRunSuccess:P,error:b}))},clearOutput(P){return k.t(),k.z([],P,!1)},appendOutput(P,R){return k.t(),k.z(P,R,!0)},replaceOutput(P,R){return k.t(),k.z(P,R,!1)},appendOutputItems(P,R){return k.t(),k.C(P,R,!0)},replaceOutputItems(P,R){return k.t(),k.C(P,R,!1)}})}}var l;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(l||(l={}));class m extends T.$Xc{static{this.a=0}get state(){return this.f}constructor(k,w,P){super(),this.h=w,this.j=P,this.b=m.a++,this.c=new N.$oe,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new C.$ze),this.j.$createNotebookExecution(this.b,k,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class g{constructor(k,w){this.f=k,this.g=w,this.a=[],this.b=Date.now()}addItem(k){return this.a.push(k),this.c||(this.c=new D.$6h,this.b=Date.now(),(0,D.$Jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const k=this.c;this.c=void 0;const w=this.a;return this.a=[],this.g(w).finally(()=>k.complete())}}function d(S,k){return`${S.value}/${k}`}}),define(Oe[57],Ae([1,0,6,5,3,2,16,4,7,9,13,180,19,38,181,182,35,10,8,34,37]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=e.$crc=e.$brc=e.$arc=void 0,e.$arc=(0,C.$Ii)("IExtHostTerminalService");class t extends O.$Xc{constructor($,b,L,A){super(),this.u=$,this._id=b,this.w=L,this.y=A,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new y.$oe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(Z=>this.g=Z);const M=this;this.value={get name(){return M.y||""},get processId(){return M.b},get creationOptions(){return M.w},get exitStatus(){return M.j},get state(){return M.m},get selection(){return M.n},get shellIntegration(){return M.shellIntegration},sendText(Z,G=!0){M.C(),M.u.$sendText(M._id,Z,G)},show(Z){M.C(),M.u.$show(M._id,Z)},hide(){M.C(),M.u.$hide(M._id)},dispose(){M.a||(M.a=!0,M.u.$dispose(M._id))},get dimensions(){if(!(M.f===void 0||M.h===void 0))return{columns:M.f,rows:M.h}}}}dispose(){this.s.fire(),super.dispose()}async create($,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??b?.cwd??void 0,env:$.env??void 0,icon:k($.iconPath)??void 0,color:a.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z($.location,b?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,b,L,A,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:A,color:a.ThemeColor.isThemeColor(M)?M.id:void 0,location:b?.location||this.z($,L),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z($,b){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in $?{viewColumn:u.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.y=$}setExitStatus($,b){this.j=Object.freeze({code:$,reason:b})}setDimensions($,b){return $===this.f&&b===this.h||$===0||b===0?!1:(this.f=$,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection($){this.n=$}_setProcessId($){this.g?(this.g($),this.g=void 0):this.b.then(b=>{b!==$&&(this.b=Promise.resolve($))})}}e.$brc=t;class o{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new y.$oe,this.onProcessData=this.a.event,this.b=new y.$oe,this.d=new y.$oe,this.onDidChangeProperty=this.d.event,this.f=new y.$oe,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,b){this.g.setDimensions?.({columns:$,rows:b})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:f.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:f.ProcessPropertyType.Title,value:b})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,m=class extends O.$Xc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,b,L){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new O.$Yc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$oe,this.onDidCloseTerminal=this.H.event,this.I=new y.$oe,this.onDidOpenTerminal=this.I.event,this.J=new y.$oe,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$oe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$oe,this.onDidChangeTerminalState=this.M.event,this.N=new y.$oe,this.onDidChangeShell=this.N.event,this.O=new y.$oe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$oe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=L.getProxy(D.$3N.MainThreadTerminalService),this.y=new r.$myb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:A=>{const M=Z=>{const G=Z;return this.getTerminalById(G.instanceId)?.value};switch(A?.$mid){case n.MarshalledId.TerminalContext:return M(A);default:{if(Array.isArray(A))for(let Z=0;Z<A.length&&A[Z].$mid===n.MarshalledId.TerminalContext;Z++)A[Z]=M(A[Z]);return A}}}}),this.B({dispose:()=>{for(const[A,M]of this.g)M.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,b){const L=new t(this.a,(0,E.$5g)(),$,$.name),A=new o($.pty);return L.createExtensionTerminal($.location,b,this.R($,b).resolvedExtHostIdentifier,k($.iconPath),w($.color)).then(M=>{const Z=this.S(M,A);this.h[M]=Z}),this.f.push(L),L.value}R($,b){if(b=b||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const L=$.location.parentTerminal;if(L){const A=this.f.find(M=>M.value===L);A&&(b.resolvedExtHostIdentifier=A._id)}}else $.location&&typeof $.location!="object"?b.location=$.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal($,b){if(!this.getTerminalById($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const A=new o(b),M=this.S($,A);this.h[$]=M}async $acceptActiveTerminalChanged($){const b=this.b;if($===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const L=this.getTerminalById($);L&&(this.b=L,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,b){const L=this.getTerminalById($);L&&this.O.fire({terminal:L.value,data:b})}async $acceptTerminalDimensions($,b,L){const A=this.getTerminalById($);A&&A.setDimensions(b,L)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand($,b){const L=this.getTerminalById($);L&&this.P.fire({terminal:L.value,...b})}async $acceptTerminalMaximumDimensions($,b,L){this.g.get($)?.resize(b,L)}async $acceptTerminalTitleChange($,b){const L=this.getTerminalById($);L&&(L.name=b)}async $acceptTerminalClosed($,b,L){const A=this.X(this.f,$);if(A!==null){const M=this.f.splice(A,1)[0];M.setExitStatus(b,L),this.H.fire(M.value)}}$acceptTerminalOpened($,b,L,A){if(b){const G=this.X(this.f,b);if(G!==null){this.f[G]._id=$,this.I.fire(this.terminals[G]),this.f[G].isOpen=!0;return}}const M={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:N.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},Z=new t(this.a,$,M,L);this.f.push(Z),this.I.fire(Z.value),Z.isOpen=!0}async $acceptTerminalProcessId($,b){this.getTerminalById($)?._setProcessId(b)}async $startExtensionTerminal($,b){const L=this.getTerminalById($);if(!L)return{message:(0,s.localize)(2712,null,$)};L.isOpen||await new Promise(M=>{const Z=this.onDidOpenTerminal(async G=>{G===L.value&&(Z.dispose(),M())})});const A=this.g.get($);A?A.startSendingEvents(b):this.j[$]={initialDimensions:b}}S($,b){const L=new O.$Wc;L.add(b.onProcessReady(M=>this.a.$sendProcessReady($,M.pid,M.cwd,M.windowsPty))),L.add(b.onDidChangeProperty(M=>this.a.$sendProcessProperty($,M))),this.y.startBuffering($,b.onProcessData),L.add(b.onProcessExit(M=>this.U($,M))),this.g.set($,b);const A=this.j[$];return A&&b instanceof o&&(b.startSendingEvents(A.initialDimensions),delete this.j[$]),L}$acceptProcessAckDataEvent($,b){this.g.get($)?.acknowledgeDataEvent(b)}$acceptProcessInput($,b){this.g.get($)?.input(b)}$acceptTerminalInteraction($){const b=this.getTerminalById($);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection($,b){this.getTerminalById($)?.setSelection(b)}$acceptProcessResize($,b,L){try{this.g.get($)?.resize(b,L)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown($,b){this.g.get($)?.shutdown(b)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(b=>this.a.$sendProcessProperty($,{type:f.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(b=>this.a.$sendProcessProperty($,{type:f.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new p.$5N(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,b,L){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,L),this.a.$registerProfileProvider(b,$.identifier.value),new p.$5N(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider($,b,L){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,L),this.a.$registerQuickFixProvider($,b),new p.$5N(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,b){const L=new h.$ze().token;if(L.isCancellationRequested)return;const A=this.D.get($);if(!A)return;const M=await A.provideTerminalQuickFixes(b,L);if(M===null||Array.isArray(M)&&M.length===0)return;const Z=new O.$Wc;if(this.w.value=Z,!Array.isArray(M))return M?u.TerminalQuickFix.from(M,this.Q.converter,Z):void 0;const G=[];for(const U of M){const V=u.TerminalQuickFix.from(U,this.Q.converter,Z);V&&G.push(V)}return G}async $createContributedProfileTerminal($,b){const L=new h.$ze().token;let A=await this.C.get($)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,b);return}this.createTerminalFromOptions(A.options,b)}}async $provideLinks($,b){const L=this.getTerminalById($);if(!L)return[];this.F.delete($),this.G.get($)?.dispose(!0);const M=new h.$ze;this.G.set($,M);const Z=[],G={terminal:L.value,line:b},U=[];for(const ne of this.z)U.push(c.Promises.withAsyncBody(async ue=>{M.token.onCancellationRequested(()=>ue({provider:ne,links:[]}));const x=await ne.provideTerminalLinks(G,M.token)||[];M.token.isCancellationRequested||ue({provider:ne,links:x})}));const V=await Promise.all(U);if(M.token.isCancellationRequested)return[];const Q=new Map;for(const ne of V)ne&&ne.links.length>0&&Z.push(...ne.links.map(ue=>{const x={id:l++,startIndex:ue.startIndex,length:ue.length,label:ue.tooltip};return Q.set(x.id,{provider:ne.provider,link:ue}),x}));return this.F.set($,Q),Z}$activateLink($,b){const L=this.F.get($)?.get(b);L&&L.provider.handleTerminalLink(L.link)}U($,b){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const L=this.h[$];L&&(L.dispose(),delete this.h[$]),this.a.$sendProcessExit($,b)}getTerminalById($){return this.W(this.f,$)}getTerminalIdByApiObject($){const b=this.f.findIndex(L=>L.value===$);return b>=0?b:null}W($,b){const L=this.X($,b);return L!==null?$[L]:null}X($,b){const L=$.findIndex(A=>A._id===b);return L>=0?L:null}getEnvironmentVariableCollection($){let b=this.n.get($.identifier.value);return b||(b=this.B(new g),this.Z($.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y($,b){const L=(0,v.$Ks)(b.map),A=(0,v.$Ls)(b.descriptionMap);this.a.$setEnvironmentVariableCollection($,b.persistent,L.length===0?void 0:L,A)}$initEnvironmentVariableCollections($){$.forEach(b=>{const L=b[0],A=this.B(new g(b[1]));this.Z(L,A)})}$acceptDefaultProfile($,b){const L=this.s;this.s=$,this.u=b,L?.path!==$.path&&this.N.fire($.path)}Z($,b){this.n.set($,b),this.B(b.onDidChangeCollection(()=>{this.Y($,b)}))}};e.$crc=m,e.$crc=m=Xe([Qe(1,i.$ZQ),Qe(2,T.$DQ)],m);class g extends O.$Xc{get persistent(){return this.b}set persistent($){this.b=$,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor($){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new y.$oe,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const b=this.j($);let L=this.a.get(b);return L||(L=new d(this,$),this.a.set(b,L),this.B(L.onDidChangeCollection(()=>this.f.fire()))),L}replace($,b,L,A){this.g($,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:L??{applyAtProcessCreation:!0},scope:A})}append($,b,L,A){this.g($,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:L??{applyAtProcessCreation:!0},scope:A})}prepend($,b,L,A){this.g($,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:L??{applyAtProcessCreation:!0},scope:A})}g($,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h($,b.scope),A=this.map.get(L),M=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==b.value||A.type!==b.type||A.options?.applyAtProcessCreation!==M.applyAtProcessCreation||A.options?.applyAtShellIntegration!==M.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const Z=this.h($,b.scope),G={variable:$,...b,options:M};this.map.set(Z,G),this.f.fire()}}get($,b){const L=this.h($,b),A=this.map.get(L);return A?P(A):void 0}h($,b){const L=this.j(b);return L.length?`${$}:::${L}`:$}j($){return this.m($?.workspaceFolder)??""}m($){return $?$.uri.toString():void 0}getVariableMap($){const b=new Map;for(const[L,A]of this.map)this.j(A.scope)===this.j($)&&b.set(A.variable,P(A));return b}delete($,b){const L=this.h($,b);this.map.delete(L),this.f.fire()}clear($){if($?.workspaceFolder){for(const[b,L]of this.map)L.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(b);this.n($)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription($,b){const L=this.j(b),A=this.descriptionMap.get(L);if(!A||A.description!==$){let M;typeof $=="string"?M=$:M=$?.value.split(`

`)[0];const Z={description:M,scope:b};this.descriptionMap.set(L,Z),this.f.fire()}}getDescription($){const b=this.j($);return this.descriptionMap.get(b)?.description}n($){const b=this.j($);this.descriptionMap.delete(b)}}class d{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,b){this.b=$,this.d=b,this.a=new y.$oe}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,b,L){this.b.replace($,b,L,this.d)}append($,b,L){this.b.append($,b,L,this.d)}prepend($,b,L){this.b.prepend($,b,L,this.d)}get($){return this.b.get($,this.d)}forEach($,b){this.b.getVariableMap(this.d).forEach((L,A)=>$.call(b,A,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends m{constructor($,b){super(!1,$,b)}createTerminal($,b,L){throw new I.$bb}createTerminalFromOptions($,b){throw new I.$bb}};e.$drc=S,e.$drc=S=Xe([Qe(0,i.$ZQ),Qe(1,T.$DQ)],S);function k(R){if(!(!R||typeof R=="string"))return"id"in R?{id:R.id,color:R.color}:R}function w(R){return a.ThemeColor.isThemeColor(R)?R:void 0}function P(R){const $={...R};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Oe[128],Ae([1,0,7,4,3,5,16,57,6,2,10]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tsc=e.$ssc=void 0,e.$ssc=(0,C.$Ii)("IExtHostTerminalShellIntegration");let v=class extends D.$Xc{constructor(a,c){super(),this.h=c,this.b=new Map,this.c=new p.$oe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$oe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$oe,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(N.$3N.MainThreadTerminalShellIntegration),this.B((0,D.$Vc)(()=>{for(const[u,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(a){const c=this.h.getTerminalById(a);if(!c)return;const u=c.value;let i=this.b.get(a);i||(i=new h(c.value,this.f),this.b.set(a,i),i.store.add(c.onWillDispose(()=>this.b.get(a)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(a,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),c.shellIntegration=i.value),this.c.fire({terminal:u,shellIntegration:i.value})}$shellExecutionStart(a,c,u,i,n){this.b.has(a)||this.$shellIntegrationChange(a);const t={value:c,confidence:u,isTrusted:i};this.b.get(a)?.startShellExecution(t,s.URI.revive(n))}$shellExecutionEnd(a,c,u,i,n){const t={value:c,confidence:u,isTrusted:i};this.b.get(a)?.endShellExecution(t,n)}$shellExecutionData(a,c){this.b.get(a)?.emitData(c)}$cwdChange(a,c){this.b.get(a)?.setCwd(s.URI.revive(c))}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$tsc=v,e.$tsc=v=Xe([Qe(0,T.$DQ),Qe(1,O.$arc)],v);class h extends D.$Xc{get currentExecution(){return this.a}constructor(a,c){super(),this.j=a,this.m=c,this.b=!1,this.store=this.B(new D.$Wc),this.f=this.B(new p.$oe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$oe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$oe),this.onDidRequestEndExecution=this.h.event;const u=this;this.value={get cwd(){return u.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(m=>`${m.replaceAll('"','\\"')}`).join('" "')}"`),u.g.fire(t);const o={value:t,confidence:y.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=u.startShellExecution(o,u.c,!0).value;return u.b=!0,l}}}startShellExecution(a,c,u){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(a,c??this.c);u?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,c){this.a&&(this.a.endExecution(a),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(a){let c=!1;s.URI.isUri(this.c)?c=!s.URI.isUri(a)||this.c.toString()!==a.toString():this.c!==a&&(c=!0),c&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(a,c){this.c=a,this.cwd=c,this.b=!1;const u=this;this.value={get commandLine(){return u.c},get cwd(){return u.cwd},read(){return u.d()}}}d(){if(!this.a){if(this.b)return I.$9h.EMPTY;this.a=new f}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a){a&&(this.c=a),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends D.$Xc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Hh);const a=this.a;return new I.$9h(async u=>{this.b.push(u),await a.wait()})}emitData(a){for(const c of this.b)c.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Oe[129],Ae([1,0,62,13,97,8,7]),function($e,e,y,D,C,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=e.$KQ=void 0,N=He(N);class O{static{this.c=new C.$IQ("TextEditorDecorationType")}constructor(h,E,f){const r=O.c.nextId();h.$registerTextEditorDecorationType(E.identifier,r,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){h.$removeTextEditorDecorationType(r)}})}}e.$KQ=O;class p{constructor(h,E){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,E){this.k();let f=null;if(h instanceof T.$6N)f=new T.$7N(h,h);else if(h instanceof T.$7N)f=h;else throw new Error("Unrecognized location");this.l(f,E,!1)}insert(h,E){this.k(),this.l(new T.$7N(h,h),E,!0)}delete(h){this.k();let E=null;if(h instanceof T.$7N)E=h;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(h,E,f){const r=this.c.validateRange(h);this.g.push({range:r,text:E,forceMoveMarkers:f})}setEndOfLine(h){if(this.k(),h!==T.EndOfLine.LF&&h!==T.EndOfLine.CRLF)throw(0,D.$9)("endOfLine");this.h=h}}class s{constructor(h,E,f,r){this.c=h,this.d=E,this._accept(f),this.e=r;const a=this;this.value={get tabSize(){return a.f},set tabSize(c){a.n(c)},get indentSize(){return a.g},set indentSize(c){a.p(c)},get insertSpaces(){return a.j},set insertSpaces(c){a.s(c)},get cursorStyle(){return a.k},set cursorStyle(c){a.t(c)},get lineNumbers(){return a.l},set lineNumbers(c){a.u(c)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.originalIndentSize,this.j=h.insertSpaces,this.k=h.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(h.lineNumbers)}m(h){if(h==="auto")return"auto";if(typeof h=="number"){const E=Math.floor(h);return E>0?E:null}if(typeof h=="string"){const E=parseInt(h,10);return isNaN(E)?null:E>0?E:null}return null}n(h){const E=this.m(h);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const E=Math.floor(h);return E>0?E:null}if(typeof h=="string"){const E=parseInt(h,10);return isNaN(E)?null:E>0?E:null}return null}p(h){const E=this.o(h);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(h){return h==="auto"?"auto":h==="false"?!1:!!h}s(h){const E=this.q(h);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(h){this.k!==h&&(this.k=h,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}u(h){this.l!==h&&(this.l=h,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(h)})))}assign(h){const E={};let f=!1;if(typeof h.tabSize<"u"){const r=this.m(h.tabSize);r==="auto"?(f=!0,E.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,f=!0,E.tabSize=r)}if(typeof h.indentSize<"u"){const r=this.o(h.indentSize);r==="tabSize"?(f=!0,E.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,f=!0,E.indentSize=r)}if(typeof h.insertSpaces<"u"){const r=this.q(h.insertSpaces);r==="auto"?(f=!0,E.insertSpaces=r):this.j!==r&&(this.j=r,f=!0,E.insertSpaces=r)}typeof h.cursorStyle<"u"&&this.k!==h.cursorStyle&&(this.k=h.cursorStyle,f=!0,E.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.l!==h.lineNumbers&&(this.l=h.lineNumbers,f=!0,E.lineNumbers=N.TextEditorLineNumbersStyle.from(h.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(h,E){E.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(f)})}}e.$LQ=s;class I{constructor(h,E,f,r,a,c,u,i){this.id=h,this.j=E,this.k=f,this.g=!1,this.h=new Set,this.c=a,this.d=new s(this.j,this.id,c,f),this.e=u,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new D.$$("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof T.$8N))throw(0,D.$9)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof T.$8N)))throw(0,D.$9)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new D.$$("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new D.$$("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new p(r.value,o);return t(l),n.m(l)},insertSnippet(t,o,l={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!o||Array.isArray(o)&&o.length===0)m=n.c.map(g=>N.Range.from(g));else if(o instanceof T.$6N){const{lineNumber:g,column:d}=N.Position.from(o);m=[{startLineNumber:g,startColumn:d,endLineNumber:g,endColumn:d}]}else if(o instanceof T.$7N)m=[N.Range.from(o)];else{m=[];for(const g of o)if(g instanceof T.$7N)m.push(N.Range.from(g));else{const{lineNumber:d,column:S}=N.Position.from(g);m.push({startLineNumber:d,startColumn:S,endLineNumber:d,endColumn:S})}}return E.$tryInsertSnippet(h,r.value.version,t.value,m,l)},setDecorations(t,o){const l=o.length===0;l&&!n.h.has(t.key)||(l?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(N.$AQ(o))return E.$trySetDecorations(h,t.key,N.$BQ(o));{const m=new Array(4*o.length);for(let g=0,d=o.length;g<d;g++){const S=o[g];m[4*g]=S.start.line+1,m[4*g+1]=S.start.character+1,m[4*g+2]=S.end.line+1,m[4*g+3]=S.end.character+1}return E.$trySetDecorationsFast(h,t.key,m)}}))},revealRange(t,o){n.n(()=>E.$tryRevealRange(h,N.Range.from(t),o||T.TextEditorRevealType.Default))},show(t){E.$tryShowEditor(h,N.ViewColumn.from(t))},hide(){E.$tryHideEditor(h)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,y.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,y.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,y.ok)(!this.g),this.f=h}_acceptSelections(h){(0,y.ok)(!this.g),this.c=h}async l(){const h=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const E=h.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const f=E.edits.map(a=>a.range);f.sort((a,c)=>a.end.line===c.end.line?a.end.character===c.end.character?a.start.line===c.start.line?a.start.character-c.start.character:a.start.line-c.start.line:a.end.character-c.end.character:a.end.line-c.end.line);for(let a=0,c=f.length-1;a<c;a++){const u=f[a].end;if(f[a+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=E.edits.map(a=>({range:N.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,r,{setEndOfLine:typeof E.setEndOfLine=="number"?N.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$MQ=I}),define(Oe[58],Ae([1,0,62,6,4,2,3,5,125,16,129,8,11,28,15,40,48]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=void 0,y=He(y),v=He(v);class c{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let u=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new E.$Dc,this.d=new D.$oe,this.e=new D.$oe,this.f=new D.$oe,this.g=new D.$oe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],o=[],l=[];if(n.removedDocuments)for(const m of n.removedDocuments){const g=N.URI.revive(m),d=this.c.get(g);d?.unref()&&(this.c.delete(g),t.push(d.value))}if(n.addedDocuments)for(const m of n.addedDocuments){const g=N.URI.revive(m.uri);let d=this.c.get(g);if(d&&g.scheme!==f.Schemas.vscodeNotebookCell&&g.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);d||(d=new c(new p.$GQ(this.h.getProxy(O.$3N.MainThreadDocuments),g,m.lines,m.EOL,m.versionId,m.languageId,m.isDirty)),this.c.set(g,d),o.push(d.value)),d.ref()}if(n.removedEditors)for(const m of n.removedEditors){const g=this.b.get(m);this.b.delete(m),g&&l.push(g)}if(n.addedEditors)for(const m of n.addedEditors){const g=N.URI.revive(m.documentUri);y.ok(this.c.has(g),`document '${g}' does not exist`),y.ok(!this.b.has(m.id),`editor '${m.id}' already exists!`);const d=this.c.get(g).value,S=new I.$MQ(m.id,this.h.getProxy(O.$3N.MainThreadTextEditors),this.i,new a.$W(()=>d.document),m.selections.map(v.Selection.to),m.options,m.visibleRanges.map(k=>v.Range.to(k)),typeof m.editorPosition=="number"?v.ViewColumn.to(m.editorPosition):void 0);this.b.set(m.id,S)}n.newActiveEditor!==void 0&&(y.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,C.$Sc)(t),(0,C.$Sc)(l),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(o),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(m=>m.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$NQ=u,e.$NQ=u=Xe([Qe(0,s.$DQ),Qe(1,h.$dk)],u),e.$OQ=(0,T.$Ii)("IExtHostDocumentsAndEditors")}),define(Oe[96],Ae([1,0,10,22,19,6,231,76,4,37,14,2,38,3,11,5,34,58,16,127,8,7,200,55,82,56,24]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l,m,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrc=e.$xrc=e.$wrc=e.$vrc=e.$urc=void 0,n=He(n);let S=0;const k=new WeakMap;e.$urc=(0,E.$Ii)("IExtHostTesting");let w=class extends p.$Xc{constructor(x,oe,se,ce){super(),this.C=oe,this.D=se,this.F=ce,this.f=this.B(new N.$oe),this.g=new Map,this.w=this.B(new N.$oe),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=x.getProxy(r.$3N.MainThreadTesting),this.m=new G(this.h),this.j=new b(this.h,oe),se.registerArgumentProcessor({processArgument:te=>{switch(te?.$mid){case s.MarshalledId.TestItemContext:{const we=te,Ce=we.tests[we.tests.length-1].item.extId;return this.g.get(l.$lJ.root(Ce))?.collection.tree.get(Ce)?.actual??(0,i.$PQ)(te)}case s.MarshalledId.TestMessageMenuArgs:{const{test:we,message:Ce}=te,Y=we.item.extId;return{test:this.g.get(l.$lJ.root(Y))?.collection.tree.get(Y)?.actual??(0,i.$PQ)({$mid:s.MarshalledId.TestItemContext,tests:[we]}),message:n.TestMessage.to(Ce)}}default:return te}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const te=await se.executeCommand(o.TestCommandId.GetExplorerSelection),we=Ce=>{const Y=this.g.get(l.$lJ.root(Ce));if(Y)return l.$lJ.isRoot(Ce)?Y.controller:Y.collection.tree.get(Ce)?.actual};return{include:te?.include.map(we).filter(I.$pg)||[],exclude:te?.exclude.map(we).filter(I.$pg)||[]}})}createTestController(x,oe,se,ce){if(this.g.has(oe))throw new Error(`Attempt to insert a duplicate controller with ID "${oe}"`);const te=new p.$Wc,we=te.add(new i.$SQ(oe,se,this.F));we.root.label=se;const Ce=new Map,Y=new Set,W=this.h,ee=()=>{let je=0;ce&&(je|=g.TestControllerCapability.Refresh);const Te=Pe.relatedCodeProvider;return Te&&(Te?.provideRelatedTests&&(je|=g.TestControllerCapability.TestRelatedToCode),Te?.provideRelatedCode&&(je|=g.TestControllerCapability.CodeRelatedToTest)),je},be={items:we.root.children,get label(){return se},set label(je){se=je,we.root.label=je,W.$updateController(oe,{label:se})},get refreshHandler(){return ce},set refreshHandler(je){ce=je,W.$updateController(oe,{capabilities:ee()})},get id(){return oe},get relatedCodeProvider(){return Pe.relatedCodeProvider},set relatedCodeProvider(je){(0,d.$vH)(x,"testRelatedCode"),Pe.relatedCodeProvider=je,W.$updateController(oe,{capabilities:ee()})},createRunProfile:(je,Te,Ee,Fe,Ve,Ge)=>{let et=(0,O.$wj)(je);for(;Ce.has(et);)et++;return new V(this.h,Ce,Y,this.w.event,oe,et,je,Te,Ee,Fe,Ve,Ge)},createTestItem(je,Te,Ee){return new i.$QQ(oe,je,Te,Ee)},createTestRun:(je,Te,Ee=!0)=>this.j.createTestRun(x,oe,we,je,Te,Ee),invalidateTestResults:je=>{if(je===void 0)this.h.$markTestRetired(void 0);else{const Te=je instanceof Array?je:[je];this.h.$markTestRetired(Te.map(Ee=>l.$lJ.fromExtHostTestItem(Ee,oe).toString()))}},set resolveHandler(je){we.resolveHandler=je},get resolveHandler(){return we.resolveHandler},dispose:()=>{te.dispose()}},Pe={controller:be,collection:we,profiles:Ce,extension:x,activeProfiles:Y};return W.$registerTestController(oe,se,ee()),te.add((0,p.$Vc)(()=>W.$unregisterTestController(oe))),this.g.set(oe,Pe),te.add((0,p.$Vc)(()=>this.g.delete(oe))),te.add(we.onDidGenerateDiff(je=>W.$publishDiff(oe,je.map(g.TestsDiffOp.serialize)))),be}createTestObserver(){return this.m.checkout()}async runTests(x,oe=C.CancellationToken.None){const se=L(x);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(se.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:x.preserveFocus??!0,group:Q[se.kind],targets:[{testIds:x.include?.map(te=>l.$lJ.fromExtHostTestItem(te,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:x.exclude?.map(te=>te.id)},oe)}registerTestFollowupProvider(x){return this.y.add(x),{dispose:()=>{this.y.delete(x)}}}async $getTestsRelatedToCode(x,oe,se){const ce=this.F.getDocument(v.URI.revive(x));if(!ce)return[];const te=n.Position.to(oe),we=[];return await Promise.all([...this.g.values()].map(async Ce=>{let Y;try{Y=await Ce.relatedCodeProvider?.provideRelatedTests?.(ce.document,te,se)}catch(W){se.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Ce.controller.label}`,W)}if(Y){for(const W of Y)we.push(l.$lJ.fromExtHostTestItem(W,Ce.controller.id).toString());Ce.collection.flushDiff()}})),we}async $getCodeRelatedToTest(x,oe){const se=this.g.get(l.$lJ.root(x));if(!se)return[];const ce=se.collection.tree.get(x);return ce?(await se.relatedCodeProvider?.provideRelatedCode?.(ce.actual,oe))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:x}of this.g.values())x.flushDiff();return Promise.resolve()}async $getCoverageDetails(x,oe,se){return(await this.j.getCoverageDetails(x,oe,se))?.map(n.TestCoverage.fromDetails)}async $disposeRun(x){this.j.disposeTestRun(x)}$configureRunProfile(x,oe){this.g.get(x)?.profiles.get(oe)?.configureHandler?.()}$setDefaultRunProfiles(x){const oe=new Map;for(const[se,ce]of Object.entries(x)){const te=this.g.get(se);if(!te)continue;const we=new Map,Ce=ce.filter(W=>!te.activeProfiles.has(W)),Y=[...te.activeProfiles].filter(W=>!ce.includes(W));for(const W of Ce)we.set(W,!0),te.activeProfiles.add(W);for(const W of Y)we.set(W,!1),te.activeProfiles.delete(W);we.size&&oe.set(se,we)}this.w.fire(oe)}async $refreshTests(x,oe){await this.g.get(x)?.controller.refreshHandler?.(oe)}$publishTestResults(x){this.results=Object.freeze(x.map(oe=>{const se=n.TestResults.to(oe);return k.set(se,oe.id),se}).concat(this.results).sort((oe,se)=>se.completedAt-oe.completedAt).slice(0,32)),this.f.fire()}async $expandTest(x,oe){const se=this.g.get(l.$lJ.fromString(x).controllerId)?.collection;se&&(await se.expand(x,oe<0?1/0:oe),se.flushDiff())}$acceptDiff(x){this.m.applyDiff(x.map(oe=>g.TestsDiffOp.deserialize({asCanonicalUri:se=>se},oe)))}async $runControllerTests(x,oe){return Promise.all(x.map(se=>this.G(se,!1,oe)))}async $startContinuousRun(x,oe){const se=new C.$ze(oe),ce=await Promise.all(x.map(te=>this.G(te,!0,se.token)));return!oe.isCancellationRequested&&!ce.some(te=>te.error)&&await new Promise(te=>oe.onCancellationRequested(te)),se.dispose(!0),ce}async $provideTestFollowups(x,oe){const se=this.results.find(we=>k.get(we)===x.resultId),ce=se&&ne(l.$lJ.fromString(x.extId),se?.results);if(!ce)return[];let te=[];return await Promise.all([...this.y].map(async we=>{try{const Ce=await we.provideFollowup(se,ce,x.taskIndex,x.messageIndex,oe);Ce&&(te=te.concat(Ce))}catch(Ce){this.C.error("Error thrown while providing followup for test message",Ce)}})),oe.isCancellationRequested?[]:te.map(we=>{const Ce=S++;return this.z.set(Ce,we),{title:we.title,id:Ce}})}$disposeTestFollowups(x){for(const oe of x)this.z.delete(oe)}$executeTestFollowup(x){const oe=this.z.get(x);return oe?this.D.executeCommand(oe.command,...oe.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(x,oe){x===void 0?this.j.cancelAllRuns():this.j.cancelRunById(x,oe)}getMetadataForRun(x){for(const oe of this.j.trackers){const se=oe.getTaskIdForRun(x);if(se)return{taskId:se,runId:oe.id}}}async G(x,oe,se){const ce=this.g.get(x.controllerId);if(!ce)return{};const{collection:te,profiles:we,extension:Ce}=ce,Y=we.get(x.profileId);if(!Y)return{};const W=x.testIds.map(je=>te.tree.get(je)).filter(I.$pg),ee=x.excludeExtIds.map(je=>ce.collection.tree.get(je)).filter(I.$pg).filter(je=>W.some(Te=>Te.fullId.compare(je.fullId)===l.TestPosition.IsChild));if(!W.length)return{};const be=new t.$HP(W.some(je=>je.actual instanceof i.$RQ)?void 0:W.map(je=>je.actual),ee.map(je=>je.actual),Y,oe),Pe=(0,g.$oJ)(x)&&this.j.prepareForMainThreadTestRun(Ce,be,A.fromInternal(x,ce.collection),Y,se);try{return await Y.runHandler(be,se),{}}catch(je){return{error:String(je)}}finally{Pe&&Pe.hasRunningTasks&&!se.isCancellationRequested&&await N.Event.toPromise(Pe.onEnd)}}};e.$vrc=w,e.$vrc=w=Xe([Qe(0,u.$DQ),Qe(1,f.$dk),Qe(2,a.$ZQ),Qe(3,c.$OQ)],w);const P=1e4;var R;(function(ue){ue[ue.Running=0]="Running",ue[ue.Cancelling=1]="Cancelling",ue[ue.Ended=2]="Ended"})(R||(R={}));class $ extends p.$Xc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(x,oe,se,ce,te,we){super(),this.C=x,this.D=oe,this.F=se,this.G=ce,this.H=te,this.f=R.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new N.$oe),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new C.$ze(we));const Ce=this.B(new y.$Uh(()=>this.I(),P));this.B(this.m.token.onCancellationRequested(()=>Ce.schedule()));const Y=new N.$oe;this.y=Y.event,this.B((0,p.$Vc)(()=>{Y.fire(),Y.dispose()}))}getTaskIdForRun(x){for(const[oe,{run:se}]of this.h)if(se===x)return oe}cancel(x){x?this.h.get(x)?.cts.cancel():this.f===R.Running?(this.m.cancel(),this.f=R.Cancelling):this.f===R.Cancelling&&this.I()}async getCoverageDetails(x,oe,se){const[,ce]=l.$lJ.fromString(x).path,te=this.z.get(x);if(!te)return[];const{report:we,extIds:Ce}=te,Y=this.h.get(ce);if(!Y)throw new Error("unreachable: run task was not found");let W;if(oe&&we instanceof t.$NP){const be=Ce.indexOf(oe);if(be===-1)return[];W=we.fromTests[be]}return await(W?this.G?.loadDetailedCoverageForTest?.(Y.run,we,W,se):this.G?.loadDetailedCoverage?.(Y.run,we,se))??[]}createRun(x){const oe=this.C.id,se=this.C.controllerId,ce=(0,h.$5g)(),te=ee=>(be,...Pe)=>{if(Ce){this.F.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.L(be),ee(be,...Pe)},we=(ee,be)=>{const Pe=be instanceof Array?be.map(n.TestMessage.from):[n.TestMessage.from(be)];if(ee.uri&&ee.range){const je={range:n.Range.from(ee.range),uri:ee.uri};for(const Te of Pe)Te.location=Te.location||je}this.D.$appendTestMessagesInRun(oe,ce,l.$lJ.fromExtHostTestItem(ee,se).toString(),Pe)};let Ce=!1;const Y=this.B(new C.$ze(this.m.token)),W={isPersisted:this.C.isPersisted,token:Y.token,name:x,onDidDispose:this.y,addCoverage:ee=>{if(Ce)return;const be=ee instanceof t.$NP?ee.fromTests:[];if(be.length){(0,d.$vH)(this.H,"attributableCoverage");for(const Te of be)this.L(Te)}const Pe=ee.uri.toString(),je=new l.$lJ([oe,ce,Pe]).toString();this.z.set(je,{report:ee,extIds:be.map(Te=>l.$lJ.fromExtHostTestItem(Te,se).toString())}),this.D.$appendCoverage(oe,ce,n.TestCoverage.fromFile(se,je,ee))},enqueued:te(ee=>{this.D.$updateTestStateInRun(oe,ce,l.$lJ.fromExtHostTestItem(ee,se).toString(),g.TestResultState.Queued)}),skipped:te(ee=>{this.D.$updateTestStateInRun(oe,ce,l.$lJ.fromExtHostTestItem(ee,se).toString(),g.TestResultState.Skipped)}),started:te(ee=>{this.D.$updateTestStateInRun(oe,ce,l.$lJ.fromExtHostTestItem(ee,se).toString(),g.TestResultState.Running)}),errored:te((ee,be,Pe)=>{we(ee,be),this.D.$updateTestStateInRun(oe,ce,l.$lJ.fromExtHostTestItem(ee,se).toString(),g.TestResultState.Errored,Pe)}),failed:te((ee,be,Pe)=>{we(ee,be),this.D.$updateTestStateInRun(oe,ce,l.$lJ.fromExtHostTestItem(ee,se).toString(),g.TestResultState.Failed,Pe)}),passed:te((ee,be)=>{this.D.$updateTestStateInRun(oe,ce,l.$lJ.fromExtHostTestItem(ee,this.C.controllerId).toString(),g.TestResultState.Passed,be)}),appendOutput:(ee,be,Pe)=>{Ce||(Pe&&this.L(Pe),this.D.$appendOutputToRun(oe,ce,D.$Qe.fromString(ee),be&&n.location.from(be),Pe&&l.$lJ.fromExtHostTestItem(Pe,se).toString()))},end:()=>{Ce||(Ce=!0,this.D.$finishedTestRunTask(oe,ce),--this.g||this.J())}};return this.g++,this.h.set(ce,{run:W,cts:Y}),this.D.$startedTestRunTask(oe,{id:ce,ctrlId:this.C.controllerId,name:x||this.H.displayName||this.H.identifier.value,running:!0}),W}I(){for(const{run:x}of this.h.values())x.end()}J(){this.f!==R.Ended&&(this.f=R.Ended,this.w.fire())}L(x){if(!(x instanceof i.$QQ))throw new m.$vQ(x.id);if(this.j.has(l.$lJ.fromExtHostTestItem(x,this.C.controllerId).toString()))return;const oe=[],se=this.C.colllection.root;for(;;){const ce=n.TestItem.from(x);if(oe.unshift(ce),this.j.has(ce.extId)||(this.j.add(ce.extId),x===se))break;x=x.parent||se}this.D.$addTestsToRun(this.C.controllerId,this.C.id,oe)}dispose(){this.J(),super.dispose()}}class b{get trackers(){return this.f.values()}constructor(x,oe){this.h=x,this.j=oe,this.f=new Map,this.g=new Map}getCoverageDetails(x,oe,se){const ce=l.$lJ.root(x);return this.g.get(ce)?.getCoverageDetails(x,oe,se)||[]}disposeTestRun(x){this.g.get(x)?.dispose(),this.g.delete(x);for(const[oe,{id:se}]of this.f)se===x&&this.f.delete(oe)}prepareForMainThreadTestRun(x,oe,se,ce,te){return this.k(oe,se,ce,x,te)}cancelRunById(x,oe){this.g.get(x)?.cancel(oe)}cancelAllRuns(){for(const x of this.f.values())x.cancel()}createTestRun(x,oe,se,ce,te,we){const Ce=this.f.get(ce);if(Ce)return Ce.createRun(te);const Y=A.fromPublic(oe,se,ce,we),W=L(ce);this.h.$startedExtensionTestRun({controllerId:oe,continuous:!!ce.continuous,profile:W&&{group:Q[W.kind],id:W.profileId},exclude:ce.exclude?.map(be=>l.$lJ.fromExtHostTestItem(be,se.root.id).toString())??[],id:Y.id,include:ce.include?.map(be=>l.$lJ.fromExtHostTestItem(be,se.root.id).toString())??[se.root.id],preserveFocus:ce.preserveFocus??!0,persist:we});const ee=this.k(ce,Y,ce.profile,x);return N.Event.once(ee.onEnd)(()=>{this.h.$finishedExtensionTestRun(Y.id)}),ee.createRun(te)}k(x,oe,se,ce,te){const we=new $(oe,this.h,this.j,se,ce,te);return this.f.set(x,we),this.g.set(we.id,we),we}}e.$wrc=b;const L=ue=>{if(ue.profile){if(!(ue.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ue.profile}};class A{static fromPublic(x,oe,se,ce){return new A(x,(0,h.$5g)(),ce,oe)}static fromInternal(x,oe){return new A(x.controllerId,x.runId,!0,oe)}constructor(x,oe,se,ce){this.controllerId=x,this.id=oe,this.isPersisted=se,this.colllection=ce}}e.$xrc=A;class M{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(x){this.k=x,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(x){this.f.add(x)}update(x){Object.assign(x.revived,n.TestItem.toPlain(x.item)),this.f.has(x)||this.g.add(x)}remove(x){if(this.f.has(x)){this.f.delete(x);return}this.g.delete(x);const oe=l.$lJ.parentId(x.item.extId);if(oe&&this.j.has(oe.toString())){this.j.add(x.item.extId);return}this.h.add(x)}getChangeEvent(){const{f:x,g:oe,h:se}=this;return{get added(){return[...x].map(ce=>ce.revived)},get updated(){return[...oe].map(ce=>ce.revived)},get removed(){return[...se].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class Z extends g.$uJ{constructor(){super(...arguments),this.z=new N.$oe,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(x){return this.g.get(x)}getMirroredTestDataByReference(x){return this.g.get(x.id)}y(x,oe){return{...x,revived:n.TestItem.toPlain(x.item),depth:oe?oe.depth+1:0,children:new Set}}x(){return new M(this.z)}}class G{constructor(x){this.g=x}checkout(){this.f||(this.f=this.h());const x=this.f;return x.observers++,{onDidChangeTest:x.tests.onDidChangeTests,get tests(){return[...x.tests.rootTests].map(oe=>oe.revived)},dispose:(0,T.$fb)(()=>{--x.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(x){return this.f?.tests.getMirroredTestDataByReference(x)}applyDiff(x){this.f?.tests.apply(x)}h(){const x=new Z({asCanonicalUri:oe=>oe});return this.g.$subscribeToDiffs(),{observers:0,tests:x}}}const U=(ue,x,oe,se)=>{oe?Object.assign(oe,se):x.$updateTestRunConfig(ue.controllerId,ue.profileId,se)};class V{#e;#t;#i;#n;#s;get label(){return this.g}set label(x){x!==this.g&&(this.g=x,U(this,this.#e,this.#n,{label:x}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(x){x!==this.h&&(this.h=x,U(this,this.#e,this.#n,{supportsContinuousRun:x}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(x){x!==this.isDefault&&(x?this.#t.add(this.profileId):this.#t.delete(this.profileId),U(this,this.#e,this.#n,{isDefault:x}))}get tag(){return this._tag}set tag(x){x?.id!==this._tag?.id&&(this._tag=x,U(this,this.#e,this.#n,{tag:x?n.TestTag.namespace(this.controllerId,x.id):null}))}get configureHandler(){return this.f}set configureHandler(x){x!==this.f&&(this.f=x,U(this,this.#e,this.#n,{hasConfigurationHandler:!!x}))}get onDidChangeDefault(){return N.Event.chain(this.#i,x=>x.map(oe=>oe.get(this.controllerId)?.get(this.profileId)).filter(I.$pg))}constructor(x,oe,se,ce,te,we,Ce,Y,W,ee=!1,be=void 0,Pe=!1){this.controllerId=te,this.profileId=we,this.g=Ce,this.kind=Y,this.runHandler=W,this._tag=be,this.h=Pe,this.#e=x,this.#s=oe,this.#t=se,this.#i=ce,oe.set(we,this);const je=Q[Y];if(typeof je!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);ee&&se.add(we),this.#n={profileId:we,controllerId:te,tag:be?n.TestTag.namespace(this.controllerId,be.id):null,label:Ce,group:je,isDefault:ee,hasConfigurationHandler:!1,supportsContinuousRun:Pe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$yrc=V;const Q={[t.TestRunProfileKind.Coverage]:g.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:g.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:g.TestRunProfileBitset.Run};function ne(ue,x){for(let oe=0;oe<ue.path.length;oe++){const se=x.find(ce=>ce.id===ue.path[oe]);if(!se)return;if(oe===ue.path.length-1)return se;x=se.children}}}),define(Oe[259],Ae([1,0,17,6,4,5,129,8,7]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=void 0,y=He(y),O=He(O);class s extends C.$Xc{constructor(v,h){super(),this.m=h,this.a=new D.$oe,this.b=new D.$oe,this.c=new D.$oe,this.f=new D.$oe,this.g=new D.$oe,this.h=new D.$oe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=v.getProxy(N.$3N.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(v){const h=this.m.allEditors();return v?h:h.map(E=>E.value)}async showTextDocument(v,h,E){let f;typeof h=="number"?f={position:O.ViewColumn.from(h),preserveFocus:E}:typeof h=="object"?f={position:O.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selection:typeof h.selection=="object"?O.Range.from(h.selection):void 0,pinned:typeof h.preview=="boolean"?!h.preview:void 0}:f={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(v.uri,f),a=r&&this.m.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}createTextEditorDecorationType(v,h){return new T.$KQ(this.j,v,h).value}$acceptEditorPropertiesChanged(v,h){const E=this.m.getEditor(v);if(!E)throw new Error("unknown text editor");if(h.options&&E._acceptOptions(h.options),h.selections){const f=h.selections.selections.map(O.Selection.to);E._acceptSelections(f)}if(h.visibleRanges){const f=y.$Jb(h.visibleRanges.map(O.Range.to));E._acceptVisibleRanges(f)}if(h.options&&this.b.fire({textEditor:E.value,options:{...h.options,lineNumbers:O.TextEditorLineNumbersStyle.to(h.options.lineNumbers)}}),h.selections){const f=p.TextEditorSelectionChangeKind.fromValue(h.selections.source),r=h.selections.selections.map(O.Selection.to);this.a.fire({textEditor:E.value,selections:r,kind:f})}if(h.visibleRanges){const f=y.$Jb(h.visibleRanges.map(O.Range.to));this.c.fire({textEditor:E.value,visibleRanges:f})}}$acceptEditorPositionData(v){for(const h in v){const E=this.m.getEditor(h);if(!E)throw new Error("Unknown text editor");const f=O.ViewColumn.to(v[h]);E.value.viewColumn!==f&&(E._acceptViewColumn(f),this.f.fire({textEditor:E.value,viewColumn:f}))}}getDiffInformation(v){return Promise.resolve(this.j.$getDiffInformation(v))}}e.$Fqc=s}),define(Oe[260],Ae([1,0,2,3,5,4,7,8,18,37,14]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsc=e.$vsc=void 0,e.$vsc=(0,D.$Ii)("IExtHostTimeline");class v{constructor(f,r){this.b=new Map,this.c=new Map,this.a=f.getProxy(C.$3N.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(a,c)=>{if(a&&a.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(a.source)&&p.$un.equals(c,this.b.get(a.source)?.extension)){const u=a.uri===void 0?void 0:y.URI.revive(a.uri);return this.c.get(a.source)?.get(h(u))?.get(a.handle)}else return;return a}})}async $getTimeline(f,r,a,c){return this.b.get(f)?.provider.provideTimeline(y.URI.revive(r),a,c)}registerTimelineProvider(f,r,a,c){const u=new N.$Wc,i=this.d(r.id,c,u).bind(this);let n;r.onDidChange&&(n=r.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:r.id}),this));const t=this.c;return this.f({...r,scheme:f,onDidChange:void 0,async provideTimeline(o,l,m){l?.resetCache&&(u.clear(),t.get(r.id)?.clear());const g=await r.provideTimeline(o,l,m);if(g==null)return;const d=i(o,l);return{...g,source:r.id,items:g.items.map(d)}},dispose(){for(const o of t.values())o.get(r.id)?.clear();n?.dispose(),u.dispose()}},a)}d(f,r,a){return(c,u)=>{let i;if(u?.cacheResults){let n=this.c.get(f);n===void 0&&(n=new Map,this.c.set(f,n));const t=h(c);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...o}=n,l=`${f}|${n.id??n.timestamp}`;i?.set(l,n);let m,g,d;n.iconPath&&(t instanceof T.$4O?d={id:t.id,color:t.color}:y.URI.isUri(t)?(m=t,g=t):{light:m,dark:g}=t);let S;return T.$wO.isMarkdownString(o.tooltip)?S=O.MarkdownString.from(o.tooltip):(0,I.$hg)(o.tooltip)?S=o.tooltip:T.$wO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=O.MarkdownString.from(o.detail)):(0,I.$hg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=o.detail),{...o,id:o.id??void 0,handle:l,source:f,command:n.command?r.toInternal(n.command,a):void 0,icon:m,iconDark:g,themeIcon:d,tooltip:S,accessibilityInformation:n.accessibilityInformation}}}}f(f,r){if(this.b.get(f.id))throw new Error(`Timeline Provider ${f.id} already exists.`);return this.a.$registerTimelineProvider({id:f.id,label:f.label,scheme:f.scheme}),this.b.set(f.id,{provider:f,extension:r}),(0,N.$Vc)(()=>{for(const c of this.c.values())c.get(f.id)?.clear();this.b.delete(f.id),this.a.$unregisterTimelineProvider(f.id),f.dispose()})}}e.$wsc=v;function h(E){return E?.toString()}}),define(Oe[261],Ae([1,0,9,23,2,6,4,192,10,7,14,17,8,60,19,164,24]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xsc=void 0,s=He(s);function c(n,t){if((0,I.$hg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let o;return Array.isArray(n.highlights)&&(o=n.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),o=o.length?o:void 0),{label:n.label,highlights:o}}}class u extends T.$Xc{constructor(t,o,l){super(),this.f=t,this.g=o,this.h=l,this.a=new Map,this.b=new r.$0_;function m(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:g=>m(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(d=>m(d)?this.r(d):d):g})}registerTreeDataProvider(t,o,l){const m=this.createTreeView(t,{treeDataProvider:o},l);return{dispose:()=>m.dispose()}}createTreeView(t,o,l){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=o.dragAndDropController?.dropMimeTypes??[],g=o.dragAndDropController?.dragMimeTypes??[],d=!!o.dragAndDropController?.handleDrag,S=!!o.dragAndDropController?.handleDrop,k=this.m(t,o,l),w={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:m,dragMimeTypes:g,hasHandleDrag:d,hasHandleDrop:S,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},P=this.f.$registerTreeViewDataProvider(t,w),R={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,a.$vH)(l,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,a.$vH)(l,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message($){(0,E.$9k)($)&&(0,a.$vH)(l,"treeViewMarkdownMessage"),k.message=$},get title(){return k.title},set title($){k.title=$},get description(){return k.description},set description($){k.description=$},get badge(){return k.badge},set badge($){$!==void 0&&s.ViewBadge.isViewBadge($)?k.badge={value:Math.floor(Math.abs($.value)),tooltip:$.tooltip}:$===void 0&&(k.badge=void 0)},reveal:($,b)=>k.reveal($,b),dispose:async()=>{await P,this.a.delete(t),k.dispose()}};return this.B(R),R}$getChildren(t,o){const l=this.a.get(t);return l?l.getChildren(o):Promise.reject(new O.$PG(t))}async $handleDrop(t,o,l,m,g,d,S,k){const w=this.a.get(t);if(!w)return Promise.reject(new O.$PG(t));const P=h.DataTransfer.toDataTransfer(l,async R=>(await this.f.$resolveDropFileData(t,o,R)).buffer);return S===t&&k&&await this.j(P,w,k,g,d),w.onDrop(P,m,g)}async j(t,o,l,m,g){const d=this.b.removeDragOperationTransfer(g);if(d)(await d)?.forEach((S,k)=>{S&&t.set(k,S)});else if(g&&o.handleDrag){const S=o.handleDrag(l,t,m);this.b.addDragOperationTransfer(g,S),await S}return t}async $handleDrag(t,o,l,m){const g=this.a.get(t);if(!g)return Promise.reject(new O.$PG(t));const d=await this.j(new s.$ZO,g,o,m,l);if(!(!d||m.isCancellationRequested))return h.DataTransfer.from(d)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new O.$PG(t);return o.hasResolve}$resolve(t,o,l){const m=this.a.get(t);if(!m)throw new O.$PG(t);return m.resolveTreeItem(o,l)}$setExpanded(t,o,l){const m=this.a.get(t);if(!m)throw new O.$PG(t);m.setExpanded(o,l)}$setSelectionAndFocus(t,o,l){const m=this.a.get(t);if(!m)throw new O.$PG(t);m.setSelectionAndFocus(o,l)}$setVisible(t,o){const l=this.a.get(t);if(!l){if(!o)return;throw new O.$PG(t)}l.setVisible(o)}$changeCheckboxState(t,o){const l=this.a.get(t);if(!l)throw new O.$PG(t);l.setCheckboxState(o)}m(t,o,l){const m=this.B(new i(t,o,this.f,this.g.converter,this.h,l));return this.a.set(t,m),m}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$xsc=u;class i extends T.$Xc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$qg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,l,m,g,d){if(super(),this.I=t,this.J=l,this.L=m,this.M=g,this.N=d,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$oe),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$oe),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$oe),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$oe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$oe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$oe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$oe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$ze,d.contributes&&d.contributes.views)for(const P in d.contributes.views)for(const R of d.contributes.views[P])R.id===t&&(this.P=R.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(P=>{Array.isArray(P)&&P.length===0||this.F.fire({message:!1,element:P})}));let S,k;const w=N.Event.debounce(this.F.event,(P,R)=>(P||(P={message:!1,elements:[]}),R.element!==!1&&(S||(S=new Promise($=>k=$),this.G=this.G.then(()=>S)),Array.isArray(R.element)?P.elements.push(...R.element):P.elements.push(R.element)),R.message&&(P.message=!0),P),200,!0);this.B(w(({message:P,elements:R})=>{R.length&&(this.H=this.H.then(()=>{const $=k;return S=null,this.$(R).then(()=>$())})),P&&this.J.$setMessage(this.I,h.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(o)),l?l.map(m=>m.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const l=(0,I.$qg)(o.select)?!0:o.select,m=(0,I.$qg)(o.focus)?!1:o.focus,g=(0,I.$qg)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(d=>this.W(t,d[d.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:d.map(k=>k.item)},{select:l,focus:m,expand:g})),d=>this.M.error(d)):this.J.$reveal(this.I,void 0,{select:l,focus:m,expand:g})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=h.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const l=this.getExtensionElement(t);l&&(o?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,o){const l=!(0,v.$wb)(this.s,t);this.s=t;const m=this.t!==o;this.t=o,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),m&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async l=>{const m=this.getExtensionElement(l.treeItemHandle);return m?{extensionItem:m,treeItem:await this.f.getTreeItem(m),newState:l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);o.forEach(l=>{l.treeItem.checkboxState=l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,o,l){const m=[];for(const g of t){const d=this.getExtensionElement(g);d&&m.push(d)}if(!(!this.g?.handleDrag||m.length===0))return await this.g.handleDrag(m,o,l),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,l){const m=o?this.getExtensionElement(o):void 0;if(!(!m&&o||!this.g?.handleDrop))return(0,p.$Ah)(()=>this.g?.handleDrop?this.g.handleDrop(m,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const m=this.m.get(l);if(m){const g=await this.f.resolveTreeItem(m.extensionItem,l,o)??m.extensionItem;return this.hb(g),m.item.tooltip=this.eb(g.tooltip),m.item.command=this.fb(m.disposableStore,g.command),m.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(l=>this.W(o,l[l.length-1]).then(m=>(l.push(m),l))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,p.$Ah)(()=>this.f.getParent(t))}W(t,o){const l=this.m.get(t);return l?Promise.resolve(l):(0,p.$Ah)(()=>this.f.getTreeItem(t)).then(m=>this.kb(t,m,o,!0)).then(m=>this.getChildren(o?o.item.handle:void 0).then(()=>{const g=this.getExtensionElement(m);if(g){const d=this.m.get(g);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${m} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const l=this.getExtensionElement(t);o=l?this.m.get(l):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new f.$ze(this.Z.token);try{const l=t?this.m.get(t):void 0,m=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const g=(0,v.$Jb)(m||[]),d=await Promise.all((0,v.$Jb)(g).map(k=>this.f.getTreeItem(k)));if(o.token.isCancellationRequested)return;const S=d.map((k,w)=>k?this.db(g[w],k,l):null);return(0,v.$Jb)(S)}finally{o.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new f.$ze,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const o=new Set,l=t.map(g=>this.m.get(g));for(const g of l)if(g&&!o.has(g.item.handle)){let d=g;for(;d&&d.parent&&l.findIndex(S=>d&&d.parent&&S&&S.item.handle===d.parent.item.handle)===-1;){const S=this.j.get(d.parent.item.handle);d=S?this.m.get(S):void 0}d&&!d.parent&&o.add(g.item.handle)}const m=[];return o.forEach(g=>{const d=this.j.get(g);if(d){const S=this.m.get(d);S&&(!S.parent||!o.has(S.parent.item.handle))&&m.push(g)}}),m}bb(t){const o={};return Promise.all(t.map(l=>this.cb(l).then(m=>{m&&(o[l]=m.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const l=this.m.get(o);if(l)return this.rb(o),(0,p.$Ah)(()=>this.f.getTreeItem(o)).then(m=>{if(m){const g=this.ib(o,m,l.parent);return this.pb(o,g,l,l.parent),l.dispose(),g}return null})}return Promise.resolve(null)}db(t,o,l){const m=this.ib(t,o,l);if(o.id&&this.j.has(m.item.handle))throw new Error((0,y.localize)(2713,null,o.id));return this.ob(t,m),this.qb(m,l),m}eb(t){return s.$wO.isMarkdownString(t)?h.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,l,m;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,l=t.checkboxState.tooltip,m=t.checkboxState.accessibilityInformation),{isChecked:o===s.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:m}}hb(t){if(!s.$UO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,l){this.hb(o);const m=this.B(new T.$Wc),g=this.kb(t,o,l),d=this.lb(o);return{item:{handle:g,parentHandle:l?l.item.handle:void 0,label:c(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(m,o.command),contextValue:o.contextValue,icon:d,iconDark:this.mb(o)||d,themeIcon:this.jb(o),collapsibleState:(0,I.$qg)(o.collapsibleState)?s.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:l,children:void 0,disposableStore:m,dispose(){m.dispose()}}}jb(t){return t.iconPath instanceof s.$4O?t.iconPath:void 0}kb(t,{id:o,label:l,resourceUri:m},g,d){if(o)return`${i.b}/${o}`;const S=c(l,this.N),k=g?g.item.handle:i.a;let w=S?S.label:m?(0,D.$gh)(m):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const P=this.m.has(t)?this.m.get(t).item.handle:void 0,R=this.X(g)||[];let $,b=0;do{if($=`${k}/${b}:${w}`,d||!this.j.has($)||P===$)break;b++}while(b<=R.length);return $}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$4O))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$4O)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,l,m){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,o);const g=this.X(m)||[],d=g.filter(S=>S.item.handle===l.item.handle)[0];d&&g.splice(g.indexOf(d),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const l of o.children){const m=this.j.get(l.item.handle);m&&this.sb(m)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const l of o.children){const m=this.j.get(l.item.handle);m&&this.sb(m)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Oe[262],Ae([1,0,6,4,2,38,8,68,5,7]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=void 0,T=He(T),p=He(p),s=He(s);class I extends D.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(f,r,a,c){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new y.$oe),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$oe),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=r,this.#n=a,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#l=c.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,C.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(f){this.#u||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#l=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:T.ViewColumn.from(f),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class v extends D.$Xc{static c(){return(0,N.$5g)()}constructor(f,r,a){super(),this.j=r,this.m=a,this.g=new Map,this.h=new Map,this.f=f.getProxy(p.$3N.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,r,a,c,u={}){const i=typeof c=="object"?c.viewColumn:c,n={viewColumn:T.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},t=(0,O.$Uqc)(f),o=v.c();this.f.$createWebviewPanel((0,O.$Wqc)(f),o,r,{title:a,panelOptions:h(u),webviewOptions:(0,O.$Xqc)(f,this.m,u),serializeBuffersForPostMessage:t},n);const l=this.j.createNewWebview(o,u,f);return this.createNewWebviewPanel(o,r,a,i,u,l,!0)}$onDidChangeWebviewPanelViewStates(f){const r=Object.keys(f);r.sort((a,c)=>{const u=f[a],i=f[c];return u.active?1:i.active?-1:+u.visible-+i.visible});for(const a of r){const c=this.getWebviewPanel(a);if(!c)continue;const u=f[a];c._updateViewState({active:u.active,visible:u.visible,viewColumn:T.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,r,a){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:a,extension:f}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,O.$Uqc)(f)}),new s.$5N(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(f,r,a,c){const u=this.h.get(r);if(!u)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=u,t=this.j.createNewWebview(f,a.webviewOptions,n),o=this.createNewWebviewPanel(f,r,a.title,c,a.panelOptions,t,a.active);await i.deserializeWebviewPanel(o,a.state)}createNewWebviewPanel(f,r,a,c,u,i,n){const t=new I(f,this.f,i,{viewType:r,title:a,viewColumn:c,panelOptions:u,active:n});return this.g.set(f,t),t}getWebviewPanel(f){return this.g.get(f)}}e.$Yqc=v;function h(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Oe[263],Ae([1,0,6,4,68,8,5,7]),function($e,e,y,D,C,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Asc=void 0,T=He(T),O=He(O);class p extends D.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(v,h,E,f,r,a){super(),this.#s=!1,this.#l=this.B(new y.$oe),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new y.$oe),this.onDidDispose=this.#u.event,this.#i=E,this.#a=f,this.#e=v,this.#t=h,this.#n=r,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(v){this.a(),this.#a!==v&&(this.#a=v,this.#t.$setWebviewViewTitle(this.#e,v))}get description(){return this.a(),this.#o}set description(v){this.a(),this.#o!==v&&(this.#o=v,this.#t.$setWebviewViewDescription(this.#e,v))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(v){v===this.#r||this.#s||(this.#r=v,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(v){this.a(),!(v?.value===this.#c?.value&&v?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(v),this.#t.$setWebviewViewBadge(this.#e,v))}show(v){this.a(),this.#t.$show(this.#e,!!v)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(v,h){this.d=h,this.b=new Map,this.c=new Map,this.a=v.getProxy(T.$3N.MainThreadWebviewViews)}registerWebviewViewProvider(v,h,E,f){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:E,extension:v}),this.a.$registerWebviewViewProvider((0,C.$Wqc)(v),h,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Uqc)(v)}),new O.$5N(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(v,h,E,f,r){const a=this.b.get(h);if(!a)throw new Error(`No view provider found for '${h}'`);const{provider:c,extension:u}=a,i=this.d.createNewWebview(v,{},u),n=new p(v,this.a,h,E,i,!0);this.c.set(v,n),await c.resolveWebviewView(n,{state:f},r)}async $onDidChangeWebviewViewVisibility(v,h){this.e(v)._setVisible(h)}async $disposeWebviewView(v){const h=this.e(v);this.c.delete(v),h.dispose(),this.d.deleteWebview(v)}e(v){const h=this.c.get(v);if(!h)throw new Error("No webview found");return h}}e.$Asc=s}),define(Oe[264],Ae([1,0,6,30,31,3]),function($e,e,y,D,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.OutputChannelUpdateMode=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=void 0,e.$0M="text/x-code-output",e.$$M="Log",e.$_M="text/x-code-log-output",e.$aN="log",e.$bN="workbench.panel.output",e.$cN=new C.$Zj("inOutput",!1),e.$dN=new C.$Zj("activeLogOutput",!1),e.$eN=new C.$Zj("activeLogOutput.levelSettable",!1),e.$fN=new C.$Zj("activeLogOutput.level",""),e.$gN=new C.$Zj("activeLogOutput.levelIsDefault",!1),e.$hN=new C.$Zj("outputView.scrollLock",!1),e.$iN=(0,N.$Ii)("outputService");var T;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$jN={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new y.$oe,this.onDidRegisterChannel=this.b.event,this.c=new y.$oe,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(I=>s.push(I)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}D.$uo.add(e.$jN.OutputChannels,new O),e.$kN=new C.$Zj("activeOutputChannel","")}),define(Oe[130],Ae([1,0,5,3,16,18,11,264,69,26,51,166,22,14,29,6,4]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$esc=e.$dsc=void 0;class c extends T.$jk{get disposed(){return this.n}constructor(t,o,l,m,g){super(),this.id=t,this.name=o,this.r=l,this.s=m,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,O.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=h.$Qe.fromString(o).byteLength,(0,T.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class u extends c{appendLine(t){this.append(t)}}let i=class{constructor(t,o,l,m,g,d){this.i=o,this.j=l,this.k=m,this.l=g,this.m=d,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(y.$3N.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,v.$7m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,l]of this.g)l.visible=o===this.h}createOutputChannel(t,o,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const m=typeof o=="object"&&o.log,g=(0,E.$hg)(o)?o:void 0;if((0,E.$hg)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const S=this.i.environment.extensionLogLevel?.find(([w])=>N.$un.equals(l.identifier,w))?.[1];S&&(d=(0,T.$uk)(S));const k=m?this.o(t,d,l):this.n(t,g,l);return k.then(w=>{this.g.set(w.id,w),w.visible=w.id===this.h}),m?this.r(t,d??this.m.getLevel(),k):this.q(t,k)}async n(t,o,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const m=await this.c,g=this.k.extUri.joinPath(m,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,g,o,l.identifier.value);return new c(S,t,d,this.a,l)}async o(t,o,l){const m=await this.p(l),g=t.replace(/[\\/:\*\?"<>\|]/g,""),d=this.k.extUri.joinPath(m,`${g}.log`),S=`${l.identifier.value}.${g}`,k=this.l.createLogger(d,{id:S,name:t,logLevel:o,extensionId:l.identifier.value});return new u(S,t,k,this.a,l)}p(t){let o=this.d.get(t.identifier.value);if(!o){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(l)}catch(m){if((0,f.$tl)(m)!==f.FileSystemProviderErrorCode.FileExists)throw m}return l})())}return o}q(t,o){let l=!1;const m=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(g){m(),o.then(d=>d.append(g))},appendLine(g){m(),o.then(d=>d.appendLine(g))},clear(){m(),o.then(g=>g.clear())},replace(g){m(),o.then(d=>d.replace(g))},show(g,d){m(),o.then(S=>S.show(g,d))},hide(){m(),o.then(g=>g.hide())},dispose(){l=!0,o.then(g=>g.dispose())}}}r(t,o,l){const m=new a.$Wc,g=()=>{if(m.isDisposed)throw new Error("Channel has been closed")},d=m.add(new r.$oe);function S(k){o=k,d.fire(k)}return l.then(k=>{m.add(k),k.logLevel!==o&&S(k.logLevel),m.add(k.onDidChangeLogLevel(w=>S(w)))}),{...this.q(t,l),get logLevel(){return o},onDidChangeLogLevel:d.event,trace(k,...w){g(),l.then(P=>P.trace(k,...w))},debug(k,...w){g(),l.then(P=>P.debug(k,...w))},info(k,...w){g(),l.then(P=>P.info(k,...w))},warn(k,...w){g(),l.then(P=>P.warn(k,...w))},error(k,...w){g(),l.then(P=>P.error(k,...w))},dispose(){m.dispose()}}}};e.$dsc=i,e.$dsc=i=Xe([Qe(0,C.$DQ),Qe(1,s.$TQ),Qe(2,p.$Qqc),Qe(3,I.$tqc),Qe(4,T.$ek),Qe(5,T.$dk)],i),e.$esc=(0,D.$Ii)("IExtHostOutputService")}),define(Oe[131],Ae([1,0,3,10]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=void 0,e.$Zm=(0,y.$Ii)("remoteAgentService"),e.$1m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let N=1/0;for(let O=0;O<this.maxSampleCount;O++){const p=await C.getRoundTripTime();if(p===void 0)return;N=Math.min(N,p/2),await(0,D.$Jh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(N):T=this.initial.reduce((O,p)=>O+p,0)/this.initial.length,this.lastMeasurement={initial:T,current:N,average:this.average.reduce((O,p)=>O+p,0)/this.average.length,high:typeof T>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(Oe[265],Ae([1,0,9,54,30,50,43,4,6,131,21,25,10,115]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=void 0,e.$uL=Object.freeze({id:"application",order:100,title:(0,y.localize)(3973,null),type:"object"}),e.$vL=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(3974,null),type:"object"}),e.$wL=Object.freeze({id:"security",scope:D.ConfigurationScope.APPLICATION,title:(0,y.localize)(3975,null),type:"object",order:7}),e.$xL=Object.freeze({id:"problems",title:(0,y.localize)(3976,null),type:"object",order:101}),e.$yL=Object.freeze({id:"window",order:8,title:(0,y.localize)(3977,null),type:"object"}),e.$zL={ConfigurationMigration:"base.contributions.configuration.migration"};class f{constructor(){this.migrations=[],this.a=new p.$oe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new f;C.$uo.add(e.$zL.ConfigurationMigration,r);let a=class extends O.$Xc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const l of o.added)await this.f(l,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(o=>this.g(o,n?.uri))])}async g(n,t){const o=this.a.inspect(n.key,{resource:t}),l=this.b.getWorkbenchState()===N.WorkbenchState.WORKSPACE?[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE],["workspaceFolder",T.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE]];for(const[m,g]of l){const d=o[m];if(!d)continue;const S=[];if(d.value!==void 0){const k=await this.h(n,m,d.value,t,void 0);for(const w of k??[])S.push([w,[]])}for(const{identifiers:k,value:w}of d.overrides??[])if(w!==void 0){const P=await this.h(n,m,w,t,k);for(const R of P??[])S.push([R,k])}S.length&&await Promise.allSettled(S.map(async([[k,w],P])=>this.a.updateValue(k,w.value,{resource:t,overrideIdentifiers:P},g)))}}async h(n,t,o,l,m){const g=S=>{const w=this.a.inspect(S,{resource:l})[t];if(w)return m?w.overrides?.find(({identifiers:P})=>(0,v.$lo)(P,m))?.value:w.value},d=await n.migrateFn(o,g);return Array.isArray(d)?d:[[n.key,d]]}};e.$AL=a,e.$AL=a=Xe([Qe(0,T.$cj),Qe(1,N.$Ri)],a);let c=class extends O.$Xc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new h.$6h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;C.$uo.as(D.$zo.Configuration).registerConfiguration({...e.$wL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(3978,null)},default:[],markdownDescription:(0,y.localize)(3979,null),scope:D.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(3980,null),scope:D.ConfigurationScope.MACHINE}}})}};e.$BL=c,e.$BL=c=Xe([Qe(0,s.$Zm)],c),e.$CL="window.newWindowProfile";let u=class extends O.$Xc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==T.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$CL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=C.$uo.as(D.$zo.Configuration),t={...e.$yL,properties:{[e.$CL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,y.localize)(3981,null)],description:(0,y.localize)(3982,null),scope:D.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$CL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$CL);if(!n)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$CL,t?.name)}};e.$DL=u,e.$DL=u=Xe([Qe(0,E.$Pl),Qe(1,T.$cj)],u)}),define(Oe[266],Ae([1,0,41,15,20,23,9,265,54,3,30]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$FL=e.$EL=void 0,e.$GL=r,e.$HL=a,y=He(y),e.$EL=(0,s.$Ii)("editorResolverService"),e.$FL="workbench.editorAssociations";const v=I.$uo.as(p.$zo.Configuration),h={...O.$vL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(12210,null),additionalProperties:{type:"string"}}}};v.registerConfiguration(h);var E;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(E||(e.RegisteredEditorPriority=E={}));var f;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function r(c){switch(c){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function a(c,u){if(new Set([D.Schemas.extension,D.Schemas.webviewPanel,D.Schemas.vscodeWorkspaceTrust,D.Schemas.vscodeSettings]).has(u.scheme))return!1;const t=typeof c=="string"&&c.indexOf(C.$jc.sep)>=0?`${u.scheme}:${u.path}`:(0,N.$gh)(u);return y.$Ck(typeof c=="string"?c.toLowerCase():c,t.toLowerCase())}}),define(Oe[267],Ae([1,0,52,15,20,21,23,2,3,186,50,205,131]),function($e,e,y,D,C,N,T,O,p,s,I,v,h){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=void 0,e.$CN=(0,p.$Ii)("pathService");let f=E=class{constructor(a,c,u,i){this.d=a,this.e=c,this.f=u,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??a})()}hasValidBasename(a,c,u){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(a,i,c)):this.h(a,c,u)}h(a,c,u){return a.scheme===D.Schemas.file||a.scheme===D.Schemas.vscodeRemote?(0,y.$Fg)(u??(0,T.$gh)(a),c===N.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,c){if(a.remoteAuthority)return D.Schemas.vscodeRemote;const u=(0,s.$zN)(c.getWorkspace());if(u)return u;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=c.getWorkspace().configuration;return n?n.scheme:D.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===N.OperatingSystem.Windows?C.$ic:C.$jc)}async fileURI(a){let c="";if(await this.a===N.OperatingSystem.Windows&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const i=a.indexOf("/",2);i===-1?(c=a.substring(2),a="/"):(c=a.substring(2,i),a=a.substring(i)||"/")}return O.URI.from({scheme:D.Schemas.file,authority:c,path:a,query:"",fragment:""})}};e.$DN=f,e.$DN=f=E=Xe([Qe(1,h.$Zm),Qe(2,v.$lN),Qe(3,I.$Ri)],f)}),define(Oe[59],Ae([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.$eM=e.$dM=e.$cM=e.$bM=void 0;class y{constructor(s,I){this.line=s,this.character=I}isBefore(s){return!1}isBeforeOrEqual(s){return!1}isAfter(s){return!1}isAfterOrEqual(s){return!1}isEqual(s){return!1}compareTo(s){return 0}translate(s,I){return new y(0,0)}with(s){return new y(0,0)}}e.$bM=y;class D{constructor(s,I,v,h){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(s,I),this.end=new y(v,h)}contains(s){return!1}isEqual(s){return!1}intersection(s){}union(s){return new D(0,0,0,0)}with(s){return new D(0,0,0,0)}}e.$cM=D;class C{constructor(s,I,v){this.uri=s,this.ranges=I,this.previewText=v}}e.$dM=C;class N{constructor(s,I,v){this.uri=s,this.text=I,this.lineNumber=v}}e.$eM=N;var T;(function(p){p[p.None=1]="None",p[p.FilesExclude=2]="FilesExclude",p[p.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(T||(e.ExcludeSettingOptions=T={}));var O;(function(p){p[p.Information=1]="Information",p[p.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}))}),define(Oe[44],Ae([1,0,17,41,25,52,12,3,20,13,59,10]),function($e,e,y,D,C,N,T,O,p,s,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=e.$CM=e.$vM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sM=e.$rM=e.$qM=e.$pM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.TextSearchCompleteMessageType=void 0,e.$mM=c,e.$nM=u,e.$oM=i,e.$tM=k,e.$uM=w,e.$wM=$,e.$xM=b,e.$yM=L,e.$zM=A,e.$AM=M,e.$BM=Z,e.$DM=U,e.$FM=ne,e.$GM=ue,e.$HM=oe,D=He(D),C=He(C),N=He(N),p=He(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$fM="workbench.view.search",e.$gM="workbench.panel.search",e.$hM="workbench.view.search",e.$iM="search-result",e.$jM="search.exclude",e.$kM=2e4;const h="\u27EA ",E=" characters skipped \u27EB",f=(h.length+E.length+5)*2;e.$lM=(0,O.$Ii)("searchService");var r;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var a;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(a||(e.QueryType=a={}));function c(se){return!!se.rangeLocations&&!!se.previewText}function u(se){return!!se.resource}function i(se){return!!se.message}var n;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$pM=t;class o{constructor(ce,te,we,Ce){this.rangeLocations=[],this.webviewIndex=Ce;const Y=Array.isArray(te)?te:[te];if(we&&we.matchLines===1&&l(Y)){ce=(0,T.$ag)(ce,we.matchLines);let W="",ee=0,be=0;const Pe=Math.floor(we.charsPerLine/5);for(const je of Y){const Te=Math.max(je.startColumn-Pe,0),Ee=je.startColumn+we.charsPerLine;if(Te>be+Pe+f){const Fe=h+(Te-be)+E;W+=Fe+ce.slice(Te,Ee),ee+=Te-(be+Fe.length)}else W+=ce.slice(be,Ee);be=Ee,this.rangeLocations.push({source:je,preview:new g(0,je.startColumn-ee,je.endColumn-ee)})}this.previewText=W}else{const W=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber,ee=(0,y.$3b)(te,be=>({preview:new m(be.startLineNumber-W,be.startColumn,be.endLineNumber-W,be.endColumn),source:be}));this.rangeLocations=Array.isArray(ee)?ee:[ee],this.previewText=ce}}}e.$qM=o;function l(se){const ce=se[0].startLineNumber;for(const te of se)if(te.startLineNumber!==ce||te.endLineNumber!==ce)return!1;return!0}class m{constructor(ce,te,we,Ce){this.startLineNumber=ce,this.startColumn=te,this.endLineNumber=we,this.endColumn=Ce}}e.$rM=m;class g extends m{constructor(ce,te,we){super(ce,te,ce,we)}}e.$sM=g;var d;(function(se){se.List="list",se.Tree="tree"})(d||(e.ViewMode=d={}));var S;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function k(se,ce=!0){const te=se&&se.files&&se.files.exclude,we=ce&&se&&se.search&&se.search.exclude;if(!te&&!we)return;if(!te||!we)return te||we||void 0;let Ce=Object.create(null);return Ce=C.$ko(Ce,C.$ho(te)),Ce=C.$ko(Ce,C.$ho(we),!0),Ce}function w(se,ce){return se.excludePattern&&D.$Ck(se.excludePattern,ce)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&D.$Ck(se.includePattern,ce)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(te=>{const we=te.folder.fsPath;if(N.$Hg(ce,we)){const Ce=p.$oc(we,ce);return!te.includePattern||!!D.$Ck(te.includePattern,Ce)}else return!1}):!1:!0}var P;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(P||(e.SearchErrorCode=P={}));class R extends Error{constructor(ce,te){super(ce),this.code=te}}e.$vM=R;function $(se){const ce=se.message;if((0,s.$6)(se))return new R(ce,P.canceled);try{const te=JSON.parse(ce);return new R(te.message,te.code)}catch{return new R(ce,P.other)}}function b(se){const ce={message:se.message,code:se.code};return new Error(JSON.stringify(ce))}function L(se){return se.type==="error"?!0:se.type==="success"}function A(se){return se.type==="success"}function M(se){return!!se.path}function Z(se,ce,te=!0){const we=se.searchPath?se.searchPath:se.relativePath;return te?(0,T.$0f)(we,ce):D.$Ck(ce,we)}class G{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CM=G;function U(se,ce){const te={...se||{},...ce||{}};return Object.keys(te).filter(we=>{const Ce=te[we];return typeof Ce=="boolean"&&Ce})}class V{constructor(ce,te){this.c=null,this.a={...ce.excludePattern||{},...te.excludePattern?.pattern||{}},this.b=D.$Dk(this.a);let we=ce.includePattern;te.includePattern&&(we?we={...we,...te.includePattern}:we=te.includePattern),we&&(this.c=D.$Dk(we))}matchesExcludesSync(ce,te,we){return!!(this.b&&this.b(ce,te,we))}includedInQuerySync(ce,te,we){return!(this.b&&this.b(ce,te,we)||this.c&&!this.c(ce,te,we))}includedInQuery(ce,te,we){const Ce=this.b(ce,te,we),Y=()=>this.c?!!this.c(ce,te,we):!0;return(0,v.$uh)(Ce)?Ce.then(W=>W?!1:Y()):Y()}hasSiblingExcludeClauses(){return Q(this.a)}}e.$EM=V;function Q(se){for(const ce in se)if(typeof se[ce]!="boolean")return!0;return!1}function ne(se){if(!se)return;let ce;return te=>(ce||(ce=(se()||Promise.resolve([])).then(we=>we?x(we):{})),ce.then(we=>!!we[te]))}function ue(se){if(!se)return;let ce;return te=>{if(!ce){const we=se();ce=we?x(we):{}}return!!ce[te]}}function x(se){const ce={};for(const te of se)ce[te]=!0;return ce}function oe(se,ce){return ce.map(te=>se?{baseUri:se,pattern:te}:te)}}),define(Oe[45],Ae([1,0,17,10,19,6,4,49,15,141,23,12,2,9,29,3,11,174,50,51,26,16,8,7,66,44,5,33,59]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l,m,g,d,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=e.$Kqc=void 0;function w(Z,G,U){return new I.$$g(V=>b(V,U)).isEqual(Z,G)}function P(Z,G,U){return w(Z.uri,G.uri,U)?0:(0,v.$Bf)(Z.uri.toString(),G.uri.toString())}function R(Z,G,U){return Z.index!==G.index?Z.index<G.index?-1:1:w(Z.uri,G.uri,U)?(0,v.$Bf)(Z.name,G.name):(0,v.$Bf)(Z.uri.toString(),G.uri.toString())}function $(Z,G,U,V){const Q=Z.slice(0).sort((ue,x)=>U(ue,x,V)),ne=G.slice(0).sort((ue,x)=>U(ue,x,V));return(0,y.$Gb)(Q,ne,(ue,x)=>U(ue,x,V))}function b(Z,G){const U=G.getCapabilities(Z.scheme);return!(U&&U&f.FileSystemProviderCapabilities.PathCaseSensitive)}class L extends u.$2i{static toExtHostWorkspace(G,U,V,Q){if(!G)return{workspace:null,added:[],removed:[]};const{id:ne,name:ue,folders:x,configuration:oe,transient:se,isUntitled:ce}=G,te=[],we=U;U?x.forEach((ee,be)=>{const Pe=h.URI.revive(ee.uri),je=L.o(V||U,Pe,Q);je?(je.name=ee.name,je.index=ee.index,te.push(je)):te.push({uri:Pe,name:ee.name,index:be})}):te.push(...x.map(({uri:ee,name:be,index:Pe})=>({uri:h.URI.revive(ee),name:be,index:Pe}))),te.sort((ee,be)=>ee.index<be.index?-1:1);const Ce=new L(ne,ue,te,!!se,oe?h.URI.revive(oe):null,!!ce,ee=>b(ee,Q)),{added:Y,removed:W}=$(we?we.workspaceFolders:[],Ce.workspaceFolders,P,Q);return{workspace:Ce,added:Y,removed:W}}static o(G,U,V){for(let Q=0;Q<G.folders.length;Q++){const ne=G.workspaceFolders[Q];if(w(ne.uri,U,V))return ne}}constructor(G,U,V,Q,ne,ue,x){super(G,V.map(oe=>new u.$3i(oe)),Q,ne,x),this.t=U,this.u=ue,this.q=[],this.s=O.$Oi.forUris(x,()=>!0),V.forEach(oe=>{this.q.push(oe),this.s.set(oe.uri,oe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,U){return U&&this.s.get(G)&&(G=(0,I.$ih)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let A=class{constructor(G,U,V,Q,ne){this.c=new N.$oe,this.onDidChangeWorkspace=this.c.event,this.g=new N.$oe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$qe,this.C=new Map,this.h=Q,this.s=V,this.t=ne,this.j=new s.$Qm,this.k=new D.$Hh,this.o=G.getProxy(d.$3N.MainThreadWorkspace),this.q=G.getProxy(d.$3N.MainThreadMessageService);const ue=U.workspace;this.l=ue?new L(ue.id,ue.name,[],!!ue.transient,ue.configuration?h.URI.revive(ue.configuration):null,!!ue.isUntitled,x=>b(x,V)):void 0}$initializeWorkspace(G,U){this.v=U,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?h.URI.from({scheme:p.Schemas.untitled,path:(0,I.$gh)((0,I.$ih)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,U,V,...Q){const ne=[];if(Array.isArray(Q)&&Q.forEach(ce=>{h.URI.isUri(ce.uri)&&!ne.some(te=>w(te.uri,ce.uri,this.s))&&ne.push({uri:ce.uri,name:ce.name||(0,I.$fh)(ce.uri)})}),this.n||[U,V].some(ce=>typeof ce!="number"||ce<0)||V===0&&ne.length===0)return!1;const ue=this.x?this.x.workspaceFolders:[];if(U+V>ue.length)return!1;const x=ue.slice(0);x.splice(U,V,...ne.map(ce=>({uri:ce.uri,name:ce.name||(0,I.$fh)(ce.uri),index:void 0})));for(let ce=0;ce<x.length;ce++){const te=x[ce];if(x.some((we,Ce)=>Ce!==ce&&w(te.uri,we.uri,this.s)))return!1}x.forEach((ce,te)=>ce.index=te);const{added:oe,removed:se}=$(ue,x,R,this.s);if(oe.length===0&&se.length===0)return!1;if(this.o){const ce=G.displayName||G.name;this.o.$updateWorkspaceFolders(ce,U,V,ne).then(void 0,te=>{this.n=void 0;const we={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(c.Severity.Error,(0,E.localize)(2716,null,ce,te.toString()),we,[])})}return this.y(x),!0}getWorkspaceFolder(G,U){if(this.x)return this.x.getWorkspaceFolder(G,U)}async getWorkspaceFolder2(G,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,U)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,U){let V,Q="";if(typeof G=="string"?(V=h.URI.file(G),Q=G):typeof G<"u"&&(V=G,Q=G.fsPath),!V)return Q;const ne=this.getWorkspaceFolder(V,!0);if(!ne)return Q;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ue=(0,I.$lh)(ne.uri,V);return U&&ne.name&&(ue=`${ne.name}/${ue}`),ue}y(G){this.x&&(this.n=L.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:U,added:V,removed:Q}=L.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:V,removed:Q}))}findFiles(G,U,V,Q,ne=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let ue="",x=!0;return U===null?x=!1:U!==void 0&&(typeof U=="string"?ue=U:ue=U.pattern),this.z(G,void 0,{exclude:ue,maxResults:V,useDefaultExcludes:x,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ne)}findFiles2(G,U={},V,Q=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${V.value}, entryPoint: findFiles2`),this.z(void 0,G,U,Q)}async z(G,U,V,Q=C.CancellationToken.None){if(Q&&Q.isCancellationRequested)return Promise.resolve([]);const ne=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,ue={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof V.useDefaultSearchExcludes=="boolean"?!V.useDefaultSearchExcludes:!1,maxResults:V.maxResults,excludePattern:ne,shouldGlobSearch:typeof V.fuzzy=="boolean"?!V.fuzzy:!0,_reason:"startFileSearch"};let x;if(G){const{includePattern:oe,folder:se}=M(o.GlobPattern.from(G));x=se,ue.includePattern=oe}else{const{includePattern:oe,folder:se}=M(o.GlobPattern.from(U));x=se,ue.filePattern=oe}return this.o.$startFileSearch(x??null,ue,Q).then(oe=>Array.isArray(oe)?oe.map(se=>h.URI.revive(se)):[])}findTextInFilesNew(G,U,V,Q){this.h.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${U.value}, entryPoint: findTextInFilesNew`);const ne=V?.include?.map(oe=>{const{includePattern:se,folder:ce}=M(o.GlobPattern.from(oe));return{options:{ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useIgnoreFiles?.global=="boolean"?!V.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof V.useIgnoreFiles?.parent=="boolean"?!V.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:V.useExcludeSettings!==void 0&&V.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:V.useExcludeSettings!==void 0&&V.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:V.previewOptions?{matchLines:V.previewOptions?.numMatchLines??100,charsPerLine:V.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:V.surroundingContext,includePattern:se,excludePattern:V.exclude&&V.exclude.length>0?V.exclude[0]:void 0},folder:ce}}),ue=Promise.resolve(void 0);return{results:new D.$9h(async oe=>{const se=(ce,te)=>((0,g.$mM)(ce)?oe.emitOne(new k.$dM(te,ce.rangeLocations.map(we=>({previewRange:new l.$7N(we.preview.startLineNumber,we.preview.startColumn,we.preview.endLineNumber,we.preview.endColumn),sourceRange:new l.$7N(we.source.startLineNumber,we.source.startColumn,we.source.endLineNumber,we.source.endColumn)})),ce.previewText)):oe.emitOne(new k.$eM(te,ce.text,ce.lineNumber)),ce);await ue.then(ce=>this.findTextInFilesBase(G,ne,se,Q))}),complete:ue.then(oe=>({limitHit:oe?.limitHit??!1}))}}async findTextInFilesBase(G,U,V,Q=C.CancellationToken.None){const ne=this.j.getNext(),ue=!1;if(this.u[ne]=x=>{if(ue)return;const oe=h.URI.revive(x.resource);x.results.forEach(se=>{const ce=(0,S.$fi)(se);V(ce,oe)})},Q.isCancellationRequested)return{};try{const x=await Promise.all(U?.map(oe=>this.o.$startTextSearch(G,oe.folder??null,oe.options,ne,Q)||{})??[]);return delete this.u[ne],x.reduce((oe,se)=>({limitHit:oe?.limitHit||(se?.limitHit??!1),message:[oe?.message??[],se?.message??[]].flat()}),{})??{limitHit:!1}}catch(x){throw delete this.u[ne],x}}async findTextInFiles(G,U,V,Q,ne=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const ue=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:x,folder:oe}=M(o.GlobPattern.from(U.include)),se=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ce={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof U.useSearchExclude=="boolean"?!U.useSearchExclude:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ue,surroundingContext:U.afterContext,includePattern:x,excludePattern:se},te=(we,Ce)=>{(0,g.$mM)(we)?V({uri:Ce,preview:{text:we.previewText,matches:(0,y.$3b)(we.rangeLocations,Y=>new l.$7N(Y.preview.startLineNumber,Y.preview.startColumn,Y.preview.endLineNumber,Y.preview.endColumn))},ranges:(0,y.$3b)(we.rangeLocations,Y=>new l.$7N(Y.source.startLineNumber,Y.source.startColumn,Y.source.endLineNumber,Y.source.endColumn))}):V({uri:Ce,text:we.text,lineNumber:we.lineNumber})};return this.findTextInFilesBase(G,[{options:ce,folder:oe}],te,ne)}$handleTextSearchResult(G,U){this.u[U]?.(G)}async save(G){const U=await this.o.$save(G,{saveAs:!1});return h.URI.revive(U)}async saveAs(G){const U=await this.o.$save(G,{saveAs:!0});return h.URI.revive(U)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}lookupAuthorization(G){return this.o.$lookupAuthorization(G)}lookupKerberosAuthorization(G){return this.o.$lookupKerberosAuthorization(G)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,U){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,U);const V=this.t.transformOutgoingScheme(G),Q=this.A++;return this.o.$registerEditSessionIdentityProvider(Q,V),(0,T.$Vc)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(Q)})}async $getEditSessionIdentifier(G,U){this.h.info("Getting edit session identifier for workspaceFolder",G);const V=await this.resolveWorkspaceFolder(h.URI.revive(G));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const Q=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!Q),!Q)return;const ne=await Q.provideEditSessionIdentity(V,U);if(this.h.info("Provider returned edit session identifier: ",ne),!!ne)return ne}async $provideEditSessionIdentityMatch(G,U,V,Q){this.h.info("Getting edit session identifier for workspaceFolder",G);const ne=await this.resolveWorkspaceFolder(h.URI.revive(G));if(!ne){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ne);const ue=this.w.get(ne.uri.scheme);if(this.h.info(`Provider for scheme ${ne.uri.scheme} is defined: `,!!ue),!ue)return;const x=await ue.provideEditSessionIdentityMatch?.(U,V,Q);if(this.h.info("Provider returned edit session identifier match result: ",x),!!x)return x}getOnWillCreateEditSessionIdentityEvent(G){return(U,V,Q)=>{const ne=function(x){U.call(V,x)};return ne.extension=G,this.B.event(ne,void 0,Q)}}async $onWillCreateEditSessionIdentity(G,U,V){const Q=await this.resolveWorkspaceFolder(h.URI.revive(G));if(Q===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:Q},U,async(ne,ue)=>{const x=Date.now();await Promise.resolve(ne),Date.now()-x>V&&this.h.warn("SLOW edit session create-participant",ue.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(G,U){if(this.C.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.C.set(G,U);const V=this.t.transformOutgoingScheme(G),Q=this.A++;return this.o.$registerCanonicalUriProvider(Q,V),(0,T.$Vc)(()=>{this.C.delete(G),this.o.$unregisterCanonicalUriProvider(Q)})}async provideCanonicalUri(G,U,V){const Q=this.C.get(G.scheme);if(!Q)return;const ne=await Q.provideCanonicalUri?.(h.URI.revive(G),U,V);if(ne)return ne}async $provideCanonicalUri(G,U,V){return this.provideCanonicalUri(h.URI.revive(G),{targetScheme:U},V)}};e.$Kqc=A,e.$Kqc=A=Xe([Qe(0,t.$DQ),Qe(1,n.$TQ),Qe(2,i.$tqc),Qe(3,a.$dk),Qe(4,m.$Iqc)],A),e.$Lqc=(0,r.$Ii)("IExtHostWorkspace");function M(Z){let G,U;return Z&&(typeof Z=="string"?G=Z:(G=Z.pattern,U=h.URI.revive(Z.baseUri))),{includePattern:G,folder:U}}}),define(Oe[46],Ae([1,0,25,6,45,5,7,43,175,54,14,10,3,16,11,2]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=e.$Nqc=e.$Mqc=void 0;function a(m,g){if(g){const d=g.split(".");let S=m;for(let k=0;S&&k<d.length;k++)S=S[d[k]];return S}}function c(m){return m instanceof r.URI}function u(m){return m&&m.uri instanceof r.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function n(m){return m&&m.uri instanceof r.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function t(m){if(c(m))return{resource:m};if(u(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(n(m))return{resource:m.uri};if(m===null)return{resource:null}}let o=class{constructor(g,d,S){this.a=g.getProxy(N.$3N.MainThreadConfiguration),this.c=d,this.b=S,this.d=new v.$Hh,this.e=null}getConfigProvider(){return this.d.wait().then(g=>this.e)}$initializeConfiguration(g){this.e=new l(this.a,this.c,g,this.b),this.d.open()}$acceptConfigurationChanged(g,d){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(g,d))}};e.$Mqc=o,e.$Mqc=o=Xe([Qe(0,E.$DQ),Qe(1,C.$Lqc),Qe(2,f.$dk)],o);class l{constructor(g,d,S,k){this.a=new D.$oe,this.b=g,this.f=k,this.c=d,this.e=p.$Uo.parse(S,k),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(g,d){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Uo.parse(g,this.f),this.d=this.k(g.configurationScopes),this.a.fire(this.j(d,S))}getConfiguration(g,d,S){const k=t(d)||{},w=this.g(g?a(this.e.getValue(void 0,k,this.c.workspace),g):this.e.getValue(void 0,k,this.c.workspace));g&&this.h(g,k,S?.identifier);function P($){if($==null)return null;if(typeof $=="boolean")return $?O.ConfigurationTarget.USER:O.ConfigurationTarget.WORKSPACE;switch($){case T.ConfigurationTarget.Global:return O.ConfigurationTarget.USER;case T.ConfigurationTarget.Workspace:return O.ConfigurationTarget.WORKSPACE;case T.ConfigurationTarget.WorkspaceFolder:return O.ConfigurationTarget.WORKSPACE_FOLDER}}const R={has($){return typeof a(w,$)<"u"},get:($,b)=>{this.h(g?`${g}.${$}`:$,k,S?.identifier);let L=a(w,$);if(typeof L>"u")L=b;else{let A;const M=(Z,G)=>{if((0,I.$jg)(Z)){let U;const V=()=>{A=A||(0,y.$ho)(w),U=U||a(A,G)};return new Proxy(Z,{get:(Q,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return V(),()=>U;if(A)return U=U||a(A,G),U[ne];const ue=Q[ne];return typeof ne=="string"?M(ue,`${G}.${ne}`):ue},set:(Q,ne,ue)=>(V(),U&&(U[ne]=ue),!0),deleteProperty:(Q,ne)=>(V(),U&&delete U[ne],!0),defineProperty:(Q,ne,ue)=>(V(),U&&Object.defineProperty(U,ne,ue),!0)})}return Array.isArray(Z)?(0,y.$ho)(Z):Z};L=M(L,$)}return L},update:($,b,L,A)=>{$=g?`${g}.${$}`:$;const M=P(L);return b!==void 0?this.b.$updateConfigurationOption(M,$,b,k,A):this.b.$removeConfigurationOption(M,$,k,A)},inspect:$=>{$=g?`${g}.${$}`:$;const b=this.e.inspect($,k,this.c.workspace);if(b)return{key:$,defaultValue:(0,y.$ho)(b.policy?.value??b.default?.value),globalValue:(0,y.$ho)(b.user?.value??b.application?.value),workspaceValue:(0,y.$ho)(b.workspace?.value),workspaceFolderValue:(0,y.$ho)(b.workspaceFolder?.value),defaultLanguageValue:(0,y.$ho)(b.default?.override),globalLanguageValue:(0,y.$ho)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,y.$ho)(b.workspace?.override),workspaceFolderLanguageValue:(0,y.$ho)(b.workspaceFolder?.override),languageIds:(0,y.$ho)(b.overrideIdentifiers)}}};return typeof w=="object"&&(0,y.$ko)(R,w,!1),Object.freeze(R)}g(g){const d=S=>(0,I.$jg)(S)?new Proxy(S,{get:(k,w)=>d(k[w]),set:(k,w,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(k,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(k,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return d(g)}h(g,d,S){const k=s.$Jo.test(g)?s.ConfigurationScope.RESOURCE:this.d.get(g),w=S?`[${S.value}] `:"";if(s.ConfigurationScope.RESOURCE===k){typeof d?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${g}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===k){d?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${g}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(g,d){const S=new p.$Wo(g,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(k,w)=>S.affectsConfiguration(k,t(w))})}k(g){return g.reduce((d,S)=>(d.set(S[0],S[1]),d),new Map)}}e.$Nqc=l,e.$Oqc=(0,h.$Ii)("IExtHostConfiguration")}),define(Oe[132],Ae([1,0,2,10,6,5,7,45,58,46,19,57,16,26,3,15,21,11,85,209,13]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsc=e.$qsc=e.$psc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,T=He(T),a=He(a);var t;(function(A){function M(G){if(G!=null)return G}A.from=M;function Z(G){if(G!=null)return G}A.to=Z})(t||(t={}));var o;(function(A){function M(G){if(G!=null)return G}A.from=M;function Z(G){if(G!=null)return G}A.to=Z})(o||(o={}));var l;(function(A){function M(G){if(G!=null)return G}A.from=M;function Z(G){if(G!=null)return G}A.to=Z})(l||(l={}));var m;(function(A){function M(U){if(U){const V=U;return V&&!!V.process}else return!1}A.is=M;function Z(U){if(U==null)return;const V={process:U.process,args:U.args};return U.options&&(V.options=l.from(U.options)),V}A.from=Z;function G(U){if(U!=null)return new T.$QO(U.process,U.args,U.options)}A.to=G})(m||(m={}));var g;(function(A){function M(G){if(G!=null)return G}A.from=M;function Z(G){if(G!=null)return G}A.to=Z})(g||(g={}));var d;(function(A){function M(U){if(U){const V=U;return V&&(!!V.commandLine||!!V.command)}else return!1}A.is=M;function Z(U){if(U==null)return;const V={};return U.commandLine!==void 0?V.commandLine=U.commandLine:(V.command=U.command,V.args=U.args),U.options&&(V.options=g.from(U.options)),V}A.from=Z;function G(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new T.$RO(U.commandLine,U.options):new T.$RO(U.command,U.args?U.args:[],U.options)}A.to=G})(d||(d={}));var S;(function(A){function M(U){if(U){const V=U;return V&&V.customExecution==="customExecution"}else return!1}A.is=M;function Z(U){return{customExecution:"customExecution"}}A.from=Z;function G(U,V){return V.get(U)}A.to=G})(S||(e.CustomExecutionDTO=S={}));var k;(function(A){function M(Z,G){let U;return Z.scope!==void 0&&typeof Z.scope!="number"?U=Z.scope.uri:Z.scope!==void 0&&typeof Z.scope=="number"&&(Z.scope===T.TaskScope.Workspace&&G&&G.workspaceFile?U=G.workspaceFile:U=i.$aJ),{id:Z._id,workspaceFolder:U}}A.from=M})(k||(e.TaskHandleDTO=k={}));var w;(function(A){function M(Z){if(Z!=null)return{_id:Z.id,isDefault:Z.isDefault}}A.from=M})(w||(w={}));var P;(function(A){function M(U,V){if(U==null)return[];const Q=[];for(const ne of U){const ue=Z(ne,V);ue&&Q.push(ue)}return Q}A.fromMany=M;function Z(U,V){if(U==null)return;let Q;U.execution instanceof T.$QO?Q=m.from(U.execution):U.execution instanceof T.$RO?Q=d.from(U.execution):U.execution&&U.execution instanceof T.$SO&&(Q=S.from(U.execution));const ne=t.from(U.definition);let ue;return U.scope?typeof U.scope=="number"?ue=U.scope:ue=U.scope.uri:ue=T.TaskScope.Workspace,!ne||!ue?void 0:{_id:U._id,definition:ne,name:U.name,source:{extensionId:V.identifier.value,label:U.source,scope:ue},execution:Q,isBackground:U.isBackground,group:w.from(U.group),presentationOptions:o.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}A.from=Z;async function G(U,V,Q){if(U==null)return;let ne;m.is(U.execution)?ne=m.to(U.execution):d.is(U.execution)?ne=d.to(U.execution):S.is(U.execution)&&(ne=S.to(U._id,Q));const ue=t.to(U.definition);let x;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?x=U.source.scope:x=await V.resolveWorkspaceFolder(y.URI.revive(U.source.scope)):x=T.TaskScope.Workspace),!ue||!x)return;const oe=new T.$TO(ue,x,U.name,U.source.label,ne,U.problemMatchers);return U.isBackground!==void 0&&(oe.isBackground=U.isBackground),U.group!==void 0&&(oe.group=T.$PO.from(U.group._id),oe.group&&U.group.isDefault&&(oe.group=new T.$PO(oe.group.id,oe.group.label),U.group.isDefault===!0&&(oe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(oe.presentationOptions=o.to(U.presentationOptions)),U._id&&(oe._id=U._id),U.detail&&(oe.detail=U.detail),oe}A.to=G})(P||(e.TaskDTO=P={}));var R;(function(A){function M(G){return G}A.from=M;function Z(G){if(G)return Object.assign(Object.create(null),G)}A.to=Z})(R||(R={}));class ${#e;constructor(M,Z,G){this._id=Z,this.a=G,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let b=class{constructor(M,Z,G,U,V,Q,ne,ue){this.q=new C.$oe,this.r=new C.$oe,this.s=new C.$oe,this.u=new C.$oe,this.a=M.getProxy(N.$3N.MainThreadTask),this.b=G,this.c=U,this.d=V,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ne,this.g=ue,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,Z,G){if(!G)return new T.$5N(()=>{});const U=this.x();return this.j.set(U,{type:Z,provider:G,extension:M}),this.a.$registerTaskProvider(U,Z),new T.$5N(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(M,Z){this.a.$registerTaskSystem(M,Z)}fetchTasks(M){return this.a.$fetchTasks(R.from(M)).then(async Z=>{const G=[];for(const U of Z){const V=await P.to(U,this.b,this.m);V&&G.push(V)}return G})}get taskExecutions(){const M=[];return this.k.forEach(Z=>M.push(Z)),M}terminateTask(M){if(!(M instanceof $))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,Z,G){const U=this.m.get(M.id);U&&(this.o.set(M.id,U),this.e.attachPtyToTerminal(Z,await U.callback(G))),this.p=M.id,this.q.fire({execution:await this.z(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){if(!this.l.has(M.id))return;const Z=await this.z(M);this.l.delete(M.id),this.k.delete(M.id),this.B(M),this.r.fire({execution:Z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const Z=await this.z(M.id);this.s.fire({execution:Z,processId:M.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(M){const Z=await this.z(M.id);this.u.fire({execution:Z,exitCode:M.exitCode})}$provideTasks(M,Z){const G=this.j.get(M);if(!G)return Promise.reject(new Error("no handler found"));const U=[],V=(0,D.$Ah)(()=>G.provider.provideTasks(I.CancellationToken.None)).then(Q=>this.v(Z,U,G,Q));return new Promise(Q=>{V.then(ne=>{Promise.all(U).then(()=>{Q(ne)})})})}async $resolveTask(M,Z){const G=this.j.get(M);if(!G)return Promise.reject(new Error("no handler found"));if(Z.definition.type!==G.type)throw new Error(`Unexpected: Task of type [${Z.definition.type}] cannot be resolved by provider of type [${G.type}].`);const U=await P.to(Z,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const V=await G.provider.resolveTask(U,I.CancellationToken.None);if(!V)return;this.A(V,G);const Q=P.from(V,G.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(Q.execution)&&await this.y(Q,V,!0),await this.w(Q)}x(){return this.h++}async y(M,Z,G){const U=await this.a.$createTaskId(M);!G&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,Z.execution)),this.m.set(U,Z.execution)}async z(M,Z){if(typeof M=="string"){const V=this.l.get(M);if(!V)throw new n.$db("Unexpected: The specified task is missing an execution");return V}const G=this.l.get(M.id);if(G)return G;let U;return Z?U=Promise.resolve(new $(this,M.id,Z)):U=P.to(M.task,this.b,this.m).then(V=>{if(!V)throw new n.$db("Unexpected: Task does not exist.");return new $(this,M.id,V)}),this.l.set(M.id,U),U.then(V=>(this.k.set(M.id,V),V))}A(M,Z){M._deprecated&&this.g.report("Task.constructor",Z.extension,"Use the Task constructor that takes a `scope` instead.")}B(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const G=this.n.values();let U=G.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=G.next()}};e.$psc=b,e.$psc=b=Xe([Qe(0,h.$DQ),Qe(1,E.$TQ),Qe(2,O.$Lqc),Qe(3,p.$OQ),Qe(4,s.$Oqc),Qe(5,v.$arc),Qe(6,c.$dk),Qe(7,u.$pqc)],b);let L=class extends b{constructor(M,Z,G,U,V,Q,ne,ue){super(M,Z,G,U,V,Q,ne,ue),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:a.$i(a.Platform.Web)})}async executeTask(M,Z){if(!Z.execution)throw new Error("Tasks to execute must include an execution");const G=P.from(Z,M);if(G===void 0)throw new Error("Task is not valid");if(S.is(G.execution))await this.y(G,Z,!1);else throw new n.$bb;const U=await this.z(await this.a.$getTaskExecution(G),Z);return this.a.$executeTask(G).catch(V=>{throw new Error(V)}),U}v(M,Z,G,U){const V=[];if(U)for(const Q of U){if(this.A(Q,G),!Q.definition||!M[Q.definition.type]){const ue=Q.source?Q.source:"No task source";this.f.warn(`The task [${ue}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const ne=P.from(Q,G.extension);ne&&S.is(ne.execution)?(V.push(ne),Z.push(this.y(ne,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:G.extension}}async w(M){if(S.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,Z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,Z,G){}};e.$qsc=L,e.$qsc=L=Xe([Qe(0,h.$DQ),Qe(1,E.$TQ),Qe(2,O.$Lqc),Qe(3,p.$OQ),Qe(4,s.$Oqc),Qe(5,v.$arc),Qe(6,c.$dk),Qe(7,u.$pqc)],L),e.$rsc=(0,f.$Ii)("IExtHostTask")}),define(Oe[268],Ae([1,0,44,32]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0,e.$NM=C,e.$PM=N;function C(T){return"cellResults"in T}e.$OM="rawCell#";function N(T,O){let p=-1;const s=[];let I=[];return T.forEach(h=>{h.range.startLineNumber!==p&&I.length>0&&(s.push([...I]),I=[]),I.push(h),p=h.range.endLineNumber}),I.length>0&&s.push([...I]),s.map(h=>{const E=[],f=h[0].range.startLineNumber,r=h[h.length-1].range.endLineNumber;for(let a=f;a<=r;a++)E.push(O.getLineContent(a));return new y.$qM(E.join(`
`)+`
`,h.map(a=>new D.$Tt(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}}),define(Oe[269],Ae([1,0,9,22,6,4,28,37,12,14,2,29,80,5,34,8,7,39,246,126,25,15,44,199,268,266]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rc=void 0,v=He(v),r=He(r),a=He(a);class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(k=>k.apiEditor)}constructor(k,w,P,R,$,b,L){this.q=P,this.r=R,this.s=$,this.t=b,this.u=L,this.f=new Map,this.g=new T.$Dc,this.h=new Map,this.j=new C.$oe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$oe,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$oe,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$oe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new h.$nqc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=k.getProxy(E.$3N.MainThreadNotebook),this.c=k.getProxy(E.$3N.MainThreadNotebookDocuments),this.d=k.getProxy(E.$3N.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===O.MarshalledId.NotebookCellActionContext){const M=A.notebookEditor?.notebookUri,Z=A.cell.handle,U=this.g.get(M)?.getCell(Z);if(U)return U.apiCell}if(A&&A.$mid===O.MarshalledId.NotebookActionContext){const M=A.uri,Z=this.g.get(M);if(Z)return Z.apiNotebook}return A}}),d.C(w)}getEditorById(k){const w=this.h.get(k);if(!w)throw new Error(`unknown text editor: ${k}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(k){for(const[w,P]of this.h)if(P.apiEditor===k)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(k,w){const P=this.g.get(k);if(!P&&!w)throw new Error(`NO notebook document for '${k}'`);return P}static w(k,w){if(!w)return;const P=w.filenamePattern.map(R=>r.NotebookExclusiveDocumentPattern.from(R)).filter(R=>R!==void 0);if(w.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:w.displayName,filenamePattern:P,priority:w.exclusive?g.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(k,w,P){const R=d.a++,$=typeof P.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(R,P),this.b.$registerNotebookCellStatusBarItemProvider(R,$,w);let b;return $!==void 0&&(b=P.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent($))),new a.$5N(()=>{this.f.delete(R),this.b.$unregisterNotebookCellStatusBarItemProvider(R,$),b?.dispose()})}async createNotebookDocument(k){const w=await this.c.$tryCreateNotebook({viewType:k.viewType,content:k.content&&r.NotebookData.from(k.content)});return I.URI.revive(w)}async openNotebookDocument(k){const w=this.g.get(k);if(w)return w.apiNotebook;const P=await this.c.$tryOpenNotebook(k),R=this.g.get(I.URI.revive(P));return(0,s.$sg)(R?.apiNotebook)}async showNotebookDocument(k,w){let P;typeof w=="object"?P={position:r.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(r.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0,label:w?.label}:P={preserveFocus:!1,pinned:!0};const R=w?.asRepl?"repl":k.notebookType,$=await this.d.$tryShowNotebookDocument(k.uri,R,P),b=$&&this.h.get($)?.apiEditor;if(b)return b;throw $?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,w,P,R){const $=this.f.get(k),b=I.URI.revive(w),L=this.g.get(b);if(!L||!$)return;const A=L.getCellFromIndex(P);if(!A)return;const M=await $.provideCellStatusBarItems(A.apiCell,R);if(!M)return;const Z=new N.$Wc,G=this.p.add([Z]),V=(Array.isArray(M)?M:[M]).map(Q=>r.NotebookStatusBarItem.from(Q,this.i,Z));return{cacheId:G,items:V}}$releaseNotebookCellStatusBarItems(k){this.p.delete(k)}registerNotebookSerializer(k,w,P,R,$){if((0,p.$ff)(w))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:w,serializer:P,options:R}),this.b.$registerNotebookSerializer(b,{id:k.identifier,location:k.extensionLocation},w,r.NotebookDocumentContentOptions.from(R),d.w(k,$)),(0,N.$Vc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(k,w,P){const R=this.y.get(k);if(!R)throw new Error("NO serializer found");const $=await R.serializer.deserializeNotebook(w.buffer,P);return new c.$4w(r.NotebookData.from($))}async $notebookToData(k,w,P){const R=this.y.get(k);if(!R)throw new Error("NO serializer found");const $=await R.serializer.serializeNotebook(r.NotebookData.to(w.value),P);return D.$Qe.wrap($)}async $saveNotebook(k,w,P,R,$){const b=I.URI.revive(w),L=this.y.get(k);if(this.D(`enter saveNotebook(versionId: ${P}, ${b.toString()})`),!L)throw new Error("NO serializer found");const A=this.g.get(b);if(!A)throw new Error("Document NOT found");if(A.versionId!==P)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new v.$yl((0,y.localize)(2707,null,this.A(b)),v.FileOperationResult.FILE_PERMISSION_DENIED);const M={metadata:(0,n.$po)(A.apiNotebook.metadata,Q=>!(L.options?.transientDocumentMetadata??{})[Q]),cells:[]};for(const Q of A.apiNotebook.getCells()){const ne=new a.$xP(Q.kind,Q.document.getText(),Q.document.languageId,Q.mime,L.options?.transientOutputs?[]:[...Q.outputs],Q.metadata,Q.executionSummary);ne.metadata=(0,n.$po)(Q.metadata,ue=>!(L.options?.transientCellMetadata??{})[ue]),M.cells.push(ne)}if(await this.z(b,R),$.isCancellationRequested)throw new Error("canceled");const Z=await L.serializer.serializeNotebook(M,$);if($.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${P} ${b.toString()}`),await this.s.value.writeFile(b,Z),this.D(`Finished write versionId: ${P} ${b.toString()}`);const G=this.s.getFileSystemProviderExtUri(b.scheme),U=await this.s.value.stat(b),V={name:G.basename(b),isFile:(U.type&v.FileType.File)!==0,isDirectory:(U.type&v.FileType.Directory)!==0,isSymbolicLink:(U.type&v.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&v.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((U.permissions??0)&v.FilePermission.Locked),etag:v.$Jl({mtime:U.mtime,size:U.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${P}, ${b.toString()})`),V}async $searchInNotebooks(k,w,P,R,$){const b=this.y.get(k)?.serializer;if(!b)return{limitHit:!1,results:[]};const L=new T.$Ec;await(async(U,V,Q)=>{await Promise.all(U.map(async ne=>await Promise.all(ne.filenamePatterns.map(ue=>{const x={_reason:Q._reason,folderQueries:Q.folderQueries,includePattern:Q.includePattern,excludePattern:Q.excludePattern,maxResults:Q.maxResults,type:o.QueryType.File,filePattern:ue};return this.t.doInternalFileSearchWithCustomCallback(x,V,oe=>{oe.forEach(se=>{L.has(se)||R.some(te=>ne.isFromSettings&&!te.isFromSettings?!1:te.filenamePatterns.some(we=>(0,g.$HL)(we,se)))||L.add(se)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(P,$,w);const M=new T.$Dc;let Z=!1;const G=Array.from(L).map(async U=>{const V=[];try{if($.isCancellationRequested)return;if(w.maxResults&&[...M.values()].reduce((x,oe)=>x+oe.cellResults.length,0)>w.maxResults){Z=!0;return}const Q=[],ne=this.g.get(U);if(ne)ne.apiNotebook.getCells().forEach(oe=>Q.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(se=>se.items.map(ce=>ce.data.toString()))}));else{const x=await this.s.value.readFile(U),oe=D.$Qe.fromString(x.toString()),se=await b.deserializeNotebook(oe.buffer,$);if($.isCancellationRequested)return;r.NotebookData.from(se).cells.forEach(te=>Q.push({input:te.source,outputs:te.outputs.flatMap(we=>we.items.map(Ce=>Ce.valueBytes.toString()))}))}if($.isCancellationRequested)return;Q.forEach((x,oe)=>{const se=w.contentPattern.pattern,ce=new l.$m2b(x.input,void 0,x.outputs),te=ce.findInInputs(se),we=ce.findInOutputs(se),Ce=we.flatMap(Y=>(0,m.$PM)(Y.matches,Y.textBuffer)).map((Y,W)=>(Y.webviewIndex=W,Y));if(te.length>0||we.length>0){const Y={index:oe,contentResults:(0,m.$PM)(te,ce.inputTextBuffer),webviewResults:Ce};V.push(Y)}});const ue={resource:U,cellResults:V};M.set(U,ue);return}catch{return}});return await Promise.all(G),{limitHit:Z,results:[...M.values()]}}async z(k,w){const P=await this.s.value.stat(k);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==v.$Il&&typeof P.mtime=="number"&&typeof P.size=="number"&&w.mtime<P.mtime&&w.etag!==v.$Jl({mtime:w.mtime,size:P.size}))throw new v.$yl((0,y.localize)(2708,null),v.FileOperationResult.FILE_MODIFIED_SINCE,w)}A(k){return k.scheme===t.Schemas.file?k.fsPath:k.toString()}B(k,w,P){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const R=new i.$Prc(w,this.d,k,P.visibleRanges.map(r.NotebookRange.to),P.selections.map(r.NotebookRange.to),typeof P.viewColumn=="number"?r.ViewColumn.to(P.viewColumn):void 0);this.h.set(w,R)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const P of k.value.removedDocuments){const R=I.URI.revive(P),$=this.g.get(R);$&&($.dispose(),this.g.delete(R),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire($.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===R.toString()&&this.h.delete(b.id)}if(k.value.addedDocuments){const P=[];for(const R of k.value.addedDocuments){const $=I.URI.revive(R.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const b=new u.$Orc(this.c,this.q,this.r,$,R);P.push(...R.cells.map(L=>u.$Nrc.asModelAddData(L))),this.g.get($)?.dispose(),this.g.set($,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this.m.fire(b.apiNotebook)}}if(k.value.addedEditors)for(const P of k.value.addedEditors){if(this.h.has(P.id))return;const R=I.URI.revive(P.documentUri),$=this.g.get(R);$&&this.B($,P.id,P)}const w=[];if(k.value.removedEditors)for(const P of k.value.removedEditors){const R=this.h.get(P);R&&(this.h.delete(P),this.k?.id===R.id&&(this.k=void 0),w.push(R))}if(k.value.visibleEditors){this.l=k.value.visibleEditors.map(R=>this.h.get(R)).filter(R=>!!R);const P=new Set;this.l.forEach(R=>P.add(R.id));for(const R of this.h.values()){const $=P.has(R.id);R._acceptVisibility($)}this.l=[...this.h.values()].map(R=>R).filter(R=>R.visible),this.o.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this.k=void 0:k.value.newActiveEditor&&(this.h.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this.k=this.h.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(k){const w=f.$2Q.String.with("notebookType","A notebook type"),P=new f.$4Q("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new f.$2Q("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>D.$Qe.wrap($))],new f.$3Q("Notebook Data",$=>r.NotebookData.to($.value))),R=new f.$4Q("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new f.$2Q("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new c.$4w(r.NotebookData.from($)))],new f.$3Q("Bytes",$=>$.buffer));k.registerApiCommand(P),k.registerApiCommand(R)}D(k){this.u.trace(`[Extension Host Notebook] ${k}`)}}e.$4rc=d}),define(Oe[270],Ae([1,0,20,19,42,41,23,70,44,49]),function($e,e,y,D,C,N,T,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qrc=void 0,y=He(y),N=He(N),T=He(T);class I{constructor(E,f,r){this.l=E,this.o=f,this.p=r,this.f=!1,this.g=0,this.h=!1,this.a=E.filePattern,this.b=E.includePattern&&N.$Dk(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.j=new Set,this.k=E.excludePattern&&N.$Dk(E.excludePattern)}cancel(){this.h=!0,this.j.forEach(E=>E.cancel()),this.j=new Set}search(E){const f=this.l.folderQueries||[];return new Promise((r,a)=>{const c=u=>{this.g++,E(u)};if(this.h)return r({limitHit:this.f});this.l.extraFileResources&&this.l.extraFileResources.forEach(u=>{const i=u.toString(),n=y.$qc(i);this.k&&this.k(i,n)||this.w(c,{base:u,basename:n})}),this.q(f,c).then(u=>{r({limitHit:this.f,stats:u||void 0})},u=>{a(new Error((0,C.$tj)(u)))})})}async q(E,f){const r=new D.$ze,c={folderOptions:E.map(n=>this.r(n)),maxResults:this.l.maxResults??p.$kM,session:this.p},u=s.$Oi.forUris();E.forEach(n=>{const t=new p.$EM(this.l,n),o=!t.hasSiblingExcludeClauses();u.set(n.folder,{queryTester:t,noSiblingsClauses:o,folder:n.folder,tree:this.s()})});let i;try{this.j.add(r),i=O.$ie.create();const n=await this.o.provideFileSearchResults(this.l.filePattern||"",c,r.token),t=i.elapsed(),o=O.$ie.create();return this.h&&!this.f||(n&&n.forEach(l=>{const m=u.findSubstr(l),g=y.$jc.relative(m.folder.path,l.path);if(m.noSiblingsClauses){const d=y.$qc(l.path);this.w(f,{base:m.folder,relativePath:g,basename:d});return}this.u(m.tree,m.folder,g,f)}),this.h&&!this.f)?null:(u.forEach(l=>{this.v(l.tree,l.queryTester,f)}),{providerTime:t,postProcessTime:o.elapsed()})}finally{r.dispose(),this.j.delete(r)}}r(E){const f=(0,p.$DM)(this.l.includePattern,E.includePattern),r=(0,p.$HM)(E.excludePattern?.folder,(0,p.$DM)(this.l.excludePattern,E.excludePattern?.pattern));return{folder:E.folder,excludes:r,includes:f,useIgnoreFiles:{local:!E.disregardIgnoreFiles,parent:!E.disregardParentIgnoreFiles,global:!E.disregardGlobalIgnoreFiles},followSymlinks:!E.ignoreSymlinks}}s(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}u({pathToEntries:E},f,r,a){if(r===this.a){const u=y.$qc(this.a);this.w(a,{base:f,relativePath:this.a,basename:u})}function c(u){const i=y.$qc(u),n=y.$pc(u);let t=E[n];t||(t=E[n]=[],c(n)),t.push({base:f,relativePath:u,basename:i})}c(r)}v({rootEntries:E,pathToEntries:f},r,a){const c=this,u=this.a;function i(n){const t=(0,p.$GM)(()=>n.map(o=>o.basename));for(let o=0,l=n.length;o<l;o++){const m=n[o],{relativePath:g,basename:d}=m;if(r.matchesExcludesSync(g,d,u!==d?t:void 0))continue;const S=f[g];if(S)i(S);else{if(g===u)continue;c.w(a,m)}if(c.f)break}}i(E)}w(E,f){(!this.b||f.relativePath&&this.b(f.relativePath,f.basename))&&((this.d||this.c&&this.g>=this.c)&&(this.f=!0,this.cancel()),this.f||E(f))}}class v{constructor(){this.b=new Map}static{this.a=512}fileSearch(E,f,r,a){const c=this.c(E.cacheKey),u=new I(E,f,c&&c.token);let i=0;const n=t=>{i+=t.length,r(t.map(o=>this.d(o)))};return this.f(u,v.a,n,a).then(t=>({limitHit:t.limitHit,stats:t.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:t.stats}:void 0,messages:[]}))}clearCache(E){this.c(E)?.cancel()}c(E){if(E)return this.b.has(E)||this.b.set(E,new D.$ze),this.b.get(E)}d(E){return E.relativePath?{resource:T.$jh(E.base,E.relativePath)}:{resource:E.base}}f(E,f,r,a){const c=a.onCancellationRequested(()=>{E.cancel()}),u=n=>{n&&(i.push(n),f>0&&i.length>=f&&(r(i),i=[]))};let i=[];return E.search(u).then(n=>(i.length&&r(i),c.dispose(),n),n=>(i.length&&r(i),c.dispose(),Promise.reject(n)))}}e.$Qrc=v}),define(Oe[271],Ae([1,0,17,240,41,100,28,15,20,23,12,14,2,103,9,43,11,114,50,120,267,44]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=void 0,e.$EN=o,e.$FN=l,e.$HN=$,y=He(y),D=He(D),C=He(C),p=He(p),I=He(I),f=He(f);function o(b){return typeof b=="object"&&"uri"in b&&"pattern"in b}function l(b){return typeof b=="string"?{pattern:b}:{pattern:b.pattern,uri:b.baseUri}}let m=class{constructor(L,A,M,Z,G,U){this.a=L,this.b=A,this.c=M,this.d=Z,this.e=G,this.f=U}text(L,A,M={}){L=this.g(L,M);const Z=this.a.getValue(),G=A&&A.some(V=>!this.a.getValue({resource:V}).search.useRipgrep);return{...this.i(A?.map(u.$4i),M),type:t.QueryType.Text,contentPattern:L,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:Z.search.usePCRE2||G||!1,surroundingContext:M.surroundingContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}g(L,A){const M=this.a.getValue();L.isRegExp&&(L.pattern=L.pattern.replace(/\r?\n/g,"\\n"));const Z={...L,wordSeparators:M.editor.wordSeparators};return this.k(L,A)&&(Z.isCaseSensitive=!0),this.l(L)&&(Z.isMultiline=!0),A.notebookSearchConfig?.includeMarkupInput&&(Z.notebookInfo||(Z.notebookInfo={}),Z.notebookInfo.isInNotebookMarkdownInput=A.notebookSearchConfig.includeMarkupInput),A.notebookSearchConfig?.includeMarkupPreview&&(Z.notebookInfo||(Z.notebookInfo={}),Z.notebookInfo.isInNotebookMarkdownPreview=A.notebookSearchConfig.includeMarkupPreview),A.notebookSearchConfig?.includeCodeInput&&(Z.notebookInfo||(Z.notebookInfo={}),Z.notebookInfo.isInNotebookCellInput=A.notebookSearchConfig.includeCodeInput),A.notebookSearchConfig?.includeOutput&&(Z.notebookInfo||(Z.notebookInfo={}),Z.notebookInfo.isInNotebookCellOutput=A.notebookSearchConfig.includeOutput),Z}file(L,A={}){return{...this.i(L,A),type:t.QueryType.File,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey,shouldGlobMatchFilePattern:A.shouldGlobSearch}}h(L,A){return L?(L=Array.isArray(L)?L.map(w):w(L),A?this.parseSearchPaths(L):{pattern:d(...Array.isArray(L)?L:[L])}):{}}i(L=[],A={}){const M=A.excludePattern&&o(A.excludePattern)?A.excludePattern.pattern:A.excludePattern,Z=this.h(A.includePattern,A.expandPatterns),G=this.h(M,A.expandPatterns),U=L.length>1,V=(Z.searchPaths&&Z.searchPaths.length?Z.searchPaths.map(ue=>this.r(ue,A,G)):L.map(ue=>this.t(ue,A,G,U))).filter(ue=>!!ue),Q={_reason:A._reason,folderQueries:V,usingSearchPaths:!!(Z.searchPaths&&Z.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:G.pattern,includePattern:Z.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const ue=y.$Jb(this.c.groups.flatMap(se=>se.editors.map(ce=>ce.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(ue));const x=ue.filter(se=>(0,t.$uM)(Q,se.fsPath)),oe=this.j(x);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(oe)),{...Q,...oe}}const ne=A.extraFileResources&&A.extraFileResources.filter(ue=>(0,t.$uM)(Q,ue.fsPath));return Q.extraFileResources=ne&&ne.length?ne:void 0,Q}j(L){const A=[],M=new T.$Dc,Z={};let G=!1;return L.forEach(U=>{if(U.scheme===O.Schemas.walkThrough)return;if((0,s.$nh)(U)){const Q=this.b.getWorkspaceFolder(U)?.uri??this.f.extUri.dirname(U);let ne=M.get(Q);ne||(G=!0,ne={folder:Q,includePattern:{}},A.push(ne),M.set(Q,ne));const ue=p.$oc(Q.fsPath,U.fsPath);(0,v.$sg)(ne.includePattern)[ue.replace(/\\/g,"/")]=!0}else U.fsPath&&(G=!0,Z[U.fsPath]=!0)}),{folderQueries:A,includePattern:Z,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}k(L,A){if(A.isSmartCase){if(L.isRegExp){if(I.$$f(L.pattern,!0))return!0}else if(I.$$f(L.pattern))return!0}return!!L.isCaseSensitive}l(L){return L.isMultiline||L.isRegExp&&(0,E.$vD)(L.pattern)||L.pattern.indexOf(`
`)>=0?!0:!!L.isMultiline}parseSearchPaths(L){const A=x=>p.$lc(x)||/^\.\.?([\/\\]|$)/.test(x),Z=(Array.isArray(L)?L:S(L)).map(x=>{const oe=this.e.resolvedUserHome;return oe?(0,N.$9w)(x,oe.scheme===O.Schemas.file?oe.fsPath:oe.path):x}),G=D.$c(Z,x=>A(x)?"searchPaths":"exprSegments"),U=(G.exprSegments||[]).map(x=>I.$qf(x,"/")).map(x=>I.$qf(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),k(x))),V={},Q=this.n(G.searchPaths||[]);Q&&Q.length&&(V.searchPaths=Q);const ne=U.flat(),ue=d(...ne);return ue&&(V.pattern=ue),V}m(L,A){return A.disregardExcludeSettings?void 0:(0,t.$tM)(L,!A.disregardSearchExcludeSettings)}n(L){if(!L||!L.length)return[];const A=L.flatMap(Z=>{let{pathPortion:G,globPortion:U}=g(Z);return U&&(U=P(U)),this.o(G).flatMap(Q=>this.q(Q,U))}),M=new Map;return A.forEach(Z=>{const G=Z.searchPath.toString(),U=M.get(G);U?Z.pattern&&(U.pattern=U.pattern||{},U.pattern[Z.pattern]=!0):M.set(G,{searchPath:Z.searchPath,pattern:Z.pattern?d(Z.pattern):void 0})}),Array.from(M.values())}o(L){if(p.$lc(L)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==O.Schemas.file?[{searchPath:A[0].uri.with({path:L})}]:[{searchPath:h.URI.file(p.$kc(L))}]}if(this.b.getWorkbenchState()===u.WorkbenchState.FOLDER){const A=this.b.getWorkspace().folders[0].uri;if(L=w(L),L.startsWith("../")||L===".."){const Z=p.$jc.resolve(A.path,L);return[{searchPath:A.with({path:Z})}]}const M=P(L);return[{searchPath:A,pattern:M}]}else{if(L==="./"||L===".\\")return[];{const A=L.replace(/^\.[\/\\]/,""),Z=this.b.getWorkspace().folders.map(G=>{const U=A.match(new RegExp(`^${I.$kf(G.name)}(?:/(.*)|$)`));return U?{match:U,folder:G}:null}).filter(v.$pg);if(Z.length)return Z.map(G=>{const U=G.match[1];return{searchPath:G.folder.uri,pattern:U&&P(U)}});{const G=L.match(/\.[\/\\](.+)[\/\\]?/),U=G?G[1]:L,V=f.localize(12603,null,U);throw new Error(V)}}}}q(L,A){const M=L.pattern&&A?`${L.pattern}/${A}`:L.pattern||A,Z=[{searchPath:L.searchPath,pattern:M}];return M&&!M.endsWith("**")&&Z.push({searchPath:L.searchPath,pattern:M+"/**"}),Z}r(L,A,M){const Z=this.t((0,u.$4i)(L.searchPath),A,M,!1);return Z?{...Z,includePattern:L.pattern}:null}t(L,A,M,Z){let G;const U=h.URI.isUri(L)?L:L.uri,V=A.excludePattern&&o(A.excludePattern)?A.excludePattern.uri:void 0,ne=!V||!(h.URI.isUri(L)&&this.f.extUri.isEqual(L,V))?V:void 0;if(M.searchPaths){const te=M.searchPaths.filter(we=>(0,s.$ch)(we.searchPath,U))[0];if(te&&!te.pattern)return null;te&&(G=te.pattern)}const ue=this.a.getValue({resource:U}),oe={...this.m(ue,A)||{},...G||{}},se=h.URI.isUri(L)?(0,s.$gh)(L):L.name,ce=Object.keys(oe).length>0?{folder:ne,pattern:oe}:void 0;return{folder:U,folderName:Z?se:void 0,excludePattern:ce,fileEncoding:ue.files&&ue.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!ue.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!ue.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!ue.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!ue.search.followSymlinks}}};e.$GN=m,e.$GN=m=Xe([Qe(0,r.$cj),Qe(1,u.$Ri),Qe(2,i.$IE),Qe(3,a.$dk),Qe(4,n.$CN),Qe(5,c.$Nl)],m);function g(b){const L=b.match(/[\*\{\}\(\)\[\]\?]/);if(L){const A=L.index,M=b.substr(0,A).match(/[/|\\][^/\\]*$/);if(M){let Z=b.substr(0,M.index);return Z.match(/[/\\]/)||(Z+="/"),{pathPortion:Z,globPortion:b.substr((M.index||0)+1)}}}return{pathPortion:b}}function d(...b){return b.length?b.reduce((L,A)=>(L[A]=!0,L),Object.create(null)):void 0}function S(b){return C.$Bk(b,",").map(L=>L.trim()).filter(L=>!!L.length)}function k(b){return[`**/${b}/**`,`**/${b}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function w(b){return b.replace(/\\/g,"/")}function P(b){return w(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function R(b){return b.replace(/([?*[\]])/g,"[$1]")}function $(b,L){b=y.$Ob(b,Z=>Z.toString());const A=[],M=L.getWorkspace();return b&&b.forEach(Z=>{let G;if(L.getWorkbenchState()===u.WorkbenchState.FOLDER)G=(0,s.$lh)(M.folders[0].uri,Z),G&&G!=="."&&(G="./"+G);else{const U=L.getWorkspaceFolder(Z);if(U){const V=U.name;if(M.folders.filter(ne=>ne.name===V).length===1){const ne=(0,s.$lh)(U.uri,Z);ne===""?G=`./${U.name}`:G=`./${U.name}/${ne}`}else G=Z.fsPath}}G&&A.push(R(G))}),A}}),define(Oe[272],Ae([1,0,23,2,19,13,3,271,44,50,10]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5yb=h,e.$6yb=r,y=He(y),N=He(N);const v=7e3;function h(a,c){const u=c.activationEvents;if(!u)return Promise.resolve(void 0);const i=[],n=[];for(const d of u)if(/^workspaceContains:/.test(d)){const S=d.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||a.forceUsingSearch?n.push(S):i.push(S)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$Bh)(),l=d=>o({activationEvent:d}),m=Promise.all(i.map(d=>E(a,d,l))).then(()=>{}),g=f(a,c.identifier,n,l);return Promise.all([m,g]).then(()=>{o(void 0)}),t}async function E(a,c,u){for(const i of a.folders)if(await a.exists(y.$jh(D.URI.revive(i),c))){u(`workspaceContains:${c}`);return}}async function f(a,c,u,i){if(u.length===0)return Promise.resolve(void 0);const n=new C.$ze,t=a.checkExists(a.folders,u,n.token),o=setTimeout(async()=>{n.cancel(),a.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},v);let l=!1;try{l=await t}catch(m){N.$6(m)||N.$2(m)}n.dispose(),clearTimeout(o),l&&i(`workspaceContains:${u.join(",")}`)}function r(a,c,u,i){const n=a.get(T.$Hi),t=a.get(p.$lM),l=n.createInstance(O.$GN).file(c.map(m=>(0,s.$4i)(D.URI.revive(m))),{_reason:"checkExists",includePattern:u,exists:!0});return t.fileSearch(l,i).then(m=>!!m.limitHit,m=>N.$6(m)?!1:Promise.reject(m))}}),define(Oe[47],Ae([1,0,9,20,65,23,10,4,49,2,11,5,46,206,89,45,24,121,13,18,22,189,7,110,3,26,92,16,75,93,57,95,6,272,88,191,15,86,70,21,87]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l,m,g,d,S,k,w,P,R,$,b,L,A,M,Z,G,U,V){"use strict";var Q;Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=e.$qrc=e.$prc=e.$orc=e.$nrc=void 0,y=He(y),D=He(D),C=He(C),u=He(u),e.$nrc=(0,m.$Ii)("IHostUtils");let ne=Q=class extends O.$Xc{constructor(Y,W,ee,be,Pe,je,Te,Ee,Fe,Ve,Ge,et,it){super(),this.Y=et,this.Z=it,this.a=this.B(new $.$oe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=ee,this.f=Te,this.j=be,this.m=Pe,this.s=je,this.t=Fe,this.u=Ve,this.w=Ge,this.y=this.g.getProxy(v.$3N.MainThreadWorkspace),this.z=this.g.getProxy(v.$3N.MainThreadTelemetry),this.C=this.g.getProxy(v.$3N.MainThreadExtensionService),this.D=new T.$Hh,this.F=new T.$Hh,this.G=new T.$Hh,this.H=new T.$Hh,this.I=new we(this.f.extensions.activationEvents),this.L=new c.$Gec(this.I,this.f.extensions.allExtensions);const Me=new i.$vn(this.f.extensions.myExtensions);this.J=new c.$Gec(this.I,ce(this.L,Me)),U.$u&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new f.$9qc(this.g,this.s),this.N=new L.$grc(this.g),this.O=Ee,this.h=this.q.add(Y.createChild(new k.$Gi([f.$0qc,this.M],[L.$hrc,this.N]))),this.P=this.B(new E.$8qc(this.J,this.L,{onExtensionActivationError:(Ue,ze,B)=>{this.C.$onExtensionActivationError(Ue,u.$4(ze),B)},actualActivateExtension:async(Ue,ze)=>{if(c.$Gec.isHostExtension(Ue,this.J,this.L))return await this.C.$activateExtension(Ue,ze),new E.$7qc;const B=this.J.getExtensionDescription(Ue);return this.fb(B,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){u.$2(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Pe=>Pe.identifier).filter(Pe=>this.isActivated(Pe)).map(Pe=>this.eb(Pe))}catch{}await Promise.all(Y)}terminate(Y,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),u.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ee=this.$();Promise.race([(0,T.$Jh)(5e3),ee]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const W=await this.C.$getExtension(Y);return W&&{...W,identifier:new i.$un(W.identifier.value),extensionLocation:s.URI.revive(W.extensionLocation)}}ab(Y,W){return this.P.activateByEvent(Y,W)}bb(Y,W){return this.P.activateById(Y,W)}activateByIdWithErrors(Y,W){return this.bb(Y,W).then(()=>{const ee=this.P.getActivatedExtension(Y);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===M.Schemas.file&&this.c.fsRealpath){const W=Y.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const ee=await this.R.get(W);return s.URI.file(ee)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new te(Y))),this.Q}async db(Y){const W=p.$Oi.forUris(ee=>N.$ah.ignorePathCasing(ee));return await Promise.all(Y.map(async ee=>{if(this.wb(ee)){const be=await this.cb(ee.extensionLocation);W.set(be,ee)}})),W}eb(Y){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return W;const ee=this.P.getActivatedExtension(Y);if(!ee)return W;try{typeof ee.module.deactivate=="function"&&(W=Promise.resolve(ee.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(be)}try{ee.disposable.dispose()}catch(be){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(be)}return W}async fb(Y,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,W).then(ee=>{const be=ee.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,W),this.gb(Y,W,"success",be),ee},ee=>{throw this.gb(Y,W,"failure"),ee})}gb(Y,W,ee,be){const Pe=x(Y,W);this.z.$publicLog2("extensionActivationTimes",{...Pe,...be||{},outcome:ee})}hb(Y,W){const ee=x(Y,W);this.z.$publicLog2("activatePlugin",ee);const be=this.wb(Y);if(!be)return Promise.resolve(new E.$6qc(E.$3qc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${Y.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const Pe=new O.$Wc,je=new E.$4qc(W.startup);return Promise.all([this.xb(Y,(0,N.$jh)(Y.extensionLocation,be),je),this.ib(Y,Pe)]).then(Te=>(C.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Q.jb(this.s,Y.identifier,Te[0],Te[1],Pe,je))).then(Te=>(C.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Te))}ib(Y,W){const ee=this.Z.createLanguageModelAccessInformation(Y),be=W.add(new t.$_qc(Y,this.M)),Pe=W.add(new t.$$qc(Y.identifier.value,!1,this.M)),je=W.add(new A.$irc(Y,this.N)),Te=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Ee=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([be.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const Fe=this;let Ve,Ge;const et=(0,a.$uH)(Y,"ipc")?this.f.messagePorts?.get(i.$un.toKey(Y.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Pe,secrets:je,subscriptions:[],get languageModelAccessInformation(){return ee},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(it){return D.$mc(Y.extensionLocation.fsPath,it)},get storagePath(){return Fe.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return Fe.O.globalValue(Y).fsPath},get logPath(){return D.$mc(Fe.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return s.URI.joinPath(Fe.f.logsLocation,Y.identifier.value)},get storageUri(){return Fe.O.workspaceValue(Y)},get globalStorageUri(){return Fe.O.globalValue(Y)},get extensionMode(){return Te},get extension(){return Ve===void 0&&(Ve=new se(Fe,Y.identifier,Y,Ee,!1)),Ve},get extensionRuntime(){return(0,a.$vH)(Y,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Ge){if(!et)return;const it=$.Event.buffer($.Event.fromDOMEventEmitter(et,"message",Me=>Me.data));et.start(),Ge={onDidReceiveMessage:it,postMessage:et.postMessage.bind(et)}}return Ge}})})}static jb(Y,W,ee,be,Pe,je){return ee=ee||{activate:void 0,deactivate:void 0},this.kb(Y,W,ee,be,je).then(Te=>new E.$5qc(!1,null,je.build(),ee,Te,(0,O.$Vc)(()=>{Pe.dispose(),(0,O.$Sc)(be.subscriptions)})))}static kb(Y,W,ee,be,Pe){if(typeof ee.activate=="function")try{Pe.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${W.value}`);const je=typeof global=="object"?global:self,Te=ee.activate.apply(je,[be]);return Pe.activateCallStop(),Pe.activateResolveStart(),Promise.resolve(Te).then(Ee=>(Pe.activateResolveStop(),Ee))}catch(je){return Promise.reject(je)}else return Promise.resolve(ee)}lb(Y,W){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:W}).then(void 0,ee=>{this.s.error(ee)})}mb(Y,W=0){const be=Date.now();(0,U.$C)(()=>{for(let Pe=W;Pe<Y.length;Pe+=1){const je=Y[Pe];for(const Te of je.activationEvents??[])if(Te==="onStartupFinished")if(Date.now()-be>50){this.mb(Y,Pe);break}else this.lb(je,Te)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Y=>{const W=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ee=this.J.getAllExtensionDescriptions();if(W)this.mb(ee);else for(const be of ee)if(be.activationEvents)for(const Pe of be.activationEvents)Pe==="onStartupFinished"&&this.lb(be,Pe)})}ob(){const Y=this.ab("*",!0).then(void 0,je=>{this.s.error(je)});this.B(this.j.onDidChangeWorkspace(je=>this.pb(je.added)));const W=this.j.workspace?this.j.workspace.folders:[],ee=this.pb(W),be=this.rb(),Pe=Promise.all([be,Y,ee]).then(()=>{});return Promise.race([Pe,(0,T.$Jh)(1e4)]).then(()=>{this.nb()}),Pe}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(Y,W))).then(()=>{})}async qb(Y,W){if(this.isActivated(W.identifier))return;const ee=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:Y.map(je=>je.uri),forceUsingSearch:ee||!this.c.fsExists,exists:je=>this.c.fsExists(je.fsPath),checkExists:(je,Te,Ee)=>this.y.$checkExists(je,Te,Ee)},Pe=await(0,b.$5yb)(be,W);if(Pe)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:Pe.activationEvent}).then(void 0,je=>this.s.error(je))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:W}=this.f.environment;if(!Y||!W)throw new Error(y.localize(2699,null));const ee=await this.xb(null,W,new E.$4qc(!1));if(!ee||typeof ee.run!="function")throw new Error(y.localize(2700,null,W.toString()));return new Promise((be,Pe)=>{const je=(Fe,Ve)=>{Fe?(U.$u&&this.s.error("Test runner called back with error",Fe),Pe(Fe)):(U.$u&&(Ve?this.s.info(`Test runner called back with ${Ve} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof Ve=="number"&&Ve>0?1:0))},Te=(0,N.$0g)(W),Ee=ee.run(Te,je);Ee&&Ee.then&&Ee.then(()=>{U.$u&&this.s.info("Test runner finished successfully."),be(0)}).catch(Fe=>{U.$u&&this.s.error("Test runner finished with error",Fe),Pe(Fe instanceof Error&&Fe.stack?Fe.stack:String(Fe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,T.$Jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,W){return this.S[Y]=W,(0,O.$Vc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:W}=await this.ub(Y);return W?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const W=Y.indexOf("+");if(W===-1)throw new o.$aO("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ee=Y.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this.S[ee]}}async $resolveAuthority(Y,W){const ee=G.$ie.create(!1),be=()=>`[resolveAuthority(${(0,l.$Yl)(Y)},${W})][${ee.elapsed()}ms] `,Pe=j=>this.s.info(`${be()}${j}`),je=j=>this.s.warn(`${be()}${j}`),Te=(j,H=void 0)=>this.s.error(`${be()}${j}`,H),Ee=j=>{if(j instanceof o.$aO)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},Fe=async j=>{Pe(`activating resolver for ${j}...`);const{resolver:H,authorityPrefix:J}=await this.ub(j);if(!H)throw Te(`no resolver for ${J}`),new o.$aO(`No remote extension installed to resolve ${J}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:J,remoteAuthority:j}},Ve=Y.split(/@|%40/g).reverse();Pe(`activating remote resolvers ${Ve.join(" -> ")}`);let Ge;try{Ge=await Promise.all(Ve.map(Fe)).catch(async j=>{if(!(j instanceof o.$aO)||j._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return je(`resolving nested authorities failed: ${j.message}`),[await Fe(Y)]})}catch(j){return Ee(j)}const et=new T.$Th;et.cancelAndSet(()=>Pe("waiting..."),1e3);let it,Me;for(const[j,{authorityPrefix:H,resolver:J,remoteAuthority:re}]of Ge.entries())try{if(j===Ge.length-1)Pe("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${H}`),it=await J.resolve(re,{resolveAttempt:W,execServer:Me}),C.mark(`code/extHost/didResolveAuthorityOK/${H}`),Pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,o.$_N.isManagedResolvedAuthority(it)?it:void 0));else{if(Pe(`invoking resolveExecServer() for ${re}`),C.mark(`code/extHost/willResolveExecServer/${H}`),Me=await J.resolveExecServer?.(re,{resolveAttempt:W,execServer:Me}),!Me)throw new o.$aO(`Exec server was not available for ${re}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ge){return C.mark(`code/extHost/didResolveAuthorityError/${H}`),Te("returned an error",ge),et.dispose(),Ee(ge)}et.dispose();const Ue={environmentTunnels:it.environmentTunnels,features:it.tunnelFeatures?{elevation:it.tunnelFeatures.elevation,privacyOptions:it.tunnelFeatures.privacyOptions,protocol:it.tunnelFeatures.protocol===void 0?!0:it.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:it.extensionHostEnv,isTrusted:it.isTrusted,authenticationSession:it.authenticationSessionForInitializingExtensions?{id:it.authenticationSessionForInitializingExtensions.id,providerId:it.authenticationSessionForInitializingExtensions.providerId}:void 0};Pe(`returned ${o.$_N.isManagedResolvedAuthority(it)?"managed authority":`${it.host}:${it.port}`}`);let B;if(o.$_N.isManagedResolvedAuthority(it)){const j=W;this.Y.setFactory(j,it.makeConnection),B={authority:Y,connectTo:new l.$Vl(j),connectionToken:it.connectionToken}}else B={authority:Y,connectTo:new l.$Wl(it.host,it.port),connectionToken:it.connectionToken};return{type:"ok",value:{authority:B,options:ze,tunnelInformation:Ue}}}async $getCanonicalURI(Y,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Yl)(Y)})`);const{resolver:ee}=await this.ub(Y);if(!ee)return null;const be=s.URI.revive(W);if(typeof ee.getCanonicalURI>"u")return be;const Pe=await(0,T.$Ah)(()=>ee.getCanonicalURI(be));return Pe||be}async $startExtensionHost(Y){Y.toAdd.forEach(je=>je.extensionLocation=s.URI.revive(je.extensionLocation));const{globalRegistry:W,myExtensions:ee}=ue(this.I,this.L,this.J,Y),be=await this.db(ee);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ee),U.$u&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(Y,W){return W===a.ActivationKind.Immediate?this.D.wait().then(ee=>this.ab(Y,!1)):this.G.wait().then(ee=>this.ab(Y,!1))}async $activate(Y,W){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,W),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(je=>je.extensionLocation=s.URI.revive(je.extensionLocation));const{globalRegistry:W,myExtensions:ee}=ue(this.I,this.L,this.J,Y),be=await this.db(ee);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ee),U.$u&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const W=n.$Qe.alloc(Y),ee=Math.random()%256;for(let be=0;be<Y;be++)W.writeUInt8(ee,be);return W}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$orc=ne,e.$orc=ne=Q=Xe([Qe(0,m.$Hi),Qe(1,e.$nrc),Qe(2,S.$DQ),Qe(3,r.$Lqc),Qe(4,h.$Oqc),Qe(5,I.$dk),Qe(6,g.$TQ),Qe(7,d.$Rqc),Qe(8,w.$MGb),Qe(9,P.$arc),Qe(10,Z.$krc),Qe(11,V.$lrc),Qe(12,R.$erc)],ne);function ue(Ce,Y,W,ee){Ce.addActivationEvents(ee.addActivationEvents);const be=new c.$Gec(Ce,Y.getAllExtensionDescriptions());be.deltaExtensions(ee.toAdd,ee.toRemove);const Pe=new i.$vn(W.getAllExtensionDescriptions().map(Te=>Te.identifier));for(const Te of ee.myToRemove)Pe.delete(Te);for(const Te of ee.myToAdd)Pe.add(Te);const je=ce(be,Pe);return{globalRegistry:be,myExtensions:je}}function x(Ce,Y){return{id:Ce.identifier.value,name:Ce.name,extensionVersion:Ce.version,publisherDisplayName:Ce.publisher,activationEvents:Ce.activationEvents?Ce.activationEvents.join(","):null,isBuiltin:Ce.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function oe(Ce){return Ce.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$prc=(0,m.$Ii)("IExtHostExtensionService");class se{#e;#t;#i;constructor(Y,W,ee,be,Pe){this.#e=Y,this.#t=W,this.#i=ee.identifier,this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=D.$kc((0,N.$0g)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=be,this.isFromDifferentExtensionHost=Pe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$qrc=se;function ce(Ce,Y){return Ce.getAllExtensionDescriptions().filter(W=>Y.has(W.identifier))}class te{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$rrc=te;class we{constructor(Y){this.a=new i.$wn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const W of Object.keys(Y))this.a.set(W,Y[W])}}}),define(Oe[273],Ae([1,0,65,2,5,46,24,18,16,26,3,47,11,12]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsc=void 0,y=He(y);let r=class{constructor(n,t,o,l,m,g,d){this.c=n,this.d=t,this.e=o,this.f=l,this.g=m,this.h=g,this.i=d,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new c(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(u,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$Hsc=r,e.$Hsc=r=Xe([Qe(2,I.$Hi),Qe(3,N.$Oqc),Qe(4,v.$prc),Qe(5,s.$TQ),Qe(6,h.$dk)],r);let a=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&f.a.size){const t=(0,E.$kf)(this.c(n.environment.appRoot.fsPath)),o="[a-z0-9_.-]",l=`@${o}+\\/${o}+|${o}+`,m="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${m}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,o,l,m]=t,g=f.a.get(l);if(g!==void 0)return console.warn(`${l} as been renamed to ${g}, please update your imports`),o+g+m}c(n){return n.replace(/\\/g,"/")}};a=f=Xe([Qe(0,s.$TQ)],a);class c{constructor(n,t,o,l,m){this.c=n,this.d=t,this.e=o,this.f=l,this.g=m,this.nodeModuleName="vscode",this.a=new O.$wn}load(n,t){const o=this.d.findSubstr(t);if(o){let l=this.a.get(o.identifier);return l||(l=this.c(o,this.e,this.f),this.a.set(o.identifier,l)),l}if(!this.b){let l="";this.d.forEach((m,g)=>l+=`	${g} -> ${m.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(T.$pH,this.e,this.f)}return this.b}}let u=class{constructor(n,t,o){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(C.$3N.MainThreadTelemetry);const l=o.getProxy(C.$3N.MainThreadWindow);this.c=(m,g)=>{const d=D.URI.parse(m);return g?this.g(m,g):d.scheme==="http"||d.scheme==="https"?l.$openUri(d,m,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?l.$openUri(d,m,{}):this.g(m,g)}}load(n,t,o){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=o(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};u=Xe([Qe(2,p.$DQ)],u)}),define(Oe[133],Ae([1,0,48,4,20,79,3,58,71,47,7,45,203,46]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=e.$src=void 0,C=He(C),N=He(N),e.$src=(0,T.$Ii)("IExtHostVariableResolverProvider");class f extends h.$HR{constructor(c,u,i,n,t,o,l){function m(){if(i){const g=i.activeEditor();if(g)return g.document.uri;const d=n.tabGroups.all.find(S=>S.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof I.$TP||d.input instanceof I.$YP)return d.input.modified;if(d.input instanceof I.$SP||d.input instanceof I.$XP||d.input instanceof I.$VP)return d.input.uri}}}super({getFolderUri:g=>{const d=o.folders.filter(S=>S.name===g);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(g,d)=>t.getConfiguration(void 0,g).get(d),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=m();if(g)return C.$kc(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const g=m();if(g){const d=u.getWorkspaceFolder(g);if(d)return C.$kc(d.uri.fsPath)}}},getSelectedText:()=>{if(i){const g=i.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(i){const g=i.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>c.getExtension(g)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(N.env))}}let r=class extends D.$Xc{constructor(c,u,i,n,t){super(),this.b=c,this.c=u,this.g=i,this.h=n,this.j=t,this.a=new y.$W(async()=>{const o=await this.h.getConfigProvider(),m={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{m.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,o,m,this.m())})}getResolver(){return this.a.value}m(){}};e.$trc=r,e.$trc=r=Xe([Qe(0,s.$prc),Qe(1,v.$Lqc),Qe(2,O.$OQ),Qe(3,E.$Oqc),Qe(4,p.$1qc)],r)}),define(Oe[134],Ae([1,0,10,6,2,4,18,3,5,71,47,16,7,45,195,81,196,46,133,35,34,8,17,96]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=e.$Crc=e.$Brc=e.$Arc=e.$zrc=void 0,t=He(t),e.$zrc=(0,O.$Ii)("IExtHostDebugService");let m=class extends N.$Xc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(R,$,b,L,A,M,Z,G){super(),this.Y=$,this.Z=b,this.$=L,this.ab=A,this.bb=M,this.cb=Z,this.db=G,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new D.$oe),this.z=this.B(new D.$oe),this.C=this.B(new D.$oe),this.F=this.B(new D.$oe),this.u=R.getProxy(p.$3N.MainThreadDebugService),this.I=this.B(new D.$oe),this.L=this.B(new D.$oe),this.G=new d(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(U=>{this.B(U.onDidChange(V=>{this.fb(U)})),this.fb(U)})}async $getVisualizerTreeItem(R,$){const b=this.gb($);if(!b)return;const L=await this.Q.get(R)?.getTreeItem?.(b);return L?this.eb(R,L):void 0}registerDebugVisualizationTree(R,$,b){const L=T.$un.toKey(R.identifier),A=this.ub(L,$);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.Q.set(A,b),this.u.$registerDebugVisualizerTree(A,!!b.editItem),(0,N.$Vc)(()=>{this.u.$unregisterDebugVisualizerTree(A),this.Q.delete($)})}async $getVisualizerTreeItemChildren(R,$){const b=this.S.get($)?.item;return b?(await this.Q.get(R)?.getChildren?.(b))?.map(A=>this.eb(R,A))||[]:[]}async $editVisualizerTreeItem(R,$){const b=this.S.get(R);if(!b)return;const L=await this.Q.get(b.provider)?.editItem?.(b.item,$);return this.eb(b.provider,L||b.item)}$disposeVisualizedTree(R){const $=this.S.get(R);if(!$)return;const b=[$.children];for(const L of b)if(L)for(const A of L)b.push(this.S.get(A)?.children),this.S.delete(A)}eb(R,$){let b=this.R.get($);return b||(b=this.O++,this.R.set($,b),this.S.set(b,{provider:R,item:$})),t.DebugTreeItem.from($,b)}asDebugSourceUri(R,$){const b=R;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let L=`debug:${encodeURIComponent(b.path||"")}`,A="?";return $&&(L+=`${A}session=${encodeURIComponent($.id)}`,A="&"),L+=`${A}ref=${b.sourceReference}`,C.URI.parse(L)}else{if(b.path)return C.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(R){const $=[];for(const b of R.getAllExtensionDescriptions())if(b.contributes){const L=b.contributes.debuggers;if(L&&L.length>0)for(const A of L)(0,a.$qI)(A)&&$.push(A.type)}this.u.$registerDebugTypes($)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const R=[];return this.H.forEach($=>R.push($)),R}async $resolveDebugVisualizer(R,$){const b=this.W.get(R);if(!b)throw new Error(`No debug visualizer found with id '${R}'`);let{v:L,provider:A,extensionId:M}=b;if(L.visualization||(L=await A.resolveDebugVisualization?.(L,$)||L,b.v=L),!L.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${A}'`);return this.vb(M,L.visualization)}async $executeDebugVisualizerCommand(R){const $=this.W.get(R);if(!$)throw new Error(`No debug visualizer found with id '${R}'`);const b=$.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(R){const $=this.w.get(R.sessionId);return $&&{session:$.api,variable:R.variable,containerId:R.containerId,frameId:R.frameId,threadId:R.threadId}}async $provideDebugVisualizers(R,$,b,L){const A=this.gb(b),M=this.ub(R,$),Z=this.P.get(M);if(!A||!Z)return[];const G=await Z.provideDebugVisualization(A,L);return G?G.map(U=>{const V=++this.X;this.W.set(V,{v:U,provider:Z,extensionId:R});const Q=U.iconPath?this.wb(U.iconPath):void 0;return{id:V,name:U.name,iconClass:Q?.iconClass,iconPath:Q?.iconPath,visualization:this.vb(R,U.visualization)}}):[]}$disposeDebugVisualizers(R){for(const $ of R)this.W.delete($)}registerDebugVisualizationProvider(R,$,b){if(!R.contributes?.debugVisualizers?.some(M=>M.id===$))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${$})`);const L=T.$un.toKey(R.identifier),A=this.ub(L,$);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.P.set(A,b),this.u.$registerDebugVisualizer(L,$),(0,N.$Vc)(()=>{this.u.$unregisterDebugVisualizer(L,$),this.P.delete($)})}addBreakpoints(R){const $=R.filter(A=>{const M=A.id;return this.H.has(M)?!1:(this.H.set(M,A),!0)});this.rb($,[],[]);const b=[],L=new Map;for(const A of $)if(A instanceof h.$9O){let M=L.get(A.location.uri.toString());M||(M={type:"sourceMulti",uri:A.location.uri,lines:[]},L.set(A.location.uri.toString(),M),b.push(M)),M.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character,mode:A.mode})}else A instanceof h.$0O&&b.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName,mode:A.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(R){const $=R.filter(M=>this.H.delete(M.id));this.rb([],$,[]);const b=$.filter(M=>M instanceof h.$9O).map(M=>M.id),L=$.filter(M=>M instanceof h.$0O).map(M=>M.id),A=$.filter(M=>M instanceof h.$$O).map(M=>M.id);return this.u.$unregisterBreakpoints(b,L,A)}startDebugging(R,$,b){const L=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(R?R.uri:void 0,$,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===h.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:L&&{runId:L.runId,taskId:L.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(R){return this.u.$stopDebugging(R?R.id:void 0)}registerDebugConfigurationProvider(R,$,b){if(!$)return new h.$5N(()=>{});const L=this.f++;return this.g.push({type:R,handle:L,provider:$}),this.u.$registerDebugConfigurationProvider(R,b,!!$.provideDebugConfigurations,!!$.resolveDebugConfiguration,!!$.resolveDebugConfigurationWithSubstitutedVariables,L),new h.$5N(()=>{this.g=this.g.filter(A=>A.provider!==$),this.u.$unregisterDebugConfigurationProvider(L)})}registerDebugAdapterDescriptorFactory(R,$,b){if(!b)return new h.$5N(()=>{});if(!this.nb(R,$))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${$}' debugger.`);if(this.kb($))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const L=this.h++;return this.j.push({type:$,handle:L,factory:b}),this.u.$registerDebugAdapterDescriptorFactory($,L),new h.$5N(()=>{this.j=this.j.filter(A=>A.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(L)})}registerDebugAdapterTrackerFactory(R,$){if(!$)return new h.$5N(()=>{});const b=this.m++;return this.n.push({type:R,handle:b,factory:$}),new h.$5N(()=>{this.n=this.n.filter(L=>L.factory!==$)})}async $runInTerminal(R,$){return Promise.resolve(void 0)}async $substituteVariables(R,$){let b;const L=await this.tb(R);return L&&(b={uri:L.uri,name:L.name,index:L.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,$)}hb(R,$){if(R.type==="implementation")return new k(R.implementation)}ib(){}async $startDASession(R,$){const b=this,L=await this.sb($);return this.pb(this.kb(L.type),L).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}' (extension might have failed to activate)`);const M=this.jb(A),Z=this.hb(M,L);if(!Z)throw new Error(`Couldn't create a debug adapter for type '${L.type}'.`);const G=Z;return this.M.set(R,G),this.ob(L).then(U=>(U&&this.N.set(R,U),G.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const Q=V,ne={type:"response",seq:0,command:Q.command,request_seq:Q.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const ue=await this.U.sign(Q.arguments.value);ne.body={signature:ue},G.sendResponse(ne)}else throw new Error("no signer")}catch(ue){ne.success=!1,ne.message=ue.message,G.sendResponse(ne)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(V),V=(0,a.$vI)(V,!0),b.u.$acceptDAMessage(R,V)}),G.onError(V=>{U&&U.onError&&U.onError(V),this.u.$acceptDAError(R,V.name,V.message,V.stack)}),G.onExit(V=>{U&&U.onExit&&U.onExit(V??void 0,void 0),this.u.$acceptDAExit(R,V??void 0,void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),G.startSession()))})}$sendDAMessage(R,$){$=(0,a.$uI)($,!1);const b=this.N.get(R);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage($),this.M.get(R)?.sendMessage($)}$stopDASession(R){const $=this.N.get(R);this.N.delete(R),$&&$.onWillStopSession&&$.onWillStopSession();const b=this.M.get(R);return this.M.delete(R),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(R){const $=[],b=[],L=[];if(R.added)for(const A of R.added){const M=A.id;if(M&&!this.H.has(M)){let Z;if(A.type==="function")Z=new h.$0O(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode);else if(A.type==="data")Z=new h.$$O(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage,A.mode);else{const G=C.URI.revive(A.uri);Z=new h.$9O(new h.$gO(G,new h.$6N(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode)}(0,h.$7O)(Z,M),this.H.set(M,Z),$.push(Z)}}if(R.removed)for(const A of R.removed){const M=this.H.get(A);M&&(this.H.delete(A),b.push(M))}if(R.changed){for(const A of R.changed)if(A.id){const M=this.H.get(A.id);if(M){if(M instanceof h.$0O&&A.type==="function"){const Z=M;Z.enabled=A.enabled,Z.condition=A.condition,Z.hitCondition=A.hitCondition,Z.logMessage=A.logMessage,Z.functionName=A.functionName}else if(M instanceof h.$9O&&A.type==="source"){const Z=M;Z.enabled=A.enabled,Z.condition=A.condition,Z.hitCondition=A.hitCondition,Z.logMessage=A.logMessage,Z.location=new h.$gO(C.URI.revive(A.uri),new h.$6N(A.line,A.character))}L.push(M)}}}this.rb($,b,L)}async $acceptStackFrameFocus(R){let $;if(R){const b=await this.sb(R.sessionId);R.kind==="thread"?$=new h.$eP(b.api,R.threadId):$=new h.$dP(b.api,R.threadId,R.frameId)}this.J=$,this.L.fire(this.J)}$provideDebugConfigurations(R,$,b){return(0,y.$Ah)(async()=>{const L=this.mb(R);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.tb($);return L.provideDebugConfigurations(A,b)}).then(L=>{if(!L)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return L})}$resolveDebugConfiguration(R,$,b,L){return(0,y.$Ah)(async()=>{const A=this.mb(R);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.tb($);return A.resolveDebugConfiguration(M,b,L)})}$resolveDebugConfigurationWithSubstitutedVariables(R,$,b,L){return(0,y.$Ah)(async()=>{const A=this.mb(R);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.tb($);return A.resolveDebugConfigurationWithSubstitutedVariables(M,b,L)})}async $provideDebugAdapter(R,$){const b=this.lb(R);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const L=await this.sb($);return this.pb(b,L).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}'`);return this.jb(A)})}async $acceptDebugSessionStarted(R){const $=await this.sb(R);this.y.fire($.api)}async $acceptDebugSessionTerminated(R){const $=await this.sb(R);$&&(this.z.fire($.api),this.w.delete($.id))}async $acceptDebugSessionActiveChanged(R){this.D=R?await this.sb(R):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(R,$){(await this.sb(R))?._acceptNameChanged($)}async $acceptDebugSessionCustomEvent(R,$){const L={session:(await this.sb(R)).api,event:$.event,body:$.body};this.F.fire(L)}jb(R){if(R instanceof h.$_O)return{type:"executable",command:R.command,args:R.args,options:R.options};if(R instanceof h.$aP)return{type:"server",port:R.port,host:R.host};if(R instanceof h.$bP)return{type:"pipeServer",path:R.path};if(R instanceof h.$cP)return{type:"implementation",implementation:R.implementation};throw new Error("convertToDto unexpected type")}kb(R){const $=this.j.filter(b=>b.type===R);if($.length>0)return $[0].factory}lb(R){const $=this.j.filter(b=>b.handle===R);if($.length>0)return $[0].factory}mb(R){const $=this.g.filter(b=>b.handle===R);if($.length>0)return $[0].provider}nb(R,$){if(R.contributes){const b=R.contributes.debuggers;if(b&&b.length>0){for(const L of b)if(L.label&&L.type&&L.type===$)return!0}}return!1}ob(R){const b=R.configuration.type,L=this.n.filter(A=>A.type===b||A.type==="*").map(A=>(0,y.$Ah)(()=>A.factory.createDebugAdapterTracker(R.api)).then(M=>M,M=>null));return Promise.race([Promise.all(L).then(A=>{const M=(0,o.$Jb)(A);if(M.length>0)return new S(M)}),new Promise(A=>setTimeout(()=>A(void 0),1e3))]).catch(A=>{})}async pb(R,$){const b=$.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new h.$aP(b));if(R){const A=await this.Z.getExtensionRegistry();return(0,y.$Ah)(()=>R.createDebugAdapterDescriptor($.api,this.qb($,A))).then(M=>{if(M)return M})}const L=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb($,L))}qb(R,$){}rb(R,$,b){(R.length>0||$.length>0||b.length>0)&&this.I.fire(Object.freeze({added:R,removed:$,changed:b}))}async sb(R){if(R)if(typeof R=="string"){const $=this.w.get(R);if($)return $}else{let $=this.w.get(R.id);if(!$){const b=await this.tb(R.folderUri),L=R.parent?this.w.get(R.parent):void 0;$=new g(this.u,R.id,R.type,R.name,b,R.configuration,L?.api),this.w.set($.id,$),this.u.$sessionCached($.id)}return $}throw new Error("cannot find session")}tb(R){if(R){const $=C.URI.revive(R);return this.Y.resolveWorkspaceFolder($)}return Promise.resolve(void 0)}ub(R,$){return`${R}\0${$}`}vb(R,$){if($){if("title"in $&&"command"in $)return{type:r.DebugVisualizationType.Command};if("treeId"in $)return{type:r.DebugVisualizationType.Tree,id:`${R}\0${$.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(R){const $=this.xb(R);let b,L;return"id"in $?L=i.ThemeIcon.asClassName($):b=$,{iconPath:b,iconClass:L}}xb(R){if(R instanceof h.$4O)return{id:R.id};const $=typeof R=="object"&&"dark"in R?R.dark:R,b=typeof R=="object"&&"light"in R?R.light:R;return{dark:typeof $=="string"?C.URI.file($):$,light:typeof b=="string"?C.URI.file(b):b}}};e.$Arc=m,e.$Arc=m=Xe([Qe(0,v.$DQ),Qe(1,E.$Lqc),Qe(2,I.$prc),Qe(3,c.$Oqc),Qe(4,s.$1qc),Qe(5,u.$src),Qe(6,n.$ZQ),Qe(7,l.$urc)],m);class g{constructor(R,$,b,L,A,M,Z){this.f=R,this.g=$,this.h=b,this.j=L,this.k=A,this.l=M,this.m=Z}get api(){const R=this;return this.d??=Object.freeze({id:R.g,type:R.h,get name(){return R.j},set name($){R.j=$,R.f.$setDebugSessionName(R.g,$)},parentSession:R.m,workspaceFolder:R.k,configuration:R.l,customRequest($,b){return R.f.$customDebugAdapterRequest(R.g,$,b)},getDebugProtocolBreakpoint($){return R.f.$getDebugProtocolBreakpoint(R.g,$.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(R){this.j=R}get configuration(){return this.l}}e.$Brc=g;class d{constructor(R){this.value=Object.freeze({append($){R.$appendDebugConsole($)},appendLine($){this.append($+`
`)}})}}e.$Crc=d;class S{constructor(R){this.d=R}onWillStartSession(){this.d.forEach(R=>R.onWillStartSession?R.onWillStartSession():void 0)}onWillReceiveMessage(R){this.d.forEach($=>$.onWillReceiveMessage?$.onWillReceiveMessage(R):void 0)}onDidSendMessage(R){this.d.forEach($=>$.onDidSendMessage?$.onDidSendMessage(R):void 0)}onWillStopSession(){this.d.forEach(R=>R.onWillStopSession?R.onWillStopSession():void 0)}onError(R){this.d.forEach($=>$.onError?$.onError(R):void 0)}onExit(R,$){this.d.forEach(b=>b.onExit?b.onExit(R,$):void 0)}}class k extends f.$yub{constructor(R){super(),this.h=R,R.onDidSendMessage($=>{this.acceptMessage($)})}startSession(){return Promise.resolve(void 0)}sendMessage(R){this.h.handleMessage(R)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends m{constructor(R,$,b,L,A,M,Z,G){super(R,$,b,L,A,M,Z,G)}};e.$Drc=w,e.$Drc=w=Xe([Qe(0,v.$DQ),Qe(1,E.$Lqc),Qe(2,I.$prc),Qe(3,c.$Oqc),Qe(4,s.$1qc),Qe(5,u.$src),Qe(6,n.$ZQ),Qe(7,l.$urc)],w)}),define(Oe[274],Ae([1,0,13,65,2,5,224,11,61,75,26,171,16,66,47,67]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jsc=e.$Isc=void 0,y=He(y),D=He(D);class a{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(O.$dk),o=i.get(h.$DQ).getProxy(N.$3N.MainThreadErrors);y.setUnexpectedErrorHandler(l=>{n.error(l);const m=y.$4(l);o.$onUnexpectedError(m)})}static async installFullHandler(i){const n=i.get(O.$dk),t=i.get(h.$DQ),o=i.get(f.$prc),l=i.get(r.$XQ),m=t.getProxy(N.$3N.MainThreadExtensionService),g=t.getProxy(N.$3N.MainThreadErrors),d=await o.getExtensionPathIndex(),S=new WeakMap;function k(R,$){if(S.has(R))return S.get(R).stack;let b="",L,A;for(const Z of $)b+=`
	at ${Z.toString()}`,A=Z.getFileName(),!L&&A&&(L=d.findSubstr(C.URI.file(A)));const M=`${R.name||"Error"}: ${R.message||""}${b}`;return S.set(R,{extensionIdentifier:L?.identifier,stack:M}),M}const w=Symbol("prepareStackTrace wrapped");let P=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return P},set(R){if(R===k||!R||R[w]){P=R||k;return}P=function($,b){return k($,b),R.call(Error,$,b)},Object.assign(P,{[w]:!0})}}),y.setUnexpectedErrorHandler(R=>{n.error(R);const $=y.$4(R),b=S.get(R);if(!b?.extensionIdentifier){g.$onUnexpectedError($);return}m.$onExtensionRuntimeError(b.extensionIdentifier,$);const L=l.onExtensionError(b.extensionIdentifier,R);n.trace("forwarded error to extension?",L,b)})}}e.$Isc=a;class c{constructor(i,n,t,o,l){this.a=t,this.b=new T.$Oec(i,null,o),n=c.e(n,this.b);const m=new s.$Gi(...(0,p.$Xs)());m.set(I.$TQ,{_serviceBrand:void 0,...n,messagePorts:l}),m.set(h.$DQ,new h.$EQ(this.b)),m.set(E.$Iqc,new E.$Jqc(o)),m.set(f.$nrc,t);const g=new v.$Br(m,!0);g.invokeFunction(a.installEarlyHandler),this.d=g.invokeFunction(d=>d.get(O.$dk)),D.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=g.invokeFunction(d=>d.get(f.$prc)),this.c.initialize(),g.invokeFunction(a.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(N.$3N.MainThreadExtensionService);return C.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=C.URI.revive(n.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=C.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>C.URI.revive(n.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=C.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$Jsc=c}),define(Oe[275],Ae([1,0,17,59]),function($e,e,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=e.$Xrc=e.$Urc=void 0,e.$Vrc=p,e.$Wrc=s,e.$Zrc=E;function C(f){return"uri"in f&&"ranges"in f&&"preview"in f}function N(f){return f.folderOptions.map(r=>({folder:r.folder,excludes:r.excludes.map(a=>typeof a=="string"?a:a.pattern),includes:r.includes,useGlobalIgnoreFiles:r.useIgnoreFiles.global,useIgnoreFiles:r.useIgnoreFiles.local,useParentIgnoreFiles:r.useIgnoreFiles.parent,followSymlinks:r.followSymlinks,maxResults:f.maxResults,session:f.session}))}class T{constructor(r){this.a=r}provideFileSearchResults(r,a,c){return(async()=>{const i=N(a);return Promise.all(i.map(n=>this.a.provideFileSearchResults({pattern:r},n,c)))})().then(i=>(0,y.$Jb)(i).flat())}}e.$Urc=T;function O(f){return f.folderOptions.map(r=>({folder:r.folder,excludes:r.excludes.map(a=>typeof a=="string"?a:a.pattern),includes:r.includes,useGlobalIgnoreFiles:r.useIgnoreFiles.global,useIgnoreFiles:r.useIgnoreFiles.local,useParentIgnoreFiles:r.useIgnoreFiles.parent,followSymlinks:r.followSymlinks,maxResults:f.maxResults,previewOptions:p(f.previewOptions),maxFileSize:f.maxFileSize,encoding:r.encoding,afterContext:f.surroundingContext,beforeContext:f.surroundingContext}))}function p(f){if(!(!f||f.matchLines===void 0&&f.charsPerLine===void 0))return{matchLines:f.matchLines??100,charsPerLine:f.charsPerLine??1e4}}function s(f){if(C(f)){const r=(0,y.$4b)(f.ranges).map((a,c)=>{const i=(0,y.$4b)(f.preview.matches)[c];return{sourceRange:a,previewRange:i}});return new D.$dM(f.uri,r,f.preview.text)}else return new D.$eM(f.uri,f.text,f.lineNumber)}class I{constructor(r){this.a=r}provideTextSearchResults(r,a,c,u){const i=o=>{h(o)&&c.report(s(o))};return(async()=>(0,y.$Jb)(await Promise.all(O(a).map(o=>this.a.provideTextSearchResults(r,o,{report:l=>i(l)},u)))).reduce((o,l)=>({limitHit:o.limitHit||l.limitHit}),{limitHit:!1}))().then(o=>({limitHit:o.limitHit,message:(0,y.$Jb)((0,y.$4b)(o.message))}))}}e.$Xrc=I;class v{constructor(r){this.a=r}provideAITextSearchResults(r,a,c,u){const i=o=>{h(o)&&c.report(s(o))};return(async()=>(0,y.$Jb)(await Promise.all(O(a).map(o=>this.a.provideAITextSearchResults(r,o,{report:l=>i(l)},u)))).reduce((o,l)=>({limitHit:o.limitHit||l.limitHit}),{limitHit:!1}))().then(o=>({limitHit:o.limitHit,message:(0,y.$Jb)((0,y.$4b)(o.message))}))}}e.$Yrc=v;function h(f){if(E(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function E(f){return!!f.preview}}),define(Oe[276],Ae([1,0,10,19,42,15,20,23,49,2,44,59]),function($e,e,y,D,C,N,T,O,p,s,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Trc=e.$Src=e.$Rrc=void 0,T=He(T),O=He(O);class h{constructor(u,i,n){this.e=u,this.f=i,this.g=n,this.b=null,this.c=!1,this.d=0}get h(){return this.e.query}search(u,i){const n=this.h.folderQueries||[],t=new D.$ze(i);return new Promise((o,l)=>{this.b=new f(u);let m=!1;const g=(d,S)=>{if(!m&&!this.c){const k=this.k(d);d instanceof v.$dM&&typeof this.h.maxResults=="number"&&this.d+k>this.h.maxResults&&(this.c=!0,m=!0,t.cancel(),d=this.l(d,this.h.maxResults-this.d));const w=this.k(d);this.d+=w;const P=d instanceof v.$dM;(w>0||!P)&&this.b.add(d,S)}};this.m(n,g,t.token).then(d=>{t.dispose(),this.b.flush(),o({limitHit:this.c||d?.limitHit,messages:this.j(d),stats:{type:this.g}})},d=>{t.dispose();const S=(0,C.$tj)(d);l(new Error(S))})})}j(u){return u?.message?Array.isArray(u.message)?u.message:[u.message]:[]}k(u){return u instanceof v.$dM?Array.isArray(u.ranges)?u.ranges.length:1:0}l(u,i){return new v.$dM(u.uri,u.ranges.slice(0,i),u.previewText)}async m(u,i,n){const t=p.$Oi.forUris();u.forEach((S,k)=>{const w=new I.$EM(this.h,S);t.set(S.folder,{queryTester:w,folder:S.folder,folderIdx:k})});const o=[],l={report:S=>{const k=t.findSubstr(S.uri),w=k.folder.scheme===N.Schemas.file?(0,I.$FM)(()=>this.f.readdir(O.$ih(S.uri))):void 0,P=O.$lh(k.folder,S.uri);if(P){const R=k.queryTester.includedInQuery(P,T.$qc(P),w);(0,y.$uh)(R)?o.push(R.then($=>{$&&i(S,k.folderIdx)})):R&&i(S,k.folderIdx)}}},g={folderOptions:u.map(S=>this.n(S)),maxFileSize:this.h.maxFileSize,maxResults:this.h.maxResults??I.$kM,previewOptions:this.h.previewOptions,surroundingContext:this.h.surroundingContext??0};"usePCRE2"in this.h&&(g.usePCRE2=this.h.usePCRE2);let d;return this.e.query.type===I.QueryType.aiText?d=await this.e.provider.provideAITextSearchResults(this.e.query.contentPattern,g,l,n):d=await this.e.provider.provideTextSearchResults(E(this.e.query.contentPattern),g,l,n),o.length&&await Promise.all(o),d}n(u){const i=(0,I.$DM)(this.h.includePattern,u.includePattern),n=(0,I.$HM)(u.excludePattern?.folder,(0,I.$DM)(this.h.excludePattern,u.excludePattern?.pattern));return{folder:s.URI.from(u.folder),excludes:n,includes:i,useIgnoreFiles:{local:!u.disregardIgnoreFiles,parent:!u.disregardParentIgnoreFiles,global:!u.disregardGlobalIgnoreFiles},followSymlinks:!u.ignoreSymlinks,encoding:(u.fileEncoding&&this.f.toCanonicalName(u.fileEncoding))??""}}}e.$Rrc=h;function E(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class f{constructor(u){this.f=u,this.c=-1,this.e=null,this.b=new a(512,i=>this.h(i))}add(u,i){this.e&&(this.c!==i||!O.$ch(this.d,u.uri))&&(this.g(),this.e=null),this.e||(this.c=i,this.e={resource:u.uri,results:[]}),this.e.results.push(r(u))}g(){const u=this.e&&this.e.results?this.e.results.length:0;this.b.addItem(this.e,u)}flush(){this.g(),this.b.flush()}h(u){this.f(u)}}e.$Src=f;function r(c){return c instanceof v.$dM?{previewText:c.previewText,rangeLocations:c.ranges.map(u=>({preview:{startLineNumber:u.previewRange.start.line,startColumn:u.previewRange.start.character,endLineNumber:u.previewRange.end.line,endColumn:u.previewRange.end.character},source:{startLineNumber:u.sourceRange.start.line,startColumn:u.sourceRange.start.character,endLineNumber:u.sourceRange.end.line,endColumn:u.sourceRange.end.character}}))}:{text:c.text,lineNumber:c.lineNumber}}class a{static{this.b=4e3}static{this.c=50}constructor(u,i){this.h=u,this.j=i,this.d=0,this.e=[],this.f=0}addItem(u,i){u&&this.k(u,i)}addItems(u,i){u&&this.l(u,i)}k(u,i){this.e.push(u),this.f+=i,this.m()}l(u,i){this.e=this.e.concat(u),this.f+=i,this.m()}m(){this.d<a.c?this.flush():this.f>=this.h?this.flush():this.g||(this.g=setTimeout(()=>{this.flush()},a.b))}flush(){this.f&&(this.d+=this.f,this.j(this.e),this.e=[],this.f=0,this.g&&(clearTimeout(this.g),this.g=0))}}e.$Trc=a}),define(Oe[135],Ae([1,0,4,5,3,270,16,66,11,2,276,33,275]),function($e,e,y,D,C,N,T,O,p,s,I,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rc=e.$1rc=void 0,e.$3rc=f,e.$1rc=(0,C.$Ii)("IExtHostSearch");let E=class{constructor(c,u,i){this.n=c,this.o=u,this.q=i,this.c=this.n.getProxy(D.$3N.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$Qrc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProviderOld(c,u){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const i=this.d++;return this.e.set(i,new h.$Xrc(u)),this.c.$registerTextSearchProvider(i,this.s(c)),(0,y.$Vc)(()=>{this.g.delete(c),this.e.delete(i),this.c.$unregisterProvider(i)})}registerTextSearchProvider(c,u){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const i=this.d++;return this.e.set(i,u),this.c.$registerTextSearchProvider(i,this.s(c)),(0,y.$Vc)(()=>{this.g.delete(c),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProviderOld(c,u){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const i=this.d++;return this.h.set(i,new h.$Yrc(u)),this.c.$registerAITextSearchProvider(i,this.s(c)),(0,y.$Vc)(()=>{this.i.delete(c),this.h.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider(c,u){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const i=this.d++;return this.h.set(i,u),this.c.$registerAITextSearchProvider(i,this.s(c)),(0,y.$Vc)(()=>{this.i.delete(c),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProviderOld(c,u){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const i=this.d++;return this.j.set(i,new h.$Urc(u)),this.c.$registerFileSearchProvider(i,this.s(c)),(0,y.$Vc)(()=>{this.k.delete(c),this.j.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(c,u){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const i=this.d++;return this.j.set(i,u),this.c.$registerFileSearchProvider(i,this.s(c)),(0,y.$Vc)(()=>{this.k.delete(c),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(c,u,i,n){const t=f(i),o=this.j.get(c);if(o)return this.l.fileSearch(t,o,l=>{this.c.$handleFileMatch(c,u,l.map(m=>m.resource))},n);throw new Error("unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,u,i){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,u,i,n){const t=this.e.get(c);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${c}`);const o=f(i);return this.t(o,t).search(m=>this.c.$handleTextMatch(c,u,m),n)}$provideAITextSearchResults(c,u,i,n){const t=this.h.get(c);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${c}`);const o=f(i);return this.v(o,t).search(m=>this.c.$handleTextMatch(c,u,m),n)}$enableExtensionHostSearch(){}t(c,u){return new I.$Rrc({query:c,provider:u},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v(c,u){return new I.$Rrc({query:c,provider:u},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$2rc=E,e.$2rc=E=Xe([Qe(0,T.$DQ),Qe(1,O.$Iqc),Qe(2,p.$dk)],E);function f(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(r),extraFileResources:a.extraFileResources&&a.extraFileResources.map(c=>s.URI.revive(c))}}function r(a){return(0,v.$fi)(a)}});var si=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Oe[277],Ae([1,0,19,13,6,4,15,36,2,106,158,159,53,18,29,11,63,64,185,5,227,256,85,91,232,233,234,211,201,34,235,46,236,134,124,237,213,228,238,239,58,71,214,229,47,241,69,242,51,26,257,215,243,244,95,245,86,87,217,269,247,190,248,258,249,130,218,250,251,252,16,253,135,88,254,219,255,89,92,132,67,57,128,96,259,230,260,261,93,8,7,220,66,221,68,262,263,123,45,81,84,24,59]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l,m,g,d,S,k,w,P,R,$,b,L,A,M,Z,G,U,V,Q,ne,ue,x,oe,se,ce,te,we,Ce,Y,W,ee,be,Pe,je,Te,Ee,Fe,Ve,Ge,et,it,Me,Ue,ze,B,j,H,J,re,ge,ke,qe,xe,rt,st,ut,ot,lt,vt,nt,he,pe,ye,Re,fe,ve,X,q,de,We,Je,ct,dt,mt,Rt,At,Qt,_t,_e,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsc=Ut,D=He(D),O=si(O),v=He(v),f=He(f),X=He(X),q=He(q);function Ut($t){const Pt=$t.get(we.$TQ),ei=$t.get(te.$tqc),ti=$t.get(se.$Qqc),Ht=$t.get(x.$prc),wt=$t.get(At.$Lqc),Nt=$t.get(lt.$XQ),ai=$t.get(R.$Oqc),Zt=$t.get(We.$Iqc),Ye=$t.get(J.$DQ),ii=$t.get(st.$0qc),ci=$t.get(ut.$Rqc),ui=$t.get(r.$ek),Et=$t.get(r.$dk),jt=$t.get(ve.$MGb),Lt=$t.get(o.$pqc),Bt=$t.get(Rt.$Csc),oi=$t.get(ke.$hrc),ni=$t.get(Q.$1qc),ri=$t.get(Te.$lrc),Kt=$t.get(l.$zqc),Gt=$t.get(be.$erc);Ye.set(i.$4N.ExtHostFileSystemInfo,ei),Ye.set(i.$4N.ExtHostLogLevelServiceShape,ui),Ye.set(i.$4N.ExtHostWorkspace,wt),Ye.set(i.$4N.ExtHostConfiguration,ai),Ye.set(i.$4N.ExtHostExtensionService,Ht),Ye.set(i.$4N.ExtHostStorage,ii),Ye.set(i.$4N.ExtHostTunnelService,jt),Ye.set(i.$4N.ExtHostWindow,Bt),Ye.set(i.$4N.ExtHostSecretState,oi),Ye.set(i.$4N.ExtHostTelemetry,Nt),Ye.set(i.$4N.ExtHostEditorTabs,ni),Ye.set(i.$4N.ExtHostManagedSockets,ri),Ye.set(i.$4N.ExtHostAuthentication,Kt),Ye.set(i.$4N.ExtHostChatProvider,Gt);const li=Ye.set(i.$4N.ExtHostDecorations,$t.get(L.$Frc)),Mt=Ye.set(i.$4N.ExtHostDocumentsAndEditors,$t.get(V.$OQ)),Dt=Ye.set(i.$4N.ExtHostCommands,$t.get(w.$ZQ)),bt=Ye.set(i.$4N.ExtHostTerminalService,$t.get(vt.$arc)),Jt=Ye.set(i.$4N.ExtHostTerminalShellIntegration,$t.get(nt.$ssc)),St=Ye.set(i.$4N.ExtHostDebugService,$t.get(b.$zrc)),hi=Ye.set(i.$4N.ExtHostSearch,$t.get(ge.$1rc)),Xt=Ye.set(i.$4N.ExtHostTask,$t.get(ot.$rsc)),Mi=Ye.set(i.$4N.ExtHostOutputService,$t.get(Ue.$esc)),di=Ye.set(i.$4N.ExtHostLocalization,$t.get(je.$krc)),yi=Ye.set(i.$4N.ExtHostUrls,new Je.$zsc(Ye)),Wt=Ye.set(i.$4N.ExtHostDocuments,new U.$wqc(Ye,Mt)),fi=Ye.set(i.$4N.ExtHostDocumentContentProviders,new Z.$Hrc(Ye,Mt,Et)),Fi=Ye.set(i.$4N.ExtHostDocumentSaveParticipant,new G.$Irc(Et,Wt,Ye.getProxy(i.$3N.MainThreadBulkEdits))),Ct=Ye.set(i.$4N.ExtHostNotebook,new Fe.$4rc(Ye,Dt,Mt,Wt,ti,hi,Et)),Si=Ye.set(i.$4N.ExtHostNotebookDocuments,new Ge.$$rc(Ct)),Ai=Ye.set(i.$4N.ExtHostNotebookEditors,new et.$_rc(Et,Ct)),gi=Ye.set(i.$4N.ExtHostNotebookKernels,new it.$asc(Ye,Pt,Ct,Dt,Et)),zi=Ye.set(i.$4N.ExtHostNotebookRenderers,new Me.$csc(Ye,Ct)),ji=Ye.set(i.$4N.ExtHostNotebookDocumentSaveParticipant,new Ve.$0rc(Et,Ct,Ye.getProxy(i.$3N.MainThreadBulkEdits))),zt=Ye.set(i.$4N.ExtHostEditors,new pe.$Fqc(Ye,Mt)),Pi=Ye.set(i.$4N.ExtHostTreeViews,new fe.$xsc(Ye.getProxy(i.$3N.MainThreadTreeViews),Dt,Et)),Di=Ye.set(i.$4N.ExtHostEditorInsets,new k.$Gqc(Ye.getProxy(i.$3N.MainThreadEditorInsets),zt,Pt.remote)),wi=Ye.set(i.$4N.ExtHostDiagnostics,new A.$vqc(Ye,Et,ei,Mt)),bi=Ye.set(i.$4N.ExtHostLanguages,new Pe.$8rc(Ye,Wt,Dt.converter,Zt)),me=Ye.set(i.$4N.ExtHostLanguageFeatures,new W.$xqc(Ye,Zt,Wt,Dt,wi,Et,Lt,Nt)),De=Ye.set(i.$4N.ExtHostFileSystem,new oe.$Lrc(Ye,me)),ae=Ye.set(i.$4N.ExtHostFileSystemEventService,new ce.$Mrc(Ye,Et,Mt)),K=Ye.set(i.$4N.ExtHostQuickOpen,(0,H.$isc)(Ye,wt,Dt)),Ie=Ye.set(i.$4N.ExtHostSCM,new re.$ksc(Ye,Dt,Wt,Et)),Be=Ye.set(i.$4N.ExtHostQuickDiff,new j.$hsc(Ye,Zt)),tt=Ye.set(i.$4N.ExtHostShare,new qe.$lsc(Ye,Zt)),Ke=Ye.set(i.$4N.ExtHostComments,(0,P.$Hqc)(Ye,Dt,Wt)),gt=Ye.set(i.$4N.ExtHostProgress,new B.$gsc(Ye.getProxy(i.$3N.MainThreadProgress))),Tt=Ye.set(i.$4N.ExtHostLabelService,new Y.$6rc(Ye)),Yt=Ye.set(i.$4N.ExtHostTheming,new ye.$usc(Ye)),Vt=Ye.set(i.$4N.ExtHostTimeline,new Re.$wsc(Ye,Dt)),qt=Ye.set(i.$4N.ExtHostWebviews,new ct.$Vqc(Ye,Pt.remote,wt,Et,Lt)),Ni=Ye.set(i.$4N.ExtHostWebviewPanels,new dt.$Yqc(Ye,qt,wt)),en=Ye.set(i.$4N.ExtHostCustomEditors,new $.$Zqc(Ye,Wt,ci,qt,Ni)),Vi=Ye.set(i.$4N.ExtHostWebviewViews,new mt.$Asc(Ye,qt)),Ei=Ye.set(i.$4N.ExtHostTesting,$t.get(he.$urc)),tn=Ye.set(i.$4N.ExtHostUriOpeners,new de.$ysc(Ye)),nn=Ye.set(i.$4N.ExtHostProfileContentHandlers,new ze.$fsc(Ye));Ye.set(i.$4N.ExtHostInteractive,new Ce.$5rc(Ye,Ct,Mt,Dt,Et));const Ui=Ye.set(i.$4N.ExtHostChatAgents2,new g.$Cqc(Ye,Et,Dt,Wt)),rn=Ye.set(i.$4N.ExtHostChatVariables,new d.$Dqc(Ye)),Bi=Ye.set(i.$4N.ExtHostLanguageModelTools,new ee.$7rc(Ye)),Qi=Ye.set(i.$4N.ExtHostAiRelatedInformation,new n.$oqc(Ye)),sn=Ye.set(i.$4N.ExtHostAiEmbeddingVector,new ue.$Krc(Ye)),on=Ye.set(i.$4N.ExtHostStatusBar,new rt.$osc(Ye,Dt.converter)),wn=Ye.set(i.$4N.ExtHostSpeech,new xe.$msc(Ye)),Ci=Ye.set(i.$4N.ExtHostEmbeddings,new ne.$Jrc(Ye)),Hi=Object.values(i.$4N);Ye.assertRegistered(Hi);const bn=new m.$Bqc(Ye,Mt),vn=new S.$Eqc(Ye),qi=new Ee.$9rc(Ye,Et),an=new M.$Grc(Ye);return t.$yqc.register(Dt),function(Le,mi,Ki){function ht(_){return(le,Ne,ft)=>{const It=_(Ft=>{try{le.call(Ne,Ft)}catch(Ti){D.$3(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Ti.toString()}`,{cause:Ti})),Nt.onExtensionError(Le.identifier,Ti)}});return ft?.push(It),It}}const kt=function(){let _=!Le.isUnderDevelopment;function le(){_||(Et.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Ne(ft){if(Array.isArray(ft))ft.forEach(Ne);else if(typeof ft=="string")le();else{const It=ft;typeof It.scheme>"u"&&le(),typeof It.exclusive=="boolean"&&(0,_e.$vH)(Le,"documentFiltersExclusive")}return ft}}(),yn={getSession(_,le,Ne){return typeof Ne?.forceNewSession=="object"&&Ne.forceNewSession.learnMore&&(0,_e.$vH)(Le,"authLearnMore"),Kt.getSession(Le,_,le,Ne)},getAccounts(_){return Kt.getAccounts(_)},async hasSession(_,le){return(0,_e.$vH)(Le,"authSession"),!!await Kt.getSession(Le,_,le,{silent:!0})},get onDidChangeSessions(){return ht(Kt.onDidChangeSessions)},registerAuthenticationProvider(_,le,Ne,ft){return Kt.registerAuthenticationProvider(_,le,Ne,ft)}},Gi={registerCommand(_,le,Ne){return Dt.registerCommand(!0,_,le,Ne,void 0,Le)},registerTextEditorCommand(_,le,Ne){return Dt.registerCommand(!0,_,(...ft)=>{const It=zt.getActiveTextEditor();if(!It){Et.warn("Cannot execute "+_+" because there is no active text editor.");return}return It.edit(Ft=>{le.apply(Ne,[It,Ft,...ft])}).then(Ft=>{Ft||Et.warn("Edits from command "+_+" were not applied.")},Ft=>{Et.warn("An error occurred while running command "+_,Ft)})},void 0,void 0,Le)},registerDiffInformationCommand:(_,le,Ne)=>((0,_e.$vH)(Le,"diffCommand"),Dt.registerCommand(!0,_,async(...ft)=>{const It=Mt.activeEditor(!0);if(!It){Et.warn("Cannot execute "+_+" because there is no active text editor.");return}const Ft=await zt.getDiffInformation(It.id);le.apply(Ne,[Ft,...ft])},void 0,void 0,Le)),executeCommand(_,...le){return Dt.executeCommand(_,...le)},getCommands(_=!1){return Dt.getCommands(_)}},Ji={get machineId(){return Pt.telemetryInfo.machineId},get sessionId(){return Pt.telemetryInfo.sessionId},get language(){return Pt.environment.appLanguage},get appName(){return Pt.environment.appName},get appRoot(){return Pt.environment.appRoot?.fsPath??""},get appHost(){return Pt.environment.appHost},get uriScheme(){return Pt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ht(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ht(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$vH)(Le,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$vH)(Le,"telemetry"),ht(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,lt.$WQ)(Pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,le){return lt.$VQ.validateSender(_),Nt.instantiateLogger(Le,_,le)},openExternal(_,le){return Bt.openUri(_,{allowTunneling:!!Pt.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===Pt.environment.appUriScheme)return yi.createAppUri(_);try{return await Bt.asExternalUri(_,{allowTunneling:!!Pt.remote.authority})}catch(le){if((0,T.$Rg)(_,T.Schemas.http)||(0,T.$Rg)(_,T.Schemas.https))return _;throw le}},get remoteName(){return(0,a.$ln)(Pt.remote.authority)},get remoteAuthority(){return(0,_e.$vH)(Le,"resolvers"),Pt.remote.authority},get uiKind(){return Pt.uiKind},get logLevel(){return Et.getLevel()},get onDidChangeLogLevel(){return ht(Et.onDidChangeLogLevel)},get appQuality(){return(0,_e.$vH)(Le,"resolvers"),Pt.quality},get appCommit(){return(0,_e.$vH)(Le,"resolvers"),Pt.commit}};Pt.environment.extensionTestsLocationURI||Object.freeze(Ji);const ki={createTestController(_,le,Ne){return Ei.createTestController(Le,_,le,Ne)},createTestObserver(){return(0,_e.$vH)(Le,"testObserver"),Ei.createTestObserver()},runTests(_){return(0,_e.$vH)(Le,"testObserver"),Ei.runTests(_)},registerTestFollowupProvider(_){return(0,_e.$vH)(Le,"testObserver"),Ei.registerTestFollowupProvider(_)},get onDidChangeTestResults(){return(0,_e.$vH)(Le,"testObserver"),ht(Ei.onResultsChanged)},get testResults(){return(0,_e.$vH)(Le,"testObserver"),Ei.results}},Ri=Pt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,Sn={getExtension(_,le){(0,_e.$uH)(Le,"extensionsAny")||(le=!1);const Ne=mi.mine.getExtensionDescription(_);if(Ne)return new x.$qrc(Ht,Le.identifier,Ne,Ri,!1);if(le){const ft=mi.all.getExtensionDescription(_);if(ft)return new x.$qrc(Ht,Le.identifier,ft,Ri,!0)}},get all(){const _=[];for(const le of mi.mine.getAllExtensionDescriptions())_.push(new x.$qrc(Ht,Le.identifier,le,Ri,!1));return _},get allAcrossExtensionHosts(){(0,_e.$vH)(Le,"extensionsAny");const _=new E.$vn(mi.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),le=[];for(const Ne of mi.all.getAllExtensionDescriptions()){const ft=!_.has(Ne.identifier);le.push(new x.$qrc(Ht,Le.identifier,Ne,Ri,ft))}return le},get onDidChange(){return(0,_e.$uH)(Le,"extensionsAny")?ht(C.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ht(mi.mine.onDidChange)}},pi={createDiagnosticCollection(_){return wi.createDiagnosticCollection(Le.identifier,_)},get onDidChangeDiagnostics(){return ht(wi.onDidChangeDiagnostics)},getDiagnostics:_=>wi.getDiagnostics(_),getLanguages(){return bi.getLanguages()},setTextDocumentLanguage(_,le){return bi.changeLanguage(_.uri,le)},match(_,le){const Ne=X.LanguageSelector.from(_);let ft;return(0,I.$Cu)(Ne)&&(ft=Ct.notebookDocuments.find(It=>It.apiNotebook.getCells().find(Ft=>Ft.document===le))?.apiNotebook),(0,I.$Bu)(Ne,le.uri,le.languageId,!0,ft?.uri,ft?.notebookType)},registerCodeActionsProvider(_,le,Ne){return me.registerCodeActionProvider(Le,kt(_),le,Ne)},registerDocumentPasteEditProvider(_,le,Ne){return(0,_e.$vH)(Le,"documentPaste"),me.registerDocumentPasteEditProvider(Le,kt(_),le,Ne)},registerCodeLensProvider(_,le){return me.registerCodeLensProvider(Le,kt(_),le)},registerDefinitionProvider(_,le){return me.registerDefinitionProvider(Le,kt(_),le)},registerDeclarationProvider(_,le){return me.registerDeclarationProvider(Le,kt(_),le)},registerImplementationProvider(_,le){return me.registerImplementationProvider(Le,kt(_),le)},registerTypeDefinitionProvider(_,le){return me.registerTypeDefinitionProvider(Le,kt(_),le)},registerHoverProvider(_,le){return me.registerHoverProvider(Le,kt(_),le,Le.identifier)},registerEvaluatableExpressionProvider(_,le){return me.registerEvaluatableExpressionProvider(Le,kt(_),le,Le.identifier)},registerInlineValuesProvider(_,le){return me.registerInlineValuesProvider(Le,kt(_),le,Le.identifier)},registerDocumentHighlightProvider(_,le){return me.registerDocumentHighlightProvider(Le,kt(_),le)},registerMultiDocumentHighlightProvider(_,le){return me.registerMultiDocumentHighlightProvider(Le,kt(_),le)},registerLinkedEditingRangeProvider(_,le){return me.registerLinkedEditingRangeProvider(Le,kt(_),le)},registerReferenceProvider(_,le){return me.registerReferenceProvider(Le,kt(_),le)},registerRenameProvider(_,le){return me.registerRenameProvider(Le,kt(_),le)},registerNewSymbolNamesProvider(_,le){return(0,_e.$vH)(Le,"newSymbolNamesProvider"),me.registerNewSymbolNamesProvider(Le,kt(_),le)},registerDocumentSymbolProvider(_,le,Ne){return me.registerDocumentSymbolProvider(Le,kt(_),le,Ne)},registerWorkspaceSymbolProvider(_){return me.registerWorkspaceSymbolProvider(Le,_)},registerDocumentFormattingEditProvider(_,le){return me.registerDocumentFormattingEditProvider(Le,kt(_),le)},registerDocumentRangeFormattingEditProvider(_,le){return me.registerDocumentRangeFormattingEditProvider(Le,kt(_),le)},registerOnTypeFormattingEditProvider(_,le,Ne,...ft){return me.registerOnTypeFormattingEditProvider(Le,kt(_),le,[Ne].concat(ft))},registerDocumentSemanticTokensProvider(_,le,Ne){return me.registerDocumentSemanticTokensProvider(Le,kt(_),le,Ne)},registerDocumentRangeSemanticTokensProvider(_,le,Ne){return me.registerDocumentRangeSemanticTokensProvider(Le,kt(_),le,Ne)},registerSignatureHelpProvider(_,le,Ne,...ft){return typeof Ne=="object"?me.registerSignatureHelpProvider(Le,kt(_),le,Ne):me.registerSignatureHelpProvider(Le,kt(_),le,typeof Ne>"u"?[]:[Ne,...ft])},registerCompletionItemProvider(_,le,...Ne){return me.registerCompletionItemProvider(Le,kt(_),le,Ne)},registerInlineCompletionItemProvider(_,le,Ne){return le.handleDidShowCompletionItem&&(0,_e.$vH)(Le,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,_e.$vH)(Le,"inlineCompletionsAdditions"),Ne&&(0,_e.$vH)(Le,"inlineCompletionsAdditions"),me.registerInlineCompletionsProvider(Le,kt(_),le,Ne)},registerInlineEditProvider(_,le){return(0,_e.$vH)(Le,"inlineEdit"),me.registerInlineEditProvider(Le,kt(_),le)},registerDocumentLinkProvider(_,le){return me.registerDocumentLinkProvider(Le,kt(_),le)},registerColorProvider(_,le){return me.registerColorProvider(Le,kt(_),le)},registerFoldingRangeProvider(_,le){return me.registerFoldingRangeProvider(Le,kt(_),le)},registerSelectionRangeProvider(_,le){return me.registerSelectionRangeProvider(Le,_,le)},registerCallHierarchyProvider(_,le){return me.registerCallHierarchyProvider(Le,_,le)},registerTypeHierarchyProvider(_,le){return me.registerTypeHierarchyProvider(Le,_,le)},setLanguageConfiguration:(_,le)=>me.setLanguageConfiguration(Le,_,le),getTokenInformationAtPosition(_,le){return(0,_e.$vH)(Le,"tokenInformation"),bi.tokenAtPosition(_,le)},registerInlayHintsProvider(_,le){return me.registerInlayHintsProvider(Le,_,le)},createLanguageStatusItem(_,le){return bi.createLanguageStatusItem(Le,_,le)},registerDocumentDropEditProvider(_,le,Ne){return me.registerDocumentOnDropEditProvider(Le,_,le,(0,_e.$uH)(Le,"documentPaste")?Ne:void 0)}},Wi={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(_,le,Ne){p.URI.isUri(_)&&_.scheme===T.Schemas.vscodeRemote&&!_.authority&&Lt.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const ft=await(p.URI.isUri(_)?Promise.resolve(Zi.openTextDocument(_)):Promise.resolve(_));return zt.showTextDocument(ft,le,Ne)},createTextEditorDecorationType(_){return zt.createTextEditorDecorationType(Le,_)},onDidChangeActiveTextEditor(_,le,Ne){return ht(zt.onDidChangeActiveTextEditor)(_,le,Ne)},onDidChangeVisibleTextEditors(_,le,Ne){return ht(zt.onDidChangeVisibleTextEditors)(_,le,Ne)},onDidChangeTextEditorSelection(_,le,Ne){return ht(zt.onDidChangeTextEditorSelection)(_,le,Ne)},onDidChangeTextEditorOptions(_,le,Ne){return ht(zt.onDidChangeTextEditorOptions)(_,le,Ne)},onDidChangeTextEditorVisibleRanges(_,le,Ne){return ht(zt.onDidChangeTextEditorVisibleRanges)(_,le,Ne)},onDidChangeTextEditorViewColumn(_,le,Ne){return ht(zt.onDidChangeTextEditorViewColumn)(_,le,Ne)},onDidCloseTerminal(_,le,Ne){return ht(bt.onDidCloseTerminal)(_,le,Ne)},onDidOpenTerminal(_,le,Ne){return ht(bt.onDidOpenTerminal)(_,le,Ne)},onDidChangeActiveTerminal(_,le,Ne){return ht(bt.onDidChangeActiveTerminal)(_,le,Ne)},onDidChangeTerminalDimensions(_,le,Ne){return(0,_e.$vH)(Le,"terminalDimensions"),ht(bt.onDidChangeTerminalDimensions)(_,le,Ne)},onDidChangeTerminalState(_,le,Ne){return ht(bt.onDidChangeTerminalState)(_,le,Ne)},onDidWriteTerminalData(_,le,Ne){return(0,_e.$vH)(Le,"terminalDataWriteEvent"),ht(bt.onDidWriteTerminalData)(_,le,Ne)},onDidExecuteTerminalCommand(_,le,Ne){return(0,_e.$vH)(Le,"terminalExecuteCommandEvent"),ht(bt.onDidExecuteTerminalCommand)(_,le,Ne)},onDidChangeTerminalShellIntegration(_,le,Ne){return ht(Jt.onDidChangeTerminalShellIntegration)(_,le,Ne)},onDidStartTerminalShellExecution(_,le,Ne){return ht(Jt.onDidStartTerminalShellExecution)(_,le,Ne)},onDidEndTerminalShellExecution(_,le,Ne){return ht(Jt.onDidEndTerminalShellExecution)(_,le,Ne)},get state(){return Bt.getState()},onDidChangeWindowState(_,le,Ne){return ht(Bt.onDidChangeWindowState)(_,le,Ne)},showInformationMessage(_,...le){return qi.showMessage(Le,O.default.Info,_,le[0],le.slice(1))},showWarningMessage(_,...le){return qi.showMessage(Le,O.default.Warning,_,le[0],le.slice(1))},showErrorMessage(_,...le){return qi.showMessage(Le,O.default.Error,_,le[0],le.slice(1))},showQuickPick(_,le,Ne){return K.showQuickPick(Le,_,le,Ne)},showWorkspaceFolderPick(_){return K.showWorkspaceFolderPick(_)},showInputBox(_,le){return K.showInput(_,le)},showOpenDialog(_){return an.showOpenDialog(Le,_)},showSaveDialog(_){return an.showSaveDialog(_)},createStatusBarItem(_,le,Ne){let ft,It,Ft;return typeof _=="string"?(ft=_,It=le,Ft=Ne):(It=_,Ft=le),on.createStatusBarEntry(Le,ft,It,Ft)},setStatusBarMessage(_,le){return on.setStatusBarMessage(_,le)},withScmProgress(_){return Lt.report("window.withScmProgress",Le,"Use 'withProgress' instead."),gt.withProgress(Le,{location:q.ProgressLocation.SourceControl},(le,Ne)=>_({report(ft){}}))},withProgress(_,le){return gt.withProgress(Le,_,le)},createOutputChannel(_,le){return Mi.createOutputChannel(_,le,Le)},createWebviewPanel(_,le,Ne,ft){return Ni.createWebviewPanel(Le,_,le,Ne,ft)},createWebviewTextEditorInset(_,le,Ne,ft){return(0,_e.$vH)(Le,"editorInsets"),Di.createWebviewEditorInset(_,le,Ne,ft,Le)},createTerminal(_,le,Ne){return typeof _=="object"?"pty"in _?bt.createExtensionTerminal(_):bt.createTerminalFromOptions(_):bt.createTerminal(_,le,Ne)},registerTerminalLinkProvider(_){return bt.registerLinkProvider(_)},registerTerminalProfileProvider(_,le){return bt.registerProfileProvider(Le,_,le)},registerTerminalQuickFixProvider(_,le){return(0,_e.$vH)(Le,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(_,Le.identifier.value,le)},registerTreeDataProvider(_,le){return Pi.registerTreeDataProvider(_,le,Le)},createTreeView(_,le){return Pi.createTreeView(_,le,Le)},registerWebviewPanelSerializer:(_,le)=>Ni.registerWebviewPanelSerializer(Le,_,le),registerCustomEditorProvider:(_,le,Ne={})=>en.registerCustomEditorProvider(Le,_,le,Ne),registerFileDecorationProvider(_){return li.registerFileDecorationProvider(_,Le)},registerUriHandler(_){return yi.registerUriHandler(Le,_)},createQuickPick(){return K.createQuickPick(Le)},createInputBox(){return K.createInputBox(Le)},get activeColorTheme(){return Yt.activeColorTheme},onDidChangeActiveColorTheme(_,le,Ne){return ht(Yt.onDidChangeActiveColorTheme)(_,le,Ne)},registerWebviewViewProvider(_,le,Ne){return Vi.registerWebviewViewProvider(Le,_,le,Ne?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,le,Ne){return ht(Ct.onDidChangeActiveNotebookEditor)(_,le,Ne)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ht(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,le,Ne){return ht(Ai.onDidChangeNotebookEditorSelection)(_,le,Ne)},onDidChangeNotebookEditorVisibleRanges(_,le,Ne){return ht(Ai.onDidChangeNotebookEditorVisibleRanges)(_,le,Ne)},showNotebookDocument(_,le){return Ct.showNotebookDocument(_,le)},registerExternalUriOpener(_,le,Ne){return(0,_e.$vH)(Le,"externalUriOpener"),tn.registerExternalUriOpener(Le.identifier,_,le,Ne)},registerProfileContentHandler(_,le){return(0,_e.$vH)(Le,"profileContentHandlers"),nn.registerProfileContentHandler(Le,_,le)},registerQuickDiffProvider(_,le,Ne,ft){return(0,_e.$vH)(Le,"quickDiffProvider"),Be.registerQuickDiffProvider(kt(_),le,Ne,ft)},get tabGroups(){return ni.tabGroups},registerShareProvider(_,le){return(0,_e.$vH)(Le,"shareProvider"),tt.registerShareProvider(kt(_),le)}},Zi={get rootPath(){return Lt.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(_){throw new D.$$("rootPath")},getWorkspaceFolder(_){return wt.getWorkspaceFolder(_)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(_){throw new D.$$("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(_){throw new D.$$("workspaceFile")},updateWorkspaceFolders:(_,le,...Ne)=>wt.updateWorkspaceFolders(Le,_,le||0,...Ne),onDidChangeWorkspaceFolders:function(_,le,Ne){return ht(wt.onDidChangeWorkspace)(_,le,Ne)},asRelativePath:(_,le)=>wt.getRelativePath(_,le),findFiles:(_,le,Ne,ft)=>wt.findFiles(_,le,Ne,Le.identifier,ft),findFiles2:(_,le,Ne)=>((0,_e.$vH)(Le,"findFiles2"),wt.findFiles2(_,le,Le.identifier,Ne)),findFiles2New:(_,le,Ne)=>{(0,_e.$vH)(Le,"findFiles2New");const ft={exclude:le?.exclude&&le.exclude.length>0?le.exclude[0]:void 0,useDefaultExcludes:!le?.useExcludeSettings||le?.useExcludeSettings===Ot.ExcludeSettingOptions.FilesExclude||le?.useExcludeSettings===Ot.ExcludeSettingOptions.SearchAndFilesExclude,useDefaultSearchExcludes:!le?.useExcludeSettings||le?.useExcludeSettings===Ot.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:le?.maxResults,useIgnoreFiles:le?.useIgnoreFiles?.local,useGlobalIgnoreFiles:le?.useIgnoreFiles?.global,useParentIgnoreFiles:le?.useIgnoreFiles?.parent,followSymlinks:le?.followSymlinks};return wt.findFiles2(_&&_.length>0?_[0]:void 0,ft,Le.identifier,Ne)},findTextInFiles:(_,le,Ne,ft)=>{(0,_e.$vH)(Le,"findTextInFiles");let It,Ft;return typeof le=="object"?(It=le,Ft=Ne):(It={},Ft=le,ft=Ne),wt.findTextInFiles(_,It||{},Ft,Le.identifier,ft)},findTextInFilesNew:(_,le,Ne)=>((0,_e.$vH)(Le,"findTextInFilesNew"),(0,_e.$vH)(Le,"textSearchProviderNew"),wt.findTextInFilesNew(_,Le.identifier,le||{},Ne)),save:_=>wt.save(_),saveAs:_=>wt.saveAs(_),saveAll:_=>wt.saveAll(_),applyEdit(_,le){return bn.applyWorkspaceEdit(_,Le,le)},createFileSystemWatcher:(_,le,Ne,ft)=>{let It;return typeof le=="boolean"?It={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!ft,correlate:!1}:le&&((0,_e.$vH)(Le,"createFileSystemWatcher"),It={...le,correlate:!0}),ae.createFileSystemWatcher(wt,Le,_,It)},get textDocuments(){return Wt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new D.$$("textDocuments")},openTextDocument(_){let le;const Ne=_;if(typeof _=="string")le=Promise.resolve(p.URI.file(_));else if(p.URI.isUri(_))le=Promise.resolve(_);else if(!Ne||typeof Ne=="object")le=Wt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ft=>(Et.trace(`openTextDocument from ${Le.identifier}`),ft.scheme===T.Schemas.vscodeRemote&&!ft.authority&&Lt.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Wt.ensureDocumentData(ft).then(It=>It.document)))},onDidOpenTextDocument:(_,le,Ne)=>ht(Wt.onDidAddDocument)(_,le,Ne),onDidCloseTextDocument:(_,le,Ne)=>ht(Wt.onDidRemoveDocument)(_,le,Ne),onDidChangeTextDocument:(_,le,Ne)=>ht(Wt.onDidChangeDocument)(_,le,Ne),onDidSaveTextDocument:(_,le,Ne)=>ht(Wt.onDidSaveDocument)(_,le,Ne),onWillSaveTextDocument:(_,le,Ne)=>ht(Fi.getOnWillSaveTextDocumentEvent(Le))(_,le,Ne),get notebookDocuments(){return Ct.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,le){let Ne;if(p.URI.isUri(_))Ne=_,await Ct.openNotebookDocument(_);else if(typeof _=="string")Ne=p.URI.revive(await Ct.createNotebookDocument({viewType:_,content:le}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(_,le,Ne){return ht(Si.onDidSaveNotebookDocument)(_,le,Ne)},onDidChangeNotebookDocument(_,le,Ne){return ht(Si.onDidChangeNotebookDocument)(_,le,Ne)},onWillSaveNotebookDocument(_,le,Ne){return ht(ji.getOnWillSaveNotebookDocumentEvent(Le))(_,le,Ne)},get onDidOpenNotebookDocument(){return ht(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ht(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(_,le,Ne,ft){return Ct.registerNotebookSerializer(Le,_,le,Ne,(0,_e.$uH)(Le,"notebookLiveShare")?ft:void 0)},onDidChangeConfiguration:(_,le,Ne)=>ht(Ki.onDidChangeConfiguration)(_,le,Ne),getConfiguration(_,le){return le=arguments.length===1?void 0:le,Ki.getConfiguration(_,le,Le)},registerTextDocumentContentProvider(_,le){return fi.registerTextDocumentContentProvider(_,le)},registerTaskProvider:(_,le)=>(Lt.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Xt.registerTaskProvider(Le,_,le)),registerFileSystemProvider(_,le,Ne){return(0,N.$Uc)(De.registerFileSystemProvider(Le,_,le,Ne),ti.addFileSystemProvider(_,le,Ne))},get fs(){return ti.value},registerFileSearchProvider:(_,le)=>((0,_e.$vH)(Le,"fileSearchProvider"),hi.registerFileSearchProviderOld(_,le)),registerTextSearchProvider:(_,le)=>((0,_e.$vH)(Le,"textSearchProvider"),hi.registerTextSearchProviderOld(_,le)),registerAITextSearchProvider:(_,le)=>((0,_e.$vH)(Le,"aiTextSearchProvider"),(0,_e.$vH)(Le,"textSearchProvider"),hi.registerAITextSearchProviderOld(_,le)),registerFileSearchProviderNew:(_,le)=>((0,_e.$vH)(Le,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(_,le)=>((0,_e.$vH)(Le,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(_,le)=>((0,_e.$vH)(Le,"aiTextSearchProviderNew"),(0,_e.$vH)(Le,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(_,le)=>((0,_e.$vH)(Le,"resolvers"),Ht.registerRemoteAuthorityResolver(_,le)),registerResourceLabelFormatter:_=>((0,_e.$vH)(Le,"resolvers"),Tt.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,_e.$vH)(Le,"resolvers"),Ht.getRemoteExecServer(_)),onDidCreateFiles:(_,le,Ne)=>ht(ae.onDidCreateFile)(_,le,Ne),onDidDeleteFiles:(_,le,Ne)=>ht(ae.onDidDeleteFile)(_,le,Ne),onDidRenameFiles:(_,le,Ne)=>ht(ae.onDidRenameFile)(_,le,Ne),onWillCreateFiles:(_,le,Ne)=>ht(ae.getOnWillCreateFileEvent(Le))(_,le,Ne),onWillDeleteFiles:(_,le,Ne)=>ht(ae.getOnWillDeleteFileEvent(Le))(_,le,Ne),onWillRenameFiles:(_,le,Ne)=>ht(ae.getOnWillRenameFileEvent(Le))(_,le,Ne),openTunnel:_=>((0,_e.$vH)(Le,"tunnels"),jt.openTunnel(Le,_).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,_e.$vH)(Le,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(_,le,Ne)=>((0,_e.$vH)(Le,"tunnels"),ht(jt.onDidChangeTunnels)(_,le,Ne)),registerPortAttributesProvider:(_,le)=>((0,_e.$vH)(Le,"portsAttributes"),jt.registerPortsAttributesProvider(_,le)),registerTunnelProvider:(_,le)=>((0,_e.$vH)(Le,"tunnelFactory"),jt.registerTunnelProvider(_,le)),registerTimelineProvider:(_,le)=>((0,_e.$vH)(Le,"timeline"),Vt.registerTimelineProvider(_,le,Le.identifier,Dt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:_=>((0,_e.$vH)(Le,"workspaceTrust"),wt.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,le,Ne)=>ht(wt.onDidGrantWorkspaceTrust)(_,le,Ne),registerEditSessionIdentityProvider:(_,le)=>((0,_e.$vH)(Le,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(_,le)),onWillCreateEditSessionIdentity:(_,le,Ne)=>((0,_e.$vH)(Le,"editSessionIdentityProvider"),ht(wt.getOnWillCreateEditSessionIdentityEvent(Le))(_,le,Ne)),registerCanonicalUriProvider:(_,le)=>((0,_e.$vH)(Le,"canonicalUriProvider"),wt.registerCanonicalUriProvider(_,le)),getCanonicalUri:(_,le,Ne)=>((0,_e.$vH)(Le,"canonicalUriProvider"),wt.provideCanonicalUri(_,le,Ne))},cn={get inputBox(){return Lt.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ie.getLastInputBox(Le)},createSourceControl(_,le,Ne){return Ie.createSourceControl(Le,_,le,Ne)}},ln={createCommentController(_,le){return Ke.createCommentController(Le,_,le)}},un={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){return St.activeStackItem},registerDebugVisualizationProvider(_,le){return(0,_e.$vH)(Le,"debugVisualization"),St.registerDebugVisualizationProvider(Le,_,le)},registerDebugVisualizationTreeProvider(_,le){return(0,_e.$vH)(Le,"debugVisualization"),St.registerDebugVisualizationTree(Le,_,le)},onDidStartDebugSession(_,le,Ne){return ht(St.onDidStartDebugSession)(_,le,Ne)},onDidTerminateDebugSession(_,le,Ne){return ht(St.onDidTerminateDebugSession)(_,le,Ne)},onDidChangeActiveDebugSession(_,le,Ne){return ht(St.onDidChangeActiveDebugSession)(_,le,Ne)},onDidReceiveDebugSessionCustomEvent(_,le,Ne){return ht(St.onDidReceiveDebugSessionCustomEvent)(_,le,Ne)},onDidChangeBreakpoints(_,le,Ne){return ht(St.onDidChangeBreakpoints)(_,le,Ne)},onDidChangeActiveStackItem(_,le,Ne){return ht(St.onDidChangeActiveStackItem)(_,le,Ne)},registerDebugConfigurationProvider(_,le,Ne){return St.registerDebugConfigurationProvider(_,le,Ne||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,le){return St.registerDebugAdapterDescriptorFactory(Le,_,le)},registerDebugAdapterTrackerFactory(_,le){return St.registerDebugAdapterTrackerFactory(_,le)},startDebugging(_,le,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?St.startDebugging(_,le,{parentSession:Ne}):St.startDebugging(_,le,Ne||{})},stopDebugging(_){return St.stopDebugging(_)},addBreakpoints(_){return St.addBreakpoints(_)},removeBreakpoints(_){return St.removeBreakpoints(_)},asDebugSourceUri(_,le){return St.asDebugSourceUri(_,le)}},En={registerTaskProvider:(_,le)=>Xt.registerTaskProvider(Le,_,le),fetchTasks:_=>Xt.fetchTasks(_),executeTask:_=>Xt.executeTask(Le,_),get taskExecutions(){return Xt.taskExecutions},onDidStartTask:(_,le,Ne)=>ht(Xt.onDidStartTask)(_,le,Ne),onDidEndTask:(_,le,Ne)=>ht(Xt.onDidEndTask)(_,le,Ne),onDidStartTaskProcess:(_,le,Ne)=>ht(Xt.onDidStartTaskProcess)(_,le,Ne),onDidEndTaskProcess:(_,le,Ne)=>ht(Xt.onDidEndTaskProcess)(_,le,Ne)},hn={createNotebookController(_,le,Ne,ft,It){return gi.createNotebookController(Le,_,le,Ne,ft,(0,_e.$uH)(Le,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(_,le)=>Ct.registerNotebookCellStatusBarItemProvider(Le,_,le),createRendererMessaging(_){return zi.createRendererMessaging(Le,_)},createNotebookControllerDetectionTask(_){return(0,_e.$vH)(Le,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Le,_)},registerKernelSourceActionProvider(_,le){return(0,_e.$vH)(Le,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Le,_,le)},onDidChangeNotebookCellExecutionState(_,le,Ne){return(0,_e.$vH)(Le,"notebookCellExecutionState"),ht(gi.onDidChangeNotebookCellExecutionState)(_,le,Ne)}},dn={t(..._){if(typeof _[0]=="string"){const le=_.shift(),Ne=!_||typeof _[0]!="object"?_:_[0];return di.getMessage(Le.identifier.value,{message:le,args:Ne})}return di.getMessage(Le.identifier.value,_[0])},get bundle(){return di.getBundle(Le.identifier.value)},get uri(){return di.getBundleUri(Le.identifier.value)}},kn={transferActiveChat(_){return(0,_e.$vH)(Le,"interactive"),Ui.transferActiveChat(_)}},In={getRelatedInformation(_,le){return(0,_e.$vH)(Le,"aiRelatedInformation"),Qi.getRelatedInformation(Le,_,le)},registerRelatedInformationProvider(_,le){return(0,_e.$vH)(Le,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Le,_,le)},registerEmbeddingVectorProvider(_,le){return(0,_e.$vH)(Le,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Le,_,le)}},fn={registerChatResponseProvider(_,le,Ne){return(0,_e.$vH)(Le,"chatProvider"),Gt.registerLanguageModel(Le,_,le,Ne)},registerChatVariableResolver(_,le,Ne,ft,It,Ft,Ti,Yi){return(0,_e.$vH)(Le,"chatVariableResolver"),rn.registerVariableResolver(Le,_,le,Ne,ft,It,Ft,Ti,Yi?.id)},registerMappedEditsProvider(_,le){return(0,_e.$vH)(Le,"mappedEditsProvider"),me.registerMappedEditsProvider(Le,_,le)},createChatParticipant(_,le){return Ui.createChatAgent(Le,_,le)},createDynamicChatParticipant(_,le,Ne){return(0,_e.$vH)(Le,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Le,_,le,Ne)},registerChatParticipantDetectionProvider(_){return(0,_e.$vH)(Le,"chatParticipantAdditions"),Ui.registerChatParticipantDetectionProvider(_)}},Xi={selectChatModels:_=>Gt.selectLanguageModels(Le,_??{}),onDidChangeChatModels:(_,le,Ne)=>Gt.onDidChangeProviders(_,le,Ne),registerChatModelProvider:(_,le,Ne)=>((0,_e.$vH)(Le,"chatProvider"),Gt.registerLanguageModel(Le,_,le,Ne)),get embeddingModels(){return(0,_e.$vH)(Le,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(_,le,Ne)=>((0,_e.$vH)(Le,"embeddings"),Ci.onDidChange(_,le,Ne)),registerEmbeddingsProvider(_,le){return(0,_e.$vH)(Le,"embeddings"),Ci.registerEmbeddingsProvider(Le,_,le)},async computeEmbeddings(_,le,Ne){return(0,_e.$vH)(Le,"embeddings"),Ci.computeEmbeddings(_,le,Ne)},registerTool(_,le){return(0,_e.$vH)(Le,"lmTools"),Bi.registerTool(Le,_,le)},invokeTool(_,le,Ne){return(0,_e.$vH)(Le,"lmTools"),Bi.invokeTool(_,le,Ne)},get tools(){return(0,_e.$vH)(Le,"lmTools"),Bi.tools}},gn={registerSpeechProvider(_,le){return(0,_e.$vH)(Le,"speech"),wn.registerProvider(Le.identifier,_,le)}};return{version:Pt.version,ai:In,authentication:yn,commands:Gi,comments:ln,chat:fn,debug:un,env:Ji,extensions:Sn,interactive:kn,l10n:dn,languages:pi,lm:Xi,notebooks:hn,scm:cn,speech:gn,tasks:En,tests:ki,window:Wi,workspace:Zi,Breakpoint:q.$8O,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatResultFeedbackKind:q.ChatResultFeedbackKind,ChatVariableLevel:q.ChatVariableLevel,ChatCompletionItem:q.$4P,CallHierarchyIncomingCall:q.$tO,CallHierarchyItem:q.$sO,CallHierarchyOutgoingCall:q.$uO,CancellationError:D.$7,CancellationTokenSource:y.$ze,CandidatePortSource:i.CandidatePortSource,CodeAction:q.$pO,CodeActionKind:q.$qO,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$vO,Color:q.$IO,ColorInformation:q.$JO,ColorPresentation:q.$KO,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CommentThreadApplicability:q.CommentThreadApplicability,CommentThreadFocus:q.CommentThreadFocus,CompletionItem:q.$CO,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$DO,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$SO,DebugAdapterExecutable:q.$_O,DebugAdapterInlineImplementation:q.$cP,DebugAdapterNamedPipeServer:q.$bP,DebugAdapterServer:q.$aP,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DebugVisualization:q.$sP,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$iO,DiagnosticRelatedInformation:q.$hO,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$5N,DocumentHighlight:q.$lO,DocumentHighlightKind:q.DocumentHighlightKind,MultiDocumentHighlight:q.$mO,DocumentLink:q.$HO,DocumentSymbol:q.$oO,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$fP,InlineValueText:q.$gP,InlineValueVariableLookup:q.$hP,InlineValueEvaluatableExpression:q.$iP,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:C.$oe,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$uP,FileDecoration2:q.$uP,FileSystemError:q.$lP,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:q.$mP,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$0O,InlineCompletionItem:q.$EO,InlineCompletionList:q.$FO,Hover:q.$jO,VerboseHover:q.$kO,HoverVerbosityAction:q.HoverVerbosityAction,IndentAction:v.IndentAction,Location:q.$gO,MarkdownString:q.$wO,OverviewRulerLane:h.OverviewRulerLane,ParameterInformation:q.$xO,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$6N,ProcessExecution:q.$QO,ProgressLocation:q.ProgressLocation,QuickInputButtonLocation:q.QuickInputButtonLocation,QuickInputButtons:q.$tP,Range:q.$7N,RelativePattern:q.$6O,Selection:q.$8N,SelectionRange:q.$rO,SemanticTokens:q.$pP,SemanticTokensBuilder:q.$oP,SemanticTokensEdit:q.$qP,SemanticTokensEdits:q.$rP,SemanticTokensLegend:q.$nP,ShellExecution:q.$RO,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$zO,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$yO,SnippetString:q.$fO,SourceBreakpoint:q.$9O,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$nO,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$TO,TaskGroup:q.$PO,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$LO,TerminalQuickFixTerminalCommand:q.$NO,TerminalQuickFixOpener:q.$MO,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$OO,TerminalExitReason:q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$bO,SnippetTextEdit:q.$dO,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$5O,ThemeIcon:q.$4O,TreeItem:q.$UO,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$RP,UIKind:_t.UIKind,Uri:p.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$eO,DocumentPasteTriggerKind:q.DocumentPasteTriggerKind,DocumentDropEdit:q.$1O,DocumentDropOrPasteEditKind:q.$2O,DocumentPasteEdit:q.$3O,InlayHint:q.$BO,InlayHintLabelPart:q.$AO,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$aO,ResolvedAuthority:q.$$N,ManagedResolvedAuthority:q.$_N,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$EP,NotebookRange:q.$wP,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$xP,NotebookData:q.$yP,NotebookRendererScript:q.$CP,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$AP,NotebookCellOutputItem:q.$zP,NotebookCellStatusBarItem:q.$BP,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$cO,NotebookKernelSourceAction:q.$DP,NotebookVariablesRequestKind:q.NotebookVariablesRequestKind,PortAttributes:q.$GP,LinkedEditingRanges:q.$FP,TestResultState:q.TestResultState,TestRunRequest:q.$HP,TestMessage:q.$IP,TestMessageStackFrame:q.$KP,TestTag:q.$JP,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Ot.TextSearchCompleteMessageType,DataTransfer:q.$ZO,DataTransferItem:q.$VO,TestCoverageCount:q.$LP,FileCoverage:q.$NP,FileCoverage2:q.$NP,StatementCoverage:q.$OP,BranchCoverage:q.$PP,DeclarationCoverage:q.$QP,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$SP,TabInputTextDiff:q.$TP,TabInputTextMerge:q.$UP,TabInputCustom:q.$VP,TabInputNotebook:q.$XP,TabInputNotebookDiff:q.$YP,TabInputWebview:q.$WP,TabInputTerminal:q.$ZP,TabInputInteractiveWindow:q.$1P,TabInputChat:q.$2P,TabInputTextMultiDiff:q.$3P,TelemetryTrustedValue:c.$Ap,LogLevel:r.LogLevel,EditSessionIdentityMatch:u.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,ChatCopyKind:q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:q.$dP,DebugThread:q.$eP,RelatedInformationType:q.RelatedInformationType,SpeechToTextStatus:q.SpeechToTextStatus,TextToSpeechStatus:q.TextToSpeechStatus,PartialAcceptTriggerKind:q.PartialAcceptTriggerKind,KeywordRecognitionStatus:q.KeywordRecognitionStatus,ChatResponseMarkdownPart:q.$5P,ChatResponseFileTreePart:q.$9P,ChatResponseAnchorPart:q.$0P,ChatResponseProgressPart:q.$$P,ChatResponseProgressPart2:q.$_P,ChatResponseReferencePart:q.$cQ,ChatResponseReferencePart2:q.$cQ,ChatResponseCodeCitationPart:q.$dQ,ChatResponseWarningPart:q.$aQ,ChatResponseTextEditPart:q.$fQ,ChatResponseMarkdownWithVulnerabilitiesPart:q.$6P,ChatResponseCommandButtonPart:q.$bQ,ChatResponseDetectedParticipantPart:q.$7P,ChatResponseConfirmationPart:q.$8P,ChatResponseMovePart:q.$eQ,ChatResponseReferencePartStatusKind:q.ChatResponseReferencePartStatusKind,ChatRequestTurn:q.$gQ,ChatResponseTurn:q.$hQ,ChatLocation:q.ChatLocation,ChatRequestEditorData:q.$iQ,ChatRequestNotebookData:q.$jQ,LanguageModelChatMessageRole:q.LanguageModelChatMessageRole,LanguageModelChatMessage:q.$lQ,LanguageModelChatMessageFunctionResultPart:q.$kQ,LanguageModelChatResponseTextPart:q.$nQ,LanguageModelChatResponseFunctionUsePart:q.$mQ,LanguageModelError:q.$rQ,NewSymbolName:q.$kP,NewSymbolNameTag:q.NewSymbolNameTag,NewSymbolNameTriggerKind:q.NewSymbolNameTriggerKind,InlineEdit:q.$sQ,InlineEditTriggerKind:q.InlineEditTriggerKind,ExcludeSettingOptions:Ot.ExcludeSettingOptions,TextSearchContextNew:Ot.$eM,TextSearchMatchNew:Ot.$dM,TextSearchCompleteMessageTypeNew:Ot.TextSearchCompleteMessageType}}}}),define(Oe[278],Ae([1,0,61,130,45,124,46,34,58,57,132,134,135,89,93,85,123,69,51,88,67,71,216,11,133,86,87,91,95,128,96]),function($e,e,y,D,C,N,T,O,p,s,I,v,h,E,f,r,a,c,u,i,n,t,o,l,m,g,d,S,k,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Ws)(g.$krc,g.$jrc,y.InstantiationType.Delayed),(0,y.$Ws)(l.$ek,o.$Esc,y.InstantiationType.Delayed),(0,y.$Ws)(r.$pqc,r.$qqc,y.InstantiationType.Delayed),(0,y.$Ws)(O.$ZQ,O.$YQ,y.InstantiationType.Eager),(0,y.$Ws)(S.$zqc,S.$Aqc,y.InstantiationType.Eager),(0,y.$Ws)(k.$erc,k.$frc,y.InstantiationType.Eager),(0,y.$Ws)(T.$Oqc,T.$Mqc,y.InstantiationType.Eager),(0,y.$Ws)(c.$Qqc,c.$Pqc,y.InstantiationType.Eager),(0,y.$Ws)(P.$urc,P.$vrc,y.InstantiationType.Eager),(0,y.$Ws)(v.$zrc,v.$Drc,y.InstantiationType.Eager),(0,y.$Ws)(N.$Frc,N.$Erc,y.InstantiationType.Eager),(0,y.$Ws)(p.$OQ,p.$NQ,y.InstantiationType.Eager),(0,y.$Ws)(d.$lrc,d.$mrc,y.InstantiationType.Eager),(0,y.$Ws)(u.$tqc,u.$sqc,y.InstantiationType.Eager),(0,y.$Ws)(D.$esc,D.$dsc,y.InstantiationType.Delayed),(0,y.$Ws)(h.$1rc,h.$2rc,y.InstantiationType.Eager),(0,y.$Ws)(E.$0qc,E.$9qc,y.InstantiationType.Eager),(0,y.$Ws)(I.$rsc,I.$qsc,y.InstantiationType.Eager),(0,y.$Ws)(s.$arc,s.$drc,y.InstantiationType.Eager),(0,y.$Ws)(w.$ssc,w.$tsc,y.InstantiationType.Eager),(0,y.$Ws)(f.$MGb,f.$NGb,y.InstantiationType.Eager),(0,y.$Ws)(a.$Csc,a.$Bsc,y.InstantiationType.Eager),(0,y.$Ws)(C.$Lqc,C.$Kqc,y.InstantiationType.Eager),(0,y.$Ws)(i.$hrc,i.$grc,y.InstantiationType.Eager),(0,y.$Ws)(n.$XQ,n.$UQ,y.InstantiationType.Eager),(0,y.$Ws)(t.$1qc,t.$2qc,y.InstantiationType.Eager),(0,y.$Ws)(m.$src,m.$trc,y.InstantiationType.Eager)}),define(Oe[279],Ae([1,0,277,47,2,273,7,10,223]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Suc=void 0;class s extends N.$Hsc{j(){}getModule(E,f){for(const r of this.b){const a=r(E);if(a){E=a;break}}if(this.a.has(E))return this.a.get(E).load(E,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends D.$orc{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$Ruc);const E=this.h.invokeFunction(y.$Dsc);this.r=this.h.createInstance(s,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,f,r){f=f.with({path:v(f.path,".js")});const a=E?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const c=C.URI.revive(await this.C.$asBrowserUri(f)),u=await fetch(c.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),u.status!==200)throw new Error(u.statusText);const i=await u.text(),n=`${f.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let o;try{o=new Function("module","exports","require",t)}catch(d){throw console.error(a?`Loading code for extension ${a} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${f.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}E&&await this.w.initializeLocalizedMessages(E);const l={},m={exports:l},g=d=>{const S=this.r.getModule(d,f);if(S===void 0)throw new Error(`Cannot load module '${d}'`);return S};try{return r.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),o(m,l,g),m.exports!==l?m.exports:l}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),r.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+E;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,O.$Jh)(10)}}e.$Suc=I;function v(h,E){return h.endsWith(E)?h:h+E}}),define(Oe[280],Ae([1,0,74,61,11,47,188,92,279]),function($e,e,y,D,C,N,T,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Ws)(C.$dk,new y.$Fi(T.$Gsc,[!0],!0)),(0,D.$Ws)(N.$prc,p.$Suc,D.InstantiationType.Eager),(0,D.$Ws)(O.$Rqc,O.$Sqc,D.InstantiationType.Eager)}),define(Oe[288],Ae([1,0,22,6,84,274,225,20,65,15,2,278,280]),function($e,e,y,D,C,N,T,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,O=He(O),p=He(p);const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(o){return/^(file|vscode-remote):/i.test(o)}const f=fetch.bind(self);function r(o){self.fetch=async function(l,m){return l instanceof Request||E(String(l))&&(l=(await o(I.URI.parse(String(l)))).toString(!0)),f(l,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,m,g,d,S){(async()=>(E(m.toString())&&(m=(await o(I.URI.parse(m.toString()))).toString(!0)),super.open(l,m,g??!0,d,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.Worker;Worker=function(l,m){if(/^file:/i.test(l.toString()))l=s.$3g.uriToBrowserUri(I.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const d=`(${function(P){function R(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const $=fetch.bind(self);self.fetch=function(L,A){return L instanceof Request?$(L,A):$(R(L),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,A,M,Z,G){return super.open(L,R(A),M??!0,Z,G)}};const b=importScripts.bind(self);self.importScripts=(...L)=>{b(...L.map(R))},b(P)}.toString()}('${l}'))`;m=m||{},m.name=`${name} -> ${m.name||O.$qc(l.toString())}`;const S=new Blob([d],{type:"application/javascript"}),k=URL.createObjectURL(S);return new o(k,m)}}else self.Worker=class extends T.$Tuc{constructor(o,l){super(h,o,{name:O.$qc(o.toString()),...l})}};const a=new class{constructor(){this.pid=void 0}exit(o){v()}};class c{constructor(){const l=new MessageChannel,m=new D.$oe;let g=!1;h(l.port2,[l.port2]),l.port1.onmessage=d=>{const{data:S}=d;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const k=y.$Qe.wrap(new Uint8Array(S,0,S.byteLength));if((0,C.$Fn)(k,C.MessageType.Terminate)){g=!0,i("received terminate message from renderer");return}m.fire(k)},this.protocol={onMessage:m.event,send:d=>{if(!g){const S=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);l.port1.postMessage(S,[S])}}}}}function u(o){return new Promise(l=>{const m=o.onMessage(g=>{m.dispose();const d=JSON.parse(g.toString());o.send((0,C.$En)(C.MessageType.Initialized)),l({protocol:o,initData:d})});o.send((0,C.$En)(C.MessageType.Ready))})}let i=o=>v();function n(o){return!!o&&typeof o=="object"&&o.type==="vscode.init"&&o.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const o=new c;return{onmessage(l){n(l)&&u(o.protocol).then(m=>{p.mark("code/extHost/didWaitForInitData");const g=new N.$Jsc(m.protocol,m.initData,a,null,l.data);r(d=>g.asBrowserUri(d)),i=d=>g.terminate(d)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e2b54301a5745870f6b95d81c91fb3e9557d4f08/core/vs/workbench/api/worker/extensionHostWorker.js.map
